/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   acitpch.h

@brief
   
CVS Header Information:
   $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/drivers/initiator/acit/acitpch.h,v 1.11 2006/03/14 20:21:43 prabalm Exp $
*/
#ifndef __acitpch_h__
#define __acitpch_h__

#define MODULE_NAME "be2iscsi"

// Avoid including the common register code for now.  I redefine the macros in register.h
#define __BEREGISTER_H__

#define  STATIC_CAST(_type_, _value_) ( * ((_type_ *) &(_value_)))

#include "beclib_ll.h"

#include "acitcfg.h"
#include "acitdefs.h"

#ifdef _WINISCSI_INBOX
#include "sa_system.h"
#include "sa_runtime.h"
#else
#include "sa.h"
#include "ioctl_defines.h"
#endif

// common error code
#include "uerr.h"

// Defines
#include "vase.h"
#include "blade.h"

// Stats
#include "iscsi_drvr_stats.h"

#undef SG_PRAGMA_PACK

// acit
#if defined(SA_LINUXK)|| defined(SA_SOLARISK) || defined(_WINISCSI_INBOX)
#include "acitapi.h"
#else

#include "acit_top.h"
#include "osm_bmap.h"
#include "acitfdecs.h"
#include "osmfuncp_bmap.h"
#include "acitfunp.h"
#include "acit_bmap.h"

#endif

#ifndef _WINISCSI_INBOX
// V1 API for BE3
#include "be3iscsi_v1_bmap.h"
// IOCTL version
#include "ioctlver.h"
#endif

// acit main
#include "acitmain.h"

// scsi
#include "acitscsi.h"

// management
#include "mgmtapi.h"
#include "mgmtpvt.h"

// iscsi
#include "iscsipdu.h"
#include "iscsiapi.h"
#include "iscsipvt.h"

#ifdef BE_EMULATION
#include "acitemul.h"
#endif

// hardware
#include "register.h"
#include "hwiasync.h"
#include "hwi.h"
#include "hwiwrb.h"

#endif


