/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be3iscsi_v1_bmap_h__
#define __be3iscsi_v1_bmap_h__

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif


typedef struct _MIB_ISCSI_STATISTICS_V1 {
   UEXACT32 iscsi_cmd_pdus;
   UEXACT32 iscsi_rsp_pdus;
   UEXACT64 iscsi_tx_data_octets;
   UEXACT64 iscsi_rx_data_octets;
   UEXACT32 iscsi_digest_errors;
   UEXACT32 iscsi_cxn_timeout_errors;
   UEXACT32 iscsi_format_errors;
   UEXACT32 rsvd0;
} SG_PACK MIB_ISCSI_STATISTICS_V1, *PMIB_ISCSI_STATISTICS_V1;




typedef struct _CONNECTION_DATA_V1 {
   UEXACT32 connection_handle;
   UEXACT32 conn_status;
   UEXACT32 conn_iscsi_cid;
   UEXACT32 estimated_throughput;
   UEXACT32 header_digest;
   UEXACT32 data_digest;
} SG_PACK CONNECTION_DATA_V1, *PCONNECTION_DATA_V1;




typedef struct _OFFLOAD_SESSION_OUT_V1 {
   UEXACT32 session_handle;
   UEXACT32 session_owner;
   UEXACT32 expcmdsn;
   UEXACT32 maxcmdsn;
   UEXACT32 cmdsn;
   UEXACT32 session_status;
   MIB_ISCSI_STATISTICS_V1 session_statistics;
   UEXACT8 tmf_method;
   UEXACT8 error_recovery_level;
   UEXACT16 max_connections;
   UEXACT32 extended_timeout;
   CONNECTION_DATA_V1 connection_info;
} SG_PACK OFFLOAD_SESSION_OUT_V1, *POFFLOAD_SESSION_OUT_V1;




typedef struct _OFFLOAD_CONN_OUT_V1 {
   UEXACT32 session_handle;
   CONNECTION_DATA_V1 connection_info;
} SG_PACK OFFLOAD_CONN_OUT_V1, *POFFLOAD_CONN_OUT_V1;




typedef struct _OFFLOAD_SESSION_IN_V1 {
   union {
      struct { 
         UEXACT32 session_handle;
         UEXACT16 connection_handle;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT16 defq_id;
         PHYS_ADDR_V1 dataout_template_pa;
         UEXACT16 hdr_ring_id;
         UEXACT16 data_ring_id;
         UEXACT8 ifd_state;
         UEXACT8 rsvd0[3];
      } SG_PACK ; // unnamed struct
      u32 dw[7]; // dword union
   }; // unnamed union
} SG_PACK OFFLOAD_SESSION_IN_V1, *POFFLOAD_SESSION_IN_V1;

SG_C_ASSERT(__sizeof__OFFLOAD_SESSION_IN, sizeof (OFFLOAD_SESSION_IN_V1) == 28);



typedef struct _OFFLOAD_CONN_IN_V1 {
   union {
      struct { 
         UEXACT32 session_handle;
         UEXACT16 connection_handle;
         UEXACT16 cid;
         UEXACT16 cq_id;
         UEXACT16 defq_id;
         PHYS_ADDR_V1 dataout_template_pa;
         UEXACT16 hdr_ring_id;
         UEXACT16 data_ring_id;
         UEXACT8 ifd_state;
         UEXACT8 rsvd0[3];
      } SG_PACK ; // unnamed struct
      u32 dw[7]; // dword union
   }; // unnamed union
} SG_PACK OFFLOAD_CONN_IN_V1, *POFFLOAD_CONN_IN_V1;

SG_C_ASSERT(__sizeof__OFFLOAD_CONN_IN, sizeof (OFFLOAD_CONN_IN_V1) == 28);



typedef struct _OFFLOAD_SESSION_PARAMS_V1 {
   union {
      union { 
         OFFLOAD_SESSION_IN_V1 request;
         OFFLOAD_SESSION_OUT_V1 response;
      } SG_PACK ; // unnamed struct
      u32 dw[24]; // dword union
   }; // unnamed union
} SG_PACK OFFLOAD_SESSION_PARAMS_V1, *POFFLOAD_SESSION_PARAMS_V1;

SG_C_ASSERT(__sizeof__OFFLOAD_SESSION_PARAMS, sizeof (OFFLOAD_SESSION_PARAMS_V1) == 96);



typedef struct _OFFLOAD_CONN_PARAMS_V1 {
   union {
      union { 
         OFFLOAD_CONN_IN_V1 request;
         OFFLOAD_CONN_OUT_V1 response;
      } SG_PACK ; // unnamed struct
      u32 dw[7]; // dword union
   }; // unnamed union
} SG_PACK OFFLOAD_CONN_PARAMS_V1, *POFFLOAD_CONN_PARAMS_V1;

SG_C_ASSERT(__sizeof__OFFLOAD_CONN_PARAMS, sizeof (OFFLOAD_CONN_PARAMS_V1) == 28);


// --- IFD_STATE ---
#define IFD_STATE_DISABLE_V1            (0)       
#define IFD_STATE_ENABLE_V1             (1)       



typedef struct _BE_LINK_STATUS_V1 {
   union {
      struct { 
         u32 port_number : 6;                     // DWORD 0
         u32 pt : 2;                              // DWORD 0
         u32 link_duplex : 8;                     // DWORD 0
         u32 physical_port_speed : 8;             // DWORD 0
         u32 physical_port_fault : 8;             // DWORD 0
         UEXACT16 rsvd0;
         UEXACT16 qos_link_speed;
         UEXACT8 logical_link_status;
         UEXACT8 rsvd1[3];
      } SG_PACK ; // unnamed struct
      u32 dw[3]; // dword union
   }; // unnamed union
} SG_PACK BE_LINK_STATUS_V1, *PBE_LINK_STATUS_V1;

SG_C_ASSERT(__sizeof__BE_LINK_STATUS_V1, sizeof (BE_LINK_STATUS_V1) == 12);


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be3iscsi_v1_bmap_h__

