/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

 /*++

    Filename:

        mgmtpvt.h

    Purpose:

        Header file for private Management functions and structures


--*/

#ifndef MGMTPVT_H
#define MGMTPVT_H

MGMT_STATUS
mgmt_alloc_internal_resources(
    PMGMT_CONTROLLER_WS     pmgmt_controller,
    PMGMT_IOCTL_HANDLE      pioctl_handle);

MGMT_STATUS
mgmt_peek_internal_resources(
    PMGMT_CONTROLLER_WS     pmgmt_controller);

ACIT_VOID
mgmt_free_internal_resources(
    PMGMT_CONTROLLER_WS     pmgmt_controller,
    PMGMT_IOCTL_HANDLE      pioctl_handle);

MGMT_STATUS
mgmt_submit_ioctl(
    PACIT_CONTROLLER_WS     pcontroller, 
    PMGMT_IOCTL_HANDLE      pioctl_handle);

MGMT_STATUS
mgmt_fill_ioctl_request(
    PACIT_CONTROLLER_WS     pcontroller,
    PMGMT_IOCTL_HANDLE      pioctl_handle);

ACIT_VOID
mgmt_complete_beclib_ioctl(
    PACIT_VOID              pcontext,
    BESTATUS                bestatus,
    PMCC_WRB                pwrb);

ACIT_VOID
mgmt_async_event_handler(
    PACIT_VOID              pcontext,
    ACIT_UEXACT32           event_code,
    PACIT_VOID              pevent);

#endif

