/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

/*++

    Filename:

        vase.h

    Purpose:

        Header file for declaring VASE data structures and function templates
        

--*/

extern volatile ACIT_PTR DbgMasterBlkPtr;



/*
 * Definitions used in this file.
 */
#define OP_PARAMETER_STRING_SIZE            (30)
#define DBG_OP_PARAMETER_BLOCK_ENTRIES      (40)
#define DBG_BLOCK_ALIGN_MASK                (0x00000007)
#define DBG_TEXT_BLOCK_MARKER               (0xFF)


#define VASE_MODULE_OSM                     (0x0)
#define VASE_MODULE_ACIT                    (0x1)
#define VASE_MODULE_MGMT                    (0x2)
#define VASE_MODULE_ISCSI                   (0x3)

/*
 * Define basic data types used by VASE for driver (VASE Server).
 * VASE GUI (Translation software) will have its own definition.
 */
#ifndef __VASE_CLIENT__
//typedef ACIT_VOID                       VOID,       *PVOID;
//typedef ACIT_UEXACT64                   ULONGLONG,  *PULONGLONG;
//typedef ACIT_UEXACT32                   ULONG,      *PULONG;
//typedef ACIT_UEXACT16                   USHORT,     *PUSHORT;
//typedef ACIT_UEXACT8                    UCHAR,      *PUCHAR;
#endif

/*
// **********************************************************************
// ********************************  NOTE  ******************************
// The following portion of this file is processed by external tools
// Please follow these rules to make sure other tools work correctly
// *** Function names should be defined exactly prefixed with a string
//     "FUNC_".
// *** Value assigned to the function name should never be changed
//     because existing log files that are saved cannot be translated
// *** All function names should be defined withing the 
//     FUNCTION_EXTRACT_TO_TXT-BEGIN and FUNCTION_EXTRACT_TO_TEXT-END comments
// *** New functions names should be added to the end of the list below
//     so that their assigned values remain in asending order.
// Following definitions are for function constants that are logged
// in the function block.
// FUNCTION_EXTRACT_TO_TXT_BEGIN    */
#define FUNC_acit_init_controller_ws             0
#define FUNC_acit_init_target_ws                 1
#define FUNC_acit_init_lun_ws                    2
#define FUNC_acit_init_io_ws                     3
#define FUNC_acit_init_tmf_ws                    4
#define FUNC_acit_init_controller                5
#define FUNC_acit_stop_controller                6
#define FUNC_acit_discover_targets               7
#define FUNC_acit_enable_irq                     8
#define FUNC_acit_disable_irq                    9
#define FUNC_acit_process_irq                   10
#define FUNC_acit_start_io                      11
#define FUNC_acit_abort_io                      12
#define FUNC_acit_reset_lun                     13
#define FUNC_acit_reset_target                  14
#define FUNC_acit_resethard_controller          15
#define FUNC_acit_resetsoft_controller          16
#define FUNC_acit_process_power_event           17
#define FUNC_acit_save_state                    18
#define FUNC_acit_restore_state                 19
#define FUNC_acit_process_timer_tick            20
#define FUNC_acit_process_hiber_irq             21
#define FUNC_acit_start_hiber_io                22
#define FUNC_ap_alloc_io_resources              23
#define FUNC_ap_free_io_resources               24
#define FUNC_ap_complete_io                     25
#define FUNC_hwi_process_irq                    26
#define FUNC_hwi_process_cq                     27
#define FUNC_WinCompleteSrb                     28
#define FUNC_hwi_process_eq                     29
#define FUNC_WinBuildIo                         30
#define FUNC_WinQueueIO                         31
#define FUNC_WinInterrupt                       32
#define FUNC_WinMsiInterrupt                    33
#define FUNC_acit_process_msi_irq               34
#define FUNC_acit_update_lun_info               35/*
#define FUNC_                                   36
#define FUNC_                                   37
#define FUNC_                                   38
#define FUNC_                                   39
#define FUNC_                                   40
#define FUNC_                                   41
#define FUNC_                                   42
#define FUNC_                                   43
#define FUNC_                                   44
#define FUNC_                                   45
#define FUNC_                                   46
#define FUNC_                                   47
#define FUNC_                                   48
#define FUNC_                                   49
#define FUNC_                                   50
#define FUNC_                                   51
#define FUNC_                                   52
#define FUNC_                                   53
#define FUNC_                                   54
#define FUNC_                                   55
#define FUNC_                                   56
#define FUNC_                                   57
#define FUNC_                                   58
#define FUNC_                                   59
#define FUNC_                                   60
#define FUNC_                                   61
#define FUNC_                                   62
#define FUNC_                                   63
#define FUNC_                                   64
#define FUNC_                                   65
#define FUNC_                                   66
#define FUNC_                                   67
#define FUNC_                                   68
#define FUNC_                                   69
#define FUNC_                                   70
#define FUNC_                                   71
#define FUNC_                                   72
#define FUNC_                                   73
#define FUNC_                                   74
#define FUNC_                                   75
#define FUNC_                                   76
#define FUNC_                                   77
#define FUNC_                                   78
#define FUNC_                                   79
#define FUNC_                                   80
#define FUNC_                                   81
#define FUNC_                                   82
#define FUNC_                                   83
#define FUNC_                                   84
#define FUNC_                                   85
#define FUNC_                                   86
#define FUNC_                                   87
#define FUNC_                                   88
#define FUNC_                                   89
#define FUNC_                                   90
#define FUNC_                                   91
#define FUNC_                                   92
#define FUNC_                                   93
#define FUNC_                                   94
#define FUNC_                                   95
#define FUNC_                                   96
#define FUNC_                                   97
#define FUNC_                                   98
#define FUNC_                                   99
#define FUNC_                                   100
#define FUNC_                                   101
#define FUNC_                                   102
#define FUNC_                                   103
#define FUNC_                                   104
#define FUNC_                                   105
#define FUNC_                                   106
#define FUNC_                                   107
// FUNCTION_EXTRACT_TO_TEXT_END
*/

/*
#define FUNC_Unused0                             0
#define FUNC_HwFindAdapter                       1
#define FUNC_HwInitialize                        2
#define FUNC_HwStartIo                           3
#define FUNC_HwInterrupt                         4
#define FUNC_HwResetBus                          5
#define FUNC_HwAdapterState                      6
#define FUNC_HwHwTimer                           7
#define FUNC_HwAdapterControl                    8
#define FUNC_Unused1                             9
#define FUNC_Unused2                            10
#define FUNC_Unused3                            11
#define FUNC_Unused4                            12
#define FUNC_Unused4                            13
#define FUNC_Unused4                            14
#define FUNC_Unused4                            15
*/

/*
// VERSION_RULES
// ****************************************************************************
// * ** Structures in this file are shared between miniport and other apps
// * ** NOTE ** increment following number every time any change is made to the 
// * IOCTL API. The DBG_IOCTLCMD_NOP and the expected structure has to be 
// * supported in any case and in any version.
// * VASE Server (miniport) and Client (Application) both use these version to 
// * check concistency. Increment the upper 16 bits by one if your changes will
// * break the IOCTL API with existing application. Increment lower 16 bits if
// * your changes just adds some new feature to the IOCTL API.
// ***************************************************************************/
// Version 1,1 initial implementation
#define DBG_API_VERSION                 0x00010001 

/*
// * The following version are for individual debug blocks. Increment the upper
// * 16 bits by one if your change to the corresponding block structure break
// * existing applications. Increment the lower 16 bits if you just adds some
// * additional stuff that does not break existing application. */
// version 1,1 initial implementation
#define DBG_BLK_MASTER_VERSION          0x00010001
// version 1,1 initial implementation
#define DBG_BLK_FUNC_VERSION            0x00010001
// version 1,1 initial implementation
#define DBG_BLK_TEXT_MESSAGE_VERSION    0x00010001
// version 1,1 initial implementation
#define DBG_BLK_OP_PARAMETER_VERSION    0x00010001
// version 1,1 initial implementation
#define DBG_BLK_STATISTICS_VERSION      0x00010001
/* ***************************************************************************/



#define DBG_MAX_BLOCKS                  32  /*  Maximum possible blocks. */

/*  Definitions for all the debug blocks supported. */
#define DBG_BLK_MASTER                  0   /*  master debug block */
#define DBG_BLK_FUNC                    1   /*  function entry/exit logs */
#define DBG_BLK_TEXT_MESSAGE            2   /*  free flowing text messages. */
#define DBG_BLK_OP_PARAMETER            3   /*  operating params for miniport*/
#define DBG_BLK_STATISTICS              4   /*  statistics params for miniport*/



/*+

Macro:
    DBG_BLK_COMPILED_IN

Purpose:
    This macro returns a 32 bit data type bit map of the debug blocks that 
    are to be enabled in the built binary.
-*/

#if ACIT_CFG_DEBUG_BUILD
    /*  Following macro defines what debug blocks are supported  */
    /*  in the debug build of the driver */
    #define DBG_BLK_COMPILED_IN()   \
        (                               \
        (0x1 << DBG_BLK_FUNC        ) | \
        (0x1 << DBG_BLK_TEXT_MESSAGE) | \
        (0x1 << DBG_BLK_OP_PARAMETER) | \
        (0x1 << DBG_BLK_STATISTICS  ) | \
        (0x1 << DBG_BLK_MASTER      )   \
        )
#else
    /*  Following macro defines what debug blocks are supported  */
    /*  in the free build of the driver */
    #define DBG_BLK_COMPILED_IN()   \
        (                               \
        (0x1 << DBG_BLK_FUNC        ) | \
        (0x1 << DBG_BLK_TEXT_MESSAGE) | \
        (0x1 << DBG_BLK_OP_PARAMETER) | \
        (0x1 << DBG_BLK_STATISTICS  ) | \
        (0x1 << DBG_BLK_MASTER      )   \
        )
#endif



/*+

Macro:
    DBG_IS_BLOCK_ENABLED

Purpose:
    Macro to check if a particular debug block is enabled.
-*/

#define DBG_IS_BLOCK_ENABLED(flag, block)     (flag & (0x1 << block))

/*+

Macro:
    DBG_GET_HI and DBG_GET_LO

Purpose:
    Macro to check version number in debug block structures
-*/

#define DBG_GET_HI(x) (( x & 0xFFFF0000) >> 16 )
#define DBG_GET_LO(x) ( x & 0x0000FFFF)

/*+

Macro:
    DBG_SET_HI and DBG_SET_LO

Purpose:
    Macro to set version number in debug block structures
-*/

#define DBG_SET_HI(word, value) ( word = (word & 0x0000FFFF) | (value << 16) )
#define DBG_SET_LO(word, value) ( word = (word & 0xFFFF0000) | (value) )


/*+

Macro:
    DBG_LOG_FUNC_ENTER

Purpose:
    Macro to log an entry in function block. Only use this macro at the start 
    of any function. If this macro is used also use one of the exit macro 
    below to log the exit.
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_FUNC_ENTER(pMasterBlock, FuncConstant, Module, P1, P2, P3) \
    if((pMasterBlock) && (DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks, DBG_BLK_FUNC)))  \
       DbgLogFuncBlock(pMasterBlock,FuncConstant,DBG_FUNC_ENTER,Module,P1,P2,P3)

#else

    #define DBG_LOG_FUNC_ENTER(pMasterBlock, FuncConstant, Module, P1, P2, P3)

#endif



/*+

Macro:
    DBG_LOG_FUNC_EXIT

Purpose:
    Only use this macro before a return on exit of any function definately 
    use it if the Enter macro has been used for that function do not use it 
    if the enter macro has not been used.
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_FUNC_EXIT(pMasterBlock, FuncConstant, Module, P1, P2, P3) \
    if((pMasterBlock) && (DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks, DBG_BLK_FUNC))) \
       DbgLogFuncBlock(pMasterBlock,FuncConstant,DBG_FUNC_EXIT,Module,P1,P2,P3)

#else

    #define DBG_LOG_FUNC_EXIT(pMasterBlock, FuncConstant, Module, P1, P2, P3)

#endif



/*+

Macro:
    DBG_LOG_FUNC_ERROR_EXIT

Purpose:
    Only use this macro before an error return on exit of any function 
    definately use it if the Enter macro has been used for that function 
    do not use it if the enter macro has not been used.
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_FUNC_ERROR_EXIT(pMasterBlock,FuncConstant,Module,P1,P2,P3)\
if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks,DBG_BLK_FUNC))  \
  DbgLogFuncBlock(pMasterBlock,FuncConstant,DBG_FUNC_ERROR_EXIT,Module,P1,P2,P3)

#else

    #define DBG_LOG_FUNC_ERROR_EXIT(pMasterBlock, FuncConstant, P1, P2, P3)

#endif


/*+

Macro:
    DBG_LOG_FUNC_EXEC

Purpose:
    Only use this macro in the center of execution of any function. This can
    be used to log a particular state of the function.
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_FUNC_EXEC(pMasterBlock, FuncConstant, Module, P1, P2, P3) \
    if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks,DBG_BLK_FUNC))  \
       DbgLogFuncBlock(pMasterBlock,FuncConstant,DBG_FUNC_EXEC,Module,P1,P2,P3)

#else

    #define DBG_LOG_FUNC_EXEC(pMasterBlock, FuncConstant, Module, P1, P2, P3)

#endif



/*+

Macro:
    DBG_LOG_FUNC_ERROR

Purpose:
    Use this macro to indicate some error condition in a function.
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_FUNC_ERROR(pMasterBlock, FuncConstant, Module, P1, P2, P3)\
    if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocksDBG_BLK_FUNC))  \
       DbgLogFuncBlock(pMasterBlock,FuncConstant,DBG_FUNC_EXEC,Module,P1,P2,P3)

#else

    #define DBG_LOG_FUNC_ERROR(pMasterBlock, FuncConstant, Module, P1, P2, P3)

#endif



/*+

Macro:
    DBG_LOG_TEXT

Purpose:
    Macro to log an entry in the Text block
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_TEXT(pMasterBlock, dbgString) \
    if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks, \
                                        DBG_BLK_TEXT_MESSAGE))  \
        DbgLogTextBlock(pMasterBlock, sizeof(dbgString), dbgString)

#else

    #define DBG_LOG_TEXT(pMasterBlock, dbgString)

#endif



/*+

Macro:
    DBG_LOG_SIZED_TEXT

Purpose:
    Macro to log an entry in the Text block
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_SIZED_TEXT(pMasterBlock, strLen, dbgString) \
        if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks, \
                                DBG_BLK_TEXT_MESSAGE))  \
            DbgLogTextBlock(pMasterBlock, strLen, dbgString)

#else

    #define DBG_LOG_SIZED_TEXT(pMasterBlock, strLen, dbgString)

#endif



/*+

Macro:
    DBG_LOG_OP_PARAMETER

Purpose:
    Macro to log an operating parameter value
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_OP_PARAMETER(pMasterBlock, pParameterString, Value) \
        if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks, \
                                            DBG_BLK_OP_PARAMETER))  \
            DbgLogOpParameter(pMasterBlock, pParameterString, (ACIT_UEXACT64)Value)

#else

    #define DBG_LOG_OP_PARAMETER(pMasterBlock, pParameterString, Value)

#endif



/*+

Macro:
    DBG_LOG_STATISTICS

Purpose:
    Macro to log an a statistical value
-*/

#if ACIT_CFG_VASE_ENABLED

    #define DBG_LOG_STATISTICS_INCREMENT(pMasterBlock, _FIELD_NAME_)    \
        if(DBG_IS_BLOCK_ENABLED((pMasterBlock)->ThisSessionBlocks,      \
                                                 DBG_BLK_STATISTICS))   \
        do {                                                            \
            PDBG_STATISTICS_BLOCK      pStat;                           \
            pStat = (PDBG_STATISTICS_BLOCK)                             \
              ((pMasterBlock)->BlockHdrs[DBG_BLK_STATISTICS].Buffer);   \
            pStat->_FIELD_NAME_ ++;                                     \
        } while (0)

#else

    #define DBG_LOG_STATISTICS_INCREMENT(pMasterBlock, _FIELD_NAME_)

#endif



/*+

Macro:
    INCREMENT_ENTRY_INDEX

Purpose:
    Increments all index that track an entry
-*/

#define INCREMENT_ENTRY_INDEX(BLOCKNUM, CURRENT_ENTRY)                                 \
    do {                                                                               \
    CURRENT_ENTRY =                                                                    \
        OSM_LOCKED_INCREMENT_EXCHANGE32(&pMasterBlock->BlockHdrs[BLOCKNUM].HeadEntry); \
    if(CURRENT_ENTRY == (pMasterBlock->BlockHdrs[BLOCKNUM].MaxEntries - 1))            \
    {   /* This operations need to be proteced by a spin lock */                       \
        pMasterBlock->BlockHdrs[BLOCKNUM].HeadEntry =                                  \
            pMasterBlock->BlockHdrs[BLOCKNUM].HeadEntry %                              \
            pMasterBlock->BlockHdrs[BLOCKNUM].MaxEntries;                              \
        pMasterBlock->BlockHdrs[BLOCKNUM].TailEntry = 1;                               \
    }                                                                                  \
    else if(CURRENT_ENTRY >= pMasterBlock->BlockHdrs[BLOCKNUM].MaxEntries)             \
    {                                                                                  \
        CURRENT_ENTRY = CURRENT_ENTRY % pMasterBlock->BlockHdrs[BLOCKNUM].MaxEntries;  \
        pMasterBlock->BlockHdrs[BLOCKNUM].TailEntry = CURRENT_ENTRY + 2;               \
    }                                                                                  \
    else                                                                               \
    {                                                                                  \
        pMasterBlock->BlockHdrs[BLOCKNUM].TailEntry =                                  \
        (pMasterBlock->BlockHdrs[BLOCKNUM].EntriesMade >                               \
            pMasterBlock->BlockHdrs[BLOCKNUM].MaxEntries) ?                            \
            CURRENT_ENTRY + 2 :0;                                                      \
    }                                                                                  \
    OSM_LOCKED_INCREMENT32(&pMasterBlock->BlockHdrs[BLOCKNUM].EntriesMade);            \
    OSM_LOCKED_INCREMENT32(&pMasterBlock->CurrentSequenceNumber);                      \
    } while (0)



#if ACIT_CFG_VASE_ENABLED

/*
 * Data structures defined to interface with VASE.
 */
typedef struct _VASE_PROFILE
{
    ACIT_UEXACT64   Context;
    ACIT_UEXACT64   TimeStampFrequency;
    ACIT_UEXACT32   ConfigFlags;
    ACIT_UEXACT32   FuncBlockSize;
    ACIT_UEXACT32   TextBlockSize;
    ACIT_UEXACT32   OpParamBlockSize;
} VASE_PROFILE, *PVASE_PROFILE;



typedef ACIT_UEXACT32 (*POSM_LOCKED_INCREMENT_COUNTER)(
    PACIT_UEXACT32      Counter);

typedef ACIT_UEXACT32 (*POSM_CALL_SYNCHRONIZED)(
    PACIT_VOID          pMasterBlock,
    PACIT_VOID          Context);

typedef ACIT_UEXACT32 (*POSM_GET_TIMESTAMP)(
    PACIT_UEXACT64      pTimeStamp);



typedef struct _VASE_API_TABLE
{
    POSM_LOCKED_INCREMENT_COUNTER   posm_locked_increment_counter;
    POSM_CALL_SYNCHRONIZED          posm_call_syncronized;
    POSM_GET_TIMESTAMP              posm_get_timestamp;
/*
    pfunc_log_entry;
    popparam_log_entry;
    ptext_log_entry;
    pstart_log;
    pstop_log;
    pget_log;
*/
} VASE_API_TABLE, *PVASE_API_TABLE;


/*  Following structure defines the details on each debug block that is  */
/*  stored in the master block. */
typedef struct _DBG_BLOCK_HEADER
{
    ACIT_UEXACT32       ID;             /*  block identifier */
    ACIT_UEXACT32       Version;        /*  version of this bloc structure */
    ACIT_UEXACT8        Name[20];       /*  name of this block */
    ACIT_UEXACT32       Flags;          /*  special flags for block */
    ACIT_UEXACT32       TotalSize;      /*  total size for this block */
    ACIT_UEXACT32       MaxEntries;     /*  number of entries in it. */
    ACIT_UEXACT32       EntrySize;      /*  size of each entry */
    ACIT_UEXACT32       HeadEntry;      /*  first free entry location */
    ACIT_UEXACT32       TailEntry;      /*  earliest entry made in block */
    ACIT_UEXACT32       EntriesMade;    /*  total entries made in this block */
    ACIT_UEXACT64       Buffer;         /*  pointer to the block memory */
    ACIT_UEXACT32       BlockSpecific1; /*  blocks can use for whatever */
    ACIT_UEXACT32       BlockSpecific2; /*  blocks can use for whatever */
} DBG_BLOCK_HEADER, *PDBG_BLOCK_HEADER;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/



/*  ******************************************************************** */
/*  **************  Master Block                         *************** */
/*  ******************************************************************** */

/*  Following structure defines the master block layout */
typedef struct _DBG_MASTER_BLOCK
{
    /*  ver num of master block */
    ACIT_UEXACT32       Version;               
    /*  ptr to adapters dev extension */
    ACIT_UEXACT64       Context;               
    /*  blocks enabled during compile time */
    ACIT_UEXACT32       CompileEnabledBlocks;  
    /*  blocks enabled in the registry */
    ACIT_UEXACT32       RegistryEnabledBlocks; 
    /*  blocks available in this session */
    ACIT_UEXACT32       ThisSessionBlocks;     
    /*  Number of debug blocks available */
    ACIT_UEXACT32       NumberOfBlocksAvailable;
    /*  Number of debug blocks enabled */
    ACIT_UEXACT32       NumberOfBlocksEnabled; 
    /*  Total memory used for debugging */
    ACIT_UEXACT32       TotalDebugLogSize;     
    /*  last seq number */
    ACIT_UEXACT32       CurrentSequenceNumber; 
    /*  pointer to the top of debug memory */
    ACIT_UEXACT64       BlockBuffer;           
    /*  copy of Headers of other blocks */
    DBG_BLOCK_HEADER    BlockHdrs[DBG_MAX_BLOCKS];
} DBG_MASTER_BLOCK, *PDBG_MASTER_BLOCK;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/



/*  ******************************************************************** */
/*  **************  Function Block                       *************** */
/*  ******************************************************************** */

/*  Following structure defines details stored for each function block entry */
typedef struct _DBG_FUNC_BLOCK_ENTRY
{
    ACIT_UEXACT64       TimeStamp;
    ACIT_UEXACT32       SequenceNumber;
    ACIT_UEXACT16       FunctionID;     /* function identifier */     
    ACIT_UEXACT8        State;          /* entry or exit or middle state */
    ACIT_UEXACT8        Module;         /* more on function entry */
    ACIT_UEXACT64       Parameter1;     /* parameter 1 to log */
    ACIT_UEXACT64       Parameter2;     /* parameter 2 to log */
    ACIT_UEXACT64       Parameter3;     /* parameter 3 to log */
} DBG_FUNC_BLOCK_ENTRY, *PDBG_FUNC_BLOCK_ENTRY;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/


/*  Following definitions are flags for the function log entry */
/*  function entry is critical/noticeable */
#define DBG_FUNC_SEVERE                         0x80
/*  function entry nothing special */
#define DBG_FUNC_NORMAL                         0x00

/*  Following definitions are for function state constants that are logged */
/*  entering a function */
#define DBG_FUNC_ENTER                          0x01
/*  executing function */
#define DBG_FUNC_EXEC                           0x02
/*  exiting from function */
#define DBG_FUNC_EXIT                           0x03
/*  exiting with error from function */
#define DBG_FUNC_ERROR_EXIT                     0x04

/*  Following structure defines the function block */
typedef struct _DBG_FUNC_BLOCK
{
    DBG_FUNC_BLOCK_ENTRY    pLog[1];    /*  array of log entries. */
                                        /*  1 defined to allow compilation */
                                        /*  actual value picked at runtime. */
} DBG_FUNC_BLOCK, *PDBG_FUNC_BLOCK;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/



/*  ******************************************************************** */
/*  **************  Text Message Block                   *************** */
/*  ******************************************************************** */

/*  Following structure defines the text block entry */
/*  save the byte allignment */
/* #pragma pack(push) */
/*  set 1 byte allignment as this is a free flowing entry */
/* #pragma pack(1) */
typedef struct _DBG_TEXT_BLOCK_ENTRY
{
    /*  Used to identify this entry in a free flowing log */
    ACIT_UEXACT8     Marker1;          
    /*  sequence number of this entry */
    ACIT_UEXACT32   SequenceNumber;    
    /*  Used to identify this entry in a free flowing log */
    ACIT_UEXACT8     Marker2;          
// text buffer. 2 defined to maintain alignment and  */
/*     ACIT_UEXACT8    TextBuffer[2];    */
/*  to go thru compilation with no error. real value */
/*  is picked up later. */
    
} DBG_TEXT_BLOCK_ENTRY, *PDBG_TEXT_BLOCK_ENTRY;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/

/* #pragma pack(pop) */              /*  restore the byte allignment */

/*  Following structure defines the text block */
typedef struct _DBG_TEXT_BLOCK
{

    DBG_TEXT_BLOCK_ENTRY TextEntry[1];  /*  1 defined as compiler does  */
                                        /*  not like 0 and we do not know */
                                        /* the exact size */
} DBG_TEXT_BLOCK, *PDBG_TEXT_BLOCK;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/




/*  ******************************************************************** */
/*  **************  Operating Parameter Block            *************** */
/*  ******************************************************************** */

/*  Following structure defines the operating parameter block entry */
typedef struct _DBG_OP_PARAMETER_BLOCK_ENTRY
{
    ACIT_UEXACT32       SequenceNumber;     /*  sequence number of this entry */
    ACIT_UEXACT64       Value;              /*  value of the given parameter */
    ACIT_UEXACT8        ParameterString[OP_PARAMETER_STRING_SIZE];
                                /*  buffer to hold the parameter name */
} DBG_OP_PARAMETER_BLOCK_ENTRY, *PDBG_OP_PARAMETER_BLOCK_ENTRY;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/


/*  Following structure defines the text block */
typedef struct _DBG_OP_PARAMETER_BLOCK
{
    DBG_OP_PARAMETER_BLOCK_ENTRY Param[1];  /* 1 defined as compiler does */
                                            /*  not like 0 and we do not */
                                            /* know the exact size */
} DBG_OP_PARAMETER_BLOCK, *PDBG_OP_PARAMETER_BLOCK;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/



/*  ******************************************************************** */
/*  **************  Statistics Block  ********************************** */
/*  ******************************************************************** */

typedef struct _DBG_STATISTICS_BLOCK
{
    ACIT_UEXACT64               TimerTicks;
    ACIT_UEXACT64               ValidInterrupts;
    ACIT_UEXACT64               InvalidInterrupts;
    ACIT_UEXACT64               IOs;
    ACIT_UEXACT64               IOCTLs;
    ACIT_UEXACT64               Aborts;
    ACIT_UEXACT64               LuResets;
    ACIT_UEXACT64               TgtResets;

} DBG_STATISTICS_BLOCK, *PDBG_STATISTICS_BLOCK;
/*** PLEASE READ 'VERSION_RULES' above when making changes to this structure **/


// Following definitions describe the debug ioctl commands supported
#define DBG_IOCTLCMD_NOP                        0x00000000
#define DBG_IOCTLCMD_GET_MASTER_BLOCK           0x00000001
#define DBG_IOCTLCMD_GET_DEBUG_BLOCK            0x00000002
// ******   PLEASE READ 'VERSION_RULES' above when making changes to these definitions ******


// Following definitions describe the debug ioctl status
#define DBG_IOCTLCMD_STATUS_SUCCESS             0x00000000
#define DBG_IOCTLCMD_STATUS_FAIL                0x00000001
#define DBG_IOCTLCMD_STATUS_UNKNOWNCMD          0x00000002
#define DBG_IOCTLCMD_STATUS_INSUFFICIENT_BUFFER 0x00000003
#define DBG_IOCTLCMD_STATUS_BLOCK_UNAVAILABLE   0x00000004
#define DBG_IOCTLCMD_STATUS_UNKNOWN_BLOCKID     0x00000005
// ******   PLEASE READ 'VERSION_RULES' above when making changes to these definitions ******

// Following definitions describe the debug ioctl flags
#define DBG_IOCTLCMD_FLAG_CHECKSTR              0x00000001
// ******   PLEASE READ 'VERSION_RULES' above when making changes to these definitions ******

typedef struct _DBG_COMMAND
{
    ACIT_UEXACT32       CommandCode;    // application fills this up.
    ACIT_UEXACT32       Version;        // application fills this up.
    ACIT_UEXACT32       BufferLength;   // application fills this up.
    ACIT_UEXACT32       BufferOffset;   // application fills this up.
    ACIT_UEXACT32       CmdFlags;       // application fills this up.
    ACIT_UEXACT32       Status;         // miniport fills this up.
    ACIT_UEXACT32       StatusFlag;     // miniport fills this up.
    ACIT_UEXACT8        StatusStr[256]; // miniport fills this up.
    ACIT_UEXACT32       Parameter1;     // parameter for any command
    ACIT_UEXACT32       Reserved;       // not used now.
} DBG_COMMAND, *PDBG_COMMAND;




ACIT_UEXACT32
DbgLogPreInit(
    PDBG_MASTER_BLOCK   pMasterBlock,
    PACIT_UEXACT32      pMemNeeded,
    PVASE_PROFILE       pVaseProfile);

ACIT_UEXACT32   
DbgLogInitialize(
    PDBG_MASTER_BLOCK   pMasterBlock,
    PACIT_VOID          pMemBuffer,
    ACIT_UEXACT32       FreqFor10ms);

ACIT_UEXACT32 
DbgLogIoctl(
    PACIT_VOID          pMasterBuffer,
    PACIT_VOID          pCmdBuffer);

ACIT_VOID 
DbgLogFuncBlock(
    PDBG_MASTER_BLOCK   pMasterBlock, 
    ACIT_UEXACT16       FunctionID, 
    ACIT_UEXACT8        FuncState,
    ACIT_UEXACT8        Module,
    ACIT_UEXACT64       Param1,
    ACIT_UEXACT64       Param2,
    ACIT_UEXACT64       Param3);

ACIT_VOID
DbgLogTextBlock(
    PDBG_MASTER_BLOCK    pMasterBlock,
    ACIT_UEXACT32        messageSize,
    ACIT_UEXACT8         dbgMessage[]);

ACIT_VOID
DbgLogOpParameter(
    PDBG_MASTER_BLOCK    pMasterBlock,
    PACIT_UEXACT8        pParameterString,
    ACIT_UEXACT64        Value);


#endif /* ACIT_CFG_VASE_ENABLED */


