/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __beclib_ll_enum_h__
#define __beclib_ll_enum_h__
#include "setypes.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- BECLIB_VERSION_ENUM ---
#define BECLIB_VER0                     (0)       
#define BECLIB_VER1                     (1)       

typedef enum {
   ENUM_BECLIB_VER0 = 0x0UL,
   ENUM_BECLIB_VER1 = 0x1UL
} BECLIB_VERSION_ENUM;

// --- BE_FUNCTION_ENUM ---
#define BE_FUNCTION_TYPE_ISCSI          (0)       
#define BE_FUNCTION_TYPE_NETWORK        (1)       
#define BE_FUNCTION_TYPE_ARM            (2)       
#define BE_FUNCTION_TYPE_FCOE           (3)       

typedef enum {
   ENUM_BE_FUNCTION_TYPE_ISCSI = 0x0UL,
   ENUM_BE_FUNCTION_TYPE_NETWORK = 0x1UL,
   ENUM_BE_FUNCTION_TYPE_ARM = 0x2UL,
   ENUM_BE_FUNCTION_TYPE_FCOE = 0x3UL
} BE_FUNCTION_ENUM;

// --- BE_CQ_DMA_COALESCING ---
// Enumeration for cqe_dma_coalescing parameter. 
#define BE_CQ_DMA_COALESCE_NONE         (0)       // Disable coalescing of CQ DMAs.
#define BE_CQ_DMA_COALESCE_2            (1)       // If >= 2 CQEs are pending for the host
                                                  // driver, start coalescing CQE DMAs.
#define BE_CQ_DMA_COALESCE_4            (2)       // If >= 4 CQEs are pending for the host
                                                  // driver, start coalescing CQE DMAs.
#define BE_CQ_DMA_COALESCE_16           (3)       // If >= 16 CQEs are pending for the
                                                  // host driver, start coalescing CQE
                                                  // DMAs.

typedef enum {
   ENUM_BE_CQ_DMA_COALESCE_NONE = 0x0UL,
   ENUM_BE_CQ_DMA_COALESCE_2 = 0x1UL,
   ENUM_BE_CQ_DMA_COALESCE_4 = 0x2UL,
   ENUM_BE_CQ_DMA_COALESCE_16 = 0x3UL
} BE_CQ_DMA_COALESCING;

// --- BE_MCC_RING_CREATE_EXT_FLAGS ---
#define BE_MCC_RING_CREATE_EXT_FLAG_NONE (0)      // Don't subscribe to any events
#define BE_MCC_RING_CREATE_EXT_FLAG_LINK_STATE (2) // Link State Event
#define BE_MCC_RING_CREATE_EXT_FLAG_FCF_STATE (4) // FCF State Event
#define BE_MCC_RING_CREATE_EXT_FLAG_GROUP5 (32)   // Group 5 Event

typedef enum {
   ENUM_BE_MCC_RING_CREATE_EXT_FLAG_NONE = 0x0UL,
   ENUM_BE_MCC_RING_CREATE_EXT_FLAG_LINK_STATE = 0x2UL,
   ENUM_BE_MCC_RING_CREATE_EXT_FLAG_FCF_STATE = 0x4UL,
   ENUM_BE_MCC_RING_CREATE_EXT_FLAG_GROUP5 = 0x20UL
} BE_MCC_RING_CREATE_EXT_FLAGS;

// --- BE_ETH_TX_RING_TYPE_ENUM ---
#define BE_ETH_TX_RING_TYPE_FORWARDING  (1)       // Ethernet ring for forwarding packets
                                                  // to the offload TOE engine.
#define BE_ETH_TX_RING_TYPE_STANDARD    (2)       // Ethernet ring for sending network
                                                  // packets.
#define BE_ETH_TX_RING_TYPE_LOW_LATENCY (4)       // Low latency ring for sending network
                                                  // packets. Does not support LSO or
                                                  // VLAN.
#define BE_ETH_TX_RING_TYPE_BOUND       (8)       // Bound ring type for ethernet sends.
#define BE_ETH_TX_RING_TYPE_STANDARD_NO_QOS (16)  // Standard ring not subject to QoS
                                                  // limits.
#define BE_ETH_TX_RING_TYPE_PRIORITY    (32)      // Ring for sending packets according to
                                                  // associated priority.

typedef enum {
   ENUM_BE_ETH_TX_RING_TYPE_FORWARDING = 0x1UL,
   ENUM_BE_ETH_TX_RING_TYPE_STANDARD = 0x2UL,
   ENUM_BE_ETH_TX_RING_TYPE_LOW_LATENCY = 0x4UL,
   ENUM_BE_ETH_TX_RING_TYPE_BOUND = 0x8UL,
   ENUM_BE_ETH_TX_RING_TYPE_STANDARD_NO_QOS = 0x10UL,
   ENUM_BE_ETH_TX_RING_TYPE_PRIORITY = 0x20UL
} BE_ETH_TX_RING_TYPE_ENUM;

// --- BE_TOE_CXN_UPLOAD_ENUM ---
#define BE_TOE_UPLOAD_FLAG_NONE         (0)       // Graceful Upload
#define BE_TOE_UPLOAD_FLAG_GRACEFUL     (0)       // Graceful Upload
#define BE_TOE_UPLOAD_FLAG_RESET        (1)       // Sends a TCP RST
#define BE_TOE_UPLOAD_FLAG_ABORT        (2)       // Aborts connection without sending a
                                                  // RST.
#define BE_TOE_UPLOAD_FLAG_RST_WITH_SEQUENCE (4)  // Sends a TCP RST with given sequence
                                                  // number.

typedef enum {
   ENUM_BE_TOE_UPLOAD_FLAG_NONE = 0x0UL,
   ENUM_BE_TOE_UPLOAD_FLAG_GRACEFUL = 0x0UL,
   ENUM_BE_TOE_UPLOAD_FLAG_RESET = 0x1UL,
   ENUM_BE_TOE_UPLOAD_FLAG_ABORT = 0x2UL,
   ENUM_BE_TOE_UPLOAD_FLAG_RST_WITH_SEQUENCE = 0x4UL
} BE_TOE_CXN_UPLOAD_ENUM;

// --- UE_SCRATCHPAD_DISABLE_ENUM ---
#define UE_DISABLE_NONE                 (0)       
#define UE_DISABLE_PF0                  (1)       
#define UE_DISABLE_PF1                  (2)       
#define UE_DISABLE_PF2                  (4)       
#define UE_DISABLE_PF3                  (8)       
#define UE_DISABLE_PF4                  (16)      
#define UE_DISABLE_PF5                  (32)      
#define UE_DISABLE_PF6                  (64)      
#define UE_DISABLE_PF7                  (128)     
#define UE_DISABLE_FIRMWARE             (256)     

// --- UE_TIMEOUTS ---
// These timeout values must be validated and honored by all drivers. They are expressed
// as microseconds. 
#define UE_TIMEOUT_SEMAPHORE            (20000)   // A semaphore acquisition will timeout
                                                  // after this interval. If the semaphore
                                                  // acquisition times out, UE recovery
                                                  // will fail for that function. It is
                                                  // important that all functions hold the
                                                  // semaphore for extremely short
                                                  // durations -- similar to a spinlock.
                                                  // However, unlike a spinlock the
                                                  // acquisition order is not queued and a
                                                  // single function may be starved access
                                                  // to the semaphore. Therefore short
                                                  // locking durations are even more
                                                  // critical. 
#define UE_TIMEOUT_RESET_POLL           (50000)   // During the reset sequence, this is
                                                  // the timeout for polling the registers
                                                  // for feedback.
#define UE_TIMEOUT_MASTER               (10000000) // The master waits for this timeout
                                                   // before resetting the ASIC. This
                                                   // requires all functions to detect the
                                                   // UE and quiesce operations within the
                                                   // timeout. 
#define UE_TIMEOUT_FAT                  (10000000) // After the master timeout, the master
                                                   // will wait for FAT to complete. If
                                                   // FAT fails to complete within this
                                                   // timeout, the reset will continue
                                                   // regardless since the FAT code may
                                                   // have locked up. The master_timeout +
                                                   // fat_timeout must be less than the
                                                   // slave_timeout to make sure the reset
                                                   // happens with PCI-E silence. 
#define UE_TIMEOUT_AFTER_RESET          (20000000) // After the MASTER resets the ASIC, it
                                                   // should wait for this timeout. This
                                                   // avoids detecting any false UEs as
                                                   // the ARM is booting. This timeout is
                                                   // generally slave_timeout -
                                                   // master_timeout. The ARM booting will
                                                   // entirely overlap with this timeout,
                                                   // so this doesn't affect the total
                                                   // recovery time. 
#define UE_TIMEOUT_SLAVE                (30000000) // The slave functions wait for this
                                                   // timeout before checking if the reset
                                                   // was successful. This keeps the PCI-E
                                                   // bus quiet during the reset. The
                                                   // timeout is generally the
                                                   // master_timeout plus the time
                                                   // required for the ARM to boot. 
#define UE_TIMEOUT_VM                   (35000000) // Same as the UE_TIMEOUT_SLAVE, but
                                                   // used by virtual functions. 

typedef enum {
   ENUM_UE_TIMEOUT_SEMAPHORE = 0x4e20UL,
   ENUM_UE_TIMEOUT_RESET_POLL = 0xc350UL,
   ENUM_UE_TIMEOUT_MASTER = 0x989680UL,
   ENUM_UE_TIMEOUT_FAT = 0x989680UL,
   ENUM_UE_TIMEOUT_AFTER_RESET = 0x1312d00UL,
   ENUM_UE_TIMEOUT_SLAVE = 0x1c9c380UL,
   ENUM_UE_TIMEOUT_VM = 0x2160ec0UL
} UE_TIMEOUTS;

// --- BE_UE_TIMEOUT_ENUM ---
#define UE_WHICH_TIMEOUT_SEMAPHORE      (0)       // Timeout for polling the semaphore
                                                  // acquisition.
#define UE_WHICH_TIMEOUT_MASTER         (1)       // Timeout for masters to wait for
                                                  // issuing soft reset.
#define UE_WHICH_TIMEOUT_FAT            (2)       // Timeout for waiting for FAT to
                                                  // complete before a PCI reset in the UE
                                                  // recovery sequence. If this timeout
                                                  // expires, the sequence continues
                                                  // without an error, but the FAT log may
                                                  // be incomplete.
#define UE_WHICH_TIMEOUT_SLAVE          (3)       // Timeout for slaves to remain quiet
                                                  // after detecting a UE for reset to
                                                  // occur.
#define UE_WHICH_TIMEOUT_PCI_RESET_POLL (4)       // Timeout for polling the soft reset
                                                  // register during the PCI reset
                                                  // sequence.
#define UE_WHICH_TIMEOUT_AFTER_RESET    (5)       // Timeout for master to wait after the
                                                  // reset.

typedef enum {
   ENUM_UE_WHICH_TIMEOUT_SEMAPHORE = 0x0UL,
   ENUM_UE_WHICH_TIMEOUT_MASTER = 0x1UL,
   ENUM_UE_WHICH_TIMEOUT_FAT = 0x2UL,
   ENUM_UE_WHICH_TIMEOUT_SLAVE = 0x3UL,
   ENUM_UE_WHICH_TIMEOUT_PCI_RESET_POLL = 0x4UL,
   ENUM_UE_WHICH_TIMEOUT_AFTER_RESET = 0x5UL
} BE_UE_TIMEOUT_ENUM;

// --- BE_SOFTWARE_UE_CODES ---
#define UE_SOFTWARE_CQ_TIMEOUT          (1)       // BECLIB timeout polling CQ.
#define UE_SOFTWARE_MAILBOX_TIMEOUT     (2)       // BECLIB timeout polling mailbox.

typedef enum {
   ENUM_UE_SOFTWARE_CQ_TIMEOUT = 0x1UL,
   ENUM_UE_SOFTWARE_MAILBOX_TIMEOUT = 0x2UL
} BE_SOFTWARE_UE_CODES;

#endif // __beclib_ll_enum_h__

