/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   emulation.c

@brief
   
CVS Header Information:
   $Header: $
*/

#if defined(BE_EMULATION) || defined(BE_SELECTIVE_EMULATION)

    // Emulation is enabled -- include the necessary structs and function declarations.
    #include "emulation_ll.h"

#else

    // No emulation is supported.  Define macros to fake the emulation entry points.
    #define be_mccemul_init(_x_)
    #define _be_mpuemul_init(_x_)    
    #define be_mccemul_process_wrb(_x, _y, _z)  (BE_NOT_OK)

    STATIC FORCEINLINE 
    boolean
    be_mccemul_is_emulated (struct _BE_FUNCTION_OBJECT* function_object, PMCC_WRB wrb, PVOID optional_ioctl_va) {
        return FALSE;
    }

#endif
