/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

/*!
@file
   mccemul_private_ll.h

@brief
    Provides common declarations used by lower-level emulation files.

*/

#ifndef __mccemul_priv_h__
#define __mccemul_priv_h__

#define MCCEMUL_BAD_ID (SA_BV_BAD_INDEX)


u32
be_mccemul_allocate_qid (
    IN PBE_FUNCTION_OBJECT function_object,
    IN CHIP_ID_TYPES       id_type);

BESTATUS
mccemul_map_pa_list (
    IN  PBE_FUNCTION_OBJECT function_object,
    IN  CRA_UNION           cra,
    IN  PHYS_ADDR          *pa_list,
    IN  u32                 num_pa);
/*
BESTATUS
mccemul_update_template_header (
    PBE_FUNCTION_OBJECT  function_object,
    u32                  cid,
    MPU_TEMPLATE_HEADER* header);
*/
void
mccemul_write_tcp_context (
    PBE_FUNCTION_OBJECT function_object,
    u32                 cid,
    TCP_CONTEXT*        context);
    
void
mccemul_read_tcp_context (
    PBE_FUNCTION_OBJECT function_object,
    u32                 cid,
    TCP_CONTEXT*        context);

#endif  // __mccemul_priv_h__
