/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __armspiflash_bmap_h__
#define __armspiflash_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The SPI Address registers contents are used for the address field on the SPI
   // interface. This register contains the SPI address [7:0]. These registers are only
   // used during SPI access through the register access mode. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_ADDRESS {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 addr : 24;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_ADDRESS, *PSPI_ADDRESS;

      SG_C_ASSERT(__sizeof__SPI_ADDRESS, sizeof (SPI_ADDRESS) == 4);

   #else
      typedef struct _SPI_ADDRESS {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 addr : 24;                           // DWORD 0
      } SG_PACK SPI_ADDRESS, *PSPI_ADDRESS;

      typedef union _SPI_ADDRESS_UNION {
         SPI_ADDRESS bits;
         u32 dw; // dword union
      } SG_PACK SPI_ADDRESS_UNION, *PSPI_ADDRESS_UNION;

      SG_C_ASSERT(__sizeof__SPI_ADDRESS_UNION, sizeof (SPI_ADDRESS_UNION) == 4);
   #endif


#else
   // The SPI Address registers contents are used for the address field on the SPI
   // interface. This register contains the SPI address [7:0]. These registers are only
   // used during SPI access through the register access mode. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_ADDRESS {
         union {
            struct { 
               u32 addr : 24;                     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_ADDRESS, *PSPI_ADDRESS;

      SG_C_ASSERT(__sizeof__SPI_ADDRESS, sizeof (SPI_ADDRESS) == 4);

   #else
      typedef struct _SPI_ADDRESS {
         u32 addr : 24;                           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK SPI_ADDRESS, *PSPI_ADDRESS;

      typedef union _SPI_ADDRESS_UNION {
         SPI_ADDRESS bits;
         u32 dw; // dword union
      } SG_PACK SPI_ADDRESS_UNION, *PSPI_ADDRESS_UNION;

      SG_C_ASSERT(__sizeof__SPI_ADDRESS_UNION, sizeof (SPI_ADDRESS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Data to be written to SPI flash or data read from SPI flash. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_DATA {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_DATA, *PSPI_DATA;

      SG_C_ASSERT(__sizeof__SPI_DATA, sizeof (SPI_DATA) == 4);

   #else
      typedef struct _SPI_DATA {
         u32 data;                                // DWORD 0
      } SG_PACK SPI_DATA, *PSPI_DATA;

      typedef union _SPI_DATA_UNION {
         SPI_DATA bits;
         u32 dw; // dword union
      } SG_PACK SPI_DATA_UNION, *PSPI_DATA_UNION;

      SG_C_ASSERT(__sizeof__SPI_DATA_UNION, sizeof (SPI_DATA_UNION) == 4);
   #endif


#else
   // Data to be written to SPI flash or data read from SPI flash. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_DATA {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_DATA, *PSPI_DATA;

      SG_C_ASSERT(__sizeof__SPI_DATA, sizeof (SPI_DATA) == 4);

   #else
      typedef struct _SPI_DATA {
         u32 data;                                // DWORD 0
      } SG_PACK SPI_DATA, *PSPI_DATA;

      typedef union _SPI_DATA_UNION {
         SPI_DATA bits;
         u32 dw; // dword union
      } SG_PACK SPI_DATA_UNION, *PSPI_DATA_UNION;

      SG_C_ASSERT(__sizeof__SPI_DATA_UNION, sizeof (SPI_DATA_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Firmware should not modify the SPI Controller registers (except Bit[7] and Bit[0] of
   // CMD3 register, as mentioned in the register bit description) when the SPI Controller
   // is in the middle of a transaction with the SPI Device. Modifying these registers has
   // direct effect on the timing to the SPI Device and the operation of the controller
   // and any changes in the middle of a transaction can result in corrupted data/command.
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_COMMAND {
         union {
            struct { 
               u32 cmd3_regaccess : 1;            // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 cmd3_fastread : 1;             // DWORD 0
               u32 cmd3_wrfifo : 1;               // DWORD 0
               u32 cmd3_cs : 1;                   // DWORD 0
               u32 cmd2_dummy : 8;                // DWORD 0
               u32 cmd1_numbyte : 3;              // DWORD 0
               u32 cmd1_dir : 1;                  // DWORD 0
               u32 cmd1_len : 4;                  // DWORD 0
               u32 cmd0_op : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_COMMAND, *PSPI_COMMAND;

      SG_C_ASSERT(__sizeof__SPI_COMMAND, sizeof (SPI_COMMAND) == 4);

   #else
      typedef struct _SPI_COMMAND {
         u32 cmd3_regaccess : 1;                  // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cmd3_fastread : 1;                   // DWORD 0
         u32 cmd3_wrfifo : 1;                     // DWORD 0
         u32 cmd3_cs : 1;                         // DWORD 0
         u32 cmd2_dummy : 8;                      // DWORD 0
         u32 cmd1_numbyte : 3;                    // DWORD 0
         u32 cmd1_dir : 1;                        // DWORD 0
         u32 cmd1_len : 4;                        // DWORD 0
         u32 cmd0_op : 8;                         // DWORD 0
      } SG_PACK SPI_COMMAND, *PSPI_COMMAND;

      typedef union _SPI_COMMAND_UNION {
         SPI_COMMAND bits;
         u32 dw; // dword union
      } SG_PACK SPI_COMMAND_UNION, *PSPI_COMMAND_UNION;

      SG_C_ASSERT(__sizeof__SPI_COMMAND_UNION, sizeof (SPI_COMMAND_UNION) == 4);
   #endif


#else
   // Firmware should not modify the SPI Controller registers (except Bit[7] and Bit[0] of
   // CMD3 register, as mentioned in the register bit description) when the SPI Controller
   // is in the middle of a transaction with the SPI Device. Modifying these registers has
   // direct effect on the timing to the SPI Device and the operation of the controller
   // and any changes in the middle of a transaction can result in corrupted data/command.
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_COMMAND {
         union {
            struct { 
               u32 cmd0_op : 8;                   // DWORD 0
               u32 cmd1_len : 4;                  // DWORD 0
               u32 cmd1_dir : 1;                  // DWORD 0
               u32 cmd1_numbyte : 3;              // DWORD 0
               u32 cmd2_dummy : 8;                // DWORD 0
               u32 cmd3_cs : 1;                   // DWORD 0
               u32 cmd3_wrfifo : 1;               // DWORD 0
               u32 cmd3_fastread : 1;             // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 cmd3_regaccess : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_COMMAND, *PSPI_COMMAND;

      SG_C_ASSERT(__sizeof__SPI_COMMAND, sizeof (SPI_COMMAND) == 4);

   #else
      typedef struct _SPI_COMMAND {
         u32 cmd0_op : 8;                         // DWORD 0
         u32 cmd1_len : 4;                        // DWORD 0
         u32 cmd1_dir : 1;                        // DWORD 0
         u32 cmd1_numbyte : 3;                    // DWORD 0
         u32 cmd2_dummy : 8;                      // DWORD 0
         u32 cmd3_cs : 1;                         // DWORD 0
         u32 cmd3_wrfifo : 1;                     // DWORD 0
         u32 cmd3_fastread : 1;                   // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 cmd3_regaccess : 1;                  // DWORD 0
      } SG_PACK SPI_COMMAND, *PSPI_COMMAND;

      typedef union _SPI_COMMAND_UNION {
         SPI_COMMAND bits;
         u32 dw; // dword union
      } SG_PACK SPI_COMMAND_UNION, *PSPI_COMMAND_UNION;

      SG_C_ASSERT(__sizeof__SPI_COMMAND_UNION, sizeof (SPI_COMMAND_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allows for changing the timing the SPI interface. The default values should work for
   // most devices. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_TIMING_CONFIG {
         union {
            struct { 
               u32 tcsh : 8;                      // DWORD 0
               u32 tcsl : 8;                      // DWORD 0
               u32 tcs : 8;                       // DWORD 0
               u32 trec : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_TIMING_CONFIG, *PSPI_TIMING_CONFIG;

      SG_C_ASSERT(__sizeof__SPI_TIMING_CONFIG, sizeof (SPI_TIMING_CONFIG) == 4);

   #else
      typedef struct _SPI_TIMING_CONFIG {
         u32 tcsh : 8;                            // DWORD 0
         u32 tcsl : 8;                            // DWORD 0
         u32 tcs : 8;                             // DWORD 0
         u32 trec : 8;                            // DWORD 0
      } SG_PACK SPI_TIMING_CONFIG, *PSPI_TIMING_CONFIG;

      typedef union _SPI_TIMING_CONFIG_UNION {
         SPI_TIMING_CONFIG bits;
         u32 dw; // dword union
      } SG_PACK SPI_TIMING_CONFIG_UNION, *PSPI_TIMING_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__SPI_TIMING_CONFIG_UNION, sizeof (SPI_TIMING_CONFIG_UNION) == 4);
   #endif


#else
   // Allows for changing the timing the SPI interface. The default values should work for
   // most devices. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_TIMING_CONFIG {
         union {
            struct { 
               u32 trec : 8;                      // DWORD 0
               u32 tcs : 8;                       // DWORD 0
               u32 tcsl : 8;                      // DWORD 0
               u32 tcsh : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_TIMING_CONFIG, *PSPI_TIMING_CONFIG;

      SG_C_ASSERT(__sizeof__SPI_TIMING_CONFIG, sizeof (SPI_TIMING_CONFIG) == 4);

   #else
      typedef struct _SPI_TIMING_CONFIG {
         u32 trec : 8;                            // DWORD 0
         u32 tcs : 8;                             // DWORD 0
         u32 tcsl : 8;                            // DWORD 0
         u32 tcsh : 8;                            // DWORD 0
      } SG_PACK SPI_TIMING_CONFIG, *PSPI_TIMING_CONFIG;

      typedef union _SPI_TIMING_CONFIG_UNION {
         SPI_TIMING_CONFIG bits;
         u32 dw; // dword union
      } SG_PACK SPI_TIMING_CONFIG_UNION, *PSPI_TIMING_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__SPI_TIMING_CONFIG_UNION, sizeof (SPI_TIMING_CONFIG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Top level SPI control registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_CONTROL {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 clk_pol : 1;                   // DWORD 0
               u32 clk_phase : 1;                 // DWORD 0
               u32 enable : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_CONTROL, *PSPI_CONTROL;

      SG_C_ASSERT(__sizeof__SPI_CONTROL, sizeof (SPI_CONTROL) == 4);

   #else
      typedef struct _SPI_CONTROL {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 clk_pol : 1;                         // DWORD 0
         u32 clk_phase : 1;                       // DWORD 0
         u32 enable : 1;                          // DWORD 0
      } SG_PACK SPI_CONTROL, *PSPI_CONTROL;

      typedef union _SPI_CONTROL_UNION {
         SPI_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK SPI_CONTROL_UNION, *PSPI_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__SPI_CONTROL_UNION, sizeof (SPI_CONTROL_UNION) == 4);
   #endif


#else
   // Top level SPI control registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_CONTROL {
         union {
            struct { 
               u32 enable : 1;                    // DWORD 0
               u32 clk_phase : 1;                 // DWORD 0
               u32 clk_pol : 1;                   // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_CONTROL, *PSPI_CONTROL;

      SG_C_ASSERT(__sizeof__SPI_CONTROL, sizeof (SPI_CONTROL) == 4);

   #else
      typedef struct _SPI_CONTROL {
         u32 enable : 1;                          // DWORD 0
         u32 clk_phase : 1;                       // DWORD 0
         u32 clk_pol : 1;                         // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK SPI_CONTROL, *PSPI_CONTROL;

      typedef union _SPI_CONTROL_UNION {
         SPI_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK SPI_CONTROL_UNION, *PSPI_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__SPI_CONTROL_UNION, sizeof (SPI_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register defines the clock frequency going to the SPI device. The reference
   // clock used for the divider is 100MHz. The highest SPI clock frequency that is
   // supported by the hardware is 25MHz. The divider value cannot be lower than 4. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_CLOCK_CTRL {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 clk_phase : 8;                 // DWORD 0
               u32 clkdivl : 8;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_CLOCK_CTRL, *PSPI_CLOCK_CTRL;

      SG_C_ASSERT(__sizeof__SPI_CLOCK_CTRL, sizeof (SPI_CLOCK_CTRL) == 4);

   #else
      typedef struct _SPI_CLOCK_CTRL {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 clk_phase : 8;                       // DWORD 0
         u32 clkdivl : 8;                         // DWORD 0
      } SG_PACK SPI_CLOCK_CTRL, *PSPI_CLOCK_CTRL;

      typedef union _SPI_CLOCK_CTRL_UNION {
         SPI_CLOCK_CTRL bits;
         u32 dw; // dword union
      } SG_PACK SPI_CLOCK_CTRL_UNION, *PSPI_CLOCK_CTRL_UNION;

      SG_C_ASSERT(__sizeof__SPI_CLOCK_CTRL_UNION, sizeof (SPI_CLOCK_CTRL_UNION) == 4);
   #endif


#else
   // This register defines the clock frequency going to the SPI device. The reference
   // clock used for the divider is 100MHz. The highest SPI clock frequency that is
   // supported by the hardware is 25MHz. The divider value cannot be lower than 4. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_CLOCK_CTRL {
         union {
            struct { 
               u32 clkdivl : 8;                   // DWORD 0
               u32 clk_phase : 8;                 // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_CLOCK_CTRL, *PSPI_CLOCK_CTRL;

      SG_C_ASSERT(__sizeof__SPI_CLOCK_CTRL, sizeof (SPI_CLOCK_CTRL) == 4);

   #else
      typedef struct _SPI_CLOCK_CTRL {
         u32 clkdivl : 8;                         // DWORD 0
         u32 clk_phase : 8;                       // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK SPI_CLOCK_CTRL, *PSPI_CLOCK_CTRL;

      typedef union _SPI_CLOCK_CTRL_UNION {
         SPI_CLOCK_CTRL bits;
         u32 dw; // dword union
      } SG_PACK SPI_CLOCK_CTRL_UNION, *PSPI_CLOCK_CTRL_UNION;

      SG_C_ASSERT(__sizeof__SPI_CLOCK_CTRL_UNION, sizeof (SPI_CLOCK_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register contains the Boot SPI status bits. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_STATUS {
         union {
            struct { 
               u32 rsvd1 : 26;                    // DWORD 0
               u32 write_fifo_empty : 1;          // DWORD 0
               u32 write_fifo_full : 1;           // DWORD 0
               u32 write_fifo_rdy : 1;            // DWORD 0
               u32 sm_busy : 1;                   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 reg_acc_busy : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_STATUS, *PSPI_STATUS;

      SG_C_ASSERT(__sizeof__SPI_STATUS, sizeof (SPI_STATUS) == 4);

   #else
      typedef struct _SPI_STATUS {
         u32 rsvd1 : 26;                          // DWORD 0
         u32 write_fifo_empty : 1;                // DWORD 0
         u32 write_fifo_full : 1;                 // DWORD 0
         u32 write_fifo_rdy : 1;                  // DWORD 0
         u32 sm_busy : 1;                         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 reg_acc_busy : 1;                    // DWORD 0
      } SG_PACK SPI_STATUS, *PSPI_STATUS;

      typedef union _SPI_STATUS_UNION {
         SPI_STATUS bits;
         u32 dw; // dword union
      } SG_PACK SPI_STATUS_UNION, *PSPI_STATUS_UNION;

      SG_C_ASSERT(__sizeof__SPI_STATUS_UNION, sizeof (SPI_STATUS_UNION) == 4);
   #endif


#else
   // This register contains the Boot SPI status bits. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_STATUS {
         union {
            struct { 
               u32 reg_acc_busy : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 sm_busy : 1;                   // DWORD 0
               u32 write_fifo_rdy : 1;            // DWORD 0
               u32 write_fifo_full : 1;           // DWORD 0
               u32 write_fifo_empty : 1;          // DWORD 0
               u32 rsvd1 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_STATUS, *PSPI_STATUS;

      SG_C_ASSERT(__sizeof__SPI_STATUS, sizeof (SPI_STATUS) == 4);

   #else
      typedef struct _SPI_STATUS {
         u32 reg_acc_busy : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 sm_busy : 1;                         // DWORD 0
         u32 write_fifo_rdy : 1;                  // DWORD 0
         u32 write_fifo_full : 1;                 // DWORD 0
         u32 write_fifo_empty : 1;                // DWORD 0
         u32 rsvd1 : 26;                          // DWORD 0
      } SG_PACK SPI_STATUS, *PSPI_STATUS;

      typedef union _SPI_STATUS_UNION {
         SPI_STATUS bits;
         u32 dw; // dword union
      } SG_PACK SPI_STATUS_UNION, *PSPI_STATUS_UNION;

      SG_C_ASSERT(__sizeof__SPI_STATUS_UNION, sizeof (SPI_STATUS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is a miscellaneous register used for internal control of the SPI controller
   // state machine. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_MISC {
         union {
            struct { 
               u32 int_rsvd;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_MISC, *PSPI_MISC;

      SG_C_ASSERT(__sizeof__SPI_MISC, sizeof (SPI_MISC) == 4);

   #else
      typedef struct _SPI_MISC {
         u32 int_rsvd;                            // DWORD 0
      } SG_PACK SPI_MISC, *PSPI_MISC;

      typedef union _SPI_MISC_UNION {
         SPI_MISC bits;
         u32 dw; // dword union
      } SG_PACK SPI_MISC_UNION, *PSPI_MISC_UNION;

      SG_C_ASSERT(__sizeof__SPI_MISC_UNION, sizeof (SPI_MISC_UNION) == 4);
   #endif


#else
   // This is a miscellaneous register used for internal control of the SPI controller
   // state machine. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_MISC {
         union {
            struct { 
               u32 int_rsvd;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SPI_MISC, *PSPI_MISC;

      SG_C_ASSERT(__sizeof__SPI_MISC, sizeof (SPI_MISC) == 4);

   #else
      typedef struct _SPI_MISC {
         u32 int_rsvd;                            // DWORD 0
      } SG_PACK SPI_MISC, *PSPI_MISC;

      typedef union _SPI_MISC_UNION {
         SPI_MISC bits;
         u32 dw; // dword union
      } SG_PACK SPI_MISC_UNION, *PSPI_MISC_UNION;

      SG_C_ASSERT(__sizeof__SPI_MISC_UNION, sizeof (SPI_MISC_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the register section of the SPI FLASH. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_FLASH_CSRMAP {
         union {
            struct { 
               SPI_ADDRESS address;
               SPI_DATA data;
               SPI_COMMAND command;
               SPI_TIMING_CONFIG timing_config;
               SPI_CONTROL control;
               SPI_CLOCK_CTRL clock_ctrl;
               SPI_STATUS status;
               SPI_MISC misc;
               u32 rsvd0[1016];                   // DWORDS 8 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK SPI_FLASH_CSRMAP, *PSPI_FLASH_CSRMAP;

      SG_C_ASSERT(__sizeof__SPI_FLASH_CSRMAP, sizeof (SPI_FLASH_CSRMAP) == 4096);

   #else
      typedef struct _SPI_FLASH_CSRMAP {
         SPI_ADDRESS address;
         SPI_DATA data;
         SPI_COMMAND command;
         SPI_TIMING_CONFIG timing_config;
         SPI_CONTROL control;
         SPI_CLOCK_CTRL clock_ctrl;
         SPI_STATUS status;
         SPI_MISC misc;
         u32 rsvd0[1016];                         // DWORDS 8 to 1023
      } SG_PACK SPI_FLASH_CSRMAP, *PSPI_FLASH_CSRMAP;

      typedef union _SPI_FLASH_CSRMAP_UNION {
         SPI_FLASH_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK SPI_FLASH_CSRMAP_UNION, *PSPI_FLASH_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__SPI_FLASH_CSRMAP_UNION, sizeof (SPI_FLASH_CSRMAP_UNION) == 4096);
   #endif


#else
   // This is the register section of the SPI FLASH. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SPI_FLASH_CSRMAP {
         union {
            struct { 
               SPI_ADDRESS address;
               SPI_DATA data;
               SPI_COMMAND command;
               SPI_TIMING_CONFIG timing_config;
               SPI_CONTROL control;
               SPI_CLOCK_CTRL clock_ctrl;
               SPI_STATUS status;
               SPI_MISC misc;
               u32 rsvd0[1016];                   // DWORDS 8 to 1023
            } SG_PACK ; // unnamed struct
            u32 dw[1024]; // dword union
         }; // unnamed union
      } SG_PACK SPI_FLASH_CSRMAP, *PSPI_FLASH_CSRMAP;

      SG_C_ASSERT(__sizeof__SPI_FLASH_CSRMAP, sizeof (SPI_FLASH_CSRMAP) == 4096);

   #else
      typedef struct _SPI_FLASH_CSRMAP {
         SPI_ADDRESS address;
         SPI_DATA data;
         SPI_COMMAND command;
         SPI_TIMING_CONFIG timing_config;
         SPI_CONTROL control;
         SPI_CLOCK_CTRL clock_ctrl;
         SPI_STATUS status;
         SPI_MISC misc;
         u32 rsvd0[1016];                         // DWORDS 8 to 1023
      } SG_PACK SPI_FLASH_CSRMAP, *PSPI_FLASH_CSRMAP;

      typedef union _SPI_FLASH_CSRMAP_UNION {
         SPI_FLASH_CSRMAP bits;
         u32 dw[1024]; // dword union
      } SG_PACK SPI_FLASH_CSRMAP_UNION, *PSPI_FLASH_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__SPI_FLASH_CSRMAP_UNION, sizeof (SPI_FLASH_CSRMAP_UNION) == 4096);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __armspiflash_bmap_h__

