/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __armsys_bmap_h__
#define __armsys_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "gencommon_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // General top level controls of ARM System.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_SYSREG {
         union {
            struct { 
               u32 rsvd2 : 24;                    // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 override_lockup : 1;           // DWORD 0
               u32 override_flashboot : 1;        // DWORD 0
               u32 int_polarity : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 remap : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_SYSREG, *PARMSYS_SYSREG;

      SG_C_ASSERT(__sizeof__ARMSYS_SYSREG, sizeof (ARMSYS_SYSREG) == 4);

   #else
      typedef struct _ARMSYS_SYSREG {
         u32 rsvd2 : 24;                          // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 override_lockup : 1;                 // DWORD 0
         u32 override_flashboot : 1;              // DWORD 0
         u32 int_polarity : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 remap : 1;                           // DWORD 0
      } SG_PACK ARMSYS_SYSREG, *PARMSYS_SYSREG;

      typedef union _ARMSYS_SYSREG_UNION {
         ARMSYS_SYSREG bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_SYSREG_UNION, *PARMSYS_SYSREG_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_SYSREG_UNION, sizeof (ARMSYS_SYSREG_UNION) == 4);
   #endif


#else
   // General top level controls of ARM System.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_SYSREG {
         union {
            struct { 
               u32 remap : 1;                     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 int_polarity : 1;              // DWORD 0
               u32 override_flashboot : 1;        // DWORD 0
               u32 override_lockup : 1;           // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 rsvd2 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_SYSREG, *PARMSYS_SYSREG;

      SG_C_ASSERT(__sizeof__ARMSYS_SYSREG, sizeof (ARMSYS_SYSREG) == 4);

   #else
      typedef struct _ARMSYS_SYSREG {
         u32 remap : 1;                           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 int_polarity : 1;                    // DWORD 0
         u32 override_flashboot : 1;              // DWORD 0
         u32 override_lockup : 1;                 // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 rsvd2 : 24;                          // DWORD 0
      } SG_PACK ARMSYS_SYSREG, *PARMSYS_SYSREG;

      typedef union _ARMSYS_SYSREG_UNION {
         ARMSYS_SYSREG bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_SYSREG_UNION, *PARMSYS_SYSREG_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_SYSREG_UNION, sizeof (ARMSYS_SYSREG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Controls if slaves to AHB should be allowed to perform burst reads, or should be
   // restricted to slower speeds. Used for debug. If set, then burst access is allowed
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_BURSTCTRL {
         union {
            struct { 
               u32 rsvd0 : 21;                    // DWORD 0
               u32 dummy_en_for_burst : 1;        // DWORD 0
               u32 ddr_regs_en_for_burst : 1;     // DWORD 0
               u32 sys_regs_en_for_burst : 1;     // DWORD 0
               u32 vect_int_en_for_burst : 1;     // DWORD 0
               u32 bram_remp1_en_for_burst : 1;   // DWORD 0
               u32 bram_remp0_en_for_burst : 1;   // DWORD 0
               u32 ahb2apb_en_for_burst : 1;      // DWORD 0
               u32 ahb2xlmi_en_for_burst : 1;     // DWORD 0
               u32 flash_rom_en_for_burst : 1;    // DWORD 0
               u32 ddr2_remp1_en_for_burst : 1;   // DWORD 0
               u32 ddr2_remp0_en_for_burst : 1;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_BURSTCTRL, *PARMSYS_BURSTCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_BURSTCTRL, sizeof (ARMSYS_BURSTCTRL) == 4);

   #else
      typedef struct _ARMSYS_BURSTCTRL {
         u32 rsvd0 : 21;                          // DWORD 0
         u32 dummy_en_for_burst : 1;              // DWORD 0
         u32 ddr_regs_en_for_burst : 1;           // DWORD 0
         u32 sys_regs_en_for_burst : 1;           // DWORD 0
         u32 vect_int_en_for_burst : 1;           // DWORD 0
         u32 bram_remp1_en_for_burst : 1;         // DWORD 0
         u32 bram_remp0_en_for_burst : 1;         // DWORD 0
         u32 ahb2apb_en_for_burst : 1;            // DWORD 0
         u32 ahb2xlmi_en_for_burst : 1;           // DWORD 0
         u32 flash_rom_en_for_burst : 1;          // DWORD 0
         u32 ddr2_remp1_en_for_burst : 1;         // DWORD 0
         u32 ddr2_remp0_en_for_burst : 1;         // DWORD 0
      } SG_PACK ARMSYS_BURSTCTRL, *PARMSYS_BURSTCTRL;

      typedef union _ARMSYS_BURSTCTRL_UNION {
         ARMSYS_BURSTCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_BURSTCTRL_UNION, *PARMSYS_BURSTCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_BURSTCTRL_UNION, sizeof (ARMSYS_BURSTCTRL_UNION) == 4);
   #endif


#else
   // Controls if slaves to AHB should be allowed to perform burst reads, or should be
   // restricted to slower speeds. Used for debug. If set, then burst access is allowed
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_BURSTCTRL {
         union {
            struct { 
               u32 ddr2_remp0_en_for_burst : 1;   // DWORD 0
               u32 ddr2_remp1_en_for_burst : 1;   // DWORD 0
               u32 flash_rom_en_for_burst : 1;    // DWORD 0
               u32 ahb2xlmi_en_for_burst : 1;     // DWORD 0
               u32 ahb2apb_en_for_burst : 1;      // DWORD 0
               u32 bram_remp0_en_for_burst : 1;   // DWORD 0
               u32 bram_remp1_en_for_burst : 1;   // DWORD 0
               u32 vect_int_en_for_burst : 1;     // DWORD 0
               u32 sys_regs_en_for_burst : 1;     // DWORD 0
               u32 ddr_regs_en_for_burst : 1;     // DWORD 0
               u32 dummy_en_for_burst : 1;        // DWORD 0
               u32 rsvd0 : 21;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_BURSTCTRL, *PARMSYS_BURSTCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_BURSTCTRL, sizeof (ARMSYS_BURSTCTRL) == 4);

   #else
      typedef struct _ARMSYS_BURSTCTRL {
         u32 ddr2_remp0_en_for_burst : 1;         // DWORD 0
         u32 ddr2_remp1_en_for_burst : 1;         // DWORD 0
         u32 flash_rom_en_for_burst : 1;          // DWORD 0
         u32 ahb2xlmi_en_for_burst : 1;           // DWORD 0
         u32 ahb2apb_en_for_burst : 1;            // DWORD 0
         u32 bram_remp0_en_for_burst : 1;         // DWORD 0
         u32 bram_remp1_en_for_burst : 1;         // DWORD 0
         u32 vect_int_en_for_burst : 1;           // DWORD 0
         u32 sys_regs_en_for_burst : 1;           // DWORD 0
         u32 ddr_regs_en_for_burst : 1;           // DWORD 0
         u32 dummy_en_for_burst : 1;              // DWORD 0
         u32 rsvd0 : 21;                          // DWORD 0
      } SG_PACK ARMSYS_BURSTCTRL, *PARMSYS_BURSTCTRL;

      typedef union _ARMSYS_BURSTCTRL_UNION {
         ARMSYS_BURSTCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_BURSTCTRL_UNION, *PARMSYS_BURSTCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_BURSTCTRL_UNION, sizeof (ARMSYS_BURSTCTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Control Register. If set, then interrupt source will be passed into
   // ARMSYS_IRQSTAT.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_IRQCTRL {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 bank_rdy_int : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_IRQCTRL, *PARMSYS_IRQCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQCTRL, sizeof (ARMSYS_IRQCTRL) == 4);

   #else
      typedef struct _ARMSYS_IRQCTRL {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 bank_rdy_int : 1;                    // DWORD 0
      } SG_PACK ARMSYS_IRQCTRL, *PARMSYS_IRQCTRL;

      typedef union _ARMSYS_IRQCTRL_UNION {
         ARMSYS_IRQCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_IRQCTRL_UNION, *PARMSYS_IRQCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQCTRL_UNION, sizeof (ARMSYS_IRQCTRL_UNION) == 4);
   #endif


#else
   // Interrupt Control Register. If set, then interrupt source will be passed into
   // ARMSYS_IRQSTAT.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_IRQCTRL {
         union {
            struct { 
               u32 bank_rdy_int : 1;              // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_IRQCTRL, *PARMSYS_IRQCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQCTRL, sizeof (ARMSYS_IRQCTRL) == 4);

   #else
      typedef struct _ARMSYS_IRQCTRL {
         u32 bank_rdy_int : 1;                    // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
      } SG_PACK ARMSYS_IRQCTRL, *PARMSYS_IRQCTRL;

      typedef union _ARMSYS_IRQCTRL_UNION {
         ARMSYS_IRQCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_IRQCTRL_UNION, *PARMSYS_IRQCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQCTRL_UNION, sizeof (ARMSYS_IRQCTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Fast Interrupt Control Register. If set, then interrupt source will be passed into
   // ARMSYS_FIQSTAT.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQCTRL {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 bank_rdy_int : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQCTRL, *PARMSYS_FIQCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQCTRL, sizeof (ARMSYS_FIQCTRL) == 4);

   #else
      typedef struct _ARMSYS_FIQCTRL {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 bank_rdy_int : 1;                    // DWORD 0
      } SG_PACK ARMSYS_FIQCTRL, *PARMSYS_FIQCTRL;

      typedef union _ARMSYS_FIQCTRL_UNION {
         ARMSYS_FIQCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQCTRL_UNION, *PARMSYS_FIQCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQCTRL_UNION, sizeof (ARMSYS_FIQCTRL_UNION) == 4);
   #endif


#else
   // Fast Interrupt Control Register. If set, then interrupt source will be passed into
   // ARMSYS_FIQSTAT.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQCTRL {
         union {
            struct { 
               u32 bank_rdy_int : 1;              // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQCTRL, *PARMSYS_FIQCTRL;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQCTRL, sizeof (ARMSYS_FIQCTRL) == 4);

   #else
      typedef struct _ARMSYS_FIQCTRL {
         u32 bank_rdy_int : 1;                    // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
      } SG_PACK ARMSYS_FIQCTRL, *PARMSYS_FIQCTRL;

      typedef union _ARMSYS_FIQCTRL_UNION {
         ARMSYS_FIQCTRL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQCTRL_UNION, *PARMSYS_FIQCTRL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQCTRL_UNION, sizeof (ARMSYS_FIQCTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Current status of IRQ Sources. If set, then interrupt is driven to Vector Interrupt
   // as part of IRQ. They will show up at the Vector Interrupt block as IRQ in the same
   // order listed below.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_IRQSTAT {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 bank_rdy_int : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_IRQSTAT, *PARMSYS_IRQSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQSTAT, sizeof (ARMSYS_IRQSTAT) == 4);

   #else
      typedef struct _ARMSYS_IRQSTAT {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 bank_rdy_int : 1;                    // DWORD 0
      } SG_PACK ARMSYS_IRQSTAT, *PARMSYS_IRQSTAT;

      typedef union _ARMSYS_IRQSTAT_UNION {
         ARMSYS_IRQSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_IRQSTAT_UNION, *PARMSYS_IRQSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQSTAT_UNION, sizeof (ARMSYS_IRQSTAT_UNION) == 4);
   #endif


#else
   // Current status of IRQ Sources. If set, then interrupt is driven to Vector Interrupt
   // as part of IRQ. They will show up at the Vector Interrupt block as IRQ in the same
   // order listed below.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_IRQSTAT {
         union {
            struct { 
               u32 bank_rdy_int : 1;              // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_IRQSTAT, *PARMSYS_IRQSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQSTAT, sizeof (ARMSYS_IRQSTAT) == 4);

   #else
      typedef struct _ARMSYS_IRQSTAT {
         u32 bank_rdy_int : 1;                    // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
      } SG_PACK ARMSYS_IRQSTAT, *PARMSYS_IRQSTAT;

      typedef union _ARMSYS_IRQSTAT_UNION {
         ARMSYS_IRQSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_IRQSTAT_UNION, *PARMSYS_IRQSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_IRQSTAT_UNION, sizeof (ARMSYS_IRQSTAT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Current status of FIQ Sources. If set, then the corresponding interrupt can be
   // selected as part of the FIQ_VECTOR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQSTAT {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 bank_rdy_int : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQSTAT, *PARMSYS_FIQSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQSTAT, sizeof (ARMSYS_FIQSTAT) == 4);

   #else
      typedef struct _ARMSYS_FIQSTAT {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 bank_rdy_int : 1;                    // DWORD 0
      } SG_PACK ARMSYS_FIQSTAT, *PARMSYS_FIQSTAT;

      typedef union _ARMSYS_FIQSTAT_UNION {
         ARMSYS_FIQSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQSTAT_UNION, *PARMSYS_FIQSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQSTAT_UNION, sizeof (ARMSYS_FIQSTAT_UNION) == 4);
   #endif


#else
   // Current status of FIQ Sources. If set, then the corresponding interrupt can be
   // selected as part of the FIQ_VECTOR. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQSTAT {
         union {
            struct { 
               u32 bank_rdy_int : 1;              // DWORD 0
               u32 mgmt_int : 1;                  // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 mpu_bearm_int_spare : 1;       // DWORD 0
               u32 ddr_wr_int : 4;                // DWORD 0
               u32 per_uart_intr : 1;             // DWORD 0
               u32 per_timer_intr0 : 1;           // DWORD 0
               u32 per_timer_intr1 : 1;           // DWORD 0
               u32 per_timer_intr2 : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ddr_status_int : 1;            // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQSTAT, *PARMSYS_FIQSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQSTAT, sizeof (ARMSYS_FIQSTAT) == 4);

   #else
      typedef struct _ARMSYS_FIQSTAT {
         u32 bank_rdy_int : 1;                    // DWORD 0
         u32 mgmt_int : 1;                        // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 mpu_bearm_int_spare : 1;             // DWORD 0
         u32 ddr_wr_int : 4;                      // DWORD 0
         u32 per_uart_intr : 1;                   // DWORD 0
         u32 per_timer_intr0 : 1;                 // DWORD 0
         u32 per_timer_intr1 : 1;                 // DWORD 0
         u32 per_timer_intr2 : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ddr_status_int : 1;                  // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
      } SG_PACK ARMSYS_FIQSTAT, *PARMSYS_FIQSTAT;

      typedef union _ARMSYS_FIQSTAT_UNION {
         ARMSYS_FIQSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQSTAT_UNION, *PARMSYS_FIQSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQSTAT_UNION, sizeof (ARMSYS_FIQSTAT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Current status of FIQ vector. If set, then interrupt is driven to Vector Interrupt
   // as part of FIQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQ_VECTOR {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 fiq_vector : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQ_VECTOR, *PARMSYS_FIQ_VECTOR;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECTOR, sizeof (ARMSYS_FIQ_VECTOR) == 4);

   #else
      typedef struct _ARMSYS_FIQ_VECTOR {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 fiq_vector : 8;                      // DWORD 0
      } SG_PACK ARMSYS_FIQ_VECTOR, *PARMSYS_FIQ_VECTOR;

      typedef union _ARMSYS_FIQ_VECTOR_UNION {
         ARMSYS_FIQ_VECTOR bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQ_VECTOR_UNION, *PARMSYS_FIQ_VECTOR_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECTOR_UNION, sizeof (ARMSYS_FIQ_VECTOR_UNION) == 4);
   #endif


#else
   // Current status of FIQ vector. If set, then interrupt is driven to Vector Interrupt
   // as part of FIQ.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQ_VECTOR {
         union {
            struct { 
               u32 fiq_vector : 8;                // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQ_VECTOR, *PARMSYS_FIQ_VECTOR;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECTOR, sizeof (ARMSYS_FIQ_VECTOR) == 4);

   #else
      typedef struct _ARMSYS_FIQ_VECTOR {
         u32 fiq_vector : 8;                      // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ARMSYS_FIQ_VECTOR, *PARMSYS_FIQ_VECTOR;

      typedef union _ARMSYS_FIQ_VECTOR_UNION {
         ARMSYS_FIQ_VECTOR bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQ_VECTOR_UNION, *PARMSYS_FIQ_VECTOR_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECTOR_UNION, sizeof (ARMSYS_FIQ_VECTOR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Select lines to choose FIQ Vector. Each FIQ has two selects, the OR of which forms
   // FIQ_VECTOR. Each 4 bit selectors choose one of the 16 FIQSTAT fields.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQ_VECT_SEL {
         union {
            struct { 
               u32 fiq_7_sel : 4;                 // DWORD 0
               u32 fiq_6_sel : 4;                 // DWORD 0
               u32 fiq_5_sel : 4;                 // DWORD 0
               u32 fiq_4_sel : 4;                 // DWORD 0
               u32 fiq_3_sel : 4;                 // DWORD 0
               u32 fiq_2_sel : 4;                 // DWORD 0
               u32 fiq_1_sel : 4;                 // DWORD 0
               u32 fiq_0_sel : 4;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQ_VECT_SEL, *PARMSYS_FIQ_VECT_SEL;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECT_SEL, sizeof (ARMSYS_FIQ_VECT_SEL) == 4);

   #else
      typedef struct _ARMSYS_FIQ_VECT_SEL {
         u32 fiq_7_sel : 4;                       // DWORD 0
         u32 fiq_6_sel : 4;                       // DWORD 0
         u32 fiq_5_sel : 4;                       // DWORD 0
         u32 fiq_4_sel : 4;                       // DWORD 0
         u32 fiq_3_sel : 4;                       // DWORD 0
         u32 fiq_2_sel : 4;                       // DWORD 0
         u32 fiq_1_sel : 4;                       // DWORD 0
         u32 fiq_0_sel : 4;                       // DWORD 0
      } SG_PACK ARMSYS_FIQ_VECT_SEL, *PARMSYS_FIQ_VECT_SEL;

      typedef union _ARMSYS_FIQ_VECT_SEL_UNION {
         ARMSYS_FIQ_VECT_SEL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQ_VECT_SEL_UNION, *PARMSYS_FIQ_VECT_SEL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECT_SEL_UNION, sizeof (ARMSYS_FIQ_VECT_SEL_UNION) == 4);
   #endif


#else
   // Select lines to choose FIQ Vector. Each FIQ has two selects, the OR of which forms
   // FIQ_VECTOR. Each 4 bit selectors choose one of the 16 FIQSTAT fields.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_FIQ_VECT_SEL {
         union {
            struct { 
               u32 fiq_0_sel : 4;                 // DWORD 0
               u32 fiq_1_sel : 4;                 // DWORD 0
               u32 fiq_2_sel : 4;                 // DWORD 0
               u32 fiq_3_sel : 4;                 // DWORD 0
               u32 fiq_4_sel : 4;                 // DWORD 0
               u32 fiq_5_sel : 4;                 // DWORD 0
               u32 fiq_6_sel : 4;                 // DWORD 0
               u32 fiq_7_sel : 4;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_FIQ_VECT_SEL, *PARMSYS_FIQ_VECT_SEL;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECT_SEL, sizeof (ARMSYS_FIQ_VECT_SEL) == 4);

   #else
      typedef struct _ARMSYS_FIQ_VECT_SEL {
         u32 fiq_0_sel : 4;                       // DWORD 0
         u32 fiq_1_sel : 4;                       // DWORD 0
         u32 fiq_2_sel : 4;                       // DWORD 0
         u32 fiq_3_sel : 4;                       // DWORD 0
         u32 fiq_4_sel : 4;                       // DWORD 0
         u32 fiq_5_sel : 4;                       // DWORD 0
         u32 fiq_6_sel : 4;                       // DWORD 0
         u32 fiq_7_sel : 4;                       // DWORD 0
      } SG_PACK ARMSYS_FIQ_VECT_SEL, *PARMSYS_FIQ_VECT_SEL;

      typedef union _ARMSYS_FIQ_VECT_SEL_UNION {
         ARMSYS_FIQ_VECT_SEL bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_FIQ_VECT_SEL_UNION, *PARMSYS_FIQ_VECT_SEL_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_FIQ_VECT_SEL_UNION, sizeof (ARMSYS_FIQ_VECT_SEL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Source for WDMA2DDR Interrupt. This interrupt will pulse when the WDMA performs a
   // write to the EQ area, as defined in RDMA CSRMAP. A read of this register will clear
   // the interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_WDMA2DDR_INT {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 wdma2ddr_int : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_WDMA2DDR_INT, *PARMSYS_WDMA2DDR_INT;

      SG_C_ASSERT(__sizeof__ARMSYS_WDMA2DDR_INT, sizeof (ARMSYS_WDMA2DDR_INT) == 4);

   #else
      typedef struct _ARMSYS_WDMA2DDR_INT {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 wdma2ddr_int : 1;                    // DWORD 0
      } SG_PACK ARMSYS_WDMA2DDR_INT, *PARMSYS_WDMA2DDR_INT;

      typedef union _ARMSYS_WDMA2DDR_INT_UNION {
         ARMSYS_WDMA2DDR_INT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_WDMA2DDR_INT_UNION, *PARMSYS_WDMA2DDR_INT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_WDMA2DDR_INT_UNION, sizeof (ARMSYS_WDMA2DDR_INT_UNION) == 4);
   #endif


#else
   // Source for WDMA2DDR Interrupt. This interrupt will pulse when the WDMA performs a
   // write to the EQ area, as defined in RDMA CSRMAP. A read of this register will clear
   // the interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_WDMA2DDR_INT {
         union {
            struct { 
               u32 wdma2ddr_int : 1;              // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_WDMA2DDR_INT, *PARMSYS_WDMA2DDR_INT;

      SG_C_ASSERT(__sizeof__ARMSYS_WDMA2DDR_INT, sizeof (ARMSYS_WDMA2DDR_INT) == 4);

   #else
      typedef struct _ARMSYS_WDMA2DDR_INT {
         u32 wdma2ddr_int : 1;                    // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK ARMSYS_WDMA2DDR_INT, *PARMSYS_WDMA2DDR_INT;

      typedef union _ARMSYS_WDMA2DDR_INT_UNION {
         ARMSYS_WDMA2DDR_INT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_WDMA2DDR_INT_UNION, *PARMSYS_WDMA2DDR_INT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_WDMA2DDR_INT_UNION, sizeof (ARMSYS_WDMA2DDR_INT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Current status chip strap pins. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_STRAPSTAT {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 debug_bram_loading : 1;        // DWORD 0
               u32 pads_disable_spi : 1;          // DWORD 0
               u32 pad_lpc_bank_sz : 1;           // DWORD 0
               u32 pad_flashboot : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_STRAPSTAT, *PARMSYS_STRAPSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_STRAPSTAT, sizeof (ARMSYS_STRAPSTAT) == 4);

   #else
      typedef struct _ARMSYS_STRAPSTAT {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 debug_bram_loading : 1;              // DWORD 0
         u32 pads_disable_spi : 1;                // DWORD 0
         u32 pad_lpc_bank_sz : 1;                 // DWORD 0
         u32 pad_flashboot : 1;                   // DWORD 0
      } SG_PACK ARMSYS_STRAPSTAT, *PARMSYS_STRAPSTAT;

      typedef union _ARMSYS_STRAPSTAT_UNION {
         ARMSYS_STRAPSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_STRAPSTAT_UNION, *PARMSYS_STRAPSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_STRAPSTAT_UNION, sizeof (ARMSYS_STRAPSTAT_UNION) == 4);
   #endif


#else
   // Current status chip strap pins. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_STRAPSTAT {
         union {
            struct { 
               u32 pad_flashboot : 1;             // DWORD 0
               u32 pad_lpc_bank_sz : 1;           // DWORD 0
               u32 pads_disable_spi : 1;          // DWORD 0
               u32 debug_bram_loading : 1;        // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_STRAPSTAT, *PARMSYS_STRAPSTAT;

      SG_C_ASSERT(__sizeof__ARMSYS_STRAPSTAT, sizeof (ARMSYS_STRAPSTAT) == 4);

   #else
      typedef struct _ARMSYS_STRAPSTAT {
         u32 pad_flashboot : 1;                   // DWORD 0
         u32 pad_lpc_bank_sz : 1;                 // DWORD 0
         u32 pads_disable_spi : 1;                // DWORD 0
         u32 debug_bram_loading : 1;              // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK ARMSYS_STRAPSTAT, *PARMSYS_STRAPSTAT;

      typedef union _ARMSYS_STRAPSTAT_UNION {
         ARMSYS_STRAPSTAT bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_STRAPSTAT_UNION, *PARMSYS_STRAPSTAT_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_STRAPSTAT_UNION, sizeof (ARMSYS_STRAPSTAT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Weights for the DMA Arbiter. The Arbiter works on dma COMMANDS, not byte counts.
   // Note further that the read ports have the ability to request a read of between 8 and
   // 32 bytes of data, while write ports can only peroform a write of 4 bytes of data.
   // However, the vast majority of read DMA transfers will be perfomed with 32 byte
   // transfers. So, if the ratio of read weight to write weights is 1:8, this will give a
   // roughly even ratio. Note too that the system uses a greedy WRR, meaning that if the
   // WDMA WR port gains access, it will hold that access until it runs out of
   // transactions or out of credits. This is done because the DDR2 controller can achieve
   // a speedup by merging DDR writes, but only if they are near each other in the
   // pipeline. Note too that there is another WRR interfacing between the ARM reads /
   // writes itself and the result of the DDR WRR you are currently configuring. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DDR_WRR0 {
         union {
            struct { 
               u32 weight_rdma_wr : 8;            // DWORD 0
               u32 weight_rdma_rd : 8;            // DWORD 0
               u32 weight_wdma_wr : 8;            // DWORD 0
               u32 weight_wdma_rd : 8;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DDR_WRR0, *PARMSYS_DDR_WRR0;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR0, sizeof (ARMSYS_DDR_WRR0) == 4);

   #else
      typedef struct _ARMSYS_DDR_WRR0 {
         u32 weight_rdma_wr : 8;                  // DWORD 0
         u32 weight_rdma_rd : 8;                  // DWORD 0
         u32 weight_wdma_wr : 8;                  // DWORD 0
         u32 weight_wdma_rd : 8;                  // DWORD 0
      } SG_PACK ARMSYS_DDR_WRR0, *PARMSYS_DDR_WRR0;

      typedef union _ARMSYS_DDR_WRR0_UNION {
         ARMSYS_DDR_WRR0 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DDR_WRR0_UNION, *PARMSYS_DDR_WRR0_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR0_UNION, sizeof (ARMSYS_DDR_WRR0_UNION) == 4);
   #endif


#else
   // Weights for the DMA Arbiter. The Arbiter works on dma COMMANDS, not byte counts.
   // Note further that the read ports have the ability to request a read of between 8 and
   // 32 bytes of data, while write ports can only peroform a write of 4 bytes of data.
   // However, the vast majority of read DMA transfers will be perfomed with 32 byte
   // transfers. So, if the ratio of read weight to write weights is 1:8, this will give a
   // roughly even ratio. Note too that the system uses a greedy WRR, meaning that if the
   // WDMA WR port gains access, it will hold that access until it runs out of
   // transactions or out of credits. This is done because the DDR2 controller can achieve
   // a speedup by merging DDR writes, but only if they are near each other in the
   // pipeline. Note too that there is another WRR interfacing between the ARM reads /
   // writes itself and the result of the DDR WRR you are currently configuring. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DDR_WRR0 {
         union {
            struct { 
               u32 weight_wdma_rd : 8;            // DWORD 0
               u32 weight_wdma_wr : 8;            // DWORD 0
               u32 weight_rdma_rd : 8;            // DWORD 0
               u32 weight_rdma_wr : 8;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DDR_WRR0, *PARMSYS_DDR_WRR0;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR0, sizeof (ARMSYS_DDR_WRR0) == 4);

   #else
      typedef struct _ARMSYS_DDR_WRR0 {
         u32 weight_wdma_rd : 8;                  // DWORD 0
         u32 weight_wdma_wr : 8;                  // DWORD 0
         u32 weight_rdma_rd : 8;                  // DWORD 0
         u32 weight_rdma_wr : 8;                  // DWORD 0
      } SG_PACK ARMSYS_DDR_WRR0, *PARMSYS_DDR_WRR0;

      typedef union _ARMSYS_DDR_WRR0_UNION {
         ARMSYS_DDR_WRR0 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DDR_WRR0_UNION, *PARMSYS_DDR_WRR0_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR0_UNION, sizeof (ARMSYS_DDR_WRR0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // More weights for the DMA Arbiter. See ARMSYS_DMA_WRR0 for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DDR_WRR1 {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 weight_ndma_rd : 8;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DDR_WRR1, *PARMSYS_DDR_WRR1;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR1, sizeof (ARMSYS_DDR_WRR1) == 4);

   #else
      typedef struct _ARMSYS_DDR_WRR1 {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 weight_ndma_rd : 8;                  // DWORD 0
      } SG_PACK ARMSYS_DDR_WRR1, *PARMSYS_DDR_WRR1;

      typedef union _ARMSYS_DDR_WRR1_UNION {
         ARMSYS_DDR_WRR1 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DDR_WRR1_UNION, *PARMSYS_DDR_WRR1_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR1_UNION, sizeof (ARMSYS_DDR_WRR1_UNION) == 4);
   #endif


#else
   // More weights for the DMA Arbiter. See ARMSYS_DMA_WRR0 for more details
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DDR_WRR1 {
         union {
            struct { 
               u32 weight_ndma_rd : 8;            // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DDR_WRR1, *PARMSYS_DDR_WRR1;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR1, sizeof (ARMSYS_DDR_WRR1) == 4);

   #else
      typedef struct _ARMSYS_DDR_WRR1 {
         u32 weight_ndma_rd : 8;                  // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ARMSYS_DDR_WRR1, *PARMSYS_DDR_WRR1;

      typedef union _ARMSYS_DDR_WRR1_UNION {
         ARMSYS_DDR_WRR1 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DDR_WRR1_UNION, *PARMSYS_DDR_WRR1_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DDR_WRR1_UNION, sizeof (ARMSYS_DDR_WRR1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DMA DDR Arbiter Debug 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DMAARB_DEBUG0 {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 RDSTATE : 2;                   // DWORD 0
               u32 ndmard_numfilled : 4;          // DWORD 0
               u32 rdmawr_numfilled : 4;          // DWORD 0
               u32 rdmard_numfilled : 4;          // DWORD 0
               u32 wdmawr_numfilled : 5;          // DWORD 0
               u32 wdmard_numfilled : 5;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DMAARB_DEBUG0, *PARMSYS_DMAARB_DEBUG0;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG0, sizeof (ARMSYS_DMAARB_DEBUG0) == 4);

   #else
      typedef struct _ARMSYS_DMAARB_DEBUG0 {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 RDSTATE : 2;                         // DWORD 0
         u32 ndmard_numfilled : 4;                // DWORD 0
         u32 rdmawr_numfilled : 4;                // DWORD 0
         u32 rdmard_numfilled : 4;                // DWORD 0
         u32 wdmawr_numfilled : 5;                // DWORD 0
         u32 wdmard_numfilled : 5;                // DWORD 0
      } SG_PACK ARMSYS_DMAARB_DEBUG0, *PARMSYS_DMAARB_DEBUG0;

      typedef union _ARMSYS_DMAARB_DEBUG0_UNION {
         ARMSYS_DMAARB_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DMAARB_DEBUG0_UNION, *PARMSYS_DMAARB_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG0_UNION, sizeof (ARMSYS_DMAARB_DEBUG0_UNION) == 4);
   #endif


#else
   // DMA DDR Arbiter Debug 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DMAARB_DEBUG0 {
         union {
            struct { 
               u32 wdmard_numfilled : 5;          // DWORD 0
               u32 wdmawr_numfilled : 5;          // DWORD 0
               u32 rdmard_numfilled : 4;          // DWORD 0
               u32 rdmawr_numfilled : 4;          // DWORD 0
               u32 ndmard_numfilled : 4;          // DWORD 0
               u32 RDSTATE : 2;                   // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DMAARB_DEBUG0, *PARMSYS_DMAARB_DEBUG0;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG0, sizeof (ARMSYS_DMAARB_DEBUG0) == 4);

   #else
      typedef struct _ARMSYS_DMAARB_DEBUG0 {
         u32 wdmard_numfilled : 5;                // DWORD 0
         u32 wdmawr_numfilled : 5;                // DWORD 0
         u32 rdmard_numfilled : 4;                // DWORD 0
         u32 rdmawr_numfilled : 4;                // DWORD 0
         u32 ndmard_numfilled : 4;                // DWORD 0
         u32 RDSTATE : 2;                         // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK ARMSYS_DMAARB_DEBUG0, *PARMSYS_DMAARB_DEBUG0;

      typedef union _ARMSYS_DMAARB_DEBUG0_UNION {
         ARMSYS_DMAARB_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DMAARB_DEBUG0_UNION, *PARMSYS_DMAARB_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG0_UNION, sizeof (ARMSYS_DMAARB_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DMA DDR Arbiter Debug 1. Writing to this location clears sticky Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DMAARB_DEBUG1 {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 ndmard_underflow : 1;          // DWORD 0
               u32 rdmawr_underflow : 1;          // DWORD 0
               u32 rdmard_underflow : 1;          // DWORD 0
               u32 wdmawr_underflow : 1;          // DWORD 0
               u32 wdmard_underflow : 1;          // DWORD 0
               u32 ndmard_overflow : 1;           // DWORD 0
               u32 rdmawr_overflow : 1;           // DWORD 0
               u32 rdmard_overflow : 1;           // DWORD 0
               u32 wdmawr_overflow : 1;           // DWORD 0
               u32 wdmard_overflow : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DMAARB_DEBUG1, *PARMSYS_DMAARB_DEBUG1;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG1, sizeof (ARMSYS_DMAARB_DEBUG1) == 4);

   #else
      typedef struct _ARMSYS_DMAARB_DEBUG1 {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 ndmard_underflow : 1;                // DWORD 0
         u32 rdmawr_underflow : 1;                // DWORD 0
         u32 rdmard_underflow : 1;                // DWORD 0
         u32 wdmawr_underflow : 1;                // DWORD 0
         u32 wdmard_underflow : 1;                // DWORD 0
         u32 ndmard_overflow : 1;                 // DWORD 0
         u32 rdmawr_overflow : 1;                 // DWORD 0
         u32 rdmard_overflow : 1;                 // DWORD 0
         u32 wdmawr_overflow : 1;                 // DWORD 0
         u32 wdmard_overflow : 1;                 // DWORD 0
      } SG_PACK ARMSYS_DMAARB_DEBUG1, *PARMSYS_DMAARB_DEBUG1;

      typedef union _ARMSYS_DMAARB_DEBUG1_UNION {
         ARMSYS_DMAARB_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DMAARB_DEBUG1_UNION, *PARMSYS_DMAARB_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG1_UNION, sizeof (ARMSYS_DMAARB_DEBUG1_UNION) == 4);
   #endif


#else
   // DMA DDR Arbiter Debug 1. Writing to this location clears sticky Overflow/Underflow
   // indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_DMAARB_DEBUG1 {
         union {
            struct { 
               u32 wdmard_overflow : 1;           // DWORD 0
               u32 wdmawr_overflow : 1;           // DWORD 0
               u32 rdmard_overflow : 1;           // DWORD 0
               u32 rdmawr_overflow : 1;           // DWORD 0
               u32 ndmard_overflow : 1;           // DWORD 0
               u32 wdmard_underflow : 1;          // DWORD 0
               u32 wdmawr_underflow : 1;          // DWORD 0
               u32 rdmard_underflow : 1;          // DWORD 0
               u32 rdmawr_underflow : 1;          // DWORD 0
               u32 ndmard_underflow : 1;          // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_DMAARB_DEBUG1, *PARMSYS_DMAARB_DEBUG1;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG1, sizeof (ARMSYS_DMAARB_DEBUG1) == 4);

   #else
      typedef struct _ARMSYS_DMAARB_DEBUG1 {
         u32 wdmard_overflow : 1;                 // DWORD 0
         u32 wdmawr_overflow : 1;                 // DWORD 0
         u32 rdmard_overflow : 1;                 // DWORD 0
         u32 rdmawr_overflow : 1;                 // DWORD 0
         u32 ndmard_overflow : 1;                 // DWORD 0
         u32 wdmard_underflow : 1;                // DWORD 0
         u32 wdmawr_underflow : 1;                // DWORD 0
         u32 rdmard_underflow : 1;                // DWORD 0
         u32 rdmawr_underflow : 1;                // DWORD 0
         u32 ndmard_underflow : 1;                // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK ARMSYS_DMAARB_DEBUG1, *PARMSYS_DMAARB_DEBUG1;

      typedef union _ARMSYS_DMAARB_DEBUG1_UNION {
         ARMSYS_DMAARB_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK ARMSYS_DMAARB_DEBUG1_UNION, *PARMSYS_DMAARB_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_DMAARB_DEBUG1_UNION, sizeof (ARMSYS_DMAARB_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control for DDR INT. The DMA Arbiter interfaces between the DMA engines and the DDR
   // controller. This arbiter has the ability to identify and flag any writes that occur
   // within specified regions. In this way, a region of space can be carved out of the
   // DDR, and when an external entity (e.g. CEV) writes within that space, an interrupt
   // is generated. This interrupt is sent to the interrupt coalescers. As a rule, the
   // interrupt must be enabled and then a DMA engine must perform a write to the DDR
   // space between the DDR address specified in ADDR_LOW and ADDR_HIGH (inclusive)
   // registers. When the last word is written to the DDR (or at least deep enough in the
   // pipeline to the DDR write that no other request can pass it), a pulse will be sent
   // to the interrupts "producer" index. This is then compared with the interrupts
   // "consumer" index, and any difference will generate a potential interrupt. The
   // processor then, will post to the consumer index the number of DDR writes it has
   // processed (where "DDR Writes" can be read as completions, or whatever that DDR
   // region has been designated as). When the consumer / producer indecies match, the
   // interrupt processing is completed. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_CTRL {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 en_rdma_int3 : 1;              // DWORD 0
               u32 en_rdma_int2 : 1;              // DWORD 0
               u32 en_rdma_int1 : 1;              // DWORD 0
               u32 en_rdma_int0 : 1;              // DWORD 0
               u32 en_int3 : 1;                   // DWORD 0
               u32 en_int2 : 1;                   // DWORD 0
               u32 en_int1 : 1;                   // DWORD 0
               u32 en_int0 : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_CTRL, *PARM_DDRINT_CTRL;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_CTRL, sizeof (ARM_DDRINT_CTRL) == 4);

   #else
      typedef struct _ARM_DDRINT_CTRL {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 en_rdma_int3 : 1;                    // DWORD 0
         u32 en_rdma_int2 : 1;                    // DWORD 0
         u32 en_rdma_int1 : 1;                    // DWORD 0
         u32 en_rdma_int0 : 1;                    // DWORD 0
         u32 en_int3 : 1;                         // DWORD 0
         u32 en_int2 : 1;                         // DWORD 0
         u32 en_int1 : 1;                         // DWORD 0
         u32 en_int0 : 1;                         // DWORD 0
      } SG_PACK ARM_DDRINT_CTRL, *PARM_DDRINT_CTRL;

      typedef union _ARM_DDRINT_CTRL_UNION {
         ARM_DDRINT_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_CTRL_UNION, *PARM_DDRINT_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_CTRL_UNION, sizeof (ARM_DDRINT_CTRL_UNION) == 4);
   #endif


#else
   // Control for DDR INT. The DMA Arbiter interfaces between the DMA engines and the DDR
   // controller. This arbiter has the ability to identify and flag any writes that occur
   // within specified regions. In this way, a region of space can be carved out of the
   // DDR, and when an external entity (e.g. CEV) writes within that space, an interrupt
   // is generated. This interrupt is sent to the interrupt coalescers. As a rule, the
   // interrupt must be enabled and then a DMA engine must perform a write to the DDR
   // space between the DDR address specified in ADDR_LOW and ADDR_HIGH (inclusive)
   // registers. When the last word is written to the DDR (or at least deep enough in the
   // pipeline to the DDR write that no other request can pass it), a pulse will be sent
   // to the interrupts "producer" index. This is then compared with the interrupts
   // "consumer" index, and any difference will generate a potential interrupt. The
   // processor then, will post to the consumer index the number of DDR writes it has
   // processed (where "DDR Writes" can be read as completions, or whatever that DDR
   // region has been designated as). When the consumer / producer indecies match, the
   // interrupt processing is completed. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_CTRL {
         union {
            struct { 
               u32 en_int0 : 1;                   // DWORD 0
               u32 en_int1 : 1;                   // DWORD 0
               u32 en_int2 : 1;                   // DWORD 0
               u32 en_int3 : 1;                   // DWORD 0
               u32 en_rdma_int0 : 1;              // DWORD 0
               u32 en_rdma_int1 : 1;              // DWORD 0
               u32 en_rdma_int2 : 1;              // DWORD 0
               u32 en_rdma_int3 : 1;              // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_CTRL, *PARM_DDRINT_CTRL;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_CTRL, sizeof (ARM_DDRINT_CTRL) == 4);

   #else
      typedef struct _ARM_DDRINT_CTRL {
         u32 en_int0 : 1;                         // DWORD 0
         u32 en_int1 : 1;                         // DWORD 0
         u32 en_int2 : 1;                         // DWORD 0
         u32 en_int3 : 1;                         // DWORD 0
         u32 en_rdma_int0 : 1;                    // DWORD 0
         u32 en_rdma_int1 : 1;                    // DWORD 0
         u32 en_rdma_int2 : 1;                    // DWORD 0
         u32 en_rdma_int3 : 1;                    // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK ARM_DDRINT_CTRL, *PARM_DDRINT_CTRL;

      typedef union _ARM_DDRINT_CTRL_UNION {
         ARM_DDRINT_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_CTRL_UNION, *PARM_DDRINT_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_CTRL_UNION, sizeof (ARM_DDRINT_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Lower Address for DDR Interrupt. This address should be written in 4 byte increments
   // (i.e. byte address / 4). See ARM_DDRINT_CTRL for details. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_ADDR_LOW {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_ADDR_LOW, *PARM_DDRINT_ADDR_LOW;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_LOW, sizeof (ARM_DDRINT_ADDR_LOW) == 4);

   #else
      typedef struct _ARM_DDRINT_ADDR_LOW {
         u32 data;                                // DWORD 0
      } SG_PACK ARM_DDRINT_ADDR_LOW, *PARM_DDRINT_ADDR_LOW;

      typedef union _ARM_DDRINT_ADDR_LOW_UNION {
         ARM_DDRINT_ADDR_LOW bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_ADDR_LOW_UNION, *PARM_DDRINT_ADDR_LOW_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_LOW_UNION, sizeof (ARM_DDRINT_ADDR_LOW_UNION) == 4);
   #endif


#else
   // Lower Address for DDR Interrupt. This address should be written in 4 byte increments
   // (i.e. byte address / 4). See ARM_DDRINT_CTRL for details. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_ADDR_LOW {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_ADDR_LOW, *PARM_DDRINT_ADDR_LOW;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_LOW, sizeof (ARM_DDRINT_ADDR_LOW) == 4);

   #else
      typedef struct _ARM_DDRINT_ADDR_LOW {
         u32 data;                                // DWORD 0
      } SG_PACK ARM_DDRINT_ADDR_LOW, *PARM_DDRINT_ADDR_LOW;

      typedef union _ARM_DDRINT_ADDR_LOW_UNION {
         ARM_DDRINT_ADDR_LOW bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_ADDR_LOW_UNION, *PARM_DDRINT_ADDR_LOW_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_LOW_UNION, sizeof (ARM_DDRINT_ADDR_LOW_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Upper Address for DDR Interrupt. This address should be written in 4 byte increments
   // (i.e. byte address / 4). See ARM_DDRINT_CTRL for details. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_ADDR_HIGH {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_ADDR_HIGH, *PARM_DDRINT_ADDR_HIGH;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_HIGH, sizeof (ARM_DDRINT_ADDR_HIGH) == 4);

   #else
      typedef struct _ARM_DDRINT_ADDR_HIGH {
         u32 data;                                // DWORD 0
      } SG_PACK ARM_DDRINT_ADDR_HIGH, *PARM_DDRINT_ADDR_HIGH;

      typedef union _ARM_DDRINT_ADDR_HIGH_UNION {
         ARM_DDRINT_ADDR_HIGH bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_ADDR_HIGH_UNION, *PARM_DDRINT_ADDR_HIGH_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_HIGH_UNION, sizeof (ARM_DDRINT_ADDR_HIGH_UNION) == 4);
   #endif


#else
   // Upper Address for DDR Interrupt. This address should be written in 4 byte increments
   // (i.e. byte address / 4). See ARM_DDRINT_CTRL for details. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_ADDR_HIGH {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_ADDR_HIGH, *PARM_DDRINT_ADDR_HIGH;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_HIGH, sizeof (ARM_DDRINT_ADDR_HIGH) == 4);

   #else
      typedef struct _ARM_DDRINT_ADDR_HIGH {
         u32 data;                                // DWORD 0
      } SG_PACK ARM_DDRINT_ADDR_HIGH, *PARM_DDRINT_ADDR_HIGH;

      typedef union _ARM_DDRINT_ADDR_HIGH_UNION {
         ARM_DDRINT_ADDR_HIGH bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_ADDR_HIGH_UNION, *PARM_DDRINT_ADDR_HIGH_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_ADDR_HIGH_UNION, sizeof (ARM_DDRINT_ADDR_HIGH_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Consumer and Producer indecies for DDR Interrupt. As a debug, a write of all 1s will
   // cause the two indecies to return to zero.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_INDEX {
         union {
            struct { 
               u32 producer : 16;                 // DWORD 0
               u32 consumer : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_INDEX, *PARM_DDRINT_INDEX;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_INDEX, sizeof (ARM_DDRINT_INDEX) == 4);

   #else
      typedef struct _ARM_DDRINT_INDEX {
         u32 producer : 16;                       // DWORD 0
         u32 consumer : 16;                       // DWORD 0
      } SG_PACK ARM_DDRINT_INDEX, *PARM_DDRINT_INDEX;

      typedef union _ARM_DDRINT_INDEX_UNION {
         ARM_DDRINT_INDEX bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_INDEX_UNION, *PARM_DDRINT_INDEX_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_INDEX_UNION, sizeof (ARM_DDRINT_INDEX_UNION) == 4);
   #endif


#else
   // Consumer and Producer indecies for DDR Interrupt. As a debug, a write of all 1s will
   // cause the two indecies to return to zero.
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_DDRINT_INDEX {
         union {
            struct { 
               u32 consumer : 16;                 // DWORD 0
               u32 producer : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_DDRINT_INDEX, *PARM_DDRINT_INDEX;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_INDEX, sizeof (ARM_DDRINT_INDEX) == 4);

   #else
      typedef struct _ARM_DDRINT_INDEX {
         u32 consumer : 16;                       // DWORD 0
         u32 producer : 16;                       // DWORD 0
      } SG_PACK ARM_DDRINT_INDEX, *PARM_DDRINT_INDEX;

      typedef union _ARM_DDRINT_INDEX_UNION {
         ARM_DDRINT_INDEX bits;
         u32 dw; // dword union
      } SG_PACK ARM_DDRINT_INDEX_UNION, *PARM_DDRINT_INDEX_UNION;

      SG_C_ASSERT(__sizeof__ARM_DDRINT_INDEX_UNION, sizeof (ARM_DDRINT_INDEX_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Leaky Bucket Interrupt Coalescer controler registers. The Leaky IntCoal uses a leaky
   // bucket scheme that fills up the bucket with credit every UPDATE_RATE. If the bucket
   // has credits, an interrupt is allowed. If not, the interrupt is ignored, allowing
   // other interrupts to coalesce. The bucket also has a depth. The practical result
   // being that UPDATE_RATE and UPDATE_SCALE control the steady stream maximum interrupt
   // rate, while the DEPTH field indicates the maximum number of interrupts that can
   // arrive in an UPDATE_RATE period. NOTE that any write to this location is considered
   // traumatic enough that it triggers a soft reset of the coalescer. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_INTCOAL_LEAK_CTRL {
         union {
            struct { 
               u32 debug_intout : 1;              // DWORD 0
               u32 debug_intin : 1;               // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 fpga : 1;                      // DWORD 0
               u32 intack : 1;                    // DWORD 0
               u32 depth : 8;                     // DWORD 0
               u32 update_rate : 8;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_INTCOAL_LEAK_CTRL, *PARM_INTCOAL_LEAK_CTRL;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_LEAK_CTRL, sizeof (ARM_INTCOAL_LEAK_CTRL) == 4);

   #else
      typedef struct _ARM_INTCOAL_LEAK_CTRL {
         u32 debug_intout : 1;                    // DWORD 0
         u32 debug_intin : 1;                     // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 fpga : 1;                            // DWORD 0
         u32 intack : 1;                          // DWORD 0
         u32 depth : 8;                           // DWORD 0
         u32 update_rate : 8;                     // DWORD 0
      } SG_PACK ARM_INTCOAL_LEAK_CTRL, *PARM_INTCOAL_LEAK_CTRL;

      typedef union _ARM_INTCOAL_LEAK_CTRL_UNION {
         ARM_INTCOAL_LEAK_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_INTCOAL_LEAK_CTRL_UNION, *PARM_INTCOAL_LEAK_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_LEAK_CTRL_UNION, sizeof (ARM_INTCOAL_LEAK_CTRL_UNION) == 4);
   #endif


#else
   // Leaky Bucket Interrupt Coalescer controler registers. The Leaky IntCoal uses a leaky
   // bucket scheme that fills up the bucket with credit every UPDATE_RATE. If the bucket
   // has credits, an interrupt is allowed. If not, the interrupt is ignored, allowing
   // other interrupts to coalesce. The bucket also has a depth. The practical result
   // being that UPDATE_RATE and UPDATE_SCALE control the steady stream maximum interrupt
   // rate, while the DEPTH field indicates the maximum number of interrupts that can
   // arrive in an UPDATE_RATE period. NOTE that any write to this location is considered
   // traumatic enough that it triggers a soft reset of the coalescer. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_INTCOAL_LEAK_CTRL {
         union {
            struct { 
               u32 update_rate : 8;               // DWORD 0
               u32 depth : 8;                     // DWORD 0
               u32 intack : 1;                    // DWORD 0
               u32 fpga : 1;                      // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 debug_intin : 1;               // DWORD 0
               u32 debug_intout : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_INTCOAL_LEAK_CTRL, *PARM_INTCOAL_LEAK_CTRL;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_LEAK_CTRL, sizeof (ARM_INTCOAL_LEAK_CTRL) == 4);

   #else
      typedef struct _ARM_INTCOAL_LEAK_CTRL {
         u32 update_rate : 8;                     // DWORD 0
         u32 depth : 8;                           // DWORD 0
         u32 intack : 1;                          // DWORD 0
         u32 fpga : 1;                            // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 debug_intin : 1;                     // DWORD 0
         u32 debug_intout : 1;                    // DWORD 0
      } SG_PACK ARM_INTCOAL_LEAK_CTRL, *PARM_INTCOAL_LEAK_CTRL;

      typedef union _ARM_INTCOAL_LEAK_CTRL_UNION {
         ARM_INTCOAL_LEAK_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_INTCOAL_LEAK_CTRL_UNION, *PARM_INTCOAL_LEAK_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_LEAK_CTRL_UNION, sizeof (ARM_INTCOAL_LEAK_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Delay Interrupt Coalescer controler registers. The Delay Intcoal effectively delays
   // new interrupt(s) until a specific time passes, or a certain number of interrupts is
   // pending. The Delay Coal input is the producer/consumer index and its output goes to
   // the Leaky Bucket Coalescer.  NOTE that any write to this location is considered
   // traumatic enough that it triggers a soft reset of the coalescer. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_INTCOAL_DELAY_CTRL {
         union {
            struct { 
               u32 debug_intout : 1;              // DWORD 0
               u32 debug_intin : 1;               // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 max_coal_int : 8;              // DWORD 0
               u32 max_coal_time : 8;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_INTCOAL_DELAY_CTRL, *PARM_INTCOAL_DELAY_CTRL;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_DELAY_CTRL, sizeof (ARM_INTCOAL_DELAY_CTRL) == 4);

   #else
      typedef struct _ARM_INTCOAL_DELAY_CTRL {
         u32 debug_intout : 1;                    // DWORD 0
         u32 debug_intin : 1;                     // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 max_coal_int : 8;                    // DWORD 0
         u32 max_coal_time : 8;                   // DWORD 0
      } SG_PACK ARM_INTCOAL_DELAY_CTRL, *PARM_INTCOAL_DELAY_CTRL;

      typedef union _ARM_INTCOAL_DELAY_CTRL_UNION {
         ARM_INTCOAL_DELAY_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_INTCOAL_DELAY_CTRL_UNION, *PARM_INTCOAL_DELAY_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_DELAY_CTRL_UNION, sizeof (ARM_INTCOAL_DELAY_CTRL_UNION) == 4);
   #endif


#else
   // Delay Interrupt Coalescer controler registers. The Delay Intcoal effectively delays
   // new interrupt(s) until a specific time passes, or a certain number of interrupts is
   // pending. The Delay Coal input is the producer/consumer index and its output goes to
   // the Leaky Bucket Coalescer.  NOTE that any write to this location is considered
   // traumatic enough that it triggers a soft reset of the coalescer. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARM_INTCOAL_DELAY_CTRL {
         union {
            struct { 
               u32 max_coal_time : 8;             // DWORD 0
               u32 max_coal_int : 8;              // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 debug_intin : 1;               // DWORD 0
               u32 debug_intout : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ARM_INTCOAL_DELAY_CTRL, *PARM_INTCOAL_DELAY_CTRL;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_DELAY_CTRL, sizeof (ARM_INTCOAL_DELAY_CTRL) == 4);

   #else
      typedef struct _ARM_INTCOAL_DELAY_CTRL {
         u32 max_coal_time : 8;                   // DWORD 0
         u32 max_coal_int : 8;                    // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 debug_intin : 1;                     // DWORD 0
         u32 debug_intout : 1;                    // DWORD 0
      } SG_PACK ARM_INTCOAL_DELAY_CTRL, *PARM_INTCOAL_DELAY_CTRL;

      typedef union _ARM_INTCOAL_DELAY_CTRL_UNION {
         ARM_INTCOAL_DELAY_CTRL bits;
         u32 dw; // dword union
      } SG_PACK ARM_INTCOAL_DELAY_CTRL_UNION, *PARM_INTCOAL_DELAY_CTRL_UNION;

      SG_C_ASSERT(__sizeof__ARM_INTCOAL_DELAY_CTRL_UNION, sizeof (ARM_INTCOAL_DELAY_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The ARMSYS_CSRMAP defines the layout of the ARM System Control Registers. To access
   // any of these registers, program the relative offset into the MPUARM_SYSREG_CTRL
   // <I>addr</I> field and set the appropriate control bits in that register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_CSRMAP {
         union {
            struct { 
               ARMSYS_SYSREG sysreg;
               ARMSYS_IRQCTRL irqctrl;
               ARMSYS_FIQCTRL fiqctrl;
               ARMSYS_IRQSTAT irqstat;
               ARMSYS_FIQSTAT fiqstat;
               ARMSYS_STRAPSTAT strapstat;
               u32 rsvd0[1];                      // DWORDS 6 to 6
               ARMSYS_FIQ_VECTOR fiqsrc;
               REV_ID rev_id;
               ARMSYS_DDR_WRR0 ddr_wrr_weights0;
               ARMSYS_DDR_WRR1 ddr_wrr_weights1;
               ARM_DDRINT_CTRL ddrint_ctrl;
               ARM_DDRINT_ADDR_LOW ddrint0_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint0_addr_high;
               ARM_DDRINT_INDEX ddrint0_index;
               ARM_DDRINT_ADDR_LOW ddrint1_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint1_addr_high;
               ARM_DDRINT_INDEX ddrint1_index;
               ARM_DDRINT_ADDR_LOW ddrint2_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint2_addr_high;
               ARM_DDRINT_INDEX ddrint2_index;
               ARM_DDRINT_ADDR_LOW ddrint3_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint3_addr_high;
               ARM_DDRINT_INDEX ddrint3_index;
               ARM_INTCOAL_LEAK_CTRL intcoal0_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal1_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal2_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal3_leak_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal0_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal1_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal2_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal3_delay_ctrl;
               ARMSYS_DMAARB_DEBUG0 dmaarb_debug0;
               ARMSYS_DMAARB_DEBUG1 dmaarb_debug1;
               ARMSYS_FIQ_VECT_SEL fiq_vect_sel0;
               ARMSYS_FIQ_VECT_SEL fiq_vect_sel1;
               u32 rsvd1[220];                    // DWORDS 36 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_CSRMAP, *PARMSYS_CSRMAP;

      SG_C_ASSERT(__sizeof__ARMSYS_CSRMAP, sizeof (ARMSYS_CSRMAP) == 1024);

   #else
      typedef struct _ARMSYS_CSRMAP {
         ARMSYS_SYSREG sysreg;
         ARMSYS_IRQCTRL irqctrl;
         ARMSYS_FIQCTRL fiqctrl;
         ARMSYS_IRQSTAT irqstat;
         ARMSYS_FIQSTAT fiqstat;
         ARMSYS_STRAPSTAT strapstat;
         u32 rsvd0[1];                            // DWORDS 6 to 6
         ARMSYS_FIQ_VECTOR fiqsrc;
         REV_ID rev_id;
         ARMSYS_DDR_WRR0 ddr_wrr_weights0;
         ARMSYS_DDR_WRR1 ddr_wrr_weights1;
         ARM_DDRINT_CTRL ddrint_ctrl;
         ARM_DDRINT_ADDR_LOW ddrint0_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint0_addr_high;
         ARM_DDRINT_INDEX ddrint0_index;
         ARM_DDRINT_ADDR_LOW ddrint1_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint1_addr_high;
         ARM_DDRINT_INDEX ddrint1_index;
         ARM_DDRINT_ADDR_LOW ddrint2_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint2_addr_high;
         ARM_DDRINT_INDEX ddrint2_index;
         ARM_DDRINT_ADDR_LOW ddrint3_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint3_addr_high;
         ARM_DDRINT_INDEX ddrint3_index;
         ARM_INTCOAL_LEAK_CTRL intcoal0_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal1_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal2_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal3_leak_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal0_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal1_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal2_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal3_delay_ctrl;
         ARMSYS_DMAARB_DEBUG0 dmaarb_debug0;
         ARMSYS_DMAARB_DEBUG1 dmaarb_debug1;
         ARMSYS_FIQ_VECT_SEL fiq_vect_sel0;
         ARMSYS_FIQ_VECT_SEL fiq_vect_sel1;
         u32 rsvd1[220];                          // DWORDS 36 to 255
      } SG_PACK ARMSYS_CSRMAP, *PARMSYS_CSRMAP;

      typedef union _ARMSYS_CSRMAP_UNION {
         ARMSYS_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ARMSYS_CSRMAP_UNION, *PARMSYS_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_CSRMAP_UNION, sizeof (ARMSYS_CSRMAP_UNION) == 1024);
   #endif


#else
   // The ARMSYS_CSRMAP defines the layout of the ARM System Control Registers. To access
   // any of these registers, program the relative offset into the MPUARM_SYSREG_CTRL
   // <I>addr</I> field and set the appropriate control bits in that register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ARMSYS_CSRMAP {
         union {
            struct { 
               ARMSYS_SYSREG sysreg;
               ARMSYS_IRQCTRL irqctrl;
               ARMSYS_FIQCTRL fiqctrl;
               ARMSYS_IRQSTAT irqstat;
               ARMSYS_FIQSTAT fiqstat;
               ARMSYS_STRAPSTAT strapstat;
               u32 rsvd0[1];                      // DWORDS 6 to 6
               ARMSYS_FIQ_VECTOR fiqsrc;
               REV_ID rev_id;
               ARMSYS_DDR_WRR0 ddr_wrr_weights0;
               ARMSYS_DDR_WRR1 ddr_wrr_weights1;
               ARM_DDRINT_CTRL ddrint_ctrl;
               ARM_DDRINT_ADDR_LOW ddrint0_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint0_addr_high;
               ARM_DDRINT_INDEX ddrint0_index;
               ARM_DDRINT_ADDR_LOW ddrint1_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint1_addr_high;
               ARM_DDRINT_INDEX ddrint1_index;
               ARM_DDRINT_ADDR_LOW ddrint2_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint2_addr_high;
               ARM_DDRINT_INDEX ddrint2_index;
               ARM_DDRINT_ADDR_LOW ddrint3_addr_low;
               ARM_DDRINT_ADDR_HIGH ddrint3_addr_high;
               ARM_DDRINT_INDEX ddrint3_index;
               ARM_INTCOAL_LEAK_CTRL intcoal0_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal1_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal2_leak_ctrl;
               ARM_INTCOAL_LEAK_CTRL intcoal3_leak_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal0_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal1_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal2_delay_ctrl;
               ARM_INTCOAL_DELAY_CTRL intcoal3_delay_ctrl;
               ARMSYS_DMAARB_DEBUG0 dmaarb_debug0;
               ARMSYS_DMAARB_DEBUG1 dmaarb_debug1;
               ARMSYS_FIQ_VECT_SEL fiq_vect_sel0;
               ARMSYS_FIQ_VECT_SEL fiq_vect_sel1;
               u32 rsvd1[220];                    // DWORDS 36 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ARMSYS_CSRMAP, *PARMSYS_CSRMAP;

      SG_C_ASSERT(__sizeof__ARMSYS_CSRMAP, sizeof (ARMSYS_CSRMAP) == 1024);

   #else
      typedef struct _ARMSYS_CSRMAP {
         ARMSYS_SYSREG sysreg;
         ARMSYS_IRQCTRL irqctrl;
         ARMSYS_FIQCTRL fiqctrl;
         ARMSYS_IRQSTAT irqstat;
         ARMSYS_FIQSTAT fiqstat;
         ARMSYS_STRAPSTAT strapstat;
         u32 rsvd0[1];                            // DWORDS 6 to 6
         ARMSYS_FIQ_VECTOR fiqsrc;
         REV_ID rev_id;
         ARMSYS_DDR_WRR0 ddr_wrr_weights0;
         ARMSYS_DDR_WRR1 ddr_wrr_weights1;
         ARM_DDRINT_CTRL ddrint_ctrl;
         ARM_DDRINT_ADDR_LOW ddrint0_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint0_addr_high;
         ARM_DDRINT_INDEX ddrint0_index;
         ARM_DDRINT_ADDR_LOW ddrint1_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint1_addr_high;
         ARM_DDRINT_INDEX ddrint1_index;
         ARM_DDRINT_ADDR_LOW ddrint2_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint2_addr_high;
         ARM_DDRINT_INDEX ddrint2_index;
         ARM_DDRINT_ADDR_LOW ddrint3_addr_low;
         ARM_DDRINT_ADDR_HIGH ddrint3_addr_high;
         ARM_DDRINT_INDEX ddrint3_index;
         ARM_INTCOAL_LEAK_CTRL intcoal0_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal1_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal2_leak_ctrl;
         ARM_INTCOAL_LEAK_CTRL intcoal3_leak_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal0_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal1_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal2_delay_ctrl;
         ARM_INTCOAL_DELAY_CTRL intcoal3_delay_ctrl;
         ARMSYS_DMAARB_DEBUG0 dmaarb_debug0;
         ARMSYS_DMAARB_DEBUG1 dmaarb_debug1;
         ARMSYS_FIQ_VECT_SEL fiq_vect_sel0;
         ARMSYS_FIQ_VECT_SEL fiq_vect_sel1;
         u32 rsvd1[220];                          // DWORDS 36 to 255
      } SG_PACK ARMSYS_CSRMAP, *PARMSYS_CSRMAP;

      typedef union _ARMSYS_CSRMAP_UNION {
         ARMSYS_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK ARMSYS_CSRMAP_UNION, *PARMSYS_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__ARMSYS_CSRMAP_UNION, sizeof (ARMSYS_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __armsys_bmap_h__

