/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __be_cm_bmap_h__
#define __be_cm_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "be_common_bmap.h"
#include "cev_bmap.h"
#include "common_context_bmap.h"
#include "iscsi_context_bmap.h"
#include "rdma_context_bmap.h"
#include "fc_device_context_bmap.h"
#include "toe_context_bmap.h"
#include "tcp_context_bmap.h"
#include "lro_tcp_context_bmap.h"
#include "tcp_sack_bmap.h"
#include "mpu_context_bmap.h"
#include "ipsec_sa_structs_bmap.h"
#include "dal_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _CONFIG0_CTX_MEMORY_MAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK CONFIG0_CTX_MEMORY_MAP, *PCONFIG0_CTX_MEMORY_MAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // Chip context memory map for BE_CONFIG=0. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG0_CTX_MEMORY_MAP {
            union {
               struct { 
                  ETX_PRIMARY_SHAD_RING primary_shadow_rings[16];
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[48];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  TOE_DEFAULT_BUFFER toe_default_buffer[8];
                  TOE_CONTEXT toe[448];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  SACK_BLOCKS sack[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[512];
                  JE_HEAD_TAIL iscsi_ooo[1024];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  ISCSI_LUN luntable[512];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 112800 to 113055
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[8];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[2560];
                  PHYS_ADDR template_pointers[32];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  TXP_CRC_CTX txp_iscsi_crc_array[512];
                  IPC_OVFLOW_CTX ovflow[7];
                  WCON_BM_CC wcon_bm_cc[2496];
                  WCON_PM_CC wcon_pm_cc[1032];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  LRO_TCP_CONTEXT lroctx[8];
                  LRO_TCP_CONTEXT lroctx_hole[8];
                  u32 r2t_base_addr[4];           // DWORDS 126992 to 126995
                  u32 ooo_base_addr[4];           // DWORDS 126996 to 126999
                  u32 pad_buffer_addr[4];         // DWORDS 127000 to 127003
                  u32 sock_recv_bufsize[448];     // DWORDS 127004 to 127451
                  u32 last_syn_timestamp[1024];   // DWORDS 127452 to 128475
                  EXCESS_QOS_COUNTERS excess_qos_counters;
                  u32 rsvd0[2588];                // DWORDS 128484 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG0_CTX_MEMORY_MAP, *PCONFIG0_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG0_CTX_MEMORY_MAP, sizeof (CONFIG0_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG0_CTX_MEMORY_MAP {
            ETX_PRIMARY_SHAD_RING primary_shadow_rings[16];
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[48];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            TOE_DEFAULT_BUFFER toe_default_buffer[8];
            TOE_CONTEXT toe[448];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            SACK_BLOCKS sack[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[512];
            JE_HEAD_TAIL iscsi_ooo[1024];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            ISCSI_LUN luntable[512];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 112800 to 113055
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[8];
            WDMA_CRC_CTX wdma_iscsi_crc_array[2560];
            PHYS_ADDR template_pointers[32];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            TXP_CRC_CTX txp_iscsi_crc_array[512];
            IPC_OVFLOW_CTX ovflow[7];
            WCON_BM_CC wcon_bm_cc[2496];
            WCON_PM_CC wcon_pm_cc[1032];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            LRO_TCP_CONTEXT lroctx[8];
            LRO_TCP_CONTEXT lroctx_hole[8];
            u32 r2t_base_addr[4];                 // DWORDS 126992 to 126995
            u32 ooo_base_addr[4];                 // DWORDS 126996 to 126999
            u32 pad_buffer_addr[4];               // DWORDS 127000 to 127003
            u32 sock_recv_bufsize[448];           // DWORDS 127004 to 127451
            u32 last_syn_timestamp[1024];         // DWORDS 127452 to 128475
            EXCESS_QOS_COUNTERS excess_qos_counters;
            u32 rsvd0[2588];                      // DWORDS 128484 to 131071
         } SG_PACK CONFIG0_CTX_MEMORY_MAP, *PCONFIG0_CTX_MEMORY_MAP;

         typedef union _CONFIG0_CTX_MEMORY_MAP_UNION {
            CONFIG0_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG0_CTX_MEMORY_MAP_UNION, *PCONFIG0_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG0_CTX_MEMORY_MAP_UNION, sizeof (CONFIG0_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #else
      // Chip context memory map for BE_CONFIG=0. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG0_CTX_MEMORY_MAP {
            union {
               struct { 
                  ETX_PRIMARY_SHAD_RING primary_shadow_rings[16];
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[48];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  TOE_DEFAULT_BUFFER toe_default_buffer[8];
                  TOE_CONTEXT toe[448];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  SACK_BLOCKS sack[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[512];
                  JE_HEAD_TAIL iscsi_ooo[1024];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  ISCSI_LUN luntable[512];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 112800 to 113055
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[8];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[2560];
                  PHYS_ADDR template_pointers[32];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  TXP_CRC_CTX txp_iscsi_crc_array[512];
                  IPC_OVFLOW_CTX ovflow[7];
                  WCON_BM_CC wcon_bm_cc[2496];
                  WCON_PM_CC wcon_pm_cc[1032];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  LRO_TCP_CONTEXT lroctx[8];
                  LRO_TCP_CONTEXT lroctx_hole[8];
                  u32 r2t_base_addr[4];           // DWORDS 126992 to 126995
                  u32 ooo_base_addr[4];           // DWORDS 126996 to 126999
                  u32 pad_buffer_addr[4];         // DWORDS 127000 to 127003
                  u32 sock_recv_bufsize[448];     // DWORDS 127004 to 127451
                  u32 last_syn_timestamp[1024];   // DWORDS 127452 to 128475
                  EXCESS_QOS_COUNTERS excess_qos_counters;
                  u32 rsvd0[2588];                // DWORDS 128484 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG0_CTX_MEMORY_MAP, *PCONFIG0_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG0_CTX_MEMORY_MAP, sizeof (CONFIG0_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG0_CTX_MEMORY_MAP {
            ETX_PRIMARY_SHAD_RING primary_shadow_rings[16];
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[48];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            TOE_DEFAULT_BUFFER toe_default_buffer[8];
            TOE_CONTEXT toe[448];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            SACK_BLOCKS sack[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[512];
            JE_HEAD_TAIL iscsi_ooo[1024];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            ISCSI_LUN luntable[512];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 112800 to 113055
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[8];
            WDMA_CRC_CTX wdma_iscsi_crc_array[2560];
            PHYS_ADDR template_pointers[32];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            TXP_CRC_CTX txp_iscsi_crc_array[512];
            IPC_OVFLOW_CTX ovflow[7];
            WCON_BM_CC wcon_bm_cc[2496];
            WCON_PM_CC wcon_pm_cc[1032];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            LRO_TCP_CONTEXT lroctx[8];
            LRO_TCP_CONTEXT lroctx_hole[8];
            u32 r2t_base_addr[4];                 // DWORDS 126992 to 126995
            u32 ooo_base_addr[4];                 // DWORDS 126996 to 126999
            u32 pad_buffer_addr[4];               // DWORDS 127000 to 127003
            u32 sock_recv_bufsize[448];           // DWORDS 127004 to 127451
            u32 last_syn_timestamp[1024];         // DWORDS 127452 to 128475
            EXCESS_QOS_COUNTERS excess_qos_counters;
            u32 rsvd0[2588];                      // DWORDS 128484 to 131071
         } SG_PACK CONFIG0_CTX_MEMORY_MAP, *PCONFIG0_CTX_MEMORY_MAP;

         typedef union _CONFIG0_CTX_MEMORY_MAP_UNION {
            CONFIG0_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG0_CTX_MEMORY_MAP_UNION, *PCONFIG0_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG0_CTX_MEMORY_MAP_UNION, sizeof (CONFIG0_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _CONFIG3_CTX_MEMORY_MAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK CONFIG3_CTX_MEMORY_MAP, *PCONFIG3_CTX_MEMORY_MAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // This following table defines the layout of CTX, a large on-chip central context
      // memory for ISCSI target implementation.  The total on-chip size of CTX is 512KB. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG3_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  JE_HEAD_TAIL iscsi_ooo[2000];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  u32 ooo_base_addr[4];           // DWORDS 70864 to 70867
                  IPC_OVFLOW_CTX ovflow[9];
                  PHYS_ADDR template_pointers[32];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[1000];
                  ISCSI_LUN luntable[1000];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
                  TXP_CRC_CTX txp_iscsi_crc_array[1000];
                  WCON_BM_CC wcon_bm_cc[2048];
                  WCON_PM_CC wcon_pm_cc[1008];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  ISCSI_ITT ITTtable[2048];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 129820 to 130075
                  u32 r2t_base_addr[4];           // DWORDS 130076 to 130079
                  u32 pad_buffer_addr[4];         // DWORDS 130080 to 130083
                  u32 rsvd0[988];                 // DWORDS 130084 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG3_CTX_MEMORY_MAP, *PCONFIG3_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG3_CTX_MEMORY_MAP, sizeof (CONFIG3_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG3_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            JE_HEAD_TAIL iscsi_ooo[2000];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            u32 ooo_base_addr[4];                 // DWORDS 70864 to 70867
            IPC_OVFLOW_CTX ovflow[9];
            PHYS_ADDR template_pointers[32];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[1000];
            ISCSI_LUN luntable[1000];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
            WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
            TXP_CRC_CTX txp_iscsi_crc_array[1000];
            WCON_BM_CC wcon_bm_cc[2048];
            WCON_PM_CC wcon_pm_cc[1008];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            ISCSI_ITT ITTtable[2048];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 129820 to 130075
            u32 r2t_base_addr[4];                 // DWORDS 130076 to 130079
            u32 pad_buffer_addr[4];               // DWORDS 130080 to 130083
            u32 rsvd0[988];                       // DWORDS 130084 to 131071
         } SG_PACK CONFIG3_CTX_MEMORY_MAP, *PCONFIG3_CTX_MEMORY_MAP;

         typedef union _CONFIG3_CTX_MEMORY_MAP_UNION {
            CONFIG3_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG3_CTX_MEMORY_MAP_UNION, *PCONFIG3_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG3_CTX_MEMORY_MAP_UNION, sizeof (CONFIG3_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #else
      // This following table defines the layout of CTX, a large on-chip central context
      // memory for ISCSI target implementation.  The total on-chip size of CTX is 512KB. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG3_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  JE_HEAD_TAIL iscsi_ooo[2000];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  u32 ooo_base_addr[4];           // DWORDS 70864 to 70867
                  IPC_OVFLOW_CTX ovflow[9];
                  PHYS_ADDR template_pointers[32];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[1000];
                  ISCSI_LUN luntable[1000];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
                  TXP_CRC_CTX txp_iscsi_crc_array[1000];
                  WCON_BM_CC wcon_bm_cc[2048];
                  WCON_PM_CC wcon_pm_cc[1008];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  ISCSI_ITT ITTtable[2048];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 129820 to 130075
                  u32 r2t_base_addr[4];           // DWORDS 130076 to 130079
                  u32 pad_buffer_addr[4];         // DWORDS 130080 to 130083
                  u32 rsvd0[988];                 // DWORDS 130084 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG3_CTX_MEMORY_MAP, *PCONFIG3_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG3_CTX_MEMORY_MAP, sizeof (CONFIG3_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG3_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            JE_HEAD_TAIL iscsi_ooo[2000];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            u32 ooo_base_addr[4];                 // DWORDS 70864 to 70867
            IPC_OVFLOW_CTX ovflow[9];
            PHYS_ADDR template_pointers[32];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[1000];
            ISCSI_LUN luntable[1000];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
            WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
            TXP_CRC_CTX txp_iscsi_crc_array[1000];
            WCON_BM_CC wcon_bm_cc[2048];
            WCON_PM_CC wcon_pm_cc[1008];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            ISCSI_ITT ITTtable[2048];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 129820 to 130075
            u32 r2t_base_addr[4];                 // DWORDS 130076 to 130079
            u32 pad_buffer_addr[4];               // DWORDS 130080 to 130083
            u32 rsvd0[988];                       // DWORDS 130084 to 131071
         } SG_PACK CONFIG3_CTX_MEMORY_MAP, *PCONFIG3_CTX_MEMORY_MAP;

         typedef union _CONFIG3_CTX_MEMORY_MAP_UNION {
            CONFIG3_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG3_CTX_MEMORY_MAP_UNION, *PCONFIG3_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG3_CTX_MEMORY_MAP_UNION, sizeof (CONFIG3_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _CONFIG6_CTX_MEMORY_MAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK CONFIG6_CTX_MEMORY_MAP, *PCONFIG6_CTX_MEMORY_MAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // Chip context memory map for BE_CONFIG=6 used for DAL 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG6_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  PHYS_ADDR dal_tx_te_cache[16384];
                  DAL_TX_CONTEXT dal_tx_context[32];
                  ETX_CONTEXT eth_tx[64];
                  WCON_BM_CC wcon_bm_cc[4];
                  WCON_PM_CC wcon_pm_cc[32];
                  DAL_RX_CONTEXT dal_rx_context[32];
                  DAL_RX_TABLE dal_rx_table[32];
                  TCP_CONTEXT tcp[32];
                  TOE_DEFAULT_BUFFER toe_default_buffer[2];
                  TOE_CONTEXT toe[2];
                  JE_HEAD_TAIL tcp_retx[4];
                  JELLE jellt[4];
                  SACK_BLOCKS sack[2];
                  ICD_CONTEXT icd[2];
                  ISCSI_CONTEXT iscsi[2];
                  JE_HEAD_TAIL iscsi_ooo[4];
                  JELLE iscsi_jellt[4];
                  ISCSI_LUN luntable[2];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[2];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[4];
                  ISCSI_CMD_HDR ctx_phdr_pool[2];
                  TXP_CRC_CTX txp_iscsi_crc_array[2];
                  u32 r2t_base_addr[4];           // DWORDS 66072 to 66075
                  u32 ooo_base_addr[4];           // DWORDS 66076 to 66079
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 66112 to 66367
                  PHYS_ADDR template_pointers[32];
                  IPC_OVFLOW_CTX ovflow[7];
                  DAL_TPRE_CONTEXT dal_tpre_context[128];
                  u32 rsvd0[55552];               // DWORDS 75520 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG6_CTX_MEMORY_MAP, *PCONFIG6_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG6_CTX_MEMORY_MAP, sizeof (CONFIG6_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG6_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            PHYS_ADDR dal_tx_te_cache[16384];
            DAL_TX_CONTEXT dal_tx_context[32];
            ETX_CONTEXT eth_tx[64];
            WCON_BM_CC wcon_bm_cc[4];
            WCON_PM_CC wcon_pm_cc[32];
            DAL_RX_CONTEXT dal_rx_context[32];
            DAL_RX_TABLE dal_rx_table[32];
            TCP_CONTEXT tcp[32];
            TOE_DEFAULT_BUFFER toe_default_buffer[2];
            TOE_CONTEXT toe[2];
            JE_HEAD_TAIL tcp_retx[4];
            JELLE jellt[4];
            SACK_BLOCKS sack[2];
            ICD_CONTEXT icd[2];
            ISCSI_CONTEXT iscsi[2];
            JE_HEAD_TAIL iscsi_ooo[4];
            JELLE iscsi_jellt[4];
            ISCSI_LUN luntable[2];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[2];
            WDMA_CRC_CTX wdma_iscsi_crc_array[4];
            ISCSI_CMD_HDR ctx_phdr_pool[2];
            TXP_CRC_CTX txp_iscsi_crc_array[2];
            u32 r2t_base_addr[4];                 // DWORDS 66072 to 66075
            u32 ooo_base_addr[4];                 // DWORDS 66076 to 66079
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 66112 to 66367
            PHYS_ADDR template_pointers[32];
            IPC_OVFLOW_CTX ovflow[7];
            DAL_TPRE_CONTEXT dal_tpre_context[128];
            u32 rsvd0[55552];                     // DWORDS 75520 to 131071
         } SG_PACK CONFIG6_CTX_MEMORY_MAP, *PCONFIG6_CTX_MEMORY_MAP;

         typedef union _CONFIG6_CTX_MEMORY_MAP_UNION {
            CONFIG6_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG6_CTX_MEMORY_MAP_UNION, *PCONFIG6_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG6_CTX_MEMORY_MAP_UNION, sizeof (CONFIG6_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #else
      // Chip context memory map for BE_CONFIG=6 used for DAL 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG6_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  PHYS_ADDR dal_tx_te_cache[16384];
                  DAL_TX_CONTEXT dal_tx_context[32];
                  ETX_CONTEXT eth_tx[64];
                  WCON_BM_CC wcon_bm_cc[4];
                  WCON_PM_CC wcon_pm_cc[32];
                  DAL_RX_CONTEXT dal_rx_context[32];
                  DAL_RX_TABLE dal_rx_table[32];
                  TCP_CONTEXT tcp[32];
                  TOE_DEFAULT_BUFFER toe_default_buffer[2];
                  TOE_CONTEXT toe[2];
                  JE_HEAD_TAIL tcp_retx[4];
                  JELLE jellt[4];
                  SACK_BLOCKS sack[2];
                  ICD_CONTEXT icd[2];
                  ISCSI_CONTEXT iscsi[2];
                  JE_HEAD_TAIL iscsi_ooo[4];
                  JELLE iscsi_jellt[4];
                  ISCSI_LUN luntable[2];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[2];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[4];
                  ISCSI_CMD_HDR ctx_phdr_pool[2];
                  TXP_CRC_CTX txp_iscsi_crc_array[2];
                  u32 r2t_base_addr[4];           // DWORDS 66072 to 66075
                  u32 ooo_base_addr[4];           // DWORDS 66076 to 66079
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 66112 to 66367
                  PHYS_ADDR template_pointers[32];
                  IPC_OVFLOW_CTX ovflow[7];
                  DAL_TPRE_CONTEXT dal_tpre_context[128];
                  u32 rsvd0[55552];               // DWORDS 75520 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG6_CTX_MEMORY_MAP, *PCONFIG6_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG6_CTX_MEMORY_MAP, sizeof (CONFIG6_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG6_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            PHYS_ADDR dal_tx_te_cache[16384];
            DAL_TX_CONTEXT dal_tx_context[32];
            ETX_CONTEXT eth_tx[64];
            WCON_BM_CC wcon_bm_cc[4];
            WCON_PM_CC wcon_pm_cc[32];
            DAL_RX_CONTEXT dal_rx_context[32];
            DAL_RX_TABLE dal_rx_table[32];
            TCP_CONTEXT tcp[32];
            TOE_DEFAULT_BUFFER toe_default_buffer[2];
            TOE_CONTEXT toe[2];
            JE_HEAD_TAIL tcp_retx[4];
            JELLE jellt[4];
            SACK_BLOCKS sack[2];
            ICD_CONTEXT icd[2];
            ISCSI_CONTEXT iscsi[2];
            JE_HEAD_TAIL iscsi_ooo[4];
            JELLE iscsi_jellt[4];
            ISCSI_LUN luntable[2];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[2];
            WDMA_CRC_CTX wdma_iscsi_crc_array[4];
            ISCSI_CMD_HDR ctx_phdr_pool[2];
            TXP_CRC_CTX txp_iscsi_crc_array[2];
            u32 r2t_base_addr[4];                 // DWORDS 66072 to 66075
            u32 ooo_base_addr[4];                 // DWORDS 66076 to 66079
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 66112 to 66367
            PHYS_ADDR template_pointers[32];
            IPC_OVFLOW_CTX ovflow[7];
            DAL_TPRE_CONTEXT dal_tpre_context[128];
            u32 rsvd0[55552];                     // DWORDS 75520 to 131071
         } SG_PACK CONFIG6_CTX_MEMORY_MAP, *PCONFIG6_CTX_MEMORY_MAP;

         typedef union _CONFIG6_CTX_MEMORY_MAP_UNION {
            CONFIG6_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG6_CTX_MEMORY_MAP_UNION, *PCONFIG6_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG6_CTX_MEMORY_MAP_UNION, sizeof (CONFIG6_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _CONFIG7_CTX_MEMORY_MAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK CONFIG7_CTX_MEMORY_MAP, *PCONFIG7_CTX_MEMORY_MAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // Chip context memory map for BE_CONFIG=7 to be used for FCoE Initiator/Target. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG7_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  TOE_DEFAULT_BUFFER toe_default_buffer[8];
                  TOE_CONTEXT toe[384];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[384];
                  JELLE jellt[2048];
                  SACK_BLOCKS sack[384];
                  FC_WRB_RING_CONTEXT fc_wrb_ring_ctx[256];
                  FC_CONTEXT fc_ctx[64];
                  FC_ICD_CONTEXT fc_icd[2048];
                  RPI_CONTEXT fc_rpi_ctx[2048];
                  FCOE_DEFAULT_PDU_CONTEXT fc_default_pdu[256];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 121632 to 121887
                  PHYS_ADDR template_pointers[32];
                  WCON_BM_CC wcon_bm_cc[2433];
                  u32 rsvd0[1];                   // DWORDS 124385 to 124385
                  u32 rsvd1[1];                   // DWORDS 124386 to 124386
                  u32 rsvd2[1];                   // DWORDS 124387 to 124387
                  WCON_PM_CC wcon_pm_cc[648];
                  TCP_HOLE_INFO_EXT tcp_hole_info[384];
                  u32 sock_recv_bufsize[384];     // DWORDS 127220 to 127603
                  u32 last_syn_timestamp[1024];   // DWORDS 127604 to 128627
                  EXCESS_QOS_COUNTERS excess_qos_counters;
                  FC_CONFIG_INFO armfw_config_info;
                  u32 rsvd3[2432];                // DWORDS 128640 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG7_CTX_MEMORY_MAP, *PCONFIG7_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG7_CTX_MEMORY_MAP, sizeof (CONFIG7_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG7_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            TOE_DEFAULT_BUFFER toe_default_buffer[8];
            TOE_CONTEXT toe[384];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[384];
            JELLE jellt[2048];
            SACK_BLOCKS sack[384];
            FC_WRB_RING_CONTEXT fc_wrb_ring_ctx[256];
            FC_CONTEXT fc_ctx[64];
            FC_ICD_CONTEXT fc_icd[2048];
            RPI_CONTEXT fc_rpi_ctx[2048];
            FCOE_DEFAULT_PDU_CONTEXT fc_default_pdu[256];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 121632 to 121887
            PHYS_ADDR template_pointers[32];
            WCON_BM_CC wcon_bm_cc[2433];
            u32 rsvd0[1];                         // DWORDS 124385 to 124385
            u32 rsvd1[1];                         // DWORDS 124386 to 124386
            u32 rsvd2[1];                         // DWORDS 124387 to 124387
            WCON_PM_CC wcon_pm_cc[648];
            TCP_HOLE_INFO_EXT tcp_hole_info[384];
            u32 sock_recv_bufsize[384];           // DWORDS 127220 to 127603
            u32 last_syn_timestamp[1024];         // DWORDS 127604 to 128627
            EXCESS_QOS_COUNTERS excess_qos_counters;
            FC_CONFIG_INFO armfw_config_info;
            u32 rsvd3[2432];                      // DWORDS 128640 to 131071
         } SG_PACK CONFIG7_CTX_MEMORY_MAP, *PCONFIG7_CTX_MEMORY_MAP;

         typedef union _CONFIG7_CTX_MEMORY_MAP_UNION {
            CONFIG7_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG7_CTX_MEMORY_MAP_UNION, *PCONFIG7_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG7_CTX_MEMORY_MAP_UNION, sizeof (CONFIG7_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #else
      // Chip context memory map for BE_CONFIG=7 to be used for FCoE Initiator/Target. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG7_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  TOE_DEFAULT_BUFFER toe_default_buffer[8];
                  TOE_CONTEXT toe[384];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[384];
                  JELLE jellt[2048];
                  SACK_BLOCKS sack[384];
                  FC_WRB_RING_CONTEXT fc_wrb_ring_ctx[256];
                  FC_CONTEXT fc_ctx[64];
                  FC_ICD_CONTEXT fc_icd[2048];
                  RPI_CONTEXT fc_rpi_ctx[2048];
                  FCOE_DEFAULT_PDU_CONTEXT fc_default_pdu[256];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 121632 to 121887
                  PHYS_ADDR template_pointers[32];
                  WCON_BM_CC wcon_bm_cc[2433];
                  u32 rsvd0[1];                   // DWORDS 124385 to 124385
                  u32 rsvd1[1];                   // DWORDS 124386 to 124386
                  u32 rsvd2[1];                   // DWORDS 124387 to 124387
                  WCON_PM_CC wcon_pm_cc[648];
                  TCP_HOLE_INFO_EXT tcp_hole_info[384];
                  u32 sock_recv_bufsize[384];     // DWORDS 127220 to 127603
                  u32 last_syn_timestamp[1024];   // DWORDS 127604 to 128627
                  EXCESS_QOS_COUNTERS excess_qos_counters;
                  FC_CONFIG_INFO armfw_config_info;
                  u32 rsvd3[2432];                // DWORDS 128640 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG7_CTX_MEMORY_MAP, *PCONFIG7_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG7_CTX_MEMORY_MAP, sizeof (CONFIG7_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG7_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            TOE_DEFAULT_BUFFER toe_default_buffer[8];
            TOE_CONTEXT toe[384];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[384];
            JELLE jellt[2048];
            SACK_BLOCKS sack[384];
            FC_WRB_RING_CONTEXT fc_wrb_ring_ctx[256];
            FC_CONTEXT fc_ctx[64];
            FC_ICD_CONTEXT fc_icd[2048];
            RPI_CONTEXT fc_rpi_ctx[2048];
            FCOE_DEFAULT_PDU_CONTEXT fc_default_pdu[256];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 121632 to 121887
            PHYS_ADDR template_pointers[32];
            WCON_BM_CC wcon_bm_cc[2433];
            u32 rsvd0[1];                         // DWORDS 124385 to 124385
            u32 rsvd1[1];                         // DWORDS 124386 to 124386
            u32 rsvd2[1];                         // DWORDS 124387 to 124387
            WCON_PM_CC wcon_pm_cc[648];
            TCP_HOLE_INFO_EXT tcp_hole_info[384];
            u32 sock_recv_bufsize[384];           // DWORDS 127220 to 127603
            u32 last_syn_timestamp[1024];         // DWORDS 127604 to 128627
            EXCESS_QOS_COUNTERS excess_qos_counters;
            FC_CONFIG_INFO armfw_config_info;
            u32 rsvd3[2432];                      // DWORDS 128640 to 131071
         } SG_PACK CONFIG7_CTX_MEMORY_MAP, *PCONFIG7_CTX_MEMORY_MAP;

         typedef union _CONFIG7_CTX_MEMORY_MAP_UNION {
            CONFIG7_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG7_CTX_MEMORY_MAP_UNION, *PCONFIG7_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG7_CTX_MEMORY_MAP_UNION, sizeof (CONFIG7_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _CONFIG9_CTX_MEMORY_MAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK CONFIG9_CTX_MEMORY_MAP, *PCONFIG9_CTX_MEMORY_MAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // This following table defines the layout of CTX, a large on-chip central context
      // memory for ISCSI target implementation.  The total on-chip size of CTX is 512KB. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG9_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  JE_HEAD_TAIL iscsi_ooo[2000];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  u32 ooo_base_addr[4];           // DWORDS 70864 to 70867
                  IPC_OVFLOW_CTX ovflow[9];
                  PHYS_ADDR template_pointers[32];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[1000];
                  ISCSI_LUN luntable[1000];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
                  TXP_CRC_CTX txp_iscsi_crc_array[1000];
                  WCON_BM_CC wcon_bm_cc[2048];
                  WCON_PM_CC wcon_pm_cc[1008];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  ISCSI_ITT ITTtable[2048];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 129820 to 130075
                  u32 r2t_base_addr[4];           // DWORDS 130076 to 130079
                  u32 pad_buffer_addr[4];         // DWORDS 130080 to 130083
                  u32 rsvd0[988];                 // DWORDS 130084 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG9_CTX_MEMORY_MAP, *PCONFIG9_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG9_CTX_MEMORY_MAP, sizeof (CONFIG9_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG9_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            JE_HEAD_TAIL iscsi_ooo[2000];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            u32 ooo_base_addr[4];                 // DWORDS 70864 to 70867
            IPC_OVFLOW_CTX ovflow[9];
            PHYS_ADDR template_pointers[32];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[1000];
            ISCSI_LUN luntable[1000];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
            WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
            TXP_CRC_CTX txp_iscsi_crc_array[1000];
            WCON_BM_CC wcon_bm_cc[2048];
            WCON_PM_CC wcon_pm_cc[1008];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            ISCSI_ITT ITTtable[2048];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 129820 to 130075
            u32 r2t_base_addr[4];                 // DWORDS 130076 to 130079
            u32 pad_buffer_addr[4];               // DWORDS 130080 to 130083
            u32 rsvd0[988];                       // DWORDS 130084 to 131071
         } SG_PACK CONFIG9_CTX_MEMORY_MAP, *PCONFIG9_CTX_MEMORY_MAP;

         typedef union _CONFIG9_CTX_MEMORY_MAP_UNION {
            CONFIG9_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG9_CTX_MEMORY_MAP_UNION, *PCONFIG9_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG9_CTX_MEMORY_MAP_UNION, sizeof (CONFIG9_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #else
      // This following table defines the layout of CTX, a large on-chip central context
      // memory for ISCSI target implementation.  The total on-chip size of CTX is 512KB. 
      #if defined(SG_BMAP_UNION)
         typedef struct _CONFIG9_CTX_MEMORY_MAP {
            union {
               struct { 
                  u32 shadow_etx_ring[256];       // DWORDS 0 to 255
                  u32 shadow_etx_ring2[256];      // DWORDS 256 to 511
                  ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
                  UC_CACHE_ELEMENT unified_cache[256];
                  PT_CACHE_ELEMENT page_table_cache[128];
                  ETX_CONTEXT eth_tx[64];
                  TCP_CONTEXT tcp[1024];
                  JE_HEAD_TAIL tcp_retx[1024];
                  JELLE jellt[4096];
                  JE_HEAD_TAIL iscsi_ooo[2000];
                  JELLE iscsi_jellt[512];
                  JELLE iscsi_jellt_rsvd[512];
                  u32 ooo_base_addr[4];           // DWORDS 70864 to 70867
                  IPC_OVFLOW_CTX ovflow[9];
                  PHYS_ADDR template_pointers[32];
                  TCP_HOLE_INFO_EXT tcp_hole_info[1024];
                  ICD_CONTEXT icd[2048];
                  ISCSI_CONTEXT iscsi[1000];
                  ISCSI_LUN luntable[1000];
                  ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
                  WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
                  TXP_CRC_CTX txp_iscsi_crc_array[1000];
                  WCON_BM_CC wcon_bm_cc[2048];
                  WCON_PM_CC wcon_pm_cc[1008];
                  ISCSI_CMD_HDR ctx_phdr_pool[16];
                  ISCSI_ITT ITTtable[2048];
                  MCC_RING_CONTEXT mcc[8];
                  u32 mpu_data_buffer[256];       // DWORDS 129820 to 130075
                  u32 r2t_base_addr[4];           // DWORDS 130076 to 130079
                  u32 pad_buffer_addr[4];         // DWORDS 130080 to 130083
                  u32 rsvd0[988];                 // DWORDS 130084 to 131071
               } SG_PACK ; // unnamed struct
               u32 dw[131072]; // dword union
            }; // unnamed union
         } SG_PACK CONFIG9_CTX_MEMORY_MAP, *PCONFIG9_CTX_MEMORY_MAP;

         SG_C_ASSERT(__sizeof__CONFIG9_CTX_MEMORY_MAP, sizeof (CONFIG9_CTX_MEMORY_MAP) == 524288);

      #else
         typedef struct _CONFIG9_CTX_MEMORY_MAP {
            u32 shadow_etx_ring[256];             // DWORDS 0 to 255
            u32 shadow_etx_ring2[256];            // DWORDS 256 to 511
            ETX_SECONDARY_SHAD_RING secondary_shadow_rings[62];
            UC_CACHE_ELEMENT unified_cache[256];
            PT_CACHE_ELEMENT page_table_cache[128];
            ETX_CONTEXT eth_tx[64];
            TCP_CONTEXT tcp[1024];
            JE_HEAD_TAIL tcp_retx[1024];
            JELLE jellt[4096];
            JE_HEAD_TAIL iscsi_ooo[2000];
            JELLE iscsi_jellt[512];
            JELLE iscsi_jellt_rsvd[512];
            u32 ooo_base_addr[4];                 // DWORDS 70864 to 70867
            IPC_OVFLOW_CTX ovflow[9];
            PHYS_ADDR template_pointers[32];
            TCP_HOLE_INFO_EXT tcp_hole_info[1024];
            ICD_CONTEXT icd[2048];
            ISCSI_CONTEXT iscsi[1000];
            ISCSI_LUN luntable[1000];
            ISCSI_DEFAULT_PDU_CONTEXT iscsi_default_pdu[16];
            WDMA_CRC_CTX wdma_iscsi_crc_array[3048];
            TXP_CRC_CTX txp_iscsi_crc_array[1000];
            WCON_BM_CC wcon_bm_cc[2048];
            WCON_PM_CC wcon_pm_cc[1008];
            ISCSI_CMD_HDR ctx_phdr_pool[16];
            ISCSI_ITT ITTtable[2048];
            MCC_RING_CONTEXT mcc[8];
            u32 mpu_data_buffer[256];             // DWORDS 129820 to 130075
            u32 r2t_base_addr[4];                 // DWORDS 130076 to 130079
            u32 pad_buffer_addr[4];               // DWORDS 130080 to 130083
            u32 rsvd0[988];                       // DWORDS 130084 to 131071
         } SG_PACK CONFIG9_CTX_MEMORY_MAP, *PCONFIG9_CTX_MEMORY_MAP;

         typedef union _CONFIG9_CTX_MEMORY_MAP_UNION {
            CONFIG9_CTX_MEMORY_MAP bits;
            u32 dw[131072]; // dword union
         } SG_PACK CONFIG9_CTX_MEMORY_MAP_UNION, *PCONFIG9_CTX_MEMORY_MAP_UNION;

         SG_C_ASSERT(__sizeof__CONFIG9_CTX_MEMORY_MAP_UNION, sizeof (CONFIG9_CTX_MEMORY_MAP_UNION) == 524288);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS
#if defined(SG_REVERSE_ENDIAN)
   // The following table defines the layout of CEV CQ/EQ context memory.  The total size
   // of this dedicated SRAM in CEV is 19,456 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MEMORY_MAP {
         union {
            struct { 
               CQ_CONTEXT cqt[1024];
               EQ_CONTEXT eqt[192];
            } SG_PACK ; // unnamed struct
            u32 dw[4864]; // dword union
         }; // unnamed union
      } SG_PACK CEV_MEMORY_MAP, *PCEV_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__CEV_MEMORY_MAP, sizeof (CEV_MEMORY_MAP) == 19456);

   #else
      typedef struct _CEV_MEMORY_MAP {
         CQ_CONTEXT cqt[1024];
         EQ_CONTEXT eqt[192];
      } SG_PACK CEV_MEMORY_MAP, *PCEV_MEMORY_MAP;

      typedef union _CEV_MEMORY_MAP_UNION {
         CEV_MEMORY_MAP bits;
         u32 dw[4864]; // dword union
      } SG_PACK CEV_MEMORY_MAP_UNION, *PCEV_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__CEV_MEMORY_MAP_UNION, sizeof (CEV_MEMORY_MAP_UNION) == 19456);
   #endif


#else
   // The following table defines the layout of CEV CQ/EQ context memory.  The total size
   // of this dedicated SRAM in CEV is 19,456 bytes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MEMORY_MAP {
         union {
            struct { 
               CQ_CONTEXT cqt[1024];
               EQ_CONTEXT eqt[192];
            } SG_PACK ; // unnamed struct
            u32 dw[4864]; // dword union
         }; // unnamed union
      } SG_PACK CEV_MEMORY_MAP, *PCEV_MEMORY_MAP;

      SG_C_ASSERT(__sizeof__CEV_MEMORY_MAP, sizeof (CEV_MEMORY_MAP) == 19456);

   #else
      typedef struct _CEV_MEMORY_MAP {
         CQ_CONTEXT cqt[1024];
         EQ_CONTEXT eqt[192];
      } SG_PACK CEV_MEMORY_MAP, *PCEV_MEMORY_MAP;

      typedef union _CEV_MEMORY_MAP_UNION {
         CEV_MEMORY_MAP bits;
         u32 dw[4864]; // dword union
      } SG_PACK CEV_MEMORY_MAP_UNION, *PCEV_MEMORY_MAP_UNION;

      SG_C_ASSERT(__sizeof__CEV_MEMORY_MAP_UNION, sizeof (CEV_MEMORY_MAP_UNION) == 19456);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __be_cm_bmap_h__

