/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ctx_bmap_h__
#define __ctx_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Read/write Address
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 addr : 16;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_ADDR_CSR, *PCTX_ADDR_CSR;

      SG_C_ASSERT(__sizeof__CTX_ADDR_CSR, sizeof (CTX_ADDR_CSR) == 4);

   #else
      typedef struct _CTX_ADDR_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 addr : 16;                           // DWORD 0
      } SG_PACK CTX_ADDR_CSR, *PCTX_ADDR_CSR;

      typedef union _CTX_ADDR_CSR_UNION {
         CTX_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_ADDR_CSR_UNION, *PCTX_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_ADDR_CSR_UNION, sizeof (CTX_ADDR_CSR_UNION) == 4);
   #endif


#else
   // Read/write Address
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_ADDR_CSR {
         union {
            struct { 
               u32 addr : 16;                     // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_ADDR_CSR, *PCTX_ADDR_CSR;

      SG_C_ASSERT(__sizeof__CTX_ADDR_CSR, sizeof (CTX_ADDR_CSR) == 4);

   #else
      typedef struct _CTX_ADDR_CSR {
         u32 addr : 16;                           // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK CTX_ADDR_CSR, *PCTX_ADDR_CSR;

      typedef union _CTX_ADDR_CSR_UNION {
         CTX_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_ADDR_CSR_UNION, *PCTX_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_ADDR_CSR_UNION, sizeof (CTX_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Read/write command port. Busy bit should be polled for clear to send
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_CMD_CSR {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 be : 16;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_CMD_CSR, *PCTX_CMD_CSR;

      SG_C_ASSERT(__sizeof__CTX_CMD_CSR, sizeof (CTX_CMD_CSR) == 4);

   #else
      typedef struct _CTX_CMD_CSR {
         u32 busy : 1;                            // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 be : 16;                             // DWORD 0
      } SG_PACK CTX_CMD_CSR, *PCTX_CMD_CSR;

      typedef union _CTX_CMD_CSR_UNION {
         CTX_CMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_CMD_CSR_UNION, *PCTX_CMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_CMD_CSR_UNION, sizeof (CTX_CMD_CSR_UNION) == 4);
   #endif


#else
   // Read/write command port. Busy bit should be polled for clear to send
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_CMD_CSR {
         union {
            struct { 
               u32 be : 16;                       // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 wr : 1;                        // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_CMD_CSR, *PCTX_CMD_CSR;

      SG_C_ASSERT(__sizeof__CTX_CMD_CSR, sizeof (CTX_CMD_CSR) == 4);

   #else
      typedef struct _CTX_CMD_CSR {
         u32 be : 16;                             // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 wr : 1;                              // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK CTX_CMD_CSR, *PCTX_CMD_CSR;

      typedef union _CTX_CMD_CSR_UNION {
         CTX_CMD_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_CMD_CSR_UNION, *PCTX_CMD_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_CMD_CSR_UNION, sizeof (CTX_CMD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Reading/write data port.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DATA_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_DATA_CSR, *PCTX_DATA_CSR;

      SG_C_ASSERT(__sizeof__CTX_DATA_CSR, sizeof (CTX_DATA_CSR) == 4);

   #else
      typedef struct _CTX_DATA_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK CTX_DATA_CSR, *PCTX_DATA_CSR;

      typedef union _CTX_DATA_CSR_UNION {
         CTX_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_DATA_CSR_UNION, *PCTX_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_DATA_CSR_UNION, sizeof (CTX_DATA_CSR_UNION) == 4);
   #endif


#else
   // Reading/write data port.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DATA_CSR {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_DATA_CSR, *PCTX_DATA_CSR;

      SG_C_ASSERT(__sizeof__CTX_DATA_CSR, sizeof (CTX_DATA_CSR) == 4);

   #else
      typedef struct _CTX_DATA_CSR {
         u32 value;                               // DWORD 0
      } SG_PACK CTX_DATA_CSR, *PCTX_DATA_CSR;

      typedef union _CTX_DATA_CSR_UNION {
         CTX_DATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_DATA_CSR_UNION, *PCTX_DATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_DATA_CSR_UNION, sizeof (CTX_DATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // reserve data port.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_RSV_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_RSV_CSR, *PCTX_RSV_CSR;

      SG_C_ASSERT(__sizeof__CTX_RSV_CSR, sizeof (CTX_RSV_CSR) == 4);

   #else
      typedef struct _CTX_RSV_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK CTX_RSV_CSR, *PCTX_RSV_CSR;

      typedef union _CTX_RSV_CSR_UNION {
         CTX_RSV_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_RSV_CSR_UNION, *PCTX_RSV_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_RSV_CSR_UNION, sizeof (CTX_RSV_CSR_UNION) == 4);
   #endif


#else
   // reserve data port.
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_RSV_CSR {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_RSV_CSR, *PCTX_RSV_CSR;

      SG_C_ASSERT(__sizeof__CTX_RSV_CSR, sizeof (CTX_RSV_CSR) == 4);

   #else
      typedef struct _CTX_RSV_CSR {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK CTX_RSV_CSR, *PCTX_RSV_CSR;

      typedef union _CTX_RSV_CSR_UNION {
         CTX_RSV_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_RSV_CSR_UNION, *PCTX_RSV_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_RSV_CSR_UNION, sizeof (CTX_RSV_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CTX Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 ctx_mem_error2_ue_source : 1;  // DWORD 0
               u32 ctx_mem_error1_ue_source : 1;  // DWORD 0
               u32 ctx_mem_error0_ue_source : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_UE_SOURCE_CSR, *PCTX_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__CTX_UE_SOURCE_CSR, sizeof (CTX_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _CTX_UE_SOURCE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 ctx_mem_error2_ue_source : 1;        // DWORD 0
         u32 ctx_mem_error1_ue_source : 1;        // DWORD 0
         u32 ctx_mem_error0_ue_source : 1;        // DWORD 0
      } SG_PACK CTX_UE_SOURCE_CSR, *PCTX_UE_SOURCE_CSR;

      typedef union _CTX_UE_SOURCE_CSR_UNION {
         CTX_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_UE_SOURCE_CSR_UNION, *PCTX_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_UE_SOURCE_CSR_UNION, sizeof (CTX_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // CTX Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_UE_SOURCE_CSR {
         union {
            struct { 
               u32 ctx_mem_error0_ue_source : 1;  // DWORD 0
               u32 ctx_mem_error1_ue_source : 1;  // DWORD 0
               u32 ctx_mem_error2_ue_source : 1;  // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_UE_SOURCE_CSR, *PCTX_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__CTX_UE_SOURCE_CSR, sizeof (CTX_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _CTX_UE_SOURCE_CSR {
         u32 ctx_mem_error0_ue_source : 1;        // DWORD 0
         u32 ctx_mem_error1_ue_source : 1;        // DWORD 0
         u32 ctx_mem_error2_ue_source : 1;        // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK CTX_UE_SOURCE_CSR, *PCTX_UE_SOURCE_CSR;

      typedef union _CTX_UE_SOURCE_CSR_UNION {
         CTX_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_UE_SOURCE_CSR_UNION, *PCTX_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_UE_SOURCE_CSR_UNION, sizeof (CTX_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CTX Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 ctx_mem_error2_ue_enable : 1;  // DWORD 0
               u32 ctx_mem_error1_ue_enable : 1;  // DWORD 0
               u32 ctx_mem_error0_ue_enable : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_UE_ENABLE_CSR, *PCTX_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__CTX_UE_ENABLE_CSR, sizeof (CTX_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _CTX_UE_ENABLE_CSR {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 ctx_mem_error2_ue_enable : 1;        // DWORD 0
         u32 ctx_mem_error1_ue_enable : 1;        // DWORD 0
         u32 ctx_mem_error0_ue_enable : 1;        // DWORD 0
      } SG_PACK CTX_UE_ENABLE_CSR, *PCTX_UE_ENABLE_CSR;

      typedef union _CTX_UE_ENABLE_CSR_UNION {
         CTX_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_UE_ENABLE_CSR_UNION, *PCTX_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_UE_ENABLE_CSR_UNION, sizeof (CTX_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // CTX Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_UE_ENABLE_CSR {
         union {
            struct { 
               u32 ctx_mem_error0_ue_enable : 1;  // DWORD 0
               u32 ctx_mem_error1_ue_enable : 1;  // DWORD 0
               u32 ctx_mem_error2_ue_enable : 1;  // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_UE_ENABLE_CSR, *PCTX_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__CTX_UE_ENABLE_CSR, sizeof (CTX_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _CTX_UE_ENABLE_CSR {
         u32 ctx_mem_error0_ue_enable : 1;        // DWORD 0
         u32 ctx_mem_error1_ue_enable : 1;        // DWORD 0
         u32 ctx_mem_error2_ue_enable : 1;        // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK CTX_UE_ENABLE_CSR, *PCTX_UE_ENABLE_CSR;

      typedef union _CTX_UE_ENABLE_CSR_UNION {
         CTX_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_UE_ENABLE_CSR_UNION, *PCTX_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_UE_ENABLE_CSR_UNION, sizeof (CTX_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Weighted Arbitration control
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 weight1 : 16;                  // DWORD 0
               u32 weight0 : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_WRR_ENTRY_CSR, *PCTX_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__CTX_WRR_ENTRY_CSR, sizeof (CTX_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _CTX_WRR_ENTRY_CSR {
         u32 weight1 : 16;                        // DWORD 0
         u32 weight0 : 16;                        // DWORD 0
      } SG_PACK CTX_WRR_ENTRY_CSR, *PCTX_WRR_ENTRY_CSR;

      typedef union _CTX_WRR_ENTRY_CSR_UNION {
         CTX_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_WRR_ENTRY_CSR_UNION, *PCTX_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_WRR_ENTRY_CSR_UNION, sizeof (CTX_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#else
   // Weighted Arbitration control
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_WRR_ENTRY_CSR {
         union {
            struct { 
               u32 weight0 : 16;                  // DWORD 0
               u32 weight1 : 16;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_WRR_ENTRY_CSR, *PCTX_WRR_ENTRY_CSR;

      SG_C_ASSERT(__sizeof__CTX_WRR_ENTRY_CSR, sizeof (CTX_WRR_ENTRY_CSR) == 4);

   #else
      typedef struct _CTX_WRR_ENTRY_CSR {
         u32 weight0 : 16;                        // DWORD 0
         u32 weight1 : 16;                        // DWORD 0
      } SG_PACK CTX_WRR_ENTRY_CSR, *PCTX_WRR_ENTRY_CSR;

      typedef union _CTX_WRR_ENTRY_CSR_UNION {
         CTX_WRR_ENTRY_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_WRR_ENTRY_CSR_UNION, *PCTX_WRR_ENTRY_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_WRR_ENTRY_CSR_UNION, sizeof (CTX_WRR_ENTRY_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // CTX debug register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DEBUG_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 client_id : 5;                 // DWORD 0
               u32 mem_error : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_DEBUG_CSR, *PCTX_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__CTX_DEBUG_CSR, sizeof (CTX_DEBUG_CSR) == 4);

   #else
      typedef struct _CTX_DEBUG_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 client_id : 5;                       // DWORD 0
         u32 mem_error : 1;                       // DWORD 0
      } SG_PACK CTX_DEBUG_CSR, *PCTX_DEBUG_CSR;

      typedef union _CTX_DEBUG_CSR_UNION {
         CTX_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_DEBUG_CSR_UNION, *PCTX_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_DEBUG_CSR_UNION, sizeof (CTX_DEBUG_CSR_UNION) == 4);
   #endif


#else
   // CTX debug register
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_DEBUG_CSR {
         union {
            struct { 
               u32 mem_error : 1;                 // DWORD 0
               u32 client_id : 5;                 // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CTX_DEBUG_CSR, *PCTX_DEBUG_CSR;

      SG_C_ASSERT(__sizeof__CTX_DEBUG_CSR, sizeof (CTX_DEBUG_CSR) == 4);

   #else
      typedef struct _CTX_DEBUG_CSR {
         u32 mem_error : 1;                       // DWORD 0
         u32 client_id : 5;                       // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK CTX_DEBUG_CSR, *PCTX_DEBUG_CSR;

      typedef union _CTX_DEBUG_CSR_UNION {
         CTX_DEBUG_CSR bits;
         u32 dw; // dword union
      } SG_PACK CTX_DEBUG_CSR_UNION, *PCTX_DEBUG_CSR_UNION;

      SG_C_ASSERT(__sizeof__CTX_DEBUG_CSR_UNION, sizeof (CTX_DEBUG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allows windowed read/write access to context memory, as well as general control and
   // debug capabilities. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_CSRMAP {
         union {
            struct { 
               CTX_ADDR_CSR ctxaddr;
               u32 rsvd0[1];                      // DWORDS 1 to 1
               CTX_CMD_CSR ctxcmd;
               u32 rsvd1[1];                      // DWORDS 3 to 3
               CTX_DATA_CSR ctxdata0;
               u32 rsvd2[1];                      // DWORDS 5 to 5
               CTX_DATA_CSR ctxdata1;
               u32 rsvd3[1];                      // DWORDS 7 to 7
               CTX_DATA_CSR ctxdata2;
               u32 rsvd4[1];                      // DWORDS 9 to 9
               CTX_DATA_CSR ctxdata3;
               u32 rsvd5[1];                      // DWORDS 11 to 11
               CTX_UE_SOURCE_CSR ue_source;
               CTX_UE_ENABLE_CSR ue_enable;
               CTX_WRR_ENTRY_CSR wrr_rdma_wdma;
               CTX_WRR_ENTRY_CSR wrr_rxulp1_rxulp0;
               CTX_WRR_ENTRY_CSR wrr_tpre_rxulp2;
               CTX_WRR_ENTRY_CSR wrr_txulp1_txulp0;
               CTX_WRR_ENTRY_CSR wrr_tpost_etx;
               CTX_WRR_ENTRY_CSR wrr_ndma_tx;
               CTX_WRR_ENTRY_CSR wrr_erx_uc;
               CTX_WRR_ENTRY_CSR wrr_mpu_ptc;
               CTX_WRR_ENTRY_CSR wrr_cev_txulp2;
               CTX_WRR_ENTRY_CSR wrr_rru;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd6[229];                    // DWORDS 27 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK CTX_CSRMAP, *PCTX_CSRMAP;

      SG_C_ASSERT(__sizeof__CTX_CSRMAP, sizeof (CTX_CSRMAP) == 1024);

   #else
      typedef struct _CTX_CSRMAP {
         CTX_ADDR_CSR ctxaddr;
         u32 rsvd0[1];                            // DWORDS 1 to 1
         CTX_CMD_CSR ctxcmd;
         u32 rsvd1[1];                            // DWORDS 3 to 3
         CTX_DATA_CSR ctxdata0;
         u32 rsvd2[1];                            // DWORDS 5 to 5
         CTX_DATA_CSR ctxdata1;
         u32 rsvd3[1];                            // DWORDS 7 to 7
         CTX_DATA_CSR ctxdata2;
         u32 rsvd4[1];                            // DWORDS 9 to 9
         CTX_DATA_CSR ctxdata3;
         u32 rsvd5[1];                            // DWORDS 11 to 11
         CTX_UE_SOURCE_CSR ue_source;
         CTX_UE_ENABLE_CSR ue_enable;
         CTX_WRR_ENTRY_CSR wrr_rdma_wdma;
         CTX_WRR_ENTRY_CSR wrr_rxulp1_rxulp0;
         CTX_WRR_ENTRY_CSR wrr_tpre_rxulp2;
         CTX_WRR_ENTRY_CSR wrr_txulp1_txulp0;
         CTX_WRR_ENTRY_CSR wrr_tpost_etx;
         CTX_WRR_ENTRY_CSR wrr_ndma_tx;
         CTX_WRR_ENTRY_CSR wrr_erx_uc;
         CTX_WRR_ENTRY_CSR wrr_mpu_ptc;
         CTX_WRR_ENTRY_CSR wrr_cev_txulp2;
         CTX_WRR_ENTRY_CSR wrr_rru;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd6[229];                          // DWORDS 27 to 255
      } SG_PACK CTX_CSRMAP, *PCTX_CSRMAP;

      typedef union _CTX_CSRMAP_UNION {
         CTX_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK CTX_CSRMAP_UNION, *PCTX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__CTX_CSRMAP_UNION, sizeof (CTX_CSRMAP_UNION) == 1024);
   #endif


#else
   // Allows windowed read/write access to context memory, as well as general control and
   // debug capabilities. 
   #if defined(SG_BMAP_UNION)
      typedef struct _CTX_CSRMAP {
         union {
            struct { 
               CTX_ADDR_CSR ctxaddr;
               u32 rsvd0[1];                      // DWORDS 1 to 1
               CTX_CMD_CSR ctxcmd;
               u32 rsvd1[1];                      // DWORDS 3 to 3
               CTX_DATA_CSR ctxdata0;
               u32 rsvd2[1];                      // DWORDS 5 to 5
               CTX_DATA_CSR ctxdata1;
               u32 rsvd3[1];                      // DWORDS 7 to 7
               CTX_DATA_CSR ctxdata2;
               u32 rsvd4[1];                      // DWORDS 9 to 9
               CTX_DATA_CSR ctxdata3;
               u32 rsvd5[1];                      // DWORDS 11 to 11
               CTX_UE_SOURCE_CSR ue_source;
               CTX_UE_ENABLE_CSR ue_enable;
               CTX_WRR_ENTRY_CSR wrr_rdma_wdma;
               CTX_WRR_ENTRY_CSR wrr_rxulp1_rxulp0;
               CTX_WRR_ENTRY_CSR wrr_tpre_rxulp2;
               CTX_WRR_ENTRY_CSR wrr_txulp1_txulp0;
               CTX_WRR_ENTRY_CSR wrr_tpost_etx;
               CTX_WRR_ENTRY_CSR wrr_ndma_tx;
               CTX_WRR_ENTRY_CSR wrr_erx_uc;
               CTX_WRR_ENTRY_CSR wrr_mpu_ptc;
               CTX_WRR_ENTRY_CSR wrr_cev_txulp2;
               CTX_WRR_ENTRY_CSR wrr_rru;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd6[229];                    // DWORDS 27 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK CTX_CSRMAP, *PCTX_CSRMAP;

      SG_C_ASSERT(__sizeof__CTX_CSRMAP, sizeof (CTX_CSRMAP) == 1024);

   #else
      typedef struct _CTX_CSRMAP {
         CTX_ADDR_CSR ctxaddr;
         u32 rsvd0[1];                            // DWORDS 1 to 1
         CTX_CMD_CSR ctxcmd;
         u32 rsvd1[1];                            // DWORDS 3 to 3
         CTX_DATA_CSR ctxdata0;
         u32 rsvd2[1];                            // DWORDS 5 to 5
         CTX_DATA_CSR ctxdata1;
         u32 rsvd3[1];                            // DWORDS 7 to 7
         CTX_DATA_CSR ctxdata2;
         u32 rsvd4[1];                            // DWORDS 9 to 9
         CTX_DATA_CSR ctxdata3;
         u32 rsvd5[1];                            // DWORDS 11 to 11
         CTX_UE_SOURCE_CSR ue_source;
         CTX_UE_ENABLE_CSR ue_enable;
         CTX_WRR_ENTRY_CSR wrr_rdma_wdma;
         CTX_WRR_ENTRY_CSR wrr_rxulp1_rxulp0;
         CTX_WRR_ENTRY_CSR wrr_tpre_rxulp2;
         CTX_WRR_ENTRY_CSR wrr_txulp1_txulp0;
         CTX_WRR_ENTRY_CSR wrr_tpost_etx;
         CTX_WRR_ENTRY_CSR wrr_ndma_tx;
         CTX_WRR_ENTRY_CSR wrr_erx_uc;
         CTX_WRR_ENTRY_CSR wrr_mpu_ptc;
         CTX_WRR_ENTRY_CSR wrr_cev_txulp2;
         CTX_WRR_ENTRY_CSR wrr_rru;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd6[229];                          // DWORDS 27 to 255
      } SG_PACK CTX_CSRMAP, *PCTX_CSRMAP;

      typedef union _CTX_CSRMAP_UNION {
         CTX_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK CTX_CSRMAP_UNION, *PCTX_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__CTX_CSRMAP_UNION, sizeof (CTX_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ctx_bmap_h__

