/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __d2p_bmap_h__
#define __d2p_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "reg_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Control for D2P.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CONTROL0 {
         union {
            struct { 
               u32 d2p_cm_pdid_vld_mask : 16;     // DWORD 0
               u32 d2p_cm_pdid_mask : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_CONTROL0, *PD2P_CONTROL0;

      SG_C_ASSERT(__sizeof__D2P_CONTROL0, sizeof (D2P_CONTROL0) == 4);

   #else
      typedef struct _D2P_CONTROL0 {
         u32 d2p_cm_pdid_vld_mask : 16;           // DWORD 0
         u32 d2p_cm_pdid_mask : 16;               // DWORD 0
      } SG_PACK D2P_CONTROL0, *PD2P_CONTROL0;

      typedef union _D2P_CONTROL0_UNION {
         D2P_CONTROL0 bits;
         u32 dw; // dword union
      } SG_PACK D2P_CONTROL0_UNION, *PD2P_CONTROL0_UNION;

      SG_C_ASSERT(__sizeof__D2P_CONTROL0_UNION, sizeof (D2P_CONTROL0_UNION) == 4);
   #endif


#else
   // Control for D2P.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CONTROL0 {
         union {
            struct { 
               u32 d2p_cm_pdid_mask : 16;         // DWORD 0
               u32 d2p_cm_pdid_vld_mask : 16;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_CONTROL0, *PD2P_CONTROL0;

      SG_C_ASSERT(__sizeof__D2P_CONTROL0, sizeof (D2P_CONTROL0) == 4);

   #else
      typedef struct _D2P_CONTROL0 {
         u32 d2p_cm_pdid_mask : 16;               // DWORD 0
         u32 d2p_cm_pdid_vld_mask : 16;           // DWORD 0
      } SG_PACK D2P_CONTROL0, *PD2P_CONTROL0;

      typedef union _D2P_CONTROL0_UNION {
         D2P_CONTROL0 bits;
         u32 dw; // dword union
      } SG_PACK D2P_CONTROL0_UNION, *PD2P_CONTROL0_UNION;

      SG_C_ASSERT(__sizeof__D2P_CONTROL0_UNION, sizeof (D2P_CONTROL0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control for D2P.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CONTROL1 {
         union {
            struct { 
               u32 rsvd0 : 14;                    // DWORD 0
               u32 d2p_tedealloc_prefetch : 1;    // DWORD 0
               u32 d2p_pedealloc_prefetch : 1;    // DWORD 0
               u32 d2p_tealloc_prefetch : 1;      // DWORD 0
               u32 d2p_pealloc_prefetch : 1;      // DWORD 0
               u32 d2p_tedealloc_vl : 2;          // DWORD 0
               u32 d2p_pedealloc_vl : 2;          // DWORD 0
               u32 d2p_tealloc_vl : 2;            // DWORD 0
               u32 d2p_pealloc_vl : 2;            // DWORD 0
               u32 d2p_pedealloc_disable : 1;     // DWORD 0
               u32 d2p_pecheck_local_write_rights : 1; // DWORD 0
               u32 d2p_pecheck_local_read_rights : 1; // DWORD 0
               u32 d2p_pecheck_ignore_physbit : 1; // DWORD 0
               u32 d2p_cmcheck_pdid0_is_not_phys : 1; // DWORD 0
               u32 d2p_cmcheck_ctxaddr_is_pdid : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_CONTROL1, *PD2P_CONTROL1;

      SG_C_ASSERT(__sizeof__D2P_CONTROL1, sizeof (D2P_CONTROL1) == 4);

   #else
      typedef struct _D2P_CONTROL1 {
         u32 rsvd0 : 14;                          // DWORD 0
         u32 d2p_tedealloc_prefetch : 1;          // DWORD 0
         u32 d2p_pedealloc_prefetch : 1;          // DWORD 0
         u32 d2p_tealloc_prefetch : 1;            // DWORD 0
         u32 d2p_pealloc_prefetch : 1;            // DWORD 0
         u32 d2p_tedealloc_vl : 2;                // DWORD 0
         u32 d2p_pedealloc_vl : 2;                // DWORD 0
         u32 d2p_tealloc_vl : 2;                  // DWORD 0
         u32 d2p_pealloc_vl : 2;                  // DWORD 0
         u32 d2p_pedealloc_disable : 1;           // DWORD 0
         u32 d2p_pecheck_local_write_rights : 1;  // DWORD 0
         u32 d2p_pecheck_local_read_rights : 1;   // DWORD 0
         u32 d2p_pecheck_ignore_physbit : 1;      // DWORD 0
         u32 d2p_cmcheck_pdid0_is_not_phys : 1;   // DWORD 0
         u32 d2p_cmcheck_ctxaddr_is_pdid : 1;     // DWORD 0
      } SG_PACK D2P_CONTROL1, *PD2P_CONTROL1;

      typedef union _D2P_CONTROL1_UNION {
         D2P_CONTROL1 bits;
         u32 dw; // dword union
      } SG_PACK D2P_CONTROL1_UNION, *PD2P_CONTROL1_UNION;

      SG_C_ASSERT(__sizeof__D2P_CONTROL1_UNION, sizeof (D2P_CONTROL1_UNION) == 4);
   #endif


#else
   // Control for D2P.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CONTROL1 {
         union {
            struct { 
               u32 d2p_cmcheck_ctxaddr_is_pdid : 1; // DWORD 0
               u32 d2p_cmcheck_pdid0_is_not_phys : 1; // DWORD 0
               u32 d2p_pecheck_ignore_physbit : 1; // DWORD 0
               u32 d2p_pecheck_local_read_rights : 1; // DWORD 0
               u32 d2p_pecheck_local_write_rights : 1; // DWORD 0
               u32 d2p_pedealloc_disable : 1;     // DWORD 0
               u32 d2p_pealloc_vl : 2;            // DWORD 0
               u32 d2p_tealloc_vl : 2;            // DWORD 0
               u32 d2p_pedealloc_vl : 2;          // DWORD 0
               u32 d2p_tedealloc_vl : 2;          // DWORD 0
               u32 d2p_pealloc_prefetch : 1;      // DWORD 0
               u32 d2p_tealloc_prefetch : 1;      // DWORD 0
               u32 d2p_pedealloc_prefetch : 1;    // DWORD 0
               u32 d2p_tedealloc_prefetch : 1;    // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_CONTROL1, *PD2P_CONTROL1;

      SG_C_ASSERT(__sizeof__D2P_CONTROL1, sizeof (D2P_CONTROL1) == 4);

   #else
      typedef struct _D2P_CONTROL1 {
         u32 d2p_cmcheck_ctxaddr_is_pdid : 1;     // DWORD 0
         u32 d2p_cmcheck_pdid0_is_not_phys : 1;   // DWORD 0
         u32 d2p_pecheck_ignore_physbit : 1;      // DWORD 0
         u32 d2p_pecheck_local_read_rights : 1;   // DWORD 0
         u32 d2p_pecheck_local_write_rights : 1;  // DWORD 0
         u32 d2p_pedealloc_disable : 1;           // DWORD 0
         u32 d2p_pealloc_vl : 2;                  // DWORD 0
         u32 d2p_tealloc_vl : 2;                  // DWORD 0
         u32 d2p_pedealloc_vl : 2;                // DWORD 0
         u32 d2p_tedealloc_vl : 2;                // DWORD 0
         u32 d2p_pealloc_prefetch : 1;            // DWORD 0
         u32 d2p_tealloc_prefetch : 1;            // DWORD 0
         u32 d2p_pedealloc_prefetch : 1;          // DWORD 0
         u32 d2p_tedealloc_prefetch : 1;          // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
      } SG_PACK D2P_CONTROL1, *PD2P_CONTROL1;

      typedef union _D2P_CONTROL1_UNION {
         D2P_CONTROL1 bits;
         u32 dw; // dword union
      } SG_PACK D2P_CONTROL1_UNION, *PD2P_CONTROL1_UNION;

      SG_C_ASSERT(__sizeof__D2P_CONTROL1_UNION, sizeof (D2P_CONTROL1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Disables Specific Error Checks in D2P. Also is excellent source of documentation for
   // err codes. Note that if CMCK fails, then no PECK nor TECK will be performed and
   // their results will be invalid. Similarly, if CMCK passes, but PECK fails, then TECK
   // will not be valid. Note too there may be multiple ways to disable a check.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_ERR_DISABLE {
         union {
            struct { 
               u32 d2p_tedealloc_stallarc : 4;    // DWORD 0
               u32 d2p_tealloc_stallarc : 4;      // DWORD 0
               u32 d2p_pedealloc_stallarc : 4;    // DWORD 0
               u32 d2p_pealloc_stallarc : 4;      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 d2p_err_teck_telower_are_all_zero_disable : 1; // DWORD 0
               u32 d2p_err_teck_frag_doesnt_cross_page_boundary_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagkey_eq_fragkey_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagindx_eq_fragindx_disable : 1; // DWORD 0
               u32 d2p_err_peck_has_memory_region_set_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_fragoff_pluslen_lt_cm_va_pluslen_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_fragoff_gte_cm_va_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_rights_valid_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagpdid_equals_cmpdid_disable : 1; // DWORD 0
               u32 d2p_err_peck_has_valid_bit_set_disable : 1; // DWORD 0
               u32 d2p_err_cmck_pdid_valid_disable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_ERR_DISABLE, *PD2P_ERR_DISABLE;

      SG_C_ASSERT(__sizeof__D2P_ERR_DISABLE, sizeof (D2P_ERR_DISABLE) == 4);

   #else
      typedef struct _D2P_ERR_DISABLE {
         u32 d2p_tedealloc_stallarc : 4;          // DWORD 0
         u32 d2p_tealloc_stallarc : 4;            // DWORD 0
         u32 d2p_pedealloc_stallarc : 4;          // DWORD 0
         u32 d2p_pealloc_stallarc : 4;            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 d2p_err_teck_telower_are_all_zero_disable : 1; // DWORD 0
         u32 d2p_err_teck_frag_doesnt_cross_page_boundary_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagkey_eq_fragkey_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagindx_eq_fragindx_disable : 1; // DWORD 0
         u32 d2p_err_peck_has_memory_region_set_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_fragoff_pluslen_lt_cm_va_pluslen_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_fragoff_gte_cm_va_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_rights_valid_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagpdid_equals_cmpdid_disable : 1; // DWORD 0
         u32 d2p_err_peck_has_valid_bit_set_disable : 1; // DWORD 0
         u32 d2p_err_cmck_pdid_valid_disable : 1; // DWORD 0
      } SG_PACK D2P_ERR_DISABLE, *PD2P_ERR_DISABLE;

      typedef union _D2P_ERR_DISABLE_UNION {
         D2P_ERR_DISABLE bits;
         u32 dw; // dword union
      } SG_PACK D2P_ERR_DISABLE_UNION, *PD2P_ERR_DISABLE_UNION;

      SG_C_ASSERT(__sizeof__D2P_ERR_DISABLE_UNION, sizeof (D2P_ERR_DISABLE_UNION) == 4);
   #endif


#else
   // Disables Specific Error Checks in D2P. Also is excellent source of documentation for
   // err codes. Note that if CMCK fails, then no PECK nor TECK will be performed and
   // their results will be invalid. Similarly, if CMCK passes, but PECK fails, then TECK
   // will not be valid. Note too there may be multiple ways to disable a check.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_ERR_DISABLE {
         union {
            struct { 
               u32 d2p_err_cmck_pdid_valid_disable : 1; // DWORD 0
               u32 d2p_err_peck_has_valid_bit_set_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagpdid_equals_cmpdid_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_rights_valid_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_fragoff_gte_cm_va_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_fragoff_pluslen_lt_cm_va_pluslen_disable : 1; // DWORD 0
               u32 d2p_err_peck_has_memory_region_set_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagindx_eq_fragindx_disable : 1; // DWORD 0
               u32 d2p_err_peck_cm_stagkey_eq_fragkey_disable : 1; // DWORD 0
               u32 d2p_err_teck_frag_doesnt_cross_page_boundary_disable : 1; // DWORD 0
               u32 d2p_err_teck_telower_are_all_zero_disable : 1; // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 d2p_pealloc_stallarc : 4;      // DWORD 0
               u32 d2p_pedealloc_stallarc : 4;    // DWORD 0
               u32 d2p_tealloc_stallarc : 4;      // DWORD 0
               u32 d2p_tedealloc_stallarc : 4;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_ERR_DISABLE, *PD2P_ERR_DISABLE;

      SG_C_ASSERT(__sizeof__D2P_ERR_DISABLE, sizeof (D2P_ERR_DISABLE) == 4);

   #else
      typedef struct _D2P_ERR_DISABLE {
         u32 d2p_err_cmck_pdid_valid_disable : 1; // DWORD 0
         u32 d2p_err_peck_has_valid_bit_set_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagpdid_equals_cmpdid_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_rights_valid_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_fragoff_gte_cm_va_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_fragoff_pluslen_lt_cm_va_pluslen_disable : 1; // DWORD 0
         u32 d2p_err_peck_has_memory_region_set_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagindx_eq_fragindx_disable : 1; // DWORD 0
         u32 d2p_err_peck_cm_stagkey_eq_fragkey_disable : 1; // DWORD 0
         u32 d2p_err_teck_frag_doesnt_cross_page_boundary_disable : 1; // DWORD 0
         u32 d2p_err_teck_telower_are_all_zero_disable : 1; // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 d2p_pealloc_stallarc : 4;            // DWORD 0
         u32 d2p_pedealloc_stallarc : 4;          // DWORD 0
         u32 d2p_tealloc_stallarc : 4;            // DWORD 0
         u32 d2p_tedealloc_stallarc : 4;          // DWORD 0
      } SG_PACK D2P_ERR_DISABLE, *PD2P_ERR_DISABLE;

      typedef union _D2P_ERR_DISABLE_UNION {
         D2P_ERR_DISABLE bits;
         u32 dw; // dword union
      } SG_PACK D2P_ERR_DISABLE_UNION, *PD2P_ERR_DISABLE_UNION;

      SG_C_ASSERT(__sizeof__D2P_ERR_DISABLE_UNION, sizeof (D2P_ERR_DISABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of D2P. If read is all zero, then SM is in idle with no error cases. A write
   // to this location clears all overflow/underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_DEBUG0 {
         union {
            struct { 
               u32 techeck_ucdealloc_state : 2;   // DWORD 0
               u32 pecheck_ucdealloc_state : 2;   // DWORD 0
               u32 techeck_ucalloc_state : 2;     // DWORD 0
               u32 techeck_cmfetch_state : 3;     // DWORD 0
               u32 pecheck_cmfetch_state : 3;     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 cmcheck_cmfetch_state : 3;     // DWORD 0
               u32 pecheck_ucalloc_state : 2;     // DWORD 0
               u32 techeck_fifo2_underflow : 1;   // DWORD 0
               u32 techeck_fifo2_overflow : 1;    // DWORD 0
               u32 techeck_fifo1_underflow : 1;   // DWORD 0
               u32 techeck_fifo1_overflow : 1;    // DWORD 0
               u32 techeck_fifo0_underflow : 1;   // DWORD 0
               u32 techeck_fifo0_overflow : 1;    // DWORD 0
               u32 pecheck_fifo2_underflow : 1;   // DWORD 0
               u32 pecheck_fifo2_overflow : 1;    // DWORD 0
               u32 pecheck_fifo1_underflow : 1;   // DWORD 0
               u32 pecheck_fifo1_overflow : 1;    // DWORD 0
               u32 pecheck_fifo0_underflow : 1;   // DWORD 0
               u32 pecheck_fifo0_overflow : 1;    // DWORD 0
               u32 cmcheck_fifo0_underflow : 1;   // DWORD 0
               u32 cmcheck_fifo0_overflow : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_DEBUG0, *PD2P_DEBUG0;

      SG_C_ASSERT(__sizeof__D2P_DEBUG0, sizeof (D2P_DEBUG0) == 4);

   #else
      typedef struct _D2P_DEBUG0 {
         u32 techeck_ucdealloc_state : 2;         // DWORD 0
         u32 pecheck_ucdealloc_state : 2;         // DWORD 0
         u32 techeck_ucalloc_state : 2;           // DWORD 0
         u32 techeck_cmfetch_state : 3;           // DWORD 0
         u32 pecheck_cmfetch_state : 3;           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 cmcheck_cmfetch_state : 3;           // DWORD 0
         u32 pecheck_ucalloc_state : 2;           // DWORD 0
         u32 techeck_fifo2_underflow : 1;         // DWORD 0
         u32 techeck_fifo2_overflow : 1;          // DWORD 0
         u32 techeck_fifo1_underflow : 1;         // DWORD 0
         u32 techeck_fifo1_overflow : 1;          // DWORD 0
         u32 techeck_fifo0_underflow : 1;         // DWORD 0
         u32 techeck_fifo0_overflow : 1;          // DWORD 0
         u32 pecheck_fifo2_underflow : 1;         // DWORD 0
         u32 pecheck_fifo2_overflow : 1;          // DWORD 0
         u32 pecheck_fifo1_underflow : 1;         // DWORD 0
         u32 pecheck_fifo1_overflow : 1;          // DWORD 0
         u32 pecheck_fifo0_underflow : 1;         // DWORD 0
         u32 pecheck_fifo0_overflow : 1;          // DWORD 0
         u32 cmcheck_fifo0_underflow : 1;         // DWORD 0
         u32 cmcheck_fifo0_overflow : 1;          // DWORD 0
      } SG_PACK D2P_DEBUG0, *PD2P_DEBUG0;

      typedef union _D2P_DEBUG0_UNION {
         D2P_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK D2P_DEBUG0_UNION, *PD2P_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__D2P_DEBUG0_UNION, sizeof (D2P_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of D2P. If read is all zero, then SM is in idle with no error cases. A write
   // to this location clears all overflow/underflow indications.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_DEBUG0 {
         union {
            struct { 
               u32 cmcheck_fifo0_overflow : 1;    // DWORD 0
               u32 cmcheck_fifo0_underflow : 1;   // DWORD 0
               u32 pecheck_fifo0_overflow : 1;    // DWORD 0
               u32 pecheck_fifo0_underflow : 1;   // DWORD 0
               u32 pecheck_fifo1_overflow : 1;    // DWORD 0
               u32 pecheck_fifo1_underflow : 1;   // DWORD 0
               u32 pecheck_fifo2_overflow : 1;    // DWORD 0
               u32 pecheck_fifo2_underflow : 1;   // DWORD 0
               u32 techeck_fifo0_overflow : 1;    // DWORD 0
               u32 techeck_fifo0_underflow : 1;   // DWORD 0
               u32 techeck_fifo1_overflow : 1;    // DWORD 0
               u32 techeck_fifo1_underflow : 1;   // DWORD 0
               u32 techeck_fifo2_overflow : 1;    // DWORD 0
               u32 techeck_fifo2_underflow : 1;   // DWORD 0
               u32 pecheck_ucalloc_state : 2;     // DWORD 0
               u32 cmcheck_cmfetch_state : 3;     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 pecheck_cmfetch_state : 3;     // DWORD 0
               u32 techeck_cmfetch_state : 3;     // DWORD 0
               u32 techeck_ucalloc_state : 2;     // DWORD 0
               u32 pecheck_ucdealloc_state : 2;   // DWORD 0
               u32 techeck_ucdealloc_state : 2;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_DEBUG0, *PD2P_DEBUG0;

      SG_C_ASSERT(__sizeof__D2P_DEBUG0, sizeof (D2P_DEBUG0) == 4);

   #else
      typedef struct _D2P_DEBUG0 {
         u32 cmcheck_fifo0_overflow : 1;          // DWORD 0
         u32 cmcheck_fifo0_underflow : 1;         // DWORD 0
         u32 pecheck_fifo0_overflow : 1;          // DWORD 0
         u32 pecheck_fifo0_underflow : 1;         // DWORD 0
         u32 pecheck_fifo1_overflow : 1;          // DWORD 0
         u32 pecheck_fifo1_underflow : 1;         // DWORD 0
         u32 pecheck_fifo2_overflow : 1;          // DWORD 0
         u32 pecheck_fifo2_underflow : 1;         // DWORD 0
         u32 techeck_fifo0_overflow : 1;          // DWORD 0
         u32 techeck_fifo0_underflow : 1;         // DWORD 0
         u32 techeck_fifo1_overflow : 1;          // DWORD 0
         u32 techeck_fifo1_underflow : 1;         // DWORD 0
         u32 techeck_fifo2_overflow : 1;          // DWORD 0
         u32 techeck_fifo2_underflow : 1;         // DWORD 0
         u32 pecheck_ucalloc_state : 2;           // DWORD 0
         u32 cmcheck_cmfetch_state : 3;           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 pecheck_cmfetch_state : 3;           // DWORD 0
         u32 techeck_cmfetch_state : 3;           // DWORD 0
         u32 techeck_ucalloc_state : 2;           // DWORD 0
         u32 pecheck_ucdealloc_state : 2;         // DWORD 0
         u32 techeck_ucdealloc_state : 2;         // DWORD 0
      } SG_PACK D2P_DEBUG0, *PD2P_DEBUG0;

      typedef union _D2P_DEBUG0_UNION {
         D2P_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK D2P_DEBUG0_UNION, *PD2P_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__D2P_DEBUG0_UNION, sizeof (D2P_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of D2P. Gives information on current values in FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_DEBUG1 {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 techeck_fifo2_numfifo : 4;     // DWORD 0
               u32 techeck_fifo1_numfifo : 4;     // DWORD 0
               u32 techeck_fifo0_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo2_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo1_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo0_numfifo : 4;     // DWORD 0
               u32 cmcheck_fifo0_numfifo : 4;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_DEBUG1, *PD2P_DEBUG1;

      SG_C_ASSERT(__sizeof__D2P_DEBUG1, sizeof (D2P_DEBUG1) == 4);

   #else
      typedef struct _D2P_DEBUG1 {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 techeck_fifo2_numfifo : 4;           // DWORD 0
         u32 techeck_fifo1_numfifo : 4;           // DWORD 0
         u32 techeck_fifo0_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo2_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo1_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo0_numfifo : 4;           // DWORD 0
         u32 cmcheck_fifo0_numfifo : 4;           // DWORD 0
      } SG_PACK D2P_DEBUG1, *PD2P_DEBUG1;

      typedef union _D2P_DEBUG1_UNION {
         D2P_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK D2P_DEBUG1_UNION, *PD2P_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__D2P_DEBUG1_UNION, sizeof (D2P_DEBUG1_UNION) == 4);
   #endif


#else
   // Debug of D2P. Gives information on current values in FIFOs.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_DEBUG1 {
         union {
            struct { 
               u32 cmcheck_fifo0_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo0_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo1_numfifo : 4;     // DWORD 0
               u32 pecheck_fifo2_numfifo : 4;     // DWORD 0
               u32 techeck_fifo0_numfifo : 4;     // DWORD 0
               u32 techeck_fifo1_numfifo : 4;     // DWORD 0
               u32 techeck_fifo2_numfifo : 4;     // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK D2P_DEBUG1, *PD2P_DEBUG1;

      SG_C_ASSERT(__sizeof__D2P_DEBUG1, sizeof (D2P_DEBUG1) == 4);

   #else
      typedef struct _D2P_DEBUG1 {
         u32 cmcheck_fifo0_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo0_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo1_numfifo : 4;           // DWORD 0
         u32 pecheck_fifo2_numfifo : 4;           // DWORD 0
         u32 techeck_fifo0_numfifo : 4;           // DWORD 0
         u32 techeck_fifo1_numfifo : 4;           // DWORD 0
         u32 techeck_fifo2_numfifo : 4;           // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK D2P_DEBUG1, *PD2P_DEBUG1;

      typedef union _D2P_DEBUG1_UNION {
         D2P_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK D2P_DEBUG1_UNION, *PD2P_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__D2P_DEBUG1_UNION, sizeof (D2P_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // D2P module control CSRs.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CSRMAP {
         union {
            struct { 
               D2P_CONTROL0 d2p_control0;
               D2P_CONTROL1 d2p_control1;
               D2P_ERR_DISABLE d2p_err_disable;
               D2P_DEBUG0 d2p_debug0;
               D2P_DEBUG1 d2p_debug1;
               u32 rsvd0[3];                      // DWORDS 5 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK D2P_CSRMAP, *PD2P_CSRMAP;

      SG_C_ASSERT(__sizeof__D2P_CSRMAP, sizeof (D2P_CSRMAP) == 32);

   #else
      typedef struct _D2P_CSRMAP {
         D2P_CONTROL0 d2p_control0;
         D2P_CONTROL1 d2p_control1;
         D2P_ERR_DISABLE d2p_err_disable;
         D2P_DEBUG0 d2p_debug0;
         D2P_DEBUG1 d2p_debug1;
         u32 rsvd0[3];                            // DWORDS 5 to 7
      } SG_PACK D2P_CSRMAP, *PD2P_CSRMAP;

      typedef union _D2P_CSRMAP_UNION {
         D2P_CSRMAP bits;
         u32 dw[8]; // dword union
      } SG_PACK D2P_CSRMAP_UNION, *PD2P_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__D2P_CSRMAP_UNION, sizeof (D2P_CSRMAP_UNION) == 32);
   #endif


#else
   // D2P module control CSRs.
   #if defined(SG_BMAP_UNION)
      typedef struct _D2P_CSRMAP {
         union {
            struct { 
               D2P_CONTROL0 d2p_control0;
               D2P_CONTROL1 d2p_control1;
               D2P_ERR_DISABLE d2p_err_disable;
               D2P_DEBUG0 d2p_debug0;
               D2P_DEBUG1 d2p_debug1;
               u32 rsvd0[3];                      // DWORDS 5 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK D2P_CSRMAP, *PD2P_CSRMAP;

      SG_C_ASSERT(__sizeof__D2P_CSRMAP, sizeof (D2P_CSRMAP) == 32);

   #else
      typedef struct _D2P_CSRMAP {
         D2P_CONTROL0 d2p_control0;
         D2P_CONTROL1 d2p_control1;
         D2P_ERR_DISABLE d2p_err_disable;
         D2P_DEBUG0 d2p_debug0;
         D2P_DEBUG1 d2p_debug1;
         u32 rsvd0[3];                            // DWORDS 5 to 7
      } SG_PACK D2P_CSRMAP, *PD2P_CSRMAP;

      typedef union _D2P_CSRMAP_UNION {
         D2P_CSRMAP bits;
         u32 dw[8]; // dword union
      } SG_PACK D2P_CSRMAP_UNION, *PD2P_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__D2P_CSRMAP_UNION, sizeof (D2P_CSRMAP_UNION) == 32);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __d2p_bmap_h__

