/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __dalrx_exp_bmap_h__
#define __dalrx_exp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DALRX_STATS {
         union {
            struct { 
               u32 drops;                         // DWORD 0
               u32 drops_no_receive_bufs;         // DWORD 1
               u32 drops_excess_seg_length;       // DWORD 2
               u32 drops_invalid_pdid;            // DWORD 3
               u32 drops_no_protection_entry;     // DWORD 4
               u32 drops_seg_length_exceeds_mr;   // DWORD 5
               u32 packets_indicated;             // DWORD 6
               u32 disable_ring_protection_errors; // DWORD 7
               u32 wcon_d_count;                  // DWORD 8
               u32 wcon_d0_count;                 // DWORD 9
               u32 db_inv_pdid;                   // DWORD 10
               u32 reached_uc_limit;              // DWORD 11
               u32 spurious_db_count;             // DWORD 12
               u32 uc_imm_req;                    // DWORD 13
               u32 protection_faults;             // DWORD 14
               u32 bad_uc_resp_wrb;               // DWORD 15
               u32 bad_uc_resp_pe;                // DWORD 16
               u32 pe_fetched_on_uploaded_qp;     // DWORD 17
               u32 invalid_pe_fetched;            // DWORD 18
               u32 pe_fetch_req;                  // DWORD 19
               u32 flush_tpred;                   // DWORD 20
               u32 tpred_after_flush;             // DWORD 21
               u32 dbg1;                          // DWORD 22
               u32 dbg2;                          // DWORD 23
               u32 dbg3;                          // DWORD 24
               u32 rsvd0[231];                    // DWORDS 25 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DALRX_STATS, *PBE_DALRX_STATS;

      SG_C_ASSERT(__sizeof__BE_DALRX_STATS, sizeof (BE_DALRX_STATS) == 1024);

   #else
      typedef struct _BE_DALRX_STATS {
         u32 drops;                               // DWORD 0
         u32 drops_no_receive_bufs;               // DWORD 1
         u32 drops_excess_seg_length;             // DWORD 2
         u32 drops_invalid_pdid;                  // DWORD 3
         u32 drops_no_protection_entry;           // DWORD 4
         u32 drops_seg_length_exceeds_mr;         // DWORD 5
         u32 packets_indicated;                   // DWORD 6
         u32 disable_ring_protection_errors;      // DWORD 7
         u32 wcon_d_count;                        // DWORD 8
         u32 wcon_d0_count;                       // DWORD 9
         u32 db_inv_pdid;                         // DWORD 10
         u32 reached_uc_limit;                    // DWORD 11
         u32 spurious_db_count;                   // DWORD 12
         u32 uc_imm_req;                          // DWORD 13
         u32 protection_faults;                   // DWORD 14
         u32 bad_uc_resp_wrb;                     // DWORD 15
         u32 bad_uc_resp_pe;                      // DWORD 16
         u32 pe_fetched_on_uploaded_qp;           // DWORD 17
         u32 invalid_pe_fetched;                  // DWORD 18
         u32 pe_fetch_req;                        // DWORD 19
         u32 flush_tpred;                         // DWORD 20
         u32 tpred_after_flush;                   // DWORD 21
         u32 dbg1;                                // DWORD 22
         u32 dbg2;                                // DWORD 23
         u32 dbg3;                                // DWORD 24
         u32 rsvd0[231];                          // DWORDS 25 to 255
      } SG_PACK BE_DALRX_STATS, *PBE_DALRX_STATS;

      typedef union _BE_DALRX_STATS_UNION {
         BE_DALRX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DALRX_STATS_UNION, *PBE_DALRX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DALRX_STATS_UNION, sizeof (BE_DALRX_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DALRX_STATS {
         union {
            struct { 
               u32 drops;                         // DWORD 0
               u32 drops_no_receive_bufs;         // DWORD 1
               u32 drops_excess_seg_length;       // DWORD 2
               u32 drops_invalid_pdid;            // DWORD 3
               u32 drops_no_protection_entry;     // DWORD 4
               u32 drops_seg_length_exceeds_mr;   // DWORD 5
               u32 packets_indicated;             // DWORD 6
               u32 disable_ring_protection_errors; // DWORD 7
               u32 wcon_d_count;                  // DWORD 8
               u32 wcon_d0_count;                 // DWORD 9
               u32 db_inv_pdid;                   // DWORD 10
               u32 reached_uc_limit;              // DWORD 11
               u32 spurious_db_count;             // DWORD 12
               u32 uc_imm_req;                    // DWORD 13
               u32 protection_faults;             // DWORD 14
               u32 bad_uc_resp_wrb;               // DWORD 15
               u32 bad_uc_resp_pe;                // DWORD 16
               u32 pe_fetched_on_uploaded_qp;     // DWORD 17
               u32 invalid_pe_fetched;            // DWORD 18
               u32 pe_fetch_req;                  // DWORD 19
               u32 flush_tpred;                   // DWORD 20
               u32 tpred_after_flush;             // DWORD 21
               u32 dbg1;                          // DWORD 22
               u32 dbg2;                          // DWORD 23
               u32 dbg3;                          // DWORD 24
               u32 rsvd0[231];                    // DWORDS 25 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DALRX_STATS, *PBE_DALRX_STATS;

      SG_C_ASSERT(__sizeof__BE_DALRX_STATS, sizeof (BE_DALRX_STATS) == 1024);

   #else
      typedef struct _BE_DALRX_STATS {
         u32 drops;                               // DWORD 0
         u32 drops_no_receive_bufs;               // DWORD 1
         u32 drops_excess_seg_length;             // DWORD 2
         u32 drops_invalid_pdid;                  // DWORD 3
         u32 drops_no_protection_entry;           // DWORD 4
         u32 drops_seg_length_exceeds_mr;         // DWORD 5
         u32 packets_indicated;                   // DWORD 6
         u32 disable_ring_protection_errors;      // DWORD 7
         u32 wcon_d_count;                        // DWORD 8
         u32 wcon_d0_count;                       // DWORD 9
         u32 db_inv_pdid;                         // DWORD 10
         u32 reached_uc_limit;                    // DWORD 11
         u32 spurious_db_count;                   // DWORD 12
         u32 uc_imm_req;                          // DWORD 13
         u32 protection_faults;                   // DWORD 14
         u32 bad_uc_resp_wrb;                     // DWORD 15
         u32 bad_uc_resp_pe;                      // DWORD 16
         u32 pe_fetched_on_uploaded_qp;           // DWORD 17
         u32 invalid_pe_fetched;                  // DWORD 18
         u32 pe_fetch_req;                        // DWORD 19
         u32 flush_tpred;                         // DWORD 20
         u32 tpred_after_flush;                   // DWORD 21
         u32 dbg1;                                // DWORD 22
         u32 dbg2;                                // DWORD 23
         u32 dbg3;                                // DWORD 24
         u32 rsvd0[231];                          // DWORDS 25 to 255
      } SG_PACK BE_DALRX_STATS, *PBE_DALRX_STATS;

      typedef union _BE_DALRX_STATS_UNION {
         BE_DALRX_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DALRX_STATS_UNION, *PBE_DALRX_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DALRX_STATS_UNION, sizeof (BE_DALRX_STATS_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DAL_TPRE_STATS {
         union {
            struct { 
               u32 wrong_queue;                   // DWORD 0
               u32 packets_rxulp;                 // DWORD 1
               u32 punted_packets;                // DWORD 2
               u32 punted_no_valid_qp;            // DWORD 3
               u32 punt_header_check_fail;        // DWORD 4
               u32 punt_non_offload_packet;       // DWORD 5
               u32 marble_messages;               // DWORD 6
               u32 dbg1;                          // DWORD 7
               u32 dbg2;                          // DWORD 8
               u32 dbg3;                          // DWORD 9
               u32 rsvd0[246];                    // DWORDS 10 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DAL_TPRE_STATS, *PBE_DAL_TPRE_STATS;

      SG_C_ASSERT(__sizeof__BE_DAL_TPRE_STATS, sizeof (BE_DAL_TPRE_STATS) == 1024);

   #else
      typedef struct _BE_DAL_TPRE_STATS {
         u32 wrong_queue;                         // DWORD 0
         u32 packets_rxulp;                       // DWORD 1
         u32 punted_packets;                      // DWORD 2
         u32 punted_no_valid_qp;                  // DWORD 3
         u32 punt_header_check_fail;              // DWORD 4
         u32 punt_non_offload_packet;             // DWORD 5
         u32 marble_messages;                     // DWORD 6
         u32 dbg1;                                // DWORD 7
         u32 dbg2;                                // DWORD 8
         u32 dbg3;                                // DWORD 9
         u32 rsvd0[246];                          // DWORDS 10 to 255
      } SG_PACK BE_DAL_TPRE_STATS, *PBE_DAL_TPRE_STATS;

      typedef union _BE_DAL_TPRE_STATS_UNION {
         BE_DAL_TPRE_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DAL_TPRE_STATS_UNION, *PBE_DAL_TPRE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DAL_TPRE_STATS_UNION, sizeof (BE_DAL_TPRE_STATS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DAL_TPRE_STATS {
         union {
            struct { 
               u32 wrong_queue;                   // DWORD 0
               u32 packets_rxulp;                 // DWORD 1
               u32 punted_packets;                // DWORD 2
               u32 punted_no_valid_qp;            // DWORD 3
               u32 punt_header_check_fail;        // DWORD 4
               u32 punt_non_offload_packet;       // DWORD 5
               u32 marble_messages;               // DWORD 6
               u32 dbg1;                          // DWORD 7
               u32 dbg2;                          // DWORD 8
               u32 dbg3;                          // DWORD 9
               u32 rsvd0[246];                    // DWORDS 10 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK BE_DAL_TPRE_STATS, *PBE_DAL_TPRE_STATS;

      SG_C_ASSERT(__sizeof__BE_DAL_TPRE_STATS, sizeof (BE_DAL_TPRE_STATS) == 1024);

   #else
      typedef struct _BE_DAL_TPRE_STATS {
         u32 wrong_queue;                         // DWORD 0
         u32 packets_rxulp;                       // DWORD 1
         u32 punted_packets;                      // DWORD 2
         u32 punted_no_valid_qp;                  // DWORD 3
         u32 punt_header_check_fail;              // DWORD 4
         u32 punt_non_offload_packet;             // DWORD 5
         u32 marble_messages;                     // DWORD 6
         u32 dbg1;                                // DWORD 7
         u32 dbg2;                                // DWORD 8
         u32 dbg3;                                // DWORD 9
         u32 rsvd0[246];                          // DWORDS 10 to 255
      } SG_PACK BE_DAL_TPRE_STATS, *PBE_DAL_TPRE_STATS;

      typedef union _BE_DAL_TPRE_STATS_UNION {
         BE_DAL_TPRE_STATS bits;
         u32 dw[256]; // dword union
      } SG_PACK BE_DAL_TPRE_STATS_UNION, *PBE_DAL_TPRE_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_DAL_TPRE_STATS_UNION, sizeof (BE_DAL_TPRE_STATS_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __dalrx_exp_bmap_h__

