/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fc_common_host_struct_bmap_h__
#define __fc_common_host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "fc_enums_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This is the ring context structure for iSCSI & FCOE, because of its special linked
   // list structure. The HLL and h are used only by btlr to track the list. When
   // receiving a driver request, that is, the driver request bit is set in the
   // TCPSCH_PROC_IQ_DATA descriptor from TCP Scheduler, TXULP will double check the
   // wrb_pend to make sure it is greater than zero, and then use the wrb_addr as the
   // address of pending WRB and use it to generate CRA for UC request. After completing
   // the current WRB, the RXULP will send the ptr2NxtWRB to the CEV. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_FC {
         union {
            struct { 
               u32 r2t_cidx : 10;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 hll : 8;                       // DWORD 0
               u32 wrb_addr : 8;                  // DWORD 0
               u32 ctx_valid : 1;                 // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 h : 1;                         // DWORD 1
               u32 wrb_pend : 8;                  // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_FC, *PRING_CONTEXT_FC;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_FC, sizeof (RING_CONTEXT_FC) == 8);

   #else
      typedef struct _RING_CONTEXT_FC {
         u32 r2t_cidx : 10;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 hll : 8;                             // DWORD 0
         u32 wrb_addr : 8;                        // DWORD 0
         u32 ctx_valid : 1;                       // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 h : 1;                               // DWORD 1
         u32 wrb_pend : 8;                        // DWORD 1
      } SG_PACK RING_CONTEXT_FC, *PRING_CONTEXT_FC;

      typedef union _RING_CONTEXT_FC_UNION {
         RING_CONTEXT_FC bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_FC_UNION, *PRING_CONTEXT_FC_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_FC_UNION, sizeof (RING_CONTEXT_FC_UNION) == 8);
   #endif


#else
   // This is the ring context structure for iSCSI & FCOE, because of its special linked
   // list structure. The HLL and h are used only by btlr to track the list. When
   // receiving a driver request, that is, the driver request bit is set in the
   // TCPSCH_PROC_IQ_DATA descriptor from TCP Scheduler, TXULP will double check the
   // wrb_pend to make sure it is greater than zero, and then use the wrb_addr as the
   // address of pending WRB and use it to generate CRA for UC request. After completing
   // the current WRB, the RXULP will send the ptr2NxtWRB to the CEV. 
   #if defined(SG_BMAP_UNION)
      typedef struct _RING_CONTEXT_FC {
         union {
            struct { 
               u32 wrb_addr : 8;                  // DWORD 0
               u32 hll : 8;                       // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 r2t_cidx : 10;                 // DWORD 0
               u32 wrb_pend : 8;                  // DWORD 1
               u32 h : 1;                         // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pdid : 9;                      // DWORD 1
               u32 ctx_valid : 1;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK RING_CONTEXT_FC, *PRING_CONTEXT_FC;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_FC, sizeof (RING_CONTEXT_FC) == 8);

   #else
      typedef struct _RING_CONTEXT_FC {
         u32 wrb_addr : 8;                        // DWORD 0
         u32 hll : 8;                             // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 r2t_cidx : 10;                       // DWORD 0
         u32 wrb_pend : 8;                        // DWORD 1
         u32 h : 1;                               // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pdid : 9;                            // DWORD 1
         u32 ctx_valid : 1;                       // DWORD 1
      } SG_PACK RING_CONTEXT_FC, *PRING_CONTEXT_FC;

      typedef union _RING_CONTEXT_FC_UNION {
         RING_CONTEXT_FC bits;
         u32 dw[2]; // dword union
      } SG_PACK RING_CONTEXT_FC_UNION, *PRING_CONTEXT_FC_UNION;

      SG_C_ASSERT(__sizeof__RING_CONTEXT_FC_UNION, sizeof (RING_CONTEXT_FC_UNION) == 8);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fc_common_host_struct_bmap_h__

