/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __hw_host_struct_bmap_h__
#define __hw_host_struct_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Queue Entry Definition for all 4 byte event queue types.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_ENTRY {
         union {
            struct { 
               u32 ResourceID : 16;               // DWORD 0
               u32 MinorCode : 12;                // DWORD 0
               u32 MajorCode : 3;                 // DWORD 0
               u32 Valid : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EQ_ENTRY, *PEQ_ENTRY;

      SG_C_ASSERT(__sizeof__EQ_ENTRY, sizeof (EQ_ENTRY) == 4);

   #else
      typedef struct _EQ_ENTRY {
         u32 ResourceID : 16;                     // DWORD 0
         u32 MinorCode : 12;                      // DWORD 0
         u32 MajorCode : 3;                       // DWORD 0
         u32 Valid : 1;                           // DWORD 0
      } SG_PACK EQ_ENTRY, *PEQ_ENTRY;

      typedef union _EQ_ENTRY_UNION {
         EQ_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK EQ_ENTRY_UNION, *PEQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__EQ_ENTRY_UNION, sizeof (EQ_ENTRY_UNION) == 4);
   #endif


#else
   // Queue Entry Definition for all 4 byte event queue types.
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_ENTRY {
         union {
            struct { 
               u32 Valid : 1;                     // DWORD 0
               u32 MajorCode : 3;                 // DWORD 0
               u32 MinorCode : 12;                // DWORD 0
               u32 ResourceID : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EQ_ENTRY, *PEQ_ENTRY;

      SG_C_ASSERT(__sizeof__EQ_ENTRY, sizeof (EQ_ENTRY) == 4);

   #else
      typedef struct _EQ_ENTRY {
         u32 Valid : 1;                           // DWORD 0
         u32 MajorCode : 3;                       // DWORD 0
         u32 MinorCode : 12;                      // DWORD 0
         u32 ResourceID : 16;                     // DWORD 0
      } SG_PACK EQ_ENTRY, *PEQ_ENTRY;

      typedef union _EQ_ENTRY_UNION {
         EQ_ENTRY bits;
         u32 dw; // dword union
      } SG_PACK EQ_ENTRY_UNION, *PEQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__EQ_ENTRY_UNION, sizeof (EQ_ENTRY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is an Ethernet transmit completion descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_TX_COMPL {
         union {
            struct { 
               u32 status : 4;                    // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 port : 2;                      // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 wrb_index : 16;                // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 1
               u32 cast_enc : 2;                  // DWORD 1
               u32 lso : 1;                       // DWORD 1
               u32 nwh_bytes : 8;                 // DWORD 1
               u32 user_bytes : 16;               // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 valid : 1;                     // DWORD 3
               u32 hash_val : 4;                  // DWORD 3
               u32 ringid : 11;                   // DWORD 3
               u32 pkts : 16;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_TX_COMPL, *PETH_TX_COMPL;

      SG_C_ASSERT(__sizeof__ETH_TX_COMPL, sizeof (ETH_TX_COMPL) == 16);

   #else
      typedef struct _ETH_TX_COMPL {
         u32 status : 4;                          // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 port : 2;                            // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 wrb_index : 16;                      // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 1
         u32 cast_enc : 2;                        // DWORD 1
         u32 lso : 1;                             // DWORD 1
         u32 nwh_bytes : 8;                       // DWORD 1
         u32 user_bytes : 16;                     // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 valid : 1;                           // DWORD 3
         u32 hash_val : 4;                        // DWORD 3
         u32 ringid : 11;                         // DWORD 3
         u32 pkts : 16;                           // DWORD 3
      } SG_PACK ETH_TX_COMPL, *PETH_TX_COMPL;

      typedef union _ETH_TX_COMPL_UNION {
         ETH_TX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_TX_COMPL_UNION, *PETH_TX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__ETH_TX_COMPL_UNION, sizeof (ETH_TX_COMPL_UNION) == 16);
   #endif


#else
   // This is an Ethernet transmit completion descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_TX_COMPL {
         union {
            struct { 
               u32 wrb_index : 16;                // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 port : 2;                      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 status : 4;                    // DWORD 0
               u32 user_bytes : 16;               // DWORD 1
               u32 nwh_bytes : 8;                 // DWORD 1
               u32 lso : 1;                       // DWORD 1
               u32 cast_enc : 2;                  // DWORD 1
               u32 rsvd1 : 5;                     // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 pkts : 16;                     // DWORD 3
               u32 ringid : 11;                   // DWORD 3
               u32 hash_val : 4;                  // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_TX_COMPL, *PETH_TX_COMPL;

      SG_C_ASSERT(__sizeof__ETH_TX_COMPL, sizeof (ETH_TX_COMPL) == 16);

   #else
      typedef struct _ETH_TX_COMPL {
         u32 wrb_index : 16;                      // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 port : 2;                            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 status : 4;                          // DWORD 0
         u32 user_bytes : 16;                     // DWORD 1
         u32 nwh_bytes : 8;                       // DWORD 1
         u32 lso : 1;                             // DWORD 1
         u32 cast_enc : 2;                        // DWORD 1
         u32 rsvd1 : 5;                           // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 pkts : 16;                           // DWORD 3
         u32 ringid : 11;                         // DWORD 3
         u32 hash_val : 4;                        // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK ETH_TX_COMPL, *PETH_TX_COMPL;

      typedef union _ETH_TX_COMPL_UNION {
         ETH_TX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_TX_COMPL_UNION, *PETH_TX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__ETH_TX_COMPL_UNION, sizeof (ETH_TX_COMPL_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ethernet Receive Buffer descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_RX_D {
         union {
            struct { 
               u32 fragpa_hi;                     // DWORD 0
               u32 fragpa_lo;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ETH_RX_D, *PETH_RX_D;

      SG_C_ASSERT(__sizeof__ETH_RX_D, sizeof (ETH_RX_D) == 8);

   #else
      typedef struct _ETH_RX_D {
         u32 fragpa_hi;                           // DWORD 0
         u32 fragpa_lo;                           // DWORD 1
      } SG_PACK ETH_RX_D, *PETH_RX_D;

      typedef union _ETH_RX_D_UNION {
         ETH_RX_D bits;
         u32 dw[2]; // dword union
      } SG_PACK ETH_RX_D_UNION, *PETH_RX_D_UNION;

      SG_C_ASSERT(__sizeof__ETH_RX_D_UNION, sizeof (ETH_RX_D_UNION) == 8);
   #endif


#else
   // Ethernet Receive Buffer descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_RX_D {
         union {
            struct { 
               u32 fragpa_hi;                     // DWORD 0
               u32 fragpa_lo;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ETH_RX_D, *PETH_RX_D;

      SG_C_ASSERT(__sizeof__ETH_RX_D, sizeof (ETH_RX_D) == 8);

   #else
      typedef struct _ETH_RX_D {
         u32 fragpa_hi;                           // DWORD 0
         u32 fragpa_lo;                           // DWORD 1
      } SG_PACK ETH_RX_D, *PETH_RX_D;

      typedef union _ETH_RX_D_UNION {
         ETH_RX_D bits;
         u32 dw[2]; // dword union
      } SG_PACK ETH_RX_D_UNION, *PETH_RX_D_UNION;

      SG_C_ASSERT(__sizeof__ETH_RX_D_UNION, sizeof (ETH_RX_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is an Ethernet Receive Completion Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_RX_COMPL {
         union {
            struct { 
               u32 ip_opt : 1;                    // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 pktsize : 14;                  // DWORD 0
               u32 vlan_tag : 16;                 // DWORD 0
               u32 numfrags : 3;                  // DWORD 1
               u32 sw : 1;                        // DWORD 1
               u32 ct : 2;                        // DWORD 1
               u32 fragndx : 10;                  // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 macdst : 6;                    // DWORD 1
               u32 ip_version : 1;                // DWORD 1
               u32 l4_cksm : 1;                   // DWORD 1
               u32 ipcksm : 1;                    // DWORD 1
               u32 udpf : 1;                      // DWORD 1
               u32 tcpf : 1;                      // DWORD 1
               u32 ipf : 1;                       // DWORD 1
               u32 rsshp : 1;                     // DWORD 1
               u32 err : 1;                       // DWORD 1
               u32 valid : 1;                     // DWORD 2
               u32 rsvd2 : 2;                     // DWORD 2
               u32 lro_pkt : 1;                   // DWORD 2
               u32 rsvd1 : 23;                    // DWORD 2
               u32 rss_bank : 1;                  // DWORD 2
               u32 QnQ : 1;                       // DWORD 2
               u32 cast_enc : 2;                  // DWORD 2
               u32 rss_flush : 1;                 // DWORD 2
               u32 rsshash;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_RX_COMPL, *PETH_RX_COMPL;

      SG_C_ASSERT(__sizeof__ETH_RX_COMPL, sizeof (ETH_RX_COMPL) == 16);

   #else
      typedef struct _ETH_RX_COMPL {
         u32 ip_opt : 1;                          // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 vlan_tag : 16;                       // DWORD 0
         u32 numfrags : 3;                        // DWORD 1
         u32 sw : 1;                              // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 fragndx : 10;                        // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 macdst : 6;                          // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 err : 1;                             // DWORD 1
         u32 valid : 1;                           // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 lro_pkt : 1;                         // DWORD 2
         u32 rsvd1 : 23;                          // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 cast_enc : 2;                        // DWORD 2
         u32 rss_flush : 1;                       // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ETH_RX_COMPL, *PETH_RX_COMPL;

      typedef union _ETH_RX_COMPL_UNION {
         ETH_RX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_RX_COMPL_UNION, *PETH_RX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__ETH_RX_COMPL_UNION, sizeof (ETH_RX_COMPL_UNION) == 16);
   #endif


#else
   // This is an Ethernet Receive Completion Descriptor
   #if defined(SG_BMAP_UNION)
      typedef struct _ETH_RX_COMPL {
         union {
            struct { 
               u32 vlan_tag : 16;                 // DWORD 0
               u32 pktsize : 14;                  // DWORD 0
               u32 port : 1;                      // DWORD 0
               u32 ip_opt : 1;                    // DWORD 0
               u32 err : 1;                       // DWORD 1
               u32 rsshp : 1;                     // DWORD 1
               u32 ipf : 1;                       // DWORD 1
               u32 tcpf : 1;                      // DWORD 1
               u32 udpf : 1;                      // DWORD 1
               u32 ipcksm : 1;                    // DWORD 1
               u32 l4_cksm : 1;                   // DWORD 1
               u32 ip_version : 1;                // DWORD 1
               u32 macdst : 6;                    // DWORD 1
               u32 vtp : 1;                       // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 fragndx : 10;                  // DWORD 1
               u32 ct : 2;                        // DWORD 1
               u32 sw : 1;                        // DWORD 1
               u32 numfrags : 3;                  // DWORD 1
               u32 rss_flush : 1;                 // DWORD 2
               u32 cast_enc : 2;                  // DWORD 2
               u32 QnQ : 1;                       // DWORD 2
               u32 rss_bank : 1;                  // DWORD 2
               u32 rsvd1 : 23;                    // DWORD 2
               u32 lro_pkt : 1;                   // DWORD 2
               u32 rsvd2 : 2;                     // DWORD 2
               u32 valid : 1;                     // DWORD 2
               u32 rsshash;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETH_RX_COMPL, *PETH_RX_COMPL;

      SG_C_ASSERT(__sizeof__ETH_RX_COMPL, sizeof (ETH_RX_COMPL) == 16);

   #else
      typedef struct _ETH_RX_COMPL {
         u32 vlan_tag : 16;                       // DWORD 0
         u32 pktsize : 14;                        // DWORD 0
         u32 port : 1;                            // DWORD 0
         u32 ip_opt : 1;                          // DWORD 0
         u32 err : 1;                             // DWORD 1
         u32 rsshp : 1;                           // DWORD 1
         u32 ipf : 1;                             // DWORD 1
         u32 tcpf : 1;                            // DWORD 1
         u32 udpf : 1;                            // DWORD 1
         u32 ipcksm : 1;                          // DWORD 1
         u32 l4_cksm : 1;                         // DWORD 1
         u32 ip_version : 1;                      // DWORD 1
         u32 macdst : 6;                          // DWORD 1
         u32 vtp : 1;                             // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 fragndx : 10;                        // DWORD 1
         u32 ct : 2;                              // DWORD 1
         u32 sw : 1;                              // DWORD 1
         u32 numfrags : 3;                        // DWORD 1
         u32 rss_flush : 1;                       // DWORD 2
         u32 cast_enc : 2;                        // DWORD 2
         u32 QnQ : 1;                             // DWORD 2
         u32 rss_bank : 1;                        // DWORD 2
         u32 rsvd1 : 23;                          // DWORD 2
         u32 lro_pkt : 1;                         // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 valid : 1;                           // DWORD 2
         u32 rsshash;                             // DWORD 3
      } SG_PACK ETH_RX_COMPL, *PETH_RX_COMPL;

      typedef union _ETH_RX_COMPL_UNION {
         ETH_RX_COMPL bits;
         u32 dw[4]; // dword union
      } SG_PACK ETH_RX_COMPL_UNION, *PETH_RX_COMPL_UNION;

      SG_C_ASSERT(__sizeof__ETH_RX_COMPL_UNION, sizeof (ETH_RX_COMPL_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __hw_host_struct_bmap_h__

