/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __hwdbg_reg_bmap_h__
#define __hwdbg_reg_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Software control to override the HW debug bus register selection. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_CTRL_CSR {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 regsel : 8;                    // DWORD 0
               u32 shift : 8;                     // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 enable : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_CTRL_CSR, *PHWDBG_CTRL_CSR;

      SG_C_ASSERT(__sizeof__HWDBG_CTRL_CSR, sizeof (HWDBG_CTRL_CSR) == 4);

   #else
      typedef struct _HWDBG_CTRL_CSR {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 regsel : 8;                          // DWORD 0
         u32 shift : 8;                           // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 enable : 1;                          // DWORD 0
      } SG_PACK HWDBG_CTRL_CSR, *PHWDBG_CTRL_CSR;

      typedef union _HWDBG_CTRL_CSR_UNION {
         HWDBG_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK HWDBG_CTRL_CSR_UNION, *PHWDBG_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_CTRL_CSR_UNION, sizeof (HWDBG_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Software control to override the HW debug bus register selection. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_CTRL_CSR {
         union {
            struct { 
               u32 enable : 1;                    // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 shift : 8;                     // DWORD 0
               u32 regsel : 8;                    // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_CTRL_CSR, *PHWDBG_CTRL_CSR;

      SG_C_ASSERT(__sizeof__HWDBG_CTRL_CSR, sizeof (HWDBG_CTRL_CSR) == 4);

   #else
      typedef struct _HWDBG_CTRL_CSR {
         u32 enable : 1;                          // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 shift : 8;                           // DWORD 0
         u32 regsel : 8;                          // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
      } SG_PACK HWDBG_CTRL_CSR, *PHWDBG_CTRL_CSR;

      typedef union _HWDBG_CTRL_CSR_UNION {
         HWDBG_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK HWDBG_CTRL_CSR_UNION, *PHWDBG_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_CTRL_CSR_UNION, sizeof (HWDBG_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask bits for the HW debug bus. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_MASK_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_MASK_CSR, *PHWDBG_MASK_CSR;

      SG_C_ASSERT(__sizeof__HWDBG_MASK_CSR, sizeof (HWDBG_MASK_CSR) == 4);

   #else
      typedef struct _HWDBG_MASK_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK HWDBG_MASK_CSR, *PHWDBG_MASK_CSR;

      typedef union _HWDBG_MASK_CSR_UNION {
         HWDBG_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK HWDBG_MASK_CSR_UNION, *PHWDBG_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_MASK_CSR_UNION, sizeof (HWDBG_MASK_CSR_UNION) == 4);
   #endif


#else
   // Mask bits for the HW debug bus. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_MASK_CSR {
         union {
            struct { 
               u32 mask;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_MASK_CSR, *PHWDBG_MASK_CSR;

      SG_C_ASSERT(__sizeof__HWDBG_MASK_CSR, sizeof (HWDBG_MASK_CSR) == 4);

   #else
      typedef struct _HWDBG_MASK_CSR {
         u32 mask;                                // DWORD 0
      } SG_PACK HWDBG_MASK_CSR, *PHWDBG_MASK_CSR;

      typedef union _HWDBG_MASK_CSR_UNION {
         HWDBG_MASK_CSR bits;
         u32 dw; // dword union
      } SG_PACK HWDBG_MASK_CSR_UNION, *PHWDBG_MASK_CSR_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_MASK_CSR_UNION, sizeof (HWDBG_MASK_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each hardware block that contains a HW debug bus mux, will instantiate this
   // submodule. The same HWDBG_CSRMAP registers are used for each clock domain's HW debug
   // bus within the module. Typically, this module should be named "hwdbg" when
   // instantiated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_CSRMAP {
         union {
            struct { 
               HWDBG_CTRL_CSR ctrl;
               HWDBG_MASK_CSR mask0;
               HWDBG_MASK_CSR mask1;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_CSRMAP, *PHWDBG_CSRMAP;

      SG_C_ASSERT(__sizeof__HWDBG_CSRMAP, sizeof (HWDBG_CSRMAP) == 12);

   #else
      typedef struct _HWDBG_CSRMAP {
         HWDBG_CTRL_CSR ctrl;
         HWDBG_MASK_CSR mask0;
         HWDBG_MASK_CSR mask1;
      } SG_PACK HWDBG_CSRMAP, *PHWDBG_CSRMAP;

      typedef union _HWDBG_CSRMAP_UNION {
         HWDBG_CSRMAP bits;
         u32 dw[3]; // dword union
      } SG_PACK HWDBG_CSRMAP_UNION, *PHWDBG_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_CSRMAP_UNION, sizeof (HWDBG_CSRMAP_UNION) == 12);
   #endif


#else
   // Each hardware block that contains a HW debug bus mux, will instantiate this
   // submodule. The same HWDBG_CSRMAP registers are used for each clock domain's HW debug
   // bus within the module. Typically, this module should be named "hwdbg" when
   // instantiated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _HWDBG_CSRMAP {
         union {
            struct { 
               HWDBG_CTRL_CSR ctrl;
               HWDBG_MASK_CSR mask0;
               HWDBG_MASK_CSR mask1;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK HWDBG_CSRMAP, *PHWDBG_CSRMAP;

      SG_C_ASSERT(__sizeof__HWDBG_CSRMAP, sizeof (HWDBG_CSRMAP) == 12);

   #else
      typedef struct _HWDBG_CSRMAP {
         HWDBG_CTRL_CSR ctrl;
         HWDBG_MASK_CSR mask0;
         HWDBG_MASK_CSR mask1;
      } SG_PACK HWDBG_CSRMAP, *PHWDBG_CSRMAP;

      typedef union _HWDBG_CSRMAP_UNION {
         HWDBG_CSRMAP bits;
         u32 dw[3]; // dword union
      } SG_PACK HWDBG_CSRMAP_UNION, *PHWDBG_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__HWDBG_CSRMAP_UNION, sizeof (HWDBG_CSRMAP_UNION) == 12);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __hwdbg_reg_bmap_h__

