/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_hdr_bmap_h__
#define __ioctl_hdr_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_defs_bmap.h"
#include "ioctl_opcodes_bmap.h"
#include "fat_header_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_REQUEST_HEADER {
         union {
            struct { 
               UEXACT8 opcode;
               UEXACT8 subsystem;
               UEXACT8 port_number;
               UEXACT8 domain;
               UEXACT32 timeout;
               UEXACT32 request_length;
               UEXACT8 version;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_REQUEST_HEADER, *PIOCTL_REQUEST_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER, sizeof (IOCTL_REQUEST_HEADER) == 16);

   #else
      typedef struct _IOCTL_REQUEST_HEADER {
         UEXACT8 opcode;
         UEXACT8 subsystem;
         UEXACT8 port_number;
         UEXACT8 domain;
         UEXACT32 timeout;
         UEXACT32 request_length;
         UEXACT8 version;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_REQUEST_HEADER, *PIOCTL_REQUEST_HEADER;

      typedef union _IOCTL_REQUEST_HEADER_UNION {
         IOCTL_REQUEST_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_REQUEST_HEADER_UNION, *PIOCTL_REQUEST_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER_UNION, sizeof (IOCTL_REQUEST_HEADER_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_REQUEST_HEADER {
         union {
            struct { 
               UEXACT8 opcode;
               UEXACT8 subsystem;
               UEXACT8 port_number;
               UEXACT8 domain;
               UEXACT32 timeout;
               UEXACT32 request_length;
               UEXACT8 version;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_REQUEST_HEADER, *PIOCTL_REQUEST_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER, sizeof (IOCTL_REQUEST_HEADER) == 16);

   #else
      typedef struct _IOCTL_REQUEST_HEADER {
         UEXACT8 opcode;
         UEXACT8 subsystem;
         UEXACT8 port_number;
         UEXACT8 domain;
         UEXACT32 timeout;
         UEXACT32 request_length;
         UEXACT8 version;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_REQUEST_HEADER, *PIOCTL_REQUEST_HEADER;

      typedef union _IOCTL_REQUEST_HEADER_UNION {
         IOCTL_REQUEST_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_REQUEST_HEADER_UNION, *PIOCTL_REQUEST_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_REQUEST_HEADER_UNION, sizeof (IOCTL_REQUEST_HEADER_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RESPONSE_HEADER {
         union {
            struct { 
               UEXACT8 opcode;
               UEXACT8 subsystem;
               UEXACT8 rsvd0;
               UEXACT8 domain;
               UEXACT8 status;
               UEXACT8 additional_status;
               UEXACT16 rsvd1;
               UEXACT32 response_length;
               UEXACT32 actual_response_length;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RESPONSE_HEADER, *PIOCTL_RESPONSE_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER, sizeof (IOCTL_RESPONSE_HEADER) == 16);

   #else
      typedef struct _IOCTL_RESPONSE_HEADER {
         UEXACT8 opcode;
         UEXACT8 subsystem;
         UEXACT8 rsvd0;
         UEXACT8 domain;
         UEXACT8 status;
         UEXACT8 additional_status;
         UEXACT16 rsvd1;
         UEXACT32 response_length;
         UEXACT32 actual_response_length;
      } SG_PACK IOCTL_RESPONSE_HEADER, *PIOCTL_RESPONSE_HEADER;

      typedef union _IOCTL_RESPONSE_HEADER_UNION {
         IOCTL_RESPONSE_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_RESPONSE_HEADER_UNION, *PIOCTL_RESPONSE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER_UNION, sizeof (IOCTL_RESPONSE_HEADER_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RESPONSE_HEADER {
         union {
            struct { 
               UEXACT8 opcode;
               UEXACT8 subsystem;
               UEXACT8 rsvd0;
               UEXACT8 domain;
               UEXACT8 status;
               UEXACT8 additional_status;
               UEXACT16 rsvd1;
               UEXACT32 response_length;
               UEXACT32 actual_response_length;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RESPONSE_HEADER, *PIOCTL_RESPONSE_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER, sizeof (IOCTL_RESPONSE_HEADER) == 16);

   #else
      typedef struct _IOCTL_RESPONSE_HEADER {
         UEXACT8 opcode;
         UEXACT8 subsystem;
         UEXACT8 rsvd0;
         UEXACT8 domain;
         UEXACT8 status;
         UEXACT8 additional_status;
         UEXACT16 rsvd1;
         UEXACT32 response_length;
         UEXACT32 actual_response_length;
      } SG_PACK IOCTL_RESPONSE_HEADER, *PIOCTL_RESPONSE_HEADER;

      typedef union _IOCTL_RESPONSE_HEADER_UNION {
         IOCTL_RESPONSE_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_RESPONSE_HEADER_UNION, *PIOCTL_RESPONSE_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RESPONSE_HEADER_UNION, sizeof (IOCTL_RESPONSE_HEADER_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The firmware/driver overwrites the input IOCTL_REQUEST_HEADER with the output
   // IOCTL_RESPONSE_HEADER. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_HEADER {
         union {
            union { 
               IOCTL_REQUEST_HEADER request;
               IOCTL_RESPONSE_HEADER response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_HEADER, *PIOCTL_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_HEADER, sizeof (IOCTL_HEADER) == 16);

   #else
      typedef union _IOCTL_HEADER {
         IOCTL_REQUEST_HEADER request;
         IOCTL_RESPONSE_HEADER response;
      } SG_PACK IOCTL_HEADER, *PIOCTL_HEADER;

      typedef union _IOCTL_HEADER_UNION {
         IOCTL_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_HEADER_UNION, *PIOCTL_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_HEADER_UNION, sizeof (IOCTL_HEADER_UNION) == 16);
   #endif


#else
   // The firmware/driver overwrites the input IOCTL_REQUEST_HEADER with the output
   // IOCTL_RESPONSE_HEADER. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_HEADER {
         union {
            union { 
               IOCTL_REQUEST_HEADER request;
               IOCTL_RESPONSE_HEADER response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_HEADER, *PIOCTL_HEADER;

      SG_C_ASSERT(__sizeof__IOCTL_HEADER, sizeof (IOCTL_HEADER) == 16);

   #else
      typedef union _IOCTL_HEADER {
         IOCTL_REQUEST_HEADER request;
         IOCTL_RESPONSE_HEADER response;
      } SG_PACK IOCTL_HEADER, *PIOCTL_HEADER;

      typedef union _IOCTL_HEADER_UNION {
         IOCTL_HEADER bits;
         u32 dw[4]; // dword union
      } SG_PACK IOCTL_HEADER_UNION, *PIOCTL_HEADER_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_HEADER_UNION, sizeof (IOCTL_HEADER_UNION) == 16);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_hdr_bmap_h__

