/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_boot_bmap_h__
#define __ioctl_iscsi_ini_boot_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_TARGET_OUT {
         union {
            struct { 
               UEXACT32 boot_session_count;
               UEXACT32 boot_session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_TARGET_OUT, *PGET_BOOT_TARGET_OUT;

      SG_C_ASSERT(__sizeof__GET_BOOT_TARGET_OUT, sizeof (GET_BOOT_TARGET_OUT) == 8);

   #else
      typedef struct _GET_BOOT_TARGET_OUT {
         UEXACT32 boot_session_count;
         UEXACT32 boot_session_handle;
      } SG_PACK GET_BOOT_TARGET_OUT, *PGET_BOOT_TARGET_OUT;

      typedef union _GET_BOOT_TARGET_OUT_UNION {
         GET_BOOT_TARGET_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_TARGET_OUT_UNION, *PGET_BOOT_TARGET_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_TARGET_OUT_UNION, sizeof (GET_BOOT_TARGET_OUT_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_TARGET_OUT {
         union {
            struct { 
               UEXACT32 boot_session_count;
               UEXACT32 boot_session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_TARGET_OUT, *PGET_BOOT_TARGET_OUT;

      SG_C_ASSERT(__sizeof__GET_BOOT_TARGET_OUT, sizeof (GET_BOOT_TARGET_OUT) == 8);

   #else
      typedef struct _GET_BOOT_TARGET_OUT {
         UEXACT32 boot_session_count;
         UEXACT32 boot_session_handle;
      } SG_PACK GET_BOOT_TARGET_OUT, *PGET_BOOT_TARGET_OUT;

      typedef union _GET_BOOT_TARGET_OUT_UNION {
         GET_BOOT_TARGET_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_TARGET_OUT_UNION, *PGET_BOOT_TARGET_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_TARGET_OUT_UNION, sizeof (GET_BOOT_TARGET_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET {
      IOCTL_HEADER header;
      GET_BOOT_TARGET_OUT response;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET;



#else
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET {
      IOCTL_HEADER header;
      GET_BOOT_TARGET_OUT response;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BOOT_TARGET_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 session_flags;
               UEXACT32 ipsec_enabled;
               UEXACT16 preshared_key_length;
               UEXACT16 ipsec_id_length;
               UEXACT8 preshared_key[256];
               UEXACT8 id[256];
            } SG_PACK ; // unnamed struct
            u32 dw[132]; // dword union
         }; // unnamed union
      } SG_PACK SET_BOOT_TARGET_IN, *PSET_BOOT_TARGET_IN;

      SG_C_ASSERT(__sizeof__SET_BOOT_TARGET_IN, sizeof (SET_BOOT_TARGET_IN) == 528);

   #else
      typedef struct _SET_BOOT_TARGET_IN {
         UEXACT32 session_handle;
         UEXACT32 session_flags;
         UEXACT32 ipsec_enabled;
         UEXACT16 preshared_key_length;
         UEXACT16 ipsec_id_length;
         UEXACT8 preshared_key[256];
         UEXACT8 id[256];
      } SG_PACK SET_BOOT_TARGET_IN, *PSET_BOOT_TARGET_IN;

      typedef union _SET_BOOT_TARGET_IN_UNION {
         SET_BOOT_TARGET_IN bits;
         u32 dw[132]; // dword union
      } SG_PACK SET_BOOT_TARGET_IN_UNION, *PSET_BOOT_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BOOT_TARGET_IN_UNION, sizeof (SET_BOOT_TARGET_IN_UNION) == 528);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BOOT_TARGET_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 session_flags;
               UEXACT32 ipsec_enabled;
               UEXACT16 preshared_key_length;
               UEXACT16 ipsec_id_length;
               UEXACT8 preshared_key[256];
               UEXACT8 id[256];
            } SG_PACK ; // unnamed struct
            u32 dw[132]; // dword union
         }; // unnamed union
      } SG_PACK SET_BOOT_TARGET_IN, *PSET_BOOT_TARGET_IN;

      SG_C_ASSERT(__sizeof__SET_BOOT_TARGET_IN, sizeof (SET_BOOT_TARGET_IN) == 528);

   #else
      typedef struct _SET_BOOT_TARGET_IN {
         UEXACT32 session_handle;
         UEXACT32 session_flags;
         UEXACT32 ipsec_enabled;
         UEXACT16 preshared_key_length;
         UEXACT16 ipsec_id_length;
         UEXACT8 preshared_key[256];
         UEXACT8 id[256];
      } SG_PACK SET_BOOT_TARGET_IN, *PSET_BOOT_TARGET_IN;

      typedef union _SET_BOOT_TARGET_IN_UNION {
         SET_BOOT_TARGET_IN bits;
         u32 dw[132]; // dword union
      } SG_PACK SET_BOOT_TARGET_IN_UNION, *PSET_BOOT_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BOOT_TARGET_IN_UNION, sizeof (SET_BOOT_TARGET_IN_UNION) == 528);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET {
      IOCTL_HEADER header;
      SET_BOOT_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET;



#else
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET {
      IOCTL_HEADER header;
      SET_BOOT_TARGET_IN request;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_TARGET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN_IN, *PGET_BOOT_LUN_IN;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_IN, sizeof (GET_BOOT_LUN_IN) == 4);

   #else
      typedef struct _GET_BOOT_LUN_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_BOOT_LUN_IN, *PGET_BOOT_LUN_IN;

      typedef union _GET_BOOT_LUN_IN_UNION {
         GET_BOOT_LUN_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_BOOT_LUN_IN_UNION, *PGET_BOOT_LUN_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_IN_UNION, sizeof (GET_BOOT_LUN_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN_IN, *PGET_BOOT_LUN_IN;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_IN, sizeof (GET_BOOT_LUN_IN) == 4);

   #else
      typedef struct _GET_BOOT_LUN_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_BOOT_LUN_IN, *PGET_BOOT_LUN_IN;

      typedef union _GET_BOOT_LUN_IN_UNION {
         GET_BOOT_LUN_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_BOOT_LUN_IN_UNION, *PGET_BOOT_LUN_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_IN_UNION, sizeof (GET_BOOT_LUN_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN_OUT {
         union {
            struct { 
               UEXACT8 boot_lun[8];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN_OUT, *PGET_BOOT_LUN_OUT;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_OUT, sizeof (GET_BOOT_LUN_OUT) == 8);

   #else
      typedef struct _GET_BOOT_LUN_OUT {
         UEXACT8 boot_lun[8];
      } SG_PACK GET_BOOT_LUN_OUT, *PGET_BOOT_LUN_OUT;

      typedef union _GET_BOOT_LUN_OUT_UNION {
         GET_BOOT_LUN_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_LUN_OUT_UNION, *PGET_BOOT_LUN_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_OUT_UNION, sizeof (GET_BOOT_LUN_OUT_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN_OUT {
         union {
            struct { 
               UEXACT8 boot_lun[8];
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN_OUT, *PGET_BOOT_LUN_OUT;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_OUT, sizeof (GET_BOOT_LUN_OUT) == 8);

   #else
      typedef struct _GET_BOOT_LUN_OUT {
         UEXACT8 boot_lun[8];
      } SG_PACK GET_BOOT_LUN_OUT, *PGET_BOOT_LUN_OUT;

      typedef union _GET_BOOT_LUN_OUT_UNION {
         GET_BOOT_LUN_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_LUN_OUT_UNION, *PGET_BOOT_LUN_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_OUT_UNION, sizeof (GET_BOOT_LUN_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN {
         union {
            union { 
               GET_BOOT_LUN_IN request;
               GET_BOOT_LUN_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN, *PGET_BOOT_LUN;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN, sizeof (GET_BOOT_LUN) == 8);

   #else
      typedef union _GET_BOOT_LUN {
         GET_BOOT_LUN_IN request;
         GET_BOOT_LUN_OUT response;
      } SG_PACK GET_BOOT_LUN, *PGET_BOOT_LUN;

      typedef union _GET_BOOT_LUN_UNION {
         GET_BOOT_LUN bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_LUN_UNION, *PGET_BOOT_LUN_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_UNION, sizeof (GET_BOOT_LUN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BOOT_LUN {
         union {
            union { 
               GET_BOOT_LUN_IN request;
               GET_BOOT_LUN_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK GET_BOOT_LUN, *PGET_BOOT_LUN;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN, sizeof (GET_BOOT_LUN) == 8);

   #else
      typedef union _GET_BOOT_LUN {
         GET_BOOT_LUN_IN request;
         GET_BOOT_LUN_OUT response;
      } SG_PACK GET_BOOT_LUN, *PGET_BOOT_LUN;

      typedef union _GET_BOOT_LUN_UNION {
         GET_BOOT_LUN bits;
         u32 dw[2]; // dword union
      } SG_PACK GET_BOOT_LUN_UNION, *PGET_BOOT_LUN_UNION;

      SG_C_ASSERT(__sizeof__GET_BOOT_LUN_UNION, sizeof (GET_BOOT_LUN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This ioctl will return the Boot LUN stored in the Flash ROM. 
   typedef struct _IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN {
      IOCTL_HEADER header;
      GET_BOOT_LUN params;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN;



#else
   // This ioctl will return the Boot LUN stored in the Flash ROM. 
   typedef struct _IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN {
      IOCTL_HEADER header;
      GET_BOOT_LUN params;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN, *PIOCTL_ISCSI_INI_BOOT_GET_BOOT_LUN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BOOT_LUN_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT8 boot_lun[8];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK SET_BOOT_LUN_IN, *PSET_BOOT_LUN_IN;

      SG_C_ASSERT(__sizeof__SET_BOOT_LUN_IN, sizeof (SET_BOOT_LUN_IN) == 12);

   #else
      typedef struct _SET_BOOT_LUN_IN {
         UEXACT32 session_handle;
         UEXACT8 boot_lun[8];
      } SG_PACK SET_BOOT_LUN_IN, *PSET_BOOT_LUN_IN;

      typedef union _SET_BOOT_LUN_IN_UNION {
         SET_BOOT_LUN_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK SET_BOOT_LUN_IN_UNION, *PSET_BOOT_LUN_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BOOT_LUN_IN_UNION, sizeof (SET_BOOT_LUN_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BOOT_LUN_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT8 boot_lun[8];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK SET_BOOT_LUN_IN, *PSET_BOOT_LUN_IN;

      SG_C_ASSERT(__sizeof__SET_BOOT_LUN_IN, sizeof (SET_BOOT_LUN_IN) == 12);

   #else
      typedef struct _SET_BOOT_LUN_IN {
         UEXACT32 session_handle;
         UEXACT8 boot_lun[8];
      } SG_PACK SET_BOOT_LUN_IN, *PSET_BOOT_LUN_IN;

      typedef union _SET_BOOT_LUN_IN_UNION {
         SET_BOOT_LUN_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK SET_BOOT_LUN_IN_UNION, *PSET_BOOT_LUN_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BOOT_LUN_IN_UNION, sizeof (SET_BOOT_LUN_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN {
      IOCTL_HEADER header;
      SET_BOOT_LUN_IN request;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN;



#else
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN {
      IOCTL_HEADER header;
      SET_BOOT_LUN_IN request;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN, *PIOCTL_ISCSI_INI_BOOT_SET_BOOT_LUN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT8 lun[8];
               UEXACT8 cdb[16];
               UEXACT8 data_direction_flag;
               UEXACT8 rsvd0[3];
               MGMT_SG_TABLE sgtable;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN, *PSCSI_READ_WRITE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_IN, sizeof (SCSI_READ_WRITE_PARAMS_IN) == 56);

   #else
      typedef struct _SCSI_READ_WRITE_PARAMS_IN {
         UEXACT32 session_handle;
         UEXACT8 lun[8];
         UEXACT8 cdb[16];
         UEXACT8 data_direction_flag;
         UEXACT8 rsvd0[3];
         MGMT_SG_TABLE sgtable;
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN, *PSCSI_READ_WRITE_PARAMS_IN;

      typedef union _SCSI_READ_WRITE_PARAMS_IN_UNION {
         SCSI_READ_WRITE_PARAMS_IN bits;
         u32 dw[14]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN_UNION, *PSCSI_READ_WRITE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_IN_UNION, sizeof (SCSI_READ_WRITE_PARAMS_IN_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT8 lun[8];
               UEXACT8 cdb[16];
               UEXACT8 data_direction_flag;
               UEXACT8 rsvd0[3];
               MGMT_SG_TABLE sgtable;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN, *PSCSI_READ_WRITE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_IN, sizeof (SCSI_READ_WRITE_PARAMS_IN) == 56);

   #else
      typedef struct _SCSI_READ_WRITE_PARAMS_IN {
         UEXACT32 session_handle;
         UEXACT8 lun[8];
         UEXACT8 cdb[16];
         UEXACT8 data_direction_flag;
         UEXACT8 rsvd0[3];
         MGMT_SG_TABLE sgtable;
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN, *PSCSI_READ_WRITE_PARAMS_IN;

      typedef union _SCSI_READ_WRITE_PARAMS_IN_UNION {
         SCSI_READ_WRITE_PARAMS_IN bits;
         u32 dw[14]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_IN_UNION, *PSCSI_READ_WRITE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_IN_UNION, sizeof (SCSI_READ_WRITE_PARAMS_IN_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 scsi_status;
               UEXACT8 iscsi_response;
               UEXACT8 sense_buffer[18];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT, *PSCSI_READ_WRITE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_OUT, sizeof (SCSI_READ_WRITE_PARAMS_OUT) == 20);

   #else
      typedef struct _SCSI_READ_WRITE_PARAMS_OUT {
         UEXACT8 scsi_status;
         UEXACT8 iscsi_response;
         UEXACT8 sense_buffer[18];
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT, *PSCSI_READ_WRITE_PARAMS_OUT;

      typedef union _SCSI_READ_WRITE_PARAMS_OUT_UNION {
         SCSI_READ_WRITE_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT_UNION, *PSCSI_READ_WRITE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_OUT_UNION, sizeof (SCSI_READ_WRITE_PARAMS_OUT_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 scsi_status;
               UEXACT8 iscsi_response;
               UEXACT8 sense_buffer[18];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT, *PSCSI_READ_WRITE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_OUT, sizeof (SCSI_READ_WRITE_PARAMS_OUT) == 20);

   #else
      typedef struct _SCSI_READ_WRITE_PARAMS_OUT {
         UEXACT8 scsi_status;
         UEXACT8 iscsi_response;
         UEXACT8 sense_buffer[18];
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT, *PSCSI_READ_WRITE_PARAMS_OUT;

      typedef union _SCSI_READ_WRITE_PARAMS_OUT_UNION {
         SCSI_READ_WRITE_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_OUT_UNION, *PSCSI_READ_WRITE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_OUT_UNION, sizeof (SCSI_READ_WRITE_PARAMS_OUT_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS {
         union {
            union { 
               SCSI_READ_WRITE_PARAMS_IN request;
               SCSI_READ_WRITE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS, *PSCSI_READ_WRITE_PARAMS;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS, sizeof (SCSI_READ_WRITE_PARAMS) == 56);

   #else
      typedef union _SCSI_READ_WRITE_PARAMS {
         SCSI_READ_WRITE_PARAMS_IN request;
         SCSI_READ_WRITE_PARAMS_OUT response;
      } SG_PACK SCSI_READ_WRITE_PARAMS, *PSCSI_READ_WRITE_PARAMS;

      typedef union _SCSI_READ_WRITE_PARAMS_UNION {
         SCSI_READ_WRITE_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_UNION, *PSCSI_READ_WRITE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_UNION, sizeof (SCSI_READ_WRITE_PARAMS_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SCSI_READ_WRITE_PARAMS {
         union {
            union { 
               SCSI_READ_WRITE_PARAMS_IN request;
               SCSI_READ_WRITE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SCSI_READ_WRITE_PARAMS, *PSCSI_READ_WRITE_PARAMS;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS, sizeof (SCSI_READ_WRITE_PARAMS) == 56);

   #else
      typedef union _SCSI_READ_WRITE_PARAMS {
         SCSI_READ_WRITE_PARAMS_IN request;
         SCSI_READ_WRITE_PARAMS_OUT response;
      } SG_PACK SCSI_READ_WRITE_PARAMS, *PSCSI_READ_WRITE_PARAMS;

      typedef union _SCSI_READ_WRITE_PARAMS_UNION {
         SCSI_READ_WRITE_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK SCSI_READ_WRITE_PARAMS_UNION, *PSCSI_READ_WRITE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SCSI_READ_WRITE_PARAMS_UNION, sizeof (SCSI_READ_WRITE_PARAMS_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_READ_WRITE {
      IOCTL_HEADER header;
      SCSI_READ_WRITE_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_READ_WRITE, *PIOCTL_ISCSI_INI_BOOT_READ_WRITE;



#else
   
   typedef struct _IOCTL_ISCSI_INI_BOOT_READ_WRITE {
      IOCTL_HEADER header;
      SCSI_READ_WRITE_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_READ_WRITE, *PIOCTL_ISCSI_INI_BOOT_READ_WRITE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BIOS_PARAMS {
         union {
            struct { 
               UEXACT8 discover_boottarget;
               UEXACT8 rsvd0[3];
               UEXACT8 auto_discovery_flags;
               UEXACT8 rsvd1[3];
               UEXACT8 bios_int13_enabled;
               UEXACT8 int13_en_per_func;
               UEXACT8 rsvd2[1];
               UEXACT8 ibft_addr_valid;
               UEXACT8 remote_configuration;
               UEXACT8 ibft_pci_address[3];
               UEXACT32 bios_ver;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK BIOS_PARAMS, *PBIOS_PARAMS;

      SG_C_ASSERT(__sizeof__BIOS_PARAMS, sizeof (BIOS_PARAMS) == 20);

   #else
      typedef struct _BIOS_PARAMS {
         UEXACT8 discover_boottarget;
         UEXACT8 rsvd0[3];
         UEXACT8 auto_discovery_flags;
         UEXACT8 rsvd1[3];
         UEXACT8 bios_int13_enabled;
         UEXACT8 int13_en_per_func;
         UEXACT8 rsvd2[1];
         UEXACT8 ibft_addr_valid;
         UEXACT8 remote_configuration;
         UEXACT8 ibft_pci_address[3];
         UEXACT32 bios_ver;
      } SG_PACK BIOS_PARAMS, *PBIOS_PARAMS;

      typedef union _BIOS_PARAMS_UNION {
         BIOS_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK BIOS_PARAMS_UNION, *PBIOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__BIOS_PARAMS_UNION, sizeof (BIOS_PARAMS_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BIOS_PARAMS {
         union {
            struct { 
               UEXACT8 discover_boottarget;
               UEXACT8 rsvd0[3];
               UEXACT8 auto_discovery_flags;
               UEXACT8 rsvd1[3];
               UEXACT8 bios_int13_enabled;
               UEXACT8 int13_en_per_func;
               UEXACT8 rsvd2[1];
               UEXACT8 ibft_addr_valid;
               UEXACT8 remote_configuration;
               UEXACT8 ibft_pci_address[3];
               UEXACT32 bios_ver;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK BIOS_PARAMS, *PBIOS_PARAMS;

      SG_C_ASSERT(__sizeof__BIOS_PARAMS, sizeof (BIOS_PARAMS) == 20);

   #else
      typedef struct _BIOS_PARAMS {
         UEXACT8 discover_boottarget;
         UEXACT8 rsvd0[3];
         UEXACT8 auto_discovery_flags;
         UEXACT8 rsvd1[3];
         UEXACT8 bios_int13_enabled;
         UEXACT8 int13_en_per_func;
         UEXACT8 rsvd2[1];
         UEXACT8 ibft_addr_valid;
         UEXACT8 remote_configuration;
         UEXACT8 ibft_pci_address[3];
         UEXACT32 bios_ver;
      } SG_PACK BIOS_PARAMS, *PBIOS_PARAMS;

      typedef union _BIOS_PARAMS_UNION {
         BIOS_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK BIOS_PARAMS_UNION, *PBIOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__BIOS_PARAMS_UNION, sizeof (BIOS_PARAMS_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // OPCODE_GET/SET_BIOS_CONFIGURAION : BIOS Only IOCTL get/set BIOS configuration parms.
   typedef struct _IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION {
      IOCTL_HEADER header;
      BIOS_PARAMS bios_configuration;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION, *PIOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION;



#else
   // OPCODE_GET/SET_BIOS_CONFIGURAION : BIOS Only IOCTL get/set BIOS configuration parms.
   typedef struct _IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION {
      IOCTL_HEADER header;
      BIOS_PARAMS bios_configuration;
   } SG_PACK IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION, *PIOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION;



#endif

typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION IOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION* PIOCTL_ISCSI_INI_BOOT_GET_BIOS_CONFIGURATION;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION IOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION;


typedef IOCTL_ISCSI_INI_BOOT_BIOS_CONFIGURATION* PIOCTL_ISCSI_INI_BOOT_SET_BIOS_CONFIGURATION;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_boot_bmap_h__

