/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_stats_bmap_h__
#define __ioctl_iscsi_ini_stats_bmap_h__
#include "setypes.h"
#include "ioctl_defs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _MIB_ISCSI_STATISTICS {
      UEXACT32 iscsi_cmd_pdus;
      UEXACT32 iscsi_rsp_pdus;
      UEXACT64 iscsi_tx_data_octets;
      UEXACT64 iscsi_rx_data_octets;
      UEXACT32 iscsi_digest_errors;
      UEXACT32 iscsi_cxn_timeout_errors;
      UEXACT32 iscsi_format_errors;
      UEXACT32 rsvd0;
   } SG_PACK MIB_ISCSI_STATISTICS, *PMIB_ISCSI_STATISTICS;



#else
   
   typedef struct _MIB_ISCSI_STATISTICS {
      UEXACT32 iscsi_cmd_pdus;
      UEXACT32 iscsi_rsp_pdus;
      UEXACT64 iscsi_tx_data_octets;
      UEXACT64 iscsi_rx_data_octets;
      UEXACT32 iscsi_digest_errors;
      UEXACT32 iscsi_cxn_timeout_errors;
      UEXACT32 iscsi_format_errors;
      UEXACT32 rsvd0;
   } SG_PACK MIB_ISCSI_STATISTICS, *PMIB_ISCSI_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_INITIATOR_INSTANCE_STATISTICS {
         union {
            struct { 
               UEXACT32 iscsi_ctl_portal_count;
               UEXACT32 iscsi_ctl_node_count;
               UEXACT32 iscsi_ctl_session_count;
               UEXACT32 iscsi_ctl_ssn_failure_count;
               UEXACT32 iscsi_ctl_last_ssn_failure_type;
               EXACT8 iscsi_ctl_last_ssn_rmt_node_name[224];
               UEXACT32 iscsi_ctl_ssn_digest_errors;
               UEXACT32 iscsi_ctl_ssn_cxn_timeout_errors;
               UEXACT32 iscsi_ctl_ssn_format_errors;
               UEXACT32 iscsi_session_handle;
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS, *PMIB_INITIATOR_INSTANCE_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_INITIATOR_INSTANCE_STATISTICS, sizeof (MIB_INITIATOR_INSTANCE_STATISTICS) == 264);

   #else
      typedef struct _MIB_INITIATOR_INSTANCE_STATISTICS {
         UEXACT32 iscsi_ctl_portal_count;
         UEXACT32 iscsi_ctl_node_count;
         UEXACT32 iscsi_ctl_session_count;
         UEXACT32 iscsi_ctl_ssn_failure_count;
         UEXACT32 iscsi_ctl_last_ssn_failure_type;
         EXACT8 iscsi_ctl_last_ssn_rmt_node_name[224];
         UEXACT32 iscsi_ctl_ssn_digest_errors;
         UEXACT32 iscsi_ctl_ssn_cxn_timeout_errors;
         UEXACT32 iscsi_ctl_ssn_format_errors;
         UEXACT32 iscsi_session_handle;
         UEXACT32 rsvd0;
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS, *PMIB_INITIATOR_INSTANCE_STATISTICS;

      typedef union _MIB_INITIATOR_INSTANCE_STATISTICS_UNION {
         MIB_INITIATOR_INSTANCE_STATISTICS bits;
         u32 dw[66]; // dword union
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS_UNION, *PMIB_INITIATOR_INSTANCE_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_INITIATOR_INSTANCE_STATISTICS_UNION, sizeof (MIB_INITIATOR_INSTANCE_STATISTICS_UNION) == 264);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_INITIATOR_INSTANCE_STATISTICS {
         union {
            struct { 
               UEXACT32 iscsi_ctl_portal_count;
               UEXACT32 iscsi_ctl_node_count;
               UEXACT32 iscsi_ctl_session_count;
               UEXACT32 iscsi_ctl_ssn_failure_count;
               UEXACT32 iscsi_ctl_last_ssn_failure_type;
               EXACT8 iscsi_ctl_last_ssn_rmt_node_name[224];
               UEXACT32 iscsi_ctl_ssn_digest_errors;
               UEXACT32 iscsi_ctl_ssn_cxn_timeout_errors;
               UEXACT32 iscsi_ctl_ssn_format_errors;
               UEXACT32 iscsi_session_handle;
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS, *PMIB_INITIATOR_INSTANCE_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_INITIATOR_INSTANCE_STATISTICS, sizeof (MIB_INITIATOR_INSTANCE_STATISTICS) == 264);

   #else
      typedef struct _MIB_INITIATOR_INSTANCE_STATISTICS {
         UEXACT32 iscsi_ctl_portal_count;
         UEXACT32 iscsi_ctl_node_count;
         UEXACT32 iscsi_ctl_session_count;
         UEXACT32 iscsi_ctl_ssn_failure_count;
         UEXACT32 iscsi_ctl_last_ssn_failure_type;
         EXACT8 iscsi_ctl_last_ssn_rmt_node_name[224];
         UEXACT32 iscsi_ctl_ssn_digest_errors;
         UEXACT32 iscsi_ctl_ssn_cxn_timeout_errors;
         UEXACT32 iscsi_ctl_ssn_format_errors;
         UEXACT32 iscsi_session_handle;
         UEXACT32 rsvd0;
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS, *PMIB_INITIATOR_INSTANCE_STATISTICS;

      typedef union _MIB_INITIATOR_INSTANCE_STATISTICS_UNION {
         MIB_INITIATOR_INSTANCE_STATISTICS bits;
         u32 dw[66]; // dword union
      } SG_PACK MIB_INITIATOR_INSTANCE_STATISTICS_UNION, *PMIB_INITIATOR_INSTANCE_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_INITIATOR_INSTANCE_STATISTICS_UNION, sizeof (MIB_INITIATOR_INSTANCE_STATISTICS_UNION) == 264);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS {
      IOCTL_HEADER header;
      MIB_INITIATOR_INSTANCE_STATISTICS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS {
      IOCTL_HEADER header;
      MIB_INITIATOR_INSTANCE_STATISTICS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_INSTANCE_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_INTR_LOGIN_STATISTICS {
         union {
            struct { 
               EXACT8 iscsi_node_name[224];
               UEXACT32 iscsi_intr_login_failures;
               UEXACT32 iscsi_intr_last_failure_time;
               UEXACT32 iscsi_intr_last_failure_type;
               EXACT8 iscsi_intr_last_tgt_failure_name[224];
               UEXACT32 iscsi_intr_last_tgt_failure_type;
               IP_ADDRESS_FORMAT iscsi_intr_last_tgt_failure_addr;
               UEXACT32 iscsi_intr_login_accept_rsps;
               UEXACT32 iscsi_intr_login_other_fail_rsps;
               UEXACT32 iscsi_intr_login_redirect_rsps;
               UEXACT32 iscsi_intr_login_auth_fail_rsps;
               UEXACT32 iscsi_intr_login_authenticate_fails;
               UEXACT32 iscsi_intr_login_negotiate_fails;
               UEXACT32 iscsi_intr_logout_normals;
               UEXACT32 iscsi_intr_logout_others;
            } SG_PACK ; // unnamed struct
            u32 dw[130]; // dword union
         }; // unnamed union
      } SG_PACK MIB_INTR_LOGIN_STATISTICS, *PMIB_INTR_LOGIN_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_INTR_LOGIN_STATISTICS, sizeof (MIB_INTR_LOGIN_STATISTICS) == 520);

   #else
      typedef struct _MIB_INTR_LOGIN_STATISTICS {
         EXACT8 iscsi_node_name[224];
         UEXACT32 iscsi_intr_login_failures;
         UEXACT32 iscsi_intr_last_failure_time;
         UEXACT32 iscsi_intr_last_failure_type;
         EXACT8 iscsi_intr_last_tgt_failure_name[224];
         UEXACT32 iscsi_intr_last_tgt_failure_type;
         IP_ADDRESS_FORMAT iscsi_intr_last_tgt_failure_addr;
         UEXACT32 iscsi_intr_login_accept_rsps;
         UEXACT32 iscsi_intr_login_other_fail_rsps;
         UEXACT32 iscsi_intr_login_redirect_rsps;
         UEXACT32 iscsi_intr_login_auth_fail_rsps;
         UEXACT32 iscsi_intr_login_authenticate_fails;
         UEXACT32 iscsi_intr_login_negotiate_fails;
         UEXACT32 iscsi_intr_logout_normals;
         UEXACT32 iscsi_intr_logout_others;
      } SG_PACK MIB_INTR_LOGIN_STATISTICS, *PMIB_INTR_LOGIN_STATISTICS;

      typedef union _MIB_INTR_LOGIN_STATISTICS_UNION {
         MIB_INTR_LOGIN_STATISTICS bits;
         u32 dw[130]; // dword union
      } SG_PACK MIB_INTR_LOGIN_STATISTICS_UNION, *PMIB_INTR_LOGIN_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_INTR_LOGIN_STATISTICS_UNION, sizeof (MIB_INTR_LOGIN_STATISTICS_UNION) == 520);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_INTR_LOGIN_STATISTICS {
         union {
            struct { 
               EXACT8 iscsi_node_name[224];
               UEXACT32 iscsi_intr_login_failures;
               UEXACT32 iscsi_intr_last_failure_time;
               UEXACT32 iscsi_intr_last_failure_type;
               EXACT8 iscsi_intr_last_tgt_failure_name[224];
               UEXACT32 iscsi_intr_last_tgt_failure_type;
               IP_ADDRESS_FORMAT iscsi_intr_last_tgt_failure_addr;
               UEXACT32 iscsi_intr_login_accept_rsps;
               UEXACT32 iscsi_intr_login_other_fail_rsps;
               UEXACT32 iscsi_intr_login_redirect_rsps;
               UEXACT32 iscsi_intr_login_auth_fail_rsps;
               UEXACT32 iscsi_intr_login_authenticate_fails;
               UEXACT32 iscsi_intr_login_negotiate_fails;
               UEXACT32 iscsi_intr_logout_normals;
               UEXACT32 iscsi_intr_logout_others;
            } SG_PACK ; // unnamed struct
            u32 dw[130]; // dword union
         }; // unnamed union
      } SG_PACK MIB_INTR_LOGIN_STATISTICS, *PMIB_INTR_LOGIN_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_INTR_LOGIN_STATISTICS, sizeof (MIB_INTR_LOGIN_STATISTICS) == 520);

   #else
      typedef struct _MIB_INTR_LOGIN_STATISTICS {
         EXACT8 iscsi_node_name[224];
         UEXACT32 iscsi_intr_login_failures;
         UEXACT32 iscsi_intr_last_failure_time;
         UEXACT32 iscsi_intr_last_failure_type;
         EXACT8 iscsi_intr_last_tgt_failure_name[224];
         UEXACT32 iscsi_intr_last_tgt_failure_type;
         IP_ADDRESS_FORMAT iscsi_intr_last_tgt_failure_addr;
         UEXACT32 iscsi_intr_login_accept_rsps;
         UEXACT32 iscsi_intr_login_other_fail_rsps;
         UEXACT32 iscsi_intr_login_redirect_rsps;
         UEXACT32 iscsi_intr_login_auth_fail_rsps;
         UEXACT32 iscsi_intr_login_authenticate_fails;
         UEXACT32 iscsi_intr_login_negotiate_fails;
         UEXACT32 iscsi_intr_logout_normals;
         UEXACT32 iscsi_intr_logout_others;
      } SG_PACK MIB_INTR_LOGIN_STATISTICS, *PMIB_INTR_LOGIN_STATISTICS;

      typedef union _MIB_INTR_LOGIN_STATISTICS_UNION {
         MIB_INTR_LOGIN_STATISTICS bits;
         u32 dw[130]; // dword union
      } SG_PACK MIB_INTR_LOGIN_STATISTICS_UNION, *PMIB_INTR_LOGIN_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_INTR_LOGIN_STATISTICS_UNION, sizeof (MIB_INTR_LOGIN_STATISTICS_UNION) == 520);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS {
      IOCTL_HEADER header;
      MIB_INTR_LOGIN_STATISTICS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS {
      IOCTL_HEADER header;
      MIB_INTR_LOGIN_STATISTICS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_LOGIN_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 magic_number;
               UEXACT32 session_id_count;
               UEXACT32 session_id_list[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN, *PGET_SESSION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_IN, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_IN) == 12);

   #else
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 magic_number;
         UEXACT32 session_id_count;
         UEXACT32 session_id_list[1];
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN, *PGET_SESSION_ATTRIBUTES_PARAMS_IN;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 magic_number;
               UEXACT32 session_id_count;
               UEXACT32 session_id_list[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN, *PGET_SESSION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_IN, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_IN) == 12);

   #else
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 magic_number;
         UEXACT32 session_id_count;
         UEXACT32 session_id_list[1];
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN, *PGET_SESSION_ATTRIBUTES_PARAMS_IN;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_SESSION_ATTRIBUTES {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 iscsi_ssn_direction;
               EXACT8 iscsi_initiator_alias[32];
               EXACT8 iscsi_target_alias[32];
               MIB_ISCSI_STATISTICS iscsi_ssn_statistics;
               MGMT_SESSION_INFO iscsi_ssn_info;
            } SG_PACK ; // unnamed struct
            u32 dw[319]; // dword union
         }; // unnamed union
      } SG_PACK MIB_SESSION_ATTRIBUTES, *PMIB_SESSION_ATTRIBUTES;

      SG_C_ASSERT(__sizeof__MIB_SESSION_ATTRIBUTES, sizeof (MIB_SESSION_ATTRIBUTES) == 1276);

   #else
      typedef struct _MIB_SESSION_ATTRIBUTES {
         UEXACT32 session_handle;
         UEXACT32 iscsi_ssn_direction;
         EXACT8 iscsi_initiator_alias[32];
         EXACT8 iscsi_target_alias[32];
         MIB_ISCSI_STATISTICS iscsi_ssn_statistics;
         MGMT_SESSION_INFO iscsi_ssn_info;
      } SG_PACK MIB_SESSION_ATTRIBUTES, *PMIB_SESSION_ATTRIBUTES;

      typedef union _MIB_SESSION_ATTRIBUTES_UNION {
         MIB_SESSION_ATTRIBUTES bits;
         u32 dw[319]; // dword union
      } SG_PACK MIB_SESSION_ATTRIBUTES_UNION, *PMIB_SESSION_ATTRIBUTES_UNION;

      SG_C_ASSERT(__sizeof__MIB_SESSION_ATTRIBUTES_UNION, sizeof (MIB_SESSION_ATTRIBUTES_UNION) == 1276);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_SESSION_ATTRIBUTES {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 iscsi_ssn_direction;
               EXACT8 iscsi_initiator_alias[32];
               EXACT8 iscsi_target_alias[32];
               MIB_ISCSI_STATISTICS iscsi_ssn_statistics;
               MGMT_SESSION_INFO iscsi_ssn_info;
            } SG_PACK ; // unnamed struct
            u32 dw[319]; // dword union
         }; // unnamed union
      } SG_PACK MIB_SESSION_ATTRIBUTES, *PMIB_SESSION_ATTRIBUTES;

      SG_C_ASSERT(__sizeof__MIB_SESSION_ATTRIBUTES, sizeof (MIB_SESSION_ATTRIBUTES) == 1276);

   #else
      typedef struct _MIB_SESSION_ATTRIBUTES {
         UEXACT32 session_handle;
         UEXACT32 iscsi_ssn_direction;
         EXACT8 iscsi_initiator_alias[32];
         EXACT8 iscsi_target_alias[32];
         MIB_ISCSI_STATISTICS iscsi_ssn_statistics;
         MGMT_SESSION_INFO iscsi_ssn_info;
      } SG_PACK MIB_SESSION_ATTRIBUTES, *PMIB_SESSION_ATTRIBUTES;

      typedef union _MIB_SESSION_ATTRIBUTES_UNION {
         MIB_SESSION_ATTRIBUTES bits;
         u32 dw[319]; // dword union
      } SG_PACK MIB_SESSION_ATTRIBUTES_UNION, *PMIB_SESSION_ATTRIBUTES_UNION;

      SG_C_ASSERT(__sizeof__MIB_SESSION_ATTRIBUTES_UNION, sizeof (MIB_SESSION_ATTRIBUTES_UNION) == 1276);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
               UEXACT32 session_attribs_count;
               MIB_SESSION_ATTRIBUTES session_attribs[1];
            } SG_PACK ; // unnamed struct
            u32 dw[321]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_OUT, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_OUT) == 1284);

   #else
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_OUT {
         UEXACT32 rsvd0;
         UEXACT32 session_attribs_count;
         MIB_SESSION_ATTRIBUTES session_attribs[1];
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[321]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION) == 1284);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
               UEXACT32 session_attribs_count;
               MIB_SESSION_ATTRIBUTES session_attribs[1];
            } SG_PACK ; // unnamed struct
            u32 dw[321]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_OUT, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_OUT) == 1284);

   #else
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS_OUT {
         UEXACT32 rsvd0;
         UEXACT32 session_attribs_count;
         MIB_SESSION_ATTRIBUTES session_attribs[1];
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[321]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_OUT_UNION) == 1284);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS {
         union {
            union { 
               GET_SESSION_ATTRIBUTES_PARAMS_IN request;
               GET_SESSION_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[321]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS, *PGET_SESSION_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS, sizeof (GET_SESSION_ATTRIBUTES_PARAMS) == 1284);

   #else
      typedef union _GET_SESSION_ATTRIBUTES_PARAMS {
         GET_SESSION_ATTRIBUTES_PARAMS_IN request;
         GET_SESSION_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS, *PGET_SESSION_ATTRIBUTES_PARAMS;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS bits;
         u32 dw[321]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_UNION) == 1284);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_SESSION_ATTRIBUTES_PARAMS {
         union {
            union { 
               GET_SESSION_ATTRIBUTES_PARAMS_IN request;
               GET_SESSION_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[321]; // dword union
         }; // unnamed union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS, *PGET_SESSION_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS, sizeof (GET_SESSION_ATTRIBUTES_PARAMS) == 1284);

   #else
      typedef union _GET_SESSION_ATTRIBUTES_PARAMS {
         GET_SESSION_ATTRIBUTES_PARAMS_IN request;
         GET_SESSION_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS, *PGET_SESSION_ATTRIBUTES_PARAMS;

      typedef union _GET_SESSION_ATTRIBUTES_PARAMS_UNION {
         GET_SESSION_ATTRIBUTES_PARAMS bits;
         u32 dw[321]; // dword union
      } SG_PACK GET_SESSION_ATTRIBUTES_PARAMS_UNION, *PGET_SESSION_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_SESSION_ATTRIBUTES_PARAMS_UNION, sizeof (GET_SESSION_ATTRIBUTES_PARAMS_UNION) == 1284);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_SESSION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES, *PIOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_SESSION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES, *PIOCTL_ISCSI_INI_STATS_GET_SESSION_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN, *PGET_A_SESSION_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_IN, sizeof (GET_A_SESSION_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN, *PGET_A_SESSION_STATISTICS_PARAMS_IN;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_IN_UNION {
         GET_A_SESSION_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_IN_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN, *PGET_A_SESSION_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_IN, sizeof (GET_A_SESSION_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN, *PGET_A_SESSION_STATISTICS_PARAMS_IN;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_IN_UNION {
         GET_A_SESSION_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_IN_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_IN_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_SESSION_STATISTICS {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 rsvd0;
               UEXACT8 target_name[224];
               MIB_ISCSI_STATISTICS iscsi_ssn_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK MIB_SESSION_STATISTICS, *PMIB_SESSION_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_SESSION_STATISTICS, sizeof (MIB_SESSION_STATISTICS) == 272);

   #else
      typedef struct _MIB_SESSION_STATISTICS {
         UEXACT32 session_handle;
         UEXACT32 rsvd0;
         UEXACT8 target_name[224];
         MIB_ISCSI_STATISTICS iscsi_ssn_stats;
      } SG_PACK MIB_SESSION_STATISTICS, *PMIB_SESSION_STATISTICS;

      typedef union _MIB_SESSION_STATISTICS_UNION {
         MIB_SESSION_STATISTICS bits;
         u32 dw[68]; // dword union
      } SG_PACK MIB_SESSION_STATISTICS_UNION, *PMIB_SESSION_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_SESSION_STATISTICS_UNION, sizeof (MIB_SESSION_STATISTICS_UNION) == 272);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_SESSION_STATISTICS {
         union {
            struct { 
               UEXACT32 session_handle;
               UEXACT32 rsvd0;
               UEXACT8 target_name[224];
               MIB_ISCSI_STATISTICS iscsi_ssn_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK MIB_SESSION_STATISTICS, *PMIB_SESSION_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_SESSION_STATISTICS, sizeof (MIB_SESSION_STATISTICS) == 272);

   #else
      typedef struct _MIB_SESSION_STATISTICS {
         UEXACT32 session_handle;
         UEXACT32 rsvd0;
         UEXACT8 target_name[224];
         MIB_ISCSI_STATISTICS iscsi_ssn_stats;
      } SG_PACK MIB_SESSION_STATISTICS, *PMIB_SESSION_STATISTICS;

      typedef union _MIB_SESSION_STATISTICS_UNION {
         MIB_SESSION_STATISTICS bits;
         u32 dw[68]; // dword union
      } SG_PACK MIB_SESSION_STATISTICS_UNION, *PMIB_SESSION_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_SESSION_STATISTICS_UNION, sizeof (MIB_SESSION_STATISTICS_UNION) == 272);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_OUT {
         union {
            struct { 
               MIB_SESSION_STATISTICS session_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT, *PGET_A_SESSION_STATISTICS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_OUT, sizeof (GET_A_SESSION_STATISTICS_PARAMS_OUT) == 272);

   #else
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_OUT {
         MIB_SESSION_STATISTICS session_stats;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT, *PGET_A_SESSION_STATISTICS_PARAMS_OUT;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION {
         GET_A_SESSION_STATISTICS_PARAMS_OUT bits;
         u32 dw[68]; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION) == 272);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_OUT {
         union {
            struct { 
               MIB_SESSION_STATISTICS session_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT, *PGET_A_SESSION_STATISTICS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_OUT, sizeof (GET_A_SESSION_STATISTICS_PARAMS_OUT) == 272);

   #else
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS_OUT {
         MIB_SESSION_STATISTICS session_stats;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT, *PGET_A_SESSION_STATISTICS_PARAMS_OUT;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION {
         GET_A_SESSION_STATISTICS_PARAMS_OUT bits;
         u32 dw[68]; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_OUT_UNION) == 272);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS {
         union {
            union { 
               GET_A_SESSION_STATISTICS_PARAMS_IN request;
               GET_A_SESSION_STATISTICS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS, *PGET_A_SESSION_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS, sizeof (GET_A_SESSION_STATISTICS_PARAMS) == 272);

   #else
      typedef union _GET_A_SESSION_STATISTICS_PARAMS {
         GET_A_SESSION_STATISTICS_PARAMS_IN request;
         GET_A_SESSION_STATISTICS_PARAMS_OUT response;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS, *PGET_A_SESSION_STATISTICS_PARAMS;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_UNION {
         GET_A_SESSION_STATISTICS_PARAMS bits;
         u32 dw[68]; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_UNION) == 272);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_A_SESSION_STATISTICS_PARAMS {
         union {
            union { 
               GET_A_SESSION_STATISTICS_PARAMS_IN request;
               GET_A_SESSION_STATISTICS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS, *PGET_A_SESSION_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS, sizeof (GET_A_SESSION_STATISTICS_PARAMS) == 272);

   #else
      typedef union _GET_A_SESSION_STATISTICS_PARAMS {
         GET_A_SESSION_STATISTICS_PARAMS_IN request;
         GET_A_SESSION_STATISTICS_PARAMS_OUT response;
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS, *PGET_A_SESSION_STATISTICS_PARAMS;

      typedef union _GET_A_SESSION_STATISTICS_PARAMS_UNION {
         GET_A_SESSION_STATISTICS_PARAMS bits;
         u32 dw[68]; // dword union
      } SG_PACK GET_A_SESSION_STATISTICS_PARAMS_UNION, *PGET_A_SESSION_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_A_SESSION_STATISTICS_PARAMS_UNION, sizeof (GET_A_SESSION_STATISTICS_PARAMS_UNION) == 272);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS {
      IOCTL_HEADER header;
      GET_A_SESSION_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS {
      IOCTL_HEADER header;
      GET_A_SESSION_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_A_SESSION_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN, *PGET_CONN_STATISTICS_PER_SESSION_IN;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_IN, sizeof (GET_CONN_STATISTICS_PER_SESSION_IN) == 4);

   #else
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN, *PGET_CONN_STATISTICS_PER_SESSION_IN;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_IN_UNION {
         GET_CONN_STATISTICS_PER_SESSION_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN_UNION, *PGET_CONN_STATISTICS_PER_SESSION_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_IN_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_IN {
         union {
            struct { 
               UEXACT32 session_handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN, *PGET_CONN_STATISTICS_PER_SESSION_IN;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_IN, sizeof (GET_CONN_STATISTICS_PER_SESSION_IN) == 4);

   #else
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_IN {
         UEXACT32 session_handle;
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN, *PGET_CONN_STATISTICS_PER_SESSION_IN;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_IN_UNION {
         GET_CONN_STATISTICS_PER_SESSION_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_IN_UNION, *PGET_CONN_STATISTICS_PER_SESSION_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_IN_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // BE supports maximum 4 connections per session. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_CONNECTION_STATISTICS {
         union {
            struct { 
               UEXACT32 cid;
               UEXACT32 rsvd0;
               MIB_ISCSI_STATISTICS iscsi_conn_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MIB_CONNECTION_STATISTICS, *PMIB_CONNECTION_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_CONNECTION_STATISTICS, sizeof (MIB_CONNECTION_STATISTICS) == 48);

   #else
      typedef struct _MIB_CONNECTION_STATISTICS {
         UEXACT32 cid;
         UEXACT32 rsvd0;
         MIB_ISCSI_STATISTICS iscsi_conn_stats;
      } SG_PACK MIB_CONNECTION_STATISTICS, *PMIB_CONNECTION_STATISTICS;

      typedef union _MIB_CONNECTION_STATISTICS_UNION {
         MIB_CONNECTION_STATISTICS bits;
         u32 dw[12]; // dword union
      } SG_PACK MIB_CONNECTION_STATISTICS_UNION, *PMIB_CONNECTION_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_CONNECTION_STATISTICS_UNION, sizeof (MIB_CONNECTION_STATISTICS_UNION) == 48);
   #endif


#else
   // BE supports maximum 4 connections per session. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MIB_CONNECTION_STATISTICS {
         union {
            struct { 
               UEXACT32 cid;
               UEXACT32 rsvd0;
               MIB_ISCSI_STATISTICS iscsi_conn_stats;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK MIB_CONNECTION_STATISTICS, *PMIB_CONNECTION_STATISTICS;

      SG_C_ASSERT(__sizeof__MIB_CONNECTION_STATISTICS, sizeof (MIB_CONNECTION_STATISTICS) == 48);

   #else
      typedef struct _MIB_CONNECTION_STATISTICS {
         UEXACT32 cid;
         UEXACT32 rsvd0;
         MIB_ISCSI_STATISTICS iscsi_conn_stats;
      } SG_PACK MIB_CONNECTION_STATISTICS, *PMIB_CONNECTION_STATISTICS;

      typedef union _MIB_CONNECTION_STATISTICS_UNION {
         MIB_CONNECTION_STATISTICS bits;
         u32 dw[12]; // dword union
      } SG_PACK MIB_CONNECTION_STATISTICS_UNION, *PMIB_CONNECTION_STATISTICS_UNION;

      SG_C_ASSERT(__sizeof__MIB_CONNECTION_STATISTICS_UNION, sizeof (MIB_CONNECTION_STATISTICS_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_OUT {
         union {
            struct { 
               UEXACT32 conn_stats_count;
               UEXACT32 session_handle;
               UEXACT8 target_name[224];
               MIB_CONNECTION_STATISTICS conn_stats[4];
            } SG_PACK ; // unnamed struct
            u32 dw[106]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT, *PGET_CONN_STATISTICS_PER_SESSION_OUT;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_OUT, sizeof (GET_CONN_STATISTICS_PER_SESSION_OUT) == 424);

   #else
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_OUT {
         UEXACT32 conn_stats_count;
         UEXACT32 session_handle;
         UEXACT8 target_name[224];
         MIB_CONNECTION_STATISTICS conn_stats[4];
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT, *PGET_CONN_STATISTICS_PER_SESSION_OUT;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_OUT_UNION {
         GET_CONN_STATISTICS_PER_SESSION_OUT bits;
         u32 dw[106]; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT_UNION, *PGET_CONN_STATISTICS_PER_SESSION_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_OUT_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_OUT_UNION) == 424);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_OUT {
         union {
            struct { 
               UEXACT32 conn_stats_count;
               UEXACT32 session_handle;
               UEXACT8 target_name[224];
               MIB_CONNECTION_STATISTICS conn_stats[4];
            } SG_PACK ; // unnamed struct
            u32 dw[106]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT, *PGET_CONN_STATISTICS_PER_SESSION_OUT;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_OUT, sizeof (GET_CONN_STATISTICS_PER_SESSION_OUT) == 424);

   #else
      typedef struct _GET_CONN_STATISTICS_PER_SESSION_OUT {
         UEXACT32 conn_stats_count;
         UEXACT32 session_handle;
         UEXACT8 target_name[224];
         MIB_CONNECTION_STATISTICS conn_stats[4];
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT, *PGET_CONN_STATISTICS_PER_SESSION_OUT;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_OUT_UNION {
         GET_CONN_STATISTICS_PER_SESSION_OUT bits;
         u32 dw[106]; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_OUT_UNION, *PGET_CONN_STATISTICS_PER_SESSION_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_OUT_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_OUT_UNION) == 424);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION {
         union {
            union { 
               GET_CONN_STATISTICS_PER_SESSION_IN params_in;
               GET_CONN_STATISTICS_PER_SESSION_OUT params_out;
            } SG_PACK ; // unnamed struct
            u32 dw[106]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION, *PGET_CONN_STATISTICS_PER_SESSION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION, sizeof (GET_CONN_STATISTICS_PER_SESSION) == 424);

   #else
      typedef union _GET_CONN_STATISTICS_PER_SESSION {
         GET_CONN_STATISTICS_PER_SESSION_IN params_in;
         GET_CONN_STATISTICS_PER_SESSION_OUT params_out;
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION, *PGET_CONN_STATISTICS_PER_SESSION;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_UNION {
         GET_CONN_STATISTICS_PER_SESSION bits;
         u32 dw[106]; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_UNION, *PGET_CONN_STATISTICS_PER_SESSION_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_UNION) == 424);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONN_STATISTICS_PER_SESSION {
         union {
            union { 
               GET_CONN_STATISTICS_PER_SESSION_IN params_in;
               GET_CONN_STATISTICS_PER_SESSION_OUT params_out;
            } SG_PACK ; // unnamed struct
            u32 dw[106]; // dword union
         }; // unnamed union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION, *PGET_CONN_STATISTICS_PER_SESSION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION, sizeof (GET_CONN_STATISTICS_PER_SESSION) == 424);

   #else
      typedef union _GET_CONN_STATISTICS_PER_SESSION {
         GET_CONN_STATISTICS_PER_SESSION_IN params_in;
         GET_CONN_STATISTICS_PER_SESSION_OUT params_out;
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION, *PGET_CONN_STATISTICS_PER_SESSION;

      typedef union _GET_CONN_STATISTICS_PER_SESSION_UNION {
         GET_CONN_STATISTICS_PER_SESSION bits;
         u32 dw[106]; // dword union
      } SG_PACK GET_CONN_STATISTICS_PER_SESSION_UNION, *PGET_CONN_STATISTICS_PER_SESSION_UNION;

      SG_C_ASSERT(__sizeof__GET_CONN_STATISTICS_PER_SESSION_UNION, sizeof (GET_CONN_STATISTICS_PER_SESSION_UNION) == 424);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION {
      IOCTL_HEADER header;
      GET_CONN_STATISTICS_PER_SESSION params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION, *PIOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION {
      IOCTL_HEADER header;
      GET_CONN_STATISTICS_PER_SESSION params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION, *PIOCTL_ISCSI_INI_STATS_GET_CONN_STATISTICS_PER_SESSION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_IPSEC_STATS {
         union {
            struct { 
               u32 bad_spi_lsd;                   // DWORD 0
               u32 bad_spi_msd;                   // DWORD 1
               u32 bad_decrypt_lsd;               // DWORD 2
               u32 bad_decrypt_msd;               // DWORD 3
               u32 bad_auth_lsd;                  // DWORD 4
               u32 bad_auth_msd;                  // DWORD 5
               u32 good_replay_lsd;               // DWORD 6
               u32 good_replay_msd;               // DWORD 7
               u32 rx_esp_bytes_lsd;              // DWORD 8
               u32 rx_esp_bytes_msd;              // DWORD 9
               u32 rx_ah_bytes_lsd;               // DWORD 10
               u32 rx_ah_bytes_msd;               // DWORD 11
               u32 tx_esp_bytes_lsd;              // DWORD 12
               u32 tx_esp_bytes_msd;              // DWORD 13
               u32 tx_ah_bytes_lsd;               // DWORD 14
               u32 tx_ah_bytes_msd;               // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK BE_IPSEC_STATS, *PBE_IPSEC_STATS;

      SG_C_ASSERT(__sizeof__BE_IPSEC_STATS, sizeof (BE_IPSEC_STATS) == 64);

   #else
      typedef struct _BE_IPSEC_STATS {
         u32 bad_spi_lsd;                         // DWORD 0
         u32 bad_spi_msd;                         // DWORD 1
         u32 bad_decrypt_lsd;                     // DWORD 2
         u32 bad_decrypt_msd;                     // DWORD 3
         u32 bad_auth_lsd;                        // DWORD 4
         u32 bad_auth_msd;                        // DWORD 5
         u32 good_replay_lsd;                     // DWORD 6
         u32 good_replay_msd;                     // DWORD 7
         u32 rx_esp_bytes_lsd;                    // DWORD 8
         u32 rx_esp_bytes_msd;                    // DWORD 9
         u32 rx_ah_bytes_lsd;                     // DWORD 10
         u32 rx_ah_bytes_msd;                     // DWORD 11
         u32 tx_esp_bytes_lsd;                    // DWORD 12
         u32 tx_esp_bytes_msd;                    // DWORD 13
         u32 tx_ah_bytes_lsd;                     // DWORD 14
         u32 tx_ah_bytes_msd;                     // DWORD 15
      } SG_PACK BE_IPSEC_STATS, *PBE_IPSEC_STATS;

      typedef union _BE_IPSEC_STATS_UNION {
         BE_IPSEC_STATS bits;
         u32 dw[16]; // dword union
      } SG_PACK BE_IPSEC_STATS_UNION, *PBE_IPSEC_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_IPSEC_STATS_UNION, sizeof (BE_IPSEC_STATS_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_IPSEC_STATS {
         union {
            struct { 
               u32 bad_spi_lsd;                   // DWORD 0
               u32 bad_spi_msd;                   // DWORD 1
               u32 bad_decrypt_lsd;               // DWORD 2
               u32 bad_decrypt_msd;               // DWORD 3
               u32 bad_auth_lsd;                  // DWORD 4
               u32 bad_auth_msd;                  // DWORD 5
               u32 good_replay_lsd;               // DWORD 6
               u32 good_replay_msd;               // DWORD 7
               u32 rx_esp_bytes_lsd;              // DWORD 8
               u32 rx_esp_bytes_msd;              // DWORD 9
               u32 rx_ah_bytes_lsd;               // DWORD 10
               u32 rx_ah_bytes_msd;               // DWORD 11
               u32 tx_esp_bytes_lsd;              // DWORD 12
               u32 tx_esp_bytes_msd;              // DWORD 13
               u32 tx_ah_bytes_lsd;               // DWORD 14
               u32 tx_ah_bytes_msd;               // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK BE_IPSEC_STATS, *PBE_IPSEC_STATS;

      SG_C_ASSERT(__sizeof__BE_IPSEC_STATS, sizeof (BE_IPSEC_STATS) == 64);

   #else
      typedef struct _BE_IPSEC_STATS {
         u32 bad_spi_lsd;                         // DWORD 0
         u32 bad_spi_msd;                         // DWORD 1
         u32 bad_decrypt_lsd;                     // DWORD 2
         u32 bad_decrypt_msd;                     // DWORD 3
         u32 bad_auth_lsd;                        // DWORD 4
         u32 bad_auth_msd;                        // DWORD 5
         u32 good_replay_lsd;                     // DWORD 6
         u32 good_replay_msd;                     // DWORD 7
         u32 rx_esp_bytes_lsd;                    // DWORD 8
         u32 rx_esp_bytes_msd;                    // DWORD 9
         u32 rx_ah_bytes_lsd;                     // DWORD 10
         u32 rx_ah_bytes_msd;                     // DWORD 11
         u32 tx_esp_bytes_lsd;                    // DWORD 12
         u32 tx_esp_bytes_msd;                    // DWORD 13
         u32 tx_ah_bytes_lsd;                     // DWORD 14
         u32 tx_ah_bytes_msd;                     // DWORD 15
      } SG_PACK BE_IPSEC_STATS, *PBE_IPSEC_STATS;

      typedef union _BE_IPSEC_STATS_UNION {
         BE_IPSEC_STATS bits;
         u32 dw[16]; // dword union
      } SG_PACK BE_IPSEC_STATS_UNION, *PBE_IPSEC_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_IPSEC_STATS_UNION, sizeof (BE_IPSEC_STATS_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN;

      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION {
         IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN;

      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION {
         IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS {
         union {
            union { 
               BE_IPSEC_STATS response;
               IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS) == 64);

   #else
      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS {
         BE_IPSEC_STATS response;
         IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN request;
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS;

      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION {
         IOCTL_GET_IPSEC_STATISTICS_PARAMS bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_GET_IPSEC_STATISTICS_PARAMS {
         union {
            union { 
               BE_IPSEC_STATS response;
               IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS) == 64);

   #else
      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS {
         BE_IPSEC_STATS response;
         IOCTL_GET_IPSEC_STATISTICS_PARAMS_IN request;
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS;

      typedef union _IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION {
         IOCTL_GET_IPSEC_STATISTICS_PARAMS bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION, *PIOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION, sizeof (IOCTL_GET_IPSEC_STATISTICS_PARAMS_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS {
      IOCTL_HEADER header;
      IOCTL_GET_IPSEC_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS;



#else
   
   typedef struct _IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS {
      IOCTL_HEADER header;
      IOCTL_GET_IPSEC_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS, *PIOCTL_ISCSI_INI_STATS_GET_IPSEC_STATISTICS;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_stats_bmap_h__

