/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_target_discovery_bmap_h__
#define __ioctl_iscsi_target_discovery_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISNS_SEND_PACKET_IN {
      MGMT_ISNS_SERVER isns_server;
      UEXACT32 send_xmit_len;
      UEXACT8 payload[1];
   } SG_PACK ISNS_SEND_PACKET_IN, *PISNS_SEND_PACKET_IN;



#else
   
   typedef struct _ISNS_SEND_PACKET_IN {
      MGMT_ISNS_SERVER isns_server;
      UEXACT32 send_xmit_len;
      UEXACT8 payload[1];
   } SG_PACK ISNS_SEND_PACKET_IN, *PISNS_SEND_PACKET_IN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISNS_SEND_PACKET_OUT {
      UEXACT8 payload[1];
   } SG_PACK ISNS_SEND_PACKET_OUT, *PISNS_SEND_PACKET_OUT;



#else
   
   typedef struct _ISNS_SEND_PACKET_OUT {
      UEXACT8 payload[1];
   } SG_PACK ISNS_SEND_PACKET_OUT, *PISNS_SEND_PACKET_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS {
      ISNS_SEND_PACKET_IN request;
      ISNS_SEND_PACKET_OUT response;
   } SG_PACK IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS;



#else
   
   typedef union _IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS {
      ISNS_SEND_PACKET_IN request;
      ISNS_SEND_PACKET_OUT response;
   } SG_PACK IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will be used to send a isns packet to the iSNS server. this packet is
   // expected to be fully prepared according RFC 3271. no protocol related checks will be
   // done in ARM Firmware.  Originator(s) : Management application  Implemented in:
   // Firmware  Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_ISNS_ADDRESS
   //  - MGMT_STATUS_INVALID_TCPPORT 
   typedef struct _IOCTL_ISCSI_TGT_ISNS_SEND_PACKET {
      IOCTL_HEADER header;
      IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_ISNS_SEND_PACKET, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET;



#else
   // This IOCTL will be used to send a isns packet to the iSNS server. this packet is
   // expected to be fully prepared according RFC 3271. no protocol related checks will be
   // done in ARM Firmware.  Originator(s) : Management application  Implemented in:
   // Firmware  Return Values :  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_INVALID_ISNS_ADDRESS
   //  - MGMT_STATUS_INVALID_TCPPORT 
   typedef struct _IOCTL_ISCSI_TGT_ISNS_SEND_PACKET {
      IOCTL_HEADER header;
      IOCTL_ISCSI_TGT_ISNS_SEND_PACKET_PARAMS params;
   } SG_PACK IOCTL_ISCSI_TGT_ISNS_SEND_PACKET, *PIOCTL_ISCSI_TGT_ISNS_SEND_PACKET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_ISCSI_TGT_ESI_LISTEN {
      IOCTL_HEADER header;
      MGMT_PORTAL esi_format;
   } SG_PACK IOCTL_ISCSI_TGT_ESI_LISTEN, *PIOCTL_ISCSI_TGT_ESI_LISTEN;



#else
   
   typedef struct _IOCTL_ISCSI_TGT_ESI_LISTEN {
      IOCTL_HEADER header;
      MGMT_PORTAL esi_format;
   } SG_PACK IOCTL_ISCSI_TGT_ESI_LISTEN, *PIOCTL_ISCSI_TGT_ESI_LISTEN;



#endif

typedef IOCTL_ISCSI_TGT_ESI_LISTEN IOCTL_ISCSI_TGT_START_ESI_LISTEN;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN* PIOCTL_ISCSI_TGT_START_ESI_LISTEN;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN IOCTL_ISCSI_TGT_STOP_ESI_LISTEN;


typedef IOCTL_ISCSI_TGT_ESI_LISTEN* PIOCTL_ISCSI_TGT_STOP_ESI_LISTEN;


#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_target_discovery_bmap_h__

