/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mcc_bmap_h__
#define __ioctl_mcc_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "nativedefs_bmap.h"
#include "ioctl_defs_bmap.h"
#include "ioctl_opcodes_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Where applicable, a WRB, may contain a list of Scatter-gather elements. Each element
   // supports a 64 bit address and a 32bit length field. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_SGE {
         union {
            struct { 
               u32 pa_lo;                         // DWORD 0
               u32 pa_hi;                         // DWORD 1
               u32 length;                        // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK MCC_SGE, *PMCC_SGE;

      SG_C_ASSERT(__sizeof__MCC_SGE, sizeof (MCC_SGE) == 12);

   #else
      typedef struct _MCC_SGE {
         u32 pa_lo;                               // DWORD 0
         u32 pa_hi;                               // DWORD 1
         u32 length;                              // DWORD 2
      } SG_PACK MCC_SGE, *PMCC_SGE;

      typedef union _MCC_SGE_UNION {
         MCC_SGE bits;
         u32 dw[3]; // dword union
      } SG_PACK MCC_SGE_UNION, *PMCC_SGE_UNION;

      SG_C_ASSERT(__sizeof__MCC_SGE_UNION, sizeof (MCC_SGE_UNION) == 12);
   #endif


#else
   // Where applicable, a WRB, may contain a list of Scatter-gather elements. Each element
   // supports a 64 bit address and a 32bit length field. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_SGE {
         union {
            struct { 
               u32 pa_lo;                         // DWORD 0
               u32 pa_hi;                         // DWORD 1
               u32 length;                        // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK MCC_SGE, *PMCC_SGE;

      SG_C_ASSERT(__sizeof__MCC_SGE, sizeof (MCC_SGE) == 12);

   #else
      typedef struct _MCC_SGE {
         u32 pa_lo;                               // DWORD 0
         u32 pa_hi;                               // DWORD 1
         u32 length;                              // DWORD 2
      } SG_PACK MCC_SGE, *PMCC_SGE;

      typedef union _MCC_SGE_UNION {
         MCC_SGE bits;
         u32 dw[3]; // dword union
      } SG_PACK MCC_SGE_UNION, *PMCC_SGE_UNION;

      SG_C_ASSERT(__sizeof__MCC_SGE_UNION, sizeof (MCC_SGE_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The design of an MCC_SGE allows up to 19 elements to be embedded in a WRB,
   // supporting 64KB data transfers (assuming a 4KB page size). 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_WRB_PAYLOAD {
         union {
            union { 
               MCC_SGE sgl[19];
               u32 embedded[59];                  // DWORDS 0 to 58
            } SG_PACK ; // unnamed struct
            u32 dw[59]; // dword union
         }; // unnamed union
      } SG_PACK MCC_WRB_PAYLOAD, *PMCC_WRB_PAYLOAD;

      SG_C_ASSERT(__sizeof__MCC_WRB_PAYLOAD, sizeof (MCC_WRB_PAYLOAD) == 236);

   #else
      typedef union _MCC_WRB_PAYLOAD {
         MCC_SGE sgl[19];
         u32 embedded[59];                        // DWORDS 0 to 58
      } SG_PACK MCC_WRB_PAYLOAD, *PMCC_WRB_PAYLOAD;

      typedef union _MCC_WRB_PAYLOAD_UNION {
         MCC_WRB_PAYLOAD bits;
         u32 dw[59]; // dword union
      } SG_PACK MCC_WRB_PAYLOAD_UNION, *PMCC_WRB_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__MCC_WRB_PAYLOAD_UNION, sizeof (MCC_WRB_PAYLOAD_UNION) == 236);
   #endif


#else
   // The design of an MCC_SGE allows up to 19 elements to be embedded in a WRB,
   // supporting 64KB data transfers (assuming a 4KB page size). 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_WRB_PAYLOAD {
         union {
            union { 
               MCC_SGE sgl[19];
               u32 embedded[59];                  // DWORDS 0 to 58
            } SG_PACK ; // unnamed struct
            u32 dw[59]; // dword union
         }; // unnamed union
      } SG_PACK MCC_WRB_PAYLOAD, *PMCC_WRB_PAYLOAD;

      SG_C_ASSERT(__sizeof__MCC_WRB_PAYLOAD, sizeof (MCC_WRB_PAYLOAD) == 236);

   #else
      typedef union _MCC_WRB_PAYLOAD {
         MCC_SGE sgl[19];
         u32 embedded[59];                        // DWORDS 0 to 58
      } SG_PACK MCC_WRB_PAYLOAD, *PMCC_WRB_PAYLOAD;

      typedef union _MCC_WRB_PAYLOAD_UNION {
         MCC_WRB_PAYLOAD bits;
         u32 dw[59]; // dword union
      } SG_PACK MCC_WRB_PAYLOAD_UNION, *PMCC_WRB_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__MCC_WRB_PAYLOAD_UNION, sizeof (MCC_WRB_PAYLOAD_UNION) == 236);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the structure of the MCC Command WRB for commands sent to the Management
   // Processing Unit (MPU). See section IOCTL_TYPES for usage in embedded and
   // non-embedded modes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_WRB {
         union {
            struct { 
               u32 special : 8;                   // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
               u32 sge_count : 5;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 embedded : 1;                  // DWORD 0
               u32 payload_length;                // DWORD 1
               u32 tag[2];                        // DWORDS 2 to 3
               u32 rsvd2[1];                      // DWORDS 4 to 4
               MCC_WRB_PAYLOAD payload;
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK MCC_WRB, *PMCC_WRB;

      SG_C_ASSERT(__sizeof__MCC_WRB, sizeof (MCC_WRB) == 256);

   #else
      typedef struct _MCC_WRB {
         u32 special : 8;                         // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
         u32 sge_count : 5;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 embedded : 1;                        // DWORD 0
         u32 payload_length;                      // DWORD 1
         u32 tag[2];                              // DWORDS 2 to 3
         u32 rsvd2[1];                            // DWORDS 4 to 4
         MCC_WRB_PAYLOAD payload;
      } SG_PACK MCC_WRB, *PMCC_WRB;

      typedef union _MCC_WRB_UNION {
         MCC_WRB bits;
         u32 dw[64]; // dword union
      } SG_PACK MCC_WRB_UNION, *PMCC_WRB_UNION;

      SG_C_ASSERT(__sizeof__MCC_WRB_UNION, sizeof (MCC_WRB_UNION) == 256);
   #endif


#else
   // This is the structure of the MCC Command WRB for commands sent to the Management
   // Processing Unit (MPU). See section IOCTL_TYPES for usage in embedded and
   // non-embedded modes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_WRB {
         union {
            struct { 
               u32 embedded : 1;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 sge_count : 5;                 // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
               u32 special : 8;                   // DWORD 0
               u32 payload_length;                // DWORD 1
               u32 tag[2];                        // DWORDS 2 to 3
               u32 rsvd2[1];                      // DWORDS 4 to 4
               MCC_WRB_PAYLOAD payload;
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK MCC_WRB, *PMCC_WRB;

      SG_C_ASSERT(__sizeof__MCC_WRB, sizeof (MCC_WRB) == 256);

   #else
      typedef struct _MCC_WRB {
         u32 embedded : 1;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 sge_count : 5;                       // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
         u32 special : 8;                         // DWORD 0
         u32 payload_length;                      // DWORD 1
         u32 tag[2];                              // DWORDS 2 to 3
         u32 rsvd2[1];                            // DWORDS 4 to 4
         MCC_WRB_PAYLOAD payload;
      } SG_PACK MCC_WRB, *PMCC_WRB;

      typedef union _MCC_WRB_UNION {
         MCC_WRB bits;
         u32 dw[64]; // dword union
      } SG_PACK MCC_WRB_UNION, *PMCC_WRB_UNION;

      SG_C_ASSERT(__sizeof__MCC_WRB_UNION, sizeof (MCC_WRB_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the structure of the MCC Completion queue entry 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_CQ_ENTRY {
         union {
            struct { 
               u32 extended_status : 16;          // DWORD 0
               u32 completion_status : 16;        // DWORD 0
               u32 mcc_tag[2];                    // DWORDS 1 to 2
               u32 valid : 1;                     // DWORD 3
               u32 async_event : 1;               // DWORD 3
               u32 rsvd1 : 1;                     // DWORD 3
               u32 completed : 1;                 // DWORD 3
               u32 consumed : 1;                  // DWORD 3
               u32 rsvd0 : 27;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MCC_CQ_ENTRY, *PMCC_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__MCC_CQ_ENTRY, sizeof (MCC_CQ_ENTRY) == 16);

   #else
      typedef struct _MCC_CQ_ENTRY {
         u32 extended_status : 16;                // DWORD 0
         u32 completion_status : 16;              // DWORD 0
         u32 mcc_tag[2];                          // DWORDS 1 to 2
         u32 valid : 1;                           // DWORD 3
         u32 async_event : 1;                     // DWORD 3
         u32 rsvd1 : 1;                           // DWORD 3
         u32 completed : 1;                       // DWORD 3
         u32 consumed : 1;                        // DWORD 3
         u32 rsvd0 : 27;                          // DWORD 3
      } SG_PACK MCC_CQ_ENTRY, *PMCC_CQ_ENTRY;

      typedef union _MCC_CQ_ENTRY_UNION {
         MCC_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MCC_CQ_ENTRY_UNION, *PMCC_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MCC_CQ_ENTRY_UNION, sizeof (MCC_CQ_ENTRY_UNION) == 16);
   #endif


#else
   // This is the structure of the MCC Completion queue entry 
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_CQ_ENTRY {
         union {
            struct { 
               u32 completion_status : 16;        // DWORD 0
               u32 extended_status : 16;          // DWORD 0
               u32 mcc_tag[2];                    // DWORDS 1 to 2
               u32 rsvd0 : 27;                    // DWORD 3
               u32 consumed : 1;                  // DWORD 3
               u32 completed : 1;                 // DWORD 3
               u32 rsvd1 : 1;                     // DWORD 3
               u32 async_event : 1;               // DWORD 3
               u32 valid : 1;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK MCC_CQ_ENTRY, *PMCC_CQ_ENTRY;

      SG_C_ASSERT(__sizeof__MCC_CQ_ENTRY, sizeof (MCC_CQ_ENTRY) == 16);

   #else
      typedef struct _MCC_CQ_ENTRY {
         u32 completion_status : 16;              // DWORD 0
         u32 extended_status : 16;                // DWORD 0
         u32 mcc_tag[2];                          // DWORDS 1 to 2
         u32 rsvd0 : 27;                          // DWORD 3
         u32 consumed : 1;                        // DWORD 3
         u32 completed : 1;                       // DWORD 3
         u32 rsvd1 : 1;                           // DWORD 3
         u32 async_event : 1;                     // DWORD 3
         u32 valid : 1;                           // DWORD 3
      } SG_PACK MCC_CQ_ENTRY, *PMCC_CQ_ENTRY;

      typedef union _MCC_CQ_ENTRY_UNION {
         MCC_CQ_ENTRY bits;
         u32 dw[4]; // dword union
      } SG_PACK MCC_CQ_ENTRY_UNION, *PMCC_CQ_ENTRY_UNION;

      SG_C_ASSERT(__sizeof__MCC_CQ_ENTRY_UNION, sizeof (MCC_CQ_ENTRY_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mailbox structures used by the MPU during bootstrap
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_MAILBOX {
         union {
            struct { 
               MCC_WRB wrb;
               MCC_CQ_ENTRY cq;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK MCC_MAILBOX, *PMCC_MAILBOX;

      SG_C_ASSERT(__sizeof__MCC_MAILBOX, sizeof (MCC_MAILBOX) == 272);

   #else
      typedef struct _MCC_MAILBOX {
         MCC_WRB wrb;
         MCC_CQ_ENTRY cq;
      } SG_PACK MCC_MAILBOX, *PMCC_MAILBOX;

      typedef union _MCC_MAILBOX_UNION {
         MCC_MAILBOX bits;
         u32 dw[68]; // dword union
      } SG_PACK MCC_MAILBOX_UNION, *PMCC_MAILBOX_UNION;

      SG_C_ASSERT(__sizeof__MCC_MAILBOX_UNION, sizeof (MCC_MAILBOX_UNION) == 272);
   #endif


#else
   // Mailbox structures used by the MPU during bootstrap
   #if defined(SG_BMAP_UNION)
      typedef struct _MCC_MAILBOX {
         union {
            struct { 
               MCC_WRB wrb;
               MCC_CQ_ENTRY cq;
            } SG_PACK ; // unnamed struct
            u32 dw[68]; // dword union
         }; // unnamed union
      } SG_PACK MCC_MAILBOX, *PMCC_MAILBOX;

      SG_C_ASSERT(__sizeof__MCC_MAILBOX, sizeof (MCC_MAILBOX) == 272);

   #else
      typedef struct _MCC_MAILBOX {
         MCC_WRB wrb;
         MCC_CQ_ENTRY cq;
      } SG_PACK MCC_MAILBOX, *PMCC_MAILBOX;

      typedef union _MCC_MAILBOX_UNION {
         MCC_MAILBOX bits;
         u32 dw[68]; // dword union
      } SG_PACK MCC_MAILBOX_UNION, *PMCC_MAILBOX_UNION;

      SG_C_ASSERT(__sizeof__MCC_MAILBOX_UNION, sizeof (MCC_MAILBOX_UNION) == 272);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mcc_bmap_h__

