/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mili_ptl_bmap_h__
#define __ioctl_mili_ptl_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 portal_key;
               IP_ADDRESS_FORMAT portal_ip_addr;
               UEXACT16 tcp_port;
               UEXACT16 phy_port;
               MAC_ADDRESS_FORMAT mac_addr;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN) == 40);

   #else
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN {
         UEXACT32 portal_key;
         IP_ADDRESS_FORMAT portal_ip_addr;
         UEXACT16 tcp_port;
         UEXACT16 phy_port;
         MAC_ADDRESS_FORMAT mac_addr;
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN bits;
         u32 dw[10]; // dword union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION) == 40);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 portal_key;
               IP_ADDRESS_FORMAT portal_ip_addr;
               UEXACT16 tcp_port;
               UEXACT16 phy_port;
               MAC_ADDRESS_FORMAT mac_addr;
            } SG_PACK ; // unnamed struct
            u32 dw[10]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN) == 40);

   #else
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN {
         UEXACT32 portal_key;
         IP_ADDRESS_FORMAT portal_ip_addr;
         UEXACT16 tcp_port;
         UEXACT16 phy_port;
         MAC_ADDRESS_FORMAT mac_addr;
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN bits;
         u32 dw[10]; // dword union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN_UNION) == 40);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MILI requests PTL to create a portal with the specified IP address and port number
   // and associate it with the portal_key provided. This key is used to refer to this
   // portal in the following IOCTLs-   - IOCTL_MILI_PTL_DELETE_PORTAL  -
   // IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL, *PIOCTL_MILI_PTL_CREATE_PORTAL;



#else
   // MILI requests PTL to create a portal with the specified IP address and port number
   // and associate it with the portal_key provided. This key is used to refer to this
   // portal in the following IOCTLs-   - IOCTL_MILI_PTL_DELETE_PORTAL  -
   // IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDL_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_CREATE_PORTAL_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL, *PIOCTL_MILI_PTL_CREATE_PORTAL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Delete Portal PTL removes portal and puts it back into free pool list - Returns an
   // error if the portal key could not be located in the PTL configuration info. This
   // IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL, *PIOCTL_MILI_PTL_DELETE_PORTAL;



#else
   // Delete Portal PTL removes portal and puts it back into free pool list - Returns an
   // error if the portal key could not be located in the PTL configuration info. This
   // IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_PARAMS_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL, *PIOCTL_MILI_PTL_DELETE_PORTAL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_group_tag;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN) == 8);

   #else
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_group_tag;
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_group_tag;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN) == 8);

   #else
      typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_group_tag;
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Create a Portal Group. Add Portals into this Portal Group using
   // IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP;



#else
   // Create a Portal Group. Add Portals into this Portal Group using
   // IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_CREATE_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_CREATE_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_CREATE_PORTAL_GROUP, *PIOCTL_MILI_PTL_CREATE_PORTAL_GROUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Delete Portal Group created using IOCTL_MILI_PTL_CREATE_PORTAL_GROUP. MILI should
   // make sure to remove portals and unbind the portal group from target before deleting
   // the portal group. Otherwise PTL will return errors listed under
   // IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_STATUS. This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP;



#else
   // Delete Portal Group created using IOCTL_MILI_PTL_CREATE_PORTAL_GROUP. MILI should
   // make sure to remove portals and unbind the portal group from target before deleting
   // the portal group. Otherwise PTL will return errors listed under
   // IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_STATUS. This IOCTL returns one of the following
   // status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This
   // IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_count;
               UEXACT32 portal_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_count;
         UEXACT32 portal_key[1];
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_count;
               UEXACT32 portal_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_count;
         UEXACT32 portal_key[1];
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Add portal to Portal Group portal key,PG key status Adds the portal to portal group.
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP;



#else
   // Add portal to Portal Group portal key,PG key status Adds the portal to portal group.
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP, *PIOCTL_MILI_PTL_ADD_PORTAL_TO_PORTAL_GROUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_count;
               UEXACT32 portal_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_count;
         UEXACT32 portal_key[1];
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN {
         union {
            struct { 
               UEXACT32 portal_group_key;
               UEXACT32 portal_count;
               UEXACT32 portal_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN {
         UEXACT32 portal_group_key;
         UEXACT32 portal_count;
         UEXACT32 portal_key[1];
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Remove portal from portal group. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP;



#else
   // Remove portal from portal group. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP_IN request;
   } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP, *PIOCTL_MILI_PTL_DELETE_PORTAL_FROM_PORTAL_GROUP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
               UEXACT8 target_alias[224];
            } SG_PACK ; // unnamed struct
            u32 dw[113]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN, *PIOCTL_MILI_PTL_ADD_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_IN, sizeof (IOCTL_MILI_PTL_ADD_TARGET_IN) == 452);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
         UEXACT8 target_alias[224];
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN, *PIOCTL_MILI_PTL_ADD_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_ADD_TARGET_IN_UNION {
         IOCTL_MILI_PTL_ADD_TARGET_IN bits;
         u32 dw[113]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN_UNION, *PIOCTL_MILI_PTL_ADD_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_TARGET_IN_UNION) == 452);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT8 target_name[224];
               UEXACT8 target_alias[224];
            } SG_PACK ; // unnamed struct
            u32 dw[113]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN, *PIOCTL_MILI_PTL_ADD_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_IN, sizeof (IOCTL_MILI_PTL_ADD_TARGET_IN) == 452);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET_IN {
         UEXACT32 target_key;
         UEXACT8 target_name[224];
         UEXACT8 target_alias[224];
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN, *PIOCTL_MILI_PTL_ADD_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_ADD_TARGET_IN_UNION {
         IOCTL_MILI_PTL_ADD_TARGET_IN bits;
         u32 dw[113]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_IN_UNION, *PIOCTL_MILI_PTL_ADD_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_TARGET_IN_UNION) == 452);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Add Target name and alias. This IOCTL returns one of the following status values in
   // the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of
   // the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_ADD_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[117]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET, *PIOCTL_MILI_PTL_ADD_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET, sizeof (IOCTL_MILI_PTL_ADD_TARGET) == 468);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_ADD_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET, *PIOCTL_MILI_PTL_ADD_TARGET;

      typedef union _IOCTL_MILI_PTL_ADD_TARGET_UNION {
         IOCTL_MILI_PTL_ADD_TARGET bits;
         u32 dw[117]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_UNION, *PIOCTL_MILI_PTL_ADD_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_UNION, sizeof (IOCTL_MILI_PTL_ADD_TARGET_UNION) == 468);
   #endif


#else
   // Add Target name and alias. This IOCTL returns one of the following status values in
   // the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of
   // the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_ENTRY</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_ADD_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[117]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET, *PIOCTL_MILI_PTL_ADD_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET, sizeof (IOCTL_MILI_PTL_ADD_TARGET) == 468);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_ADD_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET, *PIOCTL_MILI_PTL_ADD_TARGET;

      typedef union _IOCTL_MILI_PTL_ADD_TARGET_UNION {
         IOCTL_MILI_PTL_ADD_TARGET bits;
         u32 dw[117]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_TARGET_UNION, *PIOCTL_MILI_PTL_ADD_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_TARGET_UNION, sizeof (IOCTL_MILI_PTL_ADD_TARGET_UNION) == 468);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_IN, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION {
         IOCTL_MILI_PTL_DELETE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION, *PIOCTL_MILI_PTL_DELETE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_IN, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET_IN {
         UEXACT32 target_key;
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION {
         IOCTL_MILI_PTL_DELETE_TARGET_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION, *PIOCTL_MILI_PTL_DELETE_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Delete Target. MILI should ensure that all Portal Groups bound to this target are
   // deleted. This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_DELETE_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET, *PIOCTL_MILI_PTL_DELETE_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET, sizeof (IOCTL_MILI_PTL_DELETE_TARGET) == 20);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_DELETE_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET, *PIOCTL_MILI_PTL_DELETE_TARGET;

      typedef union _IOCTL_MILI_PTL_DELETE_TARGET_UNION {
         IOCTL_MILI_PTL_DELETE_TARGET bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_UNION, *PIOCTL_MILI_PTL_DELETE_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_UNION, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_UNION) == 20);
   #endif


#else
   // Delete Target. MILI should ensure that all Portal Groups bound to this target are
   // deleted. This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_DELETE_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET, *PIOCTL_MILI_PTL_DELETE_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET, sizeof (IOCTL_MILI_PTL_DELETE_TARGET) == 20);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_DELETE_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET, *PIOCTL_MILI_PTL_DELETE_TARGET;

      typedef union _IOCTL_MILI_PTL_DELETE_TARGET_UNION {
         IOCTL_MILI_PTL_DELETE_TARGET bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_TARGET_UNION, *PIOCTL_MILI_PTL_DELETE_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_TARGET_UNION, sizeof (IOCTL_MILI_PTL_DELETE_TARGET_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 portal_group_count;
               UEXACT32 portal_group_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN {
         UEXACT32 target_key;
         UEXACT32 portal_group_count;
         UEXACT32 portal_group_key[1];
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 portal_group_count;
               UEXACT32 portal_group_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN {
         UEXACT32 target_key;
         UEXACT32 portal_group_count;
         UEXACT32 portal_group_key[1];
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Add portal group to target. This IOCTL returns one of the following status values in
   // the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of
   // the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET) == 28);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION) == 28);
   #endif


#else
   // Add portal group to target. This IOCTL returns one of the following status values in
   // the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of
   // the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_DUPLICATE_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET) == 28);

   #else
      typedef struct _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET;

      typedef union _IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION {
         IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION, *PIOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION, sizeof (IOCTL_MILI_PTL_ADD_PORTAL_GROUP_TO_TARGET_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 portal_group_count;
               UEXACT32 portal_group_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN {
         UEXACT32 target_key;
         UEXACT32 portal_group_count;
         UEXACT32 portal_group_key[1];
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 portal_group_count;
               UEXACT32 portal_group_key[1];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN) == 12);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN {
         UEXACT32 target_key;
         UEXACT32 portal_group_count;
         UEXACT32 portal_group_key[1];
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Remove portal group from target. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET) == 28);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION) == 28);
   #endif


#else
   // Remove portal group from target. This IOCTL returns one of the following status
   // values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL
   // returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTALGROUP_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_PORTAL_HANDLE_NOT_FOUND</link>  -
   // <link>MGMT_ADDI_STATUS_ACTIVE_SESSIONS_PRESENT</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET) == 28);

   #else
      typedef struct _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_IN request;
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET;

      typedef union _IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION {
         IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION, *PIOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION, sizeof (IOCTL_MILI_PTL_DELETE_PORTAL_GROUP_FROM_TARGET_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               MGMT_LOGIN_OPTIONS target_login_options;
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
            } SG_PACK ; // unnamed struct
            u32 dw[152]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN) == 608);

   #else
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN {
         UEXACT32 target_key;
         MGMT_LOGIN_OPTIONS target_login_options;
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN bits;
         u32 dw[152]; // dword union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION) == 608);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               MGMT_LOGIN_OPTIONS target_login_options;
               UEXACT8 auth_method_type;
               UEXACT8 pad[3];
            } SG_PACK ; // unnamed struct
            u32 dw[152]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN) == 608);

   #else
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN {
         UEXACT32 target_key;
         MGMT_LOGIN_OPTIONS target_login_options;
         UEXACT8 auth_method_type;
         UEXACT8 pad[3];
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN;

      typedef union _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION {
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN bits;
         u32 dw[152]; // dword union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN_UNION) == 608);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Set Target Login Params and authentication details. This IOCTL returns one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED
   // This IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[156]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS) == 624);

   #else
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN request;
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS;

      typedef union _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION {
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS bits;
         u32 dw[156]; // dword union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION) == 624);
   #endif


#else
   // Set Target Login Params and authentication details. This IOCTL returns one of the
   // following status values in the response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED
   // This IOCTL returns one of the following additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_INVALID_KEY</link>  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS {
         union {
            struct { 
               IOCTL_HEADER header;
               IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[156]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS) == 624);

   #else
      typedef struct _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS {
         IOCTL_HEADER header;
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_IN request;
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS;

      typedef union _IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION {
         IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS bits;
         u32 dw[156]; // dword union
      } SG_PACK IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION, *PIOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION, sizeof (IOCTL_MILI_PTL_SET_TARGET_LOGIN_PARAMS_UNION) == 624);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, sizeof (IOCTL_MILI_PTL_START_LISTEN_SERVER_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN;

      typedef union _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION {
         IOCTL_MILI_PTL_START_LISTEN_SERVER_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION, sizeof (IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, sizeof (IOCTL_MILI_PTL_START_LISTEN_SERVER_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN;

      typedef union _IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION {
         IOCTL_MILI_PTL_START_LISTEN_SERVER_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION, *PIOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION, sizeof (IOCTL_MILI_PTL_START_LISTEN_SERVER_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Start Listen server on the specified portal. PTL should pass this requests to the
   // ARM firmware. 
   typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_START_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER, *PIOCTL_MILI_PTL_START_LISTEN_SERVER;



#else
   // Start Listen server on the specified portal. PTL should pass this requests to the
   // ARM firmware. 
   typedef struct _IOCTL_MILI_PTL_START_LISTEN_SERVER {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_START_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_MILI_PTL_START_LISTEN_SERVER, *PIOCTL_MILI_PTL_START_LISTEN_SERVER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, sizeof (IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN;

      typedef union _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION {
         IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION, sizeof (IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN {
         union {
            struct { 
               UEXACT32 portal_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, sizeof (IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN) == 4);

   #else
      typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN {
         UEXACT32 portal_key;
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN;

      typedef union _IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION {
         IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION, sizeof (IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Stop Listen server on the specified portal. PTL should request ARM to stop listening
   // for TCP connections on this port. 
   typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER;



#else
   // Stop Listen server on the specified portal. PTL should request ARM to stop listening
   // for TCP connections on this port. 
   typedef struct _IOCTL_MILI_PTL_STOP_LISTEN_SERVER {
      IOCTL_HEADER header;
      IOCTL_MILI_PTL_STOP_LISTEN_SERVER_IN request;
   } SG_PACK IOCTL_MILI_PTL_STOP_LISTEN_SERVER, *PIOCTL_MILI_PTL_STOP_LISTEN_SERVER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN {
         UEXACT32 handle;
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN {
         UEXACT32 handle;
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiInstSsnFailures;
      EXACT8 iscsiInstLastSsnRmtNodeName[255];
      UEXACT32 iscsiInstDiscontinuityTime;
   } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT;



#else
   
   typedef struct _ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiInstSsnFailures;
      EXACT8 iscsiInstLastSsnRmtNodeName[255];
      UEXACT32 iscsiInstDiscontinuityTime;
   } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _ISCSI_INSTANCE_ATTRIBUTES_PARAMS {
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN request;
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS;



#else
   
   typedef union _ISCSI_INSTANCE_ATTRIBUTES_PARAMS {
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS_IN request;
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_INSTANCE_ATTRIBUTES_PARAMS, *PISCSI_INSTANCE_ATTRIBUTES_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES {
      IOCTL_HEADER header;
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES;



#else
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES {
      IOCTL_HEADER header;
      ISCSI_INSTANCE_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN {
         UEXACT32 handle;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 handle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN {
         UEXACT32 handle;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 iscsiInstSsnDigestErrors;
               UEXACT32 iscsiInstSsnCxnTimeoutErrors;
               UEXACT32 iscsiInstSsnFormatErrors;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT) == 12);

   #else
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT {
         UEXACT32 iscsiInstSsnDigestErrors;
         UEXACT32 iscsiInstSsnCxnTimeoutErrors;
         UEXACT32 iscsiInstSsnFormatErrors;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 iscsiInstSsnDigestErrors;
               UEXACT32 iscsiInstSsnCxnTimeoutErrors;
               UEXACT32 iscsiInstSsnFormatErrors;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT) == 12);

   #else
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT {
         UEXACT32 iscsiInstSsnDigestErrors;
         UEXACT32 iscsiInstSsnCxnTimeoutErrors;
         UEXACT32 iscsiInstSsnFormatErrors;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS {
         union {
            union { 
               ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN request;
               ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS) == 12);

   #else
      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN request;
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT response;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS {
         union {
            union { 
               ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN request;
               ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS) == 12);

   #else
      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_IN request;
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_OUT response;
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS;

      typedef union _ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION {
         ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION, *PISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION, sizeof (ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS {
      IOCTL_HEADER header;
      ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS;



#else
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS {
      IOCTL_HEADER header;
      ISCSI_INSTANCE_SSN_ERROR_STATS_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_INSTANCE_SSN_ERROR_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tgt_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_TARGET_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN {
         UEXACT32 tgt_key;
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_TARGET_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tgt_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_TARGET_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN {
         UEXACT32 tgt_key;
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_TARGET_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_TARGET_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiTgtLoginFailures;
      UEXACT32 iscsiTgtLastFailureTime;
      EXACT8 iscsiTgtLastIntrFailureName[255];
      UEXACT32 iscsiTgtLastIntrFailureAddrType;
      IP_ADDRESS_FORMAT iscsiTgtLastIntrFailureAddr;
   } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT, *PISCSI_TARGET_ATTRIBUTES_PARAMS_OUT;



#else
   
   typedef struct _ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiTgtLoginFailures;
      UEXACT32 iscsiTgtLastFailureTime;
      EXACT8 iscsiTgtLastIntrFailureName[255];
      UEXACT32 iscsiTgtLastIntrFailureAddrType;
      IP_ADDRESS_FORMAT iscsiTgtLastIntrFailureAddr;
   } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT, *PISCSI_TARGET_ATTRIBUTES_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _ISCSI_TARGET_ATTRIBUTES_PARAMS {
      ISCSI_TARGET_ATTRIBUTES_PARAMS_IN request;
      ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS, *PISCSI_TARGET_ATTRIBUTES_PARAMS;



#else
   
   typedef union _ISCSI_TARGET_ATTRIBUTES_PARAMS {
      ISCSI_TARGET_ATTRIBUTES_PARAMS_IN request;
      ISCSI_TARGET_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_TARGET_ATTRIBUTES_PARAMS, *PISCSI_TARGET_ATTRIBUTES_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES {
      IOCTL_HEADER header;
      ISCSI_TARGET_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES;



#else
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES {
      IOCTL_HEADER header;
      ISCSI_TARGET_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tgt_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN {
         UEXACT32 tgt_key;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tgt_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN {
         UEXACT32 tgt_key;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 iscsiTgtLoginAccepts;
               UEXACT32 iscsiTgtLoginOtherFails;
               UEXACT32 iscsiTgtLoginRedirects;
               UEXACT32 iscsiTgtLoginAuthorizeFails;
               UEXACT32 iscsiTgtLoginAuthenticateFails;
               UEXACT32 iscsiTgtLoginNegotiateFails;
               UEXACT32 iscsiTgtLogoutNormals;
               UEXACT32 iscsiTgtLogoutOthers;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT) == 32);

   #else
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT {
         UEXACT32 iscsiTgtLoginAccepts;
         UEXACT32 iscsiTgtLoginOtherFails;
         UEXACT32 iscsiTgtLoginRedirects;
         UEXACT32 iscsiTgtLoginAuthorizeFails;
         UEXACT32 iscsiTgtLoginAuthenticateFails;
         UEXACT32 iscsiTgtLoginNegotiateFails;
         UEXACT32 iscsiTgtLogoutNormals;
         UEXACT32 iscsiTgtLogoutOthers;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 iscsiTgtLoginAccepts;
               UEXACT32 iscsiTgtLoginOtherFails;
               UEXACT32 iscsiTgtLoginRedirects;
               UEXACT32 iscsiTgtLoginAuthorizeFails;
               UEXACT32 iscsiTgtLoginAuthenticateFails;
               UEXACT32 iscsiTgtLoginNegotiateFails;
               UEXACT32 iscsiTgtLogoutNormals;
               UEXACT32 iscsiTgtLogoutOthers;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT) == 32);

   #else
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT {
         UEXACT32 iscsiTgtLoginAccepts;
         UEXACT32 iscsiTgtLoginOtherFails;
         UEXACT32 iscsiTgtLoginRedirects;
         UEXACT32 iscsiTgtLoginAuthorizeFails;
         UEXACT32 iscsiTgtLoginAuthenticateFails;
         UEXACT32 iscsiTgtLoginNegotiateFails;
         UEXACT32 iscsiTgtLogoutNormals;
         UEXACT32 iscsiTgtLogoutOthers;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS {
         union {
            union { 
               ISCSI_TARGET_LOGIN_STATS_PARAMS_IN request;
               ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS, *PISCSI_TARGET_LOGIN_STATS_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS) == 32);

   #else
      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_IN request;
         ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT response;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS, *PISCSI_TARGET_LOGIN_STATS_PARAMS;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_TARGET_LOGIN_STATS_PARAMS {
         union {
            union { 
               ISCSI_TARGET_LOGIN_STATS_PARAMS_IN request;
               ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS, *PISCSI_TARGET_LOGIN_STATS_PARAMS;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS) == 32);

   #else
      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS {
         ISCSI_TARGET_LOGIN_STATS_PARAMS_IN request;
         ISCSI_TARGET_LOGIN_STATS_PARAMS_OUT response;
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS, *PISCSI_TARGET_LOGIN_STATS_PARAMS;

      typedef union _ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION {
         ISCSI_TARGET_LOGIN_STATS_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION, *PISCSI_TARGET_LOGIN_STATS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION, sizeof (ISCSI_TARGET_LOGIN_STATS_PARAMS_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS {
      IOCTL_HEADER header;
      ISCSI_TARGET_LOGIN_STATS_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS;



#else
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS {
      IOCTL_HEADER header;
      ISCSI_TARGET_LOGIN_STATS_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_TARGET_LOGIN_LOGOUT_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_SESSION_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 session_id;
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_SESSION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_SESSION_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 session_id;
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_SESSION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_SESSION_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT {
      EXACT8 iscsiSsnInitiatorName[255];
      EXACT8 iscsiSsnTargetName[255];
      UEXACT32 iscsiSsnTSIH;
      EXACT8 iscsiSsnISID[6];
      EXACT8 iscsiSsnInitiatorAlias[255];
      EXACT8 iscsiSsnTargetAlias[255];
      UEXACT32 iscsiSsnInitialR2T;
      UEXACT32 iscsiSsnImmediateData;
      UEXACT32 iscsiSsnType;
      UEXACT32 iscsiSsnMaxOutstandingR2T;
      UEXACT32 iscsiSsnFirstBurstLength;
      UEXACT32 iscsiSsnMaxBurstLength;
      UEXACT32 iscsiSsnConnectionNumber;
      UEXACT32 iscsiSsnDataSequenceInOrder;
      UEXACT32 iscsiSsnDataPDUInOrder;
      UEXACT32 iscsiSsnErrorRecoveryLevel;
      UEXACT32 iscsiSsnDiscontinuityTime;
      UEXACT32 iscsiSsnCmdPDUs;
      UEXACT32 iscsiSsnRspPDUs;
      UEXACT32 iscsiSsnTxDataOctets;
      UEXACT32 iscsiSsnRxDataOctets;
   } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT, *PISCSI_SESSION_ATTRIBUTES_PARAMS_OUT;



#else
   
   typedef struct _ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT {
      EXACT8 iscsiSsnInitiatorName[255];
      EXACT8 iscsiSsnTargetName[255];
      UEXACT32 iscsiSsnTSIH;
      EXACT8 iscsiSsnISID[6];
      EXACT8 iscsiSsnInitiatorAlias[255];
      EXACT8 iscsiSsnTargetAlias[255];
      UEXACT32 iscsiSsnInitialR2T;
      UEXACT32 iscsiSsnImmediateData;
      UEXACT32 iscsiSsnType;
      UEXACT32 iscsiSsnMaxOutstandingR2T;
      UEXACT32 iscsiSsnFirstBurstLength;
      UEXACT32 iscsiSsnMaxBurstLength;
      UEXACT32 iscsiSsnConnectionNumber;
      UEXACT32 iscsiSsnDataSequenceInOrder;
      UEXACT32 iscsiSsnDataPDUInOrder;
      UEXACT32 iscsiSsnErrorRecoveryLevel;
      UEXACT32 iscsiSsnDiscontinuityTime;
      UEXACT32 iscsiSsnCmdPDUs;
      UEXACT32 iscsiSsnRspPDUs;
      UEXACT32 iscsiSsnTxDataOctets;
      UEXACT32 iscsiSsnRxDataOctets;
   } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT, *PISCSI_SESSION_ATTRIBUTES_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _ISCSI_SESSION_ATTRIBUTES_PARAMS {
      ISCSI_SESSION_ATTRIBUTES_PARAMS_IN request;
      ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS, *PISCSI_SESSION_ATTRIBUTES_PARAMS;



#else
   
   typedef union _ISCSI_SESSION_ATTRIBUTES_PARAMS {
      ISCSI_SESSION_ATTRIBUTES_PARAMS_IN request;
      ISCSI_SESSION_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_SESSION_ATTRIBUTES_PARAMS, *PISCSI_SESSION_ATTRIBUTES_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS {
      IOCTL_HEADER header;
      ISCSI_SESSION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS;



#else
   // This IOCTL returns one of the following status values in the response  -
   // MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED This IOCTL returns one of the following
   // additional status values in the response  -
   // <link>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND</link> 
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS {
      IOCTL_HEADER header;
      ISCSI_SESSION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_SESSION_ATTRIBUTES_AND_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_id;
               UEXACT32 cid;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN) == 8);

   #else
      typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 session_id;
         UEXACT32 cid;
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 session_id;
               UEXACT32 cid;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, sizeof (ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN) == 8);

   #else
      typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN {
         UEXACT32 session_id;
         UEXACT32 cid;
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN;

      typedef union _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION {
         ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION, sizeof (ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiCxnCid;
      UEXACT32 iscsiCxnState;
      UEXACT32 iscsiCxnAddrType;
      IP_ADDRESS_FORMAT iscsiCxnLocalAddr;
      UEXACT16 iscsiCxnProtocol;
      UEXACT16 iscsiCxnLocalPort;
      IP_ADDRESS_FORMAT iscsiCxnRemoteAddr;
      UEXACT16 iscsiCxnRemotePort;
      UEXACT32 iscsiCxnMaxRecvDataSegLength;
      UEXACT32 iscsiCxnMaxXmitDataSegLength;
      UEXACT32 iscsiCxnHeaderIntegrity;
      UEXACT32 iscsiCxnDataIntegrity;
      UEXACT32 iscsiCxnRecvMarker;
      UEXACT32 iscsiCxnSendMarker;
      UEXACT32 iscsiCxnVersionActive;
      UEXACT32 iscsiSsnCxnDigestErrors;
      UEXACT32 iscsiSsnCxnTimeoutErrors;
   } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT;



#else
   
   typedef struct _ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT {
      UEXACT32 iscsiCxnCid;
      UEXACT32 iscsiCxnState;
      UEXACT32 iscsiCxnAddrType;
      IP_ADDRESS_FORMAT iscsiCxnLocalAddr;
      UEXACT16 iscsiCxnProtocol;
      UEXACT16 iscsiCxnLocalPort;
      IP_ADDRESS_FORMAT iscsiCxnRemoteAddr;
      UEXACT16 iscsiCxnRemotePort;
      UEXACT32 iscsiCxnMaxRecvDataSegLength;
      UEXACT32 iscsiCxnMaxXmitDataSegLength;
      UEXACT32 iscsiCxnHeaderIntegrity;
      UEXACT32 iscsiCxnDataIntegrity;
      UEXACT32 iscsiCxnRecvMarker;
      UEXACT32 iscsiCxnSendMarker;
      UEXACT32 iscsiCxnVersionActive;
      UEXACT32 iscsiSsnCxnDigestErrors;
      UEXACT32 iscsiSsnCxnTimeoutErrors;
   } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef union _ISCSI_CONNECTION_ATTRIBUTES_PARAMS {
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN request;
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS;



#else
   
   typedef union _ISCSI_CONNECTION_ATTRIBUTES_PARAMS {
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS_IN request;
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS_OUT response;
   } SG_PACK ISCSI_CONNECTION_ATTRIBUTES_PARAMS, *PISCSI_CONNECTION_ATTRIBUTES_PARAMS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS {
      IOCTL_HEADER header;
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS;



#else
   
   typedef struct _IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS {
      IOCTL_HEADER header;
      ISCSI_CONNECTION_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS, *PIOCTL_MILI_PTL_MIB_GET_ISCSI_CONNECTION_ATTRIBUTES_AND_STATS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN, *PMILI_GET_SESSION_LIST_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_IN, sizeof (MILI_GET_SESSION_LIST_PARAMS_IN) == 4);

   #else
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_IN {
         UEXACT32 target_key;
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN, *PMILI_GET_SESSION_LIST_PARAMS_IN;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_IN_UNION {
         MILI_GET_SESSION_LIST_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN_UNION, *PMILI_GET_SESSION_LIST_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_IN_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN, *PMILI_GET_SESSION_LIST_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_IN, sizeof (MILI_GET_SESSION_LIST_PARAMS_IN) == 4);

   #else
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_IN {
         UEXACT32 target_key;
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN, *PMILI_GET_SESSION_LIST_PARAMS_IN;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_IN_UNION {
         MILI_GET_SESSION_LIST_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_IN_UNION, *PMILI_GET_SESSION_LIST_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_IN_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _session_info {
         union {
            struct { 
               UEXACT32 session_id;
               UEXACT32 pgtag;
               UEXACT32 num_cid;
               UEXACT32 cids[4];
               UEXACT32 portalkeys[4];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK session_info, *Psession_info;

      SG_C_ASSERT(__sizeof__session_info, sizeof (session_info) == 44);

   #else
      typedef struct _session_info {
         UEXACT32 session_id;
         UEXACT32 pgtag;
         UEXACT32 num_cid;
         UEXACT32 cids[4];
         UEXACT32 portalkeys[4];
      } SG_PACK session_info, *Psession_info;

      typedef union _session_info_UNION {
         session_info bits;
         u32 dw[11]; // dword union
      } SG_PACK session_info_UNION, *Psession_info_UNION;

      SG_C_ASSERT(__sizeof__session_info_UNION, sizeof (session_info_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _session_info {
         union {
            struct { 
               UEXACT32 session_id;
               UEXACT32 pgtag;
               UEXACT32 num_cid;
               UEXACT32 cids[4];
               UEXACT32 portalkeys[4];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK session_info, *Psession_info;

      SG_C_ASSERT(__sizeof__session_info, sizeof (session_info) == 44);

   #else
      typedef struct _session_info {
         UEXACT32 session_id;
         UEXACT32 pgtag;
         UEXACT32 num_cid;
         UEXACT32 cids[4];
         UEXACT32 portalkeys[4];
      } SG_PACK session_info, *Psession_info;

      typedef union _session_info_UNION {
         session_info bits;
         u32 dw[11]; // dword union
      } SG_PACK session_info_UNION, *Psession_info_UNION;

      SG_C_ASSERT(__sizeof__session_info_UNION, sizeof (session_info_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 num_sessions;
               session_info session_list[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[11265]; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT, *PMILI_GET_SESSION_LIST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_OUT, sizeof (MILI_GET_SESSION_LIST_PARAMS_OUT) == 45060);

   #else
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_OUT {
         UEXACT32 num_sessions;
         session_info session_list[1024];
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT, *PMILI_GET_SESSION_LIST_PARAMS_OUT;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_OUT_UNION {
         MILI_GET_SESSION_LIST_PARAMS_OUT bits;
         u32 dw[11265]; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT_UNION, *PMILI_GET_SESSION_LIST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_OUT_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_OUT_UNION) == 45060);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 num_sessions;
               session_info session_list[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[11265]; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT, *PMILI_GET_SESSION_LIST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_OUT, sizeof (MILI_GET_SESSION_LIST_PARAMS_OUT) == 45060);

   #else
      typedef struct _MILI_GET_SESSION_LIST_PARAMS_OUT {
         UEXACT32 num_sessions;
         session_info session_list[1024];
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT, *PMILI_GET_SESSION_LIST_PARAMS_OUT;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_OUT_UNION {
         MILI_GET_SESSION_LIST_PARAMS_OUT bits;
         u32 dw[11265]; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_OUT_UNION, *PMILI_GET_SESSION_LIST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_OUT_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_OUT_UNION) == 45060);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS {
         union {
            union { 
               MILI_GET_SESSION_LIST_PARAMS_IN request;
               MILI_GET_SESSION_LIST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[11265]; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS, *PMILI_GET_SESSION_LIST_PARAMS;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS, sizeof (MILI_GET_SESSION_LIST_PARAMS) == 45060);

   #else
      typedef union _MILI_GET_SESSION_LIST_PARAMS {
         MILI_GET_SESSION_LIST_PARAMS_IN request;
         MILI_GET_SESSION_LIST_PARAMS_OUT response;
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS, *PMILI_GET_SESSION_LIST_PARAMS;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_UNION {
         MILI_GET_SESSION_LIST_PARAMS bits;
         u32 dw[11265]; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_UNION, *PMILI_GET_SESSION_LIST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_UNION) == 45060);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_GET_SESSION_LIST_PARAMS {
         union {
            union { 
               MILI_GET_SESSION_LIST_PARAMS_IN request;
               MILI_GET_SESSION_LIST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[11265]; // dword union
         }; // unnamed union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS, *PMILI_GET_SESSION_LIST_PARAMS;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS, sizeof (MILI_GET_SESSION_LIST_PARAMS) == 45060);

   #else
      typedef union _MILI_GET_SESSION_LIST_PARAMS {
         MILI_GET_SESSION_LIST_PARAMS_IN request;
         MILI_GET_SESSION_LIST_PARAMS_OUT response;
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS, *PMILI_GET_SESSION_LIST_PARAMS;

      typedef union _MILI_GET_SESSION_LIST_PARAMS_UNION {
         MILI_GET_SESSION_LIST_PARAMS bits;
         u32 dw[11265]; // dword union
      } SG_PACK MILI_GET_SESSION_LIST_PARAMS_UNION, *PMILI_GET_SESSION_LIST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MILI_GET_SESSION_LIST_PARAMS_UNION, sizeof (MILI_GET_SESSION_LIST_PARAMS_UNION) == 45060);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST {
      IOCTL_HEADER header;
      MILI_GET_SESSION_LIST_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST, *PIOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST;



#else
   
   typedef struct _IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST {
      IOCTL_HEADER header;
      MILI_GET_SESSION_LIST_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST, *PIOCTL_MILI_PTL_GET_ISCSI_SESSION_LIST;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 session_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN, *PMILI_PTL_KILL_SESSION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_IN, sizeof (MILI_PTL_KILL_SESSION_PARAMS_IN) == 8);

   #else
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS_IN {
         UEXACT32 target_key;
         UEXACT32 session_id;
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN, *PMILI_PTL_KILL_SESSION_PARAMS_IN;

      typedef union _MILI_PTL_KILL_SESSION_PARAMS_IN_UNION {
         MILI_PTL_KILL_SESSION_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN_UNION, *PMILI_PTL_KILL_SESSION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_IN_UNION, sizeof (MILI_PTL_KILL_SESSION_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 target_key;
               UEXACT32 session_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN, *PMILI_PTL_KILL_SESSION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_IN, sizeof (MILI_PTL_KILL_SESSION_PARAMS_IN) == 8);

   #else
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS_IN {
         UEXACT32 target_key;
         UEXACT32 session_id;
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN, *PMILI_PTL_KILL_SESSION_PARAMS_IN;

      typedef union _MILI_PTL_KILL_SESSION_PARAMS_IN_UNION {
         MILI_PTL_KILL_SESSION_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_IN_UNION, *PMILI_PTL_KILL_SESSION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_IN_UNION, sizeof (MILI_PTL_KILL_SESSION_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS {
         union {
            union { 
               MILI_PTL_KILL_SESSION_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS, *PMILI_PTL_KILL_SESSION_PARAMS;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS, sizeof (MILI_PTL_KILL_SESSION_PARAMS) == 8);

   #else
      typedef union _MILI_PTL_KILL_SESSION_PARAMS {
         MILI_PTL_KILL_SESSION_PARAMS_IN request;
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS, *PMILI_PTL_KILL_SESSION_PARAMS;

      typedef union _MILI_PTL_KILL_SESSION_PARAMS_UNION {
         MILI_PTL_KILL_SESSION_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_UNION, *PMILI_PTL_KILL_SESSION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_UNION, sizeof (MILI_PTL_KILL_SESSION_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MILI_PTL_KILL_SESSION_PARAMS {
         union {
            union { 
               MILI_PTL_KILL_SESSION_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS, *PMILI_PTL_KILL_SESSION_PARAMS;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS, sizeof (MILI_PTL_KILL_SESSION_PARAMS) == 8);

   #else
      typedef union _MILI_PTL_KILL_SESSION_PARAMS {
         MILI_PTL_KILL_SESSION_PARAMS_IN request;
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS, *PMILI_PTL_KILL_SESSION_PARAMS;

      typedef union _MILI_PTL_KILL_SESSION_PARAMS_UNION {
         MILI_PTL_KILL_SESSION_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK MILI_PTL_KILL_SESSION_PARAMS_UNION, *PMILI_PTL_KILL_SESSION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MILI_PTL_KILL_SESSION_PARAMS_UNION, sizeof (MILI_PTL_KILL_SESSION_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_MILI_PTL_KILL_SESSION {
      IOCTL_HEADER header;
      MILI_PTL_KILL_SESSION_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_KILL_SESSION, *PIOCTL_MILI_PTL_KILL_SESSION;



#else
   
   typedef struct _IOCTL_MILI_PTL_KILL_SESSION {
      IOCTL_HEADER header;
      MILI_PTL_KILL_SESSION_PARAMS params;
   } SG_PACK IOCTL_MILI_PTL_KILL_SESSION, *PIOCTL_MILI_PTL_KILL_SESSION;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mili_ptl_bmap_h__

