/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_rdma_bmap_h__
#define __ioctl_rdma_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_types_bmap.h"
#include "ioctl_common_bmap.h"
#include "fw_exp_bmap.h"
#include "rdma_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for registering UT pages which ARM will use for later PE creation. 
   typedef struct _IOCTL_RDMA_PE_INIT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR pe[26];
         } request;
         struct {
            UEXACT16 num_pages;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_PE_INIT, *PIOCTL_RDMA_PE_INIT;



#else
   // IOCTL for registering UT pages which ARM will use for later PE creation. 
   typedef struct _IOCTL_RDMA_PE_INIT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR pe[26];
         } request;
         struct {
            UEXACT16 num_pages;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_PE_INIT, *PIOCTL_RDMA_PE_INIT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for registering UT pages which ARM will use for later storing TEs. 
   typedef struct _IOCTL_RDMA_TE_INIT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT16 num_pages;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_TE_INIT, *PIOCTL_RDMA_TE_INIT;



#else
   // IOCTL for registering UT pages which ARM will use for later storing TEs. 
   typedef struct _IOCTL_RDMA_TE_INIT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT16 num_pages;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_TE_INIT, *PIOCTL_RDMA_TE_INIT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating RDMA QPs. This request creates both the RDMA send and receive
   // queue. Need 16 pages with 8 pages each for send and receive queues. 
   typedef struct _IOCTL_RDMA_QP_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 ulp_num;
            UEXACT16 num_sq_pages;
            UEXACT16 num_rq_pages;
            PHYS_ADDR sq[8];
            PHYS_ADDR rq[8];
         } request;
         struct {
            UEXACT16 cid;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_CREATE, *PIOCTL_RDMA_QP_CREATE;



#else
   // IOCTL for creating RDMA QPs. This request creates both the RDMA send and receive
   // queue. Need 16 pages with 8 pages each for send and receive queues. 
   typedef struct _IOCTL_RDMA_QP_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 ulp_num;
            UEXACT16 num_sq_pages;
            UEXACT16 num_rq_pages;
            PHYS_ADDR sq[8];
            PHYS_ADDR rq[8];
         } request;
         struct {
            UEXACT16 cid;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_CREATE, *PIOCTL_RDMA_QP_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_RDMA_QP_QUERY_PARAMS_OUT {
      UEXACT16 cid;
      UEXACT32 sq_cq_id;
      UEXACT32 rq_cq_id;
      UEXACT32 pdid;
      UEXACT32 state;
      UEXACT32 qp_sq_size;
      UEXACT32 qp_rq_size;
      UEXACT32 ird;
      UEXACT32 ord;
      UEXACT32 flags;
   } SG_PACK IOCTL_RDMA_QP_QUERY_PARAMS_OUT, *PIOCTL_RDMA_QP_QUERY_PARAMS_OUT;



#else
   
   typedef struct _IOCTL_RDMA_QP_QUERY_PARAMS_OUT {
      UEXACT16 cid;
      UEXACT32 sq_cq_id;
      UEXACT32 rq_cq_id;
      UEXACT32 pdid;
      UEXACT32 state;
      UEXACT32 qp_sq_size;
      UEXACT32 qp_rq_size;
      UEXACT32 ird;
      UEXACT32 ord;
      UEXACT32 flags;
   } SG_PACK IOCTL_RDMA_QP_QUERY_PARAMS_OUT, *PIOCTL_RDMA_QP_QUERY_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for querying the member status of the QP context data structure on chip
   // belonging to a particular QP. 
   typedef struct _IOCTL_RDMA_QP_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 qp_id;
         } request;
         IOCTL_RDMA_QP_QUERY_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_QUERY, *PIOCTL_RDMA_QP_QUERY;



#else
   // IOCTL for querying the member status of the QP context data structure on chip
   // belonging to a particular QP. 
   typedef struct _IOCTL_RDMA_QP_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 qp_id;
         } request;
         IOCTL_RDMA_QP_QUERY_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_QUERY, *PIOCTL_RDMA_QP_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 qp_id;
               UEXACT32 new_state;
               UEXACT32 qp_sq_size;
               UEXACT32 qp_rq_size;
               UEXACT32 ird;
               UEXACT32 ord;
               UEXACT32 flags;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_QP_MODIFY_PARAMS_IN, sizeof (IOCTL_RDMA_QP_MODIFY_PARAMS_IN) == 28);

   #else
      typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_IN {
         UEXACT32 qp_id;
         UEXACT32 new_state;
         UEXACT32 qp_sq_size;
         UEXACT32 qp_rq_size;
         UEXACT32 ird;
         UEXACT32 ord;
         UEXACT32 flags;
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN;

      typedef union _IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION {
         IOCTL_RDMA_QP_MODIFY_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 qp_id;
               UEXACT32 new_state;
               UEXACT32 qp_sq_size;
               UEXACT32 qp_rq_size;
               UEXACT32 ird;
               UEXACT32 ord;
               UEXACT32 flags;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_QP_MODIFY_PARAMS_IN, sizeof (IOCTL_RDMA_QP_MODIFY_PARAMS_IN) == 28);

   #else
      typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_IN {
         UEXACT32 qp_id;
         UEXACT32 new_state;
         UEXACT32 qp_sq_size;
         UEXACT32 qp_rq_size;
         UEXACT32 ird;
         UEXACT32 ord;
         UEXACT32 flags;
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN;

      typedef union _IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION {
         IOCTL_RDMA_QP_MODIFY_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_QP_MODIFY_PARAMS_IN_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_OUT {
      UEXACT16 cid;
   } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_OUT, *PIOCTL_RDMA_QP_MODIFY_PARAMS_OUT;



#else
   
   typedef struct _IOCTL_RDMA_QP_MODIFY_PARAMS_OUT {
      UEXACT16 cid;
   } SG_PACK IOCTL_RDMA_QP_MODIFY_PARAMS_OUT, *PIOCTL_RDMA_QP_MODIFY_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for modifying the member content of the QP context data structure on chip. 
   typedef struct _IOCTL_RDMA_QP_MODIFY {
      IOCTL_HEADER header;
      union {
         IOCTL_RDMA_QP_MODIFY_PARAMS_IN request;
         IOCTL_RDMA_QP_MODIFY_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_MODIFY, *PIOCTL_RDMA_QP_MODIFY;



#else
   // IOCTL for modifying the member content of the QP context data structure on chip. 
   typedef struct _IOCTL_RDMA_QP_MODIFY {
      IOCTL_HEADER header;
      union {
         IOCTL_RDMA_QP_MODIFY_PARAMS_IN request;
         IOCTL_RDMA_QP_MODIFY_PARAMS_OUT response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_MODIFY, *PIOCTL_RDMA_QP_MODIFY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT16 rsvd0;
               MPU_TEMPLATE_HEADER header;
               TCP_CONTEXT tcp;
               QP_CONTEXT qp;
               MPU_OFFLOAD_CXN_ENTRY filter;
            } SG_PACK ; // unnamed struct
            u32 dw[93]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, sizeof (IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN) == 372);

   #else
      typedef struct _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN {
         UEXACT16 cid;
         UEXACT16 rsvd0;
         MPU_TEMPLATE_HEADER header;
         TCP_CONTEXT tcp;
         QP_CONTEXT qp;
         MPU_OFFLOAD_CXN_ENTRY filter;
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN;

      typedef union _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION {
         IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN bits;
         u32 dw[93]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION) == 372);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT16 rsvd0;
               MPU_TEMPLATE_HEADER header;
               TCP_CONTEXT tcp;
               QP_CONTEXT qp;
               MPU_OFFLOAD_CXN_ENTRY filter;
            } SG_PACK ; // unnamed struct
            u32 dw[93]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, sizeof (IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN) == 372);

   #else
      typedef struct _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN {
         UEXACT16 cid;
         UEXACT16 rsvd0;
         MPU_TEMPLATE_HEADER header;
         TCP_CONTEXT tcp;
         QP_CONTEXT qp;
         MPU_OFFLOAD_CXN_ENTRY filter;
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN;

      typedef union _IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION {
         IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN bits;
         u32 dw[93]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_UNION) == 372);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for offloading an RDMA (QP) connection. 
   typedef struct _IOCTL_RDMA_CXN_OFFLOAD {
      IOCTL_HEADER header;
      union {
         IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_CXN_OFFLOAD, *PIOCTL_RDMA_CXN_OFFLOAD;



#else
   // IOCTL for offloading an RDMA (QP) connection. 
   typedef struct _IOCTL_RDMA_CXN_OFFLOAD {
      IOCTL_HEADER header;
      union {
         IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_CXN_OFFLOAD, *PIOCTL_RDMA_CXN_OFFLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT8 pload_type;
               UEXACT8 rsvd0;
               UEXACT32 reset_seq;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN {
         UEXACT16 cid;
         UEXACT8 pload_type;
         UEXACT8 rsvd0;
         UEXACT32 reset_seq;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 cid;
               UEXACT8 pload_type;
               UEXACT8 rsvd0;
               UEXACT32 reset_seq;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN {
         UEXACT16 cid;
         UEXACT8 pload_type;
         UEXACT8 rsvd0;
         UEXACT32 reset_seq;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT {
         union {
            struct { 
               QP_CONTEXT qp;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT) == 64);

   #else
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT {
         QP_CONTEXT qp;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT {
         union {
            struct { 
               QP_CONTEXT qp;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT) == 64);

   #else
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT {
         QP_CONTEXT qp;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS {
         union {
            union { 
               IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN request;
               IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS) == 64);

   #else
      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN request;
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT response;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_RDMA_CXN_UPLOAD_PARAMS {
         union {
            union { 
               IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN request;
               IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS) == 64);

   #else
      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN request;
         IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT response;
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS;

      typedef union _IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION {
         IOCTL_RDMA_CXN_UPLOAD_PARAMS bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION, sizeof (IOCTL_RDMA_CXN_UPLOAD_PARAMS_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL uploads a given RDMA (QP) connection. This upload process flushes the QP,
   // disables the offload, and returns the final QP state. 
   typedef struct _IOCTL_RDMA_CXN_UPLOAD {
      IOCTL_HEADER header;
      IOCTL_RDMA_CXN_UPLOAD_PARAMS params;
   } SG_PACK IOCTL_RDMA_CXN_UPLOAD, *PIOCTL_RDMA_CXN_UPLOAD;



#else
   // This IOCTL uploads a given RDMA (QP) connection. This upload process flushes the QP,
   // disables the offload, and returns the final QP state. 
   typedef struct _IOCTL_RDMA_CXN_UPLOAD {
      IOCTL_HEADER header;
      IOCTL_RDMA_CXN_UPLOAD_PARAMS params;
   } SG_PACK IOCTL_RDMA_CXN_UPLOAD, *PIOCTL_RDMA_CXN_UPLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Updates the content of the QP context corresponding to this connection ID. 
   typedef struct _IOCTL_RDMA_CXN_UPDATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 cid;
            UEXACT32 sq_cq_id;
            UEXACT32 rq_cq_id;
            UEXACT32 pdid;
            UEXACT32 state;
            UEXACT32 qp_sq_size;
            UEXACT32 qp_rq_size;
            UEXACT32 ird;
            UEXACT32 ord;
            UEXACT32 flags;
            MPU_TEMPLATE_HEADER header;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_CXN_UPDATE, *PIOCTL_RDMA_CXN_UPDATE;



#else
   // Updates the content of the QP context corresponding to this connection ID. 
   typedef struct _IOCTL_RDMA_CXN_UPDATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 cid;
            UEXACT32 sq_cq_id;
            UEXACT32 rq_cq_id;
            UEXACT32 pdid;
            UEXACT32 state;
            UEXACT32 qp_sq_size;
            UEXACT32 qp_rq_size;
            UEXACT32 ird;
            UEXACT32 ord;
            UEXACT32 flags;
            MPU_TEMPLATE_HEADER header;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_CXN_UPDATE, *PIOCTL_RDMA_CXN_UPDATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allocates Memory registration resources on RNIC. 
   typedef struct _IOCTL_RDMA_ALLOC_NSMR_STAG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 pd_id;
            UEXACT8 rsvd0;
            UEXACT16 flags;
            UEXACT32 length;
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT32 length;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_ALLOC_NSMR_STAG, *PIOCTL_RDMA_ALLOC_NSMR_STAG;



#else
   // Allocates Memory registration resources on RNIC. 
   typedef struct _IOCTL_RDMA_ALLOC_NSMR_STAG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 pd_id;
            UEXACT8 rsvd0;
            UEXACT16 flags;
            UEXACT32 length;
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT32 length;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_ALLOC_NSMR_STAG, *PIOCTL_RDMA_ALLOC_NSMR_STAG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCtl is used to activate a non shared memory region 
   typedef struct _IOCTL_RDMA_NSMR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            PE pe;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_NSMR_REGISTER, *PIOCTL_RDMA_NSMR_REGISTER;



#else
   // This IOCtl is used to activate a non shared memory region 
   typedef struct _IOCTL_RDMA_NSMR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            PE pe;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_NSMR_REGISTER, *PIOCTL_RDMA_NSMR_REGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCtl is used to modify the parameters of existing MR 
   typedef struct _IOCTL_RDMA_NSMR_REREGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            PE pe;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_NSMR_REREGISTER, *PIOCTL_RDMA_NSMR_REREGISTER;



#else
   // This IOCtl is used to modify the parameters of existing MR 
   typedef struct _IOCTL_RDMA_NSMR_REREGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            PE pe;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_NSMR_REREGISTER, *PIOCTL_RDMA_NSMR_REREGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCtl is used to post more TEs for a given MR 
   typedef struct _IOCTL_RDMA_ADD_TE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_ADD_TE, *PIOCTL_RDMA_ADD_TE;



#else
   // This IOCtl is used to post more TEs for a given MR 
   typedef struct _IOCTL_RDMA_ADD_TE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
            UEXACT8 te_offset;
            UEXACT8 num_tes;
            UEXACT16 rsvd0;
            PHYS_ADDR te[26];
         } request;
         struct {
            UEXACT32 stag_index;
            UEXACT16 num_pages_alloc;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_ADD_TE, *PIOCTL_RDMA_ADD_TE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCtl is used to register a Shared MR 
   typedef struct _IOCTL_RDMA_SMR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
            PE pe;
         } request;
         struct {
            UEXACT32 stag_index;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_SMR_REGISTER, *PIOCTL_RDMA_SMR_REGISTER;



#else
   // This IOCtl is used to register a Shared MR 
   typedef struct _IOCTL_RDMA_SMR_REGISTER {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
            PE pe;
         } request;
         struct {
            UEXACT32 stag_index;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_SMR_REGISTER, *PIOCTL_RDMA_SMR_REGISTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCtl is used to query a memory region 
   typedef struct _IOCTL_RDMA_QUERY_MR {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
         } request;
         struct {
            PE pe;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QUERY_MR, *PIOCTL_RDMA_QUERY_MR;



#else
   // This IOCtl is used to query a memory region 
   typedef struct _IOCTL_RDMA_QUERY_MR {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
         } request;
         struct {
            PE pe;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QUERY_MR, *PIOCTL_RDMA_QUERY_MR;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL deallocates a Stag created through an earlier allocate, register,
   // reregister, register shared memory region, or register memory window call. 
   typedef struct _IOCTL_RDMA_STAG_DEALLOC {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_key;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_STAG_DEALLOC, *PIOCTL_RDMA_STAG_DEALLOC;



#else
   // This IOCTL deallocates a Stag created through an earlier allocate, register,
   // reregister, register shared memory region, or register memory window call. 
   typedef struct _IOCTL_RDMA_STAG_DEALLOC {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_key;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_STAG_DEALLOC, *PIOCTL_RDMA_STAG_DEALLOC;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL retrieves information about a specific memory window or memory region. 
   typedef struct _IOCTL_RDMA_MW_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
         } request;
         struct {
            PE pe;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_MW_QUERY, *PIOCTL_RDMA_MW_QUERY;



#else
   // This IOCTL retrieves information about a specific memory window or memory region. 
   typedef struct _IOCTL_RDMA_MW_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 stag_index;
         } request;
         struct {
            PE pe;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_MW_QUERY, *PIOCTL_RDMA_MW_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL retrieves ipaddresses used for RDMA from ARM for Operating systems where
   // the host ip addresses cannot be used. Blocks of eight ip addresses are returned per
   // call. 
   typedef struct _IOCTL_RDMA_IPADDR_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 index;
         } request;
         struct {
            UEXACT32 valid_count;
            UEXACT32 total_count;
            UEXACT32 ip_addr[8];
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_IPADDR_QUERY, *PIOCTL_RDMA_IPADDR_QUERY;



#else
   // This IOCTL retrieves ipaddresses used for RDMA from ARM for Operating systems where
   // the host ip addresses cannot be used. Blocks of eight ip addresses are returned per
   // call. 
   typedef struct _IOCTL_RDMA_IPADDR_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 index;
         } request;
         struct {
            UEXACT32 valid_count;
            UEXACT32 total_count;
            UEXACT32 ip_addr[8];
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_IPADDR_QUERY, *PIOCTL_RDMA_IPADDR_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying an RDMA Queue Pair. 
   typedef struct _IOCTL_RDMA_QP_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_DESTROY, *PIOCTL_RDMA_QP_DESTROY;



#else
   // IOCTL for destroying an RDMA Queue Pair. 
   typedef struct _IOCTL_RDMA_QP_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 id;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_RDMA_QP_DESTROY, *PIOCTL_RDMA_QP_DESTROY;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_rdma_bmap_h__

