/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ipc_fw_impl_bmap_h__
#define __ipc_fw_impl_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "descriptors_bmap.h"
#include "iscsi_common_host_struct_bmap.h"
#include "ep_queue_bmap.h"
#include "fw_exp_bmap.h"
#include "host_struct_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // An IPC must be interpreted as IPC_TCP_STATE_D when the IPC code indicates
   // IPC_TCP_STATE 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_STATE_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 tcp_state : 8;                 // DWORD 1
               u32 tcp_error : 8;                 // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_STATE_D, *PIPC_TCP_STATE_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_STATE_D, sizeof (IPC_TCP_STATE_D) == 8);

   #else
      typedef struct _IPC_TCP_STATE_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 tcp_state : 8;                       // DWORD 1
         u32 tcp_error : 8;                       // DWORD 1
      } SG_PACK IPC_TCP_STATE_D, *PIPC_TCP_STATE_D;

      typedef union _IPC_TCP_STATE_D_UNION {
         IPC_TCP_STATE_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_TCP_STATE_D_UNION, *PIPC_TCP_STATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_STATE_D_UNION, sizeof (IPC_TCP_STATE_D_UNION) == 8);
   #endif


#else
   // An IPC must be interpreted as IPC_TCP_STATE_D when the IPC code indicates
   // IPC_TCP_STATE 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_STATE_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 tcp_error : 8;                 // DWORD 1
               u32 tcp_state : 8;                 // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_STATE_D, *PIPC_TCP_STATE_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_STATE_D, sizeof (IPC_TCP_STATE_D) == 8);

   #else
      typedef struct _IPC_TCP_STATE_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 tcp_error : 8;                       // DWORD 1
         u32 tcp_state : 8;                       // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_TCP_STATE_D, *PIPC_TCP_STATE_D;

      typedef union _IPC_TCP_STATE_D_UNION {
         IPC_TCP_STATE_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_TCP_STATE_D_UNION, *PIPC_TCP_STATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_STATE_D_UNION, sizeof (IPC_TCP_STATE_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI IPC descriptor from ARM to iSCSI TXULP to update GLOBAL QOS. IPC codes are
   // IPC_ISCSI_GLOBAL_QOS_ENABLE and IPC_ISCSI_GLOBAL_QOS_DISABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_GLOBAL_QOS_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 delta_time;                    // DWORD 2
               u32 delta_bytes;                   // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D, *PIPC_ISCSI_GLOBAL_QOS_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_GLOBAL_QOS_D, sizeof (IPC_ISCSI_GLOBAL_QOS_D) == 16);

   #else
      typedef struct _IPC_ISCSI_GLOBAL_QOS_D {
         IPC_HEADER_D header;
         u32 delta_time;                          // DWORD 2
         u32 delta_bytes;                         // DWORD 3
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D, *PIPC_ISCSI_GLOBAL_QOS_D;

      typedef union _IPC_ISCSI_GLOBAL_QOS_D_UNION {
         IPC_ISCSI_GLOBAL_QOS_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D_UNION, *PIPC_ISCSI_GLOBAL_QOS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_GLOBAL_QOS_D_UNION, sizeof (IPC_ISCSI_GLOBAL_QOS_D_UNION) == 16);
   #endif


#else
   // iSCSI IPC descriptor from ARM to iSCSI TXULP to update GLOBAL QOS. IPC codes are
   // IPC_ISCSI_GLOBAL_QOS_ENABLE and IPC_ISCSI_GLOBAL_QOS_DISABLE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_GLOBAL_QOS_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 delta_time;                    // DWORD 2
               u32 delta_bytes;                   // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D, *PIPC_ISCSI_GLOBAL_QOS_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_GLOBAL_QOS_D, sizeof (IPC_ISCSI_GLOBAL_QOS_D) == 16);

   #else
      typedef struct _IPC_ISCSI_GLOBAL_QOS_D {
         IPC_HEADER_D header;
         u32 delta_time;                          // DWORD 2
         u32 delta_bytes;                         // DWORD 3
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D, *PIPC_ISCSI_GLOBAL_QOS_D;

      typedef union _IPC_ISCSI_GLOBAL_QOS_D_UNION {
         IPC_ISCSI_GLOBAL_QOS_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_GLOBAL_QOS_D_UNION, *PIPC_ISCSI_GLOBAL_QOS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_GLOBAL_QOS_D_UNION, sizeof (IPC_ISCSI_GLOBAL_QOS_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPC descriptor from TxULP to RxULP on a WRB completion 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_WRB_COMPLETE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 rsvd0 : 16;                    // DWORD 2
               u32 icd_index : 16;                // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_WRB_COMPLETE_D, *PIPC_WRB_COMPLETE_D;

      SG_C_ASSERT(__sizeof__IPC_WRB_COMPLETE_D, sizeof (IPC_WRB_COMPLETE_D) == 12);

   #else
      typedef struct _IPC_WRB_COMPLETE_D {
         IPC_HEADER_D header;
         u32 rsvd0 : 16;                          // DWORD 2
         u32 icd_index : 16;                      // DWORD 2
      } SG_PACK IPC_WRB_COMPLETE_D, *PIPC_WRB_COMPLETE_D;

      typedef union _IPC_WRB_COMPLETE_D_UNION {
         IPC_WRB_COMPLETE_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_WRB_COMPLETE_D_UNION, *PIPC_WRB_COMPLETE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_WRB_COMPLETE_D_UNION, sizeof (IPC_WRB_COMPLETE_D_UNION) == 12);
   #endif


#else
   // IPC descriptor from TxULP to RxULP on a WRB completion 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_WRB_COMPLETE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 icd_index : 16;                // DWORD 2
               u32 rsvd0 : 16;                    // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_WRB_COMPLETE_D, *PIPC_WRB_COMPLETE_D;

      SG_C_ASSERT(__sizeof__IPC_WRB_COMPLETE_D, sizeof (IPC_WRB_COMPLETE_D) == 12);

   #else
      typedef struct _IPC_WRB_COMPLETE_D {
         IPC_HEADER_D header;
         u32 icd_index : 16;                      // DWORD 2
         u32 rsvd0 : 16;                          // DWORD 2
      } SG_PACK IPC_WRB_COMPLETE_D, *PIPC_WRB_COMPLETE_D;

      typedef union _IPC_WRB_COMPLETE_D_UNION {
         IPC_WRB_COMPLETE_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_WRB_COMPLETE_D_UNION, *PIPC_WRB_COMPLETE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_WRB_COMPLETE_D_UNION, sizeof (IPC_WRB_COMPLETE_D_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_UPDATE_RCV_SBCC_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 rsvd0 : 27;                    // DWORD 2
               u32 rcv_wnd_ulp_factor : 5;        // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_UPDATE_RCV_SBCC_D, *PIPC_UPDATE_RCV_SBCC_D;

      SG_C_ASSERT(__sizeof__IPC_UPDATE_RCV_SBCC_D, sizeof (IPC_UPDATE_RCV_SBCC_D) == 12);

   #else
      typedef struct _IPC_UPDATE_RCV_SBCC_D {
         IPC_HEADER_D header;
         u32 rsvd0 : 27;                          // DWORD 2
         u32 rcv_wnd_ulp_factor : 5;              // DWORD 2
      } SG_PACK IPC_UPDATE_RCV_SBCC_D, *PIPC_UPDATE_RCV_SBCC_D;

      typedef union _IPC_UPDATE_RCV_SBCC_D_UNION {
         IPC_UPDATE_RCV_SBCC_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_UPDATE_RCV_SBCC_D_UNION, *PIPC_UPDATE_RCV_SBCC_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_UPDATE_RCV_SBCC_D_UNION, sizeof (IPC_UPDATE_RCV_SBCC_D_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_UPDATE_RCV_SBCC_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 rcv_wnd_ulp_factor : 5;        // DWORD 2
               u32 rsvd0 : 27;                    // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_UPDATE_RCV_SBCC_D, *PIPC_UPDATE_RCV_SBCC_D;

      SG_C_ASSERT(__sizeof__IPC_UPDATE_RCV_SBCC_D, sizeof (IPC_UPDATE_RCV_SBCC_D) == 12);

   #else
      typedef struct _IPC_UPDATE_RCV_SBCC_D {
         IPC_HEADER_D header;
         u32 rcv_wnd_ulp_factor : 5;              // DWORD 2
         u32 rsvd0 : 27;                          // DWORD 2
      } SG_PACK IPC_UPDATE_RCV_SBCC_D, *PIPC_UPDATE_RCV_SBCC_D;

      typedef union _IPC_UPDATE_RCV_SBCC_D_UNION {
         IPC_UPDATE_RCV_SBCC_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_UPDATE_RCV_SBCC_D_UNION, *PIPC_UPDATE_RCV_SBCC_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_UPDATE_RCV_SBCC_D_UNION, sizeof (IPC_UPDATE_RCV_SBCC_D_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI IPC descriptor from TxULP1 to TPost and between TX/RX ULP1 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_D {
         union {
            struct { 
               IPC_HEADER_D header;
               ISCSI_RRMSG rrmsg;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_D, *PIPC_ISCSI_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_D, sizeof (IPC_ISCSI_D) == 16);

   #else
      typedef struct _IPC_ISCSI_D {
         IPC_HEADER_D header;
         ISCSI_RRMSG rrmsg;
      } SG_PACK IPC_ISCSI_D, *PIPC_ISCSI_D;

      typedef union _IPC_ISCSI_D_UNION {
         IPC_ISCSI_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_D_UNION, *PIPC_ISCSI_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_D_UNION, sizeof (IPC_ISCSI_D_UNION) == 16);
   #endif


#else
   // iSCSI IPC descriptor from TxULP1 to TPost and between TX/RX ULP1 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_D {
         union {
            struct { 
               IPC_HEADER_D header;
               ISCSI_RRMSG rrmsg;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_D, *PIPC_ISCSI_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_D, sizeof (IPC_ISCSI_D) == 16);

   #else
      typedef struct _IPC_ISCSI_D {
         IPC_HEADER_D header;
         ISCSI_RRMSG rrmsg;
      } SG_PACK IPC_ISCSI_D, *PIPC_ISCSI_D;

      typedef union _IPC_ISCSI_D_UNION {
         IPC_ISCSI_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_D_UNION, *PIPC_ISCSI_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_D_UNION, sizeof (IPC_ISCSI_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI IPC descriptor from TxULP1 to RX ULP1 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_CTX_UPD_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 rsvd0 : 6;                     // DWORD 2
               u32 fbl : 14;                      // DWORD 2
               u32 erl : 2;                       // DWORD 2
               u32 ir2t : 1;                      // DWORD 2
               u32 hdr_bytes_left : 6;            // DWORD 2
               u32 imm : 1;                       // DWORD 2
               u32 dde : 1;                       // DWORD 2
               u32 hde : 1;                       // DWORD 2
               u32 rsvd1 : 13;                    // DWORD 3
               u32 mbl : 19;                      // DWORD 3
               u32 stat_sn;                       // DWORD 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_CTX_UPD_D, *PIPC_ISCSI_CTX_UPD_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_CTX_UPD_D, sizeof (IPC_ISCSI_CTX_UPD_D) == 24);

   #else
      typedef struct _IPC_ISCSI_CTX_UPD_D {
         IPC_HEADER_D header;
         u32 rsvd0 : 6;                           // DWORD 2
         u32 fbl : 14;                            // DWORD 2
         u32 erl : 2;                             // DWORD 2
         u32 ir2t : 1;                            // DWORD 2
         u32 hdr_bytes_left : 6;                  // DWORD 2
         u32 imm : 1;                             // DWORD 2
         u32 dde : 1;                             // DWORD 2
         u32 hde : 1;                             // DWORD 2
         u32 rsvd1 : 13;                          // DWORD 3
         u32 mbl : 19;                            // DWORD 3
         u32 stat_sn;                             // DWORD 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_ISCSI_CTX_UPD_D, *PIPC_ISCSI_CTX_UPD_D;

      typedef union _IPC_ISCSI_CTX_UPD_D_UNION {
         IPC_ISCSI_CTX_UPD_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_ISCSI_CTX_UPD_D_UNION, *PIPC_ISCSI_CTX_UPD_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_CTX_UPD_D_UNION, sizeof (IPC_ISCSI_CTX_UPD_D_UNION) == 24);
   #endif


#else
   // iSCSI IPC descriptor from TxULP1 to RX ULP1 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_CTX_UPD_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 hde : 1;                       // DWORD 2
               u32 dde : 1;                       // DWORD 2
               u32 imm : 1;                       // DWORD 2
               u32 hdr_bytes_left : 6;            // DWORD 2
               u32 ir2t : 1;                      // DWORD 2
               u32 erl : 2;                       // DWORD 2
               u32 fbl : 14;                      // DWORD 2
               u32 rsvd0 : 6;                     // DWORD 2
               u32 mbl : 19;                      // DWORD 3
               u32 rsvd1 : 13;                    // DWORD 3
               u32 stat_sn;                       // DWORD 4
               u32 rsvd2[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_CTX_UPD_D, *PIPC_ISCSI_CTX_UPD_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_CTX_UPD_D, sizeof (IPC_ISCSI_CTX_UPD_D) == 24);

   #else
      typedef struct _IPC_ISCSI_CTX_UPD_D {
         IPC_HEADER_D header;
         u32 hde : 1;                             // DWORD 2
         u32 dde : 1;                             // DWORD 2
         u32 imm : 1;                             // DWORD 2
         u32 hdr_bytes_left : 6;                  // DWORD 2
         u32 ir2t : 1;                            // DWORD 2
         u32 erl : 2;                             // DWORD 2
         u32 fbl : 14;                            // DWORD 2
         u32 rsvd0 : 6;                           // DWORD 2
         u32 mbl : 19;                            // DWORD 3
         u32 rsvd1 : 13;                          // DWORD 3
         u32 stat_sn;                             // DWORD 4
         u32 rsvd2[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_ISCSI_CTX_UPD_D, *PIPC_ISCSI_CTX_UPD_D;

      typedef union _IPC_ISCSI_CTX_UPD_D_UNION {
         IPC_ISCSI_CTX_UPD_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_ISCSI_CTX_UPD_D_UNION, *PIPC_ISCSI_CTX_UPD_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_CTX_UPD_D_UNION, sizeof (IPC_ISCSI_CTX_UPD_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_COUNTER_UNLOAD {
         union {
            struct { 
               EP_UNLOAD_ORDER header;
               EP_UNLOAD_ORDER payload;
               EP_UNLOAD_ORDER scratch_ctxt_order1;
               EP_UNLOAD_ORDER scratch_ctxt_order2;
               EP_UNLOAD_ORDER null[2];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_COUNTER_UNLOAD, *PIPC_COUNTER_UNLOAD;

      SG_C_ASSERT(__sizeof__IPC_COUNTER_UNLOAD, sizeof (IPC_COUNTER_UNLOAD) == 24);

   #else
      typedef struct _IPC_COUNTER_UNLOAD {
         EP_UNLOAD_ORDER header;
         EP_UNLOAD_ORDER payload;
         EP_UNLOAD_ORDER scratch_ctxt_order1;
         EP_UNLOAD_ORDER scratch_ctxt_order2;
         EP_UNLOAD_ORDER null[2];
      } SG_PACK IPC_COUNTER_UNLOAD, *PIPC_COUNTER_UNLOAD;

      typedef union _IPC_COUNTER_UNLOAD_UNION {
         IPC_COUNTER_UNLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_COUNTER_UNLOAD_UNION, *PIPC_COUNTER_UNLOAD_UNION;

      SG_C_ASSERT(__sizeof__IPC_COUNTER_UNLOAD_UNION, sizeof (IPC_COUNTER_UNLOAD_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_COUNTER_UNLOAD {
         union {
            struct { 
               EP_UNLOAD_ORDER header;
               EP_UNLOAD_ORDER payload;
               EP_UNLOAD_ORDER scratch_ctxt_order1;
               EP_UNLOAD_ORDER scratch_ctxt_order2;
               EP_UNLOAD_ORDER null[2];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_COUNTER_UNLOAD, *PIPC_COUNTER_UNLOAD;

      SG_C_ASSERT(__sizeof__IPC_COUNTER_UNLOAD, sizeof (IPC_COUNTER_UNLOAD) == 24);

   #else
      typedef struct _IPC_COUNTER_UNLOAD {
         EP_UNLOAD_ORDER header;
         EP_UNLOAD_ORDER payload;
         EP_UNLOAD_ORDER scratch_ctxt_order1;
         EP_UNLOAD_ORDER scratch_ctxt_order2;
         EP_UNLOAD_ORDER null[2];
      } SG_PACK IPC_COUNTER_UNLOAD, *PIPC_COUNTER_UNLOAD;

      typedef union _IPC_COUNTER_UNLOAD_UNION {
         IPC_COUNTER_UNLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_COUNTER_UNLOAD_UNION, *PIPC_COUNTER_UNLOAD_UNION;

      SG_C_ASSERT(__sizeof__IPC_COUNTER_UNLOAD_UNION, sizeof (IPC_COUNTER_UNLOAD_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_PARAMS {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_PARAMETERS params;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_PARAMS, *PIPC_TCP_PARAMS;

      SG_C_ASSERT(__sizeof__IPC_TCP_PARAMS, sizeof (IPC_TCP_PARAMS) == 16);

   #else
      typedef struct _IPC_TCP_PARAMS {
         IPC_HEADER_D header;
         TCP_PARAMETERS params;
      } SG_PACK IPC_TCP_PARAMS, *PIPC_TCP_PARAMS;

      typedef union _IPC_TCP_PARAMS_UNION {
         IPC_TCP_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_PARAMS_UNION, *PIPC_TCP_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_PARAMS_UNION, sizeof (IPC_TCP_PARAMS_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_PARAMS {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_PARAMETERS params;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_PARAMS, *PIPC_TCP_PARAMS;

      SG_C_ASSERT(__sizeof__IPC_TCP_PARAMS, sizeof (IPC_TCP_PARAMS) == 16);

   #else
      typedef struct _IPC_TCP_PARAMS {
         IPC_HEADER_D header;
         TCP_PARAMETERS params;
      } SG_PACK IPC_TCP_PARAMS, *PIPC_TCP_PARAMS;

      typedef union _IPC_TCP_PARAMS_UNION {
         IPC_TCP_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_PARAMS_UNION, *PIPC_TCP_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_PARAMS_UNION, sizeof (IPC_TCP_PARAMS_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TOE_DEFQ_CRED {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 def_q_credits;                 // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TOE_DEFQ_CRED, *PIPC_TOE_DEFQ_CRED;

      SG_C_ASSERT(__sizeof__IPC_TOE_DEFQ_CRED, sizeof (IPC_TOE_DEFQ_CRED) == 12);

   #else
      typedef struct _IPC_TOE_DEFQ_CRED {
         IPC_HEADER_D header;
         u32 def_q_credits;                       // DWORD 2
      } SG_PACK IPC_TOE_DEFQ_CRED, *PIPC_TOE_DEFQ_CRED;

      typedef union _IPC_TOE_DEFQ_CRED_UNION {
         IPC_TOE_DEFQ_CRED bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_TOE_DEFQ_CRED_UNION, *PIPC_TOE_DEFQ_CRED_UNION;

      SG_C_ASSERT(__sizeof__IPC_TOE_DEFQ_CRED_UNION, sizeof (IPC_TOE_DEFQ_CRED_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TOE_DEFQ_CRED {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 def_q_credits;                 // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TOE_DEFQ_CRED, *PIPC_TOE_DEFQ_CRED;

      SG_C_ASSERT(__sizeof__IPC_TOE_DEFQ_CRED, sizeof (IPC_TOE_DEFQ_CRED) == 12);

   #else
      typedef struct _IPC_TOE_DEFQ_CRED {
         IPC_HEADER_D header;
         u32 def_q_credits;                       // DWORD 2
      } SG_PACK IPC_TOE_DEFQ_CRED, *PIPC_TOE_DEFQ_CRED;

      typedef union _IPC_TOE_DEFQ_CRED_UNION {
         IPC_TOE_DEFQ_CRED bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_TOE_DEFQ_CRED_UNION, *PIPC_TOE_DEFQ_CRED_UNION;

      SG_C_ASSERT(__sizeof__IPC_TOE_DEFQ_CRED_UNION, sizeof (IPC_TOE_DEFQ_CRED_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI IPC descriptor from ARM to iSCSI TXULP to update max. QoS counters 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_QOS_UPDATE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 rsvd0 : 27;                    // DWORD 2
               u32 domainID : 5;                  // DWORD 2
               ISCSI_QOS_COUNTERS counters;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D, *PIPC_ISCSI_QOS_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_QOS_UPDATE_D, sizeof (IPC_ISCSI_QOS_UPDATE_D) == 16);

   #else
      typedef struct _IPC_ISCSI_QOS_UPDATE_D {
         IPC_HEADER_D header;
         u32 rsvd0 : 27;                          // DWORD 2
         u32 domainID : 5;                        // DWORD 2
         ISCSI_QOS_COUNTERS counters;
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D, *PIPC_ISCSI_QOS_UPDATE_D;

      typedef union _IPC_ISCSI_QOS_UPDATE_D_UNION {
         IPC_ISCSI_QOS_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D_UNION, *PIPC_ISCSI_QOS_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_QOS_UPDATE_D_UNION, sizeof (IPC_ISCSI_QOS_UPDATE_D_UNION) == 16);
   #endif


#else
   // iSCSI IPC descriptor from ARM to iSCSI TXULP to update max. QoS counters 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ISCSI_QOS_UPDATE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 domainID : 5;                  // DWORD 2
               u32 rsvd0 : 27;                    // DWORD 2
               ISCSI_QOS_COUNTERS counters;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D, *PIPC_ISCSI_QOS_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_QOS_UPDATE_D, sizeof (IPC_ISCSI_QOS_UPDATE_D) == 16);

   #else
      typedef struct _IPC_ISCSI_QOS_UPDATE_D {
         IPC_HEADER_D header;
         u32 domainID : 5;                        // DWORD 2
         u32 rsvd0 : 27;                          // DWORD 2
         ISCSI_QOS_COUNTERS counters;
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D, *PIPC_ISCSI_QOS_UPDATE_D;

      typedef union _IPC_ISCSI_QOS_UPDATE_D_UNION {
         IPC_ISCSI_QOS_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_ISCSI_QOS_UPDATE_D_UNION, *PIPC_ISCSI_QOS_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ISCSI_QOS_UPDATE_D_UNION, sizeof (IPC_ISCSI_QOS_UPDATE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP IPC descriptor from ARM to TPOST and TPRE to update per connection parameters 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_UPDATE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_UPDATE_DATA update_data;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_UPDATE_D, *PIPC_TCP_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_UPDATE_D, sizeof (IPC_TCP_UPDATE_D) == 16);

   #else
      typedef struct _IPC_TCP_UPDATE_D {
         IPC_HEADER_D header;
         TCP_UPDATE_DATA update_data;
      } SG_PACK IPC_TCP_UPDATE_D, *PIPC_TCP_UPDATE_D;

      typedef union _IPC_TCP_UPDATE_D_UNION {
         IPC_TCP_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_UPDATE_D_UNION, *PIPC_TCP_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_UPDATE_D_UNION, sizeof (IPC_TCP_UPDATE_D_UNION) == 16);
   #endif


#else
   // TCP IPC descriptor from ARM to TPOST and TPRE to update per connection parameters 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_UPDATE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_UPDATE_DATA update_data;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_UPDATE_D, *PIPC_TCP_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_UPDATE_D, sizeof (IPC_TCP_UPDATE_D) == 16);

   #else
      typedef struct _IPC_TCP_UPDATE_D {
         IPC_HEADER_D header;
         TCP_UPDATE_DATA update_data;
      } SG_PACK IPC_TCP_UPDATE_D, *PIPC_TCP_UPDATE_D;

      typedef union _IPC_TCP_UPDATE_D_UNION {
         IPC_TCP_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_UPDATE_D_UNION, *PIPC_TCP_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_UPDATE_D_UNION, sizeof (IPC_TCP_UPDATE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP IPC descriptor from driver to ARM to TPRE and TOERX to update per connection
   // window shrink bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_WINDOW_SHRINK_D {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_WINDOW_SHRINK_DATA window_shrink_data;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D, *PIPC_TCP_WINDOW_SHRINK_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_WINDOW_SHRINK_D, sizeof (IPC_TCP_WINDOW_SHRINK_D) == 16);

   #else
      typedef struct _IPC_TCP_WINDOW_SHRINK_D {
         IPC_HEADER_D header;
         TCP_WINDOW_SHRINK_DATA window_shrink_data;
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D, *PIPC_TCP_WINDOW_SHRINK_D;

      typedef union _IPC_TCP_WINDOW_SHRINK_D_UNION {
         IPC_TCP_WINDOW_SHRINK_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D_UNION, *PIPC_TCP_WINDOW_SHRINK_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_WINDOW_SHRINK_D_UNION, sizeof (IPC_TCP_WINDOW_SHRINK_D_UNION) == 16);
   #endif


#else
   // TCP IPC descriptor from driver to ARM to TPRE and TOERX to update per connection
   // window shrink bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TCP_WINDOW_SHRINK_D {
         union {
            struct { 
               IPC_HEADER_D header;
               TCP_WINDOW_SHRINK_DATA window_shrink_data;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D, *PIPC_TCP_WINDOW_SHRINK_D;

      SG_C_ASSERT(__sizeof__IPC_TCP_WINDOW_SHRINK_D, sizeof (IPC_TCP_WINDOW_SHRINK_D) == 16);

   #else
      typedef struct _IPC_TCP_WINDOW_SHRINK_D {
         IPC_HEADER_D header;
         TCP_WINDOW_SHRINK_DATA window_shrink_data;
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D, *PIPC_TCP_WINDOW_SHRINK_D;

      typedef union _IPC_TCP_WINDOW_SHRINK_D_UNION {
         IPC_TCP_WINDOW_SHRINK_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TCP_WINDOW_SHRINK_D_UNION, *PIPC_TCP_WINDOW_SHRINK_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TCP_WINDOW_SHRINK_D_UNION, sizeof (IPC_TCP_WINDOW_SHRINK_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IPC contains information on the outer vlan tags to be inserted for the 8
   // physical functions 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_OUTER_VLAN_TAGS_D {
         union {
            struct { 
               IPC_HEADER_D header;
               OUTER_VLAN_INFO vlan_data;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_OUTER_VLAN_TAGS_D, *PIPC_OUTER_VLAN_TAGS_D;

      SG_C_ASSERT(__sizeof__IPC_OUTER_VLAN_TAGS_D, sizeof (IPC_OUTER_VLAN_TAGS_D) == 24);

   #else
      typedef struct _IPC_OUTER_VLAN_TAGS_D {
         IPC_HEADER_D header;
         OUTER_VLAN_INFO vlan_data;
      } SG_PACK IPC_OUTER_VLAN_TAGS_D, *PIPC_OUTER_VLAN_TAGS_D;

      typedef union _IPC_OUTER_VLAN_TAGS_D_UNION {
         IPC_OUTER_VLAN_TAGS_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_OUTER_VLAN_TAGS_D_UNION, *PIPC_OUTER_VLAN_TAGS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_OUTER_VLAN_TAGS_D_UNION, sizeof (IPC_OUTER_VLAN_TAGS_D_UNION) == 24);
   #endif


#else
   // This IPC contains information on the outer vlan tags to be inserted for the 8
   // physical functions 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_OUTER_VLAN_TAGS_D {
         union {
            struct { 
               IPC_HEADER_D header;
               OUTER_VLAN_INFO vlan_data;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_OUTER_VLAN_TAGS_D, *PIPC_OUTER_VLAN_TAGS_D;

      SG_C_ASSERT(__sizeof__IPC_OUTER_VLAN_TAGS_D, sizeof (IPC_OUTER_VLAN_TAGS_D) == 24);

   #else
      typedef struct _IPC_OUTER_VLAN_TAGS_D {
         IPC_HEADER_D header;
         OUTER_VLAN_INFO vlan_data;
      } SG_PACK IPC_OUTER_VLAN_TAGS_D, *PIPC_OUTER_VLAN_TAGS_D;

      typedef union _IPC_OUTER_VLAN_TAGS_D_UNION {
         IPC_OUTER_VLAN_TAGS_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_OUTER_VLAN_TAGS_D_UNION, *PIPC_OUTER_VLAN_TAGS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_OUTER_VLAN_TAGS_D_UNION, sizeof (IPC_OUTER_VLAN_TAGS_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Sent by tpost to txulp to enable excess 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TXULP_EXCESS_ENABLE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 port0_excess_bytes;            // DWORD 2
               u32 port1_excess_bytes;            // DWORD 3
               u32 port1_ct0_bytes;               // DWORD 4
               u32 port0_ct0_bytes;               // DWORD 5
               u32 port1_ct1_bytes;               // DWORD 6
               u32 port0_ct1_bytes;               // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D, *PIPC_TXULP_EXCESS_ENABLE_D;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_ENABLE_D, sizeof (IPC_TXULP_EXCESS_ENABLE_D) == 32);

   #else
      typedef struct _IPC_TXULP_EXCESS_ENABLE_D {
         IPC_HEADER_D header;
         u32 port0_excess_bytes;                  // DWORD 2
         u32 port1_excess_bytes;                  // DWORD 3
         u32 port1_ct0_bytes;                     // DWORD 4
         u32 port0_ct0_bytes;                     // DWORD 5
         u32 port1_ct1_bytes;                     // DWORD 6
         u32 port0_ct1_bytes;                     // DWORD 7
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D, *PIPC_TXULP_EXCESS_ENABLE_D;

      typedef union _IPC_TXULP_EXCESS_ENABLE_D_UNION {
         IPC_TXULP_EXCESS_ENABLE_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D_UNION, *PIPC_TXULP_EXCESS_ENABLE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_ENABLE_D_UNION, sizeof (IPC_TXULP_EXCESS_ENABLE_D_UNION) == 32);
   #endif


#else
   // Sent by tpost to txulp to enable excess 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TXULP_EXCESS_ENABLE_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 port0_excess_bytes;            // DWORD 2
               u32 port1_excess_bytes;            // DWORD 3
               u32 port1_ct0_bytes;               // DWORD 4
               u32 port0_ct0_bytes;               // DWORD 5
               u32 port1_ct1_bytes;               // DWORD 6
               u32 port0_ct1_bytes;               // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D, *PIPC_TXULP_EXCESS_ENABLE_D;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_ENABLE_D, sizeof (IPC_TXULP_EXCESS_ENABLE_D) == 32);

   #else
      typedef struct _IPC_TXULP_EXCESS_ENABLE_D {
         IPC_HEADER_D header;
         u32 port0_excess_bytes;                  // DWORD 2
         u32 port1_excess_bytes;                  // DWORD 3
         u32 port1_ct0_bytes;                     // DWORD 4
         u32 port0_ct0_bytes;                     // DWORD 5
         u32 port1_ct1_bytes;                     // DWORD 6
         u32 port0_ct1_bytes;                     // DWORD 7
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D, *PIPC_TXULP_EXCESS_ENABLE_D;

      typedef union _IPC_TXULP_EXCESS_ENABLE_D_UNION {
         IPC_TXULP_EXCESS_ENABLE_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_TXULP_EXCESS_ENABLE_D_UNION, *PIPC_TXULP_EXCESS_ENABLE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_ENABLE_D_UNION, sizeof (IPC_TXULP_EXCESS_ENABLE_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Sent by mpu to txulp to indicate excess spacing 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TXULP_EXCESS_SPACING_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 port0_excess_spacing;          // DWORD 2
               u32 port1_excess_spacing;          // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D, *PIPC_TXULP_EXCESS_SPACING_D;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_SPACING_D, sizeof (IPC_TXULP_EXCESS_SPACING_D) == 16);

   #else
      typedef struct _IPC_TXULP_EXCESS_SPACING_D {
         IPC_HEADER_D header;
         u32 port0_excess_spacing;                // DWORD 2
         u32 port1_excess_spacing;                // DWORD 3
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D, *PIPC_TXULP_EXCESS_SPACING_D;

      typedef union _IPC_TXULP_EXCESS_SPACING_D_UNION {
         IPC_TXULP_EXCESS_SPACING_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D_UNION, *PIPC_TXULP_EXCESS_SPACING_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_SPACING_D_UNION, sizeof (IPC_TXULP_EXCESS_SPACING_D_UNION) == 16);
   #endif


#else
   // Sent by mpu to txulp to indicate excess spacing 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_TXULP_EXCESS_SPACING_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 port0_excess_spacing;          // DWORD 2
               u32 port1_excess_spacing;          // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D, *PIPC_TXULP_EXCESS_SPACING_D;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_SPACING_D, sizeof (IPC_TXULP_EXCESS_SPACING_D) == 16);

   #else
      typedef struct _IPC_TXULP_EXCESS_SPACING_D {
         IPC_HEADER_D header;
         u32 port0_excess_spacing;                // DWORD 2
         u32 port1_excess_spacing;                // DWORD 3
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D, *PIPC_TXULP_EXCESS_SPACING_D;

      typedef union _IPC_TXULP_EXCESS_SPACING_D_UNION {
         IPC_TXULP_EXCESS_SPACING_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_TXULP_EXCESS_SPACING_D_UNION, *PIPC_TXULP_EXCESS_SPACING_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_TXULP_EXCESS_SPACING_D_UNION, sizeof (IPC_TXULP_EXCESS_SPACING_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IPC triggers a special CQE to the driver as a way of flushing a work queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_RELEASE_WRBS_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 sub_code : 16;                 // DWORD 1
               u32 rsvd0 : 12;                    // DWORD 2
               u32 cq_id : 10;                    // DWORD 2
               u32 wrb_index : 10;                // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_RELEASE_WRBS_D, *PIPC_FC_RELEASE_WRBS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_RELEASE_WRBS_D, sizeof (IPC_FC_RELEASE_WRBS_D) == 16);

   #else
      typedef struct _IPC_FC_RELEASE_WRBS_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 sub_code : 16;                       // DWORD 1
         u32 rsvd0 : 12;                          // DWORD 2
         u32 cq_id : 10;                          // DWORD 2
         u32 wrb_index : 10;                      // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK IPC_FC_RELEASE_WRBS_D, *PIPC_FC_RELEASE_WRBS_D;

      typedef union _IPC_FC_RELEASE_WRBS_D_UNION {
         IPC_FC_RELEASE_WRBS_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_RELEASE_WRBS_D_UNION, *PIPC_FC_RELEASE_WRBS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_RELEASE_WRBS_D_UNION, sizeof (IPC_FC_RELEASE_WRBS_D_UNION) == 16);
   #endif


#else
   // This IPC triggers a special CQE to the driver as a way of flushing a work queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_RELEASE_WRBS_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 sub_code : 16;                 // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 wrb_index : 10;                // DWORD 2
               u32 cq_id : 10;                    // DWORD 2
               u32 rsvd0 : 12;                    // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_RELEASE_WRBS_D, *PIPC_FC_RELEASE_WRBS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_RELEASE_WRBS_D, sizeof (IPC_FC_RELEASE_WRBS_D) == 16);

   #else
      typedef struct _IPC_FC_RELEASE_WRBS_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 sub_code : 16;                       // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 wrb_index : 10;                      // DWORD 2
         u32 cq_id : 10;                          // DWORD 2
         u32 rsvd0 : 12;                          // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
      } SG_PACK IPC_FC_RELEASE_WRBS_D, *PIPC_FC_RELEASE_WRBS_D;

      typedef union _IPC_FC_RELEASE_WRBS_D_UNION {
         IPC_FC_RELEASE_WRBS_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_RELEASE_WRBS_D_UNION, *PIPC_FC_RELEASE_WRBS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_RELEASE_WRBS_D_UNION, sizeof (IPC_FC_RELEASE_WRBS_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by RxULP to request that TxULP transmit an ABTS, REC, or RRQ link services
   // request for the given exchange. Not used to request that TxULP transmit an SRR link
   // services request.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_LS_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 ox_id_upper_bits_for_rrq_pyld : 4; // DWORD 0
               u32 retransmission : 1;            // DWORD 0
               u32 return_credit : 1;             // DWORD 0
               u32 cid : 10;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_LS_D, *PIPC_FC_TRANSMIT_LS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_LS_D, sizeof (IPC_FC_TRANSMIT_LS_D) == 8);

   #else
      typedef struct _IPC_FC_TRANSMIT_LS_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 ox_id_upper_bits_for_rrq_pyld : 4;   // DWORD 0
         u32 retransmission : 1;                  // DWORD 0
         u32 return_credit : 1;                   // DWORD 0
         u32 cid : 10;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
      } SG_PACK IPC_FC_TRANSMIT_LS_D, *PIPC_FC_TRANSMIT_LS_D;

      typedef union _IPC_FC_TRANSMIT_LS_D_UNION {
         IPC_FC_TRANSMIT_LS_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_LS_D_UNION, *PIPC_FC_TRANSMIT_LS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_LS_D_UNION, sizeof (IPC_FC_TRANSMIT_LS_D_UNION) == 8);
   #endif


#else
   // Used by RxULP to request that TxULP transmit an ABTS, REC, or RRQ link services
   // request for the given exchange. Not used to request that TxULP transmit an SRR link
   // services request.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_LS_D {
         union {
            struct { 
               u32 cid : 10;                      // DWORD 0
               u32 return_credit : 1;             // DWORD 0
               u32 retransmission : 1;            // DWORD 0
               u32 ox_id_upper_bits_for_rrq_pyld : 4; // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_LS_D, *PIPC_FC_TRANSMIT_LS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_LS_D, sizeof (IPC_FC_TRANSMIT_LS_D) == 8);

   #else
      typedef struct _IPC_FC_TRANSMIT_LS_D {
         u32 cid : 10;                            // DWORD 0
         u32 return_credit : 1;                   // DWORD 0
         u32 retransmission : 1;                  // DWORD 0
         u32 ox_id_upper_bits_for_rrq_pyld : 4;   // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_FC_TRANSMIT_LS_D, *PIPC_FC_TRANSMIT_LS_D;

      typedef union _IPC_FC_TRANSMIT_LS_D_UNION {
         IPC_FC_TRANSMIT_LS_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_LS_D_UNION, *PIPC_FC_TRANSMIT_LS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_LS_D_UNION, sizeof (IPC_FC_TRANSMIT_LS_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by RxULP to request that TxULP transmit an ELS reply for the given
   // exchange.NOTE: we have to add an explicit ELS payload length field because we cannot
   // use an IPC with an odd number of words
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_ELS_REPLY_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               u32 els_payload[6];                // DWORDS 2 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D, *PIPC_FC_TRANSMIT_ELS_REPLY_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_ELS_REPLY_D, sizeof (IPC_FC_TRANSMIT_ELS_REPLY_D) == 32);

   #else
      typedef struct _IPC_FC_TRANSMIT_ELS_REPLY_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         u32 els_payload[6];                      // DWORDS 2 to 7
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D, *PIPC_FC_TRANSMIT_ELS_REPLY_D;

      typedef union _IPC_FC_TRANSMIT_ELS_REPLY_D_UNION {
         IPC_FC_TRANSMIT_ELS_REPLY_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D_UNION, *PIPC_FC_TRANSMIT_ELS_REPLY_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_ELS_REPLY_D_UNION, sizeof (IPC_FC_TRANSMIT_ELS_REPLY_D_UNION) == 32);
   #endif


#else
   // Used by RxULP to request that TxULP transmit an ELS reply for the given
   // exchange.NOTE: we have to add an explicit ELS payload length field because we cannot
   // use an IPC with an odd number of words
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_ELS_REPLY_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 els_payload[6];                // DWORDS 2 to 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D, *PIPC_FC_TRANSMIT_ELS_REPLY_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_ELS_REPLY_D, sizeof (IPC_FC_TRANSMIT_ELS_REPLY_D) == 32);

   #else
      typedef struct _IPC_FC_TRANSMIT_ELS_REPLY_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 els_payload[6];                      // DWORDS 2 to 7
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D, *PIPC_FC_TRANSMIT_ELS_REPLY_D;

      typedef union _IPC_FC_TRANSMIT_ELS_REPLY_D_UNION {
         IPC_FC_TRANSMIT_ELS_REPLY_D bits;
         u32 dw[8]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_ELS_REPLY_D_UNION, *PIPC_FC_TRANSMIT_ELS_REPLY_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_ELS_REPLY_D_UNION, sizeof (IPC_FC_TRANSMIT_ELS_REPLY_D_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by RxULP to request that TxULP transmit an SRR link services frame for the
   // given exchange.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_SRR_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               u32 relative_offset;               // DWORD 2
               u32 r_ctl_for_iu : 8;              // DWORD 3
               u32 rsvd0 : 24;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_SRR_D, *PIPC_FC_TRANSMIT_SRR_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_SRR_D, sizeof (IPC_FC_TRANSMIT_SRR_D) == 16);

   #else
      typedef struct _IPC_FC_TRANSMIT_SRR_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         u32 relative_offset;                     // DWORD 2
         u32 r_ctl_for_iu : 8;                    // DWORD 3
         u32 rsvd0 : 24;                          // DWORD 3
      } SG_PACK IPC_FC_TRANSMIT_SRR_D, *PIPC_FC_TRANSMIT_SRR_D;

      typedef union _IPC_FC_TRANSMIT_SRR_D_UNION {
         IPC_FC_TRANSMIT_SRR_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_SRR_D_UNION, *PIPC_FC_TRANSMIT_SRR_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_SRR_D_UNION, sizeof (IPC_FC_TRANSMIT_SRR_D_UNION) == 16);
   #endif


#else
   // Used by RxULP to request that TxULP transmit an SRR link services frame for the
   // given exchange.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_SRR_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 relative_offset;               // DWORD 2
               u32 rsvd0 : 24;                    // DWORD 3
               u32 r_ctl_for_iu : 8;              // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_SRR_D, *PIPC_FC_TRANSMIT_SRR_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_SRR_D, sizeof (IPC_FC_TRANSMIT_SRR_D) == 16);

   #else
      typedef struct _IPC_FC_TRANSMIT_SRR_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 relative_offset;                     // DWORD 2
         u32 rsvd0 : 24;                          // DWORD 3
         u32 r_ctl_for_iu : 8;                    // DWORD 3
      } SG_PACK IPC_FC_TRANSMIT_SRR_D, *PIPC_FC_TRANSMIT_SRR_D;

      typedef union _IPC_FC_TRANSMIT_SRR_D_UNION {
         IPC_FC_TRANSMIT_SRR_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_SRR_D_UNION, *PIPC_FC_TRANSMIT_SRR_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_SRR_D_UNION, sizeof (IPC_FC_TRANSMIT_SRR_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by RxULP to request that TxULP transmit a BA_RJT link services reply for the
   // given exchange.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_BA_RJT_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 ox_id : 16;                    // DWORD 1
               FC_BA_RJT_PAYLOAD ba_rjt_payload;
               u32 rsvd0[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D, *PIPC_FC_TRANSMIT_BA_RJT_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_BA_RJT_D, sizeof (IPC_FC_TRANSMIT_BA_RJT_D) == 16);

   #else
      typedef struct _IPC_FC_TRANSMIT_BA_RJT_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 ox_id : 16;                          // DWORD 1
         FC_BA_RJT_PAYLOAD ba_rjt_payload;
         u32 rsvd0[1];                            // DWORDS 3 to 3
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D, *PIPC_FC_TRANSMIT_BA_RJT_D;

      typedef union _IPC_FC_TRANSMIT_BA_RJT_D_UNION {
         IPC_FC_TRANSMIT_BA_RJT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D_UNION, *PIPC_FC_TRANSMIT_BA_RJT_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_BA_RJT_D_UNION, sizeof (IPC_FC_TRANSMIT_BA_RJT_D_UNION) == 16);
   #endif


#else
   // Used by RxULP to request that TxULP transmit a BA_RJT link services reply for the
   // given exchange.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_TRANSMIT_BA_RJT_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 ox_id : 16;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
               FC_BA_RJT_PAYLOAD ba_rjt_payload;
               u32 rsvd0[1];                      // DWORDS 3 to 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D, *PIPC_FC_TRANSMIT_BA_RJT_D;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_BA_RJT_D, sizeof (IPC_FC_TRANSMIT_BA_RJT_D) == 16);

   #else
      typedef struct _IPC_FC_TRANSMIT_BA_RJT_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 ox_id : 16;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
         FC_BA_RJT_PAYLOAD ba_rjt_payload;
         u32 rsvd0[1];                            // DWORDS 3 to 3
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D, *PIPC_FC_TRANSMIT_BA_RJT_D;

      typedef union _IPC_FC_TRANSMIT_BA_RJT_D_UNION {
         IPC_FC_TRANSMIT_BA_RJT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_TRANSMIT_BA_RJT_D_UNION, *PIPC_FC_TRANSMIT_BA_RJT_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_TRANSMIT_BA_RJT_D_UNION, sizeof (IPC_FC_TRANSMIT_BA_RJT_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by TxULP to pass a host ABORT WQE to RxULP.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_ABORT_INVALIDATE_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 icd_index : 16;                // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 iotag16 : 16;                  // DWORD 1
               u32 rsvd1 : 6;                     // DWORD 2
               u32 cq_id_for_abort_invalidate : 10; // DWORD 2
               u32 Criteria : 8;                  // DWORD 2
               u32 rsvd0 : 6;                     // DWORD 2
               u32 AS : 1;                        // DWORD 2
               u32 IA : 1;                        // DWORD 2
               u32 T_TAG;                         // DWORD 3
               u32 rsvd2 : 8;                     // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 low_XRI : 12;                  // DWORD 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D, *PIPC_FC_ABORT_INVALIDATE_D;

      SG_C_ASSERT(__sizeof__IPC_FC_ABORT_INVALIDATE_D, sizeof (IPC_FC_ABORT_INVALIDATE_D) == 24);

   #else
      typedef struct _IPC_FC_ABORT_INVALIDATE_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 icd_index : 16;                      // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 iotag16 : 16;                        // DWORD 1
         u32 rsvd1 : 6;                           // DWORD 2
         u32 cq_id_for_abort_invalidate : 10;     // DWORD 2
         u32 Criteria : 8;                        // DWORD 2
         u32 rsvd0 : 6;                           // DWORD 2
         u32 AS : 1;                              // DWORD 2
         u32 IA : 1;                              // DWORD 2
         u32 T_TAG;                               // DWORD 3
         u32 rsvd2 : 8;                           // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 low_XRI : 12;                        // DWORD 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D, *PIPC_FC_ABORT_INVALIDATE_D;

      typedef union _IPC_FC_ABORT_INVALIDATE_D_UNION {
         IPC_FC_ABORT_INVALIDATE_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D_UNION, *PIPC_FC_ABORT_INVALIDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_ABORT_INVALIDATE_D_UNION, sizeof (IPC_FC_ABORT_INVALIDATE_D_UNION) == 24);
   #endif


#else
   // Used by TxULP to pass a host ABORT WQE to RxULP.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_ABORT_INVALIDATE_D {
         union {
            struct { 
               u32 icd_index : 16;                // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 iotag16 : 16;                  // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 IA : 1;                        // DWORD 2
               u32 AS : 1;                        // DWORD 2
               u32 rsvd0 : 6;                     // DWORD 2
               u32 Criteria : 8;                  // DWORD 2
               u32 cq_id_for_abort_invalidate : 10; // DWORD 2
               u32 rsvd1 : 6;                     // DWORD 2
               u32 T_TAG;                         // DWORD 3
               u32 low_XRI : 12;                  // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 rsvd2 : 8;                     // DWORD 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D, *PIPC_FC_ABORT_INVALIDATE_D;

      SG_C_ASSERT(__sizeof__IPC_FC_ABORT_INVALIDATE_D, sizeof (IPC_FC_ABORT_INVALIDATE_D) == 24);

   #else
      typedef struct _IPC_FC_ABORT_INVALIDATE_D {
         u32 icd_index : 16;                      // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 iotag16 : 16;                        // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 IA : 1;                              // DWORD 2
         u32 AS : 1;                              // DWORD 2
         u32 rsvd0 : 6;                           // DWORD 2
         u32 Criteria : 8;                        // DWORD 2
         u32 cq_id_for_abort_invalidate : 10;     // DWORD 2
         u32 rsvd1 : 6;                           // DWORD 2
         u32 T_TAG;                               // DWORD 3
         u32 low_XRI : 12;                        // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 rsvd2 : 8;                           // DWORD 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D, *PIPC_FC_ABORT_INVALIDATE_D;

      typedef union _IPC_FC_ABORT_INVALIDATE_D_UNION {
         IPC_FC_ABORT_INVALIDATE_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_ABORT_INVALIDATE_D_UNION, *PIPC_FC_ABORT_INVALIDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_ABORT_INVALIDATE_D_UNION, sizeof (IPC_FC_ABORT_INVALIDATE_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by TxULP to ask RxULP to send an WQ complete CQE to host.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_COMPLETE_WQ_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 XRI : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 XB : 1;                        // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 cq_id : 12;                    // DWORD 1
               u32 REQUEST_TAG : 16;              // DWORD 2
               u32 Status : 8;                    // DWORD 2
               u32 rsvd1 : 8;                     // DWORD 2
               u32 Parameter;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_COMPLETE_WQ_D, *PIPC_FC_COMPLETE_WQ_D;

      SG_C_ASSERT(__sizeof__IPC_FC_COMPLETE_WQ_D, sizeof (IPC_FC_COMPLETE_WQ_D) == 16);

   #else
      typedef struct _IPC_FC_COMPLETE_WQ_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 XRI : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 XB : 1;                              // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 cq_id : 12;                          // DWORD 1
         u32 REQUEST_TAG : 16;                    // DWORD 2
         u32 Status : 8;                          // DWORD 2
         u32 rsvd1 : 8;                           // DWORD 2
         u32 Parameter;                           // DWORD 3
      } SG_PACK IPC_FC_COMPLETE_WQ_D, *PIPC_FC_COMPLETE_WQ_D;

      typedef union _IPC_FC_COMPLETE_WQ_D_UNION {
         IPC_FC_COMPLETE_WQ_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_COMPLETE_WQ_D_UNION, *PIPC_FC_COMPLETE_WQ_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_COMPLETE_WQ_D_UNION, sizeof (IPC_FC_COMPLETE_WQ_D_UNION) == 16);
   #endif


#else
   // Used by TxULP to ask RxULP to send an WQ complete CQE to host.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_COMPLETE_WQ_D {
         union {
            struct { 
               u32 XRI : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 cq_id : 12;                    // DWORD 1
               u32 rsvd0 : 3;                     // DWORD 1
               u32 XB : 1;                        // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 rsvd1 : 8;                     // DWORD 2
               u32 Status : 8;                    // DWORD 2
               u32 REQUEST_TAG : 16;              // DWORD 2
               u32 Parameter;                     // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_COMPLETE_WQ_D, *PIPC_FC_COMPLETE_WQ_D;

      SG_C_ASSERT(__sizeof__IPC_FC_COMPLETE_WQ_D, sizeof (IPC_FC_COMPLETE_WQ_D) == 16);

   #else
      typedef struct _IPC_FC_COMPLETE_WQ_D {
         u32 XRI : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 cq_id : 12;                          // DWORD 1
         u32 rsvd0 : 3;                           // DWORD 1
         u32 XB : 1;                              // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 rsvd1 : 8;                           // DWORD 2
         u32 Status : 8;                          // DWORD 2
         u32 REQUEST_TAG : 16;                    // DWORD 2
         u32 Parameter;                           // DWORD 3
      } SG_PACK IPC_FC_COMPLETE_WQ_D, *PIPC_FC_COMPLETE_WQ_D;

      typedef union _IPC_FC_COMPLETE_WQ_D_UNION {
         IPC_FC_COMPLETE_WQ_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_COMPLETE_WQ_D_UNION, *PIPC_FC_COMPLETE_WQ_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_COMPLETE_WQ_D_UNION, sizeof (IPC_FC_COMPLETE_WQ_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by MPU/ARM to update TxULP of the RPI based header template host driver
   // registered.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_HEADER_TEMPLATE_UPDATE_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 rsvd0 : 10;                    // DWORD 1
               u32 index : 6;                     // DWORD 1
               u32 addr_hi;                       // DWORD 2
               u32 addr_lo;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_FC_HEADER_TEMPLATE_UPDATE_D, sizeof (IPC_FC_HEADER_TEMPLATE_UPDATE_D) == 16);

   #else
      typedef struct _IPC_FC_HEADER_TEMPLATE_UPDATE_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 rsvd0 : 10;                          // DWORD 1
         u32 index : 6;                           // DWORD 1
         u32 addr_hi;                             // DWORD 2
         u32 addr_lo;                             // DWORD 3
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D;

      typedef union _IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION {
         IPC_FC_HEADER_TEMPLATE_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION, sizeof (IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION) == 16);
   #endif


#else
   // Used by MPU/ARM to update TxULP of the RPI based header template host driver
   // registered.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_HEADER_TEMPLATE_UPDATE_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 index : 6;                     // DWORD 1
               u32 rsvd0 : 10;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 addr_hi;                       // DWORD 2
               u32 addr_lo;                       // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D;

      SG_C_ASSERT(__sizeof__IPC_FC_HEADER_TEMPLATE_UPDATE_D, sizeof (IPC_FC_HEADER_TEMPLATE_UPDATE_D) == 16);

   #else
      typedef struct _IPC_FC_HEADER_TEMPLATE_UPDATE_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 index : 6;                           // DWORD 1
         u32 rsvd0 : 10;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 addr_hi;                             // DWORD 2
         u32 addr_lo;                             // DWORD 3
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D;

      typedef union _IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION {
         IPC_FC_HEADER_TEMPLATE_UPDATE_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION, *PIPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION, sizeof (IPC_FC_HEADER_TEMPLATE_UPDATE_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used between MPU/ARM and TxULP to change 'per_priority_class' setting in TX_D.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_SET_PER_PRIORITY_CLASS_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 rsvd0 : 7;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 flow_id : 5;                   // DWORD 1
               u32 per_priority_class : 3;        // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D, *PIPC_FC_SET_PER_PRIORITY_CLASS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_SET_PER_PRIORITY_CLASS_D, sizeof (IPC_FC_SET_PER_PRIORITY_CLASS_D) == 8);

   #else
      typedef struct _IPC_FC_SET_PER_PRIORITY_CLASS_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 rsvd0 : 7;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 flow_id : 5;                         // DWORD 1
         u32 per_priority_class : 3;              // DWORD 1
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D, *PIPC_FC_SET_PER_PRIORITY_CLASS_D;

      typedef union _IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION {
         IPC_FC_SET_PER_PRIORITY_CLASS_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION, *PIPC_FC_SET_PER_PRIORITY_CLASS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION, sizeof (IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION) == 8);
   #endif


#else
   // Used between MPU/ARM and TxULP to change 'per_priority_class' setting in TX_D.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_SET_PER_PRIORITY_CLASS_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 per_priority_class : 3;        // DWORD 1
               u32 flow_id : 5;                   // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 rsvd0 : 7;                     // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D, *PIPC_FC_SET_PER_PRIORITY_CLASS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_SET_PER_PRIORITY_CLASS_D, sizeof (IPC_FC_SET_PER_PRIORITY_CLASS_D) == 8);

   #else
      typedef struct _IPC_FC_SET_PER_PRIORITY_CLASS_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 per_priority_class : 3;              // DWORD 1
         u32 flow_id : 5;                         // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 rsvd0 : 7;                           // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D, *PIPC_FC_SET_PER_PRIORITY_CLASS_D;

      typedef union _IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION {
         IPC_FC_SET_PER_PRIORITY_CLASS_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION, *PIPC_FC_SET_PER_PRIORITY_CLASS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION, sizeof (IPC_FC_SET_PER_PRIORITY_CLASS_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by MPU/ARM to report a change in link status to RxULP or TxULP. The XRI range
   // is used by RxULP to pause all I/Os when a link down event has occurred. This range
   // is ignored by RxULP when a link up event has occurred.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_LINK_STATUS_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 port : 16;                     // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 link_status : 16;              // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
               u32 rsvd2 : 8;                     // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 low_XRI : 12;                  // DWORD 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_LINK_STATUS_D, *PIPC_FC_LINK_STATUS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_LINK_STATUS_D, sizeof (IPC_FC_LINK_STATUS_D) == 24);

   #else
      typedef struct _IPC_FC_LINK_STATUS_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 port : 16;                           // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 link_status : 16;                    // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
         u32 rsvd2 : 8;                           // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 low_XRI : 12;                        // DWORD 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_LINK_STATUS_D, *PIPC_FC_LINK_STATUS_D;

      typedef union _IPC_FC_LINK_STATUS_D_UNION {
         IPC_FC_LINK_STATUS_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_LINK_STATUS_D_UNION, *PIPC_FC_LINK_STATUS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_LINK_STATUS_D_UNION, sizeof (IPC_FC_LINK_STATUS_D_UNION) == 24);
   #endif


#else
   // Used by MPU/ARM to report a change in link status to RxULP or TxULP. The XRI range
   // is used by RxULP to pause all I/Os when a link down event has occurred. This range
   // is ignored by RxULP when a link up event has occurred.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_LINK_STATUS_D {
         union {
            struct { 
               u32 port : 16;                     // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 link_status : 16;              // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 rsvd0[1];                      // DWORDS 2 to 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
               u32 low_XRI : 12;                  // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 rsvd2 : 8;                     // DWORD 4
               u32 rsvd3[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_LINK_STATUS_D, *PIPC_FC_LINK_STATUS_D;

      SG_C_ASSERT(__sizeof__IPC_FC_LINK_STATUS_D, sizeof (IPC_FC_LINK_STATUS_D) == 24);

   #else
      typedef struct _IPC_FC_LINK_STATUS_D {
         u32 port : 16;                           // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 link_status : 16;                    // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 rsvd0[1];                            // DWORDS 2 to 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
         u32 low_XRI : 12;                        // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 rsvd2 : 8;                           // DWORD 4
         u32 rsvd3[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_LINK_STATUS_D, *PIPC_FC_LINK_STATUS_D;

      typedef union _IPC_FC_LINK_STATUS_D_UNION {
         IPC_FC_LINK_STATUS_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_LINK_STATUS_D_UNION, *PIPC_FC_LINK_STATUS_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_LINK_STATUS_D_UNION, sizeof (IPC_FC_LINK_STATUS_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used by MPU/ARM to request that RxULP resume all I/Os associated with the given RPI
   // context.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_RESUME_RPI_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 rsvd1 : 16;                    // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rpi_tag;                       // DWORD 3
               u32 rsvd3 : 8;                     // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 low_XRI : 12;                  // DWORD 4
               u32 rsvd4[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_RESUME_RPI_D, *PIPC_FC_RESUME_RPI_D;

      SG_C_ASSERT(__sizeof__IPC_FC_RESUME_RPI_D, sizeof (IPC_FC_RESUME_RPI_D) == 24);

   #else
      typedef struct _IPC_FC_RESUME_RPI_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 rsvd1 : 16;                          // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rpi_tag;                             // DWORD 3
         u32 rsvd3 : 8;                           // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 low_XRI : 12;                        // DWORD 4
         u32 rsvd4[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_RESUME_RPI_D, *PIPC_FC_RESUME_RPI_D;

      typedef union _IPC_FC_RESUME_RPI_D_UNION {
         IPC_FC_RESUME_RPI_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_RESUME_RPI_D_UNION, *PIPC_FC_RESUME_RPI_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_RESUME_RPI_D_UNION, sizeof (IPC_FC_RESUME_RPI_D_UNION) == 24);
   #endif


#else
   // Used by MPU/ARM to request that RxULP resume all I/Os associated with the given RPI
   // context.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_RESUME_RPI_D {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 1
               u32 code : 16;                     // DWORD 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rpi_tag;                       // DWORD 3
               u32 low_XRI : 12;                  // DWORD 4
               u32 high_XRI : 12;                 // DWORD 4
               u32 rsvd3 : 8;                     // DWORD 4
               u32 rsvd4[1];                      // DWORDS 5 to 5
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_RESUME_RPI_D, *PIPC_FC_RESUME_RPI_D;

      SG_C_ASSERT(__sizeof__IPC_FC_RESUME_RPI_D, sizeof (IPC_FC_RESUME_RPI_D) == 24);

   #else
      typedef struct _IPC_FC_RESUME_RPI_D {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 1
         u32 code : 16;                           // DWORD 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rpi_tag;                             // DWORD 3
         u32 low_XRI : 12;                        // DWORD 4
         u32 high_XRI : 12;                       // DWORD 4
         u32 rsvd3 : 8;                           // DWORD 4
         u32 rsvd4[1];                            // DWORDS 5 to 5
      } SG_PACK IPC_FC_RESUME_RPI_D, *PIPC_FC_RESUME_RPI_D;

      typedef union _IPC_FC_RESUME_RPI_D_UNION {
         IPC_FC_RESUME_RPI_D bits;
         u32 dw[6]; // dword union
      } SG_PACK IPC_FC_RESUME_RPI_D_UNION, *PIPC_FC_RESUME_RPI_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_RESUME_RPI_D_UNION, sizeof (IPC_FC_RESUME_RPI_D_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // sent by MPU/ARM and TxULP to change num_segs & data_len setting in TX_D.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_CONFIG_PFC_TXD_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 cid : 16;                      // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 txd_num_segs : 3;              // DWORD 1
               u32 txd_data_len : 12;             // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D, *PIPC_FC_CONFIG_PFC_TXD_D;

      SG_C_ASSERT(__sizeof__IPC_FC_CONFIG_PFC_TXD_D, sizeof (IPC_FC_CONFIG_PFC_TXD_D) == 8);

   #else
      typedef struct _IPC_FC_CONFIG_PFC_TXD_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 cid : 16;                            // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 txd_num_segs : 3;                    // DWORD 1
         u32 txd_data_len : 12;                   // DWORD 1
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D, *PIPC_FC_CONFIG_PFC_TXD_D;

      typedef union _IPC_FC_CONFIG_PFC_TXD_D_UNION {
         IPC_FC_CONFIG_PFC_TXD_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D_UNION, *PIPC_FC_CONFIG_PFC_TXD_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_CONFIG_PFC_TXD_D_UNION, sizeof (IPC_FC_CONFIG_PFC_TXD_D_UNION) == 8);
   #endif


#else
   // sent by MPU/ARM and TxULP to change num_segs & data_len setting in TX_D.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_CONFIG_PFC_TXD_D {
         union {
            struct { 
               u32 cid : 16;                      // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 txd_data_len : 12;             // DWORD 1
               u32 txd_num_segs : 3;              // DWORD 1
               u32 port : 1;                      // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D, *PIPC_FC_CONFIG_PFC_TXD_D;

      SG_C_ASSERT(__sizeof__IPC_FC_CONFIG_PFC_TXD_D, sizeof (IPC_FC_CONFIG_PFC_TXD_D) == 8);

   #else
      typedef struct _IPC_FC_CONFIG_PFC_TXD_D {
         u32 cid : 16;                            // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 txd_data_len : 12;                   // DWORD 1
         u32 txd_num_segs : 3;                    // DWORD 1
         u32 port : 1;                            // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D, *PIPC_FC_CONFIG_PFC_TXD_D;

      typedef union _IPC_FC_CONFIG_PFC_TXD_D_UNION {
         IPC_FC_CONFIG_PFC_TXD_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_CONFIG_PFC_TXD_D_UNION, *PIPC_FC_CONFIG_PFC_TXD_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_CONFIG_PFC_TXD_D_UNION, sizeof (IPC_FC_CONFIG_PFC_TXD_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // sent by MPU/ARM to inform RxULP about default RQ and CQ rings IDs
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_ARM_DEF_RING_D {
         union {
            struct { 
               u32 dst : 4;                       // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 def_rq : 16;                   // DWORD 0
               u32 code : 16;                     // DWORD 1
               u32 def_cq : 16;                   // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_ARM_DEF_RING_D, *PIPC_FC_ARM_DEF_RING_D;

      SG_C_ASSERT(__sizeof__IPC_FC_ARM_DEF_RING_D, sizeof (IPC_FC_ARM_DEF_RING_D) == 8);

   #else
      typedef struct _IPC_FC_ARM_DEF_RING_D {
         u32 dst : 4;                             // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 def_rq : 16;                         // DWORD 0
         u32 code : 16;                           // DWORD 1
         u32 def_cq : 16;                         // DWORD 1
      } SG_PACK IPC_FC_ARM_DEF_RING_D, *PIPC_FC_ARM_DEF_RING_D;

      typedef union _IPC_FC_ARM_DEF_RING_D_UNION {
         IPC_FC_ARM_DEF_RING_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_ARM_DEF_RING_D_UNION, *PIPC_FC_ARM_DEF_RING_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_ARM_DEF_RING_D_UNION, sizeof (IPC_FC_ARM_DEF_RING_D_UNION) == 8);
   #endif


#else
   // sent by MPU/ARM to inform RxULP about default RQ and CQ rings IDs
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_FC_ARM_DEF_RING_D {
         union {
            struct { 
               u32 def_rq : 16;                   // DWORD 0
               u32 length : 8;                    // DWORD 0
               u32 src : 4;                       // DWORD 0
               u32 dst : 4;                       // DWORD 0
               u32 def_cq : 16;                   // DWORD 1
               u32 code : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IPC_FC_ARM_DEF_RING_D, *PIPC_FC_ARM_DEF_RING_D;

      SG_C_ASSERT(__sizeof__IPC_FC_ARM_DEF_RING_D, sizeof (IPC_FC_ARM_DEF_RING_D) == 8);

   #else
      typedef struct _IPC_FC_ARM_DEF_RING_D {
         u32 def_rq : 16;                         // DWORD 0
         u32 length : 8;                          // DWORD 0
         u32 src : 4;                             // DWORD 0
         u32 dst : 4;                             // DWORD 0
         u32 def_cq : 16;                         // DWORD 1
         u32 code : 16;                           // DWORD 1
      } SG_PACK IPC_FC_ARM_DEF_RING_D, *PIPC_FC_ARM_DEF_RING_D;

      typedef union _IPC_FC_ARM_DEF_RING_D_UNION {
         IPC_FC_ARM_DEF_RING_D bits;
         u32 dw[2]; // dword union
      } SG_PACK IPC_FC_ARM_DEF_RING_D_UNION, *PIPC_FC_ARM_DEF_RING_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_FC_ARM_DEF_RING_D_UNION, sizeof (IPC_FC_ARM_DEF_RING_D_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IPC is sent by ARM to any EP to set dynamic features/options supported by that
   // EP. Used by the IPC_SET_EP_OPTIONS code. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_BITSET_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 mask;                          // DWORD 2
               u32 settings;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_BITSET_D, *PIPC_BITSET_D;

      SG_C_ASSERT(__sizeof__IPC_BITSET_D, sizeof (IPC_BITSET_D) == 16);

   #else
      typedef struct _IPC_BITSET_D {
         IPC_HEADER_D header;
         u32 mask;                                // DWORD 2
         u32 settings;                            // DWORD 3
      } SG_PACK IPC_BITSET_D, *PIPC_BITSET_D;

      typedef union _IPC_BITSET_D_UNION {
         IPC_BITSET_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_BITSET_D_UNION, *PIPC_BITSET_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_BITSET_D_UNION, sizeof (IPC_BITSET_D_UNION) == 16);
   #endif


#else
   // This IPC is sent by ARM to any EP to set dynamic features/options supported by that
   // EP. Used by the IPC_SET_EP_OPTIONS code. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_BITSET_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 mask;                          // DWORD 2
               u32 settings;                      // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK IPC_BITSET_D, *PIPC_BITSET_D;

      SG_C_ASSERT(__sizeof__IPC_BITSET_D, sizeof (IPC_BITSET_D) == 16);

   #else
      typedef struct _IPC_BITSET_D {
         IPC_HEADER_D header;
         u32 mask;                                // DWORD 2
         u32 settings;                            // DWORD 3
      } SG_PACK IPC_BITSET_D, *PIPC_BITSET_D;

      typedef union _IPC_BITSET_D_UNION {
         IPC_BITSET_D bits;
         u32 dw[4]; // dword union
      } SG_PACK IPC_BITSET_D_UNION, *PIPC_BITSET_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_BITSET_D_UNION, sizeof (IPC_BITSET_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IPC is sent by ARM to any EP to get dynamic features/options supported by that
   // EP. Used by the IPC_GET_EP_OPTIONS code. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_BITGET_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 results;                       // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_BITGET_D, *PIPC_BITGET_D;

      SG_C_ASSERT(__sizeof__IPC_BITGET_D, sizeof (IPC_BITGET_D) == 12);

   #else
      typedef struct _IPC_BITGET_D {
         IPC_HEADER_D header;
         u32 results;                             // DWORD 2
      } SG_PACK IPC_BITGET_D, *PIPC_BITGET_D;

      typedef union _IPC_BITGET_D_UNION {
         IPC_BITGET_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_BITGET_D_UNION, *PIPC_BITGET_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_BITGET_D_UNION, sizeof (IPC_BITGET_D_UNION) == 12);
   #endif


#else
   // This IPC is sent by ARM to any EP to get dynamic features/options supported by that
   // EP. Used by the IPC_GET_EP_OPTIONS code. 
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_BITGET_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 results;                       // DWORD 2
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IPC_BITGET_D, *PIPC_BITGET_D;

      SG_C_ASSERT(__sizeof__IPC_BITGET_D, sizeof (IPC_BITGET_D) == 12);

   #else
      typedef struct _IPC_BITGET_D {
         IPC_HEADER_D header;
         u32 results;                             // DWORD 2
      } SG_PACK IPC_BITGET_D, *PIPC_BITGET_D;

      typedef union _IPC_BITGET_D_UNION {
         IPC_BITGET_D bits;
         u32 dw[3]; // dword union
      } SG_PACK IPC_BITGET_D_UNION, *PIPC_BITGET_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_BITGET_D_UNION, sizeof (IPC_BITGET_D_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by TPRE which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_FEATURE_OPTIONS, *PTPRE_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_FEATURE_OPTIONS, sizeof (TPRE_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_FEATURE_OPTIONS, *PTPRE_EP_FEATURE_OPTIONS;

      typedef union _TPRE_EP_FEATURE_OPTIONS_UNION {
         TPRE_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_FEATURE_OPTIONS_UNION, *PTPRE_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_FEATURE_OPTIONS_UNION, sizeof (TPRE_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by TPRE which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_FEATURE_OPTIONS, *PTPRE_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_FEATURE_OPTIONS, sizeof (TPRE_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_FEATURE_OPTIONS, *PTPRE_EP_FEATURE_OPTIONS;

      typedef union _TPRE_EP_FEATURE_OPTIONS_UNION {
         TPRE_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_FEATURE_OPTIONS_UNION, *PTPRE_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_FEATURE_OPTIONS_UNION, sizeof (TPRE_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by TPRE which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_TRACE_OPTIONS, *PTPRE_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_TRACE_OPTIONS, sizeof (TPRE_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_TRACE_OPTIONS, *PTPRE_EP_TRACE_OPTIONS;

      typedef union _TPRE_EP_TRACE_OPTIONS_UNION {
         TPRE_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_TRACE_OPTIONS_UNION, *PTPRE_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_TRACE_OPTIONS_UNION, sizeof (TPRE_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by TPRE which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_TRACE_OPTIONS, *PTPRE_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_TRACE_OPTIONS, sizeof (TPRE_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_TRACE_OPTIONS, *PTPRE_EP_TRACE_OPTIONS;

      typedef union _TPRE_EP_TRACE_OPTIONS_UNION {
         TPRE_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_TRACE_OPTIONS_UNION, *PTPRE_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_TRACE_OPTIONS_UNION, sizeof (TPRE_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by TPRE which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_DEBUG_OPTIONS, *PTPRE_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_DEBUG_OPTIONS, sizeof (TPRE_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_DEBUG_OPTIONS, *PTPRE_EP_DEBUG_OPTIONS;

      typedef union _TPRE_EP_DEBUG_OPTIONS_UNION {
         TPRE_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_DEBUG_OPTIONS_UNION, *PTPRE_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_DEBUG_OPTIONS_UNION, sizeof (TPRE_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by TPRE which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_EP_DEBUG_OPTIONS, *PTPRE_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TPRE_EP_DEBUG_OPTIONS, sizeof (TPRE_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TPRE_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPRE_EP_DEBUG_OPTIONS, *PTPRE_EP_DEBUG_OPTIONS;

      typedef union _TPRE_EP_DEBUG_OPTIONS_UNION {
         TPRE_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPRE_EP_DEBUG_OPTIONS_UNION, *PTPRE_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPRE_EP_DEBUG_OPTIONS_UNION, sizeof (TPRE_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by TPOST which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_FEATURE_OPTIONS, *PTPOST_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_FEATURE_OPTIONS, sizeof (TPOST_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_FEATURE_OPTIONS, *PTPOST_EP_FEATURE_OPTIONS;

      typedef union _TPOST_EP_FEATURE_OPTIONS_UNION {
         TPOST_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_FEATURE_OPTIONS_UNION, *PTPOST_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_FEATURE_OPTIONS_UNION, sizeof (TPOST_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by TPOST which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_FEATURE_OPTIONS, *PTPOST_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_FEATURE_OPTIONS, sizeof (TPOST_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_FEATURE_OPTIONS, *PTPOST_EP_FEATURE_OPTIONS;

      typedef union _TPOST_EP_FEATURE_OPTIONS_UNION {
         TPOST_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_FEATURE_OPTIONS_UNION, *PTPOST_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_FEATURE_OPTIONS_UNION, sizeof (TPOST_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by TPOST which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_TRACE_OPTIONS, *PTPOST_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_TRACE_OPTIONS, sizeof (TPOST_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_TRACE_OPTIONS, *PTPOST_EP_TRACE_OPTIONS;

      typedef union _TPOST_EP_TRACE_OPTIONS_UNION {
         TPOST_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_TRACE_OPTIONS_UNION, *PTPOST_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_TRACE_OPTIONS_UNION, sizeof (TPOST_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by TPOST which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_TRACE_OPTIONS, *PTPOST_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_TRACE_OPTIONS, sizeof (TPOST_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_TRACE_OPTIONS, *PTPOST_EP_TRACE_OPTIONS;

      typedef union _TPOST_EP_TRACE_OPTIONS_UNION {
         TPOST_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_TRACE_OPTIONS_UNION, *PTPOST_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_TRACE_OPTIONS_UNION, sizeof (TPOST_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by TPOST which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_DEBUG_OPTIONS, *PTPOST_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_DEBUG_OPTIONS, sizeof (TPOST_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_DEBUG_OPTIONS, *PTPOST_EP_DEBUG_OPTIONS;

      typedef union _TPOST_EP_DEBUG_OPTIONS_UNION {
         TPOST_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_DEBUG_OPTIONS_UNION, *PTPOST_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_DEBUG_OPTIONS_UNION, sizeof (TPOST_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by TPOST which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_DEBUG_OPTIONS, *PTPOST_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TPOST_EP_DEBUG_OPTIONS, sizeof (TPOST_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TPOST_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TPOST_EP_DEBUG_OPTIONS, *PTPOST_EP_DEBUG_OPTIONS;

      typedef union _TPOST_EP_DEBUG_OPTIONS_UNION {
         TPOST_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_DEBUG_OPTIONS_UNION, *PTPOST_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_DEBUG_OPTIONS_UNION, sizeof (TPOST_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by TOERX which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_FEATURE_OPTIONS, *PTOERX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_FEATURE_OPTIONS, sizeof (TOERX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_FEATURE_OPTIONS, *PTOERX_EP_FEATURE_OPTIONS;

      typedef union _TOERX_EP_FEATURE_OPTIONS_UNION {
         TOERX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_FEATURE_OPTIONS_UNION, *PTOERX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_FEATURE_OPTIONS_UNION, sizeof (TOERX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by TOERX which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_FEATURE_OPTIONS, *PTOERX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_FEATURE_OPTIONS, sizeof (TOERX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_FEATURE_OPTIONS, *PTOERX_EP_FEATURE_OPTIONS;

      typedef union _TOERX_EP_FEATURE_OPTIONS_UNION {
         TOERX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_FEATURE_OPTIONS_UNION, *PTOERX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_FEATURE_OPTIONS_UNION, sizeof (TOERX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by TOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_TRACE_OPTIONS, *PTOERX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_TRACE_OPTIONS, sizeof (TOERX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_TRACE_OPTIONS, *PTOERX_EP_TRACE_OPTIONS;

      typedef union _TOERX_EP_TRACE_OPTIONS_UNION {
         TOERX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_TRACE_OPTIONS_UNION, *PTOERX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_TRACE_OPTIONS_UNION, sizeof (TOERX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by TOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_TRACE_OPTIONS, *PTOERX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_TRACE_OPTIONS, sizeof (TOERX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_TRACE_OPTIONS, *PTOERX_EP_TRACE_OPTIONS;

      typedef union _TOERX_EP_TRACE_OPTIONS_UNION {
         TOERX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_TRACE_OPTIONS_UNION, *PTOERX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_TRACE_OPTIONS_UNION, sizeof (TOERX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by TOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_DEBUG_OPTIONS, *PTOERX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_DEBUG_OPTIONS, sizeof (TOERX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_DEBUG_OPTIONS, *PTOERX_EP_DEBUG_OPTIONS;

      typedef union _TOERX_EP_DEBUG_OPTIONS_UNION {
         TOERX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_DEBUG_OPTIONS_UNION, *PTOERX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_DEBUG_OPTIONS_UNION, sizeof (TOERX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by TOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOERX_EP_DEBUG_OPTIONS, *PTOERX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TOERX_EP_DEBUG_OPTIONS, sizeof (TOERX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TOERX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOERX_EP_DEBUG_OPTIONS, *PTOERX_EP_DEBUG_OPTIONS;

      typedef union _TOERX_EP_DEBUG_OPTIONS_UNION {
         TOERX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOERX_EP_DEBUG_OPTIONS_UNION, *PTOERX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOERX_EP_DEBUG_OPTIONS_UNION, sizeof (TOERX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by TOETX which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_FEATURE_OPTIONS, *PTOETX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_FEATURE_OPTIONS, sizeof (TOETX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_FEATURE_OPTIONS, *PTOETX_EP_FEATURE_OPTIONS;

      typedef union _TOETX_EP_FEATURE_OPTIONS_UNION {
         TOETX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_FEATURE_OPTIONS_UNION, *PTOETX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_FEATURE_OPTIONS_UNION, sizeof (TOETX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by TOETX which can be set/queried
   // via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code = SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_FEATURE_OPTIONS, *PTOETX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_FEATURE_OPTIONS, sizeof (TOETX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_FEATURE_OPTIONS, *PTOETX_EP_FEATURE_OPTIONS;

      typedef union _TOETX_EP_FEATURE_OPTIONS_UNION {
         TOETX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_FEATURE_OPTIONS_UNION, *PTOETX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_FEATURE_OPTIONS_UNION, sizeof (TOETX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by TOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_TRACE_OPTIONS, *PTOETX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_TRACE_OPTIONS, sizeof (TOETX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_TRACE_OPTIONS, *PTOETX_EP_TRACE_OPTIONS;

      typedef union _TOETX_EP_TRACE_OPTIONS_UNION {
         TOETX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_TRACE_OPTIONS_UNION, *PTOETX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_TRACE_OPTIONS_UNION, sizeof (TOETX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by TOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_TRACE_OPTIONS, *PTOETX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_TRACE_OPTIONS, sizeof (TOETX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_TRACE_OPTIONS, *PTOETX_EP_TRACE_OPTIONS;

      typedef union _TOETX_EP_TRACE_OPTIONS_UNION {
         TOETX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_TRACE_OPTIONS_UNION, *PTOETX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_TRACE_OPTIONS_UNION, sizeof (TOETX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by TOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_DEBUG_OPTIONS, *PTOETX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_DEBUG_OPTIONS, sizeof (TOETX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_DEBUG_OPTIONS, *PTOETX_EP_DEBUG_OPTIONS;

      typedef union _TOETX_EP_DEBUG_OPTIONS_UNION {
         TOETX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_DEBUG_OPTIONS_UNION, *PTOETX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_DEBUG_OPTIONS_UNION, sizeof (TOETX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by TOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TOETX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TOETX_EP_DEBUG_OPTIONS, *PTOETX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__TOETX_EP_DEBUG_OPTIONS, sizeof (TOETX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _TOETX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK TOETX_EP_DEBUG_OPTIONS, *PTOETX_EP_DEBUG_OPTIONS;

      typedef union _TOETX_EP_DEBUG_OPTIONS_UNION {
         TOETX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK TOETX_EP_DEBUG_OPTIONS_UNION, *PTOETX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__TOETX_EP_DEBUG_OPTIONS_UNION, sizeof (TOETX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS, *PISCSIRX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_FEATURE_OPTIONS, sizeof (ISCSIRX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS, *PISCSIRX_EP_FEATURE_OPTIONS;

      typedef union _ISCSIRX_EP_FEATURE_OPTIONS_UNION {
         ISCSIRX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS_UNION, *PISCSIRX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_FEATURE_OPTIONS_UNION, sizeof (ISCSIRX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS, *PISCSIRX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_FEATURE_OPTIONS, sizeof (ISCSIRX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS, *PISCSIRX_EP_FEATURE_OPTIONS;

      typedef union _ISCSIRX_EP_FEATURE_OPTIONS_UNION {
         ISCSIRX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_FEATURE_OPTIONS_UNION, *PISCSIRX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_FEATURE_OPTIONS_UNION, sizeof (ISCSIRX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS, *PISCSIRX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_TRACE_OPTIONS, sizeof (ISCSIRX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS, *PISCSIRX_EP_TRACE_OPTIONS;

      typedef union _ISCSIRX_EP_TRACE_OPTIONS_UNION {
         ISCSIRX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS_UNION, *PISCSIRX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_TRACE_OPTIONS_UNION, sizeof (ISCSIRX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS, *PISCSIRX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_TRACE_OPTIONS, sizeof (ISCSIRX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS, *PISCSIRX_EP_TRACE_OPTIONS;

      typedef union _ISCSIRX_EP_TRACE_OPTIONS_UNION {
         ISCSIRX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_TRACE_OPTIONS_UNION, *PISCSIRX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_TRACE_OPTIONS_UNION, sizeof (ISCSIRX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS, *PISCSIRX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_DEBUG_OPTIONS, sizeof (ISCSIRX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS, *PISCSIRX_EP_DEBUG_OPTIONS;

      typedef union _ISCSIRX_EP_DEBUG_OPTIONS_UNION {
         ISCSIRX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS_UNION, *PISCSIRX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_DEBUG_OPTIONS_UNION, sizeof (ISCSIRX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by ISCSIRX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSIRX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS, *PISCSIRX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_DEBUG_OPTIONS, sizeof (ISCSIRX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _ISCSIRX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS, *PISCSIRX_EP_DEBUG_OPTIONS;

      typedef union _ISCSIRX_EP_DEBUG_OPTIONS_UNION {
         ISCSIRX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSIRX_EP_DEBUG_OPTIONS_UNION, *PISCSIRX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSIRX_EP_DEBUG_OPTIONS_UNION, sizeof (ISCSIRX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS, *PISCSITX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_FEATURE_OPTIONS, sizeof (ISCSITX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS, *PISCSITX_EP_FEATURE_OPTIONS;

      typedef union _ISCSITX_EP_FEATURE_OPTIONS_UNION {
         ISCSITX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS_UNION, *PISCSITX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_FEATURE_OPTIONS_UNION, sizeof (ISCSITX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS, *PISCSITX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_FEATURE_OPTIONS, sizeof (ISCSITX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS, *PISCSITX_EP_FEATURE_OPTIONS;

      typedef union _ISCSITX_EP_FEATURE_OPTIONS_UNION {
         ISCSITX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_FEATURE_OPTIONS_UNION, *PISCSITX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_FEATURE_OPTIONS_UNION, sizeof (ISCSITX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS, *PISCSITX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_TRACE_OPTIONS, sizeof (ISCSITX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS, *PISCSITX_EP_TRACE_OPTIONS;

      typedef union _ISCSITX_EP_TRACE_OPTIONS_UNION {
         ISCSITX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS_UNION, *PISCSITX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_TRACE_OPTIONS_UNION, sizeof (ISCSITX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS, *PISCSITX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_TRACE_OPTIONS, sizeof (ISCSITX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS, *PISCSITX_EP_TRACE_OPTIONS;

      typedef union _ISCSITX_EP_TRACE_OPTIONS_UNION {
         ISCSITX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_TRACE_OPTIONS_UNION, *PISCSITX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_TRACE_OPTIONS_UNION, sizeof (ISCSITX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS, *PISCSITX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_DEBUG_OPTIONS, sizeof (ISCSITX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS, *PISCSITX_EP_DEBUG_OPTIONS;

      typedef union _ISCSITX_EP_DEBUG_OPTIONS_UNION {
         ISCSITX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS_UNION, *PISCSITX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_DEBUG_OPTIONS_UNION, sizeof (ISCSITX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by ISCSITX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSITX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS, *PISCSITX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_DEBUG_OPTIONS, sizeof (ISCSITX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _ISCSITX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS, *PISCSITX_EP_DEBUG_OPTIONS;

      typedef union _ISCSITX_EP_DEBUG_OPTIONS_UNION {
         ISCSITX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK ISCSITX_EP_DEBUG_OPTIONS_UNION, *PISCSITX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__ISCSITX_EP_DEBUG_OPTIONS_UNION, sizeof (ISCSITX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 rpi_timewait : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS, *PFCOERX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_FEATURE_OPTIONS, sizeof (FCOERX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_FEATURE_OPTIONS {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 rpi_timewait : 4;                    // DWORD 0
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS, *PFCOERX_EP_FEATURE_OPTIONS;

      typedef union _FCOERX_EP_FEATURE_OPTIONS_UNION {
         FCOERX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS_UNION, *PFCOERX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_FEATURE_OPTIONS_UNION, sizeof (FCOERX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rpi_timewait : 4;              // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS, *PFCOERX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_FEATURE_OPTIONS, sizeof (FCOERX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_FEATURE_OPTIONS {
         u32 rpi_timewait : 4;                    // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS, *PFCOERX_EP_FEATURE_OPTIONS;

      typedef union _FCOERX_EP_FEATURE_OPTIONS_UNION {
         FCOERX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_FEATURE_OPTIONS_UNION, *PFCOERX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_FEATURE_OPTIONS_UNION, sizeof (FCOERX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_TRACE_OPTIONS, *PFCOERX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_TRACE_OPTIONS, sizeof (FCOERX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOERX_EP_TRACE_OPTIONS, *PFCOERX_EP_TRACE_OPTIONS;

      typedef union _FCOERX_EP_TRACE_OPTIONS_UNION {
         FCOERX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_TRACE_OPTIONS_UNION, *PFCOERX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_TRACE_OPTIONS_UNION, sizeof (FCOERX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_TRACE_OPTIONS, *PFCOERX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_TRACE_OPTIONS, sizeof (FCOERX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOERX_EP_TRACE_OPTIONS, *PFCOERX_EP_TRACE_OPTIONS;

      typedef union _FCOERX_EP_TRACE_OPTIONS_UNION {
         FCOERX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_TRACE_OPTIONS_UNION, *PFCOERX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_TRACE_OPTIONS_UNION, sizeof (FCOERX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS, *PFCOERX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_DEBUG_OPTIONS, sizeof (FCOERX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS, *PFCOERX_EP_DEBUG_OPTIONS;

      typedef union _FCOERX_EP_DEBUG_OPTIONS_UNION {
         FCOERX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS_UNION, *PFCOERX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_DEBUG_OPTIONS_UNION, sizeof (FCOERX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by FCOERX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOERX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS, *PFCOERX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOERX_EP_DEBUG_OPTIONS, sizeof (FCOERX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _FCOERX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS, *PFCOERX_EP_DEBUG_OPTIONS;

      typedef union _FCOERX_EP_DEBUG_OPTIONS_UNION {
         FCOERX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOERX_EP_DEBUG_OPTIONS_UNION, *PFCOERX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOERX_EP_DEBUG_OPTIONS_UNION, sizeof (FCOERX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic features supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS, *PFCOETX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_FEATURE_OPTIONS, sizeof (FCOETX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS, *PFCOETX_EP_FEATURE_OPTIONS;

      typedef union _FCOETX_EP_FEATURE_OPTIONS_UNION {
         FCOETX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS_UNION, *PFCOETX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_FEATURE_OPTIONS_UNION, sizeof (FCOETX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic features supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_FEATURES. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_FEATURE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS, *PFCOETX_EP_FEATURE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_FEATURE_OPTIONS, sizeof (FCOETX_EP_FEATURE_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_FEATURE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS, *PFCOETX_EP_FEATURE_OPTIONS;

      typedef union _FCOETX_EP_FEATURE_OPTIONS_UNION {
         FCOETX_EP_FEATURE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_FEATURE_OPTIONS_UNION, *PFCOETX_EP_FEATURE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_FEATURE_OPTIONS_UNION, sizeof (FCOETX_EP_FEATURE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic trace options supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_TRACE_OPTIONS, *PFCOETX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_TRACE_OPTIONS, sizeof (FCOETX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_TRACE_OPTIONS, *PFCOETX_EP_TRACE_OPTIONS;

      typedef union _FCOETX_EP_TRACE_OPTIONS_UNION {
         FCOETX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_TRACE_OPTIONS_UNION, *PFCOETX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_TRACE_OPTIONS_UNION, sizeof (FCOETX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic trace options supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_TRACE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_TRACE_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_TRACE_OPTIONS, *PFCOETX_EP_TRACE_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_TRACE_OPTIONS, sizeof (FCOETX_EP_TRACE_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_TRACE_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_TRACE_OPTIONS, *PFCOETX_EP_TRACE_OPTIONS;

      typedef union _FCOETX_EP_TRACE_OPTIONS_UNION {
         FCOETX_EP_TRACE_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_TRACE_OPTIONS_UNION, *PFCOETX_EP_TRACE_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_TRACE_OPTIONS_UNION, sizeof (FCOETX_EP_TRACE_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure maps the dynamic debug options supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS, *PFCOETX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_DEBUG_OPTIONS, sizeof (FCOETX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS, *PFCOETX_EP_DEBUG_OPTIONS;

      typedef union _FCOETX_EP_DEBUG_OPTIONS_UNION {
         FCOETX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS_UNION, *PFCOETX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_DEBUG_OPTIONS_UNION, sizeof (FCOETX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#else
   // This structure maps the dynamic debug options supported by FCOETX which can be
   // set/queried via IPC_SET_EP_OPTIONS/IPC_GET_EP_OPTIONS with sub_code =
   // SUBCODE_EP_DEBUG. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FCOETX_EP_DEBUG_OPTIONS {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS, *PFCOETX_EP_DEBUG_OPTIONS;

      SG_C_ASSERT(__sizeof__FCOETX_EP_DEBUG_OPTIONS, sizeof (FCOETX_EP_DEBUG_OPTIONS) == 4);

   #else
      typedef struct _FCOETX_EP_DEBUG_OPTIONS {
         u32 rsvd0[1];                            // DWORDS 0 to 0
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS, *PFCOETX_EP_DEBUG_OPTIONS;

      typedef union _FCOETX_EP_DEBUG_OPTIONS_UNION {
         FCOETX_EP_DEBUG_OPTIONS bits;
         u32 dw; // dword union
      } SG_PACK FCOETX_EP_DEBUG_OPTIONS_UNION, *PFCOETX_EP_DEBUG_OPTIONS_UNION;

      SG_C_ASSERT(__sizeof__FCOETX_EP_DEBUG_OPTIONS_UNION, sizeof (FCOETX_EP_DEBUG_OPTIONS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPC from MPU to RxULP to communicate physical address for zero byte DMA
   // transactions.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ZERO_DMA_ADDR_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 addr_lo;                       // DWORD 2
               u32 addr_hi;                       // DWORD 3
               u32 flush : 16;                    // DWORD 4
               u32 fid : 16;                      // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ZERO_DMA_ADDR_D, *PIPC_ZERO_DMA_ADDR_D;

      SG_C_ASSERT(__sizeof__IPC_ZERO_DMA_ADDR_D, sizeof (IPC_ZERO_DMA_ADDR_D) == 20);

   #else
      typedef struct _IPC_ZERO_DMA_ADDR_D {
         IPC_HEADER_D header;
         u32 addr_lo;                             // DWORD 2
         u32 addr_hi;                             // DWORD 3
         u32 flush : 16;                          // DWORD 4
         u32 fid : 16;                            // DWORD 4
      } SG_PACK IPC_ZERO_DMA_ADDR_D, *PIPC_ZERO_DMA_ADDR_D;

      typedef union _IPC_ZERO_DMA_ADDR_D_UNION {
         IPC_ZERO_DMA_ADDR_D bits;
         u32 dw[5]; // dword union
      } SG_PACK IPC_ZERO_DMA_ADDR_D_UNION, *PIPC_ZERO_DMA_ADDR_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ZERO_DMA_ADDR_D_UNION, sizeof (IPC_ZERO_DMA_ADDR_D_UNION) == 20);
   #endif


#else
   // IPC from MPU to RxULP to communicate physical address for zero byte DMA
   // transactions.
   #if defined(SG_BMAP_UNION)
      typedef struct _IPC_ZERO_DMA_ADDR_D {
         union {
            struct { 
               IPC_HEADER_D header;
               u32 addr_lo;                       // DWORD 2
               u32 addr_hi;                       // DWORD 3
               u32 fid : 16;                      // DWORD 4
               u32 flush : 16;                    // DWORD 4
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IPC_ZERO_DMA_ADDR_D, *PIPC_ZERO_DMA_ADDR_D;

      SG_C_ASSERT(__sizeof__IPC_ZERO_DMA_ADDR_D, sizeof (IPC_ZERO_DMA_ADDR_D) == 20);

   #else
      typedef struct _IPC_ZERO_DMA_ADDR_D {
         IPC_HEADER_D header;
         u32 addr_lo;                             // DWORD 2
         u32 addr_hi;                             // DWORD 3
         u32 fid : 16;                            // DWORD 4
         u32 flush : 16;                          // DWORD 4
      } SG_PACK IPC_ZERO_DMA_ADDR_D, *PIPC_ZERO_DMA_ADDR_D;

      typedef union _IPC_ZERO_DMA_ADDR_D_UNION {
         IPC_ZERO_DMA_ADDR_D bits;
         u32 dw[5]; // dword union
      } SG_PACK IPC_ZERO_DMA_ADDR_D_UNION, *PIPC_ZERO_DMA_ADDR_D_UNION;

      SG_C_ASSERT(__sizeof__IPC_ZERO_DMA_ADDR_D_UNION, sizeof (IPC_ZERO_DMA_ADDR_D_UNION) == 20);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ipc_fw_impl_bmap_h__

