/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __jellm_bmap_h__
#define __jellm_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // The JELLM configuration register contains information on the location and number of
   // entries in the Journal Entry Linked List Table (JELLT) in CTX on-chip context
   // memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLT_CFG_CSR {
         union {
            struct { 
               u32 jellt_base_a : 16;             // DWORD 0
               u32 jellt_size : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLT_CFG_CSR, *PJELLT_CFG_CSR;

      SG_C_ASSERT(__sizeof__JELLT_CFG_CSR, sizeof (JELLT_CFG_CSR) == 4);

   #else
      typedef struct _JELLT_CFG_CSR {
         u32 jellt_base_a : 16;                   // DWORD 0
         u32 jellt_size : 16;                     // DWORD 0
      } SG_PACK JELLT_CFG_CSR, *PJELLT_CFG_CSR;

      typedef union _JELLT_CFG_CSR_UNION {
         JELLT_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLT_CFG_CSR_UNION, *PJELLT_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLT_CFG_CSR_UNION, sizeof (JELLT_CFG_CSR_UNION) == 4);
   #endif


#else
   // The JELLM configuration register contains information on the location and number of
   // entries in the Journal Entry Linked List Table (JELLT) in CTX on-chip context
   // memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLT_CFG_CSR {
         union {
            struct { 
               u32 jellt_size : 16;               // DWORD 0
               u32 jellt_base_a : 16;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLT_CFG_CSR, *PJELLT_CFG_CSR;

      SG_C_ASSERT(__sizeof__JELLT_CFG_CSR, sizeof (JELLT_CFG_CSR) == 4);

   #else
      typedef struct _JELLT_CFG_CSR {
         u32 jellt_size : 16;                     // DWORD 0
         u32 jellt_base_a : 16;                   // DWORD 0
      } SG_PACK JELLT_CFG_CSR, *PJELLT_CFG_CSR;

      typedef union _JELLT_CFG_CSR_UNION {
         JELLT_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLT_CFG_CSR_UNION, *PJELLT_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLT_CFG_CSR_UNION, sizeof (JELLT_CFG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The CID configuration register contains information on the base location and stride
   // of JELLM connection context in CTX on-chip context memory. It also contains an
   // enable to have JELLM halt all operations upon detection of an Unrecoverable Error
   #if defined(SG_BMAP_UNION)
      typedef struct _CID_CFG_CSR {
         union {
            struct { 
               u32 UEhalt : 1;                    // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 cid_base_a : 16;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CID_CFG_CSR, *PCID_CFG_CSR;

      SG_C_ASSERT(__sizeof__CID_CFG_CSR, sizeof (CID_CFG_CSR) == 4);

   #else
      typedef struct _CID_CFG_CSR {
         u32 UEhalt : 1;                          // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 cid_base_a : 16;                     // DWORD 0
      } SG_PACK CID_CFG_CSR, *PCID_CFG_CSR;

      typedef union _CID_CFG_CSR_UNION {
         CID_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK CID_CFG_CSR_UNION, *PCID_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__CID_CFG_CSR_UNION, sizeof (CID_CFG_CSR_UNION) == 4);
   #endif


#else
   // The CID configuration register contains information on the base location and stride
   // of JELLM connection context in CTX on-chip context memory. It also contains an
   // enable to have JELLM halt all operations upon detection of an Unrecoverable Error
   #if defined(SG_BMAP_UNION)
      typedef struct _CID_CFG_CSR {
         union {
            struct { 
               u32 cid_base_a : 16;               // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 UEhalt : 1;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CID_CFG_CSR, *PCID_CFG_CSR;

      SG_C_ASSERT(__sizeof__CID_CFG_CSR, sizeof (CID_CFG_CSR) == 4);

   #else
      typedef struct _CID_CFG_CSR {
         u32 cid_base_a : 16;                     // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 UEhalt : 1;                          // DWORD 0
      } SG_PACK CID_CFG_CSR, *PCID_CFG_CSR;

      typedef union _CID_CFG_CSR_UNION {
         CID_CFG_CSR bits;
         u32 dw; // dword union
      } SG_PACK CID_CFG_CSR_UNION, *PCID_CFG_CSR_UNION;

      SG_C_ASSERT(__sizeof__CID_CFG_CSR_UNION, sizeof (CID_CFG_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This debug register provides read-only insight into the state of the free JE list
   // within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_FREE_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 free_je_ptr : 15;              // DWORD 0
               u32 free_cnt : 16;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_FREE_CSR, *PJELLM_FREE_CSR;

      SG_C_ASSERT(__sizeof__JELLM_FREE_CSR, sizeof (JELLM_FREE_CSR) == 4);

   #else
      typedef struct _JELLM_FREE_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 free_je_ptr : 15;                    // DWORD 0
         u32 free_cnt : 16;                       // DWORD 0
      } SG_PACK JELLM_FREE_CSR, *PJELLM_FREE_CSR;

      typedef union _JELLM_FREE_CSR_UNION {
         JELLM_FREE_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_FREE_CSR_UNION, *PJELLM_FREE_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_FREE_CSR_UNION, sizeof (JELLM_FREE_CSR_UNION) == 4);
   #endif


#else
   // This debug register provides read-only insight into the state of the free JE list
   // within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_FREE_CSR {
         union {
            struct { 
               u32 free_cnt : 16;                 // DWORD 0
               u32 free_je_ptr : 15;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_FREE_CSR, *PJELLM_FREE_CSR;

      SG_C_ASSERT(__sizeof__JELLM_FREE_CSR, sizeof (JELLM_FREE_CSR) == 4);

   #else
      typedef struct _JELLM_FREE_CSR {
         u32 free_cnt : 16;                       // DWORD 0
         u32 free_je_ptr : 15;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK JELLM_FREE_CSR, *PJELLM_FREE_CSR;

      typedef union _JELLM_FREE_CSR_UNION {
         JELLM_FREE_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_FREE_CSR_UNION, *PJELLM_FREE_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_FREE_CSR_UNION, sizeof (JELLM_FREE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This debug register provides a count of the number of JELLEs allocated by hardware.
   // This register may be initialized/written by software.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_ALLOC_CNT_CSR {
         union {
            struct { 
               u32 alloc_cnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_ALLOC_CNT_CSR, *PJELLM_ALLOC_CNT_CSR;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_CNT_CSR, sizeof (JELLM_ALLOC_CNT_CSR) == 4);

   #else
      typedef struct _JELLM_ALLOC_CNT_CSR {
         u32 alloc_cnt;                           // DWORD 0
      } SG_PACK JELLM_ALLOC_CNT_CSR, *PJELLM_ALLOC_CNT_CSR;

      typedef union _JELLM_ALLOC_CNT_CSR_UNION {
         JELLM_ALLOC_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_ALLOC_CNT_CSR_UNION, *PJELLM_ALLOC_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_CNT_CSR_UNION, sizeof (JELLM_ALLOC_CNT_CSR_UNION) == 4);
   #endif


#else
   // This debug register provides a count of the number of JELLEs allocated by hardware.
   // This register may be initialized/written by software.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_ALLOC_CNT_CSR {
         union {
            struct { 
               u32 alloc_cnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_ALLOC_CNT_CSR, *PJELLM_ALLOC_CNT_CSR;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_CNT_CSR, sizeof (JELLM_ALLOC_CNT_CSR) == 4);

   #else
      typedef struct _JELLM_ALLOC_CNT_CSR {
         u32 alloc_cnt;                           // DWORD 0
      } SG_PACK JELLM_ALLOC_CNT_CSR, *PJELLM_ALLOC_CNT_CSR;

      typedef union _JELLM_ALLOC_CNT_CSR_UNION {
         JELLM_ALLOC_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_ALLOC_CNT_CSR_UNION, *PJELLM_ALLOC_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_CNT_CSR_UNION, sizeof (JELLM_ALLOC_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This debug register provides a count of the number of JELLEs de-allocated by
   // hardware.This register may be initialized/written by software.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_DEALLOC_CNT_CSR {
         union {
            struct { 
               u32 dealloc_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_DEALLOC_CNT_CSR, *PJELLM_DEALLOC_CNT_CSR;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_CNT_CSR, sizeof (JELLM_DEALLOC_CNT_CSR) == 4);

   #else
      typedef struct _JELLM_DEALLOC_CNT_CSR {
         u32 dealloc_cnt;                         // DWORD 0
      } SG_PACK JELLM_DEALLOC_CNT_CSR, *PJELLM_DEALLOC_CNT_CSR;

      typedef union _JELLM_DEALLOC_CNT_CSR_UNION {
         JELLM_DEALLOC_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_DEALLOC_CNT_CSR_UNION, *PJELLM_DEALLOC_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_CNT_CSR_UNION, sizeof (JELLM_DEALLOC_CNT_CSR_UNION) == 4);
   #endif


#else
   // This debug register provides a count of the number of JELLEs de-allocated by
   // hardware.This register may be initialized/written by software.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_DEALLOC_CNT_CSR {
         union {
            struct { 
               u32 dealloc_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_DEALLOC_CNT_CSR, *PJELLM_DEALLOC_CNT_CSR;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_CNT_CSR, sizeof (JELLM_DEALLOC_CNT_CSR) == 4);

   #else
      typedef struct _JELLM_DEALLOC_CNT_CSR {
         u32 dealloc_cnt;                         // DWORD 0
      } SG_PACK JELLM_DEALLOC_CNT_CSR, *PJELLM_DEALLOC_CNT_CSR;

      typedef union _JELLM_DEALLOC_CNT_CSR_UNION {
         JELLM_DEALLOC_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_DEALLOC_CNT_CSR_UNION, *PJELLM_DEALLOC_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_CNT_CSR_UNION, sizeof (JELLM_DEALLOC_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This read-only debug register provides observability of state within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_SM_CSR {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 alloc_sm : 5;                  // DWORD 0
               u32 dealloc_sm : 4;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_SM_CSR, *PJELLM_SM_CSR;

      SG_C_ASSERT(__sizeof__JELLM_SM_CSR, sizeof (JELLM_SM_CSR) == 4);

   #else
      typedef struct _JELLM_SM_CSR {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 alloc_sm : 5;                        // DWORD 0
         u32 dealloc_sm : 4;                      // DWORD 0
      } SG_PACK JELLM_SM_CSR, *PJELLM_SM_CSR;

      typedef union _JELLM_SM_CSR_UNION {
         JELLM_SM_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_SM_CSR_UNION, *PJELLM_SM_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_SM_CSR_UNION, sizeof (JELLM_SM_CSR_UNION) == 4);
   #endif


#else
   // This read-only debug register provides observability of state within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_SM_CSR {
         union {
            struct { 
               u32 dealloc_sm : 4;                // DWORD 0
               u32 alloc_sm : 5;                  // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_SM_CSR, *PJELLM_SM_CSR;

      SG_C_ASSERT(__sizeof__JELLM_SM_CSR, sizeof (JELLM_SM_CSR) == 4);

   #else
      typedef struct _JELLM_SM_CSR {
         u32 dealloc_sm : 4;                      // DWORD 0
         u32 alloc_sm : 5;                        // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK JELLM_SM_CSR, *PJELLM_SM_CSR;

      typedef union _JELLM_SM_CSR_UNION {
         JELLM_SM_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_SM_CSR_UNION, *PJELLM_SM_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_SM_CSR_UNION, sizeof (JELLM_SM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This read-only debug register provides the last request written by the Allocating EP
   // to its JE_ALLOC_REG.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_AREQ_CSR {
         union {
            struct { 
               u32 alloc_data;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_AREQ_CSR, *PJELLM_LAST_AREQ_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_AREQ_CSR, sizeof (JELLM_LAST_AREQ_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_AREQ_CSR {
         u32 alloc_data;                          // DWORD 0
      } SG_PACK JELLM_LAST_AREQ_CSR, *PJELLM_LAST_AREQ_CSR;

      typedef union _JELLM_LAST_AREQ_CSR_UNION {
         JELLM_LAST_AREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_AREQ_CSR_UNION, *PJELLM_LAST_AREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_AREQ_CSR_UNION, sizeof (JELLM_LAST_AREQ_CSR_UNION) == 4);
   #endif


#else
   // This read-only debug register provides the last request written by the Allocating EP
   // to its JE_ALLOC_REG.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_AREQ_CSR {
         union {
            struct { 
               u32 alloc_data;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_AREQ_CSR, *PJELLM_LAST_AREQ_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_AREQ_CSR, sizeof (JELLM_LAST_AREQ_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_AREQ_CSR {
         u32 alloc_data;                          // DWORD 0
      } SG_PACK JELLM_LAST_AREQ_CSR, *PJELLM_LAST_AREQ_CSR;

      typedef union _JELLM_LAST_AREQ_CSR_UNION {
         JELLM_LAST_AREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_AREQ_CSR_UNION, *PJELLM_LAST_AREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_AREQ_CSR_UNION, sizeof (JELLM_LAST_AREQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This read-only debug register provides the last response returned to the Allocating
   // EP.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_ARESP_CSR {
         union {
            struct { 
               u32 alloc_data;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_ARESP_CSR, *PJELLM_LAST_ARESP_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_ARESP_CSR, sizeof (JELLM_LAST_ARESP_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_ARESP_CSR {
         u32 alloc_data;                          // DWORD 0
      } SG_PACK JELLM_LAST_ARESP_CSR, *PJELLM_LAST_ARESP_CSR;

      typedef union _JELLM_LAST_ARESP_CSR_UNION {
         JELLM_LAST_ARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_ARESP_CSR_UNION, *PJELLM_LAST_ARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_ARESP_CSR_UNION, sizeof (JELLM_LAST_ARESP_CSR_UNION) == 4);
   #endif


#else
   // This read-only debug register provides the last response returned to the Allocating
   // EP.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_ARESP_CSR {
         union {
            struct { 
               u32 alloc_data;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_ARESP_CSR, *PJELLM_LAST_ARESP_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_ARESP_CSR, sizeof (JELLM_LAST_ARESP_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_ARESP_CSR {
         u32 alloc_data;                          // DWORD 0
      } SG_PACK JELLM_LAST_ARESP_CSR, *PJELLM_LAST_ARESP_CSR;

      typedef union _JELLM_LAST_ARESP_CSR_UNION {
         JELLM_LAST_ARESP_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_ARESP_CSR_UNION, *PJELLM_LAST_ARESP_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_ARESP_CSR_UNION, sizeof (JELLM_LAST_ARESP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This read-only debug register provides the last request written by the De-Allocating
   // EP to JELLM. If the UEhalt bit is set in the CID_CFG_CSR and the request causes an
   // Unrecoverable Error, this register contains the offending request.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_DREQ_CSR {
         union {
            struct { 
               u32 dealloc_data;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_DREQ_CSR, *PJELLM_LAST_DREQ_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DREQ_CSR, sizeof (JELLM_LAST_DREQ_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_DREQ_CSR {
         u32 dealloc_data;                        // DWORD 0
      } SG_PACK JELLM_LAST_DREQ_CSR, *PJELLM_LAST_DREQ_CSR;

      typedef union _JELLM_LAST_DREQ_CSR_UNION {
         JELLM_LAST_DREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_DREQ_CSR_UNION, *PJELLM_LAST_DREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DREQ_CSR_UNION, sizeof (JELLM_LAST_DREQ_CSR_UNION) == 4);
   #endif


#else
   // This read-only debug register provides the last request written by the De-Allocating
   // EP to JELLM. If the UEhalt bit is set in the CID_CFG_CSR and the request causes an
   // Unrecoverable Error, this register contains the offending request.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_DREQ_CSR {
         union {
            struct { 
               u32 dealloc_data;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_DREQ_CSR, *PJELLM_LAST_DREQ_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DREQ_CSR, sizeof (JELLM_LAST_DREQ_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_DREQ_CSR {
         u32 dealloc_data;                        // DWORD 0
      } SG_PACK JELLM_LAST_DREQ_CSR, *PJELLM_LAST_DREQ_CSR;

      typedef union _JELLM_LAST_DREQ_CSR_UNION {
         JELLM_LAST_DREQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_DREQ_CSR_UNION, *PJELLM_LAST_DREQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DREQ_CSR_UNION, sizeof (JELLM_LAST_DREQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This read-only debug register provides details of the last JELLE de-allocated by
   // JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_DEALLOC_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dq_full : 1;                   // DWORD 0
               u32 cid : 13;                      // DWORD 0
               u32 dpend : 1;                     // DWORD 0
               u32 je : 15;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_DEALLOC_CSR, *PJELLM_LAST_DEALLOC_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DEALLOC_CSR, sizeof (JELLM_LAST_DEALLOC_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_DEALLOC_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dq_full : 1;                         // DWORD 0
         u32 cid : 13;                            // DWORD 0
         u32 dpend : 1;                           // DWORD 0
         u32 je : 15;                             // DWORD 0
      } SG_PACK JELLM_LAST_DEALLOC_CSR, *PJELLM_LAST_DEALLOC_CSR;

      typedef union _JELLM_LAST_DEALLOC_CSR_UNION {
         JELLM_LAST_DEALLOC_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_DEALLOC_CSR_UNION, *PJELLM_LAST_DEALLOC_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DEALLOC_CSR_UNION, sizeof (JELLM_LAST_DEALLOC_CSR_UNION) == 4);
   #endif


#else
   // This read-only debug register provides details of the last JELLE de-allocated by
   // JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_LAST_DEALLOC_CSR {
         union {
            struct { 
               u32 je : 15;                       // DWORD 0
               u32 dpend : 1;                     // DWORD 0
               u32 cid : 13;                      // DWORD 0
               u32 dq_full : 1;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_LAST_DEALLOC_CSR, *PJELLM_LAST_DEALLOC_CSR;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DEALLOC_CSR, sizeof (JELLM_LAST_DEALLOC_CSR) == 4);

   #else
      typedef struct _JELLM_LAST_DEALLOC_CSR {
         u32 je : 15;                             // DWORD 0
         u32 dpend : 1;                           // DWORD 0
         u32 cid : 13;                            // DWORD 0
         u32 dq_full : 1;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK JELLM_LAST_DEALLOC_CSR, *PJELLM_LAST_DEALLOC_CSR;

      typedef union _JELLM_LAST_DEALLOC_CSR_UNION {
         JELLM_LAST_DEALLOC_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_LAST_DEALLOC_CSR_UNION, *PJELLM_LAST_DEALLOC_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_LAST_DEALLOC_CSR_UNION, sizeof (JELLM_LAST_DEALLOC_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // JELLM Unrecoverable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_UE_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 dealloc_overrun : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_UE_STATUS_CSR, *PJELLM_UE_STATUS_CSR;

      SG_C_ASSERT(__sizeof__JELLM_UE_STATUS_CSR, sizeof (JELLM_UE_STATUS_CSR) == 4);

   #else
      typedef struct _JELLM_UE_STATUS_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 dealloc_overrun : 1;                 // DWORD 0
      } SG_PACK JELLM_UE_STATUS_CSR, *PJELLM_UE_STATUS_CSR;

      typedef union _JELLM_UE_STATUS_CSR_UNION {
         JELLM_UE_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_UE_STATUS_CSR_UNION, *PJELLM_UE_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_UE_STATUS_CSR_UNION, sizeof (JELLM_UE_STATUS_CSR_UNION) == 4);
   #endif


#else
   // JELLM Unrecoverable Error Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_UE_STATUS_CSR {
         union {
            struct { 
               u32 dealloc_overrun : 1;           // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_UE_STATUS_CSR, *PJELLM_UE_STATUS_CSR;

      SG_C_ASSERT(__sizeof__JELLM_UE_STATUS_CSR, sizeof (JELLM_UE_STATUS_CSR) == 4);

   #else
      typedef struct _JELLM_UE_STATUS_CSR {
         u32 dealloc_overrun : 1;                 // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK JELLM_UE_STATUS_CSR, *PJELLM_UE_STATUS_CSR;

      typedef union _JELLM_UE_STATUS_CSR_UNION {
         JELLM_UE_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_UE_STATUS_CSR_UNION, *PJELLM_UE_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_UE_STATUS_CSR_UNION, sizeof (JELLM_UE_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // JELLM Unrecoverable Error Enable Register. Setting each bit allows the relevant UE
   // to propagate to the central collector in the GPIO block.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 dealloc_overrun : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_UE_ENABLE_CSR, *PJELLM_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__JELLM_UE_ENABLE_CSR, sizeof (JELLM_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _JELLM_UE_ENABLE_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 dealloc_overrun : 1;                 // DWORD 0
      } SG_PACK JELLM_UE_ENABLE_CSR, *PJELLM_UE_ENABLE_CSR;

      typedef union _JELLM_UE_ENABLE_CSR_UNION {
         JELLM_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_UE_ENABLE_CSR_UNION, *PJELLM_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_UE_ENABLE_CSR_UNION, sizeof (JELLM_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // JELLM Unrecoverable Error Enable Register. Setting each bit allows the relevant UE
   // to propagate to the central collector in the GPIO block.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_UE_ENABLE_CSR {
         union {
            struct { 
               u32 dealloc_overrun : 1;           // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK JELLM_UE_ENABLE_CSR, *PJELLM_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__JELLM_UE_ENABLE_CSR, sizeof (JELLM_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _JELLM_UE_ENABLE_CSR {
         u32 dealloc_overrun : 1;                 // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK JELLM_UE_ENABLE_CSR, *PJELLM_UE_ENABLE_CSR;

      typedef union _JELLM_UE_ENABLE_CSR_UNION {
         JELLM_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK JELLM_UE_ENABLE_CSR_UNION, *PJELLM_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__JELLM_UE_ENABLE_CSR_UNION, sizeof (JELLM_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // First JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has all of the Allocation bit cid : 10 { doc = "TCP connection ID."; }
   // field and some of the Allocation length field.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D0_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_online : 1;          // DWORD 0
               u32 jellm_dbg_dealloc_all : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_alloc_len : 3;       // DWORD 1
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D0_HWDBG, *PJELLM_A_D0_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D0_HWDBG, sizeof (JELLM_A_D0_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D0_HWDBG {
         u32 jellm_dbg_online : 1;                // DWORD 0
         u32 jellm_dbg_dealloc_all : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_alloc_len : 3;             // DWORD 1
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
      } SG_PACK JELLM_A_D0_HWDBG, *PJELLM_A_D0_HWDBG;

      typedef union _JELLM_A_D0_HWDBG_UNION {
         JELLM_A_D0_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D0_HWDBG_UNION, *PJELLM_A_D0_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D0_HWDBG_UNION, sizeof (JELLM_A_D0_HWDBG_UNION) == 8);
   #endif


#else
   // First JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has all of the Allocation bit cid : 10 { doc = "TCP connection ID."; }
   // field and some of the Allocation length field.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D0_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_all : 1;     // DWORD 0
               u32 jellm_dbg_online : 1;          // DWORD 0
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 1
               u32 jellm_dbg_alloc_len : 3;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D0_HWDBG, *PJELLM_A_D0_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D0_HWDBG, sizeof (JELLM_A_D0_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D0_HWDBG {
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_all : 1;           // DWORD 0
         u32 jellm_dbg_online : 1;                // DWORD 0
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 1
         u32 jellm_dbg_alloc_len : 3;             // DWORD 1
      } SG_PACK JELLM_A_D0_HWDBG, *PJELLM_A_D0_HWDBG;

      typedef union _JELLM_A_D0_HWDBG_UNION {
         JELLM_A_D0_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D0_HWDBG_UNION, *PJELLM_A_D0_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D0_HWDBG_UNION, sizeof (JELLM_A_D0_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Second JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has all of the Allocation length field.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D1_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_online : 1;          // DWORD 0
               u32 jellm_dbg_dealloc_all : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_alloc_len : 16;      // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D1_HWDBG, *PJELLM_A_D1_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D1_HWDBG, sizeof (JELLM_A_D1_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D1_HWDBG {
         u32 jellm_dbg_online : 1;                // DWORD 0
         u32 jellm_dbg_dealloc_all : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_alloc_len : 16;            // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
      } SG_PACK JELLM_A_D1_HWDBG, *PJELLM_A_D1_HWDBG;

      typedef union _JELLM_A_D1_HWDBG_UNION {
         JELLM_A_D1_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D1_HWDBG_UNION, *PJELLM_A_D1_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D1_HWDBG_UNION, sizeof (JELLM_A_D1_HWDBG_UNION) == 8);
   #endif


#else
   // Second JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has all of the Allocation length field.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D1_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_all : 1;     // DWORD 0
               u32 jellm_dbg_online : 1;          // DWORD 0
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_len : 16;      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D1_HWDBG, *PJELLM_A_D1_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D1_HWDBG, sizeof (JELLM_A_D1_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D1_HWDBG {
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_all : 1;           // DWORD 0
         u32 jellm_dbg_online : 1;                // DWORD 0
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_len : 16;            // DWORD 1
      } SG_PACK JELLM_A_D1_HWDBG, *PJELLM_A_D1_HWDBG;

      typedef union _JELLM_A_D1_HWDBG_UNION {
         JELLM_A_D1_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D1_HWDBG_UNION, *PJELLM_A_D1_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D1_HWDBG_UNION, sizeof (JELLM_A_D1_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has CIDs and Lengths for all Allocate and De-allocate requests.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D2_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_len : 16;    // DWORD 0
               u32 jellm_dbg_dealloc_q_full : 1;  // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_req : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_alloc_len : 16;      // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_online : 1;          // DWORD 1
               u32 jellm_dbg_alloc_poll : 1;      // DWORD 1
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D2_HWDBG, *PJELLM_A_D2_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D2_HWDBG, sizeof (JELLM_A_D2_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D2_HWDBG {
         u32 jellm_dbg_dealloc_len : 16;          // DWORD 0
         u32 jellm_dbg_dealloc_q_full : 1;        // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_req : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_alloc_len : 16;            // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_online : 1;                // DWORD 1
         u32 jellm_dbg_alloc_poll : 1;            // DWORD 1
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 1
      } SG_PACK JELLM_A_D2_HWDBG, *PJELLM_A_D2_HWDBG;

      typedef union _JELLM_A_D2_HWDBG_UNION {
         JELLM_A_D2_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D2_HWDBG_UNION, *PJELLM_A_D2_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D2_HWDBG_UNION, sizeof (JELLM_A_D2_HWDBG_UNION) == 8);
   #endif


#else
   // This JELLM realtime vector variant combining Allocate and De-allocate activities.
   // This one has CIDs and Lengths for all Allocate and De-allocate requests.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_A_D2_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc_req : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_q_full : 1;  // DWORD 0
               u32 jellm_dbg_dealloc_len : 16;    // DWORD 0
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 1
               u32 jellm_dbg_alloc_poll : 1;      // DWORD 1
               u32 jellm_dbg_online : 1;          // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_len : 16;      // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_A_D2_HWDBG, *PJELLM_A_D2_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_A_D2_HWDBG, sizeof (JELLM_A_D2_HWDBG) == 8);

   #else
      typedef struct _JELLM_A_D2_HWDBG {
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc_req : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_q_full : 1;        // DWORD 0
         u32 jellm_dbg_dealloc_len : 16;          // DWORD 0
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 1
         u32 jellm_dbg_alloc_poll : 1;            // DWORD 1
         u32 jellm_dbg_online : 1;                // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_len : 16;            // DWORD 1
      } SG_PACK JELLM_A_D2_HWDBG, *PJELLM_A_D2_HWDBG;

      typedef union _JELLM_A_D2_HWDBG_UNION {
         JELLM_A_D2_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_A_D2_HWDBG_UNION, *PJELLM_A_D2_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_A_D2_HWDBG_UNION, sizeof (JELLM_A_D2_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // JELLM realtime vector tracking allocations, de-allocations and the resulting free
   // JELLE counter within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_FREE_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_alloc : 1;           // DWORD 0
               u32 jellm_dbg_alloc_je : 15;       // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 1
               u32 jellm_dbg_free_je_ptr : 15;    // DWORD 1
               u32 jellm_dbg_free_cnt : 16;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_FREE_HWDBG, *PJELLM_FREE_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_FREE_HWDBG, sizeof (JELLM_FREE_HWDBG) == 8);

   #else
      typedef struct _JELLM_FREE_HWDBG {
         u32 jellm_dbg_alloc : 1;                 // DWORD 0
         u32 jellm_dbg_alloc_je : 15;             // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 1
         u32 jellm_dbg_free_je_ptr : 15;          // DWORD 1
         u32 jellm_dbg_free_cnt : 16;             // DWORD 1
      } SG_PACK JELLM_FREE_HWDBG, *PJELLM_FREE_HWDBG;

      typedef union _JELLM_FREE_HWDBG_UNION {
         JELLM_FREE_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_FREE_HWDBG_UNION, *PJELLM_FREE_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_FREE_HWDBG_UNION, sizeof (JELLM_FREE_HWDBG_UNION) == 8);
   #endif


#else
   // JELLM realtime vector tracking allocations, de-allocations and the resulting free
   // JELLE counter within JELLM.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_FREE_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_alloc_je : 15;       // DWORD 0
               u32 jellm_dbg_alloc : 1;           // DWORD 0
               u32 jellm_dbg_free_cnt : 16;       // DWORD 1
               u32 jellm_dbg_free_je_ptr : 15;    // DWORD 1
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_FREE_HWDBG, *PJELLM_FREE_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_FREE_HWDBG, sizeof (JELLM_FREE_HWDBG) == 8);

   #else
      typedef struct _JELLM_FREE_HWDBG {
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_alloc_je : 15;             // DWORD 0
         u32 jellm_dbg_alloc : 1;                 // DWORD 0
         u32 jellm_dbg_free_cnt : 16;             // DWORD 1
         u32 jellm_dbg_free_je_ptr : 15;          // DWORD 1
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 1
      } SG_PACK JELLM_FREE_HWDBG, *PJELLM_FREE_HWDBG;

      typedef union _JELLM_FREE_HWDBG_UNION {
         JELLM_FREE_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_FREE_HWDBG_UNION, *PJELLM_FREE_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_FREE_HWDBG_UNION, sizeof (JELLM_FREE_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // JELLM realtime vector tracking incoming allocation request versus resulting JELLE
   // allocation.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_ALLOC_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_alloc_len : 16;      // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_alloc_poll : 1;      // DWORD 0
               u32 jellm_dbg_alloc_req : 1;       // DWORD 0
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 0
               u32 jellm_dbg_free_cnt : 4;        // DWORD 1
               u32 jellm_dbg_dealloc_state : 4;   // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 jellm_dbg_dealloc_pop : 1;     // DWORD 1
               u32 jellm_dbg_dealloc_pend : 1;    // DWORD 1
               u32 jellm_dbg_alloc_state : 5;     // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_ALLOC_HWDBG, *PJELLM_ALLOC_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_HWDBG, sizeof (JELLM_ALLOC_HWDBG) == 8);

   #else
      typedef struct _JELLM_ALLOC_HWDBG {
         u32 jellm_dbg_alloc_len : 16;            // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_alloc_poll : 1;            // DWORD 0
         u32 jellm_dbg_alloc_req : 1;             // DWORD 0
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 0
         u32 jellm_dbg_free_cnt : 4;              // DWORD 1
         u32 jellm_dbg_dealloc_state : 4;         // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 jellm_dbg_dealloc_pop : 1;           // DWORD 1
         u32 jellm_dbg_dealloc_pend : 1;          // DWORD 1
         u32 jellm_dbg_alloc_state : 5;           // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
      } SG_PACK JELLM_ALLOC_HWDBG, *PJELLM_ALLOC_HWDBG;

      typedef union _JELLM_ALLOC_HWDBG_UNION {
         JELLM_ALLOC_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_ALLOC_HWDBG_UNION, *PJELLM_ALLOC_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_HWDBG_UNION, sizeof (JELLM_ALLOC_HWDBG_UNION) == 8);
   #endif


#else
   // JELLM realtime vector tracking incoming allocation request versus resulting JELLE
   // allocation.
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_ALLOC_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_alloc_cid : 13;      // DWORD 0
               u32 jellm_dbg_alloc_req : 1;       // DWORD 0
               u32 jellm_dbg_alloc_poll : 1;      // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_alloc_len : 16;      // DWORD 0
               u32 jellm_dbg_alloc_je : 15;       // DWORD 1
               u32 jellm_dbg_alloc : 1;           // DWORD 1
               u32 jellm_dbg_alloc_state : 5;     // DWORD 1
               u32 jellm_dbg_dealloc_pend : 1;    // DWORD 1
               u32 jellm_dbg_dealloc_pop : 1;     // DWORD 1
               u32 rsvd0 : 1;                     // DWORD 1
               u32 jellm_dbg_dealloc_state : 4;   // DWORD 1
               u32 jellm_dbg_free_cnt : 4;        // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_ALLOC_HWDBG, *PJELLM_ALLOC_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_HWDBG, sizeof (JELLM_ALLOC_HWDBG) == 8);

   #else
      typedef struct _JELLM_ALLOC_HWDBG {
         u32 jellm_dbg_alloc_cid : 13;            // DWORD 0
         u32 jellm_dbg_alloc_req : 1;             // DWORD 0
         u32 jellm_dbg_alloc_poll : 1;            // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_alloc_len : 16;            // DWORD 0
         u32 jellm_dbg_alloc_je : 15;             // DWORD 1
         u32 jellm_dbg_alloc : 1;                 // DWORD 1
         u32 jellm_dbg_alloc_state : 5;           // DWORD 1
         u32 jellm_dbg_dealloc_pend : 1;          // DWORD 1
         u32 jellm_dbg_dealloc_pop : 1;           // DWORD 1
         u32 rsvd0 : 1;                           // DWORD 1
         u32 jellm_dbg_dealloc_state : 4;         // DWORD 1
         u32 jellm_dbg_free_cnt : 4;              // DWORD 1
      } SG_PACK JELLM_ALLOC_HWDBG, *PJELLM_ALLOC_HWDBG;

      typedef union _JELLM_ALLOC_HWDBG_UNION {
         JELLM_ALLOC_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_ALLOC_HWDBG_UNION, *PJELLM_ALLOC_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_ALLOC_HWDBG_UNION, sizeof (JELLM_ALLOC_HWDBG_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // JELLM realtime vector tracking incoming de-allocation request versus resulting JELLE
   // de-allocation(s).
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_DEALLOC_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_q_full : 1;  // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_req : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_free_cnt : 16;       // DWORD 1
               u32 jellm_dbg_dealloc_len : 16;    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_DEALLOC_HWDBG, *PJELLM_DEALLOC_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_HWDBG, sizeof (JELLM_DEALLOC_HWDBG) == 8);

   #else
      typedef struct _JELLM_DEALLOC_HWDBG {
         u32 jellm_dbg_dealloc_q_full : 1;        // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_req : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_free_cnt : 16;             // DWORD 1
         u32 jellm_dbg_dealloc_len : 16;          // DWORD 1
      } SG_PACK JELLM_DEALLOC_HWDBG, *PJELLM_DEALLOC_HWDBG;

      typedef union _JELLM_DEALLOC_HWDBG_UNION {
         JELLM_DEALLOC_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_DEALLOC_HWDBG_UNION, *PJELLM_DEALLOC_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_HWDBG_UNION, sizeof (JELLM_DEALLOC_HWDBG_UNION) == 8);
   #endif


#else
   // JELLM realtime vector tracking incoming de-allocation request versus resulting JELLE
   // de-allocation(s).
   #if defined(SG_BMAP_UNION)
      typedef struct _JELLM_DEALLOC_HWDBG {
         union {
            struct { 
               u32 jellm_dbg_dealloc_je : 15;     // DWORD 0
               u32 jellm_dbg_dealloc : 1;         // DWORD 0
               u32 jellm_dbg_dealloc_cid : 13;    // DWORD 0
               u32 jellm_dbg_dealloc_req : 1;     // DWORD 0
               u32 jellm_dbg_dealloc_overrun : 1; // DWORD 0
               u32 jellm_dbg_dealloc_q_full : 1;  // DWORD 0
               u32 jellm_dbg_dealloc_len : 16;    // DWORD 1
               u32 jellm_dbg_free_cnt : 16;       // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK JELLM_DEALLOC_HWDBG, *PJELLM_DEALLOC_HWDBG;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_HWDBG, sizeof (JELLM_DEALLOC_HWDBG) == 8);

   #else
      typedef struct _JELLM_DEALLOC_HWDBG {
         u32 jellm_dbg_dealloc_je : 15;           // DWORD 0
         u32 jellm_dbg_dealloc : 1;               // DWORD 0
         u32 jellm_dbg_dealloc_cid : 13;          // DWORD 0
         u32 jellm_dbg_dealloc_req : 1;           // DWORD 0
         u32 jellm_dbg_dealloc_overrun : 1;       // DWORD 0
         u32 jellm_dbg_dealloc_q_full : 1;        // DWORD 0
         u32 jellm_dbg_dealloc_len : 16;          // DWORD 1
         u32 jellm_dbg_free_cnt : 16;             // DWORD 1
      } SG_PACK JELLM_DEALLOC_HWDBG, *PJELLM_DEALLOC_HWDBG;

      typedef union _JELLM_DEALLOC_HWDBG_UNION {
         JELLM_DEALLOC_HWDBG bits;
         u32 dw[2]; // dword union
      } SG_PACK JELLM_DEALLOC_HWDBG_UNION, *PJELLM_DEALLOC_HWDBG_UNION;

      SG_C_ASSERT(__sizeof__JELLM_DEALLOC_HWDBG_UNION, sizeof (JELLM_DEALLOC_HWDBG_UNION) == 8);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __jellm_bmap_h__

