/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_local_mmr_bmap_h__
#define __mpu_local_mmr_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // Register Router Address. This register is used to specify a register offset. The
   // base address is taken from the corresponding PCI BAR register specified in the
   // MPU_RR_CTRL_REG.  The three RR registers are accessed the same way. First, 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_ADDR_REG {
         union {
            struct { 
               u32 baroffset;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_ADDR_REG, *PMPU_RR_ADDR_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_ADDR_REG, sizeof (MPU_RR_ADDR_REG) == 4);

   #else
      typedef struct _MPU_RR_ADDR_REG {
         u32 baroffset;                           // DWORD 0
      } SG_PACK MPU_RR_ADDR_REG, *PMPU_RR_ADDR_REG;

      typedef union _MPU_RR_ADDR_REG_UNION {
         MPU_RR_ADDR_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_ADDR_REG_UNION, *PMPU_RR_ADDR_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_ADDR_REG_UNION, sizeof (MPU_RR_ADDR_REG_UNION) == 4);
   #endif


#else
   // Register Router Address. This register is used to specify a register offset. The
   // base address is taken from the corresponding PCI BAR register specified in the
   // MPU_RR_CTRL_REG.  The three RR registers are accessed the same way. First, 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_ADDR_REG {
         union {
            struct { 
               u32 baroffset;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_ADDR_REG, *PMPU_RR_ADDR_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_ADDR_REG, sizeof (MPU_RR_ADDR_REG) == 4);

   #else
      typedef struct _MPU_RR_ADDR_REG {
         u32 baroffset;                           // DWORD 0
      } SG_PACK MPU_RR_ADDR_REG, *PMPU_RR_ADDR_REG;

      typedef union _MPU_RR_ADDR_REG_UNION {
         MPU_RR_ADDR_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_ADDR_REG_UNION, *PMPU_RR_ADDR_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_ADDR_REG_UNION, sizeof (MPU_RR_ADDR_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Register Router Data. This register is used to read or write data.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_DATA_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_DATA_REG, *PMPU_RR_DATA_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_DATA_REG, sizeof (MPU_RR_DATA_REG) == 4);

   #else
      typedef struct _MPU_RR_DATA_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_RR_DATA_REG, *PMPU_RR_DATA_REG;

      typedef union _MPU_RR_DATA_REG_UNION {
         MPU_RR_DATA_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_DATA_REG_UNION, *PMPU_RR_DATA_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_DATA_REG_UNION, sizeof (MPU_RR_DATA_REG_UNION) == 4);
   #endif


#else
   // Register Router Data. This register is used to read or write data.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_DATA_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_DATA_REG, *PMPU_RR_DATA_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_DATA_REG, sizeof (MPU_RR_DATA_REG) == 4);

   #else
      typedef struct _MPU_RR_DATA_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_RR_DATA_REG, *PMPU_RR_DATA_REG;

      typedef union _MPU_RR_DATA_REG_UNION {
         MPU_RR_DATA_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_DATA_REG_UNION, *PMPU_RR_DATA_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_DATA_REG_UNION, sizeof (MPU_RR_DATA_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Register Router Control. This is a general control register used to specify
   // parameters pertaining to the operation on the Register Router bus such as PCI
   // function number, read or write request, etc.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_CTRL_REG {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 bar_num : 3;                   // DWORD 0
               u32 func_num : 3;                  // DWORD 0
               u32 dev_num : 5;                   // DWORD 0
               u32 override : 1;                  // DWORD 0
               u32 read : 1;                      // DWORD 0
               u32 read_valid : 1;                // DWORD 0
               u32 byte_enable : 4;               // DWORD 0
               u32 match : 1;                     // DWORD 0
               u32 error : 1;                     // DWORD 0
               u32 full : 1;                      // DWORD 0
               u32 wr_ctrl : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_CTRL_REG, *PMPU_RR_CTRL_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_CTRL_REG, sizeof (MPU_RR_CTRL_REG) == 4);

   #else
      typedef struct _MPU_RR_CTRL_REG {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 bar_num : 3;                         // DWORD 0
         u32 func_num : 3;                        // DWORD 0
         u32 dev_num : 5;                         // DWORD 0
         u32 override : 1;                        // DWORD 0
         u32 read : 1;                            // DWORD 0
         u32 read_valid : 1;                      // DWORD 0
         u32 byte_enable : 4;                     // DWORD 0
         u32 match : 1;                           // DWORD 0
         u32 error : 1;                           // DWORD 0
         u32 full : 1;                            // DWORD 0
         u32 wr_ctrl : 1;                         // DWORD 0
      } SG_PACK MPU_RR_CTRL_REG, *PMPU_RR_CTRL_REG;

      typedef union _MPU_RR_CTRL_REG_UNION {
         MPU_RR_CTRL_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_CTRL_REG_UNION, *PMPU_RR_CTRL_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_CTRL_REG_UNION, sizeof (MPU_RR_CTRL_REG_UNION) == 4);
   #endif


#else
   // Register Router Control. This is a general control register used to specify
   // parameters pertaining to the operation on the Register Router bus such as PCI
   // function number, read or write request, etc.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RR_CTRL_REG {
         union {
            struct { 
               u32 wr_ctrl : 1;                   // DWORD 0
               u32 full : 1;                      // DWORD 0
               u32 error : 1;                     // DWORD 0
               u32 match : 1;                     // DWORD 0
               u32 byte_enable : 4;               // DWORD 0
               u32 read_valid : 1;                // DWORD 0
               u32 read : 1;                      // DWORD 0
               u32 override : 1;                  // DWORD 0
               u32 dev_num : 5;                   // DWORD 0
               u32 func_num : 3;                  // DWORD 0
               u32 bar_num : 3;                   // DWORD 0
               u32 type : 2;                      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RR_CTRL_REG, *PMPU_RR_CTRL_REG;

      SG_C_ASSERT(__sizeof__MPU_RR_CTRL_REG, sizeof (MPU_RR_CTRL_REG) == 4);

   #else
      typedef struct _MPU_RR_CTRL_REG {
         u32 wr_ctrl : 1;                         // DWORD 0
         u32 full : 1;                            // DWORD 0
         u32 error : 1;                           // DWORD 0
         u32 match : 1;                           // DWORD 0
         u32 byte_enable : 4;                     // DWORD 0
         u32 read_valid : 1;                      // DWORD 0
         u32 read : 1;                            // DWORD 0
         u32 override : 1;                        // DWORD 0
         u32 dev_num : 5;                         // DWORD 0
         u32 func_num : 3;                        // DWORD 0
         u32 bar_num : 3;                         // DWORD 0
         u32 type : 2;                            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK MPU_RR_CTRL_REG, *PMPU_RR_CTRL_REG;

      typedef union _MPU_RR_CTRL_REG_UNION {
         MPU_RR_CTRL_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_RR_CTRL_REG_UNION, *PMPU_RR_CTRL_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_RR_CTRL_REG_UNION, sizeof (MPU_RR_CTRL_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw interrupt source bits (31:0). These are not masked by MPU_INT_MASK0_REG. Reading
   // this register will provide a live snapshot of the interrupts presented to the MPU at
   // the time of the read. Note, masked interrupts will not cause the interrupt
   // "scheduler" to deliver the interrupt to the MPU interrupt input queue.  Interrupts
   // can detected by the MPU in three ways:  - Polling directly via an MMR. The
   // INTRPENDING_SRC bit in MPU_INT_SRC0_REG can be used to check if any unmasked
   // interrupts are pending.  - Loaded into the MPU's EP Input Queue 4. When the
   // INTRPENDING_SRC bit is set and MPU_INT_ACK_REG is set appropriately, then a 64 bit
   // vector of interrupts will be loaded into IQ4. This will also trigger a
   // <i>bank_rdy_int</i> rom the MPU EP to the ARM, visible in the ARM System Register
   // space (ARMSYS_IRQSTAT and/or ARMSYS_FIQSTAT depending on the control bit in their
   // corresponding control registers, ARMSYS_IRQCTRL and ARMSYS_FIQCTRL).  - Driven
   // directly into the ARM ICTL block. When the INTRPENDING_SRC bit is set, there is a
   // corresponding <i>mpu_int</i> bit in the ARM System Register interrupt status
   // registers (ARMSYS_IRQSTAT and ARMSYS_FIQSTAT) that is set depending on the
   // respective control bit in the interrupt control registers (ARMSYS_IRQCTRL and
   // ARMSYS_FIQCTRL).  - Note that ctx_interrupt is a misnomer. It is actually mapped to
   // the single-bit error interrupt that comes from the DDR Controller. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SRC0_REG {
         union {
            struct { 
               u32 mpu_intpend_interrupt : 1;     // DWORD 0
               u32 jtag_interrupt : 1;            // DWORD 0
               u32 axgmac1_interrupt : 1;         // DWORD 0
               u32 axgmac0_interrupt : 1;         // DWORD 0
               u32 mbox_interrupt : 1;            // DWORD 0
               u32 host_gpio_interrupt : 1;       // DWORD 0
               u32 p1_ob_link_interrupt : 1;      // DWORD 0
               u32 p0_ob_link_interrupt : 1;      // DWORD 0
               u32 host1_interrupt : 1;           // DWORD 0
               u32 txulp2_interrupt : 1;          // DWORD 0
               u32 wdma_interrupt : 1;            // DWORD 0
               u32 uc_interrupt : 1;              // DWORD 0
               u32 txulp1_interrupt : 1;          // DWORD 0
               u32 txulp0_interrupt : 1;          // DWORD 0
               u32 txips_interrupt : 1;           // DWORD 0
               u32 tpre_interrupt : 1;            // DWORD 0
               u32 tpost_interrupt : 1;           // DWORD 0
               u32 tim_interrupt : 1;             // DWORD 0
               u32 rxulp2_interrupt : 1;          // DWORD 0
               u32 rxulp1_interrupt : 1;          // DWORD 0
               u32 rxulp0_interrupt : 1;          // DWORD 0
               u32 rxips_interrupt : 1;           // DWORD 0
               u32 rxf_interrupt : 1;             // DWORD 0
               u32 rdma_interrupt : 1;            // DWORD 0
               u32 ptc_interrupt : 1;             // DWORD 0
               u32 ndma_interrupt : 1;            // DWORD 0
               u32 mpu_interrupt : 1;             // DWORD 0
               u32 host_interrupt : 1;            // DWORD 0
               u32 erx_interrupt : 1;             // DWORD 0
               u32 dbuf_interrupt : 1;            // DWORD 0
               u32 ctx_interrupt : 1;             // DWORD 0
               u32 cev_interrupt : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SRC0_REG, *PMPU_INT_SRC0_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC0_REG, sizeof (MPU_INT_SRC0_REG) == 4);

   #else
      typedef struct _MPU_INT_SRC0_REG {
         u32 mpu_intpend_interrupt : 1;           // DWORD 0
         u32 jtag_interrupt : 1;                  // DWORD 0
         u32 axgmac1_interrupt : 1;               // DWORD 0
         u32 axgmac0_interrupt : 1;               // DWORD 0
         u32 mbox_interrupt : 1;                  // DWORD 0
         u32 host_gpio_interrupt : 1;             // DWORD 0
         u32 p1_ob_link_interrupt : 1;            // DWORD 0
         u32 p0_ob_link_interrupt : 1;            // DWORD 0
         u32 host1_interrupt : 1;                 // DWORD 0
         u32 txulp2_interrupt : 1;                // DWORD 0
         u32 wdma_interrupt : 1;                  // DWORD 0
         u32 uc_interrupt : 1;                    // DWORD 0
         u32 txulp1_interrupt : 1;                // DWORD 0
         u32 txulp0_interrupt : 1;                // DWORD 0
         u32 txips_interrupt : 1;                 // DWORD 0
         u32 tpre_interrupt : 1;                  // DWORD 0
         u32 tpost_interrupt : 1;                 // DWORD 0
         u32 tim_interrupt : 1;                   // DWORD 0
         u32 rxulp2_interrupt : 1;                // DWORD 0
         u32 rxulp1_interrupt : 1;                // DWORD 0
         u32 rxulp0_interrupt : 1;                // DWORD 0
         u32 rxips_interrupt : 1;                 // DWORD 0
         u32 rxf_interrupt : 1;                   // DWORD 0
         u32 rdma_interrupt : 1;                  // DWORD 0
         u32 ptc_interrupt : 1;                   // DWORD 0
         u32 ndma_interrupt : 1;                  // DWORD 0
         u32 mpu_interrupt : 1;                   // DWORD 0
         u32 host_interrupt : 1;                  // DWORD 0
         u32 erx_interrupt : 1;                   // DWORD 0
         u32 dbuf_interrupt : 1;                  // DWORD 0
         u32 ctx_interrupt : 1;                   // DWORD 0
         u32 cev_interrupt : 1;                   // DWORD 0
      } SG_PACK MPU_INT_SRC0_REG, *PMPU_INT_SRC0_REG;

      typedef union _MPU_INT_SRC0_REG_UNION {
         MPU_INT_SRC0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SRC0_REG_UNION, *PMPU_INT_SRC0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC0_REG_UNION, sizeof (MPU_INT_SRC0_REG_UNION) == 4);
   #endif


#else
   // Raw interrupt source bits (31:0). These are not masked by MPU_INT_MASK0_REG. Reading
   // this register will provide a live snapshot of the interrupts presented to the MPU at
   // the time of the read. Note, masked interrupts will not cause the interrupt
   // "scheduler" to deliver the interrupt to the MPU interrupt input queue.  Interrupts
   // can detected by the MPU in three ways:  - Polling directly via an MMR. The
   // INTRPENDING_SRC bit in MPU_INT_SRC0_REG can be used to check if any unmasked
   // interrupts are pending.  - Loaded into the MPU's EP Input Queue 4. When the
   // INTRPENDING_SRC bit is set and MPU_INT_ACK_REG is set appropriately, then a 64 bit
   // vector of interrupts will be loaded into IQ4. This will also trigger a
   // <i>bank_rdy_int</i> rom the MPU EP to the ARM, visible in the ARM System Register
   // space (ARMSYS_IRQSTAT and/or ARMSYS_FIQSTAT depending on the control bit in their
   // corresponding control registers, ARMSYS_IRQCTRL and ARMSYS_FIQCTRL).  - Driven
   // directly into the ARM ICTL block. When the INTRPENDING_SRC bit is set, there is a
   // corresponding <i>mpu_int</i> bit in the ARM System Register interrupt status
   // registers (ARMSYS_IRQSTAT and ARMSYS_FIQSTAT) that is set depending on the
   // respective control bit in the interrupt control registers (ARMSYS_IRQCTRL and
   // ARMSYS_FIQCTRL).  - Note that ctx_interrupt is a misnomer. It is actually mapped to
   // the single-bit error interrupt that comes from the DDR Controller. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SRC0_REG {
         union {
            struct { 
               u32 cev_interrupt : 1;             // DWORD 0
               u32 ctx_interrupt : 1;             // DWORD 0
               u32 dbuf_interrupt : 1;            // DWORD 0
               u32 erx_interrupt : 1;             // DWORD 0
               u32 host_interrupt : 1;            // DWORD 0
               u32 mpu_interrupt : 1;             // DWORD 0
               u32 ndma_interrupt : 1;            // DWORD 0
               u32 ptc_interrupt : 1;             // DWORD 0
               u32 rdma_interrupt : 1;            // DWORD 0
               u32 rxf_interrupt : 1;             // DWORD 0
               u32 rxips_interrupt : 1;           // DWORD 0
               u32 rxulp0_interrupt : 1;          // DWORD 0
               u32 rxulp1_interrupt : 1;          // DWORD 0
               u32 rxulp2_interrupt : 1;          // DWORD 0
               u32 tim_interrupt : 1;             // DWORD 0
               u32 tpost_interrupt : 1;           // DWORD 0
               u32 tpre_interrupt : 1;            // DWORD 0
               u32 txips_interrupt : 1;           // DWORD 0
               u32 txulp0_interrupt : 1;          // DWORD 0
               u32 txulp1_interrupt : 1;          // DWORD 0
               u32 uc_interrupt : 1;              // DWORD 0
               u32 wdma_interrupt : 1;            // DWORD 0
               u32 txulp2_interrupt : 1;          // DWORD 0
               u32 host1_interrupt : 1;           // DWORD 0
               u32 p0_ob_link_interrupt : 1;      // DWORD 0
               u32 p1_ob_link_interrupt : 1;      // DWORD 0
               u32 host_gpio_interrupt : 1;       // DWORD 0
               u32 mbox_interrupt : 1;            // DWORD 0
               u32 axgmac0_interrupt : 1;         // DWORD 0
               u32 axgmac1_interrupt : 1;         // DWORD 0
               u32 jtag_interrupt : 1;            // DWORD 0
               u32 mpu_intpend_interrupt : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SRC0_REG, *PMPU_INT_SRC0_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC0_REG, sizeof (MPU_INT_SRC0_REG) == 4);

   #else
      typedef struct _MPU_INT_SRC0_REG {
         u32 cev_interrupt : 1;                   // DWORD 0
         u32 ctx_interrupt : 1;                   // DWORD 0
         u32 dbuf_interrupt : 1;                  // DWORD 0
         u32 erx_interrupt : 1;                   // DWORD 0
         u32 host_interrupt : 1;                  // DWORD 0
         u32 mpu_interrupt : 1;                   // DWORD 0
         u32 ndma_interrupt : 1;                  // DWORD 0
         u32 ptc_interrupt : 1;                   // DWORD 0
         u32 rdma_interrupt : 1;                  // DWORD 0
         u32 rxf_interrupt : 1;                   // DWORD 0
         u32 rxips_interrupt : 1;                 // DWORD 0
         u32 rxulp0_interrupt : 1;                // DWORD 0
         u32 rxulp1_interrupt : 1;                // DWORD 0
         u32 rxulp2_interrupt : 1;                // DWORD 0
         u32 tim_interrupt : 1;                   // DWORD 0
         u32 tpost_interrupt : 1;                 // DWORD 0
         u32 tpre_interrupt : 1;                  // DWORD 0
         u32 txips_interrupt : 1;                 // DWORD 0
         u32 txulp0_interrupt : 1;                // DWORD 0
         u32 txulp1_interrupt : 1;                // DWORD 0
         u32 uc_interrupt : 1;                    // DWORD 0
         u32 wdma_interrupt : 1;                  // DWORD 0
         u32 txulp2_interrupt : 1;                // DWORD 0
         u32 host1_interrupt : 1;                 // DWORD 0
         u32 p0_ob_link_interrupt : 1;            // DWORD 0
         u32 p1_ob_link_interrupt : 1;            // DWORD 0
         u32 host_gpio_interrupt : 1;             // DWORD 0
         u32 mbox_interrupt : 1;                  // DWORD 0
         u32 axgmac0_interrupt : 1;               // DWORD 0
         u32 axgmac1_interrupt : 1;               // DWORD 0
         u32 jtag_interrupt : 1;                  // DWORD 0
         u32 mpu_intpend_interrupt : 1;           // DWORD 0
      } SG_PACK MPU_INT_SRC0_REG, *PMPU_INT_SRC0_REG;

      typedef union _MPU_INT_SRC0_REG_UNION {
         MPU_INT_SRC0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SRC0_REG_UNION, *PMPU_INT_SRC0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC0_REG_UNION, sizeof (MPU_INT_SRC0_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw interrupt source bits (63:32). These are not masked by MPU_INT_MASK1_REG.
   // Reading this register will provide a live snapshot of the interrupts presented to
   // the MPU at the time of the read. Note, masked interrupts will not cause the
   // interrupt "scheduler" to deliver the interrupt to the MPU interrupt input queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SRC1_REG {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 host8_interrupt : 1;           // DWORD 0
               u32 host7_interrupt : 1;           // DWORD 0
               u32 host6_interrupt : 1;           // DWORD 0
               u32 host5_interrupt : 1;           // DWORD 0
               u32 host4_interrupt : 1;           // DWORD 0
               u32 host3_interrupt : 1;           // DWORD 0
               u32 host2_interrupt : 1;           // DWORD 0
               u32 ipc_interrupt : 1;             // DWORD 0
               u32 arm_interrupt : 1;             // DWORD 0
               u32 txp_interrupt : 1;             // DWORD 0
               u32 xaui_interrupt : 1;            // DWORD 0
               u32 rxpp_interrupt : 1;            // DWORD 0
               u32 txpb_interrupt : 1;            // DWORD 0
               u32 rr_interrupt : 1;              // DWORD 0
               u32 pmem_interrupt : 1;            // DWORD 0
               u32 pctl1_interrupt : 1;           // DWORD 0
               u32 pctl0_interrupt : 1;           // DWORD 0
               u32 pcs1online_interrupt : 1;      // DWORD 0
               u32 mpu_iram_interrupt : 1;        // DWORD 0
               u32 pcs0online_interrupt : 1;      // DWORD 0
               u32 mgmt_mac_interrupt : 1;        // DWORD 0
               u32 lpcmemhost_interrupt : 1;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SRC1_REG, *PMPU_INT_SRC1_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC1_REG, sizeof (MPU_INT_SRC1_REG) == 4);

   #else
      typedef struct _MPU_INT_SRC1_REG {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 host8_interrupt : 1;                 // DWORD 0
         u32 host7_interrupt : 1;                 // DWORD 0
         u32 host6_interrupt : 1;                 // DWORD 0
         u32 host5_interrupt : 1;                 // DWORD 0
         u32 host4_interrupt : 1;                 // DWORD 0
         u32 host3_interrupt : 1;                 // DWORD 0
         u32 host2_interrupt : 1;                 // DWORD 0
         u32 ipc_interrupt : 1;                   // DWORD 0
         u32 arm_interrupt : 1;                   // DWORD 0
         u32 txp_interrupt : 1;                   // DWORD 0
         u32 xaui_interrupt : 1;                  // DWORD 0
         u32 rxpp_interrupt : 1;                  // DWORD 0
         u32 txpb_interrupt : 1;                  // DWORD 0
         u32 rr_interrupt : 1;                    // DWORD 0
         u32 pmem_interrupt : 1;                  // DWORD 0
         u32 pctl1_interrupt : 1;                 // DWORD 0
         u32 pctl0_interrupt : 1;                 // DWORD 0
         u32 pcs1online_interrupt : 1;            // DWORD 0
         u32 mpu_iram_interrupt : 1;              // DWORD 0
         u32 pcs0online_interrupt : 1;            // DWORD 0
         u32 mgmt_mac_interrupt : 1;              // DWORD 0
         u32 lpcmemhost_interrupt : 1;            // DWORD 0
      } SG_PACK MPU_INT_SRC1_REG, *PMPU_INT_SRC1_REG;

      typedef union _MPU_INT_SRC1_REG_UNION {
         MPU_INT_SRC1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SRC1_REG_UNION, *PMPU_INT_SRC1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC1_REG_UNION, sizeof (MPU_INT_SRC1_REG_UNION) == 4);
   #endif


#else
   // Raw interrupt source bits (63:32). These are not masked by MPU_INT_MASK1_REG.
   // Reading this register will provide a live snapshot of the interrupts presented to
   // the MPU at the time of the read. Note, masked interrupts will not cause the
   // interrupt "scheduler" to deliver the interrupt to the MPU interrupt input queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SRC1_REG {
         union {
            struct { 
               u32 lpcmemhost_interrupt : 1;      // DWORD 0
               u32 mgmt_mac_interrupt : 1;        // DWORD 0
               u32 pcs0online_interrupt : 1;      // DWORD 0
               u32 mpu_iram_interrupt : 1;        // DWORD 0
               u32 pcs1online_interrupt : 1;      // DWORD 0
               u32 pctl0_interrupt : 1;           // DWORD 0
               u32 pctl1_interrupt : 1;           // DWORD 0
               u32 pmem_interrupt : 1;            // DWORD 0
               u32 rr_interrupt : 1;              // DWORD 0
               u32 txpb_interrupt : 1;            // DWORD 0
               u32 rxpp_interrupt : 1;            // DWORD 0
               u32 xaui_interrupt : 1;            // DWORD 0
               u32 txp_interrupt : 1;             // DWORD 0
               u32 arm_interrupt : 1;             // DWORD 0
               u32 ipc_interrupt : 1;             // DWORD 0
               u32 host2_interrupt : 1;           // DWORD 0
               u32 host3_interrupt : 1;           // DWORD 0
               u32 host4_interrupt : 1;           // DWORD 0
               u32 host5_interrupt : 1;           // DWORD 0
               u32 host6_interrupt : 1;           // DWORD 0
               u32 host7_interrupt : 1;           // DWORD 0
               u32 host8_interrupt : 1;           // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SRC1_REG, *PMPU_INT_SRC1_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC1_REG, sizeof (MPU_INT_SRC1_REG) == 4);

   #else
      typedef struct _MPU_INT_SRC1_REG {
         u32 lpcmemhost_interrupt : 1;            // DWORD 0
         u32 mgmt_mac_interrupt : 1;              // DWORD 0
         u32 pcs0online_interrupt : 1;            // DWORD 0
         u32 mpu_iram_interrupt : 1;              // DWORD 0
         u32 pcs1online_interrupt : 1;            // DWORD 0
         u32 pctl0_interrupt : 1;                 // DWORD 0
         u32 pctl1_interrupt : 1;                 // DWORD 0
         u32 pmem_interrupt : 1;                  // DWORD 0
         u32 rr_interrupt : 1;                    // DWORD 0
         u32 txpb_interrupt : 1;                  // DWORD 0
         u32 rxpp_interrupt : 1;                  // DWORD 0
         u32 xaui_interrupt : 1;                  // DWORD 0
         u32 txp_interrupt : 1;                   // DWORD 0
         u32 arm_interrupt : 1;                   // DWORD 0
         u32 ipc_interrupt : 1;                   // DWORD 0
         u32 host2_interrupt : 1;                 // DWORD 0
         u32 host3_interrupt : 1;                 // DWORD 0
         u32 host4_interrupt : 1;                 // DWORD 0
         u32 host5_interrupt : 1;                 // DWORD 0
         u32 host6_interrupt : 1;                 // DWORD 0
         u32 host7_interrupt : 1;                 // DWORD 0
         u32 host8_interrupt : 1;                 // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK MPU_INT_SRC1_REG, *PMPU_INT_SRC1_REG;

      typedef union _MPU_INT_SRC1_REG_UNION {
         MPU_INT_SRC1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SRC1_REG_UNION, *PMPU_INT_SRC1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SRC1_REG_UNION, sizeof (MPU_INT_SRC1_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These bits mask the corresponding interrupt bits in MPU_INT_SRC0_REG. Masked
   // interrupts (set to 1) will not cause an event to be written to the interrupt input
   // queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK0_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK0_REG, *PMPU_INT_MASK0_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK0_REG, sizeof (MPU_INT_MASK0_REG) == 4);

   #else
      typedef struct _MPU_INT_MASK0_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_INT_MASK0_REG, *PMPU_INT_MASK0_REG;

      typedef union _MPU_INT_MASK0_REG_UNION {
         MPU_INT_MASK0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK0_REG_UNION, *PMPU_INT_MASK0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK0_REG_UNION, sizeof (MPU_INT_MASK0_REG_UNION) == 4);
   #endif


#else
   // These bits mask the corresponding interrupt bits in MPU_INT_SRC0_REG. Masked
   // interrupts (set to 1) will not cause an event to be written to the interrupt input
   // queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK0_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK0_REG, *PMPU_INT_MASK0_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK0_REG, sizeof (MPU_INT_MASK0_REG) == 4);

   #else
      typedef struct _MPU_INT_MASK0_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_INT_MASK0_REG, *PMPU_INT_MASK0_REG;

      typedef union _MPU_INT_MASK0_REG_UNION {
         MPU_INT_MASK0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK0_REG_UNION, *PMPU_INT_MASK0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK0_REG_UNION, sizeof (MPU_INT_MASK0_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // These bits mask the corresponding interrupt bits in MPU_INT_SRC1_REG. Masked
   // interrupts (set to 1) will not cause an event to be written to the interrupt input
   // queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK1_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK1_REG, *PMPU_INT_MASK1_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK1_REG, sizeof (MPU_INT_MASK1_REG) == 4);

   #else
      typedef struct _MPU_INT_MASK1_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_INT_MASK1_REG, *PMPU_INT_MASK1_REG;

      typedef union _MPU_INT_MASK1_REG_UNION {
         MPU_INT_MASK1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK1_REG_UNION, *PMPU_INT_MASK1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK1_REG_UNION, sizeof (MPU_INT_MASK1_REG_UNION) == 4);
   #endif


#else
   // These bits mask the corresponding interrupt bits in MPU_INT_SRC1_REG. Masked
   // interrupts (set to 1) will not cause an event to be written to the interrupt input
   // queue. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK1_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK1_REG, *PMPU_INT_MASK1_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK1_REG, sizeof (MPU_INT_MASK1_REG) == 4);

   #else
      typedef struct _MPU_INT_MASK1_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_INT_MASK1_REG, *PMPU_INT_MASK1_REG;

      typedef union _MPU_INT_MASK1_REG_UNION {
         MPU_INT_MASK1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK1_REG_UNION, *PMPU_INT_MASK1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK1_REG_UNION, sizeof (MPU_INT_MASK1_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Interrupt Acknowledge register. Interrupts are delivered to an MPU input queue when
   // they are received if an interrupt "credit" is available. The MPU firmware must write
   // this register for a credit to be granted back to the interrupt "scheduler" module.
   // The act of writing this register refreshes the credit, regardless of the value
   // written. A read of this register returns garbage. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_ACK_REG {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 grant_credit : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_ACK_REG, *PMPU_INT_ACK_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_ACK_REG, sizeof (MPU_INT_ACK_REG) == 4);

   #else
      typedef struct _MPU_INT_ACK_REG {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 grant_credit : 1;                    // DWORD 0
      } SG_PACK MPU_INT_ACK_REG, *PMPU_INT_ACK_REG;

      typedef union _MPU_INT_ACK_REG_UNION {
         MPU_INT_ACK_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_ACK_REG_UNION, *PMPU_INT_ACK_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_ACK_REG_UNION, sizeof (MPU_INT_ACK_REG_UNION) == 4);
   #endif


#else
   // Interrupt Acknowledge register. Interrupts are delivered to an MPU input queue when
   // they are received if an interrupt "credit" is available. The MPU firmware must write
   // this register for a credit to be granted back to the interrupt "scheduler" module.
   // The act of writing this register refreshes the credit, regardless of the value
   // written. A read of this register returns garbage. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_ACK_REG {
         union {
            struct { 
               u32 grant_credit : 1;              // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_ACK_REG, *PMPU_INT_ACK_REG;

      SG_C_ASSERT(__sizeof__MPU_INT_ACK_REG, sizeof (MPU_INT_ACK_REG) == 4);

   #else
      typedef struct _MPU_INT_ACK_REG {
         u32 grant_credit : 1;                    // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_INT_ACK_REG, *PMPU_INT_ACK_REG;

      typedef union _MPU_INT_ACK_REG_UNION {
         MPU_INT_ACK_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_ACK_REG_UNION, *PMPU_INT_ACK_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_ACK_REG_UNION, sizeof (MPU_INT_ACK_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unique Identifier 0 Register. This register along with MPU_UID1_REG uniquely
   // identifies the BladeEngine chip.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UID0_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UID0_REG, *PMPU_UID0_REG;

      SG_C_ASSERT(__sizeof__MPU_UID0_REG, sizeof (MPU_UID0_REG) == 4);

   #else
      typedef struct _MPU_UID0_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_UID0_REG, *PMPU_UID0_REG;

      typedef union _MPU_UID0_REG_UNION {
         MPU_UID0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_UID0_REG_UNION, *PMPU_UID0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_UID0_REG_UNION, sizeof (MPU_UID0_REG_UNION) == 4);
   #endif


#else
   // Unique Identifier 0 Register. This register along with MPU_UID1_REG uniquely
   // identifies the BladeEngine chip.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UID0_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UID0_REG, *PMPU_UID0_REG;

      SG_C_ASSERT(__sizeof__MPU_UID0_REG, sizeof (MPU_UID0_REG) == 4);

   #else
      typedef struct _MPU_UID0_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_UID0_REG, *PMPU_UID0_REG;

      typedef union _MPU_UID0_REG_UNION {
         MPU_UID0_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_UID0_REG_UNION, *PMPU_UID0_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_UID0_REG_UNION, sizeof (MPU_UID0_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Unique Identifier 1 Register. This register along with MPU_UID0_REG uniquely
   // identifies the BladeEngine chip.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UID1_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UID1_REG, *PMPU_UID1_REG;

      SG_C_ASSERT(__sizeof__MPU_UID1_REG, sizeof (MPU_UID1_REG) == 4);

   #else
      typedef struct _MPU_UID1_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_UID1_REG, *PMPU_UID1_REG;

      typedef union _MPU_UID1_REG_UNION {
         MPU_UID1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_UID1_REG_UNION, *PMPU_UID1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_UID1_REG_UNION, sizeof (MPU_UID1_REG_UNION) == 4);
   #endif


#else
   // Unique Identifier 1 Register. This register along with MPU_UID0_REG uniquely
   // identifies the BladeEngine chip.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UID1_REG {
         union {
            struct { 
               u32 value;                         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UID1_REG, *PMPU_UID1_REG;

      SG_C_ASSERT(__sizeof__MPU_UID1_REG, sizeof (MPU_UID1_REG) == 4);

   #else
      typedef struct _MPU_UID1_REG {
         u32 value;                               // DWORD 0
      } SG_PACK MPU_UID1_REG, *PMPU_UID1_REG;

      typedef union _MPU_UID1_REG_UNION {
         MPU_UID1_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_UID1_REG_UNION, *PMPU_UID1_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_UID1_REG_UNION, sizeof (MPU_UID1_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Boot Control register. This register is used to control the behavior of MPU boot
   // firmware. It is a debug register for bringup purposes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_CTRL_REG {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 cfg_ATS_enable : 1;            // DWORD 0
               u32 mbox_sram_init_done : 1;       // DWORD 0
               u32 ism_in_control : 1;            // DWORD 0
               u32 mpuismoff : 1;                 // DWORD 0
               u32 crc_hash_disable : 1;          // DWORD 0
               u32 iram_boot : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_CTRL_REG, *PMPU_BOOT_CTRL_REG;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_REG, sizeof (MPU_BOOT_CTRL_REG) == 4);

   #else
      typedef struct _MPU_BOOT_CTRL_REG {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 cfg_ATS_enable : 1;                  // DWORD 0
         u32 mbox_sram_init_done : 1;             // DWORD 0
         u32 ism_in_control : 1;                  // DWORD 0
         u32 mpuismoff : 1;                       // DWORD 0
         u32 crc_hash_disable : 1;                // DWORD 0
         u32 iram_boot : 1;                       // DWORD 0
      } SG_PACK MPU_BOOT_CTRL_REG, *PMPU_BOOT_CTRL_REG;

      typedef union _MPU_BOOT_CTRL_REG_UNION {
         MPU_BOOT_CTRL_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_CTRL_REG_UNION, *PMPU_BOOT_CTRL_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_REG_UNION, sizeof (MPU_BOOT_CTRL_REG_UNION) == 4);
   #endif


#else
   // MPU Boot Control register. This register is used to control the behavior of MPU boot
   // firmware. It is a debug register for bringup purposes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_CTRL_REG {
         union {
            struct { 
               u32 iram_boot : 1;                 // DWORD 0
               u32 crc_hash_disable : 1;          // DWORD 0
               u32 mpuismoff : 1;                 // DWORD 0
               u32 ism_in_control : 1;            // DWORD 0
               u32 mbox_sram_init_done : 1;       // DWORD 0
               u32 cfg_ATS_enable : 1;            // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_CTRL_REG, *PMPU_BOOT_CTRL_REG;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_REG, sizeof (MPU_BOOT_CTRL_REG) == 4);

   #else
      typedef struct _MPU_BOOT_CTRL_REG {
         u32 iram_boot : 1;                       // DWORD 0
         u32 crc_hash_disable : 1;                // DWORD 0
         u32 mpuismoff : 1;                       // DWORD 0
         u32 ism_in_control : 1;                  // DWORD 0
         u32 mbox_sram_init_done : 1;             // DWORD 0
         u32 cfg_ATS_enable : 1;                  // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK MPU_BOOT_CTRL_REG, *PMPU_BOOT_CTRL_REG;

      typedef union _MPU_BOOT_CTRL_REG_UNION {
         MPU_BOOT_CTRL_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_CTRL_REG_UNION, *PMPU_BOOT_CTRL_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_REG_UNION, sizeof (MPU_BOOT_CTRL_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Boot Status register. This register is used by MPU boot firmware to reflect
   // errors detected during boot. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_STATUS_REG {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 fw_boot_fail : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_STATUS_REG, *PMPU_BOOT_STATUS_REG;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_REG, sizeof (MPU_BOOT_STATUS_REG) == 4);

   #else
      typedef struct _MPU_BOOT_STATUS_REG {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 fw_boot_fail : 1;                    // DWORD 0
      } SG_PACK MPU_BOOT_STATUS_REG, *PMPU_BOOT_STATUS_REG;

      typedef union _MPU_BOOT_STATUS_REG_UNION {
         MPU_BOOT_STATUS_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_STATUS_REG_UNION, *PMPU_BOOT_STATUS_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_REG_UNION, sizeof (MPU_BOOT_STATUS_REG_UNION) == 4);
   #endif


#else
   // MPU Boot Status register. This register is used by MPU boot firmware to reflect
   // errors detected during boot. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_STATUS_REG {
         union {
            struct { 
               u32 fw_boot_fail : 1;              // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_STATUS_REG, *PMPU_BOOT_STATUS_REG;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_REG, sizeof (MPU_BOOT_STATUS_REG) == 4);

   #else
      typedef struct _MPU_BOOT_STATUS_REG {
         u32 fw_boot_fail : 1;                    // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_BOOT_STATUS_REG, *PMPU_BOOT_STATUS_REG;

      typedef union _MPU_BOOT_STATUS_REG_UNION {
         MPU_BOOT_STATUS_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_STATUS_REG_UNION, *PMPU_BOOT_STATUS_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_REG_UNION, sizeof (MPU_BOOT_STATUS_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Timestamp Reset register. This register is used by the MPU firmware to reset the
   // timestamp registers (EP_CLK_CNT_REG) accross the chip to the same values. After a
   // reset, firmware should delay at least 3 clock cycles for the reset to take place.
   // Reading the register produces indeterminate values. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TIMESTAMP_RST_REG {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 rst : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_TIMESTAMP_RST_REG, *PMPU_TIMESTAMP_RST_REG;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_RST_REG, sizeof (MPU_TIMESTAMP_RST_REG) == 4);

   #else
      typedef struct _MPU_TIMESTAMP_RST_REG {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 rst : 1;                             // DWORD 0
      } SG_PACK MPU_TIMESTAMP_RST_REG, *PMPU_TIMESTAMP_RST_REG;

      typedef union _MPU_TIMESTAMP_RST_REG_UNION {
         MPU_TIMESTAMP_RST_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_TIMESTAMP_RST_REG_UNION, *PMPU_TIMESTAMP_RST_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_RST_REG_UNION, sizeof (MPU_TIMESTAMP_RST_REG_UNION) == 4);
   #endif


#else
   // MPU Timestamp Reset register. This register is used by the MPU firmware to reset the
   // timestamp registers (EP_CLK_CNT_REG) accross the chip to the same values. After a
   // reset, firmware should delay at least 3 clock cycles for the reset to take place.
   // Reading the register produces indeterminate values. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TIMESTAMP_RST_REG {
         union {
            struct { 
               u32 rst : 1;                       // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_TIMESTAMP_RST_REG, *PMPU_TIMESTAMP_RST_REG;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_RST_REG, sizeof (MPU_TIMESTAMP_RST_REG) == 4);

   #else
      typedef struct _MPU_TIMESTAMP_RST_REG {
         u32 rst : 1;                             // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_TIMESTAMP_RST_REG, *PMPU_TIMESTAMP_RST_REG;

      typedef union _MPU_TIMESTAMP_RST_REG_UNION {
         MPU_TIMESTAMP_RST_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_TIMESTAMP_RST_REG_UNION, *PMPU_TIMESTAMP_RST_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_RST_REG_UNION, sizeof (MPU_TIMESTAMP_RST_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU to TIM (timer) hold 10m second timer. This register is used by the MPU firmware
   // to hold the TIM block back, allowing the TIM to sync with the FW's timestamp. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TIMESTAMP_HOLD_10MS_REG {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 rst : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG, *PMPU_TIMESTAMP_HOLD_10MS_REG;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_HOLD_10MS_REG, sizeof (MPU_TIMESTAMP_HOLD_10MS_REG) == 4);

   #else
      typedef struct _MPU_TIMESTAMP_HOLD_10MS_REG {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 rst : 1;                             // DWORD 0
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG, *PMPU_TIMESTAMP_HOLD_10MS_REG;

      typedef union _MPU_TIMESTAMP_HOLD_10MS_REG_UNION {
         MPU_TIMESTAMP_HOLD_10MS_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG_UNION, *PMPU_TIMESTAMP_HOLD_10MS_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_HOLD_10MS_REG_UNION, sizeof (MPU_TIMESTAMP_HOLD_10MS_REG_UNION) == 4);
   #endif


#else
   // MPU to TIM (timer) hold 10m second timer. This register is used by the MPU firmware
   // to hold the TIM block back, allowing the TIM to sync with the FW's timestamp. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_TIMESTAMP_HOLD_10MS_REG {
         union {
            struct { 
               u32 rst : 1;                       // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG, *PMPU_TIMESTAMP_HOLD_10MS_REG;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_HOLD_10MS_REG, sizeof (MPU_TIMESTAMP_HOLD_10MS_REG) == 4);

   #else
      typedef struct _MPU_TIMESTAMP_HOLD_10MS_REG {
         u32 rst : 1;                             // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG, *PMPU_TIMESTAMP_HOLD_10MS_REG;

      typedef union _MPU_TIMESTAMP_HOLD_10MS_REG_UNION {
         MPU_TIMESTAMP_HOLD_10MS_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_TIMESTAMP_HOLD_10MS_REG_UNION, *PMPU_TIMESTAMP_HOLD_10MS_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_TIMESTAMP_HOLD_10MS_REG_UNION, sizeof (MPU_TIMESTAMP_HOLD_10MS_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register indicates if a particular FID has issued a write to that FID's
   // mailbox. The indications are sticky, and must be cleared by writing a 1 to the
   // individual bit. Note that each register has the indications of 32 FID. Also note
   // that not all FID have valid mailboxes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MBOXRANG_REG {
         union {
            struct { 
               u32 mboxid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MBOXRANG_REG, *PMPU_MBOXRANG_REG;

      SG_C_ASSERT(__sizeof__MPU_MBOXRANG_REG, sizeof (MPU_MBOXRANG_REG) == 4);

   #else
      typedef struct _MPU_MBOXRANG_REG {
         u32 mboxid;                              // DWORD 0
      } SG_PACK MPU_MBOXRANG_REG, *PMPU_MBOXRANG_REG;

      typedef union _MPU_MBOXRANG_REG_UNION {
         MPU_MBOXRANG_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_MBOXRANG_REG_UNION, *PMPU_MBOXRANG_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_MBOXRANG_REG_UNION, sizeof (MPU_MBOXRANG_REG_UNION) == 4);
   #endif


#else
   // This register indicates if a particular FID has issued a write to that FID's
   // mailbox. The indications are sticky, and must be cleared by writing a 1 to the
   // individual bit. Note that each register has the indications of 32 FID. Also note
   // that not all FID have valid mailboxes. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MBOXRANG_REG {
         union {
            struct { 
               u32 mboxid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MBOXRANG_REG, *PMPU_MBOXRANG_REG;

      SG_C_ASSERT(__sizeof__MPU_MBOXRANG_REG, sizeof (MPU_MBOXRANG_REG) == 4);

   #else
      typedef struct _MPU_MBOXRANG_REG {
         u32 mboxid;                              // DWORD 0
      } SG_PACK MPU_MBOXRANG_REG, *PMPU_MBOXRANG_REG;

      typedef union _MPU_MBOXRANG_REG_UNION {
         MPU_MBOXRANG_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_MBOXRANG_REG_UNION, *PMPU_MBOXRANG_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_MBOXRANG_REG_UNION, sizeof (MPU_MBOXRANG_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Enable bit used to allow the presence of a bit in the corresponding MPU_MBOXRANG_REG
   // mmr to cause an interrupt. Clearing this bit does not clear the corresponding bit in
   // the RANG mmr, it only prevents it from generating an interrupt. Each bit represents
   // one FID's mailbox interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_EN_REG {
         union {
            struct { 
               u32 mboxid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_EN_REG, *PMPU_MAILBOX_EN_REG;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_EN_REG, sizeof (MPU_MAILBOX_EN_REG) == 4);

   #else
      typedef struct _MPU_MAILBOX_EN_REG {
         u32 mboxid;                              // DWORD 0
      } SG_PACK MPU_MAILBOX_EN_REG, *PMPU_MAILBOX_EN_REG;

      typedef union _MPU_MAILBOX_EN_REG_UNION {
         MPU_MAILBOX_EN_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_MAILBOX_EN_REG_UNION, *PMPU_MAILBOX_EN_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_EN_REG_UNION, sizeof (MPU_MAILBOX_EN_REG_UNION) == 4);
   #endif


#else
   // Enable bit used to allow the presence of a bit in the corresponding MPU_MBOXRANG_REG
   // mmr to cause an interrupt. Clearing this bit does not clear the corresponding bit in
   // the RANG mmr, it only prevents it from generating an interrupt. Each bit represents
   // one FID's mailbox interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_MAILBOX_EN_REG {
         union {
            struct { 
               u32 mboxid;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_MAILBOX_EN_REG, *PMPU_MAILBOX_EN_REG;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_EN_REG, sizeof (MPU_MAILBOX_EN_REG) == 4);

   #else
      typedef struct _MPU_MAILBOX_EN_REG {
         u32 mboxid;                              // DWORD 0
      } SG_PACK MPU_MAILBOX_EN_REG, *PMPU_MAILBOX_EN_REG;

      typedef union _MPU_MAILBOX_EN_REG_UNION {
         MPU_MAILBOX_EN_REG bits;
         u32 dw; // dword union
      } SG_PACK MPU_MAILBOX_EN_REG_UNION, *PMPU_MAILBOX_EN_REG_UNION;

      SG_C_ASSERT(__sizeof__MPU_MAILBOX_EN_REG_UNION, sizeof (MPU_MAILBOX_EN_REG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU complex that bypasses EP input queues. Read the upper IQ data first (if needed)
   // and then the lower IQ to pop an entry off of the input FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_LOWER {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_LOWER, *PMPU_IQ_LOWER;

      SG_C_ASSERT(__sizeof__MPU_IQ_LOWER, sizeof (MPU_IQ_LOWER) == 4);

   #else
      typedef struct _MPU_IQ_LOWER {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_IQ_LOWER, *PMPU_IQ_LOWER;

      typedef union _MPU_IQ_LOWER_UNION {
         MPU_IQ_LOWER bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_LOWER_UNION, *PMPU_IQ_LOWER_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_LOWER_UNION, sizeof (MPU_IQ_LOWER_UNION) == 4);
   #endif


#else
   // MPU complex that bypasses EP input queues. Read the upper IQ data first (if needed)
   // and then the lower IQ to pop an entry off of the input FIFO. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_LOWER {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_LOWER, *PMPU_IQ_LOWER;

      SG_C_ASSERT(__sizeof__MPU_IQ_LOWER, sizeof (MPU_IQ_LOWER) == 4);

   #else
      typedef struct _MPU_IQ_LOWER {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_IQ_LOWER, *PMPU_IQ_LOWER;

      typedef union _MPU_IQ_LOWER_UNION {
         MPU_IQ_LOWER bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_LOWER_UNION, *PMPU_IQ_LOWER_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_LOWER_UNION, sizeof (MPU_IQ_LOWER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // See MPU_IQ_LOWER. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_UPPER {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_UPPER, *PMPU_IQ_UPPER;

      SG_C_ASSERT(__sizeof__MPU_IQ_UPPER, sizeof (MPU_IQ_UPPER) == 4);

   #else
      typedef struct _MPU_IQ_UPPER {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_IQ_UPPER, *PMPU_IQ_UPPER;

      typedef union _MPU_IQ_UPPER_UNION {
         MPU_IQ_UPPER bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_UPPER_UNION, *PMPU_IQ_UPPER_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_UPPER_UNION, sizeof (MPU_IQ_UPPER_UNION) == 4);
   #endif


#else
   // See MPU_IQ_LOWER. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_UPPER {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_UPPER, *PMPU_IQ_UPPER;

      SG_C_ASSERT(__sizeof__MPU_IQ_UPPER, sizeof (MPU_IQ_UPPER) == 4);

   #else
      typedef struct _MPU_IQ_UPPER {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_IQ_UPPER, *PMPU_IQ_UPPER;

      typedef union _MPU_IQ_UPPER_UNION {
         MPU_IQ_UPPER bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_UPPER_UNION, *PMPU_IQ_UPPER_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_UPPER_UNION, sizeof (MPU_IQ_UPPER_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates which queues have data ready to be read out. If not set, reading that
   // queue can cause unpredictable results. If set, at least one vector (32-64 bits) is
   // avaialble. In the case of some multi-word IQ (like IPC), the SW must read this
   // register again and again to get the full data. The RDY signals are live, so there is
   // no need to clear the interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_RDY {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 iq_rdy : 8;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_RDY, *PMPU_IQ_RDY;

      SG_C_ASSERT(__sizeof__MPU_IQ_RDY, sizeof (MPU_IQ_RDY) == 4);

   #else
      typedef struct _MPU_IQ_RDY {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 iq_rdy : 8;                          // DWORD 0
      } SG_PACK MPU_IQ_RDY, *PMPU_IQ_RDY;

      typedef union _MPU_IQ_RDY_UNION {
         MPU_IQ_RDY bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_RDY_UNION, *PMPU_IQ_RDY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_RDY_UNION, sizeof (MPU_IQ_RDY_UNION) == 4);
   #endif


#else
   // Indicates which queues have data ready to be read out. If not set, reading that
   // queue can cause unpredictable results. If set, at least one vector (32-64 bits) is
   // avaialble. In the case of some multi-word IQ (like IPC), the SW must read this
   // register again and again to get the full data. The RDY signals are live, so there is
   // no need to clear the interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_RDY {
         union {
            struct { 
               u32 iq_rdy : 8;                    // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_RDY, *PMPU_IQ_RDY;

      SG_C_ASSERT(__sizeof__MPU_IQ_RDY, sizeof (MPU_IQ_RDY) == 4);

   #else
      typedef struct _MPU_IQ_RDY {
         u32 iq_rdy : 8;                          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK MPU_IQ_RDY, *PMPU_IQ_RDY;

      typedef union _MPU_IQ_RDY_UNION {
         MPU_IQ_RDY bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_RDY_UNION, *PMPU_IQ_RDY_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_RDY_UNION, sizeof (MPU_IQ_RDY_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each bit controls if a particular IQ that has data ready to read will trigger an
   // interrupt into the ARM. Note that this does not affect reads of the "MPU_IQ_RDY",
   // only if those rdy signals will trigger an interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_EN_INT {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 enable_int : 8;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_EN_INT, *PMPU_IQ_EN_INT;

      SG_C_ASSERT(__sizeof__MPU_IQ_EN_INT, sizeof (MPU_IQ_EN_INT) == 4);

   #else
      typedef struct _MPU_IQ_EN_INT {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 enable_int : 8;                      // DWORD 0
      } SG_PACK MPU_IQ_EN_INT, *PMPU_IQ_EN_INT;

      typedef union _MPU_IQ_EN_INT_UNION {
         MPU_IQ_EN_INT bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_EN_INT_UNION, *PMPU_IQ_EN_INT_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_EN_INT_UNION, sizeof (MPU_IQ_EN_INT_UNION) == 4);
   #endif


#else
   // Each bit controls if a particular IQ that has data ready to read will trigger an
   // interrupt into the ARM. Note that this does not affect reads of the "MPU_IQ_RDY",
   // only if those rdy signals will trigger an interrupt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_EN_INT {
         union {
            struct { 
               u32 enable_int : 8;                // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_EN_INT, *PMPU_IQ_EN_INT;

      SG_C_ASSERT(__sizeof__MPU_IQ_EN_INT, sizeof (MPU_IQ_EN_INT) == 4);

   #else
      typedef struct _MPU_IQ_EN_INT {
         u32 enable_int : 8;                      // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK MPU_IQ_EN_INT, *PMPU_IQ_EN_INT;

      typedef union _MPU_IQ_EN_INT_UNION {
         MPU_IQ_EN_INT bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_EN_INT_UNION, *PMPU_IQ_EN_INT_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_EN_INT_UNION, sizeof (MPU_IQ_EN_INT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU-Specific Firmware Interface Register Map
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_LOCAL_IF_REGMAP {
         union {
            struct { 
               MPU_RR_ADDR_REG rr_addr;
               u32 rsvd0[1];                      // DWORDS 1 to 1
               MPU_RR_DATA_REG rr_data;
               u32 rsvd1[1];                      // DWORDS 3 to 3
               MPU_RR_CTRL_REG rr_ctrl;
               u32 rsvd2[1];                      // DWORDS 5 to 5
               MPU_INT_MASK0_REG int_mask0;
               u32 rsvd3[1];                      // DWORDS 7 to 7
               MPU_INT_MASK1_REG int_mask1;
               u32 rsvd4[1];                      // DWORDS 9 to 9
               MPU_INT_SRC0_REG int_src0;
               u32 rsvd5[1];                      // DWORDS 11 to 11
               MPU_INT_SRC1_REG int_src1;
               u32 rsvd6[1];                      // DWORDS 13 to 13
               MPU_INT_ACK_REG int_ack;
               u32 rsvd7[1];                      // DWORDS 15 to 15
               u32 rsvd8[1];                      // DWORDS 16 to 16
               MPU_UID0_REG uid0;
               MPU_UID1_REG uid1;
               u32 rsvd9[1];                      // DWORDS 19 to 19
               MPU_BOOT_CTRL_REG boot_ctrl;
               u32 rsvd10[1];                     // DWORDS 21 to 21
               MPU_BOOT_STATUS_REG boot_status;
               u32 rsvd11[1];                     // DWORDS 23 to 23
               MPU_TIMESTAMP_RST_REG timestamp_rst;
               u32 rsvd12[1];                     // DWORDS 25 to 25
               MPU_TIMESTAMP_HOLD_10MS_REG timestamp_hold_10ms;
               u32 rsvd13[1];                     // DWORDS 27 to 27
               MPU_MBOXRANG_REG mboxrang0;
               u32 rsvd14[1];                     // DWORDS 29 to 29
               MPU_MBOXRANG_REG mboxrang1;
               u32 rsvd15[1];                     // DWORDS 31 to 31
               MPU_MBOXRANG_REG mboxrang2;
               u32 rsvd16[1];                     // DWORDS 33 to 33
               MPU_MBOXRANG_REG mboxrang3;
               u32 rsvd17[1];                     // DWORDS 35 to 35
               MPU_MBOXRANG_REG mboxrang4;
               u32 rsvd18[1];                     // DWORDS 37 to 37
               MPU_MBOXRANG_REG mboxrang5;
               u32 rsvd19[1];                     // DWORDS 39 to 39
               MPU_MBOXRANG_REG mboxrang6;
               u32 rsvd20[1];                     // DWORDS 41 to 41
               MPU_MBOXRANG_REG mboxrang7;
               u32 rsvd21[1];                     // DWORDS 43 to 43
               MPU_MAILBOX_EN_REG mailbox_en0;
               u32 rsvd22[1];                     // DWORDS 45 to 45
               MPU_MAILBOX_EN_REG mailbox_en1;
               u32 rsvd23[1];                     // DWORDS 47 to 47
               MPU_MAILBOX_EN_REG mailbox_en2;
               u32 rsvd24[1];                     // DWORDS 49 to 49
               MPU_MAILBOX_EN_REG mailbox_en3;
               u32 rsvd25[1];                     // DWORDS 51 to 51
               MPU_MAILBOX_EN_REG mailbox_en4;
               u32 rsvd26[1];                     // DWORDS 53 to 53
               MPU_MAILBOX_EN_REG mailbox_en5;
               u32 rsvd27[1];                     // DWORDS 55 to 55
               MPU_MAILBOX_EN_REG mailbox_en6;
               u32 rsvd28[1];                     // DWORDS 57 to 57
               MPU_MAILBOX_EN_REG mailbox_en7;
               u32 rsvd29[1];                     // DWORDS 59 to 59
               MPU_IQ_LOWER iq0_lower;
               u32 rsvd30[1];                     // DWORDS 61 to 61
               MPU_IQ_UPPER iq0_upper;
               u32 rsvd31[1];                     // DWORDS 63 to 63
               MPU_IQ_LOWER iq1_lower;
               u32 rsvd32[1];                     // DWORDS 65 to 65
               MPU_IQ_UPPER iq1_upper;
               u32 rsvd33[1];                     // DWORDS 67 to 67
               MPU_IQ_LOWER iq2_lower;
               u32 rsvd34[1];                     // DWORDS 69 to 69
               MPU_IQ_UPPER iq2_upper;
               u32 rsvd35[1];                     // DWORDS 71 to 71
               MPU_IQ_LOWER iq3_lower;
               u32 rsvd36[1];                     // DWORDS 73 to 73
               MPU_IQ_UPPER iq3_upper;
               u32 rsvd37[1];                     // DWORDS 75 to 75
               MPU_IQ_LOWER iq4_lower;
               u32 rsvd38[1];                     // DWORDS 77 to 77
               MPU_IQ_UPPER iq4_upper;
               u32 rsvd39[1];                     // DWORDS 79 to 79
               MPU_IQ_LOWER iq5_lower;
               u32 rsvd40[1];                     // DWORDS 81 to 81
               MPU_IQ_UPPER iq5_upper;
               u32 rsvd41[1];                     // DWORDS 83 to 83
               MPU_IQ_LOWER iq6_lower;
               u32 rsvd42[1];                     // DWORDS 85 to 85
               MPU_IQ_UPPER iq6_upper;
               u32 rsvd43[1];                     // DWORDS 87 to 87
               MPU_IQ_LOWER iq7_lower;
               u32 rsvd44[1];                     // DWORDS 89 to 89
               MPU_IQ_UPPER iq7_upper;
               u32 rsvd45[1];                     // DWORDS 91 to 91
               MPU_IQ_RDY iq_rdy;
               u32 rsvd46[1];                     // DWORDS 93 to 93
               MPU_IQ_EN_INT iq_en_int;
               u32 rsvd47[1];                     // DWORDS 95 to 95
               u32 rsvd48[32];                    // DWORDS 96 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK MPU_LOCAL_IF_REGMAP, *PMPU_LOCAL_IF_REGMAP;

      SG_C_ASSERT(__sizeof__MPU_LOCAL_IF_REGMAP, sizeof (MPU_LOCAL_IF_REGMAP) == 512);

   #else
      typedef struct _MPU_LOCAL_IF_REGMAP {
         MPU_RR_ADDR_REG rr_addr;
         u32 rsvd0[1];                            // DWORDS 1 to 1
         MPU_RR_DATA_REG rr_data;
         u32 rsvd1[1];                            // DWORDS 3 to 3
         MPU_RR_CTRL_REG rr_ctrl;
         u32 rsvd2[1];                            // DWORDS 5 to 5
         MPU_INT_MASK0_REG int_mask0;
         u32 rsvd3[1];                            // DWORDS 7 to 7
         MPU_INT_MASK1_REG int_mask1;
         u32 rsvd4[1];                            // DWORDS 9 to 9
         MPU_INT_SRC0_REG int_src0;
         u32 rsvd5[1];                            // DWORDS 11 to 11
         MPU_INT_SRC1_REG int_src1;
         u32 rsvd6[1];                            // DWORDS 13 to 13
         MPU_INT_ACK_REG int_ack;
         u32 rsvd7[1];                            // DWORDS 15 to 15
         u32 rsvd8[1];                            // DWORDS 16 to 16
         MPU_UID0_REG uid0;
         MPU_UID1_REG uid1;
         u32 rsvd9[1];                            // DWORDS 19 to 19
         MPU_BOOT_CTRL_REG boot_ctrl;
         u32 rsvd10[1];                           // DWORDS 21 to 21
         MPU_BOOT_STATUS_REG boot_status;
         u32 rsvd11[1];                           // DWORDS 23 to 23
         MPU_TIMESTAMP_RST_REG timestamp_rst;
         u32 rsvd12[1];                           // DWORDS 25 to 25
         MPU_TIMESTAMP_HOLD_10MS_REG timestamp_hold_10ms;
         u32 rsvd13[1];                           // DWORDS 27 to 27
         MPU_MBOXRANG_REG mboxrang0;
         u32 rsvd14[1];                           // DWORDS 29 to 29
         MPU_MBOXRANG_REG mboxrang1;
         u32 rsvd15[1];                           // DWORDS 31 to 31
         MPU_MBOXRANG_REG mboxrang2;
         u32 rsvd16[1];                           // DWORDS 33 to 33
         MPU_MBOXRANG_REG mboxrang3;
         u32 rsvd17[1];                           // DWORDS 35 to 35
         MPU_MBOXRANG_REG mboxrang4;
         u32 rsvd18[1];                           // DWORDS 37 to 37
         MPU_MBOXRANG_REG mboxrang5;
         u32 rsvd19[1];                           // DWORDS 39 to 39
         MPU_MBOXRANG_REG mboxrang6;
         u32 rsvd20[1];                           // DWORDS 41 to 41
         MPU_MBOXRANG_REG mboxrang7;
         u32 rsvd21[1];                           // DWORDS 43 to 43
         MPU_MAILBOX_EN_REG mailbox_en0;
         u32 rsvd22[1];                           // DWORDS 45 to 45
         MPU_MAILBOX_EN_REG mailbox_en1;
         u32 rsvd23[1];                           // DWORDS 47 to 47
         MPU_MAILBOX_EN_REG mailbox_en2;
         u32 rsvd24[1];                           // DWORDS 49 to 49
         MPU_MAILBOX_EN_REG mailbox_en3;
         u32 rsvd25[1];                           // DWORDS 51 to 51
         MPU_MAILBOX_EN_REG mailbox_en4;
         u32 rsvd26[1];                           // DWORDS 53 to 53
         MPU_MAILBOX_EN_REG mailbox_en5;
         u32 rsvd27[1];                           // DWORDS 55 to 55
         MPU_MAILBOX_EN_REG mailbox_en6;
         u32 rsvd28[1];                           // DWORDS 57 to 57
         MPU_MAILBOX_EN_REG mailbox_en7;
         u32 rsvd29[1];                           // DWORDS 59 to 59
         MPU_IQ_LOWER iq0_lower;
         u32 rsvd30[1];                           // DWORDS 61 to 61
         MPU_IQ_UPPER iq0_upper;
         u32 rsvd31[1];                           // DWORDS 63 to 63
         MPU_IQ_LOWER iq1_lower;
         u32 rsvd32[1];                           // DWORDS 65 to 65
         MPU_IQ_UPPER iq1_upper;
         u32 rsvd33[1];                           // DWORDS 67 to 67
         MPU_IQ_LOWER iq2_lower;
         u32 rsvd34[1];                           // DWORDS 69 to 69
         MPU_IQ_UPPER iq2_upper;
         u32 rsvd35[1];                           // DWORDS 71 to 71
         MPU_IQ_LOWER iq3_lower;
         u32 rsvd36[1];                           // DWORDS 73 to 73
         MPU_IQ_UPPER iq3_upper;
         u32 rsvd37[1];                           // DWORDS 75 to 75
         MPU_IQ_LOWER iq4_lower;
         u32 rsvd38[1];                           // DWORDS 77 to 77
         MPU_IQ_UPPER iq4_upper;
         u32 rsvd39[1];                           // DWORDS 79 to 79
         MPU_IQ_LOWER iq5_lower;
         u32 rsvd40[1];                           // DWORDS 81 to 81
         MPU_IQ_UPPER iq5_upper;
         u32 rsvd41[1];                           // DWORDS 83 to 83
         MPU_IQ_LOWER iq6_lower;
         u32 rsvd42[1];                           // DWORDS 85 to 85
         MPU_IQ_UPPER iq6_upper;
         u32 rsvd43[1];                           // DWORDS 87 to 87
         MPU_IQ_LOWER iq7_lower;
         u32 rsvd44[1];                           // DWORDS 89 to 89
         MPU_IQ_UPPER iq7_upper;
         u32 rsvd45[1];                           // DWORDS 91 to 91
         MPU_IQ_RDY iq_rdy;
         u32 rsvd46[1];                           // DWORDS 93 to 93
         MPU_IQ_EN_INT iq_en_int;
         u32 rsvd47[1];                           // DWORDS 95 to 95
         u32 rsvd48[32];                          // DWORDS 96 to 127
      } SG_PACK MPU_LOCAL_IF_REGMAP, *PMPU_LOCAL_IF_REGMAP;

      typedef union _MPU_LOCAL_IF_REGMAP_UNION {
         MPU_LOCAL_IF_REGMAP bits;
         u32 dw[128]; // dword union
      } SG_PACK MPU_LOCAL_IF_REGMAP_UNION, *PMPU_LOCAL_IF_REGMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_LOCAL_IF_REGMAP_UNION, sizeof (MPU_LOCAL_IF_REGMAP_UNION) == 512);
   #endif


#else
   // MPU-Specific Firmware Interface Register Map
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_LOCAL_IF_REGMAP {
         union {
            struct { 
               MPU_RR_ADDR_REG rr_addr;
               u32 rsvd0[1];                      // DWORDS 1 to 1
               MPU_RR_DATA_REG rr_data;
               u32 rsvd1[1];                      // DWORDS 3 to 3
               MPU_RR_CTRL_REG rr_ctrl;
               u32 rsvd2[1];                      // DWORDS 5 to 5
               MPU_INT_MASK0_REG int_mask0;
               u32 rsvd3[1];                      // DWORDS 7 to 7
               MPU_INT_MASK1_REG int_mask1;
               u32 rsvd4[1];                      // DWORDS 9 to 9
               MPU_INT_SRC0_REG int_src0;
               u32 rsvd5[1];                      // DWORDS 11 to 11
               MPU_INT_SRC1_REG int_src1;
               u32 rsvd6[1];                      // DWORDS 13 to 13
               MPU_INT_ACK_REG int_ack;
               u32 rsvd7[1];                      // DWORDS 15 to 15
               u32 rsvd8[1];                      // DWORDS 16 to 16
               MPU_UID0_REG uid0;
               MPU_UID1_REG uid1;
               u32 rsvd9[1];                      // DWORDS 19 to 19
               MPU_BOOT_CTRL_REG boot_ctrl;
               u32 rsvd10[1];                     // DWORDS 21 to 21
               MPU_BOOT_STATUS_REG boot_status;
               u32 rsvd11[1];                     // DWORDS 23 to 23
               MPU_TIMESTAMP_RST_REG timestamp_rst;
               u32 rsvd12[1];                     // DWORDS 25 to 25
               MPU_TIMESTAMP_HOLD_10MS_REG timestamp_hold_10ms;
               u32 rsvd13[1];                     // DWORDS 27 to 27
               MPU_MBOXRANG_REG mboxrang0;
               u32 rsvd14[1];                     // DWORDS 29 to 29
               MPU_MBOXRANG_REG mboxrang1;
               u32 rsvd15[1];                     // DWORDS 31 to 31
               MPU_MBOXRANG_REG mboxrang2;
               u32 rsvd16[1];                     // DWORDS 33 to 33
               MPU_MBOXRANG_REG mboxrang3;
               u32 rsvd17[1];                     // DWORDS 35 to 35
               MPU_MBOXRANG_REG mboxrang4;
               u32 rsvd18[1];                     // DWORDS 37 to 37
               MPU_MBOXRANG_REG mboxrang5;
               u32 rsvd19[1];                     // DWORDS 39 to 39
               MPU_MBOXRANG_REG mboxrang6;
               u32 rsvd20[1];                     // DWORDS 41 to 41
               MPU_MBOXRANG_REG mboxrang7;
               u32 rsvd21[1];                     // DWORDS 43 to 43
               MPU_MAILBOX_EN_REG mailbox_en0;
               u32 rsvd22[1];                     // DWORDS 45 to 45
               MPU_MAILBOX_EN_REG mailbox_en1;
               u32 rsvd23[1];                     // DWORDS 47 to 47
               MPU_MAILBOX_EN_REG mailbox_en2;
               u32 rsvd24[1];                     // DWORDS 49 to 49
               MPU_MAILBOX_EN_REG mailbox_en3;
               u32 rsvd25[1];                     // DWORDS 51 to 51
               MPU_MAILBOX_EN_REG mailbox_en4;
               u32 rsvd26[1];                     // DWORDS 53 to 53
               MPU_MAILBOX_EN_REG mailbox_en5;
               u32 rsvd27[1];                     // DWORDS 55 to 55
               MPU_MAILBOX_EN_REG mailbox_en6;
               u32 rsvd28[1];                     // DWORDS 57 to 57
               MPU_MAILBOX_EN_REG mailbox_en7;
               u32 rsvd29[1];                     // DWORDS 59 to 59
               MPU_IQ_LOWER iq0_lower;
               u32 rsvd30[1];                     // DWORDS 61 to 61
               MPU_IQ_UPPER iq0_upper;
               u32 rsvd31[1];                     // DWORDS 63 to 63
               MPU_IQ_LOWER iq1_lower;
               u32 rsvd32[1];                     // DWORDS 65 to 65
               MPU_IQ_UPPER iq1_upper;
               u32 rsvd33[1];                     // DWORDS 67 to 67
               MPU_IQ_LOWER iq2_lower;
               u32 rsvd34[1];                     // DWORDS 69 to 69
               MPU_IQ_UPPER iq2_upper;
               u32 rsvd35[1];                     // DWORDS 71 to 71
               MPU_IQ_LOWER iq3_lower;
               u32 rsvd36[1];                     // DWORDS 73 to 73
               MPU_IQ_UPPER iq3_upper;
               u32 rsvd37[1];                     // DWORDS 75 to 75
               MPU_IQ_LOWER iq4_lower;
               u32 rsvd38[1];                     // DWORDS 77 to 77
               MPU_IQ_UPPER iq4_upper;
               u32 rsvd39[1];                     // DWORDS 79 to 79
               MPU_IQ_LOWER iq5_lower;
               u32 rsvd40[1];                     // DWORDS 81 to 81
               MPU_IQ_UPPER iq5_upper;
               u32 rsvd41[1];                     // DWORDS 83 to 83
               MPU_IQ_LOWER iq6_lower;
               u32 rsvd42[1];                     // DWORDS 85 to 85
               MPU_IQ_UPPER iq6_upper;
               u32 rsvd43[1];                     // DWORDS 87 to 87
               MPU_IQ_LOWER iq7_lower;
               u32 rsvd44[1];                     // DWORDS 89 to 89
               MPU_IQ_UPPER iq7_upper;
               u32 rsvd45[1];                     // DWORDS 91 to 91
               MPU_IQ_RDY iq_rdy;
               u32 rsvd46[1];                     // DWORDS 93 to 93
               MPU_IQ_EN_INT iq_en_int;
               u32 rsvd47[1];                     // DWORDS 95 to 95
               u32 rsvd48[32];                    // DWORDS 96 to 127
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK MPU_LOCAL_IF_REGMAP, *PMPU_LOCAL_IF_REGMAP;

      SG_C_ASSERT(__sizeof__MPU_LOCAL_IF_REGMAP, sizeof (MPU_LOCAL_IF_REGMAP) == 512);

   #else
      typedef struct _MPU_LOCAL_IF_REGMAP {
         MPU_RR_ADDR_REG rr_addr;
         u32 rsvd0[1];                            // DWORDS 1 to 1
         MPU_RR_DATA_REG rr_data;
         u32 rsvd1[1];                            // DWORDS 3 to 3
         MPU_RR_CTRL_REG rr_ctrl;
         u32 rsvd2[1];                            // DWORDS 5 to 5
         MPU_INT_MASK0_REG int_mask0;
         u32 rsvd3[1];                            // DWORDS 7 to 7
         MPU_INT_MASK1_REG int_mask1;
         u32 rsvd4[1];                            // DWORDS 9 to 9
         MPU_INT_SRC0_REG int_src0;
         u32 rsvd5[1];                            // DWORDS 11 to 11
         MPU_INT_SRC1_REG int_src1;
         u32 rsvd6[1];                            // DWORDS 13 to 13
         MPU_INT_ACK_REG int_ack;
         u32 rsvd7[1];                            // DWORDS 15 to 15
         u32 rsvd8[1];                            // DWORDS 16 to 16
         MPU_UID0_REG uid0;
         MPU_UID1_REG uid1;
         u32 rsvd9[1];                            // DWORDS 19 to 19
         MPU_BOOT_CTRL_REG boot_ctrl;
         u32 rsvd10[1];                           // DWORDS 21 to 21
         MPU_BOOT_STATUS_REG boot_status;
         u32 rsvd11[1];                           // DWORDS 23 to 23
         MPU_TIMESTAMP_RST_REG timestamp_rst;
         u32 rsvd12[1];                           // DWORDS 25 to 25
         MPU_TIMESTAMP_HOLD_10MS_REG timestamp_hold_10ms;
         u32 rsvd13[1];                           // DWORDS 27 to 27
         MPU_MBOXRANG_REG mboxrang0;
         u32 rsvd14[1];                           // DWORDS 29 to 29
         MPU_MBOXRANG_REG mboxrang1;
         u32 rsvd15[1];                           // DWORDS 31 to 31
         MPU_MBOXRANG_REG mboxrang2;
         u32 rsvd16[1];                           // DWORDS 33 to 33
         MPU_MBOXRANG_REG mboxrang3;
         u32 rsvd17[1];                           // DWORDS 35 to 35
         MPU_MBOXRANG_REG mboxrang4;
         u32 rsvd18[1];                           // DWORDS 37 to 37
         MPU_MBOXRANG_REG mboxrang5;
         u32 rsvd19[1];                           // DWORDS 39 to 39
         MPU_MBOXRANG_REG mboxrang6;
         u32 rsvd20[1];                           // DWORDS 41 to 41
         MPU_MBOXRANG_REG mboxrang7;
         u32 rsvd21[1];                           // DWORDS 43 to 43
         MPU_MAILBOX_EN_REG mailbox_en0;
         u32 rsvd22[1];                           // DWORDS 45 to 45
         MPU_MAILBOX_EN_REG mailbox_en1;
         u32 rsvd23[1];                           // DWORDS 47 to 47
         MPU_MAILBOX_EN_REG mailbox_en2;
         u32 rsvd24[1];                           // DWORDS 49 to 49
         MPU_MAILBOX_EN_REG mailbox_en3;
         u32 rsvd25[1];                           // DWORDS 51 to 51
         MPU_MAILBOX_EN_REG mailbox_en4;
         u32 rsvd26[1];                           // DWORDS 53 to 53
         MPU_MAILBOX_EN_REG mailbox_en5;
         u32 rsvd27[1];                           // DWORDS 55 to 55
         MPU_MAILBOX_EN_REG mailbox_en6;
         u32 rsvd28[1];                           // DWORDS 57 to 57
         MPU_MAILBOX_EN_REG mailbox_en7;
         u32 rsvd29[1];                           // DWORDS 59 to 59
         MPU_IQ_LOWER iq0_lower;
         u32 rsvd30[1];                           // DWORDS 61 to 61
         MPU_IQ_UPPER iq0_upper;
         u32 rsvd31[1];                           // DWORDS 63 to 63
         MPU_IQ_LOWER iq1_lower;
         u32 rsvd32[1];                           // DWORDS 65 to 65
         MPU_IQ_UPPER iq1_upper;
         u32 rsvd33[1];                           // DWORDS 67 to 67
         MPU_IQ_LOWER iq2_lower;
         u32 rsvd34[1];                           // DWORDS 69 to 69
         MPU_IQ_UPPER iq2_upper;
         u32 rsvd35[1];                           // DWORDS 71 to 71
         MPU_IQ_LOWER iq3_lower;
         u32 rsvd36[1];                           // DWORDS 73 to 73
         MPU_IQ_UPPER iq3_upper;
         u32 rsvd37[1];                           // DWORDS 75 to 75
         MPU_IQ_LOWER iq4_lower;
         u32 rsvd38[1];                           // DWORDS 77 to 77
         MPU_IQ_UPPER iq4_upper;
         u32 rsvd39[1];                           // DWORDS 79 to 79
         MPU_IQ_LOWER iq5_lower;
         u32 rsvd40[1];                           // DWORDS 81 to 81
         MPU_IQ_UPPER iq5_upper;
         u32 rsvd41[1];                           // DWORDS 83 to 83
         MPU_IQ_LOWER iq6_lower;
         u32 rsvd42[1];                           // DWORDS 85 to 85
         MPU_IQ_UPPER iq6_upper;
         u32 rsvd43[1];                           // DWORDS 87 to 87
         MPU_IQ_LOWER iq7_lower;
         u32 rsvd44[1];                           // DWORDS 89 to 89
         MPU_IQ_UPPER iq7_upper;
         u32 rsvd45[1];                           // DWORDS 91 to 91
         MPU_IQ_RDY iq_rdy;
         u32 rsvd46[1];                           // DWORDS 93 to 93
         MPU_IQ_EN_INT iq_en_int;
         u32 rsvd47[1];                           // DWORDS 95 to 95
         u32 rsvd48[32];                          // DWORDS 96 to 127
      } SG_PACK MPU_LOCAL_IF_REGMAP, *PMPU_LOCAL_IF_REGMAP;

      typedef union _MPU_LOCAL_IF_REGMAP_UNION {
         MPU_LOCAL_IF_REGMAP bits;
         u32 dw[128]; // dword union
      } SG_PACK MPU_LOCAL_IF_REGMAP_UNION, *PMPU_LOCAL_IF_REGMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_LOCAL_IF_REGMAP_UNION, sizeof (MPU_LOCAL_IF_REGMAP_UNION) == 512);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_local_mmr_bmap_h__

