/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __post_codes_bmap_h__
#define __post_codes_bmap_h__
#include "setypes.h"
#include "nativedefs_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // This structure defines the format of the MPU semaphore register when used for POST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_HBA_POST_STATUS_STRUCT {
         union {
            struct { 
               u32 error : 1;                     // DWORD 0
               u32 backup_fw : 1;                 // DWORD 0
               u32 iscsi_no_ip : 1;               // DWORD 0
               u32 iscsi_ip_conflict : 1;         // DWORD 0
               u32 option_rom_installed : 1;      // DWORD 0
               u32 iscsi_driver_loaded : 1;       // DWORD 0
               u32 nic_driver_loaded : 1;         // DWORD 0
               u32 pxe_option_rom_flags : 2;      // DWORD 0
               u32 flash_semaphore_status : 1;    // DWORD 0
               u32 flash_semaphore_request : 1;   // DWORD 0
               u32 p1_linkup : 1;                 // DWORD 0
               u32 p0_linkup : 1;                 // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 stage : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT, *PMGMT_HBA_POST_STATUS_STRUCT;

      SG_C_ASSERT(__sizeof__MGMT_HBA_POST_STATUS_STRUCT, sizeof (MGMT_HBA_POST_STATUS_STRUCT) == 4);

   #else
      typedef struct _MGMT_HBA_POST_STATUS_STRUCT {
         u32 error : 1;                           // DWORD 0
         u32 backup_fw : 1;                       // DWORD 0
         u32 iscsi_no_ip : 1;                     // DWORD 0
         u32 iscsi_ip_conflict : 1;               // DWORD 0
         u32 option_rom_installed : 1;            // DWORD 0
         u32 iscsi_driver_loaded : 1;             // DWORD 0
         u32 nic_driver_loaded : 1;               // DWORD 0
         u32 pxe_option_rom_flags : 2;            // DWORD 0
         u32 flash_semaphore_status : 1;          // DWORD 0
         u32 flash_semaphore_request : 1;         // DWORD 0
         u32 p1_linkup : 1;                       // DWORD 0
         u32 p0_linkup : 1;                       // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 stage : 16;                          // DWORD 0
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT, *PMGMT_HBA_POST_STATUS_STRUCT;

      typedef union _MGMT_HBA_POST_STATUS_STRUCT_UNION {
         MGMT_HBA_POST_STATUS_STRUCT bits;
         u32 dw; // dword union
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT_UNION, *PMGMT_HBA_POST_STATUS_STRUCT_UNION;

      SG_C_ASSERT(__sizeof__MGMT_HBA_POST_STATUS_STRUCT_UNION, sizeof (MGMT_HBA_POST_STATUS_STRUCT_UNION) == 4);
   #endif


#else
   // This structure defines the format of the MPU semaphore register when used for POST. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MGMT_HBA_POST_STATUS_STRUCT {
         union {
            struct { 
               u32 stage : 16;                    // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 p0_linkup : 1;                 // DWORD 0
               u32 p1_linkup : 1;                 // DWORD 0
               u32 flash_semaphore_request : 1;   // DWORD 0
               u32 flash_semaphore_status : 1;    // DWORD 0
               u32 pxe_option_rom_flags : 2;      // DWORD 0
               u32 nic_driver_loaded : 1;         // DWORD 0
               u32 iscsi_driver_loaded : 1;       // DWORD 0
               u32 option_rom_installed : 1;      // DWORD 0
               u32 iscsi_ip_conflict : 1;         // DWORD 0
               u32 iscsi_no_ip : 1;               // DWORD 0
               u32 backup_fw : 1;                 // DWORD 0
               u32 error : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT, *PMGMT_HBA_POST_STATUS_STRUCT;

      SG_C_ASSERT(__sizeof__MGMT_HBA_POST_STATUS_STRUCT, sizeof (MGMT_HBA_POST_STATUS_STRUCT) == 4);

   #else
      typedef struct _MGMT_HBA_POST_STATUS_STRUCT {
         u32 stage : 16;                          // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 p0_linkup : 1;                       // DWORD 0
         u32 p1_linkup : 1;                       // DWORD 0
         u32 flash_semaphore_request : 1;         // DWORD 0
         u32 flash_semaphore_status : 1;          // DWORD 0
         u32 pxe_option_rom_flags : 2;            // DWORD 0
         u32 nic_driver_loaded : 1;               // DWORD 0
         u32 iscsi_driver_loaded : 1;             // DWORD 0
         u32 option_rom_installed : 1;            // DWORD 0
         u32 iscsi_ip_conflict : 1;               // DWORD 0
         u32 iscsi_no_ip : 1;                     // DWORD 0
         u32 backup_fw : 1;                       // DWORD 0
         u32 error : 1;                           // DWORD 0
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT, *PMGMT_HBA_POST_STATUS_STRUCT;

      typedef union _MGMT_HBA_POST_STATUS_STRUCT_UNION {
         MGMT_HBA_POST_STATUS_STRUCT bits;
         u32 dw; // dword union
      } SG_PACK MGMT_HBA_POST_STATUS_STRUCT_UNION, *PMGMT_HBA_POST_STATUS_STRUCT_UNION;

      SG_C_ASSERT(__sizeof__MGMT_HBA_POST_STATUS_STRUCT_UNION, sizeof (MGMT_HBA_POST_STATUS_STRUCT_UNION) == 4);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __post_codes_bmap_h__

