/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __regmap_bmap_h__
#define __regmap_bmap_h__
#include "setypes.h"
#include "pcicfg_bmap.h"
#include "pq_bmap.h"
#include "jellm_bmap.h"
#include "ep_bmap.h"
#include "btlr_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "d2p_bmap.h"
#include "ep_minirom_bmap.h"
#include "gencommon_bmap.h"
#include "ctx_bmap.h"
#include "cev_bmap.h"
#include "ptc_bmap.h"
#include "uc_bmap.h"
#include "rxf_bmap.h"
#include "erx_bmap.h"
#include "lpc_bmap.h"
#include "mpu_bmap.h"
#include "tpost_bmap.h"
#include "rxulp_bmap.h"
#include "txulp_bmap.h"
#include "tpre_bmap.h"
#include "txpb_bmap.h"
#include "txp_bmap.h"
#include "wdma_bmap.h"
#include "rdma_bmap.h"
#include "ndma_bmap.h"
#include "dbuf_bmap.h"
#include "pmem_bmap.h"
#include "wcon_bmap.h"
#include "doorbells_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#ifdef SG_OMIT_64KB_STRUCTS
   typedef struct _BLADE_ENGINE_CSRMAP {
      u32 rsvd; // Dummy member for >=64kB struct
   } SG_PACK BLADE_ENGINE_CSRMAP, *PBLADE_ENGINE_CSRMAP;
#else
   #if defined(SG_REVERSE_ENDIAN)
      // This is the control and status register map for BladeEngine, showing the relative
      // size and offset of each sub-module. The CSR registers are identical for the
      // network and storage PCI functions. The CSR map is shown below, followed by
      // details of each block, in sub-sections. The sub-sections begin with a description
      // of CSRs that are instantiated in multiple blocks.
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_CSRMAP {
            union {
               struct { 
                  MPU_CSRMAP mpu;
                  TPOST_CSRMAP tpost;
                  TPRE_CSRMAP tpre;
                  CEV_CSRMAP cev;
                  RXULP_CSRMAP rxulp0;
                  RXULP_CSRMAP rxulp1;
                  WCON_CSRMAP wcon;
                  TXULP_CSRMAP txulp0;
                  TXULP_CSRMAP txulp1;
                  UC_CSRMAP uc;
                  PTC_CSRMAP ptc;
                  TXP_CSRMAP txp;
                  NDMA_CSRMAP ndma;
                  RDMA_CSRMAP rdma;
                  WDMA_CSRMAP wdma;
                  TXPB_CSRMAP txpb;
                  CTX_CSRMAP ctx;
                  DBUF_CSRMAP dbuf;
                  PMEM_CSRMAP pmem;
                  u32 rsvd0[256];                 // DWORDS 4864 to 5119
                  RXF_CSRMAP rxf;
                  ERX_CSRMAP erx;
                  u32 rsvd1[17920];               // DWORDS 5632 to 23551
               } SG_PACK ; // unnamed struct
               u32 dw[23552]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_CSRMAP, *PBLADE_ENGINE_CSRMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_CSRMAP, sizeof (BLADE_ENGINE_CSRMAP) == 94208);

      #else
         typedef struct _BLADE_ENGINE_CSRMAP {
            MPU_CSRMAP mpu;
            TPOST_CSRMAP tpost;
            TPRE_CSRMAP tpre;
            CEV_CSRMAP cev;
            RXULP_CSRMAP rxulp0;
            RXULP_CSRMAP rxulp1;
            WCON_CSRMAP wcon;
            TXULP_CSRMAP txulp0;
            TXULP_CSRMAP txulp1;
            UC_CSRMAP uc;
            PTC_CSRMAP ptc;
            TXP_CSRMAP txp;
            NDMA_CSRMAP ndma;
            RDMA_CSRMAP rdma;
            WDMA_CSRMAP wdma;
            TXPB_CSRMAP txpb;
            CTX_CSRMAP ctx;
            DBUF_CSRMAP dbuf;
            PMEM_CSRMAP pmem;
            u32 rsvd0[256];                       // DWORDS 4864 to 5119
            RXF_CSRMAP rxf;
            ERX_CSRMAP erx;
            u32 rsvd1[17920];                     // DWORDS 5632 to 23551
         } SG_PACK BLADE_ENGINE_CSRMAP, *PBLADE_ENGINE_CSRMAP;

         typedef union _BLADE_ENGINE_CSRMAP_UNION {
            BLADE_ENGINE_CSRMAP bits;
            u32 dw[23552]; // dword union
         } SG_PACK BLADE_ENGINE_CSRMAP_UNION, *PBLADE_ENGINE_CSRMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_CSRMAP_UNION, sizeof (BLADE_ENGINE_CSRMAP_UNION) == 94208);
      #endif


   #else
      // This is the control and status register map for BladeEngine, showing the relative
      // size and offset of each sub-module. The CSR registers are identical for the
      // network and storage PCI functions. The CSR map is shown below, followed by
      // details of each block, in sub-sections. The sub-sections begin with a description
      // of CSRs that are instantiated in multiple blocks.
      #if defined(SG_BMAP_UNION)
         typedef struct _BLADE_ENGINE_CSRMAP {
            union {
               struct { 
                  MPU_CSRMAP mpu;
                  TPOST_CSRMAP tpost;
                  TPRE_CSRMAP tpre;
                  CEV_CSRMAP cev;
                  RXULP_CSRMAP rxulp0;
                  RXULP_CSRMAP rxulp1;
                  WCON_CSRMAP wcon;
                  TXULP_CSRMAP txulp0;
                  TXULP_CSRMAP txulp1;
                  UC_CSRMAP uc;
                  PTC_CSRMAP ptc;
                  TXP_CSRMAP txp;
                  NDMA_CSRMAP ndma;
                  RDMA_CSRMAP rdma;
                  WDMA_CSRMAP wdma;
                  TXPB_CSRMAP txpb;
                  CTX_CSRMAP ctx;
                  DBUF_CSRMAP dbuf;
                  PMEM_CSRMAP pmem;
                  u32 rsvd0[256];                 // DWORDS 4864 to 5119
                  RXF_CSRMAP rxf;
                  ERX_CSRMAP erx;
                  u32 rsvd1[17920];               // DWORDS 5632 to 23551
               } SG_PACK ; // unnamed struct
               u32 dw[23552]; // dword union
            }; // unnamed union
         } SG_PACK BLADE_ENGINE_CSRMAP, *PBLADE_ENGINE_CSRMAP;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_CSRMAP, sizeof (BLADE_ENGINE_CSRMAP) == 94208);

      #else
         typedef struct _BLADE_ENGINE_CSRMAP {
            MPU_CSRMAP mpu;
            TPOST_CSRMAP tpost;
            TPRE_CSRMAP tpre;
            CEV_CSRMAP cev;
            RXULP_CSRMAP rxulp0;
            RXULP_CSRMAP rxulp1;
            WCON_CSRMAP wcon;
            TXULP_CSRMAP txulp0;
            TXULP_CSRMAP txulp1;
            UC_CSRMAP uc;
            PTC_CSRMAP ptc;
            TXP_CSRMAP txp;
            NDMA_CSRMAP ndma;
            RDMA_CSRMAP rdma;
            WDMA_CSRMAP wdma;
            TXPB_CSRMAP txpb;
            CTX_CSRMAP ctx;
            DBUF_CSRMAP dbuf;
            PMEM_CSRMAP pmem;
            u32 rsvd0[256];                       // DWORDS 4864 to 5119
            RXF_CSRMAP rxf;
            ERX_CSRMAP erx;
            u32 rsvd1[17920];                     // DWORDS 5632 to 23551
         } SG_PACK BLADE_ENGINE_CSRMAP, *PBLADE_ENGINE_CSRMAP;

         typedef union _BLADE_ENGINE_CSRMAP_UNION {
            BLADE_ENGINE_CSRMAP bits;
            u32 dw[23552]; // dword union
         } SG_PACK BLADE_ENGINE_CSRMAP_UNION, *PBLADE_ENGINE_CSRMAP_UNION;

         SG_C_ASSERT(__sizeof__BLADE_ENGINE_CSRMAP_UNION, sizeof (BLADE_ENGINE_CSRMAP_UNION) == 94208);
      #endif


   #endif
#endif // SG_OMIT_64KB_STRUCTS

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __regmap_bmap_h__

