/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __seeprom_bmap_h__
#define __seeprom_bmap_h__
#include "setypes.h"
#include "ioctl_types_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _FLASH_ROM_INFO {
      UEXACT8 manuf_code;
      UEXACT8 device_code;
      UEXACT8 id[3];
      UEXACT8 device_size;
      UEXACT8 device_interface[2];
      UEXACT8 buffer_size[2];
      UEXACT8 is_block_oriented;
      UEXACT8 num_regions[2];
      UEXACT8 region_size[2];
   } SG_PACK FLASH_ROM_INFO, *PFLASH_ROM_INFO;



#else
   
   typedef struct _FLASH_ROM_INFO {
      UEXACT8 manuf_code;
      UEXACT8 device_code;
      UEXACT8 id[3];
      UEXACT8 device_size;
      UEXACT8 device_interface[2];
      UEXACT8 buffer_size[2];
      UEXACT8 is_block_oriented;
      UEXACT8 num_regions[2];
      UEXACT8 region_size[2];
   } SG_PACK FLASH_ROM_INFO, *PFLASH_ROM_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _SEEPROM_DATA {
      UEXACT32 jmp_addr_for_D3_ISM;
      UEXACT32 jmp_addr_for_D0_ISM;
      UEXACT8 seeprom_version[2];
      UEXACT16 supported_modes;
      UEXACT16 max_iscsi_sessions;
      UEXACT8 icds_config;
      UEXACT8 net_queues;
      UEXACT8 starting_MAC_address[6];
      UEXACT8 MAC_addresses_allocated;
      UEXACT8 max_domains_supported;
      UEXACT8 mgmt_MAC_address[6];
      UEXACT8 VLAN_mode;
      UEXACT8 verify_mtu;
      UEXACT32 mtu_port[2];
      UEXACT8 IPv6_enabled;
      UEXACT8 interface_10Gb_type;
      UEXACT8 PHY_type;
      UEXACT8 CLP_support;
      UEXACT16 function_mode_mapping[8];
      UEXACT8 function_mac_addr_assignment[8];
      UEXACT8 function_port_mapping;
      UEXACT8 swap_be_hba_port;
      UEXACT8 port_name[2];
      UEXACT8 ipl_file_version;
      UEXACT8 function_boot_mapping;
      UEXACT16 FCoE_MAC_addresses_allocated;
      UEXACT8 function_reported_port[8];
      UEXACT16 pf_default_bandwidth[8];
      UEXACT8 emulex_serial_number[12];
      UEXACT8 oem_serial_number[24];
      UEXACT32 oem_personality_mgmt;
      UEXACT16 supported_sw_version;
      UEXACT16 board_id;
      UEXACT8 elx_rsvd[95];
      UEXACT8 current_personality;
      UEXACT8 function_iscsi_session_count[8];
      UEXACT8 more_rsvd[4];
      UEXACT8 flash_ROM_type;
      UEXACT8 flash_ROM_size;
      UEXACT8 flash_cfi_data_manuf_code;
      UEXACT8 flash_cfi_data_device_code;
      UEXACT8 flash_cfi_data_id[3];
      UEXACT8 flash_cfi_data_device_size;
      UEXACT8 flash_cfi_data_device_interface[2];
      UEXACT8 flash_cfi_data_buffer_size[2];
      UEXACT8 flash_cfi_data_is_block_oriented;
      UEXACT8 flash_cfi_data_num_regions[2];
      UEXACT8 flash_cfi_data_region_size[2];
      UEXACT8 DDR_type;
      UEXACT8 DDR_size;
      UEXACT8 DDR_mode;
      UEXACT8 manuf_code_1;
      UEXACT8 manuf_code_2;
      UEXACT8 wol_capability;
      UEXACT8 rsvd0[39];
      UEXACT8 arm_internal1[4];
      UEXACT8 sig1;
      UEXACT8 sig2;
      UEXACT8 rsvd1[2];
      UEXACT8 sig3;
      UEXACT8 sig4;
      UEXACT32 emph_lev_sel_port0;
      UEXACT32 emph_lev_sel_port1;
      UEXACT8 xaui_vo_sel;
      UEXACT8 xaui_state;
      UEXACT16 xaui_magic;
      UEXACT32 xaui_eq_vector;
      UEXACT32 xaui_serdes_info[4];
      UEXACT8 pad[152];
      UEXACT32 digest;
      UEXACT8 ism_code[480];
      UEXACT8 feature_word[6];
      UEXACT8 feature_word_hash[6];
      UEXACT8 lic_key_rev;
      UEXACT8 lic_arm_internal;
      u32 rsvd2 : 16;                             // DWORD 251
      u32 rsvd2_array[4];                         // DWORDS 252 to 255
   } SG_PACK SEEPROM_DATA, *PSEEPROM_DATA;



#else
   
   typedef struct _SEEPROM_DATA {
      UEXACT32 jmp_addr_for_D3_ISM;
      UEXACT32 jmp_addr_for_D0_ISM;
      UEXACT8 seeprom_version[2];
      UEXACT16 supported_modes;
      UEXACT16 max_iscsi_sessions;
      UEXACT8 icds_config;
      UEXACT8 net_queues;
      UEXACT8 starting_MAC_address[6];
      UEXACT8 MAC_addresses_allocated;
      UEXACT8 max_domains_supported;
      UEXACT8 mgmt_MAC_address[6];
      UEXACT8 VLAN_mode;
      UEXACT8 verify_mtu;
      UEXACT32 mtu_port[2];
      UEXACT8 IPv6_enabled;
      UEXACT8 interface_10Gb_type;
      UEXACT8 PHY_type;
      UEXACT8 CLP_support;
      UEXACT16 function_mode_mapping[8];
      UEXACT8 function_mac_addr_assignment[8];
      UEXACT8 function_port_mapping;
      UEXACT8 swap_be_hba_port;
      UEXACT8 port_name[2];
      UEXACT8 ipl_file_version;
      UEXACT8 function_boot_mapping;
      UEXACT16 FCoE_MAC_addresses_allocated;
      UEXACT8 function_reported_port[8];
      UEXACT16 pf_default_bandwidth[8];
      UEXACT8 emulex_serial_number[12];
      UEXACT8 oem_serial_number[24];
      UEXACT32 oem_personality_mgmt;
      UEXACT16 supported_sw_version;
      UEXACT16 board_id;
      UEXACT8 elx_rsvd[95];
      UEXACT8 current_personality;
      UEXACT8 function_iscsi_session_count[8];
      UEXACT8 more_rsvd[4];
      UEXACT8 flash_ROM_type;
      UEXACT8 flash_ROM_size;
      UEXACT8 flash_cfi_data_manuf_code;
      UEXACT8 flash_cfi_data_device_code;
      UEXACT8 flash_cfi_data_id[3];
      UEXACT8 flash_cfi_data_device_size;
      UEXACT8 flash_cfi_data_device_interface[2];
      UEXACT8 flash_cfi_data_buffer_size[2];
      UEXACT8 flash_cfi_data_is_block_oriented;
      UEXACT8 flash_cfi_data_num_regions[2];
      UEXACT8 flash_cfi_data_region_size[2];
      UEXACT8 DDR_type;
      UEXACT8 DDR_size;
      UEXACT8 DDR_mode;
      UEXACT8 manuf_code_1;
      UEXACT8 manuf_code_2;
      UEXACT8 wol_capability;
      UEXACT8 rsvd0[39];
      UEXACT8 arm_internal1[4];
      UEXACT8 sig1;
      UEXACT8 sig2;
      UEXACT8 rsvd1[2];
      UEXACT8 sig3;
      UEXACT8 sig4;
      UEXACT32 emph_lev_sel_port0;
      UEXACT32 emph_lev_sel_port1;
      UEXACT8 xaui_vo_sel;
      UEXACT8 xaui_state;
      UEXACT16 xaui_magic;
      UEXACT32 xaui_eq_vector;
      UEXACT32 xaui_serdes_info[4];
      UEXACT8 pad[152];
      UEXACT32 digest;
      UEXACT8 ism_code[480];
      UEXACT8 feature_word[6];
      UEXACT8 feature_word_hash[6];
      UEXACT8 lic_key_rev;
      UEXACT8 lic_arm_internal;
      u32 rsvd2 : 16;                             // DWORD 251
      u32 rsvd2_array[4];                         // DWORDS 252 to 255
   } SG_PACK SEEPROM_DATA, *PSEEPROM_DATA;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __seeprom_bmap_h__

