/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __toe_context_bmap_h__
#define __toe_context_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "descriptors_bmap.h"
#include "ulp_context_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // TOE connection context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_CONTEXT {
         union {
            struct { 
               u32 sws_avoid : 1;                 // DWORD 0
               u32 tx_delegated : 1;              // DWORD 0
               u32 toetx_opaque : 8;              // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 use_repeat_wrb : 1;            // DWORD 0
               u32 del_state_not_vld : 1;         // DWORD 0
               u32 tx_cidx : 14;                  // DWORD 0
               u32 ctx_valid : 1;                 // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pidx : 14;                     // DWORD 1
               u32 excess_qos : 1;                // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 rsvd1 : 2;                     // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 disable_sws : 1;               // DWORD 2
               u32 disable_repeat_wrb : 1;        // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 default_ring_rid : 3;          // DWORD 2
               u32 cq_id_send : 10;               // DWORD 2
               u32 sws_timestamp : 16;            // DWORD 3
               u32 t_maxseg : 16;                 // DWORD 3
               u32 window_bleed_bytes;            // DWORD 4
               u32 data_bytes_posted;             // DWORD 5
               u32 rx_preposted_sequence;         // DWORD 6
               u32 saved_preposted_cidx : 9;      // DWORD 7
               u32 last_sgl : 1;                  // DWORD 7
               u32 consumed_preposted_window : 1; // DWORD 7
               u32 preposted_push_mode : 1;       // DWORD 7
               u32 remaining_sgl_bytes : 20;      // DWORD 7
               u32 consume_preposted_bytes : 1;   // DWORD 8
               u32 schedule_ack : 1;              // DWORD 8
               u32 fence_next_wcon_d : 1;         // DWORD 8
               u32 tpred_vqueue_disarmed : 1;     // DWORD 8
               u32 scheduler_grant_held : 1;      // DWORD 8
               u32 rx_flush_done : 1;             // DWORD 8
               u32 fin_preposted_sgl : 1;         // DWORD 8
               u32 push_preposted_sgl : 1;        // DWORD 8
               u32 current_state : 2;             // DWORD 8
               u32 previous_state : 2;            // DWORD 8
               u32 saved_preposted_offset : 20;   // DWORD 8
               u32 ooo_hole_count : 2;            // DWORD 9
               u32 cq_id_def : 10;                // DWORD 9
               u32 preposted_dma_bytes : 20;      // DWORD 9
               u32 skip_preposted_sgl_group : 1;  // DWORD 10
               u32 fin_indicated : 1;             // DWORD 10
               u32 default_buff_offset : 14;      // DWORD 10
               u32 tx_flush_done : 1;             // DWORD 10
               u32 stake_valid : 1;               // DWORD 10
               u32 stake_index : 14;              // DWORD 10
               u32 stake_sequence;                // DWORD 11
               u32 default_buff_size : 2;         // DWORD 12
               u32 cq_id_recv : 10;               // DWORD 12
               u32 rx_ring_size : 4;              // DWORD 12
               u32 default_mode : 2;              // DWORD 12
               u32 preposted_cidx : 14;           // DWORD 12
               u32 rx_pdid_valid : 1;             // DWORD 13
               u32 rx_pdid : 9;                   // DWORD 13
               u32 rx_pci_func : 8;               // DWORD 13
               u32 preposted_pidx : 14;           // DWORD 13
               u32 last_tx_len : 16;              // DWORD 14
               u32 tx_buf_offset : 16;            // DWORD 14
               u32 cur_seq;                       // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TOE_CONTEXT, *PTOE_CONTEXT;

      SG_C_ASSERT(__sizeof__TOE_CONTEXT, sizeof (TOE_CONTEXT) == 64);

   #else
      typedef struct _TOE_CONTEXT {
         u32 sws_avoid : 1;                       // DWORD 0
         u32 tx_delegated : 1;                    // DWORD 0
         u32 toetx_opaque : 8;                    // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 use_repeat_wrb : 1;                  // DWORD 0
         u32 del_state_not_vld : 1;               // DWORD 0
         u32 tx_cidx : 14;                        // DWORD 0
         u32 ctx_valid : 1;                       // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pidx : 14;                           // DWORD 1
         u32 excess_qos : 1;                      // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 rsvd1 : 2;                           // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 disable_sws : 1;                     // DWORD 2
         u32 disable_repeat_wrb : 1;              // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 default_ring_rid : 3;                // DWORD 2
         u32 cq_id_send : 10;                     // DWORD 2
         u32 sws_timestamp : 16;                  // DWORD 3
         u32 t_maxseg : 16;                       // DWORD 3
         u32 window_bleed_bytes;                  // DWORD 4
         u32 data_bytes_posted;                   // DWORD 5
         u32 rx_preposted_sequence;               // DWORD 6
         u32 saved_preposted_cidx : 9;            // DWORD 7
         u32 last_sgl : 1;                        // DWORD 7
         u32 consumed_preposted_window : 1;       // DWORD 7
         u32 preposted_push_mode : 1;             // DWORD 7
         u32 remaining_sgl_bytes : 20;            // DWORD 7
         u32 consume_preposted_bytes : 1;         // DWORD 8
         u32 schedule_ack : 1;                    // DWORD 8
         u32 fence_next_wcon_d : 1;               // DWORD 8
         u32 tpred_vqueue_disarmed : 1;           // DWORD 8
         u32 scheduler_grant_held : 1;            // DWORD 8
         u32 rx_flush_done : 1;                   // DWORD 8
         u32 fin_preposted_sgl : 1;               // DWORD 8
         u32 push_preposted_sgl : 1;              // DWORD 8
         u32 current_state : 2;                   // DWORD 8
         u32 previous_state : 2;                  // DWORD 8
         u32 saved_preposted_offset : 20;         // DWORD 8
         u32 ooo_hole_count : 2;                  // DWORD 9
         u32 cq_id_def : 10;                      // DWORD 9
         u32 preposted_dma_bytes : 20;            // DWORD 9
         u32 skip_preposted_sgl_group : 1;        // DWORD 10
         u32 fin_indicated : 1;                   // DWORD 10
         u32 default_buff_offset : 14;            // DWORD 10
         u32 tx_flush_done : 1;                   // DWORD 10
         u32 stake_valid : 1;                     // DWORD 10
         u32 stake_index : 14;                    // DWORD 10
         u32 stake_sequence;                      // DWORD 11
         u32 default_buff_size : 2;               // DWORD 12
         u32 cq_id_recv : 10;                     // DWORD 12
         u32 rx_ring_size : 4;                    // DWORD 12
         u32 default_mode : 2;                    // DWORD 12
         u32 preposted_cidx : 14;                 // DWORD 12
         u32 rx_pdid_valid : 1;                   // DWORD 13
         u32 rx_pdid : 9;                         // DWORD 13
         u32 rx_pci_func : 8;                     // DWORD 13
         u32 preposted_pidx : 14;                 // DWORD 13
         u32 last_tx_len : 16;                    // DWORD 14
         u32 tx_buf_offset : 16;                  // DWORD 14
         u32 cur_seq;                             // DWORD 15
      } SG_PACK TOE_CONTEXT, *PTOE_CONTEXT;

      typedef union _TOE_CONTEXT_UNION {
         TOE_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK TOE_CONTEXT_UNION, *PTOE_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__TOE_CONTEXT_UNION, sizeof (TOE_CONTEXT_UNION) == 64);
   #endif


#else
   // TOE connection context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_CONTEXT {
         union {
            struct { 
               u32 tx_cidx : 14;                  // DWORD 0
               u32 del_state_not_vld : 1;         // DWORD 0
               u32 use_repeat_wrb : 1;            // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 toetx_opaque : 8;              // DWORD 0
               u32 tx_delegated : 1;              // DWORD 0
               u32 sws_avoid : 1;                 // DWORD 0
               u32 pidx : 14;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 ctx_valid : 1;                 // DWORD 1
               u32 cq_id_send : 10;               // DWORD 2
               u32 default_ring_rid : 3;          // DWORD 2
               u32 rsvd0 : 1;                     // DWORD 2
               u32 disable_repeat_wrb : 1;        // DWORD 2
               u32 disable_sws : 1;               // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 rsvd1 : 2;                     // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 excess_qos : 1;                // DWORD 2
               u32 t_maxseg : 16;                 // DWORD 3
               u32 sws_timestamp : 16;            // DWORD 3
               u32 window_bleed_bytes;            // DWORD 4
               u32 data_bytes_posted;             // DWORD 5
               u32 rx_preposted_sequence;         // DWORD 6
               u32 remaining_sgl_bytes : 20;      // DWORD 7
               u32 preposted_push_mode : 1;       // DWORD 7
               u32 consumed_preposted_window : 1; // DWORD 7
               u32 last_sgl : 1;                  // DWORD 7
               u32 saved_preposted_cidx : 9;      // DWORD 7
               u32 saved_preposted_offset : 20;   // DWORD 8
               u32 previous_state : 2;            // DWORD 8
               u32 current_state : 2;             // DWORD 8
               u32 push_preposted_sgl : 1;        // DWORD 8
               u32 fin_preposted_sgl : 1;         // DWORD 8
               u32 rx_flush_done : 1;             // DWORD 8
               u32 scheduler_grant_held : 1;      // DWORD 8
               u32 tpred_vqueue_disarmed : 1;     // DWORD 8
               u32 fence_next_wcon_d : 1;         // DWORD 8
               u32 schedule_ack : 1;              // DWORD 8
               u32 consume_preposted_bytes : 1;   // DWORD 8
               u32 preposted_dma_bytes : 20;      // DWORD 9
               u32 cq_id_def : 10;                // DWORD 9
               u32 ooo_hole_count : 2;            // DWORD 9
               u32 stake_index : 14;              // DWORD 10
               u32 stake_valid : 1;               // DWORD 10
               u32 tx_flush_done : 1;             // DWORD 10
               u32 default_buff_offset : 14;      // DWORD 10
               u32 fin_indicated : 1;             // DWORD 10
               u32 skip_preposted_sgl_group : 1;  // DWORD 10
               u32 stake_sequence;                // DWORD 11
               u32 preposted_cidx : 14;           // DWORD 12
               u32 default_mode : 2;              // DWORD 12
               u32 rx_ring_size : 4;              // DWORD 12
               u32 cq_id_recv : 10;               // DWORD 12
               u32 default_buff_size : 2;         // DWORD 12
               u32 preposted_pidx : 14;           // DWORD 13
               u32 rx_pci_func : 8;               // DWORD 13
               u32 rx_pdid : 9;                   // DWORD 13
               u32 rx_pdid_valid : 1;             // DWORD 13
               u32 tx_buf_offset : 16;            // DWORD 14
               u32 last_tx_len : 16;              // DWORD 14
               u32 cur_seq;                       // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TOE_CONTEXT, *PTOE_CONTEXT;

      SG_C_ASSERT(__sizeof__TOE_CONTEXT, sizeof (TOE_CONTEXT) == 64);

   #else
      typedef struct _TOE_CONTEXT {
         u32 tx_cidx : 14;                        // DWORD 0
         u32 del_state_not_vld : 1;               // DWORD 0
         u32 use_repeat_wrb : 1;                  // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 toetx_opaque : 8;                    // DWORD 0
         u32 tx_delegated : 1;                    // DWORD 0
         u32 sws_avoid : 1;                       // DWORD 0
         u32 pidx : 14;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 ctx_valid : 1;                       // DWORD 1
         u32 cq_id_send : 10;                     // DWORD 2
         u32 default_ring_rid : 3;                // DWORD 2
         u32 rsvd0 : 1;                           // DWORD 2
         u32 disable_repeat_wrb : 1;              // DWORD 2
         u32 disable_sws : 1;                     // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 rsvd1 : 2;                           // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 excess_qos : 1;                      // DWORD 2
         u32 t_maxseg : 16;                       // DWORD 3
         u32 sws_timestamp : 16;                  // DWORD 3
         u32 window_bleed_bytes;                  // DWORD 4
         u32 data_bytes_posted;                   // DWORD 5
         u32 rx_preposted_sequence;               // DWORD 6
         u32 remaining_sgl_bytes : 20;            // DWORD 7
         u32 preposted_push_mode : 1;             // DWORD 7
         u32 consumed_preposted_window : 1;       // DWORD 7
         u32 last_sgl : 1;                        // DWORD 7
         u32 saved_preposted_cidx : 9;            // DWORD 7
         u32 saved_preposted_offset : 20;         // DWORD 8
         u32 previous_state : 2;                  // DWORD 8
         u32 current_state : 2;                   // DWORD 8
         u32 push_preposted_sgl : 1;              // DWORD 8
         u32 fin_preposted_sgl : 1;               // DWORD 8
         u32 rx_flush_done : 1;                   // DWORD 8
         u32 scheduler_grant_held : 1;            // DWORD 8
         u32 tpred_vqueue_disarmed : 1;           // DWORD 8
         u32 fence_next_wcon_d : 1;               // DWORD 8
         u32 schedule_ack : 1;                    // DWORD 8
         u32 consume_preposted_bytes : 1;         // DWORD 8
         u32 preposted_dma_bytes : 20;            // DWORD 9
         u32 cq_id_def : 10;                      // DWORD 9
         u32 ooo_hole_count : 2;                  // DWORD 9
         u32 stake_index : 14;                    // DWORD 10
         u32 stake_valid : 1;                     // DWORD 10
         u32 tx_flush_done : 1;                   // DWORD 10
         u32 default_buff_offset : 14;            // DWORD 10
         u32 fin_indicated : 1;                   // DWORD 10
         u32 skip_preposted_sgl_group : 1;        // DWORD 10
         u32 stake_sequence;                      // DWORD 11
         u32 preposted_cidx : 14;                 // DWORD 12
         u32 default_mode : 2;                    // DWORD 12
         u32 rx_ring_size : 4;                    // DWORD 12
         u32 cq_id_recv : 10;                     // DWORD 12
         u32 default_buff_size : 2;               // DWORD 12
         u32 preposted_pidx : 14;                 // DWORD 13
         u32 rx_pci_func : 8;                     // DWORD 13
         u32 rx_pdid : 9;                         // DWORD 13
         u32 rx_pdid_valid : 1;                   // DWORD 13
         u32 tx_buf_offset : 16;                  // DWORD 14
         u32 last_tx_len : 16;                    // DWORD 14
         u32 cur_seq;                             // DWORD 15
      } SG_PACK TOE_CONTEXT, *PTOE_CONTEXT;

      typedef union _TOE_CONTEXT_UNION {
         TOE_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK TOE_CONTEXT_UNION, *PTOE_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__TOE_CONTEXT_UNION, sizeof (TOE_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_DEFAULT_BUFFER {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u32 rsvd4[1];                      // DWORDS 4 to 4
               u32 rsvd5[1];                      // DWORDS 5 to 5
               u32 rsvd6[1];                      // DWORDS 6 to 6
               u32 rsvd7[1];                      // DWORDS 7 to 7
               u32 rsvd8[1];                      // DWORDS 8 to 8
               u32 rsvd9[1];                      // DWORDS 9 to 9
               u32 rsvd10[1];                     // DWORDS 10 to 10
               u32 rsvd11[1];                     // DWORDS 11 to 11
               u32 flush_done : 1;                // DWORD 12
               u32 reserve_1_dbuffer : 1;         // DWORD 12
               u32 rsvd13 : 10;                   // DWORD 12
               u32 ring_size : 4;                 // DWORD 12
               u32 rsvd12 : 2;                    // DWORD 12
               u32 buff_cidx : 14;                // DWORD 12
               u32 pdid_valid : 1;                // DWORD 13
               u32 pdid : 9;                      // DWORD 13
               u32 pci_func : 8;                  // DWORD 13
               u32 buff_pidx : 14;                // DWORD 13
               u32 rsvd14[1];                     // DWORDS 14 to 14
               u32 rsvd15[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TOE_DEFAULT_BUFFER, *PTOE_DEFAULT_BUFFER;

      SG_C_ASSERT(__sizeof__TOE_DEFAULT_BUFFER, sizeof (TOE_DEFAULT_BUFFER) == 64);

   #else
      typedef struct _TOE_DEFAULT_BUFFER {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u32 rsvd4[1];                            // DWORDS 4 to 4
         u32 rsvd5[1];                            // DWORDS 5 to 5
         u32 rsvd6[1];                            // DWORDS 6 to 6
         u32 rsvd7[1];                            // DWORDS 7 to 7
         u32 rsvd8[1];                            // DWORDS 8 to 8
         u32 rsvd9[1];                            // DWORDS 9 to 9
         u32 rsvd10[1];                           // DWORDS 10 to 10
         u32 rsvd11[1];                           // DWORDS 11 to 11
         u32 flush_done : 1;                      // DWORD 12
         u32 reserve_1_dbuffer : 1;               // DWORD 12
         u32 rsvd13 : 10;                         // DWORD 12
         u32 ring_size : 4;                       // DWORD 12
         u32 rsvd12 : 2;                          // DWORD 12
         u32 buff_cidx : 14;                      // DWORD 12
         u32 pdid_valid : 1;                      // DWORD 13
         u32 pdid : 9;                            // DWORD 13
         u32 pci_func : 8;                        // DWORD 13
         u32 buff_pidx : 14;                      // DWORD 13
         u32 rsvd14[1];                           // DWORDS 14 to 14
         u32 rsvd15[1];                           // DWORDS 15 to 15
      } SG_PACK TOE_DEFAULT_BUFFER, *PTOE_DEFAULT_BUFFER;

      typedef union _TOE_DEFAULT_BUFFER_UNION {
         TOE_DEFAULT_BUFFER bits;
         u32 dw[16]; // dword union
      } SG_PACK TOE_DEFAULT_BUFFER_UNION, *PTOE_DEFAULT_BUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_DEFAULT_BUFFER_UNION, sizeof (TOE_DEFAULT_BUFFER_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOE_DEFAULT_BUFFER {
         union {
            struct { 
               u32 rsvd0[1];                      // DWORDS 0 to 0
               u32 rsvd1[1];                      // DWORDS 1 to 1
               u32 rsvd2[1];                      // DWORDS 2 to 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u32 rsvd4[1];                      // DWORDS 4 to 4
               u32 rsvd5[1];                      // DWORDS 5 to 5
               u32 rsvd6[1];                      // DWORDS 6 to 6
               u32 rsvd7[1];                      // DWORDS 7 to 7
               u32 rsvd8[1];                      // DWORDS 8 to 8
               u32 rsvd9[1];                      // DWORDS 9 to 9
               u32 rsvd10[1];                     // DWORDS 10 to 10
               u32 rsvd11[1];                     // DWORDS 11 to 11
               u32 buff_cidx : 14;                // DWORD 12
               u32 rsvd12 : 2;                    // DWORD 12
               u32 ring_size : 4;                 // DWORD 12
               u32 rsvd13 : 10;                   // DWORD 12
               u32 reserve_1_dbuffer : 1;         // DWORD 12
               u32 flush_done : 1;                // DWORD 12
               u32 buff_pidx : 14;                // DWORD 13
               u32 pci_func : 8;                  // DWORD 13
               u32 pdid : 9;                      // DWORD 13
               u32 pdid_valid : 1;                // DWORD 13
               u32 rsvd14[1];                     // DWORDS 14 to 14
               u32 rsvd15[1];                     // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK TOE_DEFAULT_BUFFER, *PTOE_DEFAULT_BUFFER;

      SG_C_ASSERT(__sizeof__TOE_DEFAULT_BUFFER, sizeof (TOE_DEFAULT_BUFFER) == 64);

   #else
      typedef struct _TOE_DEFAULT_BUFFER {
         u32 rsvd0[1];                            // DWORDS 0 to 0
         u32 rsvd1[1];                            // DWORDS 1 to 1
         u32 rsvd2[1];                            // DWORDS 2 to 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u32 rsvd4[1];                            // DWORDS 4 to 4
         u32 rsvd5[1];                            // DWORDS 5 to 5
         u32 rsvd6[1];                            // DWORDS 6 to 6
         u32 rsvd7[1];                            // DWORDS 7 to 7
         u32 rsvd8[1];                            // DWORDS 8 to 8
         u32 rsvd9[1];                            // DWORDS 9 to 9
         u32 rsvd10[1];                           // DWORDS 10 to 10
         u32 rsvd11[1];                           // DWORDS 11 to 11
         u32 buff_cidx : 14;                      // DWORD 12
         u32 rsvd12 : 2;                          // DWORD 12
         u32 ring_size : 4;                       // DWORD 12
         u32 rsvd13 : 10;                         // DWORD 12
         u32 reserve_1_dbuffer : 1;               // DWORD 12
         u32 flush_done : 1;                      // DWORD 12
         u32 buff_pidx : 14;                      // DWORD 13
         u32 pci_func : 8;                        // DWORD 13
         u32 pdid : 9;                            // DWORD 13
         u32 pdid_valid : 1;                      // DWORD 13
         u32 rsvd14[1];                           // DWORDS 14 to 14
         u32 rsvd15[1];                           // DWORDS 15 to 15
      } SG_PACK TOE_DEFAULT_BUFFER, *PTOE_DEFAULT_BUFFER;

      typedef union _TOE_DEFAULT_BUFFER_UNION {
         TOE_DEFAULT_BUFFER bits;
         u32 dw[16]; // dword union
      } SG_PACK TOE_DEFAULT_BUFFER_UNION, *PTOE_DEFAULT_BUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOE_DEFAULT_BUFFER_UNION, sizeof (TOE_DEFAULT_BUFFER_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_FRAGMENT_BUFFER {
         union {
            struct { 
               struct {
                  u32 high;                       // DWORD 0
                  u32 low;                        // DWORD 1
               } addr[32];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK TOERX_FRAGMENT_BUFFER, *PTOERX_FRAGMENT_BUFFER;

      SG_C_ASSERT(__sizeof__TOERX_FRAGMENT_BUFFER, sizeof (TOERX_FRAGMENT_BUFFER) == 256);

   #else
      typedef struct _TOERX_FRAGMENT_BUFFER {
         struct {
            u32 high;                             // DWORD 0
            u32 low;                              // DWORD 1
         } addr[32];
      } SG_PACK TOERX_FRAGMENT_BUFFER, *PTOERX_FRAGMENT_BUFFER;

      typedef union _TOERX_FRAGMENT_BUFFER_UNION {
         TOERX_FRAGMENT_BUFFER bits;
         u32 dw[64]; // dword union
      } SG_PACK TOERX_FRAGMENT_BUFFER_UNION, *PTOERX_FRAGMENT_BUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOERX_FRAGMENT_BUFFER_UNION, sizeof (TOERX_FRAGMENT_BUFFER_UNION) == 256);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TOERX_FRAGMENT_BUFFER {
         union {
            struct { 
               struct {
                  u32 high;                       // DWORD 0
                  u32 low;                        // DWORD 1
               } addr[32];
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK TOERX_FRAGMENT_BUFFER, *PTOERX_FRAGMENT_BUFFER;

      SG_C_ASSERT(__sizeof__TOERX_FRAGMENT_BUFFER, sizeof (TOERX_FRAGMENT_BUFFER) == 256);

   #else
      typedef struct _TOERX_FRAGMENT_BUFFER {
         struct {
            u32 high;                             // DWORD 0
            u32 low;                              // DWORD 1
         } addr[32];
      } SG_PACK TOERX_FRAGMENT_BUFFER, *PTOERX_FRAGMENT_BUFFER;

      typedef union _TOERX_FRAGMENT_BUFFER_UNION {
         TOERX_FRAGMENT_BUFFER bits;
         u32 dw[64]; // dword union
      } SG_PACK TOERX_FRAGMENT_BUFFER_UNION, *PTOERX_FRAGMENT_BUFFER_UNION;

      SG_C_ASSERT(__sizeof__TOERX_FRAGMENT_BUFFER_UNION, sizeof (TOERX_FRAGMENT_BUFFER_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // ETX ring context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_CONTEXT {
         union {
            struct { 
               u32 per_priority_class : 3;        // DWORD 0
               u32 outer_vtag : 1;                // DWORD 0
               u32 inner_vtag : 1;                // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tx_cidx : 14;                  // DWORD 0
               u32 ctx_valid : 1;                 // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pidx : 14;                     // DWORD 1
               u32 excess_qos : 1;                // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 rsvd2 : 2;                     // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 cq_id_send : 16;               // DWORD 2
               u32 outer_vtag_val : 16;           // DWORD 3
               u32 inner_vtag_val : 16;           // DWORD 3
               u32 tcp_ack_number;                // DWORD 4
               u32 tcp_timestamp_ecr;             // DWORD 5
               u32 vlan_tag : 16;                 // DWORD 6
               u32 tcp_window : 16;               // DWORD 6
               u32 valid : 1;                     // DWORD 7
               u32 cid : 5;                       // DWORD 7
               u32 lro_timer_pop : 1;             // DWORD 7
               u32 lro_flush : 1;                 // DWORD 7
               u32 vtp : 1;                       // DWORD 7
               u32 tcp_push : 1;                  // DWORD 7
               u32 snap : 1;                      // DWORD 7
               u32 ip_version : 1;                // DWORD 7
               u32 tsopt : 1;                     // DWORD 7
               u32 qinq : 1;                      // DWORD 7
               u32 dupack_count : 2;              // DWORD 7
               u32 pktsize : 16;                  // DWORD 7
               u32 rsvd3 : 16;                    // DWORD 8
               u32 ctx_addr2_part1 : 16;          // DWORD 8
               u32 ctx_addr2_part2 : 8;           // DWORD 9
               u32 ctx_addr1_part1 : 24;          // DWORD 9
               u32 buff_size_mask : 16;           // DWORD 10
               u32 lro_page_size : 16;            // DWORD 10
               u32 ring_size_mask;                // DWORD 11
               u32 rsvd5 : 12;                    // DWORD 12
               u32 rx_ring_size : 4;              // DWORD 12
               u32 disable_qos : 1;               // DWORD 12
               u32 rsvd4 : 1;                     // DWORD 12
               u32 lro_pidx : 14;                 // DWORD 12
               u32 lro_pdid_valid : 1;            // DWORD 13
               u32 lro_pdid : 9;                  // DWORD 13
               u32 rx_pci_func : 8;               // DWORD 13
               u32 lro_cidx : 14;                 // DWORD 13
               u32 wcon_rsvd : 8;                 // DWORD 14
               u32 EPretCargo : 8;                // DWORD 14
               u32 mrkpreface : 1;                // DWORD 14
               u32 SolEvent : 1;                  // DWORD 14
               u32 CQid : 10;                     // DWORD 14
               u32 fenceAll : 1;                  // DWORD 14
               u32 fence : 1;                     // DWORD 14
               u32 mrklen : 2;                    // DWORD 14
               u32 mrken : 1;                     // DWORD 15
               u32 mrkstride : 2;                 // DWORD 15
               u32 mrkstart : 13;                 // DWORD 15
               u32 msrc : 1;                      // DWORD 15
               u32 wconPageSize : 3;              // DWORD 15
               u32 HoldPyldDBUFs : 1;             // DWORD 15
               u32 dif_mode : 2;                  // DWORD 15
               u32 tgtsel : 1;                    // DWORD 15
               u32 FID : 8;                       // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ETX_CONTEXT, *PETX_CONTEXT;

      SG_C_ASSERT(__sizeof__ETX_CONTEXT, sizeof (ETX_CONTEXT) == 64);

   #else
      typedef struct _ETX_CONTEXT {
         u32 per_priority_class : 3;              // DWORD 0
         u32 outer_vtag : 1;                      // DWORD 0
         u32 inner_vtag : 1;                      // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tx_cidx : 14;                        // DWORD 0
         u32 ctx_valid : 1;                       // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pidx : 14;                           // DWORD 1
         u32 excess_qos : 1;                      // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 cq_id_send : 16;                     // DWORD 2
         u32 outer_vtag_val : 16;                 // DWORD 3
         u32 inner_vtag_val : 16;                 // DWORD 3
         u32 tcp_ack_number;                      // DWORD 4
         u32 tcp_timestamp_ecr;                   // DWORD 5
         u32 vlan_tag : 16;                       // DWORD 6
         u32 tcp_window : 16;                     // DWORD 6
         u32 valid : 1;                           // DWORD 7
         u32 cid : 5;                             // DWORD 7
         u32 lro_timer_pop : 1;                   // DWORD 7
         u32 lro_flush : 1;                       // DWORD 7
         u32 vtp : 1;                             // DWORD 7
         u32 tcp_push : 1;                        // DWORD 7
         u32 snap : 1;                            // DWORD 7
         u32 ip_version : 1;                      // DWORD 7
         u32 tsopt : 1;                           // DWORD 7
         u32 qinq : 1;                            // DWORD 7
         u32 dupack_count : 2;                    // DWORD 7
         u32 pktsize : 16;                        // DWORD 7
         u32 rsvd3 : 16;                          // DWORD 8
         u32 ctx_addr2_part1 : 16;                // DWORD 8
         u32 ctx_addr2_part2 : 8;                 // DWORD 9
         u32 ctx_addr1_part1 : 24;                // DWORD 9
         u32 buff_size_mask : 16;                 // DWORD 10
         u32 lro_page_size : 16;                  // DWORD 10
         u32 ring_size_mask;                      // DWORD 11
         u32 rsvd5 : 12;                          // DWORD 12
         u32 rx_ring_size : 4;                    // DWORD 12
         u32 disable_qos : 1;                     // DWORD 12
         u32 rsvd4 : 1;                           // DWORD 12
         u32 lro_pidx : 14;                       // DWORD 12
         u32 lro_pdid_valid : 1;                  // DWORD 13
         u32 lro_pdid : 9;                        // DWORD 13
         u32 rx_pci_func : 8;                     // DWORD 13
         u32 lro_cidx : 14;                       // DWORD 13
         u32 wcon_rsvd : 8;                       // DWORD 14
         u32 EPretCargo : 8;                      // DWORD 14
         u32 mrkpreface : 1;                      // DWORD 14
         u32 SolEvent : 1;                        // DWORD 14
         u32 CQid : 10;                           // DWORD 14
         u32 fenceAll : 1;                        // DWORD 14
         u32 fence : 1;                           // DWORD 14
         u32 mrklen : 2;                          // DWORD 14
         u32 mrken : 1;                           // DWORD 15
         u32 mrkstride : 2;                       // DWORD 15
         u32 mrkstart : 13;                       // DWORD 15
         u32 msrc : 1;                            // DWORD 15
         u32 wconPageSize : 3;                    // DWORD 15
         u32 HoldPyldDBUFs : 1;                   // DWORD 15
         u32 dif_mode : 2;                        // DWORD 15
         u32 tgtsel : 1;                          // DWORD 15
         u32 FID : 8;                             // DWORD 15
      } SG_PACK ETX_CONTEXT, *PETX_CONTEXT;

      typedef union _ETX_CONTEXT_UNION {
         ETX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK ETX_CONTEXT_UNION, *PETX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ETX_CONTEXT_UNION, sizeof (ETX_CONTEXT_UNION) == 64);
   #endif


#else
   // ETX ring context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_CONTEXT {
         union {
            struct { 
               u32 tx_cidx : 14;                  // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 tx_ring_size : 4;              // DWORD 0
               u32 fetch_wrb : 1;                 // DWORD 0
               u32 fetch_r2t : 1;                 // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 inner_vtag : 1;                // DWORD 0
               u32 outer_vtag : 1;                // DWORD 0
               u32 per_priority_class : 3;        // DWORD 0
               u32 pidx : 14;                     // DWORD 1
               u32 pci_func_id : 8;               // DWORD 1
               u32 pd_id : 9;                     // DWORD 1
               u32 ctx_valid : 1;                 // DWORD 1
               u32 cq_id_send : 16;               // DWORD 2
               u32 local_flow_id : 5;             // DWORD 2
               u32 global_flow_id : 5;            // DWORD 2
               u32 rsvd2 : 2;                     // DWORD 2
               u32 yellow_to_red_local : 1;       // DWORD 2
               u32 yellow_to_red_global : 1;      // DWORD 2
               u32 no_remain_allowed : 1;         // DWORD 2
               u32 excess_qos : 1;                // DWORD 2
               u32 inner_vtag_val : 16;           // DWORD 3
               u32 outer_vtag_val : 16;           // DWORD 3
               u32 tcp_ack_number;                // DWORD 4
               u32 tcp_timestamp_ecr;             // DWORD 5
               u32 tcp_window : 16;               // DWORD 6
               u32 vlan_tag : 16;                 // DWORD 6
               u32 pktsize : 16;                  // DWORD 7
               u32 dupack_count : 2;              // DWORD 7
               u32 qinq : 1;                      // DWORD 7
               u32 tsopt : 1;                     // DWORD 7
               u32 ip_version : 1;                // DWORD 7
               u32 snap : 1;                      // DWORD 7
               u32 tcp_push : 1;                  // DWORD 7
               u32 vtp : 1;                       // DWORD 7
               u32 lro_flush : 1;                 // DWORD 7
               u32 lro_timer_pop : 1;             // DWORD 7
               u32 cid : 5;                       // DWORD 7
               u32 valid : 1;                     // DWORD 7
               u32 ctx_addr2_part1 : 16;          // DWORD 8
               u32 rsvd3 : 16;                    // DWORD 8
               u32 ctx_addr1_part1 : 24;          // DWORD 9
               u32 ctx_addr2_part2 : 8;           // DWORD 9
               u32 lro_page_size : 16;            // DWORD 10
               u32 buff_size_mask : 16;           // DWORD 10
               u32 ring_size_mask;                // DWORD 11
               u32 lro_pidx : 14;                 // DWORD 12
               u32 rsvd4 : 1;                     // DWORD 12
               u32 disable_qos : 1;               // DWORD 12
               u32 rx_ring_size : 4;              // DWORD 12
               u32 rsvd5 : 12;                    // DWORD 12
               u32 lro_cidx : 14;                 // DWORD 13
               u32 rx_pci_func : 8;               // DWORD 13
               u32 lro_pdid : 9;                  // DWORD 13
               u32 lro_pdid_valid : 1;            // DWORD 13
               u32 mrklen : 2;                    // DWORD 14
               u32 fence : 1;                     // DWORD 14
               u32 fenceAll : 1;                  // DWORD 14
               u32 CQid : 10;                     // DWORD 14
               u32 SolEvent : 1;                  // DWORD 14
               u32 mrkpreface : 1;                // DWORD 14
               u32 EPretCargo : 8;                // DWORD 14
               u32 wcon_rsvd : 8;                 // DWORD 14
               u32 FID : 8;                       // DWORD 15
               u32 tgtsel : 1;                    // DWORD 15
               u32 dif_mode : 2;                  // DWORD 15
               u32 HoldPyldDBUFs : 1;             // DWORD 15
               u32 wconPageSize : 3;              // DWORD 15
               u32 msrc : 1;                      // DWORD 15
               u32 mrkstart : 13;                 // DWORD 15
               u32 mrkstride : 2;                 // DWORD 15
               u32 mrken : 1;                     // DWORD 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ETX_CONTEXT, *PETX_CONTEXT;

      SG_C_ASSERT(__sizeof__ETX_CONTEXT, sizeof (ETX_CONTEXT) == 64);

   #else
      typedef struct _ETX_CONTEXT {
         u32 tx_cidx : 14;                        // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 tx_ring_size : 4;                    // DWORD 0
         u32 fetch_wrb : 1;                       // DWORD 0
         u32 fetch_r2t : 1;                       // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 inner_vtag : 1;                      // DWORD 0
         u32 outer_vtag : 1;                      // DWORD 0
         u32 per_priority_class : 3;              // DWORD 0
         u32 pidx : 14;                           // DWORD 1
         u32 pci_func_id : 8;                     // DWORD 1
         u32 pd_id : 9;                           // DWORD 1
         u32 ctx_valid : 1;                       // DWORD 1
         u32 cq_id_send : 16;                     // DWORD 2
         u32 local_flow_id : 5;                   // DWORD 2
         u32 global_flow_id : 5;                  // DWORD 2
         u32 rsvd2 : 2;                           // DWORD 2
         u32 yellow_to_red_local : 1;             // DWORD 2
         u32 yellow_to_red_global : 1;            // DWORD 2
         u32 no_remain_allowed : 1;               // DWORD 2
         u32 excess_qos : 1;                      // DWORD 2
         u32 inner_vtag_val : 16;                 // DWORD 3
         u32 outer_vtag_val : 16;                 // DWORD 3
         u32 tcp_ack_number;                      // DWORD 4
         u32 tcp_timestamp_ecr;                   // DWORD 5
         u32 tcp_window : 16;                     // DWORD 6
         u32 vlan_tag : 16;                       // DWORD 6
         u32 pktsize : 16;                        // DWORD 7
         u32 dupack_count : 2;                    // DWORD 7
         u32 qinq : 1;                            // DWORD 7
         u32 tsopt : 1;                           // DWORD 7
         u32 ip_version : 1;                      // DWORD 7
         u32 snap : 1;                            // DWORD 7
         u32 tcp_push : 1;                        // DWORD 7
         u32 vtp : 1;                             // DWORD 7
         u32 lro_flush : 1;                       // DWORD 7
         u32 lro_timer_pop : 1;                   // DWORD 7
         u32 cid : 5;                             // DWORD 7
         u32 valid : 1;                           // DWORD 7
         u32 ctx_addr2_part1 : 16;                // DWORD 8
         u32 rsvd3 : 16;                          // DWORD 8
         u32 ctx_addr1_part1 : 24;                // DWORD 9
         u32 ctx_addr2_part2 : 8;                 // DWORD 9
         u32 lro_page_size : 16;                  // DWORD 10
         u32 buff_size_mask : 16;                 // DWORD 10
         u32 ring_size_mask;                      // DWORD 11
         u32 lro_pidx : 14;                       // DWORD 12
         u32 rsvd4 : 1;                           // DWORD 12
         u32 disable_qos : 1;                     // DWORD 12
         u32 rx_ring_size : 4;                    // DWORD 12
         u32 rsvd5 : 12;                          // DWORD 12
         u32 lro_cidx : 14;                       // DWORD 13
         u32 rx_pci_func : 8;                     // DWORD 13
         u32 lro_pdid : 9;                        // DWORD 13
         u32 lro_pdid_valid : 1;                  // DWORD 13
         u32 mrklen : 2;                          // DWORD 14
         u32 fence : 1;                           // DWORD 14
         u32 fenceAll : 1;                        // DWORD 14
         u32 CQid : 10;                           // DWORD 14
         u32 SolEvent : 1;                        // DWORD 14
         u32 mrkpreface : 1;                      // DWORD 14
         u32 EPretCargo : 8;                      // DWORD 14
         u32 wcon_rsvd : 8;                       // DWORD 14
         u32 FID : 8;                             // DWORD 15
         u32 tgtsel : 1;                          // DWORD 15
         u32 dif_mode : 2;                        // DWORD 15
         u32 HoldPyldDBUFs : 1;                   // DWORD 15
         u32 wconPageSize : 3;                    // DWORD 15
         u32 msrc : 1;                            // DWORD 15
         u32 mrkstart : 13;                       // DWORD 15
         u32 mrkstride : 2;                       // DWORD 15
         u32 mrken : 1;                           // DWORD 15
      } SG_PACK ETX_CONTEXT, *PETX_CONTEXT;

      typedef union _ETX_CONTEXT_UNION {
         ETX_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK ETX_CONTEXT_UNION, *PETX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ETX_CONTEXT_UNION, sizeof (ETX_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ethernet Primary shadow rings. Each ring can hold 64 WRBs and is sized (64*16) =
   // 1024 bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_PRIMARY_SHAD_RING {
         union {
            struct { 
               BE2_ETH_WRB wrbs[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ETX_PRIMARY_SHAD_RING, *PETX_PRIMARY_SHAD_RING;

      SG_C_ASSERT(__sizeof__ETX_PRIMARY_SHAD_RING, sizeof (ETX_PRIMARY_SHAD_RING) == 1024);

   #else
      typedef struct _ETX_PRIMARY_SHAD_RING {
         BE2_ETH_WRB wrbs[64];
      } SG_PACK ETX_PRIMARY_SHAD_RING, *PETX_PRIMARY_SHAD_RING;

      typedef union _ETX_PRIMARY_SHAD_RING_UNION {
         ETX_PRIMARY_SHAD_RING bits;
         u32 dw[256]; // dword union
      } SG_PACK ETX_PRIMARY_SHAD_RING_UNION, *PETX_PRIMARY_SHAD_RING_UNION;

      SG_C_ASSERT(__sizeof__ETX_PRIMARY_SHAD_RING_UNION, sizeof (ETX_PRIMARY_SHAD_RING_UNION) == 1024);
   #endif


#else
   // Ethernet Primary shadow rings. Each ring can hold 64 WRBs and is sized (64*16) =
   // 1024 bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_PRIMARY_SHAD_RING {
         union {
            struct { 
               BE2_ETH_WRB wrbs[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK ETX_PRIMARY_SHAD_RING, *PETX_PRIMARY_SHAD_RING;

      SG_C_ASSERT(__sizeof__ETX_PRIMARY_SHAD_RING, sizeof (ETX_PRIMARY_SHAD_RING) == 1024);

   #else
      typedef struct _ETX_PRIMARY_SHAD_RING {
         BE2_ETH_WRB wrbs[64];
      } SG_PACK ETX_PRIMARY_SHAD_RING, *PETX_PRIMARY_SHAD_RING;

      typedef union _ETX_PRIMARY_SHAD_RING_UNION {
         ETX_PRIMARY_SHAD_RING bits;
         u32 dw[256]; // dword union
      } SG_PACK ETX_PRIMARY_SHAD_RING_UNION, *PETX_PRIMARY_SHAD_RING_UNION;

      SG_C_ASSERT(__sizeof__ETX_PRIMARY_SHAD_RING_UNION, sizeof (ETX_PRIMARY_SHAD_RING_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ethernet Secondary shadow rings. Each ring can hold 32 WRBs and is sized (32*16) =
   // 512 bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_SECONDARY_SHAD_RING {
         union {
            struct { 
               BE2_ETH_WRB wrbs[32];
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK ETX_SECONDARY_SHAD_RING, *PETX_SECONDARY_SHAD_RING;

      SG_C_ASSERT(__sizeof__ETX_SECONDARY_SHAD_RING, sizeof (ETX_SECONDARY_SHAD_RING) == 512);

   #else
      typedef struct _ETX_SECONDARY_SHAD_RING {
         BE2_ETH_WRB wrbs[32];
      } SG_PACK ETX_SECONDARY_SHAD_RING, *PETX_SECONDARY_SHAD_RING;

      typedef union _ETX_SECONDARY_SHAD_RING_UNION {
         ETX_SECONDARY_SHAD_RING bits;
         u32 dw[128]; // dword union
      } SG_PACK ETX_SECONDARY_SHAD_RING_UNION, *PETX_SECONDARY_SHAD_RING_UNION;

      SG_C_ASSERT(__sizeof__ETX_SECONDARY_SHAD_RING_UNION, sizeof (ETX_SECONDARY_SHAD_RING_UNION) == 512);
   #endif


#else
   // Ethernet Secondary shadow rings. Each ring can hold 32 WRBs and is sized (32*16) =
   // 512 bytes 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_SECONDARY_SHAD_RING {
         union {
            struct { 
               BE2_ETH_WRB wrbs[32];
            } SG_PACK ; // unnamed struct
            u32 dw[128]; // dword union
         }; // unnamed union
      } SG_PACK ETX_SECONDARY_SHAD_RING, *PETX_SECONDARY_SHAD_RING;

      SG_C_ASSERT(__sizeof__ETX_SECONDARY_SHAD_RING, sizeof (ETX_SECONDARY_SHAD_RING) == 512);

   #else
      typedef struct _ETX_SECONDARY_SHAD_RING {
         BE2_ETH_WRB wrbs[32];
      } SG_PACK ETX_SECONDARY_SHAD_RING, *PETX_SECONDARY_SHAD_RING;

      typedef union _ETX_SECONDARY_SHAD_RING_UNION {
         ETX_SECONDARY_SHAD_RING bits;
         u32 dw[128]; // dword union
      } SG_PACK ETX_SECONDARY_SHAD_RING_UNION, *PETX_SECONDARY_SHAD_RING_UNION;

      SG_C_ASSERT(__sizeof__ETX_SECONDARY_SHAD_RING_UNION, sizeof (ETX_SECONDARY_SHAD_RING_UNION) == 512);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Descriptor format for the ethernet low latency rings. The descriptor is followed by
   // one or more BUFFER Descriptors. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_LOW_LAT_D {
         union {
            struct { 
               u32 rsvd2 : 6;                     // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 num_writes : 7;                // DWORD 0
               u32 wrb_index : 16;                // DWORD 1
               u32 rsvd3 : 3;                     // DWORD 1
               u32 inline_data : 1;               // DWORD 1
               u32 num_bd : 4;                    // DWORD 1
               u32 func : 8;                      // DWORD 1
               u32 cq_index : 16;                 // DWORD 2
               u32 rsvd5 : 7;                     // DWORD 2
               u32 tcp_checksum : 1;              // DWORD 2
               u32 udp_checksum : 1;              // DWORD 2
               u32 ip_checksum : 1;               // DWORD 2
               u32 rsvd4 : 4;                     // DWORD 2
               u32 event : 1;                     // DWORD 2
               u32 completion : 1;                // DWORD 2
               u32 rsvd6 : 16;                    // DWORD 3
               u32 data_len : 16;                 // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETX_LOW_LAT_D, *PETX_LOW_LAT_D;

      SG_C_ASSERT(__sizeof__ETX_LOW_LAT_D, sizeof (ETX_LOW_LAT_D) == 16);

   #else
      typedef struct _ETX_LOW_LAT_D {
         u32 rsvd2 : 6;                           // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 num_writes : 7;                      // DWORD 0
         u32 wrb_index : 16;                      // DWORD 1
         u32 rsvd3 : 3;                           // DWORD 1
         u32 inline_data : 1;                     // DWORD 1
         u32 num_bd : 4;                          // DWORD 1
         u32 func : 8;                            // DWORD 1
         u32 cq_index : 16;                       // DWORD 2
         u32 rsvd5 : 7;                           // DWORD 2
         u32 tcp_checksum : 1;                    // DWORD 2
         u32 udp_checksum : 1;                    // DWORD 2
         u32 ip_checksum : 1;                     // DWORD 2
         u32 rsvd4 : 4;                           // DWORD 2
         u32 event : 1;                           // DWORD 2
         u32 completion : 1;                      // DWORD 2
         u32 rsvd6 : 16;                          // DWORD 3
         u32 data_len : 16;                       // DWORD 3
      } SG_PACK ETX_LOW_LAT_D, *PETX_LOW_LAT_D;

      typedef union _ETX_LOW_LAT_D_UNION {
         ETX_LOW_LAT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK ETX_LOW_LAT_D_UNION, *PETX_LOW_LAT_D_UNION;

      SG_C_ASSERT(__sizeof__ETX_LOW_LAT_D_UNION, sizeof (ETX_LOW_LAT_D_UNION) == 16);
   #endif


#else
   // Descriptor format for the ethernet low latency rings. The descriptor is followed by
   // one or more BUFFER Descriptors. 
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_LOW_LAT_D {
         union {
            struct { 
               u32 num_writes : 7;                // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 iq_select : 1;                 // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
               u32 ct : 2;                        // DWORD 0
               u32 rsvd2 : 6;                     // DWORD 0
               u32 func : 8;                      // DWORD 1
               u32 num_bd : 4;                    // DWORD 1
               u32 inline_data : 1;               // DWORD 1
               u32 rsvd3 : 3;                     // DWORD 1
               u32 wrb_index : 16;                // DWORD 1
               u32 completion : 1;                // DWORD 2
               u32 event : 1;                     // DWORD 2
               u32 rsvd4 : 4;                     // DWORD 2
               u32 ip_checksum : 1;               // DWORD 2
               u32 udp_checksum : 1;              // DWORD 2
               u32 tcp_checksum : 1;              // DWORD 2
               u32 rsvd5 : 7;                     // DWORD 2
               u32 cq_index : 16;                 // DWORD 2
               u32 data_len : 16;                 // DWORD 3
               u32 rsvd6 : 16;                    // DWORD 3
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK ETX_LOW_LAT_D, *PETX_LOW_LAT_D;

      SG_C_ASSERT(__sizeof__ETX_LOW_LAT_D, sizeof (ETX_LOW_LAT_D) == 16);

   #else
      typedef struct _ETX_LOW_LAT_D {
         u32 num_writes : 7;                      // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 iq_select : 1;                       // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
         u32 ct : 2;                              // DWORD 0
         u32 rsvd2 : 6;                           // DWORD 0
         u32 func : 8;                            // DWORD 1
         u32 num_bd : 4;                          // DWORD 1
         u32 inline_data : 1;                     // DWORD 1
         u32 rsvd3 : 3;                           // DWORD 1
         u32 wrb_index : 16;                      // DWORD 1
         u32 completion : 1;                      // DWORD 2
         u32 event : 1;                           // DWORD 2
         u32 rsvd4 : 4;                           // DWORD 2
         u32 ip_checksum : 1;                     // DWORD 2
         u32 udp_checksum : 1;                    // DWORD 2
         u32 tcp_checksum : 1;                    // DWORD 2
         u32 rsvd5 : 7;                           // DWORD 2
         u32 cq_index : 16;                       // DWORD 2
         u32 data_len : 16;                       // DWORD 3
         u32 rsvd6 : 16;                          // DWORD 3
      } SG_PACK ETX_LOW_LAT_D, *PETX_LOW_LAT_D;

      typedef union _ETX_LOW_LAT_D_UNION {
         ETX_LOW_LAT_D bits;
         u32 dw[4]; // dword union
      } SG_PACK ETX_LOW_LAT_D_UNION, *PETX_LOW_LAT_D_UNION;

      SG_C_ASSERT(__sizeof__ETX_LOW_LAT_D_UNION, sizeof (ETX_LOW_LAT_D_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI OOO replay context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_ISCSI_OOO_CONTEXT {
         union {
            struct { 
               u32 dcq_wr_ptr : 16;               // DWORD 0
               u32 dcq_rd_ptr : 16;               // DWORD 0
               u32 rsvd1 : 10;                    // DWORD 1
               u32 pd_id_not_valid : 1;           // DWORD 1
               u32 pd_id : 5;                     // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 tx_pidx : 11;                  // DWORD 1
               u32 rsvd2 : 15;                    // DWORD 2
               u32 dcq_full : 1;                  // DWORD 2
               u32 rcq_rd_ptr : 16;               // DWORD 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u8 dcq_window_cid[16];
               u8 rcq_window_cid[16];
               u32 rsvd4[1];                      // DWORDS 12 to 12
               u32 rsvd6 : 10;                    // DWORD 13
               u32 rx_pdid_not_valid : 1;         // DWORD 13
               u32 rx_pdid : 5;                   // DWORD 13
               u32 window_factor : 4;             // DWORD 13
               u32 rsvd5 : 1;                     // DWORD 13
               u32 preposted_buf_cidx : 11;       // DWORD 13
               u32 rsvd7 : 16;                    // DWORD 14
               u32 rcq_wr_ptr : 16;               // DWORD 14
               u32 rsvd8[1];                      // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ETX_ISCSI_OOO_CONTEXT, *PETX_ISCSI_OOO_CONTEXT;

      SG_C_ASSERT(__sizeof__ETX_ISCSI_OOO_CONTEXT, sizeof (ETX_ISCSI_OOO_CONTEXT) == 64);

   #else
      typedef struct _ETX_ISCSI_OOO_CONTEXT {
         u32 dcq_wr_ptr : 16;                     // DWORD 0
         u32 dcq_rd_ptr : 16;                     // DWORD 0
         u32 rsvd1 : 10;                          // DWORD 1
         u32 pd_id_not_valid : 1;                 // DWORD 1
         u32 pd_id : 5;                           // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 tx_pidx : 11;                        // DWORD 1
         u32 rsvd2 : 15;                          // DWORD 2
         u32 dcq_full : 1;                        // DWORD 2
         u32 rcq_rd_ptr : 16;                     // DWORD 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u8 dcq_window_cid[16];
         u8 rcq_window_cid[16];
         u32 rsvd4[1];                            // DWORDS 12 to 12
         u32 rsvd6 : 10;                          // DWORD 13
         u32 rx_pdid_not_valid : 1;               // DWORD 13
         u32 rx_pdid : 5;                         // DWORD 13
         u32 window_factor : 4;                   // DWORD 13
         u32 rsvd5 : 1;                           // DWORD 13
         u32 preposted_buf_cidx : 11;             // DWORD 13
         u32 rsvd7 : 16;                          // DWORD 14
         u32 rcq_wr_ptr : 16;                     // DWORD 14
         u32 rsvd8[1];                            // DWORDS 15 to 15
      } SG_PACK ETX_ISCSI_OOO_CONTEXT, *PETX_ISCSI_OOO_CONTEXT;

      typedef union _ETX_ISCSI_OOO_CONTEXT_UNION {
         ETX_ISCSI_OOO_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK ETX_ISCSI_OOO_CONTEXT_UNION, *PETX_ISCSI_OOO_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ETX_ISCSI_OOO_CONTEXT_UNION, sizeof (ETX_ISCSI_OOO_CONTEXT_UNION) == 64);
   #endif


#else
   // iSCSI OOO replay context structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ETX_ISCSI_OOO_CONTEXT {
         union {
            struct { 
               u32 dcq_rd_ptr : 16;               // DWORD 0
               u32 dcq_wr_ptr : 16;               // DWORD 0
               u32 tx_pidx : 11;                  // DWORD 1
               u32 rsvd0 : 5;                     // DWORD 1
               u32 pd_id : 5;                     // DWORD 1
               u32 pd_id_not_valid : 1;           // DWORD 1
               u32 rsvd1 : 10;                    // DWORD 1
               u32 rcq_rd_ptr : 16;               // DWORD 2
               u32 dcq_full : 1;                  // DWORD 2
               u32 rsvd2 : 15;                    // DWORD 2
               u32 rsvd3[1];                      // DWORDS 3 to 3
               u8 dcq_window_cid[16];
               u8 rcq_window_cid[16];
               u32 rsvd4[1];                      // DWORDS 12 to 12
               u32 preposted_buf_cidx : 11;       // DWORD 13
               u32 rsvd5 : 1;                     // DWORD 13
               u32 window_factor : 4;             // DWORD 13
               u32 rx_pdid : 5;                   // DWORD 13
               u32 rx_pdid_not_valid : 1;         // DWORD 13
               u32 rsvd6 : 10;                    // DWORD 13
               u32 rcq_wr_ptr : 16;               // DWORD 14
               u32 rsvd7 : 16;                    // DWORD 14
               u32 rsvd8[1];                      // DWORDS 15 to 15
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK ETX_ISCSI_OOO_CONTEXT, *PETX_ISCSI_OOO_CONTEXT;

      SG_C_ASSERT(__sizeof__ETX_ISCSI_OOO_CONTEXT, sizeof (ETX_ISCSI_OOO_CONTEXT) == 64);

   #else
      typedef struct _ETX_ISCSI_OOO_CONTEXT {
         u32 dcq_rd_ptr : 16;                     // DWORD 0
         u32 dcq_wr_ptr : 16;                     // DWORD 0
         u32 tx_pidx : 11;                        // DWORD 1
         u32 rsvd0 : 5;                           // DWORD 1
         u32 pd_id : 5;                           // DWORD 1
         u32 pd_id_not_valid : 1;                 // DWORD 1
         u32 rsvd1 : 10;                          // DWORD 1
         u32 rcq_rd_ptr : 16;                     // DWORD 2
         u32 dcq_full : 1;                        // DWORD 2
         u32 rsvd2 : 15;                          // DWORD 2
         u32 rsvd3[1];                            // DWORDS 3 to 3
         u8 dcq_window_cid[16];
         u8 rcq_window_cid[16];
         u32 rsvd4[1];                            // DWORDS 12 to 12
         u32 preposted_buf_cidx : 11;             // DWORD 13
         u32 rsvd5 : 1;                           // DWORD 13
         u32 window_factor : 4;                   // DWORD 13
         u32 rx_pdid : 5;                         // DWORD 13
         u32 rx_pdid_not_valid : 1;               // DWORD 13
         u32 rsvd6 : 10;                          // DWORD 13
         u32 rcq_wr_ptr : 16;                     // DWORD 14
         u32 rsvd7 : 16;                          // DWORD 14
         u32 rsvd8[1];                            // DWORDS 15 to 15
      } SG_PACK ETX_ISCSI_OOO_CONTEXT, *PETX_ISCSI_OOO_CONTEXT;

      typedef union _ETX_ISCSI_OOO_CONTEXT_UNION {
         ETX_ISCSI_OOO_CONTEXT bits;
         u32 dw[16]; // dword union
      } SG_PACK ETX_ISCSI_OOO_CONTEXT_UNION, *PETX_ISCSI_OOO_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ETX_ISCSI_OOO_CONTEXT_UNION, sizeof (ETX_ISCSI_OOO_CONTEXT_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI OOO replay CID data structure managed by TOE TX.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT {
         union {
            struct { 
               u32 hole_id : 1;                   // DWORD 0
               u32 num_replayed : 15;             // DWORD 0
               u32 last : 16;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT) == 4);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT {
         u32 hole_id : 1;                         // DWORD 0
         u32 num_replayed : 15;                   // DWORD 0
         u32 last : 16;                           // DWORD 0
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION) == 4);
   #endif


#else
   // iSCSI OOO replay CID data structure managed by TOE TX.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT {
         union {
            struct { 
               u32 last : 16;                     // DWORD 0
               u32 num_replayed : 15;             // DWORD 0
               u32 hole_id : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT) == 4);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT {
         u32 last : 16;                           // DWORD 0
         u32 num_replayed : 15;                   // DWORD 0
         u32 hole_id : 1;                         // DWORD 0
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT bits;
         u32 dw; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI OOO replay CID data structure managed by iSCSI RX.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT {
         union {
            struct { 
               u32 total_num_ooo : 16;            // DWORD 0
               u32 num_ooo : 16;                  // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 1
               u32 hole_id : 1;                   // DWORD 1
               u32 tail : 16;                     // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT) == 8);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT {
         u32 total_num_ooo : 16;                  // DWORD 0
         u32 num_ooo : 16;                        // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 1
         u32 hole_id : 1;                         // DWORD 1
         u32 tail : 16;                           // DWORD 1
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION) == 8);
   #endif


#else
   // iSCSI OOO replay CID data structure managed by iSCSI RX.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT {
         union {
            struct { 
               u32 num_ooo : 16;                  // DWORD 0
               u32 total_num_ooo : 16;            // DWORD 0
               u32 tail : 16;                     // DWORD 1
               u32 hole_id : 1;                   // DWORD 1
               u32 rsvd0 : 15;                    // DWORD 1
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT) == 8);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT {
         u32 num_ooo : 16;                        // DWORD 0
         u32 total_num_ooo : 16;                  // DWORD 0
         u32 tail : 16;                           // DWORD 1
         u32 hole_id : 1;                         // DWORD 1
         u32 rsvd0 : 15;                          // DWORD 1
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT bits;
         u32 dw[2]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI OOO replay CID data structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_CONTEXT {
         union {
            struct { 
               ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT iscsi_ooo_replay_cid_toetx_ctx[4];
               ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT iscsi_ooo_replay_cid_iscsirx_ctx[4];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT, *PISCSI_OOO_REPLAY_CID_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_CONTEXT) == 48);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_CONTEXT {
         ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT iscsi_ooo_replay_cid_toetx_ctx[4];
         ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT iscsi_ooo_replay_cid_iscsirx_ctx[4];
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT, *PISCSI_OOO_REPLAY_CID_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_CONTEXT bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_CONTEXT_UNION) == 48);
   #endif


#else
   // iSCSI OOO replay CID data structure.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_CONTEXT {
         union {
            struct { 
               ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT iscsi_ooo_replay_cid_toetx_ctx[4];
               ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT iscsi_ooo_replay_cid_iscsirx_ctx[4];
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT, *PISCSI_OOO_REPLAY_CID_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_CONTEXT) == 48);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_CONTEXT {
         ISCSI_OOO_REPLAY_CID_TOETX_CONTEXT iscsi_ooo_replay_cid_toetx_ctx[4];
         ISCSI_OOO_REPLAY_CID_ISCSIRX_CONTEXT iscsi_ooo_replay_cid_iscsirx_ctx[4];
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT, *PISCSI_OOO_REPLAY_CID_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_CONTEXT bits;
         u32 dw[12]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_CONTEXT_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI OOO replay CID data structure and replay queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT {
         union {
            struct { 
               u16 dcqueue[512];
               u16 rcqueue[512];
               ISCSI_OOO_REPLAY_CID_CONTEXT iscsi_ooo_replay_cid_ctx[128];
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_CQ_CONTEXT) == 8192);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT {
         u16 dcqueue[512];
         u16 rcqueue[512];
         ISCSI_OOO_REPLAY_CID_CONTEXT iscsi_ooo_replay_cid_ctx[128];
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_CQ_CONTEXT bits;
         u32 dw[2048]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION) == 8192);
   #endif


#else
   // iSCSI OOO replay CID data structure and replay queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT {
         union {
            struct { 
               u16 dcqueue[512];
               u16 rcqueue[512];
               ISCSI_OOO_REPLAY_CID_CONTEXT iscsi_ooo_replay_cid_ctx[128];
            } SG_PACK ; // unnamed struct
            u32 dw[2048]; // dword union
         }; // unnamed union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, sizeof (ISCSI_OOO_REPLAY_CID_CQ_CONTEXT) == 8192);

   #else
      typedef struct _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT {
         u16 dcqueue[512];
         u16 rcqueue[512];
         ISCSI_OOO_REPLAY_CID_CONTEXT iscsi_ooo_replay_cid_ctx[128];
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT;

      typedef union _ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION {
         ISCSI_OOO_REPLAY_CID_CQ_CONTEXT bits;
         u32 dw[2048]; // dword union
      } SG_PACK ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION, *PISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION;

      SG_C_ASSERT(__sizeof__ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION, sizeof (ISCSI_OOO_REPLAY_CID_CQ_CONTEXT_UNION) == 8192);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Excess QOS counters kept by tpost. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EXCESS_QOS_COUNTERS {
         union {
            struct { 
               u32 port0_excess_bytes;            // DWORD 0
               u32 port1_excess_bytes;            // DWORD 1
               u32 rsvd0 : 31;                    // DWORD 2
               u32 timer_phase : 1;               // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
               u32 port0_ct0_bytes;               // DWORD 4
               u32 port1_ct0_bytes;               // DWORD 5
               u32 port0_ct1_bytes;               // DWORD 6
               u32 port1_ct1_bytes;               // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK EXCESS_QOS_COUNTERS, *PEXCESS_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__EXCESS_QOS_COUNTERS, sizeof (EXCESS_QOS_COUNTERS) == 32);

   #else
      typedef struct _EXCESS_QOS_COUNTERS {
         u32 port0_excess_bytes;                  // DWORD 0
         u32 port1_excess_bytes;                  // DWORD 1
         u32 rsvd0 : 31;                          // DWORD 2
         u32 timer_phase : 1;                     // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
         u32 port0_ct0_bytes;                     // DWORD 4
         u32 port1_ct0_bytes;                     // DWORD 5
         u32 port0_ct1_bytes;                     // DWORD 6
         u32 port1_ct1_bytes;                     // DWORD 7
      } SG_PACK EXCESS_QOS_COUNTERS, *PEXCESS_QOS_COUNTERS;

      typedef union _EXCESS_QOS_COUNTERS_UNION {
         EXCESS_QOS_COUNTERS bits;
         u32 dw[8]; // dword union
      } SG_PACK EXCESS_QOS_COUNTERS_UNION, *PEXCESS_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__EXCESS_QOS_COUNTERS_UNION, sizeof (EXCESS_QOS_COUNTERS_UNION) == 32);
   #endif


#else
   // Excess QOS counters kept by tpost. 
   #if defined(SG_BMAP_UNION)
      typedef struct _EXCESS_QOS_COUNTERS {
         union {
            struct { 
               u32 port0_excess_bytes;            // DWORD 0
               u32 port1_excess_bytes;            // DWORD 1
               u32 timer_phase : 1;               // DWORD 2
               u32 rsvd0 : 31;                    // DWORD 2
               u32 rsvd1[1];                      // DWORDS 3 to 3
               u32 port0_ct0_bytes;               // DWORD 4
               u32 port1_ct0_bytes;               // DWORD 5
               u32 port0_ct1_bytes;               // DWORD 6
               u32 port1_ct1_bytes;               // DWORD 7
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK EXCESS_QOS_COUNTERS, *PEXCESS_QOS_COUNTERS;

      SG_C_ASSERT(__sizeof__EXCESS_QOS_COUNTERS, sizeof (EXCESS_QOS_COUNTERS) == 32);

   #else
      typedef struct _EXCESS_QOS_COUNTERS {
         u32 port0_excess_bytes;                  // DWORD 0
         u32 port1_excess_bytes;                  // DWORD 1
         u32 timer_phase : 1;                     // DWORD 2
         u32 rsvd0 : 31;                          // DWORD 2
         u32 rsvd1[1];                            // DWORDS 3 to 3
         u32 port0_ct0_bytes;                     // DWORD 4
         u32 port1_ct0_bytes;                     // DWORD 5
         u32 port0_ct1_bytes;                     // DWORD 6
         u32 port1_ct1_bytes;                     // DWORD 7
      } SG_PACK EXCESS_QOS_COUNTERS, *PEXCESS_QOS_COUNTERS;

      typedef union _EXCESS_QOS_COUNTERS_UNION {
         EXCESS_QOS_COUNTERS bits;
         u32 dw[8]; // dword union
      } SG_PACK EXCESS_QOS_COUNTERS_UNION, *PEXCESS_QOS_COUNTERS_UNION;

      SG_C_ASSERT(__sizeof__EXCESS_QOS_COUNTERS_UNION, sizeof (EXCESS_QOS_COUNTERS_UNION) == 32);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __toe_context_bmap_h__

