/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __wcon_bmap_h__
#define __wcon_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "pq_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // WCON Configuration 1 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CFG1_CR {
         union {
            struct { 
               u32 disableDBUFprefetch : 1;       // DWORD 0
               u32 UCreqLim : 3;                  // DWORD 0
               u32 complSwapMode : 2;             // DWORD 0
               u32 pyldSwapMode : 2;              // DWORD 0
               u32 LenViolPolicy : 1;             // DWORD 0
               u32 BMstride : 3;                  // DWORD 0
               u32 UConeVL : 1;                   // DWORD 0
               u32 HoldPyldDBUFs : 1;             // DWORD 0
               u32 BMbaseAddr : 18;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CFG1_CR, *PRXULP_WCON_CFG1_CR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG1_CR, sizeof (RXULP_WCON_CFG1_CR) == 4);

   #else
      typedef struct _RXULP_WCON_CFG1_CR {
         u32 disableDBUFprefetch : 1;             // DWORD 0
         u32 UCreqLim : 3;                        // DWORD 0
         u32 complSwapMode : 2;                   // DWORD 0
         u32 pyldSwapMode : 2;                    // DWORD 0
         u32 LenViolPolicy : 1;                   // DWORD 0
         u32 BMstride : 3;                        // DWORD 0
         u32 UConeVL : 1;                         // DWORD 0
         u32 HoldPyldDBUFs : 1;                   // DWORD 0
         u32 BMbaseAddr : 18;                     // DWORD 0
      } SG_PACK RXULP_WCON_CFG1_CR, *PRXULP_WCON_CFG1_CR;

      typedef union _RXULP_WCON_CFG1_CR_UNION {
         RXULP_WCON_CFG1_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CFG1_CR_UNION, *PRXULP_WCON_CFG1_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG1_CR_UNION, sizeof (RXULP_WCON_CFG1_CR_UNION) == 4);
   #endif


#else
   // WCON Configuration 1 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CFG1_CR {
         union {
            struct { 
               u32 BMbaseAddr : 18;               // DWORD 0
               u32 HoldPyldDBUFs : 1;             // DWORD 0
               u32 UConeVL : 1;                   // DWORD 0
               u32 BMstride : 3;                  // DWORD 0
               u32 LenViolPolicy : 1;             // DWORD 0
               u32 pyldSwapMode : 2;              // DWORD 0
               u32 complSwapMode : 2;             // DWORD 0
               u32 UCreqLim : 3;                  // DWORD 0
               u32 disableDBUFprefetch : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CFG1_CR, *PRXULP_WCON_CFG1_CR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG1_CR, sizeof (RXULP_WCON_CFG1_CR) == 4);

   #else
      typedef struct _RXULP_WCON_CFG1_CR {
         u32 BMbaseAddr : 18;                     // DWORD 0
         u32 HoldPyldDBUFs : 1;                   // DWORD 0
         u32 UConeVL : 1;                         // DWORD 0
         u32 BMstride : 3;                        // DWORD 0
         u32 LenViolPolicy : 1;                   // DWORD 0
         u32 pyldSwapMode : 2;                    // DWORD 0
         u32 complSwapMode : 2;                   // DWORD 0
         u32 UCreqLim : 3;                        // DWORD 0
         u32 disableDBUFprefetch : 1;             // DWORD 0
      } SG_PACK RXULP_WCON_CFG1_CR, *PRXULP_WCON_CFG1_CR;

      typedef union _RXULP_WCON_CFG1_CR_UNION {
         RXULP_WCON_CFG1_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CFG1_CR_UNION, *PRXULP_WCON_CFG1_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG1_CR_UNION, sizeof (RXULP_WCON_CFG1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WCON Configuration 2 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CFG2_CR {
         union {
            struct { 
               u32 cev_eds : 3;                   // DWORD 0
               u32 wdma_eds : 3;                  // DWORD 0
               u32 UCfixedVL : 2;                 // DWORD 0
               u32 WDMAreqLim : 4;                // DWORD 0
               u32 PMstride : 3;                  // DWORD 0
               u32 PMbaseAddr : 17;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CFG2_CR, *PRXULP_WCON_CFG2_CR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG2_CR, sizeof (RXULP_WCON_CFG2_CR) == 4);

   #else
      typedef struct _RXULP_WCON_CFG2_CR {
         u32 cev_eds : 3;                         // DWORD 0
         u32 wdma_eds : 3;                        // DWORD 0
         u32 UCfixedVL : 2;                       // DWORD 0
         u32 WDMAreqLim : 4;                      // DWORD 0
         u32 PMstride : 3;                        // DWORD 0
         u32 PMbaseAddr : 17;                     // DWORD 0
      } SG_PACK RXULP_WCON_CFG2_CR, *PRXULP_WCON_CFG2_CR;

      typedef union _RXULP_WCON_CFG2_CR_UNION {
         RXULP_WCON_CFG2_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CFG2_CR_UNION, *PRXULP_WCON_CFG2_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG2_CR_UNION, sizeof (RXULP_WCON_CFG2_CR_UNION) == 4);
   #endif


#else
   // WCON Configuration 2 Register
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CFG2_CR {
         union {
            struct { 
               u32 PMbaseAddr : 17;               // DWORD 0
               u32 PMstride : 3;                  // DWORD 0
               u32 WDMAreqLim : 4;                // DWORD 0
               u32 UCfixedVL : 2;                 // DWORD 0
               u32 wdma_eds : 3;                  // DWORD 0
               u32 cev_eds : 3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CFG2_CR, *PRXULP_WCON_CFG2_CR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG2_CR, sizeof (RXULP_WCON_CFG2_CR) == 4);

   #else
      typedef struct _RXULP_WCON_CFG2_CR {
         u32 PMbaseAddr : 17;                     // DWORD 0
         u32 PMstride : 3;                        // DWORD 0
         u32 WDMAreqLim : 4;                      // DWORD 0
         u32 UCfixedVL : 2;                       // DWORD 0
         u32 wdma_eds : 3;                        // DWORD 0
         u32 cev_eds : 3;                         // DWORD 0
      } SG_PACK RXULP_WCON_CFG2_CR, *PRXULP_WCON_CFG2_CR;

      typedef union _RXULP_WCON_CFG2_CR_UNION {
         RXULP_WCON_CFG2_CR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CFG2_CR_UNION, *PRXULP_WCON_CFG2_CR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CFG2_CR_UNION, sizeof (RXULP_WCON_CFG2_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WCON Unrecoverable Error Enable register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UE_ENABLE_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 WDMAbadCRA : 1;                // DWORD 0
               u32 UCbadCRA : 1;                  // DWORD 0
               u32 CmdWrPgOv : 1;                 // DWORD 0
               u32 CRB : 1;                       // DWORD 0
               u32 wcon_d_parse : 1;              // DWORD 0
               u32 wcon_ctx_perr : 1;             // DWORD 0
               u32 wcon_unexp_wdma_resp : 1;      // DWORD 0
               u32 wcon_bad_wdma_resp : 1;        // DWORD 0
               u32 wcon_unexp_uc_resp : 1;        // DWORD 0
               u32 wcon_bad_uc_resp : 1;          // DWORD 0
               u32 wcon_cqe_upd_un : 1;           // DWORD 0
               u32 wcon_cqe_upd_ov : 1;           // DWORD 0
               u32 wcon_uc_inv_un : 1;            // DWORD 0
               u32 wcon_uc_inv_ov : 1;            // DWORD 0
               u32 wcon_pyld_dbuf_un : 1;         // DWORD 0
               u32 wcon_pyld_dbuf_ov : 1;         // DWORD 0
               u32 wcon_sgl_un : 1;               // DWORD 0
               u32 wcon_sgl_ov : 1;               // DWORD 0
               u32 wcon_uc_resp_un : 1;           // DWORD 0
               u32 wcon_uc_resp_ov : 1;           // DWORD 0
               u32 wcon_conn_rd_un : 1;           // DWORD 0
               u32 wcon_conn_rd_ov : 1;           // DWORD 0
               u32 wcon_if_un : 1;                // DWORD 0
               u32 wcon_if_ov : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UE_ENABLE_CSR, *PWCON_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__WCON_UE_ENABLE_CSR, sizeof (WCON_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _WCON_UE_ENABLE_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 WDMAbadCRA : 1;                      // DWORD 0
         u32 UCbadCRA : 1;                        // DWORD 0
         u32 CmdWrPgOv : 1;                       // DWORD 0
         u32 CRB : 1;                             // DWORD 0
         u32 wcon_d_parse : 1;                    // DWORD 0
         u32 wcon_ctx_perr : 1;                   // DWORD 0
         u32 wcon_unexp_wdma_resp : 1;            // DWORD 0
         u32 wcon_bad_wdma_resp : 1;              // DWORD 0
         u32 wcon_unexp_uc_resp : 1;              // DWORD 0
         u32 wcon_bad_uc_resp : 1;                // DWORD 0
         u32 wcon_cqe_upd_un : 1;                 // DWORD 0
         u32 wcon_cqe_upd_ov : 1;                 // DWORD 0
         u32 wcon_uc_inv_un : 1;                  // DWORD 0
         u32 wcon_uc_inv_ov : 1;                  // DWORD 0
         u32 wcon_pyld_dbuf_un : 1;               // DWORD 0
         u32 wcon_pyld_dbuf_ov : 1;               // DWORD 0
         u32 wcon_sgl_un : 1;                     // DWORD 0
         u32 wcon_sgl_ov : 1;                     // DWORD 0
         u32 wcon_uc_resp_un : 1;                 // DWORD 0
         u32 wcon_uc_resp_ov : 1;                 // DWORD 0
         u32 wcon_conn_rd_un : 1;                 // DWORD 0
         u32 wcon_conn_rd_ov : 1;                 // DWORD 0
         u32 wcon_if_un : 1;                      // DWORD 0
         u32 wcon_if_ov : 1;                      // DWORD 0
      } SG_PACK WCON_UE_ENABLE_CSR, *PWCON_UE_ENABLE_CSR;

      typedef union _WCON_UE_ENABLE_CSR_UNION {
         WCON_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UE_ENABLE_CSR_UNION, *PWCON_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UE_ENABLE_CSR_UNION, sizeof (WCON_UE_ENABLE_CSR_UNION) == 4);
   #endif


#else
   // WCON Unrecoverable Error Enable register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UE_ENABLE_CSR {
         union {
            struct { 
               u32 wcon_if_ov : 1;                // DWORD 0
               u32 wcon_if_un : 1;                // DWORD 0
               u32 wcon_conn_rd_ov : 1;           // DWORD 0
               u32 wcon_conn_rd_un : 1;           // DWORD 0
               u32 wcon_uc_resp_ov : 1;           // DWORD 0
               u32 wcon_uc_resp_un : 1;           // DWORD 0
               u32 wcon_sgl_ov : 1;               // DWORD 0
               u32 wcon_sgl_un : 1;               // DWORD 0
               u32 wcon_pyld_dbuf_ov : 1;         // DWORD 0
               u32 wcon_pyld_dbuf_un : 1;         // DWORD 0
               u32 wcon_uc_inv_ov : 1;            // DWORD 0
               u32 wcon_uc_inv_un : 1;            // DWORD 0
               u32 wcon_cqe_upd_ov : 1;           // DWORD 0
               u32 wcon_cqe_upd_un : 1;           // DWORD 0
               u32 wcon_bad_uc_resp : 1;          // DWORD 0
               u32 wcon_unexp_uc_resp : 1;        // DWORD 0
               u32 wcon_bad_wdma_resp : 1;        // DWORD 0
               u32 wcon_unexp_wdma_resp : 1;      // DWORD 0
               u32 wcon_ctx_perr : 1;             // DWORD 0
               u32 wcon_d_parse : 1;              // DWORD 0
               u32 CRB : 1;                       // DWORD 0
               u32 CmdWrPgOv : 1;                 // DWORD 0
               u32 UCbadCRA : 1;                  // DWORD 0
               u32 WDMAbadCRA : 1;                // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UE_ENABLE_CSR, *PWCON_UE_ENABLE_CSR;

      SG_C_ASSERT(__sizeof__WCON_UE_ENABLE_CSR, sizeof (WCON_UE_ENABLE_CSR) == 4);

   #else
      typedef struct _WCON_UE_ENABLE_CSR {
         u32 wcon_if_ov : 1;                      // DWORD 0
         u32 wcon_if_un : 1;                      // DWORD 0
         u32 wcon_conn_rd_ov : 1;                 // DWORD 0
         u32 wcon_conn_rd_un : 1;                 // DWORD 0
         u32 wcon_uc_resp_ov : 1;                 // DWORD 0
         u32 wcon_uc_resp_un : 1;                 // DWORD 0
         u32 wcon_sgl_ov : 1;                     // DWORD 0
         u32 wcon_sgl_un : 1;                     // DWORD 0
         u32 wcon_pyld_dbuf_ov : 1;               // DWORD 0
         u32 wcon_pyld_dbuf_un : 1;               // DWORD 0
         u32 wcon_uc_inv_ov : 1;                  // DWORD 0
         u32 wcon_uc_inv_un : 1;                  // DWORD 0
         u32 wcon_cqe_upd_ov : 1;                 // DWORD 0
         u32 wcon_cqe_upd_un : 1;                 // DWORD 0
         u32 wcon_bad_uc_resp : 1;                // DWORD 0
         u32 wcon_unexp_uc_resp : 1;              // DWORD 0
         u32 wcon_bad_wdma_resp : 1;              // DWORD 0
         u32 wcon_unexp_wdma_resp : 1;            // DWORD 0
         u32 wcon_ctx_perr : 1;                   // DWORD 0
         u32 wcon_d_parse : 1;                    // DWORD 0
         u32 CRB : 1;                             // DWORD 0
         u32 CmdWrPgOv : 1;                       // DWORD 0
         u32 UCbadCRA : 1;                        // DWORD 0
         u32 WDMAbadCRA : 1;                      // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK WCON_UE_ENABLE_CSR, *PWCON_UE_ENABLE_CSR;

      typedef union _WCON_UE_ENABLE_CSR_UNION {
         WCON_UE_ENABLE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UE_ENABLE_CSR_UNION, *PWCON_UE_ENABLE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UE_ENABLE_CSR_UNION, sizeof (WCON_UE_ENABLE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WCON Unrecoverable Error Status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UE_SOURCE_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 WDMAbadCRA : 1;                // DWORD 0
               u32 UCbadCRA : 1;                  // DWORD 0
               u32 CmdWrPgOv : 1;                 // DWORD 0
               u32 CRB : 1;                       // DWORD 0
               u32 wcon_d_parse : 1;              // DWORD 0
               u32 wcon_ctx_perr : 1;             // DWORD 0
               u32 wcon_unexp_wdma_resp : 1;      // DWORD 0
               u32 wcon_bad_wdma_resp : 1;        // DWORD 0
               u32 wcon_unexp_uc_resp : 1;        // DWORD 0
               u32 wcon_bad_uc_resp : 1;          // DWORD 0
               u32 wcon_cqe_upd_un : 1;           // DWORD 0
               u32 wcon_cqe_upd_ov : 1;           // DWORD 0
               u32 wcon_uc_inv_un : 1;            // DWORD 0
               u32 wcon_uc_inv_ov : 1;            // DWORD 0
               u32 wcon_pyld_dbuf_un : 1;         // DWORD 0
               u32 wcon_pyld_dbuf_ov : 1;         // DWORD 0
               u32 wcon_sgl_un : 1;               // DWORD 0
               u32 wcon_sgl_ov : 1;               // DWORD 0
               u32 wcon_uc_resp_un : 1;           // DWORD 0
               u32 wcon_uc_resp_ov : 1;           // DWORD 0
               u32 wcon_conn_rd_un : 1;           // DWORD 0
               u32 wcon_conn_rd_ov : 1;           // DWORD 0
               u32 wcon_if_un : 1;                // DWORD 0
               u32 wcon_if_ov : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UE_SOURCE_CSR, *PWCON_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__WCON_UE_SOURCE_CSR, sizeof (WCON_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _WCON_UE_SOURCE_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 WDMAbadCRA : 1;                      // DWORD 0
         u32 UCbadCRA : 1;                        // DWORD 0
         u32 CmdWrPgOv : 1;                       // DWORD 0
         u32 CRB : 1;                             // DWORD 0
         u32 wcon_d_parse : 1;                    // DWORD 0
         u32 wcon_ctx_perr : 1;                   // DWORD 0
         u32 wcon_unexp_wdma_resp : 1;            // DWORD 0
         u32 wcon_bad_wdma_resp : 1;              // DWORD 0
         u32 wcon_unexp_uc_resp : 1;              // DWORD 0
         u32 wcon_bad_uc_resp : 1;                // DWORD 0
         u32 wcon_cqe_upd_un : 1;                 // DWORD 0
         u32 wcon_cqe_upd_ov : 1;                 // DWORD 0
         u32 wcon_uc_inv_un : 1;                  // DWORD 0
         u32 wcon_uc_inv_ov : 1;                  // DWORD 0
         u32 wcon_pyld_dbuf_un : 1;               // DWORD 0
         u32 wcon_pyld_dbuf_ov : 1;               // DWORD 0
         u32 wcon_sgl_un : 1;                     // DWORD 0
         u32 wcon_sgl_ov : 1;                     // DWORD 0
         u32 wcon_uc_resp_un : 1;                 // DWORD 0
         u32 wcon_uc_resp_ov : 1;                 // DWORD 0
         u32 wcon_conn_rd_un : 1;                 // DWORD 0
         u32 wcon_conn_rd_ov : 1;                 // DWORD 0
         u32 wcon_if_un : 1;                      // DWORD 0
         u32 wcon_if_ov : 1;                      // DWORD 0
      } SG_PACK WCON_UE_SOURCE_CSR, *PWCON_UE_SOURCE_CSR;

      typedef union _WCON_UE_SOURCE_CSR_UNION {
         WCON_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UE_SOURCE_CSR_UNION, *PWCON_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UE_SOURCE_CSR_UNION, sizeof (WCON_UE_SOURCE_CSR_UNION) == 4);
   #endif


#else
   // WCON Unrecoverable Error Status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UE_SOURCE_CSR {
         union {
            struct { 
               u32 wcon_if_ov : 1;                // DWORD 0
               u32 wcon_if_un : 1;                // DWORD 0
               u32 wcon_conn_rd_ov : 1;           // DWORD 0
               u32 wcon_conn_rd_un : 1;           // DWORD 0
               u32 wcon_uc_resp_ov : 1;           // DWORD 0
               u32 wcon_uc_resp_un : 1;           // DWORD 0
               u32 wcon_sgl_ov : 1;               // DWORD 0
               u32 wcon_sgl_un : 1;               // DWORD 0
               u32 wcon_pyld_dbuf_ov : 1;         // DWORD 0
               u32 wcon_pyld_dbuf_un : 1;         // DWORD 0
               u32 wcon_uc_inv_ov : 1;            // DWORD 0
               u32 wcon_uc_inv_un : 1;            // DWORD 0
               u32 wcon_cqe_upd_ov : 1;           // DWORD 0
               u32 wcon_cqe_upd_un : 1;           // DWORD 0
               u32 wcon_bad_uc_resp : 1;          // DWORD 0
               u32 wcon_unexp_uc_resp : 1;        // DWORD 0
               u32 wcon_bad_wdma_resp : 1;        // DWORD 0
               u32 wcon_unexp_wdma_resp : 1;      // DWORD 0
               u32 wcon_ctx_perr : 1;             // DWORD 0
               u32 wcon_d_parse : 1;              // DWORD 0
               u32 CRB : 1;                       // DWORD 0
               u32 CmdWrPgOv : 1;                 // DWORD 0
               u32 UCbadCRA : 1;                  // DWORD 0
               u32 WDMAbadCRA : 1;                // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UE_SOURCE_CSR, *PWCON_UE_SOURCE_CSR;

      SG_C_ASSERT(__sizeof__WCON_UE_SOURCE_CSR, sizeof (WCON_UE_SOURCE_CSR) == 4);

   #else
      typedef struct _WCON_UE_SOURCE_CSR {
         u32 wcon_if_ov : 1;                      // DWORD 0
         u32 wcon_if_un : 1;                      // DWORD 0
         u32 wcon_conn_rd_ov : 1;                 // DWORD 0
         u32 wcon_conn_rd_un : 1;                 // DWORD 0
         u32 wcon_uc_resp_ov : 1;                 // DWORD 0
         u32 wcon_uc_resp_un : 1;                 // DWORD 0
         u32 wcon_sgl_ov : 1;                     // DWORD 0
         u32 wcon_sgl_un : 1;                     // DWORD 0
         u32 wcon_pyld_dbuf_ov : 1;               // DWORD 0
         u32 wcon_pyld_dbuf_un : 1;               // DWORD 0
         u32 wcon_uc_inv_ov : 1;                  // DWORD 0
         u32 wcon_uc_inv_un : 1;                  // DWORD 0
         u32 wcon_cqe_upd_ov : 1;                 // DWORD 0
         u32 wcon_cqe_upd_un : 1;                 // DWORD 0
         u32 wcon_bad_uc_resp : 1;                // DWORD 0
         u32 wcon_unexp_uc_resp : 1;              // DWORD 0
         u32 wcon_bad_wdma_resp : 1;              // DWORD 0
         u32 wcon_unexp_wdma_resp : 1;            // DWORD 0
         u32 wcon_ctx_perr : 1;                   // DWORD 0
         u32 wcon_d_parse : 1;                    // DWORD 0
         u32 CRB : 1;                             // DWORD 0
         u32 CmdWrPgOv : 1;                       // DWORD 0
         u32 UCbadCRA : 1;                        // DWORD 0
         u32 WDMAbadCRA : 1;                      // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK WCON_UE_SOURCE_CSR, *PWCON_UE_SOURCE_CSR;

      typedef union _WCON_UE_SOURCE_CSR_UNION {
         WCON_UE_SOURCE_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UE_SOURCE_CSR_UNION, *PWCON_UE_SOURCE_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UE_SOURCE_CSR_UNION, sizeof (WCON_UE_SOURCE_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC CRA Range Checker, Address High Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CRA_HI_CSR {
         union {
            struct { 
               u32 WDMArangeCheckEn : 1;          // DWORD 0
               u32 UCrangeCheckEn : 1;            // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 cra : 25;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_CRA_HI_CSR, *PWCON_CRA_HI_CSR;

      SG_C_ASSERT(__sizeof__WCON_CRA_HI_CSR, sizeof (WCON_CRA_HI_CSR) == 4);

   #else
      typedef struct _WCON_CRA_HI_CSR {
         u32 WDMArangeCheckEn : 1;                // DWORD 0
         u32 UCrangeCheckEn : 1;                  // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 cra : 25;                            // DWORD 0
      } SG_PACK WCON_CRA_HI_CSR, *PWCON_CRA_HI_CSR;

      typedef union _WCON_CRA_HI_CSR_UNION {
         WCON_CRA_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_CRA_HI_CSR_UNION, *PWCON_CRA_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_CRA_HI_CSR_UNION, sizeof (WCON_CRA_HI_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC CRA Range Checker, Address High Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CRA_HI_CSR {
         union {
            struct { 
               u32 cra : 25;                      // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 UCrangeCheckEn : 1;            // DWORD 0
               u32 WDMArangeCheckEn : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_CRA_HI_CSR, *PWCON_CRA_HI_CSR;

      SG_C_ASSERT(__sizeof__WCON_CRA_HI_CSR, sizeof (WCON_CRA_HI_CSR) == 4);

   #else
      typedef struct _WCON_CRA_HI_CSR {
         u32 cra : 25;                            // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 UCrangeCheckEn : 1;                  // DWORD 0
         u32 WDMArangeCheckEn : 1;                // DWORD 0
      } SG_PACK WCON_CRA_HI_CSR, *PWCON_CRA_HI_CSR;

      typedef union _WCON_CRA_HI_CSR_UNION {
         WCON_CRA_HI_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_CRA_HI_CSR_UNION, *PWCON_CRA_HI_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_CRA_HI_CSR_UNION, sizeof (WCON_CRA_HI_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC CRA Range Checker, Address Low Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CRA_LO_CSR {
         union {
            struct { 
               u32 rsvd0 : 7;                     // DWORD 0
               u32 cra : 25;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_CRA_LO_CSR, *PWCON_CRA_LO_CSR;

      SG_C_ASSERT(__sizeof__WCON_CRA_LO_CSR, sizeof (WCON_CRA_LO_CSR) == 4);

   #else
      typedef struct _WCON_CRA_LO_CSR {
         u32 rsvd0 : 7;                           // DWORD 0
         u32 cra : 25;                            // DWORD 0
      } SG_PACK WCON_CRA_LO_CSR, *PWCON_CRA_LO_CSR;

      typedef union _WCON_CRA_LO_CSR_UNION {
         WCON_CRA_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_CRA_LO_CSR_UNION, *PWCON_CRA_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_CRA_LO_CSR_UNION, sizeof (WCON_CRA_LO_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC CRA Range Checker, Address Low Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CRA_LO_CSR {
         union {
            struct { 
               u32 cra : 25;                      // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_CRA_LO_CSR, *PWCON_CRA_LO_CSR;

      SG_C_ASSERT(__sizeof__WCON_CRA_LO_CSR, sizeof (WCON_CRA_LO_CSR) == 4);

   #else
      typedef struct _WCON_CRA_LO_CSR {
         u32 cra : 25;                            // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
      } SG_PACK WCON_CRA_LO_CSR, *PWCON_CRA_LO_CSR;

      typedef union _WCON_CRA_LO_CSR_UNION {
         WCON_CRA_LO_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_CRA_LO_CSR_UNION, *PWCON_CRA_LO_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_CRA_LO_CSR_UNION, sizeof (WCON_CRA_LO_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC-Related Unrecoverable Error Details1 Register. This register
   // gets updated when a wcon_bad_uc_resp or wcon_unexp_uc_resp UE occurs. It is also
   // updated when a CRB UE of type WCON_CRBERR_DUPUCRESP or WCON_CRBERR_UCRESPINV or
   // WCON_CRBERR_POPNOTHEAD occurs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_UE_DETAILS1_CSR {
         union {
            struct { 
               u32 uc_resp_l;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR, *PRXULP_WCON_UC_UE_DETAILS1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS1_CSR, sizeof (RXULP_WCON_UC_UE_DETAILS1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_UE_DETAILS1_CSR {
         u32 uc_resp_l;                           // DWORD 0
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR, *PRXULP_WCON_UC_UE_DETAILS1_CSR;

      typedef union _RXULP_WCON_UC_UE_DETAILS1_CSR_UNION {
         RXULP_WCON_UC_UE_DETAILS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR_UNION, *PRXULP_WCON_UC_UE_DETAILS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS1_CSR_UNION, sizeof (RXULP_WCON_UC_UE_DETAILS1_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC-Related Unrecoverable Error Details1 Register. This register
   // gets updated when a wcon_bad_uc_resp or wcon_unexp_uc_resp UE occurs. It is also
   // updated when a CRB UE of type WCON_CRBERR_DUPUCRESP or WCON_CRBERR_UCRESPINV or
   // WCON_CRBERR_POPNOTHEAD occurs.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_UE_DETAILS1_CSR {
         union {
            struct { 
               u32 uc_resp_l;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR, *PRXULP_WCON_UC_UE_DETAILS1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS1_CSR, sizeof (RXULP_WCON_UC_UE_DETAILS1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_UE_DETAILS1_CSR {
         u32 uc_resp_l;                           // DWORD 0
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR, *PRXULP_WCON_UC_UE_DETAILS1_CSR;

      typedef union _RXULP_WCON_UC_UE_DETAILS1_CSR_UNION {
         RXULP_WCON_UC_UE_DETAILS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS1_CSR_UNION, *PRXULP_WCON_UC_UE_DETAILS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS1_CSR_UNION, sizeof (RXULP_WCON_UC_UE_DETAILS1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC-Related Unrecoverable Error Details2 Register. See
   // RXULP_WCON_UC_UE_DETAILS1_CSR for update conditions.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_UE_DETAILS2_CSR {
         union {
            struct { 
               u32 uc_resp_u;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR, *PRXULP_WCON_UC_UE_DETAILS2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS2_CSR, sizeof (RXULP_WCON_UC_UE_DETAILS2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_UE_DETAILS2_CSR {
         u32 uc_resp_u;                           // DWORD 0
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR, *PRXULP_WCON_UC_UE_DETAILS2_CSR;

      typedef union _RXULP_WCON_UC_UE_DETAILS2_CSR_UNION {
         RXULP_WCON_UC_UE_DETAILS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR_UNION, *PRXULP_WCON_UC_UE_DETAILS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS2_CSR_UNION, sizeof (RXULP_WCON_UC_UE_DETAILS2_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC-Related Unrecoverable Error Details2 Register. See
   // RXULP_WCON_UC_UE_DETAILS1_CSR for update conditions.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_UE_DETAILS2_CSR {
         union {
            struct { 
               u32 uc_resp_u;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR, *PRXULP_WCON_UC_UE_DETAILS2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS2_CSR, sizeof (RXULP_WCON_UC_UE_DETAILS2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_UE_DETAILS2_CSR {
         u32 uc_resp_u;                           // DWORD 0
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR, *PRXULP_WCON_UC_UE_DETAILS2_CSR;

      typedef union _RXULP_WCON_UC_UE_DETAILS2_CSR_UNION {
         RXULP_WCON_UC_UE_DETAILS2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_UE_DETAILS2_CSR_UNION, *PRXULP_WCON_UC_UE_DETAILS2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_UE_DETAILS2_CSR_UNION, sizeof (RXULP_WCON_UC_UE_DETAILS2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Details of Bad (CRA out of range) UC Request issued by WCON,
   // directly or indirectly (via WDMA).
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BAD_UC_REQ_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 opcode : 3;                    // DWORD 0
               u32 badcra : 25;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_BAD_UC_REQ_CSR, *PWCON_BAD_UC_REQ_CSR;

      SG_C_ASSERT(__sizeof__WCON_BAD_UC_REQ_CSR, sizeof (WCON_BAD_UC_REQ_CSR) == 4);

   #else
      typedef struct _WCON_BAD_UC_REQ_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 opcode : 3;                          // DWORD 0
         u32 badcra : 25;                         // DWORD 0
      } SG_PACK WCON_BAD_UC_REQ_CSR, *PWCON_BAD_UC_REQ_CSR;

      typedef union _WCON_BAD_UC_REQ_CSR_UNION {
         WCON_BAD_UC_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_BAD_UC_REQ_CSR_UNION, *PWCON_BAD_UC_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_BAD_UC_REQ_CSR_UNION, sizeof (WCON_BAD_UC_REQ_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Details of Bad (CRA out of range) UC Request issued by WCON,
   // directly or indirectly (via WDMA).
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_BAD_UC_REQ_CSR {
         union {
            struct { 
               u32 badcra : 25;                   // DWORD 0
               u32 opcode : 3;                    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_BAD_UC_REQ_CSR, *PWCON_BAD_UC_REQ_CSR;

      SG_C_ASSERT(__sizeof__WCON_BAD_UC_REQ_CSR, sizeof (WCON_BAD_UC_REQ_CSR) == 4);

   #else
      typedef struct _WCON_BAD_UC_REQ_CSR {
         u32 badcra : 25;                         // DWORD 0
         u32 opcode : 3;                          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK WCON_BAD_UC_REQ_CSR, *PWCON_BAD_UC_REQ_CSR;

      typedef union _WCON_BAD_UC_REQ_CSR_UNION {
         WCON_BAD_UC_REQ_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_BAD_UC_REQ_CSR_UNION, *PWCON_BAD_UC_REQ_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_BAD_UC_REQ_CSR_UNION, sizeof (WCON_BAD_UC_REQ_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Unrecoverable Error Details1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UE_DETAILS1_CSR {
         union {
            struct { 
               u32 rsvd0 : 15;                    // DWORD 0
               u32 dbgTag : 5;                    // DWORD 0
               u32 crb_errtype : 4;               // DWORD 0
               u32 wdma_pducrc_error : 1;         // DWORD 0
               u32 wdma_host_error : 1;           // DWORD 0
               u32 wcon_d_parse_errclient : 1;    // DWORD 0
               u32 wcon_d_parse_errtype : 5;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR, *PRXULP_WCON_UE_DETAILS1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UE_DETAILS1_CSR, sizeof (RXULP_WCON_UE_DETAILS1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UE_DETAILS1_CSR {
         u32 rsvd0 : 15;                          // DWORD 0
         u32 dbgTag : 5;                          // DWORD 0
         u32 crb_errtype : 4;                     // DWORD 0
         u32 wdma_pducrc_error : 1;               // DWORD 0
         u32 wdma_host_error : 1;                 // DWORD 0
         u32 wcon_d_parse_errclient : 1;          // DWORD 0
         u32 wcon_d_parse_errtype : 5;            // DWORD 0
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR, *PRXULP_WCON_UE_DETAILS1_CSR;

      typedef union _RXULP_WCON_UE_DETAILS1_CSR_UNION {
         RXULP_WCON_UE_DETAILS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR_UNION, *PRXULP_WCON_UE_DETAILS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UE_DETAILS1_CSR_UNION, sizeof (RXULP_WCON_UE_DETAILS1_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Unrecoverable Error Details1 Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UE_DETAILS1_CSR {
         union {
            struct { 
               u32 wcon_d_parse_errtype : 5;      // DWORD 0
               u32 wcon_d_parse_errclient : 1;    // DWORD 0
               u32 wdma_host_error : 1;           // DWORD 0
               u32 wdma_pducrc_error : 1;         // DWORD 0
               u32 crb_errtype : 4;               // DWORD 0
               u32 dbgTag : 5;                    // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR, *PRXULP_WCON_UE_DETAILS1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UE_DETAILS1_CSR, sizeof (RXULP_WCON_UE_DETAILS1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UE_DETAILS1_CSR {
         u32 wcon_d_parse_errtype : 5;            // DWORD 0
         u32 wcon_d_parse_errclient : 1;          // DWORD 0
         u32 wdma_host_error : 1;                 // DWORD 0
         u32 wdma_pducrc_error : 1;               // DWORD 0
         u32 crb_errtype : 4;                     // DWORD 0
         u32 dbgTag : 5;                          // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR, *PRXULP_WCON_UE_DETAILS1_CSR;

      typedef union _RXULP_WCON_UE_DETAILS1_CSR_UNION {
         RXULP_WCON_UE_DETAILS1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UE_DETAILS1_CSR_UNION, *PRXULP_WCON_UE_DETAILS1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UE_DETAILS1_CSR_UNION, sizeof (RXULP_WCON_UE_DETAILS1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of WCON_D requests received from both RxULP clients.
   // For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 wcon_d_cnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_CNT_CSR, *PRXULP_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_CNT_CSR, sizeof (RXULP_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_CNT_CSR {
         u32 wcon_d_cnt;                          // DWORD 0
      } SG_PACK RXULP_WCON_D_CNT_CSR, *PRXULP_WCON_D_CNT_CSR;

      typedef union _RXULP_WCON_D_CNT_CSR_UNION {
         RXULP_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_CNT_CSR_UNION, *PRXULP_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_CNT_CSR_UNION, sizeof (RXULP_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of WCON_D requests received from both RxULP clients.
   // For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 wcon_d_cnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_CNT_CSR, *PRXULP_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_CNT_CSR, sizeof (RXULP_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_CNT_CSR {
         u32 wcon_d_cnt;                          // DWORD 0
      } SG_PACK RXULP_WCON_D_CNT_CSR, *PRXULP_WCON_D_CNT_CSR;

      typedef union _RXULP_WCON_D_CNT_CSR_UNION {
         RXULP_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_CNT_CSR_UNION, *PRXULP_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_CNT_CSR_UNION, sizeof (RXULP_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of zero-byte WCON_D requests received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D0_CNT_CSR {
         union {
            struct { 
               u32 wcon_d0_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D0_CNT_CSR, *PRXULP_WCON_D0_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D0_CNT_CSR, sizeof (RXULP_WCON_D0_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D0_CNT_CSR {
         u32 wcon_d0_cnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_D0_CNT_CSR, *PRXULP_WCON_D0_CNT_CSR;

      typedef union _RXULP_WCON_D0_CNT_CSR_UNION {
         RXULP_WCON_D0_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D0_CNT_CSR_UNION, *PRXULP_WCON_D0_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D0_CNT_CSR_UNION, sizeof (RXULP_WCON_D0_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of zero-byte WCON_D requests received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D0_CNT_CSR {
         union {
            struct { 
               u32 wcon_d0_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D0_CNT_CSR, *PRXULP_WCON_D0_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D0_CNT_CSR, sizeof (RXULP_WCON_D0_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D0_CNT_CSR {
         u32 wcon_d0_cnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_D0_CNT_CSR, *PRXULP_WCON_D0_CNT_CSR;

      typedef union _RXULP_WCON_D0_CNT_CSR_UNION {
         RXULP_WCON_D0_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D0_CNT_CSR_UNION, *PRXULP_WCON_D0_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D0_CNT_CSR_UNION, sizeof (RXULP_WCON_D0_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of Block Mode WCON_D requests received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_BM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 bm_wcon_d_cnt;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR, *PRXULP_BM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_BM_WCON_D_CNT_CSR, sizeof (RXULP_BM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_BM_WCON_D_CNT_CSR {
         u32 bm_wcon_d_cnt;                       // DWORD 0
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR, *PRXULP_BM_WCON_D_CNT_CSR;

      typedef union _RXULP_BM_WCON_D_CNT_CSR_UNION {
         RXULP_BM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR_UNION, *PRXULP_BM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_BM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_BM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of Block Mode WCON_D requests received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_BM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 bm_wcon_d_cnt;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR, *PRXULP_BM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_BM_WCON_D_CNT_CSR, sizeof (RXULP_BM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_BM_WCON_D_CNT_CSR {
         u32 bm_wcon_d_cnt;                       // DWORD 0
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR, *PRXULP_BM_WCON_D_CNT_CSR;

      typedef union _RXULP_BM_WCON_D_CNT_CSR_UNION {
         RXULP_BM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_BM_WCON_D_CNT_CSR_UNION, *PRXULP_BM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_BM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_BM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of Non-Packed Page Mode WCON_D requests received
   // from both RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 pm_wcon_d_cnt;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR, *PRXULP_PM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PM_WCON_D_CNT_CSR, sizeof (RXULP_PM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PM_WCON_D_CNT_CSR {
         u32 pm_wcon_d_cnt;                       // DWORD 0
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR, *PRXULP_PM_WCON_D_CNT_CSR;

      typedef union _RXULP_PM_WCON_D_CNT_CSR_UNION {
         RXULP_PM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR_UNION, *PRXULP_PM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_PM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of Non-Packed Page Mode WCON_D requests received
   // from both RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 pm_wcon_d_cnt;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR, *PRXULP_PM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PM_WCON_D_CNT_CSR, sizeof (RXULP_PM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PM_WCON_D_CNT_CSR {
         u32 pm_wcon_d_cnt;                       // DWORD 0
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR, *PRXULP_PM_WCON_D_CNT_CSR;

      typedef union _RXULP_PM_WCON_D_CNT_CSR_UNION {
         RXULP_PM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PM_WCON_D_CNT_CSR_UNION, *PRXULP_PM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_PM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of Packed Page Mode WCON_D requests received from
   // both RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PPM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 ppm_wcon_d_cnt;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR, *PRXULP_PPM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PPM_WCON_D_CNT_CSR, sizeof (RXULP_PPM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PPM_WCON_D_CNT_CSR {
         u32 ppm_wcon_d_cnt;                      // DWORD 0
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR, *PRXULP_PPM_WCON_D_CNT_CSR;

      typedef union _RXULP_PPM_WCON_D_CNT_CSR_UNION {
         RXULP_PPM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR_UNION, *PRXULP_PPM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PPM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_PPM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of Packed Page Mode WCON_D requests received from
   // both RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PPM_WCON_D_CNT_CSR {
         union {
            struct { 
               u32 ppm_wcon_d_cnt;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR, *PRXULP_PPM_WCON_D_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PPM_WCON_D_CNT_CSR, sizeof (RXULP_PPM_WCON_D_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PPM_WCON_D_CNT_CSR {
         u32 ppm_wcon_d_cnt;                      // DWORD 0
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR, *PRXULP_PPM_WCON_D_CNT_CSR;

      typedef union _RXULP_PPM_WCON_D_CNT_CSR_UNION {
         RXULP_PPM_WCON_D_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PPM_WCON_D_CNT_CSR_UNION, *PRXULP_PPM_WCON_D_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PPM_WCON_D_CNT_CSR_UNION, sizeof (RXULP_PPM_WCON_D_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of PDU CQEs received from both RxULP clients. For
   // debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PDU_CQE_CNT_CSR {
         union {
            struct { 
               u32 pdu_cqe_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PDU_CQE_CNT_CSR, *PRXULP_PDU_CQE_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CQE_CNT_CSR, sizeof (RXULP_PDU_CQE_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PDU_CQE_CNT_CSR {
         u32 pdu_cqe_cnt;                         // DWORD 0
      } SG_PACK RXULP_PDU_CQE_CNT_CSR, *PRXULP_PDU_CQE_CNT_CSR;

      typedef union _RXULP_PDU_CQE_CNT_CSR_UNION {
         RXULP_PDU_CQE_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PDU_CQE_CNT_CSR_UNION, *PRXULP_PDU_CQE_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CQE_CNT_CSR_UNION, sizeof (RXULP_PDU_CQE_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of PDU CQEs received from both RxULP clients. For
   // debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PDU_CQE_CNT_CSR {
         union {
            struct { 
               u32 pdu_cqe_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PDU_CQE_CNT_CSR, *PRXULP_PDU_CQE_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CQE_CNT_CSR, sizeof (RXULP_PDU_CQE_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PDU_CQE_CNT_CSR {
         u32 pdu_cqe_cnt;                         // DWORD 0
      } SG_PACK RXULP_PDU_CQE_CNT_CSR, *PRXULP_PDU_CQE_CNT_CSR;

      typedef union _RXULP_PDU_CQE_CNT_CSR_UNION {
         RXULP_PDU_CQE_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PDU_CQE_CNT_CSR_UNION, *PRXULP_PDU_CQE_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CQE_CNT_CSR_UNION, sizeof (RXULP_PDU_CQE_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of PDU received from both RxULP clients. The counter
   // is incremented when WCON receives a request with WCON_D:crc_en and WCON_D:crc_end
   // bits set. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PDU_CNT_CSR {
         union {
            struct { 
               u32 pdu_cnt;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PDU_CNT_CSR, *PRXULP_PDU_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CNT_CSR, sizeof (RXULP_PDU_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PDU_CNT_CSR {
         u32 pdu_cnt;                             // DWORD 0
      } SG_PACK RXULP_PDU_CNT_CSR, *PRXULP_PDU_CNT_CSR;

      typedef union _RXULP_PDU_CNT_CSR_UNION {
         RXULP_PDU_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PDU_CNT_CSR_UNION, *PRXULP_PDU_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CNT_CSR_UNION, sizeof (RXULP_PDU_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of PDU received from both RxULP clients. The counter
   // is incremented when WCON receives a request with WCON_D:crc_en and WCON_D:crc_end
   // bits set. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_PDU_CNT_CSR {
         union {
            struct { 
               u32 pdu_cnt;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_PDU_CNT_CSR, *PRXULP_PDU_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CNT_CSR, sizeof (RXULP_PDU_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_PDU_CNT_CSR {
         u32 pdu_cnt;                             // DWORD 0
      } SG_PACK RXULP_PDU_CNT_CSR, *PRXULP_PDU_CNT_CSR;

      typedef union _RXULP_PDU_CNT_CSR_UNION {
         RXULP_PDU_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_PDU_CNT_CSR_UNION, *PRXULP_PDU_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_PDU_CNT_CSR_UNION, sizeof (RXULP_PDU_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD0. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D0_CSR {
         union {
            struct { 
               u32 wcon_d_d0;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D0_CSR, *PRXULP_WCON_D_D0_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D0_CSR, sizeof (RXULP_WCON_D_D0_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D0_CSR {
         u32 wcon_d_d0;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D0_CSR, *PRXULP_WCON_D_D0_CSR;

      typedef union _RXULP_WCON_D_D0_CSR_UNION {
         RXULP_WCON_D_D0_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D0_CSR_UNION, *PRXULP_WCON_D_D0_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D0_CSR_UNION, sizeof (RXULP_WCON_D_D0_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD0. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D0_CSR {
         union {
            struct { 
               u32 wcon_d_d0;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D0_CSR, *PRXULP_WCON_D_D0_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D0_CSR, sizeof (RXULP_WCON_D_D0_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D0_CSR {
         u32 wcon_d_d0;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D0_CSR, *PRXULP_WCON_D_D0_CSR;

      typedef union _RXULP_WCON_D_D0_CSR_UNION {
         RXULP_WCON_D_D0_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D0_CSR_UNION, *PRXULP_WCON_D_D0_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D0_CSR_UNION, sizeof (RXULP_WCON_D_D0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD1. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D1_CSR {
         union {
            struct { 
               u32 wcon_d_d1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D1_CSR, *PRXULP_WCON_D_D1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D1_CSR, sizeof (RXULP_WCON_D_D1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D1_CSR {
         u32 wcon_d_d1;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D1_CSR, *PRXULP_WCON_D_D1_CSR;

      typedef union _RXULP_WCON_D_D1_CSR_UNION {
         RXULP_WCON_D_D1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D1_CSR_UNION, *PRXULP_WCON_D_D1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D1_CSR_UNION, sizeof (RXULP_WCON_D_D1_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD1. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D1_CSR {
         union {
            struct { 
               u32 wcon_d_d1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D1_CSR, *PRXULP_WCON_D_D1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D1_CSR, sizeof (RXULP_WCON_D_D1_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D1_CSR {
         u32 wcon_d_d1;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D1_CSR, *PRXULP_WCON_D_D1_CSR;

      typedef union _RXULP_WCON_D_D1_CSR_UNION {
         RXULP_WCON_D_D1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D1_CSR_UNION, *PRXULP_WCON_D_D1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D1_CSR_UNION, sizeof (RXULP_WCON_D_D1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD2. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D2_CSR {
         union {
            struct { 
               u32 wcon_d_d2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D2_CSR, *PRXULP_WCON_D_D2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D2_CSR, sizeof (RXULP_WCON_D_D2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D2_CSR {
         u32 wcon_d_d2;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D2_CSR, *PRXULP_WCON_D_D2_CSR;

      typedef union _RXULP_WCON_D_D2_CSR_UNION {
         RXULP_WCON_D_D2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D2_CSR_UNION, *PRXULP_WCON_D_D2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D2_CSR_UNION, sizeof (RXULP_WCON_D_D2_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD2. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D2_CSR {
         union {
            struct { 
               u32 wcon_d_d2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D2_CSR, *PRXULP_WCON_D_D2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D2_CSR, sizeof (RXULP_WCON_D_D2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D2_CSR {
         u32 wcon_d_d2;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D2_CSR, *PRXULP_WCON_D_D2_CSR;

      typedef union _RXULP_WCON_D_D2_CSR_UNION {
         RXULP_WCON_D_D2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D2_CSR_UNION, *PRXULP_WCON_D_D2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D2_CSR_UNION, sizeof (RXULP_WCON_D_D2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD3. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D3_CSR {
         union {
            struct { 
               u32 wcon_d_d3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D3_CSR, *PRXULP_WCON_D_D3_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D3_CSR, sizeof (RXULP_WCON_D_D3_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D3_CSR {
         u32 wcon_d_d3;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D3_CSR, *PRXULP_WCON_D_D3_CSR;

      typedef union _RXULP_WCON_D_D3_CSR_UNION {
         RXULP_WCON_D_D3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D3_CSR_UNION, *PRXULP_WCON_D_D3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D3_CSR_UNION, sizeof (RXULP_WCON_D_D3_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD3. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D3_CSR {
         union {
            struct { 
               u32 wcon_d_d3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D3_CSR, *PRXULP_WCON_D_D3_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D3_CSR, sizeof (RXULP_WCON_D_D3_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D3_CSR {
         u32 wcon_d_d3;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D3_CSR, *PRXULP_WCON_D_D3_CSR;

      typedef union _RXULP_WCON_D_D3_CSR_UNION {
         RXULP_WCON_D_D3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D3_CSR_UNION, *PRXULP_WCON_D_D3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D3_CSR_UNION, sizeof (RXULP_WCON_D_D3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD4. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D4_CSR {
         union {
            struct { 
               u32 wcon_d_d4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D4_CSR, *PRXULP_WCON_D_D4_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D4_CSR, sizeof (RXULP_WCON_D_D4_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D4_CSR {
         u32 wcon_d_d4;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D4_CSR, *PRXULP_WCON_D_D4_CSR;

      typedef union _RXULP_WCON_D_D4_CSR_UNION {
         RXULP_WCON_D_D4_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D4_CSR_UNION, *PRXULP_WCON_D_D4_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D4_CSR_UNION, sizeof (RXULP_WCON_D_D4_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD4. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D4_CSR {
         union {
            struct { 
               u32 wcon_d_d4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D4_CSR, *PRXULP_WCON_D_D4_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D4_CSR, sizeof (RXULP_WCON_D_D4_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D4_CSR {
         u32 wcon_d_d4;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D4_CSR, *PRXULP_WCON_D_D4_CSR;

      typedef union _RXULP_WCON_D_D4_CSR_UNION {
         RXULP_WCON_D_D4_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D4_CSR_UNION, *PRXULP_WCON_D_D4_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D4_CSR_UNION, sizeof (RXULP_WCON_D_D4_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of latest WCON_D request, DWORD5. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D5_CSR {
         union {
            struct { 
               u32 wcon_d_d5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D5_CSR, *PRXULP_WCON_D_D5_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D5_CSR, sizeof (RXULP_WCON_D_D5_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D5_CSR {
         u32 wcon_d_d5;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D5_CSR, *PRXULP_WCON_D_D5_CSR;

      typedef union _RXULP_WCON_D_D5_CSR_UNION {
         RXULP_WCON_D_D5_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D5_CSR_UNION, *PRXULP_WCON_D_D5_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D5_CSR_UNION, sizeof (RXULP_WCON_D_D5_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of latest WCON_D request, DWORD5. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_D_D5_CSR {
         union {
            struct { 
               u32 wcon_d_d5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_D_D5_CSR, *PRXULP_WCON_D_D5_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D5_CSR, sizeof (RXULP_WCON_D_D5_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_D_D5_CSR {
         u32 wcon_d_d5;                           // DWORD 0
      } SG_PACK RXULP_WCON_D_D5_CSR, *PRXULP_WCON_D_D5_CSR;

      typedef union _RXULP_WCON_D_D5_CSR_UNION {
         RXULP_WCON_D_D5_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_D_D5_CSR_UNION, *PRXULP_WCON_D_D5_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_D_D5_CSR_UNION, sizeof (RXULP_WCON_D_D5_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD0.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D0_CSR {
         union {
            struct { 
               u32 wcon_cqe_d0;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D0_CSR, *PRXULP_CQE_D0_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D0_CSR, sizeof (RXULP_CQE_D0_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D0_CSR {
         u32 wcon_cqe_d0;                         // DWORD 0
      } SG_PACK RXULP_CQE_D0_CSR, *PRXULP_CQE_D0_CSR;

      typedef union _RXULP_CQE_D0_CSR_UNION {
         RXULP_CQE_D0_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D0_CSR_UNION, *PRXULP_CQE_D0_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D0_CSR_UNION, sizeof (RXULP_CQE_D0_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD0.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D0_CSR {
         union {
            struct { 
               u32 wcon_cqe_d0;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D0_CSR, *PRXULP_CQE_D0_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D0_CSR, sizeof (RXULP_CQE_D0_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D0_CSR {
         u32 wcon_cqe_d0;                         // DWORD 0
      } SG_PACK RXULP_CQE_D0_CSR, *PRXULP_CQE_D0_CSR;

      typedef union _RXULP_CQE_D0_CSR_UNION {
         RXULP_CQE_D0_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D0_CSR_UNION, *PRXULP_CQE_D0_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D0_CSR_UNION, sizeof (RXULP_CQE_D0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD1.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D1_CSR {
         union {
            struct { 
               u32 wcon_cqe_d1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D1_CSR, *PRXULP_CQE_D1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D1_CSR, sizeof (RXULP_CQE_D1_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D1_CSR {
         u32 wcon_cqe_d1;                         // DWORD 0
      } SG_PACK RXULP_CQE_D1_CSR, *PRXULP_CQE_D1_CSR;

      typedef union _RXULP_CQE_D1_CSR_UNION {
         RXULP_CQE_D1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D1_CSR_UNION, *PRXULP_CQE_D1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D1_CSR_UNION, sizeof (RXULP_CQE_D1_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD1.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D1_CSR {
         union {
            struct { 
               u32 wcon_cqe_d1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D1_CSR, *PRXULP_CQE_D1_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D1_CSR, sizeof (RXULP_CQE_D1_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D1_CSR {
         u32 wcon_cqe_d1;                         // DWORD 0
      } SG_PACK RXULP_CQE_D1_CSR, *PRXULP_CQE_D1_CSR;

      typedef union _RXULP_CQE_D1_CSR_UNION {
         RXULP_CQE_D1_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D1_CSR_UNION, *PRXULP_CQE_D1_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D1_CSR_UNION, sizeof (RXULP_CQE_D1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD2.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D2_CSR {
         union {
            struct { 
               u32 wcon_cqe_d2;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D2_CSR, *PRXULP_CQE_D2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D2_CSR, sizeof (RXULP_CQE_D2_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D2_CSR {
         u32 wcon_cqe_d2;                         // DWORD 0
      } SG_PACK RXULP_CQE_D2_CSR, *PRXULP_CQE_D2_CSR;

      typedef union _RXULP_CQE_D2_CSR_UNION {
         RXULP_CQE_D2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D2_CSR_UNION, *PRXULP_CQE_D2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D2_CSR_UNION, sizeof (RXULP_CQE_D2_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD2.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D2_CSR {
         union {
            struct { 
               u32 wcon_cqe_d2;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D2_CSR, *PRXULP_CQE_D2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D2_CSR, sizeof (RXULP_CQE_D2_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D2_CSR {
         u32 wcon_cqe_d2;                         // DWORD 0
      } SG_PACK RXULP_CQE_D2_CSR, *PRXULP_CQE_D2_CSR;

      typedef union _RXULP_CQE_D2_CSR_UNION {
         RXULP_CQE_D2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D2_CSR_UNION, *PRXULP_CQE_D2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D2_CSR_UNION, sizeof (RXULP_CQE_D2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD3.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D3_CSR {
         union {
            struct { 
               u32 wcon_cqe_d3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D3_CSR, *PRXULP_CQE_D3_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D3_CSR, sizeof (RXULP_CQE_D3_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D3_CSR {
         u32 wcon_cqe_d3;                         // DWORD 0
      } SG_PACK RXULP_CQE_D3_CSR, *PRXULP_CQE_D3_CSR;

      typedef union _RXULP_CQE_D3_CSR_UNION {
         RXULP_CQE_D3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D3_CSR_UNION, *PRXULP_CQE_D3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D3_CSR_UNION, sizeof (RXULP_CQE_D3_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, content of most recent CQE pushed with a WCON_D request, DWORD3.
   // For debug purposes. Note: this will not match most recent WCON_D content in
   // RXULP_WCON_D_Dx_CSRs if the latter is CQE-less. Also, these CSRs record the CQE
   // content at the start of the WCON pipeline, before WCON updates, if any, occur.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CQE_D3_CSR {
         union {
            struct { 
               u32 wcon_cqe_d3;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CQE_D3_CSR, *PRXULP_CQE_D3_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D3_CSR, sizeof (RXULP_CQE_D3_CSR) == 4);

   #else
      typedef struct _RXULP_CQE_D3_CSR {
         u32 wcon_cqe_d3;                         // DWORD 0
      } SG_PACK RXULP_CQE_D3_CSR, *PRXULP_CQE_D3_CSR;

      typedef union _RXULP_CQE_D3_CSR_UNION {
         RXULP_CQE_D3_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CQE_D3_CSR_UNION, *PRXULP_CQE_D3_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CQE_D3_CSR_UNION, sizeof (RXULP_CQE_D3_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, total number of Command-closing (Status) CQEs received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CMD_CQE_CNT_CSR {
         union {
            struct { 
               u32 cmd_cqe_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CMD_CQE_CNT_CSR, *PRXULP_CMD_CQE_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CMD_CQE_CNT_CSR, sizeof (RXULP_CMD_CQE_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_CMD_CQE_CNT_CSR {
         u32 cmd_cqe_cnt;                         // DWORD 0
      } SG_PACK RXULP_CMD_CQE_CNT_CSR, *PRXULP_CMD_CQE_CNT_CSR;

      typedef union _RXULP_CMD_CQE_CNT_CSR_UNION {
         RXULP_CMD_CQE_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CMD_CQE_CNT_CSR_UNION, *PRXULP_CMD_CQE_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CMD_CQE_CNT_CSR_UNION, sizeof (RXULP_CMD_CQE_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, total number of Command-closing (Status) CQEs received from both
   // RxULP clients. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_CMD_CQE_CNT_CSR {
         union {
            struct { 
               u32 cmd_cqe_cnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_CMD_CQE_CNT_CSR, *PRXULP_CMD_CQE_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_CMD_CQE_CNT_CSR, sizeof (RXULP_CMD_CQE_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_CMD_CQE_CNT_CSR {
         u32 cmd_cqe_cnt;                         // DWORD 0
      } SG_PACK RXULP_CMD_CQE_CNT_CSR, *PRXULP_CMD_CQE_CNT_CSR;

      typedef union _RXULP_CMD_CQE_CNT_CSR_UNION {
         RXULP_CMD_CQE_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_CMD_CQE_CNT_CSR_UNION, *PRXULP_CMD_CQE_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_CMD_CQE_CNT_CSR_UNION, sizeof (RXULP_CMD_CQE_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC Read (Access+) counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_RD_CNT_CSR {
         union {
            struct { 
               u32 ucReqCnt;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR, *PRXULP_WCON_UC_RD_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_RD_CNT_CSR, sizeof (RXULP_WCON_UC_RD_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_RD_CNT_CSR {
         u32 ucReqCnt;                            // DWORD 0
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR, *PRXULP_WCON_UC_RD_CNT_CSR;

      typedef union _RXULP_WCON_UC_RD_CNT_CSR_UNION {
         RXULP_WCON_UC_RD_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR_UNION, *PRXULP_WCON_UC_RD_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_RD_CNT_CSR_UNION, sizeof (RXULP_WCON_UC_RD_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC Read (Access+) counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_RD_CNT_CSR {
         union {
            struct { 
               u32 ucReqCnt;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR, *PRXULP_WCON_UC_RD_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_RD_CNT_CSR, sizeof (RXULP_WCON_UC_RD_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_RD_CNT_CSR {
         u32 ucReqCnt;                            // DWORD 0
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR, *PRXULP_WCON_UC_RD_CNT_CSR;

      typedef union _RXULP_WCON_UC_RD_CNT_CSR_UNION {
         RXULP_WCON_UC_RD_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_RD_CNT_CSR_UNION, *PRXULP_WCON_UC_RD_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_RD_CNT_CSR_UNION, sizeof (RXULP_WCON_UC_RD_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC Response counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UC_RESP_CNT_CSR {
         union {
            struct { 
               u32 UCrespCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UC_RESP_CNT_CSR, *PWCON_UC_RESP_CNT_CSR;

      SG_C_ASSERT(__sizeof__WCON_UC_RESP_CNT_CSR, sizeof (WCON_UC_RESP_CNT_CSR) == 4);

   #else
      typedef struct _WCON_UC_RESP_CNT_CSR {
         u32 UCrespCnt;                           // DWORD 0
      } SG_PACK WCON_UC_RESP_CNT_CSR, *PWCON_UC_RESP_CNT_CSR;

      typedef union _WCON_UC_RESP_CNT_CSR_UNION {
         WCON_UC_RESP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UC_RESP_CNT_CSR_UNION, *PWCON_UC_RESP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UC_RESP_CNT_CSR_UNION, sizeof (WCON_UC_RESP_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC Response counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_UC_RESP_CNT_CSR {
         union {
            struct { 
               u32 UCrespCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK WCON_UC_RESP_CNT_CSR, *PWCON_UC_RESP_CNT_CSR;

      SG_C_ASSERT(__sizeof__WCON_UC_RESP_CNT_CSR, sizeof (WCON_UC_RESP_CNT_CSR) == 4);

   #else
      typedef struct _WCON_UC_RESP_CNT_CSR {
         u32 UCrespCnt;                           // DWORD 0
      } SG_PACK WCON_UC_RESP_CNT_CSR, *PWCON_UC_RESP_CNT_CSR;

      typedef union _WCON_UC_RESP_CNT_CSR_UNION {
         WCON_UC_RESP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK WCON_UC_RESP_CNT_CSR_UNION, *PWCON_UC_RESP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__WCON_UC_RESP_CNT_CSR_UNION, sizeof (WCON_UC_RESP_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, UC Invalidate counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_INV_CNT_CSR {
         union {
            struct { 
               u32 ucInvCnt;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR, *PRXULP_WCON_UC_INV_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_INV_CNT_CSR, sizeof (RXULP_WCON_UC_INV_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_INV_CNT_CSR {
         u32 ucInvCnt;                            // DWORD 0
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR, *PRXULP_WCON_UC_INV_CNT_CSR;

      typedef union _RXULP_WCON_UC_INV_CNT_CSR_UNION {
         RXULP_WCON_UC_INV_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR_UNION, *PRXULP_WCON_UC_INV_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_INV_CNT_CSR_UNION, sizeof (RXULP_WCON_UC_INV_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, UC Invalidate counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_UC_INV_CNT_CSR {
         union {
            struct { 
               u32 ucInvCnt;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR, *PRXULP_WCON_UC_INV_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_INV_CNT_CSR, sizeof (RXULP_WCON_UC_INV_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_UC_INV_CNT_CSR {
         u32 ucInvCnt;                            // DWORD 0
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR, *PRXULP_WCON_UC_INV_CNT_CSR;

      typedef union _RXULP_WCON_UC_INV_CNT_CSR_UNION {
         RXULP_WCON_UC_INV_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_UC_INV_CNT_CSR_UNION, *PRXULP_WCON_UC_INV_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_UC_INV_CNT_CSR_UNION, sizeof (RXULP_WCON_UC_INV_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, CEV Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CEV_REQ_CNT_CSR {
         union {
            struct { 
               u32 CEVreqCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR, *PRXULP_WCON_CEV_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CEV_REQ_CNT_CSR, sizeof (RXULP_WCON_CEV_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CEV_REQ_CNT_CSR {
         u32 CEVreqCnt;                           // DWORD 0
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR, *PRXULP_WCON_CEV_REQ_CNT_CSR;

      typedef union _RXULP_WCON_CEV_REQ_CNT_CSR_UNION {
         RXULP_WCON_CEV_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR_UNION, *PRXULP_WCON_CEV_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CEV_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_CEV_REQ_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, CEV Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CEV_REQ_CNT_CSR {
         union {
            struct { 
               u32 CEVreqCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR, *PRXULP_WCON_CEV_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CEV_REQ_CNT_CSR, sizeof (RXULP_WCON_CEV_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CEV_REQ_CNT_CSR {
         u32 CEVreqCnt;                           // DWORD 0
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR, *PRXULP_WCON_CEV_REQ_CNT_CSR;

      typedef union _RXULP_WCON_CEV_REQ_CNT_CSR_UNION {
         RXULP_WCON_CEV_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CEV_REQ_CNT_CSR_UNION, *PRXULP_WCON_CEV_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CEV_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_CEV_REQ_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, number of UC Release requests issued directly by WCON (as opposed
   // to indirectly via WDMA. This occurs when a Seek entirely consumes a UC line, for
   // example.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_SEEK_REL_CNT_CSR {
         union {
            struct { 
               u32 wcon_rel_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR, *PRXULP_WCON_SEEK_REL_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_SEEK_REL_CNT_CSR, sizeof (RXULP_WCON_SEEK_REL_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_SEEK_REL_CNT_CSR {
         u32 wcon_rel_cnt;                        // DWORD 0
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR, *PRXULP_WCON_SEEK_REL_CNT_CSR;

      typedef union _RXULP_WCON_SEEK_REL_CNT_CSR_UNION {
         RXULP_WCON_SEEK_REL_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR_UNION, *PRXULP_WCON_SEEK_REL_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_SEEK_REL_CNT_CSR_UNION, sizeof (RXULP_WCON_SEEK_REL_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, number of UC Release requests issued directly by WCON (as opposed
   // to indirectly via WDMA. This occurs when a Seek entirely consumes a UC line, for
   // example.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_SEEK_REL_CNT_CSR {
         union {
            struct { 
               u32 wcon_rel_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR, *PRXULP_WCON_SEEK_REL_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_SEEK_REL_CNT_CSR, sizeof (RXULP_WCON_SEEK_REL_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_SEEK_REL_CNT_CSR {
         u32 wcon_rel_cnt;                        // DWORD 0
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR, *PRXULP_WCON_SEEK_REL_CNT_CSR;

      typedef union _RXULP_WCON_SEEK_REL_CNT_CSR_UNION {
         RXULP_WCON_SEEK_REL_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_SEEK_REL_CNT_CSR_UNION, *PRXULP_WCON_SEEK_REL_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_SEEK_REL_CNT_CSR_UNION, sizeof (RXULP_WCON_SEEK_REL_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, number of UC Release requests issued indirectly by WCON via a
   // WDMA operation. This is the primary UC Release mechanism used by WCON.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_REL_CNT_CSR {
         union {
            struct { 
               u32 wcon_rel_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR, *PRXULP_WCON_WDMA_REL_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REL_CNT_CSR, sizeof (RXULP_WCON_WDMA_REL_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_REL_CNT_CSR {
         u32 wcon_rel_cnt;                        // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR, *PRXULP_WCON_WDMA_REL_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_REL_CNT_CSR_UNION {
         RXULP_WCON_WDMA_REL_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR_UNION, *PRXULP_WCON_WDMA_REL_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REL_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_REL_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, number of UC Release requests issued indirectly by WCON via a
   // WDMA operation. This is the primary UC Release mechanism used by WCON.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_REL_CNT_CSR {
         union {
            struct { 
               u32 wcon_rel_cnt;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR, *PRXULP_WCON_WDMA_REL_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REL_CNT_CSR, sizeof (RXULP_WCON_WDMA_REL_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_REL_CNT_CSR {
         u32 wcon_rel_cnt;                        // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR, *PRXULP_WCON_WDMA_REL_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_REL_CNT_CSR_UNION {
         RXULP_WCON_WDMA_REL_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_REL_CNT_CSR_UNION, *PRXULP_WCON_WDMA_REL_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REL_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_REL_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Command Re-order Buffer request (WCON_D) pop counter. For debug
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CRB_POP_CNT_CSR {
         union {
            struct { 
               u32 CRPpopCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR, *PRXULP_WCON_CRB_POP_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CRB_POP_CNT_CSR, sizeof (RXULP_WCON_CRB_POP_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CRB_POP_CNT_CSR {
         u32 CRPpopCnt;                           // DWORD 0
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR, *PRXULP_WCON_CRB_POP_CNT_CSR;

      typedef union _RXULP_WCON_CRB_POP_CNT_CSR_UNION {
         RXULP_WCON_CRB_POP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR_UNION, *PRXULP_WCON_CRB_POP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CRB_POP_CNT_CSR_UNION, sizeof (RXULP_WCON_CRB_POP_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Command Re-order Buffer request (WCON_D) pop counter. For debug
   // purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CRB_POP_CNT_CSR {
         union {
            struct { 
               u32 CRPpopCnt;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR, *PRXULP_WCON_CRB_POP_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CRB_POP_CNT_CSR, sizeof (RXULP_WCON_CRB_POP_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CRB_POP_CNT_CSR {
         u32 CRPpopCnt;                           // DWORD 0
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR, *PRXULP_WCON_CRB_POP_CNT_CSR;

      typedef union _RXULP_WCON_CRB_POP_CNT_CSR_UNION {
         RXULP_WCON_CRB_POP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CRB_POP_CNT_CSR_UNION, *PRXULP_WCON_CRB_POP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CRB_POP_CNT_CSR_UNION, sizeof (RXULP_WCON_CRB_POP_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Command Context Write counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CCW_REQ_CNT_CSR {
         union {
            struct { 
               u32 CCWcnt;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR, *PRXULP_WCON_CCW_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CCW_REQ_CNT_CSR, sizeof (RXULP_WCON_CCW_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CCW_REQ_CNT_CSR {
         u32 CCWcnt;                              // DWORD 0
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR, *PRXULP_WCON_CCW_REQ_CNT_CSR;

      typedef union _RXULP_WCON_CCW_REQ_CNT_CSR_UNION {
         RXULP_WCON_CCW_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR_UNION, *PRXULP_WCON_CCW_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CCW_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_CCW_REQ_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Command Context Write counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_CCW_REQ_CNT_CSR {
         union {
            struct { 
               u32 CCWcnt;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR, *PRXULP_WCON_CCW_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CCW_REQ_CNT_CSR, sizeof (RXULP_WCON_CCW_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_CCW_REQ_CNT_CSR {
         u32 CCWcnt;                              // DWORD 0
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR, *PRXULP_WCON_CCW_REQ_CNT_CSR;

      typedef union _RXULP_WCON_CCW_REQ_CNT_CSR_UNION {
         RXULP_WCON_CCW_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_CCW_REQ_CNT_CSR_UNION, *PRXULP_WCON_CCW_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_CCW_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_CCW_REQ_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, WDMA Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_REQ_CNT_CSR {
         union {
            struct { 
               u32 WDMAreqCnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR, *PRXULP_WCON_WDMA_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REQ_CNT_CSR, sizeof (RXULP_WCON_WDMA_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_REQ_CNT_CSR {
         u32 WDMAreqCnt;                          // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR, *PRXULP_WCON_WDMA_REQ_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_REQ_CNT_CSR_UNION {
         RXULP_WCON_WDMA_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR_UNION, *PRXULP_WCON_WDMA_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_REQ_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, WDMA Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_REQ_CNT_CSR {
         union {
            struct { 
               u32 WDMAreqCnt;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR, *PRXULP_WCON_WDMA_REQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REQ_CNT_CSR, sizeof (RXULP_WCON_WDMA_REQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_REQ_CNT_CSR {
         u32 WDMAreqCnt;                          // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR, *PRXULP_WCON_WDMA_REQ_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_REQ_CNT_CSR_UNION {
         RXULP_WCON_WDMA_REQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_REQ_CNT_CSR_UNION, *PRXULP_WCON_WDMA_REQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_REQ_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_REQ_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Zero-Byte WDMA Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_ZREQ_CNT_CSR {
         union {
            struct { 
               u32 WDMAzReqCnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_ZREQ_CNT_CSR, sizeof (RXULP_WCON_WDMA_ZREQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_ZREQ_CNT_CSR {
         u32 WDMAzReqCnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION {
         RXULP_WCON_WDMA_ZREQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Zero-Byte WDMA Request counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_ZREQ_CNT_CSR {
         union {
            struct { 
               u32 WDMAzReqCnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_ZREQ_CNT_CSR, sizeof (RXULP_WCON_WDMA_ZREQ_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_ZREQ_CNT_CSR {
         u32 WDMAzReqCnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION {
         RXULP_WCON_WDMA_ZREQ_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION, *PRXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_ZREQ_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, WDMA Response counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_RESP_CNT_CSR {
         union {
            struct { 
               u32 WDMArespCnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR, *PRXULP_WCON_WDMA_RESP_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_RESP_CNT_CSR, sizeof (RXULP_WCON_WDMA_RESP_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_RESP_CNT_CSR {
         u32 WDMArespCnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR, *PRXULP_WCON_WDMA_RESP_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_RESP_CNT_CSR_UNION {
         RXULP_WCON_WDMA_RESP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR_UNION, *PRXULP_WCON_WDMA_RESP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_RESP_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_RESP_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, WDMA Response counter. For debug purposes.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_WDMA_RESP_CNT_CSR {
         union {
            struct { 
               u32 WDMArespCnt;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR, *PRXULP_WCON_WDMA_RESP_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_RESP_CNT_CSR, sizeof (RXULP_WCON_WDMA_RESP_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_WDMA_RESP_CNT_CSR {
         u32 WDMArespCnt;                         // DWORD 0
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR, *PRXULP_WCON_WDMA_RESP_CNT_CSR;

      typedef union _RXULP_WCON_WDMA_RESP_CNT_CSR_UNION {
         RXULP_WCON_WDMA_RESP_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_WDMA_RESP_CNT_CSR_UNION, *PRXULP_WCON_WDMA_RESP_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_WDMA_RESP_CNT_CSR_UNION, sizeof (RXULP_WCON_WDMA_RESP_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Transaction Counts within Pipeline. An empty WCON pipeline is
   // indicated by all zeroes in this register and all zeroes in the neighboring
   // RXULP_WCON_INT_CNT2_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_INT_CNT_CSR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 pyld : 2;                      // DWORD 0
               u32 connwr : 1;                    // DWORD 0
               u32 UCR : 5;                       // DWORD 0
               u32 CRB : 4;                       // DWORD 0
               u32 sgef : 1;                      // DWORD 0
               u32 connrd : 4;                    // DWORD 0
               u32 ififo : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_INT_CNT_CSR, *PRXULP_WCON_INT_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT_CSR, sizeof (RXULP_WCON_INT_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_INT_CNT_CSR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 pyld : 2;                            // DWORD 0
         u32 connwr : 1;                          // DWORD 0
         u32 UCR : 5;                             // DWORD 0
         u32 CRB : 4;                             // DWORD 0
         u32 sgef : 1;                            // DWORD 0
         u32 connrd : 4;                          // DWORD 0
         u32 ififo : 5;                           // DWORD 0
      } SG_PACK RXULP_WCON_INT_CNT_CSR, *PRXULP_WCON_INT_CNT_CSR;

      typedef union _RXULP_WCON_INT_CNT_CSR_UNION {
         RXULP_WCON_INT_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_INT_CNT_CSR_UNION, *PRXULP_WCON_INT_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT_CSR_UNION, sizeof (RXULP_WCON_INT_CNT_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Transaction Counts within Pipeline. An empty WCON pipeline is
   // indicated by all zeroes in this register and all zeroes in the neighboring
   // RXULP_WCON_INT_CNT2_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_INT_CNT_CSR {
         union {
            struct { 
               u32 ififo : 5;                     // DWORD 0
               u32 connrd : 4;                    // DWORD 0
               u32 sgef : 1;                      // DWORD 0
               u32 CRB : 4;                       // DWORD 0
               u32 UCR : 5;                       // DWORD 0
               u32 connwr : 1;                    // DWORD 0
               u32 pyld : 2;                      // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_INT_CNT_CSR, *PRXULP_WCON_INT_CNT_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT_CSR, sizeof (RXULP_WCON_INT_CNT_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_INT_CNT_CSR {
         u32 ififo : 5;                           // DWORD 0
         u32 connrd : 4;                          // DWORD 0
         u32 sgef : 1;                            // DWORD 0
         u32 CRB : 4;                             // DWORD 0
         u32 UCR : 5;                             // DWORD 0
         u32 connwr : 1;                          // DWORD 0
         u32 pyld : 2;                            // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK RXULP_WCON_INT_CNT_CSR, *PRXULP_WCON_INT_CNT_CSR;

      typedef union _RXULP_WCON_INT_CNT_CSR_UNION {
         RXULP_WCON_INT_CNT_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_INT_CNT_CSR_UNION, *PRXULP_WCON_INT_CNT_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT_CSR_UNION, sizeof (RXULP_WCON_INT_CNT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // WDMA Consolidator, Transaction Counts within Pipeline. An empty WCON pipeline is
   // indicated by all zeroes in this register and all zeroes in the neighboring
   // RXULP_WCON_INT_CNT_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_INT_CNT2_CSR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 CQEupd : 2;                    // DWORD 0
               u32 WDR : 5;                       // DWORD 0
               u32 UCI : 5;                       // DWORD 0
               u32 outstUCreqs : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_INT_CNT2_CSR, *PRXULP_WCON_INT_CNT2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT2_CSR, sizeof (RXULP_WCON_INT_CNT2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_INT_CNT2_CSR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 CQEupd : 2;                          // DWORD 0
         u32 WDR : 5;                             // DWORD 0
         u32 UCI : 5;                             // DWORD 0
         u32 outstUCreqs : 4;                     // DWORD 0
      } SG_PACK RXULP_WCON_INT_CNT2_CSR, *PRXULP_WCON_INT_CNT2_CSR;

      typedef union _RXULP_WCON_INT_CNT2_CSR_UNION {
         RXULP_WCON_INT_CNT2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_INT_CNT2_CSR_UNION, *PRXULP_WCON_INT_CNT2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT2_CSR_UNION, sizeof (RXULP_WCON_INT_CNT2_CSR_UNION) == 4);
   #endif


#else
   // WDMA Consolidator, Transaction Counts within Pipeline. An empty WCON pipeline is
   // indicated by all zeroes in this register and all zeroes in the neighboring
   // RXULP_WCON_INT_CNT_CSR.
   #if defined(SG_BMAP_UNION)
      typedef struct _RXULP_WCON_INT_CNT2_CSR {
         union {
            struct { 
               u32 outstUCreqs : 4;               // DWORD 0
               u32 UCI : 5;                       // DWORD 0
               u32 WDR : 5;                       // DWORD 0
               u32 CQEupd : 2;                    // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK RXULP_WCON_INT_CNT2_CSR, *PRXULP_WCON_INT_CNT2_CSR;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT2_CSR, sizeof (RXULP_WCON_INT_CNT2_CSR) == 4);

   #else
      typedef struct _RXULP_WCON_INT_CNT2_CSR {
         u32 outstUCreqs : 4;                     // DWORD 0
         u32 UCI : 5;                             // DWORD 0
         u32 WDR : 5;                             // DWORD 0
         u32 CQEupd : 2;                          // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK RXULP_WCON_INT_CNT2_CSR, *PRXULP_WCON_INT_CNT2_CSR;

      typedef union _RXULP_WCON_INT_CNT2_CSR_UNION {
         RXULP_WCON_INT_CNT2_CSR bits;
         u32 dw; // dword union
      } SG_PACK RXULP_WCON_INT_CNT2_CSR_UNION, *PRXULP_WCON_INT_CNT2_CSR_UNION;

      SG_C_ASSERT(__sizeof__RXULP_WCON_INT_CNT2_CSR_UNION, sizeof (RXULP_WCON_INT_CNT2_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // random text random text random text.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CSRMAP {
         union {
            struct { 
               RXULP_WCON_CFG1_CR wcon_cfg1;
               RXULP_WCON_CFG2_CR wcon_cfg2;
               WCON_UE_ENABLE_CSR ue_enable;
               WCON_UE_SOURCE_CSR ue_source;
               WCON_CRA_HI_CSR cra_hi;
               WCON_CRA_LO_CSR cra_lo;
               RXULP_WCON_UE_DETAILS1_CSR wcon_ue1;
               RXULP_WCON_UC_UE_DETAILS1_CSR wcon_uc_ue1;
               RXULP_WCON_UC_UE_DETAILS2_CSR wcon_uc_ue2;
               WCON_BAD_UC_REQ_CSR bad_uc_req;
               RXULP_WCON_D_CNT_CSR wcon_d_cnt;
               RXULP_WCON_D0_CNT_CSR wcon_d0_cnt;
               RXULP_BM_WCON_D_CNT_CSR bm_wcon_d_cnt;
               RXULP_PM_WCON_D_CNT_CSR pm_wcon_d_cnt;
               RXULP_PPM_WCON_D_CNT_CSR ppm_wcon_d_cnt;
               RXULP_PDU_CNT_CSR pdu_cnt;
               RXULP_PDU_CQE_CNT_CSR pdu_cqe_cnt;
               RXULP_CMD_CQE_CNT_CSR cmd_cqe_cnt;
               RXULP_WCON_UC_RD_CNT_CSR wcon_uc_rd_cnt;
               WCON_UC_RESP_CNT_CSR uc_resp_cnt;
               RXULP_WCON_SEEK_REL_CNT_CSR wcon_dir_uc_rel_cnt;
               RXULP_WCON_WDMA_REL_CNT_CSR wcon_indir_uc_rel_cnt;
               RXULP_WCON_CRB_POP_CNT_CSR wcon_crb_pop_cnt;
               RXULP_WCON_UC_INV_CNT_CSR wcon_uc_inv_cnt;
               RXULP_WCON_CEV_REQ_CNT_CSR wcon_cev_req_cnt;
               RXULP_WCON_CCW_REQ_CNT_CSR wcon_ccw_cnt;
               RXULP_WCON_WDMA_REQ_CNT_CSR wcon_wdma_req_cnt;
               RXULP_WCON_WDMA_ZREQ_CNT_CSR wcon_wdma_zreq_cnt;
               RXULP_WCON_WDMA_RESP_CNT_CSR wcon_wdma_resp_cnt;
               RXULP_WCON_INT_CNT_CSR wcon_int_cnt;
               RXULP_WCON_INT_CNT2_CSR wcon_int_cnt2;
               RXULP_WCON_D_D0_CSR wcon_d_d0;
               RXULP_WCON_D_D1_CSR wcon_d_d1;
               RXULP_WCON_D_D2_CSR wcon_d_d2;
               RXULP_WCON_D_D3_CSR wcon_d_d3;
               RXULP_WCON_D_D4_CSR wcon_d_d4;
               RXULP_WCON_D_D5_CSR wcon_d_d5;
               RXULP_CQE_D0_CSR cqe_d0;
               RXULP_CQE_D1_CSR cqe_d1;
               RXULP_CQE_D2_CSR cqe_d2;
               RXULP_CQE_D3_CSR cqe_d3;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } uc_pq;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[200];                    // DWORDS 56 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK WCON_CSRMAP, *PWCON_CSRMAP;

      SG_C_ASSERT(__sizeof__WCON_CSRMAP, sizeof (WCON_CSRMAP) == 1024);

   #else
      typedef struct _WCON_CSRMAP {
         RXULP_WCON_CFG1_CR wcon_cfg1;
         RXULP_WCON_CFG2_CR wcon_cfg2;
         WCON_UE_ENABLE_CSR ue_enable;
         WCON_UE_SOURCE_CSR ue_source;
         WCON_CRA_HI_CSR cra_hi;
         WCON_CRA_LO_CSR cra_lo;
         RXULP_WCON_UE_DETAILS1_CSR wcon_ue1;
         RXULP_WCON_UC_UE_DETAILS1_CSR wcon_uc_ue1;
         RXULP_WCON_UC_UE_DETAILS2_CSR wcon_uc_ue2;
         WCON_BAD_UC_REQ_CSR bad_uc_req;
         RXULP_WCON_D_CNT_CSR wcon_d_cnt;
         RXULP_WCON_D0_CNT_CSR wcon_d0_cnt;
         RXULP_BM_WCON_D_CNT_CSR bm_wcon_d_cnt;
         RXULP_PM_WCON_D_CNT_CSR pm_wcon_d_cnt;
         RXULP_PPM_WCON_D_CNT_CSR ppm_wcon_d_cnt;
         RXULP_PDU_CNT_CSR pdu_cnt;
         RXULP_PDU_CQE_CNT_CSR pdu_cqe_cnt;
         RXULP_CMD_CQE_CNT_CSR cmd_cqe_cnt;
         RXULP_WCON_UC_RD_CNT_CSR wcon_uc_rd_cnt;
         WCON_UC_RESP_CNT_CSR uc_resp_cnt;
         RXULP_WCON_SEEK_REL_CNT_CSR wcon_dir_uc_rel_cnt;
         RXULP_WCON_WDMA_REL_CNT_CSR wcon_indir_uc_rel_cnt;
         RXULP_WCON_CRB_POP_CNT_CSR wcon_crb_pop_cnt;
         RXULP_WCON_UC_INV_CNT_CSR wcon_uc_inv_cnt;
         RXULP_WCON_CEV_REQ_CNT_CSR wcon_cev_req_cnt;
         RXULP_WCON_CCW_REQ_CNT_CSR wcon_ccw_cnt;
         RXULP_WCON_WDMA_REQ_CNT_CSR wcon_wdma_req_cnt;
         RXULP_WCON_WDMA_ZREQ_CNT_CSR wcon_wdma_zreq_cnt;
         RXULP_WCON_WDMA_RESP_CNT_CSR wcon_wdma_resp_cnt;
         RXULP_WCON_INT_CNT_CSR wcon_int_cnt;
         RXULP_WCON_INT_CNT2_CSR wcon_int_cnt2;
         RXULP_WCON_D_D0_CSR wcon_d_d0;
         RXULP_WCON_D_D1_CSR wcon_d_d1;
         RXULP_WCON_D_D2_CSR wcon_d_d2;
         RXULP_WCON_D_D3_CSR wcon_d_d3;
         RXULP_WCON_D_D4_CSR wcon_d_d4;
         RXULP_WCON_D_D5_CSR wcon_d_d5;
         RXULP_CQE_D0_CSR cqe_d0;
         RXULP_CQE_D1_CSR cqe_d1;
         RXULP_CQE_D2_CSR cqe_d2;
         RXULP_CQE_D3_CSR cqe_d3;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } uc_pq;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[200];                          // DWORDS 56 to 255
      } SG_PACK WCON_CSRMAP, *PWCON_CSRMAP;

      typedef union _WCON_CSRMAP_UNION {
         WCON_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK WCON_CSRMAP_UNION, *PWCON_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__WCON_CSRMAP_UNION, sizeof (WCON_CSRMAP_UNION) == 1024);
   #endif


#else
   // random text random text random text.
   #if defined(SG_BMAP_UNION)
      typedef struct _WCON_CSRMAP {
         union {
            struct { 
               RXULP_WCON_CFG1_CR wcon_cfg1;
               RXULP_WCON_CFG2_CR wcon_cfg2;
               WCON_UE_ENABLE_CSR ue_enable;
               WCON_UE_SOURCE_CSR ue_source;
               WCON_CRA_HI_CSR cra_hi;
               WCON_CRA_LO_CSR cra_lo;
               RXULP_WCON_UE_DETAILS1_CSR wcon_ue1;
               RXULP_WCON_UC_UE_DETAILS1_CSR wcon_uc_ue1;
               RXULP_WCON_UC_UE_DETAILS2_CSR wcon_uc_ue2;
               WCON_BAD_UC_REQ_CSR bad_uc_req;
               RXULP_WCON_D_CNT_CSR wcon_d_cnt;
               RXULP_WCON_D0_CNT_CSR wcon_d0_cnt;
               RXULP_BM_WCON_D_CNT_CSR bm_wcon_d_cnt;
               RXULP_PM_WCON_D_CNT_CSR pm_wcon_d_cnt;
               RXULP_PPM_WCON_D_CNT_CSR ppm_wcon_d_cnt;
               RXULP_PDU_CNT_CSR pdu_cnt;
               RXULP_PDU_CQE_CNT_CSR pdu_cqe_cnt;
               RXULP_CMD_CQE_CNT_CSR cmd_cqe_cnt;
               RXULP_WCON_UC_RD_CNT_CSR wcon_uc_rd_cnt;
               WCON_UC_RESP_CNT_CSR uc_resp_cnt;
               RXULP_WCON_SEEK_REL_CNT_CSR wcon_dir_uc_rel_cnt;
               RXULP_WCON_WDMA_REL_CNT_CSR wcon_indir_uc_rel_cnt;
               RXULP_WCON_CRB_POP_CNT_CSR wcon_crb_pop_cnt;
               RXULP_WCON_UC_INV_CNT_CSR wcon_uc_inv_cnt;
               RXULP_WCON_CEV_REQ_CNT_CSR wcon_cev_req_cnt;
               RXULP_WCON_CCW_REQ_CNT_CSR wcon_ccw_cnt;
               RXULP_WCON_WDMA_REQ_CNT_CSR wcon_wdma_req_cnt;
               RXULP_WCON_WDMA_ZREQ_CNT_CSR wcon_wdma_zreq_cnt;
               RXULP_WCON_WDMA_RESP_CNT_CSR wcon_wdma_resp_cnt;
               RXULP_WCON_INT_CNT_CSR wcon_int_cnt;
               RXULP_WCON_INT_CNT2_CSR wcon_int_cnt2;
               RXULP_WCON_D_D0_CSR wcon_d_d0;
               RXULP_WCON_D_D1_CSR wcon_d_d1;
               RXULP_WCON_D_D2_CSR wcon_d_d2;
               RXULP_WCON_D_D3_CSR wcon_d_d3;
               RXULP_WCON_D_D4_CSR wcon_d_d4;
               RXULP_WCON_D_D5_CSR wcon_d_d5;
               RXULP_CQE_D0_CSR cqe_d0;
               RXULP_CQE_D1_CSR cqe_d1;
               RXULP_CQE_D2_CSR cqe_d2;
               RXULP_CQE_D3_CSR cqe_d3;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } wdma_pq;
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
                  PQ_DATA1_WRITE_CSR wrdata1;
                  PQ_DATA1_READ_CSR rddata1;
               } uc_pq;
               HWDBG_CSRMAP hwdbg;
               u32 rsvd0[200];                    // DWORDS 56 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK WCON_CSRMAP, *PWCON_CSRMAP;

      SG_C_ASSERT(__sizeof__WCON_CSRMAP, sizeof (WCON_CSRMAP) == 1024);

   #else
      typedef struct _WCON_CSRMAP {
         RXULP_WCON_CFG1_CR wcon_cfg1;
         RXULP_WCON_CFG2_CR wcon_cfg2;
         WCON_UE_ENABLE_CSR ue_enable;
         WCON_UE_SOURCE_CSR ue_source;
         WCON_CRA_HI_CSR cra_hi;
         WCON_CRA_LO_CSR cra_lo;
         RXULP_WCON_UE_DETAILS1_CSR wcon_ue1;
         RXULP_WCON_UC_UE_DETAILS1_CSR wcon_uc_ue1;
         RXULP_WCON_UC_UE_DETAILS2_CSR wcon_uc_ue2;
         WCON_BAD_UC_REQ_CSR bad_uc_req;
         RXULP_WCON_D_CNT_CSR wcon_d_cnt;
         RXULP_WCON_D0_CNT_CSR wcon_d0_cnt;
         RXULP_BM_WCON_D_CNT_CSR bm_wcon_d_cnt;
         RXULP_PM_WCON_D_CNT_CSR pm_wcon_d_cnt;
         RXULP_PPM_WCON_D_CNT_CSR ppm_wcon_d_cnt;
         RXULP_PDU_CNT_CSR pdu_cnt;
         RXULP_PDU_CQE_CNT_CSR pdu_cqe_cnt;
         RXULP_CMD_CQE_CNT_CSR cmd_cqe_cnt;
         RXULP_WCON_UC_RD_CNT_CSR wcon_uc_rd_cnt;
         WCON_UC_RESP_CNT_CSR uc_resp_cnt;
         RXULP_WCON_SEEK_REL_CNT_CSR wcon_dir_uc_rel_cnt;
         RXULP_WCON_WDMA_REL_CNT_CSR wcon_indir_uc_rel_cnt;
         RXULP_WCON_CRB_POP_CNT_CSR wcon_crb_pop_cnt;
         RXULP_WCON_UC_INV_CNT_CSR wcon_uc_inv_cnt;
         RXULP_WCON_CEV_REQ_CNT_CSR wcon_cev_req_cnt;
         RXULP_WCON_CCW_REQ_CNT_CSR wcon_ccw_cnt;
         RXULP_WCON_WDMA_REQ_CNT_CSR wcon_wdma_req_cnt;
         RXULP_WCON_WDMA_ZREQ_CNT_CSR wcon_wdma_zreq_cnt;
         RXULP_WCON_WDMA_RESP_CNT_CSR wcon_wdma_resp_cnt;
         RXULP_WCON_INT_CNT_CSR wcon_int_cnt;
         RXULP_WCON_INT_CNT2_CSR wcon_int_cnt2;
         RXULP_WCON_D_D0_CSR wcon_d_d0;
         RXULP_WCON_D_D1_CSR wcon_d_d1;
         RXULP_WCON_D_D2_CSR wcon_d_d2;
         RXULP_WCON_D_D3_CSR wcon_d_d3;
         RXULP_WCON_D_D4_CSR wcon_d_d4;
         RXULP_WCON_D_D5_CSR wcon_d_d5;
         RXULP_CQE_D0_CSR cqe_d0;
         RXULP_CQE_D1_CSR cqe_d1;
         RXULP_CQE_D2_CSR cqe_d2;
         RXULP_CQE_D3_CSR cqe_d3;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } wdma_pq;
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
            PQ_DATA1_WRITE_CSR wrdata1;
            PQ_DATA1_READ_CSR rddata1;
         } uc_pq;
         HWDBG_CSRMAP hwdbg;
         u32 rsvd0[200];                          // DWORDS 56 to 255
      } SG_PACK WCON_CSRMAP, *PWCON_CSRMAP;

      typedef union _WCON_CSRMAP_UNION {
         WCON_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK WCON_CSRMAP_UNION, *PWCON_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__WCON_CSRMAP_UNION, sizeof (WCON_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __wcon_bmap_h__

