/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __armspiflash_amap_h__
#define __armspiflash_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//  The SPI Address registers contents are used for the address                field on
// the SPI interface. This register contains the SPI                address [7:0]. These
// registers are only used during SPI                access through the register access
// mode.         
typedef struct {
   BE_BIT addr[24];                               // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_SPI_ADDRESS_AMAP;
typedef struct { u32 dw[1]; } SPI_ADDRESS_AMAP, *PSPI_ADDRESS_AMAP;


//  Data to be written to SPI flash or data read from SPI flash. 
typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_SPI_DATA_AMAP;
typedef struct { u32 dw[1]; } SPI_DATA_AMAP, *PSPI_DATA_AMAP;


//  Firmware should not modify the SPI Controller registers                (except Bit[7]
// and Bit[0] of CMD3 register, as mentioned in                the register bit
// description) when the SPI Controller is in                the middle of a transaction
// with the SPI Device. Modifying                these registers has direct effect on the
// timing to the SPI                Device and the operation of the controller and any
// changes                in the middle of a transaction can result in corrupted          
//      data/command.         
typedef struct {
   BE_BIT cmd0_op[8];                             // DWORD 0
   BE_BIT cmd1_len[4];                            // DWORD 0
   BE_BIT cmd1_dir;                               // DWORD 0
   BE_BIT cmd1_numbyte[3];                        // DWORD 0
   BE_BIT cmd2_dummy[8];                          // DWORD 0
   BE_BIT cmd3_cs;                                // DWORD 0
   BE_BIT cmd3_wrfifo;                            // DWORD 0
   BE_BIT cmd3_fastread;                          // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT cmd3_regaccess;                         // DWORD 0
} SG_PACK BE_SPI_COMMAND_AMAP;
typedef struct { u32 dw[1]; } SPI_COMMAND_AMAP, *PSPI_COMMAND_AMAP;


//  Allows for changing the timing the SPI interface.  The default values               
// should work for most devices.         
typedef struct {
   BE_BIT trec[8];                                // DWORD 0
   BE_BIT tcs[8];                                 // DWORD 0
   BE_BIT tcsl[8];                                // DWORD 0
   BE_BIT tcsh[8];                                // DWORD 0
} SG_PACK BE_SPI_TIMING_CONFIG_AMAP;
typedef struct { u32 dw[1]; } SPI_TIMING_CONFIG_AMAP, *PSPI_TIMING_CONFIG_AMAP;


//  This register contains the Boot SPI status bits.         
typedef struct {
   BE_BIT reg_acc_busy;                           // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT sm_busy;                                // DWORD 0
   BE_BIT write_fifo_rdy;                         // DWORD 0
   BE_BIT write_fifo_full;                        // DWORD 0
   BE_BIT write_fifo_empty;                       // DWORD 0
   BE_BIT rsvd1[26];                              // DWORD 0
} SG_PACK BE_SPI_STATUS_AMAP;
typedef struct { u32 dw[1]; } SPI_STATUS_AMAP, *PSPI_STATUS_AMAP;


// This is the register section of the SPI FLASH. 
typedef struct {
   BE_SPI_ADDRESS_AMAP address;
   BE_SPI_DATA_AMAP data;
   BE_SPI_COMMAND_AMAP command;
   BE_SPI_TIMING_CONFIG_AMAP timing_config;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_BIT rsvd1[32];                              // DWORD 5
   BE_SPI_STATUS_AMAP status;
   BE_BIT rsvd2[32];                              // DWORD 7
   BE_BIT rsvd3[1016][32];                        // DWORD 8
} SG_PACK BE_SPI_FLASH_CSRMAP_AMAP;
typedef struct { u32 dw[1024]; } SPI_FLASH_CSRMAP_AMAP, *PSPI_FLASH_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __armspiflash_amap_h__

