/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __cev_amap_h__
#define __cev_amap_h__
#include "setypes.h"
#include "defines.h"
#include "pq.h"
#include "ep.h"
#include "txulp.h"
#include "reg_enums.h"
#include "gencommon.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- CQ_CNT_ENUM ---
// Completion Queue Count Encodings.
#define CEV_CQ_CNT_256                  (0)       // CQ has 256 entries
#define CEV_CQ_CNT_512                  (1)       // CQ has 512 entries
#define CEV_CQ_CNT_1024                 (2)       // CQ has 1024 entries

typedef enum {
   ENUM_CEV_CQ_CNT_256 = 0x0UL,
   ENUM_CEV_CQ_CNT_512 = 0x1UL,
   ENUM_CEV_CQ_CNT_1024 = 0x2UL
} CQ_CNT_ENUM;

// --- EQ_CNT_ENUM ---
// Event Queue Count Encodings.
#define CEV_EQ_CNT_256                  (0)       // EQ has 256 entries (16-byte EQEs
                                                  // only)
#define CEV_EQ_CNT_512                  (1)       // EQ has 512 entries (16-byte EQEs
                                                  // only)
#define CEV_EQ_CNT_1024                 (2)       // EQ has 1024 entries (4-byte or
                                                  // 16-byte EQEs only)
#define CEV_EQ_CNT_2048                 (3)       // EQ has 2048 entries (4-byte or
                                                  // 16-byte EQEs only)
#define CEV_EQ_CNT_4096                 (4)       // EQ has 4096 entries (4-byte EQEs
                                                  // only)

typedef enum {
   ENUM_CEV_EQ_CNT_256 = 0x0UL,
   ENUM_CEV_EQ_CNT_512 = 0x1UL,
   ENUM_CEV_EQ_CNT_1024 = 0x2UL,
   ENUM_CEV_EQ_CNT_2048 = 0x3UL,
   ENUM_CEV_EQ_CNT_4096 = 0x4UL
} EQ_CNT_ENUM;

// --- EQ_SIZE_ENUM ---
// Event Queue Entry Size Encoding.
#define CEV_EQ_SIZE_4                   (0)       // EQE is 4 bytes
#define CEV_EQ_SIZE_16                  (1)       // EQE is 16 bytes

typedef enum {
   ENUM_CEV_EQ_SIZE_4 = 0x0UL,
   ENUM_CEV_EQ_SIZE_16 = 0x1UL
} EQ_SIZE_ENUM;

// --- CQE_COALESC_WM_ENUM ---
// CQE Coalescing Threshold/Watermark Encoding.Note: 0 value set the CQ for non-coalescing
#define CEV_CQE_COALESC_WM_0            (0)       // No CQE Coalescing.
#define CEV_CQE_COALESC_WM_1            (1)       // CQE coalesicng Watermark is given by
                                                  // bit field COALESC_WM1 ( bits [15:8] )
                                                  // of CEV_CSR_COALESCWM_CFG register.
#define CEV_CQE_COALESC_WM_2            (2)       // CQE coalescing Watermark is given by
                                                  // bit field COALESC_WM2 (bits [23:16] )
                                                  // of CEV_CSR_COALESCWM_CFG register.
#define CEV_CQE_COALESC_WM_3            (3)       // CQE coalescing Watermark is given by
                                                  // bit field COALESC_WM3 (bits [24:31] )
                                                  // of CEV_CSR_COALESCWM_CFG register.

typedef enum {
   ENUM_CEV_CQE_COALESC_WM_0 = 0x0UL,
   ENUM_CEV_CQE_COALESC_WM_1 = 0x1UL,
   ENUM_CEV_CQE_COALESC_WM_2 = 0x2UL,
   ENUM_CEV_CQE_COALESC_WM_3 = 0x3UL
} CQE_COALESC_WM_ENUM;

// Completion Queue Context Table Entry. Contains the state of a CQ. Located in RAM within
// the CEV block.
typedef struct {
   BE_BIT Cidx[11];                               // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT CoalescWM[2];                           // DWORD 0
   BE_BIT NoDelay;                                // DWORD 0
   BE_BIT EPIdx[11];                              // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT Count[2];                               // DWORD 0
   BE_BIT valid;                                  // DWORD 0
   BE_BIT SolEvent;                               // DWORD 0
   BE_BIT Eventable;                              // DWORD 0
   BE_BIT Pidx[11];                               // DWORD 1
   BE_BIT rsvd2;                                  // DWORD 1
   BE_BIT PD[10];                                 // DWORD 1
   BE_BIT EQID[8];                                // DWORD 1
   BE_BIT Stalled;                                // DWORD 1
   BE_BIT Armed;                                  // DWORD 1
   BE_BIT rsvd3[4];                               // DWORD 2
   BE_BIT Func[8];                                // DWORD 2
   BE_BIT rsvd4[20];                              // DWORD 2
   BE_BIT rsvd5[32];                              // DWORD 3
} SG_PACK BE_CQ_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } CQ_CONTEXT_AMAP, *PCQ_CONTEXT_AMAP;


// Event Queue Context Table Entry. Contains the state of an EQ. Located in RAM in the CEV
// block.
typedef struct {
   BE_BIT Cidx[13];                               // DWORD 0
   BE_BIT rsvd0[3];                               // DWORD 0
   BE_BIT EPIdx[13];                              // DWORD 0
   BE_BIT valid;                                  // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT Size;                                   // DWORD 0
   BE_BIT Pidx[13];                               // DWORD 1
   BE_BIT rsvd2[3];                               // DWORD 1
   BE_BIT PD[10];                                 // DWORD 1
   BE_BIT Count[3];                               // DWORD 1
   BE_BIT SolEvent;                               // DWORD 1
   BE_BIT Stalled;                                // DWORD 1
   BE_BIT Armed;                                  // DWORD 1
   BE_BIT rsvd3[4];                               // DWORD 2
   BE_BIT Func[8];                                // DWORD 2
   BE_BIT rsvd4;                                  // DWORD 2
   BE_BIT DelayMult[10];                          // DWORD 2
   BE_BIT rsvd5[2];                               // DWORD 2
   BE_BIT PHASE[2];                               // DWORD 2
   BE_BIT NoDelay;                                // DWORD 2
   BE_BIT rsvd6[4];                               // DWORD 2
   BE_BIT rsvd7[32];                              // DWORD 3
} SG_PACK BE_EQ_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } EQ_CONTEXT_AMAP, *PEQ_CONTEXT_AMAP;


// Interrupt Status Register 0. The first of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ0 through EQ7.
typedef struct {
   BE_BIT interrupt0;                             // DWORD 0
   BE_BIT interrupt1;                             // DWORD 0
   BE_BIT interrupt2;                             // DWORD 0
   BE_BIT interrupt3;                             // DWORD 0
   BE_BIT interrupt4;                             // DWORD 0
   BE_BIT interrupt5;                             // DWORD 0
   BE_BIT interrupt6;                             // DWORD 0
   BE_BIT interrupt7;                             // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR0_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR0_CSR_AMAP, *PCEV_ISR0_CSR_AMAP;


// Interrupt Status Register 1. The second of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ8 through EQ15.
typedef struct {
   BE_BIT interrupt8;                             // DWORD 0
   BE_BIT interrupt9;                             // DWORD 0
   BE_BIT interrupt10;                            // DWORD 0
   BE_BIT interrupt11;                            // DWORD 0
   BE_BIT interrupt12;                            // DWORD 0
   BE_BIT interrupt13;                            // DWORD 0
   BE_BIT interrupt14;                            // DWORD 0
   BE_BIT interrupt15;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR1_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR1_CSR_AMAP, *PCEV_ISR1_CSR_AMAP;


// Interrupt Status Register 2. The third of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ16 through EQ23.
typedef struct {
   BE_BIT interrupt16;                            // DWORD 0
   BE_BIT interrupt17;                            // DWORD 0
   BE_BIT interrupt18;                            // DWORD 0
   BE_BIT interrupt19;                            // DWORD 0
   BE_BIT interrupt20;                            // DWORD 0
   BE_BIT interrupt21;                            // DWORD 0
   BE_BIT interrupt22;                            // DWORD 0
   BE_BIT interrupt23;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR2_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR2_CSR_AMAP, *PCEV_ISR2_CSR_AMAP;


// Interrupt Status Register 3. The fourth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ24 through EQ31.
typedef struct {
   BE_BIT interrupt24;                            // DWORD 0
   BE_BIT interrupt25;                            // DWORD 0
   BE_BIT interrupt26;                            // DWORD 0
   BE_BIT interrupt27;                            // DWORD 0
   BE_BIT interrupt28;                            // DWORD 0
   BE_BIT interrupt29;                            // DWORD 0
   BE_BIT interrupt30;                            // DWORD 0
   BE_BIT interrupt31;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR3_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR3_CSR_AMAP, *PCEV_ISR3_CSR_AMAP;


// Interrupt Status Register 4. The fifth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ32 through EQ39.
typedef struct {
   BE_BIT interrupt32;                            // DWORD 0
   BE_BIT interrupt33;                            // DWORD 0
   BE_BIT interrupt34;                            // DWORD 0
   BE_BIT interrupt35;                            // DWORD 0
   BE_BIT interrupt36;                            // DWORD 0
   BE_BIT interrupt37;                            // DWORD 0
   BE_BIT interrupt38;                            // DWORD 0
   BE_BIT interrupt39;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR4_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR4_CSR_AMAP, *PCEV_ISR4_CSR_AMAP;


// Interrupt Status Register 5. The sixth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ40 through EQ47.
typedef struct {
   BE_BIT interrupt40;                            // DWORD 0
   BE_BIT interrupt41;                            // DWORD 0
   BE_BIT interrupt42;                            // DWORD 0
   BE_BIT interrupt43;                            // DWORD 0
   BE_BIT interrupt44;                            // DWORD 0
   BE_BIT interrupt45;                            // DWORD 0
   BE_BIT interrupt46;                            // DWORD 0
   BE_BIT interrupt47;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR5_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR5_CSR_AMAP, *PCEV_ISR5_CSR_AMAP;


// Interrupt Status Register 6. The seventh of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ48 through EQ55.
typedef struct {
   BE_BIT interrupt48;                            // DWORD 0
   BE_BIT interrupt49;                            // DWORD 0
   BE_BIT interrupt50;                            // DWORD 0
   BE_BIT interrupt51;                            // DWORD 0
   BE_BIT interrupt52;                            // DWORD 0
   BE_BIT interrupt53;                            // DWORD 0
   BE_BIT interrupt54;                            // DWORD 0
   BE_BIT interrupt55;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR6_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR6_CSR_AMAP, *PCEV_ISR6_CSR_AMAP;


// Interrupt Status Register 7. The eigth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ56 through EQ63.
typedef struct {
   BE_BIT interrupt56;                            // DWORD 0
   BE_BIT interrupt57;                            // DWORD 0
   BE_BIT interrupt58;                            // DWORD 0
   BE_BIT interrupt59;                            // DWORD 0
   BE_BIT interrupt60;                            // DWORD 0
   BE_BIT interrupt61;                            // DWORD 0
   BE_BIT interrupt62;                            // DWORD 0
   BE_BIT interrupt63;                            // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
} SG_PACK BE_CEV_ISR7_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR7_CSR_AMAP, *PCEV_ISR7_CSR_AMAP;


// Interrupt Status Register 8. The ninth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ64 through EQ95.
typedef struct {
   BE_BIT interrupt64;                            // DWORD 0
   BE_BIT interrupt65;                            // DWORD 0
   BE_BIT interrupt66;                            // DWORD 0
   BE_BIT interrupt67;                            // DWORD 0
   BE_BIT interrupt68;                            // DWORD 0
   BE_BIT interrupt69;                            // DWORD 0
   BE_BIT interrupt70;                            // DWORD 0
   BE_BIT interrupt71;                            // DWORD 0
   BE_BIT interrupt72;                            // DWORD 0
   BE_BIT interrupt73;                            // DWORD 0
   BE_BIT interrupt74;                            // DWORD 0
   BE_BIT interrupt75;                            // DWORD 0
   BE_BIT interrupt76;                            // DWORD 0
   BE_BIT interrupt77;                            // DWORD 0
   BE_BIT interrupt78;                            // DWORD 0
   BE_BIT interrupt79;                            // DWORD 0
   BE_BIT interrupt80;                            // DWORD 0
   BE_BIT interrupt81;                            // DWORD 0
   BE_BIT interrupt82;                            // DWORD 0
   BE_BIT interrupt83;                            // DWORD 0
   BE_BIT interrupt84;                            // DWORD 0
   BE_BIT interrupt85;                            // DWORD 0
   BE_BIT interrupt86;                            // DWORD 0
   BE_BIT interrupt87;                            // DWORD 0
   BE_BIT interrupt88;                            // DWORD 0
   BE_BIT interrupt89;                            // DWORD 0
   BE_BIT interrupt90;                            // DWORD 0
   BE_BIT interrupt91;                            // DWORD 0
   BE_BIT interrupt92;                            // DWORD 0
   BE_BIT interrupt93;                            // DWORD 0
   BE_BIT interrupt94;                            // DWORD 0
   BE_BIT interrupt95;                            // DWORD 0
} SG_PACK BE_CEV_ISR8_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR8_CSR_AMAP, *PCEV_ISR8_CSR_AMAP;


// Interrupt Status Register 9. The tenth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ96 through EQ127.
typedef struct {
   BE_BIT interrupt96;                            // DWORD 0
   BE_BIT interrupt97;                            // DWORD 0
   BE_BIT interrupt98;                            // DWORD 0
   BE_BIT interrupt99;                            // DWORD 0
   BE_BIT interrupt100;                           // DWORD 0
   BE_BIT interrupt101;                           // DWORD 0
   BE_BIT interrupt102;                           // DWORD 0
   BE_BIT interrupt103;                           // DWORD 0
   BE_BIT interrupt104;                           // DWORD 0
   BE_BIT interrupt105;                           // DWORD 0
   BE_BIT interrupt106;                           // DWORD 0
   BE_BIT interrupt107;                           // DWORD 0
   BE_BIT interrupt108;                           // DWORD 0
   BE_BIT interrupt109;                           // DWORD 0
   BE_BIT interrupt110;                           // DWORD 0
   BE_BIT interrupt111;                           // DWORD 0
   BE_BIT interrupt112;                           // DWORD 0
   BE_BIT interrupt113;                           // DWORD 0
   BE_BIT interrupt114;                           // DWORD 0
   BE_BIT interrupt115;                           // DWORD 0
   BE_BIT interrupt116;                           // DWORD 0
   BE_BIT interrupt117;                           // DWORD 0
   BE_BIT interrupt118;                           // DWORD 0
   BE_BIT interrupt119;                           // DWORD 0
   BE_BIT interrupt120;                           // DWORD 0
   BE_BIT interrupt121;                           // DWORD 0
   BE_BIT interrupt122;                           // DWORD 0
   BE_BIT interrupt123;                           // DWORD 0
   BE_BIT interrupt124;                           // DWORD 0
   BE_BIT interrupt125;                           // DWORD 0
   BE_BIT interrupt126;                           // DWORD 0
   BE_BIT interrupt127;                           // DWORD 0
} SG_PACK BE_CEV_ISR9_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR9_CSR_AMAP, *PCEV_ISR9_CSR_AMAP;


// Interrupt Status Register 10. The eleventh of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ128 through EQ159.
typedef struct {
   BE_BIT interrupt128;                           // DWORD 0
   BE_BIT interrupt129;                           // DWORD 0
   BE_BIT interrupt130;                           // DWORD 0
   BE_BIT interrupt131;                           // DWORD 0
   BE_BIT interrupt132;                           // DWORD 0
   BE_BIT interrupt133;                           // DWORD 0
   BE_BIT interrupt134;                           // DWORD 0
   BE_BIT interrupt135;                           // DWORD 0
   BE_BIT interrupt136;                           // DWORD 0
   BE_BIT interrupt137;                           // DWORD 0
   BE_BIT interrupt138;                           // DWORD 0
   BE_BIT interrupt139;                           // DWORD 0
   BE_BIT interrupt140;                           // DWORD 0
   BE_BIT interrupt141;                           // DWORD 0
   BE_BIT interrupt142;                           // DWORD 0
   BE_BIT interrupt143;                           // DWORD 0
   BE_BIT interrupt144;                           // DWORD 0
   BE_BIT interrupt145;                           // DWORD 0
   BE_BIT interrupt146;                           // DWORD 0
   BE_BIT interrupt147;                           // DWORD 0
   BE_BIT interrupt148;                           // DWORD 0
   BE_BIT interrupt149;                           // DWORD 0
   BE_BIT interrupt150;                           // DWORD 0
   BE_BIT interrupt151;                           // DWORD 0
   BE_BIT interrupt152;                           // DWORD 0
   BE_BIT interrupt153;                           // DWORD 0
   BE_BIT interrupt154;                           // DWORD 0
   BE_BIT interrupt155;                           // DWORD 0
   BE_BIT interrupt156;                           // DWORD 0
   BE_BIT interrupt157;                           // DWORD 0
   BE_BIT interrupt158;                           // DWORD 0
   BE_BIT interrupt159;                           // DWORD 0
} SG_PACK BE_CEV_ISR10_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR10_CSR_AMAP, *PCEV_ISR10_CSR_AMAP;


// Interrupt Status Register 11. The twelfth of twelve application  interrupt status
// registers. This register contains the interrupts for Event Queues EQ160 through EQ191.
typedef struct {
   BE_BIT interrupt160;                           // DWORD 0
   BE_BIT interrupt161;                           // DWORD 0
   BE_BIT interrupt162;                           // DWORD 0
   BE_BIT interrupt163;                           // DWORD 0
   BE_BIT interrupt164;                           // DWORD 0
   BE_BIT interrupt165;                           // DWORD 0
   BE_BIT interrupt166;                           // DWORD 0
   BE_BIT interrupt167;                           // DWORD 0
   BE_BIT interrupt168;                           // DWORD 0
   BE_BIT interrupt169;                           // DWORD 0
   BE_BIT interrupt170;                           // DWORD 0
   BE_BIT interrupt171;                           // DWORD 0
   BE_BIT interrupt172;                           // DWORD 0
   BE_BIT interrupt173;                           // DWORD 0
   BE_BIT interrupt174;                           // DWORD 0
   BE_BIT interrupt175;                           // DWORD 0
   BE_BIT interrupt176;                           // DWORD 0
   BE_BIT interrupt177;                           // DWORD 0
   BE_BIT interrupt178;                           // DWORD 0
   BE_BIT interrupt179;                           // DWORD 0
   BE_BIT interrupt180;                           // DWORD 0
   BE_BIT interrupt181;                           // DWORD 0
   BE_BIT interrupt182;                           // DWORD 0
   BE_BIT interrupt183;                           // DWORD 0
   BE_BIT interrupt184;                           // DWORD 0
   BE_BIT interrupt185;                           // DWORD 0
   BE_BIT interrupt186;                           // DWORD 0
   BE_BIT interrupt187;                           // DWORD 0
   BE_BIT interrupt188;                           // DWORD 0
   BE_BIT interrupt189;                           // DWORD 0
   BE_BIT interrupt190;                           // DWORD 0
   BE_BIT interrupt191;                           // DWORD 0
} SG_PACK BE_CEV_ISR11_CSR_AMAP;
typedef struct { u32 dw[1]; } CEV_ISR11_CSR_AMAP, *PCEV_ISR11_CSR_AMAP;


//  Control registers for how and what completions and events are generated. 
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_BIT rsvd3[32];                              // DWORD 3
   BE_BIT rsvd4[32];                              // DWORD 4
   BE_BIT rsvd5[32];                              // DWORD 5
   BE_CEV_ISR0_CSR_AMAP isr0;
   BE_CEV_ISR1_CSR_AMAP isr1;
   BE_CEV_ISR2_CSR_AMAP isr2;
   BE_CEV_ISR3_CSR_AMAP isr3;
   BE_CEV_ISR4_CSR_AMAP isr4;
   BE_CEV_ISR5_CSR_AMAP isr5;
   BE_CEV_ISR6_CSR_AMAP isr6;
   BE_CEV_ISR7_CSR_AMAP isr7;
   BE_CEV_ISR8_CSR_AMAP isr8;
   BE_CEV_ISR9_CSR_AMAP isr9;
   BE_CEV_ISR10_CSR_AMAP isr10;
   BE_CEV_ISR11_CSR_AMAP isr11;
   BE_BIT rsvd6[32];                              // DWORD 18
   BE_BIT rsvd7[32];                              // DWORD 19
   BE_BIT rsvd8[32];                              // DWORD 20
   BE_BIT rsvd9[32];                              // DWORD 21
   BE_BIT rsvd10[32];                             // DWORD 22
   BE_BIT rsvd11[32];                             // DWORD 23
   BE_BIT rsvd12[32];                             // DWORD 24
   BE_BIT rsvd13[32];                             // DWORD 25
   BE_BIT rsvd14[32];                             // DWORD 26
   BE_BIT rsvd15[32];                             // DWORD 27
   BE_BIT rsvd16[32];                             // DWORD 28
   BE_BIT rsvd17[32];                             // DWORD 29
   BE_BIT rsvd18[32];                             // DWORD 30
   BE_BIT rsvd19[32];                             // DWORD 31
   BE_BIT rsvd20[32];                             // DWORD 32
   BE_BIT rsvd21[32];                             // DWORD 33
   BE_BIT rsvd22[32];                             // DWORD 34
   BE_BIT rsvd23[32];                             // DWORD 35
   BE_BIT rsvd24[32];                             // DWORD 36
   BE_BIT rsvd25[32];                             // DWORD 37
   BE_BIT rsvd26[32];                             // DWORD 38
   BE_BIT rsvd27[32];                             // DWORD 39
   BE_BIT rsvd28[32];                             // DWORD 40
   BE_BIT rsvd29[32];                             // DWORD 41
   BE_BIT rsvd30[32];                             // DWORD 42
   BE_BIT rsvd31[32];                             // DWORD 43
   BE_BIT rsvd32[32];                             // DWORD 44
   BE_BIT rsvd33[32];                             // DWORD 45
   BE_BIT rsvd34[32];                             // DWORD 46
   BE_BIT rsvd35[32];                             // DWORD 47
   BE_BIT rsvd36[32];                             // DWORD 48
   BE_BIT rsvd37[32];                             // DWORD 49
   BE_BIT rsvd38[32];                             // DWORD 50
   BE_BIT rsvd39[32];                             // DWORD 51
   BE_BIT rsvd40[32];                             // DWORD 52
   BE_BIT rsvd41[32];                             // DWORD 53
   BE_BIT rsvd42[32];                             // DWORD 54
   BE_BIT rsvd43[32];                             // DWORD 55
   BE_BIT rsvd44[32];                             // DWORD 56
   BE_BIT rsvd45[32];                             // DWORD 57
   BE_BIT rsvd46[32];                             // DWORD 58
   BE_BIT rsvd47[32];                             // DWORD 59
   BE_BIT rsvd48[32];                             // DWORD 60
   BE_BIT rsvd49[32];                             // DWORD 61
   BE_BIT rsvd50[32];                             // DWORD 62
   BE_BIT rsvd51[32];                             // DWORD 63
   BE_BIT rsvd52[32];                             // DWORD 64
   BE_BIT rsvd53[32];                             // DWORD 65
   BE_BIT rsvd54[32];                             // DWORD 66
   BE_BIT rsvd55[32];                             // DWORD 67
   BE_BIT rsvd56[192];                            // DWORD 68
   BE_BIT rsvd57[32];                             // DWORD 74
   BE_BIT rsvd58[32];                             // DWORD 75
   BE_BIT rsvd59[32];                             // DWORD 76
   BE_BIT rsvd60[160];                            // DWORD 77
   BE_BIT rsvd61[160];                            // DWORD 82
   BE_BIT rsvd62[160];                            // DWORD 87
   BE_BIT rsvd63[160];                            // DWORD 92
   BE_BIT rsvd64[352];                            // DWORD 97
   BE_BIT rsvd65[96];                             // DWORD 108
   BE_BIT rsvd66[145][32];                        // DWORD 111
} SG_PACK BE_CEV_CSRMAP_AMAP;
typedef struct { u32 dw[256]; } CEV_CSRMAP_AMAP, *PCEV_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __cev_amap_h__

