/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __descriptors_amap_h__
#define __descriptors_amap_h__
#include "setypes.h"
#include "defines.h"
#include "headers.h"
#include "uc.h"
#include "mpu_local_mmr.h"
#include "reg_enums.h"
#include "eeprom.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// RxULP WDMA Consolidator Packed Page Mode Command Context. This structure must be
// aligned to a eight-byte boundary in CTX. 
typedef struct {
   BE_BIT palo[32];                               // DWORD 0
   BE_BIT pahi[32];                               // DWORD 1
} SG_PACK BE_WCON_PM_CC_AMAP;
typedef struct { u32 dw[2]; } WCON_PM_CC_AMAP, *PWCON_PM_CC_AMAP;


// --- IPC_NODE_ID_ENUM ---
// IPC processor id values
#define TPOST_NODE_ID                   (0)       // TPOST ID
#define TPRE_NODE_ID                    (1)       // TPRE ID
#define TXULP0_NODE_ID                  (2)       // TXULP0 ID
#define TXULP1_NODE_ID                  (3)       // TXULP1 ID
#define TXULP2_NODE_ID                  (4)       // TXULP2 ID
#define RXULP0_NODE_ID                  (5)       // RXULP0 ID
#define RXULP1_NODE_ID                  (6)       // RXULP1 ID
#define RXULP2_NODE_ID                  (7)       // RXULP2 ID
#define MPU_NODE_ID                     (15)      // MPU ID

typedef enum {
   ENUM_TPOST_NODE_ID = 0x0UL,
   ENUM_TPRE_NODE_ID = 0x1UL,
   ENUM_TXULP0_NODE_ID = 0x2UL,
   ENUM_TXULP1_NODE_ID = 0x3UL,
   ENUM_TXULP2_NODE_ID = 0x4UL,
   ENUM_RXULP0_NODE_ID = 0x5UL,
   ENUM_RXULP1_NODE_ID = 0x6UL,
   ENUM_RXULP2_NODE_ID = 0x7UL,
   ENUM_MPU_NODE_ID = 0xfUL
} IPC_NODE_ID_ENUM;

//                Buffer Descriptor Format             
typedef struct {
   BE_BIT frag_pa_hi[32];                         // DWORD 0
   BE_BIT frag_pa_lo[32];                         // DWORD 1
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_BIT frag_len[17];                           // DWORD 3
   BE_BIT rsvd1[14];                              // DWORD 3
   BE_BIT ddr;                                    // DWORD 3
} SG_PACK BE_BUFFER_DESC_AMAP;
typedef struct { u32 dw[4]; } BUFFER_DESC_AMAP, *PBUFFER_DESC_AMAP;


// --- TXULP_CLASS_COLOR_ENUM ---
// Classification color values
#define TXULP_CLASS_NOCOLOR             (0)       // classification is not enabled
                                                  // (hardware drives this value)
#define TXULP_CLASS_GREEN               (1)       // green (enough tokens in the qos Tc)
#define TXULP_CLASS_YELLOW              (2)       // yellow (enough tokens in the qos EBP)
#define TXULP_CLASS_RED                 (3)       // red (not enough tokens in the qos Tc
                                                  // or EBP)

typedef enum {
   ENUM_TXULP_CLASS_NOCOLOR = 0x0UL,
   ENUM_TXULP_CLASS_GREEN = 0x1UL,
   ENUM_TXULP_CLASS_YELLOW = 0x2UL,
   ENUM_TXULP_CLASS_RED = 0x3UL
} TXULP_CLASS_COLOR_ENUM;

//              Work request block that the driver issues to the chip for             
// Ethernet transmissions. All control fields must be valid in              each WRB for a
// message. The controller, as specified by the              flags, optionally writes an
// entry to the Completion Ring and              generate an event.           
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[18];                              // DWORD 1
   BE_BIT last_seg_udp_len[14];                   // DWORD 1
   BE_BIT complete;                               // DWORD 2
   BE_BIT event;                                  // DWORD 2
   BE_BIT crc;                                    // DWORD 2
   BE_BIT forward;                                // DWORD 2
   BE_BIT ipv6_lso;                               // DWORD 2
   BE_BIT mgmt;                                   // DWORD 2
   BE_BIT ipcs;                                   // DWORD 2
   BE_BIT udpcs;                                  // DWORD 2
   BE_BIT tcpcs;                                  // DWORD 2
   BE_BIT lso;                                    // DWORD 2
   BE_BIT vlan;                                   // DWORD 2
   BE_BIT gso[2];                                 // DWORD 2
   BE_BIT num_wrb[5];                             // DWORD 2
   BE_BIT lso_mss[14];                            // DWORD 2
   BE_BIT len[16];                                // DWORD 3
   BE_BIT vlan_tag[16];                           // DWORD 3
} SG_PACK BE_BE2_ETH_HDR_WRB_AMAP;
typedef struct { u32 dw[4]; } BE2_ETH_HDR_WRB_AMAP, *PBE2_ETH_HDR_WRB_AMAP;


//              Work request block that the driver issues to the chip for             
// Ethernet transmissions. All control fields must be valid in              each WRB for a
// message. The controller, as specified by the              flags, optionally writes an
// entry to the Completion Ring and              generate an event.           
typedef struct {
   BE_BIT frag_pa_hi[32];                         // DWORD 0
   BE_BIT frag_pa_lo[32];                         // DWORD 1
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_BIT frag_len[16];                           // DWORD 3
   BE_BIT rsvd1[15];                              // DWORD 3
   BE_BIT ddr;                                    // DWORD 3
} SG_PACK BE_BE2_ETH_WRB_AMAP;
typedef struct { u32 dw[4]; } BE2_ETH_WRB_AMAP, *PBE2_ETH_WRB_AMAP;


//              REMOVE REMOVE REMOVE             THIS DOES NOT BELONG HERE. MOVE TO
// SOFTWARE AREA                          TOE WRBs are created by the driver in send
// rings. A WRB is a              16B structure as defined below. The number of TOE Work
// Request              Blocks for a message depends on the message size. The driver      
//        divides a message into multiple WRBs. The message's last WRB              has
// the last flag bit set. The message completes when the last              byte is
// transmitted. The controller, as specified by the flags,              optionally writes
// an entry to the Completion Ring and generate              an event. All control fields
// must be valid in each WRB for a              message.           
typedef struct {
   BE_BIT frag_addr_hi[32];                       // DWORD 0
   BE_BIT frag_addr_lo[32];                       // DWORD 1
   BE_BIT complete;                               // DWORD 2
   BE_BIT fin;                                    // DWORD 2
   BE_BIT push;                                   // DWORD 2
   BE_BIT jrnl_only;                              // DWORD 2
   BE_BIT jrnl_last;                              // DWORD 2
   BE_BIT nodelay;                                // DWORD 2
   BE_BIT cid[11];                                // DWORD 2
   BE_BIT idx[14];                                // DWORD 2
   BE_BIT rsvd0;                                  // DWORD 2
   BE_BIT frag_len[21];                           // DWORD 3
   BE_BIT rsvd1[10];                              // DWORD 3
   BE_BIT ddr;                                    // DWORD 3
} SG_PACK BE_BE2_TOE_WRB_AMAP;
typedef struct { u32 dw[4]; } BE2_TOE_WRB_AMAP, *PBE2_TOE_WRB_AMAP;


// --- TPRE_ORDER_ENUM ---
#define TPRE_ORDER_INLINE               (1)       // Indicates that this data segment is
                                                  // inline
#define TPRE_ORDER_INLINE_PLUG          (2)       // Indicates that this data segment
                                                  // plugs an ooo hole
#define TPRE_ORDER_NEW_OOO              (3)       // Indicates that this data segment
                                                  // results in a new hole
#define TPRE_ORDER_OOO_PREPEND          (4)       // Indicates a prepend operation to the
                                                  // ooo queue
#define TPRE_ORDER_OOO_APPEND           (5)       // Indicates an append operation to the
                                                  // ooo queue
#define TPRE_ORDER_TT_DONE              (6)       // Indicates a triple trip operation has
                                                  // concluded. Not used in driver
#define TPRE_ORDER_INLINE_PLUG_ADV_RCVNXT (6)     // Indicates a inline plug which
                                                  // advances the receive next
#define TPRE_ORDER_PURGE_OOO            (7)       // Indicates that all OOO data received
                                                  // so far has to be purged.

typedef enum {
   ENUM_TPRE_ORDER_INLINE = 0x1UL,
   ENUM_TPRE_ORDER_INLINE_PLUG = 0x2UL,
   ENUM_TPRE_ORDER_NEW_OOO = 0x3UL,
   ENUM_TPRE_ORDER_OOO_PREPEND = 0x4UL,
   ENUM_TPRE_ORDER_OOO_APPEND = 0x5UL,
   ENUM_TPRE_ORDER_TT_DONE = 0x6UL,
   ENUM_TPRE_ORDER_INLINE_PLUG_ADV_RCVNXT = 0x6UL,
   ENUM_TPRE_ORDER_PURGE_OOO = 0x7UL
} TPRE_ORDER_ENUM;

// After a packet is written to the appropriate FIFO, the receive filter will write an
// 128bit pseudo-header with the results of the parsing and checking. This pseudo header
// is used by the Receive Packet Processor to determine what command descriptor to
// generate, and where to send it. <br>A special case of this descriptor is called a
// Marble, and is used to flush receive rings. A Marble is defined as having a LEN field
// of 32 (decimal) or less, a CT filed of 0, and the MAC_ID field is not RXULP (0x2d). A
// Marble will not consume a pbuf, and will be sent to ERX.
typedef struct {
   BE_BIT l2type[2];                              // DWORD 0
   BE_BIT qinq;                                   // DWORD 0
   BE_BIT mac_id[6];                              // DWORD 0
   BE_BIT vtp;                                    // DWORD 0
   BE_BIT port;                                   // DWORD 0
   BE_BIT tho;                                    // DWORD 0
   BE_BIT snap;                                   // DWORD 0
   BE_BIT l3type[2];                              // DWORD 0
   BE_BIT rsvd0;                                  // DWORD 0
   BE_BIT ipcksm;                                 // DWORD 0
   BE_BIT l4_cksm;                                // DWORD 0
   BE_BIT ip_version;                             // DWORD 0
   BE_BIT err;                                    // DWORD 0
   BE_BIT dest_id[10];                            // DWORD 0
   BE_BIT sw;                                     // DWORD 0
   BE_BIT s;                                      // DWORD 0
   BE_BIT vtag[16];                               // DWORD 1
   BE_BIT len[14];                                // DWORD 1
   BE_BIT ct[2];                                  // DWORD 1
   BE_BIT mpacrc[32];                             // DWORD 2
   BE_BIT rss_hash[32];                           // DWORD 3
} SG_PACK BE_RXFILT_D_AMAP;
typedef struct { u32 dw[4]; } RXFILT_D_AMAP, *PRXFILT_D_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __descriptors_amap_h__

