/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fat_header_amap_h__
#define __fat_header_amap_h__
#include "setypes.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- BE_FAT_SIGNATURES ---
#define BE_FAT_HDR_SIGNATURE            (215793329) 
#define BE_FAT_DATA_SIGNATURE           (447528638) 
#define BE_FAT_SUBSECTION_SIGNATURE     (664568609) 
#define BE_FAT_DMA_SIGNATURE            (900876316) 
#define BE_FAT_RXF_SUBSECTION_SIGNATURE (1252283750) 
#define BE_FAT_TXD_SIGNATURE            (1301990257) 
#define BE_FAT_CONTEXT_SIGNATURE        (1539074194) 
#define BE_FAT_EP_SUBSECTION_SIGNATURE  (1835477488) 
#define BE_FAT_DATA_FOOTER_SIGNATURE    (2058346157) 

typedef enum {
   ENUM_BE_FAT_HDR_SIGNATURE = 0xcdcbeb1UL,
   ENUM_BE_FAT_DATA_SIGNATURE = 0x1aacbebeUL,
   ENUM_BE_FAT_SUBSECTION_SIGNATURE = 0x279c8321UL,
   ENUM_BE_FAT_DMA_SIGNATURE = 0x35b2481cUL,
   ENUM_BE_FAT_RXF_SUBSECTION_SIGNATURE = 0x4aa45566UL,
   ENUM_BE_FAT_TXD_SIGNATURE = 0x4d9acb71UL,
   ENUM_BE_FAT_CONTEXT_SIGNATURE = 0x5bbc6892UL,
   ENUM_BE_FAT_EP_SUBSECTION_SIGNATURE = 0x6d6729f0UL,
   ENUM_BE_FAT_DATA_FOOTER_SIGNATURE = 0x7aafdeadUL
} BE_FAT_SIGNATURES;

// --- FAT_CHIP_REV ---
#define FAT_CHIPREV_B2                  (1792)    
#define FAT_CHIPREV_B3                  (1808)    
#define FAT_CHIPREV_SKYHAWK             (4319)    

typedef enum {
   ENUM_FAT_CHIPREV_B2 = 0x700UL,
   ENUM_FAT_CHIPREV_B3 = 0x710UL,
   ENUM_FAT_CHIPREV_SKYHAWK = 0x10dfUL
} FAT_CHIP_REV;

// --- FAT_HDR_VERSION ---
#define FAT_HDR_VERSION1                (1)       
#define FAT_HDR_VERSION_CURRENT         (1)       

typedef enum {
   ENUM_FAT_HDR_VERSION1 = 0x1UL,
   ENUM_FAT_HDR_VERSION_CURRENT = 0x1UL
} FAT_HDR_VERSION;

// --- FAT_DATA_ID ---
#define FAT_DATA_ID_EP_CSR              (0)       
#define FAT_DATA_ID_MPU_CSR             (1)       
#define FAT_DATA_ID_EP_DUMP             (2)       
#define FAT_DATA_ID_SEEPROM             (3)       
#define FAT_DATA_ID_AUX_REG             (4)       
#define FAT_DATA_ID_RXF_STATS           (5)       
#define FAT_DATA_ID_TXP_STATS           (6)       
#define FAT_DATA_ID_TXD_DATA            (7)       
#define FAT_DATA_ID_PTC_STATS           (8)       
#define FAT_DATA_ID_UC_STATS            (9)       
#define FAT_DATA_ID_NDMA                (10)      
#define FAT_DATA_ID_RXF_DATA            (11)      
#define FAT_DATA_ID_RDMA                (12)      
#define FAT_DATA_ID_WDMA                (13)      
#define FAT_DATA_ID_CONTEXT             (14)      
#define FAT_DATA_ID_PMEM                (15)      
#define FAT_DATA_ID_PMEM_DATA           (16)      
#define FAT_DATA_ID_TXPB                (17)      
#define FAT_DATA_ID_TPRE_VQ             (18)      
#define FAT_DATA_ID_TPOST_VQ            (19)      
#define FAT_DATA_ID_TXP_VQ              (20)      
#define FAT_DATA_ID_RXULP_VQ            (21)      
#define FAT_DATA_ID_EXTFAT              (22)      
#define FAT_DATA_ID_MPU_SYSREG          (23)      
#define FAT_DATA_ID_MPU_DDRREG          (24)      

typedef enum {
   ENUM_FAT_DATA_ID_EP_CSR = 0x0UL,
   ENUM_FAT_DATA_ID_MPU_CSR = 0x1UL,
   ENUM_FAT_DATA_ID_EP_DUMP = 0x2UL,
   ENUM_FAT_DATA_ID_SEEPROM = 0x3UL,
   ENUM_FAT_DATA_ID_AUX_REG = 0x4UL,
   ENUM_FAT_DATA_ID_RXF_STATS = 0x5UL,
   ENUM_FAT_DATA_ID_TXP_STATS = 0x6UL,
   ENUM_FAT_DATA_ID_TXD_DATA = 0x7UL,
   ENUM_FAT_DATA_ID_PTC_STATS = 0x8UL,
   ENUM_FAT_DATA_ID_UC_STATS = 0x9UL,
   ENUM_FAT_DATA_ID_NDMA = 0xaUL,
   ENUM_FAT_DATA_ID_RXF_DATA = 0xbUL,
   ENUM_FAT_DATA_ID_RDMA = 0xcUL,
   ENUM_FAT_DATA_ID_WDMA = 0xdUL,
   ENUM_FAT_DATA_ID_CONTEXT = 0xeUL,
   ENUM_FAT_DATA_ID_PMEM = 0xfUL,
   ENUM_FAT_DATA_ID_PMEM_DATA = 0x10UL,
   ENUM_FAT_DATA_ID_TXPB = 0x11UL,
   ENUM_FAT_DATA_ID_TPRE_VQ = 0x12UL,
   ENUM_FAT_DATA_ID_TPOST_VQ = 0x13UL,
   ENUM_FAT_DATA_ID_TXP_VQ = 0x14UL,
   ENUM_FAT_DATA_ID_RXULP_VQ = 0x15UL,
   ENUM_FAT_DATA_ID_EXTFAT = 0x16UL,
   ENUM_FAT_DATA_ID_MPU_SYSREG = 0x17UL,
   ENUM_FAT_DATA_ID_MPU_DDRREG = 0x18UL
} FAT_DATA_ID;

// --- FAT_EP_ID ---
#define FAT_EP_ID_TPOST                 (0)       
#define FAT_EP_ID_TPRE                  (1)       
#define FAT_EP_TXULP0                   (2)       
#define FAT_EP_TXULP1                   (3)       
#define FAT_EP_RXULP0                   (5)       
#define FAT_EP_RXULP1                   (6)       
#define FAT_ARM_MPU                     (15)      
#define FAT_NON_SPECIFIC                (65280)   
#define FAT_EP_END_MARKER               (65535)   
#define FAT_EP_ID_ALL_CSR               (2147483647) 

typedef enum {
   ENUM_FAT_EP_ID_TPOST = 0x0UL,
   ENUM_FAT_EP_ID_TPRE = 0x1UL,
   ENUM_FAT_EP_TXULP0 = 0x2UL,
   ENUM_FAT_EP_TXULP1 = 0x3UL,
   ENUM_FAT_EP_RXULP0 = 0x5UL,
   ENUM_FAT_EP_RXULP1 = 0x6UL,
   ENUM_FAT_ARM_MPU = 0xfUL,
   ENUM_FAT_NON_SPECIFIC = 0xff00UL,
   ENUM_FAT_EP_END_MARKER = 0xffffUL,
   ENUM_FAT_EP_ID_ALL_CSR = 0x7fffffffUL
} FAT_EP_ID;

// --- FAT_EP_SUBSECTION_ID ---
#define FAT_EP_PROC_ID                  (1)       
#define FAT_EP_FIXED_ID                 (2)       
#define FAT_EP_BANKED_ID                (4)       
#define FAT_EP_SHARED_FIXED_ID          (8)       
#define FAT_EP_IRAM_ID                  (16)      
#define FAT_EP_MMR_ID                   (32)      
#define FAT_EP_STATISTICS_ID            (64)      

typedef enum {
   ENUM_FAT_EP_PROC_ID = 0x1UL,
   ENUM_FAT_EP_FIXED_ID = 0x2UL,
   ENUM_FAT_EP_BANKED_ID = 0x4UL,
   ENUM_FAT_EP_SHARED_FIXED_ID = 0x8UL,
   ENUM_FAT_EP_IRAM_ID = 0x10UL,
   ENUM_FAT_EP_MMR_ID = 0x20UL,
   ENUM_FAT_EP_STATISTICS_ID = 0x40UL
} FAT_EP_SUBSECTION_ID;

// --- FAT_EP_SUBSECTION_VERSION ---
#define FAT_EP_SUBSECTION_VERSION1      (1)       
#define FAT_EP_SUBSECTION_VERSION_CURRENT (1)     

typedef enum {
   ENUM_FAT_EP_SUBSECTION_VERSION1 = 0x1UL,
   ENUM_FAT_EP_SUBSECTION_VERSION_CURRENT = 0x1UL
} FAT_EP_SUBSECTION_VERSION;

// --- FAT_SEEPROM_VERSION ---
#define FAT_SEEPROM_ALLDATA             (1)       
#define FAT_SEEPROM_VERSION1            (2)       
#define FAT_SEEPROM_VERSION2            (3)       
#define FAT_SEEPROM_VERSION_CURRENT     (3)       

typedef enum {
   ENUM_FAT_SEEPROM_ALLDATA = 0x1UL,
   ENUM_FAT_SEEPROM_VERSION1 = 0x2UL,
   ENUM_FAT_SEEPROM_VERSION2 = 0x3UL,
   ENUM_FAT_SEEPROM_VERSION_CURRENT = 0x3UL
} FAT_SEEPROM_VERSION;

// --- FAT_EP_DUMP_VERSION ---
#define FAT_EP_DUMP_VERSION1            (1)       
#define FAT_EP_DUMP_VERSION2            (2)       
#define FAT_EP_DUMP_VERSION3            (3)       
#define FAT_EP_DUMP_VERSION_CURRENT     (3)       

typedef enum {
   ENUM_FAT_EP_DUMP_VERSION1 = 0x1UL,
   ENUM_FAT_EP_DUMP_VERSION2 = 0x2UL,
   ENUM_FAT_EP_DUMP_VERSION3 = 0x3UL,
   ENUM_FAT_EP_DUMP_VERSION_CURRENT = 0x3UL
} FAT_EP_DUMP_VERSION;

// --- FAT_EP_PROCESSOR_COLLECTION_VERSION ---
#define FAT_EP_PROCESSOR_COLLECTION_VERSION1 (1)  
#define FAT_EP_PROCESSOR_COLLECTION_VERSION2 (2)  
#define FAT_EP_PROCESSOR_COLLECTION_VERSION_CURRENT (2) 

typedef enum {
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION1 = 0x1UL,
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION2 = 0x2UL,
   ENUM_FAT_EP_PROCESSOR_COLLECTION_VERSION_CURRENT = 0x2UL
} FAT_EP_PROCESSOR_COLLECTION_VERSION;

// --- FAT_EP_OP_CODES ---
#define FAT_EP_RSR                      (48)      
#define FAT_EP_WSR                      (49)      
#define FAT_EP_RUR                      (62)      

typedef enum {
   ENUM_FAT_EP_RSR = 0x30UL,
   ENUM_FAT_EP_WSR = 0x31UL,
   ENUM_FAT_EP_RUR = 0x3eUL
} FAT_EP_OP_CODES;

// --- FAT_EP_REG_VALUES ---
#define FAT_EP_A0                       (0)       
#define FAT_EP_LBEG                     (0)       
#define FAT_EP_LEND                     (1)       
#define FAT_EP_LCOUNT                   (2)       
#define FAT_EP_A3                       (3)       
#define FAT_EP_SAR                      (3)       
#define FAT_EP_A4                       (4)       
#define FAT_EP_A5                       (5)       
#define FAT_EP_WINDOWBASE               (72)      
#define FAT_EP_WINDOWSTART              (73)      
#define FAT_EP_DDR                      (104)     
#define FAT_EP_IBREAKA0                 (128)     
#define FAT_EP_IBREAKA1                 (129)     
#define FAT_EP_DBREAKA0                 (144)     
#define FAT_EP_DBREAKA1                 (145)     
#define FAT_EP_EPC1                     (177)     
#define FAT_EP_EPC2                     (178)     
#define FAT_EP_EPC3                     (179)     
#define FAT_EP_EPC4                     (180)     
#define FAT_EP_DEPC                     (192)     
#define FAT_EP_EPS2                     (194)     
#define FAT_EP_EPS3                     (195)     
#define FAT_EP_EPS4                     (196)     
#define FAT_EP_EXCSAVE1                 (209)     
#define FAT_EP_EXCSAVE2                 (210)     
#define FAT_EP_EXCSAVE3                 (211)     
#define FAT_EP_EXCSAVE4                 (212)     
#define FAT_EP_INTENABLE                (228)     
#define FAT_EP_PS                       (230)     
#define FAT_EP_EXCCAUSE                 (232)     
#define FAT_EP_DEBUGCAUSE               (233)     
#define FAT_EP_CCOUNT                   (234)     
#define FAT_EP_PRID                     (235)     
#define FAT_EP_ICOUNT                   (236)     
#define FAT_EP_ICOUNTLEVEL              (237)     
#define FAT_EP_CCOMPARE0                (240)     

typedef enum {
   ENUM_FAT_EP_A0 = 0x0UL,
   ENUM_FAT_EP_LBEG = 0x0UL,
   ENUM_FAT_EP_LEND = 0x1UL,
   ENUM_FAT_EP_LCOUNT = 0x2UL,
   ENUM_FAT_EP_A3 = 0x3UL,
   ENUM_FAT_EP_SAR = 0x3UL,
   ENUM_FAT_EP_A4 = 0x4UL,
   ENUM_FAT_EP_A5 = 0x5UL,
   ENUM_FAT_EP_WINDOWBASE = 0x48UL,
   ENUM_FAT_EP_WINDOWSTART = 0x49UL,
   ENUM_FAT_EP_DDR = 0x68UL,
   ENUM_FAT_EP_IBREAKA0 = 0x80UL,
   ENUM_FAT_EP_IBREAKA1 = 0x81UL,
   ENUM_FAT_EP_DBREAKA0 = 0x90UL,
   ENUM_FAT_EP_DBREAKA1 = 0x91UL,
   ENUM_FAT_EP_EPC1 = 0xb1UL,
   ENUM_FAT_EP_EPC2 = 0xb2UL,
   ENUM_FAT_EP_EPC3 = 0xb3UL,
   ENUM_FAT_EP_EPC4 = 0xb4UL,
   ENUM_FAT_EP_DEPC = 0xc0UL,
   ENUM_FAT_EP_EPS2 = 0xc2UL,
   ENUM_FAT_EP_EPS3 = 0xc3UL,
   ENUM_FAT_EP_EPS4 = 0xc4UL,
   ENUM_FAT_EP_EXCSAVE1 = 0xd1UL,
   ENUM_FAT_EP_EXCSAVE2 = 0xd2UL,
   ENUM_FAT_EP_EXCSAVE3 = 0xd3UL,
   ENUM_FAT_EP_EXCSAVE4 = 0xd4UL,
   ENUM_FAT_EP_INTENABLE = 0xe4UL,
   ENUM_FAT_EP_PS = 0xe6UL,
   ENUM_FAT_EP_EXCCAUSE = 0xe8UL,
   ENUM_FAT_EP_DEBUGCAUSE = 0xe9UL,
   ENUM_FAT_EP_CCOUNT = 0xeaUL,
   ENUM_FAT_EP_PRID = 0xebUL,
   ENUM_FAT_EP_ICOUNT = 0xecUL,
   ENUM_FAT_EP_ICOUNTLEVEL = 0xedUL,
   ENUM_FAT_EP_CCOMPARE0 = 0xf0UL
} FAT_EP_REG_VALUES;

// --- FAT_TXD_DATA_VERSION ---
#define FAT_TXD_DATA_VERSION0           (0)       
#define FAT_TXD_DATA_VERSION1           (1)       
#define FAT_TXD_DATA_VERSION2           (2)       
#define FAT_TXD_DATA_VERSION_CURRENT    (2)       

typedef enum {
   ENUM_FAT_TXD_DATA_VERSION0 = 0x0UL,
   ENUM_FAT_TXD_DATA_VERSION1 = 0x1UL,
   ENUM_FAT_TXD_DATA_VERSION2 = 0x2UL,
   ENUM_FAT_TXD_DATA_VERSION_CURRENT = 0x2UL
} FAT_TXD_DATA_VERSION;

// --- FAT_DMA_SECTION_VERSION ---
#define FAT_DMA_SECTION_VERSION1        (1)       
#define FAT_DMA_SECTION_VERSION_CURRENT (1)       

typedef enum {
   ENUM_FAT_DMA_SECTION_VERSION1 = 0x1UL,
   ENUM_FAT_DMA_SECTION_VERSION_CURRENT = 0x1UL
} FAT_DMA_SECTION_VERSION;

// --- FAT_DMA_ID ---
#define FAT_DMA_ID_NDMA                 (1)       
#define FAT_DMA_ID_RDMA                 (2)       
#define FAT_DMA_ID_WDMA                 (4)       

typedef enum {
   ENUM_FAT_DMA_ID_NDMA = 0x1UL,
   ENUM_FAT_DMA_ID_RDMA = 0x2UL,
   ENUM_FAT_DMA_ID_WDMA = 0x4UL
} FAT_DMA_ID;

// --- FAT_RXF_DATA_VERSION ---
#define FAT_RXF_DATA_VERSION1           (1)       
#define FAT_RXF_DATA_VERSION_CURRENT    (1)       

typedef enum {
   ENUM_FAT_RXF_DATA_VERSION1 = 0x1UL,
   ENUM_FAT_RXF_DATA_VERSION_CURRENT = 0x1UL
} FAT_RXF_DATA_VERSION;

// --- FAT_RXF_SUBSECTION_ID ---
#define FAT_RXF_SUBSECTION_MAC_PORT0    (0)       
#define FAT_RXF_SUBSECTION_MULTICAST_PORT0 (1)    
#define FAT_RXF_SUBSECTION_VLAN         (2)       
#define FAT_RXF_SUBSECTION_DA           (3)       
#define FAT_RXF_SUBSECTION_ACPI         (4)       
#define FAT_RXF_SUBSECTION_OFFLOADED    (5)       
#define FAT_RXF_SUBSECTION_RSS_KEY      (9)       
#define FAT_RXF_SUBSECTION_RSS_TABLE    (10)      
#define FAT_RXF_SUBSECTION_FCOE         (11)      
#define FAT_RXF_SUBSECTION_MAC_PORT1    (12)      
#define FAT_RXF_SUBSECTION_MULTICAST_PORT1 (13)   

typedef enum {
   ENUM_FAT_RXF_SUBSECTION_MAC_PORT0 = 0x0UL,
   ENUM_FAT_RXF_SUBSECTION_MULTICAST_PORT0 = 0x1UL,
   ENUM_FAT_RXF_SUBSECTION_VLAN = 0x2UL,
   ENUM_FAT_RXF_SUBSECTION_DA = 0x3UL,
   ENUM_FAT_RXF_SUBSECTION_ACPI = 0x4UL,
   ENUM_FAT_RXF_SUBSECTION_OFFLOADED = 0x5UL,
   ENUM_FAT_RXF_SUBSECTION_RSS_KEY = 0x9UL,
   ENUM_FAT_RXF_SUBSECTION_RSS_TABLE = 0xaUL,
   ENUM_FAT_RXF_SUBSECTION_FCOE = 0xbUL,
   ENUM_FAT_RXF_SUBSECTION_MAC_PORT1 = 0xcUL,
   ENUM_FAT_RXF_SUBSECTION_MULTICAST_PORT1 = 0xdUL
} FAT_RXF_SUBSECTION_ID;

// --- FAT_GEN_SUBSECTION_ID ---
#define FAT_GEN_SUBSECTION_TXPB_LINK    (1)       
#define FAT_GEN_SUBSECTION_TXPB_BUFFER  (2)       
#define FAT_GEN_SUBSECTION_VQ_LL        (3)       
#define FAT_GEN_SUBSECTION_VQ_DATA      (4)       
#define FAT_GEN_SUBSECTION_VQ_REGS      (5)       
#define FAT_GEN_SUBSECTION_VQ_PTRS      (6)       

typedef enum {
   ENUM_FAT_GEN_SUBSECTION_TXPB_LINK = 0x1UL,
   ENUM_FAT_GEN_SUBSECTION_TXPB_BUFFER = 0x2UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_LL = 0x3UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_DATA = 0x4UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_REGS = 0x5UL,
   ENUM_FAT_GEN_SUBSECTION_VQ_PTRS = 0x6UL
} FAT_GEN_SUBSECTION_ID;

// --- FAT_DATA_FOOTER_VERSION ---
#define FAT_DATA_FOOTER_VERSION1        (1)       
#define FAT_DATA_FOOTER_VERSION_CURRENT (1)       

typedef enum {
   ENUM_FAT_DATA_FOOTER_VERSION1 = 0x1UL,
   ENUM_FAT_DATA_FOOTER_VERSION_CURRENT = 0x1UL
} FAT_DATA_FOOTER_VERSION;

// --- FAT_DATA_SECTION_VERSION ---
#define FAT_DATA_SECTION_VERSION0       (0)       
#define FAT_DATA_SECTION_VERSION1       (1)       
#define FAT_DATA_SECTION_VERSION_CURRENT (1)      

typedef enum {
   ENUM_FAT_DATA_SECTION_VERSION0 = 0x0UL,
   ENUM_FAT_DATA_SECTION_VERSION1 = 0x1UL,
   ENUM_FAT_DATA_SECTION_VERSION_CURRENT = 0x1UL
} FAT_DATA_SECTION_VERSION;

// --- FAT_CSR_DATA_VERSION ---
#define FAT_CSR_DATA_VERSION_INITIAL    (0)       
#define FAT_CSR_DATA_VERSION_ENHANCED   (1)       
#define FAT_CSR_DATA_VERSION_ENHANCED_PLUS_WCON (2) 
#define FAT_CSR_DATA_VERSION_CURRENT    (2)       

typedef enum {
   ENUM_FAT_CSR_DATA_VERSION_INITIAL = 0x0UL,
   ENUM_FAT_CSR_DATA_VERSION_ENHANCED = 0x1UL,
   ENUM_FAT_CSR_DATA_VERSION_ENHANCED_PLUS_WCON = 0x2UL,
   ENUM_FAT_CSR_DATA_VERSION_CURRENT = 0x2UL
} FAT_CSR_DATA_VERSION;

//  This is the header that will indicate 1) presence of a header; 2) the version and size
// of that header; 3) the data collection capabilities understood by the firmware doing
// the data collection; 4) any revision information that might be useful in debugging the
// collected problem. 
typedef struct {
   BE_UEXACT32_AMAP fixed_signature;
   BE_UEXACT32_AMAP total_file_size;
   BE_UEXACT32_AMAP header_version;
   BE_UEXACT32_AMAP header_size;
   BE_UEXACT16_AMAP build_version[4];
   BE_UEXACT16_AMAP driver_version[4];
   BE_UEXACT32_AMAP board_id;
   BE_UEXACT16_AMAP pci_ids[4];
   BE_UEXACT16_AMAP be_config;
   BE_UEXACT16_AMAP completion_deciseconds;
   BE_UEXACT32_AMAP be_chip_revision;
   BE_UEXACT32_AMAP be_chip_uid[8];
   BE_BIT rsvd0[4][32];                           // DWORD 21
   BE_UEXACT32_AMAP compressed_size;
   BE_UEXACT32_AMAP failure_seconds;
   BE_BIT rsvd1[32];                              // DWORD 27
} SG_PACK BE_FAT_HEADER_AMAP;
typedef struct { u32 dw[28]; } FAT_HEADER_AMAP, *PFAT_HEADER_AMAP;


//  Each data collection type will have its own data section.  Initially, one type will be
//  defined that will be our current FAT CSR data collection.  Each data collection type
// can  be individually versioned so that the collected data can change. 
typedef struct {
   BE_UEXACT32_AMAP signature;
   BE_UEXACT32_AMAP ep_id;
   BE_UEXACT32_AMAP data_type;
   BE_UEXACT32_AMAP version;
   BE_UEXACT32_AMAP section_total_size;
   BE_UEXACT32_AMAP delta_deciseconds;
   BE_UEXACT32_AMAP data_header_version;
   BE_BIT compressed;                             // DWORD 7
   BE_BIT subsections_present;                    // DWORD 7
   BE_BIT rsvd0[30];                              // DWORD 7
   BE_BIT rsvd1[8][32];                           // DWORD 8
   BE_UEXACT32_AMAP start_of_data;
} SG_PACK BE_FAT_DATA_SECTION_AMAP;
typedef struct { u32 dw[17]; } FAT_DATA_SECTION_AMAP, *PFAT_DATA_SECTION_AMAP;


//  This is the selected data that is pulled from the seeprom. 
typedef struct {
   BE_UEXACT8_AMAP seeprom_version[2];
   BE_UEXACT16_AMAP board_id;
   BE_UEXACT8_AMAP emulex_serial_number[12];
   BE_UEXACT8_AMAP oem_serial_number[24];
   BE_UEXACT8_AMAP interface_10Gb_type;
   BE_UEXACT8_AMAP interface_1Gb_type;
   BE_UEXACT8_AMAP PHY_type_10Gb;
   BE_UEXACT8_AMAP PHY_type_1Gb;
   BE_UEXACT16_AMAP ipl_file_number;
   BE_UEXACT8_AMAP ipl_file_version;
   BE_BIT rsvd0[8];                               // DWORD 11
   BE_BIT rsvd1[7][32];                           // DWORD 12
} SG_PACK BE_FAT_SEEPROM_DATA_AMAP;
typedef struct { u32 dw[19]; } FAT_SEEPROM_DATA_AMAP, *PFAT_SEEPROM_DATA_AMAP;


//  This is the data collected from the EPs after a UE is detected. 
typedef struct {
   BE_UEXACT16_AMAP ep_image_version;
   BE_UEXACT8_AMAP number_of_ep_cores;
   BE_UEXACT8_AMAP number_of_data_banks;
   BE_UEXACT32_AMAP size_of_processor_image;
   BE_UEXACT32_AMAP size_of_fixed_ram;
   BE_UEXACT32_AMAP starting_address_of_fixed_ram;
   BE_UEXACT16_AMAP size_of_banked_ram;
   BE_UEXACT16_AMAP banked_ram_consistent;
   BE_UEXACT16_AMAP size_of_shared_fixed_ram;
   BE_UEXACT16_AMAP size_of_non_shared_fixed_ram;
   BE_UEXACT16_AMAP size_of_iram;
   BE_BIT rsvd0[16];                              // DWORD 6
   BE_BIT rsvd1[32];                              // DWORD 7
} SG_PACK BE_FAT_EP_IMAGE_AMAP;
typedef struct { u32 dw[8]; } FAT_EP_IMAGE_AMAP, *PFAT_EP_IMAGE_AMAP;


//  This is the fencing that precedes each EP data section. 
typedef struct {
   BE_UEXACT32_AMAP ep_subsection_signature;
   BE_UEXACT8_AMAP ep_subsection_type;
   BE_UEXACT8_AMAP ep_total_of_type;
   BE_UEXACT8_AMAP ep_which_of_type;
   BE_UEXACT8_AMAP ep_subsection_version;
   BE_UEXACT32_AMAP ep_subsection_size;
   BE_UEXACT32_AMAP ep_sub_delta_deciseconds;
   BE_BIT rsvd0[4][32];                           // DWORD 4
} SG_PACK BE_FAT_EP_SUBSECTION_AMAP;
typedef struct { u32 dw[8]; } FAT_EP_SUBSECTION_AMAP, *PFAT_EP_SUBSECTION_AMAP;


//  This is the processor state collected for the BE3.  Based on EP configuration for
// T1050.4 built 11/18/2005. 
typedef struct {
   BE_UEXACT8_AMAP version;
   BE_UEXACT8_AMAP number_of_address_regs;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP ar[32];
   BE_UEXACT32_AMAP ccount;
   BE_UEXACT32_AMAP debug_cause;
   BE_UEXACT32_AMAP debug_output_data_register;
   BE_UEXACT32_AMAP epc[4];
   BE_UEXACT32_AMAP eps[3];
   BE_UEXACT32_AMAP exc_cause;
   BE_UEXACT32_AMAP exc_save[4];
   BE_UEXACT32_AMAP instruction_count;
   BE_UEXACT32_AMAP icountlevel;
   BE_UEXACT32_AMAP intenable;
   BE_UEXACT32_AMAP loop_begin;
   BE_UEXACT32_AMAP loop_count;
   BE_UEXACT32_AMAP loop_end;
   BE_UEXACT32_AMAP program_counter;
   BE_UEXACT32_AMAP pr_id;
   BE_UEXACT32_AMAP ps;
   BE_UEXACT32_AMAP sar;
   BE_UEXACT32_AMAP windowbase;
   BE_UEXACT32_AMAP windowstart;
   BE_UEXACT32_AMAP depc;
   BE_UEXACT32_AMAP rasid;
   BE_UEXACT32_AMAP ccompare0;
   BE_UEXACT32_AMAP dbreaka[2];
   BE_UEXACT32_AMAP ibreaka[2];
   BE_UEXACT32_AMAP a[16];
   BE_UEXACT32_AMAP ur[22];
   BE_BIT rsvd1[15][32];                          // DWORD 105
} SG_PACK BE_FAT_EP_BE3_PROCESSOR_STATE_AMAP;
typedef struct { u32 dw[120]; } FAT_EP_BE3_PROCESSOR_STATE_AMAP, *PFAT_EP_BE3_PROCESSOR_STATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP operation;
   BE_UEXACT8_AMAP altreg;
   BE_UEXACT8_AMAP addrreg;
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_FAT_EP_PROC_OP_AMAP;
typedef struct { u32 dw[1]; } FAT_EP_PROC_OP_AMAP, *PFAT_EP_PROC_OP_AMAP;



typedef struct {
   BE_UEXACT32_AMAP stat_packets;
   BE_UEXACT32_AMAP stat_bytes_l;
   BE_UEXACT32_AMAP stat_bytes_u;
} SG_PACK BE_FAT_TXP_STATS_AMAP;
typedef struct { u32 dw[3]; } FAT_TXP_STATS_AMAP, *PFAT_TXP_STATS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP txd_dword[12];
   BE_UEXACT32_AMAP txd_state;
   BE_UEXACT32_AMAP pu_size;
   BE_UEXACT32_AMAP je_size;
   BE_UEXACT32_AMAP bd_size;
   BE_UEXACT32_AMAP signature;
   BE_BIT rsvd0[3][32];                           // DWORD 17
} SG_PACK BE_FAT_TXD_DATA_AMAP;
typedef struct { u32 dw[20]; } FAT_TXD_DATA_AMAP, *PFAT_TXD_DATA_AMAP;



typedef struct {
   BE_UEXACT32_AMAP signature;
   BE_UEXACT32_AMAP type;
   BE_UEXACT32_AMAP subsize;
   BE_BIT flags[32];                              // DWORD 3
   BE_UEXACT32_AMAP delta_deciseconds;
   BE_BIT rsvd0[3][32];                           // DWORD 5
} SG_PACK BE_FAT_RXF_SUBSECTION_AMAP;
typedef struct { u32 dw[8]; } FAT_RXF_SUBSECTION_AMAP, *PFAT_RXF_SUBSECTION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP signature;
   BE_UEXACT32_AMAP status_count;
   BE_UEXACT32_AMAP additional_data_size;
   BE_BIT rsvd0[5][32];                           // DWORD 3
} SG_PACK BE_FAT_DMA_SUBSECTION_AMAP;
typedef struct { u32 dw[8]; } FAT_DMA_SUBSECTION_AMAP, *PFAT_DMA_SUBSECTION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP signature;
   BE_UEXACT32_AMAP type;
   BE_UEXACT32_AMAP subsize;
   BE_BIT flags[32];                              // DWORD 3
   BE_UEXACT32_AMAP delta_deciseconds;
   BE_UEXACT16_AMAP data_version;
   BE_UEXACT16_AMAP data_header_version;
   BE_UEXACT32_AMAP item_count;
   BE_BIT rsvd0[9][32];                           // DWORD 7
} SG_PACK BE_FAT_GEN_SUBSECTION_AMAP;
typedef struct { u32 dw[16]; } FAT_GEN_SUBSECTION_AMAP, *PFAT_GEN_SUBSECTION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP signature;
   BE_UEXACT16_AMAP version;
   BE_UEXACT16_AMAP total_collection_time;
   BE_UEXACT32_AMAP total_data_written;
   BE_UEXACT32_AMAP pre_compress_data_size;
   BE_UEXACT32_AMAP post_compress_data_size;
   BE_BIT rsvd0[11][32];                          // DWORD 5
} SG_PACK BE_FAT_DATA_FOOTER_AMAP;
typedef struct { u32 dw[16]; } FAT_DATA_FOOTER_AMAP, *PFAT_DATA_FOOTER_AMAP;



typedef struct {
   BE_UEXACT32_AMAP vq_stats[5];
   BE_BIT rsvd0[7][32];                           // DWORD 5
} SG_PACK BE_FAT_VQ_REGS_AMAP;
typedef struct { u32 dw[12]; } FAT_VQ_REGS_AMAP, *PFAT_VQ_REGS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __fat_header_amap_h__

