/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __hw_host_struct_amap_h__
#define __hw_host_struct_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- EQ_COMPLETION_MAJOR_CODE_ENUM ---
#define EQ_MAJOR_CODE_COMPLETION        (0)       // Completion event on a completion
                                                  // queue.
#define EQ_MAJOR_CODE_ETH               (1)       // Affiliated Ethernet Event.
#define EQ_MAJOR_CODE_TOE               (2)       // Affiliated TOE Event.
#define EQ_MAJOR_CODE_RDMA              (3)       // Affiliated RDMA Event.
#define EQ_MAJOR_CODE_ISCSI             (4)       // Affiliated ISCSI Event
#define EQ_MAJOR_CODE_UNAFFILIATED      (5)       // Unaffiliated Event

typedef enum {
   ENUM_EQ_MAJOR_CODE_COMPLETION = 0x0UL,
   ENUM_EQ_MAJOR_CODE_ETH = 0x1UL,
   ENUM_EQ_MAJOR_CODE_TOE = 0x2UL,
   ENUM_EQ_MAJOR_CODE_RDMA = 0x3UL,
   ENUM_EQ_MAJOR_CODE_ISCSI = 0x4UL,
   ENUM_EQ_MAJOR_CODE_UNAFFILIATED = 0x5UL
} EQ_COMPLETION_MAJOR_CODE_ENUM;

// --- EQ_COMPLETION_MINOR_CODE_ENUM ---
#define EQ_MINOR_CODE_COMPLETION        (0)       // Completion event on a completion
                                                  // queue.
#define EQ_MINOR_CODE_OTHER             (1)       // Other Event (to be determined).

typedef enum {
   ENUM_EQ_MINOR_CODE_COMPLETION = 0x0UL,
   ENUM_EQ_MINOR_CODE_OTHER = 0x1UL
} EQ_COMPLETION_MINOR_CODE_ENUM;

// Queue Entry Definition for all 4 byte event queue types.
typedef struct {
   BE_BIT Valid;                                  // DWORD 0
   BE_BIT MajorCode[3];                           // DWORD 0
   BE_BIT MinorCode[12];                          // DWORD 0
   BE_BIT ResourceID[16];                         // DWORD 0
} SG_PACK BE_EQ_ENTRY_AMAP;
typedef struct { u32 dw[1]; } EQ_ENTRY_AMAP, *PEQ_ENTRY_AMAP;


// --- ETH_TX_COMPL_PORT_ENUM ---
// Port indicator contained in Ethernet TX completion descriptors.
#define ETH_COMP_PORT0                  (0)       
#define ETH_COMP_PORT1                  (1)       
#define ETH_COMP_MGMT                   (2)       

typedef enum {
   ENUM_ETH_COMP_PORT0 = 0x0UL,
   ENUM_ETH_COMP_PORT1 = 0x1UL,
   ENUM_ETH_COMP_MGMT = 0x2UL
} ETH_TX_COMPL_PORT_ENUM;

// --- ETH_TX_COMPL_CT_ENUM ---
// Completion type indicator contained in Ethernet TX completion descriptors.
#define ETH_COMP_ETH                    (0)       
#define ETH_COMP_TOE                    (1)       

typedef enum {
   ENUM_ETH_COMP_ETH = 0x0UL,
   ENUM_ETH_COMP_TOE = 0x1UL
} ETH_TX_COMPL_CT_ENUM;

// --- CAST_ENUM ---
#define BE_UNICAST_PACKET               (0)       
#define BE_MULTICAST_PACKET             (1)       
#define BE_BROADCAST_PACKET             (2)       
#define BE_RSVD_PACKET                  (3)       

typedef enum {
   ENUM_BE_UNICAST_PACKET = 0x0UL,
   ENUM_BE_MULTICAST_PACKET = 0x1UL,
   ENUM_BE_BROADCAST_PACKET = 0x2UL,
   ENUM_BE_RSVD_PACKET = 0x3UL
} CAST_ENUM;

// This is an Ethernet transmit completion descriptor
typedef struct {
   BE_BIT wrb_index[16];                          // DWORD 0
   BE_BIT ct[2];                                  // DWORD 0
   BE_BIT port[2];                                // DWORD 0
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT status[4];                              // DWORD 0
   BE_BIT user_bytes[16];                         // DWORD 1
   BE_BIT nwh_bytes[8];                           // DWORD 1
   BE_BIT lso;                                    // DWORD 1
   BE_BIT cast_enc[2];                            // DWORD 1
   BE_BIT rsvd1[5];                               // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_BIT pkts[16];                               // DWORD 3
   BE_BIT ringid[11];                             // DWORD 3
   BE_BIT hash_val[4];                            // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_ETH_TX_COMPL_AMAP;
typedef struct { u32 dw[4]; } ETH_TX_COMPL_AMAP, *PETH_TX_COMPL_AMAP;


// Ethernet Receive Buffer descriptor
typedef struct {
   BE_BIT fragpa_hi[32];                          // DWORD 0
   BE_BIT fragpa_lo[32];                          // DWORD 1
} SG_PACK BE_ETH_RX_D_AMAP;
typedef struct { u32 dw[2]; } ETH_RX_D_AMAP, *PETH_RX_D_AMAP;


// --- COMPL_MAC_ID_ENUM ---
// Meaning of the mac_id field in ETH_RX_COMPL
#define ETH_RX_NETWORK0                 (0)       // host networking, interface 0.
#define ETH_RX_NETWORK1                 (1)       // host networking, interface 1.
#define ETH_RX_STORAGE0                 (2)       // host storage, interface 0.
#define ETH_RX_STORAGE1                 (3)       // host storage, interface 1.
#define ETH_RX_VM0                      (4)       // VM0.
#define ETH_RX_VM1                      (5)       // VM1.
#define ETH_RX_VM2                      (6)       // VM2.
#define ETH_RX_VM3                      (7)       // VM3.
#define ETH_RX_VM4                      (8)       // VM4.
#define ETH_RX_VM5                      (9)       // VM5.
#define ETH_RX_VM6                      (10)      // VM6.
#define ETH_RX_VM7                      (11)      // VM7.
#define ETH_RX_VM8                      (12)      // VM8.
#define ETH_RX_VM9                      (13)      // VM9.
#define ETH_RX_VM10                     (14)      // VM10.
#define ETH_RX_VM11                     (15)      // VM11.
#define ETH_RX_VM12                     (16)      // VM12.
#define ETH_RX_VM13                     (17)      // VM13.
#define ETH_RX_VM14                     (18)      // VM14.
#define ETH_RX_VM15                     (19)      // VM15.
#define ETH_RX_VM16                     (20)      // VM16.
#define ETH_RX_VM17                     (21)      // VM17.
#define ETH_RX_VM18                     (22)      // VM18.
#define ETH_RX_VM19                     (23)      // VM19.
#define ETH_RX_VM20                     (24)      // VM20.
#define ETH_RX_VM21                     (25)      // VM21.
#define ETH_RX_VM22                     (26)      // VM22.
#define ETH_RX_VM23                     (27)      // VM23.
#define ETH_RX_VM24                     (28)      // VM24.
#define ETH_RX_VM25                     (29)      // VM25.
#define ETH_RX_VM26                     (30)      // VM26.
#define ETH_RX_VM27                     (31)      // VM27.
#define ETH_RX_VM28                     (32)      // VM28.
#define ETH_RX_VM29                     (33)      // VM29.
#define ETH_RX_VM30                     (34)      // VM30.
#define ETH_RX_VM31                     (35)      // VM31.
#define ETH_RX_RSS0                     (36)      // RSS CPU 0.
#define ETH_RX_RSS1                     (37)      // RSS CPU 1.
#define ETH_RX_RSS2                     (38)      // RSS CPU 2.
#define ETH_RX_RSS3                     (39)      // RSS CPU 3.
#define ETH_RX_RSS4                     (40)      // RSS CPU 4.
#define ETH_RX_RSS5                     (41)      // RSS CPU 5.
#define ETH_RX_RSS6                     (42)      // RSS CPU 6.
#define ETH_RX_RSS7                     (43)      // RSS CPU 7.

typedef enum {
   ENUM_ETH_RX_NETWORK0 = 0x0UL,
   ENUM_ETH_RX_NETWORK1 = 0x1UL,
   ENUM_ETH_RX_STORAGE0 = 0x2UL,
   ENUM_ETH_RX_STORAGE1 = 0x3UL,
   ENUM_ETH_RX_VM0 = 0x4UL,
   ENUM_ETH_RX_VM1 = 0x5UL,
   ENUM_ETH_RX_VM2 = 0x6UL,
   ENUM_ETH_RX_VM3 = 0x7UL,
   ENUM_ETH_RX_VM4 = 0x8UL,
   ENUM_ETH_RX_VM5 = 0x9UL,
   ENUM_ETH_RX_VM6 = 0xaUL,
   ENUM_ETH_RX_VM7 = 0xbUL,
   ENUM_ETH_RX_VM8 = 0xcUL,
   ENUM_ETH_RX_VM9 = 0xdUL,
   ENUM_ETH_RX_VM10 = 0xeUL,
   ENUM_ETH_RX_VM11 = 0xfUL,
   ENUM_ETH_RX_VM12 = 0x10UL,
   ENUM_ETH_RX_VM13 = 0x11UL,
   ENUM_ETH_RX_VM14 = 0x12UL,
   ENUM_ETH_RX_VM15 = 0x13UL,
   ENUM_ETH_RX_VM16 = 0x14UL,
   ENUM_ETH_RX_VM17 = 0x15UL,
   ENUM_ETH_RX_VM18 = 0x16UL,
   ENUM_ETH_RX_VM19 = 0x17UL,
   ENUM_ETH_RX_VM20 = 0x18UL,
   ENUM_ETH_RX_VM21 = 0x19UL,
   ENUM_ETH_RX_VM22 = 0x1aUL,
   ENUM_ETH_RX_VM23 = 0x1bUL,
   ENUM_ETH_RX_VM24 = 0x1cUL,
   ENUM_ETH_RX_VM25 = 0x1dUL,
   ENUM_ETH_RX_VM26 = 0x1eUL,
   ENUM_ETH_RX_VM27 = 0x1fUL,
   ENUM_ETH_RX_VM28 = 0x20UL,
   ENUM_ETH_RX_VM29 = 0x21UL,
   ENUM_ETH_RX_VM30 = 0x22UL,
   ENUM_ETH_RX_VM31 = 0x23UL,
   ENUM_ETH_RX_RSS0 = 0x24UL,
   ENUM_ETH_RX_RSS1 = 0x25UL,
   ENUM_ETH_RX_RSS2 = 0x26UL,
   ENUM_ETH_RX_RSS3 = 0x27UL,
   ENUM_ETH_RX_RSS4 = 0x28UL,
   ENUM_ETH_RX_RSS5 = 0x29UL,
   ENUM_ETH_RX_RSS6 = 0x2aUL,
   ENUM_ETH_RX_RSS7 = 0x2bUL
} COMPL_MAC_ID_ENUM;

// This is an Ethernet Receive Completion Descriptor
typedef struct {
   BE_BIT vlan_tag[16];                           // DWORD 0
   BE_BIT pktsize[14];                            // DWORD 0
   BE_BIT port;                                   // DWORD 0
   BE_BIT ip_opt;                                 // DWORD 0
   BE_BIT err;                                    // DWORD 1
   BE_BIT rsshp;                                  // DWORD 1
   BE_BIT ipf;                                    // DWORD 1
   BE_BIT tcpf;                                   // DWORD 1
   BE_BIT udpf;                                   // DWORD 1
   BE_BIT ipcksm;                                 // DWORD 1
   BE_BIT l4_cksm;                                // DWORD 1
   BE_BIT ip_version;                             // DWORD 1
   BE_BIT macdst[6];                              // DWORD 1
   BE_BIT vtp;                                    // DWORD 1
   BE_BIT rsvd0;                                  // DWORD 1
   BE_BIT fragndx[10];                            // DWORD 1
   BE_BIT ct[2];                                  // DWORD 1
   BE_BIT sw;                                     // DWORD 1
   BE_BIT numfrags[3];                            // DWORD 1
   BE_BIT rss_flush;                              // DWORD 2
   BE_BIT cast_enc[2];                            // DWORD 2
   BE_BIT QnQ;                                    // DWORD 2
   BE_BIT rss_bank;                               // DWORD 2
   BE_BIT rsvd1[23];                              // DWORD 2
   BE_BIT lro_pkt;                                // DWORD 2
   BE_BIT rsvd2[2];                               // DWORD 2
   BE_BIT valid;                                  // DWORD 2
   BE_BIT rsshash[32];                            // DWORD 3
} SG_PACK BE_ETH_RX_COMPL_AMAP;
typedef struct { u32 dw[4]; } ETH_RX_COMPL_AMAP, *PETH_RX_COMPL_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __hw_host_struct_amap_h__

