/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_eth_amap_h__
#define __ioctl_eth_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "rxf.h"
#include "fw_exp.h"
#include "erx.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_u32_AMAP eth_red_drops;
   BE_u32_AMAP lro_red_drops;
   BE_u32_AMAP ulp0_red_drops;
   BE_u32_AMAP ulp1_red_drops;
   BE_BIT rsvd0[32];                              // DWORD 4
   BE_u32_AMAP global_red_drops;
} SG_PACK BE_BE2_PMEM_STATS_AMAP;
typedef struct { u32 dw[6]; } BE2_PMEM_STATS_AMAP, *PBE2_PMEM_STATS_AMAP;


// --- ETH_TX_RING_TYPE_ENUM ---
#define ETH_TX_RING_TYPE_FORWARDING     (1)       // Ethernet ring for forwarding packets
                                                  // to the offload TOE engine.
#define ETH_TX_RING_TYPE_STANDARD       (2)       // Ethernet ring for sending network
                                                  // packets.
#define ETH_TX_RING_TYPE_LOW_LATENCY    (4)       // Low latency ethernet ring for sending
                                                  // network packets.
#define ETH_TX_RING_TYPE_BOUND          (8)       // Bound-port ethernet ring (host only) 

typedef enum {
   ENUM_ETH_TX_RING_TYPE_FORWARDING = 0x1UL,
   ENUM_ETH_TX_RING_TYPE_STANDARD = 0x2UL,
   ENUM_ETH_TX_RING_TYPE_LOW_LATENCY = 0x4UL,
   ENUM_ETH_TX_RING_TYPE_BOUND = 0x8UL
} ETH_TX_RING_TYPE_ENUM;

// --- ETX_QUEUE_TYPE_ENUM ---
#define ETX_QUEUE_TYPE_FORWARDING       (1)       // ETX queue for forwarding packets to
                                                  // the offload engines. 
#define ETX_QUEUE_TYPE_STANDARD         (2)       // ETX queue for sending network
                                                  // packets. 
#define ETX_QUEUE_TYPE_PRIORITY         (16)      // ETX queue will transmit as per
                                                  // associated priority 

typedef enum {
   ENUM_ETX_QUEUE_TYPE_FORWARDING = 0x1UL,
   ENUM_ETX_QUEUE_TYPE_STANDARD = 0x2UL,
   ENUM_ETX_QUEUE_TYPE_PRIORITY = 0x10UL
} ETX_QUEUE_TYPE_ENUM;

// --- ETX_QUEUE_SIZE_ENUM ---
#define ETX_QUEUE_SIZE_256              (9)       // 256 entries 
#define ETX_QUEUE_SIZE_512              (10)      // 512 entries 
#define ETX_QUEUE_SIZE_1K               (11)      // 1024 entries 
#define ETX_QUEUE_SIZE_2K               (12)      // 2048 entries 

typedef enum {
   ENUM_ETX_QUEUE_SIZE_256 = 0x9UL,
   ENUM_ETX_QUEUE_SIZE_512 = 0xaUL,
   ENUM_ETX_QUEUE_SIZE_1K = 0xbUL,
   ENUM_ETX_QUEUE_SIZE_2K = 0xcUL
} ETX_QUEUE_SIZE_ENUM;

// --- ACPI_WOL_MAGIC_CONFIG_V1_ENUM ---
#define GET_ACPI_CONFIG                 (1)       // This value when set requests the
                                                  // SLI-Port to provide the ACPI patterns
                                                  // configured for the targeted SLI-Hosts
                                                  // and Ethernet port. Note that the ACPI
                                                  // capabilities and configuration
                                                  // returned in the Mailbox Response
                                                  // payload will reflect all
                                                  // configuration changes requested in
                                                  // the Request payload if successful. 
#define GET_WOL_CONFIG                  (2)       // This value when set requests that the
                                                  // SLI-Port to provide the Wake On LAN
                                                  // related capabilities and
                                                  // configurations for the targeted
                                                  // SLI-Hosts and Ethernet port. Note
                                                  // that the WOL capabilities and
                                                  // configuration returned in the Mailbox
                                                  // Response payload will reflect all
                                                  // configuration changes requested in
                                                  // the Request payload if successful 
#define ACPI_PATTERNS_VALID             (4)       // This field when set indicates that
                                                  // the NUM_ACPI_PATTERNS field is valid.
                                                  // When not set, this indicates that
                                                  // there are no ACPI configuration
                                                  // changes being requested via this
                                                  // command. 
#define WOL_MAC_VALID                   (8)       // This field when set indicates that
                                                  // the MAC_ADDRESS fields (Word 294,
                                                  // Bits31:0 and Word 295, Bits 15:0) are
                                                  // valid. When not set, this indicates
                                                  // that there are no WOL configurations
                                                  // being requested via this command. 
#define ARP_DIP_VALID                   (16)      // This field when set indicates that
                                                  // the ARP_DIP_ADDRESS field (Word 300)
                                                  // is valid. When not set, this
                                                  // indicates that there are no WOL IPv4
                                                  // ARP configuration changes being
                                                  // requested via this command. 
#define DN_DIP_VALID                    (32)      // This field when set indicates that
                                                  // the ND_DIP_ADDRESS fields (Words 296,
                                                  // 297, 298 and 299) are valid. When not
                                                  // set, this indicates that there are no
                                                  // WOL IPv6 Neighbor Discovery (ND)
                                                  // offload configuration changes being
                                                  // requested via this command 

typedef enum {
   ENUM_GET_ACPI_CONFIG = 0x1UL,
   ENUM_GET_WOL_CONFIG = 0x2UL,
   ENUM_ACPI_PATTERNS_VALID = 0x4UL,
   ENUM_WOL_MAC_VALID = 0x8UL,
   ENUM_ARP_DIP_VALID = 0x10UL,
   ENUM_DN_DIP_VALID = 0x20UL
} ACPI_WOL_MAGIC_CONFIG_V1_ENUM;

// --- ACPI_WOL_ENUM ---
#define WOL_CAP                         (1)       // This is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port provides
                                                  // WOL support and this Mailbox command
                                                  // may be used to explicitly configure
                                                  // the Magic packet MAC address. The
                                                  // explicit configuration of such a
                                                  // Magic packet MAC address
                                                  // automatically enables the WOL support
                                                  // which may be subsequently disabled by
                                                  // explicitly configuring a zero-valued
                                                  // Magic packet MAC address. </br></br>
                                                  // Note that an explicitly configured
                                                  // Magic packet MAC address will always
                                                  // override the out-of-box Magic packet
                                                  // MAC address if WOL is supported
                                                  // out-of-box (see OOBOX_WOL_CAP field
                                                  // in Word 4, Bit 17).</br> 
#define OOBOX_WOL_CAP                   (2)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // implicitly configured for WOL support
                                                  // out-of-box wherein, the Permanent
                                                  // Override MAC address is used to
                                                  // construct the Magic Packet pattern.
                                                  // This field when set to 0x0, indicates
                                                  // that WOL support is further decided
                                                  // by the WOL_CAP field in Word 4, Bit
                                                  // 16.</br> 
#define WOL_ACPI_MODE                   (4)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. If this bit is on,
                                                  // the SLI-Port is operating in the
                                                  // Unique mode. Else, the SLI-Port is
                                                  // operating in the Common mode.
                                                  // </br></br> In the Unique mode, these
                                                  // parameters are unique per targeted
                                                  // <SLI-Host, Ethernet-port> pair. Thus,
                                                  // specifying different parameters in
                                                  // successive invocations of this
                                                  // command with a different targeted
                                                  // SLI-Host each time, allows unique
                                                  // parameter settings for each SLI-Host
                                                  // even if they are mapped to the same
                                                  // targeted Ethernet port. </br></br> In
                                                  // the Common mode by contrast, these
                                                  // parameters are unique per targeted
                                                  // Ethernet-port but common for all
                                                  // targeted SLI-Hosts mapped to it.
                                                  // Thus, specifying different parameters
                                                  // in successive invocations of this
                                                  // command with a different targeted
                                                  // SLI-Host each time updates the
                                                  // parameters for all SLI-Hosts mapped
                                                  // to the same targeted Ethernet
                                                  // port.</br> 
#define PME_D0_CAP                      (8)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D0 PCIe
                                                  // power state. 
#define PME_D1_CAP                      (16)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D1 PCIe
                                                  // power state. 
#define PME_D2_CAP                      (32)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D2 PCIe
                                                  // power state. 
#define PME_D3HOT_CAP                   (64)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D3-Hot
                                                  // PCIe power state. 
#define PME_D3COLD_CAP                  (128)     // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D3-Cold
                                                  // PCIe power state. 

typedef enum {
   ENUM_WOL_CAP = 0x1UL,
   ENUM_OOBOX_WOL_CAP = 0x2UL,
   ENUM_WOL_ACPI_MODE = 0x4UL,
   ENUM_PME_D0_CAP = 0x8UL,
   ENUM_PME_D1_CAP = 0x10UL,
   ENUM_PME_D2_CAP = 0x20UL,
   ENUM_PME_D3HOT_CAP = 0x40UL,
   ENUM_PME_D3COLD_CAP = 0x80UL
} ACPI_WOL_ENUM;

// --- ACPI_CAPABILITIES_ENUM ---
#define ACPI_ND_OFFLOAD                 (1)       // This field is only valid if the
                                                  // GET_ACPI_CONFIG field (Word 4, Bit
                                                  // 16) bit has been set in the Mailbox
                                                  // Request payload. This field indicates
                                                  // that the SLI-Port is capable of
                                                  // providing ACPI ND offload support. 
#define ACPI_ARP_OFFLOAD                (2)       // This field is only valid if the
                                                  // GET_ACPI_CONFIG field (Word 4, Bit
                                                  // 16) bit has been set in the Mailbox
                                                  // Request payload. This field indicates
                                                  // that the SLI-Port is capable of
                                                  // providing ACPI ARP offload support. 

typedef enum {
   ENUM_ACPI_ND_OFFLOAD = 0x1UL,
   ENUM_ACPI_ARP_OFFLOAD = 0x2UL
} ACPI_CAPABILITIES_ENUM;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_MIB_ETH_STATISTICS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } MIB_ETH_STATISTICS_PARAMS_IN_AMAP, *PMIB_ETH_STATISTICS_PARAMS_IN_AMAP;



typedef struct {
   BE_BE2_RXF_STATS_AMAP rxf;
   BE_BE2_TXP_SW_COUNTERS_AMAP txp;
   BE_BE2_ERX_STATS_AMAP erx;
   BE_BE2_PMEM_STATS_AMAP pmem;
} SG_PACK BE_BE2_HARDWARE_STATS_AMAP;
typedef struct { u32 dw[265]; } BE2_HARDWARE_STATS_AMAP, *PBE2_HARDWARE_STATS_AMAP;



typedef union {
   BE_MIB_ETH_STATISTICS_PARAMS_IN_AMAP request;
   BE_BE2_HARDWARE_STATS_AMAP response;
} SG_PACK BE_MIB_ETH_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[265]; } MIB_ETH_STATISTICS_PARAMS_AMAP, *PMIB_ETH_STATISTICS_PARAMS_AMAP;


//  Query ethernet statistics. All domains may issue this IOCTL.         The host domain
// drivers may optionally reset internal statistic counters         with a query.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MIB_ETH_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ETH_GET_STATISTICS_AMAP;
typedef struct { u32 dw[269]; } IOCTL_ETH_GET_STATISTICS_AMAP, *PIOCTL_ETH_GET_STATISTICS_AMAP;


// --- ENABLE_RSS_ENUM ---
// Enable RSS enum. Bits needs to be or'ed in
#define RSS_ENABLE_NONE                 (0)       // No RSS
#define RSS_ENABLE_IPV4                 (1)       // IPV4 HASH enabled 
#define RSS_ENABLE_TCP_IPV4             (2)       // TCP IPV4 Hash enabled
#define RSS_ENABLE_IPV6                 (4)       // IPV6 HASH enabled
#define RSS_ENABLE_TCP_IPV6             (8)       // TCP IPV6 HASH enabled

typedef enum {
   ENUM_RSS_ENABLE_NONE = 0x0UL,
   ENUM_RSS_ENABLE_IPV4 = 0x1UL,
   ENUM_RSS_ENABLE_TCP_IPV4 = 0x2UL,
   ENUM_RSS_ENABLE_IPV6 = 0x4UL,
   ENUM_RSS_ENABLE_TCP_IPV6 = 0x8UL
} ENABLE_RSS_ENUM;


typedef struct {
   BE_UEXACT32_AMAP if_id;
   BE_UEXACT16_AMAP enable_rss;
   BE_UEXACT16_AMAP cpu_table_size_log2;
   BE_UEXACT32_AMAP hash[10];
   BE_UEXACT8_AMAP cpu_table[128];
   BE_UEXACT8_AMAP flush;
   BE_BIT rsvd0[3][8];                            // DWORD 44
} SG_PACK BE_BE_RSS_CONFIG_AMAP;
typedef struct { u32 dw[45]; } BE_RSS_CONFIG_AMAP, *PBE_RSS_CONFIG_AMAP;


//              Configures or disables receive side scaling (RSS), which distributes      
//       ethernet receive completions among (up to 4) completion queues. This is          
//   in addition to the default ethernet receive completion queue.             Presumably,
// the host driver processes each completion queue with a DPC             running on a
// different processor. This IOCTL can only be issued by domain 0 network            
// drivers.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_BE_RSS_CONFIG_AMAP request;
      struct {
         BE_UEXACT8_AMAP rss_bank;
         BE_BIT rsvd0[3][8];                      // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_RSS_CONFIG_AMAP;
typedef struct { u32 dw[49]; } IOCTL_ETH_RSS_CONFIG_AMAP, *PIOCTL_ETH_RSS_CONFIG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP index;
   BE_UEXACT8_AMAP port0;
   BE_UEXACT8_AMAP port1;
   BE_UEXACT8_AMAP magic_packet;
   BE_UEXACT8_AMAP byte_pattern[128];
   BE_UEXACT32_AMAP bit_mask[4];
} SG_PACK BE_IOCTL_ETH_ACPI_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[37]; } IOCTL_ETH_ACPI_CONFIG_PARAMS_AMAP, *PIOCTL_ETH_ACPI_CONFIG_PARAMS_AMAP;


//  Sets the magic packet or interesting packet byte pattern and mask          for
// wake-on-lan. Only host drivers are allowed to modify magic packet          settings.
// Only the host networking driver is allowed to modify the          interesting packet
// byte pattern and mask settings.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_IOCTL_ETH_ACPI_CONFIG_PARAMS_AMAP request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_ACPI_CONFIG_AMAP;
typedef struct { u32 dw[41]; } IOCTL_ETH_ACPI_CONFIG_AMAP, *PIOCTL_ETH_ACPI_CONFIG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP byte_pattern[128];
   BE_UEXACT32_AMAP bit_masks[4];
} SG_PACK BE_ACPI_PATTERN_AMAP;
typedef struct { u32 dw[36]; } ACPI_PATTERN_AMAP, *PACPI_PATTERN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP acpi_num_patterns;
   BE_UEXACT8_AMAP wol_enable;
   BE_UEXACT8_AMAP query;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_ACPI_PATTERN_AMAP acpi_pattern[4];
   BE_UEXACT8_AMAP mac_address[6];
   BE_BIT rsvd1[2][8];                            // DWORD 146
} SG_PACK BE_ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_AMAP;
typedef struct { u32 dw[147]; } ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_AMAP, *PACPI_WOL_MAGIC_CONFIG_PARAMS_IN_AMAP;



typedef struct {
   BE_ACPI_PATTERN_AMAP acpi_pattern[4];
} SG_PACK BE_ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[144]; } ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_AMAP, *PACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_AMAP;


//  Configure the ACPI (Advanced Configuration and Power Interface), WoL (Wake on LAN) -
// packet and Magic MAC capabilities.                 Only the host networking driver is
// allowed to modify the interesting packet byte pattern, WoL capability and mask
// settings.                 Upto 4 such packet patterns are supported and to be shared
// first come first serve by all active functions.                The Magic packet
// congiguration for a given MAC address can be enabled / disabled using this IOCTL. There
// are maximum of 2                 MAC addresses per port shared by all the functions on
// a first come first server basis.                Only NIC host adapters can issue this
// IOCTL.        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_ACPI_WOL_MAGIC_CONFIG_PARAMS_IN_AMAP request;
      BE_ACPI_WOL_MAGIC_CONFIG_PARAMS_OUT_AMAP response;
   } params;
} SG_PACK BE_IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_AMAP;
typedef struct { u32 dw[151]; } IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_AMAP, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_AMAP;



typedef struct {
   BE_UEXACT8_AMAP num_acpi_patterns;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_AMAP query_options;
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_BIT rsvd2[32];                              // DWORD 1
   BE_ACPI_PATTERN_AMAP acpi_pattern[8];
   BE_UEXACT8_AMAP mac_address[6];
   BE_BIT rsvd3[2][8];                            // DWORD 291
   BE_UEXACT32_AMAP nd_dip_address[4];
   BE_UEXACT32_AMAP arp_dip_address;
} SG_PACK BE_ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_AMAP;
typedef struct { u32 dw[297]; } ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_AMAP, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP num_acpi_patterns;
   BE_UEXACT8_AMAP acpi_patterns_total;
   BE_UEXACT8_AMAP wol_capabilities;
   BE_UEXACT8_AMAP acpi_capabilities;
   BE_UEXACT8_AMAP arp_dip_total;
   BE_UEXACT8_AMAP nd_dip_total;
   BE_BIT rsvd0[8];                               // DWORD 1
   BE_UEXACT8_AMAP acpi_pattern_per_port;
   BE_ACPI_PATTERN_AMAP acpi_pattern[8];
   BE_UEXACT8_AMAP mac_address[6];
   BE_BIT rsvd1[2][8];                            // DWORD 291
   BE_UEXACT32_AMAP nd_dip_address[4];
   BE_UEXACT32_AMAP arp_dip_address;
} SG_PACK BE_ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_AMAP;
typedef struct { u32 dw[297]; } ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_AMAP, *PACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_AMAP;


//  This command configures the ACPI (Advanced Configuration and Power Interface), WoL
// (Wake on LAN) packet                  and Magic Packet capabilities. Only the SLI host
// networking driver can configure the packet byte pattern,                  WoL
// capability and mask settings. This command can enable/disable the Magic packet
// configuration for a                  given MAC address among the set of MAC addresses
// allowed on the physical port.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_IN_AMAP request;
      BE_ACPI_WOL_MAGIC_CONFIG_V1_PARAMS_OUT_AMAP response;
   } params;
} SG_PACK BE_IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1_AMAP;
typedef struct { u32 dw[301]; } IOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1_AMAP, *PIOCTL_ETH_ACPI_WOL_MAGIC_CONFIG_V1_AMAP;


//  Enables/Disables promiscuous ethernet receive mode. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT8_AMAP port0_promiscuous;
         BE_UEXACT8_AMAP port1_promiscuous;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_PROMISCUOUS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ETH_PROMISCUOUS_AMAP, *PIOCTL_ETH_PROMISCUOUS_AMAP;


//              IOCTL for creating an Ethernet transmit ring.              <P>            
// An ETX ring contains [link]ETH_WRB[/link] entries (16 bytes each).             An ETX
// ring must be at least 256 entries deep (corresponding to 1 page) and             at
// most 2k entries deep (corresponding to 8 pages).              <P>             For
// Version 0 of the IOCTL see [link]IOCTL_ETH_TX_CREATE_V0[/link].         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT8_AMAP num_pages;
         BE_UEXACT8_AMAP ulp_num;
         BE_UEXACT8_AMAP type;
         BE_UEXACT8_AMAP bound_port;
         BE_ETX_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP cid;
         BE_UEXACT16_AMAP rid;
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_TX_CREATE_AMAP;
typedef struct { u32 dw[37]; } IOCTL_ETH_TX_CREATE_AMAP, *PIOCTL_ETH_TX_CREATE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP num_pages;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_AMAP type;
   BE_UEXACT16_AMAP iface_id;
   BE_UEXACT8_AMAP queue_size;
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT rsvd2[32];                              // DWORD 2
   BE_UEXACT16_AMAP cq_id;
   BE_BIT rsvd3[16];                              // DWORD 3
   BE_BIT rsvd4[13][32];                          // DWORD 4
   BE_PHYS_ADDR_AMAP pages[8];
} SG_PACK BE_TX_CREATE_V1_PARAMS_IN_AMAP;
typedef struct { u32 dw[33]; } TX_CREATE_V1_PARAMS_IN_AMAP, *PTX_CREATE_V1_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP id;
   BE_UEXACT16_AMAP rid;
   BE_UEXACT32_AMAP doorbell_offset;
   BE_UEXACT8_AMAP class_queue_id;
   BE_BIT rsvd0[3][8];                            // DWORD 2
} SG_PACK BE_TX_CREATE_V1_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } TX_CREATE_V1_PARAMS_OUT_AMAP, *PTX_CREATE_V1_PARAMS_OUT_AMAP;



typedef union {
   BE_TX_CREATE_V1_PARAMS_IN_AMAP request;
   BE_TX_CREATE_V1_PARAMS_OUT_AMAP response;
} SG_PACK BE_TX_CREATE_V1_PARAMS_AMAP;
typedef struct { u32 dw[33]; } TX_CREATE_V1_PARAMS_AMAP, *PTX_CREATE_V1_PARAMS_AMAP;


//          IOCTL for creating an Ethernet transmit queue.          <P>         The
// [link]IOCTL_ETH_TX_CREATE_V1[/link] structure format is         indicated by the
// IOCTL_REQUEST_HEADER version field set to 1.                  <P>         Note: The
// version 0 command structure format is defined by        
// [link]IOCTL_ETH_TX_CREATE[/link].                     <P>            The IOCTL may
// complete with the following status/additional_status codes:            <UL>           
// <LI>[link]MGMT_STATUS_SUCCESS[/link]                 -- the request completes
// successfully.            </LI>         <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]      
//        -- this indicates an invalid request parameter at the byte offset            
// specified in the additional_status response field.         </LI>           
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the
// IOCTL_REQUEST_HEADER version field indicates an unsupported                  version of
// the command structure format.            </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- there are no
// available Ethernet transmit queue IDs.         </LI>            </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TX_CREATE_V1_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ETH_TX_CREATE_V1_AMAP;
typedef struct { u32 dw[37]; } IOCTL_ETH_TX_CREATE_V1_AMAP, *PIOCTL_ETH_TX_CREATE_V1_AMAP;


// --- HEADER_DMA_ENUM ---
#define HEADER_DMA_TO_HEADER            (1)       
#define HEADER_DMA_TO_DATA              (2)       
#define HEADER_DMA_TO_HEADER_AND_DATA   (3)       

typedef enum {
   ENUM_HEADER_DMA_TO_HEADER = 0x1UL,
   ENUM_HEADER_DMA_TO_DATA = 0x2UL,
   ENUM_HEADER_DMA_TO_HEADER_AND_DATA = 0x3UL
} HEADER_DMA_ENUM;

// --- HEADER_SPLIT_LOCATION_ENUM ---
#define HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER (0) // The packet is split directly after
                                                    // the TCP or UDP header, if it
                                                    // exists. Otherwise, it is split
                                                    // directly after the IPv4 or IPv6
                                                    // header. 
#define HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER (1) // The packet is split directly after
                                                   // the IPv4 or IPv6 header. 
#define HEADER_SPLIT_LOCATION_FIXED     (2)       // The packet is split on a fixed
                                                  // boundary specified by
                                                  // fixed_split_location field. 

typedef enum {
   ENUM_HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER = 0x0UL,
   ENUM_HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER = 0x1UL,
   ENUM_HEADER_SPLIT_LOCATION_FIXED = 0x2UL
} HEADER_SPLIT_LOCATION_ENUM;

//              IOCTL for creating an Ethernet receive ring.              <P>            
// An ERX ring contains [link]ETH_RX_D[/link] entries (8 bytes each).             An ERX
// ring must be 1024 entries deep (corresponding to 2 pages).         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP cq_id;
         BE_UEXACT8_AMAP frag_size;
         BE_UEXACT8_AMAP num_pages;
         BE_PHYS_ADDR_AMAP pages[2];
         BE_UEXACT32_AMAP interface_id;
         BE_UEXACT16_AMAP max_frame_size;
         BE_BIT rsvd0[16];                        // DWORD 10
         BE_UEXACT32_AMAP rss_queue;
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_UEXACT8_AMAP cpu_id;
         BE_BIT rsvd0[8];                         // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_RX_CREATE_AMAP;
typedef struct { u32 dw[12]; } IOCTL_ETH_RX_CREATE_AMAP, *PIOCTL_ETH_RX_CREATE_AMAP;


//              IOCTL for destroying a Ethernet transmit ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_TX_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ETH_TX_DESTROY_AMAP, *PIOCTL_ETH_TX_DESTROY_AMAP;


//              IOCTL for destroying a Ethernet receive ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_UEXACT16_AMAP bypass_flush;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_RX_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ETH_RX_DESTROY_AMAP, *PIOCTL_ETH_RX_DESTROY_AMAP;


//              <p>             This is a consolidated set of stats that are typically
// used by a driver during             runtime.             <p>             Note that
// BladeEngine2 counts all TOE transmit and retransmit stats as IPv4 if more            
// than 1 physical function is loaded per port.               The IPv6 stats will be zero
// in this case.         
typedef struct {
   BE_UEXACT32_AMAP ToeTxIPv4Packets;
   BE_UEXACT32_AMAP ToeTxIPv6Packets;
   BE_UEXACT64_AMAP ToeTxIPv4Bytes;
   BE_UEXACT64_AMAP ToeTxIPv6Bytes;
   BE_UEXACT32_AMAP ToeTxIPv4RetransmitPackets;
   BE_UEXACT32_AMAP ToeTxIPv6RetransmitPackets;
   BE_UEXACT32_AMAP ToeTxIPv4RetransmitBytes;
   BE_UEXACT32_AMAP ToeTxIPv6RetransmitBytes;
   BE_UEXACT32_AMAP ToeRxIPv4Packets;
   BE_UEXACT32_AMAP ToeRxIPv6Packets;
   BE_UEXACT32_AMAP ToeRxIPv4Drops;
   BE_UEXACT32_AMAP ToeRxIPv6Drops;
   BE_UEXACT64_AMAP ToeRxIPv4Bytes;
   BE_UEXACT64_AMAP ToeRxIPv6Bytes;
   BE_UEXACT32_AMAP ToeTxAcks;
   BE_UEXACT32_AMAP ToeTxDelayedAcks;
   BE_UEXACT32_AMAP ToeTxWindowProbes;
   BE_UEXACT32_AMAP ToeRxWindowUpdates;
   BE_UEXACT32_AMAP ToeRxWindowProbes;
   BE_UEXACT32_AMAP ToeRxOutOfOrderPackets;
   BE_UEXACT32_AMAP ToeRxAcks;
   BE_UEXACT32_AMAP ToeRxDuplicateAcks;
   BE_UEXACT32_AMAP TxPauseFrames;
   BE_UEXACT32_AMAP RxPauseFrames;
   BE_UEXACT32_AMAP RxNoPacketMemoryDrops;
   BE_UEXACT32_AMAP RedDrops;
   BE_UEXACT32_AMAP EthRxDropsNoFragments;
   BE_UEXACT32_AMAP RxCrcErrors;
   BE_UEXACT32_AMAP RxAlignmentErrors;
   BE_UEXACT32_AMAP RxJabbers;
   BE_UEXACT32_AMAP RxRuntErrors;
   BE_UEXACT32_AMAP RxFrameTooLongError;
   BE_UEXACT32_AMAP RxEthLengthErrors;
   BE_UEXACT32_AMAP RxIpHeaderError;
   BE_UEXACT32_AMAP RxIpChecksumErrors;
   BE_UEXACT32_AMAP RxTcpChecksumErrors;
   BE_UEXACT32_AMAP RxUdpChecksumErrors;
   BE_UEXACT64_AMAP TxControllerBytes;
   BE_UEXACT64_AMAP RxControllerBytes;
   BE_BIT rsvd0[9][32];                           // DWORD 45
} SG_PACK BE_NIC_TOE_STATS_AMAP;
typedef struct { u32 dw[54]; } NIC_TOE_STATS_AMAP, *PNIC_TOE_STATS_AMAP;


//              IOCTL for querying NIC/TOE stats for a given network function.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP query_toe;
      } request;
      struct {
         BE_NIC_TOE_STATS_AMAP stats;
      } response;
   } params;
   BE_BIT rsvd0[32];                              // DWORD 58
} SG_PACK BE_IOCTL_ETH_NETWORK_STATS_AMAP;
typedef struct { u32 dw[59]; } IOCTL_ETH_NETWORK_STATS_AMAP, *PIOCTL_ETH_NETWORK_STATS_AMAP;


//              IOCTL for querying PG capabilites required to configure the ETH stack for
// supporting PFC/PG.             Return codes:- 				If the query bit was set and none of
// the feature bits were set, firmware will return [link] MGMT_STATUS_ILLEGAL_REQUEST
// [/link] 				If query bit was not set and none of the feature bits were set, firmware
// will return [link] MGMT_STATUS_ILLEGAL_REQUEST[/link] 				Firmware will return [link]
// MGMT_STATUS_FAILED [/link] for all other errors. 				         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT query;                            // DWORD 4
         BE_BIT rsvd0[31];                        // DWORD 4
         BE_BIT eth_pfc_pg_feature;               // DWORD 5
         BE_BIT rsvd1[31];                        // DWORD 5
      } request;
      struct {
         BE_BIT eth_pfc_pg_feature;               // DWORD 4
         BE_BIT rsvd0[31];                        // DWORD 4
         BE_BIT num_tx_rings[32];                 // DWORD 5
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ETH_PG_FEATURE_QUERY_REQUEST_AMAP, *PIOCTL_ETH_PG_FEATURE_QUERY_REQUEST_AMAP;


//              IOCTL for querying mapping between eth tx ring's class_queue_id and
// ethernet traffic priority.             Every priority class will have a 3 bit class
// index returned with [link]IOCTL_ETH_TX_CREATE_V1[/link] with type
// ETX_QUEUE_TYPE_PRIORITY bit             was set in the type field.              Return
// codes:-                 If there are no ETH Tx rings created with
// ETX_QUEUE_TYPE_PRIORITY firmware will return [link] MGMT_STATUS_FAILED [/link].        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_UEXACT8_AMAP priority0_classq;
         BE_UEXACT8_AMAP priority1_classq;
         BE_UEXACT8_AMAP priority2_classq;
         BE_UEXACT8_AMAP priority3_classq;
         BE_UEXACT8_AMAP priority4_classq;
         BE_UEXACT8_AMAP priority5_classq;
         BE_UEXACT8_AMAP priority6_classq;
         BE_UEXACT8_AMAP priority7_classq;
      } response;
   } params;
} SG_PACK BE_IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_AMAP, *PIOCTL_ETH_QUERY_PRIORITY_CLASS_QUEUE_MAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_eth_amap_h__

