/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_extfat_amap_h__
#define __ioctl_extfat_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- EXT_FAT_PARAM_TYPE ---
#define EXT_FAT_PARAM_TYPE_DFEFAULT     (0)       // Default static parameters 
#define EXT_FAT_PARAM_TYPE_CURRENT      (1)       // Currently set parameters 

typedef enum {
   ENUM_EXT_FAT_PARAM_TYPE_DFEFAULT = 0x0UL,
   ENUM_EXT_FAT_PARAM_TYPE_CURRENT = 0x1UL
} EXT_FAT_PARAM_TYPE;

// --- EXT_FAT_RETRIEVE_MODE ---
#define EXT_FAT_RETRIEVE_MODE_VRAM      (0)       // RAM/DDR 
#define EXT_FAT_RETRIEVE_MODE_NVRAM     (1)       // FLASH 

typedef enum {
   ENUM_EXT_FAT_RETRIEVE_MODE_VRAM = 0x0UL,
   ENUM_EXT_FAT_RETRIEVE_MODE_NVRAM = 0x1UL
} EXT_FAT_RETRIEVE_MODE;

// --- EXT_FAT_LOG_TYPE ---
#define LOG_TYPE_SYNCHRONOUS            (0)       // Logging synchronous
#define LOG_TYPE_ASYNCHRONOUS           (1)       // Logging asynchronous(deferred)

typedef enum {
   ENUM_LOG_TYPE_SYNCHRONOUS = 0x0UL,
   ENUM_LOG_TYPE_ASYNCHRONOUS = 0x1UL
} EXT_FAT_LOG_TYPE;

// --- EXT_FAT_SUPPORTED_LOGGING_MODES ---
#define LOG_MODE_UART_MASK              (1)       // Log to UART
#define LOG_MODE_RAM_MASK               (2)       // Log to votalite RAM
#define LOG_MODE_NVRAM_MASK             (4)       // Log to NVRAM
#define LOG_MODE_NWTK_MASK              (8)       // Log to network client ot TFTP

typedef enum {
   ENUM_LOG_MODE_UART_MASK = 0x1UL,
   ENUM_LOG_MODE_RAM_MASK = 0x2UL,
   ENUM_LOG_MODE_NVRAM_MASK = 0x4UL,
   ENUM_LOG_MODE_NWTK_MASK = 0x8UL
} EXT_FAT_SUPPORTED_LOGGING_MODES;

// --- EXT_FAT_LOGGING_MODE_ENUM ---
#define LOG_MODE_UART                   (0)       // Log to UART
#define LOG_MODE_RAM                    (1)       // Log to votalite RAM
#define LOG_MODE_NVRAM                  (2)       // Log to NVRAM
#define LOG_MODE_NWTK                   (3)       // Log to network client ot TFTP
#define LOG_MODE_MAX                    (3)       

typedef enum {
   ENUM_LOG_MODE_UART = 0x0UL,
   ENUM_LOG_MODE_RAM = 0x1UL,
   ENUM_LOG_MODE_NVRAM = 0x2UL,
   ENUM_LOG_MODE_NWTK = 0x3UL,
   ENUM_LOG_MODE_MAX = 0x3UL
} EXT_FAT_LOGGING_MODE_ENUM;

// --- ARM_TRACE_LEVEL_ENUM ---
// Valid trace levels. There are 4-bits allocated for trace level. 
#define TRACE_LEVEL_ALL                 (0)       
#define TRACE_LEVEL_ENTER_FUNCTION      (1)       
#define TRACE_LEVEL_VERBOSE             (4)       
#define TRACE_LEVEL_INFO                (5)       
#define TRACE_LEVEL_TEST                (8)       
#define TRACE_LEVEL_SHOW                (16)      
#define TRACE_LEVEL_WARNING             (32)      
#define TRACE_LEVEL_ERROR               (48)      
#define TRACE_LEVEL_FATAL               (64)      
#define TRACE_LEVEL_ALWAYS              (128)     
#define TRACE_LEVEL_DISABLED            (255)     
#define TRACE_LEVEL_MAX                 (255)     

typedef enum {
   ENUM_TRACE_LEVEL_ALL = 0x0UL,
   ENUM_TRACE_LEVEL_ENTER_FUNCTION = 0x1UL,
   ENUM_TRACE_LEVEL_VERBOSE = 0x4UL,
   ENUM_TRACE_LEVEL_INFO = 0x5UL,
   ENUM_TRACE_LEVEL_TEST = 0x8UL,
   ENUM_TRACE_LEVEL_SHOW = 0x10UL,
   ENUM_TRACE_LEVEL_WARNING = 0x20UL,
   ENUM_TRACE_LEVEL_ERROR = 0x30UL,
   ENUM_TRACE_LEVEL_FATAL = 0x40UL,
   ENUM_TRACE_LEVEL_ALWAYS = 0x80UL,
   ENUM_TRACE_LEVEL_DISABLED = 0xffUL,
   ENUM_TRACE_LEVEL_MAX = 0xffUL
} ARM_TRACE_LEVEL_ENUM;


typedef struct {
   BE_UEXACT8_AMAP mode;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT16_AMAP port_mask;
   BE_UEXACT32_AMAP trace_level;
   BE_UEXACT64_AMAP function_mask;
} SG_PACK BE_EXT_FAT_MODE_AMAP;
typedef struct { u32 dw[4]; } EXT_FAT_MODE_AMAP, *PEXT_FAT_MODE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP module_str[32];
   BE_UEXACT32_AMAP module_id;
   BE_UEXACT32_AMAP num_modes;
   BE_EXT_FAT_MODE_AMAP mode_trace_level[1];
} SG_PACK BE_EXT_FAT_MODULE_AMAP;
typedef struct { u32 dw[14]; } EXT_FAT_MODULE_AMAP, *PEXT_FAT_MODULE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP max_log_entries;
   BE_UEXACT32_AMAP log_entry_size;
   BE_UEXACT8_AMAP logging_type;
   BE_UEXACT8_AMAP max_logging_functions;
   BE_UEXACT8_AMAP max_logging_ports;
   BE_BIT rsvd0[8];                               // DWORD 2
   BE_UEXACT32_AMAP supported_modes;
   BE_UEXACT32_AMAP num_modules;
   BE_EXT_FAT_MODULE_AMAP debug_module[1];
} SG_PACK BE_EXT_FAT_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[19]; } EXT_FAT_CONFIG_PARAMS_AMAP, *PEXT_FAT_CONFIG_PARAMS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP parameter_type;
} SG_PACK BE_GET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP, *PGET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP;



typedef struct {
   BE_EXT_FAT_CONFIG_PARAMS_AMAP config;
} SG_PACK BE_GET_EXT_FAT_CAPABILITES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[19]; } GET_EXT_FAT_CAPABILITES_PARAMS_OUT_AMAP, *PGET_EXT_FAT_CAPABILITES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP request;
   BE_GET_EXT_FAT_CAPABILITES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_EXT_FAT_CAPABILITES_PARAMS_AMAP;
typedef struct { u32 dw[19]; } GET_EXT_FAT_CAPABILITES_PARAMS_AMAP, *PGET_EXT_FAT_CAPABILITES_PARAMS_AMAP;


//  			  This Ioctl should be issued by management software to get the current 			  ARM
// Log settings from the ARM firmware. 			  Two types of parameters can retrieved  			 
// <ul> 				<li> Default parameters 				<li> Parameter set by the management software
// earlier using the  					  [link]IOCTL_ARM_LOG_SET_CAP[/link] 			  </ul> 			  The ioctl
// STATUS returned is [link]MGMT_STATUS_SUCCESS[/link].  		  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_EXT_FAT_CAPABILITES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_EXT_FAT_CAPABILITES_AMAP;
typedef struct { u32 dw[23]; } IOCTL_COMMON_GET_EXT_FAT_CAPABILITES_AMAP, *PIOCTL_COMMON_GET_EXT_FAT_CAPABILITES_AMAP;



typedef struct {
   BE_EXT_FAT_CONFIG_PARAMS_AMAP config;
} SG_PACK BE_SET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP;
typedef struct { u32 dw[19]; } SET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP, *PSET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP;



typedef union {
   BE_SET_EXT_FAT_CAPABILITES_PARAMS_IN_AMAP request;
} SG_PACK BE_SET_EXT_FAT_CAPABILITES_PARAMS_AMAP;
typedef struct { u32 dw[19]; } SET_EXT_FAT_CAPABILITES_PARAMS_AMAP, *PSET_EXT_FAT_CAPABILITES_PARAMS_AMAP;


//  			  This Ioctl should be issued by management software to set user defined  			 
// logging parameters to ARM Firmware 			  The ioctl STATUS returned is
// [link]MGMT_STATUS_SUCCESS[/link].  			  If ARM firmware does not support a particular
// setting due to resource constraints 			  or for any other reason, status will be set to
// [link]MGMT_STATUS_ILLEGAL_FIELD[/link]. 		  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_EXT_FAT_CAPABILITES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_EXT_FAT_CAPABILITES_AMAP;
typedef struct { u32 dw[23]; } IOCTL_COMMON_SET_EXT_FAT_CAPABILITES_AMAP, *PIOCTL_COMMON_SET_EXT_FAT_CAPABILITES_AMAP;


//  				This structure represents an individual ARM trace record entry. 				
typedef struct {
   BE_UEXACT8_AMAP version;
   BE_UEXACT8_AMAP phy_port;
   BE_UEXACT16_AMAP fid;
   BE_UEXACT32_AMAP trace_level;
   BE_UEXACT64_AMAP module_mask;
   BE_UEXACT32_AMAP trace_table_index;
   BE_UEXACT32_AMAP timestamp;
   BE_UEXACT8_AMAP str_data[16];
   BE_UEXACT32_AMAP data[6];
} SG_PACK BE_ARM_TRACE_RECORD_AMAP;
typedef struct { u32 dw[16]; } ARM_TRACE_RECORD_AMAP, *PARM_TRACE_RECORD_AMAP;



typedef struct {
   BE_UEXACT32_AMAP total_log_entries;
} SG_PACK BE_ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_AMAP, *PARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_AMAP;



typedef union {
   BE_ARM_LOG_CONFIGURE_SNAPSHOT_PARAMS_OUT_AMAP response;
} SG_PACK BE_ARM_LOG_CREATE_SNAPSHOT_PARAMS_AMAP;
typedef struct { u32 dw[1]; } ARM_LOG_CREATE_SNAPSHOT_PARAMS_AMAP, *PARM_LOG_CREATE_SNAPSHOT_PARAMS_AMAP;


//  			  This Ioctl should be issued by management software to create a new snaphot. 			 
// The ioctl STATUS returned is [link]MGMT_STATUS_SUCCESS[/link].  		  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ARM_LOG_CREATE_SNAPSHOT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_AMAP, *PIOCTL_COMMON_EXT_FAT_CONFIGURE_SNAPSHOT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP snapshot_mode;
   BE_UEXACT32_AMAP start_index;
   BE_UEXACT32_AMAP num_log_entries;
} SG_PACK BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_AMAP, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_log_entries;
   BE_ARM_TRACE_RECORD_AMAP trace[1];
} SG_PACK BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[17]; } EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_AMAP, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_AMAP;



typedef union {
   BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_IN_AMAP request;
   BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_OUT_AMAP response;
} SG_PACK BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_AMAP;
typedef struct { u32 dw[17]; } EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_AMAP, *PEXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_AMAP;


//  			  This Ioctl should be issued by management software to retrieve a snapshot 			 
// The ioctl STATUS returned is [link]MGMT_STATUS_SUCCESS[/link].  			  If there are no
// more records to be reirieved, firmware will return 			 
// [link]MGMT_STATUS_END_OF_LOG[/link] 			  If the start index is invalid on the current
// snapshot, 			  firmware will return [link]MGMT_STATUS_ILLEGAL_FIELD[/link] 			  If the
// request length set in ioctl header is not sufficient to get all entries specified in
// 			  num_log_entries, the firmware will return
// [link]MGMT_STATUS_INSIFFICIENT_BUFFER[/link]. 		  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_EXT_FAT_RETRIEVE_SNAPSHOT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_AMAP;
typedef struct { u32 dw[21]; } IOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_AMAP, *PIOCTL_COMMON_EXT_FAT_RETRIEVE_SNAPSHOT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP byte_offset;
   BE_UEXACT32_AMAP num_bytes;
} SG_PACK BE_EXT_FAT_READ_STRING_TABLE_IN_AMAP;
typedef struct { u32 dw[2]; } EXT_FAT_READ_STRING_TABLE_IN_AMAP, *PEXT_FAT_READ_STRING_TABLE_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP num_returned_bytes;
   BE_UEXACT32_AMAP num_remaining_bytes;
   BE_UEXACT8_AMAP table_data[1];
} SG_PACK BE_EXT_FAT_READ_STRING_TABLE_OUT_AMAP;
typedef struct { u32 dw[3]; } EXT_FAT_READ_STRING_TABLE_OUT_AMAP, *PEXT_FAT_READ_STRING_TABLE_OUT_AMAP;



typedef union {
   BE_EXT_FAT_READ_STRING_TABLE_IN_AMAP request;
   BE_EXT_FAT_READ_STRING_TABLE_OUT_AMAP response;
} SG_PACK BE_EXT_FAT_READ_STRING_TABLE_AMAP;
typedef struct { u32 dw[3]; } EXT_FAT_READ_STRING_TABLE_AMAP, *PEXT_FAT_READ_STRING_TABLE_AMAP;


//  			  This Ioctl should be issued by management software to retrieve the string table.
// 			  The ioctl STATUS returned is [link]MGMT_STATUS_SUCCESS[/link].  			  If there are
// no more data to be reirieved, firmware will return 			 
// [link]MGMT_STATUS_END_OF_LOG[/link] 			  If the byte_offset is invalid on the current
// snapshot, 			  firmware will return [link]MGMT_STATUS_ILLEGAL_FIELD[/link] 			  If the
// request length set in ioctl header is not sufficient to get all entries specified in
// 			  num_log_entries, the firmware will return
// [link]MGMT_STATUS_INSIFFICIENT_BUFFER[/link]. 		  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_EXT_FAT_READ_STRING_TABLE_AMAP params;
} SG_PACK BE_IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_EXT_FAT_READ_STRING_TABLE_AMAP, *PIOCTL_COMMON_EXT_FAT_READ_STRING_TABLE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_extfat_amap_h__

