/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_amap_h__
#define __ioctl_iscsi_ini_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_iscsi_ini_boot.h"
#include "ioctl_iscsi_ini_stats.h"
#include "ioctl_iscsi_ini_cfg.h"
#include "ioctl_iscsi_ini_session.h"
#include "ioctl_iscsi_ini_driver.h"
#include "ioctl_iscsi_ini_discovery.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP os_bt_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_OS_BT_AMAP os_bt_list[1];
} SG_PACK BE_QUERY_OS_BUS_TARGET_INUSE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[4]; } QUERY_OS_BUS_TARGET_INUSE_PARAMS_OUT_AMAP, *PQUERY_OS_BUS_TARGET_INUSE_PARAMS_OUT_AMAP;


//               IOCTL_BTL_QUERY_OS_BUS_TARGET_INUSE              <br>              The
// application queries the Firmware of the OS Bus/Target settings being in used or
// reserved.              This IOCTL is handled by Firmware.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_OS_BUS_TARGET_INUSE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_AMAP;
typedef struct { u32 dw[8]; } IOCTL_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_AMAP, *PIOCTL_ISCSI_INI_BTL_MAPPING_QUERY_OS_BT_INUSE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP max_osbus_supported;
   BE_UEXACT32_AMAP max_ostarget_supported;
   BE_UEXACT32_AMAP max_oslun_supported;
} SG_PACK BE_QUERY_MAX_OS_SUPPORTED_BTL_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } QUERY_MAX_OS_SUPPORTED_BTL_PARAMS_OUT_AMAP, *PQUERY_MAX_OS_SUPPORTED_BTL_PARAMS_OUT_AMAP;


//               IOCTL_BTL_QUERY_MAX_OS_SUPPORTED_BTL              <br>              The
// application queries the driver of the maximum value of the bus, target, lun id
// supported              by the host OS. This IOCTL is handled by the OSM, not the
// firmware.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_MAX_OS_SUPPORTED_BTL_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_AMAP, *PIOCTL_ISCSI_INI_BTL_MAPPING_MAX_OS_SUPPORTED_BTL_AMAP;


// --- SCSI_STATUS ---
#define SCSI_STATUS_SUCCESS             (0)       
#define SCSI_STATUS_CHECK_CONDITION     (2)       
#define SCSI_STATUS_CONDITION_MET       (4)       
#define SCSI_STATUS_BUSY                (8)       
#define SCSI_STATUS_INTERMEDIATE        (16)      
#define SCSI_STATUS_INTERMEDIATE_CONDITION_MET (20) 
#define SCSI_STATUS_RESERVATION_CONFLICT (24)     
#define SCSI_STATUS_OBSOLETE            (34)      
#define SCSI_STATUS_TASK_SET_FULL       (40)      
#define SCSI_STATUS_TASK_ACA_ACTIVE     (48)      
#define SCSI_STATUS_TASK_ABORTED        (64)      

typedef enum {
   ENUM_SCSI_STATUS_SUCCESS = 0x0UL,
   ENUM_SCSI_STATUS_CHECK_CONDITION = 0x2UL,
   ENUM_SCSI_STATUS_CONDITION_MET = 0x4UL,
   ENUM_SCSI_STATUS_BUSY = 0x8UL,
   ENUM_SCSI_STATUS_INTERMEDIATE = 0x10UL,
   ENUM_SCSI_STATUS_INTERMEDIATE_CONDITION_MET = 0x14UL,
   ENUM_SCSI_STATUS_RESERVATION_CONFLICT = 0x18UL,
   ENUM_SCSI_STATUS_OBSOLETE = 0x22UL,
   ENUM_SCSI_STATUS_TASK_SET_FULL = 0x28UL,
   ENUM_SCSI_STATUS_TASK_ACA_ACTIVE = 0x30UL,
   ENUM_SCSI_STATUS_TASK_ABORTED = 0x40UL
} SCSI_STATUS;

// --- IOCTL_PASS_THRU_STATUS_FLAG ---
#define IOCTL_PASS_THRU_STATUS_UNDERRUN (1)       
#define IOCTL_PASS_THRU_STATUS_OVERRUN  (2)       

typedef enum {
   ENUM_IOCTL_PASS_THRU_STATUS_UNDERRUN = 0x1UL,
   ENUM_IOCTL_PASS_THRU_STATUS_OVERRUN = 0x2UL
} IOCTL_PASS_THRU_STATUS_FLAG;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP lun[8];
   BE_UEXACT8_AMAP data_direction_flag;
   BE_UEXACT8_AMAP pad1;
   BE_UEXACT8_AMAP pad2;
   BE_UEXACT8_AMAP pad3;
   BE_UEXACT8_AMAP cdb[16];
   BE_UEXACT16_AMAP pad4;
   BE_UEXACT16_AMAP data_transfer_size;
   BE_UEXACT8_AMAP sense_buffer[256];
   BE_UEXACT8_AMAP data_buffer[1];
} SG_PACK BE_SCSI_PASS_THRU_PARAMS_IN_AMAP;
typedef struct { u32 dw[74]; } SCSI_PASS_THRU_PARAMS_IN_AMAP, *PSCSI_PASS_THRU_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP rsrvd_1;
   BE_UEXACT8_AMAP lun[8];
   BE_UEXACT8_AMAP data_direction_flag;
   BE_UEXACT8_AMAP sense_data_length;
   BE_UEXACT8_AMAP flag;
   BE_UEXACT8_AMAP scsi_status;
   BE_UEXACT8_AMAP cdb[16];
   BE_UEXACT16_AMAP residual_count;
   BE_UEXACT16_AMAP data_transfer_size;
   BE_UEXACT8_AMAP sense_buffer[256];
   BE_UEXACT8_AMAP data_buffer[1];
} SG_PACK BE_SCSI_PASS_THRU_PARAMS_OUT_AMAP;
typedef struct { u32 dw[74]; } SCSI_PASS_THRU_PARAMS_OUT_AMAP, *PSCSI_PASS_THRU_PARAMS_OUT_AMAP;



typedef union {
   BE_SCSI_PASS_THRU_PARAMS_IN_AMAP request;
   BE_SCSI_PASS_THRU_PARAMS_OUT_AMAP response;
} SG_PACK BE_SCSI_PASS_THRU_PARAMS_AMAP;
typedef struct { u32 dw[74]; } SCSI_PASS_THRU_PARAMS_AMAP, *PSCSI_PASS_THRU_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SCSI_PASS_THRU_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_SCSI_PASS_THRU_AMAP;
typedef struct { u32 dw[78]; } IOCTL_SCSI_PASS_THRU_AMAP, *PIOCTL_SCSI_PASS_THRU_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_amap_h__

