/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_cfg_amap_h__
#define __ioctl_iscsi_ini_cfg_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TCPIP_CONFIGURATION_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP;
typedef struct { u32 dw[35]; } IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP, *PIOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP;



typedef IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP IOCTL_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_AMAP;
typedef BE_IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP BE_IOCTL_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_AMAP;


typedef IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP* PIOCTL_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_NTWK_GET_TCPIP_CONFIG_AMAP;


typedef IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP IOCTL_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_AMAP;
typedef BE_IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP BE_IOCTL_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_AMAP;


typedef IOCTL_ISCSI_INI_NTWK_TCPIP_CONFIG_AMAP* PIOCTL_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_NTWK_SET_TCPIP_CONFIG_AMAP;

// --- ISCSI_HBA_NAME_FLAGS ---
// Bit definition of flags in ISCSI_HBA_NAME_PARAMS 
#define MGMT_ISCSI_HBA_NAME_FLAG_USE_CUSTOM_NAME (0) // User specified name 
#define MGMT_ISCSI_HBA_NAME_FLAG_USE_FACTORY_DEFAULT_NAME (1) // If set, use the factory
                                                              // default name 

typedef enum {
   ENUM_MGMT_ISCSI_HBA_NAME_FLAG_USE_CUSTOM_NAME = 0x0UL,
   ENUM_MGMT_ISCSI_HBA_NAME_FLAG_USE_FACTORY_DEFAULT_NAME = 0x1UL
} ISCSI_HBA_NAME_FLAGS;

// --- ISCSI_HBA_NAME_RSVD_FLAGS ---
// Bit definition of reserved_flags in ISCSI_HBA_NAME_PARAMS
// MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS 
#define MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS (1) // Only applicable in
                                                                    // IOCTL_SET_ISCSI_HBA
                                                                    // _NAME operation. It
                                                                    // is not applicable
                                                                    // in
                                                                    // IOCTL_GET_ISCSI_HBA
                                                                    // _NAME. If set to 1,
                                                                    // after the firmware
                                                                    // changes the HBA's
                                                                    // iSCSI name, the
                                                                    // firmware needs to
                                                                    // reconnect all the
                                                                    // sessions that is
                                                                    // currently closed
                                                                    // due to session
                                                                    // recovery. This only
                                                                    // applicable to
                                                                    // sessions that has
                                                                    // the status with
                                                                    // MGMT_SESSION_STATUS
                                                                    // _CLOSED_IN_RECOVERY
                                                                    // = 1. If set to 0,
                                                                    // after the firmware
                                                                    // change the HBA's
                                                                    // iSCSI name, the
                                                                    // firmware does NOT
                                                                    // need to reconnect
                                                                    // all the sessions
                                                                    // that is currently
                                                                    // closed due to
                                                                    // session recovery. 

typedef enum {
   ENUM_MGMT_ISCSI_HBA_NAME_RSVD_FLAG_RECONNECT_CLOSED_SESSIONS = 0x1UL
} ISCSI_HBA_NAME_RSVD_FLAGS;


typedef struct {
   BE_UEXACT16_AMAP flags;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_EXACT8_AMAP iscsiname[224];
   BE_EXACT8_AMAP iscsialias[32];
} SG_PACK BE_ISCSI_HBA_NAME_PARAMS_AMAP;
typedef struct { u32 dw[65]; } ISCSI_HBA_NAME_PARAMS_AMAP, *PISCSI_HBA_NAME_PARAMS_AMAP;


//                  This Ioctl provides GET/SET functionality for storing a global iSCSI
// Name for the                  BladeEngine. If the user wants to restore the
// factory-default iSCSI Name, the                  firmware appends the MAC address of
// Ethernet port A to the a fixed iqn string to                 generate a name of the
// form "iqn.2005-06.serverengines.aa-bb-cc-dd-ee-ff". The                  firmware does
// not use this string for purposes of iSCSI Login (Normal or Discovery)                
// and iSNS/SLP Discovery. In such cases the iSCSI Name is provided by the management     
//            application or the BIOS GUI in their corresponding Ioctls, this Ioctl is
// just used                 to store the iSCSI Name across reboots.                 <br> 
//                <b>Originator(s)</b> : Management applications or BE INT13H BIOS        
//         <br>                 <b>Implemented in</b>: Firmware                 <br>      
//           <b>Return Values</b> : MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_HBA_NAME_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP;
typedef struct { u32 dw[69]; } IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP, *PIOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP;



typedef IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP IOCTL_ISCSI_INI_CFG_GET_HBA_NAME_AMAP;
typedef BE_IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP BE_IOCTL_ISCSI_INI_CFG_GET_HBA_NAME_AMAP;


typedef IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP* PIOCTL_ISCSI_INI_CFG_GET_HBA_NAME_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_CFG_GET_HBA_NAME_AMAP;


typedef IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP IOCTL_ISCSI_INI_CFG_SET_HBA_NAME_AMAP;
typedef BE_IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP BE_IOCTL_ISCSI_INI_CFG_SET_HBA_NAME_AMAP;


typedef IOCTL_ISCSI_INI_CFG_HBA_NAME_AMAP* PIOCTL_ISCSI_INI_CFG_SET_HBA_NAME_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_CFG_SET_HBA_NAME_AMAP;


typedef struct {
   BE_UEXACT32_AMAP epoch_time;
} SG_PACK BE_ISCSI_HBA_TIME_PARAMS_AMAP;
typedef struct { u32 dw[1]; } ISCSI_HBA_TIME_PARAMS_AMAP, *PISCSI_HBA_TIME_PARAMS_AMAP;


//                  This Ioctl provides SET functionality for configuring the epoch
// time/date on 				the iSCSI HBA.  Epoch time represente the number of seconds since Jan
// 1, 1970.                 <br>                 <b>Originator(s)</b> : Management
// applications or BE INT13H BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :
// MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ISCSI_HBA_TIME_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_SET_HBA_TIME_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_INI_CFG_SET_HBA_TIME_AMAP, *PIOCTL_ISCSI_INI_CFG_SET_HBA_TIME_AMAP;



typedef struct {
   BE_UEXACT32_AMAP secret_size;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT8_AMAP secret_string[16];
} SG_PACK BE_CHAP_SECRET_AMAP;
typedef struct { u32 dw[6]; } CHAP_SECRET_AMAP, *PCHAP_SECRET_AMAP;


//              Mutual CHAP is a per-Target setting. The user may chose to specify a
// single initiator secret to be used             for logging-into all the targets from a
// given domain. In such cases this Ioctl can be used to set that 'global'            
// initiator secret. However this setting can be overridden by passing a target-specific
// CHAP secret in the             [link]IOCTL_ISCSI_INI_SESSION_LOGIN_TARGET[/link] IOCTL.
//              <br>                 <br>                 <b>Originator(s)</b> :
// Management applications or BE INT13H BIOS                 <br>                
// <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> : MGMT_STATUS_SUCCESS           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_CHAP_SECRET_AMAP request;
      BE_CHAP_SECRET_AMAP response;
   } params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP;
typedef struct { u32 dw[10]; } IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP, *PIOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP;



typedef IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP IOCTL_ISCSI_INI_CFG_GET_CHAP_SECRET_AMAP;
typedef BE_IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP BE_IOCTL_ISCSI_INI_CFG_GET_CHAP_SECRET_AMAP;


typedef IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP* PIOCTL_ISCSI_INI_CFG_GET_CHAP_SECRET_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_CFG_GET_CHAP_SECRET_AMAP;


typedef IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP IOCTL_ISCSI_INI_CFG_SET_CHAP_SECRET_AMAP;
typedef BE_IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP BE_IOCTL_ISCSI_INI_CFG_SET_CHAP_SECRET_AMAP;


typedef IOCTL_ISCSI_INI_CFG_CHAP_SECRET_AMAP* PIOCTL_ISCSI_INI_CFG_SET_CHAP_SECRET_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_ISCSI_INI_CFG_SET_CHAP_SECRET_AMAP;


typedef struct {
   BE_UEXACT32_AMAP hba_count;
} SG_PACK BE_GET_HBA_COUNT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } GET_HBA_COUNT_PARAMS_OUT_AMAP, *PGET_HBA_COUNT_PARAMS_OUT_AMAP;


//              IOCTL_HBA_CFG_GET_HBA_COUNT is used to get the total number of HBA
// installed in the system             This is call is used [b]only[/b] by the Linux
// driver. The Windows driver DOES NOT              handle this IOCTL.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_HBA_COUNT_PARAMS_OUT_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_GET_HBA_COUNT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_INI_CFG_GET_HBA_COUNT_AMAP, *PIOCTL_ISCSI_INI_CFG_GET_HBA_COUNT_AMAP;


//                This IOCTL is obsolete and will soon be replaced by
// [link]IOCTL_COMMON_GET_CNTL_ATTRIBUTES[/link].              Old documentation info:    
//          This ioctl queries the controller information from the Flash ROM. This is
// required for management              applications and BIOS to display this information
// to the users.                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MGMT_CONTROLLER_ATTRIBUTES_AMAP cntl_attributes_info;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_AMAP;
typedef struct { u32 dw[139]; } IOCTL_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_AMAP, *PIOCTL_ISCSI_INI_CFG_GET_CNTL_ATTRIBUTES_AMAP;


//                      Common error code described in Common Error Message Specification 
//                    Last error from the firmware.  This may not indicate the current
// health of the HBA                     For current HBA status, MILI should examine
// hba_status             
typedef struct {
   BE_UEXACT32_AMAP last_error_code;
   BE_UEXACT8_AMAP hba_status;
} SG_PACK BE_GET_HBA_STATUS_PARAMS_AMAP;
typedef struct { u32 dw[2]; } GET_HBA_STATUS_PARAMS_AMAP, *PGET_HBA_STATUS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_HBA_STATUS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_GET_HBA_STATUS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_INI_CFG_GET_HBA_STATUS_AMAP, *PIOCTL_ISCSI_INI_CFG_GET_HBA_STATUS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_MGMT_PCI_INFO_REQUEST_AMAP;
typedef struct { u32 dw[1]; } MGMT_PCI_INFO_REQUEST_AMAP, *PMGMT_PCI_INFO_REQUEST_AMAP;


//                  This IOCTL gets the PCI-e information. This is required for the
// management applications                 to display this information to the user.       
//                               <br>                     <br>                    
// <b>Originator(s)</b> : Management applications                     <br>                
//     <b>Implemented in</b>: Driver                     <br>                    
// <b>Return Values</b> : MGMT_STATUS_SUCCESS                                  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_MGMT_PCI_INFO_REQUEST_AMAP request;
      BE_MGMT_PCIE_INFO_AMAP pcie_info;
   } params;
} SG_PACK BE_IOCTL_ISCSI_INI_CFG_GET_PCIE_INFO_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_INI_CFG_GET_PCIE_INFO_AMAP, *PIOCTL_ISCSI_INI_CFG_GET_PCIE_INFO_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_cfg_amap_h__

