/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_driver_amap_h__
#define __ioctl_iscsi_ini_driver_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_iscsi_ini_stats.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_SESSION_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_ISCSI_REOPEN_A_SESSION_IN_AMAP, *PIOCTL_ISCSI_REOPEN_A_SESSION_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_SESSION_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_ISCSI_REOPEN_A_SESSION_OUT_AMAP, *PIOCTL_ISCSI_REOPEN_A_SESSION_OUT_AMAP;



typedef union {
   BE_IOCTL_ISCSI_REOPEN_A_SESSION_IN_AMAP request;
   BE_IOCTL_ISCSI_REOPEN_A_SESSION_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_ISCSI_REOPEN_A_SESSION_PARAMS_AMAP, *PIOCTL_ISCSI_REOPEN_A_SESSION_PARAMS_AMAP;


//               This Ioctl should be used by drivers during session recovery. The session
// to be opened should marked             closed in recovery so that the firmware does not
// delete all the session information from its local store.              This Ioctl will
// return immediately, and the request will be queued internally by the firmware. When the
//             login is successful an asynchronous message will be sent to driver to
// indicate that the session is re-established.             <br>            
// <b>Originator(s)</b> : Driver             <br>             <b>Implemented in</b>:
// Firmware             <br>             <b>Return Values</b> : MGMT_STATUS_SUCCESS       
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_REOPEN_A_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION_AMAP, *PIOCTL_ISCSI_INI_DRIVER_REOPEN_A_SESSION_AMAP;


// --- ISCSI_DRIVER_REOPEN_ALL_SESSIONS_TYPE ---
#define IOCTL_ISCSI_REOPEN_ALL_SESSIONS (0)       // Reopen all the previously closed
                                                  // session. If any session is offloaded
                                                  // then that session will be invalidated
                                                  // and reopened again
#define IOCTL_ISCSI_REOPEN_BOOT_SESSION (1)       // Reopen only boot session. Mainly used
                                                  // in mailbox mode by hiber and crash
                                                  // dump driver. Bios will also use it
                                                  // for session recovery
#define IOCTL_ISCSI_REOPEN_A_SESSION    (2)       // Reopen specified session. The
                                                  // session_handle is also passed by
                                                  // IOCTL when this type is used

typedef enum {
   ENUM_IOCTL_ISCSI_REOPEN_ALL_SESSIONS = 0x0UL,
   ENUM_IOCTL_ISCSI_REOPEN_BOOT_SESSION = 0x1UL,
   ENUM_IOCTL_ISCSI_REOPEN_A_SESSION = 0x2UL
} ISCSI_DRIVER_REOPEN_ALL_SESSIONS_TYPE;


typedef struct {
   BE_UEXACT16_AMAP reopen_type;
   BE_UEXACT16_AMAP unused;
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_ALL_SESSIONS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_ISCSI_REOPEN_ALL_SESSIONS_IN_AMAP, *PIOCTL_ISCSI_REOPEN_ALL_SESSIONS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP unused;
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_ALL_SESSIONS_OUT_AMAP;
typedef struct { u32 dw[2]; } IOCTL_ISCSI_REOPEN_ALL_SESSIONS_OUT_AMAP, *PIOCTL_ISCSI_REOPEN_ALL_SESSIONS_OUT_AMAP;



typedef union {
   BE_IOCTL_ISCSI_REOPEN_ALL_SESSIONS_IN_AMAP request;
   BE_IOCTL_ISCSI_REOPEN_ALL_SESSIONS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_ALL_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_ISCSI_REOPEN_ALL_SESSION_PARAMS_AMAP, *PIOCTL_ISCSI_REOPEN_ALL_SESSION_PARAMS_AMAP;


//              This Ioctl should be issued by the driver during a session recovery, to
// re-open all previously existing             sessions,         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_REOPEN_ALL_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_AMAP, *PIOCTL_ISCSI_INI_DRIVER_REOPEN_ALL_SESSIONS_AMAP;


// --- IOCTL_ISCSI_INVALIDATE_CONNECTION_TYPE ---
#define IOCTL_ISCSI_CONNECTION_INVALIDATE (1)     // Request the EP firmware to
                                                  // 'invalidate' this connection.
#define IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST (2)  // Issue a TCP RST on this connection 
#define IOCTL_ISCSI_CONNECTION_IGNORE_HANDLE (32768) // With this bit set the session
                                                     // handle field in invalid and will
                                                     // not be used in ARM FW. This is
                                                     // used/set by Open iSCSI drivers. 

typedef enum {
   ENUM_IOCTL_ISCSI_CONNECTION_INVALIDATE = 0x1UL,
   ENUM_IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST = 0x2UL,
   ENUM_IOCTL_ISCSI_CONNECTION_IGNORE_HANDLE = 0x8000UL
} IOCTL_ISCSI_INVALIDATE_CONNECTION_TYPE;

// --- IOCTL_ISCSI_SESSION_SAVE_CFG ---
// This flag will not be used be driver since non persistent target will not be saved
// after successful login. It will only be saved when IOCTL to save these target is
// called. 
#define IOCTL_ISCSI_SESSION_DEL_CFG_FROM_FLASH (0) // If this is the last conn of a
                                                   // session, remove all session cfg data
                                                   // from Flash. This flag is ONLY
                                                   // applicable to non persistent
                                                   // targets. To delete a persistent
                                                   // target from Flash, an explicit
                                                   // command to delete the target
                                                   // IOCTL_ISCSI_INI_SESSION_DELETE_PERSI
                                                   // STENT_LOGIN must be received from
                                                   // the management layer. 
#define IOCTL_ISCSI_SESSION_SAVE_CFG_ON_FLASH (1) // Leave iSCSI session/conn info on
                                                  // Flash ROM

typedef enum {
   ENUM_IOCTL_ISCSI_SESSION_DEL_CFG_FROM_FLASH = 0x0UL,
   ENUM_IOCTL_ISCSI_SESSION_SAVE_CFG_ON_FLASH = 0x1UL
} IOCTL_ISCSI_SESSION_SAVE_CFG;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP unused;
   BE_UEXACT16_AMAP cleanup_type;
   BE_UEXACT16_AMAP save_cfg;
} SG_PACK BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_IN_AMAP, *PIOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP unused;
} SG_PACK BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_OUT_AMAP, *PIOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_IN_AMAP request;
   BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_AMAP;
typedef struct { u32 dw[3]; } IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_AMAP, *PIOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_AMAP;


//               The host driver should use this command to invalidate a connection and
// optionally send a TCP RST              before terminating the connection and releasing
// all I/O requests and other resources. The ARM firmware forwards             this
// request to the EP firmware. The EP firmware will clean up its internal data structures
// and issue             a TCP reset if IOCTL_ISCSI_CONNECTION_ISSUE_TCP_RST is set.      
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_INVALIDATE_CONNECTION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_AMAP, *PIOCTL_ISCSI_INI_DRIVER_INVALIDATE_CONNECTION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT32_AMAP cmd_sn;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_CONN_IN_AMAP;
typedef struct { u32 dw[3]; } IOCTL_ISCSI_REOPEN_A_CONN_IN_AMAP, *PIOCTL_ISCSI_REOPEN_A_CONN_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_CONNECTION_DATA_AMAP conn_data;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_CONN_OUT_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_REOPEN_A_CONN_OUT_AMAP, *PIOCTL_ISCSI_REOPEN_A_CONN_OUT_AMAP;



typedef union {
   BE_IOCTL_ISCSI_REOPEN_A_CONN_IN_AMAP request;
   BE_IOCTL_ISCSI_REOPEN_A_CONN_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_REOPEN_A_CONN_PARAMS_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_REOPEN_A_CONN_PARAMS_AMAP, *PIOCTL_ISCSI_REOPEN_A_CONN_PARAMS_AMAP;


//          <b>         Opcode: OPCODE_REOPEN_A_CONN         <br>         Type:         
// </b>         <p>         This IOCTL can be used in response to an async message
// [link]ASYNC_EVENT_NEW_TCP_CONNECTION_ESTABLISHED[/link]             issue an iSCSI
// login to add a connection to an existing session.         The firmware will return the
// MCC Command WRB immediately, without waiting for the actual login to complete.         
// When login completes, the firmware will provide Asynchronous notification        
// [link]ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED[/link]that a new iSCSI connection
// has been established.       
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_ISCSI_REOPEN_A_CONN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_REOPEN_A_CONN_AMAP;
typedef struct { u32 dw[11]; } IOCTL_ISCSI_INI_DRIVER_REOPEN_A_CONN_AMAP, *PIOCTL_ISCSI_INI_DRIVER_REOPEN_A_CONN_AMAP;


//              This Ioctl tells the firmware to delete all non persistent sessions, This
// Ioctl is used during              power management since the firmware is not aware of
// the reason why the system is being powered             down (hibernation  or shutdown).
// When restarting from a hibernation state, the ARM firmware needs             to login
// to non-persistent targets, apart from persistent targets. This call from the host
// driver             lets the firmware know whenever the current boot is not related to
// hibernation; allowing it to              delete the non-persistent target information
// from its Flash ROM.     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_AMAP;
typedef struct { u32 dw[4]; } IOCTL_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_AMAP, *PIOCTL_ISCSI_INI_DRIVER_DEL_ALL_NONPERSISTENT_SESSIONS_AMAP;


//              This Ioctl tells the firmware to store non persistent sessions, This Ioctl
// is used              when the system is going to hibernation. When restarting from a
// hibernation state,              the ARM firmware needs to login to non-persistent
// targets, apart from persistent targets.              This call from the host driver
// lets the firmware know to store the non-persistent target             information to
// its Flash ROM.     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_AMAP;
typedef struct { u32 dw[4]; } IOCTL_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_AMAP, *PIOCTL_ISCSI_INI_DRIVER_STORE_NONPERSISTENT_SESSIONS_AMAP;


//          <b>         Opcode: OPCODE_LOGIN_ALL_SESSIONS         <br>         Type:      
//    </b>         <p>         This IOCTL is used to request a login to all targets known
// to the firmware. The firmware will          establish an iSCSI session with all the
// Targets stored in its Flash ROM including both persistent          and non-persistent
// ones. If a session previously contained multiple connections, an attempt will         
// be made to add those connections. This IOCTL does not have any input / output
// parameters.          <p>         ACIT must call this IOCTL during driver
// initialization.          -   For normal bootup after a power cycle, this IOCTL must be
// preceded by              OPCODE_DEL_ALL_NONPERSISTENT_SESSIONS causing this IOCTL login
// only to persistent targets.          -   For driver initialization after an unload,
// this IOCTL must be preceded by              OPCODE_DEL_ALL_NONPERSISTENT_SESSIONS
// causing this IOCTL login only to persistent targets.          -   While booting up from
// standby or hibernation modes the driver issues this IOCTL to force             the
// firmware to establish sessions with both persistent and non-persistent targets.        
// <p>     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_AMAP;
typedef struct { u32 dw[4]; } IOCTL_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_AMAP, *PIOCTL_ISCSI_INI_DRIVER_LOGIN_ALL_SESSIONS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT16_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP cq_id;
   BE_UEXACT16_AMAP defq_id;
   BE_PHYS_ADDR_AMAP dataout_template_pa;
   BE_UEXACT16_AMAP hdr_ring_id;
   BE_UEXACT16_AMAP data_ring_id;
} SG_PACK BE_OFFLOAD_SESSION_IN_AMAP;
typedef struct { u32 dw[6]; } OFFLOAD_SESSION_IN_AMAP, *POFFLOAD_SESSION_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP session_owner;
   BE_UEXACT32_AMAP expcmdsn;
   BE_UEXACT32_AMAP maxcmdsn;
   BE_UEXACT32_AMAP cmdsn;
   BE_UEXACT32_AMAP session_status;
   BE_MIB_ISCSI_STATISTICS_AMAP session_statistics;
   BE_UEXACT8_AMAP tmf_method;
   BE_UEXACT8_AMAP error_recovery_level;
   BE_UEXACT16_AMAP max_connections;
   BE_UEXACT32_AMAP extended_timeout;
   BE_CONNECTION_DATA_AMAP connection_info;
} SG_PACK BE_OFFLOAD_SESSION_OUT_AMAP;
typedef struct { u32 dw[24]; } OFFLOAD_SESSION_OUT_AMAP, *POFFLOAD_SESSION_OUT_AMAP;



typedef union {
   BE_OFFLOAD_SESSION_IN_AMAP request;
   BE_OFFLOAD_SESSION_OUT_AMAP response;
} SG_PACK BE_OFFLOAD_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[24]; } OFFLOAD_SESSION_PARAMS_AMAP, *POFFLOAD_SESSION_PARAMS_AMAP;


//               The iSCSI login negotiation sequence is handled by the Blade Engine's ARM
// Firmware, The Login             itself can be initiated by the Management Application
// (IOCTLs), WMI call (Windows) or by BIOS.             When persistent targets are
// configured, the ARM firmware may initiate a login on its own.             These
// sessions are 'owned' by Firmware from the time they are logged in, The Host driver can 
//            transfer the ownership of these sessions whenever it wants, This Ioctl is
// sent by the Driver             indicating the driver's intent to take ownership of the
// session and use the BE's accelerated              iSCSI hardware path for I/Os.        
//      <br>             <b>Originator(s)</b> : Driver             <br>            
// <b>Implemented in</b>: Firmware             <br>             <b>Return Values</b> :
// <ul>                             <li> MGMT_STATUS_SUCCESS,                            
// <li> MGMT_STATUS_INVALID_SESSION (session_handle or connection_handle is invalid)      
//                       <li> MGMT_STATUS_FAILED - Errors from EP firmware                
//             </ul>          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_OFFLOAD_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_OFFLOAD_SESSION_AMAP;
typedef struct { u32 dw[28]; } IOCTL_ISCSI_INI_DRIVER_OFFLOAD_SESSION_AMAP, *PIOCTL_ISCSI_INI_DRIVER_OFFLOAD_SESSION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT16_AMAP connection_handle;
   BE_UEXACT16_AMAP cid;
   BE_UEXACT16_AMAP cq_id;
   BE_UEXACT16_AMAP defq_id;
   BE_PHYS_ADDR_AMAP dataout_template_pa;
   BE_UEXACT16_AMAP hdr_ring_id;
   BE_UEXACT16_AMAP data_ring_id;
} SG_PACK BE_OFFLOAD_CONN_IN_AMAP;
typedef struct { u32 dw[6]; } OFFLOAD_CONN_IN_AMAP, *POFFLOAD_CONN_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_CONNECTION_DATA_AMAP connection_info;
} SG_PACK BE_OFFLOAD_CONN_OUT_AMAP;
typedef struct { u32 dw[7]; } OFFLOAD_CONN_OUT_AMAP, *POFFLOAD_CONN_OUT_AMAP;



typedef union {
   BE_OFFLOAD_CONN_IN_AMAP request;
   BE_OFFLOAD_CONN_OUT_AMAP response;
} SG_PACK BE_OFFLOAD_CONN_PARAMS_AMAP;
typedef struct { u32 dw[7]; } OFFLOAD_CONN_PARAMS_AMAP, *POFFLOAD_CONN_PARAMS_AMAP;


//                  IOCTL_ISCSI_INI_SESSION_OFFLOAD_CONN offloads additional connections
// in a                 session. To offload the leading connection in a session use       
//          [link]IOCTL_ISCSI_INI_DRIVER_OFFLOAD_SESSION[/link]             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_OFFLOAD_CONN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_DRIVER_OFFLOAD_CONN_AMAP;
typedef struct { u32 dw[11]; } IOCTL_ISCSI_INI_DRIVER_OFFLOAD_CONN_AMAP, *PIOCTL_ISCSI_INI_DRIVER_OFFLOAD_CONN_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_driver_amap_h__

