/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_iscsi_ini_session_amap_h__
#define __ioctl_iscsi_ini_session_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_iscsi_ini_stats.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_UEXACT32_AMAP session_flags;
} SG_PACK BE_GET_ALL_SESSIONS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_ALL_SESSIONS_PARAMS_IN_AMAP, *PGET_ALL_SESSIONS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_SESSION_INFO_AMAP session_list[1];
} SG_PACK BE_GET_ALL_SESSIONS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[293]; } GET_ALL_SESSIONS_PARAMS_OUT_AMAP, *PGET_ALL_SESSIONS_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ALL_SESSIONS_PARAMS_IN_AMAP request;
   BE_GET_ALL_SESSIONS_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ALL_SESSIONS_PARAMS_AMAP;
typedef struct { u32 dw[293]; } GET_ALL_SESSIONS_PARAMS_AMAP, *PGET_ALL_SESSIONS_PARAMS_AMAP;


//                   This Ioctl is is used to retrieve information on all sessions in a
// domain.                  The session_flags field can be used to filter the returned
// data.                   <br>                 <b>Originator(s)</b> : Management
// applications or BE INT13H BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :
// MGMT_STATUS_SUCCESS, MGMT_STATUS_INSUFFICIENT_BUFFER              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_SESSIONS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_ALL_SESSIONS_AMAP;
typedef struct { u32 dw[297]; } IOCTL_ISCSI_INI_SESSION_GET_ALL_SESSIONS_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_ALL_SESSIONS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_id_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT32_AMAP session_id_list[1];
} SG_PACK BE_GET_SESSION_LIST_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } GET_SESSION_LIST_PARAMS_IN_AMAP, *PGET_SESSION_LIST_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_SESSION_INFO_AMAP session_list[1];
} SG_PACK BE_GET_SESSION_LIST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[293]; } GET_SESSION_LIST_PARAMS_OUT_AMAP, *PGET_SESSION_LIST_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_SESSION_LIST_PARAMS_IN_AMAP request;
   BE_GET_SESSION_LIST_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_SESSION_LIST_PARAMS_AMAP;
typedef struct { u32 dw[293]; } GET_SESSION_LIST_PARAMS_AMAP, *PGET_SESSION_LIST_PARAMS_AMAP;


//                   This Ioctl is is used to retrieve information of sessions in a domain
//                 specified in the session_id_list.                   <br>               
//  <b>Originator(s)</b> : Management applications or BE INT13H BIOS                 <br> 
//                <b>Implemented in</b>: Firmware                 <br>                
// <b>Return Values</b> : MGMT_STATUS_SUCCESS, MGMT_STATUS_INSUFFICIENT_BUFFER            
//  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_SESSION_LIST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_SESSION_LIST_AMAP;
typedef struct { u32 dw[297]; } IOCTL_ISCSI_INI_SESSION_GET_SESSION_LIST_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_SESSION_LIST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_GET_A_SESSION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_A_SESSION_PARAMS_IN_AMAP, *PGET_A_SESSION_PARAMS_IN_AMAP;



typedef struct {
   BE_MGMT_SESSION_INFO_AMAP session_info;
} SG_PACK BE_GET_A_SESSION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[291]; } GET_A_SESSION_PARAMS_OUT_AMAP, *PGET_A_SESSION_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_A_SESSION_PARAMS_IN_AMAP request;
   BE_GET_A_SESSION_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_A_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[291]; } GET_A_SESSION_PARAMS_AMAP, *PGET_A_SESSION_PARAMS_AMAP;


//                   This Ioctl is is used to retrieve information about an individual
// session in a domain.                   <br>                 <b>Originator(s)</b> :
// Management applications or BE INT13H BIOS                 <br>                
// <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> :  <ul>                                             <li>MGMT_STATUS_SUCCESS 
//                                            <li>MGMT_STATUS_INVALID_SESSION (invalid
// session handle).                                         </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_A_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_A_SESSION_AMAP;
typedef struct { u32 dw[295]; } IOCTL_ISCSI_INI_SESSION_GET_A_SESSION_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_A_SESSION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_flags;
} SG_PACK BE_GET_ALL_CONNECTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_ALL_CONNECTION_PARAMS_IN_AMAP, *PGET_ALL_CONNECTION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_CONN_LB_INFO_AMAP connection_list[1];
} SG_PACK BE_GET_ALL_CONNECTION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[10]; } GET_ALL_CONNECTION_PARAMS_OUT_AMAP, *PGET_ALL_CONNECTION_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ALL_CONNECTION_PARAMS_IN_AMAP request;
   BE_GET_ALL_CONNECTION_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ALL_CONNECTION_PARAMS_AMAP;
typedef struct { u32 dw[10]; } GET_ALL_CONNECTION_PARAMS_AMAP, *PGET_ALL_CONNECTION_PARAMS_AMAP;


//                   This Ioctl is is used to retrieve information on all connections in a
// domain.                  The session_flags field can be used to filter the returned
// data.                   <br>                 <b>Originator(s)</b> : Management
// applications or BE INT13H BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> :
// MGMT_STATUS_SUCCESS, MGMT_STATUS_INSUFFICIENT_BUFFER              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_CONNECTION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_AMAP;
typedef struct { u32 dw[14]; } IOCTL_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_ALL_CONNECTIONS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_GET_SESSION_CONFIGURATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_SESSION_CONFIGURATION_PARAMS_IN_AMAP, *PGET_SESSION_CONFIGURATION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP extended_timeout;
   BE_UEXACT8_AMAP tmf_method;
   BE_BIT rsvd0[3][8];                            // DWORD 2
   BE_EXACT8_AMAP target_name[224];
   BE_BIT rsvd1[32];                              // DWORD 59
   BE_MGMT_BTL_MAPPING_AMAP btl_mapping;
} SG_PACK BE_GET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[69]; } GET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP, *PGET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_SESSION_CONFIGURATION_PARAMS_IN_AMAP request;
   BE_GET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_SESSION_CONFIGURATION_PARAMS_AMAP;
typedef struct { u32 dw[69]; } GET_SESSION_CONFIGURATION_PARAMS_AMAP, *PGET_SESSION_CONFIGURATION_PARAMS_AMAP;


//                  This Ioctl is used to get non iSCSI-related parameters for a
// particular session.                 An OS-specific driver layer may use this call to
// retrieve the Bus-Target mapping                 used for a persistent session, before
// exposing the same to the OS. It may also be                 used to determine the error
// recovery behaviour set for a target.                  <br>                
// <b>Originator(s)</b> : Management applications or BE INT13H BIOS                 <br>  
//               <b>Implemented in</b>: Firmware                 <br>                
// <b>Return Values</b> :  <ul>                                             <li>
// MGMT_STATUS_SUCCESS                                             <li>
// MGMT_STATUS_INVALID_SESSION (session_handle is invalid)                                
//         </ul>                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_SESSION_CONFIGURATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_AMAP;
typedef struct { u32 dw[73]; } IOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_AMAP;


// --- SESSIONCONFIG_PARAM_FLAG ---
#define SET_SESSCONFIG_PARAM_FLAG_ETO   (1)       // The 'extended_timeout' field is valid
#define SET_SESSCONFIG_PARAM_FLAG_BTL   (2)       // The 'btl_mapping' field is valid 
#define SET_SESSCONFIG_PARAM_FLAG_TMF   (4)       // The 'tmf_method' field is valid 
#define SET_SESSCONFIG_PARAM_FLAG_FULL  (4294967295) // All the parameters are valid 

typedef enum {
   ENUM_SET_SESSCONFIG_PARAM_FLAG_ETO = 0x1UL,
   ENUM_SET_SESSCONFIG_PARAM_FLAG_BTL = 0x2UL,
   ENUM_SET_SESSCONFIG_PARAM_FLAG_TMF = 0x4UL,
   ENUM_SET_SESSCONFIG_PARAM_FLAG_FULL = 0xffffffffUL
} SESSIONCONFIG_PARAM_FLAG;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP param_flags;
   BE_UEXACT32_AMAP extended_timeout;
   BE_UEXACT8_AMAP tmf_method;
   BE_BIT rsvd0[3][8];                            // DWORD 3
   BE_EXACT8_AMAP target_name[224];
   BE_BIT rsvd1[32];                              // DWORD 60
   BE_MGMT_BTL_MAPPING_AMAP btl_mapping;
} SG_PACK BE_SET_SESSION_CONFIGURATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[70]; } SET_SESSION_CONFIGURATION_PARAMS_IN_AMAP, *PSET_SESSION_CONFIGURATION_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP, *PSET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_SESSION_CONFIGURATION_PARAMS_IN_AMAP request;
   BE_SET_SESSION_CONFIGURATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_SESSION_CONFIGURATION_PARAMS_AMAP;
typedef struct { u32 dw[70]; } SET_SESSION_CONFIGURATION_PARAMS_AMAP, *PSET_SESSION_CONFIGURATION_PARAMS_AMAP;


//                  Host drivers may issue this call to save Bus-Target mapping
// information to be used after the next                 reboot. The firmware does not do
// perform any validation on the contents of this IOCTL.Management                
// applications may send this IOCTL to change the error recovery parameters for a
// target/session.                  <br>                 <b>Originator(s)</b> : Host
// Driver, Management applications or BE INT13H BIOS                 <br>                
// <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> :  <ul>                                             <li> MGMT_STATUS_SUCCESS
//                                             <li> MGMT_STATUS_INVALID_SESSION
// (session_handle is invalid)                                         </ul>              
//   <p>              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_SESSION_CONFIGURATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_SET_CONFIGURATION_AMAP;
typedef struct { u32 dw[74]; } IOCTL_ISCSI_INI_SESSION_SET_CONFIGURATION_AMAP, *PIOCTL_ISCSI_INI_SESSION_SET_CONFIGURATION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_id_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_UEXACT32_AMAP session_id_list[1];
} SG_PACK BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } SESSION_GET_CONFIGURATION_LIST_PARAMS_IN_AMAP, *PSESSION_GET_CONFIGURATION_LIST_PARAMS_IN_AMAP;


//                               The size of this array is determined by the session_count
// field                         
typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP extended_timeout;
   BE_UEXACT8_AMAP tmf_method;
   BE_BIT rsvd0[3][8];                            // DWORD 2
   BE_EXACT8_AMAP target_name[224];
   BE_BIT rsvd1[32];                              // DWORD 59
   BE_MGMT_BTL_MAPPING_AMAP btl_mapping;
} SG_PACK BE_SESSION_CONFIGURATION_LIST_AMAP;
typedef struct { u32 dw[69]; } SESSION_CONFIGURATION_LIST_AMAP, *PSESSION_CONFIGURATION_LIST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_SESSION_CONFIGURATION_LIST_AMAP session_list[1];
} SG_PACK BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[71]; } SESSION_GET_CONFIGURATION_LIST_PARAMS_OUT_AMAP, *PSESSION_GET_CONFIGURATION_LIST_PARAMS_OUT_AMAP;



typedef union {
   BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_IN_AMAP request;
   BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_OUT_AMAP response;
} SG_PACK BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_AMAP;
typedef struct { u32 dw[71]; } SESSION_GET_CONFIGURATION_LIST_PARAMS_AMAP, *PSESSION_GET_CONFIGURATION_LIST_PARAMS_AMAP;


//                  This Ioctl is used to get non iSCSI-related parameters for a
// particular session.                 An OS-specific driver layer may use this call to
// retrieve the Bus-Target mapping                 used for a persistent session, before
// exposing the same to the OS. It may also be                 used to determine the error
// recovery behaviour set for a target.                  <br>                
// <b>Originator(s)</b> : Management applications or BE INT13H BIOS                 <br>  
//               <b>Implemented in</b>: Firmware                 <br>                
// <b>Return Values</b> :  <ul>                                             <li>
// MGMT_STATUS_SUCCESS                                             <li>
// MGMT_STATUS_INVALID_SESSION (session_handle is invalid)                                
//         </ul>                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SESSION_GET_CONFIGURATION_LIST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_AMAP;
typedef struct { u32 dw[75]; } IOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_CONFIGURATION_LIST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_LOGIN_OPTIONS_AMAP specified_login_options;
} SG_PACK BE_MODIFY_SESSION_LOGINKEYS_PARAMS_IN_AMAP;
typedef struct { u32 dw[152]; } MODIFY_SESSION_LOGINKEYS_PARAMS_IN_AMAP, *PMODIFY_SESSION_LOGINKEYS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_status;
   BE_UEXACT32_AMAP session_handle;
   BE_MGMT_LOGIN_OPTIONS_AMAP negotiated_login_options;
} SG_PACK BE_MODIFY_SESSION_LOGINKEYS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[152]; } MODIFY_SESSION_LOGINKEYS_PARAMS_OUT_AMAP, *PMODIFY_SESSION_LOGINKEYS_PARAMS_OUT_AMAP;



typedef union {
   BE_MODIFY_SESSION_LOGINKEYS_PARAMS_IN_AMAP request;
   BE_MODIFY_SESSION_LOGINKEYS_PARAMS_OUT_AMAP response;
} SG_PACK BE_MODIFY_SESSION_LOGINKEYS_PARAMS_AMAP;
typedef struct { u32 dw[152]; } MODIFY_SESSION_LOGINKEYS_PARAMS_AMAP, *PMODIFY_SESSION_LOGINKEYS_PARAMS_AMAP;


//                  This Ioctl is used by management layers to change the session Login
// parameters of a currently open                  session, The host driver intercepts
// this Ioctl, closes the session and marks it for recovery so that                 the
// firmware does not erase the configuration information for this session from Flash ROM. 
//                The driver then forwards this Ioctl to the ARM firmware. The firmware
// logs in to this session with                 the modified login parameters. On a
// successful login these values are updated in the Flash. If the                  session
// could not be opened, the Ioctl is returned with an error status. The ARM Firmware will
// not                 retry session establishmenton its own after reporting a failure.   
//               <br>                 <b>Originator(s)</b> : Management applications      
//           <br>                 <b>Implemented in</b>: Driver and Firmware              
//   <br>                 <b>Return Values</b> : < ul>                                    
//         <li>MGMT_STATUS_SUCCESS                                            
// <li>MGMT_STATUS_INVALID_SESSION (session_handle is invalid)                            
//                 <li>MGMT_STATUS_FAILED - login Failed                                  
//           <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Login Timed out                         
//                </ul>                           
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MODIFY_SESSION_LOGINKEYS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_AMAP;
typedef struct { u32 dw[156]; } IOCTL_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_AMAP, *PIOCTL_ISCSI_INI_SESSION_MODIFY_SESSION_LOGINKEYS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP connection_handle;
   BE_BIT rsvd0[32];                              // DWORD 2
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP specified_connection_options;
} SG_PACK BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_IN_AMAP;
typedef struct { u32 dw[148]; } MODIFY_CONNECTION_LOGINKEYS_PARAMS_IN_AMAP, *PMODIFY_CONNECTION_LOGINKEYS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT32_AMAP connection_status;
   BE_BIT rsvd0[32];                              // DWORD 3
   BE_BIT rsvd1[192];                             // DWORD 4
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP negotiated_connection_options;
} SG_PACK BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[155]; } MODIFY_CONNECTION_LOGINKEYS_PARAMS_OUT_AMAP, *PMODIFY_CONNECTION_LOGINKEYS_PARAMS_OUT_AMAP;



typedef union {
   BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_IN_AMAP request;
   BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_OUT_AMAP response;
} SG_PACK BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_AMAP;
typedef struct { u32 dw[155]; } MODIFY_CONNECTION_LOGINKEYS_PARAMS_AMAP, *PMODIFY_CONNECTION_LOGINKEYS_PARAMS_AMAP;


//                  This Ioctl is used by Management layers to change the connection login
// parameters for a session.                 The host driver intercepts this Ioctl, closes
// the connection and marks it in recovery so that                  firmware does not
// erase the configuration data for this session from Flash ROM. The driver then forwards 
//                this Ioctl to the ARM firmware. The firmware adds this connection to the
// corresponding session.                  <br>                 <b>Originator(s)</b> :
// Management applications                 <br>                 <b>Implemented in</b>:
// Driver and Firmware                 <br>                 <b>Return Values</b> :  <ul>  
//                                           <li>MGMT_STATUS_SUCCESS                      
//                       <li>MGMT_STATUS_INVALID_CONNECTION (connection_handle is invalid)
//                                             <li>MGMT_STATUS_FAILED - login Failed      
//                                       <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Login Timed
// out                                         </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MODIFY_CONNECTION_LOGINKEYS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_AMAP;
typedef struct { u32 dw[159]; } IOCTL_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_AMAP, *PIOCTL_ISCSI_INI_SESSION_MODIFY_CONNECTION_LOGINKEYS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP cmd_sn;
   BE_MGMT_PORTAL_AMAP portal;
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP specified_options;
} SG_PACK BE_ADD_CONNECTION_TO_SESSION_PARAMS_IN_AMAP;
typedef struct { u32 dw[154]; } ADD_CONNECTION_TO_SESSION_PARAMS_IN_AMAP, *PADD_CONNECTION_TO_SESSION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_CONNECTION_DATA_AMAP conn_data;
   BE_MGMT_CONN_LOGIN_OPTIONS_AMAP negotiated_options;
} SG_PACK BE_ADD_CONNECTION_TO_SESSION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[152]; } ADD_CONNECTION_TO_SESSION_PARAMS_OUT_AMAP, *PADD_CONNECTION_TO_SESSION_PARAMS_OUT_AMAP;



typedef union {
   BE_ADD_CONNECTION_TO_SESSION_PARAMS_IN_AMAP request;
   BE_ADD_CONNECTION_TO_SESSION_PARAMS_OUT_AMAP response;
} SG_PACK BE_ADD_CONNECTION_TO_SESSION_PARAMS_AMAP;
typedef struct { u32 dw[154]; } ADD_CONNECTION_TO_SESSION_PARAMS_AMAP, *PADD_CONNECTION_TO_SESSION_PARAMS_AMAP;


//                  This ioctl is called by Management Layers to add a connection to an
// existing session.                 BladeEngine supports upto four
// connections-per-session. The Ioctl returns when the login sequence                
// required to add a connection completes. The driver will offload the connection at a
// later point                 in response to an asynchronous message
// [link]ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED[/link].                  <br>       
//          <b>Originator(s)</b> : Management applications                 <br>           
//      <b>Implemented in</b>: Driver and Firmware                 <br>                
// <b>Return Values</b> :  <ul>                                            
// <li>MGMT_STATUS_SUCCESS                                            
// <li>MGMT_STATUS_FAILED - login to new iSCSI Connection Failed                          
//                   <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT -  new iSCSI Connection Login
// Timed out                                         </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ADD_CONNECTION_TO_SESSION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_AMAP;
typedef struct { u32 dw[158]; } IOCTL_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_AMAP, *PIOCTL_ISCSI_INI_SESSION_ADD_CONNECTION_TO_SESSION_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP connection_handle;
} SG_PACK BE_CLOSE_CONNECTION_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } CLOSE_CONNECTION_PARAMS_IN_AMAP, *PCLOSE_CONNECTION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP connection_status;
} SG_PACK BE_CLOSE_CONNECTION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } CLOSE_CONNECTION_PARAMS_OUT_AMAP, *PCLOSE_CONNECTION_PARAMS_OUT_AMAP;



typedef union {
   BE_CLOSE_CONNECTION_PARAMS_IN_AMAP request;
   BE_CLOSE_CONNECTION_PARAMS_OUT_AMAP response;
} SG_PACK BE_CLOSE_CONNECTION_PARAMS_AMAP;
typedef struct { u32 dw[2]; } CLOSE_CONNECTION_PARAMS_AMAP, *PCLOSE_CONNECTION_PARAMS_AMAP;


//                  This ioctl is invoked by management layers to close a particular
// connection in a session.                 Multiple connections-per-session are supported
// only for data Sessions, All data sessions                  are owned by the driver, the
// driver does a logout of connection and calls other Ioctl to                  cleanup
// the connection (TCP/IP) resources.                  <br>                
// <b>Originator(s)</b> : Management applications                 <br>                
// <b>Implemented in</b>: Driver and Firmware                 <br>                
// <b>Return Values</b> :  <ul>                                            
// <li>MGMT_STATUS_SUCCESS                                            
// <li>MGMT_STATUS_INVALID_CONNECTION (connection_handle is invalid)                      
//                       <li>MGMT_STATUS_FAILED - iSCSI Connection logout Failed (Event
// Log is to be checked for exact status)                                         </ul>   
//          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_CLOSE_CONNECTION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_CLOSE_CONNECTION_AMAP;
typedef struct { u32 dw[6]; } IOCTL_ISCSI_INI_SESSION_CLOSE_CONNECTION_AMAP, *PIOCTL_ISCSI_INI_SESSION_CLOSE_CONNECTION_AMAP;


//   Input parameters for logging in to an iSCSI Target. 
typedef struct {
   BE_EXACT8_AMAP tgt_iscsi_name[224];
   BE_IP_ADDRESS_FORMAT_AMAP ip_address;
   BE_UEXACT16_AMAP tcp_port;
   BE_UEXACT16_AMAP preshared_keysize;
   BE_UEXACT8_AMAP preshared_key[256];
   BE_UEXACT32_AMAP session_flags;
   BE_UEXACT32_AMAP iscsi_security_flags;
   BE_UEXACT32_AMAP login_flags;
   BE_UEXACT32_AMAP extended_timeout;
   BE_UEXACT16_AMAP isid_qualifier;
   BE_UEXACT8_AMAP tmf_method;
   BE_UEXACT8_AMAP magic_number;
   BE_MGMT_LOGIN_OPTIONS_AMAP tgt_login_options;
   BE_EXACT8_AMAP initiator_name[224];
   BE_EXACT8_AMAP initiator_alias[32];
   BE_MGMT_BTL_MAPPING_AMAP btl_mapping;
} SG_PACK BE_LOGIN_TARGET_PARAMS_IN_AMAP;
typedef struct { u32 dw[355]; } LOGIN_TARGET_PARAMS_IN_AMAP, *PLOGIN_TARGET_PARAMS_IN_AMAP;


//  Returned values after a iSCSI Login completes
typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT32_AMAP session_status;
   BE_UEXACT32_AMAP connection_handle;
   BE_UEXACT32_AMAP session_flags;
   BE_MGMT_LOGIN_OPTIONS_AMAP negotiated_login_options;
   BE_UEXACT32_AMAP target_handle;
} SG_PACK BE_LOGIN_TARGET_PARAMS_OUT_AMAP;
typedef struct { u32 dw[155]; } LOGIN_TARGET_PARAMS_OUT_AMAP, *PLOGIN_TARGET_PARAMS_OUT_AMAP;



typedef union {
   BE_LOGIN_TARGET_PARAMS_IN_AMAP request;
   BE_LOGIN_TARGET_PARAMS_OUT_AMAP response;
} SG_PACK BE_LOGIN_TARGET_PARAMS_AMAP;
typedef struct { u32 dw[355]; } LOGIN_TARGET_PARAMS_AMAP, *PLOGIN_TARGET_PARAMS_AMAP;


//                  This Ioctl is used by Management layers to login to a target and
// create a new session.                 If the login is successful, a session_handle is
// returned.This handle should be used for                 all session management
// functions. The firmware also returns a target_id field. This is a                
// reference to the firmware's internal data structures for a target and should be used   
//              as an identifier in all Persistent-Target Ioctls.                 This
// Ioctl will result in an asynchronous message
// [link]ASYNC_EVENT_NEW_ISCSI_CONNECTION_ESTABLISHED[/link].                 This async
// message is sent on a successful login, to the intended domain when a [b]data[/b]       
//          session is established.                   <br>                
// <b>Originator(s)</b> : Management applications, BIOS                 <br>              
//   <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> :  <ul>                                             <li>MGMT_STATUS_SUCCESS 
//                                            <li>MGMT_STATUS_FAILED - login Failed (Event
// Log is to be checked for exact status)                                            
// <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Login Timed out                                   
//          <li>MGMT_STATUS_TGTTBL_FULL - Exceeded maximum number of targets supported    
//                                     </ul>               
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_LOGIN_TARGET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_LOGIN_TARGET_AMAP;
typedef struct { u32 dw[359]; } IOCTL_ISCSI_INI_SESSION_LOGIN_TARGET_AMAP, *PIOCTL_ISCSI_INI_SESSION_LOGIN_TARGET_AMAP;



typedef LOGIN_TARGET_PARAMS_IN_AMAP ADD_PERSISTENT_LOGIN_PARAMS_IN_AMAP;
typedef BE_LOGIN_TARGET_PARAMS_IN_AMAP BE_ADD_PERSISTENT_LOGIN_PARAMS_IN_AMAP;


typedef LOGIN_TARGET_PARAMS_IN_AMAP* PADD_PERSISTENT_LOGIN_PARAMS_IN_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PADD_PERSISTENT_LOGIN_PARAMS_IN_AMAP;


typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_LOGOUT_TARGET_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } LOGOUT_TARGET_PARAMS_IN_AMAP, *PLOGOUT_TARGET_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_status;
} SG_PACK BE_LOGOUT_TARGET_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } LOGOUT_TARGET_PARAMS_OUT_AMAP, *PLOGOUT_TARGET_PARAMS_OUT_AMAP;



typedef union {
   BE_LOGOUT_TARGET_PARAMS_IN_AMAP request;
   BE_LOGOUT_TARGET_PARAMS_OUT_AMAP response;
} SG_PACK BE_LOGOUT_TARGET_PARAMS_AMAP;
typedef struct { u32 dw[1]; } LOGOUT_TARGET_PARAMS_AMAP, *PLOGOUT_TARGET_PARAMS_AMAP;


//          This ioctl can be initiated by a management application or BIOS. If a sesson
// is          in the offloaded state, this Ioctl is intercepted and a logout is sent by
// the driver through         the EP firmware (offloaded path).         In the case of
// BIOS I/Os, where the session is not offloaded, an IOCTL_ISCSI_LOGOUT_TARGET will       
//          be sent to the ARM which issues a Logout PDU.                  <br>           
//      <b>Originator(s)</b> : Management applications, BIOS                 <br>         
//        <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> :  <ul>                                             <li>MGMT_STATUS_SUCCESS 
//                                            <li>MGMT_STATUS_INVALID_SESSION
// (session_handle is invalid)                                            
// <li>MGMT_STATUS_FAILED - logout Failed (Event Log is to be checked for exact status)   
//                                          <li>MGMT_STATUS_POLL_IOCTL_TIMEOUT - Login
// Timed out                                         </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_LOGOUT_TARGET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_LOGOUT_TARGET_AMAP;
typedef struct { u32 dw[5]; } IOCTL_ISCSI_INI_SESSION_LOGOUT_TARGET_AMAP, *PIOCTL_ISCSI_INI_SESSION_LOGOUT_TARGET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP lun[8];
   BE_UEXACT8_AMAP flags;
   BE_UEXACT8_AMAP page_code;
} SG_PACK BE_SCSI_INQUIRY_PARAMS_IN_AMAP;
typedef struct { u32 dw[4]; } SCSI_INQUIRY_PARAMS_IN_AMAP, *PSCSI_INQUIRY_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP scsi_status;
   BE_UEXACT8_AMAP iscsi_response;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_UEXACT32_AMAP response_data_size;
   BE_UEXACT8_AMAP sense_buffer[18];
   BE_UEXACT8_AMAP response_data[1];
} SG_PACK BE_SCSI_INQUIRY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[7]; } SCSI_INQUIRY_PARAMS_OUT_AMAP, *PSCSI_INQUIRY_PARAMS_OUT_AMAP;



typedef union {
   BE_SCSI_INQUIRY_PARAMS_IN_AMAP request;
   BE_SCSI_INQUIRY_PARAMS_OUT_AMAP response;
} SG_PACK BE_SCSI_INQUIRY_PARAMS_AMAP;
typedef struct { u32 dw[7]; } SCSI_INQUIRY_PARAMS_AMAP, *PSCSI_INQUIRY_PARAMS_AMAP;


//   [flag]Hari - Delete inquiry,readcapacity and report LUNs - use SCSI Rd/Wr
// instead[/flag]         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SCSI_INQUIRY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_SCSI_INQUIRY_AMAP;
typedef struct { u32 dw[11]; } IOCTL_SCSI_INQUIRY_AMAP, *PIOCTL_SCSI_INQUIRY_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
   BE_UEXACT8_AMAP lun[8];
} SG_PACK BE_SCSI_READ_CAPACITY_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } SCSI_READ_CAPACITY_PARAMS_IN_AMAP, *PSCSI_READ_CAPACITY_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP scsi_status;
   BE_UEXACT8_AMAP iscsi_response;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_UEXACT32_AMAP response_data_size;
   BE_UEXACT8_AMAP sense_buffer[18];
   BE_UEXACT8_AMAP response_data[1];
} SG_PACK BE_SCSI_READ_CAPACITY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[7]; } SCSI_READ_CAPACITY_PARAMS_OUT_AMAP, *PSCSI_READ_CAPACITY_PARAMS_OUT_AMAP;



typedef union {
   BE_SCSI_READ_CAPACITY_PARAMS_IN_AMAP request;
   BE_SCSI_READ_CAPACITY_PARAMS_OUT_AMAP response;
} SG_PACK BE_SCSI_READ_CAPACITY_PARAMS_AMAP;
typedef struct { u32 dw[7]; } SCSI_READ_CAPACITY_PARAMS_AMAP, *PSCSI_READ_CAPACITY_PARAMS_AMAP;


//               IOCTL_SCSI_READ_CAPACITY             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SCSI_READ_CAPACITY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_SCSI_READ_CAPACITY_AMAP;
typedef struct { u32 dw[11]; } IOCTL_SCSI_READ_CAPACITY_AMAP, *PIOCTL_SCSI_READ_CAPACITY_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_SCSI_REPORT_LUNS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } SCSI_REPORT_LUNS_PARAMS_IN_AMAP, *PSCSI_REPORT_LUNS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP scsi_status;
   BE_UEXACT8_AMAP iscsi_response;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_BIT rsvd1[8];                               // DWORD 0
   BE_UEXACT32_AMAP response_data_size;
   BE_UEXACT8_AMAP sense_buffer[18];
   BE_UEXACT8_AMAP response_data[1];
} SG_PACK BE_SCSI_REPORT_LUNS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[7]; } SCSI_REPORT_LUNS_PARAMS_OUT_AMAP, *PSCSI_REPORT_LUNS_PARAMS_OUT_AMAP;



typedef union {
   BE_SCSI_REPORT_LUNS_PARAMS_IN_AMAP request;
   BE_SCSI_REPORT_LUNS_PARAMS_OUT_AMAP response;
} SG_PACK BE_SCSI_REPORT_LUNS_PARAMS_AMAP;
typedef struct { u32 dw[7]; } SCSI_REPORT_LUNS_PARAMS_AMAP, *PSCSI_REPORT_LUNS_PARAMS_AMAP;


//               IOCTL_SCSI_REPORT_LUNS             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SCSI_REPORT_LUNS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_SCSI_REPORT_LUNS_AMAP;
typedef struct { u32 dw[11]; } IOCTL_SCSI_REPORT_LUNS_AMAP, *PIOCTL_SCSI_REPORT_LUNS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_flags;
} SG_PACK BE_GET_ALL_SESSION_ID_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_ALL_SESSION_ID_PARAMS_IN_AMAP, *PGET_ALL_SESSION_ID_PARAMS_IN_AMAP;


//                               The size of this array is determined by the
// session_id_count field                         
typedef struct {
   BE_UEXACT32_AMAP session_handle;
} SG_PACK BE_SESSION_ID_CONN_COUNT_AMAP;
typedef struct { u32 dw[1]; } SESSION_ID_CONN_COUNT_AMAP, *PSESSION_ID_CONN_COUNT_AMAP;



typedef struct {
   BE_UEXACT32_AMAP session_id_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_SESSION_ID_CONN_COUNT_AMAP session_id_list[1];
} SG_PACK BE_GET_ALL_SESSION_ID_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } GET_ALL_SESSION_ID_PARAMS_OUT_AMAP, *PGET_ALL_SESSION_ID_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ALL_SESSION_ID_PARAMS_IN_AMAP request;
   BE_GET_ALL_SESSION_ID_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ALL_SESSION_ID_PARAMS_AMAP;
typedef struct { u32 dw[3]; } GET_ALL_SESSION_ID_PARAMS_AMAP, *PGET_ALL_SESSION_ID_PARAMS_AMAP;


//                  IOCTL_ISCSI_INI_SESSION_GET_ALL_SESSION_ID returns session IDs of all
// the connected iSCSI session             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_SESSION_ID_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_AMAP;
typedef struct { u32 dw[7]; } IOCTL_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_ALL_SESSION_ID_AMAP;



typedef struct {
   BE_UEXACT32_AMAP portal_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_TGTID_PORTAL_AMAP list[1];
} SG_PACK BE_GET_ALL_PLOGIN_TGTID_PORTAL_PARAMS_OUT_AMAP;
typedef struct { u32 dw[10]; } GET_ALL_PLOGIN_TGTID_PORTAL_PARAMS_OUT_AMAP, *PGET_ALL_PLOGIN_TGTID_PORTAL_PARAMS_OUT_AMAP;


//                  Each persistent login is uniquely identified by the target IQN name
// and the portal (IP address                 + TCP Port number).                 It is
// possible that the user configures two persistent logins to the same target when the
// target                 has two portals.                 This ioctl will return the
// number of persistent targets in the Flash ROM along with their target_id's.            
//     Management layers should calculate the response buffer required to get these
// targets, If it exceeds                  the maximum data transfer size supported by the
// driver then the Ioctl IOCTL_ISCSI_QUERY_A_PERSISTENT_LOGIN                  should be
// used repetitively to get this information for each target. In the WMI case, when OSM
// receives                  the WMI Query request for MSiSCSI_PersistentLogins, OSM will
// issue several internal IOCTLs to perform                  the same sequence.           
//      <br>                 <b>Originator(s)</b> : Management applications, BIOS         
//        <br>                 <b>Implemented in</b>: Firmware                 <br>       
//          <b>Return Values</b> : MGMT_STATUS_SUCCESS              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ALL_PLOGIN_TGTID_PORTAL_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_AMAP;
typedef struct { u32 dw[14]; } IOCTL_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_AMAP, *PIOCTL_ISCSI_INI_SESSION_GET_ALL_PLOGIN_TGTNAME_PORTAL_AMAP;



typedef struct {
   BE_MGMT_TGTID_PORTAL_AMAP tgtid_portal;
} SG_PACK BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_IN_AMAP;
typedef struct { u32 dw[8]; } QUERY_A_PERSISTENT_LOGIN_PARAMS_IN_AMAP, *PQUERY_A_PERSISTENT_LOGIN_PARAMS_IN_AMAP;



typedef struct {
   BE_MGMT_PERSISTENT_LOGIN_AMAP persistentlogin;
} SG_PACK BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_OUT_AMAP;
typedef struct { u32 dw[225]; } QUERY_A_PERSISTENT_LOGIN_PARAMS_OUT_AMAP, *PQUERY_A_PERSISTENT_LOGIN_PARAMS_OUT_AMAP;



typedef union {
   BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_IN_AMAP request;
   BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_OUT_AMAP response;
} SG_PACK BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_AMAP;
typedef struct { u32 dw[225]; } QUERY_A_PERSISTENT_LOGIN_PARAMS_AMAP, *PQUERY_A_PERSISTENT_LOGIN_PARAMS_AMAP;


//                  This ioctl returns the persistent target for a given target_id.       
//          <br>                 <b>Originator(s)</b> : Management applications, BIOS     
//            <br>                 <b>Implemented in</b>: Firmware                 <br>   
//              <b>Return Values</b> : <ul>                                    
// <li>MGMT_STATUS_SUCCESS                                    
// <li>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND                                 </ul>     
//         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_A_PERSISTENT_LOGIN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_AMAP;
typedef struct { u32 dw[229]; } IOCTL_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_AMAP, *PIOCTL_ISCSI_INI_SESSION_QUERY_A_PERSISTENT_LOGIN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP persistentlogin_count;
   BE_BIT rsvd0[32];                              // DWORD 1
   BE_MGMT_PERSISTENT_LOGIN_AMAP persistentlogin_list[1];
} SG_PACK BE_QUERY_PERSISTENT_LOGINS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[227]; } QUERY_PERSISTENT_LOGINS_PARAMS_OUT_AMAP, *PQUERY_PERSISTENT_LOGINS_PARAMS_OUT_AMAP;


//                  This ioctl is sent by Management Layers to get all the Persistent
// Targets present in the Flash.                  <br>                
// <b>Originator(s)</b> : BIOS                 <br>                 <b>Implemented in</b>:
// Firmware                 <br>                 <b>Return Values</b> :
// MGMT_STATUS_SUCCESS             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_PERSISTENT_LOGINS_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_AMAP;
typedef struct { u32 dw[231]; } IOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_AMAP, *PIOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP start_index;
   BE_UEXACT32_AMAP max_required;
} SG_PACK BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } QUERY_PERSISTENT_LOGIN_LIST_PARAMS_IN_AMAP, *PQUERY_PERSISTENT_LOGIN_LIST_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP persistentlogin_count;
   BE_UEXACT32_AMAP max_count;
   BE_MGMT_PERSISTENT_LOGIN_AMAP persistentlogin_list[1];
} SG_PACK BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[227]; } QUERY_PERSISTENT_LOGIN_LIST_PARAMS_OUT_AMAP, *PQUERY_PERSISTENT_LOGIN_LIST_PARAMS_OUT_AMAP;



typedef union {
   BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_IN_AMAP request;
   BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_OUT_AMAP response;
} SG_PACK BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_AMAP;
typedef struct { u32 dw[227]; } QUERY_PERSISTENT_LOGIN_LIST_PARAMS_AMAP, *PQUERY_PERSISTENT_LOGIN_LIST_PARAMS_AMAP;


//                  This ioctl is sent by Management Layers to get all the Persistent
// Targets.                 This extended version is defined as a compact version of      
//            IOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGINS so that all 128 sessions    
//             can fit into 64KBytes.                                  <br>               
//  <b>Originator(s)</b> : Management applications, BIOS                 <br>             
//    <b>Implemented in</b>: Firmware                 <br>                 <b>Return
// Values</b> : <ul>                                     <li>MGMT_STATUS_SUCCESS          
//                           <li>MGMT_STATUS_INSUFFICIENT_BUFFER                          
//       </ul>              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_PERSISTENT_LOGIN_LIST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_AMAP;
typedef struct { u32 dw[231]; } IOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_AMAP, *PIOCTL_ISCSI_INI_SESSION_QUERY_PERSISTENT_LOGIN_LIST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP target_id;
} SG_PACK BE_ADD_PERSISTENT_LOGIN_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } ADD_PERSISTENT_LOGIN_PARAMS_OUT_AMAP, *PADD_PERSISTENT_LOGIN_PARAMS_OUT_AMAP;



typedef union {
   BE_ADD_PERSISTENT_LOGIN_PARAMS_IN_AMAP request;
   BE_ADD_PERSISTENT_LOGIN_PARAMS_OUT_AMAP response;
} SG_PACK BE_ADD_PERSISTENT_LOGIN_PARAMS_AMAP;
typedef struct { u32 dw[355]; } ADD_PERSISTENT_LOGIN_PARAMS_AMAP, *PADD_PERSISTENT_LOGIN_PARAMS_AMAP;


//                  This Ioctl is sent by Management layers to add the configuration of a
// Persistent Target to the                  Flash ROM. The firmware makes no attempt to
// login to the target at this time. At the next boot/reset                 the target
// will be automatically logged in by the ARM Firmware. This Ioctl can also be used to    
//              convert a non-persistent session to a persistent session,                 
// The payload of this Ioctl resembles the Login Ioctl,                   <br>            
//     <b>Originator(s)</b> : BIOS                 <br>                 <b>Implemented
// in</b>: Firmware                 <br>                 <b>Return Values</b> : <ul>      
//                               <li>MGMT_STATUS_SUCCESS                                  
//   <li>MGMT_STATUS_TGTTBL_FULL                                  </ul>             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ADD_PERSISTENT_LOGIN_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_AMAP;
typedef struct { u32 dw[359]; } IOCTL_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_AMAP, *PIOCTL_ISCSI_INI_SESSION_ADD_PERSISTENT_LOGIN_AMAP;



typedef struct {
   BE_EXACT8_AMAP target_name[224];
   BE_MGMT_PORTAL_AMAP portal;
   BE_UEXACT32_AMAP isid;
   BE_EXACT8_AMAP initiator_name[224];
} SG_PACK BE_DELETE_PERSISTENT_LOGIN_PARAMS_IN_AMAP;
typedef struct { u32 dw[120]; } DELETE_PERSISTENT_LOGIN_PARAMS_IN_AMAP, *PDELETE_PERSISTENT_LOGIN_PARAMS_IN_AMAP;


//                  This Ioctl is used by management layers to delete a persistent target.
//                 The firmware removes the target from Flash.                  <br>      
//           <b>Originator(s)</b> : Management application, BIOS                 <br>     
//            <b>Implemented in</b>: Firmware                 <br>                
// <b>Return Values</b> : <ul>                                     <li>MGMT_STATUS_SUCCESS
//                                     <li>MGMT_ADDI_STATUS_TARGET_HANDLE_NOT_FOUND       
//                          </ul>              
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DELETE_PERSISTENT_LOGIN_PARAMS_IN_AMAP request;
} SG_PACK BE_IOCTL_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_AMAP;
typedef struct { u32 dw[124]; } IOCTL_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_AMAP, *PIOCTL_ISCSI_INI_SESSION_DELETE_PERSISTENT_LOGIN_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_iscsi_ini_session_amap_h__

