/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lro_amap_h__
#define __ioctl_lro_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- LRO_MODE_ENUM ---
// Enable LRO enum
#define LRO_DISABLE                     (0)       // Disable LRO
#define LRO_ENABLE                      (1)       // Enable LRO

typedef enum {
   ENUM_LRO_DISABLE = 0x0UL,
   ENUM_LRO_ENABLE = 0x1UL
} LRO_MODE_ENUM;

//               IOCTL for creating LRO Rx ring for a given interface.                    
//      <P>             An LRO ring contains [link] WCON_PM_CC [/link] entries (8 bytes
// each). LRO ring must be at most              1024 entries deep (corresponding to 2
// pages). The host driver in allocates double the size             of the ring in UT to
// account for the virtual LRO rings.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP interface_id;
         BE_UEXACT16_AMAP lro_cq_id;
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 5
         BE_PHYS_ADDR_AMAP pages[4];
         BE_UEXACT32_AMAP page_size;
         BE_UEXACT32_AMAP ulp_num;
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LRO_RING_CREATE_AMAP;
typedef struct { u32 dw[16]; } IOCTL_LRO_RING_CREATE_AMAP, *PIOCTL_LRO_RING_CREATE_AMAP;


//               IOCTL for enabling / disabling LRO traffic and configuring LRO parameters
// for a given LRO interface.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP interface_id;
         BE_UEXACT16_AMAP mode;
         BE_LRO_INTERFACE_PARAMS_AMAP lro_params;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LRO_CONFIG_AMAP;
typedef struct { u32 dw[9]; } IOCTL_LRO_CONFIG_AMAP, *PIOCTL_LRO_CONFIG_AMAP;


//           IOCTL for destroying an LRO ring. The LRO traffic must be disabled on the
// interface associated          with the LRO ring prior to destroying the ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LRO_RING_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LRO_RING_DESTROY_AMAP, *PIOCTL_LRO_RING_DESTROY_AMAP;


//          IOCTL for retrieving LRO statistics.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_LRO_GET_STATISTICS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_LRO_GET_STATISTICS_AMAP, *PIOCTL_LRO_GET_STATISTICS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_lro_amap_h__

