/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_mcc_amap_h__
#define __ioctl_mcc_amap_h__
#include "setypes.h"
#include "defines.h"
#include "nativedefs.h"
#include "ioctl_defs.h"
#include "ioctl_opcodes.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//  				Where applicable, a WRB, may contain a list of Scatter-gather elements. Each 
// 				element supports a 64 bit address and a 32bit length field.             
typedef struct {
   BE_BIT pa_lo[32];                              // DWORD 0
   BE_BIT pa_hi[32];                              // DWORD 1
   BE_BIT length[32];                             // DWORD 2
} SG_PACK BE_MCC_SGE_AMAP;
typedef struct { u32 dw[3]; } MCC_SGE_AMAP, *PMCC_SGE_AMAP;


//  				The design of an [link]MCC_SGE[/link] allows up to 19 elements to be embedded
// 				in a WRB, supporting 64KB data transfers (assuming a 4KB page size). 			
typedef union {
   BE_MCC_SGE_AMAP sgl[19];
   BE_BIT embedded[59][32];                       // DWORD 0
} SG_PACK BE_MCC_WRB_PAYLOAD_AMAP;
typedef struct { u32 dw[59]; } MCC_WRB_PAYLOAD_AMAP, *PMCC_WRB_PAYLOAD_AMAP;


//                   This is the structure of the MCC Command WRB for commands            
//     sent to the Management Processing Unit (MPU). See section                 
// [link]IOCTL_TYPES[/link] for usage in embedded and non-embedded modes.             
typedef struct {
   BE_BIT embedded;                               // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT sge_count[5];                           // DWORD 0
   BE_BIT rsvd1[16];                              // DWORD 0
   BE_BIT special[8];                             // DWORD 0
   BE_BIT payload_length[32];                     // DWORD 1
   BE_BIT tag[2][32];                             // DWORD 2
   BE_BIT rsvd2[32];                              // DWORD 4
   BE_MCC_WRB_PAYLOAD_AMAP payload;
} SG_PACK BE_MCC_WRB_AMAP;
typedef struct { u32 dw[64]; } MCC_WRB_AMAP, *PMCC_WRB_AMAP;


//  This is the structure of the MCC Completion queue entry 
typedef struct {
   BE_BIT completion_status[16];                  // DWORD 0
   BE_BIT extended_status[16];                    // DWORD 0
   BE_BIT mcc_tag[2][32];                         // DWORD 1
   BE_BIT rsvd0[27];                              // DWORD 3
   BE_BIT consumed;                               // DWORD 3
   BE_BIT completed;                              // DWORD 3
   BE_BIT rsvd1;                                  // DWORD 3
   BE_BIT async_event;                            // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_MCC_CQ_ENTRY_AMAP;
typedef struct { u32 dw[4]; } MCC_CQ_ENTRY_AMAP, *PMCC_CQ_ENTRY_AMAP;


// Mailbox structures used by the MPU during bootstrap
typedef struct {
   BE_MCC_WRB_AMAP wrb;
   BE_MCC_CQ_ENTRY_AMAP cq;
} SG_PACK BE_MCC_MAILBOX_AMAP;
typedef struct { u32 dw[68]; } MCC_MAILBOX_AMAP, *PMCC_MAILBOX_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_mcc_amap_h__

