/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_rdma_amap_h__
#define __ioctl_rdma_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_hdr.h"
#include "ioctl_types.h"
#include "ioctl_common.h"
#include "fw_exp.h"
#include "rdma_context.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//              IOCTL for registering UT pages which ARM will use for later PE            
//  creation.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_PHYS_ADDR_AMAP pe[26];
      } request;
      struct {
         BE_UEXACT16_AMAP num_pages;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_PE_INIT_AMAP;
typedef struct { u32 dw[57]; } IOCTL_RDMA_PE_INIT_AMAP, *PIOCTL_RDMA_PE_INIT_AMAP;


//              IOCTL for registering UT pages which ARM will use for later storing       
//       TEs.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_PHYS_ADDR_AMAP te[26];
      } request;
      struct {
         BE_UEXACT16_AMAP num_pages;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_TE_INIT_AMAP;
typedef struct { u32 dw[57]; } IOCTL_RDMA_TE_INIT_AMAP, *PIOCTL_RDMA_TE_INIT_AMAP;


//              IOCTL for creating RDMA QPs. This request creates both the RDMA send and
// receive queue.              Need 16 pages with 8 pages each for send and receive
// queues.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP ulp_num;
         BE_UEXACT16_AMAP num_sq_pages;
         BE_UEXACT16_AMAP num_rq_pages;
         BE_PHYS_ADDR_AMAP sq[8];
         BE_PHYS_ADDR_AMAP rq[8];
      } request;
      struct {
         BE_UEXACT16_AMAP cid;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_QP_CREATE_AMAP;
typedef struct { u32 dw[38]; } IOCTL_RDMA_QP_CREATE_AMAP, *PIOCTL_RDMA_QP_CREATE_AMAP;



typedef struct {
   BE_UEXACT16_AMAP cid;
   BE_UEXACT32_AMAP sq_cq_id;
   BE_UEXACT32_AMAP rq_cq_id;
   BE_UEXACT32_AMAP pdid;
   BE_UEXACT32_AMAP state;
   BE_UEXACT32_AMAP qp_sq_size;
   BE_UEXACT32_AMAP qp_rq_size;
   BE_UEXACT32_AMAP ird;
   BE_UEXACT32_AMAP ord;
   BE_UEXACT32_AMAP flags;
} SG_PACK BE_IOCTL_RDMA_QP_QUERY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[10]; } IOCTL_RDMA_QP_QUERY_PARAMS_OUT_AMAP, *PIOCTL_RDMA_QP_QUERY_PARAMS_OUT_AMAP;


//              IOCTL for querying the member status of the QP context data structure on  
//            chip belonging to a particular QP.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP qp_id;
      } request;
      BE_IOCTL_RDMA_QP_QUERY_PARAMS_OUT_AMAP response;
   } params;
} SG_PACK BE_IOCTL_RDMA_QP_QUERY_AMAP;
typedef struct { u32 dw[14]; } IOCTL_RDMA_QP_QUERY_AMAP, *PIOCTL_RDMA_QP_QUERY_AMAP;



typedef struct {
   BE_UEXACT32_AMAP qp_id;
   BE_UEXACT32_AMAP new_state;
   BE_UEXACT32_AMAP qp_sq_size;
   BE_UEXACT32_AMAP qp_rq_size;
   BE_UEXACT32_AMAP ird;
   BE_UEXACT32_AMAP ord;
   BE_UEXACT32_AMAP flags;
} SG_PACK BE_IOCTL_RDMA_QP_MODIFY_PARAMS_IN_AMAP;
typedef struct { u32 dw[7]; } IOCTL_RDMA_QP_MODIFY_PARAMS_IN_AMAP, *PIOCTL_RDMA_QP_MODIFY_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP cid;
} SG_PACK BE_IOCTL_RDMA_QP_MODIFY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_RDMA_QP_MODIFY_PARAMS_OUT_AMAP, *PIOCTL_RDMA_QP_MODIFY_PARAMS_OUT_AMAP;


//              IOCTL for modifying the member content of the QP context data structure on
// chip.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_IOCTL_RDMA_QP_MODIFY_PARAMS_IN_AMAP request;
      BE_IOCTL_RDMA_QP_MODIFY_PARAMS_OUT_AMAP response;
   } params;
} SG_PACK BE_IOCTL_RDMA_QP_MODIFY_AMAP;
typedef struct { u32 dw[11]; } IOCTL_RDMA_QP_MODIFY_AMAP, *PIOCTL_RDMA_QP_MODIFY_AMAP;



typedef struct {
   BE_UEXACT16_AMAP cid;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_MPU_TEMPLATE_HEADER_AMAP header;
   BE_TCP_CONTEXT_AMAP tcp;
   BE_QP_CONTEXT_AMAP qp;
   BE_MPU_OFFLOAD_CXN_ENTRY_AMAP filter;
} SG_PACK BE_IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_AMAP;
typedef struct { u32 dw[93]; } IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_AMAP, *PIOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_AMAP;


//              IOCTL for offloading an RDMA (QP) connection.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_IOCTL_RDMA_CXN_OFFLOAD_PARAMS_IN_AMAP request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_CXN_OFFLOAD_AMAP;
typedef struct { u32 dw[97]; } IOCTL_RDMA_CXN_OFFLOAD_AMAP, *PIOCTL_RDMA_CXN_OFFLOAD_AMAP;


// --- RDMA_CXN_UPLOAD_PARAMS ---
// These parameters are used to define the type of upload desired. 
#define RDMA_CXN_UPLOAD_GRACEFUL        (1)       // Graceful upload 
#define RDMA_CXN_UPLOAD_ABORT_RESET     (2)       // Abortive upload with reset 
#define RDMA_CXN_UPLOAD_ABORT           (3)       // Abortive upload without reset 
#define RDMA_CXN_UPLOAD_ABORT_WITH_SEQ  (4)       // Abortive upload with reset, sequence
                                                  // number by driver 

typedef enum {
   ENUM_RDMA_CXN_UPLOAD_GRACEFUL = 0x1UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT_RESET = 0x2UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT = 0x3UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT_WITH_SEQ = 0x4UL
} RDMA_CXN_UPLOAD_PARAMS;


typedef struct {
   BE_UEXACT16_AMAP cid;
   BE_UEXACT8_AMAP pload_type;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT32_AMAP reset_seq;
} SG_PACK BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_AMAP, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_AMAP;



typedef struct {
   BE_QP_CONTEXT_AMAP qp;
} SG_PACK BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_AMAP;
typedef struct { u32 dw[16]; } IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_AMAP, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_IN_AMAP request;
   BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_AMAP;
typedef struct { u32 dw[16]; } IOCTL_RDMA_CXN_UPLOAD_PARAMS_AMAP, *PIOCTL_RDMA_CXN_UPLOAD_PARAMS_AMAP;


//              This IOCTL uploads a given RDMA (QP) connection. This upload process
// flushes              the QP, disables the offload, and returns the final QP state.     
//    
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_RDMA_CXN_UPLOAD_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_RDMA_CXN_UPLOAD_AMAP;
typedef struct { u32 dw[20]; } IOCTL_RDMA_CXN_UPLOAD_AMAP, *PIOCTL_RDMA_CXN_UPLOAD_AMAP;


//              Updates the content of the QP context corresponding to this connection ID.
//         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP cid;
         BE_UEXACT32_AMAP sq_cq_id;
         BE_UEXACT32_AMAP rq_cq_id;
         BE_UEXACT32_AMAP pdid;
         BE_UEXACT32_AMAP state;
         BE_UEXACT32_AMAP qp_sq_size;
         BE_UEXACT32_AMAP qp_rq_size;
         BE_UEXACT32_AMAP ird;
         BE_UEXACT32_AMAP ord;
         BE_UEXACT32_AMAP flags;
         BE_MPU_TEMPLATE_HEADER_AMAP header;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_CXN_UPDATE_AMAP;
typedef struct { u32 dw[46]; } IOCTL_RDMA_CXN_UPDATE_AMAP, *PIOCTL_RDMA_CXN_UPDATE_AMAP;


//              Allocates Memory registration resources on RNIC.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT8_AMAP pd_id;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_UEXACT16_AMAP flags;
         BE_UEXACT32_AMAP length;
      } request;
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_UEXACT32_AMAP length;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_ALLOC_NSMR_STAG_AMAP;
typedef struct { u32 dw[6]; } IOCTL_RDMA_ALLOC_NSMR_STAG_AMAP, *PIOCTL_RDMA_ALLOC_NSMR_STAG_AMAP;


//              This IOCtl is used to activate a non shared memory region         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[256];                       // DWORD 4
         BE_UEXACT8_AMAP te_offset;
         BE_UEXACT8_AMAP num_tes;
         BE_BIT rsvd1[16];                        // DWORD 12
         BE_PHYS_ADDR_AMAP te[26];
      } request;
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_UEXACT16_AMAP num_pages_alloc;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_NSMR_REGISTER_AMAP;
typedef struct { u32 dw[65]; } IOCTL_RDMA_NSMR_REGISTER_AMAP, *PIOCTL_RDMA_NSMR_REGISTER_AMAP;


//              This IOCtl is used to modify the parameters of existing MR         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[256];                       // DWORD 4
         BE_UEXACT8_AMAP te_offset;
         BE_UEXACT8_AMAP num_tes;
         BE_BIT rsvd1[16];                        // DWORD 12
         BE_PHYS_ADDR_AMAP te[26];
      } request;
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_UEXACT16_AMAP num_pages_alloc;
         BE_BIT rsvd0[16];                        // DWORD 5
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_NSMR_REREGISTER_AMAP;
typedef struct { u32 dw[65]; } IOCTL_RDMA_NSMR_REREGISTER_AMAP, *PIOCTL_RDMA_NSMR_REREGISTER_AMAP;


//              This IOCtl is used to post more TEs for a given MR         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_UEXACT8_AMAP te_offset;
         BE_UEXACT8_AMAP num_tes;
         BE_BIT rsvd0[16];                        // DWORD 5
         BE_PHYS_ADDR_AMAP te[26];
      } request;
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_UEXACT16_AMAP num_pages_alloc;
         BE_BIT rsvd0[16];                        // DWORD 5
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_ADD_TE_AMAP;
typedef struct { u32 dw[58]; } IOCTL_RDMA_ADD_TE_AMAP, *PIOCTL_RDMA_ADD_TE_AMAP;


//              This IOCtl is used to register a Shared MR         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP stag_index;
         BE_BIT rsvd0[256];                       // DWORD 5
      } request;
      struct {
         BE_UEXACT32_AMAP stag_index;
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_SMR_REGISTER_AMAP;
typedef struct { u32 dw[13]; } IOCTL_RDMA_SMR_REGISTER_AMAP, *PIOCTL_RDMA_SMR_REGISTER_AMAP;


//              This IOCtl is used to query a memory region         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP stag_index;
      } request;
      struct {
         BE_BIT rsvd0[256];                       // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_QUERY_MR_AMAP;
typedef struct { u32 dw[12]; } IOCTL_RDMA_QUERY_MR_AMAP, *PIOCTL_RDMA_QUERY_MR_AMAP;


//              This IOCTL deallocates a Stag created through an earlier allocate,
// register,              reregister, register shared memory region, or register memory
// window call.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP stag_key;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_STAG_DEALLOC_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_STAG_DEALLOC_AMAP, *PIOCTL_RDMA_STAG_DEALLOC_AMAP;


//              This IOCTL retrieves information about a specific memory window or memory
// region.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP stag_index;
      } request;
      struct {
         BE_BIT rsvd0[256];                       // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_MW_QUERY_AMAP;
typedef struct { u32 dw[12]; } IOCTL_RDMA_MW_QUERY_AMAP, *PIOCTL_RDMA_MW_QUERY_AMAP;


//              This IOCTL retrieves ipaddresses used for RDMA from ARM for Operating
// systems where              the host ip addresses cannot be used. Blocks of eight ip
// addresses are returned per             call.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP index;
      } request;
      struct {
         BE_UEXACT32_AMAP valid_count;
         BE_UEXACT32_AMAP total_count;
         BE_UEXACT32_AMAP ip_addr[8];
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_IPADDR_QUERY_AMAP;
typedef struct { u32 dw[14]; } IOCTL_RDMA_IPADDR_QUERY_AMAP, *PIOCTL_RDMA_IPADDR_QUERY_AMAP;


//               IOCTL for destroying an RDMA Queue Pair.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP id;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_RDMA_QP_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_RDMA_QP_DESTROY_AMAP, *PIOCTL_RDMA_QP_DESTROY_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_rdma_amap_h__

