/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_initiator_host_struct_amap_h__
#define __iscsi_initiator_host_struct_amap_h__
#include "setypes.h"
#include "defines.h"
#include "iscsi_enums.h"
#include "iscsi_common_host_struct.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// Status CQE for solicited PDU sequence completions in iSCSI Initiator mode.
typedef struct {
   BE_BIT hw_sts[8];                              // DWORD 0
   BE_BIT i_sts[8];                               // DWORD 0
   BE_BIT i_resp[8];                              // DWORD 0
   BE_BIT i_flags[7];                             // DWORD 0
   BE_BIT s;                                      // DWORD 0
   BE_BIT i_exp_cmd_sn[32];                       // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT wrb_index[8];                           // DWORD 2
   BE_BIT i_cmd_wnd[8];                           // DWORD 2
   BE_BIT i_res_cnt[31];                          // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_I_SOL_CQE_AMAP;
typedef struct { u32 dw[4]; } I_SOL_CQE_AMAP, *PI_SOL_CQE_AMAP;


//      [table name="iSCSIWRBInitiator" col="4" delimit=":"       caption="iSCSI Initiator
// WRB flag details."]         iSCSI PDU type : WR : DSP : DMSG :             iSCSI Write
// command with/without Immediate/unsolicited data : 1 : 1 : 0 :     iSCSI Read command: 0
// : 0 : 0 :      Text request without data: 0 : 0 : 0 :     Text request with data: 1 : 1
// : 0 :     Logout request: 0 : 0 : 0 :     NOP OUT with ping data with acknowledgement:
// 1 : 1 : 0 :     NOP OUT without ping data with acknowledgement: 0 : 0 : 0 :     NOP OUT
// without acknowledgement: 0 : 0 : 1 :     NOP OUT in response to NOP IN from iSCSI
// target: 0 : 0 : 1 :     Task Management function request: 0 : 0 : 0 :     [/table]     
//     [flag]     Note: <p>             The logout and task management response will be
// notified to host driver by Rx ULP as part     of default ring processing. It is host
// driver responsibility to wait for response or time     out for these commands to
// cleanup related data structures.     [/flag]     
typedef struct {
   BE_BIT lun[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT wr;                                     // DWORD 0
   BE_BIT wrbindex[8];                            // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT abort;                                  // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT rsvd0[4];                               // DWORD 0
   BE_BIT ptr2NextWrb[8];                         // DWORD 1
   BE_BIT rsvd1[8];                               // DWORD 1
   BE_BIT sgl_icd_Index[12];                      // DWORD 1
   BE_BIT rsvd2[4];                               // DWORD 1
   BE_BIT cmdsn[32];                              // DWORD 2
   BE_BIT abort_sgl_icd_Index[12];                // DWORD 3
   BE_BIT rsvd3[20];                              // DWORD 3
   BE_BIT addr_hi[32];                            // DWORD 4
   BE_BIT addr_lo[32];                            // DWORD 5
   BE_BIT rsvd4[32];                              // DWORD 6
   BE_BIT len[8];                                 // DWORD 7
   BE_BIT ExpDataXfrLen[24];                      // DWORD 7
} SG_PACK BE_ISCSI_INITIATOR_WRB_AMAP;
typedef struct { u32 dw[8]; } ISCSI_INITIATOR_WRB_AMAP, *PISCSI_INITIATOR_WRB_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_initiator_host_struct_amap_h__

