/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __iscsi_target_host_struct_amap_h__
#define __iscsi_target_host_struct_amap_h__
#include "setypes.h"
#include "defines.h"
#include "iscsi_enums.h"
#include "iscsi_common_host_struct.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

typedef struct {
   BE_BIT lun[14];                                // DWORD 0
   BE_BIT lt;                                     // DWORD 0
   BE_BIT invld;                                  // DWORD 0
   BE_BIT wrb_idx[8];                             // DWORD 0
   BE_BIT dsp;                                    // DWORD 0
   BE_BIT dmsg;                                   // DWORD 0
   BE_BIT undr_run;                               // DWORD 0
   BE_BIT over_run;                               // DWORD 0
   BE_BIT type[4];                                // DWORD 0
   BE_BIT ptr2NextWrb[8];                         // DWORD 1
   BE_BIT maxBurstLength[19];                     // DWORD 1
   BE_BIT rsvd0[5];                               // DWORD 1
   BE_BIT rsvd1[15];                              // DWORD 2
   BE_BIT maxSendDataSegmentLength[17];           // DWORD 2
   BE_BIT firstBurstLength[14];                   // DWORD 3
   BE_BIT rsvd2[2];                               // DWORD 3
   BE_BIT tx_wrbindex_drv_msg[8];                 // DWORD 3
   BE_BIT rsvd3[5];                               // DWORD 3
   BE_BIT sessionState[3];                        // DWORD 3
   BE_BIT rsvd4[16];                              // DWORD 4
   BE_BIT tx_jumbo;                               // DWORD 4
   BE_BIT HDE;                                    // DWORD 4
   BE_BIT DDE;                                    // DWORD 4
   BE_BIT ERL[2];                                 // DWORD 4
   BE_BIT domainID[5];                            // DWORD 4
   BE_BIT mode;                                   // DWORD 4
   BE_BIT imd;                                    // DWORD 4
   BE_BIT ir2t;                                   // DWORD 4
   BE_BIT notpredblq[2];                          // DWORD 4
   BE_BIT compltonack;                            // DWORD 4
   BE_BIT stat_sn[32];                            // DWORD 5
   BE_BIT pad_buffer_addr_hi[32];                 // DWORD 6
   BE_BIT pad_buffer_addr_lo[32];                 // DWORD 7
   BE_BIT pad_addr_hi[32];                        // DWORD 8
   BE_BIT pad_addr_lo[32];                        // DWORD 9
   BE_BIT rsvd5[32];                              // DWORD 10
   BE_BIT rsvd6[32];                              // DWORD 11
   BE_BIT rsvd7[32];                              // DWORD 12
   BE_BIT rsvd8[32];                              // DWORD 13
   BE_BIT rsvd9[32];                              // DWORD 14
   BE_BIT rsvd10[32];                             // DWORD 15
} SG_PACK BE_ISCSI_TARGET_CONTEXT_UPDATE_WRB_AMAP;
typedef struct { u32 dw[16]; } ISCSI_TARGET_CONTEXT_UPDATE_WRB_AMAP, *PISCSI_TARGET_CONTEXT_UPDATE_WRB_AMAP;


// iSCSI target solicited data place notify completion queue entry.
typedef struct {
   BE_BIT hw_sts[8];                              // DWORD 0
   BE_BIT rsvd0[24];                              // DWORD 0
   BE_BIT pdu_bytes_rcvd[32];                     // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT rsvd1[16];                              // DWORD 2
   BE_BIT wrb_index[8];                           // DWORD 3
   BE_BIT rsvd2[23];                              // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_T_SOL_CQE_AMAP;
typedef struct { u32 dw[4]; } T_SOL_CQE_AMAP, *PT_SOL_CQE_AMAP;


// iSCSI target solicited data digest error completion queue entry.
typedef struct {
   BE_BIT bufferoffset[32];                       // DWORD 0
   BE_BIT expStatSN[32];                          // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT dataSN[12];                             // DWORD 2
   BE_BIT rsvd0[2];                               // DWORD 2
   BE_BIT FinalBit;                               // DWORD 2
   BE_BIT rsvd1;                                  // DWORD 2
   BE_BIT dataSegmentLength[17];                  // DWORD 3
   BE_BIT rsvd2[2];                               // DWORD 3
   BE_BIT sgl_icd_index[12];                      // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_T_SOL_DATA_DIGEST_CQE_AMAP;
typedef struct { u32 dw[4]; } T_SOL_DATA_DIGEST_CQE_AMAP, *PT_SOL_DATA_DIGEST_CQE_AMAP;


// iSCSI connection invalidation completion queue entry.
typedef struct {
   BE_BIT db_addr_hi[32];                         // DWORD 0
   BE_BIT db_addr_lo[32];                         // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT index[16];                              // DWORD 2
   BE_BIT partial_dsl[17];                        // DWORD 3
   BE_BIT rsvd0[14];                              // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_T_CNXINV_CQE_AMAP;
typedef struct { u32 dw[4]; } T_CNXINV_CQE_AMAP, *PT_CNXINV_CQE_AMAP;


// iSCSI command invalidation completion queue entry.
typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_BIT code[6];                                // DWORD 2
   BE_BIT cid[10];                                // DWORD 2
   BE_BIT rsvd2[16];                              // DWORD 2
   BE_BIT sgl_icd_index[12];                      // DWORD 3
   BE_BIT rsvd3[19];                              // DWORD 3
   BE_BIT valid;                                  // DWORD 3
} SG_PACK BE_T_CMNDINV_CQE_AMAP;
typedef struct { u32 dw[4]; } T_CMNDINV_CQE_AMAP, *PT_CMNDINV_CQE_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __iscsi_target_host_struct_amap_h__

