/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_amap_h__
#define __mpu_amap_h__
#include "setypes.h"
#include "pq.h"
#include "ep.h"
#include "defines.h"
#include "btlr.h"
#include "ep_minirom.h"
#include "gencommon.h"
#include "hwdbg_reg.h"
#include "armsys.h"
#include "armddr.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//          Provides an interface to the ARM System Registers. Writing to         this
// triggers a CSR access. If a write to an ARM System Register         is intended, be
// sure to write          [link]MPUARM_SYSREG_DATA[/link] first.         If a read is
// intended, [link]MPUARM_SYSREG_DATA[/link] contains          valid data once <I>busy</I>
// deasserts. The ARM System Register          map is described in the [link
// target="MPU_ARMSYS_REGS"]Management          Processor Unit ARM System Registers[/link]
// section.         
typedef struct {
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT addr[10];                               // DWORD 0
   BE_BIT sel;                                    // DWORD 0
   BE_BIT rsvd1[3];                               // DWORD 0
   BE_BIT byte_en[4];                             // DWORD 0
   BE_BIT rsvd2[4];                               // DWORD 0
   BE_BIT rsvd3[6];                               // DWORD 0
   BE_BIT write;                                  // DWORD 0
   BE_BIT busy;                                   // DWORD 0
} SG_PACK BE_MPUARM_SYSREG_CTRL_AMAP;
typedef struct { u32 dw[1]; } MPUARM_SYSREG_CTRL_AMAP, *PMPUARM_SYSREG_CTRL_AMAP;


// Allows for interface to ARM System Regs in ARM.  Writing to this triggers a CSR access.
typedef struct {
   BE_BIT data[32];                               // DWORD 0
} SG_PACK BE_MPUARM_SYSREG_DATA_AMAP;
typedef struct { u32 dw[1]; } MPUARM_SYSREG_DATA_AMAP, *PMPUARM_SYSREG_DATA_AMAP;


// General Control and Status Register.
typedef struct {
   BE_BIT m0_RxPbuf;                              // DWORD 0
   BE_BIT m1_RxPbuf;                              // DWORD 0
   BE_BIT m2_RxPbuf;                              // DWORD 0
   BE_BIT rsvd0[12];                              // DWORD 0
   BE_BIT rsvd1;                                  // DWORD 0
   BE_BIT rsvd2[15];                              // DWORD 0
   BE_BIT CPU_reset;                              // DWORD 0
} SG_PACK BE_EP_MPU_CONTROL_CSR_AMAP;
typedef struct { u32 dw[1]; } EP_MPU_CONTROL_CSR_AMAP, *PEP_MPU_CONTROL_CSR_AMAP;


// Embedded Processor Specific Registers.
typedef struct {
   BE_EP_MPU_CONTROL_CSR_AMAP ep_control;
   BE_BIT rsvd0[128];                             // DWORD 1
   BE_BIT rsvd1[32];                              // DWORD 5
   BE_BIT rsvd2[8][128];                          // DWORD 6
   BE_BIT rsvd3[32];                              // DWORD 38
   BE_BIT rsvd4[32];                              // DWORD 39
   BE_BIT rsvd5[32];                              // DWORD 40
   BE_BIT rsvd6[32];                              // DWORD 41
   BE_BIT rsvd7[32];                              // DWORD 42
   BE_EP_SEMAPHORE_CSR_AMAP ep_semaphore;
   BE_BIT rsvd8[32];                              // DWORD 44
   BE_BIT rsvd9[32];                              // DWORD 45
   BE_BIT rsvd10[32];                             // DWORD 46
   BE_BIT rsvd11[17][32];                         // DWORD 47
} SG_PACK BE_EP_MPU_CSRMAP_AMAP;
typedef struct { u32 dw[64]; } EP_MPU_CSRMAP_AMAP, *PEP_MPU_CSRMAP_AMAP;


// Provide control parameters for the Managment Processor Unit.
typedef struct {
   BE_EP_MPU_CSRMAP_AMAP ep;
   BE_BIT rsvd0[128];                             // DWORD 64
   BE_BIT rsvd1[32];                              // DWORD 68
   BE_BIT rsvd2[192];                             // DWORD 69
   BE_BIT rsvd3[32];                              // DWORD 75
   BE_BIT rsvd4[32];                              // DWORD 76
   BE_BIT rsvd5[32];                              // DWORD 77
   BE_BIT rsvd6[32];                              // DWORD 78
   BE_BIT rsvd7[32];                              // DWORD 79
   BE_BIT rsvd8[32];                              // DWORD 80
   BE_BIT rsvd9[32];                              // DWORD 81
   BE_BIT rsvd10[32];                             // DWORD 82
   BE_BIT rsvd11[32];                             // DWORD 83
   BE_BIT rsvd12[32];                             // DWORD 84
   BE_BIT rsvd13[32];                             // DWORD 85
   BE_BIT rsvd14[32];                             // DWORD 86
   BE_BIT rsvd15[32];                             // DWORD 87
   BE_BIT rsvd16[32];                             // DWORD 88
   BE_BIT rsvd17[32];                             // DWORD 89
   BE_BIT rsvd18[32];                             // DWORD 90
   BE_BIT rsvd19[32];                             // DWORD 91
   BE_BIT rsvd20[32];                             // DWORD 92
   BE_BIT rsvd21[32];                             // DWORD 93
   BE_BIT rsvd22[96];                             // DWORD 94
   BE_BIT rsvd23[32];                             // DWORD 97
   BE_BIT rsvd24[32];                             // DWORD 98
   BE_BIT rsvd25[32];                             // DWORD 99
   BE_BIT rsvd26[96];                             // DWORD 100
   BE_BIT rsvd27[32];                             // DWORD 103
   BE_BIT rsvd28[32];                             // DWORD 104
   BE_BIT rsvd29[32];                             // DWORD 105
   BE_BIT rsvd30[32];                             // DWORD 106
   BE_BIT rsvd31[32];                             // DWORD 107
   BE_MPUARM_SYSREG_CTRL_AMAP arm_sysreg_ctrl;
   BE_MPUARM_SYSREG_DATA_AMAP arm_sysreg_data;
   BE_BIT rsvd32[32];                             // DWORD 110
   BE_BIT rsvd33[32];                             // DWORD 111
   BE_BIT rsvd34[32];                             // DWORD 112
   BE_BIT rsvd35[32];                             // DWORD 113
   BE_BIT rsvd36[32];                             // DWORD 114
   BE_BIT rsvd37[32];                             // DWORD 115
   BE_BIT rsvd38[32];                             // DWORD 116
   BE_BIT rsvd39[32];                             // DWORD 117
   BE_BIT rsvd40[32];                             // DWORD 118
   BE_BIT rsvd41[137][32];                        // DWORD 119
} SG_PACK BE_MPU_CSRMAP_AMAP;
typedef struct { u32 dw[256]; } MPU_CSRMAP_AMAP, *PMPU_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_amap_h__

