/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_context_amap_h__
#define __mpu_context_amap_h__
#include "setypes.h"
#include "defines.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- MCC_RING_CONTEXT_SIZE_ENUM ---
#define MCC_RING_CONTEXT_SIZE_16        (5)       // 16 entries
#define MCC_RING_CONTEXT_SIZE_32        (6)       // 32 entries
#define MCC_RING_CONTEXT_SIZE_64        (7)       // 64 entries
#define MCC_RING_CONTEXT_SIZE_128       (8)       // 128 entries

typedef enum {
   ENUM_MCC_RING_CONTEXT_SIZE_16 = 0x5UL,
   ENUM_MCC_RING_CONTEXT_SIZE_32 = 0x6UL,
   ENUM_MCC_RING_CONTEXT_SIZE_64 = 0x7UL,
   ENUM_MCC_RING_CONTEXT_SIZE_128 = 0x8UL
} MCC_RING_CONTEXT_SIZE_ENUM;

//  Management command and control ring context. 
typedef struct {
   BE_BIT con_index[14];                          // DWORD 0
   BE_BIT rsvd0[2];                               // DWORD 0
   BE_BIT ring_size[4];                           // DWORD 0
   BE_BIT fetch_wrb;                              // DWORD 0
   BE_BIT fetch_r2t;                              // DWORD 0
   BE_BIT cq_id[10];                              // DWORD 0
   BE_BIT prod_index[14];                         // DWORD 1
   BE_BIT fid[8];                                 // DWORD 1
   BE_BIT pdid[9];                                // DWORD 1
   BE_BIT valid;                                  // DWORD 1
   BE_BIT async_cq_valid;                         // DWORD 2
   BE_BIT async_cq_id[10];                        // DWORD 2
   BE_BIT rsvd1[21];                              // DWORD 2
   BE_BIT rsvd2[32];                              // DWORD 3
} SG_PACK BE_MCC_RING_CONTEXT_AMAP;
typedef struct { u32 dw[4]; } MCC_RING_CONTEXT_AMAP, *PMCC_RING_CONTEXT_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_context_amap_h__

