/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __qpge_stat_amap_h__
#define __qpge_stat_amap_h__
#include "setypes.h"
#include "nativedefs.h"
#include "ioctl_eth.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
//  This structure defines the format of the QPGE Eth statistics packet          
typedef struct {
   BE_u32_AMAP bytes_rcvd_lsd;
   BE_u32_AMAP bytes_rcvd_msd;
   BE_u32_AMAP rx_unknown_cntrl_frame_count;
   BE_u32_AMAP rx_pause_frame_count;
   BE_u32_AMAP rx_cntrl_frame_count;
   BE_u32_AMAP rx_frame_length_err_count;
   BE_u32_AMAP rx_frame_dropped_count;
   BE_u32_AMAP rx_frame_crc_err_count;
   BE_u32_AMAP rx_multicast_frame_count;
   BE_u32_AMAP rx_broadcast_frame_count;
   BE_u32_AMAP rx_small_frame_err_count;
   BE_u32_AMAP rx_alignment_err_count;
   BE_u32_AMAP rx_packets_rcvd;
   BE_u32_AMAP rx_rsvd0;
   BE_u32_AMAP bytes_txmit_lsd;
   BE_u32_AMAP bytes_txmit_msd;
   BE_u32_AMAP packets_transmitted;
   BE_u32_AMAP tx_multicast_frame_count;
   BE_u32_AMAP tx_broadcast_frame_count;
   BE_u32_AMAP tx_pause_frame_count;
   BE_u32_AMAP tx_cntrl_frame_count;
   BE_u32_AMAP tx_jumbo_frame_count;
} SG_PACK BE_BE_QPGE_PORT_STAT_AMAP;
typedef struct { u32 dw[22]; } BE_QPGE_PORT_STAT_AMAP, *PBE_QPGE_PORT_STAT_AMAP;


//  This structure defines the format of the QPGE Eth statistics packet          
typedef struct {
   BE_u64_AMAP stat_hdr_0;
   BE_u64_AMAP stat_hdr_1;
   BE_u64_AMAP stat_hdr_2;
   BE_u64_AMAP stat_hdr_3;
   BE_u64_AMAP stat_hdr_4;
   BE_u64_AMAP stat_hdr_5;
   BE_u64_AMAP stat_hdr_6;
   BE_u64_AMAP stat_hdr_7;
   BE_u64_AMAP stat_hdr_8;
   BE_u64_AMAP stat_hdr_rsvd0;
   BE_u64_AMAP stat_hdr_rsvd1;
   BE_BE_QPGE_PORT_STAT_AMAP port[4];
} SG_PACK BE_BE_QPGE_STAT_AMAP;
typedef struct { u32 dw[110]; } BE_QPGE_STAT_AMAP, *PBE_QPGE_STAT_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_MIB_ETH_STATISTICS_QPGE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } MIB_ETH_STATISTICS_QPGE_PARAMS_IN_AMAP, *PMIB_ETH_STATISTICS_QPGE_PARAMS_IN_AMAP;



typedef struct {
   BE_BE_QPGE_STAT_AMAP qpge_stat;
   BE_BE2_TXP_SW_COUNTERS_AMAP txp;
   BE_BE2_ERX_STATS_AMAP erx;
   BE_BE2_PMEM_STATS_AMAP pmem;
} SG_PACK BE_BE2_QPGE_HARDWARE_STATS_AMAP;
typedef struct { u32 dw[212]; } BE2_QPGE_HARDWARE_STATS_AMAP, *PBE2_QPGE_HARDWARE_STATS_AMAP;



typedef union {
   BE_MIB_ETH_STATISTICS_QPGE_PARAMS_IN_AMAP request;
   BE_BE2_QPGE_HARDWARE_STATS_AMAP response;
} SG_PACK BE_MIB_ETH_STATISTICS_QPGE_PARAMS_AMAP;
typedef struct { u32 dw[212]; } MIB_ETH_STATISTICS_QPGE_PARAMS_AMAP, *PMIB_ETH_STATISTICS_QPGE_PARAMS_AMAP;


//  Query ethernet statistics. All domains may issue this IOCTL.         The host domain
// drivers may optionally reset internal statistic counters          with a query.        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MIB_ETH_STATISTICS_QPGE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_ETH_GET_QPGE_STATISTICS_AMAP;
typedef struct { u32 dw[216]; } IOCTL_ETH_GET_QPGE_STATISTICS_AMAP, *PIOCTL_ETH_GET_QPGE_STATISTICS_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __qpge_stat_amap_h__

