/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpost_amap_h__
#define __tpost_amap_h__
#include "setypes.h"
#include "ep.h"
#include "jellm.h"
#include "ep_minirom.h"
#include "hwdbg_reg.h"
#include "gencommon.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// Port 0 Low Latency Transmit Data Register RangeThis register range is used by the
// driver to write the appropriate data structure set in the formof a TXD, followed by WRB
// sets, in order to generate a transmit packet. The 1st write to thisregister, to
// generate a transmit packet, will have: 1.) Number of writes to this register that will
// be generated to define the entire data     structure set (including this 1st write).
// This value needs to be written to     bits [9:0] and should be an even value. 2.) EP
// input queue select. This value needs to be written to bit 16.     (0 = normal queue, 1
// = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This value needs to
// be written to     bits [25:24].NOTE: the driver is responsible for not overflowing the
// h/w buffer which is 1024d deep
typedef struct {
   BE_BIT low_lat_dat_reg_p0[32];                 // DWORD 0
} SG_PACK BE_TPOST_LL_DATA_PORT0_CR_RANGE_AMAP;
typedef struct { u32 dw[1]; } TPOST_LL_DATA_PORT0_CR_RANGE_AMAP, *PTPOST_LL_DATA_PORT0_CR_RANGE_AMAP;


// Port 1 Low Latency Transmit Data Register RangeThis register range is used by the
// driver to write the appropriate data structure set in the formof a TXD, followed by WRB
// sets, in order to generate a transmit packet. The 1st write to thisregister, to
// generate a transmit packet, will have: 1.) Number of writes to this register that will
// be generated to define the entire data     structure set (including this 1st write).
// This value needs to be written to     bits [9:0] and should be an even value. 2.) EP
// input queue select. This value needs to be written to bit 16.     (0 = normal queue, 1
// = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This value needs to
// be written to     bits [25:24].NOTE: the driver is responsible for not overflowing the
// h/w buffer which is 1024d deep
typedef struct {
   BE_BIT low_lat_dat_reg_p1[32];                 // DWORD 0
} SG_PACK BE_TPOST_LL_DATA_PORT1_CR_RANGE_AMAP;
typedef struct { u32 dw[1]; } TPOST_LL_DATA_PORT1_CR_RANGE_AMAP, *PTPOST_LL_DATA_PORT1_CR_RANGE_AMAP;


//  TCP Post Processor control and status registers. 
typedef struct {
   BE_BIT rsvd0[2048];                            // DWORD 0
   BE_BIT rsvd1[128];                             // DWORD 64
   BE_BIT rsvd2[32];                              // DWORD 68
   BE_BIT rsvd3[32];                              // DWORD 69
   BE_BIT rsvd4[32];                              // DWORD 70
   BE_BIT rsvd5[32];                              // DWORD 71
   BE_BIT rsvd6[32];                              // DWORD 72
   BE_BIT rsvd7[384];                             // DWORD 73
   BE_BIT rsvd8[32];                              // DWORD 85
   BE_BIT rsvd9[32];                              // DWORD 86
   BE_BIT rsvd10[32];                             // DWORD 87
   BE_BIT rsvd11[32];                             // DWORD 88
   BE_BIT rsvd12[32];                             // DWORD 89
   BE_BIT rsvd13[32];                             // DWORD 90
   BE_BIT rsvd14[32];                             // DWORD 91
   BE_BIT rsvd15[32];                             // DWORD 92
   BE_BIT rsvd16[32];                             // DWORD 93
   BE_BIT rsvd17[32];                             // DWORD 94
   BE_BIT rsvd18[32];                             // DWORD 95
   BE_BIT rsvd19[32];                             // DWORD 96
   BE_BIT rsvd20[32];                             // DWORD 97
   BE_BIT rsvd21[32];                             // DWORD 98
   BE_BIT rsvd22[32];                             // DWORD 99
   BE_BIT rsvd23[32];                             // DWORD 100
   BE_BIT rsvd24[32];                             // DWORD 101
   BE_BIT rsvd25[96];                             // DWORD 102
   BE_BIT rsvd26[32];                             // DWORD 105
   BE_BIT rsvd27[32];                             // DWORD 106
   BE_BIT rsvd28[32];                             // DWORD 107
   BE_BIT rsvd29[32];                             // DWORD 108
   BE_BIT rsvd30[32];                             // DWORD 109
   BE_BIT rsvd31[32];                             // DWORD 110
   BE_BIT rsvd32[32];                             // DWORD 111
   BE_BIT rsvd33[32];                             // DWORD 112
   BE_BIT rsvd34[32];                             // DWORD 113
   BE_BIT rsvd35[32];                             // DWORD 114
   BE_BIT rsvd36[32];                             // DWORD 115
   BE_BIT rsvd37[384];                            // DWORD 116
   BE_TPOST_LL_DATA_PORT0_CR_RANGE_AMAP portA[64];
   BE_TPOST_LL_DATA_PORT1_CR_RANGE_AMAP portB[64];
} SG_PACK BE_TPOST_CSRMAP_AMAP;
typedef struct { u32 dw[256]; } TPOST_CSRMAP_AMAP, *PTPOST_CSRMAP_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpost_amap_h__

