/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __cev_enum_h__
#define __cev_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "pq_enum.h"
#include "ep_enum.h"
#include "txulp_enum.h"
#include "reg_enums_enum.h"
#include "gencommon_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- CQ_CNT_ENUM ---
// Completion Queue Count Encodings.
#define CEV_CQ_CNT_256                  (0)       // CQ has 256 entries
#define CEV_CQ_CNT_512                  (1)       // CQ has 512 entries
#define CEV_CQ_CNT_1024                 (2)       // CQ has 1024 entries

typedef enum {
   ENUM_CEV_CQ_CNT_256 = 0x0UL,
   ENUM_CEV_CQ_CNT_512 = 0x1UL,
   ENUM_CEV_CQ_CNT_1024 = 0x2UL
} CQ_CNT_ENUM;

// --- EQ_CNT_ENUM ---
// Event Queue Count Encodings.
#define CEV_EQ_CNT_256                  (0)       // EQ has 256 entries (16-byte EQEs
                                                  // only)
#define CEV_EQ_CNT_512                  (1)       // EQ has 512 entries (16-byte EQEs
                                                  // only)
#define CEV_EQ_CNT_1024                 (2)       // EQ has 1024 entries (4-byte or
                                                  // 16-byte EQEs only)
#define CEV_EQ_CNT_2048                 (3)       // EQ has 2048 entries (4-byte or
                                                  // 16-byte EQEs only)
#define CEV_EQ_CNT_4096                 (4)       // EQ has 4096 entries (4-byte EQEs
                                                  // only)

typedef enum {
   ENUM_CEV_EQ_CNT_256 = 0x0UL,
   ENUM_CEV_EQ_CNT_512 = 0x1UL,
   ENUM_CEV_EQ_CNT_1024 = 0x2UL,
   ENUM_CEV_EQ_CNT_2048 = 0x3UL,
   ENUM_CEV_EQ_CNT_4096 = 0x4UL
} EQ_CNT_ENUM;

// --- EQ_SIZE_ENUM ---
// Event Queue Entry Size Encoding.
#define CEV_EQ_SIZE_4                   (0)       // EQE is 4 bytes
#define CEV_EQ_SIZE_16                  (1)       // EQE is 16 bytes

typedef enum {
   ENUM_CEV_EQ_SIZE_4 = 0x0UL,
   ENUM_CEV_EQ_SIZE_16 = 0x1UL
} EQ_SIZE_ENUM;

// --- CQE_COALESC_WM_ENUM ---
// CQE Coalescing Threshold/Watermark Encoding.Note: 0 value set the CQ for non-coalescing
#define CEV_CQE_COALESC_WM_0            (0)       // No CQE Coalescing.
#define CEV_CQE_COALESC_WM_1            (1)       // CQE coalesicng Watermark is given by
                                                  // bit field COALESC_WM1 ( bits [15:8] )
                                                  // of CEV_CSR_COALESCWM_CFG register.
#define CEV_CQE_COALESC_WM_2            (2)       // CQE coalescing Watermark is given by
                                                  // bit field COALESC_WM2 (bits [23:16] )
                                                  // of CEV_CSR_COALESCWM_CFG register.
#define CEV_CQE_COALESC_WM_3            (3)       // CQE coalescing Watermark is given by
                                                  // bit field COALESC_WM3 (bits [24:31] )
                                                  // of CEV_CSR_COALESCWM_CFG register.

typedef enum {
   ENUM_CEV_CQE_COALESC_WM_0 = 0x0UL,
   ENUM_CEV_CQE_COALESC_WM_1 = 0x1UL,
   ENUM_CEV_CQE_COALESC_WM_2 = 0x2UL,
   ENUM_CEV_CQE_COALESC_WM_3 = 0x3UL
} CQE_COALESC_WM_ENUM;

// --- CEV_CLIENTS_ENUM ---
// List of CEV clients. Used by hardware only, to index CEV client PQs
#define CEV_CL_RXULP0                   (0)       
#define CEV_CL_RXULP1                   (1)       
#define CEV_CL_RXULP2                   (2)       
#define CEV_CL_ERX                      (3)       
#define CEV_CL_TXP                      (4)       
#define CEV_CL_MPU                      (5)       

typedef enum {
   ENUM_CEV_CL_RXULP0 = 0x0UL,
   ENUM_CEV_CL_RXULP1 = 0x1UL,
   ENUM_CEV_CL_RXULP2 = 0x2UL,
   ENUM_CEV_CL_ERX = 0x3UL,
   ENUM_CEV_CL_TXP = 0x4UL,
   ENUM_CEV_CL_MPU = 0x5UL
} CEV_CLIENTS_ENUM;

// --- CEV_BTLR_ACC_SM_ENUM ---
// Encodings for BTLR (doorbell checker) Access State Machine
#define CEV_SM_BTLR_IDLE                (0)       // Idle State
#define CEV_SM_BTLR_GNT                 (1)       // Acknowledge BTLR context read request
#define CEV_SM_BTLR_RD                  (2)       // BTLR context memory read access
#define CEV_SM_BTLR_LATCH               (3)       // Latch context memory data
#define CEV_SM_BTLR_PRESENT             (4)       // Present 16-byte data to BTLR

typedef enum {
   ENUM_CEV_SM_BTLR_IDLE = 0x0UL,
   ENUM_CEV_SM_BTLR_GNT = 0x1UL,
   ENUM_CEV_SM_BTLR_RD = 0x2UL,
   ENUM_CEV_SM_BTLR_LATCH = 0x3UL,
   ENUM_CEV_SM_BTLR_PRESENT = 0x4UL
} CEV_BTLR_ACC_SM_ENUM;

#endif // __cev_enum_h__

