/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __descriptors_enum_h__
#define __descriptors_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "headers_enum.h"
#include "uc_enum.h"
#include "mpu_local_mmr_enum.h"
#include "reg_enums_enum.h"
#include "eeprom_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- DMA_PQ_ERROR_CODES ---
#define DMA_PQ_STATUS_OK                (0)       
#define DMA_PQ_ERROR                    (1)       
#define DMA_PQ_TX_CRC_ERROR             (2)       

typedef enum {
   ENUM_DMA_PQ_STATUS_OK = 0x0UL,
   ENUM_DMA_PQ_ERROR = 0x1UL,
   ENUM_DMA_PQ_TX_CRC_ERROR = 0x2UL
} DMA_PQ_ERROR_CODES;

// --- DMA_HOST_ADDR_LIST_LOCATION_ENUM ---
#define DMA_HOST_LIST_LOCATION_CTX      (0)       // Fragment list is in CTX.
#define DMA_HOST_LIST_LOCATION_ERX      (1)       // Fragment list is in ERX.
#define DMA_HOST_LIST_LOCATION_TXPB     (2)       // Fragment list is in TxPB.
#define DMA_HOST_LIST_LOCATION_DDR      (3)       // Fragment list in in DDR.

typedef enum {
   ENUM_DMA_HOST_LIST_LOCATION_CTX = 0x0UL,
   ENUM_DMA_HOST_LIST_LOCATION_ERX = 0x1UL,
   ENUM_DMA_HOST_LIST_LOCATION_TXPB = 0x2UL,
   ENUM_DMA_HOST_LIST_LOCATION_DDR = 0x3UL
} DMA_HOST_ADDR_LIST_LOCATION_ENUM;

// --- DMA_SWAP_ENUM ---
// 64 bit definition b7 = [63:56].. b0[7:0]
#define DMA_SWAP_NONE                   (0)       // Byte lanes
                                                  // b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11
                                                  // ,b12,b13,b14,b15becomes ----->
                                                  // b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11
                                                  // ,b12,b13,b14,b15 on host interface
#define DMA_SWAP_BYTE                   (1)       // Byte lanes
                                                  // b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11
                                                  // ,b12,b13,b14,b15becomes ----->
                                                  // b3,b2,b1,b0,b7,b6,b5,b4,b11,b10,b9,b8
                                                  // ,b15,b14,b13,b12 on host interface
#define DMA_SWAP_WORD                   (2)       // Byte lanes
                                                  // b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11
                                                  // ,b12,b13,b14,b15becomes ----->
                                                  // b4,b5,b6,b7,b0,b1,b2,b3,b12,b13,b14,b
                                                  // 15,b8,b9,b10,b11 on host interface
#define DMA_SWAP_WORD_BYTE              (3)       // Byte lanes
                                                  // b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,b11
                                                  // ,b12,b13,b14,b15becomes ----->
                                                  // b15,b14,b13,b12,b11,b10,b9,b8,b7,b6,b
                                                  // 5,b4,b3,b2,b1,b0 on host interface

typedef enum {
   ENUM_DMA_SWAP_NONE = 0x0UL,
   ENUM_DMA_SWAP_BYTE = 0x1UL,
   ENUM_DMA_SWAP_WORD = 0x2UL,
   ENUM_DMA_SWAP_WORD_BYTE = 0x3UL
} DMA_SWAP_ENUM;

// --- DMA_CPLVEC_ENUM ---
// Egress return field location. 
#define DMA_CPLVEC_RET0                 (0)       // Selects cpl_ret0 
#define DMA_CPLVEC_RET1                 (1)       // Selects cpl_ret1 
#define DMA_CPLVEC_RET2                 (2)       // Selects cpl_ret2 
#define DMA_CPLVEC_RET3                 (3)       // Selects cpl_ret3 
#define DMA_CPLVEC_DBUF                 (4)       // Selects DBUF ID 

typedef enum {
   ENUM_DMA_CPLVEC_RET0 = 0x0UL,
   ENUM_DMA_CPLVEC_RET1 = 0x1UL,
   ENUM_DMA_CPLVEC_RET2 = 0x2UL,
   ENUM_DMA_CPLVEC_RET3 = 0x3UL,
   ENUM_DMA_CPLVEC_DBUF = 0x4UL
} DMA_CPLVEC_ENUM;

// --- DMA_DATA_SRC_ENUM ---
// Source data locations for DMA transfer
#define DMA_DSRC_CTX                    (0)       
#define DMA_DSRC_PMEM                   (1)       
#define DMA_DSRC_TXPB                   (2)       
#define DMA_DSRC_DDR                    (3)       

typedef enum {
   ENUM_DMA_DSRC_CTX = 0x0UL,
   ENUM_DMA_DSRC_PMEM = 0x1UL,
   ENUM_DMA_DSRC_TXPB = 0x2UL,
   ENUM_DMA_DSRC_DDR = 0x3UL
} DMA_DATA_SRC_ENUM;

// --- DMA_ATS_ENUM ---
// Encodings to distinguish PCI-ATS transactions (if enabled).
#define DMA_ATS_MEM_UNTRANS             (0)       // Host memory access, with untranslated
                                                  // address (from ATS perspective).
#define DMA_ATS_MEM_TRANS               (1)       // Host memory access, with translated
                                                  // address (from ATS perspective).
#define DMA_ATS_REQ                     (2)       // Address Translation Request (to
                                                  // host-based IOMMU).

typedef enum {
   ENUM_DMA_ATS_MEM_UNTRANS = 0x0UL,
   ENUM_DMA_ATS_MEM_TRANS = 0x1UL,
   ENUM_DMA_ATS_REQ = 0x2UL
} DMA_ATS_ENUM;

// --- DMA_DQID_ENUM ---
// DMA response (completion) destination encodings
#define DMA_ENQ_O_RXULP0                (0)       // To RxULP0
#define DMA_ENQ_O_RXULP1                (1)       // To RxULP1
#define DMA_ENQ_O_RXULP2                (2)       // To RxULP2
#define DMA_ENQ_O_ERX                   (3)       // To ERX
#define DMA_ENQ_O_UC                    (4)       // To UC
#define DMA_ENQ_O_CEV                   (5)       // To CEV
#define DMA_ENQ_O_TXP                   (8)       // To TXP
#define DMA_ENQ_O_TXPOST                (11)      // To TPost
#define DMA_ENQ_O_MPU                   (12)      // To MPU
#define DMA_ENQ_O_PTC                   (13)      // To PTC
#define DMA_ENQ_O_NO_RESPONSE           (15)      // No response generated

typedef enum {
   ENUM_DMA_ENQ_O_RXULP0 = 0x0UL,
   ENUM_DMA_ENQ_O_RXULP1 = 0x1UL,
   ENUM_DMA_ENQ_O_RXULP2 = 0x2UL,
   ENUM_DMA_ENQ_O_ERX = 0x3UL,
   ENUM_DMA_ENQ_O_UC = 0x4UL,
   ENUM_DMA_ENQ_O_CEV = 0x5UL,
   ENUM_DMA_ENQ_O_TXP = 0x8UL,
   ENUM_DMA_ENQ_O_TXPOST = 0xbUL,
   ENUM_DMA_ENQ_O_MPU = 0xcUL,
   ENUM_DMA_ENQ_O_PTC = 0xdUL,
   ENUM_DMA_ENQ_O_NO_RESPONSE = 0xfUL
} DMA_DQID_ENUM;

// --- DMA_ZEROBPOL_ENUM ---
// DMA controller zero-byte execution policy
#define DMA0EXEC_INT                    (0)       // Zero-byte transaction is executed
                                                  // within DMA (no PCI activity); DMA
                                                  // response may not return in order.
#define DMA0EXEC_PCI                    (1)       // A Zero-byte PCI transaction is
                                                  // executed, using CSR-provided address;
                                                  // DMA response returns in order.

typedef enum {
   ENUM_DMA0EXEC_INT = 0x0UL,
   ENUM_DMA0EXEC_PCI = 0x1UL
} DMA_ZEROBPOL_ENUM;

// --- DMA_MEMSEL_ENUM ---
// DMA controller Memory Selection
#define DMA_SEL_DDR                     (0)       // Select DDR memory as DMA source
                                                  // (NDMA, RDMA) or destination (WDMA).
#define DMA_SEL_HOST                    (1)       // Select Host memory as DMA source
                                                  // (NDMA, RDMA) or destination (WDMA).

typedef enum {
   ENUM_DMA_SEL_DDR = 0x0UL,
   ENUM_DMA_SEL_HOST = 0x1UL
} DMA_MEMSEL_ENUM;

// --- DMA_DESCTYPES_ENUM ---
// DMA descriptor types
#define DDESC_SINGL_ADDR                (0)       // Single Host/DDR address (no
                                                  // scatter/gather).
#define DDESC_SG_FRAGS                  (1)       // Scatter/gather to/from fragments in
                                                  // Host/DDR memory.
#define DDESC_IMM                       (2)       // Immediate data (up to 16B) in
                                                  // descriptor itself
#define DDESC_SG_IMM                    (3)       // Immediate data (up to 4 x 16B)
                                                  // distributed as Immediate data in
                                                  // other DBUFs

typedef enum {
   ENUM_DDESC_SINGL_ADDR = 0x0UL,
   ENUM_DDESC_SG_FRAGS = 0x1UL,
   ENUM_DDESC_IMM = 0x2UL,
   ENUM_DDESC_SG_IMM = 0x3UL
} DMA_DESCTYPES_ENUM;

// --- DMA_MRKLEN_ENUM ---
// DMA Marker Sizes (bytes)
#define DMA_MRKSIZE_2                   (0)       // Marker is two bytes.
#define DMA_MRKSIZE_4                   (1)       // Marker is four bytes.
#define DMA_MRKSIZE_8                   (2)       // Marker is eight bytes.
#define DMA_MRKSIZE_16                  (3)       // Marker is 16 bytes. If Markers are
                                                  // present in source data, the source
                                                  // data must contain 0 or more WHOLE
                                                  // (16B) Markers.

typedef enum {
   ENUM_DMA_MRKSIZE_2 = 0x0UL,
   ENUM_DMA_MRKSIZE_4 = 0x1UL,
   ENUM_DMA_MRKSIZE_8 = 0x2UL,
   ENUM_DMA_MRKSIZE_16 = 0x3UL
} DMA_MRKLEN_ENUM;

// --- DMA_MRKSTRIDE_ENUM ---
// DMA Marker Strides (distance between markers)
#define DMA_MRKSTRIDE_512               (0)       // 512 data bytes between markers.
#define DMA_MRKSTRIDE_1024              (1)       // 1024 data bytes between markers.
#define DMA_MRKSTRIDE_2048              (2)       // 2048 data bytes between markers.
#define DMA_MRKSTRIDE_4096              (3)       // 4096 data bytes between markers.

typedef enum {
   ENUM_DMA_MRKSTRIDE_512 = 0x0UL,
   ENUM_DMA_MRKSTRIDE_1024 = 0x1UL,
   ENUM_DMA_MRKSTRIDE_2048 = 0x2UL,
   ENUM_DMA_MRKSTRIDE_4096 = 0x3UL
} DMA_MRKSTRIDE_ENUM;

// --- DMA_LIST_TYPE_ENUM ---
#define DMA_LIST_SGL                    (0)       // Scatter Gather List: Each list
                                                  // element includes a length and
                                                  // address.
#define DMA_LIST_PBL                    (1)       // Page Mode List: Each fixed size list
                                                  // element has an address only.

typedef enum {
   ENUM_DMA_LIST_SGL = 0x0UL,
   ENUM_DMA_LIST_PBL = 0x1UL
} DMA_LIST_TYPE_ENUM;

// --- DMA_FRAG_LIST_RING_ENUM ---
#define DMA_FRAG_LIST_RING_LINEAR       (0)       // Fraglist Linear mode
#define DMA_FRAG_LIST_RING_16           (1)       // Fraglist Ring 16 Segment mode.
#define DMA_FRAG_LIST_RING_32           (2)       // Fraglist Ring 32 Segment mode.
#define DMA_FRAG_LIST_RING_64           (3)       // Fraglist Ring 64 Segment mode.
#define DMA_FRAG_LIST_RING_128          (4)       // Fraglist Ring 128 Segment mode.

typedef enum {
   ENUM_DMA_FRAG_LIST_RING_LINEAR = 0x0UL,
   ENUM_DMA_FRAG_LIST_RING_16 = 0x1UL,
   ENUM_DMA_FRAG_LIST_RING_32 = 0x2UL,
   ENUM_DMA_FRAG_LIST_RING_64 = 0x3UL,
   ENUM_DMA_FRAG_LIST_RING_128 = 0x4UL
} DMA_FRAG_LIST_RING_ENUM;

// --- DMA_FRAG_SIZES ---
#define DMA_FRAG_128                    (0)       // Each fragment is 128 bytes.
#define DMA_FRAG_256                    (1)       // Each fragment is 256 bytes.
#define DMA_FRAG_512                    (2)       // Each fragment is 512 bytes.
#define DMA_FRAG_1K                     (3)       // Each fragment is 1024 bytes.
#define DMA_FRAG_2K                     (4)       // Each fragment is 2048 bytes.
#define DMA_FRAG_4K                     (5)       // Each fragment is 4096 bytes.
#define DMA_FRAG_8K                     (6)       // Each fragment is 8192 bytes.
#define DMA_FRAG_16K                    (7)       // Each fragment is 16384 bytes.

typedef enum {
   ENUM_DMA_FRAG_128 = 0x0UL,
   ENUM_DMA_FRAG_256 = 0x1UL,
   ENUM_DMA_FRAG_512 = 0x2UL,
   ENUM_DMA_FRAG_1K = 0x3UL,
   ENUM_DMA_FRAG_2K = 0x4UL,
   ENUM_DMA_FRAG_4K = 0x5UL,
   ENUM_DMA_FRAG_8K = 0x6UL,
   ENUM_DMA_FRAG_16K = 0x7UL
} DMA_FRAG_SIZES;

// --- DMA_DATA_LOCATION_ENUM ---
#define DMA_DATA_LOCATION_DBUF          (0)       // Indicates immediate data is in the
                                                  // DBUF. (wrdma)
#define DMA_DATA_LOCATION_TXPBUF        (1)       // addr0 points to txpbuf (wrdma,
                                                  // np_rdma)
#define DMA_DATA_LOCATION_CONTEXT       (2)       // addr0 points to context memory.
                                                  // (wrdma, hp_rdma, np_rdma)
#define DMA_DATA_LOCATION_ERX           (3)       // addr0 points to erx local memory
                                                  // (wrdma, hp_rdma)

typedef enum {
   ENUM_DMA_DATA_LOCATION_DBUF = 0x0UL,
   ENUM_DMA_DATA_LOCATION_TXPBUF = 0x1UL,
   ENUM_DMA_DATA_LOCATION_CONTEXT = 0x2UL,
   ENUM_DMA_DATA_LOCATION_ERX = 0x3UL
} DMA_DATA_LOCATION_ENUM;

// --- WCON_T10_ENUM ---
// WCON T10 Dif Processing Encodings
#define WCON_T10_NONE                   (0)       // T10 Dif Processing Disabled.
#define WCON_T10_PASS                   (1)       // T10 Dif Processing Enabled, Markers
                                                  // passed through from packet to host
                                                  // memory.
#define WCON_T10_STRIP                  (2)       // T10 Dif Processing Enabled, Markers
                                                  // stripped from packet on way to host
                                                  // memory.
#define WCON_T10_INSERT                 (3)       // T10 Dif Processing Enabled,
                                                  // Markerless packet. Markers inserted
                                                  // on way to host memory.

typedef enum {
   ENUM_WCON_T10_NONE = 0x0UL,
   ENUM_WCON_T10_PASS = 0x1UL,
   ENUM_WCON_T10_STRIP = 0x2UL,
   ENUM_WCON_T10_INSERT = 0x3UL
} WCON_T10_ENUM;

// --- WCON_DSRC_ENUM ---
// WCON Data Source Encodings
#define WCON_DSRC_CTX                   (0)       // WDMA data source is CTX.
#define WCON_DSRC_PMEM                  (1)       // WDMA data source is PMEM.

typedef enum {
   ENUM_WCON_DSRC_CTX = 0x0UL,
   ENUM_WCON_DSRC_PMEM = 0x1UL
} WCON_DSRC_ENUM;

// --- PTC_STATUS_CODE_ENUM ---
#define PTC_STATUS_SUCCESS              (0)       
#define PTC_DTENTRY_INVALID             (1)       
#define PTC_PTENTRY_INVALID             (2)       
#define PTC_DT_PARITY_ERROR             (3)       
#define PTC_PT_PARITY_ERROR             (4)       
#define PTC_DMA_ERROR                   (5)       

typedef enum {
   ENUM_PTC_STATUS_SUCCESS = 0x0UL,
   ENUM_PTC_DTENTRY_INVALID = 0x1UL,
   ENUM_PTC_PTENTRY_INVALID = 0x2UL,
   ENUM_PTC_DT_PARITY_ERROR = 0x3UL,
   ENUM_PTC_PT_PARITY_ERROR = 0x4UL,
   ENUM_PTC_DMA_ERROR = 0x5UL
} PTC_STATUS_CODE_ENUM;

// --- UC_REQ_TYPE ---
#define UC_REQ_TYPE_NORMAL              (0)       
#define UC_REQ_TYPE_IMMEDIATE           (1)       

typedef enum {
   ENUM_UC_REQ_TYPE_NORMAL = 0x0UL,
   ENUM_UC_REQ_TYPE_IMMEDIATE = 0x1UL
} UC_REQ_TYPE;

// --- UC_REQ_OPCODE ---
#define UC_REQ_OPCODE_ACCESS_PLUS       (0)       
#define UC_REQ_OPCODE_ACCESS_MINUS      (1)       
#define UC_REQ_OPCODE_ACCESS_MINUS_INV  (2)       
#define UC_REQ_OPCODE_INV_LINE          (3)       
#define UC_REQ_OPCODE_FLUSH             (4)       

typedef enum {
   ENUM_UC_REQ_OPCODE_ACCESS_PLUS = 0x0UL,
   ENUM_UC_REQ_OPCODE_ACCESS_MINUS = 0x1UL,
   ENUM_UC_REQ_OPCODE_ACCESS_MINUS_INV = 0x2UL,
   ENUM_UC_REQ_OPCODE_INV_LINE = 0x3UL,
   ENUM_UC_REQ_OPCODE_FLUSH = 0x4UL
} UC_REQ_OPCODE;

// --- UC_ENUM ---
#define UC_CRA_PE                       (0)       
#define UC_CRA_TE                       (1)       
#define UC_CRA_ISCSI                    (2)       
#define UC_CRA_RINGS                    (3)       
#define PT_INDEX_SHIFT                  (12)      
#define DT_INDEX_SHIFT                  (21)      
#define UC_VA_BITS                      (30)      
#define UC_MAX_ENTRIES                  (512)     

typedef enum {
   ENUM_UC_CRA_PE = 0x0UL,
   ENUM_UC_CRA_TE = 0x1UL,
   ENUM_UC_CRA_ISCSI = 0x2UL,
   ENUM_UC_CRA_RINGS = 0x3UL,
   ENUM_PT_INDEX_SHIFT = 0xcUL,
   ENUM_DT_INDEX_SHIFT = 0x15UL,
   ENUM_UC_VA_BITS = 0x1eUL,
   ENUM_UC_MAX_ENTRIES = 0x200UL
} UC_ENUM;

// --- PCI_FUNC ---
#define STORAGE_FUNC                    (0)       
#define NETWORK_FUNC                    (1)       

typedef enum {
   ENUM_STORAGE_FUNC = 0x0UL,
   ENUM_NETWORK_FUNC = 0x1UL
} PCI_FUNC;

// --- IPC_NODE_ID_ENUM ---
// IPC processor id values
#define TPOST_NODE_ID                   (0)       // TPOST ID
#define TPRE_NODE_ID                    (1)       // TPRE ID
#define TXULP0_NODE_ID                  (2)       // TXULP0 ID
#define TXULP1_NODE_ID                  (3)       // TXULP1 ID
#define TXULP2_NODE_ID                  (4)       // TXULP2 ID
#define RXULP0_NODE_ID                  (5)       // RXULP0 ID
#define RXULP1_NODE_ID                  (6)       // RXULP1 ID
#define RXULP2_NODE_ID                  (7)       // RXULP2 ID
#define MPU_NODE_ID                     (15)      // MPU ID

typedef enum {
   ENUM_TPOST_NODE_ID = 0x0UL,
   ENUM_TPRE_NODE_ID = 0x1UL,
   ENUM_TXULP0_NODE_ID = 0x2UL,
   ENUM_TXULP1_NODE_ID = 0x3UL,
   ENUM_TXULP2_NODE_ID = 0x4UL,
   ENUM_RXULP0_NODE_ID = 0x5UL,
   ENUM_RXULP1_NODE_ID = 0x6UL,
   ENUM_RXULP2_NODE_ID = 0x7UL,
   ENUM_MPU_NODE_ID = 0xfUL
} IPC_NODE_ID_ENUM;

// --- TXULP_CLASS_COLOR_ENUM ---
// Classification color values
#define TXULP_CLASS_NOCOLOR             (0)       // classification is not enabled
                                                  // (hardware drives this value)
#define TXULP_CLASS_GREEN               (1)       // green (enough tokens in the qos Tc)
#define TXULP_CLASS_YELLOW              (2)       // yellow (enough tokens in the qos EBP)
#define TXULP_CLASS_RED                 (3)       // red (not enough tokens in the qos Tc
                                                  // or EBP)

typedef enum {
   ENUM_TXULP_CLASS_NOCOLOR = 0x0UL,
   ENUM_TXULP_CLASS_GREEN = 0x1UL,
   ENUM_TXULP_CLASS_YELLOW = 0x2UL,
   ENUM_TXULP_CLASS_RED = 0x3UL
} TXULP_CLASS_COLOR_ENUM;

// --- TX_MSG_TYPE_ENUM ---
// Values used for the message type field in the transmit descriptor (TX_D).
#define MSG_TYPE_NORMAL_TX              (0)       
#define MSG_TYPE_RETRANSMIT             (1)       
#define MSG_TYPE_ACK                    (2)       
#define MSG_TYPE_PASS_THRU              (3)       

typedef enum {
   ENUM_MSG_TYPE_NORMAL_TX = 0x0UL,
   ENUM_MSG_TYPE_RETRANSMIT = 0x1UL,
   ENUM_MSG_TYPE_ACK = 0x2UL,
   ENUM_MSG_TYPE_PASS_THRU = 0x3UL
} TX_MSG_TYPE_ENUM;

// --- TX_PARSE_HDRS_ENUM ---
// Values used for the parse headers field in the transmit descriptor (TX_D).
#define TX_PARSE_HDRS_NONE              (0)       
#define TX_PARSE_HDRS_L2                (1)       
#define TX_PARSE_HDRS_L3                (2)       
#define TX_PARSE_HDRS_L4                (3)       

typedef enum {
   ENUM_TX_PARSE_HDRS_NONE = 0x0UL,
   ENUM_TX_PARSE_HDRS_L2 = 0x1UL,
   ENUM_TX_PARSE_HDRS_L3 = 0x2UL,
   ENUM_TX_PARSE_HDRS_L4 = 0x3UL
} TX_PARSE_HDRS_ENUM;

// --- TX_MSG_SRC_ENUM ---
// Values used for the message source field in the transmit descriptor (TX_D).
#define MSG_SRC_ETH                     (0)       
#define MSG_SRC_TOE                     (1)       
#define MSG_SRC_ISCSI                   (2)       
#define MSG_SRC_RDMA                    (3)       

typedef enum {
   ENUM_MSG_SRC_ETH = 0x0UL,
   ENUM_MSG_SRC_TOE = 0x1UL,
   ENUM_MSG_SRC_ISCSI = 0x2UL,
   ENUM_MSG_SRC_RDMA = 0x3UL
} TX_MSG_SRC_ENUM;

// --- TX_NWH_TYPE_ENUM ---
// Values used for network header type
#define NWH_TYPE_DIX                    (0)       // Ethernet(DIX) encapsulation
#define NWH_TYPE_SNAP                   (0)       // IEEE 802.2/802.3(SNAP) encapsulation

typedef enum {
   ENUM_NWH_TYPE_DIX = 0x0UL,
   ENUM_NWH_TYPE_SNAP = 0x0UL
} TX_NWH_TYPE_ENUM;

// --- DST_TX_FIFO_ENUM ---
// Determines the destination of a packet enqueued to the Transmit FIFOs.
#define DST_XAUI_0                      (0)       
#define DST_XAUI_1                      (1)       
#define DST_XAUI_CSR                    (2)       
#define DST_MGMT                        (3)       
#define DST_RXF                         (4)       
#define DST_TXIPS                       (5)       

typedef enum {
   ENUM_DST_XAUI_0 = 0x0UL,
   ENUM_DST_XAUI_1 = 0x1UL,
   ENUM_DST_XAUI_CSR = 0x2UL,
   ENUM_DST_MGMT = 0x3UL,
   ENUM_DST_RXF = 0x4UL,
   ENUM_DST_TXIPS = 0x5UL
} DST_TX_FIFO_ENUM;

// --- TX_IP_OFFSET_ENUM ---
// Indicates the start of the IP header.
#define IP_OFFSET_14                    (0)       // IP header starts at byte 14, dix
                                                  // packet
#define IP_OFFSET_18                    (1)       // IP header starts at byte 18, dix with
                                                  // VLAN
#define IP_OFFSET_22                    (2)       // IP header starts at byte 22, snap
                                                  // packet
#define IP_OFFSET_26                    (3)       // IP header starts at byte 26, snap
                                                  // with VLAN
#define IP_OFFSET_2vlan                 (4)       // IP header starts at byte 22, Dix QinQ
                                                  // packet
#define IP_OFFSET_30                    (5)       // IP header starts at byte 30, Snap
                                                  // QinQ packet

typedef enum {
   ENUM_IP_OFFSET_14 = 0x0UL,
   ENUM_IP_OFFSET_18 = 0x1UL,
   ENUM_IP_OFFSET_22 = 0x2UL,
   ENUM_IP_OFFSET_26 = 0x3UL,
   ENUM_IP_OFFSET_2vlan = 0x4UL,
   ENUM_IP_OFFSET_30 = 0x5UL
} TX_IP_OFFSET_ENUM;

// --- GSO_TX_D_ENUM ---
// Indicates the type of gso frame.
#define NON_GSO_TXD                     (0)       // Indicates that the present txd is not
                                                  // a gso txd
#define GSO_TXD_START                   (1)       // Indicates that the present txd is the
                                                  // first txd of gso
#define GSO_TXD_MIDDLE                  (2)       // Indicates that the present txd a
                                                  // middle txd of gso
#define GSO_TXD_LAST                    (3)       // Indicates that the present txd is the
                                                  // last txd of gso

typedef enum {
   ENUM_NON_GSO_TXD = 0x0UL,
   ENUM_GSO_TXD_START = 0x1UL,
   ENUM_GSO_TXD_MIDDLE = 0x2UL,
   ENUM_GSO_TXD_LAST = 0x3UL
} GSO_TX_D_ENUM;

// --- PUP_REGISTERS ---
#define PUP_REGISTER_DBC1               (0)       // This register counts the bytes at the
                                                  // Data fifo input of each processor 
#define PUP_REGISTER_HBC1               (1)       // This register counts the bytes at the
                                                  // Header fifo input of each processor 
#define PUP_REGISTER_OBC0               (2)       // This register counts the bytes at the
                                                  // output of each processor 
#define PUP_REGISTER_OBC1               (3)       // This register counts the bytes at the
                                                  // output of each processor 
#define PUP_REGISTER_ODBC0              (4)       // This register counts the data bytes
                                                  // at the output of each processor. 
#define PUP_REGISTER_ODBC1              (5)       // This register counts the data bytes
                                                  // at the output of each processor. 
#define PUP_REGISTER_FC                 (6)       // This register counts the number of
                                                  // frames output from each processor 
#define PUP_REGISTER_CRC0               (7)       // This registers calculates the FCOE or
                                                  // iSCSI/RDMA 32bit CRC at the output of
                                                  // each processor. 
#define PUP_REGISTER_CRC1               (8)       // This registers calculates the T10/DIF
                                                  // 16 bit CRC at the output of each
                                                  // processor and the other 16 bits of
                                                  // the register are treated as constant.
#define PUP_REGISTER_GP0                (9)       // This is a general purpose register
                                                  // that can be manipulated with the
                                                  // loadr and incrr instructions. 
#define PUP_REGISTER_GP1                (10)      // This is a general purpose register
                                                  // that can be manipulated with the
                                                  // loadr and incrr instructions. 
#define PUP_REGISTER_GP2                (11)      // This is a general purpose register
                                                  // that can be manipulated with the
                                                  // loadr and incrr instructions. 
#define PUP_REGISTER_LDBC               (12)      // This register counts the bytes at the
                                                  // Data fifo input of each processor. It
                                                  // is used to control the operation of
                                                  // the branch loop opcode. 
#define PUP_REGISTER_LODBC              (13)      // This register counts the data bytes
                                                  // at the output of each processor. It
                                                  // is used to control the operation of
                                                  // the branch loop opcode. 
#define PUP_REGISTER_DBC0               (14)      // This register counts the bytes at the
                                                  // Data fifo input of each processor.
                                                  // The pup instructions key off of this
                                                  // byte counter 
#define PUP_REGISTER_HBC0               (15)      // This register counts the bytes at the
                                                  // Header fifo input of each processor.
                                                  // The pup instructions key off of this
                                                  // byte counter 

typedef enum {
   ENUM_PUP_REGISTER_DBC1 = 0x0UL,
   ENUM_PUP_REGISTER_HBC1 = 0x1UL,
   ENUM_PUP_REGISTER_OBC0 = 0x2UL,
   ENUM_PUP_REGISTER_OBC1 = 0x3UL,
   ENUM_PUP_REGISTER_ODBC0 = 0x4UL,
   ENUM_PUP_REGISTER_ODBC1 = 0x5UL,
   ENUM_PUP_REGISTER_FC = 0x6UL,
   ENUM_PUP_REGISTER_CRC0 = 0x7UL,
   ENUM_PUP_REGISTER_CRC1 = 0x8UL,
   ENUM_PUP_REGISTER_GP0 = 0x9UL,
   ENUM_PUP_REGISTER_GP1 = 0xaUL,
   ENUM_PUP_REGISTER_GP2 = 0xbUL,
   ENUM_PUP_REGISTER_LDBC = 0xcUL,
   ENUM_PUP_REGISTER_LODBC = 0xdUL,
   ENUM_PUP_REGISTER_DBC0 = 0xeUL,
   ENUM_PUP_REGISTER_HBC0 = 0xfUL
} PUP_REGISTERS;

// --- PUP_OPCODE ---
// These are the supported opcodes for every instruction of the PUP processor 
#define PUP_OPCODE_INSERT               (0)       // Insert data at the current byte
                                                  // counter. The data inserted is pushed
                                                  // out the output fifo immediately
                                                  // following the instruction and before
                                                  // the start of the next instruction.
                                                  // The input byte counters dont change,
                                                  // but the output byte counters do 
#define PUP_OPCODE_DELETE               (1)       // Delete data at the current byte
                                                  // counter. The data is deleted. At
                                                  // conclusion of this instruction, the
                                                  // input byte counter points past the
                                                  // last byte of data deleted. The output
                                                  // byte counter does not move. 
#define PUP_OPCODE_REPLACE              (2)       // Replace the data at the current byte
                                                  // counter. The data replaced is pushed
                                                  // out the output fifo immediately
                                                  // following the instruction and before
                                                  // the start of the next instruction.
                                                  // The input byte counters and the
                                                  // output byte counters are modified 
#define PUP_OPCODE_ADD                  (3)       // Add the data at the current byte
                                                  // counter. The input and output byte
                                                  // counters are modified as if the
                                                  // PUP_OPCODE_REPLACE instruction was
                                                  // executed 
#define PUP_OPCODE_COMPARE              (4)       // Compare the contents of the register
                                                  // with the register specified in the
                                                  // immediate value. The result is stored
                                                  // in a sticky bit in the PUP header.
                                                  // The input and output byte counters
                                                  // are modified as if the
                                                  // PUP_OPCODE_REPLACE was executed. 
#define PUP_OPCODE_BRANCH_LOOP          (5)       // The instructions immediately
                                                  // following this instruction will be
                                                  // executed in a loop till the end of a
                                                  // segment is encountered. On
                                                  // encountering the end of a segment the
                                                  // program counter will be incremented
                                                  // by the number specified in the
                                                  // instruction. 
#define PUP_OPCODE_LOADR                (6)       // This instruction is used to reset the
                                                  // counters specified in the instruction
#define PUP_OPCODE_INCRR                (7)       // Increment the specified register. The
                                                  // increment amount is the specified
                                                  // immediate value or defaults to 1 if
                                                  // no immediate value is specified. 

typedef enum {
   ENUM_PUP_OPCODE_INSERT = 0x0UL,
   ENUM_PUP_OPCODE_DELETE = 0x1UL,
   ENUM_PUP_OPCODE_REPLACE = 0x2UL,
   ENUM_PUP_OPCODE_ADD = 0x3UL,
   ENUM_PUP_OPCODE_COMPARE = 0x4UL,
   ENUM_PUP_OPCODE_BRANCH_LOOP = 0x5UL,
   ENUM_PUP_OPCODE_LOADR = 0x6UL,
   ENUM_PUP_OPCODE_INCRR = 0x7UL
} PUP_OPCODE;

// --- MAC_ID_ENUM ---
// Meaning of the mac_id field in rxpp_eth_d
#define NETWORK0                        (0)       // host networking, interface 0.
#define NETWORK1                        (1)       // host networking, interface 1.
#define STORAGE0                        (2)       // host storage, interface 0.
#define STORAGE1                        (3)       // host storage, interface 1.
#define VM0                             (4)       // VM0.
#define VM1                             (5)       // VM1.
#define VM2                             (6)       // VM2.
#define VM3                             (7)       // VM3.
#define VM4                             (8)       // VM4.
#define VM5                             (9)       // VM5.
#define VM6                             (10)      // VM6.
#define VM7                             (11)      // VM7.
#define VM8                             (12)      // VM8.
#define VM9                             (13)      // VM9.
#define VM10                            (14)      // VM10.
#define VM11                            (15)      // VM11.
#define VM12                            (16)      // VM12.
#define VM13                            (17)      // VM13.
#define VM14                            (18)      // VM14.
#define VM15                            (19)      // VM15.
#define VM16                            (20)      // VM16.
#define VM17                            (21)      // VM17.
#define VM18                            (22)      // VM18.
#define VM19                            (23)      // VM19.
#define VM20                            (24)      // VM20.
#define VM21                            (25)      // VM21.
#define VM22                            (26)      // VM22.
#define VM23                            (27)      // VM23.
#define VM24                            (28)      // VM24.
#define VM25                            (29)      // VM25.
#define VM26                            (30)      // VM26.
#define VM27                            (31)      // VM27.
#define VM28                            (32)      // VM28.
#define VM29                            (33)      // VM29.
#define VM30                            (34)      // VM30.
#define VM31                            (35)      // VM31.
#define RSS0                            (36)      // RSS CPU 0.
#define RSS1                            (37)      // RSS CPU 1.
#define RSS2                            (38)      // RSS CPU 2.
#define RSS3                            (39)      // RSS CPU 3.
#define RSS4                            (40)      // RSS CPU 4.
#define RSS5                            (41)      // RSS CPU 5.
#define RSS6                            (42)      // RSS CPU 6.
#define RSS7                            (43)      // RSS CPU 7.
#define MGMT_MAC                        (44)      // Management port MAC.
#define RXULP                           (45)      // packet is to be routed to an RXULP.
#define RSS_NI0_PF                      (46)      // RSS Network Interface 0 Policy Flush.
#define RSS_NI1_PF                      (47)      // RSS Network Interface 1 Policy Flush.
#define NULL_MAC                        (62)      // Promiscuous mode, indicates no match
#define BCAST_MCAST                     (63)      // Broadcast or multicast (i.e. packet
                                                  // is to be replicated in ERX).

typedef enum {
   ENUM_NETWORK0 = 0x0UL,
   ENUM_NETWORK1 = 0x1UL,
   ENUM_STORAGE0 = 0x2UL,
   ENUM_STORAGE1 = 0x3UL,
   ENUM_VM0 = 0x4UL,
   ENUM_VM1 = 0x5UL,
   ENUM_VM2 = 0x6UL,
   ENUM_VM3 = 0x7UL,
   ENUM_VM4 = 0x8UL,
   ENUM_VM5 = 0x9UL,
   ENUM_VM6 = 0xaUL,
   ENUM_VM7 = 0xbUL,
   ENUM_VM8 = 0xcUL,
   ENUM_VM9 = 0xdUL,
   ENUM_VM10 = 0xeUL,
   ENUM_VM11 = 0xfUL,
   ENUM_VM12 = 0x10UL,
   ENUM_VM13 = 0x11UL,
   ENUM_VM14 = 0x12UL,
   ENUM_VM15 = 0x13UL,
   ENUM_VM16 = 0x14UL,
   ENUM_VM17 = 0x15UL,
   ENUM_VM18 = 0x16UL,
   ENUM_VM19 = 0x17UL,
   ENUM_VM20 = 0x18UL,
   ENUM_VM21 = 0x19UL,
   ENUM_VM22 = 0x1aUL,
   ENUM_VM23 = 0x1bUL,
   ENUM_VM24 = 0x1cUL,
   ENUM_VM25 = 0x1dUL,
   ENUM_VM26 = 0x1eUL,
   ENUM_VM27 = 0x1fUL,
   ENUM_VM28 = 0x20UL,
   ENUM_VM29 = 0x21UL,
   ENUM_VM30 = 0x22UL,
   ENUM_VM31 = 0x23UL,
   ENUM_RSS0 = 0x24UL,
   ENUM_RSS1 = 0x25UL,
   ENUM_RSS2 = 0x26UL,
   ENUM_RSS3 = 0x27UL,
   ENUM_RSS4 = 0x28UL,
   ENUM_RSS5 = 0x29UL,
   ENUM_RSS6 = 0x2aUL,
   ENUM_RSS7 = 0x2bUL,
   ENUM_MGMT_MAC = 0x2cUL,
   ENUM_RXULP = 0x2dUL,
   ENUM_RSS_NI0_PF = 0x2eUL,
   ENUM_RSS_NI1_PF = 0x2fUL,
   ENUM_NULL_MAC = 0x3eUL,
   ENUM_BCAST_MCAST = 0x3fUL
} MAC_ID_ENUM;

// --- FPE_ENUM ---
#define FPE_NORMAL_OPERATION            (0)       // Indicates that this is a normal
                                                  // operation
#define FPE_TCP_FLUSH                   (1)       // Indicates that this is a TCP flush
                                                  // request 
#define FPE_ISCSI_OOO                   (2)       // Indicates that this is a ISCSI
                                                  // TT_REPLAY packet
#define FPE_ISCSI_OOO_FLUSH             (3)       // Indicates that this is a ISCSI OOO
                                                  // flush packet
#define FPE_REXMT_COMPLETE              (4)       // Indicates that this is a retransmit
                                                  // complete message

typedef enum {
   ENUM_FPE_NORMAL_OPERATION = 0x0UL,
   ENUM_FPE_TCP_FLUSH = 0x1UL,
   ENUM_FPE_ISCSI_OOO = 0x2UL,
   ENUM_FPE_ISCSI_OOO_FLUSH = 0x3UL,
   ENUM_FPE_REXMT_COMPLETE = 0x4UL
} FPE_ENUM;

// --- TIMESTAMP_OPTIONS ---
#define NO_OPTIONS                      (0)       // Indicates that no TCP options are
                                                  // present
#define TIMESTAMP_ONLY_TYPE1            (1)       // Indicates that only time stamp option
                                                  // is presnt without any no-ops before
                                                  // them
#define TIMESTAMP_ONLY_TYPE2            (2)       // Indicates that only time stamp option
                                                  // is presnt with no-ops before them
#define OTHER_OPTIONS                   (3)       // Indicates that other TCP options are
                                                  // present 

typedef enum {
   ENUM_NO_OPTIONS = 0x0UL,
   ENUM_TIMESTAMP_ONLY_TYPE1 = 0x1UL,
   ENUM_TIMESTAMP_ONLY_TYPE2 = 0x2UL,
   ENUM_OTHER_OPTIONS = 0x3UL
} TIMESTAMP_OPTIONS;

// --- RXPP_PACKET_TYPE ---
#define NON_IP                          (0)       // Packet is non-IP
#define IP_ONLY                         (1)       // Packet is IP only
#define TCP_NO_OPTIONS                  (2)       // Packet is TCP without options
#define TCP_TIMESTAMP_UNALIGNED         (3)       // Packet is TCP with unaligned
                                                  // TIMESTAMP option
#define TCP_TIMESTAMP_ALIGNED           (4)       // Packet is TCP with aligned TIMESTAMP
                                                  // option
#define TCP_OTHER_OPTIONS               (5)       // Packet is TCP with options other than
                                                  // TIMESTAMP
#define IP_UDP                          (6)       // Packet is UDP

typedef enum {
   ENUM_NON_IP = 0x0UL,
   ENUM_IP_ONLY = 0x1UL,
   ENUM_TCP_NO_OPTIONS = 0x2UL,
   ENUM_TCP_TIMESTAMP_UNALIGNED = 0x3UL,
   ENUM_TCP_TIMESTAMP_ALIGNED = 0x4UL,
   ENUM_TCP_OTHER_OPTIONS = 0x5UL,
   ENUM_IP_UDP = 0x6UL
} RXPP_PACKET_TYPE;

// --- RXPP_SID_CODES ---
#define SID_RXULP_L2_HIT                (0)       
#define SID_802_1au_CONTROL             (1)       
#define SID_FCoE                        (2)       
#define SID_LRO_HOST_IF_0               (3)       
#define SID_LRO_HOST_IF_1               (4)       
#define SID_IP_HOST_IF_0                (5)       
#define SID_IP_HOST_IF_1                (6)       
#define SID_RESERVED                    (7)       

typedef enum {
   ENUM_SID_RXULP_L2_HIT = 0x0UL,
   ENUM_SID_802_1au_CONTROL = 0x1UL,
   ENUM_SID_FCoE = 0x2UL,
   ENUM_SID_LRO_HOST_IF_0 = 0x3UL,
   ENUM_SID_LRO_HOST_IF_1 = 0x4UL,
   ENUM_SID_IP_HOST_IF_0 = 0x5UL,
   ENUM_SID_IP_HOST_IF_1 = 0x6UL,
   ENUM_SID_RESERVED = 0x7UL
} RXPP_SID_CODES;

// --- SOF_ENUM ---
#define SOFi2                           (0)       // value of 0x2d
#define SOFn2                           (1)       // value of 0x35
#define SOFi3                           (2)       // value of 0x2e
#define SOFn3                           (3)       // value of 0x36

typedef enum {
   ENUM_SOFi2 = 0x0UL,
   ENUM_SOFn2 = 0x1UL,
   ENUM_SOFi3 = 0x2UL,
   ENUM_SOFn3 = 0x3UL
} SOF_ENUM;

// --- EOF_ENUM ---
#define EOFn                            (0)       // value of 0x41
#define EOFt                            (1)       // value of 0x42
#define EOFni                           (2)       // value of 0x49
#define EOFa                            (3)       // value of 0x50

typedef enum {
   ENUM_EOFn = 0x0UL,
   ENUM_EOFt = 0x1UL,
   ENUM_EOFni = 0x2UL,
   ENUM_EOFa = 0x3UL
} EOF_ENUM;

// --- TPRE_ORDER_ENUM ---
#define TPRE_ORDER_INLINE               (1)       // Indicates that this data segment is
                                                  // inline
#define TPRE_ORDER_INLINE_PLUG          (2)       // Indicates that this data segment
                                                  // plugs an ooo hole
#define TPRE_ORDER_NEW_OOO              (3)       // Indicates that this data segment
                                                  // results in a new hole
#define TPRE_ORDER_OOO_PREPEND          (4)       // Indicates a prepend operation to the
                                                  // ooo queue
#define TPRE_ORDER_OOO_APPEND           (5)       // Indicates an append operation to the
                                                  // ooo queue
#define TPRE_ORDER_TT_DONE              (6)       // Indicates a triple trip operation has
                                                  // concluded. Not used in driver
#define TPRE_ORDER_INLINE_PLUG_ADV_RCVNXT (6)     // Indicates a inline plug which
                                                  // advances the receive next
#define TPRE_ORDER_PURGE_OOO            (7)       // Indicates that all OOO data received
                                                  // so far has to be purged.

typedef enum {
   ENUM_TPRE_ORDER_INLINE = 0x1UL,
   ENUM_TPRE_ORDER_INLINE_PLUG = 0x2UL,
   ENUM_TPRE_ORDER_NEW_OOO = 0x3UL,
   ENUM_TPRE_ORDER_OOO_PREPEND = 0x4UL,
   ENUM_TPRE_ORDER_OOO_APPEND = 0x5UL,
   ENUM_TPRE_ORDER_TT_DONE = 0x6UL,
   ENUM_TPRE_ORDER_INLINE_PLUG_ADV_RCVNXT = 0x6UL,
   ENUM_TPRE_ORDER_PURGE_OOO = 0x7UL
} TPRE_ORDER_ENUM;

// --- LRO_ACTION ---
#define FLUSH_LRO_RING                  (0)       // Flush last request for this LRO
                                                  // buffer ring. A message is sent to MPU
#define PROCESS_COLLISION               (1)       // A singleton request that is sent on
                                                  // its own cid for all collided packets.
#define START_CHAIN                     (2)       // Start new chain. For a start action
                                                  // the lro_offset field speciies the
                                                  // byte offset into pbuf_head of the
                                                  // start of the TCP header. This info
                                                  // should be saved for future header
                                                  // patchup, if needed. The packet starts
                                                  // at the first byte in pbuf_header
                                                  // since chains start with their
                                                  // headers. The lro_ipv6 and lro_snap
                                                  // flags indicate whether this chain is
                                                  // IPV6 and/or has SNAP headers so that
                                                  // the IP length can be patched on chain
                                                  // completion.
#define PROCESS_SINGLETON               (3)       // Process singleton packet. This
                                                  // descriptor describes a single packet
                                                  // which is to be written and marked
                                                  // complete. The packet represents an
                                                  // excpetional condition which cannot be
                                                  // combined with other packets. For
                                                  // example, the packet is an IP Frag,
                                                  // has IP options, non-TIMESTAMP TCP
                                                  // options, etc.
#define COMPLETE_CHAIN                  (4)       // Complete current chain. The pbuf_head
                                                  // and seg_length fields of the
                                                  // TPRE_LRO_D are ignored, however the
                                                  // header should be patched as indicated
                                                  // by the patch_flags, patch_win,
                                                  // patch_ack, and patch_tsecr bits.
#define COMPLETE_AND_START_CHAIN        (6)       // Complete current chain and Start New
                                                  // chain. Similar to a COMPLETE action
                                                  // however following chain completion
                                                  // the current packet should be used to
                                                  // start a new chain. Since this is a
                                                  // START operation lro_offset contains
                                                  // the byte offset into pbuf_head of the
                                                  // start of the TCP header for the new
                                                  // chain.
#define COMPLETE_AND_PROCESS_SINGLETON  (7)       // Complete current chain and process
                                                  // singleton packet. Similar to a
                                                  // COMPLETE action however following
                                                  // chain completion the current packet
                                                  // should be processed as a singleton
                                                  // packet.
#define APPEND_CHAIN                    (10)      // Append packet to current chain. The
                                                  // lro_offset field in the descriptor
                                                  // gives the byte offset within
                                                  // pbuf_head of the first data byte of
                                                  // the packet. For Append operations the
                                                  // header is skipped since only the
                                                  // start of a chain has a header. RXULP
                                                  // should track the packet length
                                                  // (seg_length minus lro_offset) for
                                                  // eventual IP header patchup when the
                                                  // chain completes.
#define APPEND_AND_COMPLETE             (11)      // Append packet to current chain and
                                                  // complete it. The descriptor is
                                                  // describing the last segment of a
                                                  // chain which is to be completed. This
                                                  // code is used when the arriving packet
                                                  // causes the chain to grow to its
                                                  // maximum allowed length. Note that the
                                                  // completion cannot involve patch_win
                                                  // processing since the seg_length field
                                                  // is overloaded for this purpose. If
                                                  // patch_win is needed then the event
                                                  // will be split into two descriptors:
                                                  // the first to complete the current
                                                  // chain (with required patchups) and
                                                  // the second to start a new chain.
#define SPLIT_HEADER                    (15)      // Split Header at ULP or Data boundary.
                                                  // Note: Header splitting is orthogonal
                                                  // to LRO processing but is performed by
                                                  // the same firmware modules.

typedef enum {
   ENUM_FLUSH_LRO_RING = 0x0UL,
   ENUM_PROCESS_COLLISION = 0x1UL,
   ENUM_START_CHAIN = 0x2UL,
   ENUM_PROCESS_SINGLETON = 0x3UL,
   ENUM_COMPLETE_CHAIN = 0x4UL,
   ENUM_COMPLETE_AND_START_CHAIN = 0x6UL,
   ENUM_COMPLETE_AND_PROCESS_SINGLETON = 0x7UL,
   ENUM_APPEND_CHAIN = 0xaUL,
   ENUM_APPEND_AND_COMPLETE = 0xbUL,
   ENUM_SPLIT_HEADER = 0xfUL
} LRO_ACTION;

#endif // __descriptors_enum_h__

