/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __eeprom_enum_h__
#define __eeprom_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- EEPROM_REGION_TYPE_ENUM ---
// Defined region types in EEPROM
#define EEPROM_REGION_TYPE_NULL         (0)       // General purpose region type.
#define EEPROM_REGION_TYPE_POST_D3COLD_REG (1)    // Denotes beginning of register data
                                                  // for registers loaded after D3 cold
#define EEPROM_REGION_TYPE_CONDITION0_REG (2)     // Conditional register write (external
                                                  // condition 0)
#define EEPROM_REGION_TYPE_CONDITION1_REG (3)     // Conditional register write (external
                                                  // condition 1)
#define EEPROM_REGION_TYPE_FW           (4)       // Firmware code region.
#define EEPROM_REGION_TYPE_SWDATA       (5)       // Global region for software data.
#define EEPROM_REGION_TYPE_EOR          (7)       // End of region indicator.

typedef enum {
   ENUM_EEPROM_REGION_TYPE_NULL = 0x0UL,
   ENUM_EEPROM_REGION_TYPE_POST_D3COLD_REG = 0x1UL,
   ENUM_EEPROM_REGION_TYPE_CONDITION0_REG = 0x2UL,
   ENUM_EEPROM_REGION_TYPE_CONDITION1_REG = 0x3UL,
   ENUM_EEPROM_REGION_TYPE_FW = 0x4UL,
   ENUM_EEPROM_REGION_TYPE_SWDATA = 0x5UL,
   ENUM_EEPROM_REGION_TYPE_EOR = 0x7UL
} EEPROM_REGION_TYPE_ENUM;

// --- EEPROM_FW_TYPE ---
// These enums describe which type of processor the firmware image is intended for.
#define EEPROM_FW_TYPE_TPOST            (0)       // Indicates TPOST firmware region
#define EEPROM_FW_TYPE_TPRE             (1)       // Indicates TPRE firmware region
#define EEPROM_FW_TYPE_TXULP0           (2)       // Indicates TXULP0 firmware region
#define EEPROM_FW_TYPE_TXULP1           (3)       // Indicates TXULP1 firmware region
#define EEPROM_FW_TYPE_TXULP2           (4)       // Indicates TXULP2 firmware region
#define EEPROM_FW_TYPE_RXULP0           (5)       // Indicates RXULP0 firmware region
#define EEPROM_FW_TYPE_RXULP1           (6)       // Indicates RXULP1 firmware region
#define EEPROM_FW_TYPE_RXULP2           (7)       // Indicates RXULP2 firmware region
#define EEPROM_FW_TYPE_MPU              (15)      // Indicates MPU firmware region

typedef enum {
   ENUM_EEPROM_FW_TYPE_TPOST = 0x0UL,
   ENUM_EEPROM_FW_TYPE_TPRE = 0x1UL,
   ENUM_EEPROM_FW_TYPE_TXULP0 = 0x2UL,
   ENUM_EEPROM_FW_TYPE_TXULP1 = 0x3UL,
   ENUM_EEPROM_FW_TYPE_TXULP2 = 0x4UL,
   ENUM_EEPROM_FW_TYPE_RXULP0 = 0x5UL,
   ENUM_EEPROM_FW_TYPE_RXULP1 = 0x6UL,
   ENUM_EEPROM_FW_TYPE_RXULP2 = 0x7UL,
   ENUM_EEPROM_FW_TYPE_MPU = 0xfUL
} EEPROM_FW_TYPE;

// --- EEPROM_REGISTER_CYCLE_TYPE ---
// Valid register cycle types
#define EEPROM_REGISTER_CYCLE_NODE      (0)       // Internal Node type
#define EEPROM_REGISTER_CYCLE_MEM       (1)       // Memory cycle type
#define EEPROM_REGISTER_CYCLE_IO        (2)       // I/O cycle type
#define EEPROM_REGISTER_CYCLE_CFG       (3)       // Config cycle type

typedef enum {
   ENUM_EEPROM_REGISTER_CYCLE_NODE = 0x0UL,
   ENUM_EEPROM_REGISTER_CYCLE_MEM = 0x1UL,
   ENUM_EEPROM_REGISTER_CYCLE_IO = 0x2UL,
   ENUM_EEPROM_REGISTER_CYCLE_CFG = 0x3UL
} EEPROM_REGISTER_CYCLE_TYPE;

// --- EEPROM_REGREGION_BAR_ENUM ---
// Valid BAR numbers for register types
#define EEPROM_REGREGION_IOBAR          (0)       // I/O Bar
#define EEPROM_REGREGION_MEMBAR0        (1)       // Memory Bar 0
#define EEPROM_REGREGION_MEMBAR1        (2)       // Memory Bar 1
#define EEPROM_REGREGION_MEMBAR2        (3)       // Memory Bar 2

typedef enum {
   ENUM_EEPROM_REGREGION_IOBAR = 0x0UL,
   ENUM_EEPROM_REGREGION_MEMBAR0 = 0x1UL,
   ENUM_EEPROM_REGREGION_MEMBAR1 = 0x2UL,
   ENUM_EEPROM_REGREGION_MEMBAR2 = 0x3UL
} EEPROM_REGREGION_BAR_ENUM;

#endif // __eeprom_enum_h__

