/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __fw_exp_enum_h__
#define __fw_exp_enum_h__
#include "setypes.h"
#include "tpost_exp_enum.h"
#include "tpre_exp_enum.h"
#include "fcoetx_exp_enum.h"
#include "fcoerx_exp_enum.h"
#include "toetx_exp_enum.h"
#include "toerx_exp_enum.h"
#include "daltx_exp_enum.h"
#include "dalrx_exp_enum.h"
#include "be2_config_sg_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- TEMP_FW_EXPORT_ENUM ---
#define TOERX_MAX_TPREDS                (15)      

typedef enum {
   ENUM_TOERX_MAX_TPREDS = 0xfUL
} TEMP_FW_EXPORT_ENUM;

// --- TCP_ACK_FREQUENCY_VALUES ---
#define TCP_ACK_FREQUENCY_DISABLE       (0)       // Indicates that sending an ack
                                                  // immediately on response to a segment
                                                  // is disabled. Has no effect on delayed
                                                  // acks 
#define TCP_ACK_FREQUENCY_MIN           (1)       // Minimum value of the ack frequency,
                                                  // send one ack per segment. 
#define TCP_ACK_FREQUENCY_DEFAULT       (2)       // Default value of the ack frequency.
                                                  // Sends one ack per two segments 
#define TCP_ACK_FREQUENCY_MAX           (15)      // Maximum value of the ack frequency 

typedef enum {
   ENUM_TCP_ACK_FREQUENCY_DISABLE = 0x0UL,
   ENUM_TCP_ACK_FREQUENCY_MIN = 0x1UL,
   ENUM_TCP_ACK_FREQUENCY_DEFAULT = 0x2UL,
   ENUM_TCP_ACK_FREQUENCY_MAX = 0xfUL
} TCP_ACK_FREQUENCY_VALUES;

// --- TCP_OOO_SUPPORTED_VALUES ---
#define TCP_OOO_DISABLE                 (0)       // Indicates that OOO is disabled. 
#define TCP_OOO_MIN                     (1)       // Minimum value of number of holes
                                                  // supported. 
#define TCP_OOO_MAX                     (3)       // Maximum value of number of holes
                                                  // supported. 
#define TCP_OOO_DEFAULT                 (3)       // Default value of holes supported. 

typedef enum {
   ENUM_TCP_OOO_DISABLE = 0x0UL,
   ENUM_TCP_OOO_MIN = 0x1UL,
   ENUM_TCP_OOO_MAX = 0x3UL,
   ENUM_TCP_OOO_DEFAULT = 0x3UL
} TCP_OOO_SUPPORTED_VALUES;

// --- TCP_DELAYED_ACK_TICKS_VALUES ---
#define TCP_DELAYED_ACK_TICKS_DISABLE   (0)       // Indicates that the delayed ack timer
                                                  // is disabled. 
#define TCP_DELAYED_ACK_TIMER_MS_STEP   (8)       // The number of milliseconds
                                                  // represented by each increment of the
                                                  // delayed ack timer 
#define TCP_DELAYED_ACK_TICKS_DEFAULT   (25)      // The default value of the delayed ack
                                                  // timer 

typedef enum {
   ENUM_TCP_DELAYED_ACK_TICKS_DISABLE = 0x0UL,
   ENUM_TCP_DELAYED_ACK_TIMER_MS_STEP = 0x8UL,
   ENUM_TCP_DELAYED_ACK_TICKS_DEFAULT = 0x19UL
} TCP_DELAYED_ACK_TICKS_VALUES;

// --- TCP_MAX_RXMT_COUNT_VALUES ---
#define TCP_MAX_RXMT_COUNT_DEFAULT      (12)      // Default max retransmit counter 

typedef enum {
   ENUM_TCP_MAX_RXMT_COUNT_DEFAULT = 0xcUL
} TCP_MAX_RXMT_COUNT_VALUES;

// --- TCP_MAX_RXMT_COUNT_ISCSI_VALUES ---
#define TCP_MAX_RXMT_COUNT_ISCSI_DEFAULT (7)      // Default max retransmit counter 

typedef enum {
   ENUM_TCP_MAX_RXMT_COUNT_ISCSI_DEFAULT = 0x7UL
} TCP_MAX_RXMT_COUNT_ISCSI_VALUES;

// --- TCP_MAX_WARNING_COUNT_VALUES ---
#define TCP_MAX_WARNING_COUNT_DEFAULT   (4)       // Default max warning count 

typedef enum {
   ENUM_TCP_MAX_WARNING_COUNT_DEFAULT = 0x4UL
} TCP_MAX_WARNING_COUNT_VALUES;

// --- TCP_DUP_ACK_THRESHOLD_VALUES ---
#define TCP_DUP_ACK_THRESHOLD_DEFAULT   (3)       // Defautl value for dup_ack_threshold 

typedef enum {
   ENUM_TCP_DUP_ACK_THRESHOLD_DEFAULT = 0x3UL
} TCP_DUP_ACK_THRESHOLD_VALUES;

// --- TCP_IDLE_TICKS_VALUES ---
#define TCP_IDLE_TICKS_DEFAULT          (1)       

typedef enum {
   ENUM_TCP_IDLE_TICKS_DEFAULT = 0x1UL
} TCP_IDLE_TICKS_VALUES;

// --- TCP_SWS_PREVENTION_TICKS_VALUES ---
#define TCP_SWS_PREVENTION_TICKS_DEFAULT (1)      

typedef enum {
   ENUM_TCP_SWS_PREVENTION_TICKS_DEFAULT = 0x1UL
} TCP_SWS_PREVENTION_TICKS_VALUES;

// --- TCP_PUSH_TIMER_TICKS_VALUES ---
#define TCP_PUSH_TIMER_TICKS_DEFAULT    (0)       

typedef enum {
   ENUM_TCP_PUSH_TIMER_TICKS_DEFAULT = 0x0UL
} TCP_PUSH_TIMER_TICKS_VALUES;

// --- TCP_FIN_WAIT2_TICKS_VALUES ---
#define TCP_FIN_WAIT2_TICKS_DEFAULT     (1)       

typedef enum {
   ENUM_TCP_FIN_WAIT2_TICKS_DEFAULT = 0x1UL
} TCP_FIN_WAIT2_TICKS_VALUES;

// --- TCP_DBCRED_COST ---
#define TCP_DBCRED_COST_DEFAULT         (4)       // Default dbcred cost 

typedef enum {
   ENUM_TCP_DBCRED_COST_DEFAULT = 0x4UL
} TCP_DBCRED_COST;

#endif // __fw_exp_enum_h__

