/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_dmtf_enum_h__
#define __ioctl_dmtf_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- IOCTL_DMTF_CLP_STATUS_CODES ---
#define DMTF_CLP_CMD_COMPLETED_SUCCESS  (0)       
#define DMTF_CLP_CMD_SPAWNED            (1)       
#define DMTF_CLP_CMD_PROCESSING_FAILED  (2)       
#define DMTF_CLP_CMD_EXECUTION_FAILED   (3)       

typedef enum {
   ENUM_DMTF_CLP_CMD_COMPLETED_SUCCESS = 0x0UL,
   ENUM_DMTF_CLP_CMD_SPAWNED = 0x1UL,
   ENUM_DMTF_CLP_CMD_PROCESSING_FAILED = 0x2UL,
   ENUM_DMTF_CLP_CMD_EXECUTION_FAILED = 0x3UL
} IOCTL_DMTF_CLP_STATUS_CODES;

// --- IOCTL_DMTF_CLP_DETAILED_STATUS_CODES ---
#define DMTF_CLP_CMD_QUEUE_FULL         (244)     
#define DMTF_CLP_CMD_REQUIRED_OPTION_MISSING (245) 
#define DMTF_CLP_CMD_INVALID_TARGET     (246)     
#define DMTF_CLP_CMD_OPTION_NOT_SUPPORTED (247)   
#define DMTF_CLP_CMD_MISSING_ARGUMENT   (248)     
#define DMTF_CLP_CMD_OUTPUT_FORMAT_NOT_SUPPORTED (249) 
#define DMTF_CLP_CMD_INVALID_ARGUMENT   (250)     
#define DMTF_CLP_CMD_INVALID_OPTION     (251)     
#define DMTF_CLP_CMD_SYNTAX_ERROR       (252)     
#define DMTF_CLP_CMD_NOT_RECOGNIZED     (253)     
#define DMTF_CLP_CMD_NOT_SUPPORTED      (254)     
#define DMTF_CLP_CMD_ERROR_NOT_SPECIFIED (255)    

typedef enum {
   ENUM_DMTF_CLP_CMD_QUEUE_FULL = 0xf4UL,
   ENUM_DMTF_CLP_CMD_REQUIRED_OPTION_MISSING = 0xf5UL,
   ENUM_DMTF_CLP_CMD_INVALID_TARGET = 0xf6UL,
   ENUM_DMTF_CLP_CMD_OPTION_NOT_SUPPORTED = 0xf7UL,
   ENUM_DMTF_CLP_CMD_MISSING_ARGUMENT = 0xf8UL,
   ENUM_DMTF_CLP_CMD_OUTPUT_FORMAT_NOT_SUPPORTED = 0xf9UL,
   ENUM_DMTF_CLP_CMD_INVALID_ARGUMENT = 0xfaUL,
   ENUM_DMTF_CLP_CMD_INVALID_OPTION = 0xfbUL,
   ENUM_DMTF_CLP_CMD_SYNTAX_ERROR = 0xfcUL,
   ENUM_DMTF_CLP_CMD_NOT_RECOGNIZED = 0xfdUL,
   ENUM_DMTF_CLP_CMD_NOT_SUPPORTED = 0xfeUL,
   ENUM_DMTF_CLP_CMD_ERROR_NOT_SPECIFIED = 0xffUL
} IOCTL_DMTF_CLP_DETAILED_STATUS_CODES;

// --- IOCTL_DMTF_CLP_EXECUTION_TYPE_CODE ---
#define DMTF_CLP_SPECIFIC_EXECUTION_CODE (0)      
#define DMTF_CLP_OEM_SPECIFIC_EXECUTION_CODE (1)  

typedef enum {
   ENUM_DMTF_CLP_SPECIFIC_EXECUTION_CODE = 0x0UL,
   ENUM_DMTF_CLP_OEM_SPECIFIC_EXECUTION_CODE = 0x1UL
} IOCTL_DMTF_CLP_EXECUTION_TYPE_CODE;

// --- IOCTL_DMTF_CLP_EXECUTION_ERROR_CODES ---
#define DMTF_CLP_EXEC_UNKNOWN_ERROR     (0)       
#define DMTF_CLP_EXEC_OTHER_ERROR       (1)       
#define DMTF_CLP_EXEC_COMMUNICATION_ERROR (2)     
#define DMTF_CLP_EXEC_QOS_ERROR         (3)       
#define DMTF_CLP_EXEC_SOFTWARE_ERROR    (4)       
#define DMTF_CLP_EXEC_HARDWARE_ERROR    (5)       
#define DMTF_CLP_EXEC_ENVIRONMENT_ERROR (6)       
#define DMTF_CLP_EXEC_SECURITY_ERROR    (7)       
#define DMTF_CLP_EXEC_OVER_SUBSCRIPTION_ERROR (8) 
#define DMTF_CLP_EXEC_UNAVAILABLE_RESOURCE_ERROR (9) 
#define DMTF_CLP_EXEC_UNSUPPORTED_OPERATION_ERROR (10) 

typedef enum {
   ENUM_DMTF_CLP_EXEC_UNKNOWN_ERROR = 0x0UL,
   ENUM_DMTF_CLP_EXEC_OTHER_ERROR = 0x1UL,
   ENUM_DMTF_CLP_EXEC_COMMUNICATION_ERROR = 0x2UL,
   ENUM_DMTF_CLP_EXEC_QOS_ERROR = 0x3UL,
   ENUM_DMTF_CLP_EXEC_SOFTWARE_ERROR = 0x4UL,
   ENUM_DMTF_CLP_EXEC_HARDWARE_ERROR = 0x5UL,
   ENUM_DMTF_CLP_EXEC_ENVIRONMENT_ERROR = 0x6UL,
   ENUM_DMTF_CLP_EXEC_SECURITY_ERROR = 0x7UL,
   ENUM_DMTF_CLP_EXEC_OVER_SUBSCRIPTION_ERROR = 0x8UL,
   ENUM_DMTF_CLP_EXEC_UNAVAILABLE_RESOURCE_ERROR = 0x9UL,
   ENUM_DMTF_CLP_EXEC_UNSUPPORTED_OPERATION_ERROR = 0xaUL
} IOCTL_DMTF_CLP_EXECUTION_ERROR_CODES;

#endif // __ioctl_dmtf_enum_h__

