/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_eth_enum_h__
#define __ioctl_eth_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "rxf_enum.h"
#include "fw_exp_enum.h"
#include "erx_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- ETH_TX_RING_TYPE_ENUM ---
#define ETH_TX_RING_TYPE_FORWARDING     (1)       // Ethernet ring for forwarding packets
                                                  // to the offload TOE engine.
#define ETH_TX_RING_TYPE_STANDARD       (2)       // Ethernet ring for sending network
                                                  // packets.
#define ETH_TX_RING_TYPE_LOW_LATENCY    (4)       // Low latency ethernet ring for sending
                                                  // network packets.
#define ETH_TX_RING_TYPE_BOUND          (8)       // Bound-port ethernet ring (host only) 

typedef enum {
   ENUM_ETH_TX_RING_TYPE_FORWARDING = 0x1UL,
   ENUM_ETH_TX_RING_TYPE_STANDARD = 0x2UL,
   ENUM_ETH_TX_RING_TYPE_LOW_LATENCY = 0x4UL,
   ENUM_ETH_TX_RING_TYPE_BOUND = 0x8UL
} ETH_TX_RING_TYPE_ENUM;

// --- ETX_QUEUE_TYPE_ENUM ---
#define ETX_QUEUE_TYPE_FORWARDING       (1)       // ETX queue for forwarding packets to
                                                  // the offload engines. 
#define ETX_QUEUE_TYPE_STANDARD         (2)       // ETX queue for sending network
                                                  // packets. 
#define ETX_QUEUE_TYPE_PRIORITY         (16)      // ETX queue will transmit as per
                                                  // associated priority 

typedef enum {
   ENUM_ETX_QUEUE_TYPE_FORWARDING = 0x1UL,
   ENUM_ETX_QUEUE_TYPE_STANDARD = 0x2UL,
   ENUM_ETX_QUEUE_TYPE_PRIORITY = 0x10UL
} ETX_QUEUE_TYPE_ENUM;

// --- ETX_QUEUE_SIZE_ENUM ---
#define ETX_QUEUE_SIZE_256              (9)       // 256 entries 
#define ETX_QUEUE_SIZE_512              (10)      // 512 entries 
#define ETX_QUEUE_SIZE_1K               (11)      // 1024 entries 
#define ETX_QUEUE_SIZE_2K               (12)      // 2048 entries 

typedef enum {
   ENUM_ETX_QUEUE_SIZE_256 = 0x9UL,
   ENUM_ETX_QUEUE_SIZE_512 = 0xaUL,
   ENUM_ETX_QUEUE_SIZE_1K = 0xbUL,
   ENUM_ETX_QUEUE_SIZE_2K = 0xcUL
} ETX_QUEUE_SIZE_ENUM;

// --- ACPI_WOL_MAGIC_CONFIG_V1_ENUM ---
#define GET_ACPI_CONFIG                 (1)       // This value when set requests the
                                                  // SLI-Port to provide the ACPI patterns
                                                  // configured for the targeted SLI-Hosts
                                                  // and Ethernet port. Note that the ACPI
                                                  // capabilities and configuration
                                                  // returned in the Mailbox Response
                                                  // payload will reflect all
                                                  // configuration changes requested in
                                                  // the Request payload if successful. 
#define GET_WOL_CONFIG                  (2)       // This value when set requests that the
                                                  // SLI-Port to provide the Wake On LAN
                                                  // related capabilities and
                                                  // configurations for the targeted
                                                  // SLI-Hosts and Ethernet port. Note
                                                  // that the WOL capabilities and
                                                  // configuration returned in the Mailbox
                                                  // Response payload will reflect all
                                                  // configuration changes requested in
                                                  // the Request payload if successful 
#define ACPI_PATTERNS_VALID             (4)       // This field when set indicates that
                                                  // the NUM_ACPI_PATTERNS field is valid.
                                                  // When not set, this indicates that
                                                  // there are no ACPI configuration
                                                  // changes being requested via this
                                                  // command. 
#define WOL_MAC_VALID                   (8)       // This field when set indicates that
                                                  // the MAC_ADDRESS fields (Word 294,
                                                  // Bits31:0 and Word 295, Bits 15:0) are
                                                  // valid. When not set, this indicates
                                                  // that there are no WOL configurations
                                                  // being requested via this command. 
#define ARP_DIP_VALID                   (16)      // This field when set indicates that
                                                  // the ARP_DIP_ADDRESS field (Word 300)
                                                  // is valid. When not set, this
                                                  // indicates that there are no WOL IPv4
                                                  // ARP configuration changes being
                                                  // requested via this command. 
#define DN_DIP_VALID                    (32)      // This field when set indicates that
                                                  // the ND_DIP_ADDRESS fields (Words 296,
                                                  // 297, 298 and 299) are valid. When not
                                                  // set, this indicates that there are no
                                                  // WOL IPv6 Neighbor Discovery (ND)
                                                  // offload configuration changes being
                                                  // requested via this command 

typedef enum {
   ENUM_GET_ACPI_CONFIG = 0x1UL,
   ENUM_GET_WOL_CONFIG = 0x2UL,
   ENUM_ACPI_PATTERNS_VALID = 0x4UL,
   ENUM_WOL_MAC_VALID = 0x8UL,
   ENUM_ARP_DIP_VALID = 0x10UL,
   ENUM_DN_DIP_VALID = 0x20UL
} ACPI_WOL_MAGIC_CONFIG_V1_ENUM;

// --- ACPI_WOL_ENUM ---
#define WOL_CAP                         (1)       // This is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port provides
                                                  // WOL support and this Mailbox command
                                                  // may be used to explicitly configure
                                                  // the Magic packet MAC address. The
                                                  // explicit configuration of such a
                                                  // Magic packet MAC address
                                                  // automatically enables the WOL support
                                                  // which may be subsequently disabled by
                                                  // explicitly configuring a zero-valued
                                                  // Magic packet MAC address. </br></br>
                                                  // Note that an explicitly configured
                                                  // Magic packet MAC address will always
                                                  // override the out-of-box Magic packet
                                                  // MAC address if WOL is supported
                                                  // out-of-box (see OOBOX_WOL_CAP field
                                                  // in Word 4, Bit 17).</br> 
#define OOBOX_WOL_CAP                   (2)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // implicitly configured for WOL support
                                                  // out-of-box wherein, the Permanent
                                                  // Override MAC address is used to
                                                  // construct the Magic Packet pattern.
                                                  // This field when set to 0x0, indicates
                                                  // that WOL support is further decided
                                                  // by the WOL_CAP field in Word 4, Bit
                                                  // 16.</br> 
#define WOL_ACPI_MODE                   (4)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. If this bit is on,
                                                  // the SLI-Port is operating in the
                                                  // Unique mode. Else, the SLI-Port is
                                                  // operating in the Common mode.
                                                  // </br></br> In the Unique mode, these
                                                  // parameters are unique per targeted
                                                  // <SLI-Host, Ethernet-port> pair. Thus,
                                                  // specifying different parameters in
                                                  // successive invocations of this
                                                  // command with a different targeted
                                                  // SLI-Host each time, allows unique
                                                  // parameter settings for each SLI-Host
                                                  // even if they are mapped to the same
                                                  // targeted Ethernet port. </br></br> In
                                                  // the Common mode by contrast, these
                                                  // parameters are unique per targeted
                                                  // Ethernet-port but common for all
                                                  // targeted SLI-Hosts mapped to it.
                                                  // Thus, specifying different parameters
                                                  // in successive invocations of this
                                                  // command with a different targeted
                                                  // SLI-Host each time updates the
                                                  // parameters for all SLI-Hosts mapped
                                                  // to the same targeted Ethernet
                                                  // port.</br> 
#define PME_D0_CAP                      (8)       // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D0 PCIe
                                                  // power state. 
#define PME_D1_CAP                      (16)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D1 PCIe
                                                  // power state. 
#define PME_D2_CAP                      (32)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D2 PCIe
                                                  // power state. 
#define PME_D3HOT_CAP                   (64)      // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D3-Hot
                                                  // PCIe power state. 
#define PME_D3COLD_CAP                  (128)     // This field is only valid if the
                                                  // GET_WOL_CONFIG field (Word 4, Bit 17)
                                                  // bit has been set in the Mailbox
                                                  // Request payload. This field when set
                                                  // indicates that the SLI-Port is
                                                  // capable of generating a PME Wake
                                                  // event when operating in the D3-Cold
                                                  // PCIe power state. 

typedef enum {
   ENUM_WOL_CAP = 0x1UL,
   ENUM_OOBOX_WOL_CAP = 0x2UL,
   ENUM_WOL_ACPI_MODE = 0x4UL,
   ENUM_PME_D0_CAP = 0x8UL,
   ENUM_PME_D1_CAP = 0x10UL,
   ENUM_PME_D2_CAP = 0x20UL,
   ENUM_PME_D3HOT_CAP = 0x40UL,
   ENUM_PME_D3COLD_CAP = 0x80UL
} ACPI_WOL_ENUM;

// --- ACPI_CAPABILITIES_ENUM ---
#define ACPI_ND_OFFLOAD                 (1)       // This field is only valid if the
                                                  // GET_ACPI_CONFIG field (Word 4, Bit
                                                  // 16) bit has been set in the Mailbox
                                                  // Request payload. This field indicates
                                                  // that the SLI-Port is capable of
                                                  // providing ACPI ND offload support. 
#define ACPI_ARP_OFFLOAD                (2)       // This field is only valid if the
                                                  // GET_ACPI_CONFIG field (Word 4, Bit
                                                  // 16) bit has been set in the Mailbox
                                                  // Request payload. This field indicates
                                                  // that the SLI-Port is capable of
                                                  // providing ACPI ARP offload support. 

typedef enum {
   ENUM_ACPI_ND_OFFLOAD = 0x1UL,
   ENUM_ACPI_ARP_OFFLOAD = 0x2UL
} ACPI_CAPABILITIES_ENUM;

// --- ENABLE_RSS_ENUM ---
// Enable RSS enum. Bits needs to be or'ed in
#define RSS_ENABLE_NONE                 (0)       // No RSS
#define RSS_ENABLE_IPV4                 (1)       // IPV4 HASH enabled 
#define RSS_ENABLE_TCP_IPV4             (2)       // TCP IPV4 Hash enabled
#define RSS_ENABLE_IPV6                 (4)       // IPV6 HASH enabled
#define RSS_ENABLE_TCP_IPV6             (8)       // TCP IPV6 HASH enabled

typedef enum {
   ENUM_RSS_ENABLE_NONE = 0x0UL,
   ENUM_RSS_ENABLE_IPV4 = 0x1UL,
   ENUM_RSS_ENABLE_TCP_IPV4 = 0x2UL,
   ENUM_RSS_ENABLE_IPV6 = 0x4UL,
   ENUM_RSS_ENABLE_TCP_IPV6 = 0x8UL
} ENABLE_RSS_ENUM;

// --- HEADER_DMA_ENUM ---
#define HEADER_DMA_TO_HEADER            (1)       
#define HEADER_DMA_TO_DATA              (2)       
#define HEADER_DMA_TO_HEADER_AND_DATA   (3)       

typedef enum {
   ENUM_HEADER_DMA_TO_HEADER = 0x1UL,
   ENUM_HEADER_DMA_TO_DATA = 0x2UL,
   ENUM_HEADER_DMA_TO_HEADER_AND_DATA = 0x3UL
} HEADER_DMA_ENUM;

// --- HEADER_SPLIT_LOCATION_ENUM ---
#define HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER (0) // The packet is split directly after
                                                    // the TCP or UDP header, if it
                                                    // exists. Otherwise, it is split
                                                    // directly after the IPv4 or IPv6
                                                    // header. 
#define HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER (1) // The packet is split directly after
                                                   // the IPv4 or IPv6 header. 
#define HEADER_SPLIT_LOCATION_FIXED     (2)       // The packet is split on a fixed
                                                  // boundary specified by
                                                  // fixed_split_location field. 

typedef enum {
   ENUM_HEADER_SPLIT_LOCATION_BEFORE_ULP_HEADER = 0x0UL,
   ENUM_HEADER_SPLIT_LOCATION_AFTER_ULP_HEADER = 0x1UL,
   ENUM_HEADER_SPLIT_LOCATION_FIXED = 0x2UL
} HEADER_SPLIT_LOCATION_ENUM;

#endif // __ioctl_eth_enum_h__

