/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_extfat_enum_h__
#define __ioctl_extfat_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- EXT_FAT_PARAM_TYPE ---
#define EXT_FAT_PARAM_TYPE_DFEFAULT     (0)       // Default static parameters 
#define EXT_FAT_PARAM_TYPE_CURRENT      (1)       // Currently set parameters 

typedef enum {
   ENUM_EXT_FAT_PARAM_TYPE_DFEFAULT = 0x0UL,
   ENUM_EXT_FAT_PARAM_TYPE_CURRENT = 0x1UL
} EXT_FAT_PARAM_TYPE;

// --- EXT_FAT_RETRIEVE_MODE ---
#define EXT_FAT_RETRIEVE_MODE_VRAM      (0)       // RAM/DDR 
#define EXT_FAT_RETRIEVE_MODE_NVRAM     (1)       // FLASH 

typedef enum {
   ENUM_EXT_FAT_RETRIEVE_MODE_VRAM = 0x0UL,
   ENUM_EXT_FAT_RETRIEVE_MODE_NVRAM = 0x1UL
} EXT_FAT_RETRIEVE_MODE;

// --- EXT_FAT_LOG_TYPE ---
#define LOG_TYPE_SYNCHRONOUS            (0)       // Logging synchronous
#define LOG_TYPE_ASYNCHRONOUS           (1)       // Logging asynchronous(deferred)

typedef enum {
   ENUM_LOG_TYPE_SYNCHRONOUS = 0x0UL,
   ENUM_LOG_TYPE_ASYNCHRONOUS = 0x1UL
} EXT_FAT_LOG_TYPE;

// --- EXT_FAT_SUPPORTED_LOGGING_MODES ---
#define LOG_MODE_UART_MASK              (1)       // Log to UART
#define LOG_MODE_RAM_MASK               (2)       // Log to votalite RAM
#define LOG_MODE_NVRAM_MASK             (4)       // Log to NVRAM
#define LOG_MODE_NWTK_MASK              (8)       // Log to network client ot TFTP

typedef enum {
   ENUM_LOG_MODE_UART_MASK = 0x1UL,
   ENUM_LOG_MODE_RAM_MASK = 0x2UL,
   ENUM_LOG_MODE_NVRAM_MASK = 0x4UL,
   ENUM_LOG_MODE_NWTK_MASK = 0x8UL
} EXT_FAT_SUPPORTED_LOGGING_MODES;

// --- EXT_FAT_LOGGING_MODE_ENUM ---
#define LOG_MODE_UART                   (0)       // Log to UART
#define LOG_MODE_RAM                    (1)       // Log to votalite RAM
#define LOG_MODE_NVRAM                  (2)       // Log to NVRAM
#define LOG_MODE_NWTK                   (3)       // Log to network client ot TFTP
#define LOG_MODE_MAX                    (3)       

typedef enum {
   ENUM_LOG_MODE_UART = 0x0UL,
   ENUM_LOG_MODE_RAM = 0x1UL,
   ENUM_LOG_MODE_NVRAM = 0x2UL,
   ENUM_LOG_MODE_NWTK = 0x3UL,
   ENUM_LOG_MODE_MAX = 0x3UL
} EXT_FAT_LOGGING_MODE_ENUM;

// --- ARM_TRACE_LEVEL_ENUM ---
// Valid trace levels. There are 4-bits allocated for trace level. 
#define TRACE_LEVEL_ALL                 (0)       
#define TRACE_LEVEL_ENTER_FUNCTION      (1)       
#define TRACE_LEVEL_VERBOSE             (4)       
#define TRACE_LEVEL_INFO                (5)       
#define TRACE_LEVEL_TEST                (8)       
#define TRACE_LEVEL_SHOW                (16)      
#define TRACE_LEVEL_WARNING             (32)      
#define TRACE_LEVEL_ERROR               (48)      
#define TRACE_LEVEL_FATAL               (64)      
#define TRACE_LEVEL_ALWAYS              (128)     
#define TRACE_LEVEL_DISABLED            (255)     
#define TRACE_LEVEL_MAX                 (255)     

typedef enum {
   ENUM_TRACE_LEVEL_ALL = 0x0UL,
   ENUM_TRACE_LEVEL_ENTER_FUNCTION = 0x1UL,
   ENUM_TRACE_LEVEL_VERBOSE = 0x4UL,
   ENUM_TRACE_LEVEL_INFO = 0x5UL,
   ENUM_TRACE_LEVEL_TEST = 0x8UL,
   ENUM_TRACE_LEVEL_SHOW = 0x10UL,
   ENUM_TRACE_LEVEL_WARNING = 0x20UL,
   ENUM_TRACE_LEVEL_ERROR = 0x30UL,
   ENUM_TRACE_LEVEL_FATAL = 0x40UL,
   ENUM_TRACE_LEVEL_ALWAYS = 0x80UL,
   ENUM_TRACE_LEVEL_DISABLED = 0xffUL,
   ENUM_TRACE_LEVEL_MAX = 0xffUL
} ARM_TRACE_LEVEL_ENUM;

#endif // __ioctl_extfat_enum_h__

