/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_lldp_enum_h__
#define __ioctl_lldp_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- LLDP_STATE ---
// By default, both Tx and Rx are enabled 
#define LLDP_STATE_DISABLED             (0)       // LLDP is disabled on this port 
#define LLDP_STATE_TX_ENABLED           (1)       // LLDP TLVs can be transmitted 
#define LLDP_STATE_RX_ENABLED           (2)       // LLDP TLVs can be received 

typedef enum {
   ENUM_LLDP_STATE_DISABLED = 0x0UL,
   ENUM_LLDP_STATE_TX_ENABLED = 0x1UL,
   ENUM_LLDP_STATE_RX_ENABLED = 0x2UL
} LLDP_STATE;

// --- LLDP_TLV_STATE ---
#define LLDP_TLV_DISABLE                (0)       // Disable this TLV
#define LLDP_TLV_ENABLE                 (1)       // Enable this TLV

typedef enum {
   ENUM_LLDP_TLV_DISABLE = 0x0UL,
   ENUM_LLDP_TLV_ENABLE = 0x1UL
} LLDP_TLV_STATE;

// --- LLDP_ASYNC_STATE ---
#define LLDP_ASYNC_DISABLE              (0)       // Disable async messages for TTL expiry
                                                  // or negotiation errors 
#define LLDP_ASYNC_ENABLE               (1)       // Enable async messages for TTL expiry
                                                  // and negotiation errors

typedef enum {
   ENUM_LLDP_ASYNC_DISABLE = 0x0UL,
   ENUM_LLDP_ASYNC_ENABLE = 0x1UL
} LLDP_ASYNC_STATE;

// --- LLDP_PARAM_TYPE ---
#define LLDP_PARAM_TYPE_ADMIN           (0)       // Parameters set by Admin 
#define LLDP_PARAM_TYPE_PEER            (1)       // Peer Parameters 

typedef enum {
   ENUM_LLDP_PARAM_TYPE_ADMIN = 0x0UL,
   ENUM_LLDP_PARAM_TYPE_PEER = 0x1UL
} LLDP_PARAM_TYPE;

// --- LLDP_CHASSIS_TYPE ---
#define LLDP_CHASSIS_ID_CHASSIS_COMPONENT (1)     
#define LLDP_CHASSIS_ID_INTERFACE_ALIAS (2)       
#define LLDP_CHASSIS_ID_PORT_COMPONENT  (3)       
#define LLDP_CHASSIS_ID_MAC_ADDRESS     (4)       
#define LLDP_CHASSIS_ID_NETWORK_ADDRESS (5)       
#define LLDP_CHASSIS_ID_INTERFACE_NAME  (6)       
#define LLDP_CHASSIS_ID_LOCALLY_ASSIGNED (7)      

typedef enum {
   ENUM_LLDP_CHASSIS_ID_CHASSIS_COMPONENT = 0x1UL,
   ENUM_LLDP_CHASSIS_ID_INTERFACE_ALIAS = 0x2UL,
   ENUM_LLDP_CHASSIS_ID_PORT_COMPONENT = 0x3UL,
   ENUM_LLDP_CHASSIS_ID_MAC_ADDRESS = 0x4UL,
   ENUM_LLDP_CHASSIS_ID_NETWORK_ADDRESS = 0x5UL,
   ENUM_LLDP_CHASSIS_ID_INTERFACE_NAME = 0x6UL,
   ENUM_LLDP_CHASSIS_ID_LOCALLY_ASSIGNED = 0x7UL
} LLDP_CHASSIS_TYPE;

// --- LLDP_PORT_TYPE ---
#define LLDP_PORT_ID_INTERFACE_ALIAS    (1)       
#define LLDP_PORT_ID_PORT_COMPONENT     (2)       
#define LLDP_PORT_ID_MAC_ADDRESS        (3)       
#define LLDP_PORT_ID_NETWORK_ADDRESS    (4)       
#define LLDP_PORT_ID_INTERFACE_NAME     (5)       
#define LLDP_PORT_ID_AGENT_CIRCUIT_ID   (6)       
#define LLDP_PORT_ID_LOCALLY_ASSIGNED   (7)       

typedef enum {
   ENUM_LLDP_PORT_ID_INTERFACE_ALIAS = 0x1UL,
   ENUM_LLDP_PORT_ID_PORT_COMPONENT = 0x2UL,
   ENUM_LLDP_PORT_ID_MAC_ADDRESS = 0x3UL,
   ENUM_LLDP_PORT_ID_NETWORK_ADDRESS = 0x4UL,
   ENUM_LLDP_PORT_ID_INTERFACE_NAME = 0x5UL,
   ENUM_LLDP_PORT_ID_AGENT_CIRCUIT_ID = 0x6UL,
   ENUM_LLDP_PORT_ID_LOCALLY_ASSIGNED = 0x7UL
} LLDP_PORT_TYPE;

// --- LLDP_SYSTEM_CAPABILITY_TYPE ---
#define LLDP_SYSTEM_CAPABILITY_OTHER    (1)       
#define LLDP_SYSTEM_CAPABILITY_REPEATER (2)       
#define LLDP_SYSTEM_CAPABILITY_BRIDGE   (4)       
#define LLDP_SYSTEM_CAPABILITY_WLAN     (8)       
#define LLDP_SYSTEM_CAPABILITY_ROUTER   (16)      
#define LLDP_SYSTEM_CAPABILITY_TELEPHONE (32)     
#define LLDP_SYSTEM_CAPABILITY_DOCSIS   (64)      
#define LLDP_SYSTEM_CAPABILITY_STATION  (128)     

typedef enum {
   ENUM_LLDP_SYSTEM_CAPABILITY_OTHER = 0x1UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_REPEATER = 0x2UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_BRIDGE = 0x4UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_WLAN = 0x8UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_ROUTER = 0x10UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_TELEPHONE = 0x20UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_DOCSIS = 0x40UL,
   ENUM_LLDP_SYSTEM_CAPABILITY_STATION = 0x80UL
} LLDP_SYSTEM_CAPABILITY_TYPE;

// --- LLDP_MAX_DEFINITIONS ---
#define LLDP_MAX_MGMT_IP_ADDR_LEN       (16)      
#define LLDP_MAX_CHASSIS_ID_LEN         (256)     
#define LLDP_MAX_PORT_ID_LEN            (256)     
#define LLDP_MAX_SYSTEM_NAME_LEN        (256)     
#define LLDP_MAX_SYSTEM_DESCRIPTION_LEN (256)     
#define LLDP_MAX_PORT_NAME_LEN          (256)     
#define LLDP_MAX_PORT_DESCRIPTION_LEN   (256)     

typedef enum {
   ENUM_LLDP_MAX_MGMT_IP_ADDR_LEN = 0x10UL,
   ENUM_LLDP_MAX_CHASSIS_ID_LEN = 0x100UL,
   ENUM_LLDP_MAX_PORT_ID_LEN = 0x100UL,
   ENUM_LLDP_MAX_SYSTEM_NAME_LEN = 0x100UL,
   ENUM_LLDP_MAX_SYSTEM_DESCRIPTION_LEN = 0x100UL,
   ENUM_LLDP_MAX_PORT_NAME_LEN = 0x100UL,
   ENUM_LLDP_MAX_PORT_DESCRIPTION_LEN = 0x100UL
} LLDP_MAX_DEFINITIONS;

#endif // __ioctl_lldp_enum_h__

