/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_rdma_enum_h__
#define __ioctl_rdma_enum_h__
#include "setypes.h"
#include "nativedefs_enum.h"
#include "ioctl_hdr_enum.h"
#include "ioctl_types_enum.h"
#include "ioctl_common_enum.h"
#include "fw_exp_enum.h"
#include "rdma_context_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- RDMA_CXN_UPLOAD_PARAMS ---
// These parameters are used to define the type of upload desired. 
#define RDMA_CXN_UPLOAD_GRACEFUL        (1)       // Graceful upload 
#define RDMA_CXN_UPLOAD_ABORT_RESET     (2)       // Abortive upload with reset 
#define RDMA_CXN_UPLOAD_ABORT           (3)       // Abortive upload without reset 
#define RDMA_CXN_UPLOAD_ABORT_WITH_SEQ  (4)       // Abortive upload with reset, sequence
                                                  // number by driver 

typedef enum {
   ENUM_RDMA_CXN_UPLOAD_GRACEFUL = 0x1UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT_RESET = 0x2UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT = 0x3UL,
   ENUM_RDMA_CXN_UPLOAD_ABORT_WITH_SEQ = 0x4UL
} RDMA_CXN_UPLOAD_PARAMS;

#endif // __ioctl_rdma_enum_h__

