/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_local_mmr_enum_h__
#define __mpu_local_mmr_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- MPU_RR_CTRL_TYPE_ENUM ---
#define RR_CTRL_TYPE_NODE               (0)       // Internal node target
#define RR_CTRL_TYPE_MEM                (1)       // Memory cycle type
#define RR_CTRL_TYPE_IO                 (2)       // I/O cycle type
#define RR_CTRL_TYPE_CFG                (3)       // Config cycle type

typedef enum {
   ENUM_RR_CTRL_TYPE_NODE = 0x0UL,
   ENUM_RR_CTRL_TYPE_MEM = 0x1UL,
   ENUM_RR_CTRL_TYPE_IO = 0x2UL,
   ENUM_RR_CTRL_TYPE_CFG = 0x3UL
} MPU_RR_CTRL_TYPE_ENUM;

// --- MPU_RR_CTRL_BARNUM_ENUM ---
#define RR_CTRL_BARNUM_0                (0)       // BAR 0
#define RR_CTRL_BARNUM_1                (1)       // BAR 1
#define RR_CTRL_BARNUM_2                (2)       // BAR 2
#define RR_CTRL_BARNUM_3                (3)       // BAR 3

typedef enum {
   ENUM_RR_CTRL_BARNUM_0 = 0x0UL,
   ENUM_RR_CTRL_BARNUM_1 = 0x1UL,
   ENUM_RR_CTRL_BARNUM_2 = 0x2UL,
   ENUM_RR_CTRL_BARNUM_3 = 0x3UL
} MPU_RR_CTRL_BARNUM_ENUM;

// --- INT_UE_ONLINE_SRC_LOC_ENUM ---
// Enumeration for interrupt, unrecoverable error and online bit field locations. 
#define LOC_CEV_SRC                     (0)       
#define LOC_CTX_SRC                     (1)       
#define LOC_DBUF_SRC                    (2)       
#define LOC_ERX_SRC                     (3)       
#define LOC_HOST_SRC                    (4)       
#define LOC_MPU_SRC                     (5)       
#define LOC_NDMA_SRC                    (6)       
#define LOC_PTC_SRC                     (7)       
#define LOC_RDMA_SRC                    (8)       
#define LOC_RXF_SRC                     (9)       
#define LOC_RXIPS_SRC                   (10)      
#define LOC_RXULP0_SRC                  (11)      
#define LOC_RXULP1_SRC                  (12)      
#define LOC_WCON_SRC                    (13)      
#define LOC_TIM_SRC                     (14)      
#define LOC_TPOST_SRC                   (15)      
#define LOC_TPRE_SRC                    (16)      
#define LOC_TXIPS_SRC                   (17)      
#define LOC_TXULP0_SRC                  (18)      
#define LOC_TXULP1_SRC                  (19)      
#define LOC_UC_SRC                      (20)      
#define LOC_WDMA_SRC                    (21)      
#define LOC_TXULP2_SRC                  (22)      
#define LOC_HOST1_SRC                   (23)      
#define LOC_P0_OB_LINK_SRC              (24)      
#define LOC_P1_OB_LINK_SRC              (25)      
#define LOC_HOST_GPIO_SRC               (26)      
#define LOC_MBOX_SRC                    (27)      
#define LOC_AXGMAC0_SRC                 (28)      
#define LOC_AXGMAC1_SRC                 (29)      
#define LOC_JTAG_SRC                    (30)      
#define LOC_MPU_INTPEND_SRC             (31)      
#define LOC_LPCMEMHOST_SRC              (32)      
#define LOC_MGMT_MAC_SRC                (33)      
#define LOC_PCS0ONLINE_SRC              (34)      
#define LOC_MPU_IRAM_SRC                (35)      
#define LOC_PCS1ONLINE_SRC              (36)      
#define LOC_PCTL0_SRC                   (37)      
#define LOC_PCTL1_SRC                   (38)      
#define LOC_PMEM_SRC                    (39)      
#define LOC_RR_SRC                      (40)      
#define LOC_TXPB_SRC                    (41)      
#define LOC_RXPP_SRC                    (42)      
#define LOC_XAUI_SRC                    (43)      
#define LOC_TXP_SRC                     (44)      
#define LOC_ARM_SRC                     (45)      
#define LOC_IPC_SRC                     (46)      
#define LOC_HOST2_SRC                   (47)      
#define LOC_HOST3_SRC                   (48)      
#define LOC_HOST4_SRC                   (49)      
#define LOC_HOST5_SRC                   (50)      
#define LOC_HOST6_SRC                   (51)      
#define LOC_HOST7_SRC                   (52)      
#define LOC_HOST8_SRC                   (53)      

typedef enum {
   ENUM_LOC_CEV_SRC = 0x0UL,
   ENUM_LOC_CTX_SRC = 0x1UL,
   ENUM_LOC_DBUF_SRC = 0x2UL,
   ENUM_LOC_ERX_SRC = 0x3UL,
   ENUM_LOC_HOST_SRC = 0x4UL,
   ENUM_LOC_MPU_SRC = 0x5UL,
   ENUM_LOC_NDMA_SRC = 0x6UL,
   ENUM_LOC_PTC_SRC = 0x7UL,
   ENUM_LOC_RDMA_SRC = 0x8UL,
   ENUM_LOC_RXF_SRC = 0x9UL,
   ENUM_LOC_RXIPS_SRC = 0xaUL,
   ENUM_LOC_RXULP0_SRC = 0xbUL,
   ENUM_LOC_RXULP1_SRC = 0xcUL,
   ENUM_LOC_WCON_SRC = 0xdUL,
   ENUM_LOC_TIM_SRC = 0xeUL,
   ENUM_LOC_TPOST_SRC = 0xfUL,
   ENUM_LOC_TPRE_SRC = 0x10UL,
   ENUM_LOC_TXIPS_SRC = 0x11UL,
   ENUM_LOC_TXULP0_SRC = 0x12UL,
   ENUM_LOC_TXULP1_SRC = 0x13UL,
   ENUM_LOC_UC_SRC = 0x14UL,
   ENUM_LOC_WDMA_SRC = 0x15UL,
   ENUM_LOC_TXULP2_SRC = 0x16UL,
   ENUM_LOC_HOST1_SRC = 0x17UL,
   ENUM_LOC_P0_OB_LINK_SRC = 0x18UL,
   ENUM_LOC_P1_OB_LINK_SRC = 0x19UL,
   ENUM_LOC_HOST_GPIO_SRC = 0x1aUL,
   ENUM_LOC_MBOX_SRC = 0x1bUL,
   ENUM_LOC_AXGMAC0_SRC = 0x1cUL,
   ENUM_LOC_AXGMAC1_SRC = 0x1dUL,
   ENUM_LOC_JTAG_SRC = 0x1eUL,
   ENUM_LOC_MPU_INTPEND_SRC = 0x1fUL,
   ENUM_LOC_LPCMEMHOST_SRC = 0x20UL,
   ENUM_LOC_MGMT_MAC_SRC = 0x21UL,
   ENUM_LOC_PCS0ONLINE_SRC = 0x22UL,
   ENUM_LOC_MPU_IRAM_SRC = 0x23UL,
   ENUM_LOC_PCS1ONLINE_SRC = 0x24UL,
   ENUM_LOC_PCTL0_SRC = 0x25UL,
   ENUM_LOC_PCTL1_SRC = 0x26UL,
   ENUM_LOC_PMEM_SRC = 0x27UL,
   ENUM_LOC_RR_SRC = 0x28UL,
   ENUM_LOC_TXPB_SRC = 0x29UL,
   ENUM_LOC_RXPP_SRC = 0x2aUL,
   ENUM_LOC_XAUI_SRC = 0x2bUL,
   ENUM_LOC_TXP_SRC = 0x2cUL,
   ENUM_LOC_ARM_SRC = 0x2dUL,
   ENUM_LOC_IPC_SRC = 0x2eUL,
   ENUM_LOC_HOST2_SRC = 0x2fUL,
   ENUM_LOC_HOST3_SRC = 0x30UL,
   ENUM_LOC_HOST4_SRC = 0x31UL,
   ENUM_LOC_HOST5_SRC = 0x32UL,
   ENUM_LOC_HOST6_SRC = 0x33UL,
   ENUM_LOC_HOST7_SRC = 0x34UL,
   ENUM_LOC_HOST8_SRC = 0x35UL
} INT_UE_ONLINE_SRC_LOC_ENUM;

// --- INT_UE_ONLINE_SRC0_ENUM ---
// Enumeration for interrupt source 0 values 
#define CEV_SRC                         (1)       
#define CTX_SRC                         (2)       
#define DBUF_SRC                        (4)       
#define ERX_SRC                         (8)       
#define HOST_SRC                        (16)      
#define MPU_SRC                         (32)      
#define NDMA_SRC                        (64)      
#define PTC_SRC                         (128)     
#define RDMA_SRC                        (256)     
#define RXF_SRC                         (512)     
#define RXIPS_SRC                       (1024)    
#define RXULP0_SRC                      (2048)    
#define RXULP1_SRC                      (4096)    
#define WCON_SRC                        (8192)    
#define TIM_SRC                         (16384)   
#define TPOST_SRC                       (32768)   
#define TPRE_SRC                        (65536)   
#define TXIPS_SRC                       (131072)  
#define TXULP0_SRC                      (262144)  
#define TXULP1_SRC                      (524288)  
#define UC_SRC                          (1048576) 
#define WDMA_SRC                        (2097152) 
#define TXULP2_SRC                      (4194304) 
#define HOST1_SRC                       (8388608) 
#define P0_OB_LINK_SRC                  (16777216) 
#define P1_OB_LINK_SRC                  (33554432) 
#define HOST_GPIO_SRC                   (67108864) 
#define MBOX_SRC                        (134217728) 
#define AXGMAC0_SRC                     (268435456) 
#define AXGMAC1_SRC                     (536870912) 
#define JTAG_SRC                        (1073741824) 
#define MPU_INTPEND_SRC                 (2147483648) 

typedef enum {
   ENUM_CEV_SRC = 0x1UL,
   ENUM_CTX_SRC = 0x2UL,
   ENUM_DBUF_SRC = 0x4UL,
   ENUM_ERX_SRC = 0x8UL,
   ENUM_HOST_SRC = 0x10UL,
   ENUM_MPU_SRC = 0x20UL,
   ENUM_NDMA_SRC = 0x40UL,
   ENUM_PTC_SRC = 0x80UL,
   ENUM_RDMA_SRC = 0x100UL,
   ENUM_RXF_SRC = 0x200UL,
   ENUM_RXIPS_SRC = 0x400UL,
   ENUM_RXULP0_SRC = 0x800UL,
   ENUM_RXULP1_SRC = 0x1000UL,
   ENUM_WCON_SRC = 0x2000UL,
   ENUM_TIM_SRC = 0x4000UL,
   ENUM_TPOST_SRC = 0x8000UL,
   ENUM_TPRE_SRC = 0x10000UL,
   ENUM_TXIPS_SRC = 0x20000UL,
   ENUM_TXULP0_SRC = 0x40000UL,
   ENUM_TXULP1_SRC = 0x80000UL,
   ENUM_UC_SRC = 0x100000UL,
   ENUM_WDMA_SRC = 0x200000UL,
   ENUM_TXULP2_SRC = 0x400000UL,
   ENUM_HOST1_SRC = 0x800000UL,
   ENUM_P0_OB_LINK_SRC = 0x1000000UL,
   ENUM_P1_OB_LINK_SRC = 0x2000000UL,
   ENUM_HOST_GPIO_SRC = 0x4000000UL,
   ENUM_MBOX_SRC = 0x8000000UL,
   ENUM_AXGMAC0_SRC = 0x10000000UL,
   ENUM_AXGMAC1_SRC = 0x20000000UL,
   ENUM_JTAG_SRC = 0x40000000UL,
   ENUM_MPU_INTPEND_SRC = 0x80000000UL
} INT_UE_ONLINE_SRC0_ENUM;

// --- INT_UE_ONLINE_SRC1_ENUM ---
// Enumeration for interrupt source 1 values 
#define LPCMEMHOST_SRC                  (1)       
#define MGMT_MAC_SRC                    (2)       
#define PCS0ONLINE_SRC                  (4)       
#define MPU_IRAM_SRC                    (8)       
#define PCS1ONLINE_SRC                  (16)      
#define PCTL0_SRC                       (32)      
#define PCTL1_SRC                       (64)      
#define PMEM_SRC                        (128)     
#define RR_SRC                          (256)     
#define TXPB_SRC                        (512)     
#define RXPP_SRC                        (1024)    
#define XAUI_SRC                        (2048)    
#define TXP_SRC                         (4096)    
#define ARM_SRC                         (8192)    
#define IPC_SRC                         (16384)   
#define HOST2_SRC                       (32768)   
#define HOST3_SRC                       (65536)   
#define HOST4_SRC                       (131072)  
#define HOST5_SRC                       (262144)  
#define HOST6_SRC                       (524288)  
#define HOST7_SRC                       (1048576) 
#define HOST8_SRC                       (2097152) 

typedef enum {
   ENUM_LPCMEMHOST_SRC = 0x1UL,
   ENUM_MGMT_MAC_SRC = 0x2UL,
   ENUM_PCS0ONLINE_SRC = 0x4UL,
   ENUM_MPU_IRAM_SRC = 0x8UL,
   ENUM_PCS1ONLINE_SRC = 0x10UL,
   ENUM_PCTL0_SRC = 0x20UL,
   ENUM_PCTL1_SRC = 0x40UL,
   ENUM_PMEM_SRC = 0x80UL,
   ENUM_RR_SRC = 0x100UL,
   ENUM_TXPB_SRC = 0x200UL,
   ENUM_RXPP_SRC = 0x400UL,
   ENUM_XAUI_SRC = 0x800UL,
   ENUM_TXP_SRC = 0x1000UL,
   ENUM_ARM_SRC = 0x2000UL,
   ENUM_IPC_SRC = 0x4000UL,
   ENUM_HOST2_SRC = 0x8000UL,
   ENUM_HOST3_SRC = 0x10000UL,
   ENUM_HOST4_SRC = 0x20000UL,
   ENUM_HOST5_SRC = 0x40000UL,
   ENUM_HOST6_SRC = 0x80000UL,
   ENUM_HOST7_SRC = 0x100000UL,
   ENUM_HOST8_SRC = 0x200000UL
} INT_UE_ONLINE_SRC1_ENUM;

#endif // __mpu_local_mmr_enum_h__

