/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rdma_context_enum_h__
#define __rdma_context_enum_h__
#include "setypes.h"
#include "defines_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- RDMA_CTXT_FLAGS_ENUM ---
// QP Configuration flags
#define QPCF_RX_MPA_EN                  (1)       // Receive MPA encapsulation enabled
#define QPCF_TX_MPA_EN                  (2)       // Transmit MPA encapsulation enabled
#define QPCF_IRD_RESP_EN                (4)       // Allow inbound rdma read responses on
                                                  // this QP
#define QPCF_IRD_REQ_EN                 (8)       // Allow inbound rdma read requests on
                                                  // this QP
#define QPCF_ORD_EN                     (16)      // Allow outbound rdma read requests on
                                                  // this QP
#define QPCF_IRW_EN                     (32)      // Allow inbound rdma writes on this QP
#define QPCF_ORW_EN                     (64)      // Allow outbound rdma writes on this QP
#define QPCF_MW_BIND_EN                 (128)     // Memory window binding enabled

typedef enum {
   ENUM_QPCF_RX_MPA_EN = 0x1UL,
   ENUM_QPCF_TX_MPA_EN = 0x2UL,
   ENUM_QPCF_IRD_RESP_EN = 0x4UL,
   ENUM_QPCF_IRD_REQ_EN = 0x8UL,
   ENUM_QPCF_ORD_EN = 0x10UL,
   ENUM_QPCF_IRW_EN = 0x20UL,
   ENUM_QPCF_ORW_EN = 0x40UL,
   ENUM_QPCF_MW_BIND_EN = 0x80UL
} RDMA_CTXT_FLAGS_ENUM;

// --- RDMA_STATE_ENUM ---
// RDMA State
#define RDMA_STATE_NONE                 (0)       
#define RDMA_STATE_IDLE                 (1)       
#define RDMA_STATE_RTS                  (2)       
#define RDMA_STATE_CLOSING              (4)       
#define RDMA_STATE_TERMINATE            (5)       
#define RDMA_STATE_RSVD                 (6)       
#define RDMA_STATE_ERROR                (7)       

typedef enum {
   ENUM_RDMA_STATE_NONE = 0x0UL,
   ENUM_RDMA_STATE_IDLE = 0x1UL,
   ENUM_RDMA_STATE_RTS = 0x2UL,
   ENUM_RDMA_STATE_CLOSING = 0x4UL,
   ENUM_RDMA_STATE_TERMINATE = 0x5UL,
   ENUM_RDMA_STATE_RSVD = 0x6UL,
   ENUM_RDMA_STATE_ERROR = 0x7UL
} RDMA_STATE_ENUM;

// --- RUNTIME_FLAGS_ENUM ---
#define ORRJ_MODIFIED                   (128)     // orrj modified

typedef enum {
   ENUM_ORRJ_MODIFIED = 0x80UL
} RUNTIME_FLAGS_ENUM;

// --- QP_SIZE_ENUM ---
#define SQ_SIZE_2                       (0)       // 2 entries
#define SQ_SIZE_4                       (1)       // 4 entries
#define SQ_SIZE_8                       (2)       // 8 entries
#define SQ_SIZE_16                      (3)       // 16 entries
#define SQ_SIZE_32                      (4)       // 32 entries
#define SQ_SIZE_64                      (5)       // 64 entries
#define SQ_SIZE_128                     (6)       // 128 entries
#define SQ_SIZE_256                     (7)       // 256 entries
#define SQ_SIZE_512                     (8)       // 512 entries - only valid for RQ.

typedef enum {
   ENUM_SQ_SIZE_2 = 0x0UL,
   ENUM_SQ_SIZE_4 = 0x1UL,
   ENUM_SQ_SIZE_8 = 0x2UL,
   ENUM_SQ_SIZE_16 = 0x3UL,
   ENUM_SQ_SIZE_32 = 0x4UL,
   ENUM_SQ_SIZE_64 = 0x5UL,
   ENUM_SQ_SIZE_128 = 0x6UL,
   ENUM_SQ_SIZE_256 = 0x7UL,
   ENUM_SQ_SIZE_512 = 0x8UL
} QP_SIZE_ENUM;

#endif // __rdma_context_enum_h__

