/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __rxf_enum_h__
#define __rxf_enum_h__
#include "setypes.h"
#include "defines_enum.h"
#include "hwdbg_reg_enum.h"
#include "gencommon_enum.h"


#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

// --- RXF_PCTL_DROP_RATE ---
// Receive filter port control drop rate.
#define RXF_PCTL_DROP_1_5               (0)       
#define RXF_PCTL_DROP_2_5               (1)       

typedef enum {
   ENUM_RXF_PCTL_DROP_1_5 = 0x0UL,
   ENUM_RXF_PCTL_DROP_2_5 = 0x1UL
} RXF_PCTL_DROP_RATE;

// --- RTPR_TABLE_ENUM ---
// This enumeration defines the index values for each table accessible through the
// RXF_RTPR_CSR register. 
#define MAC_ADDRESS_TABLE_INDEX         (0)       // MAC Address programming is discussed
                                                  // in the Programming the MAC Address
                                                  // Table section. 
#define MULTICAST_TABLE_INDEX           (1)       // Multicast programming is discussed in
                                                  // the Programming the Multicast Address
                                                  // Table section. 
#define VLAN_TABLE_INDEX                (2)       // VLAN programming is discussed in the
                                                  // Programming the VLAN Tag Table
                                                  // section. 
#define DA_TABLE_INDEX                  (3)       // DA programming is discussed in the
                                                  // Programming the RX Filter DA Table
                                                  // section. 
#define ACPI_TABLE_INDEX                (4)       // ACPI programming is discussed in the
                                                  // Programming the ACPI Filter Table
                                                  // section. 
#define OFFLOADED_CXN_TABLE_INDEX       (5)       // Connection programming is discussed
                                                  // in the Programming the TCP Connection
                                                  // Filter Table section. 
#define MAC0_REGISTER_TABLE_INDEX       (6)       // Multicast programming is discussed in
                                                  // the Direct MAC Programming Section
                                                  // section. 
#define MAC1_REGISTER_TABLE_INDEX       (7)       // Multicast programming is discussed in
                                                  // the Direct MAC Programming Section
                                                  // section. 
#define MGMT_MAC_REGISTER_TABLE_INDEX   (8)       // Management MAC programming is
                                                  // discussed in the Management MAC
                                                  // Programming section. 
#define RSS_KEY_TABLE_INDEX             (9)       // RSS key programming is discussed in
                                                  // the Programming the RSS Key Table
                                                  // section. 
#define RSS_TABLE_INDEX                 (10)      // RSS programming is discussed in the
                                                  // Programming the RSS CPU Table
                                                  // section. 
#define FCOE_TABLE_INDEX                (11)      // FCOE Table programming is discussed
                                                  // in the Programming the RX Filter
                                                  // Fibre Channel Over Ethernet (FCOE)
                                                  // Table section. 

typedef enum {
   ENUM_MAC_ADDRESS_TABLE_INDEX = 0x0UL,
   ENUM_MULTICAST_TABLE_INDEX = 0x1UL,
   ENUM_VLAN_TABLE_INDEX = 0x2UL,
   ENUM_DA_TABLE_INDEX = 0x3UL,
   ENUM_ACPI_TABLE_INDEX = 0x4UL,
   ENUM_OFFLOADED_CXN_TABLE_INDEX = 0x5UL,
   ENUM_MAC0_REGISTER_TABLE_INDEX = 0x6UL,
   ENUM_MAC1_REGISTER_TABLE_INDEX = 0x7UL,
   ENUM_MGMT_MAC_REGISTER_TABLE_INDEX = 0x8UL,
   ENUM_RSS_KEY_TABLE_INDEX = 0x9UL,
   ENUM_RSS_TABLE_INDEX = 0xaUL,
   ENUM_FCOE_TABLE_INDEX = 0xbUL
} RTPR_TABLE_ENUM;

// --- RX_VECTOR_ENUM ---
// Receive Interface Vector Programming Table
#define Network0                        (0)       
#define Network1                        (1)       
#define Storage0                        (2)       
#define Storage1                        (3)       
#define vm0                             (4)       
#define vm1                             (5)       
#define vm2                             (6)       
#define vm3                             (7)       
#define vm4                             (8)       
#define vm5                             (9)       
#define vm6                             (10)      
#define vm7                             (11)      
#define vm8                             (12)      
#define vm9                             (13)      
#define vm10                            (14)      
#define vm11                            (15)      
#define vm12                            (16)      
#define vm13                            (17)      
#define vm14                            (18)      
#define vm15                            (19)      
#define vm16                            (20)      
#define vm17                            (21)      
#define vm18                            (22)      
#define vm19                            (23)      
#define vm20                            (24)      
#define vm21                            (25)      
#define vm22                            (26)      
#define vm23                            (27)      
#define vm24                            (28)      
#define vm25                            (29)      
#define vm26                            (30)      
#define vm27                            (31)      
#define vm28                            (32)      
#define vm29                            (33)      
#define vm30                            (34)      
#define vm31                            (35)      
#define rxulp                           (36)      

typedef enum {
   ENUM_Network0 = 0x0UL,
   ENUM_Network1 = 0x1UL,
   ENUM_Storage0 = 0x2UL,
   ENUM_Storage1 = 0x3UL,
   ENUM_vm0 = 0x4UL,
   ENUM_vm1 = 0x5UL,
   ENUM_vm2 = 0x6UL,
   ENUM_vm3 = 0x7UL,
   ENUM_vm4 = 0x8UL,
   ENUM_vm5 = 0x9UL,
   ENUM_vm6 = 0xaUL,
   ENUM_vm7 = 0xbUL,
   ENUM_vm8 = 0xcUL,
   ENUM_vm9 = 0xdUL,
   ENUM_vm10 = 0xeUL,
   ENUM_vm11 = 0xfUL,
   ENUM_vm12 = 0x10UL,
   ENUM_vm13 = 0x11UL,
   ENUM_vm14 = 0x12UL,
   ENUM_vm15 = 0x13UL,
   ENUM_vm16 = 0x14UL,
   ENUM_vm17 = 0x15UL,
   ENUM_vm18 = 0x16UL,
   ENUM_vm19 = 0x17UL,
   ENUM_vm20 = 0x18UL,
   ENUM_vm21 = 0x19UL,
   ENUM_vm22 = 0x1aUL,
   ENUM_vm23 = 0x1bUL,
   ENUM_vm24 = 0x1cUL,
   ENUM_vm25 = 0x1dUL,
   ENUM_vm26 = 0x1eUL,
   ENUM_vm27 = 0x1fUL,
   ENUM_vm28 = 0x20UL,
   ENUM_vm29 = 0x21UL,
   ENUM_vm30 = 0x22UL,
   ENUM_vm31 = 0x23UL,
   ENUM_rxulp = 0x24UL
} RX_VECTOR_ENUM;

// --- RXF_CXN_TYPE_ENUM ---
#define RXF_CXN_TYPE_NON_OFFLOADED      (0)       
#define RXF_CXN_TYPE_RXULP0             (1)       
#define RXF_CXN_TYPE_RXULP1             (2)       
#define RXF_CXN_TYPE_RSVD               (3)       

typedef enum {
   ENUM_RXF_CXN_TYPE_NON_OFFLOADED = 0x0UL,
   ENUM_RXF_CXN_TYPE_RXULP0 = 0x1UL,
   ENUM_RXF_CXN_TYPE_RXULP1 = 0x2UL,
   ENUM_RXF_CXN_TYPE_RSVD = 0x3UL
} RXF_CXN_TYPE_ENUM;

// --- AMIIM_CMD_HSTMIIMCMD_ENUM ---
#define AMIIM_CMD_IDLE                  (0)       // Idle, no operation.
#define AMIIM_CMD_LEGACY_WRITE          (1)       // Legacy ( 10/100/1000 MBS PHY ) Write
#define AMIIM_CMD_LEGACY_READ           (2)       // Legacy ( 10/100/1000 MBS PHY ) Read
#define AMIIM_CMD_SINGLE_PHY_MONITOR    (3)       // Single Phy Monitor operation. The
                                                  // AMIIM will continually read from a
                                                  // single PHY register specified by the
                                                  // contents of the hstphyadx and
                                                  // hstregadx fields. 
#define AMIIM_CMD_MULTI_PHY_MONITOR     (4)       // Multiple PHY Monitor operation. The
                                                  // AMIIM will continually read from a
                                                  // set of PHYs of contiguous address
                                                  // space. The starting address of the
                                                  // PHY is specified by the content of
                                                  // the hstphyadx field, the very next
                                                  // PHY to be read will be hstphyadx + 1.
                                                  // The last PHY to be queried in this
                                                  // read sequence will be that which
                                                  // resides at address 0x31, after which
                                                  // the read sequence will continue again
                                                  // for the PHY specified by the
                                                  // hstphyadx field. 
#define AMIIM_CMD_10GB_MMD              (5)       // Ten Gigabit MMD operation. The AMIIM
                                                  // will present the contents of the
                                                  // AMIIM Field Register to the MDIO pins
                                                  // in the order specified by the
                                                  // Management Frame Format in IEEE
                                                  // Standard 802.3 clause 45. 
#define AMIIM_CMD_CLEAR_LINK_FAIL       (6)       // Clear Link Fail. Will cause the Link
                                                  // Fail bit in the MIIM Indicators
                                                  // Register to be cleared. This value
                                                  // will also clear each bit in the AMIIM
                                                  // Link Fail Vector Register. 

typedef enum {
   ENUM_AMIIM_CMD_IDLE = 0x0UL,
   ENUM_AMIIM_CMD_LEGACY_WRITE = 0x1UL,
   ENUM_AMIIM_CMD_LEGACY_READ = 0x2UL,
   ENUM_AMIIM_CMD_SINGLE_PHY_MONITOR = 0x3UL,
   ENUM_AMIIM_CMD_MULTI_PHY_MONITOR = 0x4UL,
   ENUM_AMIIM_CMD_10GB_MMD = 0x5UL,
   ENUM_AMIIM_CMD_CLEAR_LINK_FAIL = 0x6UL
} AMIIM_CMD_HSTMIIMCMD_ENUM;

#endif // __rxf_enum_h__

