/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */

/*!

@file
    main.cpp

@brief
    This file contains the main entrypoints for the shared code module. These
    entrypoints include the OS entrypoints and the exported registration routines.

@author jflores

@note
    jflores   8/03/2004    initial
    $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/drivers/beclib/main_ll.c,v 1.3 2006/02/21 03:20:07 menz Exp $

*/

#include "pch.h"


/*!
@brief
    System-invoked entry point for system DLL.                
    This routine gets called once per system instantiation, is
    responsible for registering the the driver's entry points.
    Initialization and configuration occur elsewhere.         
@return
    SA_SUCCESS if ok.   
@note
    IRQL: PASSIVE_LEVEL
    We cannot touch registers in this routine
*/
BESTATUS
be_initialize_library (void)
{    
#ifdef BE_EMULATION
    SA_TRACE (DL_ALWAYS, "Running EMULATED beclib version.");
#endif
    sa_trace_set_debug_level_string (DL_HW, "hw");    

    /*#define S(_type) TRACE (DL_ERR, "Sizeof " #_type ":%d", sizeof(_type))
    S(BE_NONEMBEDDED_QUEUE_CONTEXT);
    S(BE_TOE_UPLOAD_QUEUE_CONTEXT);
    S(BE_TOE_RQ_CREATE_QUEUE_CONTEXT);
    S(BE_TOE_SQ_CREATE_QUEUE_CONTEXT);
    S(BE_LINK_STATUS_QUEUE_CONTEXT);
    S(BE_MULTICAST_QUEUE_CONTEXT);
    S(BE_WAKE_ON_LAN_QUEUE_CONTEXT);
    S(BE_VLAN_QUEUE_CONTEXT);
    S(BE_PROMISCUOUS_QUEUE_CONTEXT);
    S(BE_RSS_QUEUE_CONTEXT);
    S(BE_NOP_QUEUE_CONTEXT);
    S(BE_GENERIC_QUEUE_CONTEXT);    */

    return  BE_SUCCESS;
}

