/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   sa_md5.h

@brief
   
CVS Header Information:
   $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/sa/runtime/sa_md5.h,v 1.4 2006/03/10 19:16:12 menz Exp $
*/
#ifndef __sa_md5_h__
#define __sa_md5_h__

#include "system/sa_system.h"
SA_CPP_HEADER

typedef struct _SA_MD5_CONTEXT {
    u32 buf[4];
    u32 bits[2];
    u8  in[64];
} SA_MD5_CONTEXT, *PSA_MD5_CONTEXT;


void sa_md5_init (PSA_MD5_CONTEXT ctx);

void sa_md5_update (PSA_MD5_CONTEXT ctx, const u8* buf, u32 len);

void sa_md5_final (u8 digest[16], PSA_MD5_CONTEXT ctx);  

void sa_md5_transform (u32 buf[4], u32 in[16]);

#if !defined(SA_OMIT_TEST_CODE)

    // Returns TRUE on success.
    boolean sa_md5_test_suite (void);

#endif

SA_CPP_TRAILER
#endif // __sa_md5_h__

