/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   rand.h

@brief
   
CVS Header Information:
   $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/sa/runtime/sa_rand.h,v 1.4 2006/03/10 19:16:12 menz Exp $
*/
#ifndef __sa_rand_h__
#define __sa_rand_h__

#include "system/sa_types.h"
SA_CPP_HEADER

// Sets 3 value seed
void sa_rand_seed (u32 seed1, u32 seed2, u32 seed3);

// returns a random 32 bit integer
u32 sa_rand (void); 

#ifdef SA_USER
    // return a random float >= 0 and < 1
    #define sa_rand_f64()  ((f64)sa_rand() / 4294967296.0)
#endif

SA_CPP_TRAILER
#endif

