/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
/*!
@file
   sa_system.h

@brief

    
    Includes all the system header files.


CVS Header Information:
   $Header: /opt/be_cvsrepo/dsn.sw.host.drivers/dsn/sw/host/sa/system/sa_system.h,v 1.7 2006/02/25 23:26:53 menz Exp $
*/
#ifndef __sa_system_h__
#define __sa_system_h__

// Core utilities
#include "system/sa_platform.h"
#include "system/sa_types.h"
#include "system/sa_status.h"
#include "system/sa_defines.h"
#include "system/sa_endian.h"
#include "system/sa_list.h"
#include "system/sa_time.h"
#include "system/sa_bits.h"
#include "system/sa_convert.h"

// std C runtime
#include "system/sa_std.h"
#include "system/sa_output.h"

// debug
#include "system/sa_assert.h"
#include "system/sa_trace.h"

// OS modules
#include "system/sa_sync.h"
#include "system/sa_mem.h"
#include "system/sa_dev.h"
#include "system/sa_ioctl.h"

// exact data types
#include "system/sa_exact.h"

#if (defined(SA_LINUXU) && !defined(SA_SIM)) || defined(SA_WIN32U)
    #include "sa_thread.h"
#endif

#endif // __sa_system_h__


