/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_bmap_h__
#define __ioctl_common_bmap_h__
#include "setypes.h"
#include "ioctl_types_bmap.h"
#include "ioctl_hdr_bmap.h"
#include "ioctl_defs_bmap.h"
#include "host_struct_bmap.h"
#include "fw_exp_bmap.h"
#include "erx_bmap.h"
#include "ioctl_mcc_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_LINK_STATUS {
         union {
            struct { 
               UEXACT8 physical_port;
               UEXACT8 mac_duplex;
               UEXACT8 mac_speed;
               UEXACT8 mac_fault;
               UEXACT8 mgmt_mac_duplex;
               UEXACT8 mgmt_mac_speed;
               UEXACT16 qos_link_speed;
               UEXACT32 logical_link_status;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE_LINK_STATUS, *PBE_LINK_STATUS;

      SG_C_ASSERT(__sizeof__BE_LINK_STATUS, sizeof (BE_LINK_STATUS) == 12);

   #else
      typedef struct _BE_LINK_STATUS {
         UEXACT8 physical_port;
         UEXACT8 mac_duplex;
         UEXACT8 mac_speed;
         UEXACT8 mac_fault;
         UEXACT8 mgmt_mac_duplex;
         UEXACT8 mgmt_mac_speed;
         UEXACT16 qos_link_speed;
         UEXACT32 logical_link_status;
      } SG_PACK BE_LINK_STATUS, *PBE_LINK_STATUS;

      typedef union _BE_LINK_STATUS_UNION {
         BE_LINK_STATUS bits;
         u32 dw[3]; // dword union
      } SG_PACK BE_LINK_STATUS_UNION, *PBE_LINK_STATUS_UNION;

      SG_C_ASSERT(__sizeof__BE_LINK_STATUS_UNION, sizeof (BE_LINK_STATUS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_LINK_STATUS {
         union {
            struct { 
               UEXACT8 physical_port;
               UEXACT8 mac_duplex;
               UEXACT8 mac_speed;
               UEXACT8 mac_fault;
               UEXACT8 mgmt_mac_duplex;
               UEXACT8 mgmt_mac_speed;
               UEXACT16 qos_link_speed;
               UEXACT32 logical_link_status;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK BE_LINK_STATUS, *PBE_LINK_STATUS;

      SG_C_ASSERT(__sizeof__BE_LINK_STATUS, sizeof (BE_LINK_STATUS) == 12);

   #else
      typedef struct _BE_LINK_STATUS {
         UEXACT8 physical_port;
         UEXACT8 mac_duplex;
         UEXACT8 mac_speed;
         UEXACT8 mac_fault;
         UEXACT8 mgmt_mac_duplex;
         UEXACT8 mgmt_mac_speed;
         UEXACT16 qos_link_speed;
         UEXACT32 logical_link_status;
      } SG_PACK BE_LINK_STATUS, *PBE_LINK_STATUS;

      typedef union _BE_LINK_STATUS_UNION {
         BE_LINK_STATUS bits;
         u32 dw[3]; // dword union
      } SG_PACK BE_LINK_STATUS_UNION, *PBE_LINK_STATUS_UNION;

      SG_C_ASSERT(__sizeof__BE_LINK_STATUS_UNION, sizeof (BE_LINK_STATUS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_STATUS_QUERY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN, *PLINK_STATUS_QUERY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_IN, sizeof (LINK_STATUS_QUERY_PARAMS_IN) == 4);

   #else
      typedef struct _LINK_STATUS_QUERY_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN, *PLINK_STATUS_QUERY_PARAMS_IN;

      typedef union _LINK_STATUS_QUERY_PARAMS_IN_UNION {
         LINK_STATUS_QUERY_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN_UNION, *PLINK_STATUS_QUERY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_IN_UNION, sizeof (LINK_STATUS_QUERY_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_STATUS_QUERY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN, *PLINK_STATUS_QUERY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_IN, sizeof (LINK_STATUS_QUERY_PARAMS_IN) == 4);

   #else
      typedef struct _LINK_STATUS_QUERY_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN, *PLINK_STATUS_QUERY_PARAMS_IN;

      typedef union _LINK_STATUS_QUERY_PARAMS_IN_UNION {
         LINK_STATUS_QUERY_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_IN_UNION, *PLINK_STATUS_QUERY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_IN_UNION, sizeof (LINK_STATUS_QUERY_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_STATUS_QUERY_PARAMS {
         union {
            union { 
               BE_LINK_STATUS response;
               LINK_STATUS_QUERY_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK LINK_STATUS_QUERY_PARAMS, *PLINK_STATUS_QUERY_PARAMS;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS, sizeof (LINK_STATUS_QUERY_PARAMS) == 12);

   #else
      typedef union _LINK_STATUS_QUERY_PARAMS {
         BE_LINK_STATUS response;
         LINK_STATUS_QUERY_PARAMS_IN request;
      } SG_PACK LINK_STATUS_QUERY_PARAMS, *PLINK_STATUS_QUERY_PARAMS;

      typedef union _LINK_STATUS_QUERY_PARAMS_UNION {
         LINK_STATUS_QUERY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_UNION, *PLINK_STATUS_QUERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_UNION, sizeof (LINK_STATUS_QUERY_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_STATUS_QUERY_PARAMS {
         union {
            union { 
               BE_LINK_STATUS response;
               LINK_STATUS_QUERY_PARAMS_IN request;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK LINK_STATUS_QUERY_PARAMS, *PLINK_STATUS_QUERY_PARAMS;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS, sizeof (LINK_STATUS_QUERY_PARAMS) == 12);

   #else
      typedef union _LINK_STATUS_QUERY_PARAMS {
         BE_LINK_STATUS response;
         LINK_STATUS_QUERY_PARAMS_IN request;
      } SG_PACK LINK_STATUS_QUERY_PARAMS, *PLINK_STATUS_QUERY_PARAMS;

      typedef union _LINK_STATUS_QUERY_PARAMS_UNION {
         LINK_STATUS_QUERY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK LINK_STATUS_QUERY_PARAMS_UNION, *PLINK_STATUS_QUERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__LINK_STATUS_QUERY_PARAMS_UNION, sizeof (LINK_STATUS_QUERY_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries the link status for the client's port.  Note: valid values below DO NOT
   // indicate a particular duplex or speed is supported by BladeEngine. The enumerations
   // simply list all possible duplexes and speeds for a given port/MAC. Consult
   // BladeEngine product documentation for the supported duplex and speed. 
   typedef struct _IOCTL_COMMON_NTWK_LINK_STATUS_QUERY {
      IOCTL_HEADER header;
      LINK_STATUS_QUERY_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_LINK_STATUS_QUERY, *PIOCTL_COMMON_NTWK_LINK_STATUS_QUERY;



#else
   // Queries the link status for the client's port.  Note: valid values below DO NOT
   // indicate a particular duplex or speed is supported by BladeEngine. The enumerations
   // simply list all possible duplexes and speeds for a given port/MAC. Consult
   // BladeEngine product documentation for the supported duplex and speed. 
   typedef struct _IOCTL_COMMON_NTWK_LINK_STATUS_QUERY {
      IOCTL_HEADER header;
      LINK_STATUS_QUERY_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_LINK_STATUS_QUERY, *PIOCTL_COMMON_NTWK_LINK_STATUS_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_SPEED_SET {
         union {
            struct { 
               UEXACT8 physical_port;
               UEXACT8 virtual_port;
               UEXACT8 mac_speed;
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LINK_SPEED_SET, *PLINK_SPEED_SET;

      SG_C_ASSERT(__sizeof__LINK_SPEED_SET, sizeof (LINK_SPEED_SET) == 4);

   #else
      typedef struct _LINK_SPEED_SET {
         UEXACT8 physical_port;
         UEXACT8 virtual_port;
         UEXACT8 mac_speed;
         UEXACT8 rsvd0;
      } SG_PACK LINK_SPEED_SET, *PLINK_SPEED_SET;

      typedef union _LINK_SPEED_SET_UNION {
         LINK_SPEED_SET bits;
         u32 dw; // dword union
      } SG_PACK LINK_SPEED_SET_UNION, *PLINK_SPEED_SET_UNION;

      SG_C_ASSERT(__sizeof__LINK_SPEED_SET_UNION, sizeof (LINK_SPEED_SET_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _LINK_SPEED_SET {
         union {
            struct { 
               UEXACT8 physical_port;
               UEXACT8 virtual_port;
               UEXACT8 mac_speed;
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK LINK_SPEED_SET, *PLINK_SPEED_SET;

      SG_C_ASSERT(__sizeof__LINK_SPEED_SET, sizeof (LINK_SPEED_SET) == 4);

   #else
      typedef struct _LINK_SPEED_SET {
         UEXACT8 physical_port;
         UEXACT8 virtual_port;
         UEXACT8 mac_speed;
         UEXACT8 rsvd0;
      } SG_PACK LINK_SPEED_SET, *PLINK_SPEED_SET;

      typedef union _LINK_SPEED_SET_UNION {
         LINK_SPEED_SET bits;
         u32 dw; // dword union
      } SG_PACK LINK_SPEED_SET_UNION, *PLINK_SPEED_SET_UNION;

      SG_C_ASSERT(__sizeof__LINK_SPEED_SET_UNION, sizeof (LINK_SPEED_SET_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_LINK_SPEED_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT, *PSET_LINK_SPEED_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_OUT, sizeof (SET_LINK_SPEED_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_LINK_SPEED_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT, *PSET_LINK_SPEED_PARAMS_OUT;

      typedef union _SET_LINK_SPEED_PARAMS_OUT_UNION {
         SET_LINK_SPEED_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT_UNION, *PSET_LINK_SPEED_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_OUT_UNION, sizeof (SET_LINK_SPEED_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_LINK_SPEED_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT, *PSET_LINK_SPEED_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_OUT, sizeof (SET_LINK_SPEED_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_LINK_SPEED_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT, *PSET_LINK_SPEED_PARAMS_OUT;

      typedef union _SET_LINK_SPEED_PARAMS_OUT_UNION {
         SET_LINK_SPEED_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_LINK_SPEED_PARAMS_OUT_UNION, *PSET_LINK_SPEED_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_OUT_UNION, sizeof (SET_LINK_SPEED_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_LINK_SPEED_PARAMS {
         union {
            union { 
               LINK_SPEED_SET request;
               SET_LINK_SPEED_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_LINK_SPEED_PARAMS, *PSET_LINK_SPEED_PARAMS;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS, sizeof (SET_LINK_SPEED_PARAMS) == 4);

   #else
      typedef union _SET_LINK_SPEED_PARAMS {
         LINK_SPEED_SET request;
         SET_LINK_SPEED_PARAMS_OUT response;
      } SG_PACK SET_LINK_SPEED_PARAMS, *PSET_LINK_SPEED_PARAMS;

      typedef union _SET_LINK_SPEED_PARAMS_UNION {
         SET_LINK_SPEED_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_LINK_SPEED_PARAMS_UNION, *PSET_LINK_SPEED_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_UNION, sizeof (SET_LINK_SPEED_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_LINK_SPEED_PARAMS {
         union {
            union { 
               LINK_SPEED_SET request;
               SET_LINK_SPEED_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_LINK_SPEED_PARAMS, *PSET_LINK_SPEED_PARAMS;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS, sizeof (SET_LINK_SPEED_PARAMS) == 4);

   #else
      typedef union _SET_LINK_SPEED_PARAMS {
         LINK_SPEED_SET request;
         SET_LINK_SPEED_PARAMS_OUT response;
      } SG_PACK SET_LINK_SPEED_PARAMS, *PSET_LINK_SPEED_PARAMS;

      typedef union _SET_LINK_SPEED_PARAMS_UNION {
         SET_LINK_SPEED_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_LINK_SPEED_PARAMS_UNION, *PSET_LINK_SPEED_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_LINK_SPEED_PARAMS_UNION, sizeof (SET_LINK_SPEED_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Sets the link status for the client's port.  Note: Some implementations using the
   // BE2, require a manual speed setting due to limitations in the PHY . The Aeluris PHY
   // supports auto detection and setting for 10G and 1G. PHY type is used to let ARM f/w
   // know that it needs to apply QoS settings to limit throughput on the virtual ports to
   // 1G. 
   typedef struct _IOCTL_COMMON_NTWK_SET_LINK_SPEED {
      IOCTL_HEADER header;
      SET_LINK_SPEED_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_SET_LINK_SPEED, *PIOCTL_COMMON_NTWK_SET_LINK_SPEED;



#else
   // Sets the link status for the client's port.  Note: Some implementations using the
   // BE2, require a manual speed setting due to limitations in the PHY . The Aeluris PHY
   // supports auto detection and setting for 10G and 1G. PHY type is used to let ARM f/w
   // know that it needs to apply QoS settings to limit throughput on the virtual ports to
   // 1G. 
   typedef struct _IOCTL_COMMON_NTWK_SET_LINK_SPEED {
      IOCTL_HEADER header;
      SET_LINK_SPEED_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_SET_LINK_SPEED, *PIOCTL_COMMON_NTWK_SET_LINK_SPEED;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS_IN {
         union {
            struct { 
               UEXACT8 type;
               UEXACT8 permanent;
               UEXACT16 if_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN, *PNTWK_MAC_QUERY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_IN, sizeof (NTWK_MAC_QUERY_PARAMS_IN) == 8);

   #else
      typedef struct _NTWK_MAC_QUERY_PARAMS_IN {
         UEXACT8 type;
         UEXACT8 permanent;
         UEXACT16 if_id;
         UEXACT32 pmac_id;
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN, *PNTWK_MAC_QUERY_PARAMS_IN;

      typedef union _NTWK_MAC_QUERY_PARAMS_IN_UNION {
         NTWK_MAC_QUERY_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN_UNION, *PNTWK_MAC_QUERY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_IN_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS_IN {
         union {
            struct { 
               UEXACT8 type;
               UEXACT8 permanent;
               UEXACT16 if_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN, *PNTWK_MAC_QUERY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_IN, sizeof (NTWK_MAC_QUERY_PARAMS_IN) == 8);

   #else
      typedef struct _NTWK_MAC_QUERY_PARAMS_IN {
         UEXACT8 type;
         UEXACT8 permanent;
         UEXACT16 if_id;
         UEXACT32 pmac_id;
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN, *PNTWK_MAC_QUERY_PARAMS_IN;

      typedef union _NTWK_MAC_QUERY_PARAMS_IN_UNION {
         NTWK_MAC_QUERY_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_IN_UNION, *PNTWK_MAC_QUERY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_IN_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS_OUT {
         union {
            struct { 
               MAC_ADDRESS_FORMAT mac;
               MAC_ADDRESS_FORMAT seeprom_mac[8];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT, *PNTWK_MAC_QUERY_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_OUT, sizeof (NTWK_MAC_QUERY_PARAMS_OUT) == 72);

   #else
      typedef struct _NTWK_MAC_QUERY_PARAMS_OUT {
         MAC_ADDRESS_FORMAT mac;
         MAC_ADDRESS_FORMAT seeprom_mac[8];
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT, *PNTWK_MAC_QUERY_PARAMS_OUT;

      typedef union _NTWK_MAC_QUERY_PARAMS_OUT_UNION {
         NTWK_MAC_QUERY_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT_UNION, *PNTWK_MAC_QUERY_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_OUT_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_OUT_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS_OUT {
         union {
            struct { 
               MAC_ADDRESS_FORMAT mac;
               MAC_ADDRESS_FORMAT seeprom_mac[8];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT, *PNTWK_MAC_QUERY_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_OUT, sizeof (NTWK_MAC_QUERY_PARAMS_OUT) == 72);

   #else
      typedef struct _NTWK_MAC_QUERY_PARAMS_OUT {
         MAC_ADDRESS_FORMAT mac;
         MAC_ADDRESS_FORMAT seeprom_mac[8];
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT, *PNTWK_MAC_QUERY_PARAMS_OUT;

      typedef union _NTWK_MAC_QUERY_PARAMS_OUT_UNION {
         NTWK_MAC_QUERY_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_OUT_UNION, *PNTWK_MAC_QUERY_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_OUT_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_OUT_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS {
         union {
            union { 
               NTWK_MAC_QUERY_PARAMS_IN request;
               NTWK_MAC_QUERY_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS, *PNTWK_MAC_QUERY_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS, sizeof (NTWK_MAC_QUERY_PARAMS) == 72);

   #else
      typedef union _NTWK_MAC_QUERY_PARAMS {
         NTWK_MAC_QUERY_PARAMS_IN request;
         NTWK_MAC_QUERY_PARAMS_OUT response;
      } SG_PACK NTWK_MAC_QUERY_PARAMS, *PNTWK_MAC_QUERY_PARAMS;

      typedef union _NTWK_MAC_QUERY_PARAMS_UNION {
         NTWK_MAC_QUERY_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_UNION, *PNTWK_MAC_QUERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_QUERY_PARAMS {
         union {
            union { 
               NTWK_MAC_QUERY_PARAMS_IN request;
               NTWK_MAC_QUERY_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_QUERY_PARAMS, *PNTWK_MAC_QUERY_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS, sizeof (NTWK_MAC_QUERY_PARAMS) == 72);

   #else
      typedef union _NTWK_MAC_QUERY_PARAMS {
         NTWK_MAC_QUERY_PARAMS_IN request;
         NTWK_MAC_QUERY_PARAMS_OUT response;
      } SG_PACK NTWK_MAC_QUERY_PARAMS, *PNTWK_MAC_QUERY_PARAMS;

      typedef union _NTWK_MAC_QUERY_PARAMS_UNION {
         NTWK_MAC_QUERY_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK NTWK_MAC_QUERY_PARAMS_UNION, *PNTWK_MAC_QUERY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_QUERY_PARAMS_UNION, sizeof (NTWK_MAC_QUERY_PARAMS_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries a MAC address. 
   typedef struct _IOCTL_COMMON_NTWK_MAC_QUERY {
      IOCTL_HEADER header;
      NTWK_MAC_QUERY_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MAC_QUERY, *PIOCTL_COMMON_NTWK_MAC_QUERY;



#else
   // Queries a MAC address. 
   typedef struct _IOCTL_COMMON_NTWK_MAC_QUERY {
      IOCTL_HEADER header;
      NTWK_MAC_QUERY_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MAC_QUERY, *PIOCTL_COMMON_NTWK_MAC_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS_IN {
         union {
            struct { 
               UEXACT8 type;
               UEXACT8 invalidate;
               UEXACT16 if_id;
               MAC_ADDRESS_FORMAT mac;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS_IN, *PNTWK_MAC_SET_PARAMS_IN;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_IN, sizeof (NTWK_MAC_SET_PARAMS_IN) == 12);

   #else
      typedef struct _NTWK_MAC_SET_PARAMS_IN {
         UEXACT8 type;
         UEXACT8 invalidate;
         UEXACT16 if_id;
         MAC_ADDRESS_FORMAT mac;
      } SG_PACK NTWK_MAC_SET_PARAMS_IN, *PNTWK_MAC_SET_PARAMS_IN;

      typedef union _NTWK_MAC_SET_PARAMS_IN_UNION {
         NTWK_MAC_SET_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_IN_UNION, *PNTWK_MAC_SET_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_IN_UNION, sizeof (NTWK_MAC_SET_PARAMS_IN_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS_IN {
         union {
            struct { 
               UEXACT8 type;
               UEXACT8 invalidate;
               UEXACT16 if_id;
               MAC_ADDRESS_FORMAT mac;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS_IN, *PNTWK_MAC_SET_PARAMS_IN;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_IN, sizeof (NTWK_MAC_SET_PARAMS_IN) == 12);

   #else
      typedef struct _NTWK_MAC_SET_PARAMS_IN {
         UEXACT8 type;
         UEXACT8 invalidate;
         UEXACT16 if_id;
         MAC_ADDRESS_FORMAT mac;
      } SG_PACK NTWK_MAC_SET_PARAMS_IN, *PNTWK_MAC_SET_PARAMS_IN;

      typedef union _NTWK_MAC_SET_PARAMS_IN_UNION {
         NTWK_MAC_SET_PARAMS_IN bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_IN_UNION, *PNTWK_MAC_SET_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_IN_UNION, sizeof (NTWK_MAC_SET_PARAMS_IN_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT, *PNTWK_MAC_SET_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_OUT, sizeof (NTWK_MAC_SET_PARAMS_OUT) == 4);

   #else
      typedef struct _NTWK_MAC_SET_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT, *PNTWK_MAC_SET_PARAMS_OUT;

      typedef union _NTWK_MAC_SET_PARAMS_OUT_UNION {
         NTWK_MAC_SET_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT_UNION, *PNTWK_MAC_SET_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_OUT_UNION, sizeof (NTWK_MAC_SET_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT, *PNTWK_MAC_SET_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_OUT, sizeof (NTWK_MAC_SET_PARAMS_OUT) == 4);

   #else
      typedef struct _NTWK_MAC_SET_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT, *PNTWK_MAC_SET_PARAMS_OUT;

      typedef union _NTWK_MAC_SET_PARAMS_OUT_UNION {
         NTWK_MAC_SET_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_OUT_UNION, *PNTWK_MAC_SET_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_OUT_UNION, sizeof (NTWK_MAC_SET_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS {
         union {
            union { 
               NTWK_MAC_SET_PARAMS_IN request;
               NTWK_MAC_SET_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS, *PNTWK_MAC_SET_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS, sizeof (NTWK_MAC_SET_PARAMS) == 12);

   #else
      typedef union _NTWK_MAC_SET_PARAMS {
         NTWK_MAC_SET_PARAMS_IN request;
         NTWK_MAC_SET_PARAMS_OUT response;
      } SG_PACK NTWK_MAC_SET_PARAMS, *PNTWK_MAC_SET_PARAMS;

      typedef union _NTWK_MAC_SET_PARAMS_UNION {
         NTWK_MAC_SET_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_UNION, *PNTWK_MAC_SET_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_UNION, sizeof (NTWK_MAC_SET_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MAC_SET_PARAMS {
         union {
            union { 
               NTWK_MAC_SET_PARAMS_IN request;
               NTWK_MAC_SET_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MAC_SET_PARAMS, *PNTWK_MAC_SET_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS, sizeof (NTWK_MAC_SET_PARAMS) == 12);

   #else
      typedef union _NTWK_MAC_SET_PARAMS {
         NTWK_MAC_SET_PARAMS_IN request;
         NTWK_MAC_SET_PARAMS_OUT response;
      } SG_PACK NTWK_MAC_SET_PARAMS, *PNTWK_MAC_SET_PARAMS;

      typedef union _NTWK_MAC_SET_PARAMS_UNION {
         NTWK_MAC_SET_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_MAC_SET_PARAMS_UNION, *PNTWK_MAC_SET_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MAC_SET_PARAMS_UNION, sizeof (NTWK_MAC_SET_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Replaces the MAC address for the associated function. The IOCTL will fail if there
   // is a MAC collision - i.e. if there exists a function with the requested MAC address.
   typedef struct _IOCTL_COMMON_NTWK_MAC_SET {
      IOCTL_HEADER header;
      NTWK_MAC_SET_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MAC_SET, *PIOCTL_COMMON_NTWK_MAC_SET;



#else
   // Replaces the MAC address for the associated function. The IOCTL will fail if there
   // is a MAC collision - i.e. if there exists a function with the requested MAC address.
   typedef struct _IOCTL_COMMON_NTWK_MAC_SET {
      IOCTL_HEADER header;
      NTWK_MAC_SET_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MAC_SET, *PIOCTL_COMMON_NTWK_MAC_SET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_ADD_REQUEST {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT8 mac_address[6];
               UEXACT8 rsvd0[2];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_ADD_REQUEST, *PNTWK_PMAC_ADD_REQUEST;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_REQUEST, sizeof (NTWK_PMAC_ADD_REQUEST) == 12);

   #else
      typedef struct _NTWK_PMAC_ADD_REQUEST {
         UEXACT32 if_id;
         UEXACT8 mac_address[6];
         UEXACT8 rsvd0[2];
      } SG_PACK NTWK_PMAC_ADD_REQUEST, *PNTWK_PMAC_ADD_REQUEST;

      typedef union _NTWK_PMAC_ADD_REQUEST_UNION {
         NTWK_PMAC_ADD_REQUEST bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_PMAC_ADD_REQUEST_UNION, *PNTWK_PMAC_ADD_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_REQUEST_UNION, sizeof (NTWK_PMAC_ADD_REQUEST_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_ADD_REQUEST {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT8 mac_address[6];
               UEXACT8 rsvd0[2];
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_ADD_REQUEST, *PNTWK_PMAC_ADD_REQUEST;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_REQUEST, sizeof (NTWK_PMAC_ADD_REQUEST) == 12);

   #else
      typedef struct _NTWK_PMAC_ADD_REQUEST {
         UEXACT32 if_id;
         UEXACT8 mac_address[6];
         UEXACT8 rsvd0[2];
      } SG_PACK NTWK_PMAC_ADD_REQUEST, *PNTWK_PMAC_ADD_REQUEST;

      typedef union _NTWK_PMAC_ADD_REQUEST_UNION {
         NTWK_PMAC_ADD_REQUEST bits;
         u32 dw[3]; // dword union
      } SG_PACK NTWK_PMAC_ADD_REQUEST_UNION, *PNTWK_PMAC_ADD_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_REQUEST_UNION, sizeof (NTWK_PMAC_ADD_REQUEST_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_ADD_RESPONSE {
         union {
            struct { 
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_ADD_RESPONSE, *PNTWK_PMAC_ADD_RESPONSE;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_RESPONSE, sizeof (NTWK_PMAC_ADD_RESPONSE) == 4);

   #else
      typedef struct _NTWK_PMAC_ADD_RESPONSE {
         UEXACT32 pmac_id;
      } SG_PACK NTWK_PMAC_ADD_RESPONSE, *PNTWK_PMAC_ADD_RESPONSE;

      typedef union _NTWK_PMAC_ADD_RESPONSE_UNION {
         NTWK_PMAC_ADD_RESPONSE bits;
         u32 dw; // dword union
      } SG_PACK NTWK_PMAC_ADD_RESPONSE_UNION, *PNTWK_PMAC_ADD_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_RESPONSE_UNION, sizeof (NTWK_PMAC_ADD_RESPONSE_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_ADD_RESPONSE {
         union {
            struct { 
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_ADD_RESPONSE, *PNTWK_PMAC_ADD_RESPONSE;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_RESPONSE, sizeof (NTWK_PMAC_ADD_RESPONSE) == 4);

   #else
      typedef struct _NTWK_PMAC_ADD_RESPONSE {
         UEXACT32 pmac_id;
      } SG_PACK NTWK_PMAC_ADD_RESPONSE, *PNTWK_PMAC_ADD_RESPONSE;

      typedef union _NTWK_PMAC_ADD_RESPONSE_UNION {
         NTWK_PMAC_ADD_RESPONSE bits;
         u32 dw; // dword union
      } SG_PACK NTWK_PMAC_ADD_RESPONSE_UNION, *PNTWK_PMAC_ADD_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_ADD_RESPONSE_UNION, sizeof (NTWK_PMAC_ADD_RESPONSE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Adds a perfect MAC addresses for an interface ID previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are no free
   // perfect MAC address slots available to satisfy the request.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_PMAC_ADD {
      IOCTL_HEADER header;
      union {
         NTWK_PMAC_ADD_REQUEST request;
         NTWK_PMAC_ADD_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_PMAC_ADD, *PIOCTL_COMMON_NTWK_PMAC_ADD;



#else
   // Adds a perfect MAC addresses for an interface ID previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are no free
   // perfect MAC address slots available to satisfy the request.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_PMAC_ADD {
      IOCTL_HEADER header;
      union {
         NTWK_PMAC_ADD_REQUEST request;
         NTWK_PMAC_ADD_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_PMAC_ADD, *PIOCTL_COMMON_NTWK_PMAC_ADD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL_REQUEST {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL_REQUEST, *PNTWK_PMAC_DEL_REQUEST;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_REQUEST, sizeof (NTWK_PMAC_DEL_REQUEST) == 8);

   #else
      typedef struct _NTWK_PMAC_DEL_REQUEST {
         UEXACT32 if_id;
         UEXACT32 pmac_id;
      } SG_PACK NTWK_PMAC_DEL_REQUEST, *PNTWK_PMAC_DEL_REQUEST;

      typedef union _NTWK_PMAC_DEL_REQUEST_UNION {
         NTWK_PMAC_DEL_REQUEST bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_PMAC_DEL_REQUEST_UNION, *PNTWK_PMAC_DEL_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_REQUEST_UNION, sizeof (NTWK_PMAC_DEL_REQUEST_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL_REQUEST {
         union {
            struct { 
               UEXACT32 if_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL_REQUEST, *PNTWK_PMAC_DEL_REQUEST;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_REQUEST, sizeof (NTWK_PMAC_DEL_REQUEST) == 8);

   #else
      typedef struct _NTWK_PMAC_DEL_REQUEST {
         UEXACT32 if_id;
         UEXACT32 pmac_id;
      } SG_PACK NTWK_PMAC_DEL_REQUEST, *PNTWK_PMAC_DEL_REQUEST;

      typedef union _NTWK_PMAC_DEL_REQUEST_UNION {
         NTWK_PMAC_DEL_REQUEST bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_PMAC_DEL_REQUEST_UNION, *PNTWK_PMAC_DEL_REQUEST_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_REQUEST_UNION, sizeof (NTWK_PMAC_DEL_REQUEST_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL_RESPONSE {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL_RESPONSE, *PNTWK_PMAC_DEL_RESPONSE;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_RESPONSE, sizeof (NTWK_PMAC_DEL_RESPONSE) == 4);

   #else
      typedef struct _NTWK_PMAC_DEL_RESPONSE {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_PMAC_DEL_RESPONSE, *PNTWK_PMAC_DEL_RESPONSE;

      typedef union _NTWK_PMAC_DEL_RESPONSE_UNION {
         NTWK_PMAC_DEL_RESPONSE bits;
         u32 dw; // dword union
      } SG_PACK NTWK_PMAC_DEL_RESPONSE_UNION, *PNTWK_PMAC_DEL_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_RESPONSE_UNION, sizeof (NTWK_PMAC_DEL_RESPONSE_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL_RESPONSE {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL_RESPONSE, *PNTWK_PMAC_DEL_RESPONSE;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_RESPONSE, sizeof (NTWK_PMAC_DEL_RESPONSE) == 4);

   #else
      typedef struct _NTWK_PMAC_DEL_RESPONSE {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_PMAC_DEL_RESPONSE, *PNTWK_PMAC_DEL_RESPONSE;

      typedef union _NTWK_PMAC_DEL_RESPONSE_UNION {
         NTWK_PMAC_DEL_RESPONSE bits;
         u32 dw; // dword union
      } SG_PACK NTWK_PMAC_DEL_RESPONSE_UNION, *PNTWK_PMAC_DEL_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_RESPONSE_UNION, sizeof (NTWK_PMAC_DEL_RESPONSE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL {
         union {
            union { 
               NTWK_PMAC_DEL_REQUEST request;
               NTWK_PMAC_DEL_RESPONSE response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL, *PNTWK_PMAC_DEL;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL, sizeof (NTWK_PMAC_DEL) == 8);

   #else
      typedef union _NTWK_PMAC_DEL {
         NTWK_PMAC_DEL_REQUEST request;
         NTWK_PMAC_DEL_RESPONSE response;
      } SG_PACK NTWK_PMAC_DEL, *PNTWK_PMAC_DEL;

      typedef union _NTWK_PMAC_DEL_UNION {
         NTWK_PMAC_DEL bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_PMAC_DEL_UNION, *PNTWK_PMAC_DEL_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_UNION, sizeof (NTWK_PMAC_DEL_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_PMAC_DEL {
         union {
            union { 
               NTWK_PMAC_DEL_REQUEST request;
               NTWK_PMAC_DEL_RESPONSE response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_PMAC_DEL, *PNTWK_PMAC_DEL;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL, sizeof (NTWK_PMAC_DEL) == 8);

   #else
      typedef union _NTWK_PMAC_DEL {
         NTWK_PMAC_DEL_REQUEST request;
         NTWK_PMAC_DEL_RESPONSE response;
      } SG_PACK NTWK_PMAC_DEL, *PNTWK_PMAC_DEL;

      typedef union _NTWK_PMAC_DEL_UNION {
         NTWK_PMAC_DEL bits;
         u32 dw[2]; // dword union
      } SG_PACK NTWK_PMAC_DEL_UNION, *PNTWK_PMAC_DEL_UNION;

      SG_C_ASSERT(__sizeof__NTWK_PMAC_DEL_UNION, sizeof (NTWK_PMAC_DEL_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Deletes a perfect MAC addresses from an interface ID previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_PMAC_DEL {
      IOCTL_HEADER header;
      NTWK_PMAC_DEL params;
   } SG_PACK IOCTL_COMMON_NTWK_PMAC_DEL, *PIOCTL_COMMON_NTWK_PMAC_DEL;



#else
   // Deletes a perfect MAC addresses from an interface ID previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_PMAC_DEL {
      IOCTL_HEADER header;
      NTWK_PMAC_DEL params;
   } SG_PACK IOCTL_COMMON_NTWK_PMAC_DEL, *PIOCTL_COMMON_NTWK_PMAC_DEL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // MAC address list.
   typedef struct _NTWK_MULTICAST_MAC_LIST {
      UEXACT8 byte[6];
   } SG_PACK NTWK_MULTICAST_MAC_LIST, *PNTWK_MULTICAST_MAC_LIST;



#else
   // MAC address list.
   typedef struct _NTWK_MULTICAST_MAC_LIST {
      UEXACT8 byte[6];
   } SG_PACK NTWK_MULTICAST_MAC_LIST, *PNTWK_MULTICAST_MAC_LIST;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT16 num_mac;
               UEXACT8 promiscuous;
               UEXACT8 interface_id;
               NTWK_MULTICAST_MAC_LIST mac[32];
            } SG_PACK ; // unnamed struct
            u32 dw[49]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD) == 196);

   #else
      typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD {
         UEXACT16 num_mac;
         UEXACT8 promiscuous;
         UEXACT8 interface_id;
         NTWK_MULTICAST_MAC_LIST mac[32];
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD bits;
         u32 dw[49]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION) == 196);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT16 num_mac;
               UEXACT8 promiscuous;
               UEXACT8 interface_id;
               NTWK_MULTICAST_MAC_LIST mac[32];
            } SG_PACK ; // unnamed struct
            u32 dw[49]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD) == 196);

   #else
      typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD {
         UEXACT16 num_mac;
         UEXACT8 promiscuous;
         UEXACT8 interface_id;
         NTWK_MULTICAST_MAC_LIST mac[32];
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD bits;
         u32 dw[49]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_UNION) == 196);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MULTICAST_SET_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT, *PNTWK_MULTICAST_SET_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_OUT, sizeof (NTWK_MULTICAST_SET_PARAMS_OUT) == 4);

   #else
      typedef struct _NTWK_MULTICAST_SET_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT, *PNTWK_MULTICAST_SET_PARAMS_OUT;

      typedef union _NTWK_MULTICAST_SET_PARAMS_OUT_UNION {
         NTWK_MULTICAST_SET_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT_UNION, *PNTWK_MULTICAST_SET_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_OUT_UNION, sizeof (NTWK_MULTICAST_SET_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MULTICAST_SET_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT, *PNTWK_MULTICAST_SET_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_OUT, sizeof (NTWK_MULTICAST_SET_PARAMS_OUT) == 4);

   #else
      typedef struct _NTWK_MULTICAST_SET_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT, *PNTWK_MULTICAST_SET_PARAMS_OUT;

      typedef union _NTWK_MULTICAST_SET_PARAMS_OUT_UNION {
         NTWK_MULTICAST_SET_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_OUT_UNION, *PNTWK_MULTICAST_SET_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_OUT_UNION, sizeof (NTWK_MULTICAST_SET_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MULTICAST_SET_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD request;
               NTWK_MULTICAST_SET_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[49]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS, *PNTWK_MULTICAST_SET_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS, sizeof (NTWK_MULTICAST_SET_PARAMS) == 196);

   #else
      typedef union _NTWK_MULTICAST_SET_PARAMS {
         IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD request;
         NTWK_MULTICAST_SET_PARAMS_OUT response;
      } SG_PACK NTWK_MULTICAST_SET_PARAMS, *PNTWK_MULTICAST_SET_PARAMS;

      typedef union _NTWK_MULTICAST_SET_PARAMS_UNION {
         NTWK_MULTICAST_SET_PARAMS bits;
         u32 dw[49]; // dword union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_UNION, *PNTWK_MULTICAST_SET_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_UNION, sizeof (NTWK_MULTICAST_SET_PARAMS_UNION) == 196);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_MULTICAST_SET_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD request;
               NTWK_MULTICAST_SET_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[49]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS, *PNTWK_MULTICAST_SET_PARAMS;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS, sizeof (NTWK_MULTICAST_SET_PARAMS) == 196);

   #else
      typedef union _NTWK_MULTICAST_SET_PARAMS {
         IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD request;
         NTWK_MULTICAST_SET_PARAMS_OUT response;
      } SG_PACK NTWK_MULTICAST_SET_PARAMS, *PNTWK_MULTICAST_SET_PARAMS;

      typedef union _NTWK_MULTICAST_SET_PARAMS_UNION {
         NTWK_MULTICAST_SET_PARAMS bits;
         u32 dw[49]; // dword union
      } SG_PACK NTWK_MULTICAST_SET_PARAMS_UNION, *PNTWK_MULTICAST_SET_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_MULTICAST_SET_PARAMS_UNION, sizeof (NTWK_MULTICAST_SET_PARAMS_UNION) == 196);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Enables or disables reception of multicast packets matching the MAC address list for
   // a particular receive interface. The multicast address matching is based on a hash of
   // the MAC address (ie. it is imperfect). Posting this IOCTL will overwrite any
   // previous multicast hash settings for the interface. 
   typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET {
      IOCTL_HEADER header;
      NTWK_MULTICAST_SET_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET, *PIOCTL_COMMON_NTWK_MULTICAST_SET;



#else
   // Enables or disables reception of multicast packets matching the MAC address list for
   // a particular receive interface. The multicast address matching is based on a hash of
   // the MAC address (ie. it is imperfect). Posting this IOCTL will overwrite any
   // previous multicast hash settings for the interface. 
   typedef struct _IOCTL_COMMON_NTWK_MULTICAST_SET {
      IOCTL_HEADER header;
      NTWK_MULTICAST_SET_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_MULTICAST_SET, *PIOCTL_COMMON_NTWK_MULTICAST_SET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST {
      UEXACT16 id;
   } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST, *PIOCTL_COMMON_NTWK_VLAN_LIST;



#else
   
   typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST {
      UEXACT16 id;
   } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST, *PIOCTL_COMMON_NTWK_VLAN_LIST;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ {
         union {
            struct { 
               UEXACT16 id_o;
               UEXACT16 id_i;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, sizeof (IOCTL_COMMON_NTWK_VLAN_LIST_QINQ) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ {
         UEXACT16 id_o;
         UEXACT16 id_i;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ;

      typedef union _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION {
         IOCTL_COMMON_NTWK_VLAN_LIST_QINQ bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ {
         union {
            struct { 
               UEXACT16 id_o;
               UEXACT16 id_i;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, sizeof (IOCTL_COMMON_NTWK_VLAN_LIST_QINQ) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ {
         UEXACT16 id_o;
         UEXACT16 id_i;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ;

      typedef union _IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION {
         IOCTL_COMMON_NTWK_VLAN_LIST_QINQ bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_VLAN_TAGS {
         union {
            union { 
               IOCTL_COMMON_NTWK_VLAN_LIST normal_vlan[64];
               IOCTL_COMMON_NTWK_VLAN_LIST_QINQ qinq_vlan[32];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_VLAN_TAGS, *PNTWK_VLAN_TAGS;

      SG_C_ASSERT(__sizeof__NTWK_VLAN_TAGS, sizeof (NTWK_VLAN_TAGS) == 128);

   #else
      typedef union _NTWK_VLAN_TAGS {
         IOCTL_COMMON_NTWK_VLAN_LIST normal_vlan[64];
         IOCTL_COMMON_NTWK_VLAN_LIST_QINQ qinq_vlan[32];
      } SG_PACK NTWK_VLAN_TAGS, *PNTWK_VLAN_TAGS;

      typedef union _NTWK_VLAN_TAGS_UNION {
         NTWK_VLAN_TAGS bits;
         u32 dw[32]; // dword union
      } SG_PACK NTWK_VLAN_TAGS_UNION, *PNTWK_VLAN_TAGS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_VLAN_TAGS_UNION, sizeof (NTWK_VLAN_TAGS_UNION) == 128);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_VLAN_TAGS {
         union {
            union { 
               IOCTL_COMMON_NTWK_VLAN_LIST normal_vlan[64];
               IOCTL_COMMON_NTWK_VLAN_LIST_QINQ qinq_vlan[32];
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_VLAN_TAGS, *PNTWK_VLAN_TAGS;

      SG_C_ASSERT(__sizeof__NTWK_VLAN_TAGS, sizeof (NTWK_VLAN_TAGS) == 128);

   #else
      typedef union _NTWK_VLAN_TAGS {
         IOCTL_COMMON_NTWK_VLAN_LIST normal_vlan[64];
         IOCTL_COMMON_NTWK_VLAN_LIST_QINQ qinq_vlan[32];
      } SG_PACK NTWK_VLAN_TAGS, *PNTWK_VLAN_TAGS;

      typedef union _NTWK_VLAN_TAGS_UNION {
         NTWK_VLAN_TAGS bits;
         u32 dw[32]; // dword union
      } SG_PACK NTWK_VLAN_TAGS_UNION, *PNTWK_VLAN_TAGS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_VLAN_TAGS_UNION, sizeof (NTWK_VLAN_TAGS_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT8 interface_id;
               UEXACT8 promiscuous;
               UEXACT8 untagged;
               UEXACT8 num_vlan;
               NTWK_VLAN_TAGS tags;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD) == 132);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD {
         UEXACT8 interface_id;
         UEXACT8 promiscuous;
         UEXACT8 untagged;
         UEXACT8 num_vlan;
         NTWK_VLAN_TAGS tags;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT8 interface_id;
               UEXACT8 promiscuous;
               UEXACT8 untagged;
               UEXACT8 num_vlan;
               NTWK_VLAN_TAGS tags;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD) == 132);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD {
         UEXACT8 interface_id;
         UEXACT8 promiscuous;
         UEXACT8 untagged;
         UEXACT8 num_vlan;
         NTWK_VLAN_TAGS tags;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD request;
               IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD request;
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD request;
               IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD request;
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS;

      typedef union _IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION {
         IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION, sizeof (IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to add or remove VLAN identifiers associated with a network
   // interface. The adapters VLAN mode configuration setting affects the expected usage
   // of this IOCTL. In normal VLAN mode, the firmware expects single VLAN tag
   // identifiers. In QinQ VLAN (non Flex10) mode, the firmware expects VLAN tag
   // identifier pairs (outer and inner). For this reason, the tags field of this IOCTL is
   // a union of either normal_vlan or qinq_vlan. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are not
   // enough free VLAN ID entries to satisfy the request.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_NO_STATUS -- the requested VLAN ID parameters conflict with
   // existing VLAN configuration.  - MGMT_STATUS_UNAUTHORIZED_REQUEST /
   // MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the caller is not authorized to issue
   // this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG, *PIOCTL_COMMON_NTWK_VLAN_CONFIG;



#else
   // This IOCTL is used to add or remove VLAN identifiers associated with a network
   // interface. The adapters VLAN mode configuration setting affects the expected usage
   // of this IOCTL. In normal VLAN mode, the firmware expects single VLAN tag
   // identifiers. In QinQ VLAN (non Flex10) mode, the firmware expects VLAN tag
   // identifier pairs (outer and inner). For this reason, the tags field of this IOCTL is
   // a union of either normal_vlan or qinq_vlan. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are not
   // enough free VLAN ID entries to satisfy the request.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_NO_STATUS -- the requested VLAN ID parameters conflict with
   // existing VLAN configuration.  - MGMT_STATUS_UNAUTHORIZED_REQUEST /
   // MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the caller is not authorized to issue
   // this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_VLAN_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_VLAN_CONFIG, *PIOCTL_COMMON_NTWK_VLAN_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TAG_QINQ {
         union {
            struct { 
               UEXACT16 outer;
               UEXACT16 inner;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TAG_QINQ, *PVLAN_TAG_QINQ;

      SG_C_ASSERT(__sizeof__VLAN_TAG_QINQ, sizeof (VLAN_TAG_QINQ) == 4);

   #else
      typedef struct _VLAN_TAG_QINQ {
         UEXACT16 outer;
         UEXACT16 inner;
      } SG_PACK VLAN_TAG_QINQ, *PVLAN_TAG_QINQ;

      typedef union _VLAN_TAG_QINQ_UNION {
         VLAN_TAG_QINQ bits;
         u32 dw; // dword union
      } SG_PACK VLAN_TAG_QINQ_UNION, *PVLAN_TAG_QINQ_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TAG_QINQ_UNION, sizeof (VLAN_TAG_QINQ_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TAG_QINQ {
         union {
            struct { 
               UEXACT16 outer;
               UEXACT16 inner;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TAG_QINQ, *PVLAN_TAG_QINQ;

      SG_C_ASSERT(__sizeof__VLAN_TAG_QINQ, sizeof (VLAN_TAG_QINQ) == 4);

   #else
      typedef struct _VLAN_TAG_QINQ {
         UEXACT16 outer;
         UEXACT16 inner;
      } SG_PACK VLAN_TAG_QINQ, *PVLAN_TAG_QINQ;

      typedef union _VLAN_TAG_QINQ_UNION {
         VLAN_TAG_QINQ bits;
         u32 dw; // dword union
      } SG_PACK VLAN_TAG_QINQ_UNION, *PVLAN_TAG_QINQ_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TAG_QINQ_UNION, sizeof (VLAN_TAG_QINQ_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TAG_NORMAL {
         union {
            struct { 
               UEXACT16 tag;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TAG_NORMAL, *PVLAN_TAG_NORMAL;

      SG_C_ASSERT(__sizeof__VLAN_TAG_NORMAL, sizeof (VLAN_TAG_NORMAL) == 4);

   #else
      typedef struct _VLAN_TAG_NORMAL {
         UEXACT16 tag;
         UEXACT16 rsvd0;
      } SG_PACK VLAN_TAG_NORMAL, *PVLAN_TAG_NORMAL;

      typedef union _VLAN_TAG_NORMAL_UNION {
         VLAN_TAG_NORMAL bits;
         u32 dw; // dword union
      } SG_PACK VLAN_TAG_NORMAL_UNION, *PVLAN_TAG_NORMAL_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TAG_NORMAL_UNION, sizeof (VLAN_TAG_NORMAL_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _VLAN_TAG_NORMAL {
         union {
            struct { 
               UEXACT16 tag;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK VLAN_TAG_NORMAL, *PVLAN_TAG_NORMAL;

      SG_C_ASSERT(__sizeof__VLAN_TAG_NORMAL, sizeof (VLAN_TAG_NORMAL) == 4);

   #else
      typedef struct _VLAN_TAG_NORMAL {
         UEXACT16 tag;
         UEXACT16 rsvd0;
      } SG_PACK VLAN_TAG_NORMAL, *PVLAN_TAG_NORMAL;

      typedef union _VLAN_TAG_NORMAL_UNION {
         VLAN_TAG_NORMAL bits;
         u32 dw; // dword union
      } SG_PACK VLAN_TAG_NORMAL_UNION, *PVLAN_TAG_NORMAL_UNION;

      SG_C_ASSERT(__sizeof__VLAN_TAG_NORMAL_UNION, sizeof (VLAN_TAG_NORMAL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_INTERFACE_VLAN_TAG {
         union {
            union { 
               VLAN_TAG_QINQ qinq;
               VLAN_TAG_NORMAL normal;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_INTERFACE_VLAN_TAG, *PNTWK_INTERFACE_VLAN_TAG;

      SG_C_ASSERT(__sizeof__NTWK_INTERFACE_VLAN_TAG, sizeof (NTWK_INTERFACE_VLAN_TAG) == 4);

   #else
      typedef union _NTWK_INTERFACE_VLAN_TAG {
         VLAN_TAG_QINQ qinq;
         VLAN_TAG_NORMAL normal;
      } SG_PACK NTWK_INTERFACE_VLAN_TAG, *PNTWK_INTERFACE_VLAN_TAG;

      typedef union _NTWK_INTERFACE_VLAN_TAG_UNION {
         NTWK_INTERFACE_VLAN_TAG bits;
         u32 dw; // dword union
      } SG_PACK NTWK_INTERFACE_VLAN_TAG_UNION, *PNTWK_INTERFACE_VLAN_TAG_UNION;

      SG_C_ASSERT(__sizeof__NTWK_INTERFACE_VLAN_TAG_UNION, sizeof (NTWK_INTERFACE_VLAN_TAG_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_INTERFACE_VLAN_TAG {
         union {
            union { 
               VLAN_TAG_QINQ qinq;
               VLAN_TAG_NORMAL normal;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK NTWK_INTERFACE_VLAN_TAG, *PNTWK_INTERFACE_VLAN_TAG;

      SG_C_ASSERT(__sizeof__NTWK_INTERFACE_VLAN_TAG, sizeof (NTWK_INTERFACE_VLAN_TAG) == 4);

   #else
      typedef union _NTWK_INTERFACE_VLAN_TAG {
         VLAN_TAG_QINQ qinq;
         VLAN_TAG_NORMAL normal;
      } SG_PACK NTWK_INTERFACE_VLAN_TAG, *PNTWK_INTERFACE_VLAN_TAG;

      typedef union _NTWK_INTERFACE_VLAN_TAG_UNION {
         NTWK_INTERFACE_VLAN_TAG bits;
         u32 dw; // dword union
      } SG_PACK NTWK_INTERFACE_VLAN_TAG_UNION, *PNTWK_INTERFACE_VLAN_TAG_UNION;

      SG_C_ASSERT(__sizeof__NTWK_INTERFACE_VLAN_TAG_UNION, sizeof (NTWK_INTERFACE_VLAN_TAG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RXF_IF_CREATE_PARAMS {
         union {
            struct { 
               UEXACT32 version;
               UEXACT32 capability_flags;
               UEXACT32 enable_flags;
               UEXACT8 mac_address[6];
               UEXACT8 rsvd0;
               UEXACT8 pmac_invalid;
               NTWK_INTERFACE_VLAN_TAG vlan_tag;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS, *PBE2_RXF_IF_CREATE_PARAMS;

      SG_C_ASSERT(__sizeof__BE2_RXF_IF_CREATE_PARAMS, sizeof (BE2_RXF_IF_CREATE_PARAMS) == 24);

   #else
      typedef struct _BE2_RXF_IF_CREATE_PARAMS {
         UEXACT32 version;
         UEXACT32 capability_flags;
         UEXACT32 enable_flags;
         UEXACT8 mac_address[6];
         UEXACT8 rsvd0;
         UEXACT8 pmac_invalid;
         NTWK_INTERFACE_VLAN_TAG vlan_tag;
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS, *PBE2_RXF_IF_CREATE_PARAMS;

      typedef union _BE2_RXF_IF_CREATE_PARAMS_UNION {
         BE2_RXF_IF_CREATE_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS_UNION, *PBE2_RXF_IF_CREATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__BE2_RXF_IF_CREATE_PARAMS_UNION, sizeof (BE2_RXF_IF_CREATE_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE2_RXF_IF_CREATE_PARAMS {
         union {
            struct { 
               UEXACT32 version;
               UEXACT32 capability_flags;
               UEXACT32 enable_flags;
               UEXACT8 mac_address[6];
               UEXACT8 rsvd0;
               UEXACT8 pmac_invalid;
               NTWK_INTERFACE_VLAN_TAG vlan_tag;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS, *PBE2_RXF_IF_CREATE_PARAMS;

      SG_C_ASSERT(__sizeof__BE2_RXF_IF_CREATE_PARAMS, sizeof (BE2_RXF_IF_CREATE_PARAMS) == 24);

   #else
      typedef struct _BE2_RXF_IF_CREATE_PARAMS {
         UEXACT32 version;
         UEXACT32 capability_flags;
         UEXACT32 enable_flags;
         UEXACT8 mac_address[6];
         UEXACT8 rsvd0;
         UEXACT8 pmac_invalid;
         NTWK_INTERFACE_VLAN_TAG vlan_tag;
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS, *PBE2_RXF_IF_CREATE_PARAMS;

      typedef union _BE2_RXF_IF_CREATE_PARAMS_UNION {
         BE2_RXF_IF_CREATE_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK BE2_RXF_IF_CREATE_PARAMS_UNION, *PBE2_RXF_IF_CREATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__BE2_RXF_IF_CREATE_PARAMS_UNION, sizeof (BE2_RXF_IF_CREATE_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD {
         union {
            struct { 
               BE2_RXF_IF_CREATE_PARAMS rxf_if_create_params;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD) == 24);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD {
         BE2_RXF_IF_CREATE_PARAMS rxf_if_create_params;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD {
         union {
            struct { 
               BE2_RXF_IF_CREATE_PARAMS rxf_if_create_params;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD) == 24);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD {
         BE2_RXF_IF_CREATE_PARAMS rxf_if_create_params;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD {
         union {
            struct { 
               UEXACT32 interface_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD) == 8);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD {
         UEXACT32 interface_id;
         UEXACT32 pmac_id;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD {
         union {
            struct { 
               UEXACT32 interface_id;
               UEXACT32 pmac_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD) == 8);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD {
         UEXACT32 interface_id;
         UEXACT32 pmac_id;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INTERFACE_CREATE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD request;
               IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK INTERFACE_CREATE_PARAMS, *PINTERFACE_CREATE_PARAMS;

      SG_C_ASSERT(__sizeof__INTERFACE_CREATE_PARAMS, sizeof (INTERFACE_CREATE_PARAMS) == 24);

   #else
      typedef union _INTERFACE_CREATE_PARAMS {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD request;
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD response;
      } SG_PACK INTERFACE_CREATE_PARAMS, *PINTERFACE_CREATE_PARAMS;

      typedef union _INTERFACE_CREATE_PARAMS_UNION {
         INTERFACE_CREATE_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK INTERFACE_CREATE_PARAMS_UNION, *PINTERFACE_CREATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__INTERFACE_CREATE_PARAMS_UNION, sizeof (INTERFACE_CREATE_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _INTERFACE_CREATE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD request;
               IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK INTERFACE_CREATE_PARAMS, *PINTERFACE_CREATE_PARAMS;

      SG_C_ASSERT(__sizeof__INTERFACE_CREATE_PARAMS, sizeof (INTERFACE_CREATE_PARAMS) == 24);

   #else
      typedef union _INTERFACE_CREATE_PARAMS {
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD request;
         IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD response;
      } SG_PACK INTERFACE_CREATE_PARAMS, *PINTERFACE_CREATE_PARAMS;

      typedef union _INTERFACE_CREATE_PARAMS_UNION {
         INTERFACE_CREATE_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK INTERFACE_CREATE_PARAMS_UNION, *PINTERFACE_CREATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__INTERFACE_CREATE_PARAMS_UNION, sizeof (INTERFACE_CREATE_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to create a network interface provided filtering constraints. All filtering
   // requests are based on the interface id returned in the response payload upon
   // success. The IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are not enough resources to satisfy
   // the request.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_NO_STATUS -- the requested
   // parameters conflict with network configuration.  - MGMT_STATUS_UNAUTHORIZED_REQUEST
   // / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the caller is not authorized to issue
   // this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE {
      IOCTL_HEADER header;
      INTERFACE_CREATE_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE;



#else
   // Used to create a network interface provided filtering constraints. All filtering
   // requests are based on the interface id returned in the response payload upon
   // success. The IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the byte offset specified in
   // the additional status response is invalid.  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are not enough resources to satisfy
   // the request.  - MGMT_STATUS_FAILED / MGMT_ADDI_STATUS_NO_STATUS -- the requested
   // parameters conflict with network configuration.  - MGMT_STATUS_UNAUTHORIZED_REQUEST
   // / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the caller is not authorized to issue
   // this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_INTERFACE_CREATE {
      IOCTL_HEADER header;
      INTERFACE_CREATE_PARAMS params;
   } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_CREATE, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT32 interface_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD {
         UEXACT32 interface_id;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD {
         union {
            struct { 
               UEXACT32 interface_id;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, sizeof (IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD) == 4);

   #else
      typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD {
         UEXACT32 interface_id;
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD;

      typedef union _IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION {
         IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION, sizeof (IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to destroy a network interface previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY {
      IOCTL_HEADER header;
      union {
         IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY;



#else
   // Used to destroy a network interface previously created with
   // IOCTL_COMMON_NTWK_INTERFACE_CREATE. The IOCTL may fail with the following
   // status/additional_status codes:  -  - MGMT_STATUS_ILLEGAL_FIELD -- the request
   // parameter at the byte offset specified in the additional status response is invalid.
   //  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL. 
   typedef struct _IOCTL_COMMON_NTWK_INTERFACE_DESTROY {
      IOCTL_HEADER header;
      union {
         IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_INTERFACE_DESTROY, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE {
         union {
            struct { 
               UEXACT32 num_used;
               UEXACT32 base_cid;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, sizeof (IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE) == 8);

   #else
      typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE {
         UEXACT32 num_used;
         UEXACT32 base_cid;
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE;

      typedef union _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION {
         IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION, sizeof (IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE {
         union {
            struct { 
               UEXACT32 num_used;
               UEXACT32 base_cid;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, sizeof (IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE) == 8);

   #else
      typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE {
         UEXACT32 num_used;
         UEXACT32 base_cid;
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE;

      typedef union _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION {
         IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION, sizeof (IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Posts template headers buffers. These should be posted before any connections are
   // offloaded. Each buffer holds 32 template headers at 128 bytes each.  This may be
   // issued multiple times to post the template header buffers in smaller pieces. This
   // allows the driver to delay allocating template header buffers until the connections
   // are actually used.  Only protection domain 0 may post template header buffers. 
   typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 type;
            PHYS_ADDR scratch_pa;
            VIRT_ADDR sratch_va;
            VIRT_ADDR pages_va;
            PHYS_ADDR pages[16];
         } request;
         IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS;



#else
   // Posts template headers buffers. These should be posted before any connections are
   // offloaded. Each buffer holds 32 template headers at 128 bytes each.  This may be
   // issued multiple times to post the template header buffers in smaller pieces. This
   // allows the driver to delay allocating template header buffers until the connections
   // are actually used.  Only protection domain 0 may post template header buffers. 
   typedef struct _IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 type;
            PHYS_ADDR scratch_pa;
            VIRT_ADDR sratch_va;
            VIRT_ADDR pages_va;
            PHYS_ADDR pages[16];
         } request;
         IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Frees all template header buffers for the given type. Only protection domain 0 may
   // issue this request. The IOCTL may fail if any rings which use these template headers
   // are still in use. 
   typedef struct _IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 type;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 num_removed;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS, *PIOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS;



#else
   // Frees all template header buffers for the given type. Only protection domain 0 may
   // issue this request. The IOCTL may fail if any rings which use these template headers
   // are still in use. 
   typedef struct _IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 type;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 num_removed;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS, *PIOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Posts page tables for the UT. This command may be issued multiple times to add page
   // tables to the chip. 
   typedef struct _IOCTL_COMMON_ADD_PAGE_TABLES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num;
            UEXACT8 shared;
            UEXACT8 rsvd0;
            VIRT_ADDR va;
            PHYS_ADDR page_tables[26];
         } request;
         struct {
            UEXACT16 num_added;
            UEXACT16 num_total;
            UEXACT16 num_free;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ADD_PAGE_TABLES, *PIOCTL_COMMON_ADD_PAGE_TABLES;



#else
   // Posts page tables for the UT. This command may be issued multiple times to add page
   // tables to the chip. 
   typedef struct _IOCTL_COMMON_ADD_PAGE_TABLES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num;
            UEXACT8 shared;
            UEXACT8 rsvd0;
            VIRT_ADDR va;
            PHYS_ADDR page_tables[26];
         } request;
         struct {
            UEXACT16 num_added;
            UEXACT16 num_total;
            UEXACT16 num_free;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_ADD_PAGE_TABLES, *PIOCTL_COMMON_ADD_PAGE_TABLES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Removes free page tables from the chip. Only page tables that are unused may be
   // removed. Page tables may not be removed in the same order as they are posted. This
   // ioctl returns a list of physical addresses for the page tables that were removed. 
   typedef struct _IOCTL_COMMON_REMOVE_PAGE_TABLES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT16 actual_num;
            UEXACT16 total_num;
            PHYS_ADDR page_tables[27];
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_REMOVE_PAGE_TABLES, *PIOCTL_COMMON_REMOVE_PAGE_TABLES;



#else
   // Removes free page tables from the chip. Only page tables that are unused may be
   // removed. Page tables may not be removed in the same order as they are posted. This
   // ioctl returns a list of physical addresses for the page tables that were removed. 
   typedef struct _IOCTL_COMMON_REMOVE_PAGE_TABLES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT16 actual_num;
            UEXACT16 total_num;
            PHYS_ADDR page_tables[27];
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_REMOVE_PAGE_TABLES, *PIOCTL_COMMON_REMOVE_PAGE_TABLES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating a completion queue. A Completion Queue must span at least 1 page
   // and at most 4 pages. Each completion queue entry is 16 bytes regardless of CQ entry
   // format. Thus the ring must be at least 256 entries deep (corresponding to 1 page)
   // and can be at most 1024 entries deep (corresponding to 4 pages). The number of pages
   // posted must contain the CQ ring size as encoded in the context. 
   typedef struct _IOCTL_COMMON_CQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            CQ_CONTEXT context;
            PHYS_ADDR pages[4];
         } request;
         struct {
            UEXACT16 cq_id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_CQ_CREATE, *PIOCTL_COMMON_CQ_CREATE;



#else
   // IOCTL for creating a completion queue. A Completion Queue must span at least 1 page
   // and at most 4 pages. Each completion queue entry is 16 bytes regardless of CQ entry
   // format. Thus the ring must be at least 256 entries deep (corresponding to 1 page)
   // and can be at most 1024 entries deep (corresponding to 4 pages). The number of pages
   // posted must contain the CQ ring size as encoded in the context. 
   typedef struct _IOCTL_COMMON_CQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            CQ_CONTEXT context;
            PHYS_ADDR pages[4];
         } request;
         struct {
            UEXACT16 cq_id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_CQ_CREATE, *PIOCTL_COMMON_CQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying an MCC ring. 
   typedef struct _IOCTL_COMMON_MCC_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_DESTROY, *PIOCTL_COMMON_MCC_DESTROY;



#else
   // IOCTL for destroying an MCC ring. 
   typedef struct _IOCTL_COMMON_MCC_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_DESTROY, *PIOCTL_COMMON_MCC_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a CQ ring. 
   typedef struct _IOCTL_COMMON_CQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_CQ_DESTROY, *PIOCTL_COMMON_CQ_DESTROY;



#else
   // IOCTL for destroying a CQ ring. 
   typedef struct _IOCTL_COMMON_CQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_CQ_DESTROY, *PIOCTL_COMMON_CQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for destroying a EQ ring. 
   typedef struct _IOCTL_COMMON_EQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_EQ_DESTROY, *PIOCTL_COMMON_EQ_DESTROY;



#else
   // IOCTL for destroying a EQ ring. 
   typedef struct _IOCTL_COMMON_EQ_DESTROY {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_EQ_DESTROY, *PIOCTL_COMMON_EQ_DESTROY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating a event queue. An Event Queue must span at least 1 page and at
   // most 8 pages. The number of pages posted must contain the EQ ring. The ring is
   // defined by the size of the EQ entries (encoded in the context) and the number of EQ
   // entries (also encoded in the context). 
   typedef struct _IOCTL_COMMON_EQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            EQ_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 eq_id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_EQ_CREATE, *PIOCTL_COMMON_EQ_CREATE;



#else
   // IOCTL for creating a event queue. An Event Queue must span at least 1 page and at
   // most 8 pages. The number of pages posted must contain the EQ ring. The ring is
   // defined by the size of the EQ entries (encoded in the context) and the number of EQ
   // entries (also encoded in the context). 
   typedef struct _IOCTL_COMMON_EQ_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            EQ_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 eq_id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_EQ_CREATE, *PIOCTL_COMMON_EQ_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating the MCC ring. An MCC ring must be at least 16 entries deep
   // (corresponding to 1 page) and at most 128 entries deep (corresponding to 8 pages). 
   typedef struct _IOCTL_COMMON_MCC_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            MCC_RING_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_CREATE, *PIOCTL_COMMON_MCC_CREATE;



#else
   // IOCTL for creating the MCC ring. An MCC ring must be at least 16 entries deep
   // (corresponding to 1 page) and at most 128 entries deep (corresponding to 8 pages). 
   typedef struct _IOCTL_COMMON_MCC_CREATE {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            MCC_RING_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_CREATE, *PIOCTL_COMMON_MCC_CREATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL for creating the MCC ring. An MCC ring must be at least 16 entries deep
   // (corresponding to 1 page) and at most 128 entries deep (corresponding to 8 pages).
   // Use the new field 'async_event_bitmap' to subscribe to events. e.g For a driver to
   // subscribe to EventCodes: Link State (1), FCF State (2) and Group5 (5), the
   // async_event_bitmap should be 0000 0026h (bits 1,2 and 5 set). 
   typedef struct _IOCTL_COMMON_MCC_CREATE_EXT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 async_event_bitmap[1];
            MCC_RING_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_CREATE_EXT, *PIOCTL_COMMON_MCC_CREATE_EXT;



#else
   // IOCTL for creating the MCC ring. An MCC ring must be at least 16 entries deep
   // (corresponding to 1 page) and at most 128 entries deep (corresponding to 8 pages).
   // Use the new field 'async_event_bitmap' to subscribe to events. e.g For a driver to
   // subscribe to EventCodes: Link State (1), FCF State (2) and Group5 (5), the
   // async_event_bitmap should be 0000 0026h (bits 1,2 and 5 set). 
   typedef struct _IOCTL_COMMON_MCC_CREATE_EXT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 num_pages;
            UEXACT16 rsvd0;
            UEXACT32 async_event_bitmap[1];
            MCC_RING_CONTEXT context;
            PHYS_ADDR pages[8];
         } request;
         struct {
            UEXACT16 id;
            UEXACT16 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_MCC_CREATE_EXT, *PIOCTL_COMMON_MCC_CREATE_EXT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Posts a physical address pointing to a single byte of zero data that may be DMA'd. 
   typedef struct _IOCTL_COMMON_POST_ZERO_BUFFER {
      IOCTL_HEADER header;
      union {
         struct {
            PHYS_ADDR page;
            UEXACT32 remove;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_POST_ZERO_BUFFER, *PIOCTL_COMMON_POST_ZERO_BUFFER;



#else
   // Posts a physical address pointing to a single byte of zero data that may be DMA'd. 
   typedef struct _IOCTL_COMMON_POST_ZERO_BUFFER {
      IOCTL_HEADER header;
      union {
         struct {
            PHYS_ADDR page;
            UEXACT32 remove;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_POST_ZERO_BUFFER, *PIOCTL_COMMON_POST_ZERO_BUFFER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Configures the JELL -- the journal entry linked list required for any TCP offload.
   // This may also free a previously configured JELL. 
   typedef struct _IOCTL_COMMON_JELL_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 free_jell;
            UEXACT8 ddr;
            UEXACT8 done;
            UEXACT8 rsvd0;
            UEXACT16 page_offset;
            UEXACT16 num_pages;
            PHYS_ADDR pages[26];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_JELL_CONFIG, *PIOCTL_COMMON_JELL_CONFIG;



#else
   // Configures the JELL -- the journal entry linked list required for any TCP offload.
   // This may also free a previously configured JELL. 
   typedef struct _IOCTL_COMMON_JELL_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 free_jell;
            UEXACT8 ddr;
            UEXACT8 done;
            UEXACT8 rsvd0;
            UEXACT16 page_offset;
            UEXACT16 num_pages;
            PHYS_ADDR pages[26];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_JELL_CONFIG, *PIOCTL_COMMON_JELL_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_IN {
         union {
            struct { 
               UEXACT32 qos_params_rsvd;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_IN, *PGET_QOS_IN;

      SG_C_ASSERT(__sizeof__GET_QOS_IN, sizeof (GET_QOS_IN) == 4);

   #else
      typedef struct _GET_QOS_IN {
         UEXACT32 qos_params_rsvd;
      } SG_PACK GET_QOS_IN, *PGET_QOS_IN;

      typedef union _GET_QOS_IN_UNION {
         GET_QOS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_QOS_IN_UNION, *PGET_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_IN_UNION, sizeof (GET_QOS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_IN {
         union {
            struct { 
               UEXACT32 qos_params_rsvd;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_IN, *PGET_QOS_IN;

      SG_C_ASSERT(__sizeof__GET_QOS_IN, sizeof (GET_QOS_IN) == 4);

   #else
      typedef struct _GET_QOS_IN {
         UEXACT32 qos_params_rsvd;
      } SG_PACK GET_QOS_IN, *PGET_QOS_IN;

      typedef union _GET_QOS_IN_UNION {
         GET_QOS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_QOS_IN_UNION, *PGET_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_IN_UNION, sizeof (GET_QOS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_OUT {
         union {
            struct { 
               UEXACT32 max_bits_per_second_NIC;
               UEXACT32 max_packets_per_second_NIC;
               UEXACT32 max_ios_per_second_iSCSI;
               UEXACT32 max_bytes_per_second_iSCSI;
               UEXACT32 qos_params_oem[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_OUT, *PGET_QOS_OUT;

      SG_C_ASSERT(__sizeof__GET_QOS_OUT, sizeof (GET_QOS_OUT) == 32);

   #else
      typedef struct _GET_QOS_OUT {
         UEXACT32 max_bits_per_second_NIC;
         UEXACT32 max_packets_per_second_NIC;
         UEXACT32 max_ios_per_second_iSCSI;
         UEXACT32 max_bytes_per_second_iSCSI;
         UEXACT32 qos_params_oem[4];
      } SG_PACK GET_QOS_OUT, *PGET_QOS_OUT;

      typedef union _GET_QOS_OUT_UNION {
         GET_QOS_OUT bits;
         u32 dw[8]; // dword union
      } SG_PACK GET_QOS_OUT_UNION, *PGET_QOS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_OUT_UNION, sizeof (GET_QOS_OUT_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_OUT {
         union {
            struct { 
               UEXACT32 max_bits_per_second_NIC;
               UEXACT32 max_packets_per_second_NIC;
               UEXACT32 max_ios_per_second_iSCSI;
               UEXACT32 max_bytes_per_second_iSCSI;
               UEXACT32 qos_params_oem[4];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_OUT, *PGET_QOS_OUT;

      SG_C_ASSERT(__sizeof__GET_QOS_OUT, sizeof (GET_QOS_OUT) == 32);

   #else
      typedef struct _GET_QOS_OUT {
         UEXACT32 max_bits_per_second_NIC;
         UEXACT32 max_packets_per_second_NIC;
         UEXACT32 max_ios_per_second_iSCSI;
         UEXACT32 max_bytes_per_second_iSCSI;
         UEXACT32 qos_params_oem[4];
      } SG_PACK GET_QOS_OUT, *PGET_QOS_OUT;

      typedef union _GET_QOS_OUT_UNION {
         GET_QOS_OUT bits;
         u32 dw[8]; // dword union
      } SG_PACK GET_QOS_OUT_UNION, *PGET_QOS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_OUT_UNION, sizeof (GET_QOS_OUT_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_PARAMS {
         union {
            union { 
               GET_QOS_IN request;
               GET_QOS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_PARAMS, *PGET_QOS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_QOS_PARAMS, sizeof (GET_QOS_PARAMS) == 32);

   #else
      typedef union _GET_QOS_PARAMS {
         GET_QOS_IN request;
         GET_QOS_OUT response;
      } SG_PACK GET_QOS_PARAMS, *PGET_QOS_PARAMS;

      typedef union _GET_QOS_PARAMS_UNION {
         GET_QOS_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK GET_QOS_PARAMS_UNION, *PGET_QOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_PARAMS_UNION, sizeof (GET_QOS_PARAMS_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_QOS_PARAMS {
         union {
            union { 
               GET_QOS_IN request;
               GET_QOS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK GET_QOS_PARAMS, *PGET_QOS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_QOS_PARAMS, sizeof (GET_QOS_PARAMS) == 32);

   #else
      typedef union _GET_QOS_PARAMS {
         GET_QOS_IN request;
         GET_QOS_OUT response;
      } SG_PACK GET_QOS_PARAMS, *PGET_QOS_PARAMS;

      typedef union _GET_QOS_PARAMS_UNION {
         GET_QOS_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK GET_QOS_PARAMS_UNION, *PGET_QOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_QOS_PARAMS_UNION, sizeof (GET_QOS_PARAMS_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Retrieve transmit QoS settings. 
   typedef struct _IOCTL_COMMON_GET_QOS {
      IOCTL_HEADER header;
      GET_QOS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_QOS, *PIOCTL_COMMON_GET_QOS;



#else
   // Retrieve transmit QoS settings. 
   typedef struct _IOCTL_COMMON_GET_QOS {
      IOCTL_HEADER header;
      GET_QOS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_QOS, *PIOCTL_COMMON_GET_QOS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_IN {
         union {
            struct { 
               UEXACT32 valid_flags;
               UEXACT32 max_bits_per_second_NIC;
               UEXACT32 max_packets_per_second_NIC;
               UEXACT32 max_ios_per_second_iSCSI;
               UEXACT32 max_bytes_per_second_iSCSI;
               UEXACT32 qos_params_oem[4];
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_IN, *PSET_QOS_IN;

      SG_C_ASSERT(__sizeof__SET_QOS_IN, sizeof (SET_QOS_IN) == 36);

   #else
      typedef struct _SET_QOS_IN {
         UEXACT32 valid_flags;
         UEXACT32 max_bits_per_second_NIC;
         UEXACT32 max_packets_per_second_NIC;
         UEXACT32 max_ios_per_second_iSCSI;
         UEXACT32 max_bytes_per_second_iSCSI;
         UEXACT32 qos_params_oem[4];
      } SG_PACK SET_QOS_IN, *PSET_QOS_IN;

      typedef union _SET_QOS_IN_UNION {
         SET_QOS_IN bits;
         u32 dw[9]; // dword union
      } SG_PACK SET_QOS_IN_UNION, *PSET_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_IN_UNION, sizeof (SET_QOS_IN_UNION) == 36);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_IN {
         union {
            struct { 
               UEXACT32 valid_flags;
               UEXACT32 max_bits_per_second_NIC;
               UEXACT32 max_packets_per_second_NIC;
               UEXACT32 max_ios_per_second_iSCSI;
               UEXACT32 max_bytes_per_second_iSCSI;
               UEXACT32 qos_params_oem[4];
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_IN, *PSET_QOS_IN;

      SG_C_ASSERT(__sizeof__SET_QOS_IN, sizeof (SET_QOS_IN) == 36);

   #else
      typedef struct _SET_QOS_IN {
         UEXACT32 valid_flags;
         UEXACT32 max_bits_per_second_NIC;
         UEXACT32 max_packets_per_second_NIC;
         UEXACT32 max_ios_per_second_iSCSI;
         UEXACT32 max_bytes_per_second_iSCSI;
         UEXACT32 qos_params_oem[4];
      } SG_PACK SET_QOS_IN, *PSET_QOS_IN;

      typedef union _SET_QOS_IN_UNION {
         SET_QOS_IN bits;
         u32 dw[9]; // dword union
      } SG_PACK SET_QOS_IN_UNION, *PSET_QOS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_IN_UNION, sizeof (SET_QOS_IN_UNION) == 36);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_OUT {
         union {
            struct { 
               UEXACT32 qos_params_rsvd;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_OUT, *PSET_QOS_OUT;

      SG_C_ASSERT(__sizeof__SET_QOS_OUT, sizeof (SET_QOS_OUT) == 4);

   #else
      typedef struct _SET_QOS_OUT {
         UEXACT32 qos_params_rsvd;
      } SG_PACK SET_QOS_OUT, *PSET_QOS_OUT;

      typedef union _SET_QOS_OUT_UNION {
         SET_QOS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_QOS_OUT_UNION, *PSET_QOS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_OUT_UNION, sizeof (SET_QOS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_OUT {
         union {
            struct { 
               UEXACT32 qos_params_rsvd;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_OUT, *PSET_QOS_OUT;

      SG_C_ASSERT(__sizeof__SET_QOS_OUT, sizeof (SET_QOS_OUT) == 4);

   #else
      typedef struct _SET_QOS_OUT {
         UEXACT32 qos_params_rsvd;
      } SG_PACK SET_QOS_OUT, *PSET_QOS_OUT;

      typedef union _SET_QOS_OUT_UNION {
         SET_QOS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_QOS_OUT_UNION, *PSET_QOS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_OUT_UNION, sizeof (SET_QOS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_PARAMS {
         union {
            union { 
               SET_QOS_IN request;
               SET_QOS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_PARAMS, *PSET_QOS_PARAMS;

      SG_C_ASSERT(__sizeof__SET_QOS_PARAMS, sizeof (SET_QOS_PARAMS) == 36);

   #else
      typedef union _SET_QOS_PARAMS {
         SET_QOS_IN request;
         SET_QOS_OUT response;
      } SG_PACK SET_QOS_PARAMS, *PSET_QOS_PARAMS;

      typedef union _SET_QOS_PARAMS_UNION {
         SET_QOS_PARAMS bits;
         u32 dw[9]; // dword union
      } SG_PACK SET_QOS_PARAMS_UNION, *PSET_QOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_PARAMS_UNION, sizeof (SET_QOS_PARAMS_UNION) == 36);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_QOS_PARAMS {
         union {
            union { 
               SET_QOS_IN request;
               SET_QOS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[9]; // dword union
         }; // unnamed union
      } SG_PACK SET_QOS_PARAMS, *PSET_QOS_PARAMS;

      SG_C_ASSERT(__sizeof__SET_QOS_PARAMS, sizeof (SET_QOS_PARAMS) == 36);

   #else
      typedef union _SET_QOS_PARAMS {
         SET_QOS_IN request;
         SET_QOS_OUT response;
      } SG_PACK SET_QOS_PARAMS, *PSET_QOS_PARAMS;

      typedef union _SET_QOS_PARAMS_UNION {
         SET_QOS_PARAMS bits;
         u32 dw[9]; // dword union
      } SG_PACK SET_QOS_PARAMS_UNION, *PSET_QOS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_QOS_PARAMS_UNION, sizeof (SET_QOS_PARAMS_UNION) == 36);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL to set the transmit QoS settings for a given domain. The IOCTL may fail with
   // the following status/additional_status codes:  -  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are insufficient resources to
   // satisfy the request.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER --
   // Not enough buffer space provided for the QoS settings (we require everything) 
   typedef struct _IOCTL_COMMON_SET_QOS {
      IOCTL_HEADER header;
      SET_QOS_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_QOS, *PIOCTL_COMMON_SET_QOS;



#else
   // IOCTL to set the transmit QoS settings for a given domain. The IOCTL may fail with
   // the following status/additional_status codes:  -  - MGMT_STATUS_FAILED /
   // MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES -- there are insufficient resources to
   // satisfy the request.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE -- the
   // caller is not authorized to issue this IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER --
   // Not enough buffer space provided for the QoS settings (we require everything) 
   typedef struct _IOCTL_COMMON_SET_QOS {
      IOCTL_HEADER header;
      SET_QOS_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_QOS, *PIOCTL_COMMON_SET_QOS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_IN {
         union {
            struct { 
               UEXACT32 max_tx_frame_size;
               UEXACT32 max_rx_frame_size;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_IN, *PSET_FRAME_SIZE_IN;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_IN, sizeof (SET_FRAME_SIZE_IN) == 8);

   #else
      typedef struct _SET_FRAME_SIZE_IN {
         UEXACT32 max_tx_frame_size;
         UEXACT32 max_rx_frame_size;
      } SG_PACK SET_FRAME_SIZE_IN, *PSET_FRAME_SIZE_IN;

      typedef union _SET_FRAME_SIZE_IN_UNION {
         SET_FRAME_SIZE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_IN_UNION, *PSET_FRAME_SIZE_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_IN_UNION, sizeof (SET_FRAME_SIZE_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_IN {
         union {
            struct { 
               UEXACT32 max_tx_frame_size;
               UEXACT32 max_rx_frame_size;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_IN, *PSET_FRAME_SIZE_IN;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_IN, sizeof (SET_FRAME_SIZE_IN) == 8);

   #else
      typedef struct _SET_FRAME_SIZE_IN {
         UEXACT32 max_tx_frame_size;
         UEXACT32 max_rx_frame_size;
      } SG_PACK SET_FRAME_SIZE_IN, *PSET_FRAME_SIZE_IN;

      typedef union _SET_FRAME_SIZE_IN_UNION {
         SET_FRAME_SIZE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_IN_UNION, *PSET_FRAME_SIZE_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_IN_UNION, sizeof (SET_FRAME_SIZE_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_OUT {
         union {
            struct { 
               UEXACT32 chip_max_tx_frame_size;
               UEXACT32 chip_max_rx_frame_size;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_OUT, *PSET_FRAME_SIZE_OUT;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_OUT, sizeof (SET_FRAME_SIZE_OUT) == 8);

   #else
      typedef struct _SET_FRAME_SIZE_OUT {
         UEXACT32 chip_max_tx_frame_size;
         UEXACT32 chip_max_rx_frame_size;
      } SG_PACK SET_FRAME_SIZE_OUT, *PSET_FRAME_SIZE_OUT;

      typedef union _SET_FRAME_SIZE_OUT_UNION {
         SET_FRAME_SIZE_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_OUT_UNION, *PSET_FRAME_SIZE_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_OUT_UNION, sizeof (SET_FRAME_SIZE_OUT_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_OUT {
         union {
            struct { 
               UEXACT32 chip_max_tx_frame_size;
               UEXACT32 chip_max_rx_frame_size;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_OUT, *PSET_FRAME_SIZE_OUT;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_OUT, sizeof (SET_FRAME_SIZE_OUT) == 8);

   #else
      typedef struct _SET_FRAME_SIZE_OUT {
         UEXACT32 chip_max_tx_frame_size;
         UEXACT32 chip_max_rx_frame_size;
      } SG_PACK SET_FRAME_SIZE_OUT, *PSET_FRAME_SIZE_OUT;

      typedef union _SET_FRAME_SIZE_OUT_UNION {
         SET_FRAME_SIZE_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_OUT_UNION, *PSET_FRAME_SIZE_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_OUT_UNION, sizeof (SET_FRAME_SIZE_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_PARAMS {
         union {
            union { 
               SET_FRAME_SIZE_IN request;
               SET_FRAME_SIZE_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_PARAMS, *PSET_FRAME_SIZE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_PARAMS, sizeof (SET_FRAME_SIZE_PARAMS) == 8);

   #else
      typedef union _SET_FRAME_SIZE_PARAMS {
         SET_FRAME_SIZE_IN request;
         SET_FRAME_SIZE_OUT response;
      } SG_PACK SET_FRAME_SIZE_PARAMS, *PSET_FRAME_SIZE_PARAMS;

      typedef union _SET_FRAME_SIZE_PARAMS_UNION {
         SET_FRAME_SIZE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_PARAMS_UNION, *PSET_FRAME_SIZE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_PARAMS_UNION, sizeof (SET_FRAME_SIZE_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_FRAME_SIZE_PARAMS {
         union {
            union { 
               SET_FRAME_SIZE_IN request;
               SET_FRAME_SIZE_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_FRAME_SIZE_PARAMS, *PSET_FRAME_SIZE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_PARAMS, sizeof (SET_FRAME_SIZE_PARAMS) == 8);

   #else
      typedef union _SET_FRAME_SIZE_PARAMS {
         SET_FRAME_SIZE_IN request;
         SET_FRAME_SIZE_OUT response;
      } SG_PACK SET_FRAME_SIZE_PARAMS, *PSET_FRAME_SIZE_PARAMS;

      typedef union _SET_FRAME_SIZE_PARAMS_UNION {
         SET_FRAME_SIZE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_FRAME_SIZE_PARAMS_UNION, *PSET_FRAME_SIZE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_FRAME_SIZE_PARAMS_UNION, sizeof (SET_FRAME_SIZE_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Set frame size IOCTL. Only a host domain may issue this IOCTL. 
   typedef struct _IOCTL_COMMON_SET_FRAME_SIZE {
      IOCTL_HEADER header;
      SET_FRAME_SIZE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_FRAME_SIZE, *PIOCTL_COMMON_SET_FRAME_SIZE;



#else
   // Set frame size IOCTL. Only a host domain may issue this IOCTL. 
   typedef struct _IOCTL_COMMON_SET_FRAME_SIZE {
      IOCTL_HEADER header;
      SET_FRAME_SIZE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_FRAME_SIZE, *PIOCTL_COMMON_SET_FRAME_SIZE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 max_ioctl_buffer_size;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, sizeof (QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT) == 4);

   #else
      typedef struct _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT {
         UEXACT32 max_ioctl_buffer_size;
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT;

      typedef union _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION {
         QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION, sizeof (QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 max_ioctl_buffer_size;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, sizeof (QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT) == 4);

   #else
      typedef struct _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT {
         UEXACT32 max_ioctl_buffer_size;
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT;

      typedef union _QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION {
         QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION, sizeof (QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IOCTL_QUERY_MAX_IOCTL_BUFFER_SIZE MILI uses this IOCTL to find out the maximum
   // buffer size that can be accepted by the host OS or the OSM. During MILI
   // initialization, MILI should send this IOCTL to find out the maximum IOCTL buffer
   // size allowed. For all the IOCTLs in the future, MILI should not allocate a buffer
   // larger than this value. In Windows, the OS doesn't deliver the IOCTL request when
   // the buffer size allocated by MILI is larger than the maximum I/O size allowed by
   // OSM. 
   typedef struct _IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE {
      IOCTL_HEADER header;
      QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT response;
   } SG_PACK IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE, *PIOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE;



#else
   // IOCTL_QUERY_MAX_IOCTL_BUFFER_SIZE MILI uses this IOCTL to find out the maximum
   // buffer size that can be accepted by the host OS or the OSM. During MILI
   // initialization, MILI should send this IOCTL to find out the maximum IOCTL buffer
   // size allowed. For all the IOCTLs in the future, MILI should not allocate a buffer
   // larger than this value. In Windows, the OS doesn't deliver the IOCTL request when
   // the buffer size allocated by MILI is larger than the maximum I/O size allowed by
   // OSM. 
   typedef struct _IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE {
      IOCTL_HEADER header;
      QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT response;
   } SG_PACK IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE, *PIOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FLASHROM_PARAMS {
         union {
            struct { 
               UEXACT32 op_code;
               UEXACT32 op_type;
               UEXACT32 data_buffer_size;
               UEXACT32 offset;
               UEXACT8 data_buffer[4];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK FLASHROM_PARAMS, *PFLASHROM_PARAMS;

      SG_C_ASSERT(__sizeof__FLASHROM_PARAMS, sizeof (FLASHROM_PARAMS) == 20);

   #else
      typedef struct _FLASHROM_PARAMS {
         UEXACT32 op_code;
         UEXACT32 op_type;
         UEXACT32 data_buffer_size;
         UEXACT32 offset;
         UEXACT8 data_buffer[4];
      } SG_PACK FLASHROM_PARAMS, *PFLASHROM_PARAMS;

      typedef union _FLASHROM_PARAMS_UNION {
         FLASHROM_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK FLASHROM_PARAMS_UNION, *PFLASHROM_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__FLASHROM_PARAMS_UNION, sizeof (FLASHROM_PARAMS_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FLASHROM_PARAMS {
         union {
            struct { 
               UEXACT32 op_code;
               UEXACT32 op_type;
               UEXACT32 data_buffer_size;
               UEXACT32 offset;
               UEXACT8 data_buffer[4];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK FLASHROM_PARAMS, *PFLASHROM_PARAMS;

      SG_C_ASSERT(__sizeof__FLASHROM_PARAMS, sizeof (FLASHROM_PARAMS) == 20);

   #else
      typedef struct _FLASHROM_PARAMS {
         UEXACT32 op_code;
         UEXACT32 op_type;
         UEXACT32 data_buffer_size;
         UEXACT32 offset;
         UEXACT8 data_buffer[4];
      } SG_PACK FLASHROM_PARAMS, *PFLASHROM_PARAMS;

      typedef union _FLASHROM_PARAMS_UNION {
         FLASHROM_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK FLASHROM_PARAMS_UNION, *PFLASHROM_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__FLASHROM_PARAMS_UNION, sizeof (FLASHROM_PARAMS_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_FLASHROM {
      IOCTL_HEADER header;
      FLASHROM_PARAMS params;
   } SG_PACK IOCTL_COMMON_FLASHROM, *PIOCTL_COMMON_FLASHROM;



#else
   
   typedef struct _IOCTL_COMMON_FLASHROM {
      IOCTL_HEADER header;
      FLASHROM_PARAMS params;
   } SG_PACK IOCTL_COMMON_FLASHROM, *PIOCTL_COMMON_FLASHROM;



#endif

typedef IOCTL_COMMON_FLASHROM IOCTL_COMMON_READ_FLASHROM;


typedef IOCTL_COMMON_FLASHROM* PIOCTL_COMMON_READ_FLASHROM;


typedef IOCTL_COMMON_FLASHROM IOCTL_COMMON_WRITE_FLASHROM;


typedef IOCTL_COMMON_FLASHROM* PIOCTL_COMMON_WRITE_FLASHROM;


typedef IOCTL_COMMON_FLASHROM IOCTL_COMMON_WRITE_PHY_FLASHROM;


typedef IOCTL_COMMON_FLASHROM* PIOCTL_COMMON_WRITE_PHY_FLASHROM;

#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEEPROM_READ_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 seeprom_data[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK SEEPROM_READ_PARAMS_OUT, *PSEEPROM_READ_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_OUT, sizeof (SEEPROM_READ_PARAMS_OUT) == 1024);

   #else
      typedef struct _SEEPROM_READ_PARAMS_OUT {
         UEXACT8 seeprom_data[1024];
      } SG_PACK SEEPROM_READ_PARAMS_OUT, *PSEEPROM_READ_PARAMS_OUT;

      typedef union _SEEPROM_READ_PARAMS_OUT_UNION {
         SEEPROM_READ_PARAMS_OUT bits;
         u32 dw[256]; // dword union
      } SG_PACK SEEPROM_READ_PARAMS_OUT_UNION, *PSEEPROM_READ_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_OUT_UNION, sizeof (SEEPROM_READ_PARAMS_OUT_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEEPROM_READ_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 seeprom_data[1024];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK SEEPROM_READ_PARAMS_OUT, *PSEEPROM_READ_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_OUT, sizeof (SEEPROM_READ_PARAMS_OUT) == 1024);

   #else
      typedef struct _SEEPROM_READ_PARAMS_OUT {
         UEXACT8 seeprom_data[1024];
      } SG_PACK SEEPROM_READ_PARAMS_OUT, *PSEEPROM_READ_PARAMS_OUT;

      typedef union _SEEPROM_READ_PARAMS_OUT_UNION {
         SEEPROM_READ_PARAMS_OUT bits;
         u32 dw[256]; // dword union
      } SG_PACK SEEPROM_READ_PARAMS_OUT_UNION, *PSEEPROM_READ_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_OUT_UNION, sizeof (SEEPROM_READ_PARAMS_OUT_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEEPROM_READ_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               SEEPROM_READ_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK SEEPROM_READ_PARAMS, *PSEEPROM_READ_PARAMS;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS, sizeof (SEEPROM_READ_PARAMS) == 1024);

   #else
      typedef union _SEEPROM_READ_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         SEEPROM_READ_PARAMS_OUT response;
      } SG_PACK SEEPROM_READ_PARAMS, *PSEEPROM_READ_PARAMS;

      typedef union _SEEPROM_READ_PARAMS_UNION {
         SEEPROM_READ_PARAMS bits;
         u32 dw[256]; // dword union
      } SG_PACK SEEPROM_READ_PARAMS_UNION, *PSEEPROM_READ_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_UNION, sizeof (SEEPROM_READ_PARAMS_UNION) == 1024);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEEPROM_READ_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               SEEPROM_READ_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK SEEPROM_READ_PARAMS, *PSEEPROM_READ_PARAMS;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS, sizeof (SEEPROM_READ_PARAMS) == 1024);

   #else
      typedef union _SEEPROM_READ_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         SEEPROM_READ_PARAMS_OUT response;
      } SG_PACK SEEPROM_READ_PARAMS, *PSEEPROM_READ_PARAMS;

      typedef union _SEEPROM_READ_PARAMS_UNION {
         SEEPROM_READ_PARAMS bits;
         u32 dw[256]; // dword union
      } SG_PACK SEEPROM_READ_PARAMS_UNION, *PSEEPROM_READ_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SEEPROM_READ_PARAMS_UNION, sizeof (SEEPROM_READ_PARAMS_UNION) == 1024);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Use this IOCTL to retrieve BE HBA/instance specific information  - Functionality (or
   // combinations of functions) supported (TOE/NIC/iSCSI/VM/RDMA etc.)  - Manufacturer
   // assigned MAC addresses for the various functions  - Flash ROM type and size 
   typedef struct _IOCTL_COMMON_SEEPROM_READ {
      IOCTL_HEADER header;
      SEEPROM_READ_PARAMS params;
   } SG_PACK IOCTL_COMMON_SEEPROM_READ, *PIOCTL_COMMON_SEEPROM_READ;



#else
   // Use this IOCTL to retrieve BE HBA/instance specific information  - Functionality (or
   // combinations of functions) supported (TOE/NIC/iSCSI/VM/RDMA etc.)  - Manufacturer
   // assigned MAC addresses for the various functions  - Flash ROM type and size 
   typedef struct _IOCTL_COMMON_SEEPROM_READ {
      IOCTL_HEADER header;
      SEEPROM_READ_PARAMS params;
   } SG_PACK IOCTL_COMMON_SEEPROM_READ, *PIOCTL_COMMON_SEEPROM_READ;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // These values are 64-bit duplicates of selected counters in BE_TPRE_STATS, if
   // driver/Host cannot poll in small intervals, these values can be used for more
   // accuracy. 
   typedef struct _BE_TPRE_STATS_MISC {
      UEXACT64 p0_rx_bytes;
      UEXACT64 p1_rx_bytes;
   } SG_PACK BE_TPRE_STATS_MISC, *PBE_TPRE_STATS_MISC;



#else
   // These values are 64-bit duplicates of selected counters in BE_TPRE_STATS, if
   // driver/Host cannot poll in small intervals, these values can be used for more
   // accuracy. 
   typedef struct _BE_TPRE_STATS_MISC {
      UEXACT64 p0_rx_bytes;
      UEXACT64 p1_rx_bytes;
   } SG_PACK BE_TPRE_STATS_MISC, *PBE_TPRE_STATS_MISC;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // These values are 64-bit duplicates of selected counters in BE_TPOST_STATS, if
   // driver/Host cannot poll in small intervals, these values can be used for more
   // accuracy. 
   typedef struct _BE_TPOST_STATS_MISC {
      UEXACT64 rsvd0;
   } SG_PACK BE_TPOST_STATS_MISC, *PBE_TPOST_STATS_MISC;



#else
   // These values are 64-bit duplicates of selected counters in BE_TPOST_STATS, if
   // driver/Host cannot poll in small intervals, these values can be used for more
   // accuracy. 
   typedef struct _BE_TPOST_STATS_MISC {
      UEXACT64 rsvd0;
   } SG_PACK BE_TPOST_STATS_MISC, *PBE_TPOST_STATS_MISC;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TCP_STATS {
         union {
            struct { 
               BE_TPRE_STATS rx;
               BE_TPOST_STATS tx;
               BE_TPRE_STATS_MISC rx_misc;
               BE_TPOST_STATS_MISC tx_misc;
            } SG_PACK ; // unnamed struct
            u32 dw[518]; // dword union
         }; // unnamed union
      } SG_PACK BE_TCP_STATS, *PBE_TCP_STATS;

      SG_C_ASSERT(__sizeof__BE_TCP_STATS, sizeof (BE_TCP_STATS) == 2072);

   #else
      typedef struct _BE_TCP_STATS {
         BE_TPRE_STATS rx;
         BE_TPOST_STATS tx;
         BE_TPRE_STATS_MISC rx_misc;
         BE_TPOST_STATS_MISC tx_misc;
      } SG_PACK BE_TCP_STATS, *PBE_TCP_STATS;

      typedef union _BE_TCP_STATS_UNION {
         BE_TCP_STATS bits;
         u32 dw[518]; // dword union
      } SG_PACK BE_TCP_STATS_UNION, *PBE_TCP_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TCP_STATS_UNION, sizeof (BE_TCP_STATS_UNION) == 2072);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_TCP_STATS {
         union {
            struct { 
               BE_TPRE_STATS rx;
               BE_TPOST_STATS tx;
               BE_TPRE_STATS_MISC rx_misc;
               BE_TPOST_STATS_MISC tx_misc;
            } SG_PACK ; // unnamed struct
            u32 dw[518]; // dword union
         }; // unnamed union
      } SG_PACK BE_TCP_STATS, *PBE_TCP_STATS;

      SG_C_ASSERT(__sizeof__BE_TCP_STATS, sizeof (BE_TCP_STATS) == 2072);

   #else
      typedef struct _BE_TCP_STATS {
         BE_TPRE_STATS rx;
         BE_TPOST_STATS tx;
         BE_TPRE_STATS_MISC rx_misc;
         BE_TPOST_STATS_MISC tx_misc;
      } SG_PACK BE_TCP_STATS, *PBE_TCP_STATS;

      typedef union _BE_TCP_STATS_UNION {
         BE_TCP_STATS bits;
         u32 dw[518]; // dword union
      } SG_PACK BE_TCP_STATS_UNION, *PBE_TCP_STATS_UNION;

      SG_C_ASSERT(__sizeof__BE_TCP_STATS_UNION, sizeof (BE_TCP_STATS_UNION) == 2072);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_GET_STATISTICS_PARAMS {
         union {
            union { 
               BE_TCP_STATS response;
               struct {
                  UEXACT32 rsvd0;
               } request;
            } SG_PACK ; // unnamed struct
            u32 dw[518]; // dword union
         }; // unnamed union
      } SG_PACK TCP_GET_STATISTICS_PARAMS, *PTCP_GET_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__TCP_GET_STATISTICS_PARAMS, sizeof (TCP_GET_STATISTICS_PARAMS) == 2072);

   #else
      typedef union _TCP_GET_STATISTICS_PARAMS {
         BE_TCP_STATS response;
         struct {
            UEXACT32 rsvd0;
         } request;
      } SG_PACK TCP_GET_STATISTICS_PARAMS, *PTCP_GET_STATISTICS_PARAMS;

      typedef union _TCP_GET_STATISTICS_PARAMS_UNION {
         TCP_GET_STATISTICS_PARAMS bits;
         u32 dw[518]; // dword union
      } SG_PACK TCP_GET_STATISTICS_PARAMS_UNION, *PTCP_GET_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TCP_GET_STATISTICS_PARAMS_UNION, sizeof (TCP_GET_STATISTICS_PARAMS_UNION) == 2072);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _TCP_GET_STATISTICS_PARAMS {
         union {
            union { 
               BE_TCP_STATS response;
               struct {
                  UEXACT32 rsvd0;
               } request;
            } SG_PACK ; // unnamed struct
            u32 dw[518]; // dword union
         }; // unnamed union
      } SG_PACK TCP_GET_STATISTICS_PARAMS, *PTCP_GET_STATISTICS_PARAMS;

      SG_C_ASSERT(__sizeof__TCP_GET_STATISTICS_PARAMS, sizeof (TCP_GET_STATISTICS_PARAMS) == 2072);

   #else
      typedef union _TCP_GET_STATISTICS_PARAMS {
         BE_TCP_STATS response;
         struct {
            UEXACT32 rsvd0;
         } request;
      } SG_PACK TCP_GET_STATISTICS_PARAMS, *PTCP_GET_STATISTICS_PARAMS;

      typedef union _TCP_GET_STATISTICS_PARAMS_UNION {
         TCP_GET_STATISTICS_PARAMS bits;
         u32 dw[518]; // dword union
      } SG_PACK TCP_GET_STATISTICS_PARAMS_UNION, *PTCP_GET_STATISTICS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__TCP_GET_STATISTICS_PARAMS_UNION, sizeof (TCP_GET_STATISTICS_PARAMS_UNION) == 2072);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_TCP_GET_STATISTICS {
      IOCTL_HEADER header;
      TCP_GET_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_COMMON_TCP_GET_STATISTICS, *PIOCTL_COMMON_TCP_GET_STATISTICS;



#else
   
   typedef struct _IOCTL_COMMON_TCP_GET_STATISTICS {
      IOCTL_HEADER header;
      TCP_GET_STATISTICS_PARAMS params;
   } SG_PACK IOCTL_COMMON_TCP_GET_STATISTICS, *PIOCTL_COMMON_TCP_GET_STATISTICS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Queries the TCP state of a given connection. 
   typedef struct _IOCTL_COMMON_TCP_STATE_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            TCP_CONTEXT context;
         } response;
         struct {
            UEXACT32 cid;
         } request;
      } params;
   } SG_PACK IOCTL_COMMON_TCP_STATE_QUERY, *PIOCTL_COMMON_TCP_STATE_QUERY;



#else
   // Queries the TCP state of a given connection. 
   typedef struct _IOCTL_COMMON_TCP_STATE_QUERY {
      IOCTL_HEADER header;
      union {
         struct {
            TCP_CONTEXT context;
         } response;
         struct {
            UEXACT32 cid;
         } request;
      } params;
   } SG_PACK IOCTL_COMMON_TCP_STATE_QUERY, *PIOCTL_COMMON_TCP_STATE_QUERY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This ioctl queries the controller information from the Flash ROM. This is required
   // for management applications and BIOS to display this information to the users. 
   typedef struct _IOCTL_COMMON_GET_CNTL_ATTRIBUTES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            MGMT_CONTROLLER_ATTRIBUTES cntl_attributes_info;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_CNTL_ATTRIBUTES, *PIOCTL_COMMON_GET_CNTL_ATTRIBUTES;



#else
   // This ioctl queries the controller information from the Flash ROM. This is required
   // for management applications and BIOS to display this information to the users. 
   typedef struct _IOCTL_COMMON_GET_CNTL_ATTRIBUTES {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            MGMT_CONTROLLER_ATTRIBUTES cntl_attributes_info;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_CNTL_ATTRIBUTES, *PIOCTL_COMMON_GET_CNTL_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This ioctl can be used by clients as a no-operation request. Typical uses for
   // drivers are as a heartbeat mechanism, or deferred processing catalyst. The ARM will
   // always complete this IOCTL with a good completion. The 64-bit parameter is not
   // touched by the ARM processor. 
   typedef struct _IOCTL_COMMON_NOP {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT64 context;
         } request;
         struct {
            UEXACT64 context;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_NOP, *PIOCTL_COMMON_NOP;



#else
   // This ioctl can be used by clients as a no-operation request. Typical uses for
   // drivers are as a heartbeat mechanism, or deferred processing catalyst. The ARM will
   // always complete this IOCTL with a good completion. The 64-bit parameter is not
   // touched by the ARM processor. 
   typedef struct _IOCTL_COMMON_NOP {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT64 context;
         } request;
         struct {
            UEXACT64 context;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_NOP, *PIOCTL_COMMON_NOP;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_RX_FILTER_SETTINGS {
         union {
            struct { 
               UEXACT32 global_flags_mask;
               UEXACT32 global_flags;
               UEXACT32 if_flags_mask;
               UEXACT32 if_flags;
               UEXACT32 if_id;
               UEXACT32 multicast_num;
               struct {
                  UEXACT8 bytes[6];
               } multicast_mac_list[32];
            } SG_PACK ; // unnamed struct
            u32 dw[54]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_RX_FILTER_SETTINGS, *PNTWK_RX_FILTER_SETTINGS;

      SG_C_ASSERT(__sizeof__NTWK_RX_FILTER_SETTINGS, sizeof (NTWK_RX_FILTER_SETTINGS) == 216);

   #else
      typedef struct _NTWK_RX_FILTER_SETTINGS {
         UEXACT32 global_flags_mask;
         UEXACT32 global_flags;
         UEXACT32 if_flags_mask;
         UEXACT32 if_flags;
         UEXACT32 if_id;
         UEXACT32 multicast_num;
         struct {
            UEXACT8 bytes[6];
         } multicast_mac_list[32];
      } SG_PACK NTWK_RX_FILTER_SETTINGS, *PNTWK_RX_FILTER_SETTINGS;

      typedef union _NTWK_RX_FILTER_SETTINGS_UNION {
         NTWK_RX_FILTER_SETTINGS bits;
         u32 dw[54]; // dword union
      } SG_PACK NTWK_RX_FILTER_SETTINGS_UNION, *PNTWK_RX_FILTER_SETTINGS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_RX_FILTER_SETTINGS_UNION, sizeof (NTWK_RX_FILTER_SETTINGS_UNION) == 216);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NTWK_RX_FILTER_SETTINGS {
         union {
            struct { 
               UEXACT32 global_flags_mask;
               UEXACT32 global_flags;
               UEXACT32 if_flags_mask;
               UEXACT32 if_flags;
               UEXACT32 if_id;
               UEXACT32 multicast_num;
               struct {
                  UEXACT8 bytes[6];
               } multicast_mac_list[32];
            } SG_PACK ; // unnamed struct
            u32 dw[54]; // dword union
         }; // unnamed union
      } SG_PACK NTWK_RX_FILTER_SETTINGS, *PNTWK_RX_FILTER_SETTINGS;

      SG_C_ASSERT(__sizeof__NTWK_RX_FILTER_SETTINGS, sizeof (NTWK_RX_FILTER_SETTINGS) == 216);

   #else
      typedef struct _NTWK_RX_FILTER_SETTINGS {
         UEXACT32 global_flags_mask;
         UEXACT32 global_flags;
         UEXACT32 if_flags_mask;
         UEXACT32 if_flags;
         UEXACT32 if_id;
         UEXACT32 multicast_num;
         struct {
            UEXACT8 bytes[6];
         } multicast_mac_list[32];
      } SG_PACK NTWK_RX_FILTER_SETTINGS, *PNTWK_RX_FILTER_SETTINGS;

      typedef union _NTWK_RX_FILTER_SETTINGS_UNION {
         NTWK_RX_FILTER_SETTINGS bits;
         u32 dw[54]; // dword union
      } SG_PACK NTWK_RX_FILTER_SETTINGS_UNION, *PNTWK_RX_FILTER_SETTINGS_UNION;

      SG_C_ASSERT(__sizeof__NTWK_RX_FILTER_SETTINGS_UNION, sizeof (NTWK_RX_FILTER_SETTINGS_UNION) == 216);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to modify the ethernet receive filter configuration, and select
   // receive interface options. Only domain 0 network function drivers may issue this
   // IOCTL. The applied configuration is returned in the response payload. 
   typedef struct _IOCTL_COMMON_NTWK_RX_FILTER {
      IOCTL_HEADER header;
      union {
         NTWK_RX_FILTER_SETTINGS request;
         NTWK_RX_FILTER_SETTINGS response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_RX_FILTER, *PIOCTL_COMMON_NTWK_RX_FILTER;



#else
   // This IOCTL is used to modify the ethernet receive filter configuration, and select
   // receive interface options. Only domain 0 network function drivers may issue this
   // IOCTL. The applied configuration is returned in the response payload. 
   typedef struct _IOCTL_COMMON_NTWK_RX_FILTER {
      IOCTL_HEADER header;
      union {
         NTWK_RX_FILTER_SETTINGS request;
         NTWK_RX_FILTER_SETTINGS response;
      } params;
   } SG_PACK IOCTL_COMMON_NTWK_RX_FILTER, *PIOCTL_COMMON_NTWK_RX_FILTER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD {
         union {
            struct { 
               EXACT8 firmware_version_string[32];
               EXACT8 fw_on_flash_version_string[32];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, sizeof (IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD) == 64);

   #else
      typedef struct _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD {
         EXACT8 firmware_version_string[32];
         EXACT8 fw_on_flash_version_string[32];
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD;

      typedef union _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION {
         IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION, sizeof (IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD {
         union {
            struct { 
               EXACT8 firmware_version_string[32];
               EXACT8 fw_on_flash_version_string[32];
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, sizeof (IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD) == 64);

   #else
      typedef struct _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD {
         EXACT8 firmware_version_string[32];
         EXACT8 fw_on_flash_version_string[32];
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD;

      typedef union _IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION {
         IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD bits;
         u32 dw[16]; // dword union
      } SG_PACK IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION, sizeof (IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL retrieves the firmware version. 
   typedef struct _IOCTL_COMMON_GET_FW_VERSION {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FW_VERSION, *PIOCTL_COMMON_GET_FW_VERSION;



#else
   // This IOCTL retrieves the firmware version. 
   typedef struct _IOCTL_COMMON_GET_FW_VERSION {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FW_VERSION, *PIOCTL_COMMON_GET_FW_VERSION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to program BladeEngine Ethernet flow control behavior.  If the
   // IOCTL_REQUEST_HEADER version field is non-zero, the IOCTL can fail if firmware is
   // operating in FCoE (or any lossless protocol) config. For a version field of zero,
   // the IOCTL will be silently discarded if firmware is operating in FCoE config -- this
   // is strictly done for the purpose of allowing older network drivers to function. The
   // IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST -- the caller is not authorized to use this IOCTL. 
   // - MGMT_STATUS_FEATURE_NOT_SUPPORTED -- Ethernet flow control parameters cannot be
   // modified. 
   typedef struct _IOCTL_COMMON_SET_FLOW_CONTROL {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 tx_flow_control;
            UEXACT16 rx_flow_control;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_SET_FLOW_CONTROL, *PIOCTL_COMMON_SET_FLOW_CONTROL;



#else
   // This IOCTL is used to program BladeEngine Ethernet flow control behavior.  If the
   // IOCTL_REQUEST_HEADER version field is non-zero, the IOCTL can fail if firmware is
   // operating in FCoE (or any lossless protocol) config. For a version field of zero,
   // the IOCTL will be silently discarded if firmware is operating in FCoE config -- this
   // is strictly done for the purpose of allowing older network drivers to function. The
   // IOCTL may fail with the following status/additional_status codes:  -  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST -- the caller is not authorized to use this IOCTL. 
   // - MGMT_STATUS_FEATURE_NOT_SUPPORTED -- Ethernet flow control parameters cannot be
   // modified. 
   typedef struct _IOCTL_COMMON_SET_FLOW_CONTROL {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT16 tx_flow_control;
            UEXACT16 rx_flow_control;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_SET_FLOW_CONTROL, *PIOCTL_COMMON_SET_FLOW_CONTROL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to read BladeEngine flow control settings. 
   typedef struct _IOCTL_COMMON_GET_FLOW_CONTROL {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT16 tx_flow_control;
            UEXACT16 rx_flow_control;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FLOW_CONTROL, *PIOCTL_COMMON_GET_FLOW_CONTROL;



#else
   // This IOCTL is used to read BladeEngine flow control settings. 
   typedef struct _IOCTL_COMMON_GET_FLOW_CONTROL {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT16 tx_flow_control;
            UEXACT16 rx_flow_control;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FLOW_CONTROL, *PIOCTL_COMMON_GET_FLOW_CONTROL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DRIVER_TCP_PARAMETERS {
         union {
            struct { 
               UEXACT32 fin_wait2_ms;
               UEXACT32 push_timer_ms;
               UEXACT32 delayed_ack_ms;
               UEXACT32 idle_ms;
               UEXACT32 sws_prevention_ms;
               UEXACT32 dup_ack_threshold;
               UEXACT32 max_warning_count;
               UEXACT32 max_rxmt_count;
               UEXACT32 ack_frequency;
               UEXACT32 num_holes_supported;
               UEXACT32 rsvd0[1];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK BE_DRIVER_TCP_PARAMETERS, *PBE_DRIVER_TCP_PARAMETERS;

      SG_C_ASSERT(__sizeof__BE_DRIVER_TCP_PARAMETERS, sizeof (BE_DRIVER_TCP_PARAMETERS) == 44);

   #else
      typedef struct _BE_DRIVER_TCP_PARAMETERS {
         UEXACT32 fin_wait2_ms;
         UEXACT32 push_timer_ms;
         UEXACT32 delayed_ack_ms;
         UEXACT32 idle_ms;
         UEXACT32 sws_prevention_ms;
         UEXACT32 dup_ack_threshold;
         UEXACT32 max_warning_count;
         UEXACT32 max_rxmt_count;
         UEXACT32 ack_frequency;
         UEXACT32 num_holes_supported;
         UEXACT32 rsvd0[1];
      } SG_PACK BE_DRIVER_TCP_PARAMETERS, *PBE_DRIVER_TCP_PARAMETERS;

      typedef union _BE_DRIVER_TCP_PARAMETERS_UNION {
         BE_DRIVER_TCP_PARAMETERS bits;
         u32 dw[11]; // dword union
      } SG_PACK BE_DRIVER_TCP_PARAMETERS_UNION, *PBE_DRIVER_TCP_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__BE_DRIVER_TCP_PARAMETERS_UNION, sizeof (BE_DRIVER_TCP_PARAMETERS_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_DRIVER_TCP_PARAMETERS {
         union {
            struct { 
               UEXACT32 fin_wait2_ms;
               UEXACT32 push_timer_ms;
               UEXACT32 delayed_ack_ms;
               UEXACT32 idle_ms;
               UEXACT32 sws_prevention_ms;
               UEXACT32 dup_ack_threshold;
               UEXACT32 max_warning_count;
               UEXACT32 max_rxmt_count;
               UEXACT32 ack_frequency;
               UEXACT32 num_holes_supported;
               UEXACT32 rsvd0[1];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK BE_DRIVER_TCP_PARAMETERS, *PBE_DRIVER_TCP_PARAMETERS;

      SG_C_ASSERT(__sizeof__BE_DRIVER_TCP_PARAMETERS, sizeof (BE_DRIVER_TCP_PARAMETERS) == 44);

   #else
      typedef struct _BE_DRIVER_TCP_PARAMETERS {
         UEXACT32 fin_wait2_ms;
         UEXACT32 push_timer_ms;
         UEXACT32 delayed_ack_ms;
         UEXACT32 idle_ms;
         UEXACT32 sws_prevention_ms;
         UEXACT32 dup_ack_threshold;
         UEXACT32 max_warning_count;
         UEXACT32 max_rxmt_count;
         UEXACT32 ack_frequency;
         UEXACT32 num_holes_supported;
         UEXACT32 rsvd0[1];
      } SG_PACK BE_DRIVER_TCP_PARAMETERS, *PBE_DRIVER_TCP_PARAMETERS;

      typedef union _BE_DRIVER_TCP_PARAMETERS_UNION {
         BE_DRIVER_TCP_PARAMETERS bits;
         u32 dw[11]; // dword union
      } SG_PACK BE_DRIVER_TCP_PARAMETERS_UNION, *PBE_DRIVER_TCP_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__BE_DRIVER_TCP_PARAMETERS_UNION, sizeof (BE_DRIVER_TCP_PARAMETERS_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL sets the global TCP parameters for offloaded connections. Only host
   // device drivers are allowed to set these. 
   typedef struct _IOCTL_COMMON_SET_TCP_PARAMETERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 ulp_mask;
            BE_DRIVER_TCP_PARAMETERS tcp_params;
         } request;
         struct {
            u32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_SET_TCP_PARAMETERS, *PIOCTL_COMMON_SET_TCP_PARAMETERS;



#else
   // This IOCTL sets the global TCP parameters for offloaded connections. Only host
   // device drivers are allowed to set these. 
   typedef struct _IOCTL_COMMON_SET_TCP_PARAMETERS {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 ulp_mask;
            BE_DRIVER_TCP_PARAMETERS tcp_params;
         } request;
         struct {
            u32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_SET_TCP_PARAMETERS, *PIOCTL_COMMON_SET_TCP_PARAMETERS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_RESPONSE {
         union {
            struct { 
               UEXACT32 log_size;
               UEXACT32 bytes_transferred;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FAT_RESPONSE, *PFAT_RESPONSE;

      SG_C_ASSERT(__sizeof__FAT_RESPONSE, sizeof (FAT_RESPONSE) == 8);

   #else
      typedef struct _FAT_RESPONSE {
         UEXACT32 log_size;
         UEXACT32 bytes_transferred;
      } SG_PACK FAT_RESPONSE, *PFAT_RESPONSE;

      typedef union _FAT_RESPONSE_UNION {
         FAT_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK FAT_RESPONSE_UNION, *PFAT_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__FAT_RESPONSE_UNION, sizeof (FAT_RESPONSE_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FAT_RESPONSE {
         union {
            struct { 
               UEXACT32 log_size;
               UEXACT32 bytes_transferred;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK FAT_RESPONSE, *PFAT_RESPONSE;

      SG_C_ASSERT(__sizeof__FAT_RESPONSE, sizeof (FAT_RESPONSE) == 8);

   #else
      typedef struct _FAT_RESPONSE {
         UEXACT32 log_size;
         UEXACT32 bytes_transferred;
      } SG_PACK FAT_RESPONSE, *PFAT_RESPONSE;

      typedef union _FAT_RESPONSE_UNION {
         FAT_RESPONSE bits;
         u32 dw[2]; // dword union
      } SG_PACK FAT_RESPONSE_UNION, *PFAT_RESPONSE_UNION;

      SG_C_ASSERT(__sizeof__FAT_RESPONSE_UNION, sizeof (FAT_RESPONSE_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL retrieves a Fault Analaysis Tool (FAT) log. The log data can be anaylzed
   // by BladeEngine support tools to diagnose faults. Only host domains may issue this
   // IOCTL. 
   typedef struct _IOCTL_COMMON_GET_FAT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 clear_log;
            UEXACT8 num_pages;
            UEXACT16 page_offset;
            PHYS_ADDR buffer_addr[27];
         } request;
         FAT_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FAT, *PIOCTL_COMMON_GET_FAT;



#else
   // This IOCTL retrieves a Fault Analaysis Tool (FAT) log. The log data can be anaylzed
   // by BladeEngine support tools to diagnose faults. Only host domains may issue this
   // IOCTL. 
   typedef struct _IOCTL_COMMON_GET_FAT {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT8 clear_log;
            UEXACT8 num_pages;
            UEXACT16 page_offset;
            PHYS_ADDR buffer_addr[27];
         } request;
         FAT_RESPONSE response;
      } params;
   } SG_PACK IOCTL_COMMON_GET_FAT, *PIOCTL_COMMON_GET_FAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 fat_operation;
               UEXACT32 read_log_offset;
               UEXACT32 read_log_length;
               UEXACT32 data_buffer_size;
               UEXACT32 data_buffer[1];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_IN) == 20);

   #else
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN {
         UEXACT32 fat_operation;
         UEXACT32 read_log_offset;
         UEXACT32 read_log_length;
         UEXACT32 data_buffer_size;
         UEXACT32 data_buffer[1];
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_IN bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 fat_operation;
               UEXACT32 read_log_offset;
               UEXACT32 read_log_length;
               UEXACT32 data_buffer_size;
               UEXACT32 data_buffer[1];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_IN) == 20);

   #else
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN {
         UEXACT32 fat_operation;
         UEXACT32 read_log_offset;
         UEXACT32 read_log_length;
         UEXACT32 data_buffer_size;
         UEXACT32 data_buffer[1];
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_IN bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 log_size;
               UEXACT32 read_log_length;
               UEXACT32 rsvd0[2];
               UEXACT32 data_buffer[1];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT) == 20);

   #else
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT {
         UEXACT32 log_size;
         UEXACT32 read_log_length;
         UEXACT32 rsvd0[2];
         UEXACT32 data_buffer[1];
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 log_size;
               UEXACT32 read_log_length;
               UEXACT32 rsvd0[2];
               UEXACT32 data_buffer[1];
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT) == 20);

   #else
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT {
         UEXACT32 log_size;
         UEXACT32 read_log_length;
         UEXACT32 rsvd0[2];
         UEXACT32 data_buffer[1];
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS {
         union {
            union { 
               IOCTL_COMMON_MANAGE_FAT_PARAMS_IN request;
               IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS, *PIOCTL_COMMON_MANAGE_FAT_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS) == 20);

   #else
      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_IN request;
         IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS, *PIOCTL_COMMON_MANAGE_FAT_PARAMS;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION) == 20);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_MANAGE_FAT_PARAMS {
         union {
            union { 
               IOCTL_COMMON_MANAGE_FAT_PARAMS_IN request;
               IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[5]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS, *PIOCTL_COMMON_MANAGE_FAT_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS) == 20);

   #else
      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS {
         IOCTL_COMMON_MANAGE_FAT_PARAMS_IN request;
         IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS, *PIOCTL_COMMON_MANAGE_FAT_PARAMS;

      typedef union _IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION {
         IOCTL_COMMON_MANAGE_FAT_PARAMS bits;
         u32 dw[5]; // dword union
      } SG_PACK IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION, sizeof (IOCTL_COMMON_MANAGE_FAT_PARAMS_UNION) == 20);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL should be issued by applications to manage FAT log data. Retreived log
   // data may be anaylzed by the ServerEngines' FAT support tool to debug and diagnose
   // adapter malfunctions. 
   typedef struct _IOCTL_COMMON_MANAGE_FAT {
      IOCTL_HEADER header;
      IOCTL_COMMON_MANAGE_FAT_PARAMS params;
   } SG_PACK IOCTL_COMMON_MANAGE_FAT, *PIOCTL_COMMON_MANAGE_FAT;



#else
   // This IOCTL should be issued by applications to manage FAT log data. Retreived log
   // data may be anaylzed by the ServerEngines' FAT support tool to debug and diagnose
   // adapter malfunctions. 
   typedef struct _IOCTL_COMMON_MANAGE_FAT {
      IOCTL_HEADER header;
      IOCTL_COMMON_MANAGE_FAT_PARAMS params;
   } SG_PACK IOCTL_COMMON_MANAGE_FAT, *PIOCTL_COMMON_MANAGE_FAT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_IN {
         union {
            struct { 
               UEXACT8 domain_function;
               UEXACT8 enable_disable;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN, *PENABLE_DISABLE_DOMAINS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_IN, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_IN) == 4);

   #else
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_IN {
         UEXACT8 domain_function;
         UEXACT8 enable_disable;
         UEXACT16 rsvd0;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN, *PENABLE_DISABLE_DOMAINS_PARAMS_IN;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_IN {
         union {
            struct { 
               UEXACT8 domain_function;
               UEXACT8 enable_disable;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN, *PENABLE_DISABLE_DOMAINS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_IN, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_IN) == 4);

   #else
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_IN {
         UEXACT8 domain_function;
         UEXACT8 enable_disable;
         UEXACT16 rsvd0;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN, *PENABLE_DISABLE_DOMAINS_PARAMS_IN;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_OUT, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_OUT) == 4);

   #else
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_OUT, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_OUT) == 4);

   #else
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS {
         union {
            union { 
               ENABLE_DISABLE_DOMAINS_PARAMS_IN request;
               ENABLE_DISABLE_DOMAINS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS, *PENABLE_DISABLE_DOMAINS_PARAMS;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS) == 4);

   #else
      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS {
         ENABLE_DISABLE_DOMAINS_PARAMS_IN request;
         ENABLE_DISABLE_DOMAINS_PARAMS_OUT response;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS, *PENABLE_DISABLE_DOMAINS_PARAMS;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _ENABLE_DISABLE_DOMAINS_PARAMS {
         union {
            union { 
               ENABLE_DISABLE_DOMAINS_PARAMS_IN request;
               ENABLE_DISABLE_DOMAINS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS, *PENABLE_DISABLE_DOMAINS_PARAMS;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS) == 4);

   #else
      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS {
         ENABLE_DISABLE_DOMAINS_PARAMS_IN request;
         ENABLE_DISABLE_DOMAINS_PARAMS_OUT response;
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS, *PENABLE_DISABLE_DOMAINS_PARAMS;

      typedef union _ENABLE_DISABLE_DOMAINS_PARAMS_UNION {
         ENABLE_DISABLE_DOMAINS_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK ENABLE_DISABLE_DOMAINS_PARAMS_UNION, *PENABLE_DISABLE_DOMAINS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__ENABLE_DISABLE_DOMAINS_PARAMS_UNION, sizeof (ENABLE_DISABLE_DOMAINS_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL enables or disables a domain for NIC/TOE or iSCSI functionality. If a
   // particular domain is enabled, management utilities like SMCLP expose a logicalHBA to
   // the user allowing the QoS, iSCSI (iqn) name etc to be set for that domain. The
   // domain number is specified in the IOCTL_HEADER. This IOCTL can only originate from
   // domain 0. <break> This IOCTL may return one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED with additional status set to
   // MGMT_ADDI_STATUS_INVALID_DOMAIN 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_DOMAINS {
      IOCTL_HEADER header;
      ENABLE_DISABLE_DOMAINS_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_DOMAINS, *PIOCTL_COMMON_ENABLE_DISABLE_DOMAINS;



#else
   // This IOCTL enables or disables a domain for NIC/TOE or iSCSI functionality. If a
   // particular domain is enabled, management utilities like SMCLP expose a logicalHBA to
   // the user allowing the QoS, iSCSI (iqn) name etc to be set for that domain. The
   // domain number is specified in the IOCTL_HEADER. This IOCTL can only originate from
   // domain 0. <break> This IOCTL may return one of the following status values in the
   // response  - MGMT_STATUS_SUCCESS  - MGMT_STATUS_FAILED with additional status set to
   // MGMT_ADDI_STATUS_INVALID_DOMAIN 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_DOMAINS {
      IOCTL_HEADER header;
      ENABLE_DISABLE_DOMAINS_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_DOMAINS, *PIOCTL_COMMON_ENABLE_DISABLE_DOMAINS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT8 domain_function;
               UEXACT8 enable_disable;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN, *PGET_DOMAIN_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_IN, sizeof (GET_DOMAIN_CONFIG_PARAMS_IN) == 4);

   #else
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_IN {
         UEXACT8 domain_function;
         UEXACT8 enable_disable;
         UEXACT16 rsvd0;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN, *PGET_DOMAIN_CONFIG_PARAMS_IN;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_IN_UNION {
         GET_DOMAIN_CONFIG_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN_UNION, *PGET_DOMAIN_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_IN_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT8 domain_function;
               UEXACT8 enable_disable;
               UEXACT16 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN, *PGET_DOMAIN_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_IN, sizeof (GET_DOMAIN_CONFIG_PARAMS_IN) == 4);

   #else
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_IN {
         UEXACT8 domain_function;
         UEXACT8 enable_disable;
         UEXACT16 rsvd0;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN, *PGET_DOMAIN_CONFIG_PARAMS_IN;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_IN_UNION {
         GET_DOMAIN_CONFIG_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_IN_UNION, *PGET_DOMAIN_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_IN_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 domain_bitmap;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT, *PGET_DOMAIN_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_OUT, sizeof (GET_DOMAIN_CONFIG_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_OUT {
         UEXACT32 domain_bitmap;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT, *PGET_DOMAIN_CONFIG_PARAMS_OUT;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_OUT_UNION {
         GET_DOMAIN_CONFIG_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT_UNION, *PGET_DOMAIN_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_OUT_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 domain_bitmap;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT, *PGET_DOMAIN_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_OUT, sizeof (GET_DOMAIN_CONFIG_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_DOMAIN_CONFIG_PARAMS_OUT {
         UEXACT32 domain_bitmap;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT, *PGET_DOMAIN_CONFIG_PARAMS_OUT;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_OUT_UNION {
         GET_DOMAIN_CONFIG_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_OUT_UNION, *PGET_DOMAIN_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_OUT_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS {
         union {
            union { 
               GET_DOMAIN_CONFIG_PARAMS_IN request;
               GET_DOMAIN_CONFIG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS, *PGET_DOMAIN_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS, sizeof (GET_DOMAIN_CONFIG_PARAMS) == 4);

   #else
      typedef union _GET_DOMAIN_CONFIG_PARAMS {
         GET_DOMAIN_CONFIG_PARAMS_IN request;
         GET_DOMAIN_CONFIG_PARAMS_OUT response;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS, *PGET_DOMAIN_CONFIG_PARAMS;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_UNION {
         GET_DOMAIN_CONFIG_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_UNION, *PGET_DOMAIN_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_DOMAIN_CONFIG_PARAMS {
         union {
            union { 
               GET_DOMAIN_CONFIG_PARAMS_IN request;
               GET_DOMAIN_CONFIG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS, *PGET_DOMAIN_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS, sizeof (GET_DOMAIN_CONFIG_PARAMS) == 4);

   #else
      typedef union _GET_DOMAIN_CONFIG_PARAMS {
         GET_DOMAIN_CONFIG_PARAMS_IN request;
         GET_DOMAIN_CONFIG_PARAMS_OUT response;
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS, *PGET_DOMAIN_CONFIG_PARAMS;

      typedef union _GET_DOMAIN_CONFIG_PARAMS_UNION {
         GET_DOMAIN_CONFIG_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_DOMAIN_CONFIG_PARAMS_UNION, *PGET_DOMAIN_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_DOMAIN_CONFIG_PARAMS_UNION, sizeof (GET_DOMAIN_CONFIG_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL returns a bitmap indicating the current status of the NIC/TOE or iSCSI
   // functionality for all the domains supported on a given BladeEngine. The domain
   // number in the IOCTL header is ignored. This IOCTL can only originate from domain 0.
   // This IOCTL will always return MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_COMMON_GET_DOMAIN_CONFIG {
      IOCTL_HEADER header;
      GET_DOMAIN_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_DOMAIN_CONFIG, *PIOCTL_COMMON_GET_DOMAIN_CONFIG;



#else
   // This IOCTL returns a bitmap indicating the current status of the NIC/TOE or iSCSI
   // functionality for all the domains supported on a given BladeEngine. The domain
   // number in the IOCTL header is ignored. This IOCTL can only originate from domain 0.
   // This IOCTL will always return MGMT_STATUS_SUCCESS 
   typedef struct _IOCTL_COMMON_GET_DOMAIN_CONFIG {
      IOCTL_HEADER header;
      GET_DOMAIN_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_DOMAIN_CONFIG, *PIOCTL_COMMON_GET_DOMAIN_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_DELAY_PARAMS {
         union {
            struct { 
               UEXACT32 eq_id;
               UEXACT32 phase;
               UEXACT32 delay_multiplier;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK EQ_DELAY_PARAMS, *PEQ_DELAY_PARAMS;

      SG_C_ASSERT(__sizeof__EQ_DELAY_PARAMS, sizeof (EQ_DELAY_PARAMS) == 12);

   #else
      typedef struct _EQ_DELAY_PARAMS {
         UEXACT32 eq_id;
         UEXACT32 phase;
         UEXACT32 delay_multiplier;
      } SG_PACK EQ_DELAY_PARAMS, *PEQ_DELAY_PARAMS;

      typedef union _EQ_DELAY_PARAMS_UNION {
         EQ_DELAY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK EQ_DELAY_PARAMS_UNION, *PEQ_DELAY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__EQ_DELAY_PARAMS_UNION, sizeof (EQ_DELAY_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _EQ_DELAY_PARAMS {
         union {
            struct { 
               UEXACT32 eq_id;
               UEXACT32 phase;
               UEXACT32 delay_multiplier;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK EQ_DELAY_PARAMS, *PEQ_DELAY_PARAMS;

      SG_C_ASSERT(__sizeof__EQ_DELAY_PARAMS, sizeof (EQ_DELAY_PARAMS) == 12);

   #else
      typedef struct _EQ_DELAY_PARAMS {
         UEXACT32 eq_id;
         UEXACT32 phase;
         UEXACT32 delay_multiplier;
      } SG_PACK EQ_DELAY_PARAMS, *PEQ_DELAY_PARAMS;

      typedef union _EQ_DELAY_PARAMS_UNION {
         EQ_DELAY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK EQ_DELAY_PARAMS_UNION, *PEQ_DELAY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__EQ_DELAY_PARAMS_UNION, sizeof (EQ_DELAY_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MODIFY_EQ_DELAY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 num_eq;
                  EQ_DELAY_PARAMS delay[8];
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[25]; // dword union
         }; // unnamed union
      } SG_PACK MODIFY_EQ_DELAY_PARAMS, *PMODIFY_EQ_DELAY_PARAMS;

      SG_C_ASSERT(__sizeof__MODIFY_EQ_DELAY_PARAMS, sizeof (MODIFY_EQ_DELAY_PARAMS) == 100);

   #else
      typedef union _MODIFY_EQ_DELAY_PARAMS {
         struct {
            UEXACT32 num_eq;
            EQ_DELAY_PARAMS delay[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK MODIFY_EQ_DELAY_PARAMS, *PMODIFY_EQ_DELAY_PARAMS;

      typedef union _MODIFY_EQ_DELAY_PARAMS_UNION {
         MODIFY_EQ_DELAY_PARAMS bits;
         u32 dw[25]; // dword union
      } SG_PACK MODIFY_EQ_DELAY_PARAMS_UNION, *PMODIFY_EQ_DELAY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MODIFY_EQ_DELAY_PARAMS_UNION, sizeof (MODIFY_EQ_DELAY_PARAMS_UNION) == 100);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _MODIFY_EQ_DELAY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 num_eq;
                  EQ_DELAY_PARAMS delay[8];
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[25]; // dword union
         }; // unnamed union
      } SG_PACK MODIFY_EQ_DELAY_PARAMS, *PMODIFY_EQ_DELAY_PARAMS;

      SG_C_ASSERT(__sizeof__MODIFY_EQ_DELAY_PARAMS, sizeof (MODIFY_EQ_DELAY_PARAMS) == 100);

   #else
      typedef union _MODIFY_EQ_DELAY_PARAMS {
         struct {
            UEXACT32 num_eq;
            EQ_DELAY_PARAMS delay[8];
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK MODIFY_EQ_DELAY_PARAMS, *PMODIFY_EQ_DELAY_PARAMS;

      typedef union _MODIFY_EQ_DELAY_PARAMS_UNION {
         MODIFY_EQ_DELAY_PARAMS bits;
         u32 dw[25]; // dword union
      } SG_PACK MODIFY_EQ_DELAY_PARAMS_UNION, *PMODIFY_EQ_DELAY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__MODIFY_EQ_DELAY_PARAMS_UNION, sizeof (MODIFY_EQ_DELAY_PARAMS_UNION) == 100);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL changes the EQ delay for a given set of EQs. 
   typedef struct _IOCTL_COMMON_MODIFY_EQ_DELAY {
      IOCTL_HEADER header;
      MODIFY_EQ_DELAY_PARAMS params;
   } SG_PACK IOCTL_COMMON_MODIFY_EQ_DELAY, *PIOCTL_COMMON_MODIFY_EQ_DELAY;



#else
   // This IOCTL changes the EQ delay for a given set of EQs. 
   typedef struct _IOCTL_COMMON_MODIFY_EQ_DELAY {
      IOCTL_HEADER header;
      MODIFY_EQ_DELAY_PARAMS params;
   } SG_PACK IOCTL_COMMON_MODIFY_EQ_DELAY, *PIOCTL_COMMON_MODIFY_EQ_DELAY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MODIFY_MSI_MESSAGES_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 num_msi_messages;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS, *PCEV_MODIFY_MSI_MESSAGES_PARAMS;

      SG_C_ASSERT(__sizeof__CEV_MODIFY_MSI_MESSAGES_PARAMS, sizeof (CEV_MODIFY_MSI_MESSAGES_PARAMS) == 4);

   #else
      typedef union _CEV_MODIFY_MSI_MESSAGES_PARAMS {
         struct {
            UEXACT32 num_msi_messages;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS, *PCEV_MODIFY_MSI_MESSAGES_PARAMS;

      typedef union _CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION {
         CEV_MODIFY_MSI_MESSAGES_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION, *PCEV_MODIFY_MSI_MESSAGES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION, sizeof (CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _CEV_MODIFY_MSI_MESSAGES_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 num_msi_messages;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS, *PCEV_MODIFY_MSI_MESSAGES_PARAMS;

      SG_C_ASSERT(__sizeof__CEV_MODIFY_MSI_MESSAGES_PARAMS, sizeof (CEV_MODIFY_MSI_MESSAGES_PARAMS) == 4);

   #else
      typedef union _CEV_MODIFY_MSI_MESSAGES_PARAMS {
         struct {
            UEXACT32 num_msi_messages;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS, *PCEV_MODIFY_MSI_MESSAGES_PARAMS;

      typedef union _CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION {
         CEV_MODIFY_MSI_MESSAGES_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION, *PCEV_MODIFY_MSI_MESSAGES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION, sizeof (CEV_MODIFY_MSI_MESSAGES_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL changes the number of MSI messages used by CEV to report interrupts to
   // the host block. 
   typedef struct _IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES {
      IOCTL_HEADER header;
      CEV_MODIFY_MSI_MESSAGES_PARAMS params;
   } SG_PACK IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES, *PIOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES;



#else
   // This IOCTL changes the number of MSI messages used by CEV to report interrupts to
   // the host block. 
   typedef struct _IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES {
      IOCTL_HEADER header;
      CEV_MODIFY_MSI_MESSAGES_PARAMS params;
   } SG_PACK IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES, *PIOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // ID information specific to protocol processing engines. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_ULP_FW_CFG {
         union {
            struct { 
               UEXACT32 ulp_mode;
               UEXACT32 etx_base;
               UEXACT32 etx_count;
               UEXACT32 sq_base;
               UEXACT32 sq_count;
               UEXACT32 rq_base;
               UEXACT32 rq_count;
               UEXACT32 dq_base;
               UEXACT32 dq_count;
               UEXACT32 lro_base;
               UEXACT32 lro_count;
               UEXACT32 icd_base;
               UEXACT32 icd_count;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK BE_ULP_FW_CFG, *PBE_ULP_FW_CFG;

      SG_C_ASSERT(__sizeof__BE_ULP_FW_CFG, sizeof (BE_ULP_FW_CFG) == 52);

   #else
      typedef struct _BE_ULP_FW_CFG {
         UEXACT32 ulp_mode;
         UEXACT32 etx_base;
         UEXACT32 etx_count;
         UEXACT32 sq_base;
         UEXACT32 sq_count;
         UEXACT32 rq_base;
         UEXACT32 rq_count;
         UEXACT32 dq_base;
         UEXACT32 dq_count;
         UEXACT32 lro_base;
         UEXACT32 lro_count;
         UEXACT32 icd_base;
         UEXACT32 icd_count;
      } SG_PACK BE_ULP_FW_CFG, *PBE_ULP_FW_CFG;

      typedef union _BE_ULP_FW_CFG_UNION {
         BE_ULP_FW_CFG bits;
         u32 dw[13]; // dword union
      } SG_PACK BE_ULP_FW_CFG_UNION, *PBE_ULP_FW_CFG_UNION;

      SG_C_ASSERT(__sizeof__BE_ULP_FW_CFG_UNION, sizeof (BE_ULP_FW_CFG_UNION) == 52);
   #endif


#else
   // ID information specific to protocol processing engines. 
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_ULP_FW_CFG {
         union {
            struct { 
               UEXACT32 ulp_mode;
               UEXACT32 etx_base;
               UEXACT32 etx_count;
               UEXACT32 sq_base;
               UEXACT32 sq_count;
               UEXACT32 rq_base;
               UEXACT32 rq_count;
               UEXACT32 dq_base;
               UEXACT32 dq_count;
               UEXACT32 lro_base;
               UEXACT32 lro_count;
               UEXACT32 icd_base;
               UEXACT32 icd_count;
            } SG_PACK ; // unnamed struct
            u32 dw[13]; // dword union
         }; // unnamed union
      } SG_PACK BE_ULP_FW_CFG, *PBE_ULP_FW_CFG;

      SG_C_ASSERT(__sizeof__BE_ULP_FW_CFG, sizeof (BE_ULP_FW_CFG) == 52);

   #else
      typedef struct _BE_ULP_FW_CFG {
         UEXACT32 ulp_mode;
         UEXACT32 etx_base;
         UEXACT32 etx_count;
         UEXACT32 sq_base;
         UEXACT32 sq_count;
         UEXACT32 rq_base;
         UEXACT32 rq_count;
         UEXACT32 dq_base;
         UEXACT32 dq_count;
         UEXACT32 lro_base;
         UEXACT32 lro_count;
         UEXACT32 icd_base;
         UEXACT32 icd_count;
      } SG_PACK BE_ULP_FW_CFG, *PBE_ULP_FW_CFG;

      typedef union _BE_ULP_FW_CFG_UNION {
         BE_ULP_FW_CFG bits;
         u32 dw[13]; // dword union
      } SG_PACK BE_ULP_FW_CFG_UNION, *PBE_ULP_FW_CFG_UNION;

      SG_C_ASSERT(__sizeof__BE_ULP_FW_CFG_UNION, sizeof (BE_ULP_FW_CFG_UNION) == 52);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_FW_CFG {
         union {
            struct { 
               UEXACT32 be_config_number;
               UEXACT32 asic_revision;
               UEXACT32 phys_port;
               UEXACT32 function_mode;
               BE_ULP_FW_CFG ulp[2];
               UEXACT32 function_caps;
            } SG_PACK ; // unnamed struct
            u32 dw[31]; // dword union
         }; // unnamed union
      } SG_PACK BE_FW_CFG, *PBE_FW_CFG;

      SG_C_ASSERT(__sizeof__BE_FW_CFG, sizeof (BE_FW_CFG) == 124);

   #else
      typedef struct _BE_FW_CFG {
         UEXACT32 be_config_number;
         UEXACT32 asic_revision;
         UEXACT32 phys_port;
         UEXACT32 function_mode;
         BE_ULP_FW_CFG ulp[2];
         UEXACT32 function_caps;
      } SG_PACK BE_FW_CFG, *PBE_FW_CFG;

      typedef union _BE_FW_CFG_UNION {
         BE_FW_CFG bits;
         u32 dw[31]; // dword union
      } SG_PACK BE_FW_CFG_UNION, *PBE_FW_CFG_UNION;

      SG_C_ASSERT(__sizeof__BE_FW_CFG_UNION, sizeof (BE_FW_CFG_UNION) == 124);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_FW_CFG {
         union {
            struct { 
               UEXACT32 be_config_number;
               UEXACT32 asic_revision;
               UEXACT32 phys_port;
               UEXACT32 function_mode;
               BE_ULP_FW_CFG ulp[2];
               UEXACT32 function_caps;
            } SG_PACK ; // unnamed struct
            u32 dw[31]; // dword union
         }; // unnamed union
      } SG_PACK BE_FW_CFG, *PBE_FW_CFG;

      SG_C_ASSERT(__sizeof__BE_FW_CFG, sizeof (BE_FW_CFG) == 124);

   #else
      typedef struct _BE_FW_CFG {
         UEXACT32 be_config_number;
         UEXACT32 asic_revision;
         UEXACT32 phys_port;
         UEXACT32 function_mode;
         BE_ULP_FW_CFG ulp[2];
         UEXACT32 function_caps;
      } SG_PACK BE_FW_CFG, *PBE_FW_CFG;

      typedef union _BE_FW_CFG_UNION {
         BE_FW_CFG bits;
         u32 dw[31]; // dword union
      } SG_PACK BE_FW_CFG_UNION, *PBE_FW_CFG_UNION;

      SG_C_ASSERT(__sizeof__BE_FW_CFG_UNION, sizeof (BE_FW_CFG_UNION) == 124);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL retrieves firmware configuration parameters and adapter resources
   // available to the driver originating the request.  The firmware configuration defines
   // supported protocols by the installed adapter firmware. This includes which Upper
   // Layer Protocol (ULP) processors support said protocols and the number of TCP
   // connections allowed for that protocol. 
   typedef struct _IOCTL_COMMON_QUERY_FIRMWARE_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         BE_FW_CFG response;
      } params;
   } SG_PACK IOCTL_COMMON_QUERY_FIRMWARE_CONFIG, *PIOCTL_COMMON_QUERY_FIRMWARE_CONFIG;



#else
   // This IOCTL retrieves firmware configuration parameters and adapter resources
   // available to the driver originating the request.  The firmware configuration defines
   // supported protocols by the installed adapter firmware. This includes which Upper
   // Layer Protocol (ULP) processors support said protocols and the number of TCP
   // connections allowed for that protocol. 
   typedef struct _IOCTL_COMMON_QUERY_FIRMWARE_CONFIG {
      IOCTL_HEADER header;
      union {
         struct {
            UEXACT32 rsvd0;
         } request;
         BE_FW_CFG response;
      } params;
   } SG_PACK IOCTL_COMMON_QUERY_FIRMWARE_CONFIG, *PIOCTL_COMMON_QUERY_FIRMWARE_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN, *PGET_PORT_EQUALIZATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_IN, sizeof (GET_PORT_EQUALIZATION_PARAMS_IN) == 4);

   #else
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN, *PGET_PORT_EQUALIZATION_PARAMS_IN;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_IN_UNION {
         GET_PORT_EQUALIZATION_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN_UNION, *PGET_PORT_EQUALIZATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_IN_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN, *PGET_PORT_EQUALIZATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_IN, sizeof (GET_PORT_EQUALIZATION_PARAMS_IN) == 4);

   #else
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN, *PGET_PORT_EQUALIZATION_PARAMS_IN;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_IN_UNION {
         GET_PORT_EQUALIZATION_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_IN_UNION, *PGET_PORT_EQUALIZATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_IN_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 port_equalization_settings;
               UEXACT32 port0_emphasis_settings;
               UEXACT32 port1_emphasis_settings;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT, *PGET_PORT_EQUALIZATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_OUT, sizeof (GET_PORT_EQUALIZATION_PARAMS_OUT) == 12);

   #else
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_OUT {
         UEXACT32 port_equalization_settings;
         UEXACT32 port0_emphasis_settings;
         UEXACT32 port1_emphasis_settings;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT, *PGET_PORT_EQUALIZATION_PARAMS_OUT;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_OUT_UNION {
         GET_PORT_EQUALIZATION_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT_UNION, *PGET_PORT_EQUALIZATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_OUT_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_OUT_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 port_equalization_settings;
               UEXACT32 port0_emphasis_settings;
               UEXACT32 port1_emphasis_settings;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT, *PGET_PORT_EQUALIZATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_OUT, sizeof (GET_PORT_EQUALIZATION_PARAMS_OUT) == 12);

   #else
      typedef struct _GET_PORT_EQUALIZATION_PARAMS_OUT {
         UEXACT32 port_equalization_settings;
         UEXACT32 port0_emphasis_settings;
         UEXACT32 port1_emphasis_settings;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT, *PGET_PORT_EQUALIZATION_PARAMS_OUT;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_OUT_UNION {
         GET_PORT_EQUALIZATION_PARAMS_OUT bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_OUT_UNION, *PGET_PORT_EQUALIZATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_OUT_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_OUT_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS {
         union {
            union { 
               GET_PORT_EQUALIZATION_PARAMS_IN request;
               GET_PORT_EQUALIZATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS, *PGET_PORT_EQUALIZATION_PARAMS;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS, sizeof (GET_PORT_EQUALIZATION_PARAMS) == 12);

   #else
      typedef union _GET_PORT_EQUALIZATION_PARAMS {
         GET_PORT_EQUALIZATION_PARAMS_IN request;
         GET_PORT_EQUALIZATION_PARAMS_OUT response;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS, *PGET_PORT_EQUALIZATION_PARAMS;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_UNION {
         GET_PORT_EQUALIZATION_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_UNION, *PGET_PORT_EQUALIZATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PORT_EQUALIZATION_PARAMS {
         union {
            union { 
               GET_PORT_EQUALIZATION_PARAMS_IN request;
               GET_PORT_EQUALIZATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS, *PGET_PORT_EQUALIZATION_PARAMS;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS, sizeof (GET_PORT_EQUALIZATION_PARAMS) == 12);

   #else
      typedef union _GET_PORT_EQUALIZATION_PARAMS {
         GET_PORT_EQUALIZATION_PARAMS_IN request;
         GET_PORT_EQUALIZATION_PARAMS_OUT response;
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS, *PGET_PORT_EQUALIZATION_PARAMS;

      typedef union _GET_PORT_EQUALIZATION_PARAMS_UNION {
         GET_PORT_EQUALIZATION_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK GET_PORT_EQUALIZATION_PARAMS_UNION, *PGET_PORT_EQUALIZATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_PORT_EQUALIZATION_PARAMS_UNION, sizeof (GET_PORT_EQUALIZATION_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL can be used to read equalization and emphasis parameters for BladeEngine
   // ports. (all 4 channels on each port) 
   typedef struct _IOCTL_COMMON_GET_PORT_EQUALIZATION {
      IOCTL_HEADER header;
      GET_PORT_EQUALIZATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_EQUALIZATION, *PIOCTL_COMMON_GET_PORT_EQUALIZATION;



#else
   // This IOCTL can be used to read equalization and emphasis parameters for BladeEngine
   // ports. (all 4 channels on each port) 
   typedef struct _IOCTL_COMMON_GET_PORT_EQUALIZATION {
      IOCTL_HEADER header;
      GET_PORT_EQUALIZATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_EQUALIZATION, *PIOCTL_COMMON_GET_PORT_EQUALIZATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_IN {
         union {
            struct { 
               UEXACT8 be_port_num;
               UEXACT8 be_port_channel;
               UEXACT8 equalization_emphasis;
               UEXACT8 rsvd0;
               UEXACT32 port_equalization_settings;
               UEXACT32 port0_emphasis_settings;
               UEXACT32 port1_emphasis_settings;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN, *PSET_PORT_EQUALIZATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_IN, sizeof (SET_PORT_EQUALIZATION_PARAMS_IN) == 16);

   #else
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_IN {
         UEXACT8 be_port_num;
         UEXACT8 be_port_channel;
         UEXACT8 equalization_emphasis;
         UEXACT8 rsvd0;
         UEXACT32 port_equalization_settings;
         UEXACT32 port0_emphasis_settings;
         UEXACT32 port1_emphasis_settings;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN, *PSET_PORT_EQUALIZATION_PARAMS_IN;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_IN_UNION {
         SET_PORT_EQUALIZATION_PARAMS_IN bits;
         u32 dw[4]; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN_UNION, *PSET_PORT_EQUALIZATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_IN_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_IN_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_IN {
         union {
            struct { 
               UEXACT8 be_port_num;
               UEXACT8 be_port_channel;
               UEXACT8 equalization_emphasis;
               UEXACT8 rsvd0;
               UEXACT32 port_equalization_settings;
               UEXACT32 port0_emphasis_settings;
               UEXACT32 port1_emphasis_settings;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN, *PSET_PORT_EQUALIZATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_IN, sizeof (SET_PORT_EQUALIZATION_PARAMS_IN) == 16);

   #else
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_IN {
         UEXACT8 be_port_num;
         UEXACT8 be_port_channel;
         UEXACT8 equalization_emphasis;
         UEXACT8 rsvd0;
         UEXACT32 port_equalization_settings;
         UEXACT32 port0_emphasis_settings;
         UEXACT32 port1_emphasis_settings;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN, *PSET_PORT_EQUALIZATION_PARAMS_IN;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_IN_UNION {
         SET_PORT_EQUALIZATION_PARAMS_IN bits;
         u32 dw[4]; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_IN_UNION, *PSET_PORT_EQUALIZATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_IN_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_IN_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT, *PSET_PORT_EQUALIZATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_OUT, sizeof (SET_PORT_EQUALIZATION_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT, *PSET_PORT_EQUALIZATION_PARAMS_OUT;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_OUT_UNION {
         SET_PORT_EQUALIZATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT_UNION, *PSET_PORT_EQUALIZATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_OUT_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT, *PSET_PORT_EQUALIZATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_OUT, sizeof (SET_PORT_EQUALIZATION_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_PORT_EQUALIZATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT, *PSET_PORT_EQUALIZATION_PARAMS_OUT;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_OUT_UNION {
         SET_PORT_EQUALIZATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_OUT_UNION, *PSET_PORT_EQUALIZATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_OUT_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS {
         union {
            union { 
               SET_PORT_EQUALIZATION_PARAMS_IN request;
               SET_PORT_EQUALIZATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS, *PSET_PORT_EQUALIZATION_PARAMS;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS, sizeof (SET_PORT_EQUALIZATION_PARAMS) == 16);

   #else
      typedef union _SET_PORT_EQUALIZATION_PARAMS {
         SET_PORT_EQUALIZATION_PARAMS_IN request;
         SET_PORT_EQUALIZATION_PARAMS_OUT response;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS, *PSET_PORT_EQUALIZATION_PARAMS;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_UNION {
         SET_PORT_EQUALIZATION_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_UNION, *PSET_PORT_EQUALIZATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_PORT_EQUALIZATION_PARAMS {
         union {
            union { 
               SET_PORT_EQUALIZATION_PARAMS_IN request;
               SET_PORT_EQUALIZATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS, *PSET_PORT_EQUALIZATION_PARAMS;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS, sizeof (SET_PORT_EQUALIZATION_PARAMS) == 16);

   #else
      typedef union _SET_PORT_EQUALIZATION_PARAMS {
         SET_PORT_EQUALIZATION_PARAMS_IN request;
         SET_PORT_EQUALIZATION_PARAMS_OUT response;
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS, *PSET_PORT_EQUALIZATION_PARAMS;

      typedef union _SET_PORT_EQUALIZATION_PARAMS_UNION {
         SET_PORT_EQUALIZATION_PARAMS bits;
         u32 dw[4]; // dword union
      } SG_PACK SET_PORT_EQUALIZATION_PARAMS_UNION, *PSET_PORT_EQUALIZATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_PORT_EQUALIZATION_PARAMS_UNION, sizeof (SET_PORT_EQUALIZATION_PARAMS_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL can be used to set equalization and emphasis parameters for BladeEngine
   // ports. 
   typedef struct _IOCTL_COMMON_SET_PORT_EQUALIZATION {
      IOCTL_HEADER header;
      SET_PORT_EQUALIZATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_PORT_EQUALIZATION, *PIOCTL_COMMON_SET_PORT_EQUALIZATION;



#else
   // This IOCTL can be used to set equalization and emphasis parameters for BladeEngine
   // ports. 
   typedef struct _IOCTL_COMMON_SET_PORT_EQUALIZATION {
      IOCTL_HEADER header;
      SET_PORT_EQUALIZATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_PORT_EQUALIZATION, *PIOCTL_COMMON_SET_PORT_EQUALIZATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_RED_PARAMETERS {
         union {
            struct { 
               UEXACT8 enable;
               UEXACT8 w1;
               UEXACT8 w2;
               UEXACT8 slope;
               UEXACT8 mtu_integer;
               UEXACT8 mtu_exponent;
               UEXACT16 rsvd0;
               UEXACT16 min_pbuf;
               UEXACT16 max_pbuf;
               UEXACT32 red_block_mask;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE_RED_PARAMETERS, *PBE_RED_PARAMETERS;

      SG_C_ASSERT(__sizeof__BE_RED_PARAMETERS, sizeof (BE_RED_PARAMETERS) == 16);

   #else
      typedef struct _BE_RED_PARAMETERS {
         UEXACT8 enable;
         UEXACT8 w1;
         UEXACT8 w2;
         UEXACT8 slope;
         UEXACT8 mtu_integer;
         UEXACT8 mtu_exponent;
         UEXACT16 rsvd0;
         UEXACT16 min_pbuf;
         UEXACT16 max_pbuf;
         UEXACT32 red_block_mask;
      } SG_PACK BE_RED_PARAMETERS, *PBE_RED_PARAMETERS;

      typedef union _BE_RED_PARAMETERS_UNION {
         BE_RED_PARAMETERS bits;
         u32 dw[4]; // dword union
      } SG_PACK BE_RED_PARAMETERS_UNION, *PBE_RED_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__BE_RED_PARAMETERS_UNION, sizeof (BE_RED_PARAMETERS_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _BE_RED_PARAMETERS {
         union {
            struct { 
               UEXACT8 enable;
               UEXACT8 w1;
               UEXACT8 w2;
               UEXACT8 slope;
               UEXACT8 mtu_integer;
               UEXACT8 mtu_exponent;
               UEXACT16 rsvd0;
               UEXACT16 min_pbuf;
               UEXACT16 max_pbuf;
               UEXACT32 red_block_mask;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK BE_RED_PARAMETERS, *PBE_RED_PARAMETERS;

      SG_C_ASSERT(__sizeof__BE_RED_PARAMETERS, sizeof (BE_RED_PARAMETERS) == 16);

   #else
      typedef struct _BE_RED_PARAMETERS {
         UEXACT8 enable;
         UEXACT8 w1;
         UEXACT8 w2;
         UEXACT8 slope;
         UEXACT8 mtu_integer;
         UEXACT8 mtu_exponent;
         UEXACT16 rsvd0;
         UEXACT16 min_pbuf;
         UEXACT16 max_pbuf;
         UEXACT32 red_block_mask;
      } SG_PACK BE_RED_PARAMETERS, *PBE_RED_PARAMETERS;

      typedef union _BE_RED_PARAMETERS_UNION {
         BE_RED_PARAMETERS bits;
         u32 dw[4]; // dword union
      } SG_PACK BE_RED_PARAMETERS_UNION, *PBE_RED_PARAMETERS_UNION;

      SG_C_ASSERT(__sizeof__BE_RED_PARAMETERS_UNION, sizeof (BE_RED_PARAMETERS_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL configures the Random Early Discard (RED) functionality for the PCI
   // function. Only the chutes owned by the given PCI function are configured. The other
   // chutes are ignored. 
   typedef struct _IOCTL_COMMON_RED_CONFIG {
      IOCTL_HEADER header;
      union {
         BE_RED_PARAMETERS request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_RED_CONFIG, *PIOCTL_COMMON_RED_CONFIG;



#else
   // This IOCTL configures the Random Early Discard (RED) functionality for the PCI
   // function. Only the chutes owned by the given PCI function are configured. The other
   // chutes are ignored. 
   typedef struct _IOCTL_COMMON_RED_CONFIG {
      IOCTL_HEADER header;
      union {
         BE_RED_PARAMETERS request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } params;
   } SG_PACK IOCTL_COMMON_RED_CONFIG, *PIOCTL_COMMON_RED_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 id;
               UEXACT16 upload_type;
               UEXACT32 reset_seq;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN {
         UEXACT16 id;
         UEXACT16 upload_type;
         UEXACT32 reset_seq;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN {
         union {
            struct { 
               UEXACT16 id;
               UEXACT16 upload_type;
               UEXACT32 reset_seq;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN {
         UEXACT16 id;
         UEXACT16 upload_type;
         UEXACT32 reset_seq;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT {
         union {
            struct { 
               TCP_CONTEXT tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT) == 128);

   #else
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT {
         TCP_CONTEXT tcp;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT bits;
         u32 dw[32]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION) == 128);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT {
         union {
            struct { 
               TCP_CONTEXT tcp;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT) == 128);

   #else
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT {
         TCP_CONTEXT tcp;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT bits;
         u32 dw[32]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS {
         union {
            union { 
               IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN request;
               IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS) == 128);

   #else
      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN request;
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS bits;
         u32 dw[32]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION) == 128);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_TCP_UPLOAD_PARAMS {
         union {
            union { 
               IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN request;
               IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[32]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS) == 128);

   #else
      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN request;
         IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS;

      typedef union _IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION {
         IOCTL_COMMON_TCP_UPLOAD_PARAMS bits;
         u32 dw[32]; // dword union
      } SG_PACK IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION, sizeof (IOCTL_COMMON_TCP_UPLOAD_PARAMS_UNION) == 128);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Uploads an offloaded TCP connection. This flushes the send queue, disables the TCP
   // offload, and returns the final TCP state. 
   typedef struct _IOCTL_COMMON_TCP_UPLOAD {
      IOCTL_HEADER header;
      IOCTL_COMMON_TCP_UPLOAD_PARAMS params;
   } SG_PACK IOCTL_COMMON_TCP_UPLOAD, *PIOCTL_COMMON_TCP_UPLOAD;



#else
   // Uploads an offloaded TCP connection. This flushes the send queue, disables the TCP
   // offload, and returns the final TCP state. 
   typedef struct _IOCTL_COMMON_TCP_UPLOAD {
      IOCTL_HEADER header;
      IOCTL_COMMON_TCP_UPLOAD_PARAMS params;
   } SG_PACK IOCTL_COMMON_TCP_UPLOAD, *PIOCTL_COMMON_TCP_UPLOAD;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Destroys all resources assigned to the PCI function which originates this request.
   // The function-reset is intended for use by drivers transitioning from boot BIOS. At
   // the completion of this IOCTL all chip resources assigned to this function are freed
   // by the ARM firmware.  This is equivalent to a PCI function-level reset. However, the
   // PCI configuration information is preserved. This function has no request or response
   // parameters. It will always return MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_FUNCTION_RESET {
      IOCTL_HEADER header;
   } SG_PACK IOCTL_COMMON_FUNCTION_RESET, *PIOCTL_COMMON_FUNCTION_RESET;



#else
   // Destroys all resources assigned to the PCI function which originates this request.
   // The function-reset is intended for use by drivers transitioning from boot BIOS. At
   // the completion of this IOCTL all chip resources assigned to this function are freed
   // by the ARM firmware.  This is equivalent to a PCI function-level reset. However, the
   // PCI configuration information is preserved. This function has no request or response
   // parameters. It will always return MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_FUNCTION_RESET {
      IOCTL_HEADER header;
   } SG_PACK IOCTL_COMMON_FUNCTION_RESET, *PIOCTL_COMMON_FUNCTION_RESET;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 port_status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT {
         UEXACT32 port_status;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 port_status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT {
         UEXACT32 port_status;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN request;
               IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN request;
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_STATUS_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN request;
               IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN request;
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_STATUS_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_STATUS_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to query the PHY port status. 
   typedef struct _IOCTL_COMMON_GET_PORT_STATUS {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_STATUS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_STATUS, *PIOCTL_COMMON_GET_PORT_STATUS;



#else
   // This IOCTL is used to query the PHY port status. 
   typedef struct _IOCTL_COMMON_GET_PORT_STATUS {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_STATUS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_STATUS, *PIOCTL_COMMON_GET_PORT_STATUS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 port_status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN {
         UEXACT32 port_status;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN {
         union {
            struct { 
               UEXACT32 port_status;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN {
         UEXACT32 port_status;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS {
         union {
            union { 
               IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN request;
               IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN request;
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS {
         union {
            union { 
               IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN request;
               IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN request;
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used to enable or disable the PHY port. 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT {
      IOCTL_HEADER header;
      IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT;



#else
   // This IOCTL is used to enable or disable the PHY port. 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_PORT {
      IOCTL_HEADER header;
      IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_PORT, *PIOCTL_COMMON_ENABLE_DISABLE_PORT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 port_speed;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 port_speed;
         } response;
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 port_speed;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 port_speed;
         } response;
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will query the PHY ports speed capability on BE2 
   typedef struct _IOCTL_COMMON_GET_PORT_CAPABILITY {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY, *PIOCTL_COMMON_GET_PORT_CAPABILITY;



#else
   // This IOCTL will query the PHY ports speed capability on BE2 
   typedef struct _IOCTL_COMMON_GET_PORT_CAPABILITY {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_CAPABILITY, *PIOCTL_COMMON_GET_PORT_CAPABILITY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 function_status;
                  UEXACT32 link_status;
                  UEXACT32 vlan_id;
                  UEXACT32 vlan_priority;
                  UEXACT32 qos_min;
                  UEXACT32 qos_max;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, sizeof (IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         struct {
            UEXACT32 function_status;
            UEXACT32 link_status;
            UEXACT32 vlan_id;
            UEXACT32 vlan_priority;
            UEXACT32 qos_min;
            UEXACT32 qos_max;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 function_status;
                  UEXACT32 link_status;
                  UEXACT32 vlan_id;
                  UEXACT32 vlan_priority;
                  UEXACT32 qos_min;
                  UEXACT32 qos_max;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, sizeof (IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         struct {
            UEXACT32 function_status;
            UEXACT32 link_status;
            UEXACT32 vlan_id;
            UEXACT32 vlan_priority;
            UEXACT32 qos_min;
            UEXACT32 qos_max;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will set the configuration parameters for a given physical function. 
   typedef struct _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG;



#else
   // This IOCTL will set the configuration parameters for a given physical function. 
   typedef struct _IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 function_status;
                  UEXACT32 vlan_id;
                  UEXACT32 vlan_priority;
                  UEXACT32 qos_min;
                  UEXACT32 qos_max;
                  UEXACT32 link_status;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, sizeof (IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 function_status;
            UEXACT32 vlan_id;
            UEXACT32 vlan_priority;
            UEXACT32 qos_min;
            UEXACT32 qos_max;
            UEXACT32 link_status;
         } response;
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 function_status;
                  UEXACT32 vlan_id;
                  UEXACT32 vlan_priority;
                  UEXACT32 qos_min;
                  UEXACT32 qos_max;
                  UEXACT32 link_status;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, sizeof (IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 function_status;
            UEXACT32 vlan_id;
            UEXACT32 vlan_priority;
            UEXACT32 qos_min;
            UEXACT32 qos_max;
            UEXACT32 link_status;
         } response;
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will query the configuration parameters for a given physical function. 
   typedef struct _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG;



#else
   // This IOCTL will query the configuration parameters for a given physical function. 
   typedef struct _IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 function_status;
                  UEXACT8 function_name[12];
                  UEXACT8 rsvd0[12];
                  UEXACT32 rsvd1[16];
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[23]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, sizeof (IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS) == 92);

   #else
      typedef union _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 function_status;
            UEXACT8 function_name[12];
            UEXACT8 rsvd0[12];
            UEXACT32 rsvd1[16];
         } response;
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS;

      typedef union _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION {
         IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS bits;
         u32 dw[23]; // dword union
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION) == 92);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 function_status;
                  UEXACT8 function_name[12];
                  UEXACT8 rsvd0[12];
                  UEXACT32 rsvd1[16];
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[23]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, sizeof (IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS) == 92);

   #else
      typedef union _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 function_status;
            UEXACT8 function_name[12];
            UEXACT8 rsvd0[12];
            UEXACT32 rsvd1[16];
         } response;
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS;

      typedef union _IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION {
         IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS bits;
         u32 dw[23]; // dword union
      } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_UNION) == 92);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will query configuration parameters for a given physical / virtual
   // function. There is no SET equivalent for this IOCTL. 
   typedef struct _IOCTL_COMMON_GET_FUNCTION_NAME_INFO {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO;



#else
   // This IOCTL will query configuration parameters for a given physical / virtual
   // function. There is no SET equivalent for this IOCTL. 
   typedef struct _IOCTL_COMMON_GET_FUNCTION_NAME_INFO {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_FUNCTION_NAME_INFO, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT8 boot_status;
                  UEXACT8 bios_instance;
                  UEXACT8 rsvd0[2];
                  UEXACT32 future;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, sizeof (IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT8 boot_status;
            UEXACT8 bios_instance;
            UEXACT8 rsvd0[2];
            UEXACT32 future;
         } response;
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT8 boot_status;
                  UEXACT8 bios_instance;
                  UEXACT8 rsvd0[2];
                  UEXACT32 future;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, sizeof (IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT8 boot_status;
            UEXACT8 bios_instance;
            UEXACT8 rsvd0[2];
            UEXACT32 future;
         } response;
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows BE expansion BIOSes to query the boot configuration for the
   // associated physical function. 
   typedef struct _IOCTL_COMMON_GET_BOOT_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG, *PIOCTL_COMMON_GET_BOOT_CONFIG;



#else
   // This IOCTL allows BE expansion BIOSes to query the boot configuration for the
   // associated physical function. 
   typedef struct _IOCTL_COMMON_GET_BOOT_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BOOT_CONFIG, *PIOCTL_COMMON_GET_BOOT_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT8 boot_status;
                  UEXACT8 bios_instance;
                  UEXACT8 rsvd0[2];
                  UEXACT32 future;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, sizeof (IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS {
         struct {
            UEXACT8 boot_status;
            UEXACT8 bios_instance;
            UEXACT8 rsvd0[2];
            UEXACT32 future;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS {
         union {
            union { 
               struct {
                  UEXACT8 boot_status;
                  UEXACT8 bios_instance;
                  UEXACT8 rsvd0[2];
                  UEXACT32 future;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, sizeof (IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS {
         struct {
            UEXACT8 boot_status;
            UEXACT8 bios_instance;
            UEXACT8 rsvd0[2];
            UEXACT32 future;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS;

      typedef union _IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION {
         IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows expansion BIOS to enable/disable user settings for the associated
   // physical function. iSCSI or PXE Select may use this to  - Enable/disable BIOS
   // functionality  - Control the number of BIOS instances for a given type of BE
   // function 
   typedef struct _IOCTL_COMMON_SET_BOOT_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG, *PIOCTL_COMMON_SET_BOOT_CONFIG;



#else
   // This IOCTL allows expansion BIOS to enable/disable user settings for the associated
   // physical function. iSCSI or PXE Select may use this to  - Enable/disable BIOS
   // functionality  - Control the number of BIOS instances for a given type of BE
   // function 
   typedef struct _IOCTL_COMMON_SET_BOOT_CONFIG {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_BOOT_CONFIG, *PIOCTL_COMMON_SET_BOOT_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN {
         union {
            struct { 
               UEXACT8 port_num;
               UEXACT8 beacon_state;
               UEXACT8 beacon_duration;
               UEXACT8 status_duration;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN {
         UEXACT8 port_num;
         UEXACT8 beacon_state;
         UEXACT8 beacon_duration;
         UEXACT8 status_duration;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN {
         union {
            struct { 
               UEXACT8 port_num;
               UEXACT8 beacon_state;
               UEXACT8 beacon_duration;
               UEXACT8 status_duration;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN {
         UEXACT8 port_num;
         UEXACT8 beacon_state;
         UEXACT8 beacon_duration;
         UEXACT8 status_duration;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS {
         union {
            union { 
               IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN request;
               IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN request;
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS {
         union {
            union { 
               IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN request;
               IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN request;
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS;

      typedef union _IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION {
         IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION, sizeof (IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will enable or disable beaconing on the selected port. 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON {
      IOCTL_HEADER header;
      IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON;



#else
   // This IOCTL will enable or disable beaconing on the selected port. 
   typedef struct _IOCTL_COMMON_ENABLE_DISABLE_BEACON {
      IOCTL_HEADER header;
      IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS params;
   } SG_PACK IOCTL_COMMON_ENABLE_DISABLE_BEACON, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN {
      UEXACT8 port_num;
   } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN;



#else
   
   typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN {
      UEXACT8 port_num;
   } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 beacon_state;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT {
         UEXACT8 beacon_state;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 beacon_state;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT {
         UEXACT8 beacon_state;
         UEXACT8 rsvd0[3];
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN request;
               IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN request;
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS;

      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_BEACON_STATE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN request;
               IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN request;
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS;

      typedef union _IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION {
         IOCTL_COMMON_GET_BEACON_STATE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_BEACON_STATE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will report the current state of beaconing on the selected port. 
   typedef struct _IOCTL_COMMON_GET_BEACON_STATE {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_BEACON_STATE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BEACON_STATE, *PIOCTL_COMMON_GET_BEACON_STATE;



#else
   // This IOCTL will report the current state of beaconing on the selected port. 
   typedef struct _IOCTL_COMMON_GET_BEACON_STATE {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_BEACON_STATE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BEACON_STATE, *PIOCTL_COMMON_GET_BEACON_STATE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN {
         union {
            struct { 
               u32 offset;
               u32 data_length;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN {
         u32 offset;
         u32 data_length;
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN {
         union {
            struct { 
               u32 offset;
               u32 data_length;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN {
         u32 offset;
         u32 data_length;
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT {
         union {
            struct { 
               u32 offset;
               u32 data_length;
               u32 pci_data[64];
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT) == 264);

   #else
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT {
         u32 offset;
         u32 data_length;
         u32 pci_data[64];
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT bits;
         u32 dw[66]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION) == 264);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT {
         union {
            struct { 
               u32 offset;
               u32 data_length;
               u32 pci_data[64];
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT) == 264);

   #else
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT {
         u32 offset;
         u32 data_length;
         u32 pci_data[64];
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT bits;
         u32 dw[66]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_UNION) == 264);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN request;
               IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS) == 264);

   #else
      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN request;
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT response;
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS bits;
         u32 dw[66]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION) == 264);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN request;
               IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[66]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS) == 264);

   #else
      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN request;
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT response;
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS;

      typedef union _IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION {
         IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS bits;
         u32 dw[66]; // dword union
      } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION, sizeof (IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_UNION) == 264);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will read up to 256B from PCI Config space for the corresponding pci
   // function number. The read data is filled in the response. 
   typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE {
      IOCTL_HEADER header;
      IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS params;
   } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE;



#else
   // This IOCTL will read up to 256B from PCI Config space for the corresponding pci
   // function number. The read data is filled in the response. 
   typedef struct _IOCTL_COMMON_READ_PCI_CONFIG_SPACE {
      IOCTL_HEADER header;
      IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS params;
   } SG_PACK IOCTL_COMMON_READ_PCI_CONFIG_SPACE, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN {
         union {
            struct { 
               u32 page_num;
               u32 port;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN {
         u32 page_num;
         u32 port;
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN {
         union {
            struct { 
               u32 page_num;
               u32 port;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN) == 8);

   #else
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN {
         u32 page_num;
         u32 port;
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT {
         union {
            struct { 
               u32 page_num;
               u32 port;
               u32 page_data[32];
            } SG_PACK ; // unnamed struct
            u32 dw[34]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT) == 136);

   #else
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT {
         u32 page_num;
         u32 port;
         u32 page_data[32];
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT bits;
         u32 dw[34]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION) == 136);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT {
         union {
            struct { 
               u32 page_num;
               u32 port;
               u32 page_data[32];
            } SG_PACK ; // unnamed struct
            u32 dw[34]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT) == 136);

   #else
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT {
         u32 page_num;
         u32 port;
         u32 page_data[32];
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT bits;
         u32 dw[34]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_UNION) == 136);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS {
         union {
            union { 
               IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN request;
               IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[34]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS) == 136);

   #else
      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN request;
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS bits;
         u32 dw[34]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION) == 136);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS {
         union {
            union { 
               IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN request;
               IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[34]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS) == 136);

   #else
      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN request;
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS;

      typedef union _IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION {
         IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS bits;
         u32 dw[34]; // dword union
      } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION, sizeof (IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_UNION) == 136);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL will read 128B of transreceiver data from each of the A0 and A2 pages.
   // The A0 and A2 pages are as defined by the SFF - 8472 specification. 
   typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA {
      IOCTL_HEADER header;
      IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS params;
   } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA;



#else
   // This IOCTL will read 128B of transreceiver data from each of the A0 and A2 pages.
   // The A0 and A2 pages are as defined by the SFF - 8472 specification. 
   typedef struct _IOCTL_COMMON_READ_TRANSRECEIVER_DATA {
      IOCTL_HEADER header;
      IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS params;
   } SG_PACK IOCTL_COMMON_READ_TRANSRECEIVER_DATA, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 emulex_serial_number[12];
               UEXACT8 oem_serial_number[24];
               UEXACT32 oem_personality_mgmt_word;
               UEXACT8 oem_current_personality;
               UEXACT8 rsrvd[3];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT) == 44);

   #else
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT {
         UEXACT8 emulex_serial_number[12];
         UEXACT8 oem_serial_number[24];
         UEXACT32 oem_personality_mgmt_word;
         UEXACT8 oem_current_personality;
         UEXACT8 rsrvd[3];
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[11]; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 emulex_serial_number[12];
               UEXACT8 oem_serial_number[24];
               UEXACT32 oem_personality_mgmt_word;
               UEXACT8 oem_current_personality;
               UEXACT8 rsrvd[3];
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT) == 44);

   #else
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT {
         UEXACT8 emulex_serial_number[12];
         UEXACT8 oem_serial_number[24];
         UEXACT32 oem_personality_mgmt_word;
         UEXACT8 oem_current_personality;
         UEXACT8 rsrvd[3];
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[11]; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN request;
               IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS) == 44);

   #else
      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN request;
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS bits;
         u32 dw[11]; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION) == 44);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN request;
               IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[11]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS) == 44);

   #else
      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN request;
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS;

      typedef union _IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION {
         IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS bits;
         u32 dw[11]; // dword union
      } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_UNION) == 44);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This ioctl queries the OEM-specific controller information stored on SEEPROM during
   // manufacturing. 
   typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES;



#else
   // This ioctl queries the OEM-specific controller information stored on SEEPROM during
   // manufacturing. 
   typedef struct _IOCTL_COMMON_GET_OEM_ATTRIBUTES {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_OEM_ATTRIBUTES, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 port0_name;
               UEXACT8 port1_name;
               UEXACT8 rsvd0[2];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT {
         UEXACT8 port0_name;
         UEXACT8 port1_name;
         UEXACT8 rsvd0[2];
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 port0_name;
               UEXACT8 port1_name;
               UEXACT8 rsvd0[2];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT {
         UEXACT8 port0_name;
         UEXACT8 port1_name;
         UEXACT8 rsvd0[2];
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN request;
               IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN request;
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PORT_NAME_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN request;
               IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN request;
         IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS;

      typedef union _IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION {
         IOCTL_COMMON_GET_PORT_NAME_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PORT_NAME_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This ioctl queries the single character 'name' assigned to each BladeEngine port.
   // The port-name is stored on SEEPROM during manufacturing. It can not be altered by
   // users/administrators. 
   typedef struct _IOCTL_COMMON_GET_PORT_NAME {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_NAME_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_NAME, *PIOCTL_COMMON_GET_PORT_NAME;



#else
   // This ioctl queries the single character 'name' assigned to each BladeEngine port.
   // The port-name is stored on SEEPROM during manufacturing. It can not be altered by
   // users/administrators. 
   typedef struct _IOCTL_COMMON_GET_PORT_NAME {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PORT_NAME_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PORT_NAME, *PIOCTL_COMMON_GET_PORT_NAME;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 config_change_source;
               UEXACT8 platform_unique_signature[128];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT) == 132);

   #else
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT {
         UEXACT32 config_change_source;
         UEXACT8 platform_unique_signature[128];
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 config_change_source;
               UEXACT8 platform_unique_signature[128];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT) == 132);

   #else
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT {
         UEXACT32 config_change_source;
         UEXACT8 platform_unique_signature[128];
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN request;
               IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN request;
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN request;
               IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN request;
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS;

      typedef union _IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION {
         IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allows MILI to verify whether its database is relevant/updated. If the retrieved
   // signature matches the one owned by a particular instance, then it can be assumed
   // that the database is in sync. The platform unique signature may be a
   // system/installation-unique GUID or license key. 
   typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE;



#else
   // Allows MILI to verify whether its database is relevant/updated. If the retrieved
   // signature matches the one owned by a particular instance, then it can be assumed
   // that the database is in sync. The platform unique signature may be a
   // system/installation-unique GUID or license key. 
   typedef struct _IOCTL_COMMON_GET_CONFIG_SIGNATURE {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CONFIG_SIGNATURE, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 config_change_source;
               UEXACT8 platform_unique_signature[128];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN) == 132);

   #else
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN {
         UEXACT32 config_change_source;
         UEXACT8 platform_unique_signature[128];
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 config_change_source;
               UEXACT8 platform_unique_signature[128];
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN) == 132);

   #else
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN {
         UEXACT32 config_change_source;
         UEXACT8 platform_unique_signature[128];
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN request;
               IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN request;
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION) == 132);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN request;
               IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[33]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS) == 132);

   #else
      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN request;
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS;

      typedef union _IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION {
         IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS bits;
         u32 dw[33]; // dword union
      } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_UNION) == 132);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Configuration utilities (e.g. MILI or iSCSI Select) MUST issue this IOCTL before
   // issuing any IOCTL which changes configuration. 
   typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE;



#else
   // Configuration utilities (e.g. MILI or iSCSI Select) MUST issue this IOCTL before
   // issuing any IOCTL which changes configuration. 
   typedef struct _IOCTL_COMMON_SET_CONFIG_SIGNATURE {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_CONFIG_SIGNATURE, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT32 enable;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN, *PFUNCTION_LINK_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_IN, sizeof (FUNCTION_LINK_CONFIG_PARAMS_IN) == 4);

   #else
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_IN {
         UEXACT32 enable;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN, *PFUNCTION_LINK_CONFIG_PARAMS_IN;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_IN_UNION {
         FUNCTION_LINK_CONFIG_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_IN_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_IN {
         union {
            struct { 
               UEXACT32 enable;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN, *PFUNCTION_LINK_CONFIG_PARAMS_IN;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_IN, sizeof (FUNCTION_LINK_CONFIG_PARAMS_IN) == 4);

   #else
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_IN {
         UEXACT32 enable;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN, *PFUNCTION_LINK_CONFIG_PARAMS_IN;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_IN_UNION {
         FUNCTION_LINK_CONFIG_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_IN_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_IN_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_OUT {
         union {
            struct { 
               u32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT, *PFUNCTION_LINK_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_OUT, sizeof (FUNCTION_LINK_CONFIG_PARAMS_OUT) == 4);

   #else
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_OUT {
         u32 rsvd0;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT, *PFUNCTION_LINK_CONFIG_PARAMS_OUT;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION {
         FUNCTION_LINK_CONFIG_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_OUT {
         union {
            struct { 
               u32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT, *PFUNCTION_LINK_CONFIG_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_OUT, sizeof (FUNCTION_LINK_CONFIG_PARAMS_OUT) == 4);

   #else
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS_OUT {
         u32 rsvd0;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT, *PFUNCTION_LINK_CONFIG_PARAMS_OUT;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION {
         FUNCTION_LINK_CONFIG_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS {
         union {
            union { 
               FUNCTION_LINK_CONFIG_PARAMS_IN request;
               FUNCTION_LINK_CONFIG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS, *PFUNCTION_LINK_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS, sizeof (FUNCTION_LINK_CONFIG_PARAMS) == 4);

   #else
      typedef union _FUNCTION_LINK_CONFIG_PARAMS {
         FUNCTION_LINK_CONFIG_PARAMS_IN request;
         FUNCTION_LINK_CONFIG_PARAMS_OUT response;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS, *PFUNCTION_LINK_CONFIG_PARAMS;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_UNION {
         FUNCTION_LINK_CONFIG_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _FUNCTION_LINK_CONFIG_PARAMS {
         union {
            union { 
               FUNCTION_LINK_CONFIG_PARAMS_IN request;
               FUNCTION_LINK_CONFIG_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS, *PFUNCTION_LINK_CONFIG_PARAMS;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS, sizeof (FUNCTION_LINK_CONFIG_PARAMS) == 4);

   #else
      typedef union _FUNCTION_LINK_CONFIG_PARAMS {
         FUNCTION_LINK_CONFIG_PARAMS_IN request;
         FUNCTION_LINK_CONFIG_PARAMS_OUT response;
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS, *PFUNCTION_LINK_CONFIG_PARAMS;

      typedef union _FUNCTION_LINK_CONFIG_PARAMS_UNION {
         FUNCTION_LINK_CONFIG_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK FUNCTION_LINK_CONFIG_PARAMS_UNION, *PFUNCTION_LINK_CONFIG_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__FUNCTION_LINK_CONFIG_PARAMS_UNION, sizeof (FUNCTION_LINK_CONFIG_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The transmit and receive capability for the associated function can be enabled or
   // disabled using this IOCTL. 
   typedef struct _IOCTL_COMMON_FUNCTION_LINK_CONFIG {
      IOCTL_HEADER header;
      FUNCTION_LINK_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_FUNCTION_LINK_CONFIG, *PIOCTL_COMMON_FUNCTION_LINK_CONFIG;



#else
   // The transmit and receive capability for the associated function can be enabled or
   // disabled using this IOCTL. 
   typedef struct _IOCTL_COMMON_FUNCTION_LINK_CONFIG {
      IOCTL_HEADER header;
      FUNCTION_LINK_CONFIG_PARAMS params;
   } SG_PACK IOCTL_COMMON_FUNCTION_LINK_CONFIG, *PIOCTL_COMMON_FUNCTION_LINK_CONFIG;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // To change the personality of a given controller (LOM/Mezz/HBA).Send the NEW pf_type
   // for the selected pf_num. Fields other than pf_nm, pf_state and pf_type are ignore
   // when a personality change is requested. At present, personality changes affect only
   // pf_num=2 and pf_num=3. These two PFs are designated as storage functions. 
   typedef struct _BE_RESOURCES_PCIE {
      UEXACT8 pf_num;
      UEXACT8 pf_state;
      UEXACT8 pf_type;
      UEXACT8 sriov_state;
      UEXACT16 msix_vectors;
      UEXACT16 number_of_vf;
      UEXACT8 msix_per_vf;
      UEXACT8 rsvd0[3];
      UEXACT32 port_num;
   } SG_PACK BE_RESOURCES_PCIE, *PBE_RESOURCES_PCIE;



#else
   // To change the personality of a given controller (LOM/Mezz/HBA).Send the NEW pf_type
   // for the selected pf_num. Fields other than pf_nm, pf_state and pf_type are ignore
   // when a personality change is requested. At present, personality changes affect only
   // pf_num=2 and pf_num=3. These two PFs are designated as storage functions. 
   typedef struct _BE_RESOURCES_PCIE {
      UEXACT8 pf_num;
      UEXACT8 pf_state;
      UEXACT8 pf_type;
      UEXACT8 sriov_state;
      UEXACT16 msix_vectors;
      UEXACT16 number_of_vf;
      UEXACT8 msix_per_vf;
      UEXACT8 rsvd0[3];
      UEXACT32 port_num;
   } SG_PACK BE_RESOURCES_PCIE, *PBE_RESOURCES_PCIE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_NIC {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 mac_unicast_count;
      UEXACT8 nic_mac_address_start[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0;
      UEXACT16 vlan_count;
      UEXACT16 mac_mcast_count;
      UEXACT16 tx_queue_count;
      UEXACT16 rx_queue_count;
      UEXACT16 rss_queue_count;
      UEXACT16 lro_queue_count;
      UEXACT16 cq_count;
      UEXACT16 toe_connection_count;
      UEXACT32 rsvd1;
   } SG_PACK BE_RESOURCES_NIC, *PBE_RESOURCES_NIC;



#else
   
   typedef struct _BE_RESOURCES_NIC {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 mac_unicast_count;
      UEXACT8 nic_mac_address_start[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0;
      UEXACT16 vlan_count;
      UEXACT16 mac_mcast_count;
      UEXACT16 tx_queue_count;
      UEXACT16 rx_queue_count;
      UEXACT16 rss_queue_count;
      UEXACT16 lro_queue_count;
      UEXACT16 cq_count;
      UEXACT16 toe_connection_count;
      UEXACT32 rsvd1;
   } SG_PACK BE_RESOURCES_NIC, *PBE_RESOURCES_NIC;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_ISCSI {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 session_count;
      UEXACT16 icd_count;
      UEXACT16 cq_count;
      UEXACT8 iscsi_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0[5];
   } SG_PACK BE_RESOURCES_ISCSI, *PBE_RESOURCES_ISCSI;



#else
   
   typedef struct _BE_RESOURCES_ISCSI {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 session_count;
      UEXACT16 icd_count;
      UEXACT16 cq_count;
      UEXACT8 iscsi_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0[5];
   } SG_PACK BE_RESOURCES_ISCSI, *PBE_RESOURCES_ISCSI;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_FCOE {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 login_count;
      UEXACT16 xri_count;
      UEXACT16 wq_count;
      UEXACT16 rq_count;
      UEXACT16 cq_count;
      UEXACT16 vpi_count;
      UEXACT16 max_fcf_count;
      UEXACT16 max_vfi_count;
      UEXACT16 rsrvd;
      UEXACT8 wwn[16];
      UEXACT8 fcoe_fip_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0[5];
   } SG_PACK BE_RESOURCES_FCOE, *PBE_RESOURCES_FCOE;



#else
   
   typedef struct _BE_RESOURCES_FCOE {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 login_count;
      UEXACT16 xri_count;
      UEXACT16 wq_count;
      UEXACT16 rq_count;
      UEXACT16 cq_count;
      UEXACT16 vpi_count;
      UEXACT16 max_fcf_count;
      UEXACT16 max_vfi_count;
      UEXACT16 rsrvd;
      UEXACT8 wwn[16];
      UEXACT8 fcoe_fip_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd0[5];
   } SG_PACK BE_RESOURCES_FCOE, *PBE_RESOURCES_FCOE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_RDMA {
      UEXACT32 rsvd0;
   } SG_PACK BE_RESOURCES_RDMA, *PBE_RESOURCES_RDMA;



#else
   
   typedef struct _BE_RESOURCES_RDMA {
      UEXACT32 rsvd0;
   } SG_PACK BE_RESOURCES_RDMA, *PBE_RESOURCES_RDMA;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESOURCE_DESC {
         union {
            union { 
               BE_RESOURCES_PCIE pci_resources;
               BE_RESOURCES_NIC nic_resources;
               BE_RESOURCES_ISCSI iscsi_resources;
               BE_RESOURCES_FCOE fcoe_resources;
               BE_RESOURCES_RDMA rdma_resources;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RESOURCE_DESC, *PRESOURCE_DESC;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC, sizeof (RESOURCE_DESC) == 48);

   #else
      typedef union _RESOURCE_DESC {
         BE_RESOURCES_PCIE pci_resources;
         BE_RESOURCES_NIC nic_resources;
         BE_RESOURCES_ISCSI iscsi_resources;
         BE_RESOURCES_FCOE fcoe_resources;
         BE_RESOURCES_RDMA rdma_resources;
      } SG_PACK RESOURCE_DESC, *PRESOURCE_DESC;

      typedef union _RESOURCE_DESC_UNION {
         RESOURCE_DESC bits;
         u32 dw[12]; // dword union
      } SG_PACK RESOURCE_DESC_UNION, *PRESOURCE_DESC_UNION;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_UNION, sizeof (RESOURCE_DESC_UNION) == 48);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESOURCE_DESC {
         union {
            union { 
               BE_RESOURCES_PCIE pci_resources;
               BE_RESOURCES_NIC nic_resources;
               BE_RESOURCES_ISCSI iscsi_resources;
               BE_RESOURCES_FCOE fcoe_resources;
               BE_RESOURCES_RDMA rdma_resources;
            } SG_PACK ; // unnamed struct
            u32 dw[12]; // dword union
         }; // unnamed union
      } SG_PACK RESOURCE_DESC, *PRESOURCE_DESC;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC, sizeof (RESOURCE_DESC) == 48);

   #else
      typedef union _RESOURCE_DESC {
         BE_RESOURCES_PCIE pci_resources;
         BE_RESOURCES_NIC nic_resources;
         BE_RESOURCES_ISCSI iscsi_resources;
         BE_RESOURCES_FCOE fcoe_resources;
         BE_RESOURCES_RDMA rdma_resources;
      } SG_PACK RESOURCE_DESC, *PRESOURCE_DESC;

      typedef union _RESOURCE_DESC_UNION {
         RESOURCE_DESC bits;
         u32 dw[12]; // dword union
      } SG_PACK RESOURCE_DESC_UNION, *PRESOURCE_DESC_UNION;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_UNION, sizeof (RESOURCE_DESC_UNION) == 48);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // During a personality-change request, only BE_RESOURCES_PCIE is relevant; aLL other
   // resource types in this IOCTL will be ignored. 
   typedef struct _BE_RESOURCES {
      UEXACT8 resource_type;
      UEXACT8 rsvd0[3];
      RESOURCE_DESC resource_descriptor;
   } SG_PACK BE_RESOURCES, *PBE_RESOURCES;



#else
   // During a personality-change request, only BE_RESOURCES_PCIE is relevant; aLL other
   // resource types in this IOCTL will be ignored. 
   typedef struct _BE_RESOURCES {
      UEXACT8 resource_type;
      UEXACT8 rsvd0[3];
      RESOURCE_DESC resource_descriptor;
   } SG_PACK BE_RESOURCES, *PBE_RESOURCES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT) == 56);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES be_resources[1];
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT) == 56);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES be_resources[1];
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         union {
            union { 
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS) == 56);

   #else
      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         union {
            union { 
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS) == 56);

   #else
      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   //   - Lists the physical functions enabled/disabled  - Lists the virtual functions
   // enabled (if any), per physical function  - Lists the per function resources based on
   // whether the function is NIC, iSCSI, FCoE or RDMA 
   typedef struct _IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES {
      IOCTL_HEADER header;
      GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES;



#else
   //   - Lists the physical functions enabled/disabled  - Lists the virtual functions
   // enabled (if any), per physical function  - Lists the per function resources based on
   // whether the function is NIC, iSCSI, FCoE or RDMA 
   typedef struct _IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES {
      IOCTL_HEADER header;
      GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN) == 56);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES be_resources[1];
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN bits;
         u32 dw[14]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN) == 56);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES be_resources[1];
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN bits;
         u32 dw[14]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         union {
            union { 
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS) == 56);

   #else
      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION) == 56);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         union {
            union { 
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[14]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS) == 56);

   #else
      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN request;
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT response;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS bits;
         u32 dw[14]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_UNION) == 56);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be used for any/all of the following.  - Enable/disable BE physical
   // functions  - Change the board personality by reassigning select PCI functions from
   // NIC<->iSCSI<->FCoE. The success of personality changes depends on modes enabled on
   // the Personality Management Word (PMW) stored on the SEEPROM on that board.  - Set
   // the per-function resources based on whether the function is NIC, iSCSI, FCoE or RDMA
   //  - Set the virtual functions enabled (if any), per-physical function To leave a
   // field unchanged, callers must set its value to -1 (0xff,0xffff,.. as appropriate).
   // If a field has never been set (by a previous call to this IOCTL), then the default
   // values are used. In the case of MAC address, for example, the default value are
   // obtained from SEEPROM.  This IOCTL may return the following status values  -
   // MGMT_STATUS_SUCCESS - The requested resource changes were applied.  -
   // MGMT_STATUS_REBOOT_REQUIRED - The personality change requested, has been accepted.
   // The system must be rebooted for these changes to take effect.  -
   // MGMT_STATUS_PERSONALITY_CHANGE_FAILED - In this case the following additional status
   // values apply  - MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF - The
   // functions assigned to the requested PFs cannot be changed. Check PF#s in the IOCTL
   // request.  - MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE - The PCI ID combination
   // did not match any entry in our table.  -
   // MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED - The PMW for this board does not
   // support a personality change. 
   typedef struct _IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES {
      IOCTL_HEADER header;
      SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES;



#else
   // This IOCTL may be used for any/all of the following.  - Enable/disable BE physical
   // functions  - Change the board personality by reassigning select PCI functions from
   // NIC<->iSCSI<->FCoE. The success of personality changes depends on modes enabled on
   // the Personality Management Word (PMW) stored on the SEEPROM on that board.  - Set
   // the per-function resources based on whether the function is NIC, iSCSI, FCoE or RDMA
   //  - Set the virtual functions enabled (if any), per-physical function To leave a
   // field unchanged, callers must set its value to -1 (0xff,0xffff,.. as appropriate).
   // If a field has never been set (by a previous call to this IOCTL), then the default
   // values are used. In the case of MAC address, for example, the default value are
   // obtained from SEEPROM.  This IOCTL may return the following status values  -
   // MGMT_STATUS_SUCCESS - The requested resource changes were applied.  -
   // MGMT_STATUS_REBOOT_REQUIRED - The personality change requested, has been accepted.
   // The system must be rebooted for these changes to take effect.  -
   // MGMT_STATUS_PERSONALITY_CHANGE_FAILED - In this case the following additional status
   // values apply  - MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF - The
   // functions assigned to the requested PFs cannot be changed. Check PF#s in the IOCTL
   // request.  - MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE - The PCI ID combination
   // did not match any entry in our table.  -
   // MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED - The PMW for this board does not
   // support a personality change. 
   typedef struct _IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES {
      IOCTL_HEADER header;
      SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // To change the personality of a given controller (LOM/Mezz/HBA).Send the NEW pf_type
   // for the selected pf_num. Fields other than pf_nm, pf_state and pf_type are ignore
   // when a personality change is requested. At present, personality changes affect only
   // pf_num=2 and pf_num=3. These two PFs are designated as storage functions. 
   typedef struct _BE_RESOURCES_PCIE_V1 {
      UEXACT8 pf_num;
      UEXACT8 pf_state;
      UEXACT8 pf_type;
      UEXACT8 rsvd0;
      UEXACT32 valid_fields;
      UEXACT8 sriov_state;
      UEXACT8 rsvd1;
      UEXACT16 msix_vectors;
      UEXACT16 number_of_vf;
      UEXACT8 msix_per_vf;
      UEXACT8 rsvd2;
      UEXACT32 port_num;
      UEXACT8 link_status;
      UEXACT8 rsvd3[43];
   } SG_PACK BE_RESOURCES_PCIE_V1, *PBE_RESOURCES_PCIE_V1;



#else
   // To change the personality of a given controller (LOM/Mezz/HBA).Send the NEW pf_type
   // for the selected pf_num. Fields other than pf_nm, pf_state and pf_type are ignore
   // when a personality change is requested. At present, personality changes affect only
   // pf_num=2 and pf_num=3. These two PFs are designated as storage functions. 
   typedef struct _BE_RESOURCES_PCIE_V1 {
      UEXACT8 pf_num;
      UEXACT8 pf_state;
      UEXACT8 pf_type;
      UEXACT8 rsvd0;
      UEXACT32 valid_fields;
      UEXACT8 sriov_state;
      UEXACT8 rsvd1;
      UEXACT16 msix_vectors;
      UEXACT16 number_of_vf;
      UEXACT8 msix_per_vf;
      UEXACT8 rsvd2;
      UEXACT32 port_num;
      UEXACT8 link_status;
      UEXACT8 rsvd3[43];
   } SG_PACK BE_RESOURCES_PCIE_V1, *PBE_RESOURCES_PCIE_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_NIC_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 mac_unicast_count;
      UEXACT8 nic_mac_address_start[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd1;
      UEXACT16 vlan_count;
      UEXACT16 mac_mcast_count;
      UEXACT16 tx_queue_count;
      UEXACT16 rx_queue_count;
      UEXACT16 rss_queue_count;
      UEXACT16 lro_queue_count;
      UEXACT16 cq_count;
      UEXACT16 toe_connection_count;
      UEXACT8 bw_percent;
      UEXACT8 rsvd2;
      UEXACT16 vlan_id;
      UEXACT8 rsvd3[26];
   } SG_PACK BE_RESOURCES_NIC_V1, *PBE_RESOURCES_NIC_V1;



#else
   
   typedef struct _BE_RESOURCES_NIC_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 mac_unicast_count;
      UEXACT8 nic_mac_address_start[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 rsvd1;
      UEXACT16 vlan_count;
      UEXACT16 mac_mcast_count;
      UEXACT16 tx_queue_count;
      UEXACT16 rx_queue_count;
      UEXACT16 rss_queue_count;
      UEXACT16 lro_queue_count;
      UEXACT16 cq_count;
      UEXACT16 toe_connection_count;
      UEXACT8 bw_percent;
      UEXACT8 rsvd2;
      UEXACT16 vlan_id;
      UEXACT8 rsvd3[26];
   } SG_PACK BE_RESOURCES_NIC_V1, *PBE_RESOURCES_NIC_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_ISCSI_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 session_count;
      UEXACT16 icd_count;
      UEXACT16 cq_count;
      UEXACT8 iscsi_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 bw_percent;
      UEXACT16 vlan_id;
      UEXACT8 rsvd1[40];
   } SG_PACK BE_RESOURCES_ISCSI_V1, *PBE_RESOURCES_ISCSI_V1;



#else
   
   typedef struct _BE_RESOURCES_ISCSI_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 session_count;
      UEXACT16 icd_count;
      UEXACT16 cq_count;
      UEXACT8 iscsi_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 bw_percent;
      UEXACT16 vlan_id;
      UEXACT8 rsvd1[40];
   } SG_PACK BE_RESOURCES_ISCSI_V1, *PBE_RESOURCES_ISCSI_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_FCOE_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 login_count;
      UEXACT16 xri_count;
      UEXACT16 wq_count;
      UEXACT16 rq_count;
      UEXACT16 cq_count;
      UEXACT16 vpi_count;
      UEXACT16 max_fcf_count;
      UEXACT16 max_vfi_count;
      UEXACT8 wwn[16];
      UEXACT8 fcoe_fip_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 bw_percent;
      UEXACT16 vlan_id;
      UEXACT8 rsvd1[14];
   } SG_PACK BE_RESOURCES_FCOE_V1, *PBE_RESOURCES_FCOE_V1;



#else
   
   typedef struct _BE_RESOURCES_FCOE_V1 {
      UEXACT8 pf_num;
      UEXACT8 vf_domain;
      UEXACT16 rsvd0;
      UEXACT32 valid_fields;
      UEXACT16 login_count;
      UEXACT16 xri_count;
      UEXACT16 wq_count;
      UEXACT16 rq_count;
      UEXACT16 cq_count;
      UEXACT16 vpi_count;
      UEXACT16 max_fcf_count;
      UEXACT16 max_vfi_count;
      UEXACT8 wwn[16];
      UEXACT8 fcoe_fip_mac_address[6];
      UEXACT8 mcc_queue_count;
      UEXACT8 bw_percent;
      UEXACT16 vlan_id;
      UEXACT8 rsvd1[14];
   } SG_PACK BE_RESOURCES_FCOE_V1, *PBE_RESOURCES_FCOE_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _BE_RESOURCES_RDMA_V1 {
      UEXACT32 valid_fields;
      UEXACT8 rsvd0[60];
   } SG_PACK BE_RESOURCES_RDMA_V1, *PBE_RESOURCES_RDMA_V1;



#else
   
   typedef struct _BE_RESOURCES_RDMA_V1 {
      UEXACT32 valid_fields;
      UEXACT8 rsvd0[60];
   } SG_PACK BE_RESOURCES_RDMA_V1, *PBE_RESOURCES_RDMA_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESOURCE_DESC_V1 {
         union {
            union { 
               BE_RESOURCES_PCIE_V1 pci_resources;
               BE_RESOURCES_NIC_V1 nic_resources;
               BE_RESOURCES_ISCSI_V1 iscsi_resources;
               BE_RESOURCES_FCOE_V1 fcoe_resources;
               BE_RESOURCES_RDMA_V1 rdma_resources;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK RESOURCE_DESC_V1, *PRESOURCE_DESC_V1;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_V1, sizeof (RESOURCE_DESC_V1) == 64);

   #else
      typedef union _RESOURCE_DESC_V1 {
         BE_RESOURCES_PCIE_V1 pci_resources;
         BE_RESOURCES_NIC_V1 nic_resources;
         BE_RESOURCES_ISCSI_V1 iscsi_resources;
         BE_RESOURCES_FCOE_V1 fcoe_resources;
         BE_RESOURCES_RDMA_V1 rdma_resources;
      } SG_PACK RESOURCE_DESC_V1, *PRESOURCE_DESC_V1;

      typedef union _RESOURCE_DESC_V1_UNION {
         RESOURCE_DESC_V1 bits;
         u32 dw[16]; // dword union
      } SG_PACK RESOURCE_DESC_V1_UNION, *PRESOURCE_DESC_V1_UNION;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_V1_UNION, sizeof (RESOURCE_DESC_V1_UNION) == 64);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESOURCE_DESC_V1 {
         union {
            union { 
               BE_RESOURCES_PCIE_V1 pci_resources;
               BE_RESOURCES_NIC_V1 nic_resources;
               BE_RESOURCES_ISCSI_V1 iscsi_resources;
               BE_RESOURCES_FCOE_V1 fcoe_resources;
               BE_RESOURCES_RDMA_V1 rdma_resources;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK RESOURCE_DESC_V1, *PRESOURCE_DESC_V1;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_V1, sizeof (RESOURCE_DESC_V1) == 64);

   #else
      typedef union _RESOURCE_DESC_V1 {
         BE_RESOURCES_PCIE_V1 pci_resources;
         BE_RESOURCES_NIC_V1 nic_resources;
         BE_RESOURCES_ISCSI_V1 iscsi_resources;
         BE_RESOURCES_FCOE_V1 fcoe_resources;
         BE_RESOURCES_RDMA_V1 rdma_resources;
      } SG_PACK RESOURCE_DESC_V1, *PRESOURCE_DESC_V1;

      typedef union _RESOURCE_DESC_V1_UNION {
         RESOURCE_DESC_V1 bits;
         u32 dw[16]; // dword union
      } SG_PACK RESOURCE_DESC_V1_UNION, *PRESOURCE_DESC_V1_UNION;

      SG_C_ASSERT(__sizeof__RESOURCE_DESC_V1_UNION, sizeof (RESOURCE_DESC_V1_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // During a personality-change request, only BE_RESOURCES_PCIE is relevant; aLL other
   // resource types in this IOCTL will be ignored. 
   typedef struct _BE_RESOURCES_V1 {
      UEXACT8 resource_type;
      UEXACT8 rsvd0[3];
      RESOURCE_DESC_V1 resource_descriptor;
   } SG_PACK BE_RESOURCES_V1, *PBE_RESOURCES_V1;



#else
   // During a personality-change request, only BE_RESOURCES_PCIE is relevant; aLL other
   // resource types in this IOCTL will be ignored. 
   typedef struct _BE_RESOURCES_V1 {
      UEXACT8 resource_type;
      UEXACT8 rsvd0[3];
      RESOURCE_DESC_V1 resource_descriptor;
   } SG_PACK BE_RESOURCES_V1, *PBE_RESOURCES_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1) == 4);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         UEXACT32 rsvd0;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 bits;
         u32 dw; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1) == 4);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         UEXACT32 rsvd0;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 bits;
         u32 dw; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES_V1 be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1) == 72);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES_V1 be_resources[1];
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES_V1 be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1) == 72);

   #else
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES_V1 be_resources[1];
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         union {
            union { 
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1) == 72);

   #else
      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         union {
            union { 
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
               GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1) == 72);

   #else
      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      typedef union _GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION {
         GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION;

      SG_C_ASSERT(__sizeof__GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, sizeof (GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   //   - Lists the physical functions enabled/disabled  - Lists the virtual functions
   // enabled (if any), per physical function  - Lists the per function resources based on
   // whether the function is NIC, iSCSI, FCoE or RDMA 
   typedef struct _IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1 {
      IOCTL_HEADER header;
      GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 params;
   } SG_PACK IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1;



#else
   //   - Lists the physical functions enabled/disabled  - Lists the virtual functions
   // enabled (if any), per physical function  - Lists the per function resources based on
   // whether the function is NIC, iSCSI, FCoE or RDMA 
   typedef struct _IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1 {
      IOCTL_HEADER header;
      GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 params;
   } SG_PACK IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES_V1 be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1) == 72);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES_V1 be_resources[1];
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         union {
            struct { 
               UEXACT32 resource_descriptor_count;
               BE_RESOURCES_V1 be_resources[1];
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1) == 72);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 {
         UEXACT32 resource_descriptor_count;
         BE_RESOURCES_V1 be_resources[1];
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1) == 4);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         UEXACT32 rsvd0;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 bits;
         u32 dw; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1) == 4);

   #else
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 {
         UEXACT32 rsvd0;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 bits;
         u32 dw; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         union {
            union { 
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1) == 72);

   #else
      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         union {
            union { 
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
               SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1) == 72);

   #else
      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1 request;
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1 response;
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1;

      typedef union _SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION {
         SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 bits;
         u32 dw[18]; // dword union
      } SG_PACK SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION;

      SG_C_ASSERT(__sizeof__SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION, sizeof (SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be used for any/all of the following.  - Enable/disable BE physical
   // functions  - Change the board personality by reassigning select PCI functions from
   // NIC<->iSCSI<->FCoE. The success of personality changes depends on modes enabled on
   // the Personality Management Word (PMW) stored on the SEEPROM on that board.  - Set
   // the per-function resources based on whether the function is NIC, iSCSI, FCoE or RDMA
   //  - Set the virtual functions enabled (if any), per-physical function Use the
   // corresponding valid_fields bitmap to indicate which fields will be changed and which
   // will be left unchanged. If a field has never been set (by a previous call to this
   // IOCTL), then the default values are used. In the case of MAC address, for example,
   // the default value are obtained from SEEPROM.  This IOCTL may return the following
   // status values  - MGMT_STATUS_SUCCESS - The requested resource changes were applied. 
   // - MGMT_STATUS_REBOOT_REQUIRED - The personality change requested, has been accepted.
   // The system must be rebooted for these changes to take effect.  -
   // MGMT_STATUS_PERSONALITY_CHANGE_FAILED - In this case the following additional status
   // values apply  - MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF - The
   // functions assigned to the requested PFs cannot be changed. Check PF#s in the IOCTL
   // request.  - MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE - The PCI ID combination
   // did not match any entry in our table.  -
   // MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED - The PMW for this board does not
   // support a personality change. 
   typedef struct _IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1 {
      IOCTL_HEADER header;
      SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 params;
   } SG_PACK IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1;



#else
   // This IOCTL may be used for any/all of the following.  - Enable/disable BE physical
   // functions  - Change the board personality by reassigning select PCI functions from
   // NIC<->iSCSI<->FCoE. The success of personality changes depends on modes enabled on
   // the Personality Management Word (PMW) stored on the SEEPROM on that board.  - Set
   // the per-function resources based on whether the function is NIC, iSCSI, FCoE or RDMA
   //  - Set the virtual functions enabled (if any), per-physical function Use the
   // corresponding valid_fields bitmap to indicate which fields will be changed and which
   // will be left unchanged. If a field has never been set (by a previous call to this
   // IOCTL), then the default values are used. In the case of MAC address, for example,
   // the default value are obtained from SEEPROM.  This IOCTL may return the following
   // status values  - MGMT_STATUS_SUCCESS - The requested resource changes were applied. 
   // - MGMT_STATUS_REBOOT_REQUIRED - The personality change requested, has been accepted.
   // The system must be rebooted for these changes to take effect.  -
   // MGMT_STATUS_PERSONALITY_CHANGE_FAILED - In this case the following additional status
   // values apply  - MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF - The
   // functions assigned to the requested PFs cannot be changed. Check PF#s in the IOCTL
   // request.  - MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE - The PCI ID combination
   // did not match any entry in our table.  -
   // MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED - The PMW for this board does not
   // support a personality change. 
   typedef struct _IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1 {
      IOCTL_HEADER header;
      SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1 params;
   } SG_PACK IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CAPABILITY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 capabilities;
                  UEXACT32 switch_type;
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CAPABILITY_PARAMS, sizeof (IOCTL_COMMON_GET_CAPABILITY_PARAMS) == 12);

   #else
      typedef union _IOCTL_COMMON_GET_CAPABILITY_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 capabilities;
            UEXACT32 switch_type;
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS;

      typedef union _IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION {
         IOCTL_COMMON_GET_CAPABILITY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION) == 12);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_CAPABILITY_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 capabilities;
                  UEXACT32 switch_type;
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[3]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CAPABILITY_PARAMS, sizeof (IOCTL_COMMON_GET_CAPABILITY_PARAMS) == 12);

   #else
      typedef union _IOCTL_COMMON_GET_CAPABILITY_PARAMS {
         struct {
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 capabilities;
            UEXACT32 switch_type;
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS;

      typedef union _IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION {
         IOCTL_COMMON_GET_CAPABILITY_PARAMS bits;
         u32 dw[3]; // dword union
      } SG_PACK IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_CAPABILITY_PARAMS_UNION) == 12);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows the caller to query the capabilities and switch type. 
   typedef struct _IOCTL_COMMON_GET_CAPABILITY {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_CAPABILITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CAPABILITY, *PIOCTL_COMMON_GET_CAPABILITY;



#else
   // This IOCTL allows the caller to query the capabilities and switch type. 
   typedef struct _IOCTL_COMMON_GET_CAPABILITY {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_CAPABILITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CAPABILITY, *PIOCTL_COMMON_GET_CAPABILITY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 switch_type;
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, sizeof (IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS {
         struct {
            UEXACT32 switch_type;
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS;

      typedef union _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION {
         IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS {
         union {
            union { 
               struct {
                  UEXACT32 switch_type;
                  UEXACT32 rsvd0;
               } request;
               struct {
                  UEXACT32 rsvd0;
               } response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, sizeof (IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS) == 8);

   #else
      typedef union _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS {
         struct {
            UEXACT32 switch_type;
            UEXACT32 rsvd0;
         } request;
         struct {
            UEXACT32 rsvd0;
         } response;
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS;

      typedef union _IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION {
         IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL allows the user to set the switch type. 
   typedef struct _IOCTL_COMMON_SET_SWITCH_TYPE {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE, *PIOCTL_COMMON_SET_SWITCH_TYPE;



#else
   // This IOCTL allows the user to set the switch type. 
   typedef struct _IOCTL_COMMON_SET_SWITCH_TYPE {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_SWITCH_TYPE, *PIOCTL_COMMON_SET_SWITCH_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN, *PGET_TX_THROTTLE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_IN, sizeof (GET_TX_THROTTLE_PARAMS_IN) == 4);

   #else
      typedef struct _GET_TX_THROTTLE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN, *PGET_TX_THROTTLE_PARAMS_IN;

      typedef union _GET_TX_THROTTLE_PARAMS_IN_UNION {
         GET_TX_THROTTLE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN_UNION, *PGET_TX_THROTTLE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_IN_UNION, sizeof (GET_TX_THROTTLE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN, *PGET_TX_THROTTLE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_IN, sizeof (GET_TX_THROTTLE_PARAMS_IN) == 4);

   #else
      typedef struct _GET_TX_THROTTLE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN, *PGET_TX_THROTTLE_PARAMS_IN;

      typedef union _GET_TX_THROTTLE_PARAMS_IN_UNION {
         GET_TX_THROTTLE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_IN_UNION, *PGET_TX_THROTTLE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_IN_UNION, sizeof (GET_TX_THROTTLE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 tx_throttle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT, *PGET_TX_THROTTLE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_OUT, sizeof (GET_TX_THROTTLE_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_TX_THROTTLE_PARAMS_OUT {
         UEXACT32 tx_throttle;
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT, *PGET_TX_THROTTLE_PARAMS_OUT;

      typedef union _GET_TX_THROTTLE_PARAMS_OUT_UNION {
         GET_TX_THROTTLE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT_UNION, *PGET_TX_THROTTLE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_OUT_UNION, sizeof (GET_TX_THROTTLE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 tx_throttle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT, *PGET_TX_THROTTLE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_OUT, sizeof (GET_TX_THROTTLE_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_TX_THROTTLE_PARAMS_OUT {
         UEXACT32 tx_throttle;
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT, *PGET_TX_THROTTLE_PARAMS_OUT;

      typedef union _GET_TX_THROTTLE_PARAMS_OUT_UNION {
         GET_TX_THROTTLE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_OUT_UNION, *PGET_TX_THROTTLE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_OUT_UNION, sizeof (GET_TX_THROTTLE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS {
         union {
            union { 
               GET_TX_THROTTLE_PARAMS_IN request;
               GET_TX_THROTTLE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS, *PGET_TX_THROTTLE_PARAMS;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS, sizeof (GET_TX_THROTTLE_PARAMS) == 4);

   #else
      typedef union _GET_TX_THROTTLE_PARAMS {
         GET_TX_THROTTLE_PARAMS_IN request;
         GET_TX_THROTTLE_PARAMS_OUT response;
      } SG_PACK GET_TX_THROTTLE_PARAMS, *PGET_TX_THROTTLE_PARAMS;

      typedef union _GET_TX_THROTTLE_PARAMS_UNION {
         GET_TX_THROTTLE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_UNION, *PGET_TX_THROTTLE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_UNION, sizeof (GET_TX_THROTTLE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_TX_THROTTLE_PARAMS {
         union {
            union { 
               GET_TX_THROTTLE_PARAMS_IN request;
               GET_TX_THROTTLE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_TX_THROTTLE_PARAMS, *PGET_TX_THROTTLE_PARAMS;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS, sizeof (GET_TX_THROTTLE_PARAMS) == 4);

   #else
      typedef union _GET_TX_THROTTLE_PARAMS {
         GET_TX_THROTTLE_PARAMS_IN request;
         GET_TX_THROTTLE_PARAMS_OUT response;
      } SG_PACK GET_TX_THROTTLE_PARAMS, *PGET_TX_THROTTLE_PARAMS;

      typedef union _GET_TX_THROTTLE_PARAMS_UNION {
         GET_TX_THROTTLE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_TX_THROTTLE_PARAMS_UNION, *PGET_TX_THROTTLE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_TX_THROTTLE_PARAMS_UNION, sizeof (GET_TX_THROTTLE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // It is applicable to BE2 cards only. This IOCTL is used to obtain the current Tx
   // Throttle setting for the requested port on the card. This IOCTL may return the
   // following status values  - MGMT_STATUS_SUCCESS - The requested tx throttle setting
   // was returned correctly.  - MGMT_STATUS_INSUFFICIENT_BUFFER - The buffer size in the
   // IOCTL is insufficient to return the current tx throttle setting. 
   typedef struct _IOCTL_COMMON_GET_TX_THROTTLE {
      IOCTL_HEADER header;
      GET_TX_THROTTLE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_TX_THROTTLE, *PIOCTL_COMMON_GET_TX_THROTTLE;



#else
   // It is applicable to BE2 cards only. This IOCTL is used to obtain the current Tx
   // Throttle setting for the requested port on the card. This IOCTL may return the
   // following status values  - MGMT_STATUS_SUCCESS - The requested tx throttle setting
   // was returned correctly.  - MGMT_STATUS_INSUFFICIENT_BUFFER - The buffer size in the
   // IOCTL is insufficient to return the current tx throttle setting. 
   typedef struct _IOCTL_COMMON_GET_TX_THROTTLE {
      IOCTL_HEADER header;
      GET_TX_THROTTLE_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_TX_THROTTLE, *PIOCTL_COMMON_GET_TX_THROTTLE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tx_throttle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN, *PSET_TX_THROTTLE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_IN, sizeof (SET_TX_THROTTLE_PARAMS_IN) == 4);

   #else
      typedef struct _SET_TX_THROTTLE_PARAMS_IN {
         UEXACT32 tx_throttle;
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN, *PSET_TX_THROTTLE_PARAMS_IN;

      typedef union _SET_TX_THROTTLE_PARAMS_IN_UNION {
         SET_TX_THROTTLE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN_UNION, *PSET_TX_THROTTLE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_IN_UNION, sizeof (SET_TX_THROTTLE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 tx_throttle;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN, *PSET_TX_THROTTLE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_IN, sizeof (SET_TX_THROTTLE_PARAMS_IN) == 4);

   #else
      typedef struct _SET_TX_THROTTLE_PARAMS_IN {
         UEXACT32 tx_throttle;
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN, *PSET_TX_THROTTLE_PARAMS_IN;

      typedef union _SET_TX_THROTTLE_PARAMS_IN_UNION {
         SET_TX_THROTTLE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_IN_UNION, *PSET_TX_THROTTLE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_IN_UNION, sizeof (SET_TX_THROTTLE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT, *PSET_TX_THROTTLE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_OUT, sizeof (SET_TX_THROTTLE_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_TX_THROTTLE_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT, *PSET_TX_THROTTLE_PARAMS_OUT;

      typedef union _SET_TX_THROTTLE_PARAMS_OUT_UNION {
         SET_TX_THROTTLE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT_UNION, *PSET_TX_THROTTLE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_OUT_UNION, sizeof (SET_TX_THROTTLE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT, *PSET_TX_THROTTLE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_OUT, sizeof (SET_TX_THROTTLE_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_TX_THROTTLE_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT, *PSET_TX_THROTTLE_PARAMS_OUT;

      typedef union _SET_TX_THROTTLE_PARAMS_OUT_UNION {
         SET_TX_THROTTLE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_OUT_UNION, *PSET_TX_THROTTLE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_OUT_UNION, sizeof (SET_TX_THROTTLE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS {
         union {
            union { 
               SET_TX_THROTTLE_PARAMS_IN request;
               SET_TX_THROTTLE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS, *PSET_TX_THROTTLE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS, sizeof (SET_TX_THROTTLE_PARAMS) == 4);

   #else
      typedef union _SET_TX_THROTTLE_PARAMS {
         SET_TX_THROTTLE_PARAMS_IN request;
         SET_TX_THROTTLE_PARAMS_OUT response;
      } SG_PACK SET_TX_THROTTLE_PARAMS, *PSET_TX_THROTTLE_PARAMS;

      typedef union _SET_TX_THROTTLE_PARAMS_UNION {
         SET_TX_THROTTLE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_UNION, *PSET_TX_THROTTLE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_UNION, sizeof (SET_TX_THROTTLE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_TX_THROTTLE_PARAMS {
         union {
            union { 
               SET_TX_THROTTLE_PARAMS_IN request;
               SET_TX_THROTTLE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_TX_THROTTLE_PARAMS, *PSET_TX_THROTTLE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS, sizeof (SET_TX_THROTTLE_PARAMS) == 4);

   #else
      typedef union _SET_TX_THROTTLE_PARAMS {
         SET_TX_THROTTLE_PARAMS_IN request;
         SET_TX_THROTTLE_PARAMS_OUT response;
      } SG_PACK SET_TX_THROTTLE_PARAMS, *PSET_TX_THROTTLE_PARAMS;

      typedef union _SET_TX_THROTTLE_PARAMS_UNION {
         SET_TX_THROTTLE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK SET_TX_THROTTLE_PARAMS_UNION, *PSET_TX_THROTTLE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_TX_THROTTLE_PARAMS_UNION, sizeof (SET_TX_THROTTLE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // It is applicable to BE2 cards only. This IOCTL is used to program the Tx Throttle
   // setting for the requested port on the card. This IOCTL may return the following
   // status values  - MGMT_STATUS_SUCCESS - The requested tx throttle setting was applied
   // successfully.  - MGMT_STATUS_ILLEGAL_FIELD - The requested tx throttle setting to be
   // applied is invalid 
   typedef struct _IOCTL_COMMON_SET_TX_THROTTLE {
      IOCTL_HEADER header;
      SET_TX_THROTTLE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_TX_THROTTLE, *PIOCTL_COMMON_SET_TX_THROTTLE;



#else
   // It is applicable to BE2 cards only. This IOCTL is used to program the Tx Throttle
   // setting for the requested port on the card. This IOCTL may return the following
   // status values  - MGMT_STATUS_SUCCESS - The requested tx throttle setting was applied
   // successfully.  - MGMT_STATUS_ILLEGAL_FIELD - The requested tx throttle setting to be
   // applied is invalid 
   typedef struct _IOCTL_COMMON_SET_TX_THROTTLE {
      IOCTL_HEADER header;
      SET_TX_THROTTLE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_TX_THROTTLE, *PIOCTL_COMMON_SET_TX_THROTTLE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 function_assignment[32];
               UEXACT32 expansion_ROM_enabled;
               UEXACT8 port_function_map[32];
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT) == 68);

   #else
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT {
         UEXACT8 function_assignment[32];
         UEXACT32 expansion_ROM_enabled;
         UEXACT8 port_function_map[32];
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT bits;
         u32 dw[17]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION) == 68);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 function_assignment[32];
               UEXACT32 expansion_ROM_enabled;
               UEXACT8 port_function_map[32];
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT) == 68);

   #else
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT {
         UEXACT8 function_assignment[32];
         UEXACT32 expansion_ROM_enabled;
         UEXACT8 port_function_map[32];
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT bits;
         u32 dw[17]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN request;
               IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS) == 68);

   #else
      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN request;
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS bits;
         u32 dw[17]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION) == 68);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN request;
               IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[17]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS) == 68);

   #else
      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN request;
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS;

      typedef union _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION {
         IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS bits;
         u32 dw[17]; // dword union
      } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_UNION) == 68);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL is used by the BE expansion ROM software to determine whether, or not,
   // expansion BIOS was enabled on a given PCI function. This information cannot be
   // determined at run time by the BIOS code since motherboard BIOS may have disabled the
   // expansion ROM space after shadowing is complete. The other fields are used by the
   // PXESelect/iSCSI Select utilities for display purposes.  This IOCTL always returns
   // MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING;



#else
   // This IOCTL is used by the BE expansion ROM software to determine whether, or not,
   // expansion BIOS was enabled on a given PCI function. This information cannot be
   // determined at run time by the BIOS code since motherboard BIOS may have disabled the
   // expansion ROM space after shadowing is complete. The other fields are used by the
   // PXESelect/iSCSI Select utilities for display purposes.  This IOCTL always returns
   // MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN;

      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN;

      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT {
      UEXACT8 personality_change_status;
   } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT;



#else
   
   typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT {
      UEXACT8 personality_change_status;
   } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN request;
               IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN request;
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS;

      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS {
         union {
            union { 
               IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN request;
               IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS) == 4);

   #else
      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN request;
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS;

      typedef union _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION {
         IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION, sizeof (IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Lets the caller know whether a system reboot is required to enforce a 'personality
   // change'. This IOCTL should be issued by all BladeEngine expansion ROMs. If the
   // response is PERSONALITY_CHANGED_REBOOT_REQUIRED then the expansion BIOS code should
   // put up an appropriate message for the user and reboot the system after an
   // appropriate delay.  This IOCTL always returns MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE {
      IOCTL_HEADER header;
      IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS params;
   } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE;



#else
   // Lets the caller know whether a system reboot is required to enforce a 'personality
   // change'. This IOCTL should be issued by all BladeEngine expansion ROMs. If the
   // response is PERSONALITY_CHANGED_REBOOT_REQUIRED then the expansion BIOS code should
   // put up an appropriate message for the user and reboot the system after an
   // appropriate delay.  This IOCTL always returns MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_QUERY_PERSONALITY_CHANGE {
      IOCTL_HEADER header;
      IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS params;
   } SG_PACK IOCTL_COMMON_QUERY_PERSONALITY_CHANGE, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 chip_uid0;
               UEXACT32 chip_uid1;
               UEXACT32 rsvd0[4];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT) == 24);

   #else
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT {
         UEXACT32 chip_uid0;
         UEXACT32 chip_uid1;
         UEXACT32 rsvd0[4];
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 chip_uid0;
               UEXACT32 chip_uid1;
               UEXACT32 rsvd0[4];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT) == 24);

   #else
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT {
         UEXACT32 chip_uid0;
         UEXACT32 chip_uid1;
         UEXACT32 rsvd0[4];
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS {
         union {
            union { 
               IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN request;
               IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN request;
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS {
         union {
            union { 
               IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN request;
               IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS) == 24);

   #else
      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN request;
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS;

      typedef union _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION {
         IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION, sizeof (IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Retrieves the unique serial number assigned to each BladeEngine at manufacturing.
   // This IOCTL always returns MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER {
      IOCTL_HEADER header;
      IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS params;
   } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER;



#else
   // Retrieves the unique serial number assigned to each BladeEngine at manufacturing.
   // This IOCTL always returns MGMT_STATUS_SUCCESS. 
   typedef struct _IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER {
      IOCTL_HEADER header;
      IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS params;
   } SG_PACK IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NEMO_DYNAMIC_CONFIG {
         union {
            struct { 
               UEXACT32 magic;
               UEXACT8 valid;
               UEXACT8 port0_mac[6];
               UEXACT8 enable_port0_wol;
               UEXACT8 port1_mac[6];
               UEXACT8 enable_port1_wol;
               UEXACT8 rsvd0;
               UEXACT16 default_vlanid;
               UEXACT8 rsvd1[2];
               UEXACT32 rsvd2[2];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK NEMO_DYNAMIC_CONFIG, *PNEMO_DYNAMIC_CONFIG;

      SG_C_ASSERT(__sizeof__NEMO_DYNAMIC_CONFIG, sizeof (NEMO_DYNAMIC_CONFIG) == 32);

   #else
      typedef struct _NEMO_DYNAMIC_CONFIG {
         UEXACT32 magic;
         UEXACT8 valid;
         UEXACT8 port0_mac[6];
         UEXACT8 enable_port0_wol;
         UEXACT8 port1_mac[6];
         UEXACT8 enable_port1_wol;
         UEXACT8 rsvd0;
         UEXACT16 default_vlanid;
         UEXACT8 rsvd1[2];
         UEXACT32 rsvd2[2];
      } SG_PACK NEMO_DYNAMIC_CONFIG, *PNEMO_DYNAMIC_CONFIG;

      typedef union _NEMO_DYNAMIC_CONFIG_UNION {
         NEMO_DYNAMIC_CONFIG bits;
         u32 dw[8]; // dword union
      } SG_PACK NEMO_DYNAMIC_CONFIG_UNION, *PNEMO_DYNAMIC_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__NEMO_DYNAMIC_CONFIG_UNION, sizeof (NEMO_DYNAMIC_CONFIG_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NEMO_DYNAMIC_CONFIG {
         union {
            struct { 
               UEXACT32 magic;
               UEXACT8 valid;
               UEXACT8 port0_mac[6];
               UEXACT8 enable_port0_wol;
               UEXACT8 port1_mac[6];
               UEXACT8 enable_port1_wol;
               UEXACT8 rsvd0;
               UEXACT16 default_vlanid;
               UEXACT8 rsvd1[2];
               UEXACT32 rsvd2[2];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK NEMO_DYNAMIC_CONFIG, *PNEMO_DYNAMIC_CONFIG;

      SG_C_ASSERT(__sizeof__NEMO_DYNAMIC_CONFIG, sizeof (NEMO_DYNAMIC_CONFIG) == 32);

   #else
      typedef struct _NEMO_DYNAMIC_CONFIG {
         UEXACT32 magic;
         UEXACT8 valid;
         UEXACT8 port0_mac[6];
         UEXACT8 enable_port0_wol;
         UEXACT8 port1_mac[6];
         UEXACT8 enable_port1_wol;
         UEXACT8 rsvd0;
         UEXACT16 default_vlanid;
         UEXACT8 rsvd1[2];
         UEXACT32 rsvd2[2];
      } SG_PACK NEMO_DYNAMIC_CONFIG, *PNEMO_DYNAMIC_CONFIG;

      typedef union _NEMO_DYNAMIC_CONFIG_UNION {
         NEMO_DYNAMIC_CONFIG bits;
         u32 dw[8]; // dword union
      } SG_PACK NEMO_DYNAMIC_CONFIG_UNION, *PNEMO_DYNAMIC_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__NEMO_DYNAMIC_CONFIG_UNION, sizeof (NEMO_DYNAMIC_CONFIG_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NEMO_STATIC_CONFIG {
         union {
            struct { 
               UEXACT32 magic;
               UEXACT8 port_swap;
               UEXACT8 port0_mac[6];
               UEXACT8 enable_port0_wol;
               UEXACT8 port1_mac[6];
               UEXACT8 enable_port1_wol;
               UEXACT8 rsvd0;
               UEXACT16 default_vlanid;
               UEXACT8 rsvd1[2];
               UEXACT32 rsvd2[2];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK NEMO_STATIC_CONFIG, *PNEMO_STATIC_CONFIG;

      SG_C_ASSERT(__sizeof__NEMO_STATIC_CONFIG, sizeof (NEMO_STATIC_CONFIG) == 32);

   #else
      typedef struct _NEMO_STATIC_CONFIG {
         UEXACT32 magic;
         UEXACT8 port_swap;
         UEXACT8 port0_mac[6];
         UEXACT8 enable_port0_wol;
         UEXACT8 port1_mac[6];
         UEXACT8 enable_port1_wol;
         UEXACT8 rsvd0;
         UEXACT16 default_vlanid;
         UEXACT8 rsvd1[2];
         UEXACT32 rsvd2[2];
      } SG_PACK NEMO_STATIC_CONFIG, *PNEMO_STATIC_CONFIG;

      typedef union _NEMO_STATIC_CONFIG_UNION {
         NEMO_STATIC_CONFIG bits;
         u32 dw[8]; // dword union
      } SG_PACK NEMO_STATIC_CONFIG_UNION, *PNEMO_STATIC_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__NEMO_STATIC_CONFIG_UNION, sizeof (NEMO_STATIC_CONFIG_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _NEMO_STATIC_CONFIG {
         union {
            struct { 
               UEXACT32 magic;
               UEXACT8 port_swap;
               UEXACT8 port0_mac[6];
               UEXACT8 enable_port0_wol;
               UEXACT8 port1_mac[6];
               UEXACT8 enable_port1_wol;
               UEXACT8 rsvd0;
               UEXACT16 default_vlanid;
               UEXACT8 rsvd1[2];
               UEXACT32 rsvd2[2];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK NEMO_STATIC_CONFIG, *PNEMO_STATIC_CONFIG;

      SG_C_ASSERT(__sizeof__NEMO_STATIC_CONFIG, sizeof (NEMO_STATIC_CONFIG) == 32);

   #else
      typedef struct _NEMO_STATIC_CONFIG {
         UEXACT32 magic;
         UEXACT8 port_swap;
         UEXACT8 port0_mac[6];
         UEXACT8 enable_port0_wol;
         UEXACT8 port1_mac[6];
         UEXACT8 enable_port1_wol;
         UEXACT8 rsvd0;
         UEXACT16 default_vlanid;
         UEXACT8 rsvd1[2];
         UEXACT32 rsvd2[2];
      } SG_PACK NEMO_STATIC_CONFIG, *PNEMO_STATIC_CONFIG;

      typedef union _NEMO_STATIC_CONFIG_UNION {
         NEMO_STATIC_CONFIG bits;
         u32 dw[8]; // dword union
      } SG_PACK NEMO_STATIC_CONFIG_UNION, *PNEMO_STATIC_CONFIG_UNION;

      SG_C_ASSERT(__sizeof__NEMO_STATIC_CONFIG_UNION, sizeof (NEMO_STATIC_CONFIG_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN) == 4);

   #else
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 ncsi_state;
               UEXACT8 ncsi_handshake_status;
               UEXACT8 rsvd0[2];
               UEXACT32 rsvd1;
               NEMO_STATIC_CONFIG nemo_static_cfg;
               NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT) == 72);

   #else
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT {
         UEXACT8 ncsi_state;
         UEXACT8 ncsi_handshake_status;
         UEXACT8 rsvd0[2];
         UEXACT32 rsvd1;
         NEMO_STATIC_CONFIG nemo_static_cfg;
         NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 ncsi_state;
               UEXACT8 ncsi_handshake_status;
               UEXACT8 rsvd0[2];
               UEXACT32 rsvd1;
               NEMO_STATIC_CONFIG nemo_static_cfg;
               NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT) == 72);

   #else
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT {
         UEXACT8 ncsi_state;
         UEXACT8 ncsi_handshake_status;
         UEXACT8 rsvd0[2];
         UEXACT32 rsvd1;
         NEMO_STATIC_CONFIG nemo_static_cfg;
         NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT bits;
         u32 dw[18]; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN request;
               IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS) == 72);

   #else
      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN request;
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION) == 72);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS {
         union {
            union { 
               IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN request;
               IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[18]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS) == 72);

   #else
      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN request;
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS;

      typedef union _IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION {
         IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS bits;
         u32 dw[18]; // dword union
      } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION, sizeof (IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_UNION) == 72);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The SEEPROM has a bit indicating whether the BE2 HBA has NCSI support. When present
   // the ARM firmware has a handshake with the 8051 processor to determine whether a part
   // of the RXF initialization is completed by Nemo (NCSI FPGA) for supporting SOL and
   // WOL in the D3 state.  This IOCTL always returns MGMT_STATUS_SUCCESS. Check the
   // ncsi_state field to determine whether the static and dynamic configuration data
   // returned is valid. 
   typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION;



#else
   // The SEEPROM has a bit indicating whether the BE2 HBA has NCSI support. When present
   // the ARM firmware has a handshake with the 8051 processor to determine whether a part
   // of the RXF initialization is completed by Nemo (NCSI FPGA) for supporting SOL and
   // WOL in the D3 state.  This IOCTL always returns MGMT_STATUS_SUCCESS. Check the
   // ncsi_state field to determine whether the static and dynamic configuration data
   // returned is valid. 
   typedef struct _IOCTL_COMMON_GET_NCSI_CONFIGURATION {
      IOCTL_HEADER header;
      IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_NCSI_CONFIGURATION, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN {
         union {
            struct { 
               NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN) == 32);

   #else
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN {
         NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN {
         union {
            struct { 
               NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN) == 32);

   #else
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN {
         NEMO_DYNAMIC_CONFIG nemo_dynamic_cfg;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN bits;
         u32 dw[8]; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT) == 4);

   #else
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS {
         union {
            union { 
               IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN request;
               IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS) == 32);

   #else
      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN request;
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION) == 32);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS {
         union {
            union { 
               IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN request;
               IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS) == 32);

   #else
      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN request;
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT response;
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS;

      typedef union _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION {
         IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS bits;
         u32 dw[8]; // dword union
      } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION, sizeof (IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Set WOL and VLAN parameters used by the Nemo NCSI processor. Only the 'dynamic'
   // configuration data can be changed. The 'static' configuration data in the Nemo flash
   // is expected to be set at manufacturing. This IOCTL returns MGMT_STATUS_SUCCESS when
   // the ncsi_state is set to NCSI_STATE_ENABLED in IOCTL_COMMON_GET_NCSI_CONFIGURATION
   // otherwise it will return MGMT_STATUS_ILLEGAL_REQUEST 
   typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION;



#else
   // Set WOL and VLAN parameters used by the Nemo NCSI processor. Only the 'dynamic'
   // configuration data can be changed. The 'static' configuration data in the Nemo flash
   // is expected to be set at manufacturing. This IOCTL returns MGMT_STATUS_SUCCESS when
   // the ncsi_state is set to NCSI_STATE_ENABLED in IOCTL_COMMON_GET_NCSI_CONFIGURATION
   // otherwise it will return MGMT_STATUS_ILLEGAL_REQUEST 
   typedef struct _IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION {
      IOCTL_HEADER header;
      IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for incrementing the option_card_count and
   // recomputing the checksum field as it configures each card for sensor updates. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_BIOS_CFG {
         union {
            struct { 
               UEXACT32 version_num;
               UEXACT32 OCSD_buffer_size;
               UEXACT32 max_option_card_count;
               UEXACT32 option_card_and_sensor_size;
               UEXACT32 option_card_buffer_start;
               UEXACT32 rsvd0[3];
               UEXACT32 requested_update_interval;
               UEXACT32 rsvd1[5];
               UEXACT32 option_card_count;
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_BIOS_CFG, *PSENSOR_BIOS_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_BIOS_CFG, sizeof (SENSOR_BIOS_CFG) == 64);

   #else
      typedef struct _SENSOR_BIOS_CFG {
         UEXACT32 version_num;
         UEXACT32 OCSD_buffer_size;
         UEXACT32 max_option_card_count;
         UEXACT32 option_card_and_sensor_size;
         UEXACT32 option_card_buffer_start;
         UEXACT32 rsvd0[3];
         UEXACT32 requested_update_interval;
         UEXACT32 rsvd1[5];
         UEXACT32 option_card_count;
         UEXACT32 checksum;
      } SG_PACK SENSOR_BIOS_CFG, *PSENSOR_BIOS_CFG;

      typedef union _SENSOR_BIOS_CFG_UNION {
         SENSOR_BIOS_CFG bits;
         u32 dw[16]; // dword union
      } SG_PACK SENSOR_BIOS_CFG_UNION, *PSENSOR_BIOS_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_BIOS_CFG_UNION, sizeof (SENSOR_BIOS_CFG_UNION) == 64);
   #endif


#else
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for incrementing the option_card_count and
   // recomputing the checksum field as it configures each card for sensor updates. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_BIOS_CFG {
         union {
            struct { 
               UEXACT32 version_num;
               UEXACT32 OCSD_buffer_size;
               UEXACT32 max_option_card_count;
               UEXACT32 option_card_and_sensor_size;
               UEXACT32 option_card_buffer_start;
               UEXACT32 rsvd0[3];
               UEXACT32 requested_update_interval;
               UEXACT32 rsvd1[5];
               UEXACT32 option_card_count;
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_BIOS_CFG, *PSENSOR_BIOS_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_BIOS_CFG, sizeof (SENSOR_BIOS_CFG) == 64);

   #else
      typedef struct _SENSOR_BIOS_CFG {
         UEXACT32 version_num;
         UEXACT32 OCSD_buffer_size;
         UEXACT32 max_option_card_count;
         UEXACT32 option_card_and_sensor_size;
         UEXACT32 option_card_buffer_start;
         UEXACT32 rsvd0[3];
         UEXACT32 requested_update_interval;
         UEXACT32 rsvd1[5];
         UEXACT32 option_card_count;
         UEXACT32 checksum;
      } SG_PACK SENSOR_BIOS_CFG, *PSENSOR_BIOS_CFG;

      typedef union _SENSOR_BIOS_CFG_UNION {
         SENSOR_BIOS_CFG bits;
         u32 dw[16]; // dword union
      } SG_PACK SENSOR_BIOS_CFG_UNION, *PSENSOR_BIOS_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_BIOS_CFG_UNION, sizeof (SENSOR_BIOS_CFG_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for filling the pci_bus_num and
   // pci_device_num and recomputing the checksum field as it configures each card for
   // sensor updates. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_OPTIONROM_CFG {
         union {
            struct { 
               UEXACT32 version_num;
               UEXACT32 pci_bus_device_num;
               UEXACT32 rsvd0[3];
               UEXACT32 flags_capabilities;
               UEXACT32 vendor_defined;
               UEXACT32 rsvd1[8];
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_OPTIONROM_CFG, *PSENSOR_OPTIONROM_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_OPTIONROM_CFG, sizeof (SENSOR_OPTIONROM_CFG) == 64);

   #else
      typedef struct _SENSOR_OPTIONROM_CFG {
         UEXACT32 version_num;
         UEXACT32 pci_bus_device_num;
         UEXACT32 rsvd0[3];
         UEXACT32 flags_capabilities;
         UEXACT32 vendor_defined;
         UEXACT32 rsvd1[8];
         UEXACT32 checksum;
      } SG_PACK SENSOR_OPTIONROM_CFG, *PSENSOR_OPTIONROM_CFG;

      typedef union _SENSOR_OPTIONROM_CFG_UNION {
         SENSOR_OPTIONROM_CFG bits;
         u32 dw[16]; // dword union
      } SG_PACK SENSOR_OPTIONROM_CFG_UNION, *PSENSOR_OPTIONROM_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_OPTIONROM_CFG_UNION, sizeof (SENSOR_OPTIONROM_CFG_UNION) == 64);
   #endif


#else
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for filling the pci_bus_num and
   // pci_device_num and recomputing the checksum field as it configures each card for
   // sensor updates. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_OPTIONROM_CFG {
         union {
            struct { 
               UEXACT32 version_num;
               UEXACT32 pci_bus_device_num;
               UEXACT32 rsvd0[3];
               UEXACT32 flags_capabilities;
               UEXACT32 vendor_defined;
               UEXACT32 rsvd1[8];
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[16]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_OPTIONROM_CFG, *PSENSOR_OPTIONROM_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_OPTIONROM_CFG, sizeof (SENSOR_OPTIONROM_CFG) == 64);

   #else
      typedef struct _SENSOR_OPTIONROM_CFG {
         UEXACT32 version_num;
         UEXACT32 pci_bus_device_num;
         UEXACT32 rsvd0[3];
         UEXACT32 flags_capabilities;
         UEXACT32 vendor_defined;
         UEXACT32 rsvd1[8];
         UEXACT32 checksum;
      } SG_PACK SENSOR_OPTIONROM_CFG, *PSENSOR_OPTIONROM_CFG;

      typedef union _SENSOR_OPTIONROM_CFG_UNION {
         SENSOR_OPTIONROM_CFG bits;
         u32 dw[16]; // dword union
      } SG_PACK SENSOR_OPTIONROM_CFG_UNION, *PSENSOR_OPTIONROM_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_OPTIONROM_CFG_UNION, sizeof (SENSOR_OPTIONROM_CFG_UNION) == 64);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for finding the starting address and size
   // of this structure in host memory and send it to the management firmware through
   // IOCTL for populating the fields back to system BIOS. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_FIELD_CFG {
         union {
            struct { 
               UEXACT32 sensor_type;
               UEXACT32 sensor_location;
               UEXACT32 sensor_critical_threshold;
               UEXACT32 sensor_caution_threshold;
               UEXACT32 sensor_config_status;
               UEXACT32 sensor_reading;
               UEXACT32 sensor_update_count;
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_FIELD_CFG, *PSENSOR_FIELD_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_FIELD_CFG, sizeof (SENSOR_FIELD_CFG) == 32);

   #else
      typedef struct _SENSOR_FIELD_CFG {
         UEXACT32 sensor_type;
         UEXACT32 sensor_location;
         UEXACT32 sensor_critical_threshold;
         UEXACT32 sensor_caution_threshold;
         UEXACT32 sensor_config_status;
         UEXACT32 sensor_reading;
         UEXACT32 sensor_update_count;
         UEXACT32 checksum;
      } SG_PACK SENSOR_FIELD_CFG, *PSENSOR_FIELD_CFG;

      typedef union _SENSOR_FIELD_CFG_UNION {
         SENSOR_FIELD_CFG bits;
         u32 dw[8]; // dword union
      } SG_PACK SENSOR_FIELD_CFG_UNION, *PSENSOR_FIELD_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_FIELD_CFG_UNION, sizeof (SENSOR_FIELD_CFG_UNION) == 32);
   #endif


#else
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for finding the starting address and size
   // of this structure in host memory and send it to the management firmware through
   // IOCTL for populating the fields back to system BIOS. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_FIELD_CFG {
         union {
            struct { 
               UEXACT32 sensor_type;
               UEXACT32 sensor_location;
               UEXACT32 sensor_critical_threshold;
               UEXACT32 sensor_caution_threshold;
               UEXACT32 sensor_config_status;
               UEXACT32 sensor_reading;
               UEXACT32 sensor_update_count;
               UEXACT32 checksum;
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_FIELD_CFG, *PSENSOR_FIELD_CFG;

      SG_C_ASSERT(__sizeof__SENSOR_FIELD_CFG, sizeof (SENSOR_FIELD_CFG) == 32);

   #else
      typedef struct _SENSOR_FIELD_CFG {
         UEXACT32 sensor_type;
         UEXACT32 sensor_location;
         UEXACT32 sensor_critical_threshold;
         UEXACT32 sensor_caution_threshold;
         UEXACT32 sensor_config_status;
         UEXACT32 sensor_reading;
         UEXACT32 sensor_update_count;
         UEXACT32 checksum;
      } SG_PACK SENSOR_FIELD_CFG, *PSENSOR_FIELD_CFG;

      typedef union _SENSOR_FIELD_CFG_UNION {
         SENSOR_FIELD_CFG bits;
         u32 dw[8]; // dword union
      } SG_PACK SENSOR_FIELD_CFG_UNION, *PSENSOR_FIELD_CFG_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_FIELD_CFG_UNION, sizeof (SENSOR_FIELD_CFG_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for filling some of the fields in BIOS_CFG
   // strucure, some of the fields in OPTION_ROM_CFG structure. The management firmware
   // will fill all the fields in FIELD_CFG structure. The order of the structure in host
   // memory is as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_CFG_STRUCT {
         union {
            struct { 
               SENSOR_BIOS_CFG sensor_bios_config;
               SENSOR_OPTIONROM_CFG sensor_oprom_config;
               SENSOR_FIELD_CFG sensor_config[1];
            } SG_PACK ; // unnamed struct
            u32 dw[40]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_CFG_STRUCT, *PSENSOR_CFG_STRUCT;

      SG_C_ASSERT(__sizeof__SENSOR_CFG_STRUCT, sizeof (SENSOR_CFG_STRUCT) == 160);

   #else
      typedef struct _SENSOR_CFG_STRUCT {
         SENSOR_BIOS_CFG sensor_bios_config;
         SENSOR_OPTIONROM_CFG sensor_oprom_config;
         SENSOR_FIELD_CFG sensor_config[1];
      } SG_PACK SENSOR_CFG_STRUCT, *PSENSOR_CFG_STRUCT;

      typedef union _SENSOR_CFG_STRUCT_UNION {
         SENSOR_CFG_STRUCT bits;
         u32 dw[40]; // dword union
      } SG_PACK SENSOR_CFG_STRUCT_UNION, *PSENSOR_CFG_STRUCT_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_CFG_STRUCT_UNION, sizeof (SENSOR_CFG_STRUCT_UNION) == 160);
   #endif


#else
   // This structure is initially populated by the System BIOS prior to Option ROM
   // execution. The Option ROM is responsible for filling some of the fields in BIOS_CFG
   // strucure, some of the fields in OPTION_ROM_CFG structure. The management firmware
   // will fill all the fields in FIELD_CFG structure. The order of the structure in host
   // memory is as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _SENSOR_CFG_STRUCT {
         union {
            struct { 
               SENSOR_BIOS_CFG sensor_bios_config;
               SENSOR_OPTIONROM_CFG sensor_oprom_config;
               SENSOR_FIELD_CFG sensor_config[1];
            } SG_PACK ; // unnamed struct
            u32 dw[40]; // dword union
         }; // unnamed union
      } SG_PACK SENSOR_CFG_STRUCT, *PSENSOR_CFG_STRUCT;

      SG_C_ASSERT(__sizeof__SENSOR_CFG_STRUCT, sizeof (SENSOR_CFG_STRUCT) == 160);

   #else
      typedef struct _SENSOR_CFG_STRUCT {
         SENSOR_BIOS_CFG sensor_bios_config;
         SENSOR_OPTIONROM_CFG sensor_oprom_config;
         SENSOR_FIELD_CFG sensor_config[1];
      } SG_PACK SENSOR_CFG_STRUCT, *PSENSOR_CFG_STRUCT;

      typedef union _SENSOR_CFG_STRUCT_UNION {
         SENSOR_CFG_STRUCT bits;
         u32 dw[40]; // dword union
      } SG_PACK SENSOR_CFG_STRUCT_UNION, *PSENSOR_CFG_STRUCT_UNION;

      SG_C_ASSERT(__sizeof__SENSOR_CFG_STRUCT_UNION, sizeof (SENSOR_CFG_STRUCT_UNION) == 160);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO_IN {
         union {
            struct { 
               UEXACT64 sensor_start_addr;
               UEXACT32 sensor_size;
               UEXACT32 sensor_interval;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN, *PPOPULATE_SENSOR_CFG_INFO_IN;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_IN, sizeof (POPULATE_SENSOR_CFG_INFO_IN) == 16);

   #else
      typedef struct _POPULATE_SENSOR_CFG_INFO_IN {
         UEXACT64 sensor_start_addr;
         UEXACT32 sensor_size;
         UEXACT32 sensor_interval;
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN, *PPOPULATE_SENSOR_CFG_INFO_IN;

      typedef union _POPULATE_SENSOR_CFG_INFO_IN_UNION {
         POPULATE_SENSOR_CFG_INFO_IN bits;
         u32 dw[4]; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN_UNION, *PPOPULATE_SENSOR_CFG_INFO_IN_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_IN_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_IN_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO_IN {
         union {
            struct { 
               UEXACT64 sensor_start_addr;
               UEXACT32 sensor_size;
               UEXACT32 sensor_interval;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN, *PPOPULATE_SENSOR_CFG_INFO_IN;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_IN, sizeof (POPULATE_SENSOR_CFG_INFO_IN) == 16);

   #else
      typedef struct _POPULATE_SENSOR_CFG_INFO_IN {
         UEXACT64 sensor_start_addr;
         UEXACT32 sensor_size;
         UEXACT32 sensor_interval;
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN, *PPOPULATE_SENSOR_CFG_INFO_IN;

      typedef union _POPULATE_SENSOR_CFG_INFO_IN_UNION {
         POPULATE_SENSOR_CFG_INFO_IN bits;
         u32 dw[4]; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_IN_UNION, *PPOPULATE_SENSOR_CFG_INFO_IN_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_IN_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_IN_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO_OUT {
         union {
            struct { 
               UEXACT32 actual_sensor_size;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT, *PPOPULATE_SENSOR_CFG_INFO_OUT;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_OUT, sizeof (POPULATE_SENSOR_CFG_INFO_OUT) == 4);

   #else
      typedef struct _POPULATE_SENSOR_CFG_INFO_OUT {
         UEXACT32 actual_sensor_size;
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT, *PPOPULATE_SENSOR_CFG_INFO_OUT;

      typedef union _POPULATE_SENSOR_CFG_INFO_OUT_UNION {
         POPULATE_SENSOR_CFG_INFO_OUT bits;
         u32 dw; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT_UNION, *PPOPULATE_SENSOR_CFG_INFO_OUT_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_OUT_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO_OUT {
         union {
            struct { 
               UEXACT32 actual_sensor_size;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT, *PPOPULATE_SENSOR_CFG_INFO_OUT;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_OUT, sizeof (POPULATE_SENSOR_CFG_INFO_OUT) == 4);

   #else
      typedef struct _POPULATE_SENSOR_CFG_INFO_OUT {
         UEXACT32 actual_sensor_size;
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT, *PPOPULATE_SENSOR_CFG_INFO_OUT;

      typedef union _POPULATE_SENSOR_CFG_INFO_OUT_UNION {
         POPULATE_SENSOR_CFG_INFO_OUT bits;
         u32 dw; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_OUT_UNION, *PPOPULATE_SENSOR_CFG_INFO_OUT_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_OUT_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO {
         union {
            union { 
               POPULATE_SENSOR_CFG_INFO_IN request;
               POPULATE_SENSOR_CFG_INFO_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO, *PPOPULATE_SENSOR_CFG_INFO;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO, sizeof (POPULATE_SENSOR_CFG_INFO) == 16);

   #else
      typedef union _POPULATE_SENSOR_CFG_INFO {
         POPULATE_SENSOR_CFG_INFO_IN request;
         POPULATE_SENSOR_CFG_INFO_OUT response;
      } SG_PACK POPULATE_SENSOR_CFG_INFO, *PPOPULATE_SENSOR_CFG_INFO;

      typedef union _POPULATE_SENSOR_CFG_INFO_UNION {
         POPULATE_SENSOR_CFG_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_UNION, *PPOPULATE_SENSOR_CFG_INFO_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_UNION) == 16);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _POPULATE_SENSOR_CFG_INFO {
         union {
            union { 
               POPULATE_SENSOR_CFG_INFO_IN request;
               POPULATE_SENSOR_CFG_INFO_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[4]; // dword union
         }; // unnamed union
      } SG_PACK POPULATE_SENSOR_CFG_INFO, *PPOPULATE_SENSOR_CFG_INFO;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO, sizeof (POPULATE_SENSOR_CFG_INFO) == 16);

   #else
      typedef union _POPULATE_SENSOR_CFG_INFO {
         POPULATE_SENSOR_CFG_INFO_IN request;
         POPULATE_SENSOR_CFG_INFO_OUT response;
      } SG_PACK POPULATE_SENSOR_CFG_INFO, *PPOPULATE_SENSOR_CFG_INFO;

      typedef union _POPULATE_SENSOR_CFG_INFO_UNION {
         POPULATE_SENSOR_CFG_INFO bits;
         u32 dw[4]; // dword union
      } SG_PACK POPULATE_SENSOR_CFG_INFO_UNION, *PPOPULATE_SENSOR_CFG_INFO_UNION;

      SG_C_ASSERT(__sizeof__POPULATE_SENSOR_CFG_INFO_UNION, sizeof (POPULATE_SENSOR_CFG_INFO_UNION) == 16);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl is issued by Option ROMs to send the sensor data structure starting
   // address, size and interval to the management firmware. Management firmware updates
   // the sensor data structure on specified intervals. This IOCTL returns
   // MGMT_STATUS_SUCCESS in case of success and MGMT_STATUS_FAILED in case of error. 
   typedef struct _IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO {
      IOCTL_HEADER header;
      POPULATE_SENSOR_CFG_INFO params;
   } SG_PACK IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO, *PIOCTL_COMMON_POPULATE_SENSOR_CFG_INFO;



#else
   // This Ioctl is issued by Option ROMs to send the sensor data structure starting
   // address, size and interval to the management firmware. Management firmware updates
   // the sensor data structure on specified intervals. This IOCTL returns
   // MGMT_STATUS_SUCCESS in case of success and MGMT_STATUS_FAILED in case of error. 
   typedef struct _IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO {
      IOCTL_HEADER header;
      POPULATE_SENSOR_CFG_INFO params;
   } SG_PACK IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO, *PIOCTL_COMMON_POPULATE_SENSOR_CFG_INFO;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 vf_domain_id;
               UEXACT32 privilege_level;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_IN) == 8);

   #else
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN {
         UEXACT32 vf_domain_id;
         UEXACT32 privilege_level;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN {
         union {
            struct { 
               UEXACT32 vf_domain_id;
               UEXACT32 privilege_level;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_IN) == 8);

   #else
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN {
         UEXACT32 vf_domain_id;
         UEXACT32 privilege_level;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 previous_privilege_level;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT {
         UEXACT32 previous_privilege_level;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 previous_privilege_level;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT {
         UEXACT32 previous_privilege_level;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS {
         union {
            union { 
               SET_VF_PRIVILEGE_LEVEL_PARAMS_IN request;
               SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS, *PSET_VF_PRIVILEGE_LEVEL_PARAMS;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS) == 8);

   #else
      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_IN request;
         SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT response;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS, *PSET_VF_PRIVILEGE_LEVEL_PARAMS;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PRIVILEGE_LEVEL_PARAMS {
         union {
            union { 
               SET_VF_PRIVILEGE_LEVEL_PARAMS_IN request;
               SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS, *PSET_VF_PRIVILEGE_LEVEL_PARAMS;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS) == 8);

   #else
      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS {
         SET_VF_PRIVILEGE_LEVEL_PARAMS_IN request;
         SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT response;
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS, *PSET_VF_PRIVILEGE_LEVEL_PARAMS;

      typedef union _SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION {
         SET_VF_PRIVILEGE_LEVEL_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION, sizeof (SET_VF_PRIVILEGE_LEVEL_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued by physical function drivers to set the privilege level of
   // a particular virtual function. The assigned privilege level directs management
   // firmware how to handle future requests by the virtual function that have privilege
   // level checks. The IOCTL may complete with the following status/additional_status
   // codes:  -  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request
   // completed successfully.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS -- the caller is not
   // authorized to issue this IOCTL.  - MGMT_STATUS_UNAUTHORIZED_REQUEST /
   // MGMT_ADDI_STATUS_NOT_A_PROXY_CALL -- Expected a proxy call by PF but thats not the
   // case.  - MGMT_STATUS_NOT_SUPPORTED / MGMT_ADDI_STATUS_NO_STATUS -- SRIOV is not
   // supported for this physical function or the adapter. 
   typedef struct _IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL {
      IOCTL_HEADER header;
      SET_VF_PRIVILEGE_LEVEL_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL, *PIOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL;



#else
   // This IOCTL may be issued by physical function drivers to set the privilege level of
   // a particular virtual function. The assigned privilege level directs management
   // firmware how to handle future requests by the virtual function that have privilege
   // level checks. The IOCTL may complete with the following status/additional_status
   // codes:  -  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request
   // completed successfully.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS -- the caller is not
   // authorized to issue this IOCTL.  - MGMT_STATUS_UNAUTHORIZED_REQUEST /
   // MGMT_ADDI_STATUS_NOT_A_PROXY_CALL -- Expected a proxy call by PF but thats not the
   // case.  - MGMT_STATUS_NOT_SUPPORTED / MGMT_ADDI_STATUS_NO_STATUS -- SRIOV is not
   // supported for this physical function or the adapter. 
   typedef struct _IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL {
      IOCTL_HEADER header;
      SET_VF_PRIVILEGE_LEVEL_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL, *PIOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 vf_domain_id;
               UEXACT32 port_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN, *PSET_VF_PORT_TYPE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_IN, sizeof (SET_VF_PORT_TYPE_PARAMS_IN) == 8);

   #else
      typedef struct _SET_VF_PORT_TYPE_PARAMS_IN {
         UEXACT32 vf_domain_id;
         UEXACT32 port_type;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN, *PSET_VF_PORT_TYPE_PARAMS_IN;

      typedef union _SET_VF_PORT_TYPE_PARAMS_IN_UNION {
         SET_VF_PORT_TYPE_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN_UNION, *PSET_VF_PORT_TYPE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_IN_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_IN_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS_IN {
         union {
            struct { 
               UEXACT32 vf_domain_id;
               UEXACT32 port_type;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN, *PSET_VF_PORT_TYPE_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_IN, sizeof (SET_VF_PORT_TYPE_PARAMS_IN) == 8);

   #else
      typedef struct _SET_VF_PORT_TYPE_PARAMS_IN {
         UEXACT32 vf_domain_id;
         UEXACT32 port_type;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN, *PSET_VF_PORT_TYPE_PARAMS_IN;

      typedef union _SET_VF_PORT_TYPE_PARAMS_IN_UNION {
         SET_VF_PORT_TYPE_PARAMS_IN bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_IN_UNION, *PSET_VF_PORT_TYPE_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_IN_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_IN_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 previous_port_type;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT, *PSET_VF_PORT_TYPE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_OUT, sizeof (SET_VF_PORT_TYPE_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_VF_PORT_TYPE_PARAMS_OUT {
         UEXACT32 previous_port_type;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT, *PSET_VF_PORT_TYPE_PARAMS_OUT;

      typedef union _SET_VF_PORT_TYPE_PARAMS_OUT_UNION {
         SET_VF_PORT_TYPE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT_UNION, *PSET_VF_PORT_TYPE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_OUT_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 previous_port_type;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT, *PSET_VF_PORT_TYPE_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_OUT, sizeof (SET_VF_PORT_TYPE_PARAMS_OUT) == 4);

   #else
      typedef struct _SET_VF_PORT_TYPE_PARAMS_OUT {
         UEXACT32 previous_port_type;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT, *PSET_VF_PORT_TYPE_PARAMS_OUT;

      typedef union _SET_VF_PORT_TYPE_PARAMS_OUT_UNION {
         SET_VF_PORT_TYPE_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_OUT_UNION, *PSET_VF_PORT_TYPE_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_OUT_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS {
         union {
            union { 
               SET_VF_PORT_TYPE_PARAMS_IN request;
               SET_VF_PORT_TYPE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS, *PSET_VF_PORT_TYPE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS, sizeof (SET_VF_PORT_TYPE_PARAMS) == 8);

   #else
      typedef union _SET_VF_PORT_TYPE_PARAMS {
         SET_VF_PORT_TYPE_PARAMS_IN request;
         SET_VF_PORT_TYPE_PARAMS_OUT response;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS, *PSET_VF_PORT_TYPE_PARAMS;

      typedef union _SET_VF_PORT_TYPE_PARAMS_UNION {
         SET_VF_PORT_TYPE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_UNION, *PSET_VF_PORT_TYPE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_VF_PORT_TYPE_PARAMS {
         union {
            union { 
               SET_VF_PORT_TYPE_PARAMS_IN request;
               SET_VF_PORT_TYPE_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS, *PSET_VF_PORT_TYPE_PARAMS;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS, sizeof (SET_VF_PORT_TYPE_PARAMS) == 8);

   #else
      typedef union _SET_VF_PORT_TYPE_PARAMS {
         SET_VF_PORT_TYPE_PARAMS_IN request;
         SET_VF_PORT_TYPE_PARAMS_OUT response;
      } SG_PACK SET_VF_PORT_TYPE_PARAMS, *PSET_VF_PORT_TYPE_PARAMS;

      typedef union _SET_VF_PORT_TYPE_PARAMS_UNION {
         SET_VF_PORT_TYPE_PARAMS bits;
         u32 dw[2]; // dword union
      } SG_PACK SET_VF_PORT_TYPE_PARAMS_UNION, *PSET_VF_PORT_TYPE_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_VF_PORT_TYPE_PARAMS_UNION, sizeof (SET_VF_PORT_TYPE_PARAMS_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued by physical function drivers to set the privilege level of
   // a particular virtual function. The assigned privilege level directs management
   // firmware how to handle future requests by the virtual function that have privilege
   // level checks. The IOCTL may complete with the following status/additional_status
   // codes:  -  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request
   // completed successfully.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS -- the caller is not
   // authorized to issue this IOCTL.  - MGMT_STATUS_NOT_SUPPORTED /
   // MGMT_ADDI_STATUS_NO_STATUS -- SRIOV is not supported for this physical function or
   // the adapter. 
   typedef struct _IOCTL_COMMON_SET_VF_PORT_TYPE {
      IOCTL_HEADER header;
      SET_VF_PORT_TYPE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_VF_PORT_TYPE, *PIOCTL_COMMON_SET_VF_PORT_TYPE;



#else
   // This IOCTL may be issued by physical function drivers to set the privilege level of
   // a particular virtual function. The assigned privilege level directs management
   // firmware how to handle future requests by the virtual function that have privilege
   // level checks. The IOCTL may complete with the following status/additional_status
   // codes:  -  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request
   // completed successfully.  - MGMT_STATUS_ILLEGAL_FIELD -- the request parameter at the
   // byte offset specified in the additional status response is invalid.  -
   // MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS -- the caller is not
   // authorized to issue this IOCTL.  - MGMT_STATUS_NOT_SUPPORTED /
   // MGMT_ADDI_STATUS_NO_STATUS -- SRIOV is not supported for this physical function or
   // the adapter. 
   typedef struct _IOCTL_COMMON_SET_VF_PORT_TYPE {
      IOCTL_HEADER header;
      SET_VF_PORT_TYPE_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_VF_PORT_TYPE, *PIOCTL_COMMON_SET_VF_PORT_TYPE;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN, *PGET_PHY_DETAILS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_IN, sizeof (GET_PHY_DETAILS_PARAMS_IN) == 4);

   #else
      typedef struct _GET_PHY_DETAILS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN, *PGET_PHY_DETAILS_PARAMS_IN;

      typedef union _GET_PHY_DETAILS_PARAMS_IN_UNION {
         GET_PHY_DETAILS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN_UNION, *PGET_PHY_DETAILS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_IN_UNION, sizeof (GET_PHY_DETAILS_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN, *PGET_PHY_DETAILS_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_IN, sizeof (GET_PHY_DETAILS_PARAMS_IN) == 4);

   #else
      typedef struct _GET_PHY_DETAILS_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN, *PGET_PHY_DETAILS_PARAMS_IN;

      typedef union _GET_PHY_DETAILS_PARAMS_IN_UNION {
         GET_PHY_DETAILS_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_IN_UNION, *PGET_PHY_DETAILS_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_IN_UNION, sizeof (GET_PHY_DETAILS_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 phy_type;
               UEXACT16 interface_type;
               UEXACT32 misc_params;
               UEXACT32 future_use[4];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT, *PGET_PHY_DETAILS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_OUT, sizeof (GET_PHY_DETAILS_PARAMS_OUT) == 24);

   #else
      typedef struct _GET_PHY_DETAILS_PARAMS_OUT {
         UEXACT16 phy_type;
         UEXACT16 interface_type;
         UEXACT32 misc_params;
         UEXACT32 future_use[4];
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT, *PGET_PHY_DETAILS_PARAMS_OUT;

      typedef union _GET_PHY_DETAILS_PARAMS_OUT_UNION {
         GET_PHY_DETAILS_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT_UNION, *PGET_PHY_DETAILS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_OUT_UNION, sizeof (GET_PHY_DETAILS_PARAMS_OUT_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 phy_type;
               UEXACT16 interface_type;
               UEXACT32 misc_params;
               UEXACT32 future_use[4];
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT, *PGET_PHY_DETAILS_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_OUT, sizeof (GET_PHY_DETAILS_PARAMS_OUT) == 24);

   #else
      typedef struct _GET_PHY_DETAILS_PARAMS_OUT {
         UEXACT16 phy_type;
         UEXACT16 interface_type;
         UEXACT32 misc_params;
         UEXACT32 future_use[4];
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT, *PGET_PHY_DETAILS_PARAMS_OUT;

      typedef union _GET_PHY_DETAILS_PARAMS_OUT_UNION {
         GET_PHY_DETAILS_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_OUT_UNION, *PGET_PHY_DETAILS_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_OUT_UNION, sizeof (GET_PHY_DETAILS_PARAMS_OUT_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS {
         union {
            union { 
               GET_PHY_DETAILS_PARAMS_IN request;
               GET_PHY_DETAILS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS, *PGET_PHY_DETAILS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS, sizeof (GET_PHY_DETAILS_PARAMS) == 24);

   #else
      typedef union _GET_PHY_DETAILS_PARAMS {
         GET_PHY_DETAILS_PARAMS_IN request;
         GET_PHY_DETAILS_PARAMS_OUT response;
      } SG_PACK GET_PHY_DETAILS_PARAMS, *PGET_PHY_DETAILS_PARAMS;

      typedef union _GET_PHY_DETAILS_PARAMS_UNION {
         GET_PHY_DETAILS_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_UNION, *PGET_PHY_DETAILS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_UNION, sizeof (GET_PHY_DETAILS_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_PHY_DETAILS_PARAMS {
         union {
            union { 
               GET_PHY_DETAILS_PARAMS_IN request;
               GET_PHY_DETAILS_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_PHY_DETAILS_PARAMS, *PGET_PHY_DETAILS_PARAMS;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS, sizeof (GET_PHY_DETAILS_PARAMS) == 24);

   #else
      typedef union _GET_PHY_DETAILS_PARAMS {
         GET_PHY_DETAILS_PARAMS_IN request;
         GET_PHY_DETAILS_PARAMS_OUT response;
      } SG_PACK GET_PHY_DETAILS_PARAMS, *PGET_PHY_DETAILS_PARAMS;

      typedef union _GET_PHY_DETAILS_PARAMS_UNION {
         GET_PHY_DETAILS_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_PHY_DETAILS_PARAMS_UNION, *PGET_PHY_DETAILS_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_PHY_DETAILS_PARAMS_UNION, sizeof (GET_PHY_DETAILS_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued by VF and PF drivers to determine the PHY type and settings
   // for the port assigned to their function. The IOCTL may complete with the following
   // status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the rsvd field in the request structure was not set to
   // zero. 
   typedef struct _IOCTL_COMMON_GET_PHY_DETAILS {
      IOCTL_HEADER header;
      GET_PHY_DETAILS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PHY_DETAILS, *PIOCTL_COMMON_GET_PHY_DETAILS;



#else
   // This IOCTL may be issued by VF and PF drivers to determine the PHY type and settings
   // for the port assigned to their function. The IOCTL may complete with the following
   // status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_FIELD -- the rsvd field in the request structure was not set to
   // zero. 
   typedef struct _IOCTL_COMMON_GET_PHY_DETAILS {
      IOCTL_HEADER header;
      GET_PHY_DETAILS_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_PHY_DETAILS, *PIOCTL_COMMON_GET_PHY_DETAILS;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 valid_capability_flags;
               UEXACT32 capability_flags;
               UEXACT8 sbz[212];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN) == 220);

   #else
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN {
         UEXACT32 valid_capability_flags;
         UEXACT32 capability_flags;
         UEXACT8 sbz[212];
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 valid_capability_flags;
               UEXACT32 capability_flags;
               UEXACT8 sbz[212];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN) == 220);

   #else
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN {
         UEXACT32 valid_capability_flags;
         UEXACT32 capability_flags;
         UEXACT8 sbz[212];
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 valid_capability_flags;
               UEXACT32 capability_flags;
               UEXACT8 sbz[212];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT) == 220);

   #else
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT {
         UEXACT32 valid_capability_flags;
         UEXACT32 capability_flags;
         UEXACT8 sbz[212];
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 valid_capability_flags;
               UEXACT32 capability_flags;
               UEXACT8 sbz[212];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT) == 220);

   #else
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT {
         UEXACT32 valid_capability_flags;
         UEXACT32 capability_flags;
         UEXACT8 sbz[212];
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS {
         union {
            union { 
               SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN request;
               SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS) == 220);

   #else
      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN request;
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT response;
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS {
         union {
            union { 
               SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN request;
               SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS) == 220);

   #else
      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN request;
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT response;
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS;

      typedef union _SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION {
         SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS bits;
         u32 dw[55]; // dword union
      } SG_PACK SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION, sizeof (SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued by PF drivers to set their function's capabilities. It is
   // expected this IOCTL is issued prior to posting resources to the adapter and creating
   // rings.  The IOCTL may complete with the following status/additional_status codes:  -
   //  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_FIELD / MGMT_ADDI_STATUS_NO_STATUS -- the sbz[]
   // array is not zero.  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS
   // -- the caller is not authorized to issue this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST
   // / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by firmware. Callers
   // should treat this error as indicative the driver advertised capabilities are not
   // supported and should not be used.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL. 
   typedef struct _IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES {
      IOCTL_HEADER header;
      SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES;



#else
   // This IOCTL may be issued by PF drivers to set their function's capabilities. It is
   // expected this IOCTL is issued prior to posting resources to the adapter and creating
   // rings.  The IOCTL may complete with the following status/additional_status codes:  -
   //  - MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_FIELD / MGMT_ADDI_STATUS_NO_STATUS -- the sbz[]
   // array is not zero.  - MGMT_STATUS_UNAUTHORIZED_REQUEST / MGMT_ADDI_STATUS_NO_STATUS
   // -- the caller is not authorized to issue this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST
   // / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by firmware. Callers
   // should treat this error as indicative the driver advertised capabilities are not
   // supported and should not be used.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL. 
   typedef struct _IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES {
      IOCTL_HEADER header;
      SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS params;
   } SG_PACK IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN, *PGET_ADAPTER_ID_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_IN, sizeof (GET_ADAPTER_ID_PARAMS_IN) == 4);

   #else
      typedef struct _GET_ADAPTER_ID_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN, *PGET_ADAPTER_ID_PARAMS_IN;

      typedef union _GET_ADAPTER_ID_PARAMS_IN_UNION {
         GET_ADAPTER_ID_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN_UNION, *PGET_ADAPTER_ID_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_IN_UNION, sizeof (GET_ADAPTER_ID_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN, *PGET_ADAPTER_ID_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_IN, sizeof (GET_ADAPTER_ID_PARAMS_IN) == 4);

   #else
      typedef struct _GET_ADAPTER_ID_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN, *PGET_ADAPTER_ID_PARAMS_IN;

      typedef union _GET_ADAPTER_ID_PARAMS_IN_UNION {
         GET_ADAPTER_ID_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_IN_UNION, *PGET_ADAPTER_ID_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_IN_UNION, sizeof (GET_ADAPTER_ID_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 adapter_id[23];
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT, *PGET_ADAPTER_ID_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_OUT, sizeof (GET_ADAPTER_ID_PARAMS_OUT) == 24);

   #else
      typedef struct _GET_ADAPTER_ID_PARAMS_OUT {
         UEXACT8 adapter_id[23];
         UEXACT8 rsvd0;
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT, *PGET_ADAPTER_ID_PARAMS_OUT;

      typedef union _GET_ADAPTER_ID_PARAMS_OUT_UNION {
         GET_ADAPTER_ID_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT_UNION, *PGET_ADAPTER_ID_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_OUT_UNION, sizeof (GET_ADAPTER_ID_PARAMS_OUT_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 adapter_id[23];
               UEXACT8 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT, *PGET_ADAPTER_ID_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_OUT, sizeof (GET_ADAPTER_ID_PARAMS_OUT) == 24);

   #else
      typedef struct _GET_ADAPTER_ID_PARAMS_OUT {
         UEXACT8 adapter_id[23];
         UEXACT8 rsvd0;
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT, *PGET_ADAPTER_ID_PARAMS_OUT;

      typedef union _GET_ADAPTER_ID_PARAMS_OUT_UNION {
         GET_ADAPTER_ID_PARAMS_OUT bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_OUT_UNION, *PGET_ADAPTER_ID_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_OUT_UNION, sizeof (GET_ADAPTER_ID_PARAMS_OUT_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS {
         union {
            union { 
               GET_ADAPTER_ID_PARAMS_IN request;
               GET_ADAPTER_ID_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS, *PGET_ADAPTER_ID_PARAMS;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS, sizeof (GET_ADAPTER_ID_PARAMS) == 24);

   #else
      typedef union _GET_ADAPTER_ID_PARAMS {
         GET_ADAPTER_ID_PARAMS_IN request;
         GET_ADAPTER_ID_PARAMS_OUT response;
      } SG_PACK GET_ADAPTER_ID_PARAMS, *PGET_ADAPTER_ID_PARAMS;

      typedef union _GET_ADAPTER_ID_PARAMS_UNION {
         GET_ADAPTER_ID_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_UNION, *PGET_ADAPTER_ID_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_UNION, sizeof (GET_ADAPTER_ID_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_ADAPTER_ID_PARAMS {
         union {
            union { 
               GET_ADAPTER_ID_PARAMS_IN request;
               GET_ADAPTER_ID_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK GET_ADAPTER_ID_PARAMS, *PGET_ADAPTER_ID_PARAMS;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS, sizeof (GET_ADAPTER_ID_PARAMS) == 24);

   #else
      typedef union _GET_ADAPTER_ID_PARAMS {
         GET_ADAPTER_ID_PARAMS_IN request;
         GET_ADAPTER_ID_PARAMS_OUT response;
      } SG_PACK GET_ADAPTER_ID_PARAMS, *PGET_ADAPTER_ID_PARAMS;

      typedef union _GET_ADAPTER_ID_PARAMS_UNION {
         GET_ADAPTER_ID_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK GET_ADAPTER_ID_PARAMS_UNION, *PGET_ADAPTER_ID_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_ADAPTER_ID_PARAMS_UNION, sizeof (GET_ADAPTER_ID_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to retrieve the Adapter ID string.  The IOCTL may complete
   // with the following status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not
   // supported by firmware. This is the case for adapters installed with older firmware.
   // A firmware update is required to use this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER -- the
   // buffer size provided is insufficient to contain the response data. The
   // IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned
   // response data. The IOCTL_RESPONSE_HEADER actual_response_length field indicates the
   // buffer size required for the full response data. 
   typedef struct _IOCTL_COMMON_GET_ADAPTER_ID {
      IOCTL_HEADER header;
      GET_ADAPTER_ID_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_ADAPTER_ID, *PIOCTL_COMMON_GET_ADAPTER_ID;



#else
   // This IOCTL may be issued to retrieve the Adapter ID string.  The IOCTL may complete
   // with the following status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not
   // supported by firmware. This is the case for adapters installed with older firmware.
   // A firmware update is required to use this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER -- the
   // buffer size provided is insufficient to contain the response data. The
   // IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned
   // response data. The IOCTL_RESPONSE_HEADER actual_response_length field indicates the
   // buffer size required for the full response data. 
   typedef struct _IOCTL_COMMON_GET_ADAPTER_ID {
      IOCTL_HEADER header;
      GET_ADAPTER_ID_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_ADAPTER_ID, *PIOCTL_COMMON_GET_ADAPTER_ID;



#endif
#if defined(SG_REVERSE_ENDIAN)
   // Up to 32 characters per feature string. Null terminated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FEATURE_NAME_STRING {
         union {
            struct { 
               UEXACT8 string_bytes[32];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FEATURE_NAME_STRING, *PFEATURE_NAME_STRING;

      SG_C_ASSERT(__sizeof__FEATURE_NAME_STRING, sizeof (FEATURE_NAME_STRING) == 32);

   #else
      typedef struct _FEATURE_NAME_STRING {
         UEXACT8 string_bytes[32];
      } SG_PACK FEATURE_NAME_STRING, *PFEATURE_NAME_STRING;

      typedef union _FEATURE_NAME_STRING_UNION {
         FEATURE_NAME_STRING bits;
         u32 dw[8]; // dword union
      } SG_PACK FEATURE_NAME_STRING_UNION, *PFEATURE_NAME_STRING_UNION;

      SG_C_ASSERT(__sizeof__FEATURE_NAME_STRING_UNION, sizeof (FEATURE_NAME_STRING_UNION) == 32);
   #endif


#else
   // Up to 32 characters per feature string. Null terminated. 
   #if defined(SG_BMAP_UNION)
      typedef struct _FEATURE_NAME_STRING {
         union {
            struct { 
               UEXACT8 string_bytes[32];
            } SG_PACK ; // unnamed struct
            u32 dw[8]; // dword union
         }; // unnamed union
      } SG_PACK FEATURE_NAME_STRING, *PFEATURE_NAME_STRING;

      SG_C_ASSERT(__sizeof__FEATURE_NAME_STRING, sizeof (FEATURE_NAME_STRING) == 32);

   #else
      typedef struct _FEATURE_NAME_STRING {
         UEXACT8 string_bytes[32];
      } SG_PACK FEATURE_NAME_STRING, *PFEATURE_NAME_STRING;

      typedef union _FEATURE_NAME_STRING_UNION {
         FEATURE_NAME_STRING bits;
         u32 dw[8]; // dword union
      } SG_PACK FEATURE_NAME_STRING_UNION, *PFEATURE_NAME_STRING_UNION;

      SG_C_ASSERT(__sizeof__FEATURE_NAME_STRING_UNION, sizeof (FEATURE_NAME_STRING_UNION) == 32);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN, *PGET_UPGRADE_FEATURES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_IN, sizeof (GET_UPGRADE_FEATURES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN, *PGET_UPGRADE_FEATURES_PARAMS_IN;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_IN_UNION {
         GET_UPGRADE_FEATURES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN_UNION, *PGET_UPGRADE_FEATURES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_IN_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN, *PGET_UPGRADE_FEATURES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_IN, sizeof (GET_UPGRADE_FEATURES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN, *PGET_UPGRADE_FEATURES_PARAMS_IN;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_IN_UNION {
         GET_UPGRADE_FEATURES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_IN_UNION, *PGET_UPGRADE_FEATURES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_IN_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 feature_valid[6];
               UEXACT8 rsvd0[2];
               FEATURE_NAME_STRING feature_name[48];
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT, *PGET_UPGRADE_FEATURES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_OUT, sizeof (GET_UPGRADE_FEATURES_PARAMS_OUT) == 1544);

   #else
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_OUT {
         UEXACT8 feature_valid[6];
         UEXACT8 rsvd0[2];
         FEATURE_NAME_STRING feature_name[48];
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT, *PGET_UPGRADE_FEATURES_PARAMS_OUT;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_OUT_UNION {
         GET_UPGRADE_FEATURES_PARAMS_OUT bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT_UNION, *PGET_UPGRADE_FEATURES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_OUT_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_OUT_UNION) == 1544);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 feature_valid[6];
               UEXACT8 rsvd0[2];
               FEATURE_NAME_STRING feature_name[48];
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT, *PGET_UPGRADE_FEATURES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_OUT, sizeof (GET_UPGRADE_FEATURES_PARAMS_OUT) == 1544);

   #else
      typedef struct _GET_UPGRADE_FEATURES_PARAMS_OUT {
         UEXACT8 feature_valid[6];
         UEXACT8 rsvd0[2];
         FEATURE_NAME_STRING feature_name[48];
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT, *PGET_UPGRADE_FEATURES_PARAMS_OUT;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_OUT_UNION {
         GET_UPGRADE_FEATURES_PARAMS_OUT bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_OUT_UNION, *PGET_UPGRADE_FEATURES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_OUT_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_OUT_UNION) == 1544);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS {
         union {
            union { 
               GET_UPGRADE_FEATURES_PARAMS_IN request;
               GET_UPGRADE_FEATURES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS, *PGET_UPGRADE_FEATURES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS, sizeof (GET_UPGRADE_FEATURES_PARAMS) == 1544);

   #else
      typedef union _GET_UPGRADE_FEATURES_PARAMS {
         GET_UPGRADE_FEATURES_PARAMS_IN request;
         GET_UPGRADE_FEATURES_PARAMS_OUT response;
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS, *PGET_UPGRADE_FEATURES_PARAMS;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_UNION {
         GET_UPGRADE_FEATURES_PARAMS bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_UNION, *PGET_UPGRADE_FEATURES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_UNION) == 1544);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_UPGRADE_FEATURES_PARAMS {
         union {
            union { 
               GET_UPGRADE_FEATURES_PARAMS_IN request;
               GET_UPGRADE_FEATURES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS, *PGET_UPGRADE_FEATURES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS, sizeof (GET_UPGRADE_FEATURES_PARAMS) == 1544);

   #else
      typedef union _GET_UPGRADE_FEATURES_PARAMS {
         GET_UPGRADE_FEATURES_PARAMS_IN request;
         GET_UPGRADE_FEATURES_PARAMS_OUT response;
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS, *PGET_UPGRADE_FEATURES_PARAMS;

      typedef union _GET_UPGRADE_FEATURES_PARAMS_UNION {
         GET_UPGRADE_FEATURES_PARAMS bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_UPGRADE_FEATURES_PARAMS_UNION, *PGET_UPGRADE_FEATURES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_UPGRADE_FEATURES_PARAMS_UNION, sizeof (GET_UPGRADE_FEATURES_PARAMS_UNION) == 1544);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to retrieve a list of available upgrade features.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_UPGRADE_FEATURES {
      IOCTL_HEADER header;
      GET_UPGRADE_FEATURES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_UPGRADE_FEATURES, *PIOCTL_COMMON_GET_UPGRADE_FEATURES;



#else
   // This IOCTL may be issued to retrieve a list of available upgrade features.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_UPGRADE_FEATURES {
      IOCTL_HEADER header;
      GET_UPGRADE_FEATURES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_UPGRADE_FEATURES, *PIOCTL_COMMON_GET_UPGRADE_FEATURES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN, *PGET_INSTALLED_FEATURES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_IN, sizeof (GET_INSTALLED_FEATURES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN, *PGET_INSTALLED_FEATURES_PARAMS_IN;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_IN_UNION {
         GET_INSTALLED_FEATURES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN_UNION, *PGET_INSTALLED_FEATURES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_IN_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN, *PGET_INSTALLED_FEATURES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_IN, sizeof (GET_INSTALLED_FEATURES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN, *PGET_INSTALLED_FEATURES_PARAMS_IN;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_IN_UNION {
         GET_INSTALLED_FEATURES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_IN_UNION, *PGET_INSTALLED_FEATURES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_IN_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 feature_valid[6];
               UEXACT8 rsvd0[2];
               FEATURE_NAME_STRING feature_name[48];
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT, *PGET_INSTALLED_FEATURES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_OUT, sizeof (GET_INSTALLED_FEATURES_PARAMS_OUT) == 1544);

   #else
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_OUT {
         UEXACT8 feature_valid[6];
         UEXACT8 rsvd0[2];
         FEATURE_NAME_STRING feature_name[48];
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT, *PGET_INSTALLED_FEATURES_PARAMS_OUT;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_OUT_UNION {
         GET_INSTALLED_FEATURES_PARAMS_OUT bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT_UNION, *PGET_INSTALLED_FEATURES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_OUT_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_OUT_UNION) == 1544);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 feature_valid[6];
               UEXACT8 rsvd0[2];
               FEATURE_NAME_STRING feature_name[48];
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT, *PGET_INSTALLED_FEATURES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_OUT, sizeof (GET_INSTALLED_FEATURES_PARAMS_OUT) == 1544);

   #else
      typedef struct _GET_INSTALLED_FEATURES_PARAMS_OUT {
         UEXACT8 feature_valid[6];
         UEXACT8 rsvd0[2];
         FEATURE_NAME_STRING feature_name[48];
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT, *PGET_INSTALLED_FEATURES_PARAMS_OUT;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_OUT_UNION {
         GET_INSTALLED_FEATURES_PARAMS_OUT bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_OUT_UNION, *PGET_INSTALLED_FEATURES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_OUT_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_OUT_UNION) == 1544);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS {
         union {
            union { 
               GET_INSTALLED_FEATURES_PARAMS_IN request;
               GET_INSTALLED_FEATURES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS, *PGET_INSTALLED_FEATURES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS, sizeof (GET_INSTALLED_FEATURES_PARAMS) == 1544);

   #else
      typedef union _GET_INSTALLED_FEATURES_PARAMS {
         GET_INSTALLED_FEATURES_PARAMS_IN request;
         GET_INSTALLED_FEATURES_PARAMS_OUT response;
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS, *PGET_INSTALLED_FEATURES_PARAMS;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_UNION {
         GET_INSTALLED_FEATURES_PARAMS bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_UNION, *PGET_INSTALLED_FEATURES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_UNION) == 1544);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_INSTALLED_FEATURES_PARAMS {
         union {
            union { 
               GET_INSTALLED_FEATURES_PARAMS_IN request;
               GET_INSTALLED_FEATURES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[386]; // dword union
         }; // unnamed union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS, *PGET_INSTALLED_FEATURES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS, sizeof (GET_INSTALLED_FEATURES_PARAMS) == 1544);

   #else
      typedef union _GET_INSTALLED_FEATURES_PARAMS {
         GET_INSTALLED_FEATURES_PARAMS_IN request;
         GET_INSTALLED_FEATURES_PARAMS_OUT response;
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS, *PGET_INSTALLED_FEATURES_PARAMS;

      typedef union _GET_INSTALLED_FEATURES_PARAMS_UNION {
         GET_INSTALLED_FEATURES_PARAMS bits;
         u32 dw[386]; // dword union
      } SG_PACK GET_INSTALLED_FEATURES_PARAMS_UNION, *PGET_INSTALLED_FEATURES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_INSTALLED_FEATURES_PARAMS_UNION, sizeof (GET_INSTALLED_FEATURES_PARAMS_UNION) == 1544);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to retrieve a list of currently installed features.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_INSTALLED_FEATURES {
      IOCTL_HEADER header;
      GET_INSTALLED_FEATURES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_INSTALLED_FEATURES, *PIOCTL_COMMON_GET_INSTALLED_FEATURES;



#else
   // This IOCTL may be issued to retrieve a list of currently installed features.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully.  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_INSTALLED_FEATURES {
      IOCTL_HEADER header;
      GET_INSTALLED_FEATURES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_INSTALLED_FEATURES, *PIOCTL_COMMON_GET_INSTALLED_FEATURES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_IN, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_IN, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 personality_string;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT {
         UEXACT8 personality_string;
         UEXACT8 rsvd0[3];
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 personality_string;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT {
         UEXACT8 personality_string;
         UEXACT8 rsvd0[3];
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS {
         union {
            union { 
               GET_AVAILABLE_PERSONALITIES_PARAMS_IN request;
               GET_AVAILABLE_PERSONALITIES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS, *PGET_AVAILABLE_PERSONALITIES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS) == 4);

   #else
      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS {
         GET_AVAILABLE_PERSONALITIES_PARAMS_IN request;
         GET_AVAILABLE_PERSONALITIES_PARAMS_OUT response;
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS, *PGET_AVAILABLE_PERSONALITIES_PARAMS;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_AVAILABLE_PERSONALITIES_PARAMS {
         union {
            union { 
               GET_AVAILABLE_PERSONALITIES_PARAMS_IN request;
               GET_AVAILABLE_PERSONALITIES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS, *PGET_AVAILABLE_PERSONALITIES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS) == 4);

   #else
      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS {
         GET_AVAILABLE_PERSONALITIES_PARAMS_IN request;
         GET_AVAILABLE_PERSONALITIES_PARAMS_OUT response;
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS, *PGET_AVAILABLE_PERSONALITIES_PARAMS;

      typedef union _GET_AVAILABLE_PERSONALITIES_PARAMS_UNION {
         GET_AVAILABLE_PERSONALITIES_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_AVAILABLE_PERSONALITIES_PARAMS_UNION, *PGET_AVAILABLE_PERSONALITIES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_AVAILABLE_PERSONALITIES_PARAMS_UNION, sizeof (GET_AVAILABLE_PERSONALITIES_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to retrieve a list of available personalities to run.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully. 0  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES {
      IOCTL_HEADER header;
      GET_AVAILABLE_PERSONALITIES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES, *PIOCTL_COMMON_GET_AVAILABLE_PERSONALITIES;



#else
   // This IOCTL may be issued to retrieve a list of available personalities to run.  The
   // IOCTL may complete with the following status/additional_status codes:  -  -
   // MGMT_STATUS_SUCCESS / MGMT_ADDI_STATUS_NO_STATUS -- the request completed
   // successfully. 0  - MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE --
   // the IOCTL is not supported by firmware. This is the case for adapters installed with
   // older firmware. A firmware update is required to use this IOCTL.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header
   // version field indicates an unknown/unsupported version of the IOCTL.  -
   // MGMT_STATUS_INSUFFICIENT_BUFFER -- the buffer size provided is insufficient to
   // contain the response data. The IOCTL_RESPONSE_HEADER response_length field indicates
   // the amount of returned response data. The IOCTL_RESPONSE_HEADER
   // actual_response_length field indicates the buffer size required for the full
   // response data. 
   typedef struct _IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES {
      IOCTL_HEADER header;
      GET_AVAILABLE_PERSONALITIES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES, *PIOCTL_COMMON_GET_AVAILABLE_PERSONALITIES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_IN, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_IN, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 personality_string;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_OUT, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_OUT {
         UEXACT8 personality_string;
         UEXACT8 rsvd0[3];
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 personality_string;
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_OUT, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_OUT) == 4);

   #else
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS_OUT {
         UEXACT8 personality_string;
         UEXACT8 rsvd0[3];
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS {
         union {
            union { 
               GET_CONFIGURED_PERSONALITY_PARAMS_IN request;
               GET_CONFIGURED_PERSONALITY_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS, *PGET_CONFIGURED_PERSONALITY_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS) == 4);

   #else
      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS {
         GET_CONFIGURED_PERSONALITY_PARAMS_IN request;
         GET_CONFIGURED_PERSONALITY_PARAMS_OUT response;
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS, *PGET_CONFIGURED_PERSONALITY_PARAMS;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CONFIGURED_PERSONALITY_PARAMS {
         union {
            union { 
               GET_CONFIGURED_PERSONALITY_PARAMS_IN request;
               GET_CONFIGURED_PERSONALITY_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS, *PGET_CONFIGURED_PERSONALITY_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS) == 4);

   #else
      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS {
         GET_CONFIGURED_PERSONALITY_PARAMS_IN request;
         GET_CONFIGURED_PERSONALITY_PARAMS_OUT response;
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS, *PGET_CONFIGURED_PERSONALITY_PARAMS;

      typedef union _GET_CONFIGURED_PERSONALITY_PARAMS_UNION {
         GET_CONFIGURED_PERSONALITY_PARAMS bits;
         u32 dw; // dword union
      } SG_PACK GET_CONFIGURED_PERSONALITY_PARAMS_UNION, *PGET_CONFIGURED_PERSONALITY_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CONFIGURED_PERSONALITY_PARAMS_UNION, sizeof (GET_CONFIGURED_PERSONALITY_PARAMS_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to retrieve the personality the adapter will be running
   // upon reboot. This differs from the currently running personality as determined by
   // FIXME INSERT EXISTING (OR NEW) IOCTL HERE.  The IOCTL may complete with the
   // following status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not
   // supported by firmware. This is the case for adapters installed with older firmware.
   // A firmware update is required to use this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER -- the
   // buffer size provided is insufficient to contain the response data. The
   // IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned
   // response data. The IOCTL_RESPONSE_HEADER actual_response_length field indicates the
   // buffer size required for the full response data. 
   typedef struct _IOCTL_COMMON_GET_CONFIGURED_PERSONALITY {
      IOCTL_HEADER header;
      GET_CONFIGURED_PERSONALITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CONFIGURED_PERSONALITY, *PIOCTL_COMMON_GET_CONFIGURED_PERSONALITY;



#else
   // This IOCTL may be issued to retrieve the personality the adapter will be running
   // upon reboot. This differs from the currently running personality as determined by
   // FIXME INSERT EXISTING (OR NEW) IOCTL HERE.  The IOCTL may complete with the
   // following status/additional_status codes:  -  - MGMT_STATUS_SUCCESS /
   // MGMT_ADDI_STATUS_NO_STATUS -- the request completed successfully.  -
   // MGMT_STATUS_ILLEGAL_REQUEST / MGMT_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not
   // supported by firmware. This is the case for adapters installed with older firmware.
   // A firmware update is required to use this IOCTL.  - MGMT_STATUS_ILLEGAL_REQUEST /
   // MGMT_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field indicates an
   // unknown/unsupported version of the IOCTL.  - MGMT_STATUS_INSUFFICIENT_BUFFER -- the
   // buffer size provided is insufficient to contain the response data. The
   // IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned
   // response data. The IOCTL_RESPONSE_HEADER actual_response_length field indicates the
   // buffer size required for the full response data. 
   typedef struct _IOCTL_COMMON_GET_CONFIGURED_PERSONALITY {
      IOCTL_HEADER header;
      GET_CONFIGURED_PERSONALITY_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CONFIGURED_PERSONALITY, *PIOCTL_COMMON_GET_CONFIGURED_PERSONALITY;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS_IN {
         union {
            struct { 
               UEXACT8 key[25];
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS_IN, *PSEND_ACTIVATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_IN, sizeof (SEND_ACTIVATION_PARAMS_IN) == 28);

   #else
      typedef struct _SEND_ACTIVATION_PARAMS_IN {
         UEXACT8 key[25];
         UEXACT8 rsvd0[3];
      } SG_PACK SEND_ACTIVATION_PARAMS_IN, *PSEND_ACTIVATION_PARAMS_IN;

      typedef union _SEND_ACTIVATION_PARAMS_IN_UNION {
         SEND_ACTIVATION_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_IN_UNION, *PSEND_ACTIVATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_IN_UNION, sizeof (SEND_ACTIVATION_PARAMS_IN_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS_IN {
         union {
            struct { 
               UEXACT8 key[25];
               UEXACT8 rsvd0[3];
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS_IN, *PSEND_ACTIVATION_PARAMS_IN;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_IN, sizeof (SEND_ACTIVATION_PARAMS_IN) == 28);

   #else
      typedef struct _SEND_ACTIVATION_PARAMS_IN {
         UEXACT8 key[25];
         UEXACT8 rsvd0[3];
      } SG_PACK SEND_ACTIVATION_PARAMS_IN, *PSEND_ACTIVATION_PARAMS_IN;

      typedef union _SEND_ACTIVATION_PARAMS_IN_UNION {
         SEND_ACTIVATION_PARAMS_IN bits;
         u32 dw[7]; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_IN_UNION, *PSEND_ACTIVATION_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_IN_UNION, sizeof (SEND_ACTIVATION_PARAMS_IN_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT, *PSEND_ACTIVATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_OUT, sizeof (SEND_ACTIVATION_PARAMS_OUT) == 4);

   #else
      typedef struct _SEND_ACTIVATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT, *PSEND_ACTIVATION_PARAMS_OUT;

      typedef union _SEND_ACTIVATION_PARAMS_OUT_UNION {
         SEND_ACTIVATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT_UNION, *PSEND_ACTIVATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_OUT_UNION, sizeof (SEND_ACTIVATION_PARAMS_OUT_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS_OUT {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT, *PSEND_ACTIVATION_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_OUT, sizeof (SEND_ACTIVATION_PARAMS_OUT) == 4);

   #else
      typedef struct _SEND_ACTIVATION_PARAMS_OUT {
         UEXACT32 rsvd0;
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT, *PSEND_ACTIVATION_PARAMS_OUT;

      typedef union _SEND_ACTIVATION_PARAMS_OUT_UNION {
         SEND_ACTIVATION_PARAMS_OUT bits;
         u32 dw; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_OUT_UNION, *PSEND_ACTIVATION_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_OUT_UNION, sizeof (SEND_ACTIVATION_PARAMS_OUT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS {
         union {
            union { 
               SEND_ACTIVATION_PARAMS_IN request;
               SEND_ACTIVATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS, *PSEND_ACTIVATION_PARAMS;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS, sizeof (SEND_ACTIVATION_PARAMS) == 28);

   #else
      typedef union _SEND_ACTIVATION_PARAMS {
         SEND_ACTIVATION_PARAMS_IN request;
         SEND_ACTIVATION_PARAMS_OUT response;
      } SG_PACK SEND_ACTIVATION_PARAMS, *PSEND_ACTIVATION_PARAMS;

      typedef union _SEND_ACTIVATION_PARAMS_UNION {
         SEND_ACTIVATION_PARAMS bits;
         u32 dw[7]; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_UNION, *PSEND_ACTIVATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_UNION, sizeof (SEND_ACTIVATION_PARAMS_UNION) == 28);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _SEND_ACTIVATION_PARAMS {
         union {
            union { 
               SEND_ACTIVATION_PARAMS_IN request;
               SEND_ACTIVATION_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[7]; // dword union
         }; // unnamed union
      } SG_PACK SEND_ACTIVATION_PARAMS, *PSEND_ACTIVATION_PARAMS;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS, sizeof (SEND_ACTIVATION_PARAMS) == 28);

   #else
      typedef union _SEND_ACTIVATION_PARAMS {
         SEND_ACTIVATION_PARAMS_IN request;
         SEND_ACTIVATION_PARAMS_OUT response;
      } SG_PACK SEND_ACTIVATION_PARAMS, *PSEND_ACTIVATION_PARAMS;

      typedef union _SEND_ACTIVATION_PARAMS_UNION {
         SEND_ACTIVATION_PARAMS bits;
         u32 dw[7]; // dword union
      } SG_PACK SEND_ACTIVATION_PARAMS_UNION, *PSEND_ACTIVATION_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__SEND_ACTIVATION_PARAMS_UNION, sizeof (SEND_ACTIVATION_PARAMS_UNION) == 28);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to activate a feature.  The IOCTL may complete with the
   // following status/additional_status codes:  -  - SEND_ACTIVATION_STATUS_SUCCESS --
   // the request completed successfully.  - SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST /
   // SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by
   // firmware. This is the case for adapters installed with older firmware. A firmware
   // update is required to use this IOCTL.  - SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST /
   // SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field
   // indicates an unknown/unsupported version of the IOCTL.  -
   // SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY -- the activation key failed authentication.
   //  - SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED -- feature upgrade is not allowed on
   // the adapter.  - SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED -- the activation key is
   // authentic, however the requested feature is not allowed on the adapter.  -
   // SEND_ACTIVATION_STATUS_FEATURE_FREE -- the activation key is authentic, however the
   // requested feature is free on the adapter.  - SEND_ACTIVATION_STATUS_FEATURE_ACTIVE
   // -- the activation key is authentic, however the requested feature is active on the
   // adapter.  - SEND_ACTIVATION_STATUS_FEATURE_INVALID -- the activation key is
   // authentic, however the requested feature is not a valid feature number.  -
   // SEND_ACTIVATION_STATUS_FEATURE_UPGRADED -- for an activation, the requested feature
   // is presently upgraded; for a deactivation, the requested feature is not presently
   // upgraded. 
   typedef struct _IOCTL_COMMON_SEND_ACTIVATION {
      IOCTL_HEADER header;
      SEND_ACTIVATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SEND_ACTIVATION, *PIOCTL_COMMON_SEND_ACTIVATION;



#else
   // This IOCTL may be issued to activate a feature.  The IOCTL may complete with the
   // following status/additional_status codes:  -  - SEND_ACTIVATION_STATUS_SUCCESS --
   // the request completed successfully.  - SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST /
   // SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by
   // firmware. This is the case for adapters installed with older firmware. A firmware
   // update is required to use this IOCTL.  - SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST /
   // SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field
   // indicates an unknown/unsupported version of the IOCTL.  -
   // SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY -- the activation key failed authentication.
   //  - SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED -- feature upgrade is not allowed on
   // the adapter.  - SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED -- the activation key is
   // authentic, however the requested feature is not allowed on the adapter.  -
   // SEND_ACTIVATION_STATUS_FEATURE_FREE -- the activation key is authentic, however the
   // requested feature is free on the adapter.  - SEND_ACTIVATION_STATUS_FEATURE_ACTIVE
   // -- the activation key is authentic, however the requested feature is active on the
   // adapter.  - SEND_ACTIVATION_STATUS_FEATURE_INVALID -- the activation key is
   // authentic, however the requested feature is not a valid feature number.  -
   // SEND_ACTIVATION_STATUS_FEATURE_UPGRADED -- for an activation, the requested feature
   // is presently upgraded; for a deactivation, the requested feature is not presently
   // upgraded. 
   typedef struct _IOCTL_COMMON_SEND_ACTIVATION {
      IOCTL_HEADER header;
      SEND_ACTIVATION_PARAMS params;
   } SG_PACK IOCTL_COMMON_SEND_ACTIVATION, *PIOCTL_COMMON_SEND_ACTIVATION;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS_IN {
         union {
            struct { 
               UEXACT8 rsvd0[220];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS_IN, *PRESET_LICENSES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_IN, sizeof (RESET_LICENSES_PARAMS_IN) == 220);

   #else
      typedef struct _RESET_LICENSES_PARAMS_IN {
         UEXACT8 rsvd0[220];
      } SG_PACK RESET_LICENSES_PARAMS_IN, *PRESET_LICENSES_PARAMS_IN;

      typedef union _RESET_LICENSES_PARAMS_IN_UNION {
         RESET_LICENSES_PARAMS_IN bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_IN_UNION, *PRESET_LICENSES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_IN_UNION, sizeof (RESET_LICENSES_PARAMS_IN_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS_IN {
         union {
            struct { 
               UEXACT8 rsvd0[220];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS_IN, *PRESET_LICENSES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_IN, sizeof (RESET_LICENSES_PARAMS_IN) == 220);

   #else
      typedef struct _RESET_LICENSES_PARAMS_IN {
         UEXACT8 rsvd0[220];
      } SG_PACK RESET_LICENSES_PARAMS_IN, *PRESET_LICENSES_PARAMS_IN;

      typedef union _RESET_LICENSES_PARAMS_IN_UNION {
         RESET_LICENSES_PARAMS_IN bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_IN_UNION, *PRESET_LICENSES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_IN_UNION, sizeof (RESET_LICENSES_PARAMS_IN_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 rsvd0[220];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS_OUT, *PRESET_LICENSES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_OUT, sizeof (RESET_LICENSES_PARAMS_OUT) == 220);

   #else
      typedef struct _RESET_LICENSES_PARAMS_OUT {
         UEXACT8 rsvd0[220];
      } SG_PACK RESET_LICENSES_PARAMS_OUT, *PRESET_LICENSES_PARAMS_OUT;

      typedef union _RESET_LICENSES_PARAMS_OUT_UNION {
         RESET_LICENSES_PARAMS_OUT bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_OUT_UNION, *PRESET_LICENSES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_OUT_UNION, sizeof (RESET_LICENSES_PARAMS_OUT_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS_OUT {
         union {
            struct { 
               UEXACT8 rsvd0[220];
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS_OUT, *PRESET_LICENSES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_OUT, sizeof (RESET_LICENSES_PARAMS_OUT) == 220);

   #else
      typedef struct _RESET_LICENSES_PARAMS_OUT {
         UEXACT8 rsvd0[220];
      } SG_PACK RESET_LICENSES_PARAMS_OUT, *PRESET_LICENSES_PARAMS_OUT;

      typedef union _RESET_LICENSES_PARAMS_OUT_UNION {
         RESET_LICENSES_PARAMS_OUT bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_OUT_UNION, *PRESET_LICENSES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_OUT_UNION, sizeof (RESET_LICENSES_PARAMS_OUT_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS {
         union {
            union { 
               RESET_LICENSES_PARAMS_IN request;
               RESET_LICENSES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS, *PRESET_LICENSES_PARAMS;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS, sizeof (RESET_LICENSES_PARAMS) == 220);

   #else
      typedef union _RESET_LICENSES_PARAMS {
         RESET_LICENSES_PARAMS_IN request;
         RESET_LICENSES_PARAMS_OUT response;
      } SG_PACK RESET_LICENSES_PARAMS, *PRESET_LICENSES_PARAMS;

      typedef union _RESET_LICENSES_PARAMS_UNION {
         RESET_LICENSES_PARAMS bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_UNION, *PRESET_LICENSES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_UNION, sizeof (RESET_LICENSES_PARAMS_UNION) == 220);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _RESET_LICENSES_PARAMS {
         union {
            union { 
               RESET_LICENSES_PARAMS_IN request;
               RESET_LICENSES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[55]; // dword union
         }; // unnamed union
      } SG_PACK RESET_LICENSES_PARAMS, *PRESET_LICENSES_PARAMS;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS, sizeof (RESET_LICENSES_PARAMS) == 220);

   #else
      typedef union _RESET_LICENSES_PARAMS {
         RESET_LICENSES_PARAMS_IN request;
         RESET_LICENSES_PARAMS_OUT response;
      } SG_PACK RESET_LICENSES_PARAMS, *PRESET_LICENSES_PARAMS;

      typedef union _RESET_LICENSES_PARAMS_UNION {
         RESET_LICENSES_PARAMS bits;
         u32 dw[55]; // dword union
      } SG_PACK RESET_LICENSES_PARAMS_UNION, *PRESET_LICENSES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__RESET_LICENSES_PARAMS_UNION, sizeof (RESET_LICENSES_PARAMS_UNION) == 220);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL may be issued to reset all licensed features. Only a physical function
   // may issue the command. This is a destructive operation that cannot be recovered. 
   // The IOCTL may complete with the following status/additional_status codes:  -  -
   // RESET_LICENSES_STATUS_SUCCESS -- the request completed successfully.  -
   // RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST -- an unauthorized function has issued
   // the IOCTL. Only a physical function may issue the command.  -
   // RESET_LICENSES_STATUS_LICENSE_IN_USE -- a licensed feature is currently in use and
   // cannot be reset. A user must disable active licensed features before resetting the
   // licenses.  - RESET_LICENSES_STATUS_ILLEGAL_REQUEST /
   // RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by firmware.
   // This is the case for adapters installed with older firmware. A firmware update is
   // required to use this IOCTL.  - RESET_LICENSES_STATUS_ILLEGAL_REQUEST /
   // RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field
   // indicates an unknown/unsupported version of the IOCTL. 
   typedef struct _IOCTL_COMMON_RESET_LICENSES {
      IOCTL_HEADER header;
      RESET_LICENSES_PARAMS params;
   } SG_PACK IOCTL_COMMON_RESET_LICENSES, *PIOCTL_COMMON_RESET_LICENSES;



#else
   // This IOCTL may be issued to reset all licensed features. Only a physical function
   // may issue the command. This is a destructive operation that cannot be recovered. 
   // The IOCTL may complete with the following status/additional_status codes:  -  -
   // RESET_LICENSES_STATUS_SUCCESS -- the request completed successfully.  -
   // RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST -- an unauthorized function has issued
   // the IOCTL. Only a physical function may issue the command.  -
   // RESET_LICENSES_STATUS_LICENSE_IN_USE -- a licensed feature is currently in use and
   // cannot be reset. A user must disable active licensed features before resetting the
   // licenses.  - RESET_LICENSES_STATUS_ILLEGAL_REQUEST /
   // RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE -- the IOCTL is not supported by firmware.
   // This is the case for adapters installed with older firmware. A firmware update is
   // required to use this IOCTL.  - RESET_LICENSES_STATUS_ILLEGAL_REQUEST /
   // RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST -- the IOCTL header version field
   // indicates an unknown/unsupported version of the IOCTL. 
   typedef struct _IOCTL_COMMON_RESET_LICENSES {
      IOCTL_HEADER header;
      RESET_LICENSES_PARAMS params;
   } SG_PACK IOCTL_COMMON_RESET_LICENSES, *PIOCTL_COMMON_RESET_LICENSES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN {
         union {
            struct { 
               UEXACT32 rsvd0;
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN) == 4);

   #else
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN {
         UEXACT32 rsvd0;
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN bits;
         u32 dw; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 ipl_file_number;
               UEXACT8 ipl_file_version;
               UEXACT8 rsvd0;
               UEXACT8 on_die_temperature;
               UEXACT8 rsvd1[3];
               UEXACT32 driver_advanced_features_supported;
               UEXACT32 rsvd2[4];
               UEXACT8 fcoe_universal_bios_version[32];
               UEXACT8 fcoe_x86_bios_version[32];
               UEXACT8 fcoe_efi_bios_version[32];
               UEXACT8 fcoe_fcode_version[32];
               UEXACT8 uefi_bios_version[32];
               UEXACT8 uefi_nic_version[32];
               UEXACT8 uefi_fcode_version[32];
               UEXACT8 uefi_iscsi_version[32];
               UEXACT8 iscsi_x86_bios_version[32];
               UEXACT8 pxe_x86_bios_version[32];
               UEXACT8 fcoe_default_wwpn[8];
               UEXACT8 rsvd3[120];
            } SG_PACK ; // unnamed struct
            u32 dw[119]; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT) == 476);

   #else
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT {
         UEXACT16 ipl_file_number;
         UEXACT8 ipl_file_version;
         UEXACT8 rsvd0;
         UEXACT8 on_die_temperature;
         UEXACT8 rsvd1[3];
         UEXACT32 driver_advanced_features_supported;
         UEXACT32 rsvd2[4];
         UEXACT8 fcoe_universal_bios_version[32];
         UEXACT8 fcoe_x86_bios_version[32];
         UEXACT8 fcoe_efi_bios_version[32];
         UEXACT8 fcoe_fcode_version[32];
         UEXACT8 uefi_bios_version[32];
         UEXACT8 uefi_nic_version[32];
         UEXACT8 uefi_fcode_version[32];
         UEXACT8 uefi_iscsi_version[32];
         UEXACT8 iscsi_x86_bios_version[32];
         UEXACT8 pxe_x86_bios_version[32];
         UEXACT8 fcoe_default_wwpn[8];
         UEXACT8 rsvd3[120];
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[119]; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION) == 476);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT {
         union {
            struct { 
               UEXACT16 ipl_file_number;
               UEXACT8 ipl_file_version;
               UEXACT8 rsvd0;
               UEXACT8 on_die_temperature;
               UEXACT8 rsvd1[3];
               UEXACT32 driver_advanced_features_supported;
               UEXACT32 rsvd2[4];
               UEXACT8 fcoe_universal_bios_version[32];
               UEXACT8 fcoe_x86_bios_version[32];
               UEXACT8 fcoe_efi_bios_version[32];
               UEXACT8 fcoe_fcode_version[32];
               UEXACT8 uefi_bios_version[32];
               UEXACT8 uefi_nic_version[32];
               UEXACT8 uefi_fcode_version[32];
               UEXACT8 uefi_iscsi_version[32];
               UEXACT8 iscsi_x86_bios_version[32];
               UEXACT8 pxe_x86_bios_version[32];
               UEXACT8 fcoe_default_wwpn[8];
               UEXACT8 rsvd3[120];
            } SG_PACK ; // unnamed struct
            u32 dw[119]; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT) == 476);

   #else
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT {
         UEXACT16 ipl_file_number;
         UEXACT8 ipl_file_version;
         UEXACT8 rsvd0;
         UEXACT8 on_die_temperature;
         UEXACT8 rsvd1[3];
         UEXACT32 driver_advanced_features_supported;
         UEXACT32 rsvd2[4];
         UEXACT8 fcoe_universal_bios_version[32];
         UEXACT8 fcoe_x86_bios_version[32];
         UEXACT8 fcoe_efi_bios_version[32];
         UEXACT8 fcoe_fcode_version[32];
         UEXACT8 uefi_bios_version[32];
         UEXACT8 uefi_nic_version[32];
         UEXACT8 uefi_fcode_version[32];
         UEXACT8 uefi_iscsi_version[32];
         UEXACT8 iscsi_x86_bios_version[32];
         UEXACT8 pxe_x86_bios_version[32];
         UEXACT8 fcoe_default_wwpn[8];
         UEXACT8 rsvd3[120];
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT bits;
         u32 dw[119]; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_UNION) == 476);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS {
         union {
            union { 
               GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN request;
               GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[119]; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS) == 476);

   #else
      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN request;
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS bits;
         u32 dw[119]; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION) == 476);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS {
         union {
            union { 
               GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN request;
               GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[119]; // dword union
         }; // unnamed union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS) == 476);

   #else
      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN request;
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT response;
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS;

      typedef union _GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION {
         GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS bits;
         u32 dw[119]; // dword union
      } SG_PACK GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION, sizeof (GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_UNION) == 476);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This IOCTL returns may be issued to retrieve the versions for all the BIOSs
   // available on the BE controller. 
   typedef struct _IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES, *PIOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES;



#else
   // This IOCTL returns may be issued to retrieve the versions for all the BIOSs
   // available on the BE controller. 
   typedef struct _IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES {
      IOCTL_HEADER header;
      GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS params;
   } SG_PACK IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES, *PIOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES;



#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS_IN {
         union {
            struct { 
               UEXACT32 direction;
               UEXACT32 host_buf_len;
               UEXACT64 host_buf_addr;
               UEXACT64 buffer_id;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN, *PDMA_HOST_BUFFER_PARAMS_IN;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_IN, sizeof (DMA_HOST_BUFFER_PARAMS_IN) == 24);

   #else
      typedef struct _DMA_HOST_BUFFER_PARAMS_IN {
         UEXACT32 direction;
         UEXACT32 host_buf_len;
         UEXACT64 host_buf_addr;
         UEXACT64 buffer_id;
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN, *PDMA_HOST_BUFFER_PARAMS_IN;

      typedef union _DMA_HOST_BUFFER_PARAMS_IN_UNION {
         DMA_HOST_BUFFER_PARAMS_IN bits;
         u32 dw[6]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN_UNION, *PDMA_HOST_BUFFER_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_IN_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_IN_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS_IN {
         union {
            struct { 
               UEXACT32 direction;
               UEXACT32 host_buf_len;
               UEXACT64 host_buf_addr;
               UEXACT64 buffer_id;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN, *PDMA_HOST_BUFFER_PARAMS_IN;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_IN, sizeof (DMA_HOST_BUFFER_PARAMS_IN) == 24);

   #else
      typedef struct _DMA_HOST_BUFFER_PARAMS_IN {
         UEXACT32 direction;
         UEXACT32 host_buf_len;
         UEXACT64 host_buf_addr;
         UEXACT64 buffer_id;
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN, *PDMA_HOST_BUFFER_PARAMS_IN;

      typedef union _DMA_HOST_BUFFER_PARAMS_IN_UNION {
         DMA_HOST_BUFFER_PARAMS_IN bits;
         u32 dw[6]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_IN_UNION, *PDMA_HOST_BUFFER_PARAMS_IN_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_IN_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_IN_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS_OUT {
         union {
            struct { 
               UEXACT64 buffer_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT, *PDMA_HOST_BUFFER_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_OUT, sizeof (DMA_HOST_BUFFER_PARAMS_OUT) == 8);

   #else
      typedef struct _DMA_HOST_BUFFER_PARAMS_OUT {
         UEXACT64 buffer_id;
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT, *PDMA_HOST_BUFFER_PARAMS_OUT;

      typedef union _DMA_HOST_BUFFER_PARAMS_OUT_UNION {
         DMA_HOST_BUFFER_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT_UNION, *PDMA_HOST_BUFFER_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_OUT_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_OUT_UNION) == 8);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS_OUT {
         union {
            struct { 
               UEXACT64 buffer_id;
            } SG_PACK ; // unnamed struct
            u32 dw[2]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT, *PDMA_HOST_BUFFER_PARAMS_OUT;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_OUT, sizeof (DMA_HOST_BUFFER_PARAMS_OUT) == 8);

   #else
      typedef struct _DMA_HOST_BUFFER_PARAMS_OUT {
         UEXACT64 buffer_id;
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT, *PDMA_HOST_BUFFER_PARAMS_OUT;

      typedef union _DMA_HOST_BUFFER_PARAMS_OUT_UNION {
         DMA_HOST_BUFFER_PARAMS_OUT bits;
         u32 dw[2]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_OUT_UNION, *PDMA_HOST_BUFFER_PARAMS_OUT_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_OUT_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_OUT_UNION) == 8);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS {
         union {
            union { 
               DMA_HOST_BUFFER_PARAMS_IN request;
               DMA_HOST_BUFFER_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS, *PDMA_HOST_BUFFER_PARAMS;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS, sizeof (DMA_HOST_BUFFER_PARAMS) == 24);

   #else
      typedef union _DMA_HOST_BUFFER_PARAMS {
         DMA_HOST_BUFFER_PARAMS_IN request;
         DMA_HOST_BUFFER_PARAMS_OUT response;
      } SG_PACK DMA_HOST_BUFFER_PARAMS, *PDMA_HOST_BUFFER_PARAMS;

      typedef union _DMA_HOST_BUFFER_PARAMS_UNION {
         DMA_HOST_BUFFER_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_UNION, *PDMA_HOST_BUFFER_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_UNION) == 24);
   #endif


#else
   
   #if defined(SG_BMAP_UNION)
      typedef struct _DMA_HOST_BUFFER_PARAMS {
         union {
            union { 
               DMA_HOST_BUFFER_PARAMS_IN request;
               DMA_HOST_BUFFER_PARAMS_OUT response;
            } SG_PACK ; // unnamed struct
            u32 dw[6]; // dword union
         }; // unnamed union
      } SG_PACK DMA_HOST_BUFFER_PARAMS, *PDMA_HOST_BUFFER_PARAMS;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS, sizeof (DMA_HOST_BUFFER_PARAMS) == 24);

   #else
      typedef union _DMA_HOST_BUFFER_PARAMS {
         DMA_HOST_BUFFER_PARAMS_IN request;
         DMA_HOST_BUFFER_PARAMS_OUT response;
      } SG_PACK DMA_HOST_BUFFER_PARAMS, *PDMA_HOST_BUFFER_PARAMS;

      typedef union _DMA_HOST_BUFFER_PARAMS_UNION {
         DMA_HOST_BUFFER_PARAMS bits;
         u32 dw[6]; // dword union
      } SG_PACK DMA_HOST_BUFFER_PARAMS_UNION, *PDMA_HOST_BUFFER_PARAMS_UNION;

      SG_C_ASSERT(__sizeof__DMA_HOST_BUFFER_PARAMS_UNION, sizeof (DMA_HOST_BUFFER_PARAMS_UNION) == 24);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This Ioctl is currently used by PXE Option ROM to store the host memory segment
   // contents temporarily as those segments will be used by the optionROMs for temporary
   // use and restore the contents back into those segments before booting continues. 
   typedef struct _IOCTL_COMMON_DMA_HOST_BUFFER {
      IOCTL_HEADER header;
      DMA_HOST_BUFFER_PARAMS params;
   } SG_PACK IOCTL_COMMON_DMA_HOST_BUFFER, *PIOCTL_COMMON_DMA_HOST_BUFFER;



#else
   // This Ioctl is currently used by PXE Option ROM to store the host memory segment
   // contents temporarily as those segments will be used by the optionROMs for temporary
   // use and restore the contents back into those segments before booting continues. 
   typedef struct _IOCTL_COMMON_DMA_HOST_BUFFER {
      IOCTL_HEADER header;
      DMA_HOST_BUFFER_PARAMS params;
   } SG_PACK IOCTL_COMMON_DMA_HOST_BUFFER, *PIOCTL_COMMON_DMA_HOST_BUFFER;



#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_bmap_h__

