/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __mpu_bmap_h__
#define __mpu_bmap_h__
#include "setypes.h"
#include "pq_bmap.h"
#include "ep_bmap.h"
#include "defines_bmap.h"
#include "btlr_bmap.h"
#include "ep_minirom_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "armsys_bmap.h"
#include "armddr_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // General control register for MPU. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_GEN_CONTROL {
         union {
            struct { 
               u32 rsvd0 : 29;                    // DWORD 0
               u32 complex_almost_full : 1;       // DWORD 0
               u32 disable_complex : 1;           // DWORD 0
               u32 enable_sm_iq : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_GEN_CONTROL, *PMPU_GEN_CONTROL;

      SG_C_ASSERT(__sizeof__MPU_GEN_CONTROL, sizeof (MPU_GEN_CONTROL) == 4);

   #else
      typedef struct _MPU_GEN_CONTROL {
         u32 rsvd0 : 29;                          // DWORD 0
         u32 complex_almost_full : 1;             // DWORD 0
         u32 disable_complex : 1;                 // DWORD 0
         u32 enable_sm_iq : 1;                    // DWORD 0
      } SG_PACK MPU_GEN_CONTROL, *PMPU_GEN_CONTROL;

      typedef union _MPU_GEN_CONTROL_UNION {
         MPU_GEN_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK MPU_GEN_CONTROL_UNION, *PMPU_GEN_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__MPU_GEN_CONTROL_UNION, sizeof (MPU_GEN_CONTROL_UNION) == 4);
   #endif


#else
   // General control register for MPU. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_GEN_CONTROL {
         union {
            struct { 
               u32 enable_sm_iq : 1;              // DWORD 0
               u32 disable_complex : 1;           // DWORD 0
               u32 complex_almost_full : 1;       // DWORD 0
               u32 rsvd0 : 29;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_GEN_CONTROL, *PMPU_GEN_CONTROL;

      SG_C_ASSERT(__sizeof__MPU_GEN_CONTROL, sizeof (MPU_GEN_CONTROL) == 4);

   #else
      typedef struct _MPU_GEN_CONTROL {
         u32 enable_sm_iq : 1;                    // DWORD 0
         u32 disable_complex : 1;                 // DWORD 0
         u32 complex_almost_full : 1;             // DWORD 0
         u32 rsvd0 : 29;                          // DWORD 0
      } SG_PACK MPU_GEN_CONTROL, *PMPU_GEN_CONTROL;

      typedef union _MPU_GEN_CONTROL_UNION {
         MPU_GEN_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK MPU_GEN_CONTROL_UNION, *PMPU_GEN_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__MPU_GEN_CONTROL_UNION, sizeof (MPU_GEN_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw interrupt source bits, not masked by MASK.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 btlr_violation : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SOURCE, *PMPU_INT_SOURCE;

      SG_C_ASSERT(__sizeof__MPU_INT_SOURCE, sizeof (MPU_INT_SOURCE) == 4);

   #else
      typedef struct _MPU_INT_SOURCE {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 btlr_violation : 1;                  // DWORD 0
      } SG_PACK MPU_INT_SOURCE, *PMPU_INT_SOURCE;

      typedef union _MPU_INT_SOURCE_UNION {
         MPU_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SOURCE_UNION, *PMPU_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SOURCE_UNION, sizeof (MPU_INT_SOURCE_UNION) == 4);
   #endif


#else
   // Raw interrupt source bits, not masked by MASK.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_SOURCE {
         union {
            struct { 
               u32 btlr_violation : 1;            // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_SOURCE, *PMPU_INT_SOURCE;

      SG_C_ASSERT(__sizeof__MPU_INT_SOURCE, sizeof (MPU_INT_SOURCE) == 4);

   #else
      typedef struct _MPU_INT_SOURCE {
         u32 btlr_violation : 1;                  // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_INT_SOURCE, *PMPU_INT_SOURCE;

      typedef union _MPU_INT_SOURCE_UNION {
         MPU_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_SOURCE_UNION, *PMPU_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_SOURCE_UNION, sizeof (MPU_INT_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling interrupts. Write a 1 to disable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 pcicfg_stor_written : 1;       // DWORD 0
               u32 pcicfg_netw_written : 1;       // DWORD 0
               u32 btlr_stor_violation : 1;       // DWORD 0
               u32 btlr_netw_violation : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK, *PMPU_INT_MASK;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK, sizeof (MPU_INT_MASK) == 4);

   #else
      typedef struct _MPU_INT_MASK {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 pcicfg_stor_written : 1;             // DWORD 0
         u32 pcicfg_netw_written : 1;             // DWORD 0
         u32 btlr_stor_violation : 1;             // DWORD 0
         u32 btlr_netw_violation : 1;             // DWORD 0
      } SG_PACK MPU_INT_MASK, *PMPU_INT_MASK;

      typedef union _MPU_INT_MASK_UNION {
         MPU_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK_UNION, *PMPU_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK_UNION, sizeof (MPU_INT_MASK_UNION) == 4);
   #endif


#else
   // Mask for disabling interrupts. Write a 1 to disable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_MASK {
         union {
            struct { 
               u32 btlr_netw_violation : 1;       // DWORD 0
               u32 btlr_stor_violation : 1;       // DWORD 0
               u32 pcicfg_netw_written : 1;       // DWORD 0
               u32 pcicfg_stor_written : 1;       // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_MASK, *PMPU_INT_MASK;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK, sizeof (MPU_INT_MASK) == 4);

   #else
      typedef struct _MPU_INT_MASK {
         u32 btlr_netw_violation : 1;             // DWORD 0
         u32 btlr_stor_violation : 1;             // DWORD 0
         u32 pcicfg_netw_written : 1;             // DWORD 0
         u32 pcicfg_stor_written : 1;             // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK MPU_INT_MASK, *PMPU_INT_MASK;

      typedef union _MPU_INT_MASK_UNION {
         MPU_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_MASK_UNION, *PMPU_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_MASK_UNION, sizeof (MPU_INT_MASK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_SOURCE {
         union {
            struct { 
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 txpb_parity_ue : 1;            // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
               u32 mbox_sram_parity_error : 1;    // DWORD 0
               u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
               u32 arm_ue_4 : 1;                  // DWORD 0
               u32 arm_ue_3 : 1;                  // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 rr_ue_nomatch : 1;             // DWORD 0
               u32 rr_ue_err : 1;                 // DWORD 0
               u32 arm_ue_2 : 1;                  // DWORD 0
               u32 arm_ue_1 : 1;                  // DWORD 0
               u32 arm_ddr2 : 1;                  // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 sram_perror : 6;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_SOURCE, *PMPU_UE_SOURCE;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE, sizeof (MPU_UE_SOURCE) == 4);

   #else
      typedef struct _MPU_UE_SOURCE {
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 txpb_parity_ue : 1;                  // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
         u32 mbox_sram_parity_error : 1;          // DWORD 0
         u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
         u32 arm_ue_4 : 1;                        // DWORD 0
         u32 arm_ue_3 : 1;                        // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 arm_ue_2 : 1;                        // DWORD 0
         u32 arm_ue_1 : 1;                        // DWORD 0
         u32 arm_ddr2 : 1;                        // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 sram_perror : 6;                     // DWORD 0
      } SG_PACK MPU_UE_SOURCE, *PMPU_UE_SOURCE;

      typedef union _MPU_UE_SOURCE_UNION {
         MPU_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_SOURCE_UNION, *PMPU_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE_UNION, sizeof (MPU_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_SOURCE {
         union {
            struct { 
               u32 sram_perror : 6;               // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 arm_ddr2 : 1;                  // DWORD 0
               u32 arm_ue_1 : 1;                  // DWORD 0
               u32 arm_ue_2 : 1;                  // DWORD 0
               u32 rr_ue_err : 1;                 // DWORD 0
               u32 rr_ue_nomatch : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 arm_ue_3 : 1;                  // DWORD 0
               u32 arm_ue_4 : 1;                  // DWORD 0
               u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
               u32 mbox_sram_parity_error : 1;    // DWORD 0
               u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
               u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 txpb_parity_ue : 1;            // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_SOURCE, *PMPU_UE_SOURCE;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE, sizeof (MPU_UE_SOURCE) == 4);

   #else
      typedef struct _MPU_UE_SOURCE {
         u32 sram_perror : 6;                     // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 arm_ddr2 : 1;                        // DWORD 0
         u32 arm_ue_1 : 1;                        // DWORD 0
         u32 arm_ue_2 : 1;                        // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 arm_ue_3 : 1;                        // DWORD 0
         u32 arm_ue_4 : 1;                        // DWORD 0
         u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
         u32 mbox_sram_parity_error : 1;          // DWORD 0
         u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
         u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 txpb_parity_ue : 1;                  // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
      } SG_PACK MPU_UE_SOURCE, *PMPU_UE_SOURCE;

      typedef union _MPU_UE_SOURCE_UNION {
         MPU_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_SOURCE_UNION, *PMPU_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE_UNION, sizeof (MPU_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_ENABLE {
         union {
            struct { 
               u32 pmem_parity_ue : 1;            // DWORD 0
               u32 txpb_parity_ue : 1;            // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
               u32 mbox_sram_parity_error : 1;    // DWORD 0
               u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
               u32 arm_ue_4 : 1;                  // DWORD 0
               u32 arm_ue_3 : 1;                  // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 rr_ue_nomatch : 1;             // DWORD 0
               u32 rr_ue_err : 1;                 // DWORD 0
               u32 arm_ue_2 : 1;                  // DWORD 0
               u32 arm_ue_1 : 1;                  // DWORD 0
               u32 arm_ddr2 : 1;                  // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 sram_perror : 6;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_ENABLE, *PMPU_UE_ENABLE;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE, sizeof (MPU_UE_ENABLE) == 4);

   #else
      typedef struct _MPU_UE_ENABLE {
         u32 pmem_parity_ue : 1;                  // DWORD 0
         u32 txpb_parity_ue : 1;                  // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
         u32 mbox_sram_parity_error : 1;          // DWORD 0
         u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
         u32 arm_ue_4 : 1;                        // DWORD 0
         u32 arm_ue_3 : 1;                        // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 arm_ue_2 : 1;                        // DWORD 0
         u32 arm_ue_1 : 1;                        // DWORD 0
         u32 arm_ddr2 : 1;                        // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 sram_perror : 6;                     // DWORD 0
      } SG_PACK MPU_UE_ENABLE, *PMPU_UE_ENABLE;

      typedef union _MPU_UE_ENABLE_UNION {
         MPU_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_ENABLE_UNION, *PMPU_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE_UNION, sizeof (MPU_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_ENABLE {
         union {
            struct { 
               u32 sram_perror : 6;               // DWORD 0
               u32 stats_parity_error : 1;        // DWORD 0
               u32 fw_ue : 1;                     // DWORD 0
               u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 arm_ddr2 : 1;                  // DWORD 0
               u32 arm_ue_1 : 1;                  // DWORD 0
               u32 arm_ue_2 : 1;                  // DWORD 0
               u32 rr_ue_err : 1;                 // DWORD 0
               u32 rr_ue_nomatch : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 arm_ue_3 : 1;                  // DWORD 0
               u32 arm_ue_4 : 1;                  // DWORD 0
               u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
               u32 mbox_sram_parity_error : 1;    // DWORD 0
               u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
               u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
               u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
               u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
               u32 ctx_parity_ue : 1;             // DWORD 0
               u32 txpb_parity_ue : 1;            // DWORD 0
               u32 pmem_parity_ue : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_ENABLE, *PMPU_UE_ENABLE;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE, sizeof (MPU_UE_ENABLE) == 4);

   #else
      typedef struct _MPU_UE_ENABLE {
         u32 sram_perror : 6;                     // DWORD 0
         u32 stats_parity_error : 1;              // DWORD 0
         u32 fw_ue : 1;                           // DWORD 0
         u32 detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 arm_ddr2 : 1;                        // DWORD 0
         u32 arm_ue_1 : 1;                        // DWORD 0
         u32 arm_ue_2 : 1;                        // DWORD 0
         u32 rr_ue_err : 1;                       // DWORD 0
         u32 rr_ue_nomatch : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 arm_ue_3 : 1;                        // DWORD 0
         u32 arm_ue_4 : 1;                        // DWORD 0
         u32 sram_access_during_init_ue_mbox : 1; // DWORD 0
         u32 mbox_sram_parity_error : 1;          // DWORD 0
         u32 sram_access_during_init_bank_x_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_ctx : 1; // DWORD 0
         u32 sram_access_during_init_bank_x_desc : 1; // DWORD 0
         u32 sram_access_during_init_bank_y_desc : 1; // DWORD 0
         u32 sram_access_during_init_shadow_ram : 1; // DWORD 0
         u32 ctx_parity_ue : 1;                   // DWORD 0
         u32 txpb_parity_ue : 1;                  // DWORD 0
         u32 pmem_parity_ue : 1;                  // DWORD 0
      } SG_PACK MPU_UE_ENABLE, *PMPU_UE_ENABLE;

      typedef union _MPU_UE_ENABLE_UNION {
         MPU_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_ENABLE_UNION, *PMPU_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE_UNION, sizeof (MPU_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_SOURCE1 {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 ipcomplex_flow : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_SOURCE1, *PMPU_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE1, sizeof (MPU_UE_SOURCE1) == 4);

   #else
      typedef struct _MPU_UE_SOURCE1 {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 ipcomplex_flow : 1;                  // DWORD 0
      } SG_PACK MPU_UE_SOURCE1, *PMPU_UE_SOURCE1;

      typedef union _MPU_UE_SOURCE1_UNION {
         MPU_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_SOURCE1_UNION, *PMPU_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE1_UNION, sizeof (MPU_UE_SOURCE1_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits, not masked by MASK. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_SOURCE1 {
         union {
            struct { 
               u32 ipcomplex_flow : 1;            // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_SOURCE1, *PMPU_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE1, sizeof (MPU_UE_SOURCE1) == 4);

   #else
      typedef struct _MPU_UE_SOURCE1 {
         u32 ipcomplex_flow : 1;                  // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_UE_SOURCE1, *PMPU_UE_SOURCE1;

      typedef union _MPU_UE_SOURCE1_UNION {
         MPU_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_SOURCE1_UNION, *PMPU_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_SOURCE1_UNION, sizeof (MPU_UE_SOURCE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_ENABLE1 {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 ipcomplex_flow : 1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_ENABLE1, *PMPU_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE1, sizeof (MPU_UE_ENABLE1) == 4);

   #else
      typedef struct _MPU_UE_ENABLE1 {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 ipcomplex_flow : 1;                  // DWORD 0
      } SG_PACK MPU_UE_ENABLE1, *PMPU_UE_ENABLE1;

      typedef union _MPU_UE_ENABLE1_UNION {
         MPU_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_ENABLE1_UNION, *PMPU_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE1_UNION, sizeof (MPU_UE_ENABLE1_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_UE_ENABLE1 {
         union {
            struct { 
               u32 ipcomplex_flow : 1;            // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_UE_ENABLE1, *PMPU_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE1, sizeof (MPU_UE_ENABLE1) == 4);

   #else
      typedef struct _MPU_UE_ENABLE1 {
         u32 ipcomplex_flow : 1;                  // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_UE_ENABLE1, *PMPU_UE_ENABLE1;

      typedef union _MPU_UE_ENABLE1_UNION {
         MPU_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_UE_ENABLE1_UNION, *PMPU_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__MPU_UE_ENABLE1_UNION, sizeof (MPU_UE_ENABLE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to control OCD TDebugInterrupts of EPs. Each processordrive an interrupt source
   // (ocdmodepulse). This is masked bythe MASK bits (1 is disabled) to determine if an
   // interrupt occurs. If an interrupt occurs, it may be sent to individualprocessors via
   // the route bits
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_TDEBUG_CTRL {
         union {
            struct { 
               u32 rsvd1 : 7;                     // DWORD 0
               u32 txulp2_route : 1;              // DWORD 0
               u32 txulp1_route : 1;              // DWORD 0
               u32 txulp0_route : 1;              // DWORD 0
               u32 rxulp2_route : 1;              // DWORD 0
               u32 rxulp1_route : 1;              // DWORD 0
               u32 rxulp0_route : 1;              // DWORD 0
               u32 mpu_route : 1;                 // DWORD 0
               u32 tpre_route : 1;                // DWORD 0
               u32 tpost_route : 1;               // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 force_ocdpulse : 1;            // DWORD 0
               u32 txulp2_mask : 1;               // DWORD 0
               u32 txulp1_mask : 1;               // DWORD 0
               u32 txulp0_mask : 1;               // DWORD 0
               u32 rxulp2_mask : 1;               // DWORD 0
               u32 rxulp1_mask : 1;               // DWORD 0
               u32 rxulp0_mask : 1;               // DWORD 0
               u32 mpu_mask : 1;                  // DWORD 0
               u32 tpre_mask : 1;                 // DWORD 0
               u32 tpost_mask : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_TDEBUG_CTRL, *PEP_TDEBUG_CTRL;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_CTRL, sizeof (EP_TDEBUG_CTRL) == 4);

   #else
      typedef struct _EP_TDEBUG_CTRL {
         u32 rsvd1 : 7;                           // DWORD 0
         u32 txulp2_route : 1;                    // DWORD 0
         u32 txulp1_route : 1;                    // DWORD 0
         u32 txulp0_route : 1;                    // DWORD 0
         u32 rxulp2_route : 1;                    // DWORD 0
         u32 rxulp1_route : 1;                    // DWORD 0
         u32 rxulp0_route : 1;                    // DWORD 0
         u32 mpu_route : 1;                       // DWORD 0
         u32 tpre_route : 1;                      // DWORD 0
         u32 tpost_route : 1;                     // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 force_ocdpulse : 1;                  // DWORD 0
         u32 txulp2_mask : 1;                     // DWORD 0
         u32 txulp1_mask : 1;                     // DWORD 0
         u32 txulp0_mask : 1;                     // DWORD 0
         u32 rxulp2_mask : 1;                     // DWORD 0
         u32 rxulp1_mask : 1;                     // DWORD 0
         u32 rxulp0_mask : 1;                     // DWORD 0
         u32 mpu_mask : 1;                        // DWORD 0
         u32 tpre_mask : 1;                       // DWORD 0
         u32 tpost_mask : 1;                      // DWORD 0
      } SG_PACK EP_TDEBUG_CTRL, *PEP_TDEBUG_CTRL;

      typedef union _EP_TDEBUG_CTRL_UNION {
         EP_TDEBUG_CTRL bits;
         u32 dw; // dword union
      } SG_PACK EP_TDEBUG_CTRL_UNION, *PEP_TDEBUG_CTRL_UNION;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_CTRL_UNION, sizeof (EP_TDEBUG_CTRL_UNION) == 4);
   #endif


#else
   // Used to control OCD TDebugInterrupts of EPs. Each processordrive an interrupt source
   // (ocdmodepulse). This is masked bythe MASK bits (1 is disabled) to determine if an
   // interrupt occurs. If an interrupt occurs, it may be sent to individualprocessors via
   // the route bits
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_TDEBUG_CTRL {
         union {
            struct { 
               u32 tpost_mask : 1;                // DWORD 0
               u32 tpre_mask : 1;                 // DWORD 0
               u32 mpu_mask : 1;                  // DWORD 0
               u32 rxulp0_mask : 1;               // DWORD 0
               u32 rxulp1_mask : 1;               // DWORD 0
               u32 rxulp2_mask : 1;               // DWORD 0
               u32 txulp0_mask : 1;               // DWORD 0
               u32 txulp1_mask : 1;               // DWORD 0
               u32 txulp2_mask : 1;               // DWORD 0
               u32 force_ocdpulse : 1;            // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 tpost_route : 1;               // DWORD 0
               u32 tpre_route : 1;                // DWORD 0
               u32 mpu_route : 1;                 // DWORD 0
               u32 rxulp0_route : 1;              // DWORD 0
               u32 rxulp1_route : 1;              // DWORD 0
               u32 rxulp2_route : 1;              // DWORD 0
               u32 txulp0_route : 1;              // DWORD 0
               u32 txulp1_route : 1;              // DWORD 0
               u32 txulp2_route : 1;              // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_TDEBUG_CTRL, *PEP_TDEBUG_CTRL;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_CTRL, sizeof (EP_TDEBUG_CTRL) == 4);

   #else
      typedef struct _EP_TDEBUG_CTRL {
         u32 tpost_mask : 1;                      // DWORD 0
         u32 tpre_mask : 1;                       // DWORD 0
         u32 mpu_mask : 1;                        // DWORD 0
         u32 rxulp0_mask : 1;                     // DWORD 0
         u32 rxulp1_mask : 1;                     // DWORD 0
         u32 rxulp2_mask : 1;                     // DWORD 0
         u32 txulp0_mask : 1;                     // DWORD 0
         u32 txulp1_mask : 1;                     // DWORD 0
         u32 txulp2_mask : 1;                     // DWORD 0
         u32 force_ocdpulse : 1;                  // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 tpost_route : 1;                     // DWORD 0
         u32 tpre_route : 1;                      // DWORD 0
         u32 mpu_route : 1;                       // DWORD 0
         u32 rxulp0_route : 1;                    // DWORD 0
         u32 rxulp1_route : 1;                    // DWORD 0
         u32 rxulp2_route : 1;                    // DWORD 0
         u32 txulp0_route : 1;                    // DWORD 0
         u32 txulp1_route : 1;                    // DWORD 0
         u32 txulp2_route : 1;                    // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
      } SG_PACK EP_TDEBUG_CTRL, *PEP_TDEBUG_CTRL;

      typedef union _EP_TDEBUG_CTRL_UNION {
         EP_TDEBUG_CTRL bits;
         u32 dw; // dword union
      } SG_PACK EP_TDEBUG_CTRL_UNION, *PEP_TDEBUG_CTRL_UNION;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_CTRL_UNION, sizeof (EP_TDEBUG_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Indicates individual processors are in OCDMODE or in PWAITMODE.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_TDEBUG_OCDMODE {
         union {
            struct { 
               u32 rsvd1 : 7;                     // DWORD 0
               u32 txulp2_pwaitmode : 1;          // DWORD 0
               u32 txulp1_pwaitmode : 1;          // DWORD 0
               u32 txulp0_pwaitmode : 1;          // DWORD 0
               u32 rxulp2_pwaitmode : 1;          // DWORD 0
               u32 rxulp1_pwaitmode : 1;          // DWORD 0
               u32 rxulp0_pwaitmode : 1;          // DWORD 0
               u32 mpu_pwaitmode : 1;             // DWORD 0
               u32 tpre_pwaitmode : 1;            // DWORD 0
               u32 tpost_pwaitmode : 1;           // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 txulp2_ocdmode : 1;            // DWORD 0
               u32 txulp1_ocdmode : 1;            // DWORD 0
               u32 txulp0_ocdmode : 1;            // DWORD 0
               u32 rxulp2_ocdmode : 1;            // DWORD 0
               u32 rxulp1_ocdmode : 1;            // DWORD 0
               u32 rxulp0_ocdmode : 1;            // DWORD 0
               u32 mpu_ocdmode : 1;               // DWORD 0
               u32 tpre_ocdmode : 1;              // DWORD 0
               u32 tpost_ocdmode : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_TDEBUG_OCDMODE, *PEP_TDEBUG_OCDMODE;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_OCDMODE, sizeof (EP_TDEBUG_OCDMODE) == 4);

   #else
      typedef struct _EP_TDEBUG_OCDMODE {
         u32 rsvd1 : 7;                           // DWORD 0
         u32 txulp2_pwaitmode : 1;                // DWORD 0
         u32 txulp1_pwaitmode : 1;                // DWORD 0
         u32 txulp0_pwaitmode : 1;                // DWORD 0
         u32 rxulp2_pwaitmode : 1;                // DWORD 0
         u32 rxulp1_pwaitmode : 1;                // DWORD 0
         u32 rxulp0_pwaitmode : 1;                // DWORD 0
         u32 mpu_pwaitmode : 1;                   // DWORD 0
         u32 tpre_pwaitmode : 1;                  // DWORD 0
         u32 tpost_pwaitmode : 1;                 // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 txulp2_ocdmode : 1;                  // DWORD 0
         u32 txulp1_ocdmode : 1;                  // DWORD 0
         u32 txulp0_ocdmode : 1;                  // DWORD 0
         u32 rxulp2_ocdmode : 1;                  // DWORD 0
         u32 rxulp1_ocdmode : 1;                  // DWORD 0
         u32 rxulp0_ocdmode : 1;                  // DWORD 0
         u32 mpu_ocdmode : 1;                     // DWORD 0
         u32 tpre_ocdmode : 1;                    // DWORD 0
         u32 tpost_ocdmode : 1;                   // DWORD 0
      } SG_PACK EP_TDEBUG_OCDMODE, *PEP_TDEBUG_OCDMODE;

      typedef union _EP_TDEBUG_OCDMODE_UNION {
         EP_TDEBUG_OCDMODE bits;
         u32 dw; // dword union
      } SG_PACK EP_TDEBUG_OCDMODE_UNION, *PEP_TDEBUG_OCDMODE_UNION;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_OCDMODE_UNION, sizeof (EP_TDEBUG_OCDMODE_UNION) == 4);
   #endif


#else
   // Indicates individual processors are in OCDMODE or in PWAITMODE.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_TDEBUG_OCDMODE {
         union {
            struct { 
               u32 tpost_ocdmode : 1;             // DWORD 0
               u32 tpre_ocdmode : 1;              // DWORD 0
               u32 mpu_ocdmode : 1;               // DWORD 0
               u32 rxulp0_ocdmode : 1;            // DWORD 0
               u32 rxulp1_ocdmode : 1;            // DWORD 0
               u32 rxulp2_ocdmode : 1;            // DWORD 0
               u32 txulp0_ocdmode : 1;            // DWORD 0
               u32 txulp1_ocdmode : 1;            // DWORD 0
               u32 txulp2_ocdmode : 1;            // DWORD 0
               u32 rsvd0 : 7;                     // DWORD 0
               u32 tpost_pwaitmode : 1;           // DWORD 0
               u32 tpre_pwaitmode : 1;            // DWORD 0
               u32 mpu_pwaitmode : 1;             // DWORD 0
               u32 rxulp0_pwaitmode : 1;          // DWORD 0
               u32 rxulp1_pwaitmode : 1;          // DWORD 0
               u32 rxulp2_pwaitmode : 1;          // DWORD 0
               u32 txulp0_pwaitmode : 1;          // DWORD 0
               u32 txulp1_pwaitmode : 1;          // DWORD 0
               u32 txulp2_pwaitmode : 1;          // DWORD 0
               u32 rsvd1 : 7;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_TDEBUG_OCDMODE, *PEP_TDEBUG_OCDMODE;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_OCDMODE, sizeof (EP_TDEBUG_OCDMODE) == 4);

   #else
      typedef struct _EP_TDEBUG_OCDMODE {
         u32 tpost_ocdmode : 1;                   // DWORD 0
         u32 tpre_ocdmode : 1;                    // DWORD 0
         u32 mpu_ocdmode : 1;                     // DWORD 0
         u32 rxulp0_ocdmode : 1;                  // DWORD 0
         u32 rxulp1_ocdmode : 1;                  // DWORD 0
         u32 rxulp2_ocdmode : 1;                  // DWORD 0
         u32 txulp0_ocdmode : 1;                  // DWORD 0
         u32 txulp1_ocdmode : 1;                  // DWORD 0
         u32 txulp2_ocdmode : 1;                  // DWORD 0
         u32 rsvd0 : 7;                           // DWORD 0
         u32 tpost_pwaitmode : 1;                 // DWORD 0
         u32 tpre_pwaitmode : 1;                  // DWORD 0
         u32 mpu_pwaitmode : 1;                   // DWORD 0
         u32 rxulp0_pwaitmode : 1;                // DWORD 0
         u32 rxulp1_pwaitmode : 1;                // DWORD 0
         u32 rxulp2_pwaitmode : 1;                // DWORD 0
         u32 txulp0_pwaitmode : 1;                // DWORD 0
         u32 txulp1_pwaitmode : 1;                // DWORD 0
         u32 txulp2_pwaitmode : 1;                // DWORD 0
         u32 rsvd1 : 7;                           // DWORD 0
      } SG_PACK EP_TDEBUG_OCDMODE, *PEP_TDEBUG_OCDMODE;

      typedef union _EP_TDEBUG_OCDMODE_UNION {
         EP_TDEBUG_OCDMODE bits;
         u32 dw; // dword union
      } SG_PACK EP_TDEBUG_OCDMODE_UNION, *PEP_TDEBUG_OCDMODE_UNION;

      SG_C_ASSERT(__sizeof__EP_TDEBUG_OCDMODE_UNION, sizeof (EP_TDEBUG_OCDMODE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Boot Control. Indicates boot control and status parameters.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 shadow_ram_init_done : 1;      // DWORD 0
               u32 bank_y_desc_init_done : 1;     // DWORD 0
               u32 bank_x_desc_init_done : 1;     // DWORD 0
               u32 bank_y_ctx_init_done : 1;      // DWORD 0
               u32 bank_x_ctx_init_done : 1;      // DWORD 0
               u32 cfg_ATS_enable : 1;            // DWORD 0
               u32 mbox_sram_init_done : 1;       // DWORD 0
               u32 bram_loading : 1;              // DWORD 0
               u32 ism_in_control : 1;            // DWORD 0
               u32 mpuismoff : 1;                 // DWORD 0
               u32 lpcboot_strap : 1;             // DWORD 0
               u32 crc_hash_disable : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_CTRL_CSR, *PMPU_BOOT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_CSR, sizeof (MPU_BOOT_CTRL_CSR) == 4);

   #else
      typedef struct _MPU_BOOT_CTRL_CSR {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 shadow_ram_init_done : 1;            // DWORD 0
         u32 bank_y_desc_init_done : 1;           // DWORD 0
         u32 bank_x_desc_init_done : 1;           // DWORD 0
         u32 bank_y_ctx_init_done : 1;            // DWORD 0
         u32 bank_x_ctx_init_done : 1;            // DWORD 0
         u32 cfg_ATS_enable : 1;                  // DWORD 0
         u32 mbox_sram_init_done : 1;             // DWORD 0
         u32 bram_loading : 1;                    // DWORD 0
         u32 ism_in_control : 1;                  // DWORD 0
         u32 mpuismoff : 1;                       // DWORD 0
         u32 lpcboot_strap : 1;                   // DWORD 0
         u32 crc_hash_disable : 1;                // DWORD 0
      } SG_PACK MPU_BOOT_CTRL_CSR, *PMPU_BOOT_CTRL_CSR;

      typedef union _MPU_BOOT_CTRL_CSR_UNION {
         MPU_BOOT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_CTRL_CSR_UNION, *PMPU_BOOT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_CSR_UNION, sizeof (MPU_BOOT_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Boot Control. Indicates boot control and status parameters.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_CTRL_CSR {
         union {
            struct { 
               u32 crc_hash_disable : 1;          // DWORD 0
               u32 lpcboot_strap : 1;             // DWORD 0
               u32 mpuismoff : 1;                 // DWORD 0
               u32 ism_in_control : 1;            // DWORD 0
               u32 bram_loading : 1;              // DWORD 0
               u32 mbox_sram_init_done : 1;       // DWORD 0
               u32 cfg_ATS_enable : 1;            // DWORD 0
               u32 bank_x_ctx_init_done : 1;      // DWORD 0
               u32 bank_y_ctx_init_done : 1;      // DWORD 0
               u32 bank_x_desc_init_done : 1;     // DWORD 0
               u32 bank_y_desc_init_done : 1;     // DWORD 0
               u32 shadow_ram_init_done : 1;      // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_CTRL_CSR, *PMPU_BOOT_CTRL_CSR;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_CSR, sizeof (MPU_BOOT_CTRL_CSR) == 4);

   #else
      typedef struct _MPU_BOOT_CTRL_CSR {
         u32 crc_hash_disable : 1;                // DWORD 0
         u32 lpcboot_strap : 1;                   // DWORD 0
         u32 mpuismoff : 1;                       // DWORD 0
         u32 ism_in_control : 1;                  // DWORD 0
         u32 bram_loading : 1;                    // DWORD 0
         u32 mbox_sram_init_done : 1;             // DWORD 0
         u32 cfg_ATS_enable : 1;                  // DWORD 0
         u32 bank_x_ctx_init_done : 1;            // DWORD 0
         u32 bank_y_ctx_init_done : 1;            // DWORD 0
         u32 bank_x_desc_init_done : 1;           // DWORD 0
         u32 bank_y_desc_init_done : 1;           // DWORD 0
         u32 shadow_ram_init_done : 1;            // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK MPU_BOOT_CTRL_CSR, *PMPU_BOOT_CTRL_CSR;

      typedef union _MPU_BOOT_CTRL_CSR_UNION {
         MPU_BOOT_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_CTRL_CSR_UNION, *PMPU_BOOT_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_CTRL_CSR_UNION, sizeof (MPU_BOOT_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Boot Status register. This register is used by MPU boot firmware to reflect
   // errors detected during boot. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_STATUS_CSR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 fw_boot_fail : 1;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_STATUS_CSR, *PMPU_BOOT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_CSR, sizeof (MPU_BOOT_STATUS_CSR) == 4);

   #else
      typedef struct _MPU_BOOT_STATUS_CSR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 fw_boot_fail : 1;                    // DWORD 0
      } SG_PACK MPU_BOOT_STATUS_CSR, *PMPU_BOOT_STATUS_CSR;

      typedef union _MPU_BOOT_STATUS_CSR_UNION {
         MPU_BOOT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_STATUS_CSR_UNION, *PMPU_BOOT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_CSR_UNION, sizeof (MPU_BOOT_STATUS_CSR_UNION) == 4);
   #endif


#else
   // MPU Boot Status register. This register is used by MPU boot firmware to reflect
   // errors detected during boot. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_BOOT_STATUS_CSR {
         union {
            struct { 
               u32 fw_boot_fail : 1;              // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_BOOT_STATUS_CSR, *PMPU_BOOT_STATUS_CSR;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_CSR, sizeof (MPU_BOOT_STATUS_CSR) == 4);

   #else
      typedef struct _MPU_BOOT_STATUS_CSR {
         u32 fw_boot_fail : 1;                    // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK MPU_BOOT_STATUS_CSR, *PMPU_BOOT_STATUS_CSR;

      typedef union _MPU_BOOT_STATUS_CSR_UNION {
         MPU_BOOT_STATUS_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_BOOT_STATUS_CSR_UNION, *PMPU_BOOT_STATUS_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_BOOT_STATUS_CSR_UNION, sizeof (MPU_BOOT_STATUS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allows direct bit banging of JTAG signals to the processors. This is used solely for
   // OCD purposes.In order, the JTAG input signals begin at the MPU and in order travel
   // to TPOST, TPRE, RXULP2, RXULP1, RXULP0, TXULP2, TXULP1, TXULP0 back to MPU.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_JTAG_INSERTION {
         union {
            struct { 
               u32 override : 1;                  // DWORD 0
               u32 enable_ocd : 1;                // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 chain : 4;                     // DWORD 0
               u32 jtrst : 1;                     // DWORD 0
               u32 jtms : 1;                      // DWORD 0
               u32 jtdi : 1;                      // DWORD 0
               u32 jtck : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_JTAG_INSERTION, *PMPU_JTAG_INSERTION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_INSERTION, sizeof (MPU_JTAG_INSERTION) == 4);

   #else
      typedef struct _MPU_JTAG_INSERTION {
         u32 override : 1;                        // DWORD 0
         u32 enable_ocd : 1;                      // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 chain : 4;                           // DWORD 0
         u32 jtrst : 1;                           // DWORD 0
         u32 jtms : 1;                            // DWORD 0
         u32 jtdi : 1;                            // DWORD 0
         u32 jtck : 1;                            // DWORD 0
      } SG_PACK MPU_JTAG_INSERTION, *PMPU_JTAG_INSERTION;

      typedef union _MPU_JTAG_INSERTION_UNION {
         MPU_JTAG_INSERTION bits;
         u32 dw; // dword union
      } SG_PACK MPU_JTAG_INSERTION_UNION, *PMPU_JTAG_INSERTION_UNION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_INSERTION_UNION, sizeof (MPU_JTAG_INSERTION_UNION) == 4);
   #endif


#else
   // Allows direct bit banging of JTAG signals to the processors. This is used solely for
   // OCD purposes.In order, the JTAG input signals begin at the MPU and in order travel
   // to TPOST, TPRE, RXULP2, RXULP1, RXULP0, TXULP2, TXULP1, TXULP0 back to MPU.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_JTAG_INSERTION {
         union {
            struct { 
               u32 jtck : 1;                      // DWORD 0
               u32 jtdi : 1;                      // DWORD 0
               u32 jtms : 1;                      // DWORD 0
               u32 jtrst : 1;                     // DWORD 0
               u32 chain : 4;                     // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
               u32 enable_ocd : 1;                // DWORD 0
               u32 override : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_JTAG_INSERTION, *PMPU_JTAG_INSERTION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_INSERTION, sizeof (MPU_JTAG_INSERTION) == 4);

   #else
      typedef struct _MPU_JTAG_INSERTION {
         u32 jtck : 1;                            // DWORD 0
         u32 jtdi : 1;                            // DWORD 0
         u32 jtms : 1;                            // DWORD 0
         u32 jtrst : 1;                           // DWORD 0
         u32 chain : 4;                           // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
         u32 enable_ocd : 1;                      // DWORD 0
         u32 override : 1;                        // DWORD 0
      } SG_PACK MPU_JTAG_INSERTION, *PMPU_JTAG_INSERTION;

      typedef union _MPU_JTAG_INSERTION_UNION {
         MPU_JTAG_INSERTION bits;
         u32 dw; // dword union
      } SG_PACK MPU_JTAG_INSERTION_UNION, *PMPU_JTAG_INSERTION_UNION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_INSERTION_UNION, sizeof (MPU_JTAG_INSERTION_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Holds the last 32 bits of data from the JTAG shift out chain. Takes TDO selected in
   // MPU_JTAG_INSERTION. Implementation Detail: Note that in a normal scan out sequence,
   // there are N+X+3 clocks, where N is the number of cycles needed to setup the shift
   // out sequence (usually 2 or 3), X is the number of bits of data, and 3 is the number
   // of TCK cycles (in conjuciton with TMS) to get back to an idle state. The logic
   // accomidates for these extra cycles, so that AFTER the extra cycles, the data will be
   // present in the 32 bit read. Note that data is shifted in lsb first (JTAG Spec) so a
   // 24 bit read will occupy the upper 24 bits of the 32 bit read data. This shift
   // register is completely ignorant of all internal states of various TAP controllers,
   // and simply shifts off of TCK. For this reason, extra TCKs (that would not affect TAP
   // SMs) will changed the data in this register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_JTAG_SHIFT {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_JTAG_SHIFT, *PMPU_JTAG_SHIFT;

      SG_C_ASSERT(__sizeof__MPU_JTAG_SHIFT, sizeof (MPU_JTAG_SHIFT) == 4);

   #else
      typedef struct _MPU_JTAG_SHIFT {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_JTAG_SHIFT, *PMPU_JTAG_SHIFT;

      typedef union _MPU_JTAG_SHIFT_UNION {
         MPU_JTAG_SHIFT bits;
         u32 dw; // dword union
      } SG_PACK MPU_JTAG_SHIFT_UNION, *PMPU_JTAG_SHIFT_UNION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_SHIFT_UNION, sizeof (MPU_JTAG_SHIFT_UNION) == 4);
   #endif


#else
   // Holds the last 32 bits of data from the JTAG shift out chain. Takes TDO selected in
   // MPU_JTAG_INSERTION. Implementation Detail: Note that in a normal scan out sequence,
   // there are N+X+3 clocks, where N is the number of cycles needed to setup the shift
   // out sequence (usually 2 or 3), X is the number of bits of data, and 3 is the number
   // of TCK cycles (in conjuciton with TMS) to get back to an idle state. The logic
   // accomidates for these extra cycles, so that AFTER the extra cycles, the data will be
   // present in the 32 bit read. Note that data is shifted in lsb first (JTAG Spec) so a
   // 24 bit read will occupy the upper 24 bits of the 32 bit read data. This shift
   // register is completely ignorant of all internal states of various TAP controllers,
   // and simply shifts off of TCK. For this reason, extra TCKs (that would not affect TAP
   // SMs) will changed the data in this register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_JTAG_SHIFT {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_JTAG_SHIFT, *PMPU_JTAG_SHIFT;

      SG_C_ASSERT(__sizeof__MPU_JTAG_SHIFT, sizeof (MPU_JTAG_SHIFT) == 4);

   #else
      typedef struct _MPU_JTAG_SHIFT {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_JTAG_SHIFT, *PMPU_JTAG_SHIFT;

      typedef union _MPU_JTAG_SHIFT_UNION {
         MPU_JTAG_SHIFT bits;
         u32 dw; // dword union
      } SG_PACK MPU_JTAG_SHIFT_UNION, *PMPU_JTAG_SHIFT_UNION;

      SG_C_ASSERT(__sizeof__MPU_JTAG_SHIFT_UNION, sizeof (MPU_JTAG_SHIFT_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Consel. Writing to this registers clears Overflow/Undeflow indications. The
   // multibit fields in this register suffer from bug 9829 and may yield occational
   // garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CONSEL_DEBUG0 {
         union {
            struct { 
               u32 drive8 : 8;                    // DWORD 0
               u32 grant8 : 8;                    // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 cur_cid : 6;                   // DWORD 0
               u32 iqstate : 2;                   // DWORD 0
               u32 numfifo : 2;                   // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 overflow : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_CONSEL_DEBUG0, *PMPU_CONSEL_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_CONSEL_DEBUG0, sizeof (MPU_CONSEL_DEBUG0) == 4);

   #else
      typedef struct _MPU_CONSEL_DEBUG0 {
         u32 drive8 : 8;                          // DWORD 0
         u32 grant8 : 8;                          // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 cur_cid : 6;                         // DWORD 0
         u32 iqstate : 2;                         // DWORD 0
         u32 numfifo : 2;                         // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 overflow : 1;                        // DWORD 0
      } SG_PACK MPU_CONSEL_DEBUG0, *PMPU_CONSEL_DEBUG0;

      typedef union _MPU_CONSEL_DEBUG0_UNION {
         MPU_CONSEL_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_CONSEL_DEBUG0_UNION, *PMPU_CONSEL_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_CONSEL_DEBUG0_UNION, sizeof (MPU_CONSEL_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Consel. Writing to this registers clears Overflow/Undeflow indications. The
   // multibit fields in this register suffer from bug 9829 and may yield occational
   // garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CONSEL_DEBUG0 {
         union {
            struct { 
               u32 overflow : 1;                  // DWORD 0
               u32 underflow : 1;                 // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 numfifo : 2;                   // DWORD 0
               u32 iqstate : 2;                   // DWORD 0
               u32 cur_cid : 6;                   // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 grant8 : 8;                    // DWORD 0
               u32 drive8 : 8;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_CONSEL_DEBUG0, *PMPU_CONSEL_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_CONSEL_DEBUG0, sizeof (MPU_CONSEL_DEBUG0) == 4);

   #else
      typedef struct _MPU_CONSEL_DEBUG0 {
         u32 overflow : 1;                        // DWORD 0
         u32 underflow : 1;                       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 numfifo : 2;                         // DWORD 0
         u32 iqstate : 2;                         // DWORD 0
         u32 cur_cid : 6;                         // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 grant8 : 8;                          // DWORD 0
         u32 drive8 : 8;                          // DWORD 0
      } SG_PACK MPU_CONSEL_DEBUG0, *PMPU_CONSEL_DEBUG0;

      typedef union _MPU_CONSEL_DEBUG0_UNION {
         MPU_CONSEL_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_CONSEL_DEBUG0_UNION, *PMPU_CONSEL_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_CONSEL_DEBUG0_UNION, sizeof (MPU_CONSEL_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Live values of interrupts from various sources. Note these values are in different
   // bit positions in MPU (ARM) memory space.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_DEBUG0 {
         union {
            struct { 
               u32 mbox_int : 1;                  // DWORD 0
               u32 p1_ob_link_int : 1;            // DWORD 0
               u32 p0_ob_link_int : 1;            // DWORD 0
               u32 wdma_int : 1;                  // DWORD 0
               u32 uc_int : 1;                    // DWORD 0
               u32 txulp2_int : 1;                // DWORD 0
               u32 txulp1_int : 1;                // DWORD 0
               u32 txulp0_int : 1;                // DWORD 0
               u32 txips_int : 1;                 // DWORD 0
               u32 tpre_int : 1;                  // DWORD 0
               u32 tpost_int : 1;                 // DWORD 0
               u32 tim_int : 1;                   // DWORD 0
               u32 rxulp2_int : 1;                // DWORD 0
               u32 rxulp1_int : 1;                // DWORD 0
               u32 rxulp0_int : 1;                // DWORD 0
               u32 rxips_int : 1;                 // DWORD 0
               u32 rxf_int : 1;                   // DWORD 0
               u32 rdma_int : 1;                  // DWORD 0
               u32 ptc_int : 1;                   // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 host_int : 8;                  // DWORD 0
               u32 erx_int : 1;                   // DWORD 0
               u32 dbuf_int : 1;                  // DWORD 0
               u32 ctx_int : 1;                   // DWORD 0
               u32 cev_int : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_DEBUG0, *PMPU_INT_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_INT_DEBUG0, sizeof (MPU_INT_DEBUG0) == 4);

   #else
      typedef struct _MPU_INT_DEBUG0 {
         u32 mbox_int : 1;                        // DWORD 0
         u32 p1_ob_link_int : 1;                  // DWORD 0
         u32 p0_ob_link_int : 1;                  // DWORD 0
         u32 wdma_int : 1;                        // DWORD 0
         u32 uc_int : 1;                          // DWORD 0
         u32 txulp2_int : 1;                      // DWORD 0
         u32 txulp1_int : 1;                      // DWORD 0
         u32 txulp0_int : 1;                      // DWORD 0
         u32 txips_int : 1;                       // DWORD 0
         u32 tpre_int : 1;                        // DWORD 0
         u32 tpost_int : 1;                       // DWORD 0
         u32 tim_int : 1;                         // DWORD 0
         u32 rxulp2_int : 1;                      // DWORD 0
         u32 rxulp1_int : 1;                      // DWORD 0
         u32 rxulp0_int : 1;                      // DWORD 0
         u32 rxips_int : 1;                       // DWORD 0
         u32 rxf_int : 1;                         // DWORD 0
         u32 rdma_int : 1;                        // DWORD 0
         u32 ptc_int : 1;                         // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 host_int : 8;                        // DWORD 0
         u32 erx_int : 1;                         // DWORD 0
         u32 dbuf_int : 1;                        // DWORD 0
         u32 ctx_int : 1;                         // DWORD 0
         u32 cev_int : 1;                         // DWORD 0
      } SG_PACK MPU_INT_DEBUG0, *PMPU_INT_DEBUG0;

      typedef union _MPU_INT_DEBUG0_UNION {
         MPU_INT_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_DEBUG0_UNION, *PMPU_INT_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_DEBUG0_UNION, sizeof (MPU_INT_DEBUG0_UNION) == 4);
   #endif


#else
   // Live values of interrupts from various sources. Note these values are in different
   // bit positions in MPU (ARM) memory space.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_INT_DEBUG0 {
         union {
            struct { 
               u32 cev_int : 1;                   // DWORD 0
               u32 ctx_int : 1;                   // DWORD 0
               u32 dbuf_int : 1;                  // DWORD 0
               u32 erx_int : 1;                   // DWORD 0
               u32 host_int : 8;                  // DWORD 0
               u32 mpu_int : 1;                   // DWORD 0
               u32 ptc_int : 1;                   // DWORD 0
               u32 rdma_int : 1;                  // DWORD 0
               u32 rxf_int : 1;                   // DWORD 0
               u32 rxips_int : 1;                 // DWORD 0
               u32 rxulp0_int : 1;                // DWORD 0
               u32 rxulp1_int : 1;                // DWORD 0
               u32 rxulp2_int : 1;                // DWORD 0
               u32 tim_int : 1;                   // DWORD 0
               u32 tpost_int : 1;                 // DWORD 0
               u32 tpre_int : 1;                  // DWORD 0
               u32 txips_int : 1;                 // DWORD 0
               u32 txulp0_int : 1;                // DWORD 0
               u32 txulp1_int : 1;                // DWORD 0
               u32 txulp2_int : 1;                // DWORD 0
               u32 uc_int : 1;                    // DWORD 0
               u32 wdma_int : 1;                  // DWORD 0
               u32 p0_ob_link_int : 1;            // DWORD 0
               u32 p1_ob_link_int : 1;            // DWORD 0
               u32 mbox_int : 1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_INT_DEBUG0, *PMPU_INT_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_INT_DEBUG0, sizeof (MPU_INT_DEBUG0) == 4);

   #else
      typedef struct _MPU_INT_DEBUG0 {
         u32 cev_int : 1;                         // DWORD 0
         u32 ctx_int : 1;                         // DWORD 0
         u32 dbuf_int : 1;                        // DWORD 0
         u32 erx_int : 1;                         // DWORD 0
         u32 host_int : 8;                        // DWORD 0
         u32 mpu_int : 1;                         // DWORD 0
         u32 ptc_int : 1;                         // DWORD 0
         u32 rdma_int : 1;                        // DWORD 0
         u32 rxf_int : 1;                         // DWORD 0
         u32 rxips_int : 1;                       // DWORD 0
         u32 rxulp0_int : 1;                      // DWORD 0
         u32 rxulp1_int : 1;                      // DWORD 0
         u32 rxulp2_int : 1;                      // DWORD 0
         u32 tim_int : 1;                         // DWORD 0
         u32 tpost_int : 1;                       // DWORD 0
         u32 tpre_int : 1;                        // DWORD 0
         u32 txips_int : 1;                       // DWORD 0
         u32 txulp0_int : 1;                      // DWORD 0
         u32 txulp1_int : 1;                      // DWORD 0
         u32 txulp2_int : 1;                      // DWORD 0
         u32 uc_int : 1;                          // DWORD 0
         u32 wdma_int : 1;                        // DWORD 0
         u32 p0_ob_link_int : 1;                  // DWORD 0
         u32 p1_ob_link_int : 1;                  // DWORD 0
         u32 mbox_int : 1;                        // DWORD 0
      } SG_PACK MPU_INT_DEBUG0, *PMPU_INT_DEBUG0;

      typedef union _MPU_INT_DEBUG0_UNION {
         MPU_INT_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_INT_DEBUG0_UNION, *PMPU_INT_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_INT_DEBUG0_UNION, sizeof (MPU_INT_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow
   // indications.The multibit fields in this register suffer from bug 9829 and may yield
   // occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_DEBUG0 {
         union {
            struct { 
               u32 ndma_numfifo : 4;              // DWORD 0
               u32 ndma_state : 2;                // DWORD 0
               u32 ndma_underflow : 1;            // DWORD 0
               u32 ndma_overflow : 1;             // DWORD 0
               u32 rdma_numfifo : 4;              // DWORD 0
               u32 rdma_state : 2;                // DWORD 0
               u32 rdma_underflow : 1;            // DWORD 0
               u32 rdma_overflow : 1;             // DWORD 0
               u32 uc_numfifo : 4;                // DWORD 0
               u32 uc_state : 2;                  // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 uc_overflow : 1;               // DWORD 0
               u32 wdma_numfifo : 4;              // DWORD 0
               u32 wdma_state : 2;                // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_DEBUG0, *PMPU_IQ_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_IQ_DEBUG0, sizeof (MPU_IQ_DEBUG0) == 4);

   #else
      typedef struct _MPU_IQ_DEBUG0 {
         u32 ndma_numfifo : 4;                    // DWORD 0
         u32 ndma_state : 2;                      // DWORD 0
         u32 ndma_underflow : 1;                  // DWORD 0
         u32 ndma_overflow : 1;                   // DWORD 0
         u32 rdma_numfifo : 4;                    // DWORD 0
         u32 rdma_state : 2;                      // DWORD 0
         u32 rdma_underflow : 1;                  // DWORD 0
         u32 rdma_overflow : 1;                   // DWORD 0
         u32 uc_numfifo : 4;                      // DWORD 0
         u32 uc_state : 2;                        // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 uc_overflow : 1;                     // DWORD 0
         u32 wdma_numfifo : 4;                    // DWORD 0
         u32 wdma_state : 2;                      // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
      } SG_PACK MPU_IQ_DEBUG0, *PMPU_IQ_DEBUG0;

      typedef union _MPU_IQ_DEBUG0_UNION {
         MPU_IQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_DEBUG0_UNION, *PMPU_IQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_DEBUG0_UNION, sizeof (MPU_IQ_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Various IQ. Writing to this registers clears Overflow/Undeflow
   // indications.The multibit fields in this register suffer from bug 9829 and may yield
   // occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IQ_DEBUG0 {
         union {
            struct { 
               u32 wdma_overflow : 1;             // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 wdma_state : 2;                // DWORD 0
               u32 wdma_numfifo : 4;              // DWORD 0
               u32 uc_overflow : 1;               // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 uc_state : 2;                  // DWORD 0
               u32 uc_numfifo : 4;                // DWORD 0
               u32 rdma_overflow : 1;             // DWORD 0
               u32 rdma_underflow : 1;            // DWORD 0
               u32 rdma_state : 2;                // DWORD 0
               u32 rdma_numfifo : 4;              // DWORD 0
               u32 ndma_overflow : 1;             // DWORD 0
               u32 ndma_underflow : 1;            // DWORD 0
               u32 ndma_state : 2;                // DWORD 0
               u32 ndma_numfifo : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IQ_DEBUG0, *PMPU_IQ_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_IQ_DEBUG0, sizeof (MPU_IQ_DEBUG0) == 4);

   #else
      typedef struct _MPU_IQ_DEBUG0 {
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 wdma_state : 2;                      // DWORD 0
         u32 wdma_numfifo : 4;                    // DWORD 0
         u32 uc_overflow : 1;                     // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 uc_state : 2;                        // DWORD 0
         u32 uc_numfifo : 4;                      // DWORD 0
         u32 rdma_overflow : 1;                   // DWORD 0
         u32 rdma_underflow : 1;                  // DWORD 0
         u32 rdma_state : 2;                      // DWORD 0
         u32 rdma_numfifo : 4;                    // DWORD 0
         u32 ndma_overflow : 1;                   // DWORD 0
         u32 ndma_underflow : 1;                  // DWORD 0
         u32 ndma_state : 2;                      // DWORD 0
         u32 ndma_numfifo : 4;                    // DWORD 0
      } SG_PACK MPU_IQ_DEBUG0, *PMPU_IQ_DEBUG0;

      typedef union _MPU_IQ_DEBUG0_UNION {
         MPU_IQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_IQ_DEBUG0_UNION, *PMPU_IQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_IQ_DEBUG0_UNION, sizeof (MPU_IQ_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various OQ. Writing to this registers clears Overflow/Undeflow
   // indications.The multibit fields in this register suffer from bug 9829 and may yield
   // occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OQ_DEBUG0 {
         union {
            struct { 
               u32 cev_numfifo : 3;               // DWORD 0
               u32 ndma_numfifo : 3;              // DWORD 0
               u32 rdma_numfifo : 3;              // DWORD 0
               u32 wdma_numfifo : 3;              // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 uc_is_release : 1;             // DWORD 0
               u32 uc_numfifo : 3;                // DWORD 0
               u32 cev_underflow : 1;             // DWORD 0
               u32 cev_overflow : 1;              // DWORD 0
               u32 ndma_underflow : 1;            // DWORD 0
               u32 ndma_overflow : 1;             // DWORD 0
               u32 rdma_underflow : 1;            // DWORD 0
               u32 rdma_overflow : 1;             // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
               u32 self_underflow : 1;            // DWORD 0
               u32 self_overflow : 1;             // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 uc_overflow : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_OQ_DEBUG0, *PMPU_OQ_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG0, sizeof (MPU_OQ_DEBUG0) == 4);

   #else
      typedef struct _MPU_OQ_DEBUG0 {
         u32 cev_numfifo : 3;                     // DWORD 0
         u32 ndma_numfifo : 3;                    // DWORD 0
         u32 rdma_numfifo : 3;                    // DWORD 0
         u32 wdma_numfifo : 3;                    // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 uc_is_release : 1;                   // DWORD 0
         u32 uc_numfifo : 3;                      // DWORD 0
         u32 cev_underflow : 1;                   // DWORD 0
         u32 cev_overflow : 1;                    // DWORD 0
         u32 ndma_underflow : 1;                  // DWORD 0
         u32 ndma_overflow : 1;                   // DWORD 0
         u32 rdma_underflow : 1;                  // DWORD 0
         u32 rdma_overflow : 1;                   // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 self_underflow : 1;                  // DWORD 0
         u32 self_overflow : 1;                   // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 uc_overflow : 1;                     // DWORD 0
      } SG_PACK MPU_OQ_DEBUG0, *PMPU_OQ_DEBUG0;

      typedef union _MPU_OQ_DEBUG0_UNION {
         MPU_OQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_OQ_DEBUG0_UNION, *PMPU_OQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG0_UNION, sizeof (MPU_OQ_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Various OQ. Writing to this registers clears Overflow/Undeflow
   // indications.The multibit fields in this register suffer from bug 9829 and may yield
   // occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OQ_DEBUG0 {
         union {
            struct { 
               u32 uc_overflow : 1;               // DWORD 0
               u32 uc_underflow : 1;              // DWORD 0
               u32 self_overflow : 1;             // DWORD 0
               u32 self_underflow : 1;            // DWORD 0
               u32 wdma_overflow : 1;             // DWORD 0
               u32 wdma_underflow : 1;            // DWORD 0
               u32 rdma_overflow : 1;             // DWORD 0
               u32 rdma_underflow : 1;            // DWORD 0
               u32 ndma_overflow : 1;             // DWORD 0
               u32 ndma_underflow : 1;            // DWORD 0
               u32 cev_overflow : 1;              // DWORD 0
               u32 cev_underflow : 1;             // DWORD 0
               u32 uc_numfifo : 3;                // DWORD 0
               u32 uc_is_release : 1;             // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 wdma_numfifo : 3;              // DWORD 0
               u32 rdma_numfifo : 3;              // DWORD 0
               u32 ndma_numfifo : 3;              // DWORD 0
               u32 cev_numfifo : 3;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_OQ_DEBUG0, *PMPU_OQ_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG0, sizeof (MPU_OQ_DEBUG0) == 4);

   #else
      typedef struct _MPU_OQ_DEBUG0 {
         u32 uc_overflow : 1;                     // DWORD 0
         u32 uc_underflow : 1;                    // DWORD 0
         u32 self_overflow : 1;                   // DWORD 0
         u32 self_underflow : 1;                  // DWORD 0
         u32 wdma_overflow : 1;                   // DWORD 0
         u32 wdma_underflow : 1;                  // DWORD 0
         u32 rdma_overflow : 1;                   // DWORD 0
         u32 rdma_underflow : 1;                  // DWORD 0
         u32 ndma_overflow : 1;                   // DWORD 0
         u32 ndma_underflow : 1;                  // DWORD 0
         u32 cev_overflow : 1;                    // DWORD 0
         u32 cev_underflow : 1;                   // DWORD 0
         u32 uc_numfifo : 3;                      // DWORD 0
         u32 uc_is_release : 1;                   // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 wdma_numfifo : 3;                    // DWORD 0
         u32 rdma_numfifo : 3;                    // DWORD 0
         u32 ndma_numfifo : 3;                    // DWORD 0
         u32 cev_numfifo : 3;                     // DWORD 0
      } SG_PACK MPU_OQ_DEBUG0, *PMPU_OQ_DEBUG0;

      typedef union _MPU_OQ_DEBUG0_UNION {
         MPU_OQ_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_OQ_DEBUG0_UNION, *PMPU_OQ_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG0_UNION, sizeof (MPU_OQ_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Various OQ.The multibit fields in this register suffer from bug 9829 and
   // may yield occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OQ_DEBUG1 {
         union {
            struct { 
               u32 rsvd2 : 12;                    // DWORD 0
               u32 armed : 1;                     // DWORD 0
               u32 int_state : 2;                 // DWORD 0
               u32 gpio_mpu_intr : 1;             // DWORD 0
               u32 mpu_bearm_int_o : 8;           // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 self_state : 2;                // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 self_numfifo : 3;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_OQ_DEBUG1, *PMPU_OQ_DEBUG1;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG1, sizeof (MPU_OQ_DEBUG1) == 4);

   #else
      typedef struct _MPU_OQ_DEBUG1 {
         u32 rsvd2 : 12;                          // DWORD 0
         u32 armed : 1;                           // DWORD 0
         u32 int_state : 2;                       // DWORD 0
         u32 gpio_mpu_intr : 1;                   // DWORD 0
         u32 mpu_bearm_int_o : 8;                 // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 self_state : 2;                      // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 self_numfifo : 3;                    // DWORD 0
      } SG_PACK MPU_OQ_DEBUG1, *PMPU_OQ_DEBUG1;

      typedef union _MPU_OQ_DEBUG1_UNION {
         MPU_OQ_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_OQ_DEBUG1_UNION, *PMPU_OQ_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG1_UNION, sizeof (MPU_OQ_DEBUG1_UNION) == 4);
   #endif


#else
   // Debug of Various OQ.The multibit fields in this register suffer from bug 9829 and
   // may yield occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_OQ_DEBUG1 {
         union {
            struct { 
               u32 self_numfifo : 3;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 self_state : 2;                // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 mpu_bearm_int_o : 8;           // DWORD 0
               u32 gpio_mpu_intr : 1;             // DWORD 0
               u32 int_state : 2;                 // DWORD 0
               u32 armed : 1;                     // DWORD 0
               u32 rsvd2 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_OQ_DEBUG1, *PMPU_OQ_DEBUG1;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG1, sizeof (MPU_OQ_DEBUG1) == 4);

   #else
      typedef struct _MPU_OQ_DEBUG1 {
         u32 self_numfifo : 3;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 self_state : 2;                      // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 mpu_bearm_int_o : 8;                 // DWORD 0
         u32 gpio_mpu_intr : 1;                   // DWORD 0
         u32 int_state : 2;                       // DWORD 0
         u32 armed : 1;                           // DWORD 0
         u32 rsvd2 : 12;                          // DWORD 0
      } SG_PACK MPU_OQ_DEBUG1, *PMPU_OQ_DEBUG1;

      typedef union _MPU_OQ_DEBUG1_UNION {
         MPU_OQ_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK MPU_OQ_DEBUG1_UNION, *PMPU_OQ_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__MPU_OQ_DEBUG1_UNION, sizeof (MPU_OQ_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug of Reg Router Master Interface. Writing to this registers clears
   // Overflow/Undeflow indications.The multibit fields in this register suffer from bug
   // 9829 and may yield occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RRM_DEBUG0 {
         union {
            struct { 
               u32 rsvd3 : 8;                     // DWORD 0
               u32 data_alloced : 4;              // DWORD 0
               u32 control_numfifo : 4;           // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 rrmi_data_numfifo : 3;         // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rrmo_data_numfifo : 2;         // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 control_underflow : 1;         // DWORD 0
               u32 control_overflow : 1;          // DWORD 0
               u32 rrmo_data_underflow : 1;       // DWORD 0
               u32 rrmo_data_overflow : 1;        // DWORD 0
               u32 rrmi_data_underflow : 1;       // DWORD 0
               u32 rrmi_data_overflow : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RRM_DEBUG0, *PMPU_RRM_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_RRM_DEBUG0, sizeof (MPU_RRM_DEBUG0) == 4);

   #else
      typedef struct _MPU_RRM_DEBUG0 {
         u32 rsvd3 : 8;                           // DWORD 0
         u32 data_alloced : 4;                    // DWORD 0
         u32 control_numfifo : 4;                 // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 rrmi_data_numfifo : 3;               // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rrmo_data_numfifo : 2;               // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 control_underflow : 1;               // DWORD 0
         u32 control_overflow : 1;                // DWORD 0
         u32 rrmo_data_underflow : 1;             // DWORD 0
         u32 rrmo_data_overflow : 1;              // DWORD 0
         u32 rrmi_data_underflow : 1;             // DWORD 0
         u32 rrmi_data_overflow : 1;              // DWORD 0
      } SG_PACK MPU_RRM_DEBUG0, *PMPU_RRM_DEBUG0;

      typedef union _MPU_RRM_DEBUG0_UNION {
         MPU_RRM_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_RRM_DEBUG0_UNION, *PMPU_RRM_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_RRM_DEBUG0_UNION, sizeof (MPU_RRM_DEBUG0_UNION) == 4);
   #endif


#else
   // Debug of Reg Router Master Interface. Writing to this registers clears
   // Overflow/Undeflow indications.The multibit fields in this register suffer from bug
   // 9829 and may yield occational garbage results. Take data with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_RRM_DEBUG0 {
         union {
            struct { 
               u32 rrmi_data_overflow : 1;        // DWORD 0
               u32 rrmi_data_underflow : 1;       // DWORD 0
               u32 rrmo_data_overflow : 1;        // DWORD 0
               u32 rrmo_data_underflow : 1;       // DWORD 0
               u32 control_overflow : 1;          // DWORD 0
               u32 control_underflow : 1;         // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 rrmo_data_numfifo : 2;         // DWORD 0
               u32 rsvd1 : 2;                     // DWORD 0
               u32 rrmi_data_numfifo : 3;         // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 control_numfifo : 4;           // DWORD 0
               u32 data_alloced : 4;              // DWORD 0
               u32 rsvd3 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_RRM_DEBUG0, *PMPU_RRM_DEBUG0;

      SG_C_ASSERT(__sizeof__MPU_RRM_DEBUG0, sizeof (MPU_RRM_DEBUG0) == 4);

   #else
      typedef struct _MPU_RRM_DEBUG0 {
         u32 rrmi_data_overflow : 1;              // DWORD 0
         u32 rrmi_data_underflow : 1;             // DWORD 0
         u32 rrmo_data_overflow : 1;              // DWORD 0
         u32 rrmo_data_underflow : 1;             // DWORD 0
         u32 control_overflow : 1;                // DWORD 0
         u32 control_underflow : 1;               // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 rrmo_data_numfifo : 2;               // DWORD 0
         u32 rsvd1 : 2;                           // DWORD 0
         u32 rrmi_data_numfifo : 3;               // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 control_numfifo : 4;                 // DWORD 0
         u32 data_alloced : 4;                    // DWORD 0
         u32 rsvd3 : 8;                           // DWORD 0
      } SG_PACK MPU_RRM_DEBUG0, *PMPU_RRM_DEBUG0;

      typedef union _MPU_RRM_DEBUG0_UNION {
         MPU_RRM_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPU_RRM_DEBUG0_UNION, *PMPU_RRM_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPU_RRM_DEBUG0_UNION, sizeof (MPU_RRM_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU EP Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 mpu_ep_hw_dbg_sel : 4;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR, *PMPU_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__MPU_EP_HW_DEBUG_SELECT_CR, sizeof (MPU_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _MPU_EP_HW_DEBUG_SELECT_CR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 mpu_ep_hw_dbg_sel : 4;               // DWORD 0
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR, *PMPU_EP_HW_DEBUG_SELECT_CR;

      typedef union _MPU_EP_HW_DEBUG_SELECT_CR_UNION {
         MPU_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR_UNION, *PMPU_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__MPU_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (MPU_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#else
   // MPU EP Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 mpu_ep_hw_dbg_sel : 4;         // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR, *PMPU_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__MPU_EP_HW_DEBUG_SELECT_CR, sizeof (MPU_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _MPU_EP_HW_DEBUG_SELECT_CR {
         u32 mpu_ep_hw_dbg_sel : 4;               // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR, *PMPU_EP_HW_DEBUG_SELECT_CR;

      typedef union _MPU_EP_HW_DEBUG_SELECT_CR_UNION {
         MPU_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK MPU_EP_HW_DEBUG_SELECT_CR_UNION, *PMPU_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__MPU_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (MPU_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR Read/Write Data
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_DDR_RWDATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_DDR_RWDATA_CSR, *PMPU_DDR_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__MPU_DDR_RWDATA_CSR, sizeof (MPU_DDR_RWDATA_CSR) == 4);

   #else
      typedef struct _MPU_DDR_RWDATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_DDR_RWDATA_CSR, *PMPU_DDR_RWDATA_CSR;

      typedef union _MPU_DDR_RWDATA_CSR_UNION {
         MPU_DDR_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_DDR_RWDATA_CSR_UNION, *PMPU_DDR_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_DDR_RWDATA_CSR_UNION, sizeof (MPU_DDR_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // DDR Read/Write Data
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_DDR_RWDATA_CSR {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_DDR_RWDATA_CSR, *PMPU_DDR_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__MPU_DDR_RWDATA_CSR, sizeof (MPU_DDR_RWDATA_CSR) == 4);

   #else
      typedef struct _MPU_DDR_RWDATA_CSR {
         u32 data;                                // DWORD 0
      } SG_PACK MPU_DDR_RWDATA_CSR, *PMPU_DDR_RWDATA_CSR;

      typedef union _MPU_DDR_RWDATA_CSR_UNION {
         MPU_DDR_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_DDR_RWDATA_CSR_UNION, *PMPU_DDR_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_DDR_RWDATA_CSR_UNION, sizeof (MPU_DDR_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // DDR RAM Address and Control. Writing to this register initiates a transaction to
   // either DDR memory or the DDR memory controller. If the <I>reg</I> bit is set, the
   // address field corresponds to a 4-byte offset into the ARMDDR_CSRMAP DDR memory
   // controller register space.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_DDR_ADDR_CSR {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 reg : 1;                       // DWORD 0
               u32 def : 1;                       // DWORD 0
               u32 data_ram_addr : 26;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_DDR_ADDR_CSR, *PMPU_DDR_ADDR_CSR;

      SG_C_ASSERT(__sizeof__MPU_DDR_ADDR_CSR, sizeof (MPU_DDR_ADDR_CSR) == 4);

   #else
      typedef struct _MPU_DDR_ADDR_CSR {
         u32 busy : 1;                            // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 reg : 1;                             // DWORD 0
         u32 def : 1;                             // DWORD 0
         u32 data_ram_addr : 26;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK MPU_DDR_ADDR_CSR, *PMPU_DDR_ADDR_CSR;

      typedef union _MPU_DDR_ADDR_CSR_UNION {
         MPU_DDR_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_DDR_ADDR_CSR_UNION, *PMPU_DDR_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_DDR_ADDR_CSR_UNION, sizeof (MPU_DDR_ADDR_CSR_UNION) == 4);
   #endif


#else
   // DDR RAM Address and Control. Writing to this register initiates a transaction to
   // either DDR memory or the DDR memory controller. If the <I>reg</I> bit is set, the
   // address field corresponds to a 4-byte offset into the ARMDDR_CSRMAP DDR memory
   // controller register space.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_DDR_ADDR_CSR {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 data_ram_addr : 26;            // DWORD 0
               u32 def : 1;                       // DWORD 0
               u32 reg : 1;                       // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_DDR_ADDR_CSR, *PMPU_DDR_ADDR_CSR;

      SG_C_ASSERT(__sizeof__MPU_DDR_ADDR_CSR, sizeof (MPU_DDR_ADDR_CSR) == 4);

   #else
      typedef struct _MPU_DDR_ADDR_CSR {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 data_ram_addr : 26;                  // DWORD 0
         u32 def : 1;                             // DWORD 0
         u32 reg : 1;                             // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK MPU_DDR_ADDR_CSR, *PMPU_DDR_ADDR_CSR;

      typedef union _MPU_DDR_ADDR_CSR_UNION {
         MPU_DDR_ADDR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_DDR_ADDR_CSR_UNION, *PMPU_DDR_ADDR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_DDR_ADDR_CSR_UNION, sizeof (MPU_DDR_ADDR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Server Interrupt Status Register. This register indicates the source/cause of
   // Recoverable Interrupts. These interrupts may interrupt the external server
   // management chip based off of the appropriate mask settings. When a
   // MPU_SERVER_ISR_CSR bit gets set and its equivalent Mask bit in MPU_SERVER_IMR_CSR is
   // cleared (enabled), external server management chip is interrupted. This register has
   // a clear-on-read functionality. If the MPU_SERVER_ISR_CSR is set, the register bit is
   // cleared when software reads it AND the equivalent MPU_SERVER_IMR_CSR bit is also
   // automatically set, disabling further MPU interrupts from that source. Software
   // re-arms the interrupt by writing ones to the MPU_SERVER_ISR_CSR. When a one is
   // written to this register, the equivalent MPU_SERVER_IMR_CSR bit is cleared,
   // (re-)enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_SERVER_ISR_CSR {
         union {
            struct { 
               u32 mbox : 1;                      // DWORD 0
               u32 p1_ob_link : 1;                // DWORD 0
               u32 p0_ob_link : 1;                // DWORD 0
               u32 wdma : 1;                      // DWORD 0
               u32 uc : 1;                        // DWORD 0
               u32 txulp2 : 1;                    // DWORD 0
               u32 txulp1 : 1;                    // DWORD 0
               u32 txulp0 : 1;                    // DWORD 0
               u32 txips : 1;                     // DWORD 0
               u32 tpre : 1;                      // DWORD 0
               u32 tpost : 1;                     // DWORD 0
               u32 tim : 1;                       // DWORD 0
               u32 rxulp2 : 1;                    // DWORD 0
               u32 rxulp1 : 1;                    // DWORD 0
               u32 rxulp0 : 1;                    // DWORD 0
               u32 rxips : 1;                     // DWORD 0
               u32 rxf : 1;                       // DWORD 0
               u32 ptc : 1;                       // DWORD 0
               u32 mpu : 1;                       // DWORD 0
               u32 host8 : 1;                     // DWORD 0
               u32 host7 : 1;                     // DWORD 0
               u32 host6 : 1;                     // DWORD 0
               u32 host5 : 1;                     // DWORD 0
               u32 host4 : 1;                     // DWORD 0
               u32 host3 : 1;                     // DWORD 0
               u32 host2 : 1;                     // DWORD 0
               u32 host1 : 1;                     // DWORD 0
               u32 host0 : 1;                     // DWORD 0
               u32 erx : 1;                       // DWORD 0
               u32 dbuf : 1;                      // DWORD 0
               u32 ctx : 1;                       // DWORD 0
               u32 cev : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_SERVER_ISR_CSR, *PMPU_SERVER_ISR_CSR;

      SG_C_ASSERT(__sizeof__MPU_SERVER_ISR_CSR, sizeof (MPU_SERVER_ISR_CSR) == 4);

   #else
      typedef struct _MPU_SERVER_ISR_CSR {
         u32 mbox : 1;                            // DWORD 0
         u32 p1_ob_link : 1;                      // DWORD 0
         u32 p0_ob_link : 1;                      // DWORD 0
         u32 wdma : 1;                            // DWORD 0
         u32 uc : 1;                              // DWORD 0
         u32 txulp2 : 1;                          // DWORD 0
         u32 txulp1 : 1;                          // DWORD 0
         u32 txulp0 : 1;                          // DWORD 0
         u32 txips : 1;                           // DWORD 0
         u32 tpre : 1;                            // DWORD 0
         u32 tpost : 1;                           // DWORD 0
         u32 tim : 1;                             // DWORD 0
         u32 rxulp2 : 1;                          // DWORD 0
         u32 rxulp1 : 1;                          // DWORD 0
         u32 rxulp0 : 1;                          // DWORD 0
         u32 rxips : 1;                           // DWORD 0
         u32 rxf : 1;                             // DWORD 0
         u32 ptc : 1;                             // DWORD 0
         u32 mpu : 1;                             // DWORD 0
         u32 host8 : 1;                           // DWORD 0
         u32 host7 : 1;                           // DWORD 0
         u32 host6 : 1;                           // DWORD 0
         u32 host5 : 1;                           // DWORD 0
         u32 host4 : 1;                           // DWORD 0
         u32 host3 : 1;                           // DWORD 0
         u32 host2 : 1;                           // DWORD 0
         u32 host1 : 1;                           // DWORD 0
         u32 host0 : 1;                           // DWORD 0
         u32 erx : 1;                             // DWORD 0
         u32 dbuf : 1;                            // DWORD 0
         u32 ctx : 1;                             // DWORD 0
         u32 cev : 1;                             // DWORD 0
      } SG_PACK MPU_SERVER_ISR_CSR, *PMPU_SERVER_ISR_CSR;

      typedef union _MPU_SERVER_ISR_CSR_UNION {
         MPU_SERVER_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_SERVER_ISR_CSR_UNION, *PMPU_SERVER_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_SERVER_ISR_CSR_UNION, sizeof (MPU_SERVER_ISR_CSR_UNION) == 4);
   #endif


#else
   // Server Interrupt Status Register. This register indicates the source/cause of
   // Recoverable Interrupts. These interrupts may interrupt the external server
   // management chip based off of the appropriate mask settings. When a
   // MPU_SERVER_ISR_CSR bit gets set and its equivalent Mask bit in MPU_SERVER_IMR_CSR is
   // cleared (enabled), external server management chip is interrupted. This register has
   // a clear-on-read functionality. If the MPU_SERVER_ISR_CSR is set, the register bit is
   // cleared when software reads it AND the equivalent MPU_SERVER_IMR_CSR bit is also
   // automatically set, disabling further MPU interrupts from that source. Software
   // re-arms the interrupt by writing ones to the MPU_SERVER_ISR_CSR. When a one is
   // written to this register, the equivalent MPU_SERVER_IMR_CSR bit is cleared,
   // (re-)enabling the interrupt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_SERVER_ISR_CSR {
         union {
            struct { 
               u32 cev : 1;                       // DWORD 0
               u32 ctx : 1;                       // DWORD 0
               u32 dbuf : 1;                      // DWORD 0
               u32 erx : 1;                       // DWORD 0
               u32 host0 : 1;                     // DWORD 0
               u32 host1 : 1;                     // DWORD 0
               u32 host2 : 1;                     // DWORD 0
               u32 host3 : 1;                     // DWORD 0
               u32 host4 : 1;                     // DWORD 0
               u32 host5 : 1;                     // DWORD 0
               u32 host6 : 1;                     // DWORD 0
               u32 host7 : 1;                     // DWORD 0
               u32 host8 : 1;                     // DWORD 0
               u32 mpu : 1;                       // DWORD 0
               u32 ptc : 1;                       // DWORD 0
               u32 rxf : 1;                       // DWORD 0
               u32 rxips : 1;                     // DWORD 0
               u32 rxulp0 : 1;                    // DWORD 0
               u32 rxulp1 : 1;                    // DWORD 0
               u32 rxulp2 : 1;                    // DWORD 0
               u32 tim : 1;                       // DWORD 0
               u32 tpost : 1;                     // DWORD 0
               u32 tpre : 1;                      // DWORD 0
               u32 txips : 1;                     // DWORD 0
               u32 txulp0 : 1;                    // DWORD 0
               u32 txulp1 : 1;                    // DWORD 0
               u32 txulp2 : 1;                    // DWORD 0
               u32 uc : 1;                        // DWORD 0
               u32 wdma : 1;                      // DWORD 0
               u32 p0_ob_link : 1;                // DWORD 0
               u32 p1_ob_link : 1;                // DWORD 0
               u32 mbox : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_SERVER_ISR_CSR, *PMPU_SERVER_ISR_CSR;

      SG_C_ASSERT(__sizeof__MPU_SERVER_ISR_CSR, sizeof (MPU_SERVER_ISR_CSR) == 4);

   #else
      typedef struct _MPU_SERVER_ISR_CSR {
         u32 cev : 1;                             // DWORD 0
         u32 ctx : 1;                             // DWORD 0
         u32 dbuf : 1;                            // DWORD 0
         u32 erx : 1;                             // DWORD 0
         u32 host0 : 1;                           // DWORD 0
         u32 host1 : 1;                           // DWORD 0
         u32 host2 : 1;                           // DWORD 0
         u32 host3 : 1;                           // DWORD 0
         u32 host4 : 1;                           // DWORD 0
         u32 host5 : 1;                           // DWORD 0
         u32 host6 : 1;                           // DWORD 0
         u32 host7 : 1;                           // DWORD 0
         u32 host8 : 1;                           // DWORD 0
         u32 mpu : 1;                             // DWORD 0
         u32 ptc : 1;                             // DWORD 0
         u32 rxf : 1;                             // DWORD 0
         u32 rxips : 1;                           // DWORD 0
         u32 rxulp0 : 1;                          // DWORD 0
         u32 rxulp1 : 1;                          // DWORD 0
         u32 rxulp2 : 1;                          // DWORD 0
         u32 tim : 1;                             // DWORD 0
         u32 tpost : 1;                           // DWORD 0
         u32 tpre : 1;                            // DWORD 0
         u32 txips : 1;                           // DWORD 0
         u32 txulp0 : 1;                          // DWORD 0
         u32 txulp1 : 1;                          // DWORD 0
         u32 txulp2 : 1;                          // DWORD 0
         u32 uc : 1;                              // DWORD 0
         u32 wdma : 1;                            // DWORD 0
         u32 p0_ob_link : 1;                      // DWORD 0
         u32 p1_ob_link : 1;                      // DWORD 0
         u32 mbox : 1;                            // DWORD 0
      } SG_PACK MPU_SERVER_ISR_CSR, *PMPU_SERVER_ISR_CSR;

      typedef union _MPU_SERVER_ISR_CSR_UNION {
         MPU_SERVER_ISR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_SERVER_ISR_CSR_UNION, *PMPU_SERVER_ISR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_SERVER_ISR_CSR_UNION, sizeof (MPU_SERVER_ISR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Internal Interrupt Mask Register. Mask register for interrupts to external server
   // management chip defined in MPU_SERVER_ISR_CSR. Software may enable or disable Server
   // interrupts by writing a one or disable respectively to the relevant bits in this
   // register. Software writes of zero have no effect. Hardware automatically sets each
   // MPU_SERVER_IMR_CSR bit when software reads a one (an interrupt) from the equivalent
   // bit in the MPU_SERVER_ISR_CSR interrupt status register. Hardware automatically
   // clears each MPU_SERVER_IMR_CSR bit when software writes a one to the equivalent bit
   // in MPU_SERVER_ISR_CSR register. Note that software writes of zero to this register
   // have no effect; only writes of one update the relevant bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_SERVER_IMR_CSR {
         union {
            struct { 
               u32 mbox : 1;                      // DWORD 0
               u32 p1_ob_link : 1;                // DWORD 0
               u32 p0_ob_link : 1;                // DWORD 0
               u32 wdma : 1;                      // DWORD 0
               u32 uc : 1;                        // DWORD 0
               u32 txulp2 : 1;                    // DWORD 0
               u32 txulp1 : 1;                    // DWORD 0
               u32 txulp0 : 1;                    // DWORD 0
               u32 txips : 1;                     // DWORD 0
               u32 tpre : 1;                      // DWORD 0
               u32 tpost : 1;                     // DWORD 0
               u32 tim : 1;                       // DWORD 0
               u32 rxulp2 : 1;                    // DWORD 0
               u32 rxulp1 : 1;                    // DWORD 0
               u32 rxulp0 : 1;                    // DWORD 0
               u32 rxips : 1;                     // DWORD 0
               u32 rxf : 1;                       // DWORD 0
               u32 ptc : 1;                       // DWORD 0
               u32 mpu : 1;                       // DWORD 0
               u32 host8 : 1;                     // DWORD 0
               u32 host7 : 1;                     // DWORD 0
               u32 host6 : 1;                     // DWORD 0
               u32 host5 : 1;                     // DWORD 0
               u32 host4 : 1;                     // DWORD 0
               u32 host3 : 1;                     // DWORD 0
               u32 host2 : 1;                     // DWORD 0
               u32 host1 : 1;                     // DWORD 0
               u32 host0 : 1;                     // DWORD 0
               u32 erx : 1;                       // DWORD 0
               u32 dbuf : 1;                      // DWORD 0
               u32 ctx : 1;                       // DWORD 0
               u32 cev : 1;                       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_SERVER_IMR_CSR, *PMPU_SERVER_IMR_CSR;

      SG_C_ASSERT(__sizeof__MPU_SERVER_IMR_CSR, sizeof (MPU_SERVER_IMR_CSR) == 4);

   #else
      typedef struct _MPU_SERVER_IMR_CSR {
         u32 mbox : 1;                            // DWORD 0
         u32 p1_ob_link : 1;                      // DWORD 0
         u32 p0_ob_link : 1;                      // DWORD 0
         u32 wdma : 1;                            // DWORD 0
         u32 uc : 1;                              // DWORD 0
         u32 txulp2 : 1;                          // DWORD 0
         u32 txulp1 : 1;                          // DWORD 0
         u32 txulp0 : 1;                          // DWORD 0
         u32 txips : 1;                           // DWORD 0
         u32 tpre : 1;                            // DWORD 0
         u32 tpost : 1;                           // DWORD 0
         u32 tim : 1;                             // DWORD 0
         u32 rxulp2 : 1;                          // DWORD 0
         u32 rxulp1 : 1;                          // DWORD 0
         u32 rxulp0 : 1;                          // DWORD 0
         u32 rxips : 1;                           // DWORD 0
         u32 rxf : 1;                             // DWORD 0
         u32 ptc : 1;                             // DWORD 0
         u32 mpu : 1;                             // DWORD 0
         u32 host8 : 1;                           // DWORD 0
         u32 host7 : 1;                           // DWORD 0
         u32 host6 : 1;                           // DWORD 0
         u32 host5 : 1;                           // DWORD 0
         u32 host4 : 1;                           // DWORD 0
         u32 host3 : 1;                           // DWORD 0
         u32 host2 : 1;                           // DWORD 0
         u32 host1 : 1;                           // DWORD 0
         u32 host0 : 1;                           // DWORD 0
         u32 erx : 1;                             // DWORD 0
         u32 dbuf : 1;                            // DWORD 0
         u32 ctx : 1;                             // DWORD 0
         u32 cev : 1;                             // DWORD 0
      } SG_PACK MPU_SERVER_IMR_CSR, *PMPU_SERVER_IMR_CSR;

      typedef union _MPU_SERVER_IMR_CSR_UNION {
         MPU_SERVER_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_SERVER_IMR_CSR_UNION, *PMPU_SERVER_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_SERVER_IMR_CSR_UNION, sizeof (MPU_SERVER_IMR_CSR_UNION) == 4);
   #endif


#else
   // Internal Interrupt Mask Register. Mask register for interrupts to external server
   // management chip defined in MPU_SERVER_ISR_CSR. Software may enable or disable Server
   // interrupts by writing a one or disable respectively to the relevant bits in this
   // register. Software writes of zero have no effect. Hardware automatically sets each
   // MPU_SERVER_IMR_CSR bit when software reads a one (an interrupt) from the equivalent
   // bit in the MPU_SERVER_ISR_CSR interrupt status register. Hardware automatically
   // clears each MPU_SERVER_IMR_CSR bit when software writes a one to the equivalent bit
   // in MPU_SERVER_ISR_CSR register. Note that software writes of zero to this register
   // have no effect; only writes of one update the relevant bit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_SERVER_IMR_CSR {
         union {
            struct { 
               u32 cev : 1;                       // DWORD 0
               u32 ctx : 1;                       // DWORD 0
               u32 dbuf : 1;                      // DWORD 0
               u32 erx : 1;                       // DWORD 0
               u32 host0 : 1;                     // DWORD 0
               u32 host1 : 1;                     // DWORD 0
               u32 host2 : 1;                     // DWORD 0
               u32 host3 : 1;                     // DWORD 0
               u32 host4 : 1;                     // DWORD 0
               u32 host5 : 1;                     // DWORD 0
               u32 host6 : 1;                     // DWORD 0
               u32 host7 : 1;                     // DWORD 0
               u32 host8 : 1;                     // DWORD 0
               u32 mpu : 1;                       // DWORD 0
               u32 ptc : 1;                       // DWORD 0
               u32 rxf : 1;                       // DWORD 0
               u32 rxips : 1;                     // DWORD 0
               u32 rxulp0 : 1;                    // DWORD 0
               u32 rxulp1 : 1;                    // DWORD 0
               u32 rxulp2 : 1;                    // DWORD 0
               u32 tim : 1;                       // DWORD 0
               u32 tpost : 1;                     // DWORD 0
               u32 tpre : 1;                      // DWORD 0
               u32 txips : 1;                     // DWORD 0
               u32 txulp0 : 1;                    // DWORD 0
               u32 txulp1 : 1;                    // DWORD 0
               u32 txulp2 : 1;                    // DWORD 0
               u32 uc : 1;                        // DWORD 0
               u32 wdma : 1;                      // DWORD 0
               u32 p0_ob_link : 1;                // DWORD 0
               u32 p1_ob_link : 1;                // DWORD 0
               u32 mbox : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_SERVER_IMR_CSR, *PMPU_SERVER_IMR_CSR;

      SG_C_ASSERT(__sizeof__MPU_SERVER_IMR_CSR, sizeof (MPU_SERVER_IMR_CSR) == 4);

   #else
      typedef struct _MPU_SERVER_IMR_CSR {
         u32 cev : 1;                             // DWORD 0
         u32 ctx : 1;                             // DWORD 0
         u32 dbuf : 1;                            // DWORD 0
         u32 erx : 1;                             // DWORD 0
         u32 host0 : 1;                           // DWORD 0
         u32 host1 : 1;                           // DWORD 0
         u32 host2 : 1;                           // DWORD 0
         u32 host3 : 1;                           // DWORD 0
         u32 host4 : 1;                           // DWORD 0
         u32 host5 : 1;                           // DWORD 0
         u32 host6 : 1;                           // DWORD 0
         u32 host7 : 1;                           // DWORD 0
         u32 host8 : 1;                           // DWORD 0
         u32 mpu : 1;                             // DWORD 0
         u32 ptc : 1;                             // DWORD 0
         u32 rxf : 1;                             // DWORD 0
         u32 rxips : 1;                           // DWORD 0
         u32 rxulp0 : 1;                          // DWORD 0
         u32 rxulp1 : 1;                          // DWORD 0
         u32 rxulp2 : 1;                          // DWORD 0
         u32 tim : 1;                             // DWORD 0
         u32 tpost : 1;                           // DWORD 0
         u32 tpre : 1;                            // DWORD 0
         u32 txips : 1;                           // DWORD 0
         u32 txulp0 : 1;                          // DWORD 0
         u32 txulp1 : 1;                          // DWORD 0
         u32 txulp2 : 1;                          // DWORD 0
         u32 uc : 1;                              // DWORD 0
         u32 wdma : 1;                            // DWORD 0
         u32 p0_ob_link : 1;                      // DWORD 0
         u32 p1_ob_link : 1;                      // DWORD 0
         u32 mbox : 1;                            // DWORD 0
      } SG_PACK MPU_SERVER_IMR_CSR, *PMPU_SERVER_IMR_CSR;

      typedef union _MPU_SERVER_IMR_CSR_UNION {
         MPU_SERVER_IMR_CSR bits;
         u32 dw; // dword union
      } SG_PACK MPU_SERVER_IMR_CSR_UNION, *PMPU_SERVER_IMR_CSR_UNION;

      SG_C_ASSERT(__sizeof__MPU_SERVER_IMR_CSR_UNION, sizeof (MPU_SERVER_IMR_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // SM access to SEEPROM on other side of MPU IIC. Note that the IIC interface is
   // natively 1 byte at a time, so that is what is presented here. Not too that ~350us
   // are required to transfer 1 byte at a time.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_IF {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 addr : 10;                     // DWORD 0
               u32 data : 8;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_IF, *PMPU_IIC_IF;

      SG_C_ASSERT(__sizeof__MPU_IIC_IF, sizeof (MPU_IIC_IF) == 4);

   #else
      typedef struct _MPU_IIC_IF {
         u32 busy : 1;                            // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 addr : 10;                           // DWORD 0
         u32 data : 8;                            // DWORD 0
      } SG_PACK MPU_IIC_IF, *PMPU_IIC_IF;

      typedef union _MPU_IIC_IF_UNION {
         MPU_IIC_IF bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_IF_UNION, *PMPU_IIC_IF_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_IF_UNION, sizeof (MPU_IIC_IF_UNION) == 4);
   #endif


#else
   // SM access to SEEPROM on other side of MPU IIC. Note that the IIC interface is
   // natively 1 byte at a time, so that is what is presented here. Not too that ~350us
   // are required to transfer 1 byte at a time.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_IF {
         union {
            struct { 
               u32 data : 8;                      // DWORD 0
               u32 addr : 10;                     // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 err : 1;                       // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_IF, *PMPU_IIC_IF;

      SG_C_ASSERT(__sizeof__MPU_IIC_IF, sizeof (MPU_IIC_IF) == 4);

   #else
      typedef struct _MPU_IIC_IF {
         u32 data : 8;                            // DWORD 0
         u32 addr : 10;                           // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 err : 1;                             // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK MPU_IIC_IF, *PMPU_IIC_IF;

      typedef union _MPU_IIC_IF_UNION {
         MPU_IIC_IF bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_IF_UNION, *PMPU_IIC_IF_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_IF_UNION, sizeof (MPU_IIC_IF_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control for MPU IIC interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_CTRL {
         union {
            struct { 
               u32 ismactive : 1;                 // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
               u32 override_mpuism : 1;           // DWORD 0
               u32 speed : 1;                     // DWORD 0
               u32 override_lockup : 1;           // DWORD 0
               u32 enable_bit_if : 1;             // DWORD 0
               u32 shift_falling_data : 1;        // DWORD 0
               u32 shift_rising_data : 1;         // DWORD 0
               u32 shift_falling_clk : 1;         // DWORD 0
               u32 shift_rising_clk : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_CTRL, *PMPU_IIC_CTRL;

      SG_C_ASSERT(__sizeof__MPU_IIC_CTRL, sizeof (MPU_IIC_CTRL) == 4);

   #else
      typedef struct _MPU_IIC_CTRL {
         u32 ismactive : 1;                       // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 override_mpuism : 1;                 // DWORD 0
         u32 speed : 1;                           // DWORD 0
         u32 override_lockup : 1;                 // DWORD 0
         u32 enable_bit_if : 1;                   // DWORD 0
         u32 shift_falling_data : 1;              // DWORD 0
         u32 shift_rising_data : 1;               // DWORD 0
         u32 shift_falling_clk : 1;               // DWORD 0
         u32 shift_rising_clk : 1;                // DWORD 0
      } SG_PACK MPU_IIC_CTRL, *PMPU_IIC_CTRL;

      typedef union _MPU_IIC_CTRL_UNION {
         MPU_IIC_CTRL bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_CTRL_UNION, *PMPU_IIC_CTRL_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_CTRL_UNION, sizeof (MPU_IIC_CTRL_UNION) == 4);
   #endif


#else
   // Control for MPU IIC interface.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_CTRL {
         union {
            struct { 
               u32 shift_rising_clk : 1;          // DWORD 0
               u32 shift_falling_clk : 1;         // DWORD 0
               u32 shift_rising_data : 1;         // DWORD 0
               u32 shift_falling_data : 1;        // DWORD 0
               u32 enable_bit_if : 1;             // DWORD 0
               u32 override_lockup : 1;           // DWORD 0
               u32 speed : 1;                     // DWORD 0
               u32 override_mpuism : 1;           // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
               u32 ismactive : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_CTRL, *PMPU_IIC_CTRL;

      SG_C_ASSERT(__sizeof__MPU_IIC_CTRL, sizeof (MPU_IIC_CTRL) == 4);

   #else
      typedef struct _MPU_IIC_CTRL {
         u32 shift_rising_clk : 1;                // DWORD 0
         u32 shift_falling_clk : 1;               // DWORD 0
         u32 shift_rising_data : 1;               // DWORD 0
         u32 shift_falling_data : 1;              // DWORD 0
         u32 enable_bit_if : 1;                   // DWORD 0
         u32 override_lockup : 1;                 // DWORD 0
         u32 speed : 1;                           // DWORD 0
         u32 override_mpuism : 1;                 // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
         u32 ismactive : 1;                       // DWORD 0
      } SG_PACK MPU_IIC_CTRL, *PMPU_IIC_CTRL;

      typedef union _MPU_IIC_CTRL_UNION {
         MPU_IIC_CTRL bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_CTRL_UNION, *PMPU_IIC_CTRL_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_CTRL_UNION, sizeof (MPU_IIC_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is the RAW, bit blasting access to the SCL and SDA pins. Note that "driving" a
   // zero onto either SCL or SDA will result in a hard driven value, but "driving" a one
   // only disables the chips output enable and allows the external pullup to pull the
   // line high. Note that the enable_bit_if bit in the MPU_IIC_CTRL must be set for the
   // outputs to work, but the inputs are always live and correct. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_BIT_IF {
         union {
            struct { 
               u32 rsvd2 : 16;                    // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 sda_in : 1;                    // DWORD 0
               u32 scl_in : 1;                    // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 sda_out : 1;                   // DWORD 0
               u32 scl_out : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_BIT_IF, *PMPU_IIC_BIT_IF;

      SG_C_ASSERT(__sizeof__MPU_IIC_BIT_IF, sizeof (MPU_IIC_BIT_IF) == 4);

   #else
      typedef struct _MPU_IIC_BIT_IF {
         u32 rsvd2 : 16;                          // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 sda_in : 1;                          // DWORD 0
         u32 scl_in : 1;                          // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 sda_out : 1;                         // DWORD 0
         u32 scl_out : 1;                         // DWORD 0
      } SG_PACK MPU_IIC_BIT_IF, *PMPU_IIC_BIT_IF;

      typedef union _MPU_IIC_BIT_IF_UNION {
         MPU_IIC_BIT_IF bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_BIT_IF_UNION, *PMPU_IIC_BIT_IF_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_BIT_IF_UNION, sizeof (MPU_IIC_BIT_IF_UNION) == 4);
   #endif


#else
   // This is the RAW, bit blasting access to the SCL and SDA pins. Note that "driving" a
   // zero onto either SCL or SDA will result in a hard driven value, but "driving" a one
   // only disables the chips output enable and allows the external pullup to pull the
   // line high. Note that the enable_bit_if bit in the MPU_IIC_CTRL must be set for the
   // outputs to work, but the inputs are always live and correct. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_IIC_BIT_IF {
         union {
            struct { 
               u32 scl_out : 1;                   // DWORD 0
               u32 sda_out : 1;                   // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 scl_in : 1;                    // DWORD 0
               u32 sda_in : 1;                    // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
               u32 rsvd2 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_IIC_BIT_IF, *PMPU_IIC_BIT_IF;

      SG_C_ASSERT(__sizeof__MPU_IIC_BIT_IF, sizeof (MPU_IIC_BIT_IF) == 4);

   #else
      typedef struct _MPU_IIC_BIT_IF {
         u32 scl_out : 1;                         // DWORD 0
         u32 sda_out : 1;                         // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 scl_in : 1;                          // DWORD 0
         u32 sda_in : 1;                          // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
         u32 rsvd2 : 16;                          // DWORD 0
      } SG_PACK MPU_IIC_BIT_IF, *PMPU_IIC_BIT_IF;

      typedef union _MPU_IIC_BIT_IF_UNION {
         MPU_IIC_BIT_IF bits;
         u32 dw; // dword union
      } SG_PACK MPU_IIC_BIT_IF_UNION, *PMPU_IIC_BIT_IF_UNION;

      SG_C_ASSERT(__sizeof__MPU_IIC_BIT_IF_UNION, sizeof (MPU_IIC_BIT_IF_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Provides an interface to the ARM System Registers. Writing to this triggers a CSR
   // access. If a write to an ARM System Register is intended, be sure to write
   // MPUARM_SYSREG_DATA first. If a read is intended, MPUARM_SYSREG_DATA contains valid
   // data once <I>busy</I> deasserts. The ARM System Register map is described in the
   // Management Processor Unit ARM System Registers section. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_SYSREG_CTRL {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 rsvd3 : 6;                     // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 byte_en : 4;                   // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 sel : 1;                       // DWORD 0
               u32 addr : 10;                     // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_SYSREG_CTRL, *PMPUARM_SYSREG_CTRL;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_CTRL, sizeof (MPUARM_SYSREG_CTRL) == 4);

   #else
      typedef struct _MPUARM_SYSREG_CTRL {
         u32 busy : 1;                            // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 rsvd3 : 6;                           // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 byte_en : 4;                         // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 sel : 1;                             // DWORD 0
         u32 addr : 10;                           // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK MPUARM_SYSREG_CTRL, *PMPUARM_SYSREG_CTRL;

      typedef union _MPUARM_SYSREG_CTRL_UNION {
         MPUARM_SYSREG_CTRL bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_SYSREG_CTRL_UNION, *PMPUARM_SYSREG_CTRL_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_CTRL_UNION, sizeof (MPUARM_SYSREG_CTRL_UNION) == 4);
   #endif


#else
   // Provides an interface to the ARM System Registers. Writing to this triggers a CSR
   // access. If a write to an ARM System Register is intended, be sure to write
   // MPUARM_SYSREG_DATA first. If a read is intended, MPUARM_SYSREG_DATA contains valid
   // data once <I>busy</I> deasserts. The ARM System Register map is described in the
   // Management Processor Unit ARM System Registers section. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_SYSREG_CTRL {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 addr : 10;                     // DWORD 0
               u32 sel : 1;                       // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 byte_en : 4;                   // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 rsvd3 : 6;                     // DWORD 0
               u32 write : 1;                     // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_SYSREG_CTRL, *PMPUARM_SYSREG_CTRL;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_CTRL, sizeof (MPUARM_SYSREG_CTRL) == 4);

   #else
      typedef struct _MPUARM_SYSREG_CTRL {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 addr : 10;                           // DWORD 0
         u32 sel : 1;                             // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 byte_en : 4;                         // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 rsvd3 : 6;                           // DWORD 0
         u32 write : 1;                           // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK MPUARM_SYSREG_CTRL, *PMPUARM_SYSREG_CTRL;

      typedef union _MPUARM_SYSREG_CTRL_UNION {
         MPUARM_SYSREG_CTRL bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_SYSREG_CTRL_UNION, *PMPUARM_SYSREG_CTRL_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_CTRL_UNION, sizeof (MPUARM_SYSREG_CTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Allows for interface to ARM System Regs in ARM. Writing to this triggers a CSR
   // access.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_SYSREG_DATA {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_SYSREG_DATA, *PMPUARM_SYSREG_DATA;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_DATA, sizeof (MPUARM_SYSREG_DATA) == 4);

   #else
      typedef struct _MPUARM_SYSREG_DATA {
         u32 data;                                // DWORD 0
      } SG_PACK MPUARM_SYSREG_DATA, *PMPUARM_SYSREG_DATA;

      typedef union _MPUARM_SYSREG_DATA_UNION {
         MPUARM_SYSREG_DATA bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_SYSREG_DATA_UNION, *PMPUARM_SYSREG_DATA_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_DATA_UNION, sizeof (MPUARM_SYSREG_DATA_UNION) == 4);
   #endif


#else
   // Allows for interface to ARM System Regs in ARM. Writing to this triggers a CSR
   // access.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_SYSREG_DATA {
         union {
            struct { 
               u32 data;                          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_SYSREG_DATA, *PMPUARM_SYSREG_DATA;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_DATA, sizeof (MPUARM_SYSREG_DATA) == 4);

   #else
      typedef struct _MPUARM_SYSREG_DATA {
         u32 data;                                // DWORD 0
      } SG_PACK MPUARM_SYSREG_DATA, *PMPUARM_SYSREG_DATA;

      typedef union _MPUARM_SYSREG_DATA_UNION {
         MPUARM_SYSREG_DATA bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_SYSREG_DATA_UNION, *PMPUARM_SYSREG_DATA_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_SYSREG_DATA_UNION, sizeof (MPUARM_SYSREG_DATA_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // IPC Debug.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IPC_DEBUG {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 data : 24;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IPC_DEBUG, *PMPUARM_IPC_DEBUG;

      SG_C_ASSERT(__sizeof__MPUARM_IPC_DEBUG, sizeof (MPUARM_IPC_DEBUG) == 4);

   #else
      typedef struct _MPUARM_IPC_DEBUG {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 data : 24;                           // DWORD 0
      } SG_PACK MPUARM_IPC_DEBUG, *PMPUARM_IPC_DEBUG;

      typedef union _MPUARM_IPC_DEBUG_UNION {
         MPUARM_IPC_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IPC_DEBUG_UNION, *PMPUARM_IPC_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IPC_DEBUG_UNION, sizeof (MPUARM_IPC_DEBUG_UNION) == 4);
   #endif


#else
   // IPC Debug.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IPC_DEBUG {
         union {
            struct { 
               u32 data : 24;                     // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IPC_DEBUG, *PMPUARM_IPC_DEBUG;

      SG_C_ASSERT(__sizeof__MPUARM_IPC_DEBUG, sizeof (MPUARM_IPC_DEBUG) == 4);

   #else
      typedef struct _MPUARM_IPC_DEBUG {
         u32 data : 24;                           // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK MPUARM_IPC_DEBUG, *PMPUARM_IPC_DEBUG;

      typedef union _MPUARM_IPC_DEBUG_UNION {
         MPUARM_IPC_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IPC_DEBUG_UNION, *PMPUARM_IPC_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IPC_DEBUG_UNION, sizeof (MPUARM_IPC_DEBUG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPUs Ring Manager / Consel control register 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_RINGMGR_CTRL0 {
         union {
            struct { 
               u32 rsvd0 : 25;                    // DWORD 0
               u32 cid_offset : 6;                // DWORD 0
               u32 disable_rm : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_RINGMGR_CTRL0, *PMPUARM_RINGMGR_CTRL0;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_CTRL0, sizeof (MPUARM_RINGMGR_CTRL0) == 4);

   #else
      typedef struct _MPUARM_RINGMGR_CTRL0 {
         u32 rsvd0 : 25;                          // DWORD 0
         u32 cid_offset : 6;                      // DWORD 0
         u32 disable_rm : 1;                      // DWORD 0
      } SG_PACK MPUARM_RINGMGR_CTRL0, *PMPUARM_RINGMGR_CTRL0;

      typedef union _MPUARM_RINGMGR_CTRL0_UNION {
         MPUARM_RINGMGR_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_RINGMGR_CTRL0_UNION, *PMPUARM_RINGMGR_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_CTRL0_UNION, sizeof (MPUARM_RINGMGR_CTRL0_UNION) == 4);
   #endif


#else
   // MPUs Ring Manager / Consel control register 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_RINGMGR_CTRL0 {
         union {
            struct { 
               u32 disable_rm : 1;                // DWORD 0
               u32 cid_offset : 6;                // DWORD 0
               u32 rsvd0 : 25;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_RINGMGR_CTRL0, *PMPUARM_RINGMGR_CTRL0;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_CTRL0, sizeof (MPUARM_RINGMGR_CTRL0) == 4);

   #else
      typedef struct _MPUARM_RINGMGR_CTRL0 {
         u32 disable_rm : 1;                      // DWORD 0
         u32 cid_offset : 6;                      // DWORD 0
         u32 rsvd0 : 25;                          // DWORD 0
      } SG_PACK MPUARM_RINGMGR_CTRL0, *PMPUARM_RINGMGR_CTRL0;

      typedef union _MPUARM_RINGMGR_CTRL0_UNION {
         MPUARM_RINGMGR_CTRL0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_RINGMGR_CTRL0_UNION, *PMPUARM_RINGMGR_CTRL0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_CTRL0_UNION, sizeof (MPUARM_RINGMGR_CTRL0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPUs Ring Manager / Consel debug register. A write to the MPU_CONSEL_DEBUG0 register
   // will clear the sticky bits here. The multibit fields in this register suffer from
   // bug 9829 and may yield occational garbage results. Take data with grain of salt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_RINGMGR_DEBUG0 {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 debug_rngman_comp_up_underflow : 1; // DWORD 0
               u32 debug_rngman_comp_rb_underflow : 1; // DWORD 0
               u32 debug_rngman_req_underflow : 1; // DWORD 0
               u32 debug_rngman_comp_up_overflow : 1; // DWORD 0
               u32 debug_rngman_comp_rb_overflow : 1; // DWORD 0
               u32 debug_rngman_req_overflow : 1; // DWORD 0
               u32 debug_rngman_comp_up_numfilled : 3; // DWORD 0
               u32 debug_rngman_comp_rb_numfilled : 2; // DWORD 0
               u32 debug_rngman_req_numfilled : 2; // DWORD 0
               u32 debug_rngman_comp_up_credit : 3; // DWORD 0
               u32 debug_rngman_comp_rb_credit : 2; // DWORD 0
               u32 debug_rngman_req_credit : 2;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_RINGMGR_DEBUG0, *PMPUARM_RINGMGR_DEBUG0;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_DEBUG0, sizeof (MPUARM_RINGMGR_DEBUG0) == 4);

   #else
      typedef struct _MPUARM_RINGMGR_DEBUG0 {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 debug_rngman_comp_up_underflow : 1;  // DWORD 0
         u32 debug_rngman_comp_rb_underflow : 1;  // DWORD 0
         u32 debug_rngman_req_underflow : 1;      // DWORD 0
         u32 debug_rngman_comp_up_overflow : 1;   // DWORD 0
         u32 debug_rngman_comp_rb_overflow : 1;   // DWORD 0
         u32 debug_rngman_req_overflow : 1;       // DWORD 0
         u32 debug_rngman_comp_up_numfilled : 3;  // DWORD 0
         u32 debug_rngman_comp_rb_numfilled : 2;  // DWORD 0
         u32 debug_rngman_req_numfilled : 2;      // DWORD 0
         u32 debug_rngman_comp_up_credit : 3;     // DWORD 0
         u32 debug_rngman_comp_rb_credit : 2;     // DWORD 0
         u32 debug_rngman_req_credit : 2;         // DWORD 0
      } SG_PACK MPUARM_RINGMGR_DEBUG0, *PMPUARM_RINGMGR_DEBUG0;

      typedef union _MPUARM_RINGMGR_DEBUG0_UNION {
         MPUARM_RINGMGR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_RINGMGR_DEBUG0_UNION, *PMPUARM_RINGMGR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_DEBUG0_UNION, sizeof (MPUARM_RINGMGR_DEBUG0_UNION) == 4);
   #endif


#else
   // MPUs Ring Manager / Consel debug register. A write to the MPU_CONSEL_DEBUG0 register
   // will clear the sticky bits here. The multibit fields in this register suffer from
   // bug 9829 and may yield occational garbage results. Take data with grain of salt. 
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_RINGMGR_DEBUG0 {
         union {
            struct { 
               u32 debug_rngman_req_credit : 2;   // DWORD 0
               u32 debug_rngman_comp_rb_credit : 2; // DWORD 0
               u32 debug_rngman_comp_up_credit : 3; // DWORD 0
               u32 debug_rngman_req_numfilled : 2; // DWORD 0
               u32 debug_rngman_comp_rb_numfilled : 2; // DWORD 0
               u32 debug_rngman_comp_up_numfilled : 3; // DWORD 0
               u32 debug_rngman_req_overflow : 1; // DWORD 0
               u32 debug_rngman_comp_rb_overflow : 1; // DWORD 0
               u32 debug_rngman_comp_up_overflow : 1; // DWORD 0
               u32 debug_rngman_req_underflow : 1; // DWORD 0
               u32 debug_rngman_comp_rb_underflow : 1; // DWORD 0
               u32 debug_rngman_comp_up_underflow : 1; // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_RINGMGR_DEBUG0, *PMPUARM_RINGMGR_DEBUG0;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_DEBUG0, sizeof (MPUARM_RINGMGR_DEBUG0) == 4);

   #else
      typedef struct _MPUARM_RINGMGR_DEBUG0 {
         u32 debug_rngman_req_credit : 2;         // DWORD 0
         u32 debug_rngman_comp_rb_credit : 2;     // DWORD 0
         u32 debug_rngman_comp_up_credit : 3;     // DWORD 0
         u32 debug_rngman_req_numfilled : 2;      // DWORD 0
         u32 debug_rngman_comp_rb_numfilled : 2;  // DWORD 0
         u32 debug_rngman_comp_up_numfilled : 3;  // DWORD 0
         u32 debug_rngman_req_overflow : 1;       // DWORD 0
         u32 debug_rngman_comp_rb_overflow : 1;   // DWORD 0
         u32 debug_rngman_comp_up_overflow : 1;   // DWORD 0
         u32 debug_rngman_req_underflow : 1;      // DWORD 0
         u32 debug_rngman_comp_rb_underflow : 1;  // DWORD 0
         u32 debug_rngman_comp_up_underflow : 1;  // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
      } SG_PACK MPUARM_RINGMGR_DEBUG0, *PMPUARM_RINGMGR_DEBUG0;

      typedef union _MPUARM_RINGMGR_DEBUG0_UNION {
         MPUARM_RINGMGR_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_RINGMGR_DEBUG0_UNION, *PMPUARM_RINGMGR_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_RINGMGR_DEBUG0_UNION, sizeof (MPUARM_RINGMGR_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPUs IQ complex debug. A write to this register will clear the sticky bits
   // associated with the IQCOMPLEX debug here. The multibit fields in this register
   // suffer from bug 9829 and may yield occational garbage results. Take data with grain
   // of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IQCOMPLEX_DEBUG0 {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 iq3_undeflow : 1;              // DWORD 0
               u32 iq3_overflow : 1;              // DWORD 0
               u32 iq3_numfilled : 3;             // DWORD 0
               u32 iq3_state : 2;                 // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 iq2_undeflow : 1;              // DWORD 0
               u32 iq2_overflow : 1;              // DWORD 0
               u32 iq2_numfilled : 3;             // DWORD 0
               u32 iq2_state : 2;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 iq1_undeflow : 1;              // DWORD 0
               u32 iq1_overflow : 1;              // DWORD 0
               u32 iq1_numfilled : 3;             // DWORD 0
               u32 iq1_state : 2;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 iq0_undeflow : 1;              // DWORD 0
               u32 iq0_overflow : 1;              // DWORD 0
               u32 iq0_numfilled : 3;             // DWORD 0
               u32 iq0_state : 2;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0, *PMPUARM_IQCOMPLEX_DEBUG0;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG0, sizeof (MPUARM_IQCOMPLEX_DEBUG0) == 4);

   #else
      typedef struct _MPUARM_IQCOMPLEX_DEBUG0 {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 iq3_undeflow : 1;                    // DWORD 0
         u32 iq3_overflow : 1;                    // DWORD 0
         u32 iq3_numfilled : 3;                   // DWORD 0
         u32 iq3_state : 2;                       // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 iq2_undeflow : 1;                    // DWORD 0
         u32 iq2_overflow : 1;                    // DWORD 0
         u32 iq2_numfilled : 3;                   // DWORD 0
         u32 iq2_state : 2;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 iq1_undeflow : 1;                    // DWORD 0
         u32 iq1_overflow : 1;                    // DWORD 0
         u32 iq1_numfilled : 3;                   // DWORD 0
         u32 iq1_state : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 iq0_undeflow : 1;                    // DWORD 0
         u32 iq0_overflow : 1;                    // DWORD 0
         u32 iq0_numfilled : 3;                   // DWORD 0
         u32 iq0_state : 2;                       // DWORD 0
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0, *PMPUARM_IQCOMPLEX_DEBUG0;

      typedef union _MPUARM_IQCOMPLEX_DEBUG0_UNION {
         MPUARM_IQCOMPLEX_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0_UNION, *PMPUARM_IQCOMPLEX_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG0_UNION, sizeof (MPUARM_IQCOMPLEX_DEBUG0_UNION) == 4);
   #endif


#else
   // MPUs IQ complex debug. A write to this register will clear the sticky bits
   // associated with the IQCOMPLEX debug here. The multibit fields in this register
   // suffer from bug 9829 and may yield occational garbage results. Take data with grain
   // of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IQCOMPLEX_DEBUG0 {
         union {
            struct { 
               u32 iq0_state : 2;                 // DWORD 0
               u32 iq0_numfilled : 3;             // DWORD 0
               u32 iq0_overflow : 1;              // DWORD 0
               u32 iq0_undeflow : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 iq1_state : 2;                 // DWORD 0
               u32 iq1_numfilled : 3;             // DWORD 0
               u32 iq1_overflow : 1;              // DWORD 0
               u32 iq1_undeflow : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 iq2_state : 2;                 // DWORD 0
               u32 iq2_numfilled : 3;             // DWORD 0
               u32 iq2_overflow : 1;              // DWORD 0
               u32 iq2_undeflow : 1;              // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 iq3_state : 2;                 // DWORD 0
               u32 iq3_numfilled : 3;             // DWORD 0
               u32 iq3_overflow : 1;              // DWORD 0
               u32 iq3_undeflow : 1;              // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0, *PMPUARM_IQCOMPLEX_DEBUG0;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG0, sizeof (MPUARM_IQCOMPLEX_DEBUG0) == 4);

   #else
      typedef struct _MPUARM_IQCOMPLEX_DEBUG0 {
         u32 iq0_state : 2;                       // DWORD 0
         u32 iq0_numfilled : 3;                   // DWORD 0
         u32 iq0_overflow : 1;                    // DWORD 0
         u32 iq0_undeflow : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 iq1_state : 2;                       // DWORD 0
         u32 iq1_numfilled : 3;                   // DWORD 0
         u32 iq1_overflow : 1;                    // DWORD 0
         u32 iq1_undeflow : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 iq2_state : 2;                       // DWORD 0
         u32 iq2_numfilled : 3;                   // DWORD 0
         u32 iq2_overflow : 1;                    // DWORD 0
         u32 iq2_undeflow : 1;                    // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 iq3_state : 2;                       // DWORD 0
         u32 iq3_numfilled : 3;                   // DWORD 0
         u32 iq3_overflow : 1;                    // DWORD 0
         u32 iq3_undeflow : 1;                    // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0, *PMPUARM_IQCOMPLEX_DEBUG0;

      typedef union _MPUARM_IQCOMPLEX_DEBUG0_UNION {
         MPUARM_IQCOMPLEX_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG0_UNION, *PMPUARM_IQCOMPLEX_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG0_UNION, sizeof (MPUARM_IQCOMPLEX_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPUs IQ complexcomplex debug. A write to MPUARM_IQCOMPLEX_DEBUG0 will clear the
   // sticky bits associated with the IQCOMPLEX debug here. The multibit fields in this
   // register suffer from bug 9829 and may yield occational garbage results. Take data
   // with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IQCOMPLEX_DEBUG1 {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 iq7_undeflow : 1;              // DWORD 0
               u32 iq7_overflow : 1;              // DWORD 0
               u32 iq7_numfilled : 3;             // DWORD 0
               u32 iq7_state : 2;                 // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 iq6_undeflow : 1;              // DWORD 0
               u32 iq6_overflow : 1;              // DWORD 0
               u32 iq6_numfilled : 3;             // DWORD 0
               u32 iq6_state : 2;                 // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 iq5_undeflow : 1;              // DWORD 0
               u32 iq5_overflow : 1;              // DWORD 0
               u32 iq5_numfilled : 3;             // DWORD 0
               u32 iq5_state : 2;                 // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 iq4_undeflow : 1;              // DWORD 0
               u32 iq4_overflow : 1;              // DWORD 0
               u32 iq4_numfilled : 3;             // DWORD 0
               u32 iq4_state : 2;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1, *PMPUARM_IQCOMPLEX_DEBUG1;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG1, sizeof (MPUARM_IQCOMPLEX_DEBUG1) == 4);

   #else
      typedef struct _MPUARM_IQCOMPLEX_DEBUG1 {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 iq7_undeflow : 1;                    // DWORD 0
         u32 iq7_overflow : 1;                    // DWORD 0
         u32 iq7_numfilled : 3;                   // DWORD 0
         u32 iq7_state : 2;                       // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 iq6_undeflow : 1;                    // DWORD 0
         u32 iq6_overflow : 1;                    // DWORD 0
         u32 iq6_numfilled : 3;                   // DWORD 0
         u32 iq6_state : 2;                       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 iq5_undeflow : 1;                    // DWORD 0
         u32 iq5_overflow : 1;                    // DWORD 0
         u32 iq5_numfilled : 3;                   // DWORD 0
         u32 iq5_state : 2;                       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 iq4_undeflow : 1;                    // DWORD 0
         u32 iq4_overflow : 1;                    // DWORD 0
         u32 iq4_numfilled : 3;                   // DWORD 0
         u32 iq4_state : 2;                       // DWORD 0
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1, *PMPUARM_IQCOMPLEX_DEBUG1;

      typedef union _MPUARM_IQCOMPLEX_DEBUG1_UNION {
         MPUARM_IQCOMPLEX_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1_UNION, *PMPUARM_IQCOMPLEX_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG1_UNION, sizeof (MPUARM_IQCOMPLEX_DEBUG1_UNION) == 4);
   #endif


#else
   // MPUs IQ complexcomplex debug. A write to MPUARM_IQCOMPLEX_DEBUG0 will clear the
   // sticky bits associated with the IQCOMPLEX debug here. The multibit fields in this
   // register suffer from bug 9829 and may yield occational garbage results. Take data
   // with grain of salt.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPUARM_IQCOMPLEX_DEBUG1 {
         union {
            struct { 
               u32 iq4_state : 2;                 // DWORD 0
               u32 iq4_numfilled : 3;             // DWORD 0
               u32 iq4_overflow : 1;              // DWORD 0
               u32 iq4_undeflow : 1;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 iq5_state : 2;                 // DWORD 0
               u32 iq5_numfilled : 3;             // DWORD 0
               u32 iq5_overflow : 1;              // DWORD 0
               u32 iq5_undeflow : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 iq6_state : 2;                 // DWORD 0
               u32 iq6_numfilled : 3;             // DWORD 0
               u32 iq6_overflow : 1;              // DWORD 0
               u32 iq6_undeflow : 1;              // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 iq7_state : 2;                 // DWORD 0
               u32 iq7_numfilled : 3;             // DWORD 0
               u32 iq7_overflow : 1;              // DWORD 0
               u32 iq7_undeflow : 1;              // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1, *PMPUARM_IQCOMPLEX_DEBUG1;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG1, sizeof (MPUARM_IQCOMPLEX_DEBUG1) == 4);

   #else
      typedef struct _MPUARM_IQCOMPLEX_DEBUG1 {
         u32 iq4_state : 2;                       // DWORD 0
         u32 iq4_numfilled : 3;                   // DWORD 0
         u32 iq4_overflow : 1;                    // DWORD 0
         u32 iq4_undeflow : 1;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 iq5_state : 2;                       // DWORD 0
         u32 iq5_numfilled : 3;                   // DWORD 0
         u32 iq5_overflow : 1;                    // DWORD 0
         u32 iq5_undeflow : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 iq6_state : 2;                       // DWORD 0
         u32 iq6_numfilled : 3;                   // DWORD 0
         u32 iq6_overflow : 1;                    // DWORD 0
         u32 iq6_undeflow : 1;                    // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 iq7_state : 2;                       // DWORD 0
         u32 iq7_numfilled : 3;                   // DWORD 0
         u32 iq7_overflow : 1;                    // DWORD 0
         u32 iq7_undeflow : 1;                    // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1, *PMPUARM_IQCOMPLEX_DEBUG1;

      typedef union _MPUARM_IQCOMPLEX_DEBUG1_UNION {
         MPUARM_IQCOMPLEX_DEBUG1 bits;
         u32 dw; // dword union
      } SG_PACK MPUARM_IQCOMPLEX_DEBUG1_UNION, *PMPUARM_IQCOMPLEX_DEBUG1_UNION;

      SG_C_ASSERT(__sizeof__MPUARM_IQCOMPLEX_DEBUG1_UNION, sizeof (MPUARM_IQCOMPLEX_DEBUG1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // EP PLL Control registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_XT_CLK_CONTROL {
         union {
            struct { 
               u32 xtpll_cfg_pc : 4;              // DWORD 0
               u32 xtpll_cfg_pb : 4;              // DWORD 0
               u32 xtpll_cfg_pa : 4;              // DWORD 0
               u32 xtpll_cfg_n : 4;               // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 xtclk_cfg : 4;                 // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 live_signal_read : 1;          // DWORD 0
               u32 live_strap_read : 1;           // DWORD 0
               u32 strap_override_value : 1;      // DWORD 0
               u32 strap_override_en : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_XT_CLK_CONTROL, *PMPU_XT_CLK_CONTROL;

      SG_C_ASSERT(__sizeof__MPU_XT_CLK_CONTROL, sizeof (MPU_XT_CLK_CONTROL) == 4);

   #else
      typedef struct _MPU_XT_CLK_CONTROL {
         u32 xtpll_cfg_pc : 4;                    // DWORD 0
         u32 xtpll_cfg_pb : 4;                    // DWORD 0
         u32 xtpll_cfg_pa : 4;                    // DWORD 0
         u32 xtpll_cfg_n : 4;                     // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 xtclk_cfg : 4;                       // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 live_signal_read : 1;                // DWORD 0
         u32 live_strap_read : 1;                 // DWORD 0
         u32 strap_override_value : 1;            // DWORD 0
         u32 strap_override_en : 1;               // DWORD 0
      } SG_PACK MPU_XT_CLK_CONTROL, *PMPU_XT_CLK_CONTROL;

      typedef union _MPU_XT_CLK_CONTROL_UNION {
         MPU_XT_CLK_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK MPU_XT_CLK_CONTROL_UNION, *PMPU_XT_CLK_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__MPU_XT_CLK_CONTROL_UNION, sizeof (MPU_XT_CLK_CONTROL_UNION) == 4);
   #endif


#else
   // EP PLL Control registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_XT_CLK_CONTROL {
         union {
            struct { 
               u32 strap_override_en : 1;         // DWORD 0
               u32 strap_override_value : 1;      // DWORD 0
               u32 live_strap_read : 1;           // DWORD 0
               u32 live_signal_read : 1;          // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 xtclk_cfg : 4;                 // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 xtpll_cfg_n : 4;               // DWORD 0
               u32 xtpll_cfg_pa : 4;              // DWORD 0
               u32 xtpll_cfg_pb : 4;              // DWORD 0
               u32 xtpll_cfg_pc : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK MPU_XT_CLK_CONTROL, *PMPU_XT_CLK_CONTROL;

      SG_C_ASSERT(__sizeof__MPU_XT_CLK_CONTROL, sizeof (MPU_XT_CLK_CONTROL) == 4);

   #else
      typedef struct _MPU_XT_CLK_CONTROL {
         u32 strap_override_en : 1;               // DWORD 0
         u32 strap_override_value : 1;            // DWORD 0
         u32 live_strap_read : 1;                 // DWORD 0
         u32 live_signal_read : 1;                // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 xtclk_cfg : 4;                       // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 xtpll_cfg_n : 4;                     // DWORD 0
         u32 xtpll_cfg_pa : 4;                    // DWORD 0
         u32 xtpll_cfg_pb : 4;                    // DWORD 0
         u32 xtpll_cfg_pc : 4;                    // DWORD 0
      } SG_PACK MPU_XT_CLK_CONTROL, *PMPU_XT_CLK_CONTROL;

      typedef union _MPU_XT_CLK_CONTROL_UNION {
         MPU_XT_CLK_CONTROL bits;
         u32 dw; // dword union
      } SG_PACK MPU_XT_CLK_CONTROL_UNION, *PMPU_XT_CLK_CONTROL_UNION;

      SG_C_ASSERT(__sizeof__MPU_XT_CLK_CONTROL_UNION, sizeof (MPU_XT_CLK_CONTROL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // General Control and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MPU_CONTROL_CSR {
         union {
            struct { 
               u32 CPU_reset : 1;                 // DWORD 0
               u32 rsvd2 : 15;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 m2_RxPbuf : 1;                 // DWORD 0
               u32 m1_RxPbuf : 1;                 // DWORD 0
               u32 m0_RxPbuf : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_MPU_CONTROL_CSR, *PEP_MPU_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_MPU_CONTROL_CSR, sizeof (EP_MPU_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_MPU_CONTROL_CSR {
         u32 CPU_reset : 1;                       // DWORD 0
         u32 rsvd2 : 15;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 m2_RxPbuf : 1;                       // DWORD 0
         u32 m1_RxPbuf : 1;                       // DWORD 0
         u32 m0_RxPbuf : 1;                       // DWORD 0
      } SG_PACK EP_MPU_CONTROL_CSR, *PEP_MPU_CONTROL_CSR;

      typedef union _EP_MPU_CONTROL_CSR_UNION {
         EP_MPU_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_MPU_CONTROL_CSR_UNION, *PEP_MPU_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_MPU_CONTROL_CSR_UNION, sizeof (EP_MPU_CONTROL_CSR_UNION) == 4);
   #endif


#else
   // General Control and Status Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MPU_CONTROL_CSR {
         union {
            struct { 
               u32 m0_RxPbuf : 1;                 // DWORD 0
               u32 m1_RxPbuf : 1;                 // DWORD 0
               u32 m2_RxPbuf : 1;                 // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 rsvd2 : 15;                    // DWORD 0
               u32 CPU_reset : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK EP_MPU_CONTROL_CSR, *PEP_MPU_CONTROL_CSR;

      SG_C_ASSERT(__sizeof__EP_MPU_CONTROL_CSR, sizeof (EP_MPU_CONTROL_CSR) == 4);

   #else
      typedef struct _EP_MPU_CONTROL_CSR {
         u32 m0_RxPbuf : 1;                       // DWORD 0
         u32 m1_RxPbuf : 1;                       // DWORD 0
         u32 m2_RxPbuf : 1;                       // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 rsvd2 : 15;                          // DWORD 0
         u32 CPU_reset : 1;                       // DWORD 0
      } SG_PACK EP_MPU_CONTROL_CSR, *PEP_MPU_CONTROL_CSR;

      typedef union _EP_MPU_CONTROL_CSR_UNION {
         EP_MPU_CONTROL_CSR bits;
         u32 dw; // dword union
      } SG_PACK EP_MPU_CONTROL_CSR_UNION, *PEP_MPU_CONTROL_CSR_UNION;

      SG_C_ASSERT(__sizeof__EP_MPU_CONTROL_CSR_UNION, sizeof (EP_MPU_CONTROL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Embedded Processor Specific Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MPU_CSRMAP {
         union {
            struct { 
               EP_MPU_CONTROL_CSR ep_control;
               u32 rsvd0[4];                      // DWORDS 1 to 4
               EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
               struct {
                  EP_QCTRL0_CSR ep_qctrl0;
                  EP_QCTRL1_CSR ep_qctrl1;
                  EP_QCTRL2_CSR ep_qctrl2;
                  EP_QCTRL3_CSR ep_qctrl3;
               } input_queue[8];
               EP_BANK_CONTROL_CSR ep_bank_control;
               EP_QCREDITA_CSR ep_qcreditA;
               EP_QCREDITB_CSR ep_qcreditB;
               EP_QCREDITC_CSR ep_qcreditC;
               EP_QCREDITD_CSR ep_qcreditD;
               EP_SEMAPHORE_CSR ep_semaphore;
               EP_IPC_OV_CSR ep_ipc_ov;
               EP_STATS_RW_CONTROL_CSR ep_stats_control;
               EP_STATS_READ_DATA_CSR ep_stats_read_data;
               u32 rsvd1[17];                     // DWORDS 19 to 35
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK EP_MPU_CSRMAP, *PEP_MPU_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_MPU_CSRMAP, sizeof (EP_MPU_CSRMAP) == 256);

   #else
      typedef struct _EP_MPU_CSRMAP {
         EP_MPU_CONTROL_CSR ep_control;
         u32 rsvd0[4];                            // DWORDS 1 to 4
         EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
         struct {
            EP_QCTRL0_CSR ep_qctrl0;
            EP_QCTRL1_CSR ep_qctrl1;
            EP_QCTRL2_CSR ep_qctrl2;
            EP_QCTRL3_CSR ep_qctrl3;
         } input_queue[8];
         EP_BANK_CONTROL_CSR ep_bank_control;
         EP_QCREDITA_CSR ep_qcreditA;
         EP_QCREDITB_CSR ep_qcreditB;
         EP_QCREDITC_CSR ep_qcreditC;
         EP_QCREDITD_CSR ep_qcreditD;
         EP_SEMAPHORE_CSR ep_semaphore;
         EP_IPC_OV_CSR ep_ipc_ov;
         EP_STATS_RW_CONTROL_CSR ep_stats_control;
         EP_STATS_READ_DATA_CSR ep_stats_read_data;
         u32 rsvd1[17];                           // DWORDS 19 to 35
      } SG_PACK EP_MPU_CSRMAP, *PEP_MPU_CSRMAP;

      typedef union _EP_MPU_CSRMAP_UNION {
         EP_MPU_CSRMAP bits;
         u32 dw[64]; // dword union
      } SG_PACK EP_MPU_CSRMAP_UNION, *PEP_MPU_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_MPU_CSRMAP_UNION, sizeof (EP_MPU_CSRMAP_UNION) == 256);
   #endif


#else
   // Embedded Processor Specific Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _EP_MPU_CSRMAP {
         union {
            struct { 
               EP_MPU_CONTROL_CSR ep_control;
               u32 rsvd0[4];                      // DWORDS 1 to 4
               EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
               struct {
                  EP_QCTRL0_CSR ep_qctrl0;
                  EP_QCTRL1_CSR ep_qctrl1;
                  EP_QCTRL2_CSR ep_qctrl2;
                  EP_QCTRL3_CSR ep_qctrl3;
               } input_queue[8];
               EP_BANK_CONTROL_CSR ep_bank_control;
               EP_QCREDITA_CSR ep_qcreditA;
               EP_QCREDITB_CSR ep_qcreditB;
               EP_QCREDITC_CSR ep_qcreditC;
               EP_QCREDITD_CSR ep_qcreditD;
               EP_SEMAPHORE_CSR ep_semaphore;
               EP_IPC_OV_CSR ep_ipc_ov;
               EP_STATS_RW_CONTROL_CSR ep_stats_control;
               EP_STATS_READ_DATA_CSR ep_stats_read_data;
               u32 rsvd1[17];                     // DWORDS 19 to 35
            } SG_PACK ; // unnamed struct
            u32 dw[64]; // dword union
         }; // unnamed union
      } SG_PACK EP_MPU_CSRMAP, *PEP_MPU_CSRMAP;

      SG_C_ASSERT(__sizeof__EP_MPU_CSRMAP, sizeof (EP_MPU_CSRMAP) == 256);

   #else
      typedef struct _EP_MPU_CSRMAP {
         EP_MPU_CONTROL_CSR ep_control;
         u32 rsvd0[4];                            // DWORDS 1 to 4
         EP_INPUT_QUE_WEIGHT_CSR ep_input_que_weight;
         struct {
            EP_QCTRL0_CSR ep_qctrl0;
            EP_QCTRL1_CSR ep_qctrl1;
            EP_QCTRL2_CSR ep_qctrl2;
            EP_QCTRL3_CSR ep_qctrl3;
         } input_queue[8];
         EP_BANK_CONTROL_CSR ep_bank_control;
         EP_QCREDITA_CSR ep_qcreditA;
         EP_QCREDITB_CSR ep_qcreditB;
         EP_QCREDITC_CSR ep_qcreditC;
         EP_QCREDITD_CSR ep_qcreditD;
         EP_SEMAPHORE_CSR ep_semaphore;
         EP_IPC_OV_CSR ep_ipc_ov;
         EP_STATS_RW_CONTROL_CSR ep_stats_control;
         EP_STATS_READ_DATA_CSR ep_stats_read_data;
         u32 rsvd1[17];                           // DWORDS 19 to 35
      } SG_PACK EP_MPU_CSRMAP, *PEP_MPU_CSRMAP;

      typedef union _EP_MPU_CSRMAP_UNION {
         EP_MPU_CSRMAP bits;
         u32 dw[64]; // dword union
      } SG_PACK EP_MPU_CSRMAP_UNION, *PEP_MPU_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__EP_MPU_CSRMAP_UNION, sizeof (EP_MPU_CSRMAP_UNION) == 256);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Provide control parameters for the Managment Processor Unit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CSRMAP {
         union {
            struct { 
               EP_MPU_CSRMAP ep;
               u32 rsvd0[4];                      // DWORDS 64 to 67
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr;
               MPU_INT_SOURCE int_source;
               MPU_INT_MASK int_mask;
               MPU_UE_SOURCE ue_source;
               MPU_UE_ENABLE ue_enable;
               EP_TDEBUG_CTRL ep_tdebug_ctrl;
               EP_TDEBUG_OCDMODE ep_tdebug_ocdmode;
               MPU_BOOT_CTRL_CSR boot_ctrl;
               MPU_BOOT_STATUS_CSR boot_status;
               MPU_CONSEL_DEBUG0 consel_debug0;
               MPU_INT_DEBUG0 int_debug0;
               MPU_IQ_DEBUG0 iq_debug0;
               MPU_OQ_DEBUG0 oq_debug0;
               MPU_OQ_DEBUG1 oq_debug1;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG pmemif_debug;
               GEN_CTXIF_DEBUG txpbif_debug;
               MPU_RRM_DEBUG0 rrm_debug0;
               MPU_JTAG_INSERTION jtag_insertion;
               MPU_JTAG_SHIFT jtag_shift;
               HWDBG_CSRMAP hwdbg;
               MPU_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               MPU_DDR_RWDATA_CSR ddr_rwdata_csr;
               MPU_DDR_ADDR_CSR ddr_addr_csr;
               HWDBG_CSRMAP armhwdbg;
               MPU_SERVER_ISR_CSR server_isr_csr;
               MPU_SERVER_IMR_CSR server_imr_csr;
               MPU_IIC_IF iic_if;
               MPU_IIC_CTRL iic_ctrl;
               MPU_IIC_BIT_IF iic_bit_if;
               MPUARM_SYSREG_CTRL arm_sysreg_ctrl;
               MPUARM_SYSREG_DATA arm_sysreg_data;
               GEN_IPC_DEBUG ipc_debug;
               MPU_GEN_CONTROL gen_control;
               MPUARM_RINGMGR_CTRL0 ringmgr_ctrl0;
               MPUARM_RINGMGR_DEBUG0 ringmgr_debug0;
               MPUARM_IQCOMPLEX_DEBUG0 iqcomplex_debug0;
               MPUARM_IQCOMPLEX_DEBUG1 iqcomplex_debug1;
               MPU_UE_SOURCE1 ue_source1;
               MPU_UE_ENABLE1 ue_enable1;
               MPU_XT_CLK_CONTROL xt_clk_control;
               u32 rsvd1[137];                    // DWORDS 119 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK MPU_CSRMAP, *PMPU_CSRMAP;

      SG_C_ASSERT(__sizeof__MPU_CSRMAP, sizeof (MPU_CSRMAP) == 1024);

   #else
      typedef struct _MPU_CSRMAP {
         EP_MPU_CSRMAP ep;
         u32 rsvd0[4];                            // DWORDS 64 to 67
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr;
         MPU_INT_SOURCE int_source;
         MPU_INT_MASK int_mask;
         MPU_UE_SOURCE ue_source;
         MPU_UE_ENABLE ue_enable;
         EP_TDEBUG_CTRL ep_tdebug_ctrl;
         EP_TDEBUG_OCDMODE ep_tdebug_ocdmode;
         MPU_BOOT_CTRL_CSR boot_ctrl;
         MPU_BOOT_STATUS_CSR boot_status;
         MPU_CONSEL_DEBUG0 consel_debug0;
         MPU_INT_DEBUG0 int_debug0;
         MPU_IQ_DEBUG0 iq_debug0;
         MPU_OQ_DEBUG0 oq_debug0;
         MPU_OQ_DEBUG1 oq_debug1;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG pmemif_debug;
         GEN_CTXIF_DEBUG txpbif_debug;
         MPU_RRM_DEBUG0 rrm_debug0;
         MPU_JTAG_INSERTION jtag_insertion;
         MPU_JTAG_SHIFT jtag_shift;
         HWDBG_CSRMAP hwdbg;
         MPU_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         MPU_DDR_RWDATA_CSR ddr_rwdata_csr;
         MPU_DDR_ADDR_CSR ddr_addr_csr;
         HWDBG_CSRMAP armhwdbg;
         MPU_SERVER_ISR_CSR server_isr_csr;
         MPU_SERVER_IMR_CSR server_imr_csr;
         MPU_IIC_IF iic_if;
         MPU_IIC_CTRL iic_ctrl;
         MPU_IIC_BIT_IF iic_bit_if;
         MPUARM_SYSREG_CTRL arm_sysreg_ctrl;
         MPUARM_SYSREG_DATA arm_sysreg_data;
         GEN_IPC_DEBUG ipc_debug;
         MPU_GEN_CONTROL gen_control;
         MPUARM_RINGMGR_CTRL0 ringmgr_ctrl0;
         MPUARM_RINGMGR_DEBUG0 ringmgr_debug0;
         MPUARM_IQCOMPLEX_DEBUG0 iqcomplex_debug0;
         MPUARM_IQCOMPLEX_DEBUG1 iqcomplex_debug1;
         MPU_UE_SOURCE1 ue_source1;
         MPU_UE_ENABLE1 ue_enable1;
         MPU_XT_CLK_CONTROL xt_clk_control;
         u32 rsvd1[137];                          // DWORDS 119 to 255
      } SG_PACK MPU_CSRMAP, *PMPU_CSRMAP;

      typedef union _MPU_CSRMAP_UNION {
         MPU_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK MPU_CSRMAP_UNION, *PMPU_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_CSRMAP_UNION, sizeof (MPU_CSRMAP_UNION) == 1024);
   #endif


#else
   // Provide control parameters for the Managment Processor Unit.
   #if defined(SG_BMAP_UNION)
      typedef struct _MPU_CSRMAP {
         union {
            struct { 
               EP_MPU_CSRMAP ep;
               u32 rsvd0[4];                      // DWORDS 64 to 67
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr;
               MPU_INT_SOURCE int_source;
               MPU_INT_MASK int_mask;
               MPU_UE_SOURCE ue_source;
               MPU_UE_ENABLE ue_enable;
               EP_TDEBUG_CTRL ep_tdebug_ctrl;
               EP_TDEBUG_OCDMODE ep_tdebug_ocdmode;
               MPU_BOOT_CTRL_CSR boot_ctrl;
               MPU_BOOT_STATUS_CSR boot_status;
               MPU_CONSEL_DEBUG0 consel_debug0;
               MPU_INT_DEBUG0 int_debug0;
               MPU_IQ_DEBUG0 iq_debug0;
               MPU_OQ_DEBUG0 oq_debug0;
               MPU_OQ_DEBUG1 oq_debug1;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG pmemif_debug;
               GEN_CTXIF_DEBUG txpbif_debug;
               MPU_RRM_DEBUG0 rrm_debug0;
               MPU_JTAG_INSERTION jtag_insertion;
               MPU_JTAG_SHIFT jtag_shift;
               HWDBG_CSRMAP hwdbg;
               MPU_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               MPU_DDR_RWDATA_CSR ddr_rwdata_csr;
               MPU_DDR_ADDR_CSR ddr_addr_csr;
               HWDBG_CSRMAP armhwdbg;
               MPU_SERVER_ISR_CSR server_isr_csr;
               MPU_SERVER_IMR_CSR server_imr_csr;
               MPU_IIC_IF iic_if;
               MPU_IIC_CTRL iic_ctrl;
               MPU_IIC_BIT_IF iic_bit_if;
               MPUARM_SYSREG_CTRL arm_sysreg_ctrl;
               MPUARM_SYSREG_DATA arm_sysreg_data;
               GEN_IPC_DEBUG ipc_debug;
               MPU_GEN_CONTROL gen_control;
               MPUARM_RINGMGR_CTRL0 ringmgr_ctrl0;
               MPUARM_RINGMGR_DEBUG0 ringmgr_debug0;
               MPUARM_IQCOMPLEX_DEBUG0 iqcomplex_debug0;
               MPUARM_IQCOMPLEX_DEBUG1 iqcomplex_debug1;
               MPU_UE_SOURCE1 ue_source1;
               MPU_UE_ENABLE1 ue_enable1;
               MPU_XT_CLK_CONTROL xt_clk_control;
               u32 rsvd1[137];                    // DWORDS 119 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK MPU_CSRMAP, *PMPU_CSRMAP;

      SG_C_ASSERT(__sizeof__MPU_CSRMAP, sizeof (MPU_CSRMAP) == 1024);

   #else
      typedef struct _MPU_CSRMAP {
         EP_MPU_CSRMAP ep;
         u32 rsvd0[4];                            // DWORDS 64 to 67
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr;
         MPU_INT_SOURCE int_source;
         MPU_INT_MASK int_mask;
         MPU_UE_SOURCE ue_source;
         MPU_UE_ENABLE ue_enable;
         EP_TDEBUG_CTRL ep_tdebug_ctrl;
         EP_TDEBUG_OCDMODE ep_tdebug_ocdmode;
         MPU_BOOT_CTRL_CSR boot_ctrl;
         MPU_BOOT_STATUS_CSR boot_status;
         MPU_CONSEL_DEBUG0 consel_debug0;
         MPU_INT_DEBUG0 int_debug0;
         MPU_IQ_DEBUG0 iq_debug0;
         MPU_OQ_DEBUG0 oq_debug0;
         MPU_OQ_DEBUG1 oq_debug1;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG pmemif_debug;
         GEN_CTXIF_DEBUG txpbif_debug;
         MPU_RRM_DEBUG0 rrm_debug0;
         MPU_JTAG_INSERTION jtag_insertion;
         MPU_JTAG_SHIFT jtag_shift;
         HWDBG_CSRMAP hwdbg;
         MPU_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         MPU_DDR_RWDATA_CSR ddr_rwdata_csr;
         MPU_DDR_ADDR_CSR ddr_addr_csr;
         HWDBG_CSRMAP armhwdbg;
         MPU_SERVER_ISR_CSR server_isr_csr;
         MPU_SERVER_IMR_CSR server_imr_csr;
         MPU_IIC_IF iic_if;
         MPU_IIC_CTRL iic_ctrl;
         MPU_IIC_BIT_IF iic_bit_if;
         MPUARM_SYSREG_CTRL arm_sysreg_ctrl;
         MPUARM_SYSREG_DATA arm_sysreg_data;
         GEN_IPC_DEBUG ipc_debug;
         MPU_GEN_CONTROL gen_control;
         MPUARM_RINGMGR_CTRL0 ringmgr_ctrl0;
         MPUARM_RINGMGR_DEBUG0 ringmgr_debug0;
         MPUARM_IQCOMPLEX_DEBUG0 iqcomplex_debug0;
         MPUARM_IQCOMPLEX_DEBUG1 iqcomplex_debug1;
         MPU_UE_SOURCE1 ue_source1;
         MPU_UE_ENABLE1 ue_enable1;
         MPU_XT_CLK_CONTROL xt_clk_control;
         u32 rsvd1[137];                          // DWORDS 119 to 255
      } SG_PACK MPU_CSRMAP, *PMPU_CSRMAP;

      typedef union _MPU_CSRMAP_UNION {
         MPU_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK MPU_CSRMAP_UNION, *PMPU_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__MPU_CSRMAP_UNION, sizeof (MPU_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __mpu_bmap_h__

