/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpost_bmap_h__
#define __tpost_bmap_h__
#include "setypes.h"
#include "ep_bmap.h"
#include "jellm_bmap.h"
#include "ep_minirom_bmap.h"
#include "hwdbg_reg_bmap.h"
#include "gencommon_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector 2nd Level Arbiter Weight Control Register 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL1_CR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 tpost_ps_weight_u2p1 : 4;      // DWORD 0
               u32 tpost_ps_weight_u2p0 : 4;      // DWORD 0
               u32 tpost_ps_weight_u1p1 : 4;      // DWORD 0
               u32 tpost_ps_weight_u1p0 : 4;      // DWORD 0
               u32 tpost_ps_weight_u0p1 : 4;      // DWORD 0
               u32 tpost_ps_weight_u0p0 : 4;      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL1_CR, *PTPOST_PROTSEL_CTL1_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL1_CR, sizeof (TPOST_PROTSEL_CTL1_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL1_CR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 tpost_ps_weight_u2p1 : 4;            // DWORD 0
         u32 tpost_ps_weight_u2p0 : 4;            // DWORD 0
         u32 tpost_ps_weight_u1p1 : 4;            // DWORD 0
         u32 tpost_ps_weight_u1p0 : 4;            // DWORD 0
         u32 tpost_ps_weight_u0p1 : 4;            // DWORD 0
         u32 tpost_ps_weight_u0p0 : 4;            // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL1_CR, *PTPOST_PROTSEL_CTL1_CR;

      typedef union _TPOST_PROTSEL_CTL1_CR_UNION {
         TPOST_PROTSEL_CTL1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL1_CR_UNION, *PTPOST_PROTSEL_CTL1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL1_CR_UNION, sizeof (TPOST_PROTSEL_CTL1_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector 2nd Level Arbiter Weight Control Register 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL1_CR {
         union {
            struct { 
               u32 tpost_ps_weight_u0p0 : 4;      // DWORD 0
               u32 tpost_ps_weight_u0p1 : 4;      // DWORD 0
               u32 tpost_ps_weight_u1p0 : 4;      // DWORD 0
               u32 tpost_ps_weight_u1p1 : 4;      // DWORD 0
               u32 tpost_ps_weight_u2p0 : 4;      // DWORD 0
               u32 tpost_ps_weight_u2p1 : 4;      // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL1_CR, *PTPOST_PROTSEL_CTL1_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL1_CR, sizeof (TPOST_PROTSEL_CTL1_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL1_CR {
         u32 tpost_ps_weight_u0p0 : 4;            // DWORD 0
         u32 tpost_ps_weight_u0p1 : 4;            // DWORD 0
         u32 tpost_ps_weight_u1p0 : 4;            // DWORD 0
         u32 tpost_ps_weight_u1p1 : 4;            // DWORD 0
         u32 tpost_ps_weight_u2p0 : 4;            // DWORD 0
         u32 tpost_ps_weight_u2p1 : 4;            // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL1_CR, *PTPOST_PROTSEL_CTL1_CR;

      typedef union _TPOST_PROTSEL_CTL1_CR_UNION {
         TPOST_PROTSEL_CTL1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL1_CR_UNION, *PTPOST_PROTSEL_CTL1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL1_CR_UNION, sizeof (TPOST_PROTSEL_CTL1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector Second Level Arbiter Weight Control Register 2.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL2_CR {
         union {
            struct { 
               u32 rsvd0 : 16;                    // DWORD 0
               u32 tpost_ps_weight_lowlat_port1 : 4; // DWORD 0
               u32 tpost_ps_weight_lowlat_port0 : 4; // DWORD 0
               u32 tpost_ps_weight_timp1 : 4;     // DWORD 0
               u32 tpost_ps_weight_timp0 : 4;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL2_CR, *PTPOST_PROTSEL_CTL2_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL2_CR, sizeof (TPOST_PROTSEL_CTL2_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL2_CR {
         u32 rsvd0 : 16;                          // DWORD 0
         u32 tpost_ps_weight_lowlat_port1 : 4;    // DWORD 0
         u32 tpost_ps_weight_lowlat_port0 : 4;    // DWORD 0
         u32 tpost_ps_weight_timp1 : 4;           // DWORD 0
         u32 tpost_ps_weight_timp0 : 4;           // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL2_CR, *PTPOST_PROTSEL_CTL2_CR;

      typedef union _TPOST_PROTSEL_CTL2_CR_UNION {
         TPOST_PROTSEL_CTL2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL2_CR_UNION, *PTPOST_PROTSEL_CTL2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL2_CR_UNION, sizeof (TPOST_PROTSEL_CTL2_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector Second Level Arbiter Weight Control Register 2.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL2_CR {
         union {
            struct { 
               u32 tpost_ps_weight_timp0 : 4;     // DWORD 0
               u32 tpost_ps_weight_timp1 : 4;     // DWORD 0
               u32 tpost_ps_weight_lowlat_port0 : 4; // DWORD 0
               u32 tpost_ps_weight_lowlat_port1 : 4; // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL2_CR, *PTPOST_PROTSEL_CTL2_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL2_CR, sizeof (TPOST_PROTSEL_CTL2_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL2_CR {
         u32 tpost_ps_weight_timp0 : 4;           // DWORD 0
         u32 tpost_ps_weight_timp1 : 4;           // DWORD 0
         u32 tpost_ps_weight_lowlat_port0 : 4;    // DWORD 0
         u32 tpost_ps_weight_lowlat_port1 : 4;    // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL2_CR, *PTPOST_PROTSEL_CTL2_CR;

      typedef union _TPOST_PROTSEL_CTL2_CR_UNION {
         TPOST_PROTSEL_CTL2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL2_CR_UNION, *PTPOST_PROTSEL_CTL2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL2_CR_UNION, sizeof (TPOST_PROTSEL_CTL2_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector First Level Arbiter(s) Weight Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL3_CR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 tpost_ps_weight_req_ack2port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute2port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack2port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute2port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack1port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute1port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack1port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute1port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack0port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute0port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack0port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute0port0 : 2; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL3_CR, *PTPOST_PROTSEL_CTL3_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL3_CR, sizeof (TPOST_PROTSEL_CTL3_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL3_CR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 tpost_ps_weight_req_ack2port1 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute2port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack2port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute2port0 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack1port1 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute1port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack1port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute1port0 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack0port1 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute0port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack0port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute0port0 : 2; // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL3_CR, *PTPOST_PROTSEL_CTL3_CR;

      typedef union _TPOST_PROTSEL_CTL3_CR_UNION {
         TPOST_PROTSEL_CTL3_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL3_CR_UNION, *PTPOST_PROTSEL_CTL3_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL3_CR_UNION, sizeof (TPOST_PROTSEL_CTL3_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector First Level Arbiter(s) Weight Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_CTL3_CR {
         union {
            struct { 
               u32 tpost_ps_weight_req_chute0port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack0port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute0port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack0port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute1port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack1port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute1port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack1port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute2port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack2port0 : 2; // DWORD 0
               u32 tpost_ps_weight_req_chute2port1 : 2; // DWORD 0
               u32 tpost_ps_weight_req_ack2port1 : 2; // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_CTL3_CR, *PTPOST_PROTSEL_CTL3_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL3_CR, sizeof (TPOST_PROTSEL_CTL3_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_CTL3_CR {
         u32 tpost_ps_weight_req_chute0port0 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack0port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute0port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack0port1 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute1port0 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack1port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute1port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack1port1 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute2port0 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack2port0 : 2;   // DWORD 0
         u32 tpost_ps_weight_req_chute2port1 : 2; // DWORD 0
         u32 tpost_ps_weight_req_ack2port1 : 2;   // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TPOST_PROTSEL_CTL3_CR, *PTPOST_PROTSEL_CTL3_CR;

      typedef union _TPOST_PROTSEL_CTL3_CR_UNION {
         TPOST_PROTSEL_CTL3_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_CTL3_CR_UNION, *PTPOST_PROTSEL_CTL3_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_CTL3_CR_UNION, sizeof (TPOST_PROTSEL_CTL3_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector Control Register 2.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEST_BUF_CREDIT_CR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 tpost_ps_dcredit_u2p1 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u2p0 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u1p1 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u1p0 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u0p1 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u0p0 : 4;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR, *PTPOST_DEST_BUF_CREDIT_CR;

      SG_C_ASSERT(__sizeof__TPOST_DEST_BUF_CREDIT_CR, sizeof (TPOST_DEST_BUF_CREDIT_CR) == 4);

   #else
      typedef struct _TPOST_DEST_BUF_CREDIT_CR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 tpost_ps_dcredit_u2p1 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u2p0 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u1p1 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u1p0 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u0p1 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u0p0 : 4;           // DWORD 0
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR, *PTPOST_DEST_BUF_CREDIT_CR;

      typedef union _TPOST_DEST_BUF_CREDIT_CR_UNION {
         TPOST_DEST_BUF_CREDIT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR_UNION, *PTPOST_DEST_BUF_CREDIT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEST_BUF_CREDIT_CR_UNION, sizeof (TPOST_DEST_BUF_CREDIT_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector Control Register 2.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEST_BUF_CREDIT_CR {
         union {
            struct { 
               u32 tpost_ps_dcredit_u0p0 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u0p1 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u1p0 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u1p1 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u2p0 : 4;     // DWORD 0
               u32 tpost_ps_dcredit_u2p1 : 4;     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR, *PTPOST_DEST_BUF_CREDIT_CR;

      SG_C_ASSERT(__sizeof__TPOST_DEST_BUF_CREDIT_CR, sizeof (TPOST_DEST_BUF_CREDIT_CR) == 4);

   #else
      typedef struct _TPOST_DEST_BUF_CREDIT_CR {
         u32 tpost_ps_dcredit_u0p0 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u0p1 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u1p0 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u1p1 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u2p0 : 4;           // DWORD 0
         u32 tpost_ps_dcredit_u2p1 : 4;           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR, *PTPOST_DEST_BUF_CREDIT_CR;

      typedef union _TPOST_DEST_BUF_CREDIT_CR_UNION {
         TPOST_DEST_BUF_CREDIT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEST_BUF_CREDIT_CR_UNION, *PTPOST_DEST_BUF_CREDIT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEST_BUF_CREDIT_CR_UNION, sizeof (TPOST_DEST_BUF_CREDIT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Journal Write Back, High Order, Physical Address
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR {
         union {
            struct { 
               u32 tpost_journal_xlat_high_order_addr; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, sizeof (TPOST_JOURNAL_WB_HO_PHY_ADDR_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR {
         u32 tpost_journal_xlat_high_order_addr;  // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR;

      typedef union _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION {
         TPOST_JOURNAL_WB_HO_PHY_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION, sizeof (TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION) == 4);
   #endif


#else
   // TPOST Journal Write Back, High Order, Physical Address
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR {
         union {
            struct { 
               u32 tpost_journal_xlat_high_order_addr; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, sizeof (TPOST_JOURNAL_WB_HO_PHY_ADDR_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR {
         u32 tpost_journal_xlat_high_order_addr;  // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR;

      typedef union _TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION {
         TPOST_JOURNAL_WB_HO_PHY_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION, *PTPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION, sizeof (TPOST_JOURNAL_WB_HO_PHY_ADDR_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Journal Write Back Translation Table Address
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 tpost_journal_addr_xlat_table_addr : 9; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 tpost_journal_addr_xlat_table_addr : 9; // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR;

      typedef union _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION {
         TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION) == 4);
   #endif


#else
   // TPOST Journal Write Back Translation Table Address
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR {
         union {
            struct { 
               u32 tpost_journal_addr_xlat_table_addr : 9; // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR {
         u32 tpost_journal_addr_xlat_table_addr : 9; // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR;

      typedef union _TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION {
         TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION, *PTPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Journal Write Back Translation Table Data
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 tpost_journal_addr_xlat_table_data : 20; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 tpost_journal_addr_xlat_table_data : 20; // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR;

      typedef union _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION {
         TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION) == 4);
   #endif


#else
   // TPOST Journal Write Back Translation Table Data
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR {
         union {
            struct { 
               u32 tpost_journal_addr_xlat_table_data : 20; // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR) == 4);

   #else
      typedef struct _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR {
         u32 tpost_journal_addr_xlat_table_data : 20; // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR;

      typedef union _TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION {
         TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION, *PTPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION, sizeof (TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_SOURCE_CR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 tpost_txpb_parity_error_status : 1; // DWORD 0
               u32 tpost_ctx_parity_error_status : 1; // DWORD 0
               u32 tpost_addr_xlat_ram_parity_error_status : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 tpost_detect_reserved_target_que_field_error_status : 1; // DWORD 0
               u32 jellm_deallocate_overrun_error_status : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_status : 1; // DWORD 0
               u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
               u32 ipc_eof_error_status : 1;      // DWORD 0
               u32 ipc_sof_error_status : 1;      // DWORD 0
               u32 ipc_overflow_error_status : 1; // DWORD 0
               u32 ep_mmr_bus_access_timeout_status : 1; // DWORD 0
               u32 ep_firmware_force_ue_error_status : 1; // DWORD 0
               u32 ep_fixed_data_ram_write_out_of_range_status : 1; // DWORD 0
               u32 ep_inst_ram_write_out_of_range_status : 1; // DWORD 0
               u32 ep_stats_ram_parity_error_status : 1; // DWORD 0
               u32 ep_inst_ram_parity_error_status : 1; // DWORD 0
               u32 ep_shadow_ram_parity_error_status : 1; // DWORD 0
               u32 ep_fixed_data_ram_parity_error_status : 1; // DWORD 0
               u32 ep_y_bank_ram_parity_error_status : 1; // DWORD 0
               u32 ep_x_bank_ram_parity_error_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_SOURCE_CR, *PTPOST_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_CR, sizeof (TPOST_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_UE_SOURCE_CR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 tpost_txpb_parity_error_status : 1;  // DWORD 0
         u32 tpost_ctx_parity_error_status : 1;   // DWORD 0
         u32 tpost_addr_xlat_ram_parity_error_status : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 tpost_detect_reserved_target_que_field_error_status : 1; // DWORD 0
         u32 jellm_deallocate_overrun_error_status : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_status : 1;  // DWORD 0
         u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
         u32 ipc_eof_error_status : 1;            // DWORD 0
         u32 ipc_sof_error_status : 1;            // DWORD 0
         u32 ipc_overflow_error_status : 1;       // DWORD 0
         u32 ep_mmr_bus_access_timeout_status : 1; // DWORD 0
         u32 ep_firmware_force_ue_error_status : 1; // DWORD 0
         u32 ep_fixed_data_ram_write_out_of_range_status : 1; // DWORD 0
         u32 ep_inst_ram_write_out_of_range_status : 1; // DWORD 0
         u32 ep_stats_ram_parity_error_status : 1; // DWORD 0
         u32 ep_inst_ram_parity_error_status : 1; // DWORD 0
         u32 ep_shadow_ram_parity_error_status : 1; // DWORD 0
         u32 ep_fixed_data_ram_parity_error_status : 1; // DWORD 0
         u32 ep_y_bank_ram_parity_error_status : 1; // DWORD 0
         u32 ep_x_bank_ram_parity_error_status : 1; // DWORD 0
      } SG_PACK TPOST_UE_SOURCE_CR, *PTPOST_UE_SOURCE_CR;

      typedef union _TPOST_UE_SOURCE_CR_UNION {
         TPOST_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_SOURCE_CR_UNION, *PTPOST_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_CR_UNION, sizeof (TPOST_UE_SOURCE_CR_UNION) == 4);
   #endif


#else
   // TPOST Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_SOURCE_CR {
         union {
            struct { 
               u32 ep_x_bank_ram_parity_error_status : 1; // DWORD 0
               u32 ep_y_bank_ram_parity_error_status : 1; // DWORD 0
               u32 ep_fixed_data_ram_parity_error_status : 1; // DWORD 0
               u32 ep_shadow_ram_parity_error_status : 1; // DWORD 0
               u32 ep_inst_ram_parity_error_status : 1; // DWORD 0
               u32 ep_stats_ram_parity_error_status : 1; // DWORD 0
               u32 ep_inst_ram_write_out_of_range_status : 1; // DWORD 0
               u32 ep_fixed_data_ram_write_out_of_range_status : 1; // DWORD 0
               u32 ep_firmware_force_ue_error_status : 1; // DWORD 0
               u32 ep_mmr_bus_access_timeout_status : 1; // DWORD 0
               u32 ipc_overflow_error_status : 1; // DWORD 0
               u32 ipc_sof_error_status : 1;      // DWORD 0
               u32 ipc_eof_error_status : 1;      // DWORD 0
               u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_status : 1; // DWORD 0
               u32 jellm_deallocate_overrun_error_status : 1; // DWORD 0
               u32 tpost_detect_reserved_target_que_field_error_status : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 tpost_addr_xlat_ram_parity_error_status : 1; // DWORD 0
               u32 tpost_ctx_parity_error_status : 1; // DWORD 0
               u32 tpost_txpb_parity_error_status : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_SOURCE_CR, *PTPOST_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_CR, sizeof (TPOST_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_UE_SOURCE_CR {
         u32 ep_x_bank_ram_parity_error_status : 1; // DWORD 0
         u32 ep_y_bank_ram_parity_error_status : 1; // DWORD 0
         u32 ep_fixed_data_ram_parity_error_status : 1; // DWORD 0
         u32 ep_shadow_ram_parity_error_status : 1; // DWORD 0
         u32 ep_inst_ram_parity_error_status : 1; // DWORD 0
         u32 ep_stats_ram_parity_error_status : 1; // DWORD 0
         u32 ep_inst_ram_write_out_of_range_status : 1; // DWORD 0
         u32 ep_fixed_data_ram_write_out_of_range_status : 1; // DWORD 0
         u32 ep_firmware_force_ue_error_status : 1; // DWORD 0
         u32 ep_mmr_bus_access_timeout_status : 1; // DWORD 0
         u32 ipc_overflow_error_status : 1;       // DWORD 0
         u32 ipc_sof_error_status : 1;            // DWORD 0
         u32 ipc_eof_error_status : 1;            // DWORD 0
         u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_status : 1;  // DWORD 0
         u32 jellm_deallocate_overrun_error_status : 1; // DWORD 0
         u32 tpost_detect_reserved_target_que_field_error_status : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 tpost_addr_xlat_ram_parity_error_status : 1; // DWORD 0
         u32 tpost_ctx_parity_error_status : 1;   // DWORD 0
         u32 tpost_txpb_parity_error_status : 1;  // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TPOST_UE_SOURCE_CR, *PTPOST_UE_SOURCE_CR;

      typedef union _TPOST_UE_SOURCE_CR_UNION {
         TPOST_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_SOURCE_CR_UNION, *PTPOST_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_CR_UNION, sizeof (TPOST_UE_SOURCE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_ENABLE_CR {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 tpost_txpb_parity_error_enable : 1; // DWORD 0
               u32 tpost_ctx_parity_error_enable : 1; // DWORD 0
               u32 tpost_addr_xlat_ram_parity_error_enable : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 tpost_detect_reserved_target_que_field_error_enable : 1; // DWORD 0
               u32 jellm_deallocate_overrun_error_enable : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_enable : 1; // DWORD 0
               u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
               u32 ipc_eof_error_enable : 1;      // DWORD 0
               u32 ipc_sof_error_enable : 1;      // DWORD 0
               u32 ipc_overflow_error_enable : 1; // DWORD 0
               u32 ep_mmr_bus_access_timeout_enable : 1; // DWORD 0
               u32 ep_firmware_force_ue_error_enable : 1; // DWORD 0
               u32 ep_fixed_data_ram_write_out_of_range_enable : 1; // DWORD 0
               u32 ep_inst_ram_write_out_of_range_enable : 1; // DWORD 0
               u32 ep_stats_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_inst_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_shadow_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_fixed_data_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_y_bank_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_x_bank_ram_parity_error_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_ENABLE_CR, *PTPOST_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_CR, sizeof (TPOST_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_UE_ENABLE_CR {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 tpost_txpb_parity_error_enable : 1;  // DWORD 0
         u32 tpost_ctx_parity_error_enable : 1;   // DWORD 0
         u32 tpost_addr_xlat_ram_parity_error_enable : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 tpost_detect_reserved_target_que_field_error_enable : 1; // DWORD 0
         u32 jellm_deallocate_overrun_error_enable : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_enable : 1;  // DWORD 0
         u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
         u32 ipc_eof_error_enable : 1;            // DWORD 0
         u32 ipc_sof_error_enable : 1;            // DWORD 0
         u32 ipc_overflow_error_enable : 1;       // DWORD 0
         u32 ep_mmr_bus_access_timeout_enable : 1; // DWORD 0
         u32 ep_firmware_force_ue_error_enable : 1; // DWORD 0
         u32 ep_fixed_data_ram_write_out_of_range_enable : 1; // DWORD 0
         u32 ep_inst_ram_write_out_of_range_enable : 1; // DWORD 0
         u32 ep_stats_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_inst_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_shadow_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_fixed_data_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_y_bank_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_x_bank_ram_parity_error_enable : 1; // DWORD 0
      } SG_PACK TPOST_UE_ENABLE_CR, *PTPOST_UE_ENABLE_CR;

      typedef union _TPOST_UE_ENABLE_CR_UNION {
         TPOST_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_ENABLE_CR_UNION, *PTPOST_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_CR_UNION, sizeof (TPOST_UE_ENABLE_CR_UNION) == 4);
   #endif


#else
   // TPOST Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_ENABLE_CR {
         union {
            struct { 
               u32 ep_x_bank_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_y_bank_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_fixed_data_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_shadow_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_inst_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_stats_ram_parity_error_enable : 1; // DWORD 0
               u32 ep_inst_ram_write_out_of_range_enable : 1; // DWORD 0
               u32 ep_fixed_data_ram_write_out_of_range_enable : 1; // DWORD 0
               u32 ep_firmware_force_ue_error_enable : 1; // DWORD 0
               u32 ep_mmr_bus_access_timeout_enable : 1; // DWORD 0
               u32 ipc_overflow_error_enable : 1; // DWORD 0
               u32 ipc_sof_error_enable : 1;      // DWORD 0
               u32 ipc_eof_error_enable : 1;      // DWORD 0
               u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_enable : 1; // DWORD 0
               u32 jellm_deallocate_overrun_error_enable : 1; // DWORD 0
               u32 tpost_detect_reserved_target_que_field_error_enable : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 tpost_detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 tpost_addr_xlat_ram_parity_error_enable : 1; // DWORD 0
               u32 tpost_ctx_parity_error_enable : 1; // DWORD 0
               u32 tpost_txpb_parity_error_enable : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_ENABLE_CR, *PTPOST_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_CR, sizeof (TPOST_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_UE_ENABLE_CR {
         u32 ep_x_bank_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_y_bank_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_fixed_data_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_shadow_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_inst_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_stats_ram_parity_error_enable : 1; // DWORD 0
         u32 ep_inst_ram_write_out_of_range_enable : 1; // DWORD 0
         u32 ep_fixed_data_ram_write_out_of_range_enable : 1; // DWORD 0
         u32 ep_firmware_force_ue_error_enable : 1; // DWORD 0
         u32 ep_mmr_bus_access_timeout_enable : 1; // DWORD 0
         u32 ipc_overflow_error_enable : 1;       // DWORD 0
         u32 ipc_sof_error_enable : 1;            // DWORD 0
         u32 ipc_eof_error_enable : 1;            // DWORD 0
         u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_enable : 1;  // DWORD 0
         u32 jellm_deallocate_overrun_error_enable : 1; // DWORD 0
         u32 tpost_detect_reserved_target_que_field_error_enable : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 tpost_detect_ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 tpost_addr_xlat_ram_parity_error_enable : 1; // DWORD 0
         u32 tpost_ctx_parity_error_enable : 1;   // DWORD 0
         u32 tpost_txpb_parity_error_enable : 1;  // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TPOST_UE_ENABLE_CR, *PTPOST_UE_ENABLE_CR;

      typedef union _TPOST_UE_ENABLE_CR_UNION {
         TPOST_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_ENABLE_CR_UNION, *PTPOST_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_CR_UNION, sizeof (TPOST_UE_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector Input Queue Unrecoverable Error Status Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_UE_SOURCE_CR {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 tpost_in4_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p0_overrun_error_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR, *PTPOST_PROTSEL_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_SOURCE_CR, sizeof (TPOST_PROTSEL_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_UE_SOURCE_CR {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 tpost_in4_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p0_overrun_error_status : 1; // DWORD 0
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR, *PTPOST_PROTSEL_UE_SOURCE_CR;

      typedef union _TPOST_PROTSEL_UE_SOURCE_CR_UNION {
         TPOST_PROTSEL_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR_UNION, *PTPOST_PROTSEL_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_SOURCE_CR_UNION, sizeof (TPOST_PROTSEL_UE_SOURCE_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector Input Queue Unrecoverable Error Status Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_UE_SOURCE_CR {
         union {
            struct { 
               u32 tpost_in0_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in0_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in1_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in2_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in3_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p0_overrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p0_underrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p1_overrun_error_status : 1; // DWORD 0
               u32 tpost_in4_ps_p1_underrun_error_status : 1; // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR, *PTPOST_PROTSEL_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_SOURCE_CR, sizeof (TPOST_PROTSEL_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_UE_SOURCE_CR {
         u32 tpost_in0_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in0_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in1_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in2_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in3_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p0_overrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p0_underrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p1_overrun_error_status : 1; // DWORD 0
         u32 tpost_in4_ps_p1_underrun_error_status : 1; // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR, *PTPOST_PROTSEL_UE_SOURCE_CR;

      typedef union _TPOST_PROTSEL_UE_SOURCE_CR_UNION {
         TPOST_PROTSEL_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_UE_SOURCE_CR_UNION, *PTPOST_PROTSEL_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_SOURCE_CR_UNION, sizeof (TPOST_PROTSEL_UE_SOURCE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Protocol Selector Input Queue Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_UE_ENABLE_CR {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 tpost_in4_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p0_overrun_error_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR, *PTPOST_PROTSEL_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_ENABLE_CR, sizeof (TPOST_PROTSEL_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_UE_ENABLE_CR {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 tpost_in4_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p0_overrun_error_enable : 1; // DWORD 0
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR, *PTPOST_PROTSEL_UE_ENABLE_CR;

      typedef union _TPOST_PROTSEL_UE_ENABLE_CR_UNION {
         TPOST_PROTSEL_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR_UNION, *PTPOST_PROTSEL_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_ENABLE_CR_UNION, sizeof (TPOST_PROTSEL_UE_ENABLE_CR_UNION) == 4);
   #endif


#else
   // TPOST Protocol Selector Input Queue Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_PROTSEL_UE_ENABLE_CR {
         union {
            struct { 
               u32 tpost_in0_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in0_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in1_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in2_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in3_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p0_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p0_underrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p1_overrun_error_enable : 1; // DWORD 0
               u32 tpost_in4_ps_p1_underrun_error_enable : 1; // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR, *PTPOST_PROTSEL_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_ENABLE_CR, sizeof (TPOST_PROTSEL_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_PROTSEL_UE_ENABLE_CR {
         u32 tpost_in0_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in0_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in1_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in2_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in3_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p0_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p0_underrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p1_overrun_error_enable : 1; // DWORD 0
         u32 tpost_in4_ps_p1_underrun_error_enable : 1; // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR, *PTPOST_PROTSEL_UE_ENABLE_CR;

      typedef union _TPOST_PROTSEL_UE_ENABLE_CR_UNION {
         TPOST_PROTSEL_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_PROTSEL_UE_ENABLE_CR_UNION, *PTPOST_PROTSEL_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_PROTSEL_UE_ENABLE_CR_UNION, sizeof (TPOST_PROTSEL_UE_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Unrecoverable Error Source Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_SOURCE_1_CR {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 ep_prefetch_un_err_status : 1; // DWORD 0
               u32 ep_prefetch_ov_err_status : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 siq2_underflow_error_status : 1; // DWORD 0
               u32 siq2_overflow_error_status : 1; // DWORD 0
               u32 siq1_underflow_error_status : 1; // DWORD 0
               u32 siq1_overflow_error_status : 1; // DWORD 0
               u32 jellm_nopq_underflow_error_status : 1; // DWORD 0
               u32 jellm_nopq_overflow_error_status : 1; // DWORD 0
               u32 wdma_input_queue_underflow_error_status : 1; // DWORD 0
               u32 wdma_input_queue_overflow_error_status : 1; // DWORD 0
               u32 wdma_output_queue_underflow_error_status : 1; // DWORD 0
               u32 wdma_output_queue_overflow_error_status : 1; // DWORD 0
               u32 txp_input_queue_underflow_error_status : 1; // DWORD 0
               u32 txp_input_queue_overflow_error_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_SOURCE_1_CR, *PTPOST_UE_SOURCE_1_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_1_CR, sizeof (TPOST_UE_SOURCE_1_CR) == 4);

   #else
      typedef struct _TPOST_UE_SOURCE_1_CR {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 ep_prefetch_un_err_status : 1;       // DWORD 0
         u32 ep_prefetch_ov_err_status : 1;       // DWORD 0
         u32 ep_m2_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 siq2_underflow_error_status : 1;     // DWORD 0
         u32 siq2_overflow_error_status : 1;      // DWORD 0
         u32 siq1_underflow_error_status : 1;     // DWORD 0
         u32 siq1_overflow_error_status : 1;      // DWORD 0
         u32 jellm_nopq_underflow_error_status : 1; // DWORD 0
         u32 jellm_nopq_overflow_error_status : 1; // DWORD 0
         u32 wdma_input_queue_underflow_error_status : 1; // DWORD 0
         u32 wdma_input_queue_overflow_error_status : 1; // DWORD 0
         u32 wdma_output_queue_underflow_error_status : 1; // DWORD 0
         u32 wdma_output_queue_overflow_error_status : 1; // DWORD 0
         u32 txp_input_queue_underflow_error_status : 1; // DWORD 0
         u32 txp_input_queue_overflow_error_status : 1; // DWORD 0
      } SG_PACK TPOST_UE_SOURCE_1_CR, *PTPOST_UE_SOURCE_1_CR;

      typedef union _TPOST_UE_SOURCE_1_CR_UNION {
         TPOST_UE_SOURCE_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_SOURCE_1_CR_UNION, *PTPOST_UE_SOURCE_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_1_CR_UNION, sizeof (TPOST_UE_SOURCE_1_CR_UNION) == 4);
   #endif


#else
   // TPOST Unrecoverable Error Source Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_SOURCE_1_CR {
         union {
            struct { 
               u32 txp_input_queue_overflow_error_status : 1; // DWORD 0
               u32 txp_input_queue_underflow_error_status : 1; // DWORD 0
               u32 wdma_output_queue_overflow_error_status : 1; // DWORD 0
               u32 wdma_output_queue_underflow_error_status : 1; // DWORD 0
               u32 wdma_input_queue_overflow_error_status : 1; // DWORD 0
               u32 wdma_input_queue_underflow_error_status : 1; // DWORD 0
               u32 jellm_nopq_overflow_error_status : 1; // DWORD 0
               u32 jellm_nopq_underflow_error_status : 1; // DWORD 0
               u32 siq1_overflow_error_status : 1; // DWORD 0
               u32 siq1_underflow_error_status : 1; // DWORD 0
               u32 siq2_overflow_error_status : 1; // DWORD 0
               u32 siq2_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_prefetch_ov_err_status : 1; // DWORD 0
               u32 ep_prefetch_un_err_status : 1; // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_SOURCE_1_CR, *PTPOST_UE_SOURCE_1_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_1_CR, sizeof (TPOST_UE_SOURCE_1_CR) == 4);

   #else
      typedef struct _TPOST_UE_SOURCE_1_CR {
         u32 txp_input_queue_overflow_error_status : 1; // DWORD 0
         u32 txp_input_queue_underflow_error_status : 1; // DWORD 0
         u32 wdma_output_queue_overflow_error_status : 1; // DWORD 0
         u32 wdma_output_queue_underflow_error_status : 1; // DWORD 0
         u32 wdma_input_queue_overflow_error_status : 1; // DWORD 0
         u32 wdma_input_queue_underflow_error_status : 1; // DWORD 0
         u32 jellm_nopq_overflow_error_status : 1; // DWORD 0
         u32 jellm_nopq_underflow_error_status : 1; // DWORD 0
         u32 siq1_overflow_error_status : 1;      // DWORD 0
         u32 siq1_underflow_error_status : 1;     // DWORD 0
         u32 siq2_overflow_error_status : 1;      // DWORD 0
         u32 siq2_underflow_error_status : 1;     // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_prefetch_ov_err_status : 1;       // DWORD 0
         u32 ep_prefetch_un_err_status : 1;       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK TPOST_UE_SOURCE_1_CR, *PTPOST_UE_SOURCE_1_CR;

      typedef union _TPOST_UE_SOURCE_1_CR_UNION {
         TPOST_UE_SOURCE_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_SOURCE_1_CR_UNION, *PTPOST_UE_SOURCE_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_SOURCE_1_CR_UNION, sizeof (TPOST_UE_SOURCE_1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Unrecoverable Error Enable Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_ENABLE_1_CR {
         union {
            struct { 
               u32 rsvd0 : 6;                     // DWORD 0
               u32 ep_prefetch_un_err_enable : 1; // DWORD 0
               u32 ep_prefetch_ov_err_enable : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 siq2_underflow_error_enable : 1; // DWORD 0
               u32 siq2_overflow_error_enable : 1; // DWORD 0
               u32 siq1_underflow_error_enable : 1; // DWORD 0
               u32 siq1_overflow_error_enable : 1; // DWORD 0
               u32 jellm_nopq_underflow_error_enable : 1; // DWORD 0
               u32 jellm_nopq_overflow_error_enable : 1; // DWORD 0
               u32 wdma_input_queue_underflow_error_enable : 1; // DWORD 0
               u32 wdma_input_queue_overflow_error_enable : 1; // DWORD 0
               u32 wdma_output_queue_underflow_error_enable : 1; // DWORD 0
               u32 wdma_output_queue_overflow_error_enable : 1; // DWORD 0
               u32 txp_input_queue_underflow_error_enable : 1; // DWORD 0
               u32 txp_input_queue_overflow_error_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_ENABLE_1_CR, *PTPOST_UE_ENABLE_1_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_1_CR, sizeof (TPOST_UE_ENABLE_1_CR) == 4);

   #else
      typedef struct _TPOST_UE_ENABLE_1_CR {
         u32 rsvd0 : 6;                           // DWORD 0
         u32 ep_prefetch_un_err_enable : 1;       // DWORD 0
         u32 ep_prefetch_ov_err_enable : 1;       // DWORD 0
         u32 ep_m2_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 siq2_underflow_error_enable : 1;     // DWORD 0
         u32 siq2_overflow_error_enable : 1;      // DWORD 0
         u32 siq1_underflow_error_enable : 1;     // DWORD 0
         u32 siq1_overflow_error_enable : 1;      // DWORD 0
         u32 jellm_nopq_underflow_error_enable : 1; // DWORD 0
         u32 jellm_nopq_overflow_error_enable : 1; // DWORD 0
         u32 wdma_input_queue_underflow_error_enable : 1; // DWORD 0
         u32 wdma_input_queue_overflow_error_enable : 1; // DWORD 0
         u32 wdma_output_queue_underflow_error_enable : 1; // DWORD 0
         u32 wdma_output_queue_overflow_error_enable : 1; // DWORD 0
         u32 txp_input_queue_underflow_error_enable : 1; // DWORD 0
         u32 txp_input_queue_overflow_error_enable : 1; // DWORD 0
      } SG_PACK TPOST_UE_ENABLE_1_CR, *PTPOST_UE_ENABLE_1_CR;

      typedef union _TPOST_UE_ENABLE_1_CR_UNION {
         TPOST_UE_ENABLE_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_ENABLE_1_CR_UNION, *PTPOST_UE_ENABLE_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_1_CR_UNION, sizeof (TPOST_UE_ENABLE_1_CR_UNION) == 4);
   #endif


#else
   // TPOST Unrecoverable Error Enable Register 1
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_UE_ENABLE_1_CR {
         union {
            struct { 
               u32 txp_input_queue_overflow_error_enable : 1; // DWORD 0
               u32 txp_input_queue_underflow_error_enable : 1; // DWORD 0
               u32 wdma_output_queue_overflow_error_enable : 1; // DWORD 0
               u32 wdma_output_queue_underflow_error_enable : 1; // DWORD 0
               u32 wdma_input_queue_overflow_error_enable : 1; // DWORD 0
               u32 wdma_input_queue_underflow_error_enable : 1; // DWORD 0
               u32 jellm_nopq_overflow_error_enable : 1; // DWORD 0
               u32 jellm_nopq_underflow_error_enable : 1; // DWORD 0
               u32 siq1_overflow_error_enable : 1; // DWORD 0
               u32 siq1_underflow_error_enable : 1; // DWORD 0
               u32 siq2_overflow_error_enable : 1; // DWORD 0
               u32 siq2_underflow_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
               u32 ep_prefetch_ov_err_enable : 1; // DWORD 0
               u32 ep_prefetch_un_err_enable : 1; // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_UE_ENABLE_1_CR, *PTPOST_UE_ENABLE_1_CR;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_1_CR, sizeof (TPOST_UE_ENABLE_1_CR) == 4);

   #else
      typedef struct _TPOST_UE_ENABLE_1_CR {
         u32 txp_input_queue_overflow_error_enable : 1; // DWORD 0
         u32 txp_input_queue_underflow_error_enable : 1; // DWORD 0
         u32 wdma_output_queue_overflow_error_enable : 1; // DWORD 0
         u32 wdma_output_queue_underflow_error_enable : 1; // DWORD 0
         u32 wdma_input_queue_overflow_error_enable : 1; // DWORD 0
         u32 wdma_input_queue_underflow_error_enable : 1; // DWORD 0
         u32 jellm_nopq_overflow_error_enable : 1; // DWORD 0
         u32 jellm_nopq_underflow_error_enable : 1; // DWORD 0
         u32 siq1_overflow_error_enable : 1;      // DWORD 0
         u32 siq1_underflow_error_enable : 1;     // DWORD 0
         u32 siq2_overflow_error_enable : 1;      // DWORD 0
         u32 siq2_underflow_error_enable : 1;     // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m2_wbp_chk_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_overflow_error_enable : 1; // DWORD 0
         u32 ep_m2_mem_write_back_que_underflow_error_enable : 1; // DWORD 0
         u32 ep_prefetch_ov_err_enable : 1;       // DWORD 0
         u32 ep_prefetch_un_err_enable : 1;       // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
      } SG_PACK TPOST_UE_ENABLE_1_CR, *PTPOST_UE_ENABLE_1_CR;

      typedef union _TPOST_UE_ENABLE_1_CR_UNION {
         TPOST_UE_ENABLE_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_UE_ENABLE_1_CR_UNION, *PTPOST_UE_ENABLE_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_UE_ENABLE_1_CR_UNION, sizeof (TPOST_UE_ENABLE_1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Low Latency Transmit Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 length_exceeded_port1_error_status : 1; // DWORD 0
               u32 odd_num_wr_port1_error_status : 1; // DWORD 0
               u32 ram_underflow_port1_error_status : 1; // DWORD 0
               u32 ram_overflow_port1_error_status : 1; // DWORD 0
               u32 ram_parity_port1_error_status : 1; // DWORD 0
               u32 reg_buf_underflow_port1_error_status : 1; // DWORD 0
               u32 reg_buf_overflow_port1_error_status : 1; // DWORD 0
               u32 length_exceeded_port0_error_status : 1; // DWORD 0
               u32 odd_num_wr_port0_error_status : 1; // DWORD 0
               u32 ram_underflow_port0_error_status : 1; // DWORD 0
               u32 ram_overflow_port0_error_status : 1; // DWORD 0
               u32 ram_parity_port0_error_status : 1; // DWORD 0
               u32 reg_buf_underflow_port0_error_status : 1; // DWORD 0
               u32 reg_buf_overflow_port0_error_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, sizeof (TPOST_LOW_LATENCY_TX_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 length_exceeded_port1_error_status : 1; // DWORD 0
         u32 odd_num_wr_port1_error_status : 1;   // DWORD 0
         u32 ram_underflow_port1_error_status : 1; // DWORD 0
         u32 ram_overflow_port1_error_status : 1; // DWORD 0
         u32 ram_parity_port1_error_status : 1;   // DWORD 0
         u32 reg_buf_underflow_port1_error_status : 1; // DWORD 0
         u32 reg_buf_overflow_port1_error_status : 1; // DWORD 0
         u32 length_exceeded_port0_error_status : 1; // DWORD 0
         u32 odd_num_wr_port0_error_status : 1;   // DWORD 0
         u32 ram_underflow_port0_error_status : 1; // DWORD 0
         u32 ram_overflow_port0_error_status : 1; // DWORD 0
         u32 ram_parity_port0_error_status : 1;   // DWORD 0
         u32 reg_buf_underflow_port0_error_status : 1; // DWORD 0
         u32 reg_buf_overflow_port0_error_status : 1; // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR;

      typedef union _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION {
         TPOST_LOW_LATENCY_TX_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION, sizeof (TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION) == 4);
   #endif


#else
   // TPOST Low Latency Transmit Unrecoverable Error Source Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR {
         union {
            struct { 
               u32 reg_buf_overflow_port0_error_status : 1; // DWORD 0
               u32 reg_buf_underflow_port0_error_status : 1; // DWORD 0
               u32 ram_parity_port0_error_status : 1; // DWORD 0
               u32 ram_overflow_port0_error_status : 1; // DWORD 0
               u32 ram_underflow_port0_error_status : 1; // DWORD 0
               u32 odd_num_wr_port0_error_status : 1; // DWORD 0
               u32 length_exceeded_port0_error_status : 1; // DWORD 0
               u32 reg_buf_overflow_port1_error_status : 1; // DWORD 0
               u32 reg_buf_underflow_port1_error_status : 1; // DWORD 0
               u32 ram_parity_port1_error_status : 1; // DWORD 0
               u32 ram_overflow_port1_error_status : 1; // DWORD 0
               u32 ram_underflow_port1_error_status : 1; // DWORD 0
               u32 odd_num_wr_port1_error_status : 1; // DWORD 0
               u32 length_exceeded_port1_error_status : 1; // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, sizeof (TPOST_LOW_LATENCY_TX_UE_SOURCE_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR {
         u32 reg_buf_overflow_port0_error_status : 1; // DWORD 0
         u32 reg_buf_underflow_port0_error_status : 1; // DWORD 0
         u32 ram_parity_port0_error_status : 1;   // DWORD 0
         u32 ram_overflow_port0_error_status : 1; // DWORD 0
         u32 ram_underflow_port0_error_status : 1; // DWORD 0
         u32 odd_num_wr_port0_error_status : 1;   // DWORD 0
         u32 length_exceeded_port0_error_status : 1; // DWORD 0
         u32 reg_buf_overflow_port1_error_status : 1; // DWORD 0
         u32 reg_buf_underflow_port1_error_status : 1; // DWORD 0
         u32 ram_parity_port1_error_status : 1;   // DWORD 0
         u32 ram_overflow_port1_error_status : 1; // DWORD 0
         u32 ram_underflow_port1_error_status : 1; // DWORD 0
         u32 odd_num_wr_port1_error_status : 1;   // DWORD 0
         u32 length_exceeded_port1_error_status : 1; // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR;

      typedef union _TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION {
         TPOST_LOW_LATENCY_TX_UE_SOURCE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION, *PTPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION, sizeof (TPOST_LOW_LATENCY_TX_UE_SOURCE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST Low Latency Transmit Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 length_exceeded_port1_error_enable : 1; // DWORD 0
               u32 odd_num_wr_port1_error_enable : 1; // DWORD 0
               u32 ram_underflow_port1_error_enable : 1; // DWORD 0
               u32 ram_overflow_port1_error_enable : 1; // DWORD 0
               u32 ram_parity_port1_error_enable : 1; // DWORD 0
               u32 reg_buf_underflow_port1_error_enable : 1; // DWORD 0
               u32 reg_buf_overflow_port1_error_enable : 1; // DWORD 0
               u32 length_exceeded_port0_error_enable : 1; // DWORD 0
               u32 odd_num_wr_port0_error_enable : 1; // DWORD 0
               u32 ram_underflow_port0_error_enable : 1; // DWORD 0
               u32 ram_overflow_port0_error_enable : 1; // DWORD 0
               u32 ram_parity_port0_error_enable : 1; // DWORD 0
               u32 reg_buf_underflow_port0_error_enable : 1; // DWORD 0
               u32 reg_buf_overflow_port0_error_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, sizeof (TPOST_LOW_LATENCY_TX_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 length_exceeded_port1_error_enable : 1; // DWORD 0
         u32 odd_num_wr_port1_error_enable : 1;   // DWORD 0
         u32 ram_underflow_port1_error_enable : 1; // DWORD 0
         u32 ram_overflow_port1_error_enable : 1; // DWORD 0
         u32 ram_parity_port1_error_enable : 1;   // DWORD 0
         u32 reg_buf_underflow_port1_error_enable : 1; // DWORD 0
         u32 reg_buf_overflow_port1_error_enable : 1; // DWORD 0
         u32 length_exceeded_port0_error_enable : 1; // DWORD 0
         u32 odd_num_wr_port0_error_enable : 1;   // DWORD 0
         u32 ram_underflow_port0_error_enable : 1; // DWORD 0
         u32 ram_overflow_port0_error_enable : 1; // DWORD 0
         u32 ram_parity_port0_error_enable : 1;   // DWORD 0
         u32 reg_buf_underflow_port0_error_enable : 1; // DWORD 0
         u32 reg_buf_overflow_port0_error_enable : 1; // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR;

      typedef union _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION {
         TPOST_LOW_LATENCY_TX_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION, sizeof (TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION) == 4);
   #endif


#else
   // TPOST Low Latency Transmit Unrecoverable Error Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR {
         union {
            struct { 
               u32 reg_buf_overflow_port0_error_enable : 1; // DWORD 0
               u32 reg_buf_underflow_port0_error_enable : 1; // DWORD 0
               u32 ram_parity_port0_error_enable : 1; // DWORD 0
               u32 ram_overflow_port0_error_enable : 1; // DWORD 0
               u32 ram_underflow_port0_error_enable : 1; // DWORD 0
               u32 odd_num_wr_port0_error_enable : 1; // DWORD 0
               u32 length_exceeded_port0_error_enable : 1; // DWORD 0
               u32 reg_buf_overflow_port1_error_enable : 1; // DWORD 0
               u32 reg_buf_underflow_port1_error_enable : 1; // DWORD 0
               u32 ram_parity_port1_error_enable : 1; // DWORD 0
               u32 ram_overflow_port1_error_enable : 1; // DWORD 0
               u32 ram_underflow_port1_error_enable : 1; // DWORD 0
               u32 odd_num_wr_port1_error_enable : 1; // DWORD 0
               u32 length_exceeded_port1_error_enable : 1; // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, sizeof (TPOST_LOW_LATENCY_TX_UE_ENABLE_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR {
         u32 reg_buf_overflow_port0_error_enable : 1; // DWORD 0
         u32 reg_buf_underflow_port0_error_enable : 1; // DWORD 0
         u32 ram_parity_port0_error_enable : 1;   // DWORD 0
         u32 ram_overflow_port0_error_enable : 1; // DWORD 0
         u32 ram_underflow_port0_error_enable : 1; // DWORD 0
         u32 odd_num_wr_port0_error_enable : 1;   // DWORD 0
         u32 length_exceeded_port0_error_enable : 1; // DWORD 0
         u32 reg_buf_overflow_port1_error_enable : 1; // DWORD 0
         u32 reg_buf_underflow_port1_error_enable : 1; // DWORD 0
         u32 ram_parity_port1_error_enable : 1;   // DWORD 0
         u32 ram_overflow_port1_error_enable : 1; // DWORD 0
         u32 ram_underflow_port1_error_enable : 1; // DWORD 0
         u32 odd_num_wr_port1_error_enable : 1;   // DWORD 0
         u32 length_exceeded_port1_error_enable : 1; // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR;

      typedef union _TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION {
         TPOST_LOW_LATENCY_TX_UE_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION, *PTPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION, sizeof (TPOST_LOW_LATENCY_TX_UE_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is used to set the maximum limit that will be allowed to be used in
   // the(Number of Writes) field of the TPOST_LL_DATA_PORT0_CR_RANGE and
   // TPOST_LL_DATA_PORT1_CR_RANGE when a Low Latency Transfer is started.If a (Number of
   // Writes) value that is larger than this value is detected, a UE will begenerated
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR {
         union {
            struct { 
               u32 rsvd1 : 6;                     // DWORD 0
               u32 port1_ll_len_limit : 10;       // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 port0_ll_len_limit : 10;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, sizeof (TPOST_LOW_LATENCY_LENGTH_LIMIT_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR {
         u32 rsvd1 : 6;                           // DWORD 0
         u32 port1_ll_len_limit : 10;             // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 port0_ll_len_limit : 10;             // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR;

      typedef union _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION {
         TPOST_LOW_LATENCY_LENGTH_LIMIT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION, sizeof (TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION) == 4);
   #endif


#else
   // This register is used to set the maximum limit that will be allowed to be used in
   // the(Number of Writes) field of the TPOST_LL_DATA_PORT0_CR_RANGE and
   // TPOST_LL_DATA_PORT1_CR_RANGE when a Low Latency Transfer is started.If a (Number of
   // Writes) value that is larger than this value is detected, a UE will begenerated
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR {
         union {
            struct { 
               u32 port0_ll_len_limit : 10;       // DWORD 0
               u32 rsvd0 : 6;                     // DWORD 0
               u32 port1_ll_len_limit : 10;       // DWORD 0
               u32 rsvd1 : 6;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, sizeof (TPOST_LOW_LATENCY_LENGTH_LIMIT_CR) == 4);

   #else
      typedef struct _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR {
         u32 port0_ll_len_limit : 10;             // DWORD 0
         u32 rsvd0 : 6;                           // DWORD 0
         u32 port1_ll_len_limit : 10;             // DWORD 0
         u32 rsvd1 : 6;                           // DWORD 0
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR;

      typedef union _TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION {
         TPOST_LOW_LATENCY_LENGTH_LIMIT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION, *PTPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION, sizeof (TPOST_LOW_LATENCY_LENGTH_LIMIT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 0 Low Latency Transmit Data Register RangeThis register range is used by the
   // driver to write the appropriate data structure set in the formof a TXD, followed by
   // WRB sets, in order to generate a transmit packet. The 1st write to thisregister, to
   // generate a transmit packet, will have: 1.) Number of writes to this register that
   // will be generated to define the entire data structure set (including this 1st
   // write). This value needs to be written to bits [9:0] and should be an even value.
   // 2.) EP input queue select. This value needs to be written to bit 16. (0 = normal
   // queue, 1 = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This
   // value needs to be written to bits [25:24].NOTE: the driver is responsible for not
   // overflowing the h/w buffer which is 1024d deep
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LL_DATA_PORT0_CR_RANGE {
         union {
            struct { 
               u32 low_lat_dat_reg_p0;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE, *PTPOST_LL_DATA_PORT0_CR_RANGE;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT0_CR_RANGE, sizeof (TPOST_LL_DATA_PORT0_CR_RANGE) == 4);

   #else
      typedef struct _TPOST_LL_DATA_PORT0_CR_RANGE {
         u32 low_lat_dat_reg_p0;                  // DWORD 0
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE, *PTPOST_LL_DATA_PORT0_CR_RANGE;

      typedef union _TPOST_LL_DATA_PORT0_CR_RANGE_UNION {
         TPOST_LL_DATA_PORT0_CR_RANGE bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE_UNION, *PTPOST_LL_DATA_PORT0_CR_RANGE_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT0_CR_RANGE_UNION, sizeof (TPOST_LL_DATA_PORT0_CR_RANGE_UNION) == 4);
   #endif


#else
   // Port 0 Low Latency Transmit Data Register RangeThis register range is used by the
   // driver to write the appropriate data structure set in the formof a TXD, followed by
   // WRB sets, in order to generate a transmit packet. The 1st write to thisregister, to
   // generate a transmit packet, will have: 1.) Number of writes to this register that
   // will be generated to define the entire data structure set (including this 1st
   // write). This value needs to be written to bits [9:0] and should be an even value.
   // 2.) EP input queue select. This value needs to be written to bit 16. (0 = normal
   // queue, 1 = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This
   // value needs to be written to bits [25:24].NOTE: the driver is responsible for not
   // overflowing the h/w buffer which is 1024d deep
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LL_DATA_PORT0_CR_RANGE {
         union {
            struct { 
               u32 low_lat_dat_reg_p0;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE, *PTPOST_LL_DATA_PORT0_CR_RANGE;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT0_CR_RANGE, sizeof (TPOST_LL_DATA_PORT0_CR_RANGE) == 4);

   #else
      typedef struct _TPOST_LL_DATA_PORT0_CR_RANGE {
         u32 low_lat_dat_reg_p0;                  // DWORD 0
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE, *PTPOST_LL_DATA_PORT0_CR_RANGE;

      typedef union _TPOST_LL_DATA_PORT0_CR_RANGE_UNION {
         TPOST_LL_DATA_PORT0_CR_RANGE bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LL_DATA_PORT0_CR_RANGE_UNION, *PTPOST_LL_DATA_PORT0_CR_RANGE_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT0_CR_RANGE_UNION, sizeof (TPOST_LL_DATA_PORT0_CR_RANGE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port 1 Low Latency Transmit Data Register RangeThis register range is used by the
   // driver to write the appropriate data structure set in the formof a TXD, followed by
   // WRB sets, in order to generate a transmit packet. The 1st write to thisregister, to
   // generate a transmit packet, will have: 1.) Number of writes to this register that
   // will be generated to define the entire data structure set (including this 1st
   // write). This value needs to be written to bits [9:0] and should be an even value.
   // 2.) EP input queue select. This value needs to be written to bit 16. (0 = normal
   // queue, 1 = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This
   // value needs to be written to bits [25:24].NOTE: the driver is responsible for not
   // overflowing the h/w buffer which is 1024d deep
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LL_DATA_PORT1_CR_RANGE {
         union {
            struct { 
               u32 low_lat_dat_reg_p1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE, *PTPOST_LL_DATA_PORT1_CR_RANGE;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT1_CR_RANGE, sizeof (TPOST_LL_DATA_PORT1_CR_RANGE) == 4);

   #else
      typedef struct _TPOST_LL_DATA_PORT1_CR_RANGE {
         u32 low_lat_dat_reg_p1;                  // DWORD 0
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE, *PTPOST_LL_DATA_PORT1_CR_RANGE;

      typedef union _TPOST_LL_DATA_PORT1_CR_RANGE_UNION {
         TPOST_LL_DATA_PORT1_CR_RANGE bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE_UNION, *PTPOST_LL_DATA_PORT1_CR_RANGE_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT1_CR_RANGE_UNION, sizeof (TPOST_LL_DATA_PORT1_CR_RANGE_UNION) == 4);
   #endif


#else
   // Port 1 Low Latency Transmit Data Register RangeThis register range is used by the
   // driver to write the appropriate data structure set in the formof a TXD, followed by
   // WRB sets, in order to generate a transmit packet. The 1st write to thisregister, to
   // generate a transmit packet, will have: 1.) Number of writes to this register that
   // will be generated to define the entire data structure set (including this 1st
   // write). This value needs to be written to bits [9:0] and should be an even value.
   // 2.) EP input queue select. This value needs to be written to bit 16. (0 = normal
   // queue, 1 = fast queue 3.) Target chute, for BE2, legal values are 1 and 2. This
   // value needs to be written to bits [25:24].NOTE: the driver is responsible for not
   // overflowing the h/w buffer which is 1024d deep
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_LL_DATA_PORT1_CR_RANGE {
         union {
            struct { 
               u32 low_lat_dat_reg_p1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE, *PTPOST_LL_DATA_PORT1_CR_RANGE;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT1_CR_RANGE, sizeof (TPOST_LL_DATA_PORT1_CR_RANGE) == 4);

   #else
      typedef struct _TPOST_LL_DATA_PORT1_CR_RANGE {
         u32 low_lat_dat_reg_p1;                  // DWORD 0
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE, *PTPOST_LL_DATA_PORT1_CR_RANGE;

      typedef union _TPOST_LL_DATA_PORT1_CR_RANGE_UNION {
         TPOST_LL_DATA_PORT1_CR_RANGE bits;
         u32 dw; // dword union
      } SG_PACK TPOST_LL_DATA_PORT1_CR_RANGE_UNION, *PTPOST_LL_DATA_PORT1_CR_RANGE_UNION;

      SG_C_ASSERT(__sizeof__TPOST_LL_DATA_PORT1_CR_RANGE_UNION, sizeof (TPOST_LL_DATA_PORT1_CR_RANGE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT0_SR {
         union {
            struct { 
               u32 tpost_debug0;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT0_SR, *PTPOST_DEBUG_STAT0_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT0_SR, sizeof (TPOST_DEBUG_STAT0_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT0_SR {
         u32 tpost_debug0;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT0_SR, *PTPOST_DEBUG_STAT0_SR;

      typedef union _TPOST_DEBUG_STAT0_SR_UNION {
         TPOST_DEBUG_STAT0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT0_SR_UNION, *PTPOST_DEBUG_STAT0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT0_SR_UNION, sizeof (TPOST_DEBUG_STAT0_SR_UNION) == 4);
   #endif


#else
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT0_SR {
         union {
            struct { 
               u32 tpost_debug0;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT0_SR, *PTPOST_DEBUG_STAT0_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT0_SR, sizeof (TPOST_DEBUG_STAT0_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT0_SR {
         u32 tpost_debug0;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT0_SR, *PTPOST_DEBUG_STAT0_SR;

      typedef union _TPOST_DEBUG_STAT0_SR_UNION {
         TPOST_DEBUG_STAT0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT0_SR_UNION, *PTPOST_DEBUG_STAT0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT0_SR_UNION, sizeof (TPOST_DEBUG_STAT0_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT1_SR {
         union {
            struct { 
               u32 tpost_debug1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT1_SR, *PTPOST_DEBUG_STAT1_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT1_SR, sizeof (TPOST_DEBUG_STAT1_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT1_SR {
         u32 tpost_debug1;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT1_SR, *PTPOST_DEBUG_STAT1_SR;

      typedef union _TPOST_DEBUG_STAT1_SR_UNION {
         TPOST_DEBUG_STAT1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT1_SR_UNION, *PTPOST_DEBUG_STAT1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT1_SR_UNION, sizeof (TPOST_DEBUG_STAT1_SR_UNION) == 4);
   #endif


#else
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT1_SR {
         union {
            struct { 
               u32 tpost_debug1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT1_SR, *PTPOST_DEBUG_STAT1_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT1_SR, sizeof (TPOST_DEBUG_STAT1_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT1_SR {
         u32 tpost_debug1;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT1_SR, *PTPOST_DEBUG_STAT1_SR;

      typedef union _TPOST_DEBUG_STAT1_SR_UNION {
         TPOST_DEBUG_STAT1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT1_SR_UNION, *PTPOST_DEBUG_STAT1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT1_SR_UNION, sizeof (TPOST_DEBUG_STAT1_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT2_SR {
         union {
            struct { 
               u32 tpost_debug2;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT2_SR, *PTPOST_DEBUG_STAT2_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT2_SR, sizeof (TPOST_DEBUG_STAT2_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT2_SR {
         u32 tpost_debug2;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT2_SR, *PTPOST_DEBUG_STAT2_SR;

      typedef union _TPOST_DEBUG_STAT2_SR_UNION {
         TPOST_DEBUG_STAT2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT2_SR_UNION, *PTPOST_DEBUG_STAT2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT2_SR_UNION, sizeof (TPOST_DEBUG_STAT2_SR_UNION) == 4);
   #endif


#else
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT2_SR {
         union {
            struct { 
               u32 tpost_debug2;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT2_SR, *PTPOST_DEBUG_STAT2_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT2_SR, sizeof (TPOST_DEBUG_STAT2_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT2_SR {
         u32 tpost_debug2;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT2_SR, *PTPOST_DEBUG_STAT2_SR;

      typedef union _TPOST_DEBUG_STAT2_SR_UNION {
         TPOST_DEBUG_STAT2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT2_SR_UNION, *PTPOST_DEBUG_STAT2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT2_SR_UNION, sizeof (TPOST_DEBUG_STAT2_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT3_SR {
         union {
            struct { 
               u32 tpost_debug3;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT3_SR, *PTPOST_DEBUG_STAT3_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT3_SR, sizeof (TPOST_DEBUG_STAT3_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT3_SR {
         u32 tpost_debug3;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT3_SR, *PTPOST_DEBUG_STAT3_SR;

      typedef union _TPOST_DEBUG_STAT3_SR_UNION {
         TPOST_DEBUG_STAT3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT3_SR_UNION, *PTPOST_DEBUG_STAT3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT3_SR_UNION, sizeof (TPOST_DEBUG_STAT3_SR_UNION) == 4);
   #endif


#else
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT3_SR {
         union {
            struct { 
               u32 tpost_debug3;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT3_SR, *PTPOST_DEBUG_STAT3_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT3_SR, sizeof (TPOST_DEBUG_STAT3_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT3_SR {
         u32 tpost_debug3;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT3_SR, *PTPOST_DEBUG_STAT3_SR;

      typedef union _TPOST_DEBUG_STAT3_SR_UNION {
         TPOST_DEBUG_STAT3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT3_SR_UNION, *PTPOST_DEBUG_STAT3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT3_SR_UNION, sizeof (TPOST_DEBUG_STAT3_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT4_SR {
         union {
            struct { 
               u32 tpost_debug4;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT4_SR, *PTPOST_DEBUG_STAT4_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT4_SR, sizeof (TPOST_DEBUG_STAT4_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT4_SR {
         u32 tpost_debug4;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT4_SR, *PTPOST_DEBUG_STAT4_SR;

      typedef union _TPOST_DEBUG_STAT4_SR_UNION {
         TPOST_DEBUG_STAT4_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT4_SR_UNION, *PTPOST_DEBUG_STAT4_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT4_SR_UNION, sizeof (TPOST_DEBUG_STAT4_SR_UNION) == 4);
   #endif


#else
   // This register provides debug status for internal TPOST state as defined below.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DEBUG_STAT4_SR {
         union {
            struct { 
               u32 tpost_debug4;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DEBUG_STAT4_SR, *PTPOST_DEBUG_STAT4_SR;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT4_SR, sizeof (TPOST_DEBUG_STAT4_SR) == 4);

   #else
      typedef struct _TPOST_DEBUG_STAT4_SR {
         u32 tpost_debug4;                        // DWORD 0
      } SG_PACK TPOST_DEBUG_STAT4_SR, *PTPOST_DEBUG_STAT4_SR;

      typedef union _TPOST_DEBUG_STAT4_SR_UNION {
         TPOST_DEBUG_STAT4_SR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DEBUG_STAT4_SR_UNION, *PTPOST_DEBUG_STAT4_SR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DEBUG_STAT4_SR_UNION, sizeof (TPOST_DEBUG_STAT4_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST EP Classification Debug Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_CLASS_DEBUG_EN_CR {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 tpost_ep_class_dbg_en : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR, *PTPOST_EP_CLASS_DEBUG_EN_CR;

      SG_C_ASSERT(__sizeof__TPOST_EP_CLASS_DEBUG_EN_CR, sizeof (TPOST_EP_CLASS_DEBUG_EN_CR) == 4);

   #else
      typedef struct _TPOST_EP_CLASS_DEBUG_EN_CR {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 tpost_ep_class_dbg_en : 1;           // DWORD 0
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR, *PTPOST_EP_CLASS_DEBUG_EN_CR;

      typedef union _TPOST_EP_CLASS_DEBUG_EN_CR_UNION {
         TPOST_EP_CLASS_DEBUG_EN_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR_UNION, *PTPOST_EP_CLASS_DEBUG_EN_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_CLASS_DEBUG_EN_CR_UNION, sizeof (TPOST_EP_CLASS_DEBUG_EN_CR_UNION) == 4);
   #endif


#else
   // TPOST EP Classification Debug Enable Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_CLASS_DEBUG_EN_CR {
         union {
            struct { 
               u32 tpost_ep_class_dbg_en : 1;     // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR, *PTPOST_EP_CLASS_DEBUG_EN_CR;

      SG_C_ASSERT(__sizeof__TPOST_EP_CLASS_DEBUG_EN_CR, sizeof (TPOST_EP_CLASS_DEBUG_EN_CR) == 4);

   #else
      typedef struct _TPOST_EP_CLASS_DEBUG_EN_CR {
         u32 tpost_ep_class_dbg_en : 1;           // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR, *PTPOST_EP_CLASS_DEBUG_EN_CR;

      typedef union _TPOST_EP_CLASS_DEBUG_EN_CR_UNION {
         TPOST_EP_CLASS_DEBUG_EN_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_CLASS_DEBUG_EN_CR_UNION, *PTPOST_EP_CLASS_DEBUG_EN_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_CLASS_DEBUG_EN_CR_UNION, sizeof (TPOST_EP_CLASS_DEBUG_EN_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPOST EP Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 tpost_ep_hw_dbg_sel : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR, *PTPOST_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__TPOST_EP_HW_DEBUG_SELECT_CR, sizeof (TPOST_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _TPOST_EP_HW_DEBUG_SELECT_CR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 tpost_ep_hw_dbg_sel : 4;             // DWORD 0
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR, *PTPOST_EP_HW_DEBUG_SELECT_CR;

      typedef union _TPOST_EP_HW_DEBUG_SELECT_CR_UNION {
         TPOST_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR_UNION, *PTPOST_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (TPOST_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#else
   // TPOST EP Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 tpost_ep_hw_dbg_sel : 4;       // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR, *PTPOST_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__TPOST_EP_HW_DEBUG_SELECT_CR, sizeof (TPOST_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _TPOST_EP_HW_DEBUG_SELECT_CR {
         u32 tpost_ep_hw_dbg_sel : 4;             // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR, *PTPOST_EP_HW_DEBUG_SELECT_CR;

      typedef union _TPOST_EP_HW_DEBUG_SELECT_CR_UNION {
         TPOST_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_EP_HW_DEBUG_SELECT_CR_UNION, *PTPOST_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (TPOST_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register determining the maximum number of input descriptors (TPRE to TPOST)
   // allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VINQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vinq_flow_id : 5;              // DWORD 0
               u32 vinq_ack_size : 4;             // DWORD 0
               u32 vinq_flow1_thresh : 8;         // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 vinq_flow0_thresh : 8;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR, *PTPOST_VINQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPOST_VINQ_ULP_LIMITS_CR, sizeof (TPOST_VINQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPOST_VINQ_ULP_LIMITS_CR {
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vinq_flow_id : 5;                    // DWORD 0
         u32 vinq_ack_size : 4;                   // DWORD 0
         u32 vinq_flow1_thresh : 8;               // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 vinq_flow0_thresh : 8;               // DWORD 0
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR, *PTPOST_VINQ_ULP_LIMITS_CR;

      typedef union _TPOST_VINQ_ULP_LIMITS_CR_UNION {
         TPOST_VINQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR_UNION, *PTPOST_VINQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VINQ_ULP_LIMITS_CR_UNION, sizeof (TPOST_VINQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#else
   // Control register determining the maximum number of input descriptors (TPRE to TPOST)
   // allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VINQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 vinq_flow0_thresh : 8;         // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 vinq_flow1_thresh : 8;         // DWORD 0
               u32 vinq_ack_size : 4;             // DWORD 0
               u32 vinq_flow_id : 5;              // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR, *PTPOST_VINQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPOST_VINQ_ULP_LIMITS_CR, sizeof (TPOST_VINQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPOST_VINQ_ULP_LIMITS_CR {
         u32 vinq_flow0_thresh : 8;               // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 vinq_flow1_thresh : 8;               // DWORD 0
         u32 vinq_ack_size : 4;                   // DWORD 0
         u32 vinq_flow_id : 5;                    // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR, *PTPOST_VINQ_ULP_LIMITS_CR;

      typedef union _TPOST_VINQ_ULP_LIMITS_CR_UNION {
         TPOST_VINQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VINQ_ULP_LIMITS_CR_UNION, *PTPOST_VINQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VINQ_ULP_LIMITS_CR_UNION, sizeof (TPOST_VINQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for accessing debug information in the TPOST's input and output
   // virtual queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQ_DEBUG_CR {
         union {
            struct { 
               u32 rsvd1 : 18;                    // DWORD 0
               u32 dbg_vinq_fme : 1;              // DWORD 0
               u32 dbg_vinq_wr : 1;               // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 dbg_vinq_addr : 9;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQ_DEBUG_CR, *PTPOST_VQ_DEBUG_CR;

      SG_C_ASSERT(__sizeof__TPOST_VQ_DEBUG_CR, sizeof (TPOST_VQ_DEBUG_CR) == 4);

   #else
      typedef struct _TPOST_VQ_DEBUG_CR {
         u32 rsvd1 : 18;                          // DWORD 0
         u32 dbg_vinq_fme : 1;                    // DWORD 0
         u32 dbg_vinq_wr : 1;                     // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 dbg_vinq_addr : 9;                   // DWORD 0
      } SG_PACK TPOST_VQ_DEBUG_CR, *PTPOST_VQ_DEBUG_CR;

      typedef union _TPOST_VQ_DEBUG_CR_UNION {
         TPOST_VQ_DEBUG_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQ_DEBUG_CR_UNION, *PTPOST_VQ_DEBUG_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQ_DEBUG_CR_UNION, sizeof (TPOST_VQ_DEBUG_CR_UNION) == 4);
   #endif


#else
   // Control register for accessing debug information in the TPOST's input and output
   // virtual queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQ_DEBUG_CR {
         union {
            struct { 
               u32 dbg_vinq_addr : 9;             // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 dbg_vinq_wr : 1;               // DWORD 0
               u32 dbg_vinq_fme : 1;              // DWORD 0
               u32 rsvd1 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQ_DEBUG_CR, *PTPOST_VQ_DEBUG_CR;

      SG_C_ASSERT(__sizeof__TPOST_VQ_DEBUG_CR, sizeof (TPOST_VQ_DEBUG_CR) == 4);

   #else
      typedef struct _TPOST_VQ_DEBUG_CR {
         u32 dbg_vinq_addr : 9;                   // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 dbg_vinq_wr : 1;                     // DWORD 0
         u32 dbg_vinq_fme : 1;                    // DWORD 0
         u32 rsvd1 : 18;                          // DWORD 0
      } SG_PACK TPOST_VQ_DEBUG_CR, *PTPOST_VQ_DEBUG_CR;

      typedef union _TPOST_VQ_DEBUG_CR_UNION {
         TPOST_VQ_DEBUG_CR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQ_DEBUG_CR_UNION, *PTPOST_VQ_DEBUG_CR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQ_DEBUG_CR_UNION, sizeof (TPOST_VQ_DEBUG_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (least-significant four bytes) from the TPOST input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_vinq_datal;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR, *PTPOST_DBG_VINQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAL_CSR, sizeof (TPOST_DBG_VINQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWDATAL_CSR {
         u32 dbg_vinq_datal;                      // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR, *PTPOST_DBG_VINQ_RWDATAL_CSR;

      typedef union _TPOST_DBG_VINQ_RWDATAL_CSR_UNION {
         TPOST_DBG_VINQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR_UNION, *PTPOST_DBG_VINQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAL_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWDATAL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (least-significant four bytes) from the TPOST input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_vinq_datal;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR, *PTPOST_DBG_VINQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAL_CSR, sizeof (TPOST_DBG_VINQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWDATAL_CSR {
         u32 dbg_vinq_datal;                      // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR, *PTPOST_DBG_VINQ_RWDATAL_CSR;

      typedef union _TPOST_DBG_VINQ_RWDATAL_CSR_UNION {
         TPOST_DBG_VINQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWDATAL_CSR_UNION, *PTPOST_DBG_VINQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAL_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWDATAL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (most-significant four bytes) from the TPOST input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_vinq_datau;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR, *PTPOST_DBG_VINQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAU_CSR, sizeof (TPOST_DBG_VINQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWDATAU_CSR {
         u32 dbg_vinq_datau;                      // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR, *PTPOST_DBG_VINQ_RWDATAU_CSR;

      typedef union _TPOST_DBG_VINQ_RWDATAU_CSR_UNION {
         TPOST_DBG_VINQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR_UNION, *PTPOST_DBG_VINQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAU_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWDATAU_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (most-significant four bytes) from the TPOST input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_vinq_datau;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR, *PTPOST_DBG_VINQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAU_CSR, sizeof (TPOST_DBG_VINQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWDATAU_CSR {
         u32 dbg_vinq_datau;                      // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR, *PTPOST_DBG_VINQ_RWDATAU_CSR;

      typedef union _TPOST_DBG_VINQ_RWDATAU_CSR_UNION {
         TPOST_DBG_VINQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWDATAU_CSR_UNION, *PTPOST_DBG_VINQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWDATAU_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWDATAU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write of the linked-list in the TPOST input virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWLL_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 dbg_vinq_ll : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR, *PTPOST_DBG_VINQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWLL_CSR, sizeof (TPOST_DBG_VINQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWLL_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 dbg_vinq_ll : 4;                     // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR, *PTPOST_DBG_VINQ_RWLL_CSR;

      typedef union _TPOST_DBG_VINQ_RWLL_CSR_UNION {
         TPOST_DBG_VINQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR_UNION, *PTPOST_DBG_VINQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWLL_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWLL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write of the linked-list in the TPOST input virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_RWLL_CSR {
         union {
            struct { 
               u32 dbg_vinq_ll : 4;               // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR, *PTPOST_DBG_VINQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWLL_CSR, sizeof (TPOST_DBG_VINQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_RWLL_CSR {
         u32 dbg_vinq_ll : 4;                     // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR, *PTPOST_DBG_VINQ_RWLL_CSR;

      typedef union _TPOST_DBG_VINQ_RWLL_CSR_UNION {
         TPOST_DBG_VINQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_RWLL_CSR_UNION, *PTPOST_DBG_VINQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_RWLL_CSR_UNION, sizeof (TPOST_DBG_VINQ_RWLL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Virtual Queue debug status.This register provides the free list pointers and state
   // information of the virtual queue 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_STATS1 {
         union {
            struct { 
               u32 rsvd2 : 3;                     // DWORD 0
               u32 vqueue_dbg_state_machine : 5;  // DWORD 0
               u32 vqueue_dbg_free_list_count : 8; // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vqueue_dbg_free_list_tail : 7; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_dbg_free_list_head : 7; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_STATS1, *PTPOST_DBG_VINQ_STATS1;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS1, sizeof (TPOST_DBG_VINQ_STATS1) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_STATS1 {
         u32 rsvd2 : 3;                           // DWORD 0
         u32 vqueue_dbg_state_machine : 5;        // DWORD 0
         u32 vqueue_dbg_free_list_count : 8;      // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vqueue_dbg_free_list_tail : 7;       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_dbg_free_list_head : 7;       // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_STATS1, *PTPOST_DBG_VINQ_STATS1;

      typedef union _TPOST_DBG_VINQ_STATS1_UNION {
         TPOST_DBG_VINQ_STATS1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_STATS1_UNION, *PTPOST_DBG_VINQ_STATS1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS1_UNION, sizeof (TPOST_DBG_VINQ_STATS1_UNION) == 4);
   #endif


#else
   // Virtual Queue debug status.This register provides the free list pointers and state
   // information of the virtual queue 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_STATS1 {
         union {
            struct { 
               u32 vqueue_dbg_free_list_head : 7; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_dbg_free_list_tail : 7; // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 vqueue_dbg_free_list_count : 8; // DWORD 0
               u32 vqueue_dbg_state_machine : 5;  // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_STATS1, *PTPOST_DBG_VINQ_STATS1;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS1, sizeof (TPOST_DBG_VINQ_STATS1) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_STATS1 {
         u32 vqueue_dbg_free_list_head : 7;       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_dbg_free_list_tail : 7;       // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 vqueue_dbg_free_list_count : 8;      // DWORD 0
         u32 vqueue_dbg_state_machine : 5;        // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_STATS1, *PTPOST_DBG_VINQ_STATS1;

      typedef union _TPOST_DBG_VINQ_STATS1_UNION {
         TPOST_DBG_VINQ_STATS1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_STATS1_UNION, *PTPOST_DBG_VINQ_STATS1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS1_UNION, sizeof (TPOST_DBG_VINQ_STATS1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Virtual Queue debug status 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_STATS2 {
         union {
            struct { 
               u32 rsvd2 : 3;                     // DWORD 0
               u32 vqueue_create_process_over : 1; // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vqueue_sram_init_over : 1;     // DWORD 0
               u32 vqueue_pop_transaction_over : 1; // DWORD 0
               u32 vqueue_create_transaction_over : 1; // DWORD 0
               u32 vqueue_rd_transaction_over : 1; // DWORD 0
               u32 vqueue_wr_transaction_over : 1; // DWORD 0
               u32 vqueue_transaction_qid : 4;    // DWORD 0
               u32 vqueue_error_qid : 4;          // DWORD 0
               u32 vqueue_underrun_qid : 4;       // DWORD 0
               u32 vqueue_manager_create_fsm : 4; // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_iqarb_arb_state : 3;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_STATS2, *PTPOST_DBG_VINQ_STATS2;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS2, sizeof (TPOST_DBG_VINQ_STATS2) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_STATS2 {
         u32 rsvd2 : 3;                           // DWORD 0
         u32 vqueue_create_process_over : 1;      // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vqueue_sram_init_over : 1;           // DWORD 0
         u32 vqueue_pop_transaction_over : 1;     // DWORD 0
         u32 vqueue_create_transaction_over : 1;  // DWORD 0
         u32 vqueue_rd_transaction_over : 1;      // DWORD 0
         u32 vqueue_wr_transaction_over : 1;      // DWORD 0
         u32 vqueue_transaction_qid : 4;          // DWORD 0
         u32 vqueue_error_qid : 4;                // DWORD 0
         u32 vqueue_underrun_qid : 4;             // DWORD 0
         u32 vqueue_manager_create_fsm : 4;       // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_iqarb_arb_state : 3;          // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_STATS2, *PTPOST_DBG_VINQ_STATS2;

      typedef union _TPOST_DBG_VINQ_STATS2_UNION {
         TPOST_DBG_VINQ_STATS2 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_STATS2_UNION, *PTPOST_DBG_VINQ_STATS2_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS2_UNION, sizeof (TPOST_DBG_VINQ_STATS2_UNION) == 4);
   #endif


#else
   // Virtual Queue debug status 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_DBG_VINQ_STATS2 {
         union {
            struct { 
               u32 vqueue_iqarb_arb_state : 3;    // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vqueue_manager_create_fsm : 4; // DWORD 0
               u32 vqueue_underrun_qid : 4;       // DWORD 0
               u32 vqueue_error_qid : 4;          // DWORD 0
               u32 vqueue_transaction_qid : 4;    // DWORD 0
               u32 vqueue_wr_transaction_over : 1; // DWORD 0
               u32 vqueue_rd_transaction_over : 1; // DWORD 0
               u32 vqueue_create_transaction_over : 1; // DWORD 0
               u32 vqueue_pop_transaction_over : 1; // DWORD 0
               u32 vqueue_sram_init_over : 1;     // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vqueue_create_process_over : 1; // DWORD 0
               u32 rsvd2 : 3;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_DBG_VINQ_STATS2, *PTPOST_DBG_VINQ_STATS2;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS2, sizeof (TPOST_DBG_VINQ_STATS2) == 4);

   #else
      typedef struct _TPOST_DBG_VINQ_STATS2 {
         u32 vqueue_iqarb_arb_state : 3;          // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vqueue_manager_create_fsm : 4;       // DWORD 0
         u32 vqueue_underrun_qid : 4;             // DWORD 0
         u32 vqueue_error_qid : 4;                // DWORD 0
         u32 vqueue_transaction_qid : 4;          // DWORD 0
         u32 vqueue_wr_transaction_over : 1;      // DWORD 0
         u32 vqueue_rd_transaction_over : 1;      // DWORD 0
         u32 vqueue_create_transaction_over : 1;  // DWORD 0
         u32 vqueue_pop_transaction_over : 1;     // DWORD 0
         u32 vqueue_sram_init_over : 1;           // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vqueue_create_process_over : 1;      // DWORD 0
         u32 rsvd2 : 3;                           // DWORD 0
      } SG_PACK TPOST_DBG_VINQ_STATS2, *PTPOST_DBG_VINQ_STATS2;

      typedef union _TPOST_DBG_VINQ_STATS2_UNION {
         TPOST_DBG_VINQ_STATS2 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_DBG_VINQ_STATS2_UNION, *PTPOST_DBG_VINQ_STATS2_UNION;

      SG_C_ASSERT(__sizeof__TPOST_DBG_VINQ_STATS2_UNION, sizeof (TPOST_DBG_VINQ_STATS2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Raw unrecoverable error source bits from the vqueue manager, not masked by MASK
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQUEUE_UE_SOURCE1 {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 vq_wr_create_same_time_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1, *PTPOST_VQUEUE_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_SOURCE1, sizeof (TPOST_VQUEUE_UE_SOURCE1) == 4);

   #else
      typedef struct _TPOST_VQUEUE_UE_SOURCE1 {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 vq_wr_create_same_time_error : 1;    // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1, *PTPOST_VQUEUE_UE_SOURCE1;

      typedef union _TPOST_VQUEUE_UE_SOURCE1_UNION {
         TPOST_VQUEUE_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1_UNION, *PTPOST_VQUEUE_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_SOURCE1_UNION, sizeof (TPOST_VQUEUE_UE_SOURCE1_UNION) == 4);
   #endif


#else
   // Raw unrecoverable error source bits from the vqueue manager, not masked by MASK
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQUEUE_UE_SOURCE1 {
         union {
            struct { 
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_wr_create_same_time_error : 1; // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1, *PTPOST_VQUEUE_UE_SOURCE1;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_SOURCE1, sizeof (TPOST_VQUEUE_UE_SOURCE1) == 4);

   #else
      typedef struct _TPOST_VQUEUE_UE_SOURCE1 {
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_wr_create_same_time_error : 1;    // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1, *PTPOST_VQUEUE_UE_SOURCE1;

      typedef union _TPOST_VQUEUE_UE_SOURCE1_UNION {
         TPOST_VQUEUE_UE_SOURCE1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQUEUE_UE_SOURCE1_UNION, *PTPOST_VQUEUE_UE_SOURCE1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_SOURCE1_UNION, sizeof (TPOST_VQUEUE_UE_SOURCE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Mask for disabling unrecoverable error . Write a 1 to enable
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQUEUE_UE_ENABLE1 {
         union {
            struct { 
               u32 rsvd0 : 18;                    // DWORD 0
               u32 vq_wr_create_same_time_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1, *PTPOST_VQUEUE_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_ENABLE1, sizeof (TPOST_VQUEUE_UE_ENABLE1) == 4);

   #else
      typedef struct _TPOST_VQUEUE_UE_ENABLE1 {
         u32 rsvd0 : 18;                          // DWORD 0
         u32 vq_wr_create_same_time_error : 1;    // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1, *PTPOST_VQUEUE_UE_ENABLE1;

      typedef union _TPOST_VQUEUE_UE_ENABLE1_UNION {
         TPOST_VQUEUE_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1_UNION, *PTPOST_VQUEUE_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_ENABLE1_UNION, sizeof (TPOST_VQUEUE_UE_ENABLE1_UNION) == 4);
   #endif


#else
   // Mask for disabling unrecoverable error . Write a 1 to enable
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_VQUEUE_UE_ENABLE1 {
         union {
            struct { 
               u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
               u32 vqueue_alloc_error : 1;        // DWORD 0
               u32 vqueue_dealloc_error : 1;      // DWORD 0
               u32 vqueue_underrun_error : 1;     // DWORD 0
               u32 vqueue_overrun_error : 1;      // DWORD 0
               u32 vqueue_sram_parity_error : 1;  // DWORD 0
               u32 vqueue_write_error : 1;        // DWORD 0
               u32 vqueue_read_error : 1;         // DWORD 0
               u32 vqueue_poke_error : 1;         // DWORD 0
               u32 vq_create_fifo_overflow_error : 1; // DWORD 0
               u32 vq_create_fifo_underflow_error : 1; // DWORD 0
               u32 vq_read_fifo_overflow_error : 1; // DWORD 0
               u32 vq_read_fifo_underflow_error : 1; // DWORD 0
               u32 vq_wr_create_same_time_error : 1; // DWORD 0
               u32 rsvd0 : 18;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1, *PTPOST_VQUEUE_UE_ENABLE1;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_ENABLE1, sizeof (TPOST_VQUEUE_UE_ENABLE1) == 4);

   #else
      typedef struct _TPOST_VQUEUE_UE_ENABLE1 {
         u32 vqueue_sram_access_during_init_error : 1; // DWORD 0
         u32 vqueue_alloc_error : 1;              // DWORD 0
         u32 vqueue_dealloc_error : 1;            // DWORD 0
         u32 vqueue_underrun_error : 1;           // DWORD 0
         u32 vqueue_overrun_error : 1;            // DWORD 0
         u32 vqueue_sram_parity_error : 1;        // DWORD 0
         u32 vqueue_write_error : 1;              // DWORD 0
         u32 vqueue_read_error : 1;               // DWORD 0
         u32 vqueue_poke_error : 1;               // DWORD 0
         u32 vq_create_fifo_overflow_error : 1;   // DWORD 0
         u32 vq_create_fifo_underflow_error : 1;  // DWORD 0
         u32 vq_read_fifo_overflow_error : 1;     // DWORD 0
         u32 vq_read_fifo_underflow_error : 1;    // DWORD 0
         u32 vq_wr_create_same_time_error : 1;    // DWORD 0
         u32 rsvd0 : 18;                          // DWORD 0
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1, *PTPOST_VQUEUE_UE_ENABLE1;

      typedef union _TPOST_VQUEUE_UE_ENABLE1_UNION {
         TPOST_VQUEUE_UE_ENABLE1 bits;
         u32 dw; // dword union
      } SG_PACK TPOST_VQUEUE_UE_ENABLE1_UNION, *PTPOST_VQUEUE_UE_ENABLE1_UNION;

      SG_C_ASSERT(__sizeof__TPOST_VQUEUE_UE_ENABLE1_UNION, sizeof (TPOST_VQUEUE_UE_ENABLE1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP Post Processor control and status registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               TPOST_PROTSEL_CTL1_CR tpost_protsel_ctl1;
               TPOST_PROTSEL_CTL2_CR tpost_protsel_ctl2;
               TPOST_PROTSEL_CTL3_CR tpost_protsel_ctl3;
               TPOST_DEST_BUF_CREDIT_CR tpost_dest_buf_credit;
               struct {
                  JELLT_CFG_CSR jellt_cfg;
                  CID_CFG_CSR cid_cfg;
                  JELLM_FREE_CSR free;
                  JELLM_SM_CSR sm;
                  JELLM_UE_ENABLE_CSR uee;
                  JELLM_UE_STATUS_CSR ues;
                  JELLM_LAST_AREQ_CSR last_areq;
                  JELLM_LAST_ARESP_CSR last_aresp;
                  JELLM_LAST_DREQ_CSR last_dreq;
                  JELLM_LAST_DEALLOC_CSR last_dealloc;
                  JELLM_ALLOC_CNT_CSR alloc_cnt;
                  JELLM_DEALLOC_CNT_CSR dealloc_cnt;
               } jellm;
               TPOST_JOURNAL_WB_HO_PHY_ADDR_CR tpost_journal_wb_ho_phy_addr;
               TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR tpost_journal_wb_xlat_table_addr;
               TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR tpost_journal_wb_xlat_table_rwdata;
               TPOST_UE_SOURCE_CR tpost_ue_source;
               TPOST_UE_ENABLE_CR tpost_ue_enable;
               TPOST_PROTSEL_UE_SOURCE_CR tpost_protsel_ue_source;
               TPOST_PROTSEL_UE_ENABLE_CR tpost_protsel_ue_enable;
               TPOST_UE_SOURCE_1_CR tpost_ue_source_1;
               TPOST_UE_ENABLE_1_CR tpost_ue_enable_1;
               TPOST_LOW_LATENCY_TX_UE_SOURCE_CR tpost_low_latency_tx_ue_source;
               TPOST_LOW_LATENCY_TX_UE_ENABLE_CR tpost_low_latency_tx_ue_enable;
               TPOST_LOW_LATENCY_LENGTH_LIMIT_CR tpost_low_latency_lenght_limit;
               TPOST_DEBUG_STAT0_SR tpost_debug_stat0;
               TPOST_DEBUG_STAT1_SR tpost_debug_stat1;
               TPOST_DEBUG_STAT2_SR tpost_debug_stat2;
               TPOST_DEBUG_STAT3_SR tpost_debug_stat3;
               TPOST_DEBUG_STAT4_SR tpost_debug_stat4;
               HWDBG_CSRMAP hwdbg;
               TPOST_EP_CLASS_DEBUG_EN_CR tpost_debug_class_debug;
               TPOST_EP_HW_DEBUG_SELECT_CR tpost_ep_hw_debug_select;
               TPOST_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
               TPOST_VQ_DEBUG_CR vq_debug;
               TPOST_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
               TPOST_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
               TPOST_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
               TPOST_DBG_VINQ_STATS1 vq_dbg_stats1;
               TPOST_DBG_VINQ_STATS2 vq_dbg_stats2;
               TPOST_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
               TPOST_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
               u32 rsvd0[12];                     // DWORDS 116 to 127
               TPOST_LL_DATA_PORT0_CR_RANGE portA[64];
               TPOST_LL_DATA_PORT1_CR_RANGE portB[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TPOST_CSRMAP, *PTPOST_CSRMAP;

      SG_C_ASSERT(__sizeof__TPOST_CSRMAP, sizeof (TPOST_CSRMAP) == 1024);

   #else
      typedef struct _TPOST_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         TPOST_PROTSEL_CTL1_CR tpost_protsel_ctl1;
         TPOST_PROTSEL_CTL2_CR tpost_protsel_ctl2;
         TPOST_PROTSEL_CTL3_CR tpost_protsel_ctl3;
         TPOST_DEST_BUF_CREDIT_CR tpost_dest_buf_credit;
         struct {
            JELLT_CFG_CSR jellt_cfg;
            CID_CFG_CSR cid_cfg;
            JELLM_FREE_CSR free;
            JELLM_SM_CSR sm;
            JELLM_UE_ENABLE_CSR uee;
            JELLM_UE_STATUS_CSR ues;
            JELLM_LAST_AREQ_CSR last_areq;
            JELLM_LAST_ARESP_CSR last_aresp;
            JELLM_LAST_DREQ_CSR last_dreq;
            JELLM_LAST_DEALLOC_CSR last_dealloc;
            JELLM_ALLOC_CNT_CSR alloc_cnt;
            JELLM_DEALLOC_CNT_CSR dealloc_cnt;
         } jellm;
         TPOST_JOURNAL_WB_HO_PHY_ADDR_CR tpost_journal_wb_ho_phy_addr;
         TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR tpost_journal_wb_xlat_table_addr;
         TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR tpost_journal_wb_xlat_table_rwdata;
         TPOST_UE_SOURCE_CR tpost_ue_source;
         TPOST_UE_ENABLE_CR tpost_ue_enable;
         TPOST_PROTSEL_UE_SOURCE_CR tpost_protsel_ue_source;
         TPOST_PROTSEL_UE_ENABLE_CR tpost_protsel_ue_enable;
         TPOST_UE_SOURCE_1_CR tpost_ue_source_1;
         TPOST_UE_ENABLE_1_CR tpost_ue_enable_1;
         TPOST_LOW_LATENCY_TX_UE_SOURCE_CR tpost_low_latency_tx_ue_source;
         TPOST_LOW_LATENCY_TX_UE_ENABLE_CR tpost_low_latency_tx_ue_enable;
         TPOST_LOW_LATENCY_LENGTH_LIMIT_CR tpost_low_latency_lenght_limit;
         TPOST_DEBUG_STAT0_SR tpost_debug_stat0;
         TPOST_DEBUG_STAT1_SR tpost_debug_stat1;
         TPOST_DEBUG_STAT2_SR tpost_debug_stat2;
         TPOST_DEBUG_STAT3_SR tpost_debug_stat3;
         TPOST_DEBUG_STAT4_SR tpost_debug_stat4;
         HWDBG_CSRMAP hwdbg;
         TPOST_EP_CLASS_DEBUG_EN_CR tpost_debug_class_debug;
         TPOST_EP_HW_DEBUG_SELECT_CR tpost_ep_hw_debug_select;
         TPOST_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
         TPOST_VQ_DEBUG_CR vq_debug;
         TPOST_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
         TPOST_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
         TPOST_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
         TPOST_DBG_VINQ_STATS1 vq_dbg_stats1;
         TPOST_DBG_VINQ_STATS2 vq_dbg_stats2;
         TPOST_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
         TPOST_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
         u32 rsvd0[12];                           // DWORDS 116 to 127
         TPOST_LL_DATA_PORT0_CR_RANGE portA[64];
         TPOST_LL_DATA_PORT1_CR_RANGE portB[64];
      } SG_PACK TPOST_CSRMAP, *PTPOST_CSRMAP;

      typedef union _TPOST_CSRMAP_UNION {
         TPOST_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TPOST_CSRMAP_UNION, *PTPOST_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TPOST_CSRMAP_UNION, sizeof (TPOST_CSRMAP_UNION) == 1024);
   #endif


#else
   // TCP Post Processor control and status registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPOST_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               TPOST_PROTSEL_CTL1_CR tpost_protsel_ctl1;
               TPOST_PROTSEL_CTL2_CR tpost_protsel_ctl2;
               TPOST_PROTSEL_CTL3_CR tpost_protsel_ctl3;
               TPOST_DEST_BUF_CREDIT_CR tpost_dest_buf_credit;
               struct {
                  JELLT_CFG_CSR jellt_cfg;
                  CID_CFG_CSR cid_cfg;
                  JELLM_FREE_CSR free;
                  JELLM_SM_CSR sm;
                  JELLM_UE_ENABLE_CSR uee;
                  JELLM_UE_STATUS_CSR ues;
                  JELLM_LAST_AREQ_CSR last_areq;
                  JELLM_LAST_ARESP_CSR last_aresp;
                  JELLM_LAST_DREQ_CSR last_dreq;
                  JELLM_LAST_DEALLOC_CSR last_dealloc;
                  JELLM_ALLOC_CNT_CSR alloc_cnt;
                  JELLM_DEALLOC_CNT_CSR dealloc_cnt;
               } jellm;
               TPOST_JOURNAL_WB_HO_PHY_ADDR_CR tpost_journal_wb_ho_phy_addr;
               TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR tpost_journal_wb_xlat_table_addr;
               TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR tpost_journal_wb_xlat_table_rwdata;
               TPOST_UE_SOURCE_CR tpost_ue_source;
               TPOST_UE_ENABLE_CR tpost_ue_enable;
               TPOST_PROTSEL_UE_SOURCE_CR tpost_protsel_ue_source;
               TPOST_PROTSEL_UE_ENABLE_CR tpost_protsel_ue_enable;
               TPOST_UE_SOURCE_1_CR tpost_ue_source_1;
               TPOST_UE_ENABLE_1_CR tpost_ue_enable_1;
               TPOST_LOW_LATENCY_TX_UE_SOURCE_CR tpost_low_latency_tx_ue_source;
               TPOST_LOW_LATENCY_TX_UE_ENABLE_CR tpost_low_latency_tx_ue_enable;
               TPOST_LOW_LATENCY_LENGTH_LIMIT_CR tpost_low_latency_lenght_limit;
               TPOST_DEBUG_STAT0_SR tpost_debug_stat0;
               TPOST_DEBUG_STAT1_SR tpost_debug_stat1;
               TPOST_DEBUG_STAT2_SR tpost_debug_stat2;
               TPOST_DEBUG_STAT3_SR tpost_debug_stat3;
               TPOST_DEBUG_STAT4_SR tpost_debug_stat4;
               HWDBG_CSRMAP hwdbg;
               TPOST_EP_CLASS_DEBUG_EN_CR tpost_debug_class_debug;
               TPOST_EP_HW_DEBUG_SELECT_CR tpost_ep_hw_debug_select;
               TPOST_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
               TPOST_VQ_DEBUG_CR vq_debug;
               TPOST_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
               TPOST_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
               TPOST_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
               TPOST_DBG_VINQ_STATS1 vq_dbg_stats1;
               TPOST_DBG_VINQ_STATS2 vq_dbg_stats2;
               TPOST_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
               TPOST_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
               u32 rsvd0[12];                     // DWORDS 116 to 127
               TPOST_LL_DATA_PORT0_CR_RANGE portA[64];
               TPOST_LL_DATA_PORT1_CR_RANGE portB[64];
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TPOST_CSRMAP, *PTPOST_CSRMAP;

      SG_C_ASSERT(__sizeof__TPOST_CSRMAP, sizeof (TPOST_CSRMAP) == 1024);

   #else
      typedef struct _TPOST_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         TPOST_PROTSEL_CTL1_CR tpost_protsel_ctl1;
         TPOST_PROTSEL_CTL2_CR tpost_protsel_ctl2;
         TPOST_PROTSEL_CTL3_CR tpost_protsel_ctl3;
         TPOST_DEST_BUF_CREDIT_CR tpost_dest_buf_credit;
         struct {
            JELLT_CFG_CSR jellt_cfg;
            CID_CFG_CSR cid_cfg;
            JELLM_FREE_CSR free;
            JELLM_SM_CSR sm;
            JELLM_UE_ENABLE_CSR uee;
            JELLM_UE_STATUS_CSR ues;
            JELLM_LAST_AREQ_CSR last_areq;
            JELLM_LAST_ARESP_CSR last_aresp;
            JELLM_LAST_DREQ_CSR last_dreq;
            JELLM_LAST_DEALLOC_CSR last_dealloc;
            JELLM_ALLOC_CNT_CSR alloc_cnt;
            JELLM_DEALLOC_CNT_CSR dealloc_cnt;
         } jellm;
         TPOST_JOURNAL_WB_HO_PHY_ADDR_CR tpost_journal_wb_ho_phy_addr;
         TPOST_JOURNAL_WB_XLAT_TABLE_ADDR_CR tpost_journal_wb_xlat_table_addr;
         TPOST_JOURNAL_WB_XLAT_TABLE_RWDATA_CR tpost_journal_wb_xlat_table_rwdata;
         TPOST_UE_SOURCE_CR tpost_ue_source;
         TPOST_UE_ENABLE_CR tpost_ue_enable;
         TPOST_PROTSEL_UE_SOURCE_CR tpost_protsel_ue_source;
         TPOST_PROTSEL_UE_ENABLE_CR tpost_protsel_ue_enable;
         TPOST_UE_SOURCE_1_CR tpost_ue_source_1;
         TPOST_UE_ENABLE_1_CR tpost_ue_enable_1;
         TPOST_LOW_LATENCY_TX_UE_SOURCE_CR tpost_low_latency_tx_ue_source;
         TPOST_LOW_LATENCY_TX_UE_ENABLE_CR tpost_low_latency_tx_ue_enable;
         TPOST_LOW_LATENCY_LENGTH_LIMIT_CR tpost_low_latency_lenght_limit;
         TPOST_DEBUG_STAT0_SR tpost_debug_stat0;
         TPOST_DEBUG_STAT1_SR tpost_debug_stat1;
         TPOST_DEBUG_STAT2_SR tpost_debug_stat2;
         TPOST_DEBUG_STAT3_SR tpost_debug_stat3;
         TPOST_DEBUG_STAT4_SR tpost_debug_stat4;
         HWDBG_CSRMAP hwdbg;
         TPOST_EP_CLASS_DEBUG_EN_CR tpost_debug_class_debug;
         TPOST_EP_HW_DEBUG_SELECT_CR tpost_ep_hw_debug_select;
         TPOST_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
         TPOST_VQ_DEBUG_CR vq_debug;
         TPOST_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
         TPOST_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
         TPOST_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
         TPOST_DBG_VINQ_STATS1 vq_dbg_stats1;
         TPOST_DBG_VINQ_STATS2 vq_dbg_stats2;
         TPOST_VQUEUE_UE_SOURCE1 vqueue_ue_source1;
         TPOST_VQUEUE_UE_ENABLE1 vqueue_ue_enable1;
         u32 rsvd0[12];                           // DWORDS 116 to 127
         TPOST_LL_DATA_PORT0_CR_RANGE portA[64];
         TPOST_LL_DATA_PORT1_CR_RANGE portB[64];
      } SG_PACK TPOST_CSRMAP, *PTPOST_CSRMAP;

      typedef union _TPOST_CSRMAP_UNION {
         TPOST_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TPOST_CSRMAP_UNION, *PTPOST_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TPOST_CSRMAP_UNION, sizeof (TPOST_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpost_bmap_h__

