/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __tpre_bmap_h__
#define __tpre_bmap_h__
#include "setypes.h"
#include "ep_bmap.h"
#include "jellm_bmap.h"
#include "ep_minirom_bmap.h"
#include "pq_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // TCP Context Memory Base Address. Addr = BaseAddr + CID*STRIDE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TCP_CM_ADDR_CR {
         union {
            struct { 
               u32 rsvd0 : 9;                     // DWORD 0
               u32 tcp_state_rxoffst : 7;         // DWORD 0
               u32 tcp_state_base : 16;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TCP_CM_ADDR_CR, *PTPRE_TCP_CM_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPRE_TCP_CM_ADDR_CR, sizeof (TPRE_TCP_CM_ADDR_CR) == 4);

   #else
      typedef struct _TPRE_TCP_CM_ADDR_CR {
         u32 rsvd0 : 9;                           // DWORD 0
         u32 tcp_state_rxoffst : 7;               // DWORD 0
         u32 tcp_state_base : 16;                 // DWORD 0
      } SG_PACK TPRE_TCP_CM_ADDR_CR, *PTPRE_TCP_CM_ADDR_CR;

      typedef union _TPRE_TCP_CM_ADDR_CR_UNION {
         TPRE_TCP_CM_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_TCP_CM_ADDR_CR_UNION, *PTPRE_TCP_CM_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TCP_CM_ADDR_CR_UNION, sizeof (TPRE_TCP_CM_ADDR_CR_UNION) == 4);
   #endif


#else
   // TCP Context Memory Base Address. Addr = BaseAddr + CID*STRIDE. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TCP_CM_ADDR_CR {
         union {
            struct { 
               u32 tcp_state_base : 16;           // DWORD 0
               u32 tcp_state_rxoffst : 7;         // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TCP_CM_ADDR_CR, *PTPRE_TCP_CM_ADDR_CR;

      SG_C_ASSERT(__sizeof__TPRE_TCP_CM_ADDR_CR, sizeof (TPRE_TCP_CM_ADDR_CR) == 4);

   #else
      typedef struct _TPRE_TCP_CM_ADDR_CR {
         u32 tcp_state_base : 16;                 // DWORD 0
         u32 tcp_state_rxoffst : 7;               // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
      } SG_PACK TPRE_TCP_CM_ADDR_CR, *PTPRE_TCP_CM_ADDR_CR;

      typedef union _TPRE_TCP_CM_ADDR_CR_UNION {
         TPRE_TCP_CM_ADDR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_TCP_CM_ADDR_CR_UNION, *PTPRE_TCP_CM_ADDR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TCP_CM_ADDR_CR_UNION, sizeof (TPRE_TCP_CM_ADDR_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for the 1ms TimeStamp register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_1MS_TIMESTAMP_CR {
         union {
            struct { 
               u32 tim_1ms_ts_divide : 16;        // DWORD 0
               u32 tim_1ms_ts_integ : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_1MS_TIMESTAMP_CR, *PTIM_1MS_TIMESTAMP_CR;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_CR, sizeof (TIM_1MS_TIMESTAMP_CR) == 4);

   #else
      typedef struct _TIM_1MS_TIMESTAMP_CR {
         u32 tim_1ms_ts_divide : 16;              // DWORD 0
         u32 tim_1ms_ts_integ : 16;               // DWORD 0
      } SG_PACK TIM_1MS_TIMESTAMP_CR, *PTIM_1MS_TIMESTAMP_CR;

      typedef union _TIM_1MS_TIMESTAMP_CR_UNION {
         TIM_1MS_TIMESTAMP_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_1MS_TIMESTAMP_CR_UNION, *PTIM_1MS_TIMESTAMP_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_CR_UNION, sizeof (TIM_1MS_TIMESTAMP_CR_UNION) == 4);
   #endif


#else
   // Control register for the 1ms TimeStamp register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_1MS_TIMESTAMP_CR {
         union {
            struct { 
               u32 tim_1ms_ts_integ : 16;         // DWORD 0
               u32 tim_1ms_ts_divide : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_1MS_TIMESTAMP_CR, *PTIM_1MS_TIMESTAMP_CR;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_CR, sizeof (TIM_1MS_TIMESTAMP_CR) == 4);

   #else
      typedef struct _TIM_1MS_TIMESTAMP_CR {
         u32 tim_1ms_ts_integ : 16;               // DWORD 0
         u32 tim_1ms_ts_divide : 16;              // DWORD 0
      } SG_PACK TIM_1MS_TIMESTAMP_CR, *PTIM_1MS_TIMESTAMP_CR;

      typedef union _TIM_1MS_TIMESTAMP_CR_UNION {
         TIM_1MS_TIMESTAMP_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_1MS_TIMESTAMP_CR_UNION, *PTIM_1MS_TIMESTAMP_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_CR_UNION, sizeof (TIM_1MS_TIMESTAMP_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for configuring TCP timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_TIMESTAMP_EXPIRE_CR {
         union {
            struct { 
               u32 tim_tcp_tpresteer : 8;         // DWORD 0
               u32 tim_tcp_tpoststeer : 8;        // DWORD 0
               u32 tim_tcp_interval : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR, *PTIM_TIMESTAMP_EXPIRE_CR;

      SG_C_ASSERT(__sizeof__TIM_TIMESTAMP_EXPIRE_CR, sizeof (TIM_TIMESTAMP_EXPIRE_CR) == 4);

   #else
      typedef struct _TIM_TIMESTAMP_EXPIRE_CR {
         u32 tim_tcp_tpresteer : 8;               // DWORD 0
         u32 tim_tcp_tpoststeer : 8;              // DWORD 0
         u32 tim_tcp_interval : 16;               // DWORD 0
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR, *PTIM_TIMESTAMP_EXPIRE_CR;

      typedef union _TIM_TIMESTAMP_EXPIRE_CR_UNION {
         TIM_TIMESTAMP_EXPIRE_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR_UNION, *PTIM_TIMESTAMP_EXPIRE_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_TIMESTAMP_EXPIRE_CR_UNION, sizeof (TIM_TIMESTAMP_EXPIRE_CR_UNION) == 4);
   #endif


#else
   // Control register for configuring TCP timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_TIMESTAMP_EXPIRE_CR {
         union {
            struct { 
               u32 tim_tcp_interval : 16;         // DWORD 0
               u32 tim_tcp_tpoststeer : 8;        // DWORD 0
               u32 tim_tcp_tpresteer : 8;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR, *PTIM_TIMESTAMP_EXPIRE_CR;

      SG_C_ASSERT(__sizeof__TIM_TIMESTAMP_EXPIRE_CR, sizeof (TIM_TIMESTAMP_EXPIRE_CR) == 4);

   #else
      typedef struct _TIM_TIMESTAMP_EXPIRE_CR {
         u32 tim_tcp_interval : 16;               // DWORD 0
         u32 tim_tcp_tpoststeer : 8;              // DWORD 0
         u32 tim_tcp_tpresteer : 8;               // DWORD 0
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR, *PTIM_TIMESTAMP_EXPIRE_CR;

      typedef union _TIM_TIMESTAMP_EXPIRE_CR_UNION {
         TIM_TIMESTAMP_EXPIRE_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_TIMESTAMP_EXPIRE_CR_UNION, *PTIM_TIMESTAMP_EXPIRE_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_TIMESTAMP_EXPIRE_CR_UNION, sizeof (TIM_TIMESTAMP_EXPIRE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // There are eight TCP timers available. Each of these timers may have a different
   // timescale associated with it. This register declaration conforms to the timer usage
   // by BladeEngine firmware. Refer to the documentation of TIM_TCP_TIMER_SCALE_CR for
   // more information. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_FW_TIMER_SCALE_CR {
         union {
            struct { 
               u32 timer0 : 4;                    // DWORD 0
               u32 timer1 : 4;                    // DWORD 0
               u32 timer2 : 4;                    // DWORD 0
               u32 timer3 : 4;                    // DWORD 0
               u32 timer4 : 4;                    // DWORD 0
               u32 timer5 : 4;                    // DWORD 0
               u32 timer6 : 4;                    // DWORD 0
               u32 timer7 : 4;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_FW_TIMER_SCALE_CR, *PTPRE_FW_TIMER_SCALE_CR;

      SG_C_ASSERT(__sizeof__TPRE_FW_TIMER_SCALE_CR, sizeof (TPRE_FW_TIMER_SCALE_CR) == 4);

   #else
      typedef struct _TPRE_FW_TIMER_SCALE_CR {
         u32 timer0 : 4;                          // DWORD 0
         u32 timer1 : 4;                          // DWORD 0
         u32 timer2 : 4;                          // DWORD 0
         u32 timer3 : 4;                          // DWORD 0
         u32 timer4 : 4;                          // DWORD 0
         u32 timer5 : 4;                          // DWORD 0
         u32 timer6 : 4;                          // DWORD 0
         u32 timer7 : 4;                          // DWORD 0
      } SG_PACK TPRE_FW_TIMER_SCALE_CR, *PTPRE_FW_TIMER_SCALE_CR;

      typedef union _TPRE_FW_TIMER_SCALE_CR_UNION {
         TPRE_FW_TIMER_SCALE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_FW_TIMER_SCALE_CR_UNION, *PTPRE_FW_TIMER_SCALE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_FW_TIMER_SCALE_CR_UNION, sizeof (TPRE_FW_TIMER_SCALE_CR_UNION) == 4);
   #endif


#else
   // There are eight TCP timers available. Each of these timers may have a different
   // timescale associated with it. This register declaration conforms to the timer usage
   // by BladeEngine firmware. Refer to the documentation of TIM_TCP_TIMER_SCALE_CR for
   // more information. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_FW_TIMER_SCALE_CR {
         union {
            struct { 
               u32 timer7 : 4;                    // DWORD 0
               u32 timer6 : 4;                    // DWORD 0
               u32 timer5 : 4;                    // DWORD 0
               u32 timer4 : 4;                    // DWORD 0
               u32 timer3 : 4;                    // DWORD 0
               u32 timer2 : 4;                    // DWORD 0
               u32 timer1 : 4;                    // DWORD 0
               u32 timer0 : 4;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_FW_TIMER_SCALE_CR, *PTPRE_FW_TIMER_SCALE_CR;

      SG_C_ASSERT(__sizeof__TPRE_FW_TIMER_SCALE_CR, sizeof (TPRE_FW_TIMER_SCALE_CR) == 4);

   #else
      typedef struct _TPRE_FW_TIMER_SCALE_CR {
         u32 timer7 : 4;                          // DWORD 0
         u32 timer6 : 4;                          // DWORD 0
         u32 timer5 : 4;                          // DWORD 0
         u32 timer4 : 4;                          // DWORD 0
         u32 timer3 : 4;                          // DWORD 0
         u32 timer2 : 4;                          // DWORD 0
         u32 timer1 : 4;                          // DWORD 0
         u32 timer0 : 4;                          // DWORD 0
      } SG_PACK TPRE_FW_TIMER_SCALE_CR, *PTPRE_FW_TIMER_SCALE_CR;

      typedef union _TPRE_FW_TIMER_SCALE_CR_UNION {
         TPRE_FW_TIMER_SCALE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_FW_TIMER_SCALE_CR_UNION, *PTPRE_FW_TIMER_SCALE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_FW_TIMER_SCALE_CR_UNION, sizeof (TPRE_FW_TIMER_SCALE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the eight TCP timers may have a different timescale associated with it. This
   // allows the single-byte timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_TCP_TIMER_SCALE_CR {
         union {
            struct { 
               u32 tim_tcp_timer_scale;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_TCP_TIMER_SCALE_CR, *PTIM_TCP_TIMER_SCALE_CR;

      SG_C_ASSERT(__sizeof__TIM_TCP_TIMER_SCALE_CR, sizeof (TIM_TCP_TIMER_SCALE_CR) == 4);

   #else
      typedef struct _TIM_TCP_TIMER_SCALE_CR {
         u32 tim_tcp_timer_scale;                 // DWORD 0
      } SG_PACK TIM_TCP_TIMER_SCALE_CR, *PTIM_TCP_TIMER_SCALE_CR;

      typedef union _TIM_TCP_TIMER_SCALE_CR_UNION {
         TIM_TCP_TIMER_SCALE_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_TCP_TIMER_SCALE_CR_UNION, *PTIM_TCP_TIMER_SCALE_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_TCP_TIMER_SCALE_CR_UNION, sizeof (TIM_TCP_TIMER_SCALE_CR_UNION) == 4);
   #endif


#else
   // Each of the eight TCP timers may have a different timescale associated with it. This
   // allows the single-byte timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_TCP_TIMER_SCALE_CR {
         union {
            struct { 
               u32 tim_tcp_timer_scale;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_TCP_TIMER_SCALE_CR, *PTIM_TCP_TIMER_SCALE_CR;

      SG_C_ASSERT(__sizeof__TIM_TCP_TIMER_SCALE_CR, sizeof (TIM_TCP_TIMER_SCALE_CR) == 4);

   #else
      typedef struct _TIM_TCP_TIMER_SCALE_CR {
         u32 tim_tcp_timer_scale;                 // DWORD 0
      } SG_PACK TIM_TCP_TIMER_SCALE_CR, *PTIM_TCP_TIMER_SCALE_CR;

      typedef union _TIM_TCP_TIMER_SCALE_CR_UNION {
         TIM_TCP_TIMER_SCALE_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_TCP_TIMER_SCALE_CR_UNION, *PTIM_TCP_TIMER_SCALE_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_TCP_TIMER_SCALE_CR_UNION, sizeof (TIM_TCP_TIMER_SCALE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 1 ms TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_1MS_TIMESTAMP_SR {
         union {
            struct { 
               u32 timestamp_1ms;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_1MS_TIMESTAMP_SR, *PTIM_1MS_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_SR, sizeof (TIM_1MS_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_1MS_TIMESTAMP_SR {
         u32 timestamp_1ms;                       // DWORD 0
      } SG_PACK TIM_1MS_TIMESTAMP_SR, *PTIM_1MS_TIMESTAMP_SR;

      typedef union _TIM_1MS_TIMESTAMP_SR_UNION {
         TIM_1MS_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_1MS_TIMESTAMP_SR_UNION, *PTIM_1MS_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_SR_UNION, sizeof (TIM_1MS_TIMESTAMP_SR_UNION) == 4);
   #endif


#else
   // 1 ms TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_1MS_TIMESTAMP_SR {
         union {
            struct { 
               u32 timestamp_1ms;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_1MS_TIMESTAMP_SR, *PTIM_1MS_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_SR, sizeof (TIM_1MS_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_1MS_TIMESTAMP_SR {
         u32 timestamp_1ms;                       // DWORD 0
      } SG_PACK TIM_1MS_TIMESTAMP_SR, *PTIM_1MS_TIMESTAMP_SR;

      typedef union _TIM_1MS_TIMESTAMP_SR_UNION {
         TIM_1MS_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_1MS_TIMESTAMP_SR_UNION, *PTIM_1MS_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_1MS_TIMESTAMP_SR_UNION, sizeof (TIM_1MS_TIMESTAMP_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 10 ms TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_10MS_TIMESTAMP_SR {
         union {
            struct { 
               u32 timestamp_10ms;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_10MS_TIMESTAMP_SR, *PTIM_10MS_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_10MS_TIMESTAMP_SR, sizeof (TIM_10MS_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_10MS_TIMESTAMP_SR {
         u32 timestamp_10ms;                      // DWORD 0
      } SG_PACK TIM_10MS_TIMESTAMP_SR, *PTIM_10MS_TIMESTAMP_SR;

      typedef union _TIM_10MS_TIMESTAMP_SR_UNION {
         TIM_10MS_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_10MS_TIMESTAMP_SR_UNION, *PTIM_10MS_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_10MS_TIMESTAMP_SR_UNION, sizeof (TIM_10MS_TIMESTAMP_SR_UNION) == 4);
   #endif


#else
   // 10 ms TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_10MS_TIMESTAMP_SR {
         union {
            struct { 
               u32 timestamp_10ms;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_10MS_TIMESTAMP_SR, *PTIM_10MS_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_10MS_TIMESTAMP_SR, sizeof (TIM_10MS_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_10MS_TIMESTAMP_SR {
         u32 timestamp_10ms;                      // DWORD 0
      } SG_PACK TIM_10MS_TIMESTAMP_SR, *PTIM_10MS_TIMESTAMP_SR;

      typedef union _TIM_10MS_TIMESTAMP_SR_UNION {
         TIM_10MS_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_10MS_TIMESTAMP_SR_UNION, *PTIM_10MS_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_10MS_TIMESTAMP_SR_UNION, sizeof (TIM_10MS_TIMESTAMP_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for the 3.2us TimeStamp register. Field
   // 'tim_lro_tpre_timerpopdelay' is used by LRO timer module.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_3_2US_TIMESTAMP_CR {
         union {
            struct { 
               u32 tim_lro_tpre_timerpopdelay : 8; // DWORD 0
               u32 tim_3_2us_ts_divide : 12;      // DWORD 0
               u32 tim_3_2us_ts_integ : 12;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_3_2US_TIMESTAMP_CR, *PTIM_3_2US_TIMESTAMP_CR;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_CR, sizeof (TIM_3_2US_TIMESTAMP_CR) == 4);

   #else
      typedef struct _TIM_3_2US_TIMESTAMP_CR {
         u32 tim_lro_tpre_timerpopdelay : 8;      // DWORD 0
         u32 tim_3_2us_ts_divide : 12;            // DWORD 0
         u32 tim_3_2us_ts_integ : 12;             // DWORD 0
      } SG_PACK TIM_3_2US_TIMESTAMP_CR, *PTIM_3_2US_TIMESTAMP_CR;

      typedef union _TIM_3_2US_TIMESTAMP_CR_UNION {
         TIM_3_2US_TIMESTAMP_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_3_2US_TIMESTAMP_CR_UNION, *PTIM_3_2US_TIMESTAMP_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_CR_UNION, sizeof (TIM_3_2US_TIMESTAMP_CR_UNION) == 4);
   #endif


#else
   // Control register for the 3.2us TimeStamp register. Field
   // 'tim_lro_tpre_timerpopdelay' is used by LRO timer module.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_3_2US_TIMESTAMP_CR {
         union {
            struct { 
               u32 tim_3_2us_ts_integ : 12;       // DWORD 0
               u32 tim_3_2us_ts_divide : 12;      // DWORD 0
               u32 tim_lro_tpre_timerpopdelay : 8; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_3_2US_TIMESTAMP_CR, *PTIM_3_2US_TIMESTAMP_CR;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_CR, sizeof (TIM_3_2US_TIMESTAMP_CR) == 4);

   #else
      typedef struct _TIM_3_2US_TIMESTAMP_CR {
         u32 tim_3_2us_ts_integ : 12;             // DWORD 0
         u32 tim_3_2us_ts_divide : 12;            // DWORD 0
         u32 tim_lro_tpre_timerpopdelay : 8;      // DWORD 0
      } SG_PACK TIM_3_2US_TIMESTAMP_CR, *PTIM_3_2US_TIMESTAMP_CR;

      typedef union _TIM_3_2US_TIMESTAMP_CR_UNION {
         TIM_3_2US_TIMESTAMP_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_3_2US_TIMESTAMP_CR_UNION, *PTIM_3_2US_TIMESTAMP_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_CR_UNION, sizeof (TIM_3_2US_TIMESTAMP_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for configuring LRO timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_EXPIRE0_CR {
         union {
            struct { 
               u32 tim_lro_tpresteer0;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR, *PTIM_LRO_TIMER_EXPIRE0_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE0_CR, sizeof (TIM_LRO_TIMER_EXPIRE0_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_EXPIRE0_CR {
         u32 tim_lro_tpresteer0;                  // DWORD 0
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR, *PTIM_LRO_TIMER_EXPIRE0_CR;

      typedef union _TIM_LRO_TIMER_EXPIRE0_CR_UNION {
         TIM_LRO_TIMER_EXPIRE0_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR_UNION, *PTIM_LRO_TIMER_EXPIRE0_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE0_CR_UNION, sizeof (TIM_LRO_TIMER_EXPIRE0_CR_UNION) == 4);
   #endif


#else
   // Control register for configuring LRO timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_EXPIRE0_CR {
         union {
            struct { 
               u32 tim_lro_tpresteer0;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR, *PTIM_LRO_TIMER_EXPIRE0_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE0_CR, sizeof (TIM_LRO_TIMER_EXPIRE0_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_EXPIRE0_CR {
         u32 tim_lro_tpresteer0;                  // DWORD 0
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR, *PTIM_LRO_TIMER_EXPIRE0_CR;

      typedef union _TIM_LRO_TIMER_EXPIRE0_CR_UNION {
         TIM_LRO_TIMER_EXPIRE0_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_EXPIRE0_CR_UNION, *PTIM_LRO_TIMER_EXPIRE0_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE0_CR_UNION, sizeof (TIM_LRO_TIMER_EXPIRE0_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for configuring LRO timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_EXPIRE1_CR {
         union {
            struct { 
               u32 tim_lro_tpresteer1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR, *PTIM_LRO_TIMER_EXPIRE1_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE1_CR, sizeof (TIM_LRO_TIMER_EXPIRE1_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_EXPIRE1_CR {
         u32 tim_lro_tpresteer1;                  // DWORD 0
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR, *PTIM_LRO_TIMER_EXPIRE1_CR;

      typedef union _TIM_LRO_TIMER_EXPIRE1_CR_UNION {
         TIM_LRO_TIMER_EXPIRE1_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR_UNION, *PTIM_LRO_TIMER_EXPIRE1_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE1_CR_UNION, sizeof (TIM_LRO_TIMER_EXPIRE1_CR_UNION) == 4);
   #endif


#else
   // Control register for configuring LRO timer expirations.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_EXPIRE1_CR {
         union {
            struct { 
               u32 tim_lro_tpresteer1;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR, *PTIM_LRO_TIMER_EXPIRE1_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE1_CR, sizeof (TIM_LRO_TIMER_EXPIRE1_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_EXPIRE1_CR {
         u32 tim_lro_tpresteer1;                  // DWORD 0
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR, *PTIM_LRO_TIMER_EXPIRE1_CR;

      typedef union _TIM_LRO_TIMER_EXPIRE1_CR_UNION {
         TIM_LRO_TIMER_EXPIRE1_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_EXPIRE1_CR_UNION, *PTIM_LRO_TIMER_EXPIRE1_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_EXPIRE1_CR_UNION, sizeof (TIM_LRO_TIMER_EXPIRE1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE0_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale0;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR, *PTIM_LRO_TIMER_SCALE0_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE0_CR, sizeof (TIM_LRO_TIMER_SCALE0_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE0_CR {
         u32 tim_lro_timer_scale0;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR, *PTIM_LRO_TIMER_SCALE0_CR;

      typedef union _TIM_LRO_TIMER_SCALE0_CR_UNION {
         TIM_LRO_TIMER_SCALE0_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR_UNION, *PTIM_LRO_TIMER_SCALE0_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE0_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE0_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE0_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale0;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR, *PTIM_LRO_TIMER_SCALE0_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE0_CR, sizeof (TIM_LRO_TIMER_SCALE0_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE0_CR {
         u32 tim_lro_timer_scale0;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR, *PTIM_LRO_TIMER_SCALE0_CR;

      typedef union _TIM_LRO_TIMER_SCALE0_CR_UNION {
         TIM_LRO_TIMER_SCALE0_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE0_CR_UNION, *PTIM_LRO_TIMER_SCALE0_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE0_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE0_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE1_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR, *PTIM_LRO_TIMER_SCALE1_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE1_CR, sizeof (TIM_LRO_TIMER_SCALE1_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE1_CR {
         u32 tim_lro_timer_scale1;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR, *PTIM_LRO_TIMER_SCALE1_CR;

      typedef union _TIM_LRO_TIMER_SCALE1_CR_UNION {
         TIM_LRO_TIMER_SCALE1_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR_UNION, *PTIM_LRO_TIMER_SCALE1_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE1_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE1_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE1_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR, *PTIM_LRO_TIMER_SCALE1_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE1_CR, sizeof (TIM_LRO_TIMER_SCALE1_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE1_CR {
         u32 tim_lro_timer_scale1;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR, *PTIM_LRO_TIMER_SCALE1_CR;

      typedef union _TIM_LRO_TIMER_SCALE1_CR_UNION {
         TIM_LRO_TIMER_SCALE1_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE1_CR_UNION, *PTIM_LRO_TIMER_SCALE1_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE1_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE2_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale2;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR, *PTIM_LRO_TIMER_SCALE2_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE2_CR, sizeof (TIM_LRO_TIMER_SCALE2_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE2_CR {
         u32 tim_lro_timer_scale2;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR, *PTIM_LRO_TIMER_SCALE2_CR;

      typedef union _TIM_LRO_TIMER_SCALE2_CR_UNION {
         TIM_LRO_TIMER_SCALE2_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR_UNION, *PTIM_LRO_TIMER_SCALE2_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE2_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE2_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE2_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale2;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR, *PTIM_LRO_TIMER_SCALE2_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE2_CR, sizeof (TIM_LRO_TIMER_SCALE2_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE2_CR {
         u32 tim_lro_timer_scale2;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR, *PTIM_LRO_TIMER_SCALE2_CR;

      typedef union _TIM_LRO_TIMER_SCALE2_CR_UNION {
         TIM_LRO_TIMER_SCALE2_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE2_CR_UNION, *PTIM_LRO_TIMER_SCALE2_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE2_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE2_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE3_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale3;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR, *PTIM_LRO_TIMER_SCALE3_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE3_CR, sizeof (TIM_LRO_TIMER_SCALE3_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE3_CR {
         u32 tim_lro_timer_scale3;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR, *PTIM_LRO_TIMER_SCALE3_CR;

      typedef union _TIM_LRO_TIMER_SCALE3_CR_UNION {
         TIM_LRO_TIMER_SCALE3_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR_UNION, *PTIM_LRO_TIMER_SCALE3_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE3_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE3_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE3_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale3;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR, *PTIM_LRO_TIMER_SCALE3_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE3_CR, sizeof (TIM_LRO_TIMER_SCALE3_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE3_CR {
         u32 tim_lro_timer_scale3;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR, *PTIM_LRO_TIMER_SCALE3_CR;

      typedef union _TIM_LRO_TIMER_SCALE3_CR_UNION {
         TIM_LRO_TIMER_SCALE3_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE3_CR_UNION, *PTIM_LRO_TIMER_SCALE3_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE3_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE3_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE4_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR, *PTIM_LRO_TIMER_SCALE4_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE4_CR, sizeof (TIM_LRO_TIMER_SCALE4_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE4_CR {
         u32 tim_lro_timer_scale4;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR, *PTIM_LRO_TIMER_SCALE4_CR;

      typedef union _TIM_LRO_TIMER_SCALE4_CR_UNION {
         TIM_LRO_TIMER_SCALE4_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR_UNION, *PTIM_LRO_TIMER_SCALE4_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE4_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE4_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE4_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale4;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR, *PTIM_LRO_TIMER_SCALE4_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE4_CR, sizeof (TIM_LRO_TIMER_SCALE4_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE4_CR {
         u32 tim_lro_timer_scale4;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR, *PTIM_LRO_TIMER_SCALE4_CR;

      typedef union _TIM_LRO_TIMER_SCALE4_CR_UNION {
         TIM_LRO_TIMER_SCALE4_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE4_CR_UNION, *PTIM_LRO_TIMER_SCALE4_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE4_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE4_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE5_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale5;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR, *PTIM_LRO_TIMER_SCALE5_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE5_CR, sizeof (TIM_LRO_TIMER_SCALE5_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE5_CR {
         u32 tim_lro_timer_scale5;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR, *PTIM_LRO_TIMER_SCALE5_CR;

      typedef union _TIM_LRO_TIMER_SCALE5_CR_UNION {
         TIM_LRO_TIMER_SCALE5_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR_UNION, *PTIM_LRO_TIMER_SCALE5_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE5_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE5_CR_UNION) == 4);
   #endif


#else
   // Each of the 64 LRO timers may have a different timescale associated with it. This
   // allows the 6-bit timer values to have vastly different expire times.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_LRO_TIMER_SCALE5_CR {
         union {
            struct { 
               u32 tim_lro_timer_scale5;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR, *PTIM_LRO_TIMER_SCALE5_CR;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE5_CR, sizeof (TIM_LRO_TIMER_SCALE5_CR) == 4);

   #else
      typedef struct _TIM_LRO_TIMER_SCALE5_CR {
         u32 tim_lro_timer_scale5;                // DWORD 0
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR, *PTIM_LRO_TIMER_SCALE5_CR;

      typedef union _TIM_LRO_TIMER_SCALE5_CR_UNION {
         TIM_LRO_TIMER_SCALE5_CR bits;
         u32 dw; // dword union
      } SG_PACK TIM_LRO_TIMER_SCALE5_CR_UNION, *PTIM_LRO_TIMER_SCALE5_CR_UNION;

      SG_C_ASSERT(__sizeof__TIM_LRO_TIMER_SCALE5_CR_UNION, sizeof (TIM_LRO_TIMER_SCALE5_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // 3.2 us TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_3_2US_TIMESTAMP_SR {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 timestamp_3_2us : 12;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_3_2US_TIMESTAMP_SR, *PTIM_3_2US_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_SR, sizeof (TIM_3_2US_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_3_2US_TIMESTAMP_SR {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 timestamp_3_2us : 12;                // DWORD 0
      } SG_PACK TIM_3_2US_TIMESTAMP_SR, *PTIM_3_2US_TIMESTAMP_SR;

      typedef union _TIM_3_2US_TIMESTAMP_SR_UNION {
         TIM_3_2US_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_3_2US_TIMESTAMP_SR_UNION, *PTIM_3_2US_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_SR_UNION, sizeof (TIM_3_2US_TIMESTAMP_SR_UNION) == 4);
   #endif


#else
   // 3.2 us TimeStamp value status register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TIM_3_2US_TIMESTAMP_SR {
         union {
            struct { 
               u32 timestamp_3_2us : 12;          // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TIM_3_2US_TIMESTAMP_SR, *PTIM_3_2US_TIMESTAMP_SR;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_SR, sizeof (TIM_3_2US_TIMESTAMP_SR) == 4);

   #else
      typedef struct _TIM_3_2US_TIMESTAMP_SR {
         u32 timestamp_3_2us : 12;                // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK TIM_3_2US_TIMESTAMP_SR, *PTIM_3_2US_TIMESTAMP_SR;

      typedef union _TIM_3_2US_TIMESTAMP_SR_UNION {
         TIM_3_2US_TIMESTAMP_SR bits;
         u32 dw; // dword union
      } SG_PACK TIM_3_2US_TIMESTAMP_SR_UNION, *PTIM_3_2US_TIMESTAMP_SR_UNION;

      SG_C_ASSERT(__sizeof__TIM_3_2US_TIMESTAMP_SR_UNION, sizeof (TIM_3_2US_TIMESTAMP_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register determining the maximum number of input descriptors (RXPP to TPRE)
   // allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 vinq_flow_id : 6;              // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vinq_flow1_thresh : 9;         // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 vinq_flow0_thresh : 9;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR, *PTPRE_VINQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_ULP_LIMITS_CR, sizeof (TPRE_VINQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPRE_VINQ_ULP_LIMITS_CR {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 vinq_flow_id : 6;                    // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vinq_flow1_thresh : 9;               // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 vinq_flow0_thresh : 9;               // DWORD 0
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR, *PTPRE_VINQ_ULP_LIMITS_CR;

      typedef union _TPRE_VINQ_ULP_LIMITS_CR_UNION {
         TPRE_VINQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR_UNION, *PTPRE_VINQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_ULP_LIMITS_CR_UNION, sizeof (TPRE_VINQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#else
   // Control register determining the maximum number of input descriptors (RXPP to TPRE)
   // allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 vinq_flow0_thresh : 9;         // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 vinq_flow1_thresh : 9;         // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 vinq_flow_id : 6;              // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR, *PTPRE_VINQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_ULP_LIMITS_CR, sizeof (TPRE_VINQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPRE_VINQ_ULP_LIMITS_CR {
         u32 vinq_flow0_thresh : 9;               // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 vinq_flow1_thresh : 9;               // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 vinq_flow_id : 6;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR, *PTPRE_VINQ_ULP_LIMITS_CR;

      typedef union _TPRE_VINQ_ULP_LIMITS_CR_UNION {
         TPRE_VINQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_ULP_LIMITS_CR_UNION, *PTPRE_VINQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_ULP_LIMITS_CR_UNION, sizeof (TPRE_VINQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register determining the maximum number of output descriptors (TPRE to
   // RxULP) allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 rsvd2 : 9;                     // DWORD 0
               u32 voq_u2_thresh : 7;             // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_u1_thresh : 7;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_u0_thresh : 7;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR, *PTPRE_VOQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_ULP_LIMITS_CR, sizeof (TPRE_VOQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPRE_VOQ_ULP_LIMITS_CR {
         u32 rsvd2 : 9;                           // DWORD 0
         u32 voq_u2_thresh : 7;                   // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_u1_thresh : 7;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_u0_thresh : 7;                   // DWORD 0
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR, *PTPRE_VOQ_ULP_LIMITS_CR;

      typedef union _TPRE_VOQ_ULP_LIMITS_CR_UNION {
         TPRE_VOQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR_UNION, *PTPRE_VOQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_ULP_LIMITS_CR_UNION, sizeof (TPRE_VOQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#else
   // Control register determining the maximum number of output descriptors (TPRE to
   // RxULP) allowed on a per-ulp basis.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_ULP_LIMITS_CR {
         union {
            struct { 
               u32 voq_u0_thresh : 7;             // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_u1_thresh : 7;             // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_u2_thresh : 7;             // DWORD 0
               u32 rsvd2 : 9;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR, *PTPRE_VOQ_ULP_LIMITS_CR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_ULP_LIMITS_CR, sizeof (TPRE_VOQ_ULP_LIMITS_CR) == 4);

   #else
      typedef struct _TPRE_VOQ_ULP_LIMITS_CR {
         u32 voq_u0_thresh : 7;                   // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_u1_thresh : 7;                   // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_u2_thresh : 7;                   // DWORD 0
         u32 rsvd2 : 9;                           // DWORD 0
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR, *PTPRE_VOQ_ULP_LIMITS_CR;

      typedef union _TPRE_VOQ_ULP_LIMITS_CR_UNION {
         TPRE_VOQ_ULP_LIMITS_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_ULP_LIMITS_CR_UNION, *PTPRE_VOQ_ULP_LIMITS_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_ULP_LIMITS_CR_UNION, sizeof (TPRE_VOQ_ULP_LIMITS_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for accessing debug information in the TPRE's input and output
   // virtual queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VQ_DEBUG_CR {
         union {
            struct { 
               u32 rsvd3 : 2;                     // DWORD 0
               u32 dbg_voq_fme : 1;               // DWORD 0
               u32 dbg_voq_wr : 1;                // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 dbg_voq_addr : 8;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 dbg_vinq_fme : 1;              // DWORD 0
               u32 dbg_vinq_wr : 1;               // DWORD 0
               u32 dbg_vinq_rxpp_wr : 1;          // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dbg_vinq_addr : 10;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VQ_DEBUG_CR, *PTPRE_VQ_DEBUG_CR;

      SG_C_ASSERT(__sizeof__TPRE_VQ_DEBUG_CR, sizeof (TPRE_VQ_DEBUG_CR) == 4);

   #else
      typedef struct _TPRE_VQ_DEBUG_CR {
         u32 rsvd3 : 2;                           // DWORD 0
         u32 dbg_voq_fme : 1;                     // DWORD 0
         u32 dbg_voq_wr : 1;                      // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 dbg_voq_addr : 8;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 dbg_vinq_fme : 1;                    // DWORD 0
         u32 dbg_vinq_wr : 1;                     // DWORD 0
         u32 dbg_vinq_rxpp_wr : 1;                // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dbg_vinq_addr : 10;                  // DWORD 0
      } SG_PACK TPRE_VQ_DEBUG_CR, *PTPRE_VQ_DEBUG_CR;

      typedef union _TPRE_VQ_DEBUG_CR_UNION {
         TPRE_VQ_DEBUG_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VQ_DEBUG_CR_UNION, *PTPRE_VQ_DEBUG_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VQ_DEBUG_CR_UNION, sizeof (TPRE_VQ_DEBUG_CR_UNION) == 4);
   #endif


#else
   // Control register for accessing debug information in the TPRE's input and output
   // virtual queues.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VQ_DEBUG_CR {
         union {
            struct { 
               u32 dbg_vinq_addr : 10;            // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 dbg_vinq_rxpp_wr : 1;          // DWORD 0
               u32 dbg_vinq_wr : 1;               // DWORD 0
               u32 dbg_vinq_fme : 1;              // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 dbg_voq_addr : 8;              // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 dbg_voq_wr : 1;                // DWORD 0
               u32 dbg_voq_fme : 1;               // DWORD 0
               u32 rsvd3 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VQ_DEBUG_CR, *PTPRE_VQ_DEBUG_CR;

      SG_C_ASSERT(__sizeof__TPRE_VQ_DEBUG_CR, sizeof (TPRE_VQ_DEBUG_CR) == 4);

   #else
      typedef struct _TPRE_VQ_DEBUG_CR {
         u32 dbg_vinq_addr : 10;                  // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 dbg_vinq_rxpp_wr : 1;                // DWORD 0
         u32 dbg_vinq_wr : 1;                     // DWORD 0
         u32 dbg_vinq_fme : 1;                    // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 dbg_voq_addr : 8;                    // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 dbg_voq_wr : 1;                      // DWORD 0
         u32 dbg_voq_fme : 1;                     // DWORD 0
         u32 rsvd3 : 2;                           // DWORD 0
      } SG_PACK TPRE_VQ_DEBUG_CR, *PTPRE_VQ_DEBUG_CR;

      typedef union _TPRE_VQ_DEBUG_CR_UNION {
         TPRE_VQ_DEBUG_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VQ_DEBUG_CR_UNION, *PTPRE_VQ_DEBUG_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VQ_DEBUG_CR_UNION, sizeof (TPRE_VQ_DEBUG_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Controls various aspects of the TPRE's hardware support logic.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TPRE_COPROCESSOR2_CR {
         union {
            struct { 
               u32 rsvd1 : 14;                    // DWORD 0
               u32 ack_credits : 6;               // DWORD 0
               u32 g : 1;                         // DWORD 0
               u32 r : 1;                         // DWORD 0
               u32 d : 1;                         // DWORD 0
               u32 c : 1;                         // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 halign_end_addr : 7;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR, *PTPRE_TPRE_COPROCESSOR2_CR;

      SG_C_ASSERT(__sizeof__TPRE_TPRE_COPROCESSOR2_CR, sizeof (TPRE_TPRE_COPROCESSOR2_CR) == 4);

   #else
      typedef struct _TPRE_TPRE_COPROCESSOR2_CR {
         u32 rsvd1 : 14;                          // DWORD 0
         u32 ack_credits : 6;                     // DWORD 0
         u32 g : 1;                               // DWORD 0
         u32 r : 1;                               // DWORD 0
         u32 d : 1;                               // DWORD 0
         u32 c : 1;                               // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 halign_end_addr : 7;                 // DWORD 0
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR, *PTPRE_TPRE_COPROCESSOR2_CR;

      typedef union _TPRE_TPRE_COPROCESSOR2_CR_UNION {
         TPRE_TPRE_COPROCESSOR2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR_UNION, *PTPRE_TPRE_COPROCESSOR2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TPRE_COPROCESSOR2_CR_UNION, sizeof (TPRE_TPRE_COPROCESSOR2_CR_UNION) == 4);
   #endif


#else
   // Controls various aspects of the TPRE's hardware support logic.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_TPRE_COPROCESSOR2_CR {
         union {
            struct { 
               u32 halign_end_addr : 7;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 c : 1;                         // DWORD 0
               u32 d : 1;                         // DWORD 0
               u32 r : 1;                         // DWORD 0
               u32 g : 1;                         // DWORD 0
               u32 ack_credits : 6;               // DWORD 0
               u32 rsvd1 : 14;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR, *PTPRE_TPRE_COPROCESSOR2_CR;

      SG_C_ASSERT(__sizeof__TPRE_TPRE_COPROCESSOR2_CR, sizeof (TPRE_TPRE_COPROCESSOR2_CR) == 4);

   #else
      typedef struct _TPRE_TPRE_COPROCESSOR2_CR {
         u32 halign_end_addr : 7;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 c : 1;                               // DWORD 0
         u32 d : 1;                               // DWORD 0
         u32 r : 1;                               // DWORD 0
         u32 g : 1;                               // DWORD 0
         u32 ack_credits : 6;                     // DWORD 0
         u32 rsvd1 : 14;                          // DWORD 0
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR, *PTPRE_TPRE_COPROCESSOR2_CR;

      typedef union _TPRE_TPRE_COPROCESSOR2_CR_UNION {
         TPRE_TPRE_COPROCESSOR2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_TPRE_COPROCESSOR2_CR_UNION, *PTPRE_TPRE_COPROCESSOR2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_TPRE_COPROCESSOR2_CR_UNION, sizeof (TPRE_TPRE_COPROCESSOR2_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for controlling which debug data is visible via the debug CSRs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_CTL_CR {
         union {
            struct { 
               u32 rsvd4 : 12;                    // DWORD 0
               u32 ep_dbg_sel : 4;                // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
               u32 mux_dbg_sel : 1;               // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 ack_dbg_sel : 2;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 oqs_dbg_sel : 3;               // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 inq_dbg_sel : 2;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_CTL_CR, *PTPRE_DEBUG_CTL_CR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_CTL_CR, sizeof (TPRE_DEBUG_CTL_CR) == 4);

   #else
      typedef struct _TPRE_DEBUG_CTL_CR {
         u32 rsvd4 : 12;                          // DWORD 0
         u32 ep_dbg_sel : 4;                      // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
         u32 mux_dbg_sel : 1;                     // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 ack_dbg_sel : 2;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 oqs_dbg_sel : 3;                     // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 inq_dbg_sel : 2;                     // DWORD 0
      } SG_PACK TPRE_DEBUG_CTL_CR, *PTPRE_DEBUG_CTL_CR;

      typedef union _TPRE_DEBUG_CTL_CR_UNION {
         TPRE_DEBUG_CTL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_CTL_CR_UNION, *PTPRE_DEBUG_CTL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_CTL_CR_UNION, sizeof (TPRE_DEBUG_CTL_CR_UNION) == 4);
   #endif


#else
   // Control register for controlling which debug data is visible via the debug CSRs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_CTL_CR {
         union {
            struct { 
               u32 inq_dbg_sel : 2;               // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 oqs_dbg_sel : 3;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 ack_dbg_sel : 2;               // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
               u32 mux_dbg_sel : 1;               // DWORD 0
               u32 rsvd3 : 3;                     // DWORD 0
               u32 ep_dbg_sel : 4;                // DWORD 0
               u32 rsvd4 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_CTL_CR, *PTPRE_DEBUG_CTL_CR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_CTL_CR, sizeof (TPRE_DEBUG_CTL_CR) == 4);

   #else
      typedef struct _TPRE_DEBUG_CTL_CR {
         u32 inq_dbg_sel : 2;                     // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 oqs_dbg_sel : 3;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 ack_dbg_sel : 2;                     // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
         u32 mux_dbg_sel : 1;                     // DWORD 0
         u32 rsvd3 : 3;                           // DWORD 0
         u32 ep_dbg_sel : 4;                      // DWORD 0
         u32 rsvd4 : 12;                          // DWORD 0
      } SG_PACK TPRE_DEBUG_CTL_CR, *PTPRE_DEBUG_CTL_CR;

      typedef union _TPRE_DEBUG_CTL_CR_UNION {
         TPRE_DEBUG_CTL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_CTL_CR_UNION, *PTPRE_DEBUG_CTL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_CTL_CR_UNION, sizeof (TPRE_DEBUG_CTL_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (least-significant four bytes) from the TPRE input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_vinq_datal;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR, *PTPRE_DBG_VINQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAL_CSR, sizeof (TPRE_DBG_VINQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWDATAL_CSR {
         u32 dbg_vinq_datal;                      // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR, *PTPRE_DBG_VINQ_RWDATAL_CSR;

      typedef union _TPRE_DBG_VINQ_RWDATAL_CSR_UNION {
         TPRE_DBG_VINQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR_UNION, *PTPRE_DBG_VINQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAL_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWDATAL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (least-significant four bytes) from the TPRE input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_vinq_datal;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR, *PTPRE_DBG_VINQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAL_CSR, sizeof (TPRE_DBG_VINQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWDATAL_CSR {
         u32 dbg_vinq_datal;                      // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR, *PTPRE_DBG_VINQ_RWDATAL_CSR;

      typedef union _TPRE_DBG_VINQ_RWDATAL_CSR_UNION {
         TPRE_DBG_VINQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWDATAL_CSR_UNION, *PTPRE_DBG_VINQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAL_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWDATAL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (most-significant four bytes) from the TPRE input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_vinq_datau;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR, *PTPRE_DBG_VINQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAU_CSR, sizeof (TPRE_DBG_VINQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWDATAU_CSR {
         u32 dbg_vinq_datau;                      // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR, *PTPRE_DBG_VINQ_RWDATAU_CSR;

      typedef union _TPRE_DBG_VINQ_RWDATAU_CSR_UNION {
         TPRE_DBG_VINQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR_UNION, *PTPRE_DBG_VINQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAU_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWDATAU_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (most-significant four bytes) from the TPRE input virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_vinq_datau;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR, *PTPRE_DBG_VINQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAU_CSR, sizeof (TPRE_DBG_VINQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWDATAU_CSR {
         u32 dbg_vinq_datau;                      // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR, *PTPRE_DBG_VINQ_RWDATAU_CSR;

      typedef union _TPRE_DBG_VINQ_RWDATAU_CSR_UNION {
         TPRE_DBG_VINQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWDATAU_CSR_UNION, *PTPRE_DBG_VINQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWDATAU_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWDATAU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write of the linked-list in the TPRE input virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWLL_CSR {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 dbg_vinq_ll : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR, *PTPRE_DBG_VINQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWLL_CSR, sizeof (TPRE_DBG_VINQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWLL_CSR {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 dbg_vinq_ll : 4;                     // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR, *PTPRE_DBG_VINQ_RWLL_CSR;

      typedef union _TPRE_DBG_VINQ_RWLL_CSR_UNION {
         TPRE_DBG_VINQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR_UNION, *PTPRE_DBG_VINQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWLL_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWLL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write of the linked-list in the TPRE input virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VINQ_RWLL_CSR {
         union {
            struct { 
               u32 dbg_vinq_ll : 4;               // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR, *PTPRE_DBG_VINQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWLL_CSR, sizeof (TPRE_DBG_VINQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VINQ_RWLL_CSR {
         u32 dbg_vinq_ll : 4;                     // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR, *PTPRE_DBG_VINQ_RWLL_CSR;

      typedef union _TPRE_DBG_VINQ_RWLL_CSR_UNION {
         TPRE_DBG_VINQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VINQ_RWLL_CSR_UNION, *PTPRE_DBG_VINQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VINQ_RWLL_CSR_UNION, sizeof (TPRE_DBG_VINQ_RWLL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (least-significant four bytes) from the TPRE output virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_voq_datal;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR, *PTPRE_DBG_VOQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAL_CSR, sizeof (TPRE_DBG_VOQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWDATAL_CSR {
         u32 dbg_voq_datal;                       // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR, *PTPRE_DBG_VOQ_RWDATAL_CSR;

      typedef union _TPRE_DBG_VOQ_RWDATAL_CSR_UNION {
         TPRE_DBG_VOQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR_UNION, *PTPRE_DBG_VOQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAL_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWDATAL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (least-significant four bytes) from the TPRE output virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWDATAL_CSR {
         union {
            struct { 
               u32 dbg_voq_datal;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR, *PTPRE_DBG_VOQ_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAL_CSR, sizeof (TPRE_DBG_VOQ_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWDATAL_CSR {
         u32 dbg_voq_datal;                       // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR, *PTPRE_DBG_VOQ_RWDATAL_CSR;

      typedef union _TPRE_DBG_VOQ_RWDATAL_CSR_UNION {
         TPRE_DBG_VOQ_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWDATAL_CSR_UNION, *PTPRE_DBG_VOQ_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAL_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWDATAL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write data (most-significant four bytes) from the TPRE output virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_voq_datau;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR, *PTPRE_DBG_VOQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAU_CSR, sizeof (TPRE_DBG_VOQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWDATAU_CSR {
         u32 dbg_voq_datau;                       // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR, *PTPRE_DBG_VOQ_RWDATAU_CSR;

      typedef union _TPRE_DBG_VOQ_RWDATAU_CSR_UNION {
         TPRE_DBG_VOQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR_UNION, *PTPRE_DBG_VOQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAU_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWDATAU_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write data (most-significant four bytes) from the TPRE output virtual
   // queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWDATAU_CSR {
         union {
            struct { 
               u32 dbg_voq_datau;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR, *PTPRE_DBG_VOQ_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAU_CSR, sizeof (TPRE_DBG_VOQ_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWDATAU_CSR {
         u32 dbg_voq_datau;                       // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR, *PTPRE_DBG_VOQ_RWDATAU_CSR;

      typedef union _TPRE_DBG_VOQ_RWDATAU_CSR_UNION {
         TPRE_DBG_VOQ_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWDATAU_CSR_UNION, *PTPRE_DBG_VOQ_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWDATAU_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWDATAU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Debug read/write of the linked-list in the TPRE output virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWLL_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 dbg_voq_ll : 5;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR, *PTPRE_DBG_VOQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWLL_CSR, sizeof (TPRE_DBG_VOQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWLL_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 dbg_voq_ll : 5;                      // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR, *PTPRE_DBG_VOQ_RWLL_CSR;

      typedef union _TPRE_DBG_VOQ_RWLL_CSR_UNION {
         TPRE_DBG_VOQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR_UNION, *PTPRE_DBG_VOQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWLL_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWLL_CSR_UNION) == 4);
   #endif


#else
   // Debug read/write of the linked-list in the TPRE output virtual queue.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBG_VOQ_RWLL_CSR {
         union {
            struct { 
               u32 dbg_voq_ll : 5;                // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR, *PTPRE_DBG_VOQ_RWLL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWLL_CSR, sizeof (TPRE_DBG_VOQ_RWLL_CSR) == 4);

   #else
      typedef struct _TPRE_DBG_VOQ_RWLL_CSR {
         u32 dbg_voq_ll : 5;                      // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR, *PTPRE_DBG_VOQ_RWLL_CSR;

      typedef union _TPRE_DBG_VOQ_RWLL_CSR_UNION {
         TPRE_DBG_VOQ_RWLL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBG_VOQ_RWLL_CSR_UNION, *PTPRE_DBG_VOQ_RWLL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBG_VOQ_RWLL_CSR_UNION, sizeof (TPRE_DBG_VOQ_RWLL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // read/write access to the default buffer credit cost parameters in the TPRE default
   // buffer checker.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBCRED_CFG_RWDATA_CSR {
         union {
            struct { 
               u32 rsvd2 : 2;                     // DWORD 0
               u32 dbcred_wr_en : 1;              // DWORD 0
               u32 dbcred_cost_cred_n : 1;        // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 dbcred_pdid : 5;               // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 dbcred_data : 17;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR, *PTPRE_DBCRED_CFG_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBCRED_CFG_RWDATA_CSR, sizeof (TPRE_DBCRED_CFG_RWDATA_CSR) == 4);

   #else
      typedef struct _TPRE_DBCRED_CFG_RWDATA_CSR {
         u32 rsvd2 : 2;                           // DWORD 0
         u32 dbcred_wr_en : 1;                    // DWORD 0
         u32 dbcred_cost_cred_n : 1;              // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 dbcred_pdid : 5;                     // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 dbcred_data : 17;                    // DWORD 0
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR, *PTPRE_DBCRED_CFG_RWDATA_CSR;

      typedef union _TPRE_DBCRED_CFG_RWDATA_CSR_UNION {
         TPRE_DBCRED_CFG_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR_UNION, *PTPRE_DBCRED_CFG_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBCRED_CFG_RWDATA_CSR_UNION, sizeof (TPRE_DBCRED_CFG_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // read/write access to the default buffer credit cost parameters in the TPRE default
   // buffer checker.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DBCRED_CFG_RWDATA_CSR {
         union {
            struct { 
               u32 dbcred_data : 17;              // DWORD 0
               u32 rsvd0 : 3;                     // DWORD 0
               u32 dbcred_pdid : 5;               // DWORD 0
               u32 rsvd1 : 3;                     // DWORD 0
               u32 dbcred_cost_cred_n : 1;        // DWORD 0
               u32 dbcred_wr_en : 1;              // DWORD 0
               u32 rsvd2 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR, *PTPRE_DBCRED_CFG_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TPRE_DBCRED_CFG_RWDATA_CSR, sizeof (TPRE_DBCRED_CFG_RWDATA_CSR) == 4);

   #else
      typedef struct _TPRE_DBCRED_CFG_RWDATA_CSR {
         u32 dbcred_data : 17;                    // DWORD 0
         u32 rsvd0 : 3;                           // DWORD 0
         u32 dbcred_pdid : 5;                     // DWORD 0
         u32 rsvd1 : 3;                           // DWORD 0
         u32 dbcred_cost_cred_n : 1;              // DWORD 0
         u32 dbcred_wr_en : 1;                    // DWORD 0
         u32 rsvd2 : 2;                           // DWORD 0
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR, *PTPRE_DBCRED_CFG_RWDATA_CSR;

      typedef union _TPRE_DBCRED_CFG_RWDATA_CSR_UNION {
         TPRE_DBCRED_CFG_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DBCRED_CFG_RWDATA_CSR_UNION, *PTPRE_DBCRED_CFG_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DBCRED_CFG_RWDATA_CSR_UNION, sizeof (TPRE_DBCRED_CFG_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE output queue control register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_OQ_CTL_CR {
         union {
            struct { 
               u32 voq_fcmap_u2 : 6;              // DWORD 0
               u32 voq_fcmap_u1 : 6;              // DWORD 0
               u32 voq_fcmap_u0 : 6;              // DWORD 0
               u32 ack_hold_thresh : 5;           // DWORD 0
               u32 voq_ulp2_wrr : 3;              // DWORD 0
               u32 voq_ulp1_wrr : 3;              // DWORD 0
               u32 voq_ulp0_wrr : 3;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_OQ_CTL_CR, *PTPRE_OQ_CTL_CR;

      SG_C_ASSERT(__sizeof__TPRE_OQ_CTL_CR, sizeof (TPRE_OQ_CTL_CR) == 4);

   #else
      typedef struct _TPRE_OQ_CTL_CR {
         u32 voq_fcmap_u2 : 6;                    // DWORD 0
         u32 voq_fcmap_u1 : 6;                    // DWORD 0
         u32 voq_fcmap_u0 : 6;                    // DWORD 0
         u32 ack_hold_thresh : 5;                 // DWORD 0
         u32 voq_ulp2_wrr : 3;                    // DWORD 0
         u32 voq_ulp1_wrr : 3;                    // DWORD 0
         u32 voq_ulp0_wrr : 3;                    // DWORD 0
      } SG_PACK TPRE_OQ_CTL_CR, *PTPRE_OQ_CTL_CR;

      typedef union _TPRE_OQ_CTL_CR_UNION {
         TPRE_OQ_CTL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_OQ_CTL_CR_UNION, *PTPRE_OQ_CTL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_OQ_CTL_CR_UNION, sizeof (TPRE_OQ_CTL_CR_UNION) == 4);
   #endif


#else
   // TPRE output queue control register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_OQ_CTL_CR {
         union {
            struct { 
               u32 voq_ulp0_wrr : 3;              // DWORD 0
               u32 voq_ulp1_wrr : 3;              // DWORD 0
               u32 voq_ulp2_wrr : 3;              // DWORD 0
               u32 ack_hold_thresh : 5;           // DWORD 0
               u32 voq_fcmap_u0 : 6;              // DWORD 0
               u32 voq_fcmap_u1 : 6;              // DWORD 0
               u32 voq_fcmap_u2 : 6;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_OQ_CTL_CR, *PTPRE_OQ_CTL_CR;

      SG_C_ASSERT(__sizeof__TPRE_OQ_CTL_CR, sizeof (TPRE_OQ_CTL_CR) == 4);

   #else
      typedef struct _TPRE_OQ_CTL_CR {
         u32 voq_ulp0_wrr : 3;                    // DWORD 0
         u32 voq_ulp1_wrr : 3;                    // DWORD 0
         u32 voq_ulp2_wrr : 3;                    // DWORD 0
         u32 ack_hold_thresh : 5;                 // DWORD 0
         u32 voq_fcmap_u0 : 6;                    // DWORD 0
         u32 voq_fcmap_u1 : 6;                    // DWORD 0
         u32 voq_fcmap_u2 : 6;                    // DWORD 0
      } SG_PACK TPRE_OQ_CTL_CR, *PTPRE_OQ_CTL_CR;

      typedef union _TPRE_OQ_CTL_CR_UNION {
         TPRE_OQ_CTL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_OQ_CTL_CR_UNION, *PTPRE_OQ_CTL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_OQ_CTL_CR_UNION, sizeof (TPRE_OQ_CTL_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for accessing the TPRE's classification instructionRAM and
   // classification and header alignment config registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_COPROCESSOR_CR {
         union {
            struct { 
               u32 halign_queues : 8;             // DWORD 0
               u32 class_queues : 8;              // DWORD 0
               u32 class_const_addr : 4;          // DWORD 0
               u32 class_en : 1;                  // DWORD 0
               u32 class_const_wr : 1;            // DWORD 0
               u32 class_iram_wr : 1;             // DWORD 0
               u32 class_iaddr : 9;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_COPROCESSOR_CR, *PTPRE_COPROCESSOR_CR;

      SG_C_ASSERT(__sizeof__TPRE_COPROCESSOR_CR, sizeof (TPRE_COPROCESSOR_CR) == 4);

   #else
      typedef struct _TPRE_COPROCESSOR_CR {
         u32 halign_queues : 8;                   // DWORD 0
         u32 class_queues : 8;                    // DWORD 0
         u32 class_const_addr : 4;                // DWORD 0
         u32 class_en : 1;                        // DWORD 0
         u32 class_const_wr : 1;                  // DWORD 0
         u32 class_iram_wr : 1;                   // DWORD 0
         u32 class_iaddr : 9;                     // DWORD 0
      } SG_PACK TPRE_COPROCESSOR_CR, *PTPRE_COPROCESSOR_CR;

      typedef union _TPRE_COPROCESSOR_CR_UNION {
         TPRE_COPROCESSOR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_COPROCESSOR_CR_UNION, *PTPRE_COPROCESSOR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_COPROCESSOR_CR_UNION, sizeof (TPRE_COPROCESSOR_CR_UNION) == 4);
   #endif


#else
   // Control register for accessing the TPRE's classification instructionRAM and
   // classification and header alignment config registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_COPROCESSOR_CR {
         union {
            struct { 
               u32 class_iaddr : 9;               // DWORD 0
               u32 class_iram_wr : 1;             // DWORD 0
               u32 class_const_wr : 1;            // DWORD 0
               u32 class_en : 1;                  // DWORD 0
               u32 class_const_addr : 4;          // DWORD 0
               u32 class_queues : 8;              // DWORD 0
               u32 halign_queues : 8;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_COPROCESSOR_CR, *PTPRE_COPROCESSOR_CR;

      SG_C_ASSERT(__sizeof__TPRE_COPROCESSOR_CR, sizeof (TPRE_COPROCESSOR_CR) == 4);

   #else
      typedef struct _TPRE_COPROCESSOR_CR {
         u32 class_iaddr : 9;                     // DWORD 0
         u32 class_iram_wr : 1;                   // DWORD 0
         u32 class_const_wr : 1;                  // DWORD 0
         u32 class_en : 1;                        // DWORD 0
         u32 class_const_addr : 4;                // DWORD 0
         u32 class_queues : 8;                    // DWORD 0
         u32 halign_queues : 8;                   // DWORD 0
      } SG_PACK TPRE_COPROCESSOR_CR, *PTPRE_COPROCESSOR_CR;

      typedef union _TPRE_COPROCESSOR_CR_UNION {
         TPRE_COPROCESSOR_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_COPROCESSOR_CR_UNION, *PTPRE_COPROCESSOR_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_COPROCESSOR_CR_UNION, sizeof (TPRE_COPROCESSOR_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register may be used to configure the classification module execution to reduce
   // the number of required instructions. It controls the classification start address
   // for both context and header loads, and allows a fixed number of clocks after loading
   // is complete for predicates and classification bits to propagate. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_CONTROL_CR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 dsc_end_addr : 7;              // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 extend : 4;                    // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 dsc_start_addr : 7;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 ctx_start_addr : 7;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_CONTROL_CR, *PTPRE_CLASS_CONTROL_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONTROL_CR, sizeof (TPRE_CLASS_CONTROL_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_CONTROL_CR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 dsc_end_addr : 7;                    // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 extend : 4;                          // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 dsc_start_addr : 7;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 ctx_start_addr : 7;                  // DWORD 0
      } SG_PACK TPRE_CLASS_CONTROL_CR, *PTPRE_CLASS_CONTROL_CR;

      typedef union _TPRE_CLASS_CONTROL_CR_UNION {
         TPRE_CLASS_CONTROL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_CONTROL_CR_UNION, *PTPRE_CLASS_CONTROL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONTROL_CR_UNION, sizeof (TPRE_CLASS_CONTROL_CR_UNION) == 4);
   #endif


#else
   // This register may be used to configure the classification module execution to reduce
   // the number of required instructions. It controls the classification start address
   // for both context and header loads, and allows a fixed number of clocks after loading
   // is complete for predicates and classification bits to propagate. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_CONTROL_CR {
         union {
            struct { 
               u32 ctx_start_addr : 7;            // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 dsc_start_addr : 7;            // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 extend : 4;                    // DWORD 0
               u32 rsvd2 : 4;                     // DWORD 0
               u32 dsc_end_addr : 7;              // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_CONTROL_CR, *PTPRE_CLASS_CONTROL_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONTROL_CR, sizeof (TPRE_CLASS_CONTROL_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_CONTROL_CR {
         u32 ctx_start_addr : 7;                  // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 dsc_start_addr : 7;                  // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 extend : 4;                          // DWORD 0
         u32 rsvd2 : 4;                           // DWORD 0
         u32 dsc_end_addr : 7;                    // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK TPRE_CLASS_CONTROL_CR, *PTPRE_CLASS_CONTROL_CR;

      typedef union _TPRE_CLASS_CONTROL_CR_UNION {
         TPRE_CLASS_CONTROL_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_CONTROL_CR_UNION, *PTPRE_CLASS_CONTROL_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONTROL_CR_UNION, sizeof (TPRE_CLASS_CONTROL_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is used to configure the jump vector location for the classification module
   // when a segment arrives. It selects the starting address in the classification
   // instruction memory based on which port the segment arrived. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_JUMP_MAP_1_CR {
         union {
            struct { 
               u32 p0_vector : 8;                 // DWORD 0
               u32 p1_vector : 8;                 // DWORD 0
               u32 p2_vector : 8;                 // DWORD 0
               u32 p3_vector : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR, *PTPRE_CLASS_JUMP_MAP_1_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_1_CR, sizeof (TPRE_CLASS_JUMP_MAP_1_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_JUMP_MAP_1_CR {
         u32 p0_vector : 8;                       // DWORD 0
         u32 p1_vector : 8;                       // DWORD 0
         u32 p2_vector : 8;                       // DWORD 0
         u32 p3_vector : 8;                       // DWORD 0
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR, *PTPRE_CLASS_JUMP_MAP_1_CR;

      typedef union _TPRE_CLASS_JUMP_MAP_1_CR_UNION {
         TPRE_CLASS_JUMP_MAP_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR_UNION, *PTPRE_CLASS_JUMP_MAP_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_1_CR_UNION, sizeof (TPRE_CLASS_JUMP_MAP_1_CR_UNION) == 4);
   #endif


#else
   // This is used to configure the jump vector location for the classification module
   // when a segment arrives. It selects the starting address in the classification
   // instruction memory based on which port the segment arrived. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_JUMP_MAP_1_CR {
         union {
            struct { 
               u32 p3_vector : 8;                 // DWORD 0
               u32 p2_vector : 8;                 // DWORD 0
               u32 p1_vector : 8;                 // DWORD 0
               u32 p0_vector : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR, *PTPRE_CLASS_JUMP_MAP_1_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_1_CR, sizeof (TPRE_CLASS_JUMP_MAP_1_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_JUMP_MAP_1_CR {
         u32 p3_vector : 8;                       // DWORD 0
         u32 p2_vector : 8;                       // DWORD 0
         u32 p1_vector : 8;                       // DWORD 0
         u32 p0_vector : 8;                       // DWORD 0
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR, *PTPRE_CLASS_JUMP_MAP_1_CR;

      typedef union _TPRE_CLASS_JUMP_MAP_1_CR_UNION {
         TPRE_CLASS_JUMP_MAP_1_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_JUMP_MAP_1_CR_UNION, *PTPRE_CLASS_JUMP_MAP_1_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_1_CR_UNION, sizeof (TPRE_CLASS_JUMP_MAP_1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is used to configure the jump vector location for the classification module
   // when a segment arrives. It selects the starting address in the classification
   // instruction memory based on which port the segment arrived. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_JUMP_MAP_2_CR {
         union {
            struct { 
               u32 p4_vector : 8;                 // DWORD 0
               u32 p5_vector : 8;                 // DWORD 0
               u32 p6_vector : 8;                 // DWORD 0
               u32 p7_vector : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR, *PTPRE_CLASS_JUMP_MAP_2_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_2_CR, sizeof (TPRE_CLASS_JUMP_MAP_2_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_JUMP_MAP_2_CR {
         u32 p4_vector : 8;                       // DWORD 0
         u32 p5_vector : 8;                       // DWORD 0
         u32 p6_vector : 8;                       // DWORD 0
         u32 p7_vector : 8;                       // DWORD 0
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR, *PTPRE_CLASS_JUMP_MAP_2_CR;

      typedef union _TPRE_CLASS_JUMP_MAP_2_CR_UNION {
         TPRE_CLASS_JUMP_MAP_2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR_UNION, *PTPRE_CLASS_JUMP_MAP_2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_2_CR_UNION, sizeof (TPRE_CLASS_JUMP_MAP_2_CR_UNION) == 4);
   #endif


#else
   // This is used to configure the jump vector location for the classification module
   // when a segment arrives. It selects the starting address in the classification
   // instruction memory based on which port the segment arrived. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_JUMP_MAP_2_CR {
         union {
            struct { 
               u32 p7_vector : 8;                 // DWORD 0
               u32 p6_vector : 8;                 // DWORD 0
               u32 p5_vector : 8;                 // DWORD 0
               u32 p4_vector : 8;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR, *PTPRE_CLASS_JUMP_MAP_2_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_2_CR, sizeof (TPRE_CLASS_JUMP_MAP_2_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_JUMP_MAP_2_CR {
         u32 p7_vector : 8;                       // DWORD 0
         u32 p6_vector : 8;                       // DWORD 0
         u32 p5_vector : 8;                       // DWORD 0
         u32 p4_vector : 8;                       // DWORD 0
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR, *PTPRE_CLASS_JUMP_MAP_2_CR;

      typedef union _TPRE_CLASS_JUMP_MAP_2_CR_UNION {
         TPRE_CLASS_JUMP_MAP_2_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_JUMP_MAP_2_CR_UNION, *PTPRE_CLASS_JUMP_MAP_2_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_JUMP_MAP_2_CR_UNION, sizeof (TPRE_CLASS_JUMP_MAP_2_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This is used to configure the PGA mapping in the classification module. It selects
   // which of the 31 classification bits each of the eight PGA result registers will be
   // mapped to. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_PGA_MAP_CR {
         union {
            struct { 
               u32 pga7_config : 4;               // DWORD 0
               u32 pga6_config : 4;               // DWORD 0
               u32 pga5_config : 4;               // DWORD 0
               u32 pga4_config : 4;               // DWORD 0
               u32 pga3_config : 4;               // DWORD 0
               u32 pga2_config : 4;               // DWORD 0
               u32 pga1_config : 4;               // DWORD 0
               u32 pga0_config : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_PGA_MAP_CR, *PTPRE_CLASS_PGA_MAP_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_PGA_MAP_CR, sizeof (TPRE_CLASS_PGA_MAP_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_PGA_MAP_CR {
         u32 pga7_config : 4;                     // DWORD 0
         u32 pga6_config : 4;                     // DWORD 0
         u32 pga5_config : 4;                     // DWORD 0
         u32 pga4_config : 4;                     // DWORD 0
         u32 pga3_config : 4;                     // DWORD 0
         u32 pga2_config : 4;                     // DWORD 0
         u32 pga1_config : 4;                     // DWORD 0
         u32 pga0_config : 4;                     // DWORD 0
      } SG_PACK TPRE_CLASS_PGA_MAP_CR, *PTPRE_CLASS_PGA_MAP_CR;

      typedef union _TPRE_CLASS_PGA_MAP_CR_UNION {
         TPRE_CLASS_PGA_MAP_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_PGA_MAP_CR_UNION, *PTPRE_CLASS_PGA_MAP_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_PGA_MAP_CR_UNION, sizeof (TPRE_CLASS_PGA_MAP_CR_UNION) == 4);
   #endif


#else
   // This is used to configure the PGA mapping in the classification module. It selects
   // which of the 31 classification bits each of the eight PGA result registers will be
   // mapped to. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_PGA_MAP_CR {
         union {
            struct { 
               u32 pga0_config : 4;               // DWORD 0
               u32 pga1_config : 4;               // DWORD 0
               u32 pga2_config : 4;               // DWORD 0
               u32 pga3_config : 4;               // DWORD 0
               u32 pga4_config : 4;               // DWORD 0
               u32 pga5_config : 4;               // DWORD 0
               u32 pga6_config : 4;               // DWORD 0
               u32 pga7_config : 4;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_PGA_MAP_CR, *PTPRE_CLASS_PGA_MAP_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_PGA_MAP_CR, sizeof (TPRE_CLASS_PGA_MAP_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_PGA_MAP_CR {
         u32 pga0_config : 4;                     // DWORD 0
         u32 pga1_config : 4;                     // DWORD 0
         u32 pga2_config : 4;                     // DWORD 0
         u32 pga3_config : 4;                     // DWORD 0
         u32 pga4_config : 4;                     // DWORD 0
         u32 pga5_config : 4;                     // DWORD 0
         u32 pga6_config : 4;                     // DWORD 0
         u32 pga7_config : 4;                     // DWORD 0
      } SG_PACK TPRE_CLASS_PGA_MAP_CR, *PTPRE_CLASS_PGA_MAP_CR;

      typedef union _TPRE_CLASS_PGA_MAP_CR_UNION {
         TPRE_CLASS_PGA_MAP_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_PGA_MAP_CR_UNION, *PTPRE_CLASS_PGA_MAP_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_PGA_MAP_CR_UNION, sizeof (TPRE_CLASS_PGA_MAP_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register allows the hardware definitions class bits to be overridden.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_DISABLE_MAP_CR {
         union {
            struct { 
               u32 class_disables;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR, *PTPRE_CLASS_DISABLE_MAP_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_DISABLE_MAP_CR, sizeof (TPRE_CLASS_DISABLE_MAP_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_DISABLE_MAP_CR {
         u32 class_disables;                      // DWORD 0
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR, *PTPRE_CLASS_DISABLE_MAP_CR;

      typedef union _TPRE_CLASS_DISABLE_MAP_CR_UNION {
         TPRE_CLASS_DISABLE_MAP_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR_UNION, *PTPRE_CLASS_DISABLE_MAP_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_DISABLE_MAP_CR_UNION, sizeof (TPRE_CLASS_DISABLE_MAP_CR_UNION) == 4);
   #endif


#else
   // This register allows the hardware definitions class bits to be overridden.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_DISABLE_MAP_CR {
         union {
            struct { 
               u32 class_disables;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR, *PTPRE_CLASS_DISABLE_MAP_CR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_DISABLE_MAP_CR, sizeof (TPRE_CLASS_DISABLE_MAP_CR) == 4);

   #else
      typedef struct _TPRE_CLASS_DISABLE_MAP_CR {
         u32 class_disables;                      // DWORD 0
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR, *PTPRE_CLASS_DISABLE_MAP_CR;

      typedef union _TPRE_CLASS_DISABLE_MAP_CR_UNION {
         TPRE_CLASS_DISABLE_MAP_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_DISABLE_MAP_CR_UNION, *PTPRE_CLASS_DISABLE_MAP_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_DISABLE_MAP_CR_UNION, sizeof (TPRE_CLASS_DISABLE_MAP_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction read/write data to the TPRE classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_IRAM_RWDATAL_CSR {
         union {
            struct { 
               u32 class_iram_datal;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR, *PTPRE_CLASS_IRAM_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAL_CSR, sizeof (TPRE_CLASS_IRAM_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_IRAM_RWDATAL_CSR {
         u32 class_iram_datal;                    // DWORD 0
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR, *PTPRE_CLASS_IRAM_RWDATAL_CSR;

      typedef union _TPRE_CLASS_IRAM_RWDATAL_CSR_UNION {
         TPRE_CLASS_IRAM_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR_UNION, *PTPRE_CLASS_IRAM_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAL_CSR_UNION, sizeof (TPRE_CLASS_IRAM_RWDATAL_CSR_UNION) == 4);
   #endif


#else
   // Instruction read/write data to the TPRE classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_IRAM_RWDATAL_CSR {
         union {
            struct { 
               u32 class_iram_datal;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR, *PTPRE_CLASS_IRAM_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAL_CSR, sizeof (TPRE_CLASS_IRAM_RWDATAL_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_IRAM_RWDATAL_CSR {
         u32 class_iram_datal;                    // DWORD 0
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR, *PTPRE_CLASS_IRAM_RWDATAL_CSR;

      typedef union _TPRE_CLASS_IRAM_RWDATAL_CSR_UNION {
         TPRE_CLASS_IRAM_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAL_CSR_UNION, *PTPRE_CLASS_IRAM_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAL_CSR_UNION, sizeof (TPRE_CLASS_IRAM_RWDATAL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction read/write data to the TPRE classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_IRAM_RWDATAU_CSR {
         union {
            struct { 
               u32 rsvd0 : 19;                    // DWORD 0
               u32 class_iram_datau : 13;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR, *PTPRE_CLASS_IRAM_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAU_CSR, sizeof (TPRE_CLASS_IRAM_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_IRAM_RWDATAU_CSR {
         u32 rsvd0 : 19;                          // DWORD 0
         u32 class_iram_datau : 13;               // DWORD 0
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR, *PTPRE_CLASS_IRAM_RWDATAU_CSR;

      typedef union _TPRE_CLASS_IRAM_RWDATAU_CSR_UNION {
         TPRE_CLASS_IRAM_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR_UNION, *PTPRE_CLASS_IRAM_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAU_CSR_UNION, sizeof (TPRE_CLASS_IRAM_RWDATAU_CSR_UNION) == 4);
   #endif


#else
   // Instruction read/write data to the TPRE classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_IRAM_RWDATAU_CSR {
         union {
            struct { 
               u32 class_iram_datau : 13;         // DWORD 0
               u32 rsvd0 : 19;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR, *PTPRE_CLASS_IRAM_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAU_CSR, sizeof (TPRE_CLASS_IRAM_RWDATAU_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_IRAM_RWDATAU_CSR {
         u32 class_iram_datau : 13;               // DWORD 0
         u32 rsvd0 : 19;                          // DWORD 0
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR, *PTPRE_CLASS_IRAM_RWDATAU_CSR;

      typedef union _TPRE_CLASS_IRAM_RWDATAU_CSR_UNION {
         TPRE_CLASS_IRAM_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_IRAM_RWDATAU_CSR_UNION, *PTPRE_CLASS_IRAM_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_IRAM_RWDATAU_CSR_UNION, sizeof (TPRE_CLASS_IRAM_RWDATAU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Read/Write data to the classification constant registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_CONST_RWDATA_CSR {
         union {
            struct { 
               u32 class_const_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR, *PTPRE_CLASS_CONST_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONST_RWDATA_CSR, sizeof (TPRE_CLASS_CONST_RWDATA_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_CONST_RWDATA_CSR {
         u32 class_const_data;                    // DWORD 0
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR, *PTPRE_CLASS_CONST_RWDATA_CSR;

      typedef union _TPRE_CLASS_CONST_RWDATA_CSR_UNION {
         TPRE_CLASS_CONST_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR_UNION, *PTPRE_CLASS_CONST_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONST_RWDATA_CSR_UNION, sizeof (TPRE_CLASS_CONST_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // Read/Write data to the classification constant registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CLASS_CONST_RWDATA_CSR {
         union {
            struct { 
               u32 class_const_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR, *PTPRE_CLASS_CONST_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONST_RWDATA_CSR, sizeof (TPRE_CLASS_CONST_RWDATA_CSR) == 4);

   #else
      typedef struct _TPRE_CLASS_CONST_RWDATA_CSR {
         u32 class_const_data;                    // DWORD 0
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR, *PTPRE_CLASS_CONST_RWDATA_CSR;

      typedef union _TPRE_CLASS_CONST_RWDATA_CSR_UNION {
         TPRE_CLASS_CONST_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_CLASS_CONST_RWDATA_CSR_UNION, *PTPRE_CLASS_CONST_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CLASS_CONST_RWDATA_CSR_UNION, sizeof (TPRE_CLASS_CONST_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE Unrecoverable Error Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE1_ENABLE_CR {
         union {
            struct { 
               u32 halign_overflow : 1;           // DWORD 0
               u32 iq_underflow : 1;              // DWORD 0
               u32 iq_overflow : 1;               // DWORD 0
               u32 vinq_sram_access_during_init : 1; // DWORD 0
               u32 vinq_read_error : 1;           // DWORD 0
               u32 vinq_write_error : 1;          // DWORD 0
               u32 vinq_wr_create_same_time : 1;  // DWORD 0
               u32 vinq_alloc_error : 1;          // DWORD 0
               u32 vinq_dealloc_error : 1;        // DWORD 0
               u32 vinq_underflow : 1;            // DWORD 0
               u32 vinq_overflow : 1;             // DWORD 0
               u32 ack_path_overflow : 1;         // DWORD 0
               u32 ack_path_underflow : 1;        // DWORD 0
               u32 ethernet_punt_overflow : 1;    // DWORD 0
               u32 ooo_jellm_overflow : 1;        // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 voq_sram_access_during_init : 1; // DWORD 0
               u32 pmem_bus_perr : 1;             // DWORD 0
               u32 ctx_bus_perr : 1;              // DWORD 0
               u32 ep_fram_perr : 1;              // DWORD 0
               u32 ep_sh_ram_perr : 1;            // DWORD 0
               u32 ep_y_bank_perr : 1;            // DWORD 0
               u32 ep_x_bank_perr : 1;            // DWORD 0
               u32 ep_stats_perr : 1;             // DWORD 0
               u32 ep_iram_perr : 1;              // DWORD 0
               u32 class_iram_perr : 1;           // DWORD 0
               u32 voq_perr : 1;                  // DWORD 0
               u32 vinq_perr : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE1_ENABLE_CR, *PTPRE_UE1_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPRE_UE1_ENABLE_CR, sizeof (TPRE_UE1_ENABLE_CR) == 4);

   #else
      typedef struct _TPRE_UE1_ENABLE_CR {
         u32 halign_overflow : 1;                 // DWORD 0
         u32 iq_underflow : 1;                    // DWORD 0
         u32 iq_overflow : 1;                     // DWORD 0
         u32 vinq_sram_access_during_init : 1;    // DWORD 0
         u32 vinq_read_error : 1;                 // DWORD 0
         u32 vinq_write_error : 1;                // DWORD 0
         u32 vinq_wr_create_same_time : 1;        // DWORD 0
         u32 vinq_alloc_error : 1;                // DWORD 0
         u32 vinq_dealloc_error : 1;              // DWORD 0
         u32 vinq_underflow : 1;                  // DWORD 0
         u32 vinq_overflow : 1;                   // DWORD 0
         u32 ack_path_overflow : 1;               // DWORD 0
         u32 ack_path_underflow : 1;              // DWORD 0
         u32 ethernet_punt_overflow : 1;          // DWORD 0
         u32 ooo_jellm_overflow : 1;              // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 voq_sram_access_during_init : 1;     // DWORD 0
         u32 pmem_bus_perr : 1;                   // DWORD 0
         u32 ctx_bus_perr : 1;                    // DWORD 0
         u32 ep_fram_perr : 1;                    // DWORD 0
         u32 ep_sh_ram_perr : 1;                  // DWORD 0
         u32 ep_y_bank_perr : 1;                  // DWORD 0
         u32 ep_x_bank_perr : 1;                  // DWORD 0
         u32 ep_stats_perr : 1;                   // DWORD 0
         u32 ep_iram_perr : 1;                    // DWORD 0
         u32 class_iram_perr : 1;                 // DWORD 0
         u32 voq_perr : 1;                        // DWORD 0
         u32 vinq_perr : 1;                       // DWORD 0
      } SG_PACK TPRE_UE1_ENABLE_CR, *PTPRE_UE1_ENABLE_CR;

      typedef union _TPRE_UE1_ENABLE_CR_UNION {
         TPRE_UE1_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE1_ENABLE_CR_UNION, *PTPRE_UE1_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE1_ENABLE_CR_UNION, sizeof (TPRE_UE1_ENABLE_CR_UNION) == 4);
   #endif


#else
   // TPRE Unrecoverable Error Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE1_ENABLE_CR {
         union {
            struct { 
               u32 vinq_perr : 1;                 // DWORD 0
               u32 voq_perr : 1;                  // DWORD 0
               u32 class_iram_perr : 1;           // DWORD 0
               u32 ep_iram_perr : 1;              // DWORD 0
               u32 ep_stats_perr : 1;             // DWORD 0
               u32 ep_x_bank_perr : 1;            // DWORD 0
               u32 ep_y_bank_perr : 1;            // DWORD 0
               u32 ep_sh_ram_perr : 1;            // DWORD 0
               u32 ep_fram_perr : 1;              // DWORD 0
               u32 ctx_bus_perr : 1;              // DWORD 0
               u32 pmem_bus_perr : 1;             // DWORD 0
               u32 voq_sram_access_during_init : 1; // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ooo_jellm_overflow : 1;        // DWORD 0
               u32 ethernet_punt_overflow : 1;    // DWORD 0
               u32 ack_path_underflow : 1;        // DWORD 0
               u32 ack_path_overflow : 1;         // DWORD 0
               u32 vinq_overflow : 1;             // DWORD 0
               u32 vinq_underflow : 1;            // DWORD 0
               u32 vinq_dealloc_error : 1;        // DWORD 0
               u32 vinq_alloc_error : 1;          // DWORD 0
               u32 vinq_wr_create_same_time : 1;  // DWORD 0
               u32 vinq_write_error : 1;          // DWORD 0
               u32 vinq_read_error : 1;           // DWORD 0
               u32 vinq_sram_access_during_init : 1; // DWORD 0
               u32 iq_overflow : 1;               // DWORD 0
               u32 iq_underflow : 1;              // DWORD 0
               u32 halign_overflow : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE1_ENABLE_CR, *PTPRE_UE1_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPRE_UE1_ENABLE_CR, sizeof (TPRE_UE1_ENABLE_CR) == 4);

   #else
      typedef struct _TPRE_UE1_ENABLE_CR {
         u32 vinq_perr : 1;                       // DWORD 0
         u32 voq_perr : 1;                        // DWORD 0
         u32 class_iram_perr : 1;                 // DWORD 0
         u32 ep_iram_perr : 1;                    // DWORD 0
         u32 ep_stats_perr : 1;                   // DWORD 0
         u32 ep_x_bank_perr : 1;                  // DWORD 0
         u32 ep_y_bank_perr : 1;                  // DWORD 0
         u32 ep_sh_ram_perr : 1;                  // DWORD 0
         u32 ep_fram_perr : 1;                    // DWORD 0
         u32 ctx_bus_perr : 1;                    // DWORD 0
         u32 pmem_bus_perr : 1;                   // DWORD 0
         u32 voq_sram_access_during_init : 1;     // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ooo_jellm_overflow : 1;              // DWORD 0
         u32 ethernet_punt_overflow : 1;          // DWORD 0
         u32 ack_path_underflow : 1;              // DWORD 0
         u32 ack_path_overflow : 1;               // DWORD 0
         u32 vinq_overflow : 1;                   // DWORD 0
         u32 vinq_underflow : 1;                  // DWORD 0
         u32 vinq_dealloc_error : 1;              // DWORD 0
         u32 vinq_alloc_error : 1;                // DWORD 0
         u32 vinq_wr_create_same_time : 1;        // DWORD 0
         u32 vinq_write_error : 1;                // DWORD 0
         u32 vinq_read_error : 1;                 // DWORD 0
         u32 vinq_sram_access_during_init : 1;    // DWORD 0
         u32 iq_overflow : 1;                     // DWORD 0
         u32 iq_underflow : 1;                    // DWORD 0
         u32 halign_overflow : 1;                 // DWORD 0
      } SG_PACK TPRE_UE1_ENABLE_CR, *PTPRE_UE1_ENABLE_CR;

      typedef union _TPRE_UE1_ENABLE_CR_UNION {
         TPRE_UE1_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE1_ENABLE_CR_UNION, *PTPRE_UE1_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE1_ENABLE_CR_UNION, sizeof (TPRE_UE1_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE Unrecoverable Error Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE2_ENABLE_CR {
         union {
            struct { 
               u32 fw_src_err : 1;                // DWORD 0
               u32 vinq_poke_err : 1;             // DWORD 0
               u32 lro_timer_fifo_overflow : 1;   // DWORD 0
               u32 ack_post_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_overflow : 1; // DWORD 0
               u32 dbcred_ue_status : 1;          // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 retrans_jellm_overflow : 1;    // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_unlop_un_err : 1;           // DWORD 0
               u32 ep_unlop_ov_err : 1;           // DWORD 0
               u32 ep_fram_woor : 1;              // DWORD 0
               u32 ep_iram_woor : 1;              // DWORD 0
               u32 voq_wrid_err : 1;              // DWORD 0
               u32 voq_2small_desc : 1;           // DWORD 0
               u32 voq_2big_desc : 1;             // DWORD 0
               u32 voq_sof_err : 1;               // DWORD 0
               u32 voq_eof_err : 1;               // DWORD 0
               u32 voq_q2_underflow : 1;          // DWORD 0
               u32 voq_q1_underflow : 1;          // DWORD 0
               u32 voq_q0_underflow : 1;          // DWORD 0
               u32 voq_req_err : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE2_ENABLE_CR, *PTPRE_UE2_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPRE_UE2_ENABLE_CR, sizeof (TPRE_UE2_ENABLE_CR) == 4);

   #else
      typedef struct _TPRE_UE2_ENABLE_CR {
         u32 fw_src_err : 1;                      // DWORD 0
         u32 vinq_poke_err : 1;                   // DWORD 0
         u32 lro_timer_fifo_overflow : 1;         // DWORD 0
         u32 ack_post_cdr_fifo_underflow : 1;     // DWORD 0
         u32 ack_post_cdr_fifo_overflow : 1;      // DWORD 0
         u32 ack_pre_cdr_fifo_underflow : 1;      // DWORD 0
         u32 ack_pre_cdr_fifo_overflow : 1;       // DWORD 0
         u32 dbcred_ue_status : 1;                // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 retrans_jellm_overflow : 1;          // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_unlop_un_err : 1;                 // DWORD 0
         u32 ep_unlop_ov_err : 1;                 // DWORD 0
         u32 ep_fram_woor : 1;                    // DWORD 0
         u32 ep_iram_woor : 1;                    // DWORD 0
         u32 voq_wrid_err : 1;                    // DWORD 0
         u32 voq_2small_desc : 1;                 // DWORD 0
         u32 voq_2big_desc : 1;                   // DWORD 0
         u32 voq_sof_err : 1;                     // DWORD 0
         u32 voq_eof_err : 1;                     // DWORD 0
         u32 voq_q2_underflow : 1;                // DWORD 0
         u32 voq_q1_underflow : 1;                // DWORD 0
         u32 voq_q0_underflow : 1;                // DWORD 0
         u32 voq_req_err : 1;                     // DWORD 0
      } SG_PACK TPRE_UE2_ENABLE_CR, *PTPRE_UE2_ENABLE_CR;

      typedef union _TPRE_UE2_ENABLE_CR_UNION {
         TPRE_UE2_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE2_ENABLE_CR_UNION, *PTPRE_UE2_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE2_ENABLE_CR_UNION, sizeof (TPRE_UE2_ENABLE_CR_UNION) == 4);
   #endif


#else
   // TPRE Unrecoverable Error Enable Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE2_ENABLE_CR {
         union {
            struct { 
               u32 voq_req_err : 1;               // DWORD 0
               u32 voq_q0_underflow : 1;          // DWORD 0
               u32 voq_q1_underflow : 1;          // DWORD 0
               u32 voq_q2_underflow : 1;          // DWORD 0
               u32 voq_eof_err : 1;               // DWORD 0
               u32 voq_sof_err : 1;               // DWORD 0
               u32 voq_2big_desc : 1;             // DWORD 0
               u32 voq_2small_desc : 1;           // DWORD 0
               u32 voq_wrid_err : 1;              // DWORD 0
               u32 ep_iram_woor : 1;              // DWORD 0
               u32 ep_fram_woor : 1;              // DWORD 0
               u32 ep_unlop_ov_err : 1;           // DWORD 0
               u32 ep_unlop_un_err : 1;           // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 retrans_jellm_overflow : 1;    // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 dbcred_ue_status : 1;          // DWORD 0
               u32 ack_pre_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_underflow : 1; // DWORD 0
               u32 lro_timer_fifo_overflow : 1;   // DWORD 0
               u32 vinq_poke_err : 1;             // DWORD 0
               u32 fw_src_err : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE2_ENABLE_CR, *PTPRE_UE2_ENABLE_CR;

      SG_C_ASSERT(__sizeof__TPRE_UE2_ENABLE_CR, sizeof (TPRE_UE2_ENABLE_CR) == 4);

   #else
      typedef struct _TPRE_UE2_ENABLE_CR {
         u32 voq_req_err : 1;                     // DWORD 0
         u32 voq_q0_underflow : 1;                // DWORD 0
         u32 voq_q1_underflow : 1;                // DWORD 0
         u32 voq_q2_underflow : 1;                // DWORD 0
         u32 voq_eof_err : 1;                     // DWORD 0
         u32 voq_sof_err : 1;                     // DWORD 0
         u32 voq_2big_desc : 1;                   // DWORD 0
         u32 voq_2small_desc : 1;                 // DWORD 0
         u32 voq_wrid_err : 1;                    // DWORD 0
         u32 ep_iram_woor : 1;                    // DWORD 0
         u32 ep_fram_woor : 1;                    // DWORD 0
         u32 ep_unlop_ov_err : 1;                 // DWORD 0
         u32 ep_unlop_un_err : 1;                 // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 retrans_jellm_overflow : 1;          // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 dbcred_ue_status : 1;                // DWORD 0
         u32 ack_pre_cdr_fifo_overflow : 1;       // DWORD 0
         u32 ack_pre_cdr_fifo_underflow : 1;      // DWORD 0
         u32 ack_post_cdr_fifo_overflow : 1;      // DWORD 0
         u32 ack_post_cdr_fifo_underflow : 1;     // DWORD 0
         u32 lro_timer_fifo_overflow : 1;         // DWORD 0
         u32 vinq_poke_err : 1;                   // DWORD 0
         u32 fw_src_err : 1;                      // DWORD 0
      } SG_PACK TPRE_UE2_ENABLE_CR, *PTPRE_UE2_ENABLE_CR;

      typedef union _TPRE_UE2_ENABLE_CR_UNION {
         TPRE_UE2_ENABLE_CR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE2_ENABLE_CR_UNION, *PTPRE_UE2_ENABLE_CR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE2_ENABLE_CR_UNION, sizeof (TPRE_UE2_ENABLE_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register indicates the cause of a parity or other unrecoverable errors.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE1_SOURCE_SR {
         union {
            struct { 
               u32 halign_overflow : 1;           // DWORD 0
               u32 iq_underflow : 1;              // DWORD 0
               u32 iq_overflow : 1;               // DWORD 0
               u32 vinq_sram_access_during_init : 1; // DWORD 0
               u32 vinq_read_error : 1;           // DWORD 0
               u32 vinq_write_error : 1;          // DWORD 0
               u32 vinq_wr_create_same_time : 1;  // DWORD 0
               u32 vinq_alloc_error : 1;          // DWORD 0
               u32 vinq_dealloc_error : 1;        // DWORD 0
               u32 vinq_underflow : 1;            // DWORD 0
               u32 vinq_overflow : 1;             // DWORD 0
               u32 ack_path_overflow : 1;         // DWORD 0
               u32 ack_path_underflow : 1;        // DWORD 0
               u32 ethernet_punt_overflow : 1;    // DWORD 0
               u32 ooo_jellm_overflow : 1;        // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 voq_sram_access_during_init : 1; // DWORD 0
               u32 pmem_bus_perr : 1;             // DWORD 0
               u32 ctx_bus_perr : 1;              // DWORD 0
               u32 ep_fram_perr : 1;              // DWORD 0
               u32 ep_sh_ram_perr : 1;            // DWORD 0
               u32 ep_y_bank_perr : 1;            // DWORD 0
               u32 ep_x_bank_perr : 1;            // DWORD 0
               u32 ep_stats_perr : 1;             // DWORD 0
               u32 ep_iram_perr : 1;              // DWORD 0
               u32 class_iram_perr : 1;           // DWORD 0
               u32 voq_perr : 1;                  // DWORD 0
               u32 vinq_perr : 1;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE1_SOURCE_SR, *PTPRE_UE1_SOURCE_SR;

      SG_C_ASSERT(__sizeof__TPRE_UE1_SOURCE_SR, sizeof (TPRE_UE1_SOURCE_SR) == 4);

   #else
      typedef struct _TPRE_UE1_SOURCE_SR {
         u32 halign_overflow : 1;                 // DWORD 0
         u32 iq_underflow : 1;                    // DWORD 0
         u32 iq_overflow : 1;                     // DWORD 0
         u32 vinq_sram_access_during_init : 1;    // DWORD 0
         u32 vinq_read_error : 1;                 // DWORD 0
         u32 vinq_write_error : 1;                // DWORD 0
         u32 vinq_wr_create_same_time : 1;        // DWORD 0
         u32 vinq_alloc_error : 1;                // DWORD 0
         u32 vinq_dealloc_error : 1;              // DWORD 0
         u32 vinq_underflow : 1;                  // DWORD 0
         u32 vinq_overflow : 1;                   // DWORD 0
         u32 ack_path_overflow : 1;               // DWORD 0
         u32 ack_path_underflow : 1;              // DWORD 0
         u32 ethernet_punt_overflow : 1;          // DWORD 0
         u32 ooo_jellm_overflow : 1;              // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 voq_sram_access_during_init : 1;     // DWORD 0
         u32 pmem_bus_perr : 1;                   // DWORD 0
         u32 ctx_bus_perr : 1;                    // DWORD 0
         u32 ep_fram_perr : 1;                    // DWORD 0
         u32 ep_sh_ram_perr : 1;                  // DWORD 0
         u32 ep_y_bank_perr : 1;                  // DWORD 0
         u32 ep_x_bank_perr : 1;                  // DWORD 0
         u32 ep_stats_perr : 1;                   // DWORD 0
         u32 ep_iram_perr : 1;                    // DWORD 0
         u32 class_iram_perr : 1;                 // DWORD 0
         u32 voq_perr : 1;                        // DWORD 0
         u32 vinq_perr : 1;                       // DWORD 0
      } SG_PACK TPRE_UE1_SOURCE_SR, *PTPRE_UE1_SOURCE_SR;

      typedef union _TPRE_UE1_SOURCE_SR_UNION {
         TPRE_UE1_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE1_SOURCE_SR_UNION, *PTPRE_UE1_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE1_SOURCE_SR_UNION, sizeof (TPRE_UE1_SOURCE_SR_UNION) == 4);
   #endif


#else
   // This register indicates the cause of a parity or other unrecoverable errors.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE1_SOURCE_SR {
         union {
            struct { 
               u32 vinq_perr : 1;                 // DWORD 0
               u32 voq_perr : 1;                  // DWORD 0
               u32 class_iram_perr : 1;           // DWORD 0
               u32 ep_iram_perr : 1;              // DWORD 0
               u32 ep_stats_perr : 1;             // DWORD 0
               u32 ep_x_bank_perr : 1;            // DWORD 0
               u32 ep_y_bank_perr : 1;            // DWORD 0
               u32 ep_sh_ram_perr : 1;            // DWORD 0
               u32 ep_fram_perr : 1;              // DWORD 0
               u32 ctx_bus_perr : 1;              // DWORD 0
               u32 pmem_bus_perr : 1;             // DWORD 0
               u32 voq_sram_access_during_init : 1; // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_rdq_overflow : 1;          // DWORD 0
               u32 ipc_rdq_underflow : 1;         // DWORD 0
               u32 ooo_jellm_overflow : 1;        // DWORD 0
               u32 ethernet_punt_overflow : 1;    // DWORD 0
               u32 ack_path_underflow : 1;        // DWORD 0
               u32 ack_path_overflow : 1;         // DWORD 0
               u32 vinq_overflow : 1;             // DWORD 0
               u32 vinq_underflow : 1;            // DWORD 0
               u32 vinq_dealloc_error : 1;        // DWORD 0
               u32 vinq_alloc_error : 1;          // DWORD 0
               u32 vinq_wr_create_same_time : 1;  // DWORD 0
               u32 vinq_write_error : 1;          // DWORD 0
               u32 vinq_read_error : 1;           // DWORD 0
               u32 vinq_sram_access_during_init : 1; // DWORD 0
               u32 iq_overflow : 1;               // DWORD 0
               u32 iq_underflow : 1;              // DWORD 0
               u32 halign_overflow : 1;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE1_SOURCE_SR, *PTPRE_UE1_SOURCE_SR;

      SG_C_ASSERT(__sizeof__TPRE_UE1_SOURCE_SR, sizeof (TPRE_UE1_SOURCE_SR) == 4);

   #else
      typedef struct _TPRE_UE1_SOURCE_SR {
         u32 vinq_perr : 1;                       // DWORD 0
         u32 voq_perr : 1;                        // DWORD 0
         u32 class_iram_perr : 1;                 // DWORD 0
         u32 ep_iram_perr : 1;                    // DWORD 0
         u32 ep_stats_perr : 1;                   // DWORD 0
         u32 ep_x_bank_perr : 1;                  // DWORD 0
         u32 ep_y_bank_perr : 1;                  // DWORD 0
         u32 ep_sh_ram_perr : 1;                  // DWORD 0
         u32 ep_fram_perr : 1;                    // DWORD 0
         u32 ctx_bus_perr : 1;                    // DWORD 0
         u32 pmem_bus_perr : 1;                   // DWORD 0
         u32 voq_sram_access_during_init : 1;     // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_rdq_overflow : 1;                // DWORD 0
         u32 ipc_rdq_underflow : 1;               // DWORD 0
         u32 ooo_jellm_overflow : 1;              // DWORD 0
         u32 ethernet_punt_overflow : 1;          // DWORD 0
         u32 ack_path_underflow : 1;              // DWORD 0
         u32 ack_path_overflow : 1;               // DWORD 0
         u32 vinq_overflow : 1;                   // DWORD 0
         u32 vinq_underflow : 1;                  // DWORD 0
         u32 vinq_dealloc_error : 1;              // DWORD 0
         u32 vinq_alloc_error : 1;                // DWORD 0
         u32 vinq_wr_create_same_time : 1;        // DWORD 0
         u32 vinq_write_error : 1;                // DWORD 0
         u32 vinq_read_error : 1;                 // DWORD 0
         u32 vinq_sram_access_during_init : 1;    // DWORD 0
         u32 iq_overflow : 1;                     // DWORD 0
         u32 iq_underflow : 1;                    // DWORD 0
         u32 halign_overflow : 1;                 // DWORD 0
      } SG_PACK TPRE_UE1_SOURCE_SR, *PTPRE_UE1_SOURCE_SR;

      typedef union _TPRE_UE1_SOURCE_SR_UNION {
         TPRE_UE1_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE1_SOURCE_SR_UNION, *PTPRE_UE1_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE1_SOURCE_SR_UNION, sizeof (TPRE_UE1_SOURCE_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register indicates the cause of a parity or other unrecoverable errors.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE2_SOURCE_SR {
         union {
            struct { 
               u32 fw_src_err : 1;                // DWORD 0
               u32 vinq_poke_err : 1;             // DWORD 0
               u32 lro_timer_fifo_overflow : 1;   // DWORD 0
               u32 ack_post_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_overflow : 1; // DWORD 0
               u32 dbcred_ue : 1;                 // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 retrans_jellm_overflow : 1;    // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_unlop_un_err : 1;           // DWORD 0
               u32 ep_unlop_ov_err : 1;           // DWORD 0
               u32 ep_fram_woor : 1;              // DWORD 0
               u32 ep_iram_woor : 1;              // DWORD 0
               u32 voq_wrid_err : 1;              // DWORD 0
               u32 voq_2small_desc : 1;           // DWORD 0
               u32 voq_2big_desc : 1;             // DWORD 0
               u32 voq_sof_err : 1;               // DWORD 0
               u32 voq_eof_err : 1;               // DWORD 0
               u32 voq_q2_underflow : 1;          // DWORD 0
               u32 voq_q1_underflow : 1;          // DWORD 0
               u32 voq_q0_underflow : 1;          // DWORD 0
               u32 voq_req_err : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE2_SOURCE_SR, *PTPRE_UE2_SOURCE_SR;

      SG_C_ASSERT(__sizeof__TPRE_UE2_SOURCE_SR, sizeof (TPRE_UE2_SOURCE_SR) == 4);

   #else
      typedef struct _TPRE_UE2_SOURCE_SR {
         u32 fw_src_err : 1;                      // DWORD 0
         u32 vinq_poke_err : 1;                   // DWORD 0
         u32 lro_timer_fifo_overflow : 1;         // DWORD 0
         u32 ack_post_cdr_fifo_underflow : 1;     // DWORD 0
         u32 ack_post_cdr_fifo_overflow : 1;      // DWORD 0
         u32 ack_pre_cdr_fifo_underflow : 1;      // DWORD 0
         u32 ack_pre_cdr_fifo_overflow : 1;       // DWORD 0
         u32 dbcred_ue : 1;                       // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 retrans_jellm_overflow : 1;          // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_unlop_un_err : 1;                 // DWORD 0
         u32 ep_unlop_ov_err : 1;                 // DWORD 0
         u32 ep_fram_woor : 1;                    // DWORD 0
         u32 ep_iram_woor : 1;                    // DWORD 0
         u32 voq_wrid_err : 1;                    // DWORD 0
         u32 voq_2small_desc : 1;                 // DWORD 0
         u32 voq_2big_desc : 1;                   // DWORD 0
         u32 voq_sof_err : 1;                     // DWORD 0
         u32 voq_eof_err : 1;                     // DWORD 0
         u32 voq_q2_underflow : 1;                // DWORD 0
         u32 voq_q1_underflow : 1;                // DWORD 0
         u32 voq_q0_underflow : 1;                // DWORD 0
         u32 voq_req_err : 1;                     // DWORD 0
      } SG_PACK TPRE_UE2_SOURCE_SR, *PTPRE_UE2_SOURCE_SR;

      typedef union _TPRE_UE2_SOURCE_SR_UNION {
         TPRE_UE2_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE2_SOURCE_SR_UNION, *PTPRE_UE2_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE2_SOURCE_SR_UNION, sizeof (TPRE_UE2_SOURCE_SR_UNION) == 4);
   #endif


#else
   // This register indicates the cause of a parity or other unrecoverable errors.
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_UE2_SOURCE_SR {
         union {
            struct { 
               u32 voq_req_err : 1;               // DWORD 0
               u32 voq_q0_underflow : 1;          // DWORD 0
               u32 voq_q1_underflow : 1;          // DWORD 0
               u32 voq_q2_underflow : 1;          // DWORD 0
               u32 voq_eof_err : 1;               // DWORD 0
               u32 voq_sof_err : 1;               // DWORD 0
               u32 voq_2big_desc : 1;             // DWORD 0
               u32 voq_2small_desc : 1;           // DWORD 0
               u32 voq_wrid_err : 1;              // DWORD 0
               u32 ep_iram_woor : 1;              // DWORD 0
               u32 ep_fram_woor : 1;              // DWORD 0
               u32 ep_unlop_ov_err : 1;           // DWORD 0
               u32 ep_unlop_un_err : 1;           // DWORD 0
               u32 ep_prefetch_ov_err : 1;        // DWORD 0
               u32 ep_prefetch_un_err : 1;        // DWORD 0
               u32 retrans_jellm_overflow : 1;    // DWORD 0
               u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
               u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
               u32 dbcred_ue : 1;                 // DWORD 0
               u32 ack_pre_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_pre_cdr_fifo_underflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_overflow : 1; // DWORD 0
               u32 ack_post_cdr_fifo_underflow : 1; // DWORD 0
               u32 lro_timer_fifo_overflow : 1;   // DWORD 0
               u32 vinq_poke_err : 1;             // DWORD 0
               u32 fw_src_err : 1;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_UE2_SOURCE_SR, *PTPRE_UE2_SOURCE_SR;

      SG_C_ASSERT(__sizeof__TPRE_UE2_SOURCE_SR, sizeof (TPRE_UE2_SOURCE_SR) == 4);

   #else
      typedef struct _TPRE_UE2_SOURCE_SR {
         u32 voq_req_err : 1;                     // DWORD 0
         u32 voq_q0_underflow : 1;                // DWORD 0
         u32 voq_q1_underflow : 1;                // DWORD 0
         u32 voq_q2_underflow : 1;                // DWORD 0
         u32 voq_eof_err : 1;                     // DWORD 0
         u32 voq_sof_err : 1;                     // DWORD 0
         u32 voq_2big_desc : 1;                   // DWORD 0
         u32 voq_2small_desc : 1;                 // DWORD 0
         u32 voq_wrid_err : 1;                    // DWORD 0
         u32 ep_iram_woor : 1;                    // DWORD 0
         u32 ep_fram_woor : 1;                    // DWORD 0
         u32 ep_unlop_ov_err : 1;                 // DWORD 0
         u32 ep_unlop_un_err : 1;                 // DWORD 0
         u32 ep_prefetch_ov_err : 1;              // DWORD 0
         u32 ep_prefetch_un_err : 1;              // DWORD 0
         u32 retrans_jellm_overflow : 1;          // DWORD 0
         u32 ep_m0_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_wbp_chk_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m0_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_overflow_error_status : 1; // DWORD 0
         u32 ep_m1_mem_write_back_que_underflow_error_status : 1; // DWORD 0
         u32 dbcred_ue : 1;                       // DWORD 0
         u32 ack_pre_cdr_fifo_overflow : 1;       // DWORD 0
         u32 ack_pre_cdr_fifo_underflow : 1;      // DWORD 0
         u32 ack_post_cdr_fifo_overflow : 1;      // DWORD 0
         u32 ack_post_cdr_fifo_underflow : 1;     // DWORD 0
         u32 lro_timer_fifo_overflow : 1;         // DWORD 0
         u32 vinq_poke_err : 1;                   // DWORD 0
         u32 fw_src_err : 1;                      // DWORD 0
      } SG_PACK TPRE_UE2_SOURCE_SR, *PTPRE_UE2_SOURCE_SR;

      typedef union _TPRE_UE2_SOURCE_SR_UNION {
         TPRE_UE2_SOURCE_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_UE2_SOURCE_SR_UNION, *PTPRE_UE2_SOURCE_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_UE2_SOURCE_SR_UNION, sizeof (TPRE_UE2_SOURCE_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE INPUT DEBUG: This register provides debug status for various TPRE input queue
   // related signals as defined in the TPRE_VINQ_DEBUG_0_SR through TPRE_VINQ_DEBUG_3_SR
   // register definitions below. The signals that are brought out are dependent upon the
   // value of the inq_dbg_sel field of the TPRE_DEBUG_CTL_CR register as shown. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_SR {
         union {
            struct { 
               u32 vinq_debug;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_SR, *PTPRE_VINQ_DEBUG_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_SR, sizeof (TPRE_VINQ_DEBUG_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_SR {
         u32 vinq_debug;                          // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_SR, *PTPRE_VINQ_DEBUG_SR;

      typedef union _TPRE_VINQ_DEBUG_SR_UNION {
         TPRE_VINQ_DEBUG_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_SR_UNION, *PTPRE_VINQ_DEBUG_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_SR_UNION, sizeof (TPRE_VINQ_DEBUG_SR_UNION) == 4);
   #endif


#else
   // TPRE INPUT DEBUG: This register provides debug status for various TPRE input queue
   // related signals as defined in the TPRE_VINQ_DEBUG_0_SR through TPRE_VINQ_DEBUG_3_SR
   // register definitions below. The signals that are brought out are dependent upon the
   // value of the inq_dbg_sel field of the TPRE_DEBUG_CTL_CR register as shown. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_SR {
         union {
            struct { 
               u32 vinq_debug;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_SR, *PTPRE_VINQ_DEBUG_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_SR, sizeof (TPRE_VINQ_DEBUG_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_SR {
         u32 vinq_debug;                          // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_SR, *PTPRE_VINQ_DEBUG_SR;

      typedef union _TPRE_VINQ_DEBUG_SR_UNION {
         TPRE_VINQ_DEBUG_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_SR_UNION, *PTPRE_VINQ_DEBUG_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_SR_UNION, sizeof (TPRE_VINQ_DEBUG_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE INPUT DEBUG - SEL 0: This register provides debug status for TPRE virtual input
   // queue related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_0_SR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 create_viq_process_done : 1;   // DWORD 0
               u32 viq_sraminit_over : 1;         // DWORD 0
               u32 viq_create_state : 4;          // DWORD 0
               u32 viq_free_count : 9;            // DWORD 0
               u32 viq_free_head : 8;             // DWORD 0
               u32 viq_free_tail : 8;             // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_0_SR, *PTPRE_VINQ_DEBUG_0_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_0_SR, sizeof (TPRE_VINQ_DEBUG_0_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_0_SR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 create_viq_process_done : 1;         // DWORD 0
         u32 viq_sraminit_over : 1;               // DWORD 0
         u32 viq_create_state : 4;                // DWORD 0
         u32 viq_free_count : 9;                  // DWORD 0
         u32 viq_free_head : 8;                   // DWORD 0
         u32 viq_free_tail : 8;                   // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_0_SR, *PTPRE_VINQ_DEBUG_0_SR;

      typedef union _TPRE_VINQ_DEBUG_0_SR_UNION {
         TPRE_VINQ_DEBUG_0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_0_SR_UNION, *PTPRE_VINQ_DEBUG_0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_0_SR_UNION, sizeof (TPRE_VINQ_DEBUG_0_SR_UNION) == 4);
   #endif


#else
   // TPRE INPUT DEBUG - SEL 0: This register provides debug status for TPRE virtual input
   // queue related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_0_SR {
         union {
            struct { 
               u32 viq_free_tail : 8;             // DWORD 0
               u32 viq_free_head : 8;             // DWORD 0
               u32 viq_free_count : 9;            // DWORD 0
               u32 viq_create_state : 4;          // DWORD 0
               u32 viq_sraminit_over : 1;         // DWORD 0
               u32 create_viq_process_done : 1;   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_0_SR, *PTPRE_VINQ_DEBUG_0_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_0_SR, sizeof (TPRE_VINQ_DEBUG_0_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_0_SR {
         u32 viq_free_tail : 8;                   // DWORD 0
         u32 viq_free_head : 8;                   // DWORD 0
         u32 viq_free_count : 9;                  // DWORD 0
         u32 viq_create_state : 4;                // DWORD 0
         u32 viq_sraminit_over : 1;               // DWORD 0
         u32 create_viq_process_done : 1;         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_0_SR, *PTPRE_VINQ_DEBUG_0_SR;

      typedef union _TPRE_VINQ_DEBUG_0_SR_UNION {
         TPRE_VINQ_DEBUG_0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_0_SR_UNION, *PTPRE_VINQ_DEBUG_0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_0_SR_UNION, sizeof (TPRE_VINQ_DEBUG_0_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE INPUT DEBUG - SEL 1: This register provides debug status for TPRE input queue
   // related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_1_SR {
         union {
            struct { 
               u32 iqarb_state : 3;               // DWORD 0
               u32 vq_state : 5;                  // DWORD 0
               u32 q7_entries : 4;                // DWORD 0
               u32 q6_entries : 3;                // DWORD 0
               u32 q5_entries : 3;                // DWORD 0
               u32 q4_entries : 5;                // DWORD 0
               u32 q3_entries : 3;                // DWORD 0
               u32 q2_entries : 3;                // DWORD 0
               u32 q1_entries : 3;                // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_1_SR, *PTPRE_VINQ_DEBUG_1_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_1_SR, sizeof (TPRE_VINQ_DEBUG_1_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_1_SR {
         u32 iqarb_state : 3;                     // DWORD 0
         u32 vq_state : 5;                        // DWORD 0
         u32 q7_entries : 4;                      // DWORD 0
         u32 q6_entries : 3;                      // DWORD 0
         u32 q5_entries : 3;                      // DWORD 0
         u32 q4_entries : 5;                      // DWORD 0
         u32 q3_entries : 3;                      // DWORD 0
         u32 q2_entries : 3;                      // DWORD 0
         u32 q1_entries : 3;                      // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_1_SR, *PTPRE_VINQ_DEBUG_1_SR;

      typedef union _TPRE_VINQ_DEBUG_1_SR_UNION {
         TPRE_VINQ_DEBUG_1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_1_SR_UNION, *PTPRE_VINQ_DEBUG_1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_1_SR_UNION, sizeof (TPRE_VINQ_DEBUG_1_SR_UNION) == 4);
   #endif


#else
   // TPRE INPUT DEBUG - SEL 1: This register provides debug status for TPRE input queue
   // related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_1_SR {
         union {
            struct { 
               u32 q1_entries : 3;                // DWORD 0
               u32 q2_entries : 3;                // DWORD 0
               u32 q3_entries : 3;                // DWORD 0
               u32 q4_entries : 5;                // DWORD 0
               u32 q5_entries : 3;                // DWORD 0
               u32 q6_entries : 3;                // DWORD 0
               u32 q7_entries : 4;                // DWORD 0
               u32 vq_state : 5;                  // DWORD 0
               u32 iqarb_state : 3;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_1_SR, *PTPRE_VINQ_DEBUG_1_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_1_SR, sizeof (TPRE_VINQ_DEBUG_1_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_1_SR {
         u32 q1_entries : 3;                      // DWORD 0
         u32 q2_entries : 3;                      // DWORD 0
         u32 q3_entries : 3;                      // DWORD 0
         u32 q4_entries : 5;                      // DWORD 0
         u32 q5_entries : 3;                      // DWORD 0
         u32 q6_entries : 3;                      // DWORD 0
         u32 q7_entries : 4;                      // DWORD 0
         u32 vq_state : 5;                        // DWORD 0
         u32 iqarb_state : 3;                     // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_1_SR, *PTPRE_VINQ_DEBUG_1_SR;

      typedef union _TPRE_VINQ_DEBUG_1_SR_UNION {
         TPRE_VINQ_DEBUG_1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_1_SR_UNION, *PTPRE_VINQ_DEBUG_1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_1_SR_UNION, sizeof (TPRE_VINQ_DEBUG_1_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE INPUT DEBUG - SEL 2: This register provides debug status for TPRE input queue
   // related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_2_SR {
         union {
            struct { 
               u32 vq_rclient_empty : 6;          // DWORD 0
               u32 vq_wclient_rdy : 6;            // DWORD 0
               u32 vq_man_ue_id : 2;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vinq_pe_address : 9;           // DWORD 0
               u32 overflow_id : 4;               // DWORD 0
               u32 underflow_id : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_2_SR, *PTPRE_VINQ_DEBUG_2_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_2_SR, sizeof (TPRE_VINQ_DEBUG_2_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_2_SR {
         u32 vq_rclient_empty : 6;                // DWORD 0
         u32 vq_wclient_rdy : 6;                  // DWORD 0
         u32 vq_man_ue_id : 2;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vinq_pe_address : 9;                 // DWORD 0
         u32 overflow_id : 4;                     // DWORD 0
         u32 underflow_id : 4;                    // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_2_SR, *PTPRE_VINQ_DEBUG_2_SR;

      typedef union _TPRE_VINQ_DEBUG_2_SR_UNION {
         TPRE_VINQ_DEBUG_2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_2_SR_UNION, *PTPRE_VINQ_DEBUG_2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_2_SR_UNION, sizeof (TPRE_VINQ_DEBUG_2_SR_UNION) == 4);
   #endif


#else
   // TPRE INPUT DEBUG - SEL 2: This register provides debug status for TPRE input queue
   // related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_2_SR {
         union {
            struct { 
               u32 underflow_id : 4;              // DWORD 0
               u32 overflow_id : 4;               // DWORD 0
               u32 vinq_pe_address : 9;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 vq_man_ue_id : 2;              // DWORD 0
               u32 vq_wclient_rdy : 6;            // DWORD 0
               u32 vq_rclient_empty : 6;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_2_SR, *PTPRE_VINQ_DEBUG_2_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_2_SR, sizeof (TPRE_VINQ_DEBUG_2_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_2_SR {
         u32 underflow_id : 4;                    // DWORD 0
         u32 overflow_id : 4;                     // DWORD 0
         u32 vinq_pe_address : 9;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 vq_man_ue_id : 2;                    // DWORD 0
         u32 vq_wclient_rdy : 6;                  // DWORD 0
         u32 vq_rclient_empty : 6;                // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_2_SR, *PTPRE_VINQ_DEBUG_2_SR;

      typedef union _TPRE_VINQ_DEBUG_2_SR_UNION {
         TPRE_VINQ_DEBUG_2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_2_SR_UNION, *PTPRE_VINQ_DEBUG_2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_2_SR_UNION, sizeof (TPRE_VINQ_DEBUG_2_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE INPUT DEBUG - SEL 3: 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_3_SR {
         union {
            struct { 
               u32 rsvd1 : 13;                    // DWORD 0
               u32 dbcred_error_id : 3;           // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 vq_err_id : 4;                 // DWORD 0
               u32 vq_underflow_id : 4;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_3_SR, *PTPRE_VINQ_DEBUG_3_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_3_SR, sizeof (TPRE_VINQ_DEBUG_3_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_3_SR {
         u32 rsvd1 : 13;                          // DWORD 0
         u32 dbcred_error_id : 3;                 // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 vq_err_id : 4;                       // DWORD 0
         u32 vq_underflow_id : 4;                 // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_3_SR, *PTPRE_VINQ_DEBUG_3_SR;

      typedef union _TPRE_VINQ_DEBUG_3_SR_UNION {
         TPRE_VINQ_DEBUG_3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_3_SR_UNION, *PTPRE_VINQ_DEBUG_3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_3_SR_UNION, sizeof (TPRE_VINQ_DEBUG_3_SR_UNION) == 4);
   #endif


#else
   // TPRE INPUT DEBUG - SEL 3: 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VINQ_DEBUG_3_SR {
         union {
            struct { 
               u32 vq_underflow_id : 4;           // DWORD 0
               u32 vq_err_id : 4;                 // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 dbcred_error_id : 3;           // DWORD 0
               u32 rsvd1 : 13;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VINQ_DEBUG_3_SR, *PTPRE_VINQ_DEBUG_3_SR;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_3_SR, sizeof (TPRE_VINQ_DEBUG_3_SR) == 4);

   #else
      typedef struct _TPRE_VINQ_DEBUG_3_SR {
         u32 vq_underflow_id : 4;                 // DWORD 0
         u32 vq_err_id : 4;                       // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 dbcred_error_id : 3;                 // DWORD 0
         u32 rsvd1 : 13;                          // DWORD 0
      } SG_PACK TPRE_VINQ_DEBUG_3_SR, *PTPRE_VINQ_DEBUG_3_SR;

      typedef union _TPRE_VINQ_DEBUG_3_SR_UNION {
         TPRE_VINQ_DEBUG_3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VINQ_DEBUG_3_SR_UNION, *PTPRE_VINQ_DEBUG_3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VINQ_DEBUG_3_SR_UNION, sizeof (TPRE_VINQ_DEBUG_3_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE OUTPUT DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. The signals that are brought out are dependent upon the
   // value of the oqs_dbg_sel field of the TPRE_DEBUG_CTL_CR register as shown. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_SR {
         union {
            struct { 
               u32 voq_debug;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_SR, *PTPRE_VOQ_DEBUG_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_SR, sizeof (TPRE_VOQ_DEBUG_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_SR {
         u32 voq_debug;                           // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_SR, *PTPRE_VOQ_DEBUG_SR;

      typedef union _TPRE_VOQ_DEBUG_SR_UNION {
         TPRE_VOQ_DEBUG_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_SR_UNION, *PTPRE_VOQ_DEBUG_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_SR_UNION, sizeof (TPRE_VOQ_DEBUG_SR_UNION) == 4);
   #endif


#else
   // TPRE OUTPUT DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. The signals that are brought out are dependent upon the
   // value of the oqs_dbg_sel field of the TPRE_DEBUG_CTL_CR register as shown. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_SR {
         union {
            struct { 
               u32 voq_debug;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_SR, *PTPRE_VOQ_DEBUG_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_SR, sizeof (TPRE_VOQ_DEBUG_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_SR {
         u32 voq_debug;                           // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_SR, *PTPRE_VOQ_DEBUG_SR;

      typedef union _TPRE_VOQ_DEBUG_SR_UNION {
         TPRE_VOQ_DEBUG_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_SR_UNION, *PTPRE_VOQ_DEBUG_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_SR_UNION, sizeof (TPRE_VOQ_DEBUG_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE OUTPUT QUEUES DEBUG - SEL 0: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_0_SR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 voq_free_head : 7;             // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_q0_head : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q0_tail : 7;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q0_count : 7;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_0_SR, *PTPRE_VOQ_DEBUG_0_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_0_SR, sizeof (TPRE_VOQ_DEBUG_0_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_0_SR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 voq_free_head : 7;                   // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_q0_head : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q0_tail : 7;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q0_count : 7;                    // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_0_SR, *PTPRE_VOQ_DEBUG_0_SR;

      typedef union _TPRE_VOQ_DEBUG_0_SR_UNION {
         TPRE_VOQ_DEBUG_0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_0_SR_UNION, *PTPRE_VOQ_DEBUG_0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_0_SR_UNION, sizeof (TPRE_VOQ_DEBUG_0_SR_UNION) == 4);
   #endif


#else
   // TPRE OUTPUT QUEUES DEBUG - SEL 0: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_0_SR {
         union {
            struct { 
               u32 voq_q0_count : 7;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q0_tail : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q0_head : 7;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_free_head : 7;             // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_0_SR, *PTPRE_VOQ_DEBUG_0_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_0_SR, sizeof (TPRE_VOQ_DEBUG_0_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_0_SR {
         u32 voq_q0_count : 7;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q0_tail : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q0_head : 7;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_free_head : 7;                   // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_0_SR, *PTPRE_VOQ_DEBUG_0_SR;

      typedef union _TPRE_VOQ_DEBUG_0_SR_UNION {
         TPRE_VOQ_DEBUG_0_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_0_SR_UNION, *PTPRE_VOQ_DEBUG_0_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_0_SR_UNION, sizeof (TPRE_VOQ_DEBUG_0_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE OUTPUT QUEUES DEBUG - SEL 1: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_1_SR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 voq_free_tail : 7;             // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_q1_head : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q1_tail : 7;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q1_count : 7;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_1_SR, *PTPRE_VOQ_DEBUG_1_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_1_SR, sizeof (TPRE_VOQ_DEBUG_1_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_1_SR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 voq_free_tail : 7;                   // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_q1_head : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q1_tail : 7;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q1_count : 7;                    // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_1_SR, *PTPRE_VOQ_DEBUG_1_SR;

      typedef union _TPRE_VOQ_DEBUG_1_SR_UNION {
         TPRE_VOQ_DEBUG_1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_1_SR_UNION, *PTPRE_VOQ_DEBUG_1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_1_SR_UNION, sizeof (TPRE_VOQ_DEBUG_1_SR_UNION) == 4);
   #endif


#else
   // TPRE OUTPUT QUEUES DEBUG - SEL 1: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_1_SR {
         union {
            struct { 
               u32 voq_q1_count : 7;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q1_tail : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q1_head : 7;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_free_tail : 7;             // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_1_SR, *PTPRE_VOQ_DEBUG_1_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_1_SR, sizeof (TPRE_VOQ_DEBUG_1_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_1_SR {
         u32 voq_q1_count : 7;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q1_tail : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q1_head : 7;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_free_tail : 7;                   // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_1_SR, *PTPRE_VOQ_DEBUG_1_SR;

      typedef union _TPRE_VOQ_DEBUG_1_SR_UNION {
         TPRE_VOQ_DEBUG_1_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_1_SR_UNION, *PTPRE_VOQ_DEBUG_1_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_1_SR_UNION, sizeof (TPRE_VOQ_DEBUG_1_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE OUTPUT QUEUES DEBUG - SEL 2: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_2_SR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 voq_free_count : 7;            // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_q2_head : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q2_tail : 7;               // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q2_count : 7;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_2_SR, *PTPRE_VOQ_DEBUG_2_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_2_SR, sizeof (TPRE_VOQ_DEBUG_2_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_2_SR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 voq_free_count : 7;                  // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_q2_head : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q2_tail : 7;                     // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q2_count : 7;                    // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_2_SR, *PTPRE_VOQ_DEBUG_2_SR;

      typedef union _TPRE_VOQ_DEBUG_2_SR_UNION {
         TPRE_VOQ_DEBUG_2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_2_SR_UNION, *PTPRE_VOQ_DEBUG_2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_2_SR_UNION, sizeof (TPRE_VOQ_DEBUG_2_SR_UNION) == 4);
   #endif


#else
   // TPRE OUTPUT QUEUES DEBUG - SEL 2: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_2_SR {
         union {
            struct { 
               u32 voq_q2_count : 7;              // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 voq_q2_tail : 7;               // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 voq_q2_head : 7;               // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 voq_free_count : 7;            // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_2_SR, *PTPRE_VOQ_DEBUG_2_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_2_SR, sizeof (TPRE_VOQ_DEBUG_2_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_2_SR {
         u32 voq_q2_count : 7;                    // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 voq_q2_tail : 7;                     // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 voq_q2_head : 7;                     // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 voq_free_count : 7;                  // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_2_SR, *PTPRE_VOQ_DEBUG_2_SR;

      typedef union _TPRE_VOQ_DEBUG_2_SR_UNION {
         TPRE_VOQ_DEBUG_2_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_2_SR_UNION, *PTPRE_VOQ_DEBUG_2_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_2_SR_UNION, sizeof (TPRE_VOQ_DEBUG_2_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE OUTPUT QUEUES DEBUG - SEL 3: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_3_SR {
         union {
            struct { 
               u32 voq_p2s_data : 7;              // DWORD 0
               u32 odd_credit : 3;                // DWORD 0
               u32 wrid_rdata : 3;                // DWORD 0
               u32 voq_oq2_empty : 1;             // DWORD 0
               u32 voq_oq1_empty : 1;             // DWORD 0
               u32 voq_oq0_empty : 1;             // DWORD 0
               u32 voq_p2s_empty : 2;             // DWORD 0
               u32 voq_p2s_count : 2;             // DWORD 0
               u32 voq_p2s_valid : 1;             // DWORD 0
               u32 voq_oq_p2s_sel : 3;            // DWORD 0
               u32 voq_oq_sof_flag : 1;           // DWORD 0
               u32 voq_oq_eof_flag : 1;           // DWORD 0
               u32 voq_srram_init_over : 1;       // DWORD 0
               u32 voq_state : 5;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_3_SR, *PTPRE_VOQ_DEBUG_3_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_3_SR, sizeof (TPRE_VOQ_DEBUG_3_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_3_SR {
         u32 voq_p2s_data : 7;                    // DWORD 0
         u32 odd_credit : 3;                      // DWORD 0
         u32 wrid_rdata : 3;                      // DWORD 0
         u32 voq_oq2_empty : 1;                   // DWORD 0
         u32 voq_oq1_empty : 1;                   // DWORD 0
         u32 voq_oq0_empty : 1;                   // DWORD 0
         u32 voq_p2s_empty : 2;                   // DWORD 0
         u32 voq_p2s_count : 2;                   // DWORD 0
         u32 voq_p2s_valid : 1;                   // DWORD 0
         u32 voq_oq_p2s_sel : 3;                  // DWORD 0
         u32 voq_oq_sof_flag : 1;                 // DWORD 0
         u32 voq_oq_eof_flag : 1;                 // DWORD 0
         u32 voq_srram_init_over : 1;             // DWORD 0
         u32 voq_state : 5;                       // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_3_SR, *PTPRE_VOQ_DEBUG_3_SR;

      typedef union _TPRE_VOQ_DEBUG_3_SR_UNION {
         TPRE_VOQ_DEBUG_3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_3_SR_UNION, *PTPRE_VOQ_DEBUG_3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_3_SR_UNION, sizeof (TPRE_VOQ_DEBUG_3_SR_UNION) == 4);
   #endif


#else
   // TPRE OUTPUT QUEUES DEBUG - SEL 3: This register provides debug status for TPRE
   // output queues and related signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_VOQ_DEBUG_3_SR {
         union {
            struct { 
               u32 voq_state : 5;                 // DWORD 0
               u32 voq_srram_init_over : 1;       // DWORD 0
               u32 voq_oq_eof_flag : 1;           // DWORD 0
               u32 voq_oq_sof_flag : 1;           // DWORD 0
               u32 voq_oq_p2s_sel : 3;            // DWORD 0
               u32 voq_p2s_valid : 1;             // DWORD 0
               u32 voq_p2s_count : 2;             // DWORD 0
               u32 voq_p2s_empty : 2;             // DWORD 0
               u32 voq_oq0_empty : 1;             // DWORD 0
               u32 voq_oq1_empty : 1;             // DWORD 0
               u32 voq_oq2_empty : 1;             // DWORD 0
               u32 wrid_rdata : 3;                // DWORD 0
               u32 odd_credit : 3;                // DWORD 0
               u32 voq_p2s_data : 7;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_VOQ_DEBUG_3_SR, *PTPRE_VOQ_DEBUG_3_SR;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_3_SR, sizeof (TPRE_VOQ_DEBUG_3_SR) == 4);

   #else
      typedef struct _TPRE_VOQ_DEBUG_3_SR {
         u32 voq_state : 5;                       // DWORD 0
         u32 voq_srram_init_over : 1;             // DWORD 0
         u32 voq_oq_eof_flag : 1;                 // DWORD 0
         u32 voq_oq_sof_flag : 1;                 // DWORD 0
         u32 voq_oq_p2s_sel : 3;                  // DWORD 0
         u32 voq_p2s_valid : 1;                   // DWORD 0
         u32 voq_p2s_count : 2;                   // DWORD 0
         u32 voq_p2s_empty : 2;                   // DWORD 0
         u32 voq_oq0_empty : 1;                   // DWORD 0
         u32 voq_oq1_empty : 1;                   // DWORD 0
         u32 voq_oq2_empty : 1;                   // DWORD 0
         u32 wrid_rdata : 3;                      // DWORD 0
         u32 odd_credit : 3;                      // DWORD 0
         u32 voq_p2s_data : 7;                    // DWORD 0
      } SG_PACK TPRE_VOQ_DEBUG_3_SR, *PTPRE_VOQ_DEBUG_3_SR;

      typedef union _TPRE_VOQ_DEBUG_3_SR_UNION {
         TPRE_VOQ_DEBUG_3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_VOQ_DEBUG_3_SR_UNION, *PTPRE_VOQ_DEBUG_3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_VOQ_DEBUG_3_SR_UNION, sizeof (TPRE_VOQ_DEBUG_3_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE CLASS DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT3_SR {
         union {
            struct { 
               u32 debug3;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT3_SR, *PTPRE_DEBUG_STAT3_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT3_SR, sizeof (TPRE_DEBUG_STAT3_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT3_SR {
         u32 debug3;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT3_SR, *PTPRE_DEBUG_STAT3_SR;

      typedef union _TPRE_DEBUG_STAT3_SR_UNION {
         TPRE_DEBUG_STAT3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT3_SR_UNION, *PTPRE_DEBUG_STAT3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT3_SR_UNION, sizeof (TPRE_DEBUG_STAT3_SR_UNION) == 4);
   #endif


#else
   // TPRE CLASS DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT3_SR {
         union {
            struct { 
               u32 debug3;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT3_SR, *PTPRE_DEBUG_STAT3_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT3_SR, sizeof (TPRE_DEBUG_STAT3_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT3_SR {
         u32 debug3;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT3_SR, *PTPRE_DEBUG_STAT3_SR;

      typedef union _TPRE_DEBUG_STAT3_SR_UNION {
         TPRE_DEBUG_STAT3_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT3_SR_UNION, *PTPRE_DEBUG_STAT3_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT3_SR_UNION, sizeof (TPRE_DEBUG_STAT3_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Brings out the current data on the hw_dbg pins. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT4_SR {
         union {
            struct { 
               u32 debug4;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT4_SR, *PTPRE_DEBUG_STAT4_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT4_SR, sizeof (TPRE_DEBUG_STAT4_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT4_SR {
         u32 debug4;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT4_SR, *PTPRE_DEBUG_STAT4_SR;

      typedef union _TPRE_DEBUG_STAT4_SR_UNION {
         TPRE_DEBUG_STAT4_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT4_SR_UNION, *PTPRE_DEBUG_STAT4_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT4_SR_UNION, sizeof (TPRE_DEBUG_STAT4_SR_UNION) == 4);
   #endif


#else
   // Brings out the current data on the hw_dbg pins. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT4_SR {
         union {
            struct { 
               u32 debug4;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT4_SR, *PTPRE_DEBUG_STAT4_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT4_SR, sizeof (TPRE_DEBUG_STAT4_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT4_SR {
         u32 debug4;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT4_SR, *PTPRE_DEBUG_STAT4_SR;

      typedef union _TPRE_DEBUG_STAT4_SR_UNION {
         TPRE_DEBUG_STAT4_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT4_SR_UNION, *PTPRE_DEBUG_STAT4_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT4_SR_UNION, sizeof (TPRE_DEBUG_STAT4_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE IPC DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT5_SR {
         union {
            struct { 
               u32 debug5;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT5_SR, *PTPRE_DEBUG_STAT5_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT5_SR, sizeof (TPRE_DEBUG_STAT5_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT5_SR {
         u32 debug5;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT5_SR, *PTPRE_DEBUG_STAT5_SR;

      typedef union _TPRE_DEBUG_STAT5_SR_UNION {
         TPRE_DEBUG_STAT5_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT5_SR_UNION, *PTPRE_DEBUG_STAT5_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT5_SR_UNION, sizeof (TPRE_DEBUG_STAT5_SR_UNION) == 4);
   #endif


#else
   // TPRE IPC DEBUG: This register provides debug status for various internal TPRE
   // signals as defined below. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT5_SR {
         union {
            struct { 
               u32 debug5;                        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT5_SR, *PTPRE_DEBUG_STAT5_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT5_SR, sizeof (TPRE_DEBUG_STAT5_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT5_SR {
         u32 debug5;                              // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT5_SR, *PTPRE_DEBUG_STAT5_SR;

      typedef union _TPRE_DEBUG_STAT5_SR_UNION {
         TPRE_DEBUG_STAT5_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT5_SR_UNION, *PTPRE_DEBUG_STAT5_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT5_SR_UNION, sizeof (TPRE_DEBUG_STAT5_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TPRE ACK PROCESSOR DEBUG: 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT6_SR {
         union {
            struct { 
               u32 ack_debug;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT6_SR, *PTPRE_DEBUG_STAT6_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT6_SR, sizeof (TPRE_DEBUG_STAT6_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT6_SR {
         u32 ack_debug;                           // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT6_SR, *PTPRE_DEBUG_STAT6_SR;

      typedef union _TPRE_DEBUG_STAT6_SR_UNION {
         TPRE_DEBUG_STAT6_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT6_SR_UNION, *PTPRE_DEBUG_STAT6_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT6_SR_UNION, sizeof (TPRE_DEBUG_STAT6_SR_UNION) == 4);
   #endif


#else
   // TPRE ACK PROCESSOR DEBUG: 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_DEBUG_STAT6_SR {
         union {
            struct { 
               u32 ack_debug;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TPRE_DEBUG_STAT6_SR, *PTPRE_DEBUG_STAT6_SR;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT6_SR, sizeof (TPRE_DEBUG_STAT6_SR) == 4);

   #else
      typedef struct _TPRE_DEBUG_STAT6_SR {
         u32 ack_debug;                           // DWORD 0
      } SG_PACK TPRE_DEBUG_STAT6_SR, *PTPRE_DEBUG_STAT6_SR;

      typedef union _TPRE_DEBUG_STAT6_SR_UNION {
         TPRE_DEBUG_STAT6_SR bits;
         u32 dw; // dword union
      } SG_PACK TPRE_DEBUG_STAT6_SR_UNION, *PTPRE_DEBUG_STAT6_SR_UNION;

      SG_C_ASSERT(__sizeof__TPRE_DEBUG_STAT6_SR_UNION, sizeof (TPRE_DEBUG_STAT6_SR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // = This register is informational only. It provides the bit locations for the
   // TPRE_DEBUG_STAT5_SR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DEBUG_STAT5 {
         union {
            struct { 
               u32 rsvd0 : 5;                     // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 head_pointer : 10;             // DWORD 0
               u32 tail_pointer : 10;             // DWORD 0
               u32 ovf_write_state : 2;           // DWORD 0
               u32 ovf_read_state : 2;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DEBUG_STAT5, *PDEBUG_STAT5;

      SG_C_ASSERT(__sizeof__DEBUG_STAT5, sizeof (DEBUG_STAT5) == 4);

   #else
      typedef struct _DEBUG_STAT5 {
         u32 rsvd0 : 5;                           // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 head_pointer : 10;                   // DWORD 0
         u32 tail_pointer : 10;                   // DWORD 0
         u32 ovf_write_state : 2;                 // DWORD 0
         u32 ovf_read_state : 2;                  // DWORD 0
      } SG_PACK DEBUG_STAT5, *PDEBUG_STAT5;

      typedef union _DEBUG_STAT5_UNION {
         DEBUG_STAT5 bits;
         u32 dw; // dword union
      } SG_PACK DEBUG_STAT5_UNION, *PDEBUG_STAT5_UNION;

      SG_C_ASSERT(__sizeof__DEBUG_STAT5_UNION, sizeof (DEBUG_STAT5_UNION) == 4);
   #endif


#else
   // = This register is informational only. It provides the bit locations for the
   // TPRE_DEBUG_STAT5_SR register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _DEBUG_STAT5 {
         union {
            struct { 
               u32 ovf_read_state : 2;            // DWORD 0
               u32 ovf_write_state : 2;           // DWORD 0
               u32 tail_pointer : 10;             // DWORD 0
               u32 head_pointer : 10;             // DWORD 0
               u32 ipc_ovflw_error : 1;           // DWORD 0
               u32 ipc_eof_error : 1;             // DWORD 0
               u32 ipc_sof_error : 1;             // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK DEBUG_STAT5, *PDEBUG_STAT5;

      SG_C_ASSERT(__sizeof__DEBUG_STAT5, sizeof (DEBUG_STAT5) == 4);

   #else
      typedef struct _DEBUG_STAT5 {
         u32 ovf_read_state : 2;                  // DWORD 0
         u32 ovf_write_state : 2;                 // DWORD 0
         u32 tail_pointer : 10;                   // DWORD 0
         u32 head_pointer : 10;                   // DWORD 0
         u32 ipc_ovflw_error : 1;                 // DWORD 0
         u32 ipc_eof_error : 1;                   // DWORD 0
         u32 ipc_sof_error : 1;                   // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
      } SG_PACK DEBUG_STAT5, *PDEBUG_STAT5;

      typedef union _DEBUG_STAT5_UNION {
         DEBUG_STAT5 bits;
         u32 dw; // dword union
      } SG_PACK DEBUG_STAT5_UNION, *PDEBUG_STAT5_UNION;

      SG_C_ASSERT(__sizeof__DEBUG_STAT5_UNION, sizeof (DEBUG_STAT5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The TCP Pre-Processor registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               u32 rsvd0[7];                      // DWORDS 69 to 75
               struct {
                  JELLT_CFG_CSR jellt_cfg;
                  CID_CFG_CSR cid_cfg;
                  JELLM_FREE_CSR free;
                  JELLM_SM_CSR sm;
                  JELLM_UE_ENABLE_CSR uee;
                  JELLM_UE_STATUS_CSR ues;
                  JELLM_LAST_AREQ_CSR last_areq;
                  JELLM_LAST_ARESP_CSR last_aresp;
                  JELLM_LAST_DREQ_CSR last_dreq;
                  JELLM_LAST_DEALLOC_CSR last_dealloc;
                  JELLM_ALLOC_CNT_CSR alloc_cnt;
                  JELLM_DEALLOC_CNT_CSR dealloc_cnt;
               } jellm;
               TIM_1MS_TIMESTAMP_CR timestamp_1ms_control;
               TIM_TIMESTAMP_EXPIRE_CR timestamp_expire;
               TIM_TCP_TIMER_SCALE_CR tcp_timer_scale;
               u32 rsvd1[5];                      // DWORDS 91 to 95
               TPRE_TCP_CM_ADDR_CR tcp_cm_addr;
               TPRE_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
               TPRE_VOQ_ULP_LIMITS_CR voq_ulp_limits;
               TPRE_OQ_CTL_CR oq_control;
               TPRE_COPROCESSOR_CR coprocessor_control;
               TPRE_CLASS_CONTROL_CR class_control;
               TPRE_CLASS_JUMP_MAP_1_CR class_jump_1;
               TPRE_CLASS_JUMP_MAP_2_CR class_jump_2;
               TPRE_CLASS_PGA_MAP_CR class_pga_mapping;
               TPRE_CLASS_DISABLE_MAP_CR class_disables;
               TPRE_VQ_DEBUG_CR vq_debug;
               TPRE_TPRE_COPROCESSOR2_CR coprocessor_control2;
               TPRE_DEBUG_CTL_CR debug_ctl;
               u32 rsvd2[7];                      // DWORDS 109 to 115
               TPRE_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
               TPRE_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
               TPRE_CLASS_CONST_RWDATA_CSR class_const_data;
               TPRE_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
               TPRE_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
               TPRE_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
               TPRE_DBG_VOQ_RWDATAL_CSR dbg_voq_datal;
               TPRE_DBG_VOQ_RWDATAU_CSR dbg_voq_datau;
               TPRE_DBG_VOQ_RWLL_CSR dbg_voq_ll;
               TPRE_DBCRED_CFG_RWDATA_CSR dbcred_cfg_data;
               u32 rsvd3[2];                      // DWORDS 126 to 127
               TIM_1MS_TIMESTAMP_SR timestamp_1ms;
               TIM_10MS_TIMESTAMP_SR timestamp_10ms;
               TPRE_VINQ_DEBUG_SR vinq_debug;
               TPRE_VOQ_DEBUG_SR voq_debug;
               TPRE_DEBUG_STAT3_SR tpre_debug_status_3;
               TPRE_DEBUG_STAT4_SR tpre_debug_status_4;
               TPRE_DEBUG_STAT5_SR tpre_debug_status_5;
               TPRE_DEBUG_STAT6_SR tpre_debug_status_6;
               GEN_CTXIF_DEBUG tpre_ctxif_debug;
               GEN_CTXIF_DEBUG tpre_pmemif_debug;
               HWDBG_CSRMAP hwdbg;
               TPRE_UE1_ENABLE_CR tpre_ue1_enable;
               TPRE_UE2_ENABLE_CR tpre_ue2_enable;
               TPRE_UE1_SOURCE_SR tpre_ue1_source;
               TPRE_UE2_SOURCE_SR tpre_ue2_source;
               u32 rsvd4[8];                      // DWORDS 145 to 152
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } jellm_pq;
               TIM_3_2US_TIMESTAMP_CR timestamp_3_2us_control;
               TIM_LRO_TIMER_EXPIRE0_CR lro_timestamp_expire0;
               TIM_LRO_TIMER_EXPIRE1_CR lro_timestamp_expire1;
               TIM_LRO_TIMER_SCALE0_CR lro_timer_scale0;
               TIM_LRO_TIMER_SCALE1_CR lro_timer_scale1;
               TIM_LRO_TIMER_SCALE2_CR lro_timer_scale2;
               TIM_LRO_TIMER_SCALE3_CR lro_timer_scale3;
               TIM_LRO_TIMER_SCALE4_CR lro_timer_scale4;
               TIM_LRO_TIMER_SCALE5_CR lro_timer_scale5;
               TIM_3_2US_TIMESTAMP_SR timestamp_3_2us;
               u32 rsvd5[88];                     // DWORDS 168 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CSRMAP, *PTPRE_CSRMAP;

      SG_C_ASSERT(__sizeof__TPRE_CSRMAP, sizeof (TPRE_CSRMAP) == 1024);

   #else
      typedef struct _TPRE_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         u32 rsvd0[7];                            // DWORDS 69 to 75
         struct {
            JELLT_CFG_CSR jellt_cfg;
            CID_CFG_CSR cid_cfg;
            JELLM_FREE_CSR free;
            JELLM_SM_CSR sm;
            JELLM_UE_ENABLE_CSR uee;
            JELLM_UE_STATUS_CSR ues;
            JELLM_LAST_AREQ_CSR last_areq;
            JELLM_LAST_ARESP_CSR last_aresp;
            JELLM_LAST_DREQ_CSR last_dreq;
            JELLM_LAST_DEALLOC_CSR last_dealloc;
            JELLM_ALLOC_CNT_CSR alloc_cnt;
            JELLM_DEALLOC_CNT_CSR dealloc_cnt;
         } jellm;
         TIM_1MS_TIMESTAMP_CR timestamp_1ms_control;
         TIM_TIMESTAMP_EXPIRE_CR timestamp_expire;
         TIM_TCP_TIMER_SCALE_CR tcp_timer_scale;
         u32 rsvd1[5];                            // DWORDS 91 to 95
         TPRE_TCP_CM_ADDR_CR tcp_cm_addr;
         TPRE_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
         TPRE_VOQ_ULP_LIMITS_CR voq_ulp_limits;
         TPRE_OQ_CTL_CR oq_control;
         TPRE_COPROCESSOR_CR coprocessor_control;
         TPRE_CLASS_CONTROL_CR class_control;
         TPRE_CLASS_JUMP_MAP_1_CR class_jump_1;
         TPRE_CLASS_JUMP_MAP_2_CR class_jump_2;
         TPRE_CLASS_PGA_MAP_CR class_pga_mapping;
         TPRE_CLASS_DISABLE_MAP_CR class_disables;
         TPRE_VQ_DEBUG_CR vq_debug;
         TPRE_TPRE_COPROCESSOR2_CR coprocessor_control2;
         TPRE_DEBUG_CTL_CR debug_ctl;
         u32 rsvd2[7];                            // DWORDS 109 to 115
         TPRE_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
         TPRE_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
         TPRE_CLASS_CONST_RWDATA_CSR class_const_data;
         TPRE_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
         TPRE_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
         TPRE_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
         TPRE_DBG_VOQ_RWDATAL_CSR dbg_voq_datal;
         TPRE_DBG_VOQ_RWDATAU_CSR dbg_voq_datau;
         TPRE_DBG_VOQ_RWLL_CSR dbg_voq_ll;
         TPRE_DBCRED_CFG_RWDATA_CSR dbcred_cfg_data;
         u32 rsvd3[2];                            // DWORDS 126 to 127
         TIM_1MS_TIMESTAMP_SR timestamp_1ms;
         TIM_10MS_TIMESTAMP_SR timestamp_10ms;
         TPRE_VINQ_DEBUG_SR vinq_debug;
         TPRE_VOQ_DEBUG_SR voq_debug;
         TPRE_DEBUG_STAT3_SR tpre_debug_status_3;
         TPRE_DEBUG_STAT4_SR tpre_debug_status_4;
         TPRE_DEBUG_STAT5_SR tpre_debug_status_5;
         TPRE_DEBUG_STAT6_SR tpre_debug_status_6;
         GEN_CTXIF_DEBUG tpre_ctxif_debug;
         GEN_CTXIF_DEBUG tpre_pmemif_debug;
         HWDBG_CSRMAP hwdbg;
         TPRE_UE1_ENABLE_CR tpre_ue1_enable;
         TPRE_UE2_ENABLE_CR tpre_ue2_enable;
         TPRE_UE1_SOURCE_SR tpre_ue1_source;
         TPRE_UE2_SOURCE_SR tpre_ue2_source;
         u32 rsvd4[8];                            // DWORDS 145 to 152
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } jellm_pq;
         TIM_3_2US_TIMESTAMP_CR timestamp_3_2us_control;
         TIM_LRO_TIMER_EXPIRE0_CR lro_timestamp_expire0;
         TIM_LRO_TIMER_EXPIRE1_CR lro_timestamp_expire1;
         TIM_LRO_TIMER_SCALE0_CR lro_timer_scale0;
         TIM_LRO_TIMER_SCALE1_CR lro_timer_scale1;
         TIM_LRO_TIMER_SCALE2_CR lro_timer_scale2;
         TIM_LRO_TIMER_SCALE3_CR lro_timer_scale3;
         TIM_LRO_TIMER_SCALE4_CR lro_timer_scale4;
         TIM_LRO_TIMER_SCALE5_CR lro_timer_scale5;
         TIM_3_2US_TIMESTAMP_SR timestamp_3_2us;
         u32 rsvd5[88];                           // DWORDS 168 to 255
      } SG_PACK TPRE_CSRMAP, *PTPRE_CSRMAP;

      typedef union _TPRE_CSRMAP_UNION {
         TPRE_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TPRE_CSRMAP_UNION, *PTPRE_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CSRMAP_UNION, sizeof (TPRE_CSRMAP_UNION) == 1024);
   #endif


#else
   // The TCP Pre-Processor registers. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TPRE_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               u32 rsvd0[7];                      // DWORDS 69 to 75
               struct {
                  JELLT_CFG_CSR jellt_cfg;
                  CID_CFG_CSR cid_cfg;
                  JELLM_FREE_CSR free;
                  JELLM_SM_CSR sm;
                  JELLM_UE_ENABLE_CSR uee;
                  JELLM_UE_STATUS_CSR ues;
                  JELLM_LAST_AREQ_CSR last_areq;
                  JELLM_LAST_ARESP_CSR last_aresp;
                  JELLM_LAST_DREQ_CSR last_dreq;
                  JELLM_LAST_DEALLOC_CSR last_dealloc;
                  JELLM_ALLOC_CNT_CSR alloc_cnt;
                  JELLM_DEALLOC_CNT_CSR dealloc_cnt;
               } jellm;
               TIM_1MS_TIMESTAMP_CR timestamp_1ms_control;
               TIM_TIMESTAMP_EXPIRE_CR timestamp_expire;
               TIM_TCP_TIMER_SCALE_CR tcp_timer_scale;
               u32 rsvd1[5];                      // DWORDS 91 to 95
               TPRE_TCP_CM_ADDR_CR tcp_cm_addr;
               TPRE_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
               TPRE_VOQ_ULP_LIMITS_CR voq_ulp_limits;
               TPRE_OQ_CTL_CR oq_control;
               TPRE_COPROCESSOR_CR coprocessor_control;
               TPRE_CLASS_CONTROL_CR class_control;
               TPRE_CLASS_JUMP_MAP_1_CR class_jump_1;
               TPRE_CLASS_JUMP_MAP_2_CR class_jump_2;
               TPRE_CLASS_PGA_MAP_CR class_pga_mapping;
               TPRE_CLASS_DISABLE_MAP_CR class_disables;
               TPRE_VQ_DEBUG_CR vq_debug;
               TPRE_TPRE_COPROCESSOR2_CR coprocessor_control2;
               TPRE_DEBUG_CTL_CR debug_ctl;
               u32 rsvd2[7];                      // DWORDS 109 to 115
               TPRE_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
               TPRE_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
               TPRE_CLASS_CONST_RWDATA_CSR class_const_data;
               TPRE_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
               TPRE_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
               TPRE_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
               TPRE_DBG_VOQ_RWDATAL_CSR dbg_voq_datal;
               TPRE_DBG_VOQ_RWDATAU_CSR dbg_voq_datau;
               TPRE_DBG_VOQ_RWLL_CSR dbg_voq_ll;
               TPRE_DBCRED_CFG_RWDATA_CSR dbcred_cfg_data;
               u32 rsvd3[2];                      // DWORDS 126 to 127
               TIM_1MS_TIMESTAMP_SR timestamp_1ms;
               TIM_10MS_TIMESTAMP_SR timestamp_10ms;
               TPRE_VINQ_DEBUG_SR vinq_debug;
               TPRE_VOQ_DEBUG_SR voq_debug;
               TPRE_DEBUG_STAT3_SR tpre_debug_status_3;
               TPRE_DEBUG_STAT4_SR tpre_debug_status_4;
               TPRE_DEBUG_STAT5_SR tpre_debug_status_5;
               TPRE_DEBUG_STAT6_SR tpre_debug_status_6;
               GEN_CTXIF_DEBUG tpre_ctxif_debug;
               GEN_CTXIF_DEBUG tpre_pmemif_debug;
               HWDBG_CSRMAP hwdbg;
               TPRE_UE1_ENABLE_CR tpre_ue1_enable;
               TPRE_UE2_ENABLE_CR tpre_ue2_enable;
               TPRE_UE1_SOURCE_SR tpre_ue1_source;
               TPRE_UE2_SOURCE_SR tpre_ue2_source;
               u32 rsvd4[8];                      // DWORDS 145 to 152
               struct {
                  PQ_CONTROL_CSR control;
                  PQ_COUNT_CSR pqcnt;
                  PQ_ENQUEUE_CSR enqueue;
                  PQ_DATA0_WRITE_CSR wrdata0;
                  PQ_DATA0_READ_CSR rddata0;
               } jellm_pq;
               TIM_3_2US_TIMESTAMP_CR timestamp_3_2us_control;
               TIM_LRO_TIMER_EXPIRE0_CR lro_timestamp_expire0;
               TIM_LRO_TIMER_EXPIRE1_CR lro_timestamp_expire1;
               TIM_LRO_TIMER_SCALE0_CR lro_timer_scale0;
               TIM_LRO_TIMER_SCALE1_CR lro_timer_scale1;
               TIM_LRO_TIMER_SCALE2_CR lro_timer_scale2;
               TIM_LRO_TIMER_SCALE3_CR lro_timer_scale3;
               TIM_LRO_TIMER_SCALE4_CR lro_timer_scale4;
               TIM_LRO_TIMER_SCALE5_CR lro_timer_scale5;
               TIM_3_2US_TIMESTAMP_SR timestamp_3_2us;
               u32 rsvd5[88];                     // DWORDS 168 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TPRE_CSRMAP, *PTPRE_CSRMAP;

      SG_C_ASSERT(__sizeof__TPRE_CSRMAP, sizeof (TPRE_CSRMAP) == 1024);

   #else
      typedef struct _TPRE_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         u32 rsvd0[7];                            // DWORDS 69 to 75
         struct {
            JELLT_CFG_CSR jellt_cfg;
            CID_CFG_CSR cid_cfg;
            JELLM_FREE_CSR free;
            JELLM_SM_CSR sm;
            JELLM_UE_ENABLE_CSR uee;
            JELLM_UE_STATUS_CSR ues;
            JELLM_LAST_AREQ_CSR last_areq;
            JELLM_LAST_ARESP_CSR last_aresp;
            JELLM_LAST_DREQ_CSR last_dreq;
            JELLM_LAST_DEALLOC_CSR last_dealloc;
            JELLM_ALLOC_CNT_CSR alloc_cnt;
            JELLM_DEALLOC_CNT_CSR dealloc_cnt;
         } jellm;
         TIM_1MS_TIMESTAMP_CR timestamp_1ms_control;
         TIM_TIMESTAMP_EXPIRE_CR timestamp_expire;
         TIM_TCP_TIMER_SCALE_CR tcp_timer_scale;
         u32 rsvd1[5];                            // DWORDS 91 to 95
         TPRE_TCP_CM_ADDR_CR tcp_cm_addr;
         TPRE_VINQ_ULP_LIMITS_CR vinq_ulp_limits;
         TPRE_VOQ_ULP_LIMITS_CR voq_ulp_limits;
         TPRE_OQ_CTL_CR oq_control;
         TPRE_COPROCESSOR_CR coprocessor_control;
         TPRE_CLASS_CONTROL_CR class_control;
         TPRE_CLASS_JUMP_MAP_1_CR class_jump_1;
         TPRE_CLASS_JUMP_MAP_2_CR class_jump_2;
         TPRE_CLASS_PGA_MAP_CR class_pga_mapping;
         TPRE_CLASS_DISABLE_MAP_CR class_disables;
         TPRE_VQ_DEBUG_CR vq_debug;
         TPRE_TPRE_COPROCESSOR2_CR coprocessor_control2;
         TPRE_DEBUG_CTL_CR debug_ctl;
         u32 rsvd2[7];                            // DWORDS 109 to 115
         TPRE_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
         TPRE_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
         TPRE_CLASS_CONST_RWDATA_CSR class_const_data;
         TPRE_DBG_VINQ_RWDATAL_CSR dbg_vinq_datal;
         TPRE_DBG_VINQ_RWDATAU_CSR dbg_vinq_datau;
         TPRE_DBG_VINQ_RWLL_CSR dbg_vinq_ll;
         TPRE_DBG_VOQ_RWDATAL_CSR dbg_voq_datal;
         TPRE_DBG_VOQ_RWDATAU_CSR dbg_voq_datau;
         TPRE_DBG_VOQ_RWLL_CSR dbg_voq_ll;
         TPRE_DBCRED_CFG_RWDATA_CSR dbcred_cfg_data;
         u32 rsvd3[2];                            // DWORDS 126 to 127
         TIM_1MS_TIMESTAMP_SR timestamp_1ms;
         TIM_10MS_TIMESTAMP_SR timestamp_10ms;
         TPRE_VINQ_DEBUG_SR vinq_debug;
         TPRE_VOQ_DEBUG_SR voq_debug;
         TPRE_DEBUG_STAT3_SR tpre_debug_status_3;
         TPRE_DEBUG_STAT4_SR tpre_debug_status_4;
         TPRE_DEBUG_STAT5_SR tpre_debug_status_5;
         TPRE_DEBUG_STAT6_SR tpre_debug_status_6;
         GEN_CTXIF_DEBUG tpre_ctxif_debug;
         GEN_CTXIF_DEBUG tpre_pmemif_debug;
         HWDBG_CSRMAP hwdbg;
         TPRE_UE1_ENABLE_CR tpre_ue1_enable;
         TPRE_UE2_ENABLE_CR tpre_ue2_enable;
         TPRE_UE1_SOURCE_SR tpre_ue1_source;
         TPRE_UE2_SOURCE_SR tpre_ue2_source;
         u32 rsvd4[8];                            // DWORDS 145 to 152
         struct {
            PQ_CONTROL_CSR control;
            PQ_COUNT_CSR pqcnt;
            PQ_ENQUEUE_CSR enqueue;
            PQ_DATA0_WRITE_CSR wrdata0;
            PQ_DATA0_READ_CSR rddata0;
         } jellm_pq;
         TIM_3_2US_TIMESTAMP_CR timestamp_3_2us_control;
         TIM_LRO_TIMER_EXPIRE0_CR lro_timestamp_expire0;
         TIM_LRO_TIMER_EXPIRE1_CR lro_timestamp_expire1;
         TIM_LRO_TIMER_SCALE0_CR lro_timer_scale0;
         TIM_LRO_TIMER_SCALE1_CR lro_timer_scale1;
         TIM_LRO_TIMER_SCALE2_CR lro_timer_scale2;
         TIM_LRO_TIMER_SCALE3_CR lro_timer_scale3;
         TIM_LRO_TIMER_SCALE4_CR lro_timer_scale4;
         TIM_LRO_TIMER_SCALE5_CR lro_timer_scale5;
         TIM_3_2US_TIMESTAMP_SR timestamp_3_2us;
         u32 rsvd5[88];                           // DWORDS 168 to 255
      } SG_PACK TPRE_CSRMAP, *PTPRE_CSRMAP;

      typedef union _TPRE_CSRMAP_UNION {
         TPRE_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TPRE_CSRMAP_UNION, *PTPRE_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TPRE_CSRMAP_UNION, sizeof (TPRE_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __tpre_bmap_h__

