/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __txulp_bmap_h__
#define __txulp_bmap_h__
#include "setypes.h"
#include "defines_bmap.h"
#include "ep_bmap.h"
#include "ep_minirom_bmap.h"
#include "btlr_bmap.h"
#include "gencommon_bmap.h"
#include "hwdbg_reg_bmap.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_C_ASSERT
   #define SG_C_ASSERT(_name_, _condition_)
#endif

#ifndef SG_ASSERT
   #define SG_ASSERT(_condition_)
#endif

#ifndef SG_CALL
   #define SG_CALL
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif

#if defined(SG_REVERSE_ENDIAN)
   // TCP Context Memory Starting Address and Stride Register. Defines starting addresses
   // and stride of TCP context data structures in CTX memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TCP_CM_ADDR_STRD_CSR {
         union {
            struct { 
               u32 tcp_context_startaddr : 16;    // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 tcp_context_strd : 2;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR, *PTXULP_TCP_CM_ADDR_STRD_CSR;

      SG_C_ASSERT(__sizeof__TXULP_TCP_CM_ADDR_STRD_CSR, sizeof (TXULP_TCP_CM_ADDR_STRD_CSR) == 4);

   #else
      typedef struct _TXULP_TCP_CM_ADDR_STRD_CSR {
         u32 tcp_context_startaddr : 16;          // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 tcp_context_strd : 2;                // DWORD 0
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR, *PTXULP_TCP_CM_ADDR_STRD_CSR;

      typedef union _TXULP_TCP_CM_ADDR_STRD_CSR_UNION {
         TXULP_TCP_CM_ADDR_STRD_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR_UNION, *PTXULP_TCP_CM_ADDR_STRD_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TCP_CM_ADDR_STRD_CSR_UNION, sizeof (TXULP_TCP_CM_ADDR_STRD_CSR_UNION) == 4);
   #endif


#else
   // TCP Context Memory Starting Address and Stride Register. Defines starting addresses
   // and stride of TCP context data structures in CTX memory.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TCP_CM_ADDR_STRD_CSR {
         union {
            struct { 
               u32 tcp_context_strd : 2;          // DWORD 0
               u32 rsvd0 : 14;                    // DWORD 0
               u32 tcp_context_startaddr : 16;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR, *PTXULP_TCP_CM_ADDR_STRD_CSR;

      SG_C_ASSERT(__sizeof__TXULP_TCP_CM_ADDR_STRD_CSR, sizeof (TXULP_TCP_CM_ADDR_STRD_CSR) == 4);

   #else
      typedef struct _TXULP_TCP_CM_ADDR_STRD_CSR {
         u32 tcp_context_strd : 2;                // DWORD 0
         u32 rsvd0 : 14;                          // DWORD 0
         u32 tcp_context_startaddr : 16;          // DWORD 0
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR, *PTXULP_TCP_CM_ADDR_STRD_CSR;

      typedef union _TXULP_TCP_CM_ADDR_STRD_CSR_UNION {
         TXULP_TCP_CM_ADDR_STRD_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TCP_CM_ADDR_STRD_CSR_UNION, *PTXULP_TCP_CM_ADDR_STRD_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TCP_CM_ADDR_STRD_CSR_UNION, sizeof (TXULP_TCP_CM_ADDR_STRD_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_CTRL_CSR {
         union {
            struct { 
               u32 rsvd1 : 28;                    // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 pass_tcppost_zcred : 1;        // DWORD 0
               u32 cntrl_en_no_tcp : 1;           // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_CTRL_CSR, *PTXULP_CONSEL_CTRL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CTRL_CSR, sizeof (TXULP_CONSEL_CTRL_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_CTRL_CSR {
         u32 rsvd1 : 28;                          // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 pass_tcppost_zcred : 1;              // DWORD 0
         u32 cntrl_en_no_tcp : 1;                 // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
      } SG_PACK TXULP_CONSEL_CTRL_CSR, *PTXULP_CONSEL_CTRL_CSR;

      typedef union _TXULP_CONSEL_CTRL_CSR_UNION {
         TXULP_CONSEL_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_CTRL_CSR_UNION, *PTXULP_CONSEL_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CTRL_CSR_UNION, sizeof (TXULP_CONSEL_CTRL_CSR_UNION) == 4);
   #endif


#else
   // Connection Selector Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_CTRL_CSR {
         union {
            struct { 
               u32 rsvd0 : 1;                     // DWORD 0
               u32 cntrl_en_no_tcp : 1;           // DWORD 0
               u32 pass_tcppost_zcred : 1;        // DWORD 0
               u32 enable_wd : 1;                 // DWORD 0
               u32 rsvd1 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_CTRL_CSR, *PTXULP_CONSEL_CTRL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CTRL_CSR, sizeof (TXULP_CONSEL_CTRL_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_CTRL_CSR {
         u32 rsvd0 : 1;                           // DWORD 0
         u32 cntrl_en_no_tcp : 1;                 // DWORD 0
         u32 pass_tcppost_zcred : 1;              // DWORD 0
         u32 enable_wd : 1;                       // DWORD 0
         u32 rsvd1 : 28;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_CTRL_CSR, *PTXULP_CONSEL_CTRL_CSR;

      typedef union _TXULP_CONSEL_CTRL_CSR_UNION {
         TXULP_CONSEL_CTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_CTRL_CSR_UNION, *PTXULP_CONSEL_CTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_CTRL_CSR_UNION, sizeof (TXULP_CONSEL_CTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Weight Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_WEIGHT_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 post_weight : 4;               // DWORD 0
               u32 rrmsg_access_weight : 4;       // DWORD 0
               u32 search_access_weight : 4;      // DWORD 0
               u32 tpre_access_weight : 4;        // DWORD 0
               u32 debug_write_weight : 4;        // DWORD 0
               u32 debug_read_weight : 4;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR, *PTXULP_CONSEL_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_WEIGHT_CSR, sizeof (TXULP_CONSEL_WEIGHT_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_WEIGHT_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 post_weight : 4;                     // DWORD 0
         u32 rrmsg_access_weight : 4;             // DWORD 0
         u32 search_access_weight : 4;            // DWORD 0
         u32 tpre_access_weight : 4;              // DWORD 0
         u32 debug_write_weight : 4;              // DWORD 0
         u32 debug_read_weight : 4;               // DWORD 0
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR, *PTXULP_CONSEL_WEIGHT_CSR;

      typedef union _TXULP_CONSEL_WEIGHT_CSR_UNION {
         TXULP_CONSEL_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR_UNION, *PTXULP_CONSEL_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_WEIGHT_CSR_UNION, sizeof (TXULP_CONSEL_WEIGHT_CSR_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Weight Control Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_WEIGHT_CSR {
         union {
            struct { 
               u32 debug_read_weight : 4;         // DWORD 0
               u32 debug_write_weight : 4;        // DWORD 0
               u32 tpre_access_weight : 4;        // DWORD 0
               u32 search_access_weight : 4;      // DWORD 0
               u32 rrmsg_access_weight : 4;       // DWORD 0
               u32 post_weight : 4;               // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR, *PTXULP_CONSEL_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_WEIGHT_CSR, sizeof (TXULP_CONSEL_WEIGHT_CSR) == 4);

   #else
      typedef struct _TXULP_CONSEL_WEIGHT_CSR {
         u32 debug_read_weight : 4;               // DWORD 0
         u32 debug_write_weight : 4;              // DWORD 0
         u32 tpre_access_weight : 4;              // DWORD 0
         u32 search_access_weight : 4;            // DWORD 0
         u32 rrmsg_access_weight : 4;             // DWORD 0
         u32 post_weight : 4;                     // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR, *PTXULP_CONSEL_WEIGHT_CSR;

      typedef union _TXULP_CONSEL_WEIGHT_CSR_UNION {
         TXULP_CONSEL_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_WEIGHT_CSR_UNION, *PTXULP_CONSEL_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_WEIGHT_CSR_UNION, sizeof (TXULP_CONSEL_WEIGHT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP CID Range Register. TCPSCH is a TxULP sub-block that fetches TCP context and
   // calculates the TCP window. For Raw Ethernet this is non useful information and so
   // the TCPSCH stage should be avoided. This register defines which CIDs are not
   // TCP-offloaded.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_CID_CSR {
         union {
            struct { 
               u32 rsvd1 : 5;                     // DWORD 0
               u32 notcp_cid_end : 11;            // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 notcp_cid_start : 11;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_CID_CSR, *PTXULP_NO_TCP_CID_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_CID_CSR, sizeof (TXULP_NO_TCP_CID_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_CID_CSR {
         u32 rsvd1 : 5;                           // DWORD 0
         u32 notcp_cid_end : 11;                  // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 notcp_cid_start : 11;                // DWORD 0
      } SG_PACK TXULP_NO_TCP_CID_CSR, *PTXULP_NO_TCP_CID_CSR;

      typedef union _TXULP_NO_TCP_CID_CSR_UNION {
         TXULP_NO_TCP_CID_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_CID_CSR_UNION, *PTXULP_NO_TCP_CID_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_CID_CSR_UNION, sizeof (TXULP_NO_TCP_CID_CSR_UNION) == 4);
   #endif


#else
   // TCP CID Range Register. TCPSCH is a TxULP sub-block that fetches TCP context and
   // calculates the TCP window. For Raw Ethernet this is non useful information and so
   // the TCPSCH stage should be avoided. This register defines which CIDs are not
   // TCP-offloaded.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_CID_CSR {
         union {
            struct { 
               u32 notcp_cid_start : 11;          // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 notcp_cid_end : 11;            // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_CID_CSR, *PTXULP_NO_TCP_CID_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_CID_CSR, sizeof (TXULP_NO_TCP_CID_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_CID_CSR {
         u32 notcp_cid_start : 11;                // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 notcp_cid_end : 11;                  // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
      } SG_PACK TXULP_NO_TCP_CID_CSR, *PTXULP_NO_TCP_CID_CSR;

      typedef union _TXULP_NO_TCP_CID_CSR_UNION {
         TXULP_NO_TCP_CID_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_CID_CSR_UNION, *PTXULP_NO_TCP_CID_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_CID_CSR_UNION, sizeof (TXULP_NO_TCP_CID_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port Associations of Raw Ethernet Rings Register. Defines the 10 Gbps Ethernet port
   // numbers for Raw Ethernet rings. This Register maps port numbers for the first 32
   // non-TCP-offloaded CIDs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_PORT0_CSR {
         union {
            struct { 
               u32 notcp_port_num0;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_PORT0_CSR, *PTXULP_NO_TCP_PORT0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT0_CSR, sizeof (TXULP_NO_TCP_PORT0_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_PORT0_CSR {
         u32 notcp_port_num0;                     // DWORD 0
      } SG_PACK TXULP_NO_TCP_PORT0_CSR, *PTXULP_NO_TCP_PORT0_CSR;

      typedef union _TXULP_NO_TCP_PORT0_CSR_UNION {
         TXULP_NO_TCP_PORT0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_PORT0_CSR_UNION, *PTXULP_NO_TCP_PORT0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT0_CSR_UNION, sizeof (TXULP_NO_TCP_PORT0_CSR_UNION) == 4);
   #endif


#else
   // Port Associations of Raw Ethernet Rings Register. Defines the 10 Gbps Ethernet port
   // numbers for Raw Ethernet rings. This Register maps port numbers for the first 32
   // non-TCP-offloaded CIDs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_PORT0_CSR {
         union {
            struct { 
               u32 notcp_port_num0;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_PORT0_CSR, *PTXULP_NO_TCP_PORT0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT0_CSR, sizeof (TXULP_NO_TCP_PORT0_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_PORT0_CSR {
         u32 notcp_port_num0;                     // DWORD 0
      } SG_PACK TXULP_NO_TCP_PORT0_CSR, *PTXULP_NO_TCP_PORT0_CSR;

      typedef union _TXULP_NO_TCP_PORT0_CSR_UNION {
         TXULP_NO_TCP_PORT0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_PORT0_CSR_UNION, *PTXULP_NO_TCP_PORT0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT0_CSR_UNION, sizeof (TXULP_NO_TCP_PORT0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Port Associations of Raw Ethernet Rings Register. Defines the 10 Gbps Ethernet port
   // numbers for Raw Ethernet rings. This Register maps port numbers for the second 32
   // non-TCP-offloaded CIDs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_PORT1_CSR {
         union {
            struct { 
               u32 notcp_port_num1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_PORT1_CSR, *PTXULP_NO_TCP_PORT1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT1_CSR, sizeof (TXULP_NO_TCP_PORT1_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_PORT1_CSR {
         u32 notcp_port_num1;                     // DWORD 0
      } SG_PACK TXULP_NO_TCP_PORT1_CSR, *PTXULP_NO_TCP_PORT1_CSR;

      typedef union _TXULP_NO_TCP_PORT1_CSR_UNION {
         TXULP_NO_TCP_PORT1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_PORT1_CSR_UNION, *PTXULP_NO_TCP_PORT1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT1_CSR_UNION, sizeof (TXULP_NO_TCP_PORT1_CSR_UNION) == 4);
   #endif


#else
   // Port Associations of Raw Ethernet Rings Register. Defines the 10 Gbps Ethernet port
   // numbers for Raw Ethernet rings. This Register maps port numbers for the second 32
   // non-TCP-offloaded CIDs.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_NO_TCP_PORT1_CSR {
         union {
            struct { 
               u32 notcp_port_num1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_NO_TCP_PORT1_CSR, *PTXULP_NO_TCP_PORT1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT1_CSR, sizeof (TXULP_NO_TCP_PORT1_CSR) == 4);

   #else
      typedef struct _TXULP_NO_TCP_PORT1_CSR {
         u32 notcp_port_num1;                     // DWORD 0
      } SG_PACK TXULP_NO_TCP_PORT1_CSR, *PTXULP_NO_TCP_PORT1_CSR;

      typedef union _TXULP_NO_TCP_PORT1_CSR_UNION {
         TXULP_NO_TCP_PORT1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_NO_TCP_PORT1_CSR_UNION, *PTXULP_NO_TCP_PORT1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_NO_TCP_PORT1_CSR_UNION, sizeof (TXULP_NO_TCP_PORT1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Software Scheduling Message Data 0 Register. Data being passed for RR Message into
   // tcpsch_proc_snd_nxt
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_DATA0_CSR {
         union {
            struct { 
               u32 rr_msg_data0;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_DATA0_CSR, *PTXULP_RR_MSG_DATA0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA0_CSR, sizeof (TXULP_RR_MSG_DATA0_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_DATA0_CSR {
         u32 rr_msg_data0;                        // DWORD 0
      } SG_PACK TXULP_RR_MSG_DATA0_CSR, *PTXULP_RR_MSG_DATA0_CSR;

      typedef union _TXULP_RR_MSG_DATA0_CSR_UNION {
         TXULP_RR_MSG_DATA0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_DATA0_CSR_UNION, *PTXULP_RR_MSG_DATA0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA0_CSR_UNION, sizeof (TXULP_RR_MSG_DATA0_CSR_UNION) == 4);
   #endif


#else
   // Software Scheduling Message Data 0 Register. Data being passed for RR Message into
   // tcpsch_proc_snd_nxt
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_DATA0_CSR {
         union {
            struct { 
               u32 rr_msg_data0;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_DATA0_CSR, *PTXULP_RR_MSG_DATA0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA0_CSR, sizeof (TXULP_RR_MSG_DATA0_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_DATA0_CSR {
         u32 rr_msg_data0;                        // DWORD 0
      } SG_PACK TXULP_RR_MSG_DATA0_CSR, *PTXULP_RR_MSG_DATA0_CSR;

      typedef union _TXULP_RR_MSG_DATA0_CSR_UNION {
         TXULP_RR_MSG_DATA0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_DATA0_CSR_UNION, *PTXULP_RR_MSG_DATA0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA0_CSR_UNION, sizeof (TXULP_RR_MSG_DATA0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Software Scheduling Message Data 1 Register. Data being passed for RR Message into
   // tcpsch_proc_snd_win
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_DATA1_CSR {
         union {
            struct { 
               u32 rr_msg_data1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_DATA1_CSR, *PTXULP_RR_MSG_DATA1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA1_CSR, sizeof (TXULP_RR_MSG_DATA1_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_DATA1_CSR {
         u32 rr_msg_data1;                        // DWORD 0
      } SG_PACK TXULP_RR_MSG_DATA1_CSR, *PTXULP_RR_MSG_DATA1_CSR;

      typedef union _TXULP_RR_MSG_DATA1_CSR_UNION {
         TXULP_RR_MSG_DATA1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_DATA1_CSR_UNION, *PTXULP_RR_MSG_DATA1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA1_CSR_UNION, sizeof (TXULP_RR_MSG_DATA1_CSR_UNION) == 4);
   #endif


#else
   // Software Scheduling Message Data 1 Register. Data being passed for RR Message into
   // tcpsch_proc_snd_win
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_DATA1_CSR {
         union {
            struct { 
               u32 rr_msg_data1;                  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_DATA1_CSR, *PTXULP_RR_MSG_DATA1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA1_CSR, sizeof (TXULP_RR_MSG_DATA1_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_DATA1_CSR {
         u32 rr_msg_data1;                        // DWORD 0
      } SG_PACK TXULP_RR_MSG_DATA1_CSR, *PTXULP_RR_MSG_DATA1_CSR;

      typedef union _TXULP_RR_MSG_DATA1_CSR_UNION {
         TXULP_RR_MSG_DATA1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_DATA1_CSR_UNION, *PTXULP_RR_MSG_DATA1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_DATA1_CSR_UNION, sizeof (TXULP_RR_MSG_DATA1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // The RR MSG allows for an entity with Reg Router access (MPU, Host, etc.) to schedule
   // a software-specified command instead of the usual C,D or R bits. The effective use
   // is to gracefully send a 16-byte command to TxULP that is guranteed to be at a time
   // when the desired connection is in a quiescent state, i.e. there are no packets in
   // flight between the top of TxULP to the bottom of the TPost, i.e. there is no more
   // stateful processing to bedone on that connection. This can be very useful for
   // shutting down connections gracefully. A more detailed explaination is below.
   // Normally, a doorbell is posted and the BTLR will intercept the doorbell, and set the
   // Driver Pending (D) bit in the TxULP Connection Selector. The TxULP Consel would then
   // scan through all bits. When it finds one that the Grant Pending (G) bit is low and
   // Driver Pending is high (or Chip Pending (C) or Retransmit Pending(R)), it will
   // select the connection, clear the CDR bits, set the G bit, and pass the CDR bits and
   // CID to the TCPSCH logic, which will then calculate various TCP window fields and
   // pass it into the TxULP. When an RR_MSG is pending, the Consel works very much the
   // same. Consel scans through looking for CIDs whose Grant Pending (G) bit is low. If
   // there is an RR_MSG pending on that CID, then it will schedule that connection
   // without clearing the CDR bits, but it will set the Grant Pending bit. When the RRMSG
   // scheduled connection arrives at the TCPSCH, no TCP scheduling is performed. Rather,
   // data (from RR_MSG_DATA0 and 1) is passed into the TxULP. Since the Grant bit was
   // set, all traffic on that connection will quiesce until the TxULP / TPost firmware
   // determines it is a good time to begin scheduling again. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_CNTRL_CSR {
         union {
            struct { 
               u32 rr_msg_pend : 1;               // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 rr_msg_cid : 11;               // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 rr_msg_cid_valid : 1;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR, *PTXULP_RR_MSG_CNTRL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_CNTRL_CSR, sizeof (TXULP_RR_MSG_CNTRL_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_CNTRL_CSR {
         u32 rr_msg_pend : 1;                     // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 rr_msg_cid : 11;                     // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 rr_msg_cid_valid : 1;                // DWORD 0
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR, *PTXULP_RR_MSG_CNTRL_CSR;

      typedef union _TXULP_RR_MSG_CNTRL_CSR_UNION {
         TXULP_RR_MSG_CNTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR_UNION, *PTXULP_RR_MSG_CNTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_CNTRL_CSR_UNION, sizeof (TXULP_RR_MSG_CNTRL_CSR_UNION) == 4);
   #endif


#else
   // The RR MSG allows for an entity with Reg Router access (MPU, Host, etc.) to schedule
   // a software-specified command instead of the usual C,D or R bits. The effective use
   // is to gracefully send a 16-byte command to TxULP that is guranteed to be at a time
   // when the desired connection is in a quiescent state, i.e. there are no packets in
   // flight between the top of TxULP to the bottom of the TPost, i.e. there is no more
   // stateful processing to bedone on that connection. This can be very useful for
   // shutting down connections gracefully. A more detailed explaination is below.
   // Normally, a doorbell is posted and the BTLR will intercept the doorbell, and set the
   // Driver Pending (D) bit in the TxULP Connection Selector. The TxULP Consel would then
   // scan through all bits. When it finds one that the Grant Pending (G) bit is low and
   // Driver Pending is high (or Chip Pending (C) or Retransmit Pending(R)), it will
   // select the connection, clear the CDR bits, set the G bit, and pass the CDR bits and
   // CID to the TCPSCH logic, which will then calculate various TCP window fields and
   // pass it into the TxULP. When an RR_MSG is pending, the Consel works very much the
   // same. Consel scans through looking for CIDs whose Grant Pending (G) bit is low. If
   // there is an RR_MSG pending on that CID, then it will schedule that connection
   // without clearing the CDR bits, but it will set the Grant Pending bit. When the RRMSG
   // scheduled connection arrives at the TCPSCH, no TCP scheduling is performed. Rather,
   // data (from RR_MSG_DATA0 and 1) is passed into the TxULP. Since the Grant bit was
   // set, all traffic on that connection will quiesce until the TxULP / TPost firmware
   // determines it is a good time to begin scheduling again. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RR_MSG_CNTRL_CSR {
         union {
            struct { 
               u32 rr_msg_cid_valid : 1;          // DWORD 0
               u32 rsvd0 : 15;                    // DWORD 0
               u32 rr_msg_cid : 11;               // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 rr_msg_pend : 1;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR, *PTXULP_RR_MSG_CNTRL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_CNTRL_CSR, sizeof (TXULP_RR_MSG_CNTRL_CSR) == 4);

   #else
      typedef struct _TXULP_RR_MSG_CNTRL_CSR {
         u32 rr_msg_cid_valid : 1;                // DWORD 0
         u32 rsvd0 : 15;                          // DWORD 0
         u32 rr_msg_cid : 11;                     // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 rr_msg_pend : 1;                     // DWORD 0
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR, *PTXULP_RR_MSG_CNTRL_CSR;

      typedef union _TXULP_RR_MSG_CNTRL_CSR_UNION {
         TXULP_RR_MSG_CNTRL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RR_MSG_CNTRL_CSR_UNION, *PTXULP_RR_MSG_CNTRL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RR_MSG_CNTRL_CSR_UNION, sizeof (TXULP_RR_MSG_CNTRL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Interrupt Sources Register. Its bits are not unmasked. MPU is the interrupt
   // destination
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_INT_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 btlr_netw_violation : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_INT_SOURCE, *PTXULP_INT_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_INT_SOURCE, sizeof (TXULP_INT_SOURCE) == 4);

   #else
      typedef struct _TXULP_INT_SOURCE {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 btlr_netw_violation : 1;             // DWORD 0
      } SG_PACK TXULP_INT_SOURCE, *PTXULP_INT_SOURCE;

      typedef union _TXULP_INT_SOURCE_UNION {
         TXULP_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_INT_SOURCE_UNION, *PTXULP_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_INT_SOURCE_UNION, sizeof (TXULP_INT_SOURCE_UNION) == 4);
   #endif


#else
   // MPU Interrupt Sources Register. Its bits are not unmasked. MPU is the interrupt
   // destination
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_INT_SOURCE {
         union {
            struct { 
               u32 btlr_netw_violation : 1;       // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_INT_SOURCE, *PTXULP_INT_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_INT_SOURCE, sizeof (TXULP_INT_SOURCE) == 4);

   #else
      typedef struct _TXULP_INT_SOURCE {
         u32 btlr_netw_violation : 1;             // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK TXULP_INT_SOURCE, *PTXULP_INT_SOURCE;

      typedef union _TXULP_INT_SOURCE_UNION {
         TXULP_INT_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_INT_SOURCE_UNION, *PTXULP_INT_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_INT_SOURCE_UNION, sizeof (TXULP_INT_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // MPU Interrupt Mask Register. Write a 1 to disable the relevant interrupt to MPU.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_INT_MASK {
         union {
            struct { 
               u32 rsvd0 : 31;                    // DWORD 0
               u32 btlr_netw_violation : 1;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_INT_MASK, *PTXULP_INT_MASK;

      SG_C_ASSERT(__sizeof__TXULP_INT_MASK, sizeof (TXULP_INT_MASK) == 4);

   #else
      typedef struct _TXULP_INT_MASK {
         u32 rsvd0 : 31;                          // DWORD 0
         u32 btlr_netw_violation : 1;             // DWORD 0
      } SG_PACK TXULP_INT_MASK, *PTXULP_INT_MASK;

      typedef union _TXULP_INT_MASK_UNION {
         TXULP_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK TXULP_INT_MASK_UNION, *PTXULP_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__TXULP_INT_MASK_UNION, sizeof (TXULP_INT_MASK_UNION) == 4);
   #endif


#else
   // MPU Interrupt Mask Register. Write a 1 to disable the relevant interrupt to MPU.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_INT_MASK {
         union {
            struct { 
               u32 btlr_netw_violation : 1;       // DWORD 0
               u32 rsvd0 : 31;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_INT_MASK, *PTXULP_INT_MASK;

      SG_C_ASSERT(__sizeof__TXULP_INT_MASK, sizeof (TXULP_INT_MASK) == 4);

   #else
      typedef struct _TXULP_INT_MASK {
         u32 btlr_netw_violation : 1;             // DWORD 0
         u32 rsvd0 : 31;                          // DWORD 0
      } SG_PACK TXULP_INT_MASK, *PTXULP_INT_MASK;

      typedef union _TXULP_INT_MASK_UNION {
         TXULP_INT_MASK bits;
         u32 dw; // dword union
      } SG_PACK TXULP_INT_MASK_UNION, *PTXULP_INT_MASK_UNION;

      SG_C_ASSERT(__sizeof__TXULP_INT_MASK_UNION, sizeof (TXULP_INT_MASK_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // EP and IPC Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_AND_IPC_UE_SOURCE {
         union {
            struct { 
               u32 ipc_fifo_overflow_error_status : 1; // DWORD 0
               u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
               u32 ipc_eof_error_status : 1;      // DWORD 0
               u32 ipc_sof_error_status : 1;      // DWORD 0
               u32 ipc_overflow_error_status : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ep_fram_woor_error_status : 1; // DWORD 0
               u32 ep_iram_woor_error_status : 1; // DWORD 0
               u32 ep_prefetch_un_error_status : 1; // DWORD 0
               u32 ep_prefetch_ov_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 ep_fw_ue_status : 1;           // DWORD 0
               u32 ep_stat_ram_perror_status : 1; // DWORD 0
               u32 ep_sram_perror_status : 5;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE, *PTXULP_EP_AND_IPC_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_SOURCE, sizeof (TXULP_EP_AND_IPC_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_EP_AND_IPC_UE_SOURCE {
         u32 ipc_fifo_overflow_error_status : 1;  // DWORD 0
         u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
         u32 ipc_eof_error_status : 1;            // DWORD 0
         u32 ipc_sof_error_status : 1;            // DWORD 0
         u32 ipc_overflow_error_status : 1;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ep_fram_woor_error_status : 1;       // DWORD 0
         u32 ep_iram_woor_error_status : 1;       // DWORD 0
         u32 ep_prefetch_un_error_status : 1;     // DWORD 0
         u32 ep_prefetch_ov_error_status : 1;     // DWORD 0
         u32 ep_m2_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m2_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 ep_fw_ue_status : 1;                 // DWORD 0
         u32 ep_stat_ram_perror_status : 1;       // DWORD 0
         u32 ep_sram_perror_status : 5;           // DWORD 0
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE, *PTXULP_EP_AND_IPC_UE_SOURCE;

      typedef union _TXULP_EP_AND_IPC_UE_SOURCE_UNION {
         TXULP_EP_AND_IPC_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE_UNION, *PTXULP_EP_AND_IPC_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_SOURCE_UNION, sizeof (TXULP_EP_AND_IPC_UE_SOURCE_UNION) == 4);
   #endif


#else
   // EP and IPC Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_AND_IPC_UE_SOURCE {
         union {
            struct { 
               u32 ep_sram_perror_status : 5;     // DWORD 0
               u32 ep_stat_ram_perror_status : 1; // DWORD 0
               u32 ep_fw_ue_status : 1;           // DWORD 0
               u32 ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
               u32 ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_status : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_status : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_status : 1; // DWORD 0
               u32 ep_prefetch_ov_error_status : 1; // DWORD 0
               u32 ep_prefetch_un_error_status : 1; // DWORD 0
               u32 ep_iram_woor_error_status : 1; // DWORD 0
               u32 ep_fram_woor_error_status : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ipc_overflow_error_status : 1; // DWORD 0
               u32 ipc_sof_error_status : 1;      // DWORD 0
               u32 ipc_eof_error_status : 1;      // DWORD 0
               u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE, *PTXULP_EP_AND_IPC_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_SOURCE, sizeof (TXULP_EP_AND_IPC_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_EP_AND_IPC_UE_SOURCE {
         u32 ep_sram_perror_status : 5;           // DWORD 0
         u32 ep_stat_ram_perror_status : 1;       // DWORD 0
         u32 ep_fw_ue_status : 1;                 // DWORD 0
         u32 ep_unload_sync_fifo_overrun_error_status : 1; // DWORD 0
         u32 ep_unload_sync_fifo_underrun_error_status : 1; // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_status : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_un_error_status : 1;   // DWORD 0
         u32 ep_m0_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_status : 1;    // DWORD 0
         u32 ep_m2_mem_wb_un_error_status : 1;    // DWORD 0
         u32 ep_prefetch_ov_error_status : 1;     // DWORD 0
         u32 ep_prefetch_un_error_status : 1;     // DWORD 0
         u32 ep_iram_woor_error_status : 1;       // DWORD 0
         u32 ep_fram_woor_error_status : 1;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ipc_overflow_error_status : 1;       // DWORD 0
         u32 ipc_sof_error_status : 1;            // DWORD 0
         u32 ipc_eof_error_status : 1;            // DWORD 0
         u32 ipc_fifo_underflow_error_status : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_status : 1;  // DWORD 0
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE, *PTXULP_EP_AND_IPC_UE_SOURCE;

      typedef union _TXULP_EP_AND_IPC_UE_SOURCE_UNION {
         TXULP_EP_AND_IPC_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_AND_IPC_UE_SOURCE_UNION, *PTXULP_EP_AND_IPC_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_SOURCE_UNION, sizeof (TXULP_EP_AND_IPC_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // EP and IPC Unrecoverable Error Enable Register. Write a 1 to Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_AND_IPC_UE_ENABLE {
         union {
            struct { 
               u32 ipc_fifo_overflow_error_enable : 1; // DWORD 0
               u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
               u32 ipc_eof_error_enable : 1;      // DWORD 0
               u32 ipc_sof_error_enable : 1;      // DWORD 0
               u32 ipc_overflow_error_enable : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ep_fram_woor_error_enable : 1; // DWORD 0
               u32 ep_iram_woor_error_enable : 1; // DWORD 0
               u32 ep_prefetch_un_error_enable : 1; // DWORD 0
               u32 ep_prefetch_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 ep_fw_ue_enable : 1;           // DWORD 0
               u32 ep_stat_ram_perror_enable : 1; // DWORD 0
               u32 ep_sram_perror_enable : 5;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE, *PTXULP_EP_AND_IPC_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_ENABLE, sizeof (TXULP_EP_AND_IPC_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_EP_AND_IPC_UE_ENABLE {
         u32 ipc_fifo_overflow_error_enable : 1;  // DWORD 0
         u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
         u32 ipc_eof_error_enable : 1;            // DWORD 0
         u32 ipc_sof_error_enable : 1;            // DWORD 0
         u32 ipc_overflow_error_enable : 1;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ep_fram_woor_error_enable : 1;       // DWORD 0
         u32 ep_iram_woor_error_enable : 1;       // DWORD 0
         u32 ep_prefetch_un_error_enable : 1;     // DWORD 0
         u32 ep_prefetch_ov_error_enable : 1;     // DWORD 0
         u32 ep_m2_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m2_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 ep_fw_ue_enable : 1;                 // DWORD 0
         u32 ep_stat_ram_perror_enable : 1;       // DWORD 0
         u32 ep_sram_perror_enable : 5;           // DWORD 0
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE, *PTXULP_EP_AND_IPC_UE_ENABLE;

      typedef union _TXULP_EP_AND_IPC_UE_ENABLE_UNION {
         TXULP_EP_AND_IPC_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE_UNION, *PTXULP_EP_AND_IPC_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_ENABLE_UNION, sizeof (TXULP_EP_AND_IPC_UE_ENABLE_UNION) == 4);
   #endif


#else
   // EP and IPC Unrecoverable Error Enable Register. Write a 1 to Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_AND_IPC_UE_ENABLE {
         union {
            struct { 
               u32 ep_sram_perror_enable : 5;     // DWORD 0
               u32 ep_stat_ram_perror_enable : 1; // DWORD 0
               u32 ep_fw_ue_enable : 1;           // DWORD 0
               u32 ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
               u32 ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_wbp_chk_un_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m0_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m1_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_ov_error_enable : 1; // DWORD 0
               u32 ep_m2_mem_wb_un_error_enable : 1; // DWORD 0
               u32 ep_prefetch_ov_error_enable : 1; // DWORD 0
               u32 ep_prefetch_un_error_enable : 1; // DWORD 0
               u32 ep_iram_woor_error_enable : 1; // DWORD 0
               u32 ep_fram_woor_error_enable : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 ipc_overflow_error_enable : 1; // DWORD 0
               u32 ipc_sof_error_enable : 1;      // DWORD 0
               u32 ipc_eof_error_enable : 1;      // DWORD 0
               u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
               u32 ipc_fifo_overflow_error_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE, *PTXULP_EP_AND_IPC_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_ENABLE, sizeof (TXULP_EP_AND_IPC_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_EP_AND_IPC_UE_ENABLE {
         u32 ep_sram_perror_enable : 5;           // DWORD 0
         u32 ep_stat_ram_perror_enable : 1;       // DWORD 0
         u32 ep_fw_ue_enable : 1;                 // DWORD 0
         u32 ep_unload_sync_fifo_overrun_error_enable : 1; // DWORD 0
         u32 ep_unload_sync_fifo_underrun_error_enable : 1; // DWORD 0
         u32 ep_m0_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m0_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m1_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_ov_error_enable : 1;   // DWORD 0
         u32 ep_m2_wbp_chk_un_error_enable : 1;   // DWORD 0
         u32 ep_m0_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m0_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m1_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_ov_error_enable : 1;    // DWORD 0
         u32 ep_m2_mem_wb_un_error_enable : 1;    // DWORD 0
         u32 ep_prefetch_ov_error_enable : 1;     // DWORD 0
         u32 ep_prefetch_un_error_enable : 1;     // DWORD 0
         u32 ep_iram_woor_error_enable : 1;       // DWORD 0
         u32 ep_fram_woor_error_enable : 1;       // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 ipc_overflow_error_enable : 1;       // DWORD 0
         u32 ipc_sof_error_enable : 1;            // DWORD 0
         u32 ipc_eof_error_enable : 1;            // DWORD 0
         u32 ipc_fifo_underflow_error_enable : 1; // DWORD 0
         u32 ipc_fifo_overflow_error_enable : 1;  // DWORD 0
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE, *PTXULP_EP_AND_IPC_UE_ENABLE;

      typedef union _TXULP_EP_AND_IPC_UE_ENABLE_UNION {
         TXULP_EP_AND_IPC_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_AND_IPC_UE_ENABLE_UNION, *PTXULP_EP_AND_IPC_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_AND_IPC_UE_ENABLE_UNION, sizeof (TXULP_EP_AND_IPC_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 final_que_under_flow_status : 1; // DWORD 0
               u32 final_que_over_flow_status : 1; // DWORD 0
               u32 sched_2_que_under_flow_status : 1; // DWORD 0
               u32 sched_2_que_over_flow_status : 1; // DWORD 0
               u32 rxulp2_ooo_que_under_flow_status : 1; // DWORD 0
               u32 rxulp2_ooo_que_over_flow_status : 1; // DWORD 0
               u32 rxulp1_ooo_que_under_flow_status : 1; // DWORD 0
               u32 rxulp1_ooo_que_over_flow_status : 1; // DWORD 0
               u32 rxulp0_ooo_que_under_flow_status : 1; // DWORD 0
               u32 rxulp0_ooo_que_over_flow_status : 1; // DWORD 0
               u32 ep_que_under_flow_status : 1;  // DWORD 0
               u32 ep_que_over_flow_status : 1;   // DWORD 0
               u32 rxulp_norm_que_under_flow_status : 1; // DWORD 0
               u32 rxulp_norm_que_over_flow_status : 1; // DWORD 0
               u32 btlr_stor_que_under_flow_status : 1; // DWORD 0
               u32 btlr_stor_que_over_flow_status : 1; // DWORD 0
               u32 btlr_netw_que_under_flow_status : 1; // DWORD 0
               u32 btlr_netw_que_over_flow_status : 1; // DWORD 0
               u32 sched_1_que_under_flow_status : 1; // DWORD 0
               u32 sched_1_que_over_flow_status : 1; // DWORD 0
               u32 tpost_que_under_flow_status : 1; // DWORD 0
               u32 tpost_que_over_flow_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE, *PTXULP_CONSEL_ARB_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_SOURCE, sizeof (TXULP_CONSEL_ARB_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_UE_SOURCE {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 final_que_under_flow_status : 1;     // DWORD 0
         u32 final_que_over_flow_status : 1;      // DWORD 0
         u32 sched_2_que_under_flow_status : 1;   // DWORD 0
         u32 sched_2_que_over_flow_status : 1;    // DWORD 0
         u32 rxulp2_ooo_que_under_flow_status : 1; // DWORD 0
         u32 rxulp2_ooo_que_over_flow_status : 1; // DWORD 0
         u32 rxulp1_ooo_que_under_flow_status : 1; // DWORD 0
         u32 rxulp1_ooo_que_over_flow_status : 1; // DWORD 0
         u32 rxulp0_ooo_que_under_flow_status : 1; // DWORD 0
         u32 rxulp0_ooo_que_over_flow_status : 1; // DWORD 0
         u32 ep_que_under_flow_status : 1;        // DWORD 0
         u32 ep_que_over_flow_status : 1;         // DWORD 0
         u32 rxulp_norm_que_under_flow_status : 1; // DWORD 0
         u32 rxulp_norm_que_over_flow_status : 1; // DWORD 0
         u32 btlr_stor_que_under_flow_status : 1; // DWORD 0
         u32 btlr_stor_que_over_flow_status : 1;  // DWORD 0
         u32 btlr_netw_que_under_flow_status : 1; // DWORD 0
         u32 btlr_netw_que_over_flow_status : 1;  // DWORD 0
         u32 sched_1_que_under_flow_status : 1;   // DWORD 0
         u32 sched_1_que_over_flow_status : 1;    // DWORD 0
         u32 tpost_que_under_flow_status : 1;     // DWORD 0
         u32 tpost_que_over_flow_status : 1;      // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE, *PTXULP_CONSEL_ARB_UE_SOURCE;

      typedef union _TXULP_CONSEL_ARB_UE_SOURCE_UNION {
         TXULP_CONSEL_ARB_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE_UNION, *PTXULP_CONSEL_ARB_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_SOURCE_UNION, sizeof (TXULP_CONSEL_ARB_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_UE_SOURCE {
         union {
            struct { 
               u32 tpost_que_over_flow_status : 1; // DWORD 0
               u32 tpost_que_under_flow_status : 1; // DWORD 0
               u32 sched_1_que_over_flow_status : 1; // DWORD 0
               u32 sched_1_que_under_flow_status : 1; // DWORD 0
               u32 btlr_netw_que_over_flow_status : 1; // DWORD 0
               u32 btlr_netw_que_under_flow_status : 1; // DWORD 0
               u32 btlr_stor_que_over_flow_status : 1; // DWORD 0
               u32 btlr_stor_que_under_flow_status : 1; // DWORD 0
               u32 rxulp_norm_que_over_flow_status : 1; // DWORD 0
               u32 rxulp_norm_que_under_flow_status : 1; // DWORD 0
               u32 ep_que_over_flow_status : 1;   // DWORD 0
               u32 ep_que_under_flow_status : 1;  // DWORD 0
               u32 rxulp0_ooo_que_over_flow_status : 1; // DWORD 0
               u32 rxulp0_ooo_que_under_flow_status : 1; // DWORD 0
               u32 rxulp1_ooo_que_over_flow_status : 1; // DWORD 0
               u32 rxulp1_ooo_que_under_flow_status : 1; // DWORD 0
               u32 rxulp2_ooo_que_over_flow_status : 1; // DWORD 0
               u32 rxulp2_ooo_que_under_flow_status : 1; // DWORD 0
               u32 sched_2_que_over_flow_status : 1; // DWORD 0
               u32 sched_2_que_under_flow_status : 1; // DWORD 0
               u32 final_que_over_flow_status : 1; // DWORD 0
               u32 final_que_under_flow_status : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE, *PTXULP_CONSEL_ARB_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_SOURCE, sizeof (TXULP_CONSEL_ARB_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_UE_SOURCE {
         u32 tpost_que_over_flow_status : 1;      // DWORD 0
         u32 tpost_que_under_flow_status : 1;     // DWORD 0
         u32 sched_1_que_over_flow_status : 1;    // DWORD 0
         u32 sched_1_que_under_flow_status : 1;   // DWORD 0
         u32 btlr_netw_que_over_flow_status : 1;  // DWORD 0
         u32 btlr_netw_que_under_flow_status : 1; // DWORD 0
         u32 btlr_stor_que_over_flow_status : 1;  // DWORD 0
         u32 btlr_stor_que_under_flow_status : 1; // DWORD 0
         u32 rxulp_norm_que_over_flow_status : 1; // DWORD 0
         u32 rxulp_norm_que_under_flow_status : 1; // DWORD 0
         u32 ep_que_over_flow_status : 1;         // DWORD 0
         u32 ep_que_under_flow_status : 1;        // DWORD 0
         u32 rxulp0_ooo_que_over_flow_status : 1; // DWORD 0
         u32 rxulp0_ooo_que_under_flow_status : 1; // DWORD 0
         u32 rxulp1_ooo_que_over_flow_status : 1; // DWORD 0
         u32 rxulp1_ooo_que_under_flow_status : 1; // DWORD 0
         u32 rxulp2_ooo_que_over_flow_status : 1; // DWORD 0
         u32 rxulp2_ooo_que_under_flow_status : 1; // DWORD 0
         u32 sched_2_que_over_flow_status : 1;    // DWORD 0
         u32 sched_2_que_under_flow_status : 1;   // DWORD 0
         u32 final_que_over_flow_status : 1;      // DWORD 0
         u32 final_que_under_flow_status : 1;     // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE, *PTXULP_CONSEL_ARB_UE_SOURCE;

      typedef union _TXULP_CONSEL_ARB_UE_SOURCE_UNION {
         TXULP_CONSEL_ARB_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_UE_SOURCE_UNION, *PTXULP_CONSEL_ARB_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_SOURCE_UNION, sizeof (TXULP_CONSEL_ARB_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Unrecoverable Error Enable Register. Write a 1 to Enable
   // the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 final_que_under_flow_enable : 1; // DWORD 0
               u32 final_que_over_flow_enable : 1; // DWORD 0
               u32 sched_2_que_under_flow_enable : 1; // DWORD 0
               u32 sched_2_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp2_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp2_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp1_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp1_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp0_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp0_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 ep_que_under_flow_enable : 1;  // DWORD 0
               u32 ep_que_over_flow_enable : 1;   // DWORD 0
               u32 rxulp_norm_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp_norm_que_over_flow_enable : 1; // DWORD 0
               u32 btlr_stor_que_under_flow_enable : 1; // DWORD 0
               u32 btlr_stor_que_over_flow_enable : 1; // DWORD 0
               u32 btlr_netw_que_under_flow_enable : 1; // DWORD 0
               u32 btlr_netw_que_over_flow_enable : 1; // DWORD 0
               u32 sched_1_que_under_flow_enable : 1; // DWORD 0
               u32 sched_1_que_over_flow_enable : 1; // DWORD 0
               u32 tpost_que_under_flow_enable : 1; // DWORD 0
               u32 tpost_que_over_flow_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE, *PTXULP_CONSEL_ARB_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_ENABLE, sizeof (TXULP_CONSEL_ARB_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_UE_ENABLE {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 final_que_under_flow_enable : 1;     // DWORD 0
         u32 final_que_over_flow_enable : 1;      // DWORD 0
         u32 sched_2_que_under_flow_enable : 1;   // DWORD 0
         u32 sched_2_que_over_flow_enable : 1;    // DWORD 0
         u32 rxulp2_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp2_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp1_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp1_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp0_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp0_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 ep_que_under_flow_enable : 1;        // DWORD 0
         u32 ep_que_over_flow_enable : 1;         // DWORD 0
         u32 rxulp_norm_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp_norm_que_over_flow_enable : 1; // DWORD 0
         u32 btlr_stor_que_under_flow_enable : 1; // DWORD 0
         u32 btlr_stor_que_over_flow_enable : 1;  // DWORD 0
         u32 btlr_netw_que_under_flow_enable : 1; // DWORD 0
         u32 btlr_netw_que_over_flow_enable : 1;  // DWORD 0
         u32 sched_1_que_under_flow_enable : 1;   // DWORD 0
         u32 sched_1_que_over_flow_enable : 1;    // DWORD 0
         u32 tpost_que_under_flow_enable : 1;     // DWORD 0
         u32 tpost_que_over_flow_enable : 1;      // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE, *PTXULP_CONSEL_ARB_UE_ENABLE;

      typedef union _TXULP_CONSEL_ARB_UE_ENABLE_UNION {
         TXULP_CONSEL_ARB_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE_UNION, *PTXULP_CONSEL_ARB_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_ENABLE_UNION, sizeof (TXULP_CONSEL_ARB_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Unrecoverable Error Enable Register. Write a 1 to Enable
   // the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_UE_ENABLE {
         union {
            struct { 
               u32 tpost_que_over_flow_enable : 1; // DWORD 0
               u32 tpost_que_under_flow_enable : 1; // DWORD 0
               u32 sched_1_que_over_flow_enable : 1; // DWORD 0
               u32 sched_1_que_under_flow_enable : 1; // DWORD 0
               u32 btlr_netw_que_over_flow_enable : 1; // DWORD 0
               u32 btlr_netw_que_under_flow_enable : 1; // DWORD 0
               u32 btlr_stor_que_over_flow_enable : 1; // DWORD 0
               u32 btlr_stor_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp_norm_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp_norm_que_under_flow_enable : 1; // DWORD 0
               u32 ep_que_over_flow_enable : 1;   // DWORD 0
               u32 ep_que_under_flow_enable : 1;  // DWORD 0
               u32 rxulp0_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp0_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp1_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp1_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 rxulp2_ooo_que_over_flow_enable : 1; // DWORD 0
               u32 rxulp2_ooo_que_under_flow_enable : 1; // DWORD 0
               u32 sched_2_que_over_flow_enable : 1; // DWORD 0
               u32 sched_2_que_under_flow_enable : 1; // DWORD 0
               u32 final_que_over_flow_enable : 1; // DWORD 0
               u32 final_que_under_flow_enable : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE, *PTXULP_CONSEL_ARB_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_ENABLE, sizeof (TXULP_CONSEL_ARB_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_UE_ENABLE {
         u32 tpost_que_over_flow_enable : 1;      // DWORD 0
         u32 tpost_que_under_flow_enable : 1;     // DWORD 0
         u32 sched_1_que_over_flow_enable : 1;    // DWORD 0
         u32 sched_1_que_under_flow_enable : 1;   // DWORD 0
         u32 btlr_netw_que_over_flow_enable : 1;  // DWORD 0
         u32 btlr_netw_que_under_flow_enable : 1; // DWORD 0
         u32 btlr_stor_que_over_flow_enable : 1;  // DWORD 0
         u32 btlr_stor_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp_norm_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp_norm_que_under_flow_enable : 1; // DWORD 0
         u32 ep_que_over_flow_enable : 1;         // DWORD 0
         u32 ep_que_under_flow_enable : 1;        // DWORD 0
         u32 rxulp0_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp0_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp1_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp1_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 rxulp2_ooo_que_over_flow_enable : 1; // DWORD 0
         u32 rxulp2_ooo_que_under_flow_enable : 1; // DWORD 0
         u32 sched_2_que_over_flow_enable : 1;    // DWORD 0
         u32 sched_2_que_under_flow_enable : 1;   // DWORD 0
         u32 final_que_over_flow_enable : 1;      // DWORD 0
         u32 final_que_under_flow_enable : 1;     // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE, *PTXULP_CONSEL_ARB_UE_ENABLE;

      typedef union _TXULP_CONSEL_ARB_UE_ENABLE_UNION {
         TXULP_CONSEL_ARB_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_UE_ENABLE_UNION, *PTXULP_CONSEL_ARB_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_UE_ENABLE_UNION, sizeof (TXULP_CONSEL_ARB_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Selector Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SEL_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 sel_in_buf_under_flow_status : 1; // DWORD 0
               u32 sel_in_buf_over_flow_status : 1; // DWORD 0
               u32 sched_buf_under_flow_status : 1; // DWORD 0
               u32 sched_buf_over_flow_status : 1; // DWORD 0
               u32 g_bit_ram_perr_status : 1;     // DWORD 0
               u32 r_bit_ram_perr_status : 1;     // DWORD 0
               u32 d_bit_ram_perr_status : 1;     // DWORD 0
               u32 c_bit_ram_perr_status : 1;     // DWORD 0
               u32 tpre_req_buf_under_flow_status : 1; // DWORD 0
               u32 tpre_req_buf_over_flow_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE, *PTXULP_CONSEL_SEL_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_SOURCE, sizeof (TXULP_CONSEL_SEL_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_CONSEL_SEL_UE_SOURCE {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 sel_in_buf_under_flow_status : 1;    // DWORD 0
         u32 sel_in_buf_over_flow_status : 1;     // DWORD 0
         u32 sched_buf_under_flow_status : 1;     // DWORD 0
         u32 sched_buf_over_flow_status : 1;      // DWORD 0
         u32 g_bit_ram_perr_status : 1;           // DWORD 0
         u32 r_bit_ram_perr_status : 1;           // DWORD 0
         u32 d_bit_ram_perr_status : 1;           // DWORD 0
         u32 c_bit_ram_perr_status : 1;           // DWORD 0
         u32 tpre_req_buf_under_flow_status : 1;  // DWORD 0
         u32 tpre_req_buf_over_flow_status : 1;   // DWORD 0
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE, *PTXULP_CONSEL_SEL_UE_SOURCE;

      typedef union _TXULP_CONSEL_SEL_UE_SOURCE_UNION {
         TXULP_CONSEL_SEL_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE_UNION, *PTXULP_CONSEL_SEL_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_SOURCE_UNION, sizeof (TXULP_CONSEL_SEL_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Connection Selector Selector Unrecoverable Error Sources Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SEL_UE_SOURCE {
         union {
            struct { 
               u32 tpre_req_buf_over_flow_status : 1; // DWORD 0
               u32 tpre_req_buf_under_flow_status : 1; // DWORD 0
               u32 c_bit_ram_perr_status : 1;     // DWORD 0
               u32 d_bit_ram_perr_status : 1;     // DWORD 0
               u32 r_bit_ram_perr_status : 1;     // DWORD 0
               u32 g_bit_ram_perr_status : 1;     // DWORD 0
               u32 sched_buf_over_flow_status : 1; // DWORD 0
               u32 sched_buf_under_flow_status : 1; // DWORD 0
               u32 sel_in_buf_over_flow_status : 1; // DWORD 0
               u32 sel_in_buf_under_flow_status : 1; // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE, *PTXULP_CONSEL_SEL_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_SOURCE, sizeof (TXULP_CONSEL_SEL_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_CONSEL_SEL_UE_SOURCE {
         u32 tpre_req_buf_over_flow_status : 1;   // DWORD 0
         u32 tpre_req_buf_under_flow_status : 1;  // DWORD 0
         u32 c_bit_ram_perr_status : 1;           // DWORD 0
         u32 d_bit_ram_perr_status : 1;           // DWORD 0
         u32 r_bit_ram_perr_status : 1;           // DWORD 0
         u32 g_bit_ram_perr_status : 1;           // DWORD 0
         u32 sched_buf_over_flow_status : 1;      // DWORD 0
         u32 sched_buf_under_flow_status : 1;     // DWORD 0
         u32 sel_in_buf_over_flow_status : 1;     // DWORD 0
         u32 sel_in_buf_under_flow_status : 1;    // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE, *PTXULP_CONSEL_SEL_UE_SOURCE;

      typedef union _TXULP_CONSEL_SEL_UE_SOURCE_UNION {
         TXULP_CONSEL_SEL_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SEL_UE_SOURCE_UNION, *PTXULP_CONSEL_SEL_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_SOURCE_UNION, sizeof (TXULP_CONSEL_SEL_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector, Selector Unrecoverable Error Enable Register. Write a 1 to
   // Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SEL_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 sel_in_buf_under_flow_enable : 1; // DWORD 0
               u32 sel_in_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_buf_over_flow_enable : 1; // DWORD 0
               u32 g_bit_ram_perr_enable : 1;     // DWORD 0
               u32 r_bit_ram_perr_enable : 1;     // DWORD 0
               u32 d_bit_ram_perr_enable : 1;     // DWORD 0
               u32 c_bit_ram_perr_enable : 1;     // DWORD 0
               u32 tpre_req_buf_under_flow_enable : 1; // DWORD 0
               u32 tpre_req_buf_over_flow_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE, *PTXULP_CONSEL_SEL_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_ENABLE, sizeof (TXULP_CONSEL_SEL_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_CONSEL_SEL_UE_ENABLE {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 sel_in_buf_under_flow_enable : 1;    // DWORD 0
         u32 sel_in_buf_over_flow_enable : 1;     // DWORD 0
         u32 sched_buf_under_flow_enable : 1;     // DWORD 0
         u32 sched_buf_over_flow_enable : 1;      // DWORD 0
         u32 g_bit_ram_perr_enable : 1;           // DWORD 0
         u32 r_bit_ram_perr_enable : 1;           // DWORD 0
         u32 d_bit_ram_perr_enable : 1;           // DWORD 0
         u32 c_bit_ram_perr_enable : 1;           // DWORD 0
         u32 tpre_req_buf_under_flow_enable : 1;  // DWORD 0
         u32 tpre_req_buf_over_flow_enable : 1;   // DWORD 0
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE, *PTXULP_CONSEL_SEL_UE_ENABLE;

      typedef union _TXULP_CONSEL_SEL_UE_ENABLE_UNION {
         TXULP_CONSEL_SEL_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE_UNION, *PTXULP_CONSEL_SEL_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_ENABLE_UNION, sizeof (TXULP_CONSEL_SEL_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Connection Selector, Selector Unrecoverable Error Enable Register. Write a 1 to
   // Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SEL_UE_ENABLE {
         union {
            struct { 
               u32 tpre_req_buf_over_flow_enable : 1; // DWORD 0
               u32 tpre_req_buf_under_flow_enable : 1; // DWORD 0
               u32 c_bit_ram_perr_enable : 1;     // DWORD 0
               u32 d_bit_ram_perr_enable : 1;     // DWORD 0
               u32 r_bit_ram_perr_enable : 1;     // DWORD 0
               u32 g_bit_ram_perr_enable : 1;     // DWORD 0
               u32 sched_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_buf_under_flow_enable : 1; // DWORD 0
               u32 sel_in_buf_over_flow_enable : 1; // DWORD 0
               u32 sel_in_buf_under_flow_enable : 1; // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE, *PTXULP_CONSEL_SEL_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_ENABLE, sizeof (TXULP_CONSEL_SEL_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_CONSEL_SEL_UE_ENABLE {
         u32 tpre_req_buf_over_flow_enable : 1;   // DWORD 0
         u32 tpre_req_buf_under_flow_enable : 1;  // DWORD 0
         u32 c_bit_ram_perr_enable : 1;           // DWORD 0
         u32 d_bit_ram_perr_enable : 1;           // DWORD 0
         u32 r_bit_ram_perr_enable : 1;           // DWORD 0
         u32 g_bit_ram_perr_enable : 1;           // DWORD 0
         u32 sched_buf_over_flow_enable : 1;      // DWORD 0
         u32 sched_buf_under_flow_enable : 1;     // DWORD 0
         u32 sel_in_buf_over_flow_enable : 1;     // DWORD 0
         u32 sel_in_buf_under_flow_enable : 1;    // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE, *PTXULP_CONSEL_SEL_UE_ENABLE;

      typedef union _TXULP_CONSEL_SEL_UE_ENABLE_UNION {
         TXULP_CONSEL_SEL_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SEL_UE_ENABLE_UNION, *PTXULP_CONSEL_SEL_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SEL_UE_ENABLE_UNION, sizeof (TXULP_CONSEL_SEL_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scheduler Unrecoverable Error Source ZERO Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_0 {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 resched_re_mw_buf_stg5_under_flow_status : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_over_flow_status : 1; // DWORD 0
               u32 build_buf_under_flow_status : 1; // DWORD 0
               u32 build_buf_over_flow_status : 1; // DWORD 0
               u32 resch_out_buf_stg5_under_flow_status : 1; // DWORD 0
               u32 resch_out_buf_stg5_over_flow_status : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 cra_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 cra_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 uc_resp_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 uc_resp_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 cra_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 cra_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg2_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg2_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg2_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg2_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg1_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg1_over_flow_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0, *PTXULP_SCHEDULER_UE_SOURCE_0;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_0, sizeof (TXULP_SCHEDULER_UE_SOURCE_0) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_0 {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 resched_re_mw_buf_stg5_under_flow_status : 1; // DWORD 0
         u32 resched_re_mw_buf_stg5_over_flow_status : 1; // DWORD 0
         u32 build_buf_under_flow_status : 1;     // DWORD 0
         u32 build_buf_over_flow_status : 1;      // DWORD 0
         u32 resch_out_buf_stg5_under_flow_status : 1; // DWORD 0
         u32 resch_out_buf_stg5_over_flow_status : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 cra_buf_stg4_under_flow_status : 1;  // DWORD 0
         u32 cra_buf_stg4_over_flow_status : 1;   // DWORD 0
         u32 toe_state_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 uc_resp_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 uc_resp_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 cra_buf_stg3_under_flow_status : 1;  // DWORD 0
         u32 cra_buf_stg3_over_flow_status : 1;   // DWORD 0
         u32 toe_state_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg2_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg2_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg2_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg2_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg1_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg1_over_flow_status : 1; // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0, *PTXULP_SCHEDULER_UE_SOURCE_0;

      typedef union _TXULP_SCHEDULER_UE_SOURCE_0_UNION {
         TXULP_SCHEDULER_UE_SOURCE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0_UNION, *PTXULP_SCHEDULER_UE_SOURCE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_0_UNION, sizeof (TXULP_SCHEDULER_UE_SOURCE_0_UNION) == 4);
   #endif


#else
   // Scheduler Unrecoverable Error Source ZERO Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_0 {
         union {
            struct { 
               u32 cs_in_buf_stg1_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg1_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg2_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg2_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg2_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg2_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 cra_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 cra_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 uc_resp_buf_stg3_over_flow_status : 1; // DWORD 0
               u32 uc_resp_buf_stg3_under_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 cs_in_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 toe_state_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 cra_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 cra_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_over_flow_status : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_under_flow_status : 1; // DWORD 0
               u32 resch_out_buf_stg5_over_flow_status : 1; // DWORD 0
               u32 resch_out_buf_stg5_under_flow_status : 1; // DWORD 0
               u32 build_buf_over_flow_status : 1; // DWORD 0
               u32 build_buf_under_flow_status : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_over_flow_status : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_under_flow_status : 1; // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0, *PTXULP_SCHEDULER_UE_SOURCE_0;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_0, sizeof (TXULP_SCHEDULER_UE_SOURCE_0) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_0 {
         u32 cs_in_buf_stg1_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg1_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg2_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg2_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg2_over_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg2_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 cra_buf_stg3_over_flow_status : 1;   // DWORD 0
         u32 cra_buf_stg3_under_flow_status : 1;  // DWORD 0
         u32 uc_resp_buf_stg3_over_flow_status : 1; // DWORD 0
         u32 uc_resp_buf_stg3_under_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 cs_in_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 toe_state_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 cra_buf_stg4_over_flow_status : 1;   // DWORD 0
         u32 cra_buf_stg4_under_flow_status : 1;  // DWORD 0
         u32 wrb_eth_buf_stg4_over_flow_status : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_under_flow_status : 1; // DWORD 0
         u32 resch_out_buf_stg5_over_flow_status : 1; // DWORD 0
         u32 resch_out_buf_stg5_under_flow_status : 1; // DWORD 0
         u32 build_buf_over_flow_status : 1;      // DWORD 0
         u32 build_buf_under_flow_status : 1;     // DWORD 0
         u32 resched_re_mw_buf_stg5_over_flow_status : 1; // DWORD 0
         u32 resched_re_mw_buf_stg5_under_flow_status : 1; // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0, *PTXULP_SCHEDULER_UE_SOURCE_0;

      typedef union _TXULP_SCHEDULER_UE_SOURCE_0_UNION {
         TXULP_SCHEDULER_UE_SOURCE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_0_UNION, *PTXULP_SCHEDULER_UE_SOURCE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_0_UNION, sizeof (TXULP_SCHEDULER_UE_SOURCE_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scheduler Unrecoverable Error Enable ZERO Register. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_0 {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 resched_re_mw_buf_stg5_under_flow_enable : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_over_flow_enable : 1; // DWORD 0
               u32 build_buf_under_flow_enable : 1; // DWORD 0
               u32 build_buf_over_flow_enable : 1; // DWORD 0
               u32 resch_out_buf_stg5_under_flow_enable : 1; // DWORD 0
               u32 resch_out_buf_stg5_over_flow_enable : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 uc_resp_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 uc_resp_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg2_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg2_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg2_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg2_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg1_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg1_over_flow_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0, *PTXULP_SCHEDULER_UE_ENABLE_0;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_0, sizeof (TXULP_SCHEDULER_UE_ENABLE_0) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_0 {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 resched_re_mw_buf_stg5_under_flow_enable : 1; // DWORD 0
         u32 resched_re_mw_buf_stg5_over_flow_enable : 1; // DWORD 0
         u32 build_buf_under_flow_enable : 1;     // DWORD 0
         u32 build_buf_over_flow_enable : 1;      // DWORD 0
         u32 resch_out_buf_stg5_under_flow_enable : 1; // DWORD 0
         u32 resch_out_buf_stg5_over_flow_enable : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 cra_buf_stg4_under_flow_enable : 1;  // DWORD 0
         u32 cra_buf_stg4_over_flow_enable : 1;   // DWORD 0
         u32 toe_state_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 uc_resp_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 uc_resp_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 cra_buf_stg3_under_flow_enable : 1;  // DWORD 0
         u32 cra_buf_stg3_over_flow_enable : 1;   // DWORD 0
         u32 toe_state_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg2_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg2_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg2_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg2_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg1_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg1_over_flow_enable : 1; // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0, *PTXULP_SCHEDULER_UE_ENABLE_0;

      typedef union _TXULP_SCHEDULER_UE_ENABLE_0_UNION {
         TXULP_SCHEDULER_UE_ENABLE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0_UNION, *PTXULP_SCHEDULER_UE_ENABLE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_0_UNION, sizeof (TXULP_SCHEDULER_UE_ENABLE_0_UNION) == 4);
   #endif


#else
   // Scheduler Unrecoverable Error Enable ZERO Register. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_0 {
         union {
            struct { 
               u32 cs_in_buf_stg1_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg1_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg2_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg2_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg2_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg2_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 uc_resp_buf_stg3_over_flow_enable : 1; // DWORD 0
               u32 uc_resp_buf_stg3_under_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 cs_in_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 toe_state_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 cra_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_over_flow_enable : 1; // DWORD 0
               u32 wrb_eth_buf_stg4_under_flow_enable : 1; // DWORD 0
               u32 resch_out_buf_stg5_over_flow_enable : 1; // DWORD 0
               u32 resch_out_buf_stg5_under_flow_enable : 1; // DWORD 0
               u32 build_buf_over_flow_enable : 1; // DWORD 0
               u32 build_buf_under_flow_enable : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_over_flow_enable : 1; // DWORD 0
               u32 resched_re_mw_buf_stg5_under_flow_enable : 1; // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0, *PTXULP_SCHEDULER_UE_ENABLE_0;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_0, sizeof (TXULP_SCHEDULER_UE_ENABLE_0) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_0 {
         u32 cs_in_buf_stg1_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg1_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg2_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg2_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg2_over_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg2_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 cra_buf_stg3_over_flow_enable : 1;   // DWORD 0
         u32 cra_buf_stg3_under_flow_enable : 1;  // DWORD 0
         u32 uc_resp_buf_stg3_over_flow_enable : 1; // DWORD 0
         u32 uc_resp_buf_stg3_under_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 cs_in_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 toe_state_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 cra_buf_stg4_over_flow_enable : 1;   // DWORD 0
         u32 cra_buf_stg4_under_flow_enable : 1;  // DWORD 0
         u32 wrb_eth_buf_stg4_over_flow_enable : 1; // DWORD 0
         u32 wrb_eth_buf_stg4_under_flow_enable : 1; // DWORD 0
         u32 resch_out_buf_stg5_over_flow_enable : 1; // DWORD 0
         u32 resch_out_buf_stg5_under_flow_enable : 1; // DWORD 0
         u32 build_buf_over_flow_enable : 1;      // DWORD 0
         u32 build_buf_under_flow_enable : 1;     // DWORD 0
         u32 resched_re_mw_buf_stg5_over_flow_enable : 1; // DWORD 0
         u32 resched_re_mw_buf_stg5_under_flow_enable : 1; // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0, *PTXULP_SCHEDULER_UE_ENABLE_0;

      typedef union _TXULP_SCHEDULER_UE_ENABLE_0_UNION {
         TXULP_SCHEDULER_UE_ENABLE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_0_UNION, *PTXULP_SCHEDULER_UE_ENABLE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_0_UNION, sizeof (TXULP_SCHEDULER_UE_ENABLE_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scheduler Unrecoverable Error Source ONE Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_1 {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 siq1_underflow_ue_status : 1;  // DWORD 0
               u32 siq1_overflow_ue_status : 1;   // DWORD 0
               u32 siq0_underflow_ue_status : 1;  // DWORD 0
               u32 siq0_overflow_ue_status : 1;   // DWORD 0
               u32 txpb_parity_ue_status : 1;     // DWORD 0
               u32 ctx_parity_ue_status : 1;      // DWORD 0
               u32 grnt_len_qos_up_buf_unf_status : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_ovf_status : 1; // DWORD 0
               u32 remain_qos_up_buf_unf_status : 1; // DWORD 0
               u32 remain_qos_up_buf_ovf_status : 1; // DWORD 0
               u32 loc_qos_ram_perr_status : 1;   // DWORD 0
               u32 loc_qos_ep_buf_underflow_err_status : 1; // DWORD 0
               u32 loc_qos_ep_buf_overflow_err_status : 1; // DWORD 0
               u32 loc_qos_ep_oq_frame_err_status : 1; // DWORD 0
               u32 class_iram_perr_status : 1;    // DWORD 0
               u32 tcpsch_uc_rel_recieved_err_status : 1; // DWORD 0
               u32 tcpsch_uc_rel_err_status : 1;  // DWORD 0
               u32 tcpsch_uc_wrb_req_err_status : 1; // DWORD 0
               u32 tcpsch_reth_chiprtran_err_status : 1; // DWORD 0
               u32 tcpsch_reth_rtran_err_status : 1; // DWORD 0
               u32 tcpsch_reth_chip_err_status : 1; // DWORD 0
               u32 build_buf_perr_status : 1;     // DWORD 0
               u32 tcp_state_ram_perr_status : 1; // DWORD 0
               u32 wrb_toe_stg4_perr_status : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1, *PTXULP_SCHEDULER_UE_SOURCE_1;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_1, sizeof (TXULP_SCHEDULER_UE_SOURCE_1) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_1 {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 siq1_underflow_ue_status : 1;        // DWORD 0
         u32 siq1_overflow_ue_status : 1;         // DWORD 0
         u32 siq0_underflow_ue_status : 1;        // DWORD 0
         u32 siq0_overflow_ue_status : 1;         // DWORD 0
         u32 txpb_parity_ue_status : 1;           // DWORD 0
         u32 ctx_parity_ue_status : 1;            // DWORD 0
         u32 grnt_len_qos_up_buf_unf_status : 1;  // DWORD 0
         u32 grnt_len_qos_up_buf_ovf_status : 1;  // DWORD 0
         u32 remain_qos_up_buf_unf_status : 1;    // DWORD 0
         u32 remain_qos_up_buf_ovf_status : 1;    // DWORD 0
         u32 loc_qos_ram_perr_status : 1;         // DWORD 0
         u32 loc_qos_ep_buf_underflow_err_status : 1; // DWORD 0
         u32 loc_qos_ep_buf_overflow_err_status : 1; // DWORD 0
         u32 loc_qos_ep_oq_frame_err_status : 1;  // DWORD 0
         u32 class_iram_perr_status : 1;          // DWORD 0
         u32 tcpsch_uc_rel_recieved_err_status : 1; // DWORD 0
         u32 tcpsch_uc_rel_err_status : 1;        // DWORD 0
         u32 tcpsch_uc_wrb_req_err_status : 1;    // DWORD 0
         u32 tcpsch_reth_chiprtran_err_status : 1; // DWORD 0
         u32 tcpsch_reth_rtran_err_status : 1;    // DWORD 0
         u32 tcpsch_reth_chip_err_status : 1;     // DWORD 0
         u32 build_buf_perr_status : 1;           // DWORD 0
         u32 tcp_state_ram_perr_status : 1;       // DWORD 0
         u32 wrb_toe_stg4_perr_status : 1;        // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1, *PTXULP_SCHEDULER_UE_SOURCE_1;

      typedef union _TXULP_SCHEDULER_UE_SOURCE_1_UNION {
         TXULP_SCHEDULER_UE_SOURCE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1_UNION, *PTXULP_SCHEDULER_UE_SOURCE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_1_UNION, sizeof (TXULP_SCHEDULER_UE_SOURCE_1_UNION) == 4);
   #endif


#else
   // Scheduler Unrecoverable Error Source ONE Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_1 {
         union {
            struct { 
               u32 wrb_toe_stg4_perr_status : 1;  // DWORD 0
               u32 tcp_state_ram_perr_status : 1; // DWORD 0
               u32 build_buf_perr_status : 1;     // DWORD 0
               u32 tcpsch_reth_chip_err_status : 1; // DWORD 0
               u32 tcpsch_reth_rtran_err_status : 1; // DWORD 0
               u32 tcpsch_reth_chiprtran_err_status : 1; // DWORD 0
               u32 tcpsch_uc_wrb_req_err_status : 1; // DWORD 0
               u32 tcpsch_uc_rel_err_status : 1;  // DWORD 0
               u32 tcpsch_uc_rel_recieved_err_status : 1; // DWORD 0
               u32 class_iram_perr_status : 1;    // DWORD 0
               u32 loc_qos_ep_oq_frame_err_status : 1; // DWORD 0
               u32 loc_qos_ep_buf_overflow_err_status : 1; // DWORD 0
               u32 loc_qos_ep_buf_underflow_err_status : 1; // DWORD 0
               u32 loc_qos_ram_perr_status : 1;   // DWORD 0
               u32 remain_qos_up_buf_ovf_status : 1; // DWORD 0
               u32 remain_qos_up_buf_unf_status : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_ovf_status : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_unf_status : 1; // DWORD 0
               u32 ctx_parity_ue_status : 1;      // DWORD 0
               u32 txpb_parity_ue_status : 1;     // DWORD 0
               u32 siq0_overflow_ue_status : 1;   // DWORD 0
               u32 siq0_underflow_ue_status : 1;  // DWORD 0
               u32 siq1_overflow_ue_status : 1;   // DWORD 0
               u32 siq1_underflow_ue_status : 1;  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1, *PTXULP_SCHEDULER_UE_SOURCE_1;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_1, sizeof (TXULP_SCHEDULER_UE_SOURCE_1) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_SOURCE_1 {
         u32 wrb_toe_stg4_perr_status : 1;        // DWORD 0
         u32 tcp_state_ram_perr_status : 1;       // DWORD 0
         u32 build_buf_perr_status : 1;           // DWORD 0
         u32 tcpsch_reth_chip_err_status : 1;     // DWORD 0
         u32 tcpsch_reth_rtran_err_status : 1;    // DWORD 0
         u32 tcpsch_reth_chiprtran_err_status : 1; // DWORD 0
         u32 tcpsch_uc_wrb_req_err_status : 1;    // DWORD 0
         u32 tcpsch_uc_rel_err_status : 1;        // DWORD 0
         u32 tcpsch_uc_rel_recieved_err_status : 1; // DWORD 0
         u32 class_iram_perr_status : 1;          // DWORD 0
         u32 loc_qos_ep_oq_frame_err_status : 1;  // DWORD 0
         u32 loc_qos_ep_buf_overflow_err_status : 1; // DWORD 0
         u32 loc_qos_ep_buf_underflow_err_status : 1; // DWORD 0
         u32 loc_qos_ram_perr_status : 1;         // DWORD 0
         u32 remain_qos_up_buf_ovf_status : 1;    // DWORD 0
         u32 remain_qos_up_buf_unf_status : 1;    // DWORD 0
         u32 grnt_len_qos_up_buf_ovf_status : 1;  // DWORD 0
         u32 grnt_len_qos_up_buf_unf_status : 1;  // DWORD 0
         u32 ctx_parity_ue_status : 1;            // DWORD 0
         u32 txpb_parity_ue_status : 1;           // DWORD 0
         u32 siq0_overflow_ue_status : 1;         // DWORD 0
         u32 siq0_underflow_ue_status : 1;        // DWORD 0
         u32 siq1_overflow_ue_status : 1;         // DWORD 0
         u32 siq1_underflow_ue_status : 1;        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1, *PTXULP_SCHEDULER_UE_SOURCE_1;

      typedef union _TXULP_SCHEDULER_UE_SOURCE_1_UNION {
         TXULP_SCHEDULER_UE_SOURCE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_SOURCE_1_UNION, *PTXULP_SCHEDULER_UE_SOURCE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_SOURCE_1_UNION, sizeof (TXULP_SCHEDULER_UE_SOURCE_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Scheduler Unrecoverable Error Enable ONE Register. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_1 {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 siq1_underflow_ue_enable : 1;  // DWORD 0
               u32 siq1_overflow_ue_enable : 1;   // DWORD 0
               u32 siq0_underflow_ue_enable : 1;  // DWORD 0
               u32 siq0_overflow_ue_enable : 1;   // DWORD 0
               u32 txpb_parity_ue_enable : 1;     // DWORD 0
               u32 ctx_parity_ue_enable : 1;      // DWORD 0
               u32 grnt_len_qos_up_buf_unf_enable : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_ovf_enable : 1; // DWORD 0
               u32 remain_qos_up_buf_unf_enable : 1; // DWORD 0
               u32 remain_qos_up_buf_ovf_enable : 1; // DWORD 0
               u32 loc_qos_ram_perr_enable : 1;   // DWORD 0
               u32 loc_qos_ep_buf_underflow_err_enable : 1; // DWORD 0
               u32 loc_qos_ep_buf_overflow_err_enable : 1; // DWORD 0
               u32 loc_qos_ep_oq_frame_err_enable : 1; // DWORD 0
               u32 class_iram_perr_enable : 1;    // DWORD 0
               u32 tcpsch_uc_rel_recieved_err_enable : 1; // DWORD 0
               u32 tcpsch_uc_rel_err_enable : 1;  // DWORD 0
               u32 tcpsch_uc_wrb_req_err_enable : 1; // DWORD 0
               u32 tcpsch_reth_chiprtran_err_enable : 1; // DWORD 0
               u32 tcpsch_reth_rtran_err_enable : 1; // DWORD 0
               u32 tcpsch_reth_chip_err_enable : 1; // DWORD 0
               u32 build_buf_perr_enable : 1;     // DWORD 0
               u32 tcp_state_ram_perr_enable : 1; // DWORD 0
               u32 wrb_toe_stg4_perr_enable : 1;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1, *PTXULP_SCHEDULER_UE_ENABLE_1;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_1, sizeof (TXULP_SCHEDULER_UE_ENABLE_1) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_1 {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 siq1_underflow_ue_enable : 1;        // DWORD 0
         u32 siq1_overflow_ue_enable : 1;         // DWORD 0
         u32 siq0_underflow_ue_enable : 1;        // DWORD 0
         u32 siq0_overflow_ue_enable : 1;         // DWORD 0
         u32 txpb_parity_ue_enable : 1;           // DWORD 0
         u32 ctx_parity_ue_enable : 1;            // DWORD 0
         u32 grnt_len_qos_up_buf_unf_enable : 1;  // DWORD 0
         u32 grnt_len_qos_up_buf_ovf_enable : 1;  // DWORD 0
         u32 remain_qos_up_buf_unf_enable : 1;    // DWORD 0
         u32 remain_qos_up_buf_ovf_enable : 1;    // DWORD 0
         u32 loc_qos_ram_perr_enable : 1;         // DWORD 0
         u32 loc_qos_ep_buf_underflow_err_enable : 1; // DWORD 0
         u32 loc_qos_ep_buf_overflow_err_enable : 1; // DWORD 0
         u32 loc_qos_ep_oq_frame_err_enable : 1;  // DWORD 0
         u32 class_iram_perr_enable : 1;          // DWORD 0
         u32 tcpsch_uc_rel_recieved_err_enable : 1; // DWORD 0
         u32 tcpsch_uc_rel_err_enable : 1;        // DWORD 0
         u32 tcpsch_uc_wrb_req_err_enable : 1;    // DWORD 0
         u32 tcpsch_reth_chiprtran_err_enable : 1; // DWORD 0
         u32 tcpsch_reth_rtran_err_enable : 1;    // DWORD 0
         u32 tcpsch_reth_chip_err_enable : 1;     // DWORD 0
         u32 build_buf_perr_enable : 1;           // DWORD 0
         u32 tcp_state_ram_perr_enable : 1;       // DWORD 0
         u32 wrb_toe_stg4_perr_enable : 1;        // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1, *PTXULP_SCHEDULER_UE_ENABLE_1;

      typedef union _TXULP_SCHEDULER_UE_ENABLE_1_UNION {
         TXULP_SCHEDULER_UE_ENABLE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1_UNION, *PTXULP_SCHEDULER_UE_ENABLE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_1_UNION, sizeof (TXULP_SCHEDULER_UE_ENABLE_1_UNION) == 4);
   #endif


#else
   // Scheduler Unrecoverable Error Enable ONE Register. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_1 {
         union {
            struct { 
               u32 wrb_toe_stg4_perr_enable : 1;  // DWORD 0
               u32 tcp_state_ram_perr_enable : 1; // DWORD 0
               u32 build_buf_perr_enable : 1;     // DWORD 0
               u32 tcpsch_reth_chip_err_enable : 1; // DWORD 0
               u32 tcpsch_reth_rtran_err_enable : 1; // DWORD 0
               u32 tcpsch_reth_chiprtran_err_enable : 1; // DWORD 0
               u32 tcpsch_uc_wrb_req_err_enable : 1; // DWORD 0
               u32 tcpsch_uc_rel_err_enable : 1;  // DWORD 0
               u32 tcpsch_uc_rel_recieved_err_enable : 1; // DWORD 0
               u32 class_iram_perr_enable : 1;    // DWORD 0
               u32 loc_qos_ep_oq_frame_err_enable : 1; // DWORD 0
               u32 loc_qos_ep_buf_overflow_err_enable : 1; // DWORD 0
               u32 loc_qos_ep_buf_underflow_err_enable : 1; // DWORD 0
               u32 loc_qos_ram_perr_enable : 1;   // DWORD 0
               u32 remain_qos_up_buf_ovf_enable : 1; // DWORD 0
               u32 remain_qos_up_buf_unf_enable : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_ovf_enable : 1; // DWORD 0
               u32 grnt_len_qos_up_buf_unf_enable : 1; // DWORD 0
               u32 ctx_parity_ue_enable : 1;      // DWORD 0
               u32 txpb_parity_ue_enable : 1;     // DWORD 0
               u32 siq0_overflow_ue_enable : 1;   // DWORD 0
               u32 siq0_underflow_ue_enable : 1;  // DWORD 0
               u32 siq1_overflow_ue_enable : 1;   // DWORD 0
               u32 siq1_underflow_ue_enable : 1;  // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1, *PTXULP_SCHEDULER_UE_ENABLE_1;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_1, sizeof (TXULP_SCHEDULER_UE_ENABLE_1) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_UE_ENABLE_1 {
         u32 wrb_toe_stg4_perr_enable : 1;        // DWORD 0
         u32 tcp_state_ram_perr_enable : 1;       // DWORD 0
         u32 build_buf_perr_enable : 1;           // DWORD 0
         u32 tcpsch_reth_chip_err_enable : 1;     // DWORD 0
         u32 tcpsch_reth_rtran_err_enable : 1;    // DWORD 0
         u32 tcpsch_reth_chiprtran_err_enable : 1; // DWORD 0
         u32 tcpsch_uc_wrb_req_err_enable : 1;    // DWORD 0
         u32 tcpsch_uc_rel_err_enable : 1;        // DWORD 0
         u32 tcpsch_uc_rel_recieved_err_enable : 1; // DWORD 0
         u32 class_iram_perr_enable : 1;          // DWORD 0
         u32 loc_qos_ep_oq_frame_err_enable : 1;  // DWORD 0
         u32 loc_qos_ep_buf_overflow_err_enable : 1; // DWORD 0
         u32 loc_qos_ep_buf_underflow_err_enable : 1; // DWORD 0
         u32 loc_qos_ram_perr_enable : 1;         // DWORD 0
         u32 remain_qos_up_buf_ovf_enable : 1;    // DWORD 0
         u32 remain_qos_up_buf_unf_enable : 1;    // DWORD 0
         u32 grnt_len_qos_up_buf_ovf_enable : 1;  // DWORD 0
         u32 grnt_len_qos_up_buf_unf_enable : 1;  // DWORD 0
         u32 ctx_parity_ue_enable : 1;            // DWORD 0
         u32 txpb_parity_ue_enable : 1;           // DWORD 0
         u32 siq0_overflow_ue_enable : 1;         // DWORD 0
         u32 siq0_underflow_ue_enable : 1;        // DWORD 0
         u32 siq1_overflow_ue_enable : 1;         // DWORD 0
         u32 siq1_underflow_ue_enable : 1;        // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1, *PTXULP_SCHEDULER_UE_ENABLE_1;

      typedef union _TXULP_SCHEDULER_UE_ENABLE_1_UNION {
         TXULP_SCHEDULER_UE_ENABLE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_UE_ENABLE_1_UNION, *PTXULP_SCHEDULER_UE_ENABLE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_UE_ENABLE_1_UNION, sizeof (TXULP_SCHEDULER_UE_ENABLE_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Unrecoverable Error Source Register 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_0 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 mpu_update_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_update_buf_over_flow_status : 1; // DWORD 0
               u32 txp_update_buf_under_flow_status : 1; // DWORD 0
               u32 txp_update_buf_over_flow_status : 1; // DWORD 0
               u32 shed_ret_buf_under_flow_status : 1; // DWORD 0
               u32 shed_ret_buf_over_flow_status : 1; // DWORD 0
               u32 sched_req_wrb_retrun_buf_under_flow_status : 1; // DWORD 0
               u32 sched_req_wrb_return_buf_over_flow_status : 1; // DWORD 0
               u32 sched_req_setup_buf_under_flow_status : 1; // DWORD 0
               u32 sched_req_setup_buf_over_flow_status : 1; // DWORD 0
               u32 mpu_req_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_req_buf_over_flow_status : 1; // DWORD 0
               u32 shed_req_buf_under_flow_status : 1; // DWORD 0
               u32 shed_req_buf_over_flow_status : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_under_flow_status : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_wr_done_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_wr_done_buf_over_flow_status : 1; // DWORD 0
               u32 uc_in_buf_under_flow_status : 1; // DWORD 0
               u32 uc_in_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_out_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_out_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_in_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_in_buf_over_flow_status : 1; // DWORD 0
               u32 stat_state_buf_under_flow_status : 1; // DWORD 0
               u32 stat_state_buf_over_flow_status : 1; // DWORD 0
               u32 mpu_entry_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_entry_buf_over_flow_status : 1; // DWORD 0
               u32 sched_entry_buf_under_flow_status : 1; // DWORD 0
               u32 sched_entry_buf_over_flow_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0, *PTXULP_RING_MANAGER_UE_SOURCE_0;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_0, sizeof (TXULP_RING_MANAGER_UE_SOURCE_0) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_0 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 mpu_update_buf_under_flow_status : 1; // DWORD 0
         u32 mpu_update_buf_over_flow_status : 1; // DWORD 0
         u32 txp_update_buf_under_flow_status : 1; // DWORD 0
         u32 txp_update_buf_over_flow_status : 1; // DWORD 0
         u32 shed_ret_buf_under_flow_status : 1;  // DWORD 0
         u32 shed_ret_buf_over_flow_status : 1;   // DWORD 0
         u32 sched_req_wrb_retrun_buf_under_flow_status : 1; // DWORD 0
         u32 sched_req_wrb_return_buf_over_flow_status : 1; // DWORD 0
         u32 sched_req_setup_buf_under_flow_status : 1; // DWORD 0
         u32 sched_req_setup_buf_over_flow_status : 1; // DWORD 0
         u32 mpu_req_buf_under_flow_status : 1;   // DWORD 0
         u32 mpu_req_buf_over_flow_status : 1;    // DWORD 0
         u32 shed_req_buf_under_flow_status : 1;  // DWORD 0
         u32 shed_req_buf_over_flow_status : 1;   // DWORD 0
         u32 uc_resp_ring_num_buf_under_flow_status : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_over_flow_status : 1; // DWORD 0
         u32 dbuf_wr_done_buf_under_flow_status : 1; // DWORD 0
         u32 dbuf_wr_done_buf_over_flow_status : 1; // DWORD 0
         u32 uc_in_buf_under_flow_status : 1;     // DWORD 0
         u32 uc_in_buf_over_flow_status : 1;      // DWORD 0
         u32 dbuf_out_buf_under_flow_status : 1;  // DWORD 0
         u32 dbuf_out_buf_over_flow_status : 1;   // DWORD 0
         u32 dbuf_in_buf_under_flow_status : 1;   // DWORD 0
         u32 dbuf_in_buf_over_flow_status : 1;    // DWORD 0
         u32 stat_state_buf_under_flow_status : 1; // DWORD 0
         u32 stat_state_buf_over_flow_status : 1; // DWORD 0
         u32 mpu_entry_buf_under_flow_status : 1; // DWORD 0
         u32 mpu_entry_buf_over_flow_status : 1;  // DWORD 0
         u32 sched_entry_buf_under_flow_status : 1; // DWORD 0
         u32 sched_entry_buf_over_flow_status : 1; // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0, *PTXULP_RING_MANAGER_UE_SOURCE_0;

      typedef union _TXULP_RING_MANAGER_UE_SOURCE_0_UNION {
         TXULP_RING_MANAGER_UE_SOURCE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0_UNION, *PTXULP_RING_MANAGER_UE_SOURCE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_0_UNION, sizeof (TXULP_RING_MANAGER_UE_SOURCE_0_UNION) == 4);
   #endif


#else
   // Ring Manager Unrecoverable Error Source Register 0.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_0 {
         union {
            struct { 
               u32 sched_entry_buf_over_flow_status : 1; // DWORD 0
               u32 sched_entry_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_entry_buf_over_flow_status : 1; // DWORD 0
               u32 mpu_entry_buf_under_flow_status : 1; // DWORD 0
               u32 stat_state_buf_over_flow_status : 1; // DWORD 0
               u32 stat_state_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_in_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_in_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_out_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_out_buf_under_flow_status : 1; // DWORD 0
               u32 uc_in_buf_over_flow_status : 1; // DWORD 0
               u32 uc_in_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_wr_done_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_wr_done_buf_under_flow_status : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_over_flow_status : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_under_flow_status : 1; // DWORD 0
               u32 shed_req_buf_over_flow_status : 1; // DWORD 0
               u32 shed_req_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_req_buf_over_flow_status : 1; // DWORD 0
               u32 mpu_req_buf_under_flow_status : 1; // DWORD 0
               u32 sched_req_setup_buf_over_flow_status : 1; // DWORD 0
               u32 sched_req_setup_buf_under_flow_status : 1; // DWORD 0
               u32 sched_req_wrb_return_buf_over_flow_status : 1; // DWORD 0
               u32 sched_req_wrb_retrun_buf_under_flow_status : 1; // DWORD 0
               u32 shed_ret_buf_over_flow_status : 1; // DWORD 0
               u32 shed_ret_buf_under_flow_status : 1; // DWORD 0
               u32 txp_update_buf_over_flow_status : 1; // DWORD 0
               u32 txp_update_buf_under_flow_status : 1; // DWORD 0
               u32 mpu_update_buf_over_flow_status : 1; // DWORD 0
               u32 mpu_update_buf_under_flow_status : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0, *PTXULP_RING_MANAGER_UE_SOURCE_0;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_0, sizeof (TXULP_RING_MANAGER_UE_SOURCE_0) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_0 {
         u32 sched_entry_buf_over_flow_status : 1; // DWORD 0
         u32 sched_entry_buf_under_flow_status : 1; // DWORD 0
         u32 mpu_entry_buf_over_flow_status : 1;  // DWORD 0
         u32 mpu_entry_buf_under_flow_status : 1; // DWORD 0
         u32 stat_state_buf_over_flow_status : 1; // DWORD 0
         u32 stat_state_buf_under_flow_status : 1; // DWORD 0
         u32 dbuf_in_buf_over_flow_status : 1;    // DWORD 0
         u32 dbuf_in_buf_under_flow_status : 1;   // DWORD 0
         u32 dbuf_out_buf_over_flow_status : 1;   // DWORD 0
         u32 dbuf_out_buf_under_flow_status : 1;  // DWORD 0
         u32 uc_in_buf_over_flow_status : 1;      // DWORD 0
         u32 uc_in_buf_under_flow_status : 1;     // DWORD 0
         u32 dbuf_wr_done_buf_over_flow_status : 1; // DWORD 0
         u32 dbuf_wr_done_buf_under_flow_status : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_over_flow_status : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_under_flow_status : 1; // DWORD 0
         u32 shed_req_buf_over_flow_status : 1;   // DWORD 0
         u32 shed_req_buf_under_flow_status : 1;  // DWORD 0
         u32 mpu_req_buf_over_flow_status : 1;    // DWORD 0
         u32 mpu_req_buf_under_flow_status : 1;   // DWORD 0
         u32 sched_req_setup_buf_over_flow_status : 1; // DWORD 0
         u32 sched_req_setup_buf_under_flow_status : 1; // DWORD 0
         u32 sched_req_wrb_return_buf_over_flow_status : 1; // DWORD 0
         u32 sched_req_wrb_retrun_buf_under_flow_status : 1; // DWORD 0
         u32 shed_ret_buf_over_flow_status : 1;   // DWORD 0
         u32 shed_ret_buf_under_flow_status : 1;  // DWORD 0
         u32 txp_update_buf_over_flow_status : 1; // DWORD 0
         u32 txp_update_buf_under_flow_status : 1; // DWORD 0
         u32 mpu_update_buf_over_flow_status : 1; // DWORD 0
         u32 mpu_update_buf_under_flow_status : 1; // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0, *PTXULP_RING_MANAGER_UE_SOURCE_0;

      typedef union _TXULP_RING_MANAGER_UE_SOURCE_0_UNION {
         TXULP_RING_MANAGER_UE_SOURCE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_0_UNION, *PTXULP_RING_MANAGER_UE_SOURCE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_0_UNION, sizeof (TXULP_RING_MANAGER_UE_SOURCE_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Unrecoverable Error Enable Register 0. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_0 {
         union {
            struct { 
               u32 rsvd0 : 2;                     // DWORD 0
               u32 mpu_update_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_update_buf_over_flow_enable : 1; // DWORD 0
               u32 txp_update_buf_under_flow_enable : 1; // DWORD 0
               u32 txp_update_buf_over_flow_enable : 1; // DWORD 0
               u32 shed_ret_buf_under_flow_enable : 1; // DWORD 0
               u32 shed_ret_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_req_wrb_retrun_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_req_wrb_return_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_req_setup_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_req_setup_buf_over_flow_enable : 1; // DWORD 0
               u32 mpu_req_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_req_buf_over_flow_enable : 1; // DWORD 0
               u32 shed_req_buf_under_flow_enable : 1; // DWORD 0
               u32 shed_req_buf_over_flow_enable : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_wr_done_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_wr_done_buf_over_flow_enable : 1; // DWORD 0
               u32 uc_in_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_in_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_out_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_out_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_in_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_in_buf_over_flow_enable : 1; // DWORD 0
               u32 stat_state_buf_under_flow_enable : 1; // DWORD 0
               u32 stat_state_buf_over_flow_enable : 1; // DWORD 0
               u32 mpu_entry_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_entry_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_entry_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_entry_buf_over_flow_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0, *PTXULP_RING_MANAGER_UE_ENABLE_0;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_0, sizeof (TXULP_RING_MANAGER_UE_ENABLE_0) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_0 {
         u32 rsvd0 : 2;                           // DWORD 0
         u32 mpu_update_buf_under_flow_enable : 1; // DWORD 0
         u32 mpu_update_buf_over_flow_enable : 1; // DWORD 0
         u32 txp_update_buf_under_flow_enable : 1; // DWORD 0
         u32 txp_update_buf_over_flow_enable : 1; // DWORD 0
         u32 shed_ret_buf_under_flow_enable : 1;  // DWORD 0
         u32 shed_ret_buf_over_flow_enable : 1;   // DWORD 0
         u32 sched_req_wrb_retrun_buf_under_flow_enable : 1; // DWORD 0
         u32 sched_req_wrb_return_buf_over_flow_enable : 1; // DWORD 0
         u32 sched_req_setup_buf_under_flow_enable : 1; // DWORD 0
         u32 sched_req_setup_buf_over_flow_enable : 1; // DWORD 0
         u32 mpu_req_buf_under_flow_enable : 1;   // DWORD 0
         u32 mpu_req_buf_over_flow_enable : 1;    // DWORD 0
         u32 shed_req_buf_under_flow_enable : 1;  // DWORD 0
         u32 shed_req_buf_over_flow_enable : 1;   // DWORD 0
         u32 uc_resp_ring_num_buf_under_flow_enable : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_over_flow_enable : 1; // DWORD 0
         u32 dbuf_wr_done_buf_under_flow_enable : 1; // DWORD 0
         u32 dbuf_wr_done_buf_over_flow_enable : 1; // DWORD 0
         u32 uc_in_buf_under_flow_enable : 1;     // DWORD 0
         u32 uc_in_buf_over_flow_enable : 1;      // DWORD 0
         u32 dbuf_out_buf_under_flow_enable : 1;  // DWORD 0
         u32 dbuf_out_buf_over_flow_enable : 1;   // DWORD 0
         u32 dbuf_in_buf_under_flow_enable : 1;   // DWORD 0
         u32 dbuf_in_buf_over_flow_enable : 1;    // DWORD 0
         u32 stat_state_buf_under_flow_enable : 1; // DWORD 0
         u32 stat_state_buf_over_flow_enable : 1; // DWORD 0
         u32 mpu_entry_buf_under_flow_enable : 1; // DWORD 0
         u32 mpu_entry_buf_over_flow_enable : 1;  // DWORD 0
         u32 sched_entry_buf_under_flow_enable : 1; // DWORD 0
         u32 sched_entry_buf_over_flow_enable : 1; // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0, *PTXULP_RING_MANAGER_UE_ENABLE_0;

      typedef union _TXULP_RING_MANAGER_UE_ENABLE_0_UNION {
         TXULP_RING_MANAGER_UE_ENABLE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0_UNION, *PTXULP_RING_MANAGER_UE_ENABLE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_0_UNION, sizeof (TXULP_RING_MANAGER_UE_ENABLE_0_UNION) == 4);
   #endif


#else
   // Ring Manager Unrecoverable Error Enable Register 0. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_0 {
         union {
            struct { 
               u32 sched_entry_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_entry_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_entry_buf_over_flow_enable : 1; // DWORD 0
               u32 mpu_entry_buf_under_flow_enable : 1; // DWORD 0
               u32 stat_state_buf_over_flow_enable : 1; // DWORD 0
               u32 stat_state_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_in_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_in_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_out_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_out_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_in_buf_over_flow_enable : 1; // DWORD 0
               u32 uc_in_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_wr_done_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_wr_done_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_over_flow_enable : 1; // DWORD 0
               u32 uc_resp_ring_num_buf_under_flow_enable : 1; // DWORD 0
               u32 shed_req_buf_over_flow_enable : 1; // DWORD 0
               u32 shed_req_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_req_buf_over_flow_enable : 1; // DWORD 0
               u32 mpu_req_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_req_setup_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_req_setup_buf_under_flow_enable : 1; // DWORD 0
               u32 sched_req_wrb_return_buf_over_flow_enable : 1; // DWORD 0
               u32 sched_req_wrb_retrun_buf_under_flow_enable : 1; // DWORD 0
               u32 shed_ret_buf_over_flow_enable : 1; // DWORD 0
               u32 shed_ret_buf_under_flow_enable : 1; // DWORD 0
               u32 txp_update_buf_over_flow_enable : 1; // DWORD 0
               u32 txp_update_buf_under_flow_enable : 1; // DWORD 0
               u32 mpu_update_buf_over_flow_enable : 1; // DWORD 0
               u32 mpu_update_buf_under_flow_enable : 1; // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0, *PTXULP_RING_MANAGER_UE_ENABLE_0;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_0, sizeof (TXULP_RING_MANAGER_UE_ENABLE_0) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_0 {
         u32 sched_entry_buf_over_flow_enable : 1; // DWORD 0
         u32 sched_entry_buf_under_flow_enable : 1; // DWORD 0
         u32 mpu_entry_buf_over_flow_enable : 1;  // DWORD 0
         u32 mpu_entry_buf_under_flow_enable : 1; // DWORD 0
         u32 stat_state_buf_over_flow_enable : 1; // DWORD 0
         u32 stat_state_buf_under_flow_enable : 1; // DWORD 0
         u32 dbuf_in_buf_over_flow_enable : 1;    // DWORD 0
         u32 dbuf_in_buf_under_flow_enable : 1;   // DWORD 0
         u32 dbuf_out_buf_over_flow_enable : 1;   // DWORD 0
         u32 dbuf_out_buf_under_flow_enable : 1;  // DWORD 0
         u32 uc_in_buf_over_flow_enable : 1;      // DWORD 0
         u32 uc_in_buf_under_flow_enable : 1;     // DWORD 0
         u32 dbuf_wr_done_buf_over_flow_enable : 1; // DWORD 0
         u32 dbuf_wr_done_buf_under_flow_enable : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_over_flow_enable : 1; // DWORD 0
         u32 uc_resp_ring_num_buf_under_flow_enable : 1; // DWORD 0
         u32 shed_req_buf_over_flow_enable : 1;   // DWORD 0
         u32 shed_req_buf_under_flow_enable : 1;  // DWORD 0
         u32 mpu_req_buf_over_flow_enable : 1;    // DWORD 0
         u32 mpu_req_buf_under_flow_enable : 1;   // DWORD 0
         u32 sched_req_setup_buf_over_flow_enable : 1; // DWORD 0
         u32 sched_req_setup_buf_under_flow_enable : 1; // DWORD 0
         u32 sched_req_wrb_return_buf_over_flow_enable : 1; // DWORD 0
         u32 sched_req_wrb_retrun_buf_under_flow_enable : 1; // DWORD 0
         u32 shed_ret_buf_over_flow_enable : 1;   // DWORD 0
         u32 shed_ret_buf_under_flow_enable : 1;  // DWORD 0
         u32 txp_update_buf_over_flow_enable : 1; // DWORD 0
         u32 txp_update_buf_under_flow_enable : 1; // DWORD 0
         u32 mpu_update_buf_over_flow_enable : 1; // DWORD 0
         u32 mpu_update_buf_under_flow_enable : 1; // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0, *PTXULP_RING_MANAGER_UE_ENABLE_0;

      typedef union _TXULP_RING_MANAGER_UE_ENABLE_0_UNION {
         TXULP_RING_MANAGER_UE_ENABLE_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_0_UNION, *PTXULP_RING_MANAGER_UE_ENABLE_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_0_UNION, sizeof (TXULP_RING_MANAGER_UE_ENABLE_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Unrecoverable Error Source Register 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_1 {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 tot_length_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
               u32 num_wrbs_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
               u32 eth_num_wrb_odd_ue_status : 1; // DWORD 0
               u32 dbuf_alloc_buf_under_flow_status : 1; // DWORD 0
               u32 dbuf_alloc_buf_over_flow_status : 1; // DWORD 0
               u32 ring_cfg_csr_rd_ram_perr_status : 1; // DWORD 0
               u32 ring_cfg_hw_rd_ram_perr_status : 1; // DWORD 0
               u32 ring_loc_state_ram_perr_status : 1; // DWORD 0
               u32 uc_resp_err_status : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1, *PTXULP_RING_MANAGER_UE_SOURCE_1;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_1, sizeof (TXULP_RING_MANAGER_UE_SOURCE_1) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_1 {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 tot_length_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
         u32 num_wrbs_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
         u32 eth_num_wrb_odd_ue_status : 1;       // DWORD 0
         u32 dbuf_alloc_buf_under_flow_status : 1; // DWORD 0
         u32 dbuf_alloc_buf_over_flow_status : 1; // DWORD 0
         u32 ring_cfg_csr_rd_ram_perr_status : 1; // DWORD 0
         u32 ring_cfg_hw_rd_ram_perr_status : 1;  // DWORD 0
         u32 ring_loc_state_ram_perr_status : 1;  // DWORD 0
         u32 uc_resp_err_status : 1;              // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1, *PTXULP_RING_MANAGER_UE_SOURCE_1;

      typedef union _TXULP_RING_MANAGER_UE_SOURCE_1_UNION {
         TXULP_RING_MANAGER_UE_SOURCE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1_UNION, *PTXULP_RING_MANAGER_UE_SOURCE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_1_UNION, sizeof (TXULP_RING_MANAGER_UE_SOURCE_1_UNION) == 4);
   #endif


#else
   // Ring Manager Unrecoverable Error Source Register 1.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_1 {
         union {
            struct { 
               u32 uc_resp_err_status : 1;        // DWORD 0
               u32 ring_loc_state_ram_perr_status : 1; // DWORD 0
               u32 ring_cfg_hw_rd_ram_perr_status : 1; // DWORD 0
               u32 ring_cfg_csr_rd_ram_perr_status : 1; // DWORD 0
               u32 dbuf_alloc_buf_over_flow_status : 1; // DWORD 0
               u32 dbuf_alloc_buf_under_flow_status : 1; // DWORD 0
               u32 eth_num_wrb_odd_ue_status : 1; // DWORD 0
               u32 num_wrbs_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
               u32 tot_length_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1, *PTXULP_RING_MANAGER_UE_SOURCE_1;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_1, sizeof (TXULP_RING_MANAGER_UE_SOURCE_1) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_SOURCE_1 {
         u32 uc_resp_err_status : 1;              // DWORD 0
         u32 ring_loc_state_ram_perr_status : 1;  // DWORD 0
         u32 ring_cfg_hw_rd_ram_perr_status : 1;  // DWORD 0
         u32 ring_cfg_csr_rd_ram_perr_status : 1; // DWORD 0
         u32 dbuf_alloc_buf_over_flow_status : 1; // DWORD 0
         u32 dbuf_alloc_buf_under_flow_status : 1; // DWORD 0
         u32 eth_num_wrb_odd_ue_status : 1;       // DWORD 0
         u32 num_wrbs_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
         u32 tot_length_in_wrb_set_eq_zero_ue_status : 1; // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1, *PTXULP_RING_MANAGER_UE_SOURCE_1;

      typedef union _TXULP_RING_MANAGER_UE_SOURCE_1_UNION {
         TXULP_RING_MANAGER_UE_SOURCE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_SOURCE_1_UNION, *PTXULP_RING_MANAGER_UE_SOURCE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_SOURCE_1_UNION, sizeof (TXULP_RING_MANAGER_UE_SOURCE_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Unrecoverable Error Enable Register 1. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_1 {
         union {
            struct { 
               u32 rsvd0 : 23;                    // DWORD 0
               u32 tot_length_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
               u32 num_wrbs_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
               u32 eth_num_wrb_odd_ue_enable : 1; // DWORD 0
               u32 dbuf_alloc_buf_under_flow_enable : 1; // DWORD 0
               u32 dbuf_alloc_buf_over_flow_enable : 1; // DWORD 0
               u32 ring_cfg_csr_rd_ram_perr_enable : 1; // DWORD 0
               u32 ring_cfg_hw_rd_ram_perr_enable : 1; // DWORD 0
               u32 ring_loc_state_ram_perr_enable : 1; // DWORD 0
               u32 uc_resp_err_enable : 1;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1, *PTXULP_RING_MANAGER_UE_ENABLE_1;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_1, sizeof (TXULP_RING_MANAGER_UE_ENABLE_1) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_1 {
         u32 rsvd0 : 23;                          // DWORD 0
         u32 tot_length_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
         u32 num_wrbs_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
         u32 eth_num_wrb_odd_ue_enable : 1;       // DWORD 0
         u32 dbuf_alloc_buf_under_flow_enable : 1; // DWORD 0
         u32 dbuf_alloc_buf_over_flow_enable : 1; // DWORD 0
         u32 ring_cfg_csr_rd_ram_perr_enable : 1; // DWORD 0
         u32 ring_cfg_hw_rd_ram_perr_enable : 1;  // DWORD 0
         u32 ring_loc_state_ram_perr_enable : 1;  // DWORD 0
         u32 uc_resp_err_enable : 1;              // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1, *PTXULP_RING_MANAGER_UE_ENABLE_1;

      typedef union _TXULP_RING_MANAGER_UE_ENABLE_1_UNION {
         TXULP_RING_MANAGER_UE_ENABLE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1_UNION, *PTXULP_RING_MANAGER_UE_ENABLE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_1_UNION, sizeof (TXULP_RING_MANAGER_UE_ENABLE_1_UNION) == 4);
   #endif


#else
   // Ring Manager Unrecoverable Error Enable Register 1. Write a 1 to Enable the relevant
   // UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_1 {
         union {
            struct { 
               u32 uc_resp_err_enable : 1;        // DWORD 0
               u32 ring_loc_state_ram_perr_enable : 1; // DWORD 0
               u32 ring_cfg_hw_rd_ram_perr_enable : 1; // DWORD 0
               u32 ring_cfg_csr_rd_ram_perr_enable : 1; // DWORD 0
               u32 dbuf_alloc_buf_over_flow_enable : 1; // DWORD 0
               u32 dbuf_alloc_buf_under_flow_enable : 1; // DWORD 0
               u32 eth_num_wrb_odd_ue_enable : 1; // DWORD 0
               u32 num_wrbs_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
               u32 tot_length_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
               u32 rsvd0 : 23;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1, *PTXULP_RING_MANAGER_UE_ENABLE_1;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_1, sizeof (TXULP_RING_MANAGER_UE_ENABLE_1) == 4);

   #else
      typedef struct _TXULP_RING_MANAGER_UE_ENABLE_1 {
         u32 uc_resp_err_enable : 1;              // DWORD 0
         u32 ring_loc_state_ram_perr_enable : 1;  // DWORD 0
         u32 ring_cfg_hw_rd_ram_perr_enable : 1;  // DWORD 0
         u32 ring_cfg_csr_rd_ram_perr_enable : 1; // DWORD 0
         u32 dbuf_alloc_buf_over_flow_enable : 1; // DWORD 0
         u32 dbuf_alloc_buf_under_flow_enable : 1; // DWORD 0
         u32 eth_num_wrb_odd_ue_enable : 1;       // DWORD 0
         u32 num_wrbs_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
         u32 tot_length_in_wrb_set_eq_zero_ue_enable : 1; // DWORD 0
         u32 rsvd0 : 23;                          // DWORD 0
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1, *PTXULP_RING_MANAGER_UE_ENABLE_1;

      typedef union _TXULP_RING_MANAGER_UE_ENABLE_1_UNION {
         TXULP_RING_MANAGER_UE_ENABLE_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_RING_MANAGER_UE_ENABLE_1_UNION, *PTXULP_RING_MANAGER_UE_ENABLE_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_RING_MANAGER_UE_ENABLE_1_UNION, sizeof (TXULP_RING_MANAGER_UE_ENABLE_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // UC Request, Release, and Reponses Merging Logic Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_MERGE_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 client_11_response_buf_under_flow_status : 1; // DWORD 0
               u32 client_11_response_buf_over_flow_status : 1; // DWORD 0
               u32 client_10_response_buf_under_flow_status : 1; // DWORD 0
               u32 client_10_response_buf_over_flow_status : 1; // DWORD 0
               u32 client_01_response_buf_under_flow_status : 1; // DWORD 0
               u32 client_01_response_buf_over_flow_status : 1; // DWORD 0
               u32 ep_response_buf_b_under_flow_status : 1; // DWORD 0
               u32 ep_response_buf_b_over_flow_status : 1; // DWORD 0
               u32 ep_response_buf_a_under_flow_status : 1; // DWORD 0
               u32 ep_response_buf_a_over_flow_status : 1; // DWORD 0
               u32 uc_response_in_buf_under_flow_status : 1; // DWORD 0
               u32 uc_response_in_buf_over_flow_status : 1; // DWORD 0
               u32 client_11_release_buf_under_flow_status : 1; // DWORD 0
               u32 client_10_release_buf_over_flow_status : 1; // DWORD 0
               u32 ep_release_buf_under_flow_status : 1; // DWORD 0
               u32 ep_release_buf_over_flow_status : 1; // DWORD 0
               u32 client_11_request_buf_under_flow_status : 1; // DWORD 0
               u32 client_11_request_buf_over_flow_status : 1; // DWORD 0
               u32 client_01_request_buf_under_flow_status : 1; // DWORD 0
               u32 client_01_request_buf_over_flow_status : 1; // DWORD 0
               u32 ep_request_buf_under_flow_status : 1; // DWORD 0
               u32 ep_request_buf_over_flow_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE, *PTXULP_UC_MERGE_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_SOURCE, sizeof (TXULP_UC_MERGE_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_UC_MERGE_UE_SOURCE {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 client_11_response_buf_under_flow_status : 1; // DWORD 0
         u32 client_11_response_buf_over_flow_status : 1; // DWORD 0
         u32 client_10_response_buf_under_flow_status : 1; // DWORD 0
         u32 client_10_response_buf_over_flow_status : 1; // DWORD 0
         u32 client_01_response_buf_under_flow_status : 1; // DWORD 0
         u32 client_01_response_buf_over_flow_status : 1; // DWORD 0
         u32 ep_response_buf_b_under_flow_status : 1; // DWORD 0
         u32 ep_response_buf_b_over_flow_status : 1; // DWORD 0
         u32 ep_response_buf_a_under_flow_status : 1; // DWORD 0
         u32 ep_response_buf_a_over_flow_status : 1; // DWORD 0
         u32 uc_response_in_buf_under_flow_status : 1; // DWORD 0
         u32 uc_response_in_buf_over_flow_status : 1; // DWORD 0
         u32 client_11_release_buf_under_flow_status : 1; // DWORD 0
         u32 client_10_release_buf_over_flow_status : 1; // DWORD 0
         u32 ep_release_buf_under_flow_status : 1; // DWORD 0
         u32 ep_release_buf_over_flow_status : 1; // DWORD 0
         u32 client_11_request_buf_under_flow_status : 1; // DWORD 0
         u32 client_11_request_buf_over_flow_status : 1; // DWORD 0
         u32 client_01_request_buf_under_flow_status : 1; // DWORD 0
         u32 client_01_request_buf_over_flow_status : 1; // DWORD 0
         u32 ep_request_buf_under_flow_status : 1; // DWORD 0
         u32 ep_request_buf_over_flow_status : 1; // DWORD 0
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE, *PTXULP_UC_MERGE_UE_SOURCE;

      typedef union _TXULP_UC_MERGE_UE_SOURCE_UNION {
         TXULP_UC_MERGE_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE_UNION, *PTXULP_UC_MERGE_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_SOURCE_UNION, sizeof (TXULP_UC_MERGE_UE_SOURCE_UNION) == 4);
   #endif


#else
   // UC Request, Release, and Reponses Merging Logic Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_MERGE_UE_SOURCE {
         union {
            struct { 
               u32 ep_request_buf_over_flow_status : 1; // DWORD 0
               u32 ep_request_buf_under_flow_status : 1; // DWORD 0
               u32 client_01_request_buf_over_flow_status : 1; // DWORD 0
               u32 client_01_request_buf_under_flow_status : 1; // DWORD 0
               u32 client_11_request_buf_over_flow_status : 1; // DWORD 0
               u32 client_11_request_buf_under_flow_status : 1; // DWORD 0
               u32 ep_release_buf_over_flow_status : 1; // DWORD 0
               u32 ep_release_buf_under_flow_status : 1; // DWORD 0
               u32 client_10_release_buf_over_flow_status : 1; // DWORD 0
               u32 client_11_release_buf_under_flow_status : 1; // DWORD 0
               u32 uc_response_in_buf_over_flow_status : 1; // DWORD 0
               u32 uc_response_in_buf_under_flow_status : 1; // DWORD 0
               u32 ep_response_buf_a_over_flow_status : 1; // DWORD 0
               u32 ep_response_buf_a_under_flow_status : 1; // DWORD 0
               u32 ep_response_buf_b_over_flow_status : 1; // DWORD 0
               u32 ep_response_buf_b_under_flow_status : 1; // DWORD 0
               u32 client_01_response_buf_over_flow_status : 1; // DWORD 0
               u32 client_01_response_buf_under_flow_status : 1; // DWORD 0
               u32 client_10_response_buf_over_flow_status : 1; // DWORD 0
               u32 client_10_response_buf_under_flow_status : 1; // DWORD 0
               u32 client_11_response_buf_over_flow_status : 1; // DWORD 0
               u32 client_11_response_buf_under_flow_status : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE, *PTXULP_UC_MERGE_UE_SOURCE;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_SOURCE, sizeof (TXULP_UC_MERGE_UE_SOURCE) == 4);

   #else
      typedef struct _TXULP_UC_MERGE_UE_SOURCE {
         u32 ep_request_buf_over_flow_status : 1; // DWORD 0
         u32 ep_request_buf_under_flow_status : 1; // DWORD 0
         u32 client_01_request_buf_over_flow_status : 1; // DWORD 0
         u32 client_01_request_buf_under_flow_status : 1; // DWORD 0
         u32 client_11_request_buf_over_flow_status : 1; // DWORD 0
         u32 client_11_request_buf_under_flow_status : 1; // DWORD 0
         u32 ep_release_buf_over_flow_status : 1; // DWORD 0
         u32 ep_release_buf_under_flow_status : 1; // DWORD 0
         u32 client_10_release_buf_over_flow_status : 1; // DWORD 0
         u32 client_11_release_buf_under_flow_status : 1; // DWORD 0
         u32 uc_response_in_buf_over_flow_status : 1; // DWORD 0
         u32 uc_response_in_buf_under_flow_status : 1; // DWORD 0
         u32 ep_response_buf_a_over_flow_status : 1; // DWORD 0
         u32 ep_response_buf_a_under_flow_status : 1; // DWORD 0
         u32 ep_response_buf_b_over_flow_status : 1; // DWORD 0
         u32 ep_response_buf_b_under_flow_status : 1; // DWORD 0
         u32 client_01_response_buf_over_flow_status : 1; // DWORD 0
         u32 client_01_response_buf_under_flow_status : 1; // DWORD 0
         u32 client_10_response_buf_over_flow_status : 1; // DWORD 0
         u32 client_10_response_buf_under_flow_status : 1; // DWORD 0
         u32 client_11_response_buf_over_flow_status : 1; // DWORD 0
         u32 client_11_response_buf_under_flow_status : 1; // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE, *PTXULP_UC_MERGE_UE_SOURCE;

      typedef union _TXULP_UC_MERGE_UE_SOURCE_UNION {
         TXULP_UC_MERGE_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_MERGE_UE_SOURCE_UNION, *PTXULP_UC_MERGE_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_SOURCE_UNION, sizeof (TXULP_UC_MERGE_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // UC Request, Release, and Reponses Merging Logic Unrecoverable Error Enable
   // Register.Write a 1 to Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_MERGE_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 10;                    // DWORD 0
               u32 client_11_response_buf_under_flow_enable : 1; // DWORD 0
               u32 client_11_response_buf_over_flow_enable : 1; // DWORD 0
               u32 client_10_response_buf_under_flow_enable : 1; // DWORD 0
               u32 client_10_response_buf_over_flow_enable : 1; // DWORD 0
               u32 client_01_response_buf_under_flow_enable : 1; // DWORD 0
               u32 client_01_response_buf_over_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_b_under_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_b_over_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_a_under_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_a_over_flow_enable : 1; // DWORD 0
               u32 uc_response_in_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_response_in_buf_over_flow_enable : 1; // DWORD 0
               u32 client_11_release_buf_under_flow_enable : 1; // DWORD 0
               u32 client_10_release_buf_over_flow_enable : 1; // DWORD 0
               u32 ep_release_buf_under_flow_enable : 1; // DWORD 0
               u32 ep_release_buf_over_flow_enable : 1; // DWORD 0
               u32 client_11_request_buf_under_flow_enable : 1; // DWORD 0
               u32 client_11_request_buf_over_flow_enable : 1; // DWORD 0
               u32 client_01_request_buf_under_flow_enable : 1; // DWORD 0
               u32 client_01_request_buf_over_flow_enable : 1; // DWORD 0
               u32 ep_request_buf_under_flow_enable : 1; // DWORD 0
               u32 ep_request_buf_over_flow_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE, *PTXULP_UC_MERGE_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_ENABLE, sizeof (TXULP_UC_MERGE_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_UC_MERGE_UE_ENABLE {
         u32 rsvd0 : 10;                          // DWORD 0
         u32 client_11_response_buf_under_flow_enable : 1; // DWORD 0
         u32 client_11_response_buf_over_flow_enable : 1; // DWORD 0
         u32 client_10_response_buf_under_flow_enable : 1; // DWORD 0
         u32 client_10_response_buf_over_flow_enable : 1; // DWORD 0
         u32 client_01_response_buf_under_flow_enable : 1; // DWORD 0
         u32 client_01_response_buf_over_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_b_under_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_b_over_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_a_under_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_a_over_flow_enable : 1; // DWORD 0
         u32 uc_response_in_buf_under_flow_enable : 1; // DWORD 0
         u32 uc_response_in_buf_over_flow_enable : 1; // DWORD 0
         u32 client_11_release_buf_under_flow_enable : 1; // DWORD 0
         u32 client_10_release_buf_over_flow_enable : 1; // DWORD 0
         u32 ep_release_buf_under_flow_enable : 1; // DWORD 0
         u32 ep_release_buf_over_flow_enable : 1; // DWORD 0
         u32 client_11_request_buf_under_flow_enable : 1; // DWORD 0
         u32 client_11_request_buf_over_flow_enable : 1; // DWORD 0
         u32 client_01_request_buf_under_flow_enable : 1; // DWORD 0
         u32 client_01_request_buf_over_flow_enable : 1; // DWORD 0
         u32 ep_request_buf_under_flow_enable : 1; // DWORD 0
         u32 ep_request_buf_over_flow_enable : 1; // DWORD 0
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE, *PTXULP_UC_MERGE_UE_ENABLE;

      typedef union _TXULP_UC_MERGE_UE_ENABLE_UNION {
         TXULP_UC_MERGE_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE_UNION, *PTXULP_UC_MERGE_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_ENABLE_UNION, sizeof (TXULP_UC_MERGE_UE_ENABLE_UNION) == 4);
   #endif


#else
   // UC Request, Release, and Reponses Merging Logic Unrecoverable Error Enable
   // Register.Write a 1 to Enable the relevant UE.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_MERGE_UE_ENABLE {
         union {
            struct { 
               u32 ep_request_buf_over_flow_enable : 1; // DWORD 0
               u32 ep_request_buf_under_flow_enable : 1; // DWORD 0
               u32 client_01_request_buf_over_flow_enable : 1; // DWORD 0
               u32 client_01_request_buf_under_flow_enable : 1; // DWORD 0
               u32 client_11_request_buf_over_flow_enable : 1; // DWORD 0
               u32 client_11_request_buf_under_flow_enable : 1; // DWORD 0
               u32 ep_release_buf_over_flow_enable : 1; // DWORD 0
               u32 ep_release_buf_under_flow_enable : 1; // DWORD 0
               u32 client_10_release_buf_over_flow_enable : 1; // DWORD 0
               u32 client_11_release_buf_under_flow_enable : 1; // DWORD 0
               u32 uc_response_in_buf_over_flow_enable : 1; // DWORD 0
               u32 uc_response_in_buf_under_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_a_over_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_a_under_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_b_over_flow_enable : 1; // DWORD 0
               u32 ep_response_buf_b_under_flow_enable : 1; // DWORD 0
               u32 client_01_response_buf_over_flow_enable : 1; // DWORD 0
               u32 client_01_response_buf_under_flow_enable : 1; // DWORD 0
               u32 client_10_response_buf_over_flow_enable : 1; // DWORD 0
               u32 client_10_response_buf_under_flow_enable : 1; // DWORD 0
               u32 client_11_response_buf_over_flow_enable : 1; // DWORD 0
               u32 client_11_response_buf_under_flow_enable : 1; // DWORD 0
               u32 rsvd0 : 10;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE, *PTXULP_UC_MERGE_UE_ENABLE;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_ENABLE, sizeof (TXULP_UC_MERGE_UE_ENABLE) == 4);

   #else
      typedef struct _TXULP_UC_MERGE_UE_ENABLE {
         u32 ep_request_buf_over_flow_enable : 1; // DWORD 0
         u32 ep_request_buf_under_flow_enable : 1; // DWORD 0
         u32 client_01_request_buf_over_flow_enable : 1; // DWORD 0
         u32 client_01_request_buf_under_flow_enable : 1; // DWORD 0
         u32 client_11_request_buf_over_flow_enable : 1; // DWORD 0
         u32 client_11_request_buf_under_flow_enable : 1; // DWORD 0
         u32 ep_release_buf_over_flow_enable : 1; // DWORD 0
         u32 ep_release_buf_under_flow_enable : 1; // DWORD 0
         u32 client_10_release_buf_over_flow_enable : 1; // DWORD 0
         u32 client_11_release_buf_under_flow_enable : 1; // DWORD 0
         u32 uc_response_in_buf_over_flow_enable : 1; // DWORD 0
         u32 uc_response_in_buf_under_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_a_over_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_a_under_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_b_over_flow_enable : 1; // DWORD 0
         u32 ep_response_buf_b_under_flow_enable : 1; // DWORD 0
         u32 client_01_response_buf_over_flow_enable : 1; // DWORD 0
         u32 client_01_response_buf_under_flow_enable : 1; // DWORD 0
         u32 client_10_response_buf_over_flow_enable : 1; // DWORD 0
         u32 client_10_response_buf_under_flow_enable : 1; // DWORD 0
         u32 client_11_response_buf_over_flow_enable : 1; // DWORD 0
         u32 client_11_response_buf_under_flow_enable : 1; // DWORD 0
         u32 rsvd0 : 10;                          // DWORD 0
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE, *PTXULP_UC_MERGE_UE_ENABLE;

      typedef union _TXULP_UC_MERGE_UE_ENABLE_UNION {
         TXULP_UC_MERGE_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_MERGE_UE_ENABLE_UNION, *PTXULP_UC_MERGE_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_MERGE_UE_ENABLE_UNION, sizeof (TXULP_UC_MERGE_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Global QoS Module Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOBAL_QOS_UE_SOURCE {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 glob_qos_ram_pe_status : 1;    // DWORD 0
               u32 txulp2_ep_buf_unf_status : 1;  // DWORD 0
               u32 txulp2_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp2_ep_frame_ue_status : 1; // DWORD 0
               u32 txulp1_ep_buf_unf_status : 1;  // DWORD 0
               u32 txulp1_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp1_ep_frame_ue_status : 1; // DWORD 0
               u32 txulp0_ep_buf_unf_status : 1;  // DWORD 0
               u32 txulp0_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp0_ep_frame_ue_status : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOBAL_QOS_UE_SOURCE, *PGLOBAL_QOS_UE_SOURCE;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_SOURCE, sizeof (GLOBAL_QOS_UE_SOURCE) == 4);

   #else
      typedef struct _GLOBAL_QOS_UE_SOURCE {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 glob_qos_ram_pe_status : 1;          // DWORD 0
         u32 txulp2_ep_buf_unf_status : 1;        // DWORD 0
         u32 txulp2_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp2_ep_frame_ue_status : 1;       // DWORD 0
         u32 txulp1_ep_buf_unf_status : 1;        // DWORD 0
         u32 txulp1_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp1_ep_frame_ue_status : 1;       // DWORD 0
         u32 txulp0_ep_buf_unf_status : 1;        // DWORD 0
         u32 txulp0_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp0_ep_frame_ue_status : 1;       // DWORD 0
      } SG_PACK GLOBAL_QOS_UE_SOURCE, *PGLOBAL_QOS_UE_SOURCE;

      typedef union _GLOBAL_QOS_UE_SOURCE_UNION {
         GLOBAL_QOS_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK GLOBAL_QOS_UE_SOURCE_UNION, *PGLOBAL_QOS_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_SOURCE_UNION, sizeof (GLOBAL_QOS_UE_SOURCE_UNION) == 4);
   #endif


#else
   // Global QoS Module Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOBAL_QOS_UE_SOURCE {
         union {
            struct { 
               u32 txulp0_ep_frame_ue_status : 1; // DWORD 0
               u32 txulp0_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp0_ep_buf_unf_status : 1;  // DWORD 0
               u32 txulp1_ep_frame_ue_status : 1; // DWORD 0
               u32 txulp1_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp1_ep_buf_unf_status : 1;  // DWORD 0
               u32 txulp2_ep_frame_ue_status : 1; // DWORD 0
               u32 txulp2_ep_buf_ovf_status : 1;  // DWORD 0
               u32 txulp2_ep_buf_unf_status : 1;  // DWORD 0
               u32 glob_qos_ram_pe_status : 1;    // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOBAL_QOS_UE_SOURCE, *PGLOBAL_QOS_UE_SOURCE;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_SOURCE, sizeof (GLOBAL_QOS_UE_SOURCE) == 4);

   #else
      typedef struct _GLOBAL_QOS_UE_SOURCE {
         u32 txulp0_ep_frame_ue_status : 1;       // DWORD 0
         u32 txulp0_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp0_ep_buf_unf_status : 1;        // DWORD 0
         u32 txulp1_ep_frame_ue_status : 1;       // DWORD 0
         u32 txulp1_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp1_ep_buf_unf_status : 1;        // DWORD 0
         u32 txulp2_ep_frame_ue_status : 1;       // DWORD 0
         u32 txulp2_ep_buf_ovf_status : 1;        // DWORD 0
         u32 txulp2_ep_buf_unf_status : 1;        // DWORD 0
         u32 glob_qos_ram_pe_status : 1;          // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK GLOBAL_QOS_UE_SOURCE, *PGLOBAL_QOS_UE_SOURCE;

      typedef union _GLOBAL_QOS_UE_SOURCE_UNION {
         GLOBAL_QOS_UE_SOURCE bits;
         u32 dw; // dword union
      } SG_PACK GLOBAL_QOS_UE_SOURCE_UNION, *PGLOBAL_QOS_UE_SOURCE_UNION;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_SOURCE_UNION, sizeof (GLOBAL_QOS_UE_SOURCE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Global QoS Module Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOBAL_QOS_UE_ENABLE {
         union {
            struct { 
               u32 rsvd0 : 22;                    // DWORD 0
               u32 glob_qos_ram_pe_enable : 1;    // DWORD 0
               u32 txulp2_ep_buf_unf_enable : 1;  // DWORD 0
               u32 txulp2_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp2_ep_frame_ue_enable : 1; // DWORD 0
               u32 txulp1_ep_buf_unf_enable : 1;  // DWORD 0
               u32 txulp1_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp1_ep_frame_ue_enable : 1; // DWORD 0
               u32 txulp0_ep_buf_unf_enable : 1;  // DWORD 0
               u32 txulp0_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp0_ep_frame_ue_enable : 1; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOBAL_QOS_UE_ENABLE, *PGLOBAL_QOS_UE_ENABLE;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_ENABLE, sizeof (GLOBAL_QOS_UE_ENABLE) == 4);

   #else
      typedef struct _GLOBAL_QOS_UE_ENABLE {
         u32 rsvd0 : 22;                          // DWORD 0
         u32 glob_qos_ram_pe_enable : 1;          // DWORD 0
         u32 txulp2_ep_buf_unf_enable : 1;        // DWORD 0
         u32 txulp2_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp2_ep_frame_ue_enable : 1;       // DWORD 0
         u32 txulp1_ep_buf_unf_enable : 1;        // DWORD 0
         u32 txulp1_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp1_ep_frame_ue_enable : 1;       // DWORD 0
         u32 txulp0_ep_buf_unf_enable : 1;        // DWORD 0
         u32 txulp0_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp0_ep_frame_ue_enable : 1;       // DWORD 0
      } SG_PACK GLOBAL_QOS_UE_ENABLE, *PGLOBAL_QOS_UE_ENABLE;

      typedef union _GLOBAL_QOS_UE_ENABLE_UNION {
         GLOBAL_QOS_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK GLOBAL_QOS_UE_ENABLE_UNION, *PGLOBAL_QOS_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_ENABLE_UNION, sizeof (GLOBAL_QOS_UE_ENABLE_UNION) == 4);
   #endif


#else
   // Global QoS Module Unrecoverable Error Source Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOBAL_QOS_UE_ENABLE {
         union {
            struct { 
               u32 txulp0_ep_frame_ue_enable : 1; // DWORD 0
               u32 txulp0_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp0_ep_buf_unf_enable : 1;  // DWORD 0
               u32 txulp1_ep_frame_ue_enable : 1; // DWORD 0
               u32 txulp1_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp1_ep_buf_unf_enable : 1;  // DWORD 0
               u32 txulp2_ep_frame_ue_enable : 1; // DWORD 0
               u32 txulp2_ep_buf_ovf_enable : 1;  // DWORD 0
               u32 txulp2_ep_buf_unf_enable : 1;  // DWORD 0
               u32 glob_qos_ram_pe_enable : 1;    // DWORD 0
               u32 rsvd0 : 22;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOBAL_QOS_UE_ENABLE, *PGLOBAL_QOS_UE_ENABLE;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_ENABLE, sizeof (GLOBAL_QOS_UE_ENABLE) == 4);

   #else
      typedef struct _GLOBAL_QOS_UE_ENABLE {
         u32 txulp0_ep_frame_ue_enable : 1;       // DWORD 0
         u32 txulp0_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp0_ep_buf_unf_enable : 1;        // DWORD 0
         u32 txulp1_ep_frame_ue_enable : 1;       // DWORD 0
         u32 txulp1_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp1_ep_buf_unf_enable : 1;        // DWORD 0
         u32 txulp2_ep_frame_ue_enable : 1;       // DWORD 0
         u32 txulp2_ep_buf_ovf_enable : 1;        // DWORD 0
         u32 txulp2_ep_buf_unf_enable : 1;        // DWORD 0
         u32 glob_qos_ram_pe_enable : 1;          // DWORD 0
         u32 rsvd0 : 22;                          // DWORD 0
      } SG_PACK GLOBAL_QOS_UE_ENABLE, *PGLOBAL_QOS_UE_ENABLE;

      typedef union _GLOBAL_QOS_UE_ENABLE_UNION {
         GLOBAL_QOS_UE_ENABLE bits;
         u32 dw; // dword union
      } SG_PACK GLOBAL_QOS_UE_ENABLE_UNION, *PGLOBAL_QOS_UE_ENABLE_UNION;

      SG_C_ASSERT(__sizeof__GLOBAL_QOS_UE_ENABLE_UNION, sizeof (GLOBAL_QOS_UE_ENABLE_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Local State Access Arbiter Weight Control Register 0. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR {
         union {
            struct { 
               u32 txrm_mpu_req_rd_weight : 4;    // DWORD 0
               u32 txrm_sched_header_wrb_tp_wr_weight : 4; // DWORD 0
               u32 txrm_sched_req_rd_weight : 4;  // DWORD 0
               u32 txrm_uc_entry_wr_weight : 4;   // DWORD 0
               u32 txrm_entry_rd_weight : 4;      // DWORD 0
               u32 txrm_entry_wr_weight : 4;      // DWORD 0
               u32 mmr_ring_flush_weight : 4;     // DWORD 0
               u32 mmr_ring_rd_weight : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR {
         u32 txrm_mpu_req_rd_weight : 4;          // DWORD 0
         u32 txrm_sched_header_wrb_tp_wr_weight : 4; // DWORD 0
         u32 txrm_sched_req_rd_weight : 4;        // DWORD 0
         u32 txrm_uc_entry_wr_weight : 4;         // DWORD 0
         u32 txrm_entry_rd_weight : 4;            // DWORD 0
         u32 txrm_entry_wr_weight : 4;            // DWORD 0
         u32 mmr_ring_flush_weight : 4;           // DWORD 0
         u32 mmr_ring_rd_weight : 4;              // DWORD 0
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR;

      typedef union _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION {
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION) == 4);
   #endif


#else
   // Ring Manager Local State Access Arbiter Weight Control Register 0. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR {
         union {
            struct { 
               u32 mmr_ring_rd_weight : 4;        // DWORD 0
               u32 mmr_ring_flush_weight : 4;     // DWORD 0
               u32 txrm_entry_wr_weight : 4;      // DWORD 0
               u32 txrm_entry_rd_weight : 4;      // DWORD 0
               u32 txrm_uc_entry_wr_weight : 4;   // DWORD 0
               u32 txrm_sched_req_rd_weight : 4;  // DWORD 0
               u32 txrm_sched_header_wrb_tp_wr_weight : 4; // DWORD 0
               u32 txrm_mpu_req_rd_weight : 4;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR {
         u32 mmr_ring_rd_weight : 4;              // DWORD 0
         u32 mmr_ring_flush_weight : 4;           // DWORD 0
         u32 txrm_entry_wr_weight : 4;            // DWORD 0
         u32 txrm_entry_rd_weight : 4;            // DWORD 0
         u32 txrm_uc_entry_wr_weight : 4;         // DWORD 0
         u32 txrm_sched_req_rd_weight : 4;        // DWORD 0
         u32 txrm_sched_header_wrb_tp_wr_weight : 4; // DWORD 0
         u32 txrm_mpu_req_rd_weight : 4;          // DWORD 0
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR;

      typedef union _TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION {
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Local State Access Arbiter Weight Control Register 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR {
         union {
            struct { 
               u32 rsvd0 : 4;                     // DWORD 0
               u32 txrm_req_logic_esnir_wb_weight : 4; // DWORD 0
               u32 csr_debug_read_access_weight : 4; // DWORD 0
               u32 mmr_ring_hwrb_tp_rb_weight : 4; // DWORD 0
               u32 mpu_ring_hwrb_tp_rb_weight : 4; // DWORD 0
               u32 mpu_ring_update_weight : 4;    // DWORD 0
               u32 txp_ring_update_weight : 4;    // DWORD 0
               u32 txrm_mpu_header_wrb_tp_wr_weight : 4; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR {
         u32 rsvd0 : 4;                           // DWORD 0
         u32 txrm_req_logic_esnir_wb_weight : 4;  // DWORD 0
         u32 csr_debug_read_access_weight : 4;    // DWORD 0
         u32 mmr_ring_hwrb_tp_rb_weight : 4;      // DWORD 0
         u32 mpu_ring_hwrb_tp_rb_weight : 4;      // DWORD 0
         u32 mpu_ring_update_weight : 4;          // DWORD 0
         u32 txp_ring_update_weight : 4;          // DWORD 0
         u32 txrm_mpu_header_wrb_tp_wr_weight : 4; // DWORD 0
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR;

      typedef union _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION {
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION) == 4);
   #endif


#else
   // Ring Manager Local State Access Arbiter Weight Control Register 1. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR {
         union {
            struct { 
               u32 txrm_mpu_header_wrb_tp_wr_weight : 4; // DWORD 0
               u32 txp_ring_update_weight : 4;    // DWORD 0
               u32 mpu_ring_update_weight : 4;    // DWORD 0
               u32 mpu_ring_hwrb_tp_rb_weight : 4; // DWORD 0
               u32 mmr_ring_hwrb_tp_rb_weight : 4; // DWORD 0
               u32 csr_debug_read_access_weight : 4; // DWORD 0
               u32 txrm_req_logic_esnir_wb_weight : 4; // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR {
         u32 txrm_mpu_header_wrb_tp_wr_weight : 4; // DWORD 0
         u32 txp_ring_update_weight : 4;          // DWORD 0
         u32 mpu_ring_update_weight : 4;          // DWORD 0
         u32 mpu_ring_hwrb_tp_rb_weight : 4;      // DWORD 0
         u32 mmr_ring_hwrb_tp_rb_weight : 4;      // DWORD 0
         u32 csr_debug_read_access_weight : 4;    // DWORD 0
         u32 txrm_req_logic_esnir_wb_weight : 4;  // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR;

      typedef union _TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION {
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION, *PTXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION, sizeof (TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Static State Access Arbiter Weight Control Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 rrnode_wr_weight : 4;          // DWORD 0
               u32 rrnode_rd_weight : 4;          // DWORD 0
               u32 txrm_entry_weight : 4;         // DWORD 0
               u32 txrm_loc_state_req_weight : 4; // DWORD 0
               u32 txrm_sched_req_weight : 4;     // DWORD 0
               u32 txrm_mpu_req_weight : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, sizeof (TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 rrnode_wr_weight : 4;                // DWORD 0
         u32 rrnode_rd_weight : 4;                // DWORD 0
         u32 txrm_entry_weight : 4;               // DWORD 0
         u32 txrm_loc_state_req_weight : 4;       // DWORD 0
         u32 txrm_sched_req_weight : 4;           // DWORD 0
         u32 txrm_mpu_req_weight : 4;             // DWORD 0
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR;

      typedef union _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION {
         TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION, sizeof (TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION) == 4);
   #endif


#else
   // Ring Manager Static State Access Arbiter Weight Control Register. 
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR {
         union {
            struct { 
               u32 txrm_mpu_req_weight : 4;       // DWORD 0
               u32 txrm_sched_req_weight : 4;     // DWORD 0
               u32 txrm_loc_state_req_weight : 4; // DWORD 0
               u32 txrm_entry_weight : 4;         // DWORD 0
               u32 rrnode_rd_weight : 4;          // DWORD 0
               u32 rrnode_wr_weight : 4;          // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, sizeof (TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR {
         u32 txrm_mpu_req_weight : 4;             // DWORD 0
         u32 txrm_sched_req_weight : 4;           // DWORD 0
         u32 txrm_loc_state_req_weight : 4;       // DWORD 0
         u32 txrm_entry_weight : 4;               // DWORD 0
         u32 rrnode_rd_weight : 4;                // DWORD 0
         u32 rrnode_wr_weight : 4;                // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR;

      typedef union _TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION {
         TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION, *PTXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION, sizeof (TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Ring Configuration Setup Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_SETUP_CSR {
         union {
            struct { 
               u32 txrm_setup_low_water_mark : 7; // DWORD 0
               u32 txrm_setup_wrb_max_fetch : 7;  // DWORD 0
               u32 txrm_setup_ring_sz : 2;        // DWORD 0
               u32 txrm_setup_base_addr : 16;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR, *PTXULP_SHAD_RING_SETUP_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_CSR, sizeof (TXULP_SHAD_RING_SETUP_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_SETUP_CSR {
         u32 txrm_setup_low_water_mark : 7;       // DWORD 0
         u32 txrm_setup_wrb_max_fetch : 7;        // DWORD 0
         u32 txrm_setup_ring_sz : 2;              // DWORD 0
         u32 txrm_setup_base_addr : 16;           // DWORD 0
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR, *PTXULP_SHAD_RING_SETUP_CSR;

      typedef union _TXULP_SHAD_RING_SETUP_CSR_UNION {
         TXULP_SHAD_RING_SETUP_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR_UNION, *PTXULP_SHAD_RING_SETUP_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_CSR_UNION, sizeof (TXULP_SHAD_RING_SETUP_CSR_UNION) == 4);
   #endif


#else
   // Ring Manager Ring Configuration Setup Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_SETUP_CSR {
         union {
            struct { 
               u32 txrm_setup_base_addr : 16;     // DWORD 0
               u32 txrm_setup_ring_sz : 2;        // DWORD 0
               u32 txrm_setup_wrb_max_fetch : 7;  // DWORD 0
               u32 txrm_setup_low_water_mark : 7; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR, *PTXULP_SHAD_RING_SETUP_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_CSR, sizeof (TXULP_SHAD_RING_SETUP_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_SETUP_CSR {
         u32 txrm_setup_base_addr : 16;           // DWORD 0
         u32 txrm_setup_ring_sz : 2;              // DWORD 0
         u32 txrm_setup_wrb_max_fetch : 7;        // DWORD 0
         u32 txrm_setup_low_water_mark : 7;       // DWORD 0
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR, *PTXULP_SHAD_RING_SETUP_CSR;

      typedef union _TXULP_SHAD_RING_SETUP_CSR_UNION {
         TXULP_SHAD_RING_SETUP_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_SETUP_CSR_UNION, *PTXULP_SHAD_RING_SETUP_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_CSR_UNION, sizeof (TXULP_SHAD_RING_SETUP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Ring Configuration Setup Number Register.This register is used in
   // conjunction with the shadow ring setup register to select thetarget ring that is
   // being setup. This value is auto incremented immediatly after theshadow ring setup
   // register is read or written.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_SETUP_NUMBER_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 txrm_setup_shad_num : 6;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_NUMBER_CSR, sizeof (TXULP_SHAD_RING_SETUP_NUMBER_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_SETUP_NUMBER_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 txrm_setup_shad_num : 6;             // DWORD 0
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR;

      typedef union _TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION {
         TXULP_SHAD_RING_SETUP_NUMBER_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION, sizeof (TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION) == 4);
   #endif


#else
   // Ring Manager Ring Configuration Setup Number Register.This register is used in
   // conjunction with the shadow ring setup register to select thetarget ring that is
   // being setup. This value is auto incremented immediatly after theshadow ring setup
   // register is read or written.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_SETUP_NUMBER_CSR {
         union {
            struct { 
               u32 txrm_setup_shad_num : 6;       // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_NUMBER_CSR, sizeof (TXULP_SHAD_RING_SETUP_NUMBER_CSR) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_SETUP_NUMBER_CSR {
         u32 txrm_setup_shad_num : 6;             // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR;

      typedef union _TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION {
         TXULP_SHAD_RING_SETUP_NUMBER_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION, *PTXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION, sizeof (TXULP_SHAD_RING_SETUP_NUMBER_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Ring Manager Upper DDR Address for DDR based Shadow Ring Register.This register is
   // used to configure a static value for the upper 8 bits of DDR based shadow rings.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_DDR_ADDRU {
         union {
            struct { 
               u32 ddr_upper_address_bits : 8;    // DWORD 0
               u32 rsvd0 : 24;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU, *PTXULP_SHAD_RING_DDR_ADDRU;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_DDR_ADDRU, sizeof (TXULP_SHAD_RING_DDR_ADDRU) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_DDR_ADDRU {
         u32 ddr_upper_address_bits : 8;          // DWORD 0
         u32 rsvd0 : 24;                          // DWORD 0
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU, *PTXULP_SHAD_RING_DDR_ADDRU;

      typedef union _TXULP_SHAD_RING_DDR_ADDRU_UNION {
         TXULP_SHAD_RING_DDR_ADDRU bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU_UNION, *PTXULP_SHAD_RING_DDR_ADDRU_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_DDR_ADDRU_UNION, sizeof (TXULP_SHAD_RING_DDR_ADDRU_UNION) == 4);
   #endif


#else
   // Ring Manager Upper DDR Address for DDR based Shadow Ring Register.This register is
   // used to configure a static value for the upper 8 bits of DDR based shadow rings.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SHAD_RING_DDR_ADDRU {
         union {
            struct { 
               u32 rsvd0 : 24;                    // DWORD 0
               u32 ddr_upper_address_bits : 8;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU, *PTXULP_SHAD_RING_DDR_ADDRU;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_DDR_ADDRU, sizeof (TXULP_SHAD_RING_DDR_ADDRU) == 4);

   #else
      typedef struct _TXULP_SHAD_RING_DDR_ADDRU {
         u32 rsvd0 : 24;                          // DWORD 0
         u32 ddr_upper_address_bits : 8;          // DWORD 0
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU, *PTXULP_SHAD_RING_DDR_ADDRU;

      typedef union _TXULP_SHAD_RING_DDR_ADDRU_UNION {
         TXULP_SHAD_RING_DDR_ADDRU bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SHAD_RING_DDR_ADDRU_UNION, *PTXULP_SHAD_RING_DDR_ADDRU_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SHAD_RING_DDR_ADDRU_UNION, sizeof (TXULP_SHAD_RING_DDR_ADDRU_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP to TPOST Initial Credit Register. Used to initialize the credit values for the
   // number ofTOE or ETHERNET work items that can be in-flight between this TXULP and
   // TPOST at any given time.The value written to this register is latched by hardware
   // when a transition from off-lineto on-line is detected, or any time that this
   // register is written.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TPOST_INIT_CRED {
         union {
            struct { 
               u32 tcpsch_port1_credit_stat : 8;  // DWORD 0
               u32 tcpsch_port0_credit_stat : 8;  // DWORD 0
               u32 tcpsch_port1_credit : 8;       // DWORD 0
               u32 tcpsch_port0_credit : 8;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TPOST_INIT_CRED, *PTXULP_TPOST_INIT_CRED;

      SG_C_ASSERT(__sizeof__TXULP_TPOST_INIT_CRED, sizeof (TXULP_TPOST_INIT_CRED) == 4);

   #else
      typedef struct _TXULP_TPOST_INIT_CRED {
         u32 tcpsch_port1_credit_stat : 8;        // DWORD 0
         u32 tcpsch_port0_credit_stat : 8;        // DWORD 0
         u32 tcpsch_port1_credit : 8;             // DWORD 0
         u32 tcpsch_port0_credit : 8;             // DWORD 0
      } SG_PACK TXULP_TPOST_INIT_CRED, *PTXULP_TPOST_INIT_CRED;

      typedef union _TXULP_TPOST_INIT_CRED_UNION {
         TXULP_TPOST_INIT_CRED bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TPOST_INIT_CRED_UNION, *PTXULP_TPOST_INIT_CRED_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TPOST_INIT_CRED_UNION, sizeof (TXULP_TPOST_INIT_CRED_UNION) == 4);
   #endif


#else
   // TXULP to TPOST Initial Credit Register. Used to initialize the credit values for the
   // number ofTOE or ETHERNET work items that can be in-flight between this TXULP and
   // TPOST at any given time.The value written to this register is latched by hardware
   // when a transition from off-lineto on-line is detected, or any time that this
   // register is written.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TPOST_INIT_CRED {
         union {
            struct { 
               u32 tcpsch_port0_credit : 8;       // DWORD 0
               u32 tcpsch_port1_credit : 8;       // DWORD 0
               u32 tcpsch_port0_credit_stat : 8;  // DWORD 0
               u32 tcpsch_port1_credit_stat : 8;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TPOST_INIT_CRED, *PTXULP_TPOST_INIT_CRED;

      SG_C_ASSERT(__sizeof__TXULP_TPOST_INIT_CRED, sizeof (TXULP_TPOST_INIT_CRED) == 4);

   #else
      typedef struct _TXULP_TPOST_INIT_CRED {
         u32 tcpsch_port0_credit : 8;             // DWORD 0
         u32 tcpsch_port1_credit : 8;             // DWORD 0
         u32 tcpsch_port0_credit_stat : 8;        // DWORD 0
         u32 tcpsch_port1_credit_stat : 8;        // DWORD 0
      } SG_PACK TXULP_TPOST_INIT_CRED, *PTXULP_TPOST_INIT_CRED;

      typedef union _TXULP_TPOST_INIT_CRED_UNION {
         TXULP_TPOST_INIT_CRED bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TPOST_INIT_CRED_UNION, *PTXULP_TPOST_INIT_CRED_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TPOST_INIT_CRED_UNION, sizeof (TXULP_TPOST_INIT_CRED_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TXULP Scheduler Control Register. Controls Various Features of the Scheduler.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_CNTRL {
         union {
            struct { 
               u32 dma_swap_mode_for_eth_immed_rd : 2; // DWORD 0
               u32 dma_swap_mode_for_mcc_immed_rd : 2; // DWORD 0
               u32 tcp_state_num_16B_rd : 4;      // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 tcp_state_second_16B_rd : 3;   // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 tcp_state_first_16B_rd : 3;    // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 uc_pre_enable : 1;             // DWORD 0
               u32 ctx_nv_rs_enable : 1;          // DWORD 0
               u32 ha_toe_enable : 1;             // DWORD 0
               u32 ha_raw_eth_enable : 1;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_CNTRL, *PTXULP_SCHEDULER_CNTRL;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_CNTRL, sizeof (TXULP_SCHEDULER_CNTRL) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_CNTRL {
         u32 dma_swap_mode_for_eth_immed_rd : 2;  // DWORD 0
         u32 dma_swap_mode_for_mcc_immed_rd : 2;  // DWORD 0
         u32 tcp_state_num_16B_rd : 4;            // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 tcp_state_second_16B_rd : 3;         // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 tcp_state_first_16B_rd : 3;          // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 uc_pre_enable : 1;                   // DWORD 0
         u32 ctx_nv_rs_enable : 1;                // DWORD 0
         u32 ha_toe_enable : 1;                   // DWORD 0
         u32 ha_raw_eth_enable : 1;               // DWORD 0
      } SG_PACK TXULP_SCHEDULER_CNTRL, *PTXULP_SCHEDULER_CNTRL;

      typedef union _TXULP_SCHEDULER_CNTRL_UNION {
         TXULP_SCHEDULER_CNTRL bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_CNTRL_UNION, *PTXULP_SCHEDULER_CNTRL_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_CNTRL_UNION, sizeof (TXULP_SCHEDULER_CNTRL_UNION) == 4);
   #endif


#else
   // TXULP Scheduler Control Register. Controls Various Features of the Scheduler.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_SCHEDULER_CNTRL {
         union {
            struct { 
               u32 ha_raw_eth_enable : 1;         // DWORD 0
               u32 ha_toe_enable : 1;             // DWORD 0
               u32 ctx_nv_rs_enable : 1;          // DWORD 0
               u32 uc_pre_enable : 1;             // DWORD 0
               u32 rsvd0 : 4;                     // DWORD 0
               u32 tcp_state_first_16B_rd : 3;    // DWORD 0
               u32 rsvd1 : 5;                     // DWORD 0
               u32 tcp_state_second_16B_rd : 3;   // DWORD 0
               u32 rsvd2 : 5;                     // DWORD 0
               u32 tcp_state_num_16B_rd : 4;      // DWORD 0
               u32 dma_swap_mode_for_mcc_immed_rd : 2; // DWORD 0
               u32 dma_swap_mode_for_eth_immed_rd : 2; // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_SCHEDULER_CNTRL, *PTXULP_SCHEDULER_CNTRL;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_CNTRL, sizeof (TXULP_SCHEDULER_CNTRL) == 4);

   #else
      typedef struct _TXULP_SCHEDULER_CNTRL {
         u32 ha_raw_eth_enable : 1;               // DWORD 0
         u32 ha_toe_enable : 1;                   // DWORD 0
         u32 ctx_nv_rs_enable : 1;                // DWORD 0
         u32 uc_pre_enable : 1;                   // DWORD 0
         u32 rsvd0 : 4;                           // DWORD 0
         u32 tcp_state_first_16B_rd : 3;          // DWORD 0
         u32 rsvd1 : 5;                           // DWORD 0
         u32 tcp_state_second_16B_rd : 3;         // DWORD 0
         u32 rsvd2 : 5;                           // DWORD 0
         u32 tcp_state_num_16B_rd : 4;            // DWORD 0
         u32 dma_swap_mode_for_mcc_immed_rd : 2;  // DWORD 0
         u32 dma_swap_mode_for_eth_immed_rd : 2;  // DWORD 0
      } SG_PACK TXULP_SCHEDULER_CNTRL, *PTXULP_SCHEDULER_CNTRL;

      typedef union _TXULP_SCHEDULER_CNTRL_UNION {
         TXULP_SCHEDULER_CNTRL bits;
         u32 dw; // dword union
      } SG_PACK TXULP_SCHEDULER_CNTRL_UNION, *PTXULP_SCHEDULER_CNTRL_UNION;

      SG_C_ASSERT(__sizeof__TXULP_SCHEDULER_CNTRL_UNION, sizeof (TXULP_SCHEDULER_CNTRL_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // iSCSI Out-of-Order Control Register. During an iSCSI OOO, the relevant RxULP
   // processor builds a set of transmit buffers as a collection of Raw Ethernet packets.
   // Once this is built, the iSCSI RxULP processor will indicate this to the Raw Ethernet
   // TxULP processor which will then <I>transmit</i> the buffers in the TXP-RXF loopback
   // path back around to the receive side of BladeEngine. This register defines the
   // dedicated Raw Ethernet CID used for the loopback.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_ISCSI_OOO_CID {
         union {
            struct { 
               u32 rsvd1 : 15;                    // DWORD 0
               u32 consel_postc_en : 1;           // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 consel_postc_cid : 11;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_ISCSI_OOO_CID, *PTXULP_ISCSI_OOO_CID;

      SG_C_ASSERT(__sizeof__TXULP_ISCSI_OOO_CID, sizeof (TXULP_ISCSI_OOO_CID) == 4);

   #else
      typedef struct _TXULP_ISCSI_OOO_CID {
         u32 rsvd1 : 15;                          // DWORD 0
         u32 consel_postc_en : 1;                 // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 consel_postc_cid : 11;               // DWORD 0
      } SG_PACK TXULP_ISCSI_OOO_CID, *PTXULP_ISCSI_OOO_CID;

      typedef union _TXULP_ISCSI_OOO_CID_UNION {
         TXULP_ISCSI_OOO_CID bits;
         u32 dw; // dword union
      } SG_PACK TXULP_ISCSI_OOO_CID_UNION, *PTXULP_ISCSI_OOO_CID_UNION;

      SG_C_ASSERT(__sizeof__TXULP_ISCSI_OOO_CID_UNION, sizeof (TXULP_ISCSI_OOO_CID_UNION) == 4);
   #endif


#else
   // iSCSI Out-of-Order Control Register. During an iSCSI OOO, the relevant RxULP
   // processor builds a set of transmit buffers as a collection of Raw Ethernet packets.
   // Once this is built, the iSCSI RxULP processor will indicate this to the Raw Ethernet
   // TxULP processor which will then <I>transmit</i> the buffers in the TXP-RXF loopback
   // path back around to the receive side of BladeEngine. This register defines the
   // dedicated Raw Ethernet CID used for the loopback.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_ISCSI_OOO_CID {
         union {
            struct { 
               u32 consel_postc_cid : 11;         // DWORD 0
               u32 rsvd0 : 5;                     // DWORD 0
               u32 consel_postc_en : 1;           // DWORD 0
               u32 rsvd1 : 15;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_ISCSI_OOO_CID, *PTXULP_ISCSI_OOO_CID;

      SG_C_ASSERT(__sizeof__TXULP_ISCSI_OOO_CID, sizeof (TXULP_ISCSI_OOO_CID) == 4);

   #else
      typedef struct _TXULP_ISCSI_OOO_CID {
         u32 consel_postc_cid : 11;               // DWORD 0
         u32 rsvd0 : 5;                           // DWORD 0
         u32 consel_postc_en : 1;                 // DWORD 0
         u32 rsvd1 : 15;                          // DWORD 0
      } SG_PACK TXULP_ISCSI_OOO_CID, *PTXULP_ISCSI_OOO_CID;

      typedef union _TXULP_ISCSI_OOO_CID_UNION {
         TXULP_ISCSI_OOO_CID bits;
         u32 dw; // dword union
      } SG_PACK TXULP_ISCSI_OOO_CID_UNION, *PTXULP_ISCSI_OOO_CID_UNION;

      SG_C_ASSERT(__sizeof__TXULP_ISCSI_OOO_CID_UNION, sizeof (TXULP_ISCSI_OOO_CID_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register for accessing the TXULP's classification instructionRAM and
   // classification constants.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_COPROCESSOR_CR {
         union {
            struct { 
               u32 rsvd1 : 16;                    // DWORD 0
               u32 class_const_addr : 4;          // DWORD 0
               u32 class_en : 1;                  // DWORD 0
               u32 class_const_wr : 1;            // DWORD 0
               u32 class_iram_wr : 1;             // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 class_iaddr : 7;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_COPROCESSOR_CR, *PTXULP_COPROCESSOR_CR;

      SG_C_ASSERT(__sizeof__TXULP_COPROCESSOR_CR, sizeof (TXULP_COPROCESSOR_CR) == 4);

   #else
      typedef struct _TXULP_COPROCESSOR_CR {
         u32 rsvd1 : 16;                          // DWORD 0
         u32 class_const_addr : 4;                // DWORD 0
         u32 class_en : 1;                        // DWORD 0
         u32 class_const_wr : 1;                  // DWORD 0
         u32 class_iram_wr : 1;                   // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 class_iaddr : 7;                     // DWORD 0
      } SG_PACK TXULP_COPROCESSOR_CR, *PTXULP_COPROCESSOR_CR;

      typedef union _TXULP_COPROCESSOR_CR_UNION {
         TXULP_COPROCESSOR_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_COPROCESSOR_CR_UNION, *PTXULP_COPROCESSOR_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_COPROCESSOR_CR_UNION, sizeof (TXULP_COPROCESSOR_CR_UNION) == 4);
   #endif


#else
   // Control register for accessing the TXULP's classification instructionRAM and
   // classification constants.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_COPROCESSOR_CR {
         union {
            struct { 
               u32 class_iaddr : 7;               // DWORD 0
               u32 rsvd0 : 2;                     // DWORD 0
               u32 class_iram_wr : 1;             // DWORD 0
               u32 class_const_wr : 1;            // DWORD 0
               u32 class_en : 1;                  // DWORD 0
               u32 class_const_addr : 4;          // DWORD 0
               u32 rsvd1 : 16;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_COPROCESSOR_CR, *PTXULP_COPROCESSOR_CR;

      SG_C_ASSERT(__sizeof__TXULP_COPROCESSOR_CR, sizeof (TXULP_COPROCESSOR_CR) == 4);

   #else
      typedef struct _TXULP_COPROCESSOR_CR {
         u32 class_iaddr : 7;                     // DWORD 0
         u32 rsvd0 : 2;                           // DWORD 0
         u32 class_iram_wr : 1;                   // DWORD 0
         u32 class_const_wr : 1;                  // DWORD 0
         u32 class_en : 1;                        // DWORD 0
         u32 class_const_addr : 4;                // DWORD 0
         u32 rsvd1 : 16;                          // DWORD 0
      } SG_PACK TXULP_COPROCESSOR_CR, *PTXULP_COPROCESSOR_CR;

      typedef union _TXULP_COPROCESSOR_CR_UNION {
         TXULP_COPROCESSOR_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_COPROCESSOR_CR_UNION, *PTXULP_COPROCESSOR_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_COPROCESSOR_CR_UNION, sizeof (TXULP_COPROCESSOR_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction read/write data to the TXULP classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_IRAM_RWDATAL_CSR {
         union {
            struct { 
               u32 class_iram_datal;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR, *PTXULP_CLASS_IRAM_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAL_CSR, sizeof (TXULP_CLASS_IRAM_RWDATAL_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_IRAM_RWDATAL_CSR {
         u32 class_iram_datal;                    // DWORD 0
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR, *PTXULP_CLASS_IRAM_RWDATAL_CSR;

      typedef union _TXULP_CLASS_IRAM_RWDATAL_CSR_UNION {
         TXULP_CLASS_IRAM_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR_UNION, *PTXULP_CLASS_IRAM_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAL_CSR_UNION, sizeof (TXULP_CLASS_IRAM_RWDATAL_CSR_UNION) == 4);
   #endif


#else
   // Instruction read/write data to the TXULP classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_IRAM_RWDATAL_CSR {
         union {
            struct { 
               u32 class_iram_datal;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR, *PTXULP_CLASS_IRAM_RWDATAL_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAL_CSR, sizeof (TXULP_CLASS_IRAM_RWDATAL_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_IRAM_RWDATAL_CSR {
         u32 class_iram_datal;                    // DWORD 0
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR, *PTXULP_CLASS_IRAM_RWDATAL_CSR;

      typedef union _TXULP_CLASS_IRAM_RWDATAL_CSR_UNION {
         TXULP_CLASS_IRAM_RWDATAL_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAL_CSR_UNION, *PTXULP_CLASS_IRAM_RWDATAL_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAL_CSR_UNION, sizeof (TXULP_CLASS_IRAM_RWDATAL_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Instruction read/write data to the TXULP classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_IRAM_RWDATAU_CSR {
         union {
            struct { 
               u32 rsvd0 : 19;                    // DWORD 0
               u32 class_iram_datau : 13;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR, *PTXULP_CLASS_IRAM_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAU_CSR, sizeof (TXULP_CLASS_IRAM_RWDATAU_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_IRAM_RWDATAU_CSR {
         u32 rsvd0 : 19;                          // DWORD 0
         u32 class_iram_datau : 13;               // DWORD 0
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR, *PTXULP_CLASS_IRAM_RWDATAU_CSR;

      typedef union _TXULP_CLASS_IRAM_RWDATAU_CSR_UNION {
         TXULP_CLASS_IRAM_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR_UNION, *PTXULP_CLASS_IRAM_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAU_CSR_UNION, sizeof (TXULP_CLASS_IRAM_RWDATAU_CSR_UNION) == 4);
   #endif


#else
   // Instruction read/write data to the TXULP classification engine.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_IRAM_RWDATAU_CSR {
         union {
            struct { 
               u32 class_iram_datau : 13;         // DWORD 0
               u32 rsvd0 : 19;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR, *PTXULP_CLASS_IRAM_RWDATAU_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAU_CSR, sizeof (TXULP_CLASS_IRAM_RWDATAU_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_IRAM_RWDATAU_CSR {
         u32 class_iram_datau : 13;               // DWORD 0
         u32 rsvd0 : 19;                          // DWORD 0
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR, *PTXULP_CLASS_IRAM_RWDATAU_CSR;

      typedef union _TXULP_CLASS_IRAM_RWDATAU_CSR_UNION {
         TXULP_CLASS_IRAM_RWDATAU_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_IRAM_RWDATAU_CSR_UNION, *PTXULP_CLASS_IRAM_RWDATAU_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_IRAM_RWDATAU_CSR_UNION, sizeof (TXULP_CLASS_IRAM_RWDATAU_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Read/Write data to the classification constant registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_CONST_RWDATA_CSR {
         union {
            struct { 
               u32 class_const_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR, *PTXULP_CLASS_CONST_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_CONST_RWDATA_CSR, sizeof (TXULP_CLASS_CONST_RWDATA_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_CONST_RWDATA_CSR {
         u32 class_const_data;                    // DWORD 0
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR, *PTXULP_CLASS_CONST_RWDATA_CSR;

      typedef union _TXULP_CLASS_CONST_RWDATA_CSR_UNION {
         TXULP_CLASS_CONST_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR_UNION, *PTXULP_CLASS_CONST_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_CONST_RWDATA_CSR_UNION, sizeof (TXULP_CLASS_CONST_RWDATA_CSR_UNION) == 4);
   #endif


#else
   // Read/Write data to the classification constant registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_CONST_RWDATA_CSR {
         union {
            struct { 
               u32 class_const_data;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR, *PTXULP_CLASS_CONST_RWDATA_CSR;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_CONST_RWDATA_CSR, sizeof (TXULP_CLASS_CONST_RWDATA_CSR) == 4);

   #else
      typedef struct _TXULP_CLASS_CONST_RWDATA_CSR {
         u32 class_const_data;                    // DWORD 0
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR, *PTXULP_CLASS_CONST_RWDATA_CSR;

      typedef union _TXULP_CLASS_CONST_RWDATA_CSR_UNION {
         TXULP_CLASS_CONST_RWDATA_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_CONST_RWDATA_CSR_UNION, *PTXULP_CLASS_CONST_RWDATA_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_CONST_RWDATA_CSR_UNION, sizeof (TXULP_CLASS_CONST_RWDATA_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register used for the process of accessing (i.e. reading or writing)the
   // TXULP's local QoS CBS and PBS values. This register is used to set the flownumber
   // for which the CBS or PBS values are to be read or written.The flow number value is
   // automatically incremented by hardware any timethat the TXULP_QOS_CBS_CSR or
   // TXULP_QOS_PBS_CSR is read or written. -CBS = Commited Burst Size -PBS = Peak Burst
   // Size
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 cbs_pbs_flow_num : 5;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, sizeof (TXULP_QOS_CBS_PBS_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 cbs_pbs_flow_num : 5;                // DWORD 0
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR;

      typedef union _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION {
         TXULP_QOS_CBS_PBS_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, sizeof (TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION) == 4);
   #endif


#else
   // Control register used for the process of accessing (i.e. reading or writing)the
   // TXULP's local QoS CBS and PBS values. This register is used to set the flownumber
   // for which the CBS or PBS values are to be read or written.The flow number value is
   // automatically incremented by hardware any timethat the TXULP_QOS_CBS_CSR or
   // TXULP_QOS_PBS_CSR is read or written. -CBS = Commited Burst Size -PBS = Peak Burst
   // Size
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR {
         union {
            struct { 
               u32 cbs_pbs_flow_num : 5;          // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, sizeof (TXULP_QOS_CBS_PBS_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR {
         u32 cbs_pbs_flow_num : 5;                // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR;

      typedef union _TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION {
         TXULP_QOS_CBS_PBS_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, *PTXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, sizeof (TXULP_QOS_CBS_PBS_FLOW_NUM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read or write the CBS variable for a given flow number.The
   // flow number must first be setup using the TXULP_CBS_PBS_FLOW_NUM_CSR.Each time that
   // this register is read or written, the flow number valueof the
   // TXULP_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_CBS_CSR {
         union {
            struct { 
               u32 cbs_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_CBS_CSR, *PTXULP_QOS_CBS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_CSR, sizeof (TXULP_QOS_CBS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_CBS_CSR {
         u32 cbs_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_CBS_CSR, *PTXULP_QOS_CBS_CSR;

      typedef union _TXULP_QOS_CBS_CSR_UNION {
         TXULP_QOS_CBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_CBS_CSR_UNION, *PTXULP_QOS_CBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_CSR_UNION, sizeof (TXULP_QOS_CBS_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read or write the CBS variable for a given flow number.The
   // flow number must first be setup using the TXULP_CBS_PBS_FLOW_NUM_CSR.Each time that
   // this register is read or written, the flow number valueof the
   // TXULP_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_CBS_CSR {
         union {
            struct { 
               u32 cbs_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_CBS_CSR, *PTXULP_QOS_CBS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_CSR, sizeof (TXULP_QOS_CBS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_CBS_CSR {
         u32 cbs_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_CBS_CSR, *PTXULP_QOS_CBS_CSR;

      typedef union _TXULP_QOS_CBS_CSR_UNION {
         TXULP_QOS_CBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_CBS_CSR_UNION, *PTXULP_QOS_CBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_CBS_CSR_UNION, sizeof (TXULP_QOS_CBS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read or write the PBS variable for a given flow number.The
   // flow number must first be setup using the TXULP_CBS_PBS_FLOW_NUM_CSR.Each time that
   // this register is read or written, the flow number valueof the
   // TXULP_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_PBS_CSR {
         union {
            struct { 
               u32 pbs_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_PBS_CSR, *PTXULP_QOS_PBS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_PBS_CSR, sizeof (TXULP_QOS_PBS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_PBS_CSR {
         u32 pbs_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_PBS_CSR, *PTXULP_QOS_PBS_CSR;

      typedef union _TXULP_QOS_PBS_CSR_UNION {
         TXULP_QOS_PBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_PBS_CSR_UNION, *PTXULP_QOS_PBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_PBS_CSR_UNION, sizeof (TXULP_QOS_PBS_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read or write the PBS variable for a given flow number.The
   // flow number must first be setup using the TXULP_CBS_PBS_FLOW_NUM_CSR.Each time that
   // this register is read or written, the flow number valueof the
   // TXULP_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_PBS_CSR {
         union {
            struct { 
               u32 pbs_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_PBS_CSR, *PTXULP_QOS_PBS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_PBS_CSR, sizeof (TXULP_QOS_PBS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_PBS_CSR {
         u32 pbs_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_PBS_CSR, *PTXULP_QOS_PBS_CSR;

      typedef union _TXULP_QOS_PBS_CSR_UNION {
         TXULP_QOS_PBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_PBS_CSR_UNION, *PTXULP_QOS_PBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_PBS_CSR_UNION, sizeof (TXULP_QOS_PBS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register used for the process of accessing (i.e. reading only)the TXULP's
   // local EBP value. This register is used to set the flownumber for which EBP value is
   // to be read. EBP is calculated by hardwareThe flow number value is automatically
   // incremented by hardware any timethat the TXULP_QOS_EBP_CSR is read. -EBP = Excess
   // Bandwidth Pointer
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_EBP_FLOW_NUM_CSR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 ebp_flow_num : 5;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR, *PTXULP_QOS_EBP_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_FLOW_NUM_CSR, sizeof (TXULP_QOS_EBP_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_EBP_FLOW_NUM_CSR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 ebp_flow_num : 5;                    // DWORD 0
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR, *PTXULP_QOS_EBP_FLOW_NUM_CSR;

      typedef union _TXULP_QOS_EBP_FLOW_NUM_CSR_UNION {
         TXULP_QOS_EBP_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR_UNION, *PTXULP_QOS_EBP_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_FLOW_NUM_CSR_UNION, sizeof (TXULP_QOS_EBP_FLOW_NUM_CSR_UNION) == 4);
   #endif


#else
   // Control register used for the process of accessing (i.e. reading only)the TXULP's
   // local EBP value. This register is used to set the flownumber for which EBP value is
   // to be read. EBP is calculated by hardwareThe flow number value is automatically
   // incremented by hardware any timethat the TXULP_QOS_EBP_CSR is read. -EBP = Excess
   // Bandwidth Pointer
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_EBP_FLOW_NUM_CSR {
         union {
            struct { 
               u32 ebp_flow_num : 5;              // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR, *PTXULP_QOS_EBP_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_FLOW_NUM_CSR, sizeof (TXULP_QOS_EBP_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_EBP_FLOW_NUM_CSR {
         u32 ebp_flow_num : 5;                    // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR, *PTXULP_QOS_EBP_FLOW_NUM_CSR;

      typedef union _TXULP_QOS_EBP_FLOW_NUM_CSR_UNION {
         TXULP_QOS_EBP_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_EBP_FLOW_NUM_CSR_UNION, *PTXULP_QOS_EBP_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_FLOW_NUM_CSR_UNION, sizeof (TXULP_QOS_EBP_FLOW_NUM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read the EBP variable for a given flow number.The flow
   // number must first be setup using the TXULP_EBP_FLOW_NUM_CSR.Each time that this
   // register is read or written, the flow number valueof the TXULP_EBP_FLOW_NUM_CSR is
   // automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_EBP_CSR {
         union {
            struct { 
               u32 ebp_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_EBP_CSR, *PTXULP_QOS_EBP_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_CSR, sizeof (TXULP_QOS_EBP_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_EBP_CSR {
         u32 ebp_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_EBP_CSR, *PTXULP_QOS_EBP_CSR;

      typedef union _TXULP_QOS_EBP_CSR_UNION {
         TXULP_QOS_EBP_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_EBP_CSR_UNION, *PTXULP_QOS_EBP_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_CSR_UNION, sizeof (TXULP_QOS_EBP_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read the EBP variable for a given flow number.The flow
   // number must first be setup using the TXULP_EBP_FLOW_NUM_CSR.Each time that this
   // register is read or written, the flow number valueof the TXULP_EBP_FLOW_NUM_CSR is
   // automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_EBP_CSR {
         union {
            struct { 
               u32 ebp_data;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_EBP_CSR, *PTXULP_QOS_EBP_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_CSR, sizeof (TXULP_QOS_EBP_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_EBP_CSR {
         u32 ebp_data;                            // DWORD 0
      } SG_PACK TXULP_QOS_EBP_CSR, *PTXULP_QOS_EBP_CSR;

      typedef union _TXULP_QOS_EBP_CSR_UNION {
         TXULP_QOS_EBP_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_EBP_CSR_UNION, *PTXULP_QOS_EBP_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_EBP_CSR_UNION, sizeof (TXULP_QOS_EBP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to set the QOS timer value. Each time the timer expires a given flow's: -QoS
   // token bucket, Tc, is re-loaded with the CBS variable value -EBP is re-calculated and
   // re-loadedThe flow number to be serviced increments by 1 each time the timer
   // expires.The timer resolution is equal to the core clock period.This register can be
   // written at any time but the timer hardware will onlybe updated to use the value
   // written to this register when the devicetransitions from its off-line state to its
   // online state.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_TIMER_INIT_CSR {
         union {
            struct { 
               u32 qos_timer_value;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR, *PTXULP_QOS_TIMER_INIT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_TIMER_INIT_CSR, sizeof (TXULP_QOS_TIMER_INIT_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_TIMER_INIT_CSR {
         u32 qos_timer_value;                     // DWORD 0
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR, *PTXULP_QOS_TIMER_INIT_CSR;

      typedef union _TXULP_QOS_TIMER_INIT_CSR_UNION {
         TXULP_QOS_TIMER_INIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR_UNION, *PTXULP_QOS_TIMER_INIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_TIMER_INIT_CSR_UNION, sizeof (TXULP_QOS_TIMER_INIT_CSR_UNION) == 4);
   #endif


#else
   // Used to set the QOS timer value. Each time the timer expires a given flow's: -QoS
   // token bucket, Tc, is re-loaded with the CBS variable value -EBP is re-calculated and
   // re-loadedThe flow number to be serviced increments by 1 each time the timer
   // expires.The timer resolution is equal to the core clock period.This register can be
   // written at any time but the timer hardware will onlybe updated to use the value
   // written to this register when the devicetransitions from its off-line state to its
   // online state.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_TIMER_INIT_CSR {
         union {
            struct { 
               u32 qos_timer_value;               // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR, *PTXULP_QOS_TIMER_INIT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_TIMER_INIT_CSR, sizeof (TXULP_QOS_TIMER_INIT_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_TIMER_INIT_CSR {
         u32 qos_timer_value;                     // DWORD 0
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR, *PTXULP_QOS_TIMER_INIT_CSR;

      typedef union _TXULP_QOS_TIMER_INIT_CSR_UNION {
         TXULP_QOS_TIMER_INIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_TIMER_INIT_CSR_UNION, *PTXULP_QOS_TIMER_INIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_TIMER_INIT_CSR_UNION, sizeof (TXULP_QOS_TIMER_INIT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to set the arbitration weights for the local QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_WEIGHTS_CSR {
         union {
            struct { 
               u32 rsvd0 : 12;                    // DWORD 0
               u32 rrnode_weight : 4;             // DWORD 0
               u32 timer_weight : 4;              // DWORD 0
               u32 class_req_weight : 4;          // DWORD 0
               u32 sched_up_weight : 4;           // DWORD 0
               u32 ep_oq_weight : 4;              // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_WEIGHTS_CSR, *PTXULP_QOS_WEIGHTS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_WEIGHTS_CSR, sizeof (TXULP_QOS_WEIGHTS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_WEIGHTS_CSR {
         u32 rsvd0 : 12;                          // DWORD 0
         u32 rrnode_weight : 4;                   // DWORD 0
         u32 timer_weight : 4;                    // DWORD 0
         u32 class_req_weight : 4;                // DWORD 0
         u32 sched_up_weight : 4;                 // DWORD 0
         u32 ep_oq_weight : 4;                    // DWORD 0
      } SG_PACK TXULP_QOS_WEIGHTS_CSR, *PTXULP_QOS_WEIGHTS_CSR;

      typedef union _TXULP_QOS_WEIGHTS_CSR_UNION {
         TXULP_QOS_WEIGHTS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_WEIGHTS_CSR_UNION, *PTXULP_QOS_WEIGHTS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_WEIGHTS_CSR_UNION, sizeof (TXULP_QOS_WEIGHTS_CSR_UNION) == 4);
   #endif


#else
   // Used to set the arbitration weights for the local QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_QOS_WEIGHTS_CSR {
         union {
            struct { 
               u32 ep_oq_weight : 4;              // DWORD 0
               u32 sched_up_weight : 4;           // DWORD 0
               u32 class_req_weight : 4;          // DWORD 0
               u32 timer_weight : 4;              // DWORD 0
               u32 rrnode_weight : 4;             // DWORD 0
               u32 rsvd0 : 12;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_QOS_WEIGHTS_CSR, *PTXULP_QOS_WEIGHTS_CSR;

      SG_C_ASSERT(__sizeof__TXULP_QOS_WEIGHTS_CSR, sizeof (TXULP_QOS_WEIGHTS_CSR) == 4);

   #else
      typedef struct _TXULP_QOS_WEIGHTS_CSR {
         u32 ep_oq_weight : 4;                    // DWORD 0
         u32 sched_up_weight : 4;                 // DWORD 0
         u32 class_req_weight : 4;                // DWORD 0
         u32 timer_weight : 4;                    // DWORD 0
         u32 rrnode_weight : 4;                   // DWORD 0
         u32 rsvd0 : 12;                          // DWORD 0
      } SG_PACK TXULP_QOS_WEIGHTS_CSR, *PTXULP_QOS_WEIGHTS_CSR;

      typedef union _TXULP_QOS_WEIGHTS_CSR_UNION {
         TXULP_QOS_WEIGHTS_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_QOS_WEIGHTS_CSR_UNION, *PTXULP_QOS_WEIGHTS_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_QOS_WEIGHTS_CSR_UNION, sizeof (TXULP_QOS_WEIGHTS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register used for the process of accessing (i.e. reading or writing)the
   // Global QoS CBS and PBS values. This register is used to set the flownumber for which
   // the CBS or PBS values are to be read or written.The flow number value is
   // automatically incremented by hardware any timethat the GLOB_QOS_CBS_CSR or
   // GLOB_QOS_PBS_CSR is read or written. -CBS = Commited Burst Size -PBS = Peak Burst
   // Size
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 glob_cbs_pbs_flow_num : 6;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, sizeof (GLOB_QOS_CBS_PBS_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 glob_cbs_pbs_flow_num : 6;           // DWORD 0
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR;

      typedef union _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION {
         GLOB_QOS_CBS_PBS_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, sizeof (GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION) == 4);
   #endif


#else
   // Control register used for the process of accessing (i.e. reading or writing)the
   // Global QoS CBS and PBS values. This register is used to set the flownumber for which
   // the CBS or PBS values are to be read or written.The flow number value is
   // automatically incremented by hardware any timethat the GLOB_QOS_CBS_CSR or
   // GLOB_QOS_PBS_CSR is read or written. -CBS = Commited Burst Size -PBS = Peak Burst
   // Size
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR {
         union {
            struct { 
               u32 glob_cbs_pbs_flow_num : 6;     // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, sizeof (GLOB_QOS_CBS_PBS_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR {
         u32 glob_cbs_pbs_flow_num : 6;           // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR;

      typedef union _GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION {
         GLOB_QOS_CBS_PBS_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, *PGLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION, sizeof (GLOB_QOS_CBS_PBS_FLOW_NUM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read or write the Global CBS variable for a given flow
   // number.The flow number must first be setup using the GLOB_CBS_PBS_FLOW_NUM_CSR.Each
   // time that this register is read or written, the flow number valueof the
   // GLOB_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_CBS_CSR {
         union {
            struct { 
               u32 glob_cbs_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_CBS_CSR, *PGLOB_QOS_CBS_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_CSR, sizeof (GLOB_QOS_CBS_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_CBS_CSR {
         u32 glob_cbs_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_CBS_CSR, *PGLOB_QOS_CBS_CSR;

      typedef union _GLOB_QOS_CBS_CSR_UNION {
         GLOB_QOS_CBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_CBS_CSR_UNION, *PGLOB_QOS_CBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_CSR_UNION, sizeof (GLOB_QOS_CBS_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read or write the Global CBS variable for a given flow
   // number.The flow number must first be setup using the GLOB_CBS_PBS_FLOW_NUM_CSR.Each
   // time that this register is read or written, the flow number valueof the
   // GLOB_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_CBS_CSR {
         union {
            struct { 
               u32 glob_cbs_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_CBS_CSR, *PGLOB_QOS_CBS_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_CSR, sizeof (GLOB_QOS_CBS_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_CBS_CSR {
         u32 glob_cbs_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_CBS_CSR, *PGLOB_QOS_CBS_CSR;

      typedef union _GLOB_QOS_CBS_CSR_UNION {
         GLOB_QOS_CBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_CBS_CSR_UNION, *PGLOB_QOS_CBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_CBS_CSR_UNION, sizeof (GLOB_QOS_CBS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read or write the Global PBS variable for a given flow
   // number.The flow number must first be setup using the GLOB_CBS_PBS_FLOW_NUM_CSR.Each
   // time that this register is read or written, the flow number valueof the
   // GLOB_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_PBS_CSR {
         union {
            struct { 
               u32 glob_pbs_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_PBS_CSR, *PGLOB_QOS_PBS_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_PBS_CSR, sizeof (GLOB_QOS_PBS_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_PBS_CSR {
         u32 glob_pbs_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_PBS_CSR, *PGLOB_QOS_PBS_CSR;

      typedef union _GLOB_QOS_PBS_CSR_UNION {
         GLOB_QOS_PBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_PBS_CSR_UNION, *PGLOB_QOS_PBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_PBS_CSR_UNION, sizeof (GLOB_QOS_PBS_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read or write the Global PBS variable for a given flow
   // number.The flow number must first be setup using the GLOB_CBS_PBS_FLOW_NUM_CSR.Each
   // time that this register is read or written, the flow number valueof the
   // GLOB_CBS_PBS_FLOW_NUM_CSR is automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_PBS_CSR {
         union {
            struct { 
               u32 glob_pbs_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_PBS_CSR, *PGLOB_QOS_PBS_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_PBS_CSR, sizeof (GLOB_QOS_PBS_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_PBS_CSR {
         u32 glob_pbs_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_PBS_CSR, *PGLOB_QOS_PBS_CSR;

      typedef union _GLOB_QOS_PBS_CSR_UNION {
         GLOB_QOS_PBS_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_PBS_CSR_UNION, *PGLOB_QOS_PBS_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_PBS_CSR_UNION, sizeof (GLOB_QOS_PBS_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Control register used for the process of accessing (i.e. reading only)the Global EBP
   // value. This register is used to set the flownumber for which Global EBP value is to
   // be read. Global EBP is calculated by hardwareThe flow number value is automatically
   // incremented by hardware any timethat the GLOB_QOS_EBP_CSR is read. -EBP = Excess
   // Bandwidth Pointer
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_EBP_FLOW_NUM_CSR {
         union {
            struct { 
               u32 rsvd0 : 26;                    // DWORD 0
               u32 glob_ebp_flow_num : 6;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR, *PGLOB_QOS_EBP_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_FLOW_NUM_CSR, sizeof (GLOB_QOS_EBP_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_EBP_FLOW_NUM_CSR {
         u32 rsvd0 : 26;                          // DWORD 0
         u32 glob_ebp_flow_num : 6;               // DWORD 0
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR, *PGLOB_QOS_EBP_FLOW_NUM_CSR;

      typedef union _GLOB_QOS_EBP_FLOW_NUM_CSR_UNION {
         GLOB_QOS_EBP_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR_UNION, *PGLOB_QOS_EBP_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_FLOW_NUM_CSR_UNION, sizeof (GLOB_QOS_EBP_FLOW_NUM_CSR_UNION) == 4);
   #endif


#else
   // Control register used for the process of accessing (i.e. reading only)the Global EBP
   // value. This register is used to set the flownumber for which Global EBP value is to
   // be read. Global EBP is calculated by hardwareThe flow number value is automatically
   // incremented by hardware any timethat the GLOB_QOS_EBP_CSR is read. -EBP = Excess
   // Bandwidth Pointer
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_EBP_FLOW_NUM_CSR {
         union {
            struct { 
               u32 glob_ebp_flow_num : 6;         // DWORD 0
               u32 rsvd0 : 26;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR, *PGLOB_QOS_EBP_FLOW_NUM_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_FLOW_NUM_CSR, sizeof (GLOB_QOS_EBP_FLOW_NUM_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_EBP_FLOW_NUM_CSR {
         u32 glob_ebp_flow_num : 6;               // DWORD 0
         u32 rsvd0 : 26;                          // DWORD 0
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR, *PGLOB_QOS_EBP_FLOW_NUM_CSR;

      typedef union _GLOB_QOS_EBP_FLOW_NUM_CSR_UNION {
         GLOB_QOS_EBP_FLOW_NUM_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_EBP_FLOW_NUM_CSR_UNION, *PGLOB_QOS_EBP_FLOW_NUM_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_FLOW_NUM_CSR_UNION, sizeof (GLOB_QOS_EBP_FLOW_NUM_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used as the data port to read the Global EBP variable for a given flow number.The
   // flow number must first be setup using the GLOB_EBP_FLOW_NUM_CSR.Each time that this
   // register is read or written, the flow number valueof the GLOB_EBP_FLOW_NUM_CSR is
   // automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_EBP_CSR {
         union {
            struct { 
               u32 glob_ebp_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_EBP_CSR, *PGLOB_QOS_EBP_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_CSR, sizeof (GLOB_QOS_EBP_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_EBP_CSR {
         u32 glob_ebp_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_EBP_CSR, *PGLOB_QOS_EBP_CSR;

      typedef union _GLOB_QOS_EBP_CSR_UNION {
         GLOB_QOS_EBP_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_EBP_CSR_UNION, *PGLOB_QOS_EBP_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_CSR_UNION, sizeof (GLOB_QOS_EBP_CSR_UNION) == 4);
   #endif


#else
   // Used as the data port to read the Global EBP variable for a given flow number.The
   // flow number must first be setup using the GLOB_EBP_FLOW_NUM_CSR.Each time that this
   // register is read or written, the flow number valueof the GLOB_EBP_FLOW_NUM_CSR is
   // automatically incremented.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_EBP_CSR {
         union {
            struct { 
               u32 glob_ebp_data;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_EBP_CSR, *PGLOB_QOS_EBP_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_CSR, sizeof (GLOB_QOS_EBP_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_EBP_CSR {
         u32 glob_ebp_data;                       // DWORD 0
      } SG_PACK GLOB_QOS_EBP_CSR, *PGLOB_QOS_EBP_CSR;

      typedef union _GLOB_QOS_EBP_CSR_UNION {
         GLOB_QOS_EBP_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_EBP_CSR_UNION, *PGLOB_QOS_EBP_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_EBP_CSR_UNION, sizeof (GLOB_QOS_EBP_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to set the Global QOS timer value. Each time the timer expires a given flow's:
   // -QoS token bucket, Tc, is re-loaded with the Global CBS variable value -EBP is
   // re-calculated and re-loadedThe flow number to be serviced increments by 1 each time
   // the timer expires.The timer resolution is equal to the core clock period.This
   // register can be written at any time but the timer hardware will onlybe updated to
   // use the value written to this register when the devicetransitions from its off-line
   // state to its online state.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_TIMER_INIT_CSR {
         union {
            struct { 
               u32 glob_qos_timer_value;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR, *PGLOB_QOS_TIMER_INIT_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_TIMER_INIT_CSR, sizeof (GLOB_QOS_TIMER_INIT_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_TIMER_INIT_CSR {
         u32 glob_qos_timer_value;                // DWORD 0
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR, *PGLOB_QOS_TIMER_INIT_CSR;

      typedef union _GLOB_QOS_TIMER_INIT_CSR_UNION {
         GLOB_QOS_TIMER_INIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR_UNION, *PGLOB_QOS_TIMER_INIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_TIMER_INIT_CSR_UNION, sizeof (GLOB_QOS_TIMER_INIT_CSR_UNION) == 4);
   #endif


#else
   // Used to set the Global QOS timer value. Each time the timer expires a given flow's:
   // -QoS token bucket, Tc, is re-loaded with the Global CBS variable value -EBP is
   // re-calculated and re-loadedThe flow number to be serviced increments by 1 each time
   // the timer expires.The timer resolution is equal to the core clock period.This
   // register can be written at any time but the timer hardware will onlybe updated to
   // use the value written to this register when the devicetransitions from its off-line
   // state to its online state.
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_TIMER_INIT_CSR {
         union {
            struct { 
               u32 glob_qos_timer_value;          // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR, *PGLOB_QOS_TIMER_INIT_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_TIMER_INIT_CSR, sizeof (GLOB_QOS_TIMER_INIT_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_TIMER_INIT_CSR {
         u32 glob_qos_timer_value;                // DWORD 0
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR, *PGLOB_QOS_TIMER_INIT_CSR;

      typedef union _GLOB_QOS_TIMER_INIT_CSR_UNION {
         GLOB_QOS_TIMER_INIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_TIMER_INIT_CSR_UNION, *PGLOB_QOS_TIMER_INIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_TIMER_INIT_CSR_UNION, sizeof (GLOB_QOS_TIMER_INIT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to set the arbitration weights for the Global QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_WEIGHTS_0_CSR {
         union {
            struct { 
               u32 txulp1_class_req_weight : 4;   // DWORD 0
               u32 txulp0_class_req_weight : 4;   // DWORD 0
               u32 txulp2_sched_up_weight : 4;    // DWORD 0
               u32 txulp1_sched_up_weight : 4;    // DWORD 0
               u32 txulp0_sched_up_weight : 4;    // DWORD 0
               u32 txulp2_ep_oq_weight : 4;       // DWORD 0
               u32 txulp1_ep_oq_weight : 4;       // DWORD 0
               u32 txulp0_ep_oq_weight : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR, *PGLOB_QOS_WEIGHTS_0_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_0_CSR, sizeof (GLOB_QOS_WEIGHTS_0_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_WEIGHTS_0_CSR {
         u32 txulp1_class_req_weight : 4;         // DWORD 0
         u32 txulp0_class_req_weight : 4;         // DWORD 0
         u32 txulp2_sched_up_weight : 4;          // DWORD 0
         u32 txulp1_sched_up_weight : 4;          // DWORD 0
         u32 txulp0_sched_up_weight : 4;          // DWORD 0
         u32 txulp2_ep_oq_weight : 4;             // DWORD 0
         u32 txulp1_ep_oq_weight : 4;             // DWORD 0
         u32 txulp0_ep_oq_weight : 4;             // DWORD 0
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR, *PGLOB_QOS_WEIGHTS_0_CSR;

      typedef union _GLOB_QOS_WEIGHTS_0_CSR_UNION {
         GLOB_QOS_WEIGHTS_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR_UNION, *PGLOB_QOS_WEIGHTS_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_0_CSR_UNION, sizeof (GLOB_QOS_WEIGHTS_0_CSR_UNION) == 4);
   #endif


#else
   // Used to set the arbitration weights for the Global QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_WEIGHTS_0_CSR {
         union {
            struct { 
               u32 txulp0_ep_oq_weight : 4;       // DWORD 0
               u32 txulp1_ep_oq_weight : 4;       // DWORD 0
               u32 txulp2_ep_oq_weight : 4;       // DWORD 0
               u32 txulp0_sched_up_weight : 4;    // DWORD 0
               u32 txulp1_sched_up_weight : 4;    // DWORD 0
               u32 txulp2_sched_up_weight : 4;    // DWORD 0
               u32 txulp0_class_req_weight : 4;   // DWORD 0
               u32 txulp1_class_req_weight : 4;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR, *PGLOB_QOS_WEIGHTS_0_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_0_CSR, sizeof (GLOB_QOS_WEIGHTS_0_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_WEIGHTS_0_CSR {
         u32 txulp0_ep_oq_weight : 4;             // DWORD 0
         u32 txulp1_ep_oq_weight : 4;             // DWORD 0
         u32 txulp2_ep_oq_weight : 4;             // DWORD 0
         u32 txulp0_sched_up_weight : 4;          // DWORD 0
         u32 txulp1_sched_up_weight : 4;          // DWORD 0
         u32 txulp2_sched_up_weight : 4;          // DWORD 0
         u32 txulp0_class_req_weight : 4;         // DWORD 0
         u32 txulp1_class_req_weight : 4;         // DWORD 0
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR, *PGLOB_QOS_WEIGHTS_0_CSR;

      typedef union _GLOB_QOS_WEIGHTS_0_CSR_UNION {
         GLOB_QOS_WEIGHTS_0_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_WEIGHTS_0_CSR_UNION, *PGLOB_QOS_WEIGHTS_0_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_0_CSR_UNION, sizeof (GLOB_QOS_WEIGHTS_0_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Used to set the arbitration weights for the Global QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_WEIGHTS_1_CSR {
         union {
            struct { 
               u32 rsvd0 : 20;                    // DWORD 0
               u32 rrnode_weight : 4;             // DWORD 0
               u32 timer_weight : 4;              // DWORD 0
               u32 txulp2_class_req_weight : 4;   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR, *PGLOB_QOS_WEIGHTS_1_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_1_CSR, sizeof (GLOB_QOS_WEIGHTS_1_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_WEIGHTS_1_CSR {
         u32 rsvd0 : 20;                          // DWORD 0
         u32 rrnode_weight : 4;                   // DWORD 0
         u32 timer_weight : 4;                    // DWORD 0
         u32 txulp2_class_req_weight : 4;         // DWORD 0
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR, *PGLOB_QOS_WEIGHTS_1_CSR;

      typedef union _GLOB_QOS_WEIGHTS_1_CSR_UNION {
         GLOB_QOS_WEIGHTS_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR_UNION, *PGLOB_QOS_WEIGHTS_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_1_CSR_UNION, sizeof (GLOB_QOS_WEIGHTS_1_CSR_UNION) == 4);
   #endif


#else
   // Used to set the arbitration weights for the Global QoS hardware clients
   #if defined(SG_BMAP_UNION)
      typedef struct _GLOB_QOS_WEIGHTS_1_CSR {
         union {
            struct { 
               u32 txulp2_class_req_weight : 4;   // DWORD 0
               u32 timer_weight : 4;              // DWORD 0
               u32 rrnode_weight : 4;             // DWORD 0
               u32 rsvd0 : 20;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR, *PGLOB_QOS_WEIGHTS_1_CSR;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_1_CSR, sizeof (GLOB_QOS_WEIGHTS_1_CSR) == 4);

   #else
      typedef struct _GLOB_QOS_WEIGHTS_1_CSR {
         u32 txulp2_class_req_weight : 4;         // DWORD 0
         u32 timer_weight : 4;                    // DWORD 0
         u32 rrnode_weight : 4;                   // DWORD 0
         u32 rsvd0 : 20;                          // DWORD 0
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR, *PGLOB_QOS_WEIGHTS_1_CSR;

      typedef union _GLOB_QOS_WEIGHTS_1_CSR_UNION {
         GLOB_QOS_WEIGHTS_1_CSR bits;
         u32 dw; // dword union
      } SG_PACK GLOB_QOS_WEIGHTS_1_CSR_UNION, *PGLOB_QOS_WEIGHTS_1_CSR_UNION;

      SG_C_ASSERT(__sizeof__GLOB_QOS_WEIGHTS_1_CSR_UNION, sizeof (GLOB_QOS_WEIGHTS_1_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // This register is used to set and monitor the total number of H/W UC request
   // outstanding from the TXULP.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_HW_CREDIT_CSR {
         union {
            struct { 
               u32 rsvd1 : 8;                     // DWORD 0
               u32 uc_hw_credit_cnt : 8;          // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 uc_hw_init_cred : 8;           // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_HW_CREDIT_CSR, *PTXULP_UC_HW_CREDIT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_UC_HW_CREDIT_CSR, sizeof (TXULP_UC_HW_CREDIT_CSR) == 4);

   #else
      typedef struct _TXULP_UC_HW_CREDIT_CSR {
         u32 rsvd1 : 8;                           // DWORD 0
         u32 uc_hw_credit_cnt : 8;                // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 uc_hw_init_cred : 8;                 // DWORD 0
      } SG_PACK TXULP_UC_HW_CREDIT_CSR, *PTXULP_UC_HW_CREDIT_CSR;

      typedef union _TXULP_UC_HW_CREDIT_CSR_UNION {
         TXULP_UC_HW_CREDIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_HW_CREDIT_CSR_UNION, *PTXULP_UC_HW_CREDIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_HW_CREDIT_CSR_UNION, sizeof (TXULP_UC_HW_CREDIT_CSR_UNION) == 4);
   #endif


#else
   // This register is used to set and monitor the total number of H/W UC request
   // outstanding from the TXULP.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_UC_HW_CREDIT_CSR {
         union {
            struct { 
               u32 uc_hw_init_cred : 8;           // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
               u32 uc_hw_credit_cnt : 8;          // DWORD 0
               u32 rsvd1 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_UC_HW_CREDIT_CSR, *PTXULP_UC_HW_CREDIT_CSR;

      SG_C_ASSERT(__sizeof__TXULP_UC_HW_CREDIT_CSR, sizeof (TXULP_UC_HW_CREDIT_CSR) == 4);

   #else
      typedef struct _TXULP_UC_HW_CREDIT_CSR {
         u32 uc_hw_init_cred : 8;                 // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
         u32 uc_hw_credit_cnt : 8;                // DWORD 0
         u32 rsvd1 : 8;                           // DWORD 0
      } SG_PACK TXULP_UC_HW_CREDIT_CSR, *PTXULP_UC_HW_CREDIT_CSR;

      typedef union _TXULP_UC_HW_CREDIT_CSR_UNION {
         TXULP_UC_HW_CREDIT_CSR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_UC_HW_CREDIT_CSR_UNION, *PTXULP_UC_HW_CREDIT_CSR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_UC_HW_CREDIT_CSR_UNION, sizeof (TXULP_UC_HW_CREDIT_CSR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Classification Regfile Address Debug Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_REGFILE_ADDR_DEBUG {
         union {
            struct { 
               u32 rsvd0 : 28;                    // DWORD 0
               u32 class_regfile_addr : 4;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG, *PTXULP_CLASS_REGFILE_ADDR_DEBUG;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_ADDR_DEBUG, sizeof (TXULP_CLASS_REGFILE_ADDR_DEBUG) == 4);

   #else
      typedef struct _TXULP_CLASS_REGFILE_ADDR_DEBUG {
         u32 rsvd0 : 28;                          // DWORD 0
         u32 class_regfile_addr : 4;              // DWORD 0
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG, *PTXULP_CLASS_REGFILE_ADDR_DEBUG;

      typedef union _TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION {
         TXULP_CLASS_REGFILE_ADDR_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION, *PTXULP_CLASS_REGFILE_ADDR_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION, sizeof (TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION) == 4);
   #endif


#else
   // Classification Regfile Address Debug Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_REGFILE_ADDR_DEBUG {
         union {
            struct { 
               u32 class_regfile_addr : 4;        // DWORD 0
               u32 rsvd0 : 28;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG, *PTXULP_CLASS_REGFILE_ADDR_DEBUG;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_ADDR_DEBUG, sizeof (TXULP_CLASS_REGFILE_ADDR_DEBUG) == 4);

   #else
      typedef struct _TXULP_CLASS_REGFILE_ADDR_DEBUG {
         u32 class_regfile_addr : 4;              // DWORD 0
         u32 rsvd0 : 28;                          // DWORD 0
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG, *PTXULP_CLASS_REGFILE_ADDR_DEBUG;

      typedef union _TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION {
         TXULP_CLASS_REGFILE_ADDR_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION, *PTXULP_CLASS_REGFILE_ADDR_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION, sizeof (TXULP_CLASS_REGFILE_ADDR_DEBUG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Classification Regfile Data Debug Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_REGFILE_DATA_DEBUG {
         union {
            struct { 
               u32 class_regfile_addr;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG, *PTXULP_CLASS_REGFILE_DATA_DEBUG;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_DATA_DEBUG, sizeof (TXULP_CLASS_REGFILE_DATA_DEBUG) == 4);

   #else
      typedef struct _TXULP_CLASS_REGFILE_DATA_DEBUG {
         u32 class_regfile_addr;                  // DWORD 0
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG, *PTXULP_CLASS_REGFILE_DATA_DEBUG;

      typedef union _TXULP_CLASS_REGFILE_DATA_DEBUG_UNION {
         TXULP_CLASS_REGFILE_DATA_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG_UNION, *PTXULP_CLASS_REGFILE_DATA_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_DATA_DEBUG_UNION, sizeof (TXULP_CLASS_REGFILE_DATA_DEBUG_UNION) == 4);
   #endif


#else
   // Classification Regfile Data Debug Register.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CLASS_REGFILE_DATA_DEBUG {
         union {
            struct { 
               u32 class_regfile_addr;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG, *PTXULP_CLASS_REGFILE_DATA_DEBUG;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_DATA_DEBUG, sizeof (TXULP_CLASS_REGFILE_DATA_DEBUG) == 4);

   #else
      typedef struct _TXULP_CLASS_REGFILE_DATA_DEBUG {
         u32 class_regfile_addr;                  // DWORD 0
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG, *PTXULP_CLASS_REGFILE_DATA_DEBUG;

      typedef union _TXULP_CLASS_REGFILE_DATA_DEBUG_UNION {
         TXULP_CLASS_REGFILE_DATA_DEBUG bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CLASS_REGFILE_DATA_DEBUG_UNION, *PTXULP_CLASS_REGFILE_DATA_DEBUG_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CLASS_REGFILE_DATA_DEBUG_UNION, sizeof (TXULP_CLASS_REGFILE_DATA_DEBUG_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 0 Register.This register reflects the current
   // number of posted workitems in each connection selector arbiter input queueNote that
   // each queue is 4 deep and has a 3 bit number filled output.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_0 {
         union {
            struct { 
               u32 final_queue_numfilled : 2;     // DWORD 0
               u32 txulp_acg_iq_numfilled : 3;    // DWORD 0
               u32 rxulp2_iq_numfilled : 3;       // DWORD 0
               u32 rxulp1_iq_numfilled : 3;       // DWORD 0
               u32 rxulp0_iq_numfilled : 3;       // DWORD 0
               u32 txulp_ep_iq_numfilled : 3;     // DWORD 0
               u32 peer_rxulp_iq_numfilled : 3;   // DWORD 0
               u32 stor_butler_iq_numfilled : 3;  // DWORD 0
               u32 netw_butler_iq_numfilled : 3;  // DWORD 0
               u32 txulp_resched_iq_numfilled : 3; // DWORD 0
               u32 tpost_iq_numfilled : 3;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0, *PTXULP_CONSEL_ARB_DEBUG_0;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_0, sizeof (TXULP_CONSEL_ARB_DEBUG_0) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_0 {
         u32 final_queue_numfilled : 2;           // DWORD 0
         u32 txulp_acg_iq_numfilled : 3;          // DWORD 0
         u32 rxulp2_iq_numfilled : 3;             // DWORD 0
         u32 rxulp1_iq_numfilled : 3;             // DWORD 0
         u32 rxulp0_iq_numfilled : 3;             // DWORD 0
         u32 txulp_ep_iq_numfilled : 3;           // DWORD 0
         u32 peer_rxulp_iq_numfilled : 3;         // DWORD 0
         u32 stor_butler_iq_numfilled : 3;        // DWORD 0
         u32 netw_butler_iq_numfilled : 3;        // DWORD 0
         u32 txulp_resched_iq_numfilled : 3;      // DWORD 0
         u32 tpost_iq_numfilled : 3;              // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0, *PTXULP_CONSEL_ARB_DEBUG_0;

      typedef union _TXULP_CONSEL_ARB_DEBUG_0_UNION {
         TXULP_CONSEL_ARB_DEBUG_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0_UNION, *PTXULP_CONSEL_ARB_DEBUG_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_0_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_0_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 0 Register.This register reflects the current
   // number of posted workitems in each connection selector arbiter input queueNote that
   // each queue is 4 deep and has a 3 bit number filled output.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_0 {
         union {
            struct { 
               u32 tpost_iq_numfilled : 3;        // DWORD 0
               u32 txulp_resched_iq_numfilled : 3; // DWORD 0
               u32 netw_butler_iq_numfilled : 3;  // DWORD 0
               u32 stor_butler_iq_numfilled : 3;  // DWORD 0
               u32 peer_rxulp_iq_numfilled : 3;   // DWORD 0
               u32 txulp_ep_iq_numfilled : 3;     // DWORD 0
               u32 rxulp0_iq_numfilled : 3;       // DWORD 0
               u32 rxulp1_iq_numfilled : 3;       // DWORD 0
               u32 rxulp2_iq_numfilled : 3;       // DWORD 0
               u32 txulp_acg_iq_numfilled : 3;    // DWORD 0
               u32 final_queue_numfilled : 2;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0, *PTXULP_CONSEL_ARB_DEBUG_0;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_0, sizeof (TXULP_CONSEL_ARB_DEBUG_0) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_0 {
         u32 tpost_iq_numfilled : 3;              // DWORD 0
         u32 txulp_resched_iq_numfilled : 3;      // DWORD 0
         u32 netw_butler_iq_numfilled : 3;        // DWORD 0
         u32 stor_butler_iq_numfilled : 3;        // DWORD 0
         u32 peer_rxulp_iq_numfilled : 3;         // DWORD 0
         u32 txulp_ep_iq_numfilled : 3;           // DWORD 0
         u32 rxulp0_iq_numfilled : 3;             // DWORD 0
         u32 rxulp1_iq_numfilled : 3;             // DWORD 0
         u32 rxulp2_iq_numfilled : 3;             // DWORD 0
         u32 txulp_acg_iq_numfilled : 3;          // DWORD 0
         u32 final_queue_numfilled : 2;           // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0, *PTXULP_CONSEL_ARB_DEBUG_0;

      typedef union _TXULP_CONSEL_ARB_DEBUG_0_UNION {
         TXULP_CONSEL_ARB_DEBUG_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_0_UNION, *PTXULP_CONSEL_ARB_DEBUG_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_0_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 1 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_1 {
         union {
            struct { 
               u32 sched_resched_wr_cnt : 16;     // DWORD 0
               u32 tpost_post_wr_cnt : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1, *PTXULP_CONSEL_ARB_DEBUG_1;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_1, sizeof (TXULP_CONSEL_ARB_DEBUG_1) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_1 {
         u32 sched_resched_wr_cnt : 16;           // DWORD 0
         u32 tpost_post_wr_cnt : 16;              // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1, *PTXULP_CONSEL_ARB_DEBUG_1;

      typedef union _TXULP_CONSEL_ARB_DEBUG_1_UNION {
         TXULP_CONSEL_ARB_DEBUG_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1_UNION, *PTXULP_CONSEL_ARB_DEBUG_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_1_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_1_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 1 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_1 {
         union {
            struct { 
               u32 tpost_post_wr_cnt : 16;        // DWORD 0
               u32 sched_resched_wr_cnt : 16;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1, *PTXULP_CONSEL_ARB_DEBUG_1;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_1, sizeof (TXULP_CONSEL_ARB_DEBUG_1) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_1 {
         u32 tpost_post_wr_cnt : 16;              // DWORD 0
         u32 sched_resched_wr_cnt : 16;           // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1, *PTXULP_CONSEL_ARB_DEBUG_1;

      typedef union _TXULP_CONSEL_ARB_DEBUG_1_UNION {
         TXULP_CONSEL_ARB_DEBUG_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_1_UNION, *PTXULP_CONSEL_ARB_DEBUG_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_1_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 2 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_2 {
         union {
            struct { 
               u32 butler_stor_post_wr_cnt : 16;  // DWORD 0
               u32 butler_netw_post_wr_cnt : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2, *PTXULP_CONSEL_ARB_DEBUG_2;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_2, sizeof (TXULP_CONSEL_ARB_DEBUG_2) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_2 {
         u32 butler_stor_post_wr_cnt : 16;        // DWORD 0
         u32 butler_netw_post_wr_cnt : 16;        // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2, *PTXULP_CONSEL_ARB_DEBUG_2;

      typedef union _TXULP_CONSEL_ARB_DEBUG_2_UNION {
         TXULP_CONSEL_ARB_DEBUG_2 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2_UNION, *PTXULP_CONSEL_ARB_DEBUG_2_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_2_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_2_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 2 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_2 {
         union {
            struct { 
               u32 butler_netw_post_wr_cnt : 16;  // DWORD 0
               u32 butler_stor_post_wr_cnt : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2, *PTXULP_CONSEL_ARB_DEBUG_2;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_2, sizeof (TXULP_CONSEL_ARB_DEBUG_2) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_2 {
         u32 butler_netw_post_wr_cnt : 16;        // DWORD 0
         u32 butler_stor_post_wr_cnt : 16;        // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2, *PTXULP_CONSEL_ARB_DEBUG_2;

      typedef union _TXULP_CONSEL_ARB_DEBUG_2_UNION {
         TXULP_CONSEL_ARB_DEBUG_2 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_2_UNION, *PTXULP_CONSEL_ARB_DEBUG_2_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_2_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 3 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_3 {
         union {
            struct { 
               u32 txulp_proc_wr_cnt : 16;        // DWORD 0
               u32 peer_rxulp_wr_cnt : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3, *PTXULP_CONSEL_ARB_DEBUG_3;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_3, sizeof (TXULP_CONSEL_ARB_DEBUG_3) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_3 {
         u32 txulp_proc_wr_cnt : 16;              // DWORD 0
         u32 peer_rxulp_wr_cnt : 16;              // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3, *PTXULP_CONSEL_ARB_DEBUG_3;

      typedef union _TXULP_CONSEL_ARB_DEBUG_3_UNION {
         TXULP_CONSEL_ARB_DEBUG_3 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3_UNION, *PTXULP_CONSEL_ARB_DEBUG_3_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_3_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_3_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 3 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_3 {
         union {
            struct { 
               u32 peer_rxulp_wr_cnt : 16;        // DWORD 0
               u32 txulp_proc_wr_cnt : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3, *PTXULP_CONSEL_ARB_DEBUG_3;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_3, sizeof (TXULP_CONSEL_ARB_DEBUG_3) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_3 {
         u32 peer_rxulp_wr_cnt : 16;              // DWORD 0
         u32 txulp_proc_wr_cnt : 16;              // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3, *PTXULP_CONSEL_ARB_DEBUG_3;

      typedef union _TXULP_CONSEL_ARB_DEBUG_3_UNION {
         TXULP_CONSEL_ARB_DEBUG_3 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_3_UNION, *PTXULP_CONSEL_ARB_DEBUG_3_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_3_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 4 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_4 {
         union {
            struct { 
               u32 rxulp1_wr_cnt : 16;            // DWORD 0
               u32 rxulp0_wr_cnt : 16;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4, *PTXULP_CONSEL_ARB_DEBUG_4;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_4, sizeof (TXULP_CONSEL_ARB_DEBUG_4) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_4 {
         u32 rxulp1_wr_cnt : 16;                  // DWORD 0
         u32 rxulp0_wr_cnt : 16;                  // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4, *PTXULP_CONSEL_ARB_DEBUG_4;

      typedef union _TXULP_CONSEL_ARB_DEBUG_4_UNION {
         TXULP_CONSEL_ARB_DEBUG_4 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4_UNION, *PTXULP_CONSEL_ARB_DEBUG_4_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_4_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_4_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 4 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_4 {
         union {
            struct { 
               u32 rxulp0_wr_cnt : 16;            // DWORD 0
               u32 rxulp1_wr_cnt : 16;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4, *PTXULP_CONSEL_ARB_DEBUG_4;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_4, sizeof (TXULP_CONSEL_ARB_DEBUG_4) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_4 {
         u32 rxulp0_wr_cnt : 16;                  // DWORD 0
         u32 rxulp1_wr_cnt : 16;                  // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4, *PTXULP_CONSEL_ARB_DEBUG_4;

      typedef union _TXULP_CONSEL_ARB_DEBUG_4_UNION {
         TXULP_CONSEL_ARB_DEBUG_4 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_4_UNION, *PTXULP_CONSEL_ARB_DEBUG_4_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_4_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Arbiter Debug 5 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_5 {
         union {
            struct { 
               u32 sched_acg_wr_cnt : 16;         // DWORD 0
               u32 rxulp2_wr_cnt : 16;            // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5, *PTXULP_CONSEL_ARB_DEBUG_5;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_5, sizeof (TXULP_CONSEL_ARB_DEBUG_5) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_5 {
         u32 sched_acg_wr_cnt : 16;               // DWORD 0
         u32 rxulp2_wr_cnt : 16;                  // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5, *PTXULP_CONSEL_ARB_DEBUG_5;

      typedef union _TXULP_CONSEL_ARB_DEBUG_5_UNION {
         TXULP_CONSEL_ARB_DEBUG_5 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5_UNION, *PTXULP_CONSEL_ARB_DEBUG_5_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_5_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_5_UNION) == 4);
   #endif


#else
   // Connection Selector Arbiter Debug 5 Register.This register returns the accumulated
   // number of entries that have beenwritten into the various connection selector arbiter
   // input queues.Note that each accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_ARB_DEBUG_5 {
         union {
            struct { 
               u32 rxulp2_wr_cnt : 16;            // DWORD 0
               u32 sched_acg_wr_cnt : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5, *PTXULP_CONSEL_ARB_DEBUG_5;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_5, sizeof (TXULP_CONSEL_ARB_DEBUG_5) == 4);

   #else
      typedef struct _TXULP_CONSEL_ARB_DEBUG_5 {
         u32 rxulp2_wr_cnt : 16;                  // DWORD 0
         u32 sched_acg_wr_cnt : 16;               // DWORD 0
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5, *PTXULP_CONSEL_ARB_DEBUG_5;

      typedef union _TXULP_CONSEL_ARB_DEBUG_5_UNION {
         TXULP_CONSEL_ARB_DEBUG_5 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_ARB_DEBUG_5_UNION, *PTXULP_CONSEL_ARB_DEBUG_5_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_ARB_DEBUG_5_UNION, sizeof (TXULP_CONSEL_ARB_DEBUG_5_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Store Search Debug 0 Register.This register can be used to force
   // CDRG bit values for a given Connection I.D. or to readthe current state of a given
   // Connection I.D.'s CDRG values.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_0 {
         union {
            struct { 
               u32 busy : 1;                      // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 new_loc_cid : 11;              // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 new_cdrg : 4;                  // DWORD 0
               u32 post_newcdrg : 1;              // DWORD 0
               u32 override_current_cid : 1;      // DWORD 0
               u32 halt_sm : 1;                   // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0, *PTXULP_CONSEL_SS_DEBUG_0;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_0, sizeof (TXULP_CONSEL_SS_DEBUG_0) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_0 {
         u32 busy : 1;                            // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 new_loc_cid : 11;                    // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 new_cdrg : 4;                        // DWORD 0
         u32 post_newcdrg : 1;                    // DWORD 0
         u32 override_current_cid : 1;            // DWORD 0
         u32 halt_sm : 1;                         // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0, *PTXULP_CONSEL_SS_DEBUG_0;

      typedef union _TXULP_CONSEL_SS_DEBUG_0_UNION {
         TXULP_CONSEL_SS_DEBUG_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0_UNION, *PTXULP_CONSEL_SS_DEBUG_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_0_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_0_UNION) == 4);
   #endif


#else
   // Connection Selector Store Search Debug 0 Register.This register can be used to force
   // CDRG bit values for a given Connection I.D. or to readthe current state of a given
   // Connection I.D.'s CDRG values.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_0 {
         union {
            struct { 
               u32 halt_sm : 1;                   // DWORD 0
               u32 override_current_cid : 1;      // DWORD 0
               u32 post_newcdrg : 1;              // DWORD 0
               u32 new_cdrg : 4;                  // DWORD 0
               u32 rsvd0 : 9;                     // DWORD 0
               u32 new_loc_cid : 11;              // DWORD 0
               u32 rsvd1 : 4;                     // DWORD 0
               u32 busy : 1;                      // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0, *PTXULP_CONSEL_SS_DEBUG_0;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_0, sizeof (TXULP_CONSEL_SS_DEBUG_0) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_0 {
         u32 halt_sm : 1;                         // DWORD 0
         u32 override_current_cid : 1;            // DWORD 0
         u32 post_newcdrg : 1;                    // DWORD 0
         u32 new_cdrg : 4;                        // DWORD 0
         u32 rsvd0 : 9;                           // DWORD 0
         u32 new_loc_cid : 11;                    // DWORD 0
         u32 rsvd1 : 4;                           // DWORD 0
         u32 busy : 1;                            // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0, *PTXULP_CONSEL_SS_DEBUG_0;

      typedef union _TXULP_CONSEL_SS_DEBUG_0_UNION {
         TXULP_CONSEL_SS_DEBUG_0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_0_UNION, *PTXULP_CONSEL_SS_DEBUG_0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_0_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_1 {
         union {
            struct { 
               u32 ram_wr_consel_arb_cnt : 16;    // DWORD 0
               u32 consel_arb_buf_in_cnt : 16;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1, *PTXULP_CONSEL_SS_DEBUG_1;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_1, sizeof (TXULP_CONSEL_SS_DEBUG_1) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_1 {
         u32 ram_wr_consel_arb_cnt : 16;          // DWORD 0
         u32 consel_arb_buf_in_cnt : 16;          // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1, *PTXULP_CONSEL_SS_DEBUG_1;

      typedef union _TXULP_CONSEL_SS_DEBUG_1_UNION {
         TXULP_CONSEL_SS_DEBUG_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1_UNION, *PTXULP_CONSEL_SS_DEBUG_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_1_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_1_UNION) == 4);
   #endif


#else
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_1 {
         union {
            struct { 
               u32 consel_arb_buf_in_cnt : 16;    // DWORD 0
               u32 ram_wr_consel_arb_cnt : 16;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1, *PTXULP_CONSEL_SS_DEBUG_1;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_1, sizeof (TXULP_CONSEL_SS_DEBUG_1) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_1 {
         u32 consel_arb_buf_in_cnt : 16;          // DWORD 0
         u32 ram_wr_consel_arb_cnt : 16;          // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1, *PTXULP_CONSEL_SS_DEBUG_1;

      typedef union _TXULP_CONSEL_SS_DEBUG_1_UNION {
         TXULP_CONSEL_SS_DEBUG_1 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_1_UNION, *PTXULP_CONSEL_SS_DEBUG_1_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_1_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_1_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_2 {
         union {
            struct { 
               u32 ram_wr_search_cnt : 16;        // DWORD 0
               u32 ram_wr_rr_msg_cnt : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2, *PTXULP_CONSEL_SS_DEBUG_2;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_2, sizeof (TXULP_CONSEL_SS_DEBUG_2) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_2 {
         u32 ram_wr_search_cnt : 16;              // DWORD 0
         u32 ram_wr_rr_msg_cnt : 16;              // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2, *PTXULP_CONSEL_SS_DEBUG_2;

      typedef union _TXULP_CONSEL_SS_DEBUG_2_UNION {
         TXULP_CONSEL_SS_DEBUG_2 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2_UNION, *PTXULP_CONSEL_SS_DEBUG_2_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_2_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_2_UNION) == 4);
   #endif


#else
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_2 {
         union {
            struct { 
               u32 ram_wr_rr_msg_cnt : 16;        // DWORD 0
               u32 ram_wr_search_cnt : 16;        // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2, *PTXULP_CONSEL_SS_DEBUG_2;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_2, sizeof (TXULP_CONSEL_SS_DEBUG_2) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_2 {
         u32 ram_wr_rr_msg_cnt : 16;              // DWORD 0
         u32 ram_wr_search_cnt : 16;              // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2, *PTXULP_CONSEL_SS_DEBUG_2;

      typedef union _TXULP_CONSEL_SS_DEBUG_2_UNION {
         TXULP_CONSEL_SS_DEBUG_2 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_2_UNION, *PTXULP_CONSEL_SS_DEBUG_2_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_2_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_2_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_3 {
         union {
            struct { 
               u32 sched_buf_wr_rr_msg_cnt : 16;  // DWORD 0
               u32 ram_wr_debug_cnt : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3, *PTXULP_CONSEL_SS_DEBUG_3;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_3, sizeof (TXULP_CONSEL_SS_DEBUG_3) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_3 {
         u32 sched_buf_wr_rr_msg_cnt : 16;        // DWORD 0
         u32 ram_wr_debug_cnt : 16;               // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3, *PTXULP_CONSEL_SS_DEBUG_3;

      typedef union _TXULP_CONSEL_SS_DEBUG_3_UNION {
         TXULP_CONSEL_SS_DEBUG_3 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3_UNION, *PTXULP_CONSEL_SS_DEBUG_3_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_3_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_3_UNION) == 4);
   #endif


#else
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_3 {
         union {
            struct { 
               u32 ram_wr_debug_cnt : 16;         // DWORD 0
               u32 sched_buf_wr_rr_msg_cnt : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3, *PTXULP_CONSEL_SS_DEBUG_3;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_3, sizeof (TXULP_CONSEL_SS_DEBUG_3) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_3 {
         u32 ram_wr_debug_cnt : 16;               // DWORD 0
         u32 sched_buf_wr_rr_msg_cnt : 16;        // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3, *PTXULP_CONSEL_SS_DEBUG_3;

      typedef union _TXULP_CONSEL_SS_DEBUG_3_UNION {
         TXULP_CONSEL_SS_DEBUG_3 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_3_UNION, *PTXULP_CONSEL_SS_DEBUG_3_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_3_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_3_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_4 {
         union {
            struct { 
               u32 sched_buf_rd_cnt : 16;         // DWORD 0
               u32 sched_buf_wr_search_cnt : 16;  // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4, *PTXULP_CONSEL_SS_DEBUG_4;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_4, sizeof (TXULP_CONSEL_SS_DEBUG_4) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_4 {
         u32 sched_buf_rd_cnt : 16;               // DWORD 0
         u32 sched_buf_wr_search_cnt : 16;        // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4, *PTXULP_CONSEL_SS_DEBUG_4;

      typedef union _TXULP_CONSEL_SS_DEBUG_4_UNION {
         TXULP_CONSEL_SS_DEBUG_4 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4_UNION, *PTXULP_CONSEL_SS_DEBUG_4_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_4_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_4_UNION) == 4);
   #endif


#else
   // Connection Selector Storage and Search Debug 1 Register.This register returns
   // various accumulated values for internal connection selector eventsNote that each
   // accumulator is 16bits.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CONSEL_SS_DEBUG_4 {
         union {
            struct { 
               u32 sched_buf_wr_search_cnt : 16;  // DWORD 0
               u32 sched_buf_rd_cnt : 16;         // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4, *PTXULP_CONSEL_SS_DEBUG_4;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_4, sizeof (TXULP_CONSEL_SS_DEBUG_4) == 4);

   #else
      typedef struct _TXULP_CONSEL_SS_DEBUG_4 {
         u32 sched_buf_wr_search_cnt : 16;        // DWORD 0
         u32 sched_buf_rd_cnt : 16;               // DWORD 0
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4, *PTXULP_CONSEL_SS_DEBUG_4;

      typedef union _TXULP_CONSEL_SS_DEBUG_4_UNION {
         TXULP_CONSEL_SS_DEBUG_4 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_CONSEL_SS_DEBUG_4_UNION, *PTXULP_CONSEL_SS_DEBUG_4_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CONSEL_SS_DEBUG_4_UNION, sizeof (TXULP_CONSEL_SS_DEBUG_4_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TCP Scheduler Debug 0 Register. Writing to this location clears
   // tcpsch_num_zcred_posts.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TCPSCH_DEBUG0 {
         union {
            struct { 
               u32 debug1_consel;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TCPSCH_DEBUG0, *PTXULP_TCPSCH_DEBUG0;

      SG_C_ASSERT(__sizeof__TXULP_TCPSCH_DEBUG0, sizeof (TXULP_TCPSCH_DEBUG0) == 4);

   #else
      typedef struct _TXULP_TCPSCH_DEBUG0 {
         u32 debug1_consel;                       // DWORD 0
      } SG_PACK TXULP_TCPSCH_DEBUG0, *PTXULP_TCPSCH_DEBUG0;

      typedef union _TXULP_TCPSCH_DEBUG0_UNION {
         TXULP_TCPSCH_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TCPSCH_DEBUG0_UNION, *PTXULP_TCPSCH_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TCPSCH_DEBUG0_UNION, sizeof (TXULP_TCPSCH_DEBUG0_UNION) == 4);
   #endif


#else
   // TCP Scheduler Debug 0 Register. Writing to this location clears
   // tcpsch_num_zcred_posts.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TCPSCH_DEBUG0 {
         union {
            struct { 
               u32 debug1_consel;                 // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TCPSCH_DEBUG0, *PTXULP_TCPSCH_DEBUG0;

      SG_C_ASSERT(__sizeof__TXULP_TCPSCH_DEBUG0, sizeof (TXULP_TCPSCH_DEBUG0) == 4);

   #else
      typedef struct _TXULP_TCPSCH_DEBUG0 {
         u32 debug1_consel;                       // DWORD 0
      } SG_PACK TXULP_TCPSCH_DEBUG0, *PTXULP_TCPSCH_DEBUG0;

      typedef union _TXULP_TCPSCH_DEBUG0_UNION {
         TXULP_TCPSCH_DEBUG0 bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TCPSCH_DEBUG0_UNION, *PTXULP_TCPSCH_DEBUG0_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TCPSCH_DEBUG0_UNION, sizeof (TXULP_TCPSCH_DEBUG0_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TxULP EP Realtime Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 rsvd0 : 27;                    // DWORD 0
               u32 txulp_ep_sn_bus_en : 1;        // DWORD 0
               u32 txulp_ep_hw_dbg_sel : 4;       // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR, *PTXULP_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__TXULP_EP_HW_DEBUG_SELECT_CR, sizeof (TXULP_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _TXULP_EP_HW_DEBUG_SELECT_CR {
         u32 rsvd0 : 27;                          // DWORD 0
         u32 txulp_ep_sn_bus_en : 1;              // DWORD 0
         u32 txulp_ep_hw_dbg_sel : 4;             // DWORD 0
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR, *PTXULP_EP_HW_DEBUG_SELECT_CR;

      typedef union _TXULP_EP_HW_DEBUG_SELECT_CR_UNION {
         TXULP_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR_UNION, *PTXULP_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (TXULP_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#else
   // TxULP EP Realtime Hardware Debug Select Register
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_EP_HW_DEBUG_SELECT_CR {
         union {
            struct { 
               u32 txulp_ep_hw_dbg_sel : 4;       // DWORD 0
               u32 txulp_ep_sn_bus_en : 1;        // DWORD 0
               u32 rsvd0 : 27;                    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR, *PTXULP_EP_HW_DEBUG_SELECT_CR;

      SG_C_ASSERT(__sizeof__TXULP_EP_HW_DEBUG_SELECT_CR, sizeof (TXULP_EP_HW_DEBUG_SELECT_CR) == 4);

   #else
      typedef struct _TXULP_EP_HW_DEBUG_SELECT_CR {
         u32 txulp_ep_hw_dbg_sel : 4;             // DWORD 0
         u32 txulp_ep_sn_bus_en : 1;              // DWORD 0
         u32 rsvd0 : 27;                          // DWORD 0
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR, *PTXULP_EP_HW_DEBUG_SELECT_CR;

      typedef union _TXULP_EP_HW_DEBUG_SELECT_CR_UNION {
         TXULP_EP_HW_DEBUG_SELECT_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_EP_HW_DEBUG_SELECT_CR_UNION, *PTXULP_EP_HW_DEBUG_SELECT_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_EP_HW_DEBUG_SELECT_CR_UNION, sizeof (TXULP_EP_HW_DEBUG_SELECT_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TxULP Ring Manager Debug Control RegisterThis register is used to read a given ring
   // manager ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_CTRL_CR {
         union {
            struct { 
               u32 txulp_txrm_debug_load : 1;     // DWORD 0
               u32 rsvd1 : 17;                    // DWORD 0
               u32 txulp_txrm_debug_rnum : 6;     // DWORD 0
               u32 rsvd0 : 8;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR, *PTXULP_TXRM_DEBUG_CTRL_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_CTRL_CR, sizeof (TXULP_TXRM_DEBUG_CTRL_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_CTRL_CR {
         u32 txulp_txrm_debug_load : 1;           // DWORD 0
         u32 rsvd1 : 17;                          // DWORD 0
         u32 txulp_txrm_debug_rnum : 6;           // DWORD 0
         u32 rsvd0 : 8;                           // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR, *PTXULP_TXRM_DEBUG_CTRL_CR;

      typedef union _TXULP_TXRM_DEBUG_CTRL_CR_UNION {
         TXULP_TXRM_DEBUG_CTRL_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR_UNION, *PTXULP_TXRM_DEBUG_CTRL_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_CTRL_CR_UNION, sizeof (TXULP_TXRM_DEBUG_CTRL_CR_UNION) == 4);
   #endif


#else
   // TxULP Ring Manager Debug Control RegisterThis register is used to read a given ring
   // manager ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_CTRL_CR {
         union {
            struct { 
               u32 rsvd0 : 8;                     // DWORD 0
               u32 txulp_txrm_debug_rnum : 6;     // DWORD 0
               u32 rsvd1 : 17;                    // DWORD 0
               u32 txulp_txrm_debug_load : 1;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR, *PTXULP_TXRM_DEBUG_CTRL_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_CTRL_CR, sizeof (TXULP_TXRM_DEBUG_CTRL_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_CTRL_CR {
         u32 rsvd0 : 8;                           // DWORD 0
         u32 txulp_txrm_debug_rnum : 6;           // DWORD 0
         u32 rsvd1 : 17;                          // DWORD 0
         u32 txulp_txrm_debug_load : 1;           // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR, *PTXULP_TXRM_DEBUG_CTRL_CR;

      typedef union _TXULP_TXRM_DEBUG_CTRL_CR_UNION {
         TXULP_TXRM_DEBUG_CTRL_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_CTRL_CR_UNION, *PTXULP_TXRM_DEBUG_CTRL_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_CTRL_CR_UNION, sizeof (TXULP_TXRM_DEBUG_CTRL_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TxULP Ring Manager Debug Data 0 RegisterThis register is used to return some of the
   // ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_DATA0_CR {
         union {
            struct { 
               u32 rsvd3 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhwtp : 7;   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhpif : 7;   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhpir : 7;   // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srtp : 7;     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR, *PTXULP_TXRM_DEBUG_DATA0_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA0_CR, sizeof (TXULP_TXRM_DEBUG_DATA0_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_DATA0_CR {
         u32 rsvd3 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhwtp : 7;         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhpif : 7;         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhpir : 7;         // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srtp : 7;           // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR, *PTXULP_TXRM_DEBUG_DATA0_CR;

      typedef union _TXULP_TXRM_DEBUG_DATA0_CR_UNION {
         TXULP_TXRM_DEBUG_DATA0_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR_UNION, *PTXULP_TXRM_DEBUG_DATA0_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA0_CR_UNION, sizeof (TXULP_TXRM_DEBUG_DATA0_CR_UNION) == 4);
   #endif


#else
   // TxULP Ring Manager Debug Data 0 RegisterThis register is used to return some of the
   // ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_DATA0_CR {
         union {
            struct { 
               u32 txulp_txrm_debug_srtp : 7;     // DWORD 0
               u32 rsvd0 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhpir : 7;   // DWORD 0
               u32 rsvd1 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhpif : 7;   // DWORD 0
               u32 rsvd2 : 1;                     // DWORD 0
               u32 txulp_txrm_debug_srhwtp : 7;   // DWORD 0
               u32 rsvd3 : 1;                     // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR, *PTXULP_TXRM_DEBUG_DATA0_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA0_CR, sizeof (TXULP_TXRM_DEBUG_DATA0_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_DATA0_CR {
         u32 txulp_txrm_debug_srtp : 7;           // DWORD 0
         u32 rsvd0 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhpir : 7;         // DWORD 0
         u32 rsvd1 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhpif : 7;         // DWORD 0
         u32 rsvd2 : 1;                           // DWORD 0
         u32 txulp_txrm_debug_srhwtp : 7;         // DWORD 0
         u32 rsvd3 : 1;                           // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR, *PTXULP_TXRM_DEBUG_DATA0_CR;

      typedef union _TXULP_TXRM_DEBUG_DATA0_CR_UNION {
         TXULP_TXRM_DEBUG_DATA0_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_DATA0_CR_UNION, *PTXULP_TXRM_DEBUG_DATA0_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA0_CR_UNION, sizeof (TXULP_TXRM_DEBUG_DATA0_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // TxULP Ring Manager Debug Data 1 RegisterThis register is used to return some of the
   // ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_DATA1_CR {
         union {
            struct { 
               u32 txulp_txrm_debug_esnir : 1;    // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 txulp_txrm_debug_hrci : 15;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR, *PTXULP_TXRM_DEBUG_DATA1_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA1_CR, sizeof (TXULP_TXRM_DEBUG_DATA1_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_DATA1_CR {
         u32 txulp_txrm_debug_esnir : 1;          // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 txulp_txrm_debug_hrci : 15;          // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR, *PTXULP_TXRM_DEBUG_DATA1_CR;

      typedef union _TXULP_TXRM_DEBUG_DATA1_CR_UNION {
         TXULP_TXRM_DEBUG_DATA1_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR_UNION, *PTXULP_TXRM_DEBUG_DATA1_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA1_CR_UNION, sizeof (TXULP_TXRM_DEBUG_DATA1_CR_UNION) == 4);
   #endif


#else
   // TxULP Ring Manager Debug Data 1 RegisterThis register is used to return some of the
   // ring's local state varibles.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_TXRM_DEBUG_DATA1_CR {
         union {
            struct { 
               u32 txulp_txrm_debug_hrci : 15;    // DWORD 0
               u32 rsvd0 : 16;                    // DWORD 0
               u32 txulp_txrm_debug_esnir : 1;    // DWORD 0
            } SG_PACK ; // unnamed struct
            u32 dw; // dword union
         }; // unnamed union
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR, *PTXULP_TXRM_DEBUG_DATA1_CR;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA1_CR, sizeof (TXULP_TXRM_DEBUG_DATA1_CR) == 4);

   #else
      typedef struct _TXULP_TXRM_DEBUG_DATA1_CR {
         u32 txulp_txrm_debug_hrci : 15;          // DWORD 0
         u32 rsvd0 : 16;                          // DWORD 0
         u32 txulp_txrm_debug_esnir : 1;          // DWORD 0
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR, *PTXULP_TXRM_DEBUG_DATA1_CR;

      typedef union _TXULP_TXRM_DEBUG_DATA1_CR_UNION {
         TXULP_TXRM_DEBUG_DATA1_CR bits;
         u32 dw; // dword union
      } SG_PACK TXULP_TXRM_DEBUG_DATA1_CR_UNION, *PTXULP_TXRM_DEBUG_DATA1_CR_UNION;

      SG_C_ASSERT(__sizeof__TXULP_TXRM_DEBUG_DATA1_CR_UNION, sizeof (TXULP_TXRM_DEBUG_DATA1_CR_UNION) == 4);
   #endif


#endif
#if defined(SG_REVERSE_ENDIAN)
   // Transmit Upper Layer Protocol Processor Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr_netw;
               TXULP_RR_MSG_CNTRL_CSR rr_msg_cntrl;
               TXULP_CONSEL_CID_CSR consel_cid;
               TXULP_CONSEL_WEIGHT_CSR consel_weights;
               TXULP_TCP_CM_ADDR_STRD_CSR tcp_cm_addr_strd;
               TXULP_CONSEL_CTRL_CSR consel_ctrl;
               TXULP_NO_TCP_CID_CSR no_tcp_cid;
               TXULP_NO_TCP_PORT0_CSR no_tcp_port0;
               TXULP_NO_TCP_PORT1_CSR no_tcp_port1;
               TXULP_RR_MSG_DATA0_CSR rr_msg_data0;
               TXULP_RR_MSG_DATA1_CSR rr_msg_data1;
               TXULP_TPOST_INIT_CRED tpost_init_cred;
               TXULP_SCHEDULER_CNTRL tcpsch_ctrl;
               TXULP_COPROCESSOR_CR coprocessor_control;
               TXULP_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
               TXULP_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
               TXULP_CLASS_CONST_RWDATA_CSR class_const_data;
               TXULP_QOS_CBS_PBS_FLOW_NUM_CSR cbr_pbr_num;
               TXULP_QOS_CBS_CSR cbr_dat;
               TXULP_QOS_PBS_CSR pbr_dat;
               TXULP_QOS_EBP_FLOW_NUM_CSR ebp_num;
               TXULP_QOS_EBP_CSR ebp_dat;
               TXULP_QOS_TIMER_INIT_CSR qos_tim_dat;
               TXULP_QOS_WEIGHTS_CSR qos_weights;
               GLOB_QOS_CBS_PBS_FLOW_NUM_CSR glob_cbr_pbr_num;
               GLOB_QOS_CBS_CSR glob_cbr_dat;
               GLOB_QOS_PBS_CSR glob_pbr_dat;
               GLOB_QOS_EBP_FLOW_NUM_CSR glob_ebp_num;
               GLOB_QOS_EBP_CSR glob_ebp_dat;
               GLOB_QOS_TIMER_INIT_CSR glob_qos_tim_dat;
               GLOB_QOS_WEIGHTS_0_CSR glob_qos_weights_0;
               GLOB_QOS_WEIGHTS_1_CSR glob_qos_weights_1;
               TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR txrm_lst_weights_0;
               TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR txrm_lst_weights_1;
               TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR txrm_sst_weights;
               TXULP_SHAD_RING_SETUP_CSR shad_ring_setup;
               TXULP_SHAD_RING_SETUP_NUMBER_CSR shad_ring_setup_num;
               TXULP_SHAD_RING_DDR_ADDRU shad_ring_ddr_addru;
               TXULP_UC_HW_CREDIT_CSR uc_hw_credit;
               TXULP_INT_SOURCE int_source;
               TXULP_INT_MASK int_mask;
               TXULP_EP_AND_IPC_UE_SOURCE ep_and_ipc_ue_source;
               TXULP_EP_AND_IPC_UE_ENABLE ep_and_ipc_ue_enable;
               TXULP_CONSEL_ARB_UE_SOURCE consel_arb_ue_source;
               TXULP_CONSEL_ARB_UE_ENABLE consel_arb_ue_enable;
               TXULP_CONSEL_SEL_UE_SOURCE consel_sel_ue_source;
               TXULP_CONSEL_SEL_UE_ENABLE consel_sel_ue_enable;
               TXULP_SCHEDULER_UE_SOURCE_0 scheduler_ue_source0;
               TXULP_SCHEDULER_UE_ENABLE_0 scheduler_ue_enable0;
               TXULP_SCHEDULER_UE_SOURCE_1 scheduler_ue_source1;
               TXULP_SCHEDULER_UE_ENABLE_1 scheduler_ue_enable1;
               TXULP_RING_MANAGER_UE_SOURCE_0 ring_man_ue_source_0;
               TXULP_RING_MANAGER_UE_ENABLE_0 ring_man_ue_enable_0;
               TXULP_RING_MANAGER_UE_SOURCE_1 ring_man_ue_source_1;
               TXULP_RING_MANAGER_UE_ENABLE_1 ring_man_ue_enable_1;
               TXULP_UC_MERGE_UE_SOURCE uc_merge_ue_source;
               TXULP_UC_MERGE_UE_ENABLE uc_merge_ue_enable;
               GLOBAL_QOS_UE_SOURCE qos_ue_source;
               GLOBAL_QOS_UE_ENABLE qos_ue_enable;
               TXULP_ISCSI_OOO_CID rxulp0_iscsi_ooo_cid;
               TXULP_ISCSI_OOO_CID rxulp1_iscsi_ooo_cid;
               TXULP_ISCSI_OOO_CID rxulp2_iscsi_ooo_cid;
               TXULP_CONSEL_ARB_DEBUG_0 consel_arb_debug_0;
               TXULP_CONSEL_ARB_DEBUG_1 consel_arb_debug_1;
               TXULP_CONSEL_ARB_DEBUG_2 consel_arb_debug_2;
               TXULP_CONSEL_ARB_DEBUG_3 consel_arb_debug_3;
               TXULP_CONSEL_ARB_DEBUG_4 consel_arb_debug_4;
               TXULP_CONSEL_ARB_DEBUG_5 consel_arb_debug_5;
               TXULP_CONSEL_SS_DEBUG_0 consel_ss_debug_0;
               TXULP_CONSEL_SS_DEBUG_1 consel_ss_debug_1;
               TXULP_CONSEL_SS_DEBUG_2 consel_ss_debug_2;
               TXULP_CONSEL_SS_DEBUG_3 consel_ss_debug_3;
               TXULP_CONSEL_SS_DEBUG_4 consel_ss_debug_4;
               TXULP_TCPSCH_DEBUG0 tcpsch_debug0;
               TXULP_CLASS_REGFILE_ADDR_DEBUG class_regfile_addr_debug;
               TXULP_CLASS_REGFILE_DATA_DEBUG class_regfile_data_debug;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG txpbif_debug;
               HWDBG_CSRMAP hwdbg;
               TXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               GEN_IPC_DEBUG ipc_debug;
               TXULP_TXRM_DEBUG_CTRL_CR txrm_debug_ctrl;
               TXULP_TXRM_DEBUG_DATA0_CR txrm_debug_data_0;
               TXULP_TXRM_DEBUG_DATA1_CR txrm_debug_data_1;
               u32 rsvd0[96];                     // DWORDS 160 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CSRMAP, *PTXULP_CSRMAP;

      SG_C_ASSERT(__sizeof__TXULP_CSRMAP, sizeof (TXULP_CSRMAP) == 1024);

   #else
      typedef struct _TXULP_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr_netw;
         TXULP_RR_MSG_CNTRL_CSR rr_msg_cntrl;
         TXULP_CONSEL_CID_CSR consel_cid;
         TXULP_CONSEL_WEIGHT_CSR consel_weights;
         TXULP_TCP_CM_ADDR_STRD_CSR tcp_cm_addr_strd;
         TXULP_CONSEL_CTRL_CSR consel_ctrl;
         TXULP_NO_TCP_CID_CSR no_tcp_cid;
         TXULP_NO_TCP_PORT0_CSR no_tcp_port0;
         TXULP_NO_TCP_PORT1_CSR no_tcp_port1;
         TXULP_RR_MSG_DATA0_CSR rr_msg_data0;
         TXULP_RR_MSG_DATA1_CSR rr_msg_data1;
         TXULP_TPOST_INIT_CRED tpost_init_cred;
         TXULP_SCHEDULER_CNTRL tcpsch_ctrl;
         TXULP_COPROCESSOR_CR coprocessor_control;
         TXULP_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
         TXULP_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
         TXULP_CLASS_CONST_RWDATA_CSR class_const_data;
         TXULP_QOS_CBS_PBS_FLOW_NUM_CSR cbr_pbr_num;
         TXULP_QOS_CBS_CSR cbr_dat;
         TXULP_QOS_PBS_CSR pbr_dat;
         TXULP_QOS_EBP_FLOW_NUM_CSR ebp_num;
         TXULP_QOS_EBP_CSR ebp_dat;
         TXULP_QOS_TIMER_INIT_CSR qos_tim_dat;
         TXULP_QOS_WEIGHTS_CSR qos_weights;
         GLOB_QOS_CBS_PBS_FLOW_NUM_CSR glob_cbr_pbr_num;
         GLOB_QOS_CBS_CSR glob_cbr_dat;
         GLOB_QOS_PBS_CSR glob_pbr_dat;
         GLOB_QOS_EBP_FLOW_NUM_CSR glob_ebp_num;
         GLOB_QOS_EBP_CSR glob_ebp_dat;
         GLOB_QOS_TIMER_INIT_CSR glob_qos_tim_dat;
         GLOB_QOS_WEIGHTS_0_CSR glob_qos_weights_0;
         GLOB_QOS_WEIGHTS_1_CSR glob_qos_weights_1;
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR txrm_lst_weights_0;
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR txrm_lst_weights_1;
         TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR txrm_sst_weights;
         TXULP_SHAD_RING_SETUP_CSR shad_ring_setup;
         TXULP_SHAD_RING_SETUP_NUMBER_CSR shad_ring_setup_num;
         TXULP_SHAD_RING_DDR_ADDRU shad_ring_ddr_addru;
         TXULP_UC_HW_CREDIT_CSR uc_hw_credit;
         TXULP_INT_SOURCE int_source;
         TXULP_INT_MASK int_mask;
         TXULP_EP_AND_IPC_UE_SOURCE ep_and_ipc_ue_source;
         TXULP_EP_AND_IPC_UE_ENABLE ep_and_ipc_ue_enable;
         TXULP_CONSEL_ARB_UE_SOURCE consel_arb_ue_source;
         TXULP_CONSEL_ARB_UE_ENABLE consel_arb_ue_enable;
         TXULP_CONSEL_SEL_UE_SOURCE consel_sel_ue_source;
         TXULP_CONSEL_SEL_UE_ENABLE consel_sel_ue_enable;
         TXULP_SCHEDULER_UE_SOURCE_0 scheduler_ue_source0;
         TXULP_SCHEDULER_UE_ENABLE_0 scheduler_ue_enable0;
         TXULP_SCHEDULER_UE_SOURCE_1 scheduler_ue_source1;
         TXULP_SCHEDULER_UE_ENABLE_1 scheduler_ue_enable1;
         TXULP_RING_MANAGER_UE_SOURCE_0 ring_man_ue_source_0;
         TXULP_RING_MANAGER_UE_ENABLE_0 ring_man_ue_enable_0;
         TXULP_RING_MANAGER_UE_SOURCE_1 ring_man_ue_source_1;
         TXULP_RING_MANAGER_UE_ENABLE_1 ring_man_ue_enable_1;
         TXULP_UC_MERGE_UE_SOURCE uc_merge_ue_source;
         TXULP_UC_MERGE_UE_ENABLE uc_merge_ue_enable;
         GLOBAL_QOS_UE_SOURCE qos_ue_source;
         GLOBAL_QOS_UE_ENABLE qos_ue_enable;
         TXULP_ISCSI_OOO_CID rxulp0_iscsi_ooo_cid;
         TXULP_ISCSI_OOO_CID rxulp1_iscsi_ooo_cid;
         TXULP_ISCSI_OOO_CID rxulp2_iscsi_ooo_cid;
         TXULP_CONSEL_ARB_DEBUG_0 consel_arb_debug_0;
         TXULP_CONSEL_ARB_DEBUG_1 consel_arb_debug_1;
         TXULP_CONSEL_ARB_DEBUG_2 consel_arb_debug_2;
         TXULP_CONSEL_ARB_DEBUG_3 consel_arb_debug_3;
         TXULP_CONSEL_ARB_DEBUG_4 consel_arb_debug_4;
         TXULP_CONSEL_ARB_DEBUG_5 consel_arb_debug_5;
         TXULP_CONSEL_SS_DEBUG_0 consel_ss_debug_0;
         TXULP_CONSEL_SS_DEBUG_1 consel_ss_debug_1;
         TXULP_CONSEL_SS_DEBUG_2 consel_ss_debug_2;
         TXULP_CONSEL_SS_DEBUG_3 consel_ss_debug_3;
         TXULP_CONSEL_SS_DEBUG_4 consel_ss_debug_4;
         TXULP_TCPSCH_DEBUG0 tcpsch_debug0;
         TXULP_CLASS_REGFILE_ADDR_DEBUG class_regfile_addr_debug;
         TXULP_CLASS_REGFILE_DATA_DEBUG class_regfile_data_debug;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG txpbif_debug;
         HWDBG_CSRMAP hwdbg;
         TXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         GEN_IPC_DEBUG ipc_debug;
         TXULP_TXRM_DEBUG_CTRL_CR txrm_debug_ctrl;
         TXULP_TXRM_DEBUG_DATA0_CR txrm_debug_data_0;
         TXULP_TXRM_DEBUG_DATA1_CR txrm_debug_data_1;
         u32 rsvd0[96];                           // DWORDS 160 to 255
      } SG_PACK TXULP_CSRMAP, *PTXULP_CSRMAP;

      typedef union _TXULP_CSRMAP_UNION {
         TXULP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXULP_CSRMAP_UNION, *PTXULP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CSRMAP_UNION, sizeof (TXULP_CSRMAP_UNION) == 1024);
   #endif


#else
   // Transmit Upper Layer Protocol Processor Registers.
   #if defined(SG_BMAP_UNION)
      typedef struct _TXULP_CSRMAP {
         union {
            struct { 
               EP_CSRMAP ep;
               EP_MINIROM_CSRMAP ep_minirom;
               REV_ID rev_id;
               struct {
                  BTLR_CTRL0 btlr_ctrl0;
                  BTLR_CTRL1 btlr_ctrl1;
                  BTLR_CTRL2 btlr_ctrl2;
                  BTLR_VIOLATION0 btlr_violation0;
                  BTLR_VIOLATION1 btlr_violation1;
                  BTLR_DEBUG btlr_debug;
               } btlr_netw;
               TXULP_RR_MSG_CNTRL_CSR rr_msg_cntrl;
               TXULP_CONSEL_CID_CSR consel_cid;
               TXULP_CONSEL_WEIGHT_CSR consel_weights;
               TXULP_TCP_CM_ADDR_STRD_CSR tcp_cm_addr_strd;
               TXULP_CONSEL_CTRL_CSR consel_ctrl;
               TXULP_NO_TCP_CID_CSR no_tcp_cid;
               TXULP_NO_TCP_PORT0_CSR no_tcp_port0;
               TXULP_NO_TCP_PORT1_CSR no_tcp_port1;
               TXULP_RR_MSG_DATA0_CSR rr_msg_data0;
               TXULP_RR_MSG_DATA1_CSR rr_msg_data1;
               TXULP_TPOST_INIT_CRED tpost_init_cred;
               TXULP_SCHEDULER_CNTRL tcpsch_ctrl;
               TXULP_COPROCESSOR_CR coprocessor_control;
               TXULP_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
               TXULP_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
               TXULP_CLASS_CONST_RWDATA_CSR class_const_data;
               TXULP_QOS_CBS_PBS_FLOW_NUM_CSR cbr_pbr_num;
               TXULP_QOS_CBS_CSR cbr_dat;
               TXULP_QOS_PBS_CSR pbr_dat;
               TXULP_QOS_EBP_FLOW_NUM_CSR ebp_num;
               TXULP_QOS_EBP_CSR ebp_dat;
               TXULP_QOS_TIMER_INIT_CSR qos_tim_dat;
               TXULP_QOS_WEIGHTS_CSR qos_weights;
               GLOB_QOS_CBS_PBS_FLOW_NUM_CSR glob_cbr_pbr_num;
               GLOB_QOS_CBS_CSR glob_cbr_dat;
               GLOB_QOS_PBS_CSR glob_pbr_dat;
               GLOB_QOS_EBP_FLOW_NUM_CSR glob_ebp_num;
               GLOB_QOS_EBP_CSR glob_ebp_dat;
               GLOB_QOS_TIMER_INIT_CSR glob_qos_tim_dat;
               GLOB_QOS_WEIGHTS_0_CSR glob_qos_weights_0;
               GLOB_QOS_WEIGHTS_1_CSR glob_qos_weights_1;
               TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR txrm_lst_weights_0;
               TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR txrm_lst_weights_1;
               TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR txrm_sst_weights;
               TXULP_SHAD_RING_SETUP_CSR shad_ring_setup;
               TXULP_SHAD_RING_SETUP_NUMBER_CSR shad_ring_setup_num;
               TXULP_SHAD_RING_DDR_ADDRU shad_ring_ddr_addru;
               TXULP_UC_HW_CREDIT_CSR uc_hw_credit;
               TXULP_INT_SOURCE int_source;
               TXULP_INT_MASK int_mask;
               TXULP_EP_AND_IPC_UE_SOURCE ep_and_ipc_ue_source;
               TXULP_EP_AND_IPC_UE_ENABLE ep_and_ipc_ue_enable;
               TXULP_CONSEL_ARB_UE_SOURCE consel_arb_ue_source;
               TXULP_CONSEL_ARB_UE_ENABLE consel_arb_ue_enable;
               TXULP_CONSEL_SEL_UE_SOURCE consel_sel_ue_source;
               TXULP_CONSEL_SEL_UE_ENABLE consel_sel_ue_enable;
               TXULP_SCHEDULER_UE_SOURCE_0 scheduler_ue_source0;
               TXULP_SCHEDULER_UE_ENABLE_0 scheduler_ue_enable0;
               TXULP_SCHEDULER_UE_SOURCE_1 scheduler_ue_source1;
               TXULP_SCHEDULER_UE_ENABLE_1 scheduler_ue_enable1;
               TXULP_RING_MANAGER_UE_SOURCE_0 ring_man_ue_source_0;
               TXULP_RING_MANAGER_UE_ENABLE_0 ring_man_ue_enable_0;
               TXULP_RING_MANAGER_UE_SOURCE_1 ring_man_ue_source_1;
               TXULP_RING_MANAGER_UE_ENABLE_1 ring_man_ue_enable_1;
               TXULP_UC_MERGE_UE_SOURCE uc_merge_ue_source;
               TXULP_UC_MERGE_UE_ENABLE uc_merge_ue_enable;
               GLOBAL_QOS_UE_SOURCE qos_ue_source;
               GLOBAL_QOS_UE_ENABLE qos_ue_enable;
               TXULP_ISCSI_OOO_CID rxulp0_iscsi_ooo_cid;
               TXULP_ISCSI_OOO_CID rxulp1_iscsi_ooo_cid;
               TXULP_ISCSI_OOO_CID rxulp2_iscsi_ooo_cid;
               TXULP_CONSEL_ARB_DEBUG_0 consel_arb_debug_0;
               TXULP_CONSEL_ARB_DEBUG_1 consel_arb_debug_1;
               TXULP_CONSEL_ARB_DEBUG_2 consel_arb_debug_2;
               TXULP_CONSEL_ARB_DEBUG_3 consel_arb_debug_3;
               TXULP_CONSEL_ARB_DEBUG_4 consel_arb_debug_4;
               TXULP_CONSEL_ARB_DEBUG_5 consel_arb_debug_5;
               TXULP_CONSEL_SS_DEBUG_0 consel_ss_debug_0;
               TXULP_CONSEL_SS_DEBUG_1 consel_ss_debug_1;
               TXULP_CONSEL_SS_DEBUG_2 consel_ss_debug_2;
               TXULP_CONSEL_SS_DEBUG_3 consel_ss_debug_3;
               TXULP_CONSEL_SS_DEBUG_4 consel_ss_debug_4;
               TXULP_TCPSCH_DEBUG0 tcpsch_debug0;
               TXULP_CLASS_REGFILE_ADDR_DEBUG class_regfile_addr_debug;
               TXULP_CLASS_REGFILE_DATA_DEBUG class_regfile_data_debug;
               GEN_CTXIF_DEBUG ctxif_debug;
               GEN_CTXIF_DEBUG txpbif_debug;
               HWDBG_CSRMAP hwdbg;
               TXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
               GEN_IPC_DEBUG ipc_debug;
               TXULP_TXRM_DEBUG_CTRL_CR txrm_debug_ctrl;
               TXULP_TXRM_DEBUG_DATA0_CR txrm_debug_data_0;
               TXULP_TXRM_DEBUG_DATA1_CR txrm_debug_data_1;
               u32 rsvd0[96];                     // DWORDS 160 to 255
            } SG_PACK ; // unnamed struct
            u32 dw[256]; // dword union
         }; // unnamed union
      } SG_PACK TXULP_CSRMAP, *PTXULP_CSRMAP;

      SG_C_ASSERT(__sizeof__TXULP_CSRMAP, sizeof (TXULP_CSRMAP) == 1024);

   #else
      typedef struct _TXULP_CSRMAP {
         EP_CSRMAP ep;
         EP_MINIROM_CSRMAP ep_minirom;
         REV_ID rev_id;
         struct {
            BTLR_CTRL0 btlr_ctrl0;
            BTLR_CTRL1 btlr_ctrl1;
            BTLR_CTRL2 btlr_ctrl2;
            BTLR_VIOLATION0 btlr_violation0;
            BTLR_VIOLATION1 btlr_violation1;
            BTLR_DEBUG btlr_debug;
         } btlr_netw;
         TXULP_RR_MSG_CNTRL_CSR rr_msg_cntrl;
         TXULP_CONSEL_CID_CSR consel_cid;
         TXULP_CONSEL_WEIGHT_CSR consel_weights;
         TXULP_TCP_CM_ADDR_STRD_CSR tcp_cm_addr_strd;
         TXULP_CONSEL_CTRL_CSR consel_ctrl;
         TXULP_NO_TCP_CID_CSR no_tcp_cid;
         TXULP_NO_TCP_PORT0_CSR no_tcp_port0;
         TXULP_NO_TCP_PORT1_CSR no_tcp_port1;
         TXULP_RR_MSG_DATA0_CSR rr_msg_data0;
         TXULP_RR_MSG_DATA1_CSR rr_msg_data1;
         TXULP_TPOST_INIT_CRED tpost_init_cred;
         TXULP_SCHEDULER_CNTRL tcpsch_ctrl;
         TXULP_COPROCESSOR_CR coprocessor_control;
         TXULP_CLASS_IRAM_RWDATAL_CSR class_iram_datal;
         TXULP_CLASS_IRAM_RWDATAU_CSR class_iram_datau;
         TXULP_CLASS_CONST_RWDATA_CSR class_const_data;
         TXULP_QOS_CBS_PBS_FLOW_NUM_CSR cbr_pbr_num;
         TXULP_QOS_CBS_CSR cbr_dat;
         TXULP_QOS_PBS_CSR pbr_dat;
         TXULP_QOS_EBP_FLOW_NUM_CSR ebp_num;
         TXULP_QOS_EBP_CSR ebp_dat;
         TXULP_QOS_TIMER_INIT_CSR qos_tim_dat;
         TXULP_QOS_WEIGHTS_CSR qos_weights;
         GLOB_QOS_CBS_PBS_FLOW_NUM_CSR glob_cbr_pbr_num;
         GLOB_QOS_CBS_CSR glob_cbr_dat;
         GLOB_QOS_PBS_CSR glob_pbr_dat;
         GLOB_QOS_EBP_FLOW_NUM_CSR glob_ebp_num;
         GLOB_QOS_EBP_CSR glob_ebp_dat;
         GLOB_QOS_TIMER_INIT_CSR glob_qos_tim_dat;
         GLOB_QOS_WEIGHTS_0_CSR glob_qos_weights_0;
         GLOB_QOS_WEIGHTS_1_CSR glob_qos_weights_1;
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_0_CSR txrm_lst_weights_0;
         TXULP_SHAD_RING_LOC_STATE_WEIGHT_1_CSR txrm_lst_weights_1;
         TXULP_SHAD_RING_STAT_STATE_WEIGHT_CSR txrm_sst_weights;
         TXULP_SHAD_RING_SETUP_CSR shad_ring_setup;
         TXULP_SHAD_RING_SETUP_NUMBER_CSR shad_ring_setup_num;
         TXULP_SHAD_RING_DDR_ADDRU shad_ring_ddr_addru;
         TXULP_UC_HW_CREDIT_CSR uc_hw_credit;
         TXULP_INT_SOURCE int_source;
         TXULP_INT_MASK int_mask;
         TXULP_EP_AND_IPC_UE_SOURCE ep_and_ipc_ue_source;
         TXULP_EP_AND_IPC_UE_ENABLE ep_and_ipc_ue_enable;
         TXULP_CONSEL_ARB_UE_SOURCE consel_arb_ue_source;
         TXULP_CONSEL_ARB_UE_ENABLE consel_arb_ue_enable;
         TXULP_CONSEL_SEL_UE_SOURCE consel_sel_ue_source;
         TXULP_CONSEL_SEL_UE_ENABLE consel_sel_ue_enable;
         TXULP_SCHEDULER_UE_SOURCE_0 scheduler_ue_source0;
         TXULP_SCHEDULER_UE_ENABLE_0 scheduler_ue_enable0;
         TXULP_SCHEDULER_UE_SOURCE_1 scheduler_ue_source1;
         TXULP_SCHEDULER_UE_ENABLE_1 scheduler_ue_enable1;
         TXULP_RING_MANAGER_UE_SOURCE_0 ring_man_ue_source_0;
         TXULP_RING_MANAGER_UE_ENABLE_0 ring_man_ue_enable_0;
         TXULP_RING_MANAGER_UE_SOURCE_1 ring_man_ue_source_1;
         TXULP_RING_MANAGER_UE_ENABLE_1 ring_man_ue_enable_1;
         TXULP_UC_MERGE_UE_SOURCE uc_merge_ue_source;
         TXULP_UC_MERGE_UE_ENABLE uc_merge_ue_enable;
         GLOBAL_QOS_UE_SOURCE qos_ue_source;
         GLOBAL_QOS_UE_ENABLE qos_ue_enable;
         TXULP_ISCSI_OOO_CID rxulp0_iscsi_ooo_cid;
         TXULP_ISCSI_OOO_CID rxulp1_iscsi_ooo_cid;
         TXULP_ISCSI_OOO_CID rxulp2_iscsi_ooo_cid;
         TXULP_CONSEL_ARB_DEBUG_0 consel_arb_debug_0;
         TXULP_CONSEL_ARB_DEBUG_1 consel_arb_debug_1;
         TXULP_CONSEL_ARB_DEBUG_2 consel_arb_debug_2;
         TXULP_CONSEL_ARB_DEBUG_3 consel_arb_debug_3;
         TXULP_CONSEL_ARB_DEBUG_4 consel_arb_debug_4;
         TXULP_CONSEL_ARB_DEBUG_5 consel_arb_debug_5;
         TXULP_CONSEL_SS_DEBUG_0 consel_ss_debug_0;
         TXULP_CONSEL_SS_DEBUG_1 consel_ss_debug_1;
         TXULP_CONSEL_SS_DEBUG_2 consel_ss_debug_2;
         TXULP_CONSEL_SS_DEBUG_3 consel_ss_debug_3;
         TXULP_CONSEL_SS_DEBUG_4 consel_ss_debug_4;
         TXULP_TCPSCH_DEBUG0 tcpsch_debug0;
         TXULP_CLASS_REGFILE_ADDR_DEBUG class_regfile_addr_debug;
         TXULP_CLASS_REGFILE_DATA_DEBUG class_regfile_data_debug;
         GEN_CTXIF_DEBUG ctxif_debug;
         GEN_CTXIF_DEBUG txpbif_debug;
         HWDBG_CSRMAP hwdbg;
         TXULP_EP_HW_DEBUG_SELECT_CR ep_hw_debug_sel;
         GEN_IPC_DEBUG ipc_debug;
         TXULP_TXRM_DEBUG_CTRL_CR txrm_debug_ctrl;
         TXULP_TXRM_DEBUG_DATA0_CR txrm_debug_data_0;
         TXULP_TXRM_DEBUG_DATA1_CR txrm_debug_data_1;
         u32 rsvd0[96];                           // DWORDS 160 to 255
      } SG_PACK TXULP_CSRMAP, *PTXULP_CSRMAP;

      typedef union _TXULP_CSRMAP_UNION {
         TXULP_CSRMAP bits;
         u32 dw[256]; // dword union
      } SG_PACK TXULP_CSRMAP_UNION, *PTXULP_CSRMAP_UNION;

      SG_C_ASSERT(__sizeof__TXULP_CSRMAP_UNION, sizeof (TXULP_CSRMAP_UNION) == 1024);
   #endif


#endif

#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __txulp_bmap_h__

