/*
 * This file is part of the Emulex Linux Device Driver for iSCSI Host Bus
 * Adapters.
 * Copyright (C) 2003 Adaptec, Inc.
 * Copyright (C) 2005-2011 Emulex.
 * All rights reserved.
 * EMULEX and SLI are trademarks of Emulex.
 * www.emulex.com
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as published
 * by the Free Software Foundation. This program is distributed in the hope that
 * it will be useful. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE DISCLAIMED, EXCEPT TO THE EXTENT
 * THAT SUCH DISCLAIMERS ARE HELD TO BE LEGALLY INVALID. See the GNU General
 * Public License for more details, a copy of which can be found in the file
 * COPYING included with this package.
 */
// Autogenerated file. Do not edit!
// srcgen version: 0146
#ifndef __ioctl_common_amap_h__
#define __ioctl_common_amap_h__
#include "setypes.h"
#include "ioctl_types.h"
#include "ioctl_hdr.h"
#include "ioctl_defs.h"
#include "host_struct.h"
#include "fw_exp.h"
#include "erx.h"
#include "ioctl_mcc.h"

#undef SG_PACK
#if defined(SG_PRAGMA_PACK)
   #pragma pack(push, 1)
   #define SG_PACK
#elif defined(SG_ATTRIBUTE_PACK)
   #define SG_PACK __attribute__ ((packed))
#else
   #define SG_PACK
#endif

#ifndef SG_STATIC_INLINE
   #define SG_STATIC_INLINE static inline
#endif
// --- IOCTL_SIZE_ENUMS ---
#define IOCTL_EMBEDDED_PARAMS_BYTES     (220)     
#define IOCTL_EMBEDDED_PAYLOAD_BYTES    (236)     

typedef enum {
   ENUM_IOCTL_EMBEDDED_PARAMS_BYTES = 0xdcUL,
   ENUM_IOCTL_EMBEDDED_PAYLOAD_BYTES = 0xecUL
} IOCTL_SIZE_ENUMS;

// --- PHY_LINK_DUPLEX_ENUM ---
#define PHY_LINK_DUPLEX_NONE            (0)       
#define PHY_LINK_DUPLEX_HALF            (1)       
#define PHY_LINK_DUPLEX_FULL            (2)       

typedef enum {
   ENUM_PHY_LINK_DUPLEX_NONE = 0x0UL,
   ENUM_PHY_LINK_DUPLEX_HALF = 0x1UL,
   ENUM_PHY_LINK_DUPLEX_FULL = 0x2UL
} PHY_LINK_DUPLEX_ENUM;

// --- PHY_LINK_SPEED_ENUM ---
#define PHY_LINK_SPEED_ZERO             (0)       // No link.
#define PHY_LINK_SPEED_10MBPS           (1)       // 10 Mbps
#define PHY_LINK_SPEED_100MBPS          (2)       // 100 Mbps
#define PHY_LINK_SPEED_1GBPS            (3)       // 1 Gbps
#define PHY_LINK_SPEED_10GBPS           (4)       // 10 Gbps

typedef enum {
   ENUM_PHY_LINK_SPEED_ZERO = 0x0UL,
   ENUM_PHY_LINK_SPEED_10MBPS = 0x1UL,
   ENUM_PHY_LINK_SPEED_100MBPS = 0x2UL,
   ENUM_PHY_LINK_SPEED_1GBPS = 0x3UL,
   ENUM_PHY_LINK_SPEED_10GBPS = 0x4UL
} PHY_LINK_SPEED_ENUM;

// --- PHY_LINK_FAULT_ENUM ---
#define PHY_LINK_FAULT_NONE             (0)       // No fault status available or detected
#define PHY_LINK_FAULT_LOCAL            (1)       // Local fault detected
#define PHY_LINK_FAULT_REMOTE           (2)       // Remote fault detected

typedef enum {
   ENUM_PHY_LINK_FAULT_NONE = 0x0UL,
   ENUM_PHY_LINK_FAULT_LOCAL = 0x1UL,
   ENUM_PHY_LINK_FAULT_REMOTE = 0x2UL
} PHY_LINK_FAULT_ENUM;

// --- BE_OPERATION ---
#define BE_OPERATION_QUERY              (0)       
#define BE_OPERATION_CREATE             (1)       
#define BE_OPERATION_DELETE             (2)       
#define BE_OPERATION_REPLACE            (4)       

typedef enum {
   ENUM_BE_OPERATION_QUERY = 0x0UL,
   ENUM_BE_OPERATION_CREATE = 0x1UL,
   ENUM_BE_OPERATION_DELETE = 0x2UL,
   ENUM_BE_OPERATION_REPLACE = 0x4UL
} BE_OPERATION;

// --- NTWK_PHYS_PORT ---
#define NTWK_PORT_A                     (0)       // Port A
#define NTWK_PORT_B                     (1)       // Port B
#define NTWK_PORT_C                     (2)       // Port C
#define NTWK_PORT_D                     (3)       // Port D

typedef enum {
   ENUM_NTWK_PORT_A = 0x0UL,
   ENUM_NTWK_PORT_B = 0x1UL,
   ENUM_NTWK_PORT_C = 0x2UL,
   ENUM_NTWK_PORT_D = 0x3UL
} NTWK_PHYS_PORT;

// --- NTWK_LINK_TYPE ---
#define NTWK_LINK_TYPE_PHYSICAL         (0)       // The associated link up/down event
                                                  // applies to the BladeEngine's Physical
                                                  // Ports
#define NTWK_LINK_TYPE_LOGICAL          (1)       // The associated link up/down event
                                                  // applies to the BladeEngine's Logical
                                                  // Links

typedef enum {
   ENUM_NTWK_LINK_TYPE_PHYSICAL = 0x0UL,
   ENUM_NTWK_LINK_TYPE_LOGICAL = 0x1UL
} NTWK_LINK_TYPE;

// --- NTWK_LOGICAL_LINK ---
#define NTWK_LOGICAL_LINK_DOWN          (0)       // Logical link is down for the
                                                  // associated function
#define NTWK_LOGICAL_LINK_UP            (1)       // Logical link is up for the associated
                                                  // function

typedef enum {
   ENUM_NTWK_LOGICAL_LINK_DOWN = 0x0UL,
   ENUM_NTWK_LOGICAL_LINK_UP = 0x1UL
} NTWK_LOGICAL_LINK;


typedef struct {
   BE_UEXACT8_AMAP physical_port;
   BE_UEXACT8_AMAP mac_duplex;
   BE_UEXACT8_AMAP mac_speed;
   BE_UEXACT8_AMAP mac_fault;
   BE_UEXACT8_AMAP mgmt_mac_duplex;
   BE_UEXACT8_AMAP mgmt_mac_speed;
   BE_UEXACT16_AMAP qos_link_speed;
   BE_UEXACT32_AMAP logical_link_status;
} SG_PACK BE_BE_LINK_STATUS_AMAP;
typedef struct { u32 dw[3]; } BE_LINK_STATUS_AMAP, *PBE_LINK_STATUS_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_LINK_STATUS_QUERY_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } LINK_STATUS_QUERY_PARAMS_IN_AMAP, *PLINK_STATUS_QUERY_PARAMS_IN_AMAP;



typedef union {
   BE_BE_LINK_STATUS_AMAP response;
   BE_LINK_STATUS_QUERY_PARAMS_IN_AMAP request;
} SG_PACK BE_LINK_STATUS_QUERY_PARAMS_AMAP;
typedef struct { u32 dw[3]; } LINK_STATUS_QUERY_PARAMS_AMAP, *PLINK_STATUS_QUERY_PARAMS_AMAP;


//               Queries the link status for the client's port.              <p>          
//   Note: valid values below DO NOT indicate a particular duplex or speed is supported by
//              BladeEngine.  The enumerations simply list all possible duplexes and
// speeds for a given port/MAC.             Consult BladeEngine product documentation for
// the supported duplex and speed.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_LINK_STATUS_QUERY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_LINK_STATUS_QUERY_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_NTWK_LINK_STATUS_QUERY_AMAP, *PIOCTL_COMMON_NTWK_LINK_STATUS_QUERY_AMAP;



typedef struct {
   BE_UEXACT8_AMAP physical_port;
   BE_UEXACT8_AMAP virtual_port;
   BE_UEXACT8_AMAP mac_speed;
   BE_BIT rsvd0[8];                               // DWORD 0
} SG_PACK BE_LINK_SPEED_SET_AMAP;
typedef struct { u32 dw[1]; } LINK_SPEED_SET_AMAP, *PLINK_SPEED_SET_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_LINK_SPEED_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_LINK_SPEED_PARAMS_OUT_AMAP, *PSET_LINK_SPEED_PARAMS_OUT_AMAP;



typedef union {
   BE_LINK_SPEED_SET_AMAP request;
   BE_SET_LINK_SPEED_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_LINK_SPEED_PARAMS_AMAP;
typedef struct { u32 dw[1]; } SET_LINK_SPEED_PARAMS_AMAP, *PSET_LINK_SPEED_PARAMS_AMAP;


//               Sets the link status for the client's port.              <p>            
// Note: Some implementations using the BE2, require a manual speed setting            
// due to limitations in the PHY . The Aeluris             PHY supports auto detection and
// setting for 10G and 1G. PHY type is used to let              ARM f/w know that it needs
// to apply QoS settings to limit throughput             on the virtual ports to 1G.      
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_LINK_SPEED_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_SET_LINK_SPEED_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_NTWK_SET_LINK_SPEED_AMAP, *PIOCTL_COMMON_NTWK_SET_LINK_SPEED_AMAP;


// --- IOCTL_MAC_TYPE_ENUM ---
// This enum defines the types of MAC addresses in the RXF MAC Address Table. 
#define MAC_ADDRESS_TYPE_STORAGE        (0)       // Storage MAC Address 
#define MAC_ADDRESS_TYPE_NETWORK        (1)       // Network MAC Address 
#define MAC_ADDRESS_TYPE_PD             (2)       // Protection Domain MAC Address 
#define MAC_ADDRESS_TYPE_MANAGEMENT     (3)       // Managment MAC Address 
#define MAC_ADDRESS_TYPE_FCOE           (4)       // FCoE MAC Address 
#define MAC_ADDRESS_TYPE_STARTING_MAC   (8)       // Starting MAC address for the HBA.
                                                  // This address is stored on SEEPROM.
                                                  // All PCI functions derive their MAC
                                                  // addresses from this starting value by
                                                  // adding the per-function MAC index
                                                  // (also stored on SEEPROM). While all
                                                  // boards/LOMs can be queried for the
                                                  // starting MAC address, the factory-set
                                                  // value stored on SEEPROM can be
                                                  // overwritten only on a limited set of
                                                  // IPLs. 
#define MAC_ADDRESS_TYPE_SEEPROM_DEFAULT (9)      // The board default MAC address which
                                                  // is stored on SEEPROM. The enum can
                                                  // ONLY be used to query the MAC
                                                  // addresses for all the supported PCI
                                                  // functions. 

typedef enum {
   ENUM_MAC_ADDRESS_TYPE_STORAGE = 0x0UL,
   ENUM_MAC_ADDRESS_TYPE_NETWORK = 0x1UL,
   ENUM_MAC_ADDRESS_TYPE_PD = 0x2UL,
   ENUM_MAC_ADDRESS_TYPE_MANAGEMENT = 0x3UL,
   ENUM_MAC_ADDRESS_TYPE_FCOE = 0x4UL,
   ENUM_MAC_ADDRESS_TYPE_STARTING_MAC = 0x8UL,
   ENUM_MAC_ADDRESS_TYPE_SEEPROM_DEFAULT = 0x9UL
} IOCTL_MAC_TYPE_ENUM;

#ifndef SG_OMIT_NAME_QUERY_FUNCTIONS
   SG_STATIC_INLINE const char* ioctl_mac_type_enum_get_name (u32 enum_value) {
      switch (enum_value) {
         case MAC_ADDRESS_TYPE_STORAGE:
            return "MAC_ADDRESS_TYPE_STORAGE";
         case MAC_ADDRESS_TYPE_NETWORK:
            return "MAC_ADDRESS_TYPE_NETWORK";
         case MAC_ADDRESS_TYPE_PD:
            return "MAC_ADDRESS_TYPE_PD";
         case MAC_ADDRESS_TYPE_MANAGEMENT:
            return "MAC_ADDRESS_TYPE_MANAGEMENT";
         case MAC_ADDRESS_TYPE_FCOE:
            return "MAC_ADDRESS_TYPE_FCOE";
         case MAC_ADDRESS_TYPE_STARTING_MAC:
            return "MAC_ADDRESS_TYPE_STARTING_MAC";
         case MAC_ADDRESS_TYPE_SEEPROM_DEFAULT:
            return "MAC_ADDRESS_TYPE_SEEPROM_DEFAULT";
         default: break;
      }
      return ""; // undefined enum value
   };
#endif


typedef struct {
   BE_UEXACT8_AMAP type;
   BE_UEXACT8_AMAP permanent;
   BE_UEXACT16_AMAP if_id;
   BE_UEXACT32_AMAP pmac_id;
} SG_PACK BE_NTWK_MAC_QUERY_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } NTWK_MAC_QUERY_PARAMS_IN_AMAP, *PNTWK_MAC_QUERY_PARAMS_IN_AMAP;



typedef struct {
   BE_MAC_ADDRESS_FORMAT_AMAP mac;
   BE_MAC_ADDRESS_FORMAT_AMAP seeprom_mac[8];
} SG_PACK BE_NTWK_MAC_QUERY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[18]; } NTWK_MAC_QUERY_PARAMS_OUT_AMAP, *PNTWK_MAC_QUERY_PARAMS_OUT_AMAP;



typedef union {
   BE_NTWK_MAC_QUERY_PARAMS_IN_AMAP request;
   BE_NTWK_MAC_QUERY_PARAMS_OUT_AMAP response;
} SG_PACK BE_NTWK_MAC_QUERY_PARAMS_AMAP;
typedef struct { u32 dw[18]; } NTWK_MAC_QUERY_PARAMS_AMAP, *PNTWK_MAC_QUERY_PARAMS_AMAP;


//  Queries a MAC address. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_NTWK_MAC_QUERY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_MAC_QUERY_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_NTWK_MAC_QUERY_AMAP, *PIOCTL_COMMON_NTWK_MAC_QUERY_AMAP;



typedef struct {
   BE_UEXACT8_AMAP type;
   BE_UEXACT8_AMAP invalidate;
   BE_UEXACT16_AMAP if_id;
   BE_MAC_ADDRESS_FORMAT_AMAP mac;
} SG_PACK BE_NTWK_MAC_SET_PARAMS_IN_AMAP;
typedef struct { u32 dw[3]; } NTWK_MAC_SET_PARAMS_IN_AMAP, *PNTWK_MAC_SET_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_NTWK_MAC_SET_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } NTWK_MAC_SET_PARAMS_OUT_AMAP, *PNTWK_MAC_SET_PARAMS_OUT_AMAP;



typedef union {
   BE_NTWK_MAC_SET_PARAMS_IN_AMAP request;
   BE_NTWK_MAC_SET_PARAMS_OUT_AMAP response;
} SG_PACK BE_NTWK_MAC_SET_PARAMS_AMAP;
typedef struct { u32 dw[3]; } NTWK_MAC_SET_PARAMS_AMAP, *PNTWK_MAC_SET_PARAMS_AMAP;


//  Replaces the MAC address for the associated function. The IOCTL will fail if there is
// a MAC collision - i.e.                 if there exists a function with the requested
// MAC address.
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_NTWK_MAC_SET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_MAC_SET_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_NTWK_MAC_SET_AMAP, *PIOCTL_COMMON_NTWK_MAC_SET_AMAP;



typedef struct {
   BE_UEXACT32_AMAP if_id;
   BE_UEXACT8_AMAP mac_address[6];
   BE_BIT rsvd0[2][8];                            // DWORD 2
} SG_PACK BE_NTWK_PMAC_ADD_REQUEST_AMAP;
typedef struct { u32 dw[3]; } NTWK_PMAC_ADD_REQUEST_AMAP, *PNTWK_PMAC_ADD_REQUEST_AMAP;



typedef struct {
   BE_UEXACT32_AMAP pmac_id;
} SG_PACK BE_NTWK_PMAC_ADD_RESPONSE_AMAP;
typedef struct { u32 dw[1]; } NTWK_PMAC_ADD_RESPONSE_AMAP, *PNTWK_PMAC_ADD_RESPONSE_AMAP;


//  Adds a perfect MAC addresses for an interface ID previously          created with
// [link]IOCTL_COMMON_NTWK_INTERFACE_CREATE[/link].                  <P>The IOCTL may fail
// with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- there are no free
// perfect MAC address slots available to satisfy the request.         </LI>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]              -- the caller is not
// authorized to issue this IOCTL.         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_NTWK_PMAC_ADD_REQUEST_AMAP request;
      BE_NTWK_PMAC_ADD_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_NTWK_PMAC_ADD_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_NTWK_PMAC_ADD_AMAP, *PIOCTL_COMMON_NTWK_PMAC_ADD_AMAP;



typedef struct {
   BE_UEXACT32_AMAP if_id;
   BE_UEXACT32_AMAP pmac_id;
} SG_PACK BE_NTWK_PMAC_DEL_REQUEST_AMAP;
typedef struct { u32 dw[2]; } NTWK_PMAC_DEL_REQUEST_AMAP, *PNTWK_PMAC_DEL_REQUEST_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_NTWK_PMAC_DEL_RESPONSE_AMAP;
typedef struct { u32 dw[1]; } NTWK_PMAC_DEL_RESPONSE_AMAP, *PNTWK_PMAC_DEL_RESPONSE_AMAP;



typedef union {
   BE_NTWK_PMAC_DEL_REQUEST_AMAP request;
   BE_NTWK_PMAC_DEL_RESPONSE_AMAP response;
} SG_PACK BE_NTWK_PMAC_DEL_AMAP;
typedef struct { u32 dw[2]; } NTWK_PMAC_DEL_AMAP, *PNTWK_PMAC_DEL_AMAP;


//  Deletes a perfect MAC addresses from an interface ID previously          created with
// [link]IOCTL_COMMON_NTWK_INTERFACE_CREATE[/link].                  <P>The IOCTL may fail
// with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]              -- the caller is not
// authorized to issue this IOCTL.         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_NTWK_PMAC_DEL_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_PMAC_DEL_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_NTWK_PMAC_DEL_AMAP, *PIOCTL_COMMON_NTWK_PMAC_DEL_AMAP;


// MAC address list.
typedef struct {
   BE_UEXACT8_AMAP byte[6];
} SG_PACK BE_NTWK_MULTICAST_MAC_LIST_AMAP;
typedef struct { u32 dw[2]; } NTWK_MULTICAST_MAC_LIST_AMAP, *PNTWK_MULTICAST_MAC_LIST_AMAP;



typedef struct {
   BE_UEXACT16_AMAP num_mac;
   BE_UEXACT8_AMAP promiscuous;
   BE_UEXACT8_AMAP interface_id;
   BE_NTWK_MULTICAST_MAC_LIST_AMAP mac[32];
} SG_PACK BE_IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_AMAP;
typedef struct { u32 dw[49]; } IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_AMAP, *PIOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_NTWK_MULTICAST_SET_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } NTWK_MULTICAST_SET_PARAMS_OUT_AMAP, *PNTWK_MULTICAST_SET_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_NTWK_MULTICAST_SET_REQUEST_PAYLOAD_AMAP request;
   BE_NTWK_MULTICAST_SET_PARAMS_OUT_AMAP response;
} SG_PACK BE_NTWK_MULTICAST_SET_PARAMS_AMAP;
typedef struct { u32 dw[49]; } NTWK_MULTICAST_SET_PARAMS_AMAP, *PNTWK_MULTICAST_SET_PARAMS_AMAP;


//           Enables or disables reception of multicast packets matching the MAC address
// list for a          particular receive interface.          The multicast address
// matching is based on a hash of the MAC address (ie. it is imperfect).         Posting
// this IOCTL will overwrite any previous multicast hash settings for the interface.      
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_NTWK_MULTICAST_SET_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_MULTICAST_SET_AMAP;
typedef struct { u32 dw[53]; } IOCTL_COMMON_NTWK_MULTICAST_SET_AMAP, *PIOCTL_COMMON_NTWK_MULTICAST_SET_AMAP;


// --- QNQ_INNER_TAG ---
// In the QnQ mode, it is possible for the interface to request ONE tag instead of a
// tag-pair. 
#define QNQ_INNER_INVALID               (65534)   
#define QNQ_OUTER_INVALID               (65535)   

typedef enum {
   ENUM_QNQ_INNER_INVALID = 0xfffeUL,
   ENUM_QNQ_OUTER_INVALID = 0xffffUL
} QNQ_INNER_TAG;


typedef struct {
   BE_UEXACT16_AMAP id;
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_LIST_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_NTWK_VLAN_LIST_AMAP, *PIOCTL_COMMON_NTWK_VLAN_LIST_AMAP;



typedef struct {
   BE_UEXACT16_AMAP id_o;
   BE_UEXACT16_AMAP id_i;
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_AMAP, *PIOCTL_COMMON_NTWK_VLAN_LIST_QINQ_AMAP;



typedef union {
   BE_IOCTL_COMMON_NTWK_VLAN_LIST_AMAP normal_vlan[64];
   BE_IOCTL_COMMON_NTWK_VLAN_LIST_QINQ_AMAP qinq_vlan[32];
} SG_PACK BE_NTWK_VLAN_TAGS_AMAP;
typedef struct { u32 dw[32]; } NTWK_VLAN_TAGS_AMAP, *PNTWK_VLAN_TAGS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP interface_id;
   BE_UEXACT8_AMAP promiscuous;
   BE_UEXACT8_AMAP untagged;
   BE_UEXACT8_AMAP num_vlan;
   BE_NTWK_VLAN_TAGS_AMAP tags;
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_AMAP, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_AMAP, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PAYLOAD_AMAP request;
   BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_AMAP, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_AMAP;


//           This IOCTL is used to add or remove VLAN identifiers associated with a       
//   network interface. The adapters VLAN mode configuration setting affects         the
// expected usage of this IOCTL. In normal VLAN mode, the firmware expects         single
// VLAN tag identifiers. In QinQ VLAN (non Flex10) mode, the firmware expects         VLAN
// tag identifier pairs (outer and inner). For this reason, the tags field         of this
// IOCTL is a union of either normal_vlan or qinq_vlan.                  <P>The IOCTL may
// fail with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- there are not
// enough free VLAN ID entries to satisfy the request.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]          
//    -- the requested VLAN ID parameters conflict with existing VLAN configuration.      
//   </LI>         <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]              -- the caller is not
// authorized to issue this IOCTL.         </LI>         </UL>                  
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_REQUEST_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_VLAN_CONFIG_AMAP;
typedef struct { u32 dw[37]; } IOCTL_COMMON_NTWK_VLAN_CONFIG_AMAP, *PIOCTL_COMMON_NTWK_VLAN_CONFIG_AMAP;


// --- BE2_RXF_IF_FLAGS_ENUM ---
#define BE2_RXF_IF_FLAGS_RSS            (4)       // Set to enable RSS capability. Only 2
                                                  // interfaces per adapter are capable of
                                                  // RSS. Clear to disable RSS capability.
#define BE2_RXF_IF_FLAGS_PROMISCUOUS    (8)       // Set to enable promiscuous reception
                                                  // of all packets. Valid option only if
                                                  // RSS capability is enabled as well.
                                                  // Clear to apply normal filtering rules
                                                  // to all packets. 
#define BE2_RXF_IF_FLAGS_BROADCAST      (16)      // Set to enable reception of broadcast
                                                  // and unfiltered multicast packets.
                                                  // Clear to disable reception of
                                                  // broadcast and unfiltered multicast
                                                  // packets. 
#define BE2_RXF_IF_FLAGS_UNTAGGED       (32)      // Set to enable reception of untagged
                                                  // packets. Clear to disable reception
                                                  // of untagged packets. 
#define BE2_RXF_IF_FLAGS_ULP            (64)      // Interface is for a particular ULP.
                                                  // Currently undefined. 
#define BE2_RXF_IF_FLAGS_VLAN_PROMISCUOUS (128)   // Set to enable VLAN promiscuous mode.
                                                  // Clear to disable VLAN promiscuous
                                                  // mode. 
#define BE2_RXF_IF_FLAGS_VLAN           (256)     // Set to use a VLAN identifier tag.
                                                  // Clear to not use a VLAN identifier
                                                  // tag. 
#define BE2_RXF_IF_FLAGS_MCAST_PROMISCUOUS (512)  // Set to request multicast promiscuous
                                                  // mode. Clear to disable multicast
                                                  // promiscuous mode. 
#define BE2_RXF_IF_FLAGS_PASS_L2_ERRORS (1024)    // Set to request reception of packets
                                                  // which fail L2 checks (ie. ethernet
                                                  // length, CRC32, etc.). Clear to
                                                  // disable reception of packets which
                                                  // fail L2 checks. 
#define BE2_RXF_IF_FLAGS_PASS_L3L4_ERRORS (2048)  // Set to request reception of packets
                                                  // which fail L3/L4 checks (ie. header
                                                  // lengths, checksum, etc.). Clear to
                                                  // disable reception of packets which
                                                  // fail L3/L4 checks. 

typedef enum {
   ENUM_BE2_RXF_IF_FLAGS_RSS = 0x4UL,
   ENUM_BE2_RXF_IF_FLAGS_PROMISCUOUS = 0x8UL,
   ENUM_BE2_RXF_IF_FLAGS_BROADCAST = 0x10UL,
   ENUM_BE2_RXF_IF_FLAGS_UNTAGGED = 0x20UL,
   ENUM_BE2_RXF_IF_FLAGS_ULP = 0x40UL,
   ENUM_BE2_RXF_IF_FLAGS_VLAN_PROMISCUOUS = 0x80UL,
   ENUM_BE2_RXF_IF_FLAGS_VLAN = 0x100UL,
   ENUM_BE2_RXF_IF_FLAGS_MCAST_PROMISCUOUS = 0x200UL,
   ENUM_BE2_RXF_IF_FLAGS_PASS_L2_ERRORS = 0x400UL,
   ENUM_BE2_RXF_IF_FLAGS_PASS_L3L4_ERRORS = 0x800UL,
} BE2_RXF_IF_FLAGS_ENUM;


typedef struct {
   BE_UEXACT16_AMAP outer;
   BE_UEXACT16_AMAP inner;
} SG_PACK BE_VLAN_TAG_QINQ_AMAP;
typedef struct { u32 dw[1]; } VLAN_TAG_QINQ_AMAP, *PVLAN_TAG_QINQ_AMAP;



typedef struct {
   BE_UEXACT16_AMAP tag;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_VLAN_TAG_NORMAL_AMAP;
typedef struct { u32 dw[1]; } VLAN_TAG_NORMAL_AMAP, *PVLAN_TAG_NORMAL_AMAP;



typedef union {
   BE_VLAN_TAG_QINQ_AMAP qinq;
   BE_VLAN_TAG_NORMAL_AMAP normal;
} SG_PACK BE_NTWK_INTERFACE_VLAN_TAG_AMAP;
typedef struct { u32 dw[1]; } NTWK_INTERFACE_VLAN_TAG_AMAP, *PNTWK_INTERFACE_VLAN_TAG_AMAP;



typedef struct {
   BE_UEXACT32_AMAP version;
   BE_UEXACT32_AMAP capability_flags;
   BE_UEXACT32_AMAP enable_flags;
   BE_UEXACT8_AMAP mac_address[6];
   BE_BIT rsvd0[8];                               // DWORD 4
   BE_UEXACT8_AMAP pmac_invalid;
   BE_NTWK_INTERFACE_VLAN_TAG_AMAP vlan_tag;
} SG_PACK BE_BE2_RXF_IF_CREATE_PARAMS_AMAP;
typedef struct { u32 dw[6]; } BE2_RXF_IF_CREATE_PARAMS_AMAP, *PBE2_RXF_IF_CREATE_PARAMS_AMAP;



typedef struct {
   BE_BE2_RXF_IF_CREATE_PARAMS_AMAP rxf_if_create_params;
} SG_PACK BE_IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_AMAP, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_id;
   BE_UEXACT32_AMAP pmac_id;
} SG_PACK BE_IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_AMAP, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_AMAP;



typedef union {
   BE_IOCTL_COMMON_NTWK_INTERFACE_CREATE_REQUEST_PAYLOAD_AMAP request;
   BE_IOCTL_COMMON_NTWK_INTERFACE_CREATE_RESPONSE_PAYLOAD_AMAP response;
} SG_PACK BE_INTERFACE_CREATE_PARAMS_AMAP;
typedef struct { u32 dw[6]; } INTERFACE_CREATE_PARAMS_AMAP, *PINTERFACE_CREATE_PARAMS_AMAP;


//           Used to create a network interface provided filtering constraints.        
// All filtering requests are based on the interface id returned in          the response
// payload upon success.                  <P>The IOCTL may fail with the following
// status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- there are not
// enough resources to satisfy the request.         </LI>        
// <LI>[link]MGMT_STATUS_FAILED[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]          
//    -- the requested parameters conflict with network configuration.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]              -- the caller is not
// authorized to issue this IOCTL.         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_INTERFACE_CREATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_NTWK_INTERFACE_CREATE_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_NTWK_INTERFACE_CREATE_AMAP, *PIOCTL_COMMON_NTWK_INTERFACE_CREATE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP interface_id;
} SG_PACK BE_IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_AMAP, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_AMAP;


//               Used to destroy a network interface previously created with             
// [link]IOCTL_COMMON_NTWK_INTERFACE_CREATE[/link].             <P>The IOCTL may fail with
// the following status/additional_status codes:             <UL>            
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                -- the request parameter at
// the byte offset specified in the additional status response is invalid.            
// </LI>             <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]               -- the caller is not
// authorized to issue this IOCTL.             </LI>             </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_IOCTL_COMMON_NTWK_INTERFACE_DESTROY_REQUEST_PAYLOAD_AMAP request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_NTWK_INTERFACE_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_NTWK_INTERFACE_DESTROY_AMAP, *PIOCTL_COMMON_NTWK_INTERFACE_DESTROY_AMAP;


// --- TEMPLATE_HEADER_TYPE_ENUM ---
#define TEMPLATE_HEADER_TYPE_ISCSI      (1)       
#define TEMPLATE_HEADER_TYPE_TOE        (2)       
#define TEMPLATE_HEADER_TYPE_RDMA       (3)       

typedef enum {
   ENUM_TEMPLATE_HEADER_TYPE_ISCSI = 0x1UL,
   ENUM_TEMPLATE_HEADER_TYPE_TOE = 0x2UL,
   ENUM_TEMPLATE_HEADER_TYPE_RDMA = 0x3UL
} TEMPLATE_HEADER_TYPE_ENUM;


typedef struct {
   BE_UEXACT32_AMAP num_used;
   BE_UEXACT32_AMAP base_cid;
} SG_PACK BE_IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_AMAP, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_AMAP;


//               Posts template headers buffers.  These should be posted            
// before any connections are offloaded.  Each buffer holds 32 template             
// headers at 128 bytes each.              <p>             This may be issued multiple
// times to post the template header             buffers in smaller pieces.  This allows
// the driver to delay             allocating template header buffers until the
// connections are             actually used.                          <p>            
// Only protection domain 0 may post template header buffers.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_UEXACT16_AMAP type;
         BE_PHYS_ADDR_AMAP scratch_pa;
         BE_VIRT_ADDR_AMAP sratch_va;
         BE_VIRT_ADDR_AMAP pages_va;
         BE_PHYS_ADDR_AMAP pages[16];
      } request;
      BE_IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_AMAP;
typedef struct { u32 dw[43]; } IOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_AMAP, *PIOCTL_COMMON_ADD_TEMPLATE_HEADER_BUFFERS_AMAP;


//               Frees all template header buffers for the given type. Only protection    
//          domain 0 may issue this request. The IOCTL may fail if any rings which        
//      use these template headers are still in use.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP type;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_UEXACT32_AMAP num_removed;
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_AMAP, *PIOCTL_COMMON_REMOVE_TEMPLATE_HEADER_BUFFERS_AMAP;


//               Posts page tables for the UT.  This command may be issued multiple times
// to             add page tables to the chip.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num;
         BE_UEXACT8_AMAP shared;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_VIRT_ADDR_AMAP va;
         BE_PHYS_ADDR_AMAP page_tables[26];
      } request;
      struct {
         BE_UEXACT16_AMAP num_added;
         BE_UEXACT16_AMAP num_total;
         BE_UEXACT16_AMAP num_free;
         BE_BIT rsvd0[16];                        // DWORD 5
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_ADD_PAGE_TABLES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_ADD_PAGE_TABLES_AMAP, *PIOCTL_COMMON_ADD_PAGE_TABLES_AMAP;


//               Removes free page tables from the chip.  Only page tables that are unused
// may be             removed.  Page tables may not be removed in the same order as they
// are posted.              This ioctl returns a list of physical addresses for the page
// tables that were             removed.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_UEXACT16_AMAP actual_num;
         BE_UEXACT16_AMAP total_num;
         BE_PHYS_ADDR_AMAP page_tables[27];
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_REMOVE_PAGE_TABLES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_REMOVE_PAGE_TABLES_AMAP, *PIOCTL_COMMON_REMOVE_PAGE_TABLES_AMAP;


// --- IOCTL_RING_TYPE_ENUM ---
#define IOCTL_RING_TYPE_ETH_RX          (1)       // Ring created with
                                                  // IOCTL_ETH_RX_CREATE.
#define IOCTL_RING_TYPE_ETH_TX          (2)       // Ring created with
                                                  // IOCTL_ETH_TX_CREATE.
#define IOCTL_RING_TYPE_ISCSI_WRBQ      (3)       // Ring created with
                                                  // IOCTL_COMMON_ISCSI_WRBQ_CREATE.
#define IOCTL_RING_TYPE_ISCSI_DEFQ      (4)       // Ring created with
                                                  // IOCTL_COMMON_ISCSI_DEFQ_CREATE.
#define IOCTL_RING_TYPE_TOE_WRBQ        (5)       // Ring created with
                                                  // IOCTL_TOE_WRBQ_CREATE.
#define IOCTL_RING_TYPE_TOE_DEFQ        (6)       // Ring created with
                                                  // IOCTL_TOE_DEFQ_CREATE.
#define IOCTL_RING_TYPE_TOE_RQ          (7)       // Ring created with
                                                  // IOCTL_TOE_RQ_CREATE.
#define IOCTL_RING_TYPE_MCC             (8)       // Ring created with
                                                  // IOCTL_COMMON_MCC_CREATE.
#define IOCTL_RING_TYPE_CQ              (9)       // Ring created with
                                                  // IOCTL_COMMON_CQ_CREATE.
#define IOCTL_RING_TYPE_EQ              (10)      // Ring created with
                                                  // IOCTL_COMMON_EQ_CREATE.
#define IOCTL_RING_TYPE_QP              (11)      // Ring created with
                                                  // IOCTL_RDMA_QP_CREATE.
#define IOCTL_RING_TYPE_FCOE_WRBQ       (12)      // Ring created with
                                                  // IOCTL_FCOE_WRBQ_CREATE.
#define IOCTL_RING_TYPE_LRO             (13)      // Ring created with
                                                  // IOCTL_LRO_RING_CREATE.
#define IOCTL_RING_TYPE_FCOE_DEFQ       (14)      // Ring created with
                                                  // IOCTL_COMMON_FCOE_DEFQ_CREATE.
#define IOCTL_RING_TYPE_DAL             (15)      // Pseudo-ring for DAL BID allocation
#define IOCTL_RING_TYPE_DAL_TX          (16)      // Ring created with
                                                  // IOCTL_DAL_QP_MODIFY_RTS.
#define IOCTL_RING_TYPE_DAL_RX          (17)      // Ring created with
                                                  // IOCTL_DAL_QP_MODIFY_RTR.

typedef enum {
   ENUM_IOCTL_RING_TYPE_ETH_RX = 0x1UL,
   ENUM_IOCTL_RING_TYPE_ETH_TX = 0x2UL,
   ENUM_IOCTL_RING_TYPE_ISCSI_WRBQ = 0x3UL,
   ENUM_IOCTL_RING_TYPE_ISCSI_DEFQ = 0x4UL,
   ENUM_IOCTL_RING_TYPE_TOE_WRBQ = 0x5UL,
   ENUM_IOCTL_RING_TYPE_TOE_DEFQ = 0x6UL,
   ENUM_IOCTL_RING_TYPE_TOE_RQ = 0x7UL,
   ENUM_IOCTL_RING_TYPE_MCC = 0x8UL,
   ENUM_IOCTL_RING_TYPE_CQ = 0x9UL,
   ENUM_IOCTL_RING_TYPE_EQ = 0xaUL,
   ENUM_IOCTL_RING_TYPE_QP = 0xbUL,
   ENUM_IOCTL_RING_TYPE_FCOE_WRBQ = 0xcUL,
   ENUM_IOCTL_RING_TYPE_LRO = 0xdUL,
   ENUM_IOCTL_RING_TYPE_FCOE_DEFQ = 0xeUL,
   ENUM_IOCTL_RING_TYPE_DAL = 0xfUL,
   ENUM_IOCTL_RING_TYPE_DAL_TX = 0x10UL,
   ENUM_IOCTL_RING_TYPE_DAL_RX = 0x11UL
} IOCTL_RING_TYPE_ENUM;

//               IOCTL for creating a completion queue.                          <P>A
// Completion Queue must span at least 1 page and at most 4 pages. Each completion        
//      queue entry is 16 bytes regardless of CQ entry format. Thus the ring must be at   
//           least 256 entries deep (corresponding to 1 page) and can be at most 1024
// entries              deep (corresponding to 4 pages). The number of pages posted must
// contain the CQ ring              size as encoded in the context.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_CQ_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[4];
      } request;
      struct {
         BE_UEXACT16_AMAP cq_id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_CQ_CREATE_AMAP;
typedef struct { u32 dw[17]; } IOCTL_COMMON_CQ_CREATE_AMAP, *PIOCTL_COMMON_CQ_CREATE_AMAP;


//               IOCTL for destroying an MCC ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_MCC_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_MCC_DESTROY_AMAP, *PIOCTL_COMMON_MCC_DESTROY_AMAP;


//               IOCTL for destroying a CQ ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_CQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_CQ_DESTROY_AMAP, *PIOCTL_COMMON_CQ_DESTROY_AMAP;


//               IOCTL for destroying a EQ ring.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_EQ_DESTROY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_EQ_DESTROY_AMAP, *PIOCTL_COMMON_EQ_DESTROY_AMAP;


//               IOCTL for creating a event queue.             <P>An Event Queue must span
// at least 1 page and at most 8 pages.              The number of pages posted must
// contain the EQ ring. The ring is              defined by the size of the EQ entries
// (encoded in the context) and              the number of EQ entries (also encoded in the
// context).                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_EQ_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP eq_id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_EQ_CREATE_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_EQ_CREATE_AMAP, *PIOCTL_COMMON_EQ_CREATE_AMAP;


//              IOCTL for creating the MCC ring.                           <P>An MCC ring
// must be at least 16 entries deep (corresponding to 1 page) and              at most 128
// entries deep (corresponding to 8 pages).          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_MCC_RING_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_MCC_CREATE_AMAP;
typedef struct { u32 dw[25]; } IOCTL_COMMON_MCC_CREATE_AMAP, *PIOCTL_COMMON_MCC_CREATE_AMAP;


//              IOCTL for creating the MCC ring.                           <P>An MCC ring
// must be at least 16 entries deep (corresponding to 1 page) and              at most 128
// entries deep (corresponding to 8 pages).              Use the new field
// 'async_event_bitmap' to subscribe to events. e.g For a driver to              subscribe
// to EventCodes: Link State (1), FCF State (2) and Group5 (5),             the
// async_event_bitmap should be 0000 0026h (bits 1,2 and 5 set).         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP num_pages;
         BE_BIT rsvd0[16];                        // DWORD 4
         BE_UEXACT32_AMAP async_event_bitmap[1];
         BE_MCC_RING_CONTEXT_AMAP context;
         BE_PHYS_ADDR_AMAP pages[8];
      } request;
      struct {
         BE_UEXACT16_AMAP id;
         BE_BIT rsvd0[16];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_MCC_CREATE_EXT_AMAP;
typedef struct { u32 dw[26]; } IOCTL_COMMON_MCC_CREATE_EXT_AMAP, *PIOCTL_COMMON_MCC_CREATE_EXT_AMAP;


//              Posts a physical address pointing to a single byte of zero data that may  
//           be DMA'd.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_PHYS_ADDR_AMAP page;
         BE_UEXACT32_AMAP remove;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_POST_ZERO_BUFFER_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_POST_ZERO_BUFFER_AMAP, *PIOCTL_COMMON_POST_ZERO_BUFFER_AMAP;


//              Configures the JELL -- the journal entry linked list required for any     
//        TCP offload.  This may also free a previously configured JELL.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT8_AMAP free_jell;
         BE_UEXACT8_AMAP ddr;
         BE_UEXACT8_AMAP done;
         BE_BIT rsvd0[8];                         // DWORD 4
         BE_UEXACT16_AMAP page_offset;
         BE_UEXACT16_AMAP num_pages;
         BE_PHYS_ADDR_AMAP pages[26];
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_JELL_CONFIG_AMAP;
typedef struct { u32 dw[58]; } IOCTL_COMMON_JELL_CONFIG_AMAP, *PIOCTL_COMMON_JELL_CONFIG_AMAP;



typedef struct {
   BE_UEXACT32_AMAP qos_params_rsvd;
} SG_PACK BE_GET_QOS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_QOS_IN_AMAP, *PGET_QOS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP max_bits_per_second_NIC;
   BE_UEXACT32_AMAP max_packets_per_second_NIC;
   BE_UEXACT32_AMAP max_ios_per_second_iSCSI;
   BE_UEXACT32_AMAP max_bytes_per_second_iSCSI;
   BE_UEXACT32_AMAP qos_params_oem[4];
} SG_PACK BE_GET_QOS_OUT_AMAP;
typedef struct { u32 dw[8]; } GET_QOS_OUT_AMAP, *PGET_QOS_OUT_AMAP;



typedef union {
   BE_GET_QOS_IN_AMAP request;
   BE_GET_QOS_OUT_AMAP response;
} SG_PACK BE_GET_QOS_PARAMS_AMAP;
typedef struct { u32 dw[8]; } GET_QOS_PARAMS_AMAP, *PGET_QOS_PARAMS_AMAP;


//           Retrieve transmit QoS settings.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_QOS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_QOS_AMAP;
typedef struct { u32 dw[12]; } IOCTL_COMMON_GET_QOS_AMAP, *PIOCTL_COMMON_GET_QOS_AMAP;


// --- IOCTL_COMMON_QOS_TYPE_ENUM ---
#define QOS_BITS_NIC                    (1)       // The max_bits_per_second_NIC field is
                                                  // valid. 
#define QOS_PKTS_NIC                    (2)       // The max_packets_per_second_NIC field
                                                  // is valid. 
#define QOS_IOPS_ISCSI                  (4)       // The max_ios_per_second_iSCSI field is
                                                  // valid. 
#define QOS_VLAN_TAG                    (8)       // The domain_VLAN_tag field is valid. 
#define QOS_FABRIC_ID                   (16)      // The fabric_domain_ID field is valid. 
#define QOS_OEM_PARAMS                  (32)      // The qos_params_oem field is valid. 
#define QOS_TPUT_ISCSI                  (64)      // The max_bytes_per_second_iSCSI field
                                                  // is valid. 

typedef enum {
   ENUM_QOS_BITS_NIC = 0x1UL,
   ENUM_QOS_PKTS_NIC = 0x2UL,
   ENUM_QOS_IOPS_ISCSI = 0x4UL,
   ENUM_QOS_VLAN_TAG = 0x8UL,
   ENUM_QOS_FABRIC_ID = 0x10UL,
   ENUM_QOS_OEM_PARAMS = 0x20UL,
   ENUM_QOS_TPUT_ISCSI = 0x40UL
} IOCTL_COMMON_QOS_TYPE_ENUM;


typedef struct {
   BE_UEXACT32_AMAP valid_flags;
   BE_UEXACT32_AMAP max_bits_per_second_NIC;
   BE_UEXACT32_AMAP max_packets_per_second_NIC;
   BE_UEXACT32_AMAP max_ios_per_second_iSCSI;
   BE_UEXACT32_AMAP max_bytes_per_second_iSCSI;
   BE_UEXACT32_AMAP qos_params_oem[4];
} SG_PACK BE_SET_QOS_IN_AMAP;
typedef struct { u32 dw[9]; } SET_QOS_IN_AMAP, *PSET_QOS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP qos_params_rsvd;
} SG_PACK BE_SET_QOS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_QOS_OUT_AMAP, *PSET_QOS_OUT_AMAP;



typedef union {
   BE_SET_QOS_IN_AMAP request;
   BE_SET_QOS_OUT_AMAP response;
} SG_PACK BE_SET_QOS_PARAMS_AMAP;
typedef struct { u32 dw[9]; } SET_QOS_PARAMS_AMAP, *PSET_QOS_PARAMS_AMAP;


//           IOCTL to set the transmit QoS settings for a given domain.         <P>The
// IOCTL may fail with the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_FAILED[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_RESOURCES[/link]              -- there are
// insufficient resources to satisfy the request.         </LI>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INSUFFICIENT_PRIVILEGE[/link]              -- the caller is not
// authorized to issue this IOCTL.         </LI>        
// <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]              -- Not enough buffer
// space provided for the QoS settings (we require everything)         </LI>         </UL>
//         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_QOS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_QOS_AMAP;
typedef struct { u32 dw[13]; } IOCTL_COMMON_SET_QOS_AMAP, *PIOCTL_COMMON_SET_QOS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP max_tx_frame_size;
   BE_UEXACT32_AMAP max_rx_frame_size;
} SG_PACK BE_SET_FRAME_SIZE_IN_AMAP;
typedef struct { u32 dw[2]; } SET_FRAME_SIZE_IN_AMAP, *PSET_FRAME_SIZE_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP chip_max_tx_frame_size;
   BE_UEXACT32_AMAP chip_max_rx_frame_size;
} SG_PACK BE_SET_FRAME_SIZE_OUT_AMAP;
typedef struct { u32 dw[2]; } SET_FRAME_SIZE_OUT_AMAP, *PSET_FRAME_SIZE_OUT_AMAP;



typedef union {
   BE_SET_FRAME_SIZE_IN_AMAP request;
   BE_SET_FRAME_SIZE_OUT_AMAP response;
} SG_PACK BE_SET_FRAME_SIZE_PARAMS_AMAP;
typedef struct { u32 dw[2]; } SET_FRAME_SIZE_PARAMS_AMAP, *PSET_FRAME_SIZE_PARAMS_AMAP;


//               Set frame size IOCTL. Only a host domain may issue this IOCTL.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_FRAME_SIZE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_FRAME_SIZE_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_FRAME_SIZE_AMAP, *PIOCTL_COMMON_SET_FRAME_SIZE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP max_ioctl_buffer_size;
} SG_PACK BE_QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_AMAP, *PQUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_AMAP;


//              IOCTL_QUERY_MAX_IOCTL_BUFFER_SIZE              MILI uses this IOCTL to
// find out the maximum buffer size that can be accepted             by the host OS or the
// OSM.              During MILI initialization, MILI should send this IOCTL to find out
// the maximum             IOCTL buffer size allowed.  For all the IOCTLs in the future,
// MILI should not allocate             a buffer larger than this value.              In
// Windows, the OS doesn't deliver the IOCTL request when the buffer size allocated       
//      by MILI is larger than the maximum I/O size allowed by OSM.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_QUERY_MAX_IOCTL_BUFFER_SIZE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_AMAP, *PIOCTL_COMMON_QUERY_MAX_IOCTL_BUFFER_SIZE_AMAP;


// --- MGMT_FLASHROM_OPCODE ---
// Flash ROM operation code 
#define MGMT_FLASHROM_OPCODE_FLASH      (1)       // Commit downloaded data to Flash ROM.
                                                  // Data sent with this IOCTL, if any, is
                                                  // appended to data received so far
                                                  // (could be zero), before issuing a
                                                  // flash to ROM.The offset field in this
                                                  // IOCTL is ignored. 
#define MGMT_FLASHROM_OPCODE_SAVE       (2)       // Save downloaded data to ARM's DDR.
                                                  // The offset field in the IOCTL is
                                                  // ignored. When enough data is
                                                  // collected for one block size of flash
                                                  // then commit it down to Flash. The
                                                  // offset on flash is assumed to be zero
                                                  // for the first call with opcode
                                                  // MGMT_FLASHROM_OPCODE_SAVE (or
                                                  // immediately after a call to
                                                  // MGMT_FLASHROM_OPCODE_FLASH).
                                                  // Successive calls with
                                                  // MGMT_FLASHROM_OPCODE_SAVE advance the
                                                  // offset by the bytes received in the
                                                  // previous call. When the caller is
                                                  // done sending all the data for a
                                                  // MGMT_FLASHROM_OPTYPE, this IOCTL must
                                                  // be issued with the
                                                  // MGMT_FLASHROM_OPCODE_FLASH to flush
                                                  // the last chunk of data to flash. 
#define MGMT_FLASHROM_OPCODE_CLEAR      (3)       // Erase specified component from Flash
                                                  // ROM
#define MGMT_FLASHROM_OPCODE_REPORT     (4)       // Read specified component from Flash
                                                  // ROM
#define MGMT_FLASHROM_OPCODE_IMAGE_INFO (5)       // Returns size of a component
#define MGMT_FLASHROM_OPCODE_IMAGE_CRC  (6)       // Returns the stored CRC and calculated
                                                  // CRC for a component. Also informs the
                                                  // caller whether the calculated and the
                                                  // read CRC matches or not.
#define MGMT_FLASHROM_OPCODE_OFFSET_BASED_FLASH (7) // Commit downloaded data to Flash
                                                    // ROM. Data sent with this IOCTL, if
                                                    // any, is to be written at the
                                                    // specified offset It is the caller's
                                                    // responsibility to specify the
                                                    // correct offset. 
#define MGMT_FLASHROM_OPCODE_OFFSET_BASED_SAVE (8) // Save downloaded data to ARM's DDR.
                                                   // The data is received is intended for
                                                   // the flash offset specified. When one
                                                   // (flash) sector size of data is
                                                   // collected, it may be committed to
                                                   // flash if there's insufficient memory
                                                   // to stage all of the data being sent.
#define MGMT_PHY_FLASHROM_OPCODE_FLASH  (9)       // Commit downloaded data to Flash ROM.
                                                  // Data sent with this IOCTL, if any, is
                                                  // appended to data received so far
                                                  // (could be zero), before issuing a
                                                  // flash to ROM.The offset field in this
                                                  // IOCTL is ignored. 
#define MGMT_PHY_FLASHROM_OPCODE_SAVE   (10)      // Save downloaded data to ARM's DDR.
                                                  // The offset field in the IOCTL is
                                                  // ignored. When enough data is
                                                  // collected for one block size of flash
                                                  // then commit it down to Flash. The
                                                  // offset on flash is assumed to be zero
                                                  // for the first call with opcode
                                                  // MGMT_PHY_FLASHROM_OPCODE_SAVE (or
                                                  // immediately after a call to
                                                  // MGMT_PHY_FLASHROM_OPCODE_FLASH).
                                                  // Successive calls with
                                                  // MGMT_PHY_FLASHROM_OPCODE_SAVE advance
                                                  // the offset by the bytes received in
                                                  // the previous call. When the caller is
                                                  // done sending all the data for a
                                                  // MGMT_FLASHROM_OPTYPE, this IOCTL must
                                                  // be issued with the
                                                  // MGMT_PHY_FLASHROM_OPCODE_FLASH to
                                                  // flush the last chunk of data to
                                                  // flash. 

typedef enum {
   ENUM_MGMT_FLASHROM_OPCODE_FLASH = 0x1UL,
   ENUM_MGMT_FLASHROM_OPCODE_SAVE = 0x2UL,
   ENUM_MGMT_FLASHROM_OPCODE_CLEAR = 0x3UL,
   ENUM_MGMT_FLASHROM_OPCODE_REPORT = 0x4UL,
   ENUM_MGMT_FLASHROM_OPCODE_IMAGE_INFO = 0x5UL,
   ENUM_MGMT_FLASHROM_OPCODE_IMAGE_CRC = 0x6UL,
   ENUM_MGMT_FLASHROM_OPCODE_OFFSET_BASED_FLASH = 0x7UL,
   ENUM_MGMT_FLASHROM_OPCODE_OFFSET_BASED_SAVE = 0x8UL,
   ENUM_MGMT_PHY_FLASHROM_OPCODE_FLASH = 0x9UL,
   ENUM_MGMT_PHY_FLASHROM_OPCODE_SAVE = 0xaUL
} MGMT_FLASHROM_OPCODE;

// --- MGMT_FLASHROM_OPTYPE ---
// Flash ROM operation type 
#define MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_ACTIVE (0) // Includes ARM firmware, IPSec
                                                      // (optional) and EP firmware 
#define MGMT_FLASHROM_OPTYPE_CODE_REDBOOT (1)     
#define MGMT_FLASHROM_OPTYPE_CODE_BIOS  (2)       // Implies iSCSI BIOS only 
#define MGMT_FLASHROM_OPTYPE_CODE_PXE_BIOS (3)    
#define MGMT_FLASHROM_OPTYPE_CODE_CTRLS (4)       
#define MGMT_FLASHROM_OPTYPE_CFG_IPSEC  (5)       
#define MGMT_FLASHROM_OPTYPE_CFG_INI    (6)       
#define MGMT_FLASHROM_OPTYPE_ROM_OFFSET_SPECIFIED (7) // TBD 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_BIOS (8)   
#define MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_BACKUP (9) 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_ACTIVE (10) 
#define MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_BACKUP (11) 
#define MGMT_FLASHROM_OPTYPE_CODE_CTRLP (12)      
#define MGMT_FLASHROM_OPTYPE_CODE_NCSI_FW (13)    
#define MGMT_FLASHROM_OPTYPE_CFG_NIC    (14)      
#define MGMT_FLASHROM_OPTYPE_CFG_DCBX   (15)      
#define MGMT_FLASHROM_OPTYPE_CFG_PXE_BIOS (16)    
#define MGMT_FLASHROM_OPTYPE_CFG_ALL    (17)      
#define MGMT_FLASHROM_OPTYPE_CODE_PHY_FW (18)     

typedef enum {
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_ACTIVE = 0x0UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_REDBOOT = 0x1UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_BIOS = 0x2UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_PXE_BIOS = 0x3UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_CTRLS = 0x4UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_IPSEC = 0x5UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_INI = 0x6UL,
   ENUM_MGMT_FLASHROM_OPTYPE_ROM_OFFSET_SPECIFIED = 0x7UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_BIOS = 0x8UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_iSCSI_FW_BACKUP = 0x9UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_ACTIVE = 0xaUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_FCOE_FW_BACKUP = 0xbUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_CTRLP = 0xcUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_NCSI_FW = 0xdUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_NIC = 0xeUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_DCBX = 0xfUL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_PXE_BIOS = 0x10UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CFG_ALL = 0x11UL,
   ENUM_MGMT_FLASHROM_OPTYPE_CODE_PHY_FW = 0x12UL
} MGMT_FLASHROM_OPTYPE;


typedef struct {
   BE_UEXACT32_AMAP op_code;
   BE_UEXACT32_AMAP op_type;
   BE_UEXACT32_AMAP data_buffer_size;
   BE_UEXACT32_AMAP offset;
   BE_UEXACT8_AMAP data_buffer[4];
} SG_PACK BE_FLASHROM_PARAMS_AMAP;
typedef struct { u32 dw[5]; } FLASHROM_PARAMS_AMAP, *PFLASHROM_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FLASHROM_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FLASHROM_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_FLASHROM_AMAP, *PIOCTL_COMMON_FLASHROM_AMAP;



typedef IOCTL_COMMON_FLASHROM_AMAP IOCTL_COMMON_READ_FLASHROM_AMAP;
typedef BE_IOCTL_COMMON_FLASHROM_AMAP BE_IOCTL_COMMON_READ_FLASHROM_AMAP;


typedef IOCTL_COMMON_FLASHROM_AMAP* PIOCTL_COMMON_READ_FLASHROM_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_READ_FLASHROM_AMAP;


typedef IOCTL_COMMON_FLASHROM_AMAP IOCTL_COMMON_WRITE_FLASHROM_AMAP;
typedef BE_IOCTL_COMMON_FLASHROM_AMAP BE_IOCTL_COMMON_WRITE_FLASHROM_AMAP;


typedef IOCTL_COMMON_FLASHROM_AMAP* PIOCTL_COMMON_WRITE_FLASHROM_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_WRITE_FLASHROM_AMAP;


typedef IOCTL_COMMON_FLASHROM_AMAP IOCTL_COMMON_WRITE_PHY_FLASHROM_AMAP;
typedef BE_IOCTL_COMMON_FLASHROM_AMAP BE_IOCTL_COMMON_WRITE_PHY_FLASHROM_AMAP;


typedef IOCTL_COMMON_FLASHROM_AMAP* PIOCTL_COMMON_WRITE_PHY_FLASHROM_AMAP;
typedef struct { BE_BIT pointer[32]; } BE_PIOCTL_COMMON_WRITE_PHY_FLASHROM_AMAP;


typedef struct {
   BE_UEXACT8_AMAP seeprom_data[1024];
} SG_PACK BE_SEEPROM_READ_PARAMS_OUT_AMAP;
typedef struct { u32 dw[256]; } SEEPROM_READ_PARAMS_OUT_AMAP, *PSEEPROM_READ_PARAMS_OUT_AMAP;



typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   BE_SEEPROM_READ_PARAMS_OUT_AMAP response;
} SG_PACK BE_SEEPROM_READ_PARAMS_AMAP;
typedef struct { u32 dw[256]; } SEEPROM_READ_PARAMS_AMAP, *PSEEPROM_READ_PARAMS_AMAP;


//               Use this IOCTL to retrieve BE HBA/instance specific information          
//    <ul>                 <li> Functionality (or combinations of functions) supported
// (TOE/NIC/iSCSI/VM/RDMA etc.)                 <li> Manufacturer assigned MAC addresses
// for the various functions                  <li> Flash ROM type and size            
// </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SEEPROM_READ_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SEEPROM_READ_AMAP;
typedef struct { u32 dw[260]; } IOCTL_COMMON_SEEPROM_READ_AMAP, *PIOCTL_COMMON_SEEPROM_READ_AMAP;


//            These values are 64-bit duplicates of selected counters in BE_TPRE_STATS, if
// driver/Host          cannot poll in small intervals, these values can be used for more
// accuracy.         
typedef struct {
   BE_UEXACT64_AMAP p0_rx_bytes;
   BE_UEXACT64_AMAP p1_rx_bytes;
} SG_PACK BE_BE_TPRE_STATS_MISC_AMAP;
typedef struct { u32 dw[4]; } BE_TPRE_STATS_MISC_AMAP, *PBE_TPRE_STATS_MISC_AMAP;


//            These values are 64-bit duplicates of selected counters in BE_TPOST_STATS,
// if driver/Host          cannot poll in small intervals, these values can be used for
// more accuracy.         
typedef struct {
   BE_BIT rsvd0[64];                              // DWORD 0
} SG_PACK BE_BE_TPOST_STATS_MISC_AMAP;
typedef struct { u32 dw[2]; } BE_TPOST_STATS_MISC_AMAP, *PBE_TPOST_STATS_MISC_AMAP;



typedef struct {
   BE_BE_TPRE_STATS_AMAP rx;
   BE_BE_TPOST_STATS_AMAP tx;
   BE_BE_TPRE_STATS_MISC_AMAP rx_misc;
   BE_BE_TPOST_STATS_MISC_AMAP tx_misc;
} SG_PACK BE_BE_TCP_STATS_AMAP;
typedef struct { u32 dw[518]; } BE_TCP_STATS_AMAP, *PBE_TCP_STATS_AMAP;



typedef union {
   BE_BE_TCP_STATS_AMAP response;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
} SG_PACK BE_TCP_GET_STATISTICS_PARAMS_AMAP;
typedef struct { u32 dw[518]; } TCP_GET_STATISTICS_PARAMS_AMAP, *PTCP_GET_STATISTICS_PARAMS_AMAP;



typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_TCP_GET_STATISTICS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_TCP_GET_STATISTICS_AMAP;
typedef struct { u32 dw[522]; } IOCTL_COMMON_TCP_GET_STATISTICS_AMAP, *PIOCTL_COMMON_TCP_GET_STATISTICS_AMAP;


//  Queries the TCP state of a given connection. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_TCP_CONTEXT_AMAP context;
      } response;
      struct {
         BE_UEXACT32_AMAP cid;
      } request;
   } params;
} SG_PACK BE_IOCTL_COMMON_TCP_STATE_QUERY_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_TCP_STATE_QUERY_AMAP, *PIOCTL_COMMON_TCP_STATE_QUERY_AMAP;


//               This ioctl queries the controller information from the Flash ROM. This is
// required for management             applications and BIOS to display this information
// to the users.                 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_MGMT_CONTROLLER_ATTRIBUTES_AMAP cntl_attributes_info;
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_GET_CNTL_ATTRIBUTES_AMAP;
typedef struct { u32 dw[139]; } IOCTL_COMMON_GET_CNTL_ATTRIBUTES_AMAP, *PIOCTL_COMMON_GET_CNTL_ATTRIBUTES_AMAP;


//               This ioctl can be used by clients as a no-operation request. Typical uses
// for drivers              are as a heartbeat mechanism, or deferred processing catalyst.
// The ARM will always              complete this IOCTL with a good completion. The 64-bit
// parameter is not touched by              the ARM processor.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT64_AMAP context;
      } request;
      struct {
         BE_UEXACT64_AMAP context;
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_NOP_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_NOP_AMAP, *PIOCTL_COMMON_NOP_AMAP;


// --- NTWK_RX_FILTER_IF_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IF_PROMISCUOUS   (8)       // Set to enable promiscuous mode. Clear
                                                  // to disable promiscuous mode. 
#define NTWK_RX_FILTER_IF_BROADCAST     (16)      // Set to enable broadcast packet
                                                  // reception. Clear to disable broadcast
                                                  // packet reception. 
#define NTWK_RX_FILTER_IF_UNTAGGED      (32)      // Set to enable untagged VLAN matching.
                                                  // Clear to disable untagged VLAN
                                                  // matching. 
#define NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS (128)  // Set to enable VLAN promiscuos mode.
                                                  // Clear to disable VLAN promiscuous
                                                  // mode. 
#define NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS (512) // Set to enable multicast promiscuous
                                                  // mode. Clear to disable multicast
                                                  // promiscuous mode. 
#define NTWK_RX_FILTER_IF_PASS_L2_ERRORS (1024)   // Set to enable passing L2 error
                                                  // packets. Clear to disable passing L2
                                                  // error packets. 
#define NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS (2048) // Set to enable passing L3/L4 errors.
                                                  // Clear to disable passing L3/L4
                                                  // errors. 
#define NTWK_RX_FILTER_IF_MULTICAST     (4096)    // Set to apply the perfect multicast
                                                  // MAC address list. This flag is
                                                  // mutually exclusive with
                                                  // NTWK_RX_FILTER_IF_MULTICAST. 
#define NTWK_RX_FILTER_IF_MULTICAST_HASH (8192)   // Set to apply the perfect multicast
                                                  // MAC address list. This flag is
                                                  // mutually exclusive with
                                                  // NTWK_RX_FILTER_IF_MULTICAST_HASH. 
#define NTWK_RX_FILTER_IF_HEADER_SPLIT  (16384)   // Set to allow header split to operate
                                                  // on all Ethernet RX rings created with
                                                  // header split enabled. Clear this flag
                                                  // to temporarily disable header split,
                                                  // causing all packets to arrive as
                                                  // non-split. 

typedef enum {
   ENUM_NTWK_RX_FILTER_IF_PROMISCUOUS = 0x8UL,
   ENUM_NTWK_RX_FILTER_IF_BROADCAST = 0x10UL,
   ENUM_NTWK_RX_FILTER_IF_UNTAGGED = 0x20UL,
   ENUM_NTWK_RX_FILTER_IF_VLAN_PROMISCUOUS = 0x80UL,
   ENUM_NTWK_RX_FILTER_IF_MCAST_PROMISCUOUS = 0x200UL,
   ENUM_NTWK_RX_FILTER_IF_PASS_L2_ERRORS = 0x400UL,
   ENUM_NTWK_RX_FILTER_IF_PASS_L3L4_ERRORS = 0x800UL,
   ENUM_NTWK_RX_FILTER_IF_MULTICAST = 0x1000UL,
   ENUM_NTWK_RX_FILTER_IF_MULTICAST_HASH = 0x2000UL,
   ENUM_NTWK_RX_FILTER_IF_HEADER_SPLIT = 0x4000UL
} NTWK_RX_FILTER_IF_FLAGS_ENUM;

// --- NTWK_RX_FILTER_FLAGS_ENUM ---
#define NTWK_RX_FILTER_IP_CKSUM         (1)       // Set to enable IP checksum. Clear to
                                                  // disable IP checksum. 
#define NTWK_RX_FILTER_TCP_CKSUM        (2)       // Set to enable TCP checksum. Clear to
                                                  // disable TCP checksum. 
#define NTWK_RX_FILTER_UDP_CKSUM        (4)       // Set to enable UDP checksum. Clear to
                                                  // disable UDP checksum. 
#define NTWK_RX_FILTER_STRIP_CRC        (8)       // Set to strip the Ethernet CRC from
                                                  // packet data. Clear to leave the
                                                  // Ethernt CRC as packet data. 

typedef enum {
   ENUM_NTWK_RX_FILTER_IP_CKSUM = 0x1UL,
   ENUM_NTWK_RX_FILTER_TCP_CKSUM = 0x2UL,
   ENUM_NTWK_RX_FILTER_UDP_CKSUM = 0x4UL,
   ENUM_NTWK_RX_FILTER_STRIP_CRC = 0x8UL
} NTWK_RX_FILTER_FLAGS_ENUM;


typedef struct {
   BE_UEXACT32_AMAP global_flags_mask;
   BE_UEXACT32_AMAP global_flags;
   BE_UEXACT32_AMAP if_flags_mask;
   BE_UEXACT32_AMAP if_flags;
   BE_UEXACT32_AMAP if_id;
   BE_UEXACT32_AMAP multicast_num;
   struct {
      BE_UEXACT8_AMAP bytes[6];
   } multicast_mac_list[32];
} SG_PACK BE_NTWK_RX_FILTER_SETTINGS_AMAP;
typedef struct { u32 dw[54]; } NTWK_RX_FILTER_SETTINGS_AMAP, *PNTWK_RX_FILTER_SETTINGS_AMAP;


//               This IOCTL is used to modify the ethernet receive filter configuration,  
//           and select receive interface options.             Only domain 0 network
// function drivers may issue this IOCTL.              The applied configuration is
// returned in the response payload.                     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_NTWK_RX_FILTER_SETTINGS_AMAP request;
      BE_NTWK_RX_FILTER_SETTINGS_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_NTWK_RX_FILTER_AMAP;
typedef struct { u32 dw[58]; } IOCTL_COMMON_NTWK_RX_FILTER_AMAP, *PIOCTL_COMMON_NTWK_RX_FILTER_AMAP;



typedef struct {
   BE_EXACT8_AMAP firmware_version_string[32];
   BE_EXACT8_AMAP fw_on_flash_version_string[32];
} SG_PACK BE_IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_AMAP;
typedef struct { u32 dw[16]; } IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_AMAP, *PIOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_AMAP;


//  This IOCTL retrieves the firmware version. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      BE_IOCTL_COMMON_GET_FW_VERSION_RESPONSE_PAYLOAD_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_GET_FW_VERSION_AMAP;
typedef struct { u32 dw[20]; } IOCTL_COMMON_GET_FW_VERSION_AMAP, *PIOCTL_COMMON_GET_FW_VERSION_AMAP;


//  This IOCTL is used to program BladeEngine Ethernet flow control behavior.         <P> 
//        If the IOCTL_REQUEST_HEADER version field is non-zero, the IOCTL can fail if
// firmware is operating         in FCoE (or any lossless protocol) config. For a version
// field of zero, the IOCTL will be silently         discarded if firmware is operating in
// FCoE config -- this is strictly done for the purpose of allowing         older network
// drivers to function.                  <P>The IOCTL may fail with the following
// status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link]              -- the caller is not
// authorized to use this IOCTL.         </LI>        
// <LI>[link]MGMT_STATUS_FEATURE_NOT_SUPPORTED[/link]              -- Ethernet flow
// control parameters cannot be modified.         </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT16_AMAP tx_flow_control;
         BE_UEXACT16_AMAP rx_flow_control;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_SET_FLOW_CONTROL_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_SET_FLOW_CONTROL_AMAP, *PIOCTL_COMMON_SET_FLOW_CONTROL_AMAP;


//  This IOCTL is used to read BladeEngine flow control settings. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      struct {
         BE_UEXACT16_AMAP tx_flow_control;
         BE_UEXACT16_AMAP rx_flow_control;
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_GET_FLOW_CONTROL_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_FLOW_CONTROL_AMAP, *PIOCTL_COMMON_GET_FLOW_CONTROL_AMAP;



typedef struct {
   BE_UEXACT32_AMAP fin_wait2_ms;
   BE_UEXACT32_AMAP push_timer_ms;
   BE_UEXACT32_AMAP delayed_ack_ms;
   BE_UEXACT32_AMAP idle_ms;
   BE_UEXACT32_AMAP sws_prevention_ms;
   BE_UEXACT32_AMAP dup_ack_threshold;
   BE_UEXACT32_AMAP max_warning_count;
   BE_UEXACT32_AMAP max_rxmt_count;
   BE_UEXACT32_AMAP ack_frequency;
   BE_UEXACT32_AMAP num_holes_supported;
   BE_BIT rsvd0[1][32];                           // DWORD 10
} SG_PACK BE_BE_DRIVER_TCP_PARAMETERS_AMAP;
typedef struct { u32 dw[11]; } BE_DRIVER_TCP_PARAMETERS_AMAP, *PBE_DRIVER_TCP_PARAMETERS_AMAP;


//           This IOCTL sets the global TCP parameters for offloaded connections. Only
// host          device drivers are allowed to set these.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT32_AMAP ulp_mask;
         BE_BE_DRIVER_TCP_PARAMETERS_AMAP tcp_params;
      } request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_SET_TCP_PARAMETERS_AMAP;
typedef struct { u32 dw[16]; } IOCTL_COMMON_SET_TCP_PARAMETERS_AMAP, *PIOCTL_COMMON_SET_TCP_PARAMETERS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP log_size;
   BE_UEXACT32_AMAP bytes_transferred;
} SG_PACK BE_FAT_RESPONSE_AMAP;
typedef struct { u32 dw[2]; } FAT_RESPONSE_AMAP, *PFAT_RESPONSE_AMAP;


//  This IOCTL retrieves a Fault Analaysis Tool (FAT) log. The log data          can be
// anaylzed by BladeEngine support tools to diagnose faults. Only host          domains
// may issue this IOCTL.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_UEXACT8_AMAP clear_log;
         BE_UEXACT8_AMAP num_pages;
         BE_UEXACT16_AMAP page_offset;
         BE_PHYS_ADDR_AMAP buffer_addr[27];
      } request;
      BE_FAT_RESPONSE_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_GET_FAT_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_GET_FAT_AMAP, *PIOCTL_COMMON_GET_FAT_AMAP;


// --- MANAGE_FAT ---
#define RETRIEVE_FAT                    (0)       // Previously logged FAT data will
                                                  // returned in data_buffer parameter. 
#define QUERY_FAT                       (1)       // Check for the presence or absence of
                                                  // FAT data logged in the flash memory.
                                                  // The log_size field in the response
                                                  // will advertize the size of FAT data. 
#define CLEAR_FAT                       (2)       // Erase any previously logged FAT data.
#define TRIGGER_FAT                     (3)       // Trigger FAT execution. This operation
                                                  // will result in the adapter being
                                                  // inoperable once FAT execution begins.
                                                  // Expected use case is to trigger a
                                                  // state capture of the adapter. No
                                                  // completion will be sent if this
                                                  // operation is initiated. The issuing
                                                  // driver should poll the POST register.
                                                  // When the POST status code shows
                                                  // POST_STAGE_ARMFW_UE and
                                                  // POST_STAGE_FAT_LOG_END ARMfw has
                                                  // completed the FAT log. The adapter
                                                  // must be reset before it is
                                                  // operational and FAT log may be
                                                  // retrieved. 

typedef enum {
   ENUM_RETRIEVE_FAT = 0x0UL,
   ENUM_QUERY_FAT = 0x1UL,
   ENUM_CLEAR_FAT = 0x2UL,
   ENUM_TRIGGER_FAT = 0x3UL
} MANAGE_FAT;


typedef struct {
   BE_UEXACT32_AMAP fat_operation;
   BE_UEXACT32_AMAP read_log_offset;
   BE_UEXACT32_AMAP read_log_length;
   BE_UEXACT32_AMAP data_buffer_size;
   BE_UEXACT32_AMAP data_buffer[1];
} SG_PACK BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_AMAP, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP log_size;
   BE_UEXACT32_AMAP read_log_length;
   BE_BIT rsvd0[2][32];                           // DWORD 2
   BE_UEXACT32_AMAP data_buffer[1];
} SG_PACK BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_AMAP, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_MANAGE_FAT_PARAMS_AMAP, *PIOCTL_COMMON_MANAGE_FAT_PARAMS_AMAP;


//  This IOCTL should be issued by applications to manage FAT log data.         Retreived
// log data may be anaylzed by the ServerEngines' FAT support          tool to debug and
// diagnose adapter malfunctions.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_MANAGE_FAT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_MANAGE_FAT_AMAP;
typedef struct { u32 dw[9]; } IOCTL_COMMON_MANAGE_FAT_AMAP, *PIOCTL_COMMON_MANAGE_FAT_AMAP;


// --- ENABLE_DISABLE_DOMAINS_ENUM ---
#define DISABLE_DOMAIN                  (0)       // Disable this domain.
#define ENABLE_DOMAIN                   (1)       // Enable this domain

typedef enum {
   ENUM_DISABLE_DOMAIN = 0x0UL,
   ENUM_ENABLE_DOMAIN = 0x1UL
} ENABLE_DISABLE_DOMAINS_ENUM;

// --- DOMAIN_FUNCTION_ENUM ---
#define ISCSI_DOMAIN                    (0)       // This domain's iSCSI functionality.
#define NIC_TOE_DOMAIN                  (1)       // This domain's NIC/TOE functionality.

typedef enum {
   ENUM_ISCSI_DOMAIN = 0x0UL,
   ENUM_NIC_TOE_DOMAIN = 0x1UL
} DOMAIN_FUNCTION_ENUM;


typedef struct {
   BE_UEXACT8_AMAP domain_function;
   BE_UEXACT8_AMAP enable_disable;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_ENABLE_DISABLE_DOMAINS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } ENABLE_DISABLE_DOMAINS_PARAMS_IN_AMAP, *PENABLE_DISABLE_DOMAINS_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_ENABLE_DISABLE_DOMAINS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } ENABLE_DISABLE_DOMAINS_PARAMS_OUT_AMAP, *PENABLE_DISABLE_DOMAINS_PARAMS_OUT_AMAP;



typedef union {
   BE_ENABLE_DISABLE_DOMAINS_PARAMS_IN_AMAP request;
   BE_ENABLE_DISABLE_DOMAINS_PARAMS_OUT_AMAP response;
} SG_PACK BE_ENABLE_DISABLE_DOMAINS_PARAMS_AMAP;
typedef struct { u32 dw[1]; } ENABLE_DISABLE_DOMAINS_PARAMS_AMAP, *PENABLE_DISABLE_DOMAINS_PARAMS_AMAP;


//           This IOCTL enables or disables a domain for NIC/TOE or iSCSI functionality.  
//       If a particular domain is enabled, management utilities like SMCLP expose a
// logicalHBA         to the user allowing the QoS, iSCSI (iqn) name etc to be set for
// that domain. The domain number         is specified in the IOCTL_HEADER. This IOCTL can
// only originate from domain 0.          <break>         This IOCTL may return one of the
// following status values in the response          <ul>             <li>
// [link]MGMT_STATUS_SUCCESS[/link]             <li> [link]MGMT_STATUS_FAILED[/link] with
// additional status set to [link]MGMT_ADDI_STATUS_INVALID_DOMAIN[/link]         </ul>    
//      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_ENABLE_DISABLE_DOMAINS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_DOMAINS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ENABLE_DISABLE_DOMAINS_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_DOMAINS_AMAP;



typedef struct {
   BE_UEXACT8_AMAP domain_function;
   BE_UEXACT8_AMAP enable_disable;
   BE_BIT rsvd0[16];                              // DWORD 0
} SG_PACK BE_GET_DOMAIN_CONFIG_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_DOMAIN_CONFIG_PARAMS_IN_AMAP, *PGET_DOMAIN_CONFIG_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP domain_bitmap;
} SG_PACK BE_GET_DOMAIN_CONFIG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } GET_DOMAIN_CONFIG_PARAMS_OUT_AMAP, *PGET_DOMAIN_CONFIG_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_DOMAIN_CONFIG_PARAMS_IN_AMAP request;
   BE_GET_DOMAIN_CONFIG_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_DOMAIN_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[1]; } GET_DOMAIN_CONFIG_PARAMS_AMAP, *PGET_DOMAIN_CONFIG_PARAMS_AMAP;


//           This IOCTL returns a bitmap indicating the current status of the NIC/TOE or
// iSCSI functionality         for all the domains supported on a given BladeEngine. The
// domain number in the IOCTL header         is ignored. This IOCTL can only originate
// from domain 0.         This IOCTL will always return [link]MGMT_STATUS_SUCCESS[/link]  
//       
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_DOMAIN_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_DOMAIN_CONFIG_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_DOMAIN_CONFIG_AMAP, *PIOCTL_COMMON_GET_DOMAIN_CONFIG_AMAP;



typedef struct {
   BE_UEXACT32_AMAP eq_id;
   BE_UEXACT32_AMAP phase;
   BE_UEXACT32_AMAP delay_multiplier;
} SG_PACK BE_EQ_DELAY_PARAMS_AMAP;
typedef struct { u32 dw[3]; } EQ_DELAY_PARAMS_AMAP, *PEQ_DELAY_PARAMS_AMAP;



typedef union {
   struct {
      BE_UEXACT32_AMAP num_eq;
      BE_EQ_DELAY_PARAMS_AMAP delay[8];
   } request;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } response;
} SG_PACK BE_MODIFY_EQ_DELAY_PARAMS_AMAP;
typedef struct { u32 dw[25]; } MODIFY_EQ_DELAY_PARAMS_AMAP, *PMODIFY_EQ_DELAY_PARAMS_AMAP;


//           This IOCTL changes the EQ delay for a given set of EQs.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_MODIFY_EQ_DELAY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_MODIFY_EQ_DELAY_AMAP;
typedef struct { u32 dw[29]; } IOCTL_COMMON_MODIFY_EQ_DELAY_AMAP, *PIOCTL_COMMON_MODIFY_EQ_DELAY_AMAP;



typedef union {
   struct {
      BE_UEXACT32_AMAP num_msi_messages;
   } request;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } response;
} SG_PACK BE_CEV_MODIFY_MSI_MESSAGES_PARAMS_AMAP;
typedef struct { u32 dw[1]; } CEV_MODIFY_MSI_MESSAGES_PARAMS_AMAP, *PCEV_MODIFY_MSI_MESSAGES_PARAMS_AMAP;


//           This IOCTL changes the number of MSI messages used by CEV to report
// interrupts          to the host block.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_CEV_MODIFY_MSI_MESSAGES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES_AMAP, *PIOCTL_COMMON_CEV_MODIFY_MSI_MESSAGES_AMAP;


// --- BE_CHIP_REVISION ---
#define BE_REV_A0                       (0)       
#define BE_REV_A1                       (1)       
#define BE_REV_A2                       (2)       

typedef enum {
   ENUM_BE_REV_A0 = 0x0UL,
   ENUM_BE_REV_A1 = 0x1UL,
   ENUM_BE_REV_A2 = 0x2UL
} BE_CHIP_REVISION;

// --- BE_ASIC_REVISION ---
#define BE_ASIC_REV_A0                  (0)       
#define BE_ASIC_REV_A1                  (1)       
#define BE_ASIC_REV_A2                  (2)       

typedef enum {
   ENUM_BE_ASIC_REV_A0 = 0x0UL,
   ENUM_BE_ASIC_REV_A1 = 0x1UL,
   ENUM_BE_ASIC_REV_A2 = 0x2UL
} BE_ASIC_REVISION;

// --- ULP_SUPPORTED_MODES ---
#define ULP_TOE_MODE                    (1)       
#define ULP_NIC_MODE                    (2)       
#define ULP_RDMA_MODE                   (4)       
#define ULP_ISCSI_INI_MODE              (16)      
#define ULP_ISCSI_TGT_MODE              (32)      
#define ULP_FCOE_INI_MODE               (64)      
#define ULP_FCOE_TGT_MODE               (128)     
#define ULP_DAL_MODE                    (256)     
#define ULP_LRO_MODE                    (512)     

typedef enum {
   ENUM_ULP_TOE_MODE = 0x1UL,
   ENUM_ULP_NIC_MODE = 0x2UL,
   ENUM_ULP_RDMA_MODE = 0x4UL,
   ENUM_ULP_ISCSI_INI_MODE = 0x10UL,
   ENUM_ULP_ISCSI_TGT_MODE = 0x20UL,
   ENUM_ULP_FCOE_INI_MODE = 0x40UL,
   ENUM_ULP_FCOE_TGT_MODE = 0x80UL,
   ENUM_ULP_DAL_MODE = 0x100UL,
   ENUM_ULP_LRO_MODE = 0x200UL
} ULP_SUPPORTED_MODES;

// --- BE_FUNCTION_CAPS ---
#define BE_FUNCTION_CAPS_UNCLASSIFIED_STATS (1)   
#define BE_FUNCTION_CAPS_RSS            (2)       
#define BE_FUNCTION_CAPS_PROMISCUOUS    (4)       
#define BE_FUNCTION_CAPS_LEGACY_MODE    (8)       

typedef enum {
   ENUM_BE_FUNCTION_CAPS_UNCLASSIFIED_STATS = 0x1UL,
   ENUM_BE_FUNCTION_CAPS_RSS = 0x2UL,
   ENUM_BE_FUNCTION_CAPS_PROMISCUOUS = 0x4UL,
   ENUM_BE_FUNCTION_CAPS_LEGACY_MODE = 0x8UL
} BE_FUNCTION_CAPS;

//              ID information specific to protocol processing engines.             
typedef struct {
   BE_UEXACT32_AMAP ulp_mode;
   BE_UEXACT32_AMAP etx_base;
   BE_UEXACT32_AMAP etx_count;
   BE_UEXACT32_AMAP sq_base;
   BE_UEXACT32_AMAP sq_count;
   BE_UEXACT32_AMAP rq_base;
   BE_UEXACT32_AMAP rq_count;
   BE_UEXACT32_AMAP dq_base;
   BE_UEXACT32_AMAP dq_count;
   BE_UEXACT32_AMAP lro_base;
   BE_UEXACT32_AMAP lro_count;
   BE_UEXACT32_AMAP icd_base;
   BE_UEXACT32_AMAP icd_count;
} SG_PACK BE_BE_ULP_FW_CFG_AMAP;
typedef struct { u32 dw[13]; } BE_ULP_FW_CFG_AMAP, *PBE_ULP_FW_CFG_AMAP;



typedef struct {
   BE_UEXACT32_AMAP be_config_number;
   BE_UEXACT32_AMAP asic_revision;
   BE_UEXACT32_AMAP phys_port;
   BE_UEXACT32_AMAP function_mode;
   BE_BE_ULP_FW_CFG_AMAP ulp[2];
   BE_UEXACT32_AMAP function_caps;
} SG_PACK BE_BE_FW_CFG_AMAP;
typedef struct { u32 dw[31]; } BE_FW_CFG_AMAP, *PBE_FW_CFG_AMAP;


//           This IOCTL retrieves firmware configuration parameters and adapter resources 
//         available to the driver originating the request.          <p>         The
// firmware configuration defines supported protocols by the installed adapter        
// firmware. This includes which Upper Layer Protocol (ULP) processors support said       
//   protocols and the number of TCP connections allowed for that protocol.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } request;
      BE_BE_FW_CFG_AMAP response;
   } params;
} SG_PACK BE_IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_AMAP;
typedef struct { u32 dw[35]; } IOCTL_COMMON_QUERY_FIRMWARE_CONFIG_AMAP, *PIOCTL_COMMON_QUERY_FIRMWARE_CONFIG_AMAP;


// --- BE_PORT_NUM ---
#define BE_PORT0                        (1)       
#define BE_PORT1                        (2)       

typedef enum {
   ENUM_BE_PORT0 = 0x1UL,
   ENUM_BE_PORT1 = 0x2UL
} BE_PORT_NUM;

// --- BE_PORT_CHANNEL_NUM ---
// Each BE port has 4 lanes/channels 
#define BE_PORT_CHANNEL0                (1)       
#define BE_PORT_CHANNEL1                (2)       
#define BE_PORT_CHANNEL2                (4)       
#define BE_PORT_CHANNEL3                (8)       

typedef enum {
   ENUM_BE_PORT_CHANNEL0 = 0x1UL,
   ENUM_BE_PORT_CHANNEL1 = 0x2UL,
   ENUM_BE_PORT_CHANNEL2 = 0x4UL,
   ENUM_BE_PORT_CHANNEL3 = 0x8UL
} BE_PORT_CHANNEL_NUM;

// --- EQ_EMP ---

#define EQUALIZATION                    (1)       
#define EMPHASIS                        (2)       

typedef enum {
   ENUM_EQUALIZATION = 0x1UL,
   ENUM_EMPHASIS = 0x2UL
} EQ_EMP;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_PORT_EQUALIZATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_PORT_EQUALIZATION_PARAMS_IN_AMAP, *PGET_PORT_EQUALIZATION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_equalization_settings;
   BE_UEXACT32_AMAP port0_emphasis_settings;
   BE_UEXACT32_AMAP port1_emphasis_settings;
} SG_PACK BE_GET_PORT_EQUALIZATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[3]; } GET_PORT_EQUALIZATION_PARAMS_OUT_AMAP, *PGET_PORT_EQUALIZATION_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_PORT_EQUALIZATION_PARAMS_IN_AMAP request;
   BE_GET_PORT_EQUALIZATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_PORT_EQUALIZATION_PARAMS_AMAP;
typedef struct { u32 dw[3]; } GET_PORT_EQUALIZATION_PARAMS_AMAP, *PGET_PORT_EQUALIZATION_PARAMS_AMAP;


//              This IOCTL can be used to read equalization and emphasis parameters for
// BladeEngine ports.            (all 4 channels on each port)         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_PORT_EQUALIZATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_EQUALIZATION_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_GET_PORT_EQUALIZATION_AMAP, *PIOCTL_COMMON_GET_PORT_EQUALIZATION_AMAP;



typedef struct {
   BE_UEXACT8_AMAP be_port_num;
   BE_UEXACT8_AMAP be_port_channel;
   BE_UEXACT8_AMAP equalization_emphasis;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT32_AMAP port_equalization_settings;
   BE_UEXACT32_AMAP port0_emphasis_settings;
   BE_UEXACT32_AMAP port1_emphasis_settings;
} SG_PACK BE_SET_PORT_EQUALIZATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[4]; } SET_PORT_EQUALIZATION_PARAMS_IN_AMAP, *PSET_PORT_EQUALIZATION_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_PORT_EQUALIZATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_PORT_EQUALIZATION_PARAMS_OUT_AMAP, *PSET_PORT_EQUALIZATION_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_PORT_EQUALIZATION_PARAMS_IN_AMAP request;
   BE_SET_PORT_EQUALIZATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_PORT_EQUALIZATION_PARAMS_AMAP;
typedef struct { u32 dw[4]; } SET_PORT_EQUALIZATION_PARAMS_AMAP, *PSET_PORT_EQUALIZATION_PARAMS_AMAP;


//               This IOCTL can be used to set equalization and emphasis parameters for
// BladeEngine ports.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_PORT_EQUALIZATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_PORT_EQUALIZATION_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_SET_PORT_EQUALIZATION_AMAP, *PIOCTL_COMMON_SET_PORT_EQUALIZATION_AMAP;


// --- RED_BLOCK ---
#define RED_BLOCK_ULP0                  (1)       
#define RED_BLOCK_ULP1                  (2)       
#define RED_BLOCK_ULP2                  (4)       
#define RED_BLOCK_ETH                   (8)       
#define RED_BLOCK_LRO                   (16)      
#define RED_BLOCK_GLOBAL                (32)      

typedef enum {
   ENUM_RED_BLOCK_ULP0 = 0x1UL,
   ENUM_RED_BLOCK_ULP1 = 0x2UL,
   ENUM_RED_BLOCK_ULP2 = 0x4UL,
   ENUM_RED_BLOCK_ETH = 0x8UL,
   ENUM_RED_BLOCK_LRO = 0x10UL,
   ENUM_RED_BLOCK_GLOBAL = 0x20UL
} RED_BLOCK;


typedef struct {
   BE_UEXACT8_AMAP enable;
   BE_UEXACT8_AMAP w1;
   BE_UEXACT8_AMAP w2;
   BE_UEXACT8_AMAP slope;
   BE_UEXACT8_AMAP mtu_integer;
   BE_UEXACT8_AMAP mtu_exponent;
   BE_BIT rsvd0[16];                              // DWORD 1
   BE_UEXACT16_AMAP min_pbuf;
   BE_UEXACT16_AMAP max_pbuf;
   BE_UEXACT32_AMAP red_block_mask;
} SG_PACK BE_BE_RED_PARAMETERS_AMAP;
typedef struct { u32 dw[4]; } BE_RED_PARAMETERS_AMAP, *PBE_RED_PARAMETERS_AMAP;


//           This IOCTL configures the Random Early Discard (RED) functionality        
// for the PCI function. Only the chutes owned by the given PCI function         are
// configured.  The other chutes are ignored.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   union {
      BE_BE_RED_PARAMETERS_AMAP request;
      struct {
         BE_BIT rsvd0[32];                        // DWORD 4
      } response;
   } params;
} SG_PACK BE_IOCTL_COMMON_RED_CONFIG_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_RED_CONFIG_AMAP, *PIOCTL_COMMON_RED_CONFIG_AMAP;


// --- CONNECTION_UPLOAD_PARAMS ---
// These parameters are used to define the type of upload desired. 
#define CONNECTION_UPLOAD_GRACEFUL      (1)       // Graceful upload 
#define CONNECTION_UPLOAD_ABORT_RESET   (2)       // Abortive upload with reset 
#define CONNECTION_UPLOAD_ABORT         (3)       // Abortive upload without reset 
#define CONNECTION_UPLOAD_ABORT_WITH_SEQ (4)      // Abortive upload with reset, sequence
                                                  // number by driver 

typedef enum {
   ENUM_CONNECTION_UPLOAD_GRACEFUL = 0x1UL,
   ENUM_CONNECTION_UPLOAD_ABORT_RESET = 0x2UL,
   ENUM_CONNECTION_UPLOAD_ABORT = 0x3UL,
   ENUM_CONNECTION_UPLOAD_ABORT_WITH_SEQ = 0x4UL
} CONNECTION_UPLOAD_PARAMS;


typedef struct {
   BE_UEXACT16_AMAP id;
   BE_UEXACT16_AMAP upload_type;
   BE_UEXACT32_AMAP reset_seq;
} SG_PACK BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_AMAP, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_AMAP;



typedef struct {
   BE_TCP_CONTEXT_AMAP tcp;
} SG_PACK BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_AMAP;
typedef struct { u32 dw[32]; } IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_AMAP, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_AMAP;
typedef struct { u32 dw[32]; } IOCTL_COMMON_TCP_UPLOAD_PARAMS_AMAP, *PIOCTL_COMMON_TCP_UPLOAD_PARAMS_AMAP;


//               Uploads an offloaded TCP connection. This flushes the send queue,
// disables the TCP offload, and returns the             final TCP state.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_TCP_UPLOAD_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_TCP_UPLOAD_AMAP;
typedef struct { u32 dw[36]; } IOCTL_COMMON_TCP_UPLOAD_AMAP, *PIOCTL_COMMON_TCP_UPLOAD_AMAP;


//           Destroys all resources assigned to the PCI function which originates this
// request.          The function-reset is intended for use by drivers transitioning      
//   from boot BIOS. At the completion of this IOCTL all chip resources assigned        
// to this function are freed by the ARM firmware.          <p>         This is equivalent
// to a PCI function-level reset. However, the PCI configuration          information is
// preserved. This function has no request or response parameters. It          will always
// return MGMT_STATUS_SUCCESS.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
} SG_PACK BE_IOCTL_COMMON_FUNCTION_RESET_AMAP;
typedef struct { u32 dw[4]; } IOCTL_COMMON_FUNCTION_RESET_AMAP, *PIOCTL_COMMON_FUNCTION_RESET_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_status;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_STATUS_PARAMS_AMAP, *PIOCTL_COMMON_GET_PORT_STATUS_PARAMS_AMAP;


//  This IOCTL is used to query the PHY port status.     
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_PORT_STATUS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_STATUS_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_PORT_STATUS_AMAP, *PIOCTL_COMMON_GET_PORT_STATUS_AMAP;



typedef struct {
   BE_UEXACT32_AMAP port_status;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_AMAP;


//  This IOCTL is used to enable or disable the PHY port.        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_PORT_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ENABLE_DISABLE_PORT_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_PORT_AMAP;



typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT32_AMAP port_speed;
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_AMAP, *PIOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_AMAP;


//  This IOCTL will query the PHY ports speed capability on BE2 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_PORT_CAPABILITY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_CAPABILITY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_PORT_CAPABILITY_AMAP, *PIOCTL_COMMON_GET_PORT_CAPABILITY_AMAP;



typedef union {
   struct {
      BE_UEXACT32_AMAP function_status;
      BE_UEXACT32_AMAP link_status;
      BE_UEXACT32_AMAP vlan_id;
      BE_UEXACT32_AMAP vlan_priority;
      BE_UEXACT32_AMAP qos_min;
      BE_UEXACT32_AMAP qos_max;
   } request;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } response;
} SG_PACK BE_IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP;


//  This IOCTL will set the configuration parameters for a given physical function.       
//   
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_AMAP, *PIOCTL_COMMON_SET_PHYSICAL_FUNCTION_CONFIG_AMAP;



typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT32_AMAP function_status;
      BE_UEXACT32_AMAP vlan_id;
      BE_UEXACT32_AMAP vlan_priority;
      BE_UEXACT32_AMAP qos_min;
      BE_UEXACT32_AMAP qos_max;
      BE_UEXACT32_AMAP link_status;
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP;


//  This IOCTL will query the configuration parameters for a given physical function.     
//      
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_AMAP, *PIOCTL_COMMON_GET_PHYSICAL_FUNCTION_CONFIG_AMAP;



typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT32_AMAP function_status;
      BE_UEXACT8_AMAP function_name[12];
      BE_BIT rsvd0[12][8];                        // DWORD 4
      BE_BIT rsvd1[16][32];                       // DWORD 7
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_AMAP;
typedef struct { u32 dw[23]; } IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_AMAP, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_AMAP;


//  This IOCTL will query configuration parameters for a given physical / virtual
// function. There is no SET equivalent for this IOCTL.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_FUNCTION_NAME_INFO_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_FUNCTION_NAME_INFO_AMAP;
typedef struct { u32 dw[27]; } IOCTL_COMMON_GET_FUNCTION_NAME_INFO_AMAP, *PIOCTL_COMMON_GET_FUNCTION_NAME_INFO_AMAP;


// --- BOOT_STATUS ---
#define BOOT_DISABLED                   (0)       // PXE/iSCSI/FCoE boot on the requested
                                                  // PCI function is disabled /should be
                                                  // disabled
#define BOOT_ENABLED                    (1)       // PXE/iSCSI/FCoE boot on the requested
                                                  // PCI function is enabled / should be
                                                  // enabled

typedef enum {
   ENUM_BOOT_DISABLED = 0x0UL,
   ENUM_BOOT_ENABLED = 0x1UL
} BOOT_STATUS;

// --- BIOS_INSTANCE ---
#define BIOS_INSTANCE_ONE_PER_SYSTEM    (1)       // One instance of expansion BIOS
                                                  // controls all BE functions in the
                                                  // system
#define BIOS_INSTANCE_ONE_PER_FUNC      (1)       // One instance of expansion BIOS loads
                                                  // for each eligible BE function 

typedef enum {
   ENUM_BIOS_INSTANCE_ONE_PER_SYSTEM = 0x1UL,
   ENUM_BIOS_INSTANCE_ONE_PER_FUNC = 0x1UL
} BIOS_INSTANCE;


typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT8_AMAP boot_status;
      BE_UEXACT8_AMAP bios_instance;
      BE_BIT rsvd0[2][8];                         // DWORD 0
      BE_UEXACT32_AMAP future;
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_AMAP, *PIOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_AMAP;


//               This IOCTL allows BE expansion BIOSes to query the boot configuration for
// the associated physical function.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_BOOT_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_BOOT_CONFIG_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_GET_BOOT_CONFIG_AMAP, *PIOCTL_COMMON_GET_BOOT_CONFIG_AMAP;



typedef union {
   struct {
      BE_UEXACT8_AMAP boot_status;
      BE_UEXACT8_AMAP bios_instance;
      BE_BIT rsvd0[2][8];                         // DWORD 0
      BE_UEXACT32_AMAP future;
   } request;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } response;
} SG_PACK BE_IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_AMAP, *PIOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_AMAP;


//               This IOCTL allows expansion BIOS to enable/disable user settings for the
// associated physical function.              iSCSI or PXE Select may use this to         
//     <ul>                 <li> Enable/disable BIOS functionality                 <li>
// Control the number of BIOS instances for a given type of BE function             </ul> 
//        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_SET_BOOT_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_BOOT_CONFIG_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_BOOT_CONFIG_AMAP, *PIOCTL_COMMON_SET_BOOT_CONFIG_AMAP;


// --- BEACON_STATE_ENUM ---
#define BEACON_STATE_DISABLED           (0)       
#define BEACON_STATE_ENABLED            (1)       // Enable blinking of LED on HBA bracket

typedef enum {
   ENUM_BEACON_STATE_DISABLED = 0x0UL,
   ENUM_BEACON_STATE_ENABLED = 0x1UL
} BEACON_STATE_ENUM;


typedef struct {
   BE_UEXACT8_AMAP port_num;
   BE_UEXACT8_AMAP beacon_state;
   BE_UEXACT8_AMAP beacon_duration;
   BE_UEXACT8_AMAP status_duration;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_AMAP;


//  This IOCTL will enable or disable beaconing on the selected port.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_ENABLE_DISABLE_BEACON_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_ENABLE_DISABLE_BEACON_AMAP, *PIOCTL_COMMON_ENABLE_DISABLE_BEACON_AMAP;



typedef struct {
   BE_UEXACT8_AMAP port_num;
} SG_PACK BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP beacon_state;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_BEACON_STATE_PARAMS_AMAP, *PIOCTL_COMMON_GET_BEACON_STATE_PARAMS_AMAP;


//  This IOCTL will report the current state of beaconing on the selected port.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_BEACON_STATE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_BEACON_STATE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_BEACON_STATE_AMAP, *PIOCTL_COMMON_GET_BEACON_STATE_AMAP;


// --- TRANS_RECV_PAGE_NUM ---
#define TR_PAGE_A0                      (160)     
#define TR_PAGE_A2                      (162)     

typedef enum {
   ENUM_TR_PAGE_A0 = 0xa0UL,
   ENUM_TR_PAGE_A2 = 0xa2UL
} TRANS_RECV_PAGE_NUM;


typedef struct {
   BE_u32_AMAP offset;
   BE_u32_AMAP data_length;
} SG_PACK BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_AMAP, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_AMAP;



typedef struct {
   BE_u32_AMAP offset;
   BE_u32_AMAP data_length;
   BE_u32_AMAP pci_data[64];
} SG_PACK BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_AMAP;
typedef struct { u32 dw[66]; } IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_AMAP, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_IN_AMAP request;
   BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_AMAP;
typedef struct { u32 dw[66]; } IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_AMAP, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_AMAP;


//  This IOCTL will read up to 256B from PCI Config space for the corresponding pci
// function number.            The read data is filled in the response.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_READ_PCI_CONFIG_SPACE_AMAP;
typedef struct { u32 dw[70]; } IOCTL_COMMON_READ_PCI_CONFIG_SPACE_AMAP, *PIOCTL_COMMON_READ_PCI_CONFIG_SPACE_AMAP;



typedef struct {
   BE_u32_AMAP page_num;
   BE_u32_AMAP port;
} SG_PACK BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_AMAP, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_AMAP;



typedef struct {
   BE_u32_AMAP page_num;
   BE_u32_AMAP port;
   BE_u32_AMAP page_data[32];
} SG_PACK BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_AMAP;
typedef struct { u32 dw[34]; } IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_AMAP, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_AMAP;
typedef struct { u32 dw[34]; } IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_AMAP, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_AMAP;


//  This IOCTL will read 128B of transreceiver data from each of the A0 and A2 pages.     
//      The A0 and A2 pages are as defined by the SFF - 8472 specification. 
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_READ_TRANSRECEIVER_DATA_AMAP;
typedef struct { u32 dw[38]; } IOCTL_COMMON_READ_TRANSRECEIVER_DATA_AMAP, *PIOCTL_COMMON_READ_TRANSRECEIVER_DATA_AMAP;


// --- PERSONALITY ---
#define PERSONALITY_NIC                 (0)       
#define PERSONALITY_ISCSI               (1)       // At the most two PFs can be assigned
                                                  // as iSCSI functions 
#define PERSONALITY_FCOE                (2)       // At the most two PFs can be assigned
                                                  // as FCoE functions 
#define PERSONALITY_RDMA                (3)       

typedef enum {
   ENUM_PERSONALITY_NIC = 0x0UL,
   ENUM_PERSONALITY_ISCSI = 0x1UL,
   ENUM_PERSONALITY_FCOE = 0x2UL,
   ENUM_PERSONALITY_RDMA = 0x3UL
} PERSONALITY;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP emulex_serial_number[12];
   BE_UEXACT8_AMAP oem_serial_number[24];
   BE_UEXACT32_AMAP oem_personality_mgmt_word;
   BE_UEXACT8_AMAP oem_current_personality;
   BE_UEXACT8_AMAP rsrvd[3];
} SG_PACK BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_AMAP, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_AMAP;


//               This ioctl queries the OEM-specific controller information stored on
// SEEPROM             during manufacturing.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_OEM_ATTRIBUTES_AMAP;
typedef struct { u32 dw[15]; } IOCTL_COMMON_GET_OEM_ATTRIBUTES_AMAP, *PIOCTL_COMMON_GET_OEM_ATTRIBUTES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP port0_name;
   BE_UEXACT8_AMAP port1_name;
   BE_BIT rsvd0[2][8];                            // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PORT_NAME_PARAMS_AMAP, *PIOCTL_COMMON_GET_PORT_NAME_PARAMS_AMAP;


//               This ioctl queries the single character 'name' assigned to each
// BladeEngine port. The port-name             is stored on SEEPROM during manufacturing.
// It can not be altered by users/administrators.             
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_PORT_NAME_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PORT_NAME_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_PORT_NAME_AMAP, *PIOCTL_COMMON_GET_PORT_NAME_AMAP;


// --- CONFIG_CHANGE_SOURCE ---

#define CONFIG_SIGNATURE_ISCSI_SELECT   (0)       // Configuration changes effected by
                                                  // iSCSISelect
#define CONFIG_SIGNATURE_MILI_WINDOWS   (1)       // Configuration changes effected by
                                                  // Windows MILI
#define CONFIG_SIGNATURE_MILI_LINUX     (2)       // Configuration changes effected by
                                                  // Linux MILI
#define CONFIG_SIGNATURE_MILI_ESX       (3)       // Configuration changes effected by ESX
                                                  // MILI
#define CONFIG_SIGNATURE_MILI_SOLARIS   (4)       // Configuration changes effected by
                                                  // Solaris MILI
#define CONFIG_SIGNATURE_MILI_OTHER     (5)       // Configuration changes effected by
                                                  // MILI running on an OS not listed
                                                  // above
#define CONFIG_SIGNATURE_PXE_SELECT     (6)       // Configuration changes effected by
                                                  // PXESelect

typedef enum {
   ENUM_CONFIG_SIGNATURE_ISCSI_SELECT = 0x0UL,
   ENUM_CONFIG_SIGNATURE_MILI_WINDOWS = 0x1UL,
   ENUM_CONFIG_SIGNATURE_MILI_LINUX = 0x2UL,
   ENUM_CONFIG_SIGNATURE_MILI_ESX = 0x3UL,
   ENUM_CONFIG_SIGNATURE_MILI_SOLARIS = 0x4UL,
   ENUM_CONFIG_SIGNATURE_MILI_OTHER = 0x5UL,
   ENUM_CONFIG_SIGNATURE_PXE_SELECT = 0x6UL
} CONFIG_CHANGE_SOURCE;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP config_change_source;
   BE_UEXACT8_AMAP platform_unique_signature[128];
} SG_PACK BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_AMAP, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_AMAP;


//              Allows MILI to verify whether its database is relevant/updated. If the    
//         retrieved signature matches the one owned by a particular instance, then       
//       it can be assumed that the database is in sync. The platform unique signature    
//         may be a system/installation-unique GUID or license key.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_CONFIG_SIGNATURE_AMAP;
typedef struct { u32 dw[37]; } IOCTL_COMMON_GET_CONFIG_SIGNATURE_AMAP, *PIOCTL_COMMON_GET_CONFIG_SIGNATURE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP config_change_source;
   BE_UEXACT8_AMAP platform_unique_signature[128];
} SG_PACK BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_AMAP, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_AMAP;
typedef struct { u32 dw[33]; } IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_AMAP, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_AMAP;


//              Configuration utilities (e.g. MILI or iSCSI Select) MUST issue this IOCTL
// before issuing             any IOCTL which changes configuration.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_CONFIG_SIGNATURE_AMAP;
typedef struct { u32 dw[37]; } IOCTL_COMMON_SET_CONFIG_SIGNATURE_AMAP, *PIOCTL_COMMON_SET_CONFIG_SIGNATURE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP enable;
} SG_PACK BE_FUNCTION_LINK_CONFIG_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } FUNCTION_LINK_CONFIG_PARAMS_IN_AMAP, *PFUNCTION_LINK_CONFIG_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_FUNCTION_LINK_CONFIG_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } FUNCTION_LINK_CONFIG_PARAMS_OUT_AMAP, *PFUNCTION_LINK_CONFIG_PARAMS_OUT_AMAP;



typedef union {
   BE_FUNCTION_LINK_CONFIG_PARAMS_IN_AMAP request;
   BE_FUNCTION_LINK_CONFIG_PARAMS_OUT_AMAP response;
} SG_PACK BE_FUNCTION_LINK_CONFIG_PARAMS_AMAP;
typedef struct { u32 dw[1]; } FUNCTION_LINK_CONFIG_PARAMS_AMAP, *PFUNCTION_LINK_CONFIG_PARAMS_AMAP;


//  The transmit and receive capability for the associated function                 can be
// enabled or disabled using this IOCTL.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_FUNCTION_LINK_CONFIG_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_FUNCTION_LINK_CONFIG_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_FUNCTION_LINK_CONFIG_AMAP, *PIOCTL_COMMON_FUNCTION_LINK_CONFIG_AMAP;


// --- FUNCTION_STATE ---
#define FUNCTION_STATE_ENABLED          (0)       
#define FUNCTION_STATE_DISABLED         (1)       
#define FUNCTION_STATE_INVALID          (255)     

typedef enum {
   ENUM_FUNCTION_STATE_ENABLED = 0x0UL,
   ENUM_FUNCTION_STATE_DISABLED = 0x1UL,
   ENUM_FUNCTION_STATE_INVALID = 0xffUL
} FUNCTION_STATE;

// --- FUNCTION_TYPE ---
#define FUNCTION_TYPE_NIC               (0)       
#define FUNCTION_TYPE_ISCSI             (1)       // At the most two PFs can be assigned
                                                  // as iSCSI functions 
#define FUNCTION_TYPE_FCOE              (2)       // At the most two PFs can be assigned
                                                  // as FCoE functions 
#define FUNCTION_TYPE_RDMA              (3)       
#define FUNCTION_TYPE_UNEXPECTED        (4)       
#define FUNCTION_TYPE_ILLEGAL           (255)     

typedef enum {
   ENUM_FUNCTION_TYPE_NIC = 0x0UL,
   ENUM_FUNCTION_TYPE_ISCSI = 0x1UL,
   ENUM_FUNCTION_TYPE_FCOE = 0x2UL,
   ENUM_FUNCTION_TYPE_RDMA = 0x3UL,
   ENUM_FUNCTION_TYPE_UNEXPECTED = 0x4UL,
   ENUM_FUNCTION_TYPE_ILLEGAL = 0xffUL
} FUNCTION_TYPE;

// --- SRIOV_STATE ---
#define SRIOV_STATE_DISABLED            (0)       
#define SRIOV_STATE_ENABLED             (1)       
#define SRIOV_STATE_INVALID             (255)     

typedef enum {
   ENUM_SRIOV_STATE_DISABLED = 0x0UL,
   ENUM_SRIOV_STATE_ENABLED = 0x1UL,
   ENUM_SRIOV_STATE_INVALID = 0xffUL
} SRIOV_STATE;

// --- RESOURCE_TYPE ---
#define RESOURCE_TYPE_PCIE              (0)       
#define RESOURCE_TYPE_NIC               (1)       
#define RESOURCE_TYPE_ISCSI             (2)       
#define RESOURCE_TYPE_FCOE              (3)       
#define RESOURCE_TYPE_RDMA              (4)       
#define RESOURCE_TYPE_UNEXPECTED        (5)       

typedef enum {
   ENUM_RESOURCE_TYPE_PCIE = 0x0UL,
   ENUM_RESOURCE_TYPE_NIC = 0x1UL,
   ENUM_RESOURCE_TYPE_ISCSI = 0x2UL,
   ENUM_RESOURCE_TYPE_FCOE = 0x3UL,
   ENUM_RESOURCE_TYPE_RDMA = 0x4UL,
   ENUM_RESOURCE_TYPE_UNEXPECTED = 0x5UL
} RESOURCE_TYPE;

// --- RESOURCE_STATE ---
#define RESOURCE_DATA_INVALID           (0)       // data in this record is invalid 
#define RESOURCE_DATA_VALID             (1)       // data in this record is valid 
#define RESOURCE_STATE_ILLEGAL          (4294967295) 

typedef enum {
   ENUM_RESOURCE_DATA_INVALID = 0x0UL,
   ENUM_RESOURCE_DATA_VALID = 0x1UL,
   ENUM_RESOURCE_STATE_ILLEGAL = 0xffffffffUL
} RESOURCE_STATE;

// --- VF_STATE ---
#define VF_INVALID                      (0)       // VFs are not enabled for this PF 
#define VF_VALID                        (1)       // VFs are enabled for this PF 
#define VF_STATE_ILLEGAL                (4294967295) 

typedef enum {
   ENUM_VF_INVALID = 0x0UL,
   ENUM_VF_VALID = 0x1UL,
   ENUM_VF_STATE_ILLEGAL = 0xffffffffUL
} VF_STATE;

//              To change the personality of a given controller (LOM/Mezz/HBA).Send the
// [flag]NEW[/flag] pf_type for              the selected pf_num. Fields other than pf_nm,
// pf_state and pf_type are ignore when a personality change              is requested. At
// present, personality changes affect only pf_num=2 and pf_num=3. These two PFs are
// designated as              storage functions.          
typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP pf_state;
   BE_UEXACT8_AMAP pf_type;
   BE_UEXACT8_AMAP sriov_state;
   BE_UEXACT16_AMAP msix_vectors;
   BE_UEXACT16_AMAP number_of_vf;
   BE_UEXACT8_AMAP msix_per_vf;
   BE_BIT rsvd0[3][8];                            // DWORD 2
   BE_UEXACT32_AMAP port_num;
} SG_PACK BE_BE_RESOURCES_PCIE_AMAP;
typedef struct { u32 dw[4]; } BE_RESOURCES_PCIE_AMAP, *PBE_RESOURCES_PCIE_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_UEXACT16_AMAP mac_unicast_count;
   BE_UEXACT8_AMAP nic_mac_address_start[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_BIT rsvd0[8];                               // DWORD 2
   BE_UEXACT16_AMAP vlan_count;
   BE_UEXACT16_AMAP mac_mcast_count;
   BE_UEXACT16_AMAP tx_queue_count;
   BE_UEXACT16_AMAP rx_queue_count;
   BE_UEXACT16_AMAP rss_queue_count;
   BE_UEXACT16_AMAP lro_queue_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT16_AMAP toe_connection_count;
   BE_BIT rsvd1[32];                              // DWORD 7
} SG_PACK BE_BE_RESOURCES_NIC_AMAP;
typedef struct { u32 dw[8]; } BE_RESOURCES_NIC_AMAP, *PBE_RESOURCES_NIC_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_UEXACT16_AMAP session_count;
   BE_UEXACT16_AMAP icd_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT8_AMAP iscsi_mac_address[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_BIT rsvd0[5][8];                            // DWORD 3
} SG_PACK BE_BE_RESOURCES_ISCSI_AMAP;
typedef struct { u32 dw[5]; } BE_RESOURCES_ISCSI_AMAP, *PBE_RESOURCES_ISCSI_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_UEXACT16_AMAP login_count;
   BE_UEXACT16_AMAP xri_count;
   BE_UEXACT16_AMAP wq_count;
   BE_UEXACT16_AMAP rq_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT16_AMAP vpi_count;
   BE_UEXACT16_AMAP max_fcf_count;
   BE_UEXACT16_AMAP max_vfi_count;
   BE_UEXACT16_AMAP rsrvd;
   BE_UEXACT8_AMAP wwn[16];
   BE_UEXACT8_AMAP fcoe_fip_mac_address[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_BIT rsvd0[5][8];                            // DWORD 10
} SG_PACK BE_BE_RESOURCES_FCOE_AMAP;
typedef struct { u32 dw[12]; } BE_RESOURCES_FCOE_AMAP, *PBE_RESOURCES_FCOE_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_BE_RESOURCES_RDMA_AMAP;
typedef struct { u32 dw[1]; } BE_RESOURCES_RDMA_AMAP, *PBE_RESOURCES_RDMA_AMAP;



typedef union {
   BE_BE_RESOURCES_PCIE_AMAP pci_resources;
   BE_BE_RESOURCES_NIC_AMAP nic_resources;
   BE_BE_RESOURCES_ISCSI_AMAP iscsi_resources;
   BE_BE_RESOURCES_FCOE_AMAP fcoe_resources;
   BE_BE_RESOURCES_RDMA_AMAP rdma_resources;
} SG_PACK BE_RESOURCE_DESC_AMAP;
typedef struct { u32 dw[12]; } RESOURCE_DESC_AMAP, *PRESOURCE_DESC_AMAP;


//              During a personality-change request, only BE_RESOURCES_PCIE is relevant;
// aLL other resource types in this IOCTL              will be ignored.         
typedef struct {
   BE_UEXACT8_AMAP resource_type;
   BE_BIT rsvd0[3][8];                            // DWORD 0
   BE_RESOURCE_DESC_AMAP resource_descriptor;
} SG_PACK BE_BE_RESOURCES_AMAP;
typedef struct { u32 dw[13]; } BE_RESOURCES_AMAP, *PBE_RESOURCES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP resource_descriptor_count;
   BE_BE_RESOURCES_AMAP be_resources[1];
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[14]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP request;
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP;
typedef struct { u32 dw[14]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP;


//              <ul>                 <li> Lists the physical functions enabled/disabled   
//              <li> Lists the virtual functions enabled (if any), per physical function  
//               <li> Lists the per function resources based on whether the function is
// NIC, iSCSI, FCoE or RDMA             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_AMAP, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_AMAP;



typedef struct {
   BE_UEXACT32_AMAP resource_descriptor_count;
   BE_BE_RESOURCES_AMAP be_resources[1];
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP;
typedef struct { u32 dw[14]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_AMAP request;
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP;
typedef struct { u32 dw[14]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP;


//              This IOCTL may be used for any/all of the following.             <ul>     
//            <li> Enable/disable BE physical functions                 <li> Change the
// board personality by reassigning select PCI functions from NIC<->iSCSI<->FCoE. The
// success                     of personality changes depends on modes enabled on the
// Personality Management Word (PMW) stored on the                      SEEPROM on that
// board.                 <li> Set the per-function resources based on whether the
// function is NIC, iSCSI, FCoE or RDMA                 <li> Set the virtual functions
// enabled (if any), per-physical function             </ul>             To leave a field
// unchanged, callers [flag]must set its value to -1 (0xff,0xffff,.. as
// appropriate)[/flag].             If a field has never been set (by a previous call to
// this IOCTL), then the default values are used. In the              case of MAC address,
// for example, the default value are obtained from SEEPROM.             <br>           
// This IOCTL may return the following status values             <ul>                 <li>
// [link]MGMT_STATUS_SUCCESS[/link] - The requested resource changes were applied.        
//         <li> [link]MGMT_STATUS_REBOOT_REQUIRED[/link] - The personality change
// requested, has been accepted.                              The system must be rebooted
// for these changes to take effect.                 <li>
// [link]MGMT_STATUS_PERSONALITY_CHANGE_FAILED[/link] - In this case the following
// additional status values apply                     <ul>                         <li>
// [link]MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF[/link] - The functions
// assigned to the                                          requested PFs cannot be
// changed. Check PF#s in the IOCTL request.                         <li>
// [link]MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE[/link] - The PCI ID combination
// did not match                                          any entry in our table.         
//                <li> [link]MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED[/link] -
// The PMW for this board does not                                          support a
// personality change.                     </ul>             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_AMAP, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_AMAP;


// --- PCIE_VALID_FIELDS ---
#define PCIE_SRIOV_STATE_VALID          (1)       
#define PCIE_LINK_STATUS_VALID          (2)       

typedef enum {
   ENUM_PCIE_SRIOV_STATE_VALID = 0x1UL,
   ENUM_PCIE_LINK_STATUS_VALID = 0x2UL
} PCIE_VALID_FIELDS;

// --- NIC_VALID_FIELDS ---
#define NIC_BW_PERCENT_VALID            (1)       
#define NIC_VLAN_ID_VALID               (2)       

typedef enum {
   ENUM_NIC_BW_PERCENT_VALID = 0x1UL,
   ENUM_NIC_VLAN_ID_VALID = 0x2UL
} NIC_VALID_FIELDS;

// --- ISCSI_VALID_FIELDS ---
#define ISCSI_BW_PERCENT_VALID          (1)       
#define ISCSI_VLAN_ID_VALID             (2)       

typedef enum {
   ENUM_ISCSI_BW_PERCENT_VALID = 0x1UL,
   ENUM_ISCSI_VLAN_ID_VALID = 0x2UL
} ISCSI_VALID_FIELDS;

// --- FCOE_VALID_FIELDS ---
#define FCOE_BW_PERCENT_VALID           (1)       
#define FCOE_VLAN_ID_VALID              (2)       

typedef enum {
   ENUM_FCOE_BW_PERCENT_VALID = 0x1UL,
   ENUM_FCOE_VLAN_ID_VALID = 0x2UL
} FCOE_VALID_FIELDS;

// --- RDMA_VALID_FIELDS ---
#define RDMA_FIELD_1_VALID              (1)       
#define RDMA_FIELD_2_VALID              (2)       

typedef enum {
   ENUM_RDMA_FIELD_1_VALID = 0x1UL,
   ENUM_RDMA_FIELD_2_VALID = 0x2UL
} RDMA_VALID_FIELDS;

//              To change the personality of a given controller (LOM/Mezz/HBA).Send the
// [flag]NEW[/flag] pf_type for              the selected pf_num. Fields other than pf_nm,
// pf_state and pf_type are ignore when a personality change              is requested. At
// present, personality changes affect only pf_num=2 and pf_num=3. These two PFs are
// designated as              storage functions.          
typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP pf_state;
   BE_UEXACT8_AMAP pf_type;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT32_AMAP valid_fields;
   BE_UEXACT8_AMAP sriov_state;
   BE_BIT rsvd1[8];                               // DWORD 2
   BE_UEXACT16_AMAP msix_vectors;
   BE_UEXACT16_AMAP number_of_vf;
   BE_UEXACT8_AMAP msix_per_vf;
   BE_BIT rsvd2[8];                               // DWORD 3
   BE_UEXACT32_AMAP port_num;
   BE_UEXACT8_AMAP link_status;
   BE_BIT rsvd3[43][8];                           // DWORD 5
} SG_PACK BE_BE_RESOURCES_PCIE_V1_AMAP;
typedef struct { u32 dw[16]; } BE_RESOURCES_PCIE_V1_AMAP, *PBE_RESOURCES_PCIE_V1_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP valid_fields;
   BE_UEXACT16_AMAP mac_unicast_count;
   BE_UEXACT8_AMAP nic_mac_address_start[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_BIT rsvd1[8];                               // DWORD 4
   BE_UEXACT16_AMAP vlan_count;
   BE_UEXACT16_AMAP mac_mcast_count;
   BE_UEXACT16_AMAP tx_queue_count;
   BE_UEXACT16_AMAP rx_queue_count;
   BE_UEXACT16_AMAP rss_queue_count;
   BE_UEXACT16_AMAP lro_queue_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT16_AMAP toe_connection_count;
   BE_UEXACT8_AMAP bw_percent;
   BE_BIT rsvd2[8];                               // DWORD 8
   BE_UEXACT16_AMAP vlan_id;
   BE_BIT rsvd3[26][8];                           // DWORD 9
} SG_PACK BE_BE_RESOURCES_NIC_V1_AMAP;
typedef struct { u32 dw[16]; } BE_RESOURCES_NIC_V1_AMAP, *PBE_RESOURCES_NIC_V1_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP valid_fields;
   BE_UEXACT16_AMAP session_count;
   BE_UEXACT16_AMAP icd_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT8_AMAP iscsi_mac_address[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_UEXACT8_AMAP bw_percent;
   BE_UEXACT16_AMAP vlan_id;
   BE_BIT rsvd1[40][8];                           // DWORD 6
} SG_PACK BE_BE_RESOURCES_ISCSI_V1_AMAP;
typedef struct { u32 dw[16]; } BE_RESOURCES_ISCSI_V1_AMAP, *PBE_RESOURCES_ISCSI_V1_AMAP;



typedef struct {
   BE_UEXACT8_AMAP pf_num;
   BE_UEXACT8_AMAP vf_domain;
   BE_BIT rsvd0[16];                              // DWORD 0
   BE_UEXACT32_AMAP valid_fields;
   BE_UEXACT16_AMAP login_count;
   BE_UEXACT16_AMAP xri_count;
   BE_UEXACT16_AMAP wq_count;
   BE_UEXACT16_AMAP rq_count;
   BE_UEXACT16_AMAP cq_count;
   BE_UEXACT16_AMAP vpi_count;
   BE_UEXACT16_AMAP max_fcf_count;
   BE_UEXACT16_AMAP max_vfi_count;
   BE_UEXACT8_AMAP wwn[16];
   BE_UEXACT8_AMAP fcoe_fip_mac_address[6];
   BE_UEXACT8_AMAP mcc_queue_count;
   BE_UEXACT8_AMAP bw_percent;
   BE_UEXACT16_AMAP vlan_id;
   BE_BIT rsvd1[14][8];                           // DWORD 12
} SG_PACK BE_BE_RESOURCES_FCOE_V1_AMAP;
typedef struct { u32 dw[16]; } BE_RESOURCES_FCOE_V1_AMAP, *PBE_RESOURCES_FCOE_V1_AMAP;



typedef struct {
   BE_UEXACT32_AMAP valid_fields;
   BE_BIT rsvd0[60][8];                           // DWORD 1
} SG_PACK BE_BE_RESOURCES_RDMA_V1_AMAP;
typedef struct { u32 dw[16]; } BE_RESOURCES_RDMA_V1_AMAP, *PBE_RESOURCES_RDMA_V1_AMAP;



typedef union {
   BE_BE_RESOURCES_PCIE_V1_AMAP pci_resources;
   BE_BE_RESOURCES_NIC_V1_AMAP nic_resources;
   BE_BE_RESOURCES_ISCSI_V1_AMAP iscsi_resources;
   BE_BE_RESOURCES_FCOE_V1_AMAP fcoe_resources;
   BE_BE_RESOURCES_RDMA_V1_AMAP rdma_resources;
} SG_PACK BE_RESOURCE_DESC_V1_AMAP;
typedef struct { u32 dw[16]; } RESOURCE_DESC_V1_AMAP, *PRESOURCE_DESC_V1_AMAP;


//              During a personality-change request, only BE_RESOURCES_PCIE is relevant;
// aLL other resource types in this IOCTL              will be ignored.         
typedef struct {
   BE_UEXACT8_AMAP resource_type;
   BE_BIT rsvd0[3][8];                            // DWORD 0
   BE_RESOURCE_DESC_V1_AMAP resource_descriptor;
} SG_PACK BE_BE_RESOURCES_V1_AMAP;
typedef struct { u32 dw[17]; } BE_RESOURCES_V1_AMAP, *PBE_RESOURCES_V1_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[1]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP;



typedef struct {
   BE_UEXACT32_AMAP resource_descriptor_count;
   BE_BE_RESOURCES_V1_AMAP be_resources[1];
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[18]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP;



typedef union {
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP request;
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP;
typedef struct { u32 dw[18]; } GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP, *PGET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP;


//              <ul>                 <li> Lists the physical functions enabled/disabled   
//              <li> Lists the virtual functions enabled (if any), per physical function  
//               <li> Lists the per function resources based on whether the function is
// NIC, iSCSI, FCoE or RDMA             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP, *PIOCTL_COMMON_GET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP;



typedef struct {
   BE_UEXACT32_AMAP resource_descriptor_count;
   BE_BE_RESOURCES_V1_AMAP be_resources[1];
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP;
typedef struct { u32 dw[18]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP;
typedef struct { u32 dw[1]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP;



typedef union {
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_IN_V1_AMAP request;
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_OUT_V1_AMAP response;
} SG_PACK BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP;
typedef struct { u32 dw[18]; } SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP, *PSET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP;


//              This IOCTL may be used for any/all of the following.             <ul>     
//            <li> Enable/disable BE physical functions                 <li> Change the
// board personality by reassigning select PCI functions from NIC<->iSCSI<->FCoE. The
// success                     of personality changes depends on modes enabled on the
// Personality Management Word (PMW) stored on the                      SEEPROM on that
// board.                 <li> Set the per-function resources based on whether the
// function is NIC, iSCSI, FCoE or RDMA                 <li> Set the virtual functions
// enabled (if any), per-physical function             </ul>             Use the
// corresponding valid_fields bitmap to indicate which fields will be changed and which
// will be left unchanged.             If a field has never been set (by a previous call
// to this IOCTL), then the default values are used. In the              case of MAC
// address, for example, the default value are obtained from SEEPROM.             <br>    
//        This IOCTL may return the following status values             <ul>              
//   <li> [link]MGMT_STATUS_SUCCESS[/link] - The requested resource changes were applied. 
//                <li> [link]MGMT_STATUS_REBOOT_REQUIRED[/link] - The personality change
// requested, has been accepted.                              The system must be rebooted
// for these changes to take effect.                 <li>
// [link]MGMT_STATUS_PERSONALITY_CHANGE_FAILED[/link] - In this case the following
// additional status values apply                     <ul>                         <li>
// [link]MGMT_ADDL_STATUS_PERSONALITY_CHANGE_ON_UNSUPPORTED_PF[/link] - The functions
// assigned to the                                          requested PFs cannot be
// changed. Check PF#s in the IOCTL request.                         <li>
// [link]MGMT_ADDL_STATUS_PERSONALITY_INVALID_BOARD_TYPE[/link] - The PCI ID combination
// did not match                                          any entry in our table.         
//                <li> [link]MGMT_ADDL_STATUS_PERSONALITY_CHANGE_NOT_SUPPORTED[/link] -
// The PMW for this board does not                                          support a
// personality change.                     </ul>             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_BE_CONFIGURATION_AND_RESOURCES_PARAMS_V1_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP, *PIOCTL_COMMON_SET_BE_CONFIGURATION_AND_RESOURCES_V1_AMAP;


// --- CAPABILITIES ---
#define UMC_CAPABLE                     (1)       
#define SRIOV_CAPABLE                   (2)       
#define VNTAG_CAPABLE                   (4)       

typedef enum {
   ENUM_UMC_CAPABLE = 0x1UL,
   ENUM_SRIOV_CAPABLE = 0x2UL,
   ENUM_VNTAG_CAPABLE = 0x4UL
} CAPABILITIES;

// --- SWITCH_TYPE ---
#define ST_Normal                       (0)       
#define ST_VNIC                         (1)       
#define ST_VNTAG                        (2)       
#define ST_QBG                          (3)       

typedef enum {
   ENUM_ST_Normal = 0x0UL,
   ENUM_ST_VNIC = 0x1UL,
   ENUM_ST_VNTAG = 0x2UL,
   ENUM_ST_QBG = 0x3UL
} SWITCH_TYPE;


typedef union {
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } request;
   struct {
      BE_UEXACT32_AMAP capabilities;
      BE_UEXACT32_AMAP switch_type;
      BE_BIT rsvd0[32];                           // DWORD 2
   } response;
} SG_PACK BE_IOCTL_COMMON_GET_CAPABILITY_PARAMS_AMAP;
typedef struct { u32 dw[3]; } IOCTL_COMMON_GET_CAPABILITY_PARAMS_AMAP, *PIOCTL_COMMON_GET_CAPABILITY_PARAMS_AMAP;


//               This IOCTL allows the caller to query the capabilities and switch type.  
//        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_CAPABILITY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_CAPABILITY_AMAP;
typedef struct { u32 dw[7]; } IOCTL_COMMON_GET_CAPABILITY_AMAP, *PIOCTL_COMMON_GET_CAPABILITY_AMAP;



typedef union {
   struct {
      BE_UEXACT32_AMAP switch_type;
      BE_BIT rsvd0[32];                           // DWORD 1
   } request;
   struct {
      BE_BIT rsvd0[32];                           // DWORD 0
   } response;
} SG_PACK BE_IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_AMAP;
typedef struct { u32 dw[2]; } IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_AMAP, *PIOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_AMAP;


//               This IOCTL allows the user to set the switch type.          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_SET_SWITCH_TYPE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_SWITCH_TYPE_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_SWITCH_TYPE_AMAP, *PIOCTL_COMMON_SET_SWITCH_TYPE_AMAP;


// --- TX_THROTTLE_SETTING ---
#define TX_THROTTLE_SETTING_UNDEF       (0)       // This is default setting which is same
                                                  // as TX_THROTTLE_SETTING_FAST 
#define TX_THROTTLE_SETTING_SLOW        (1)       // Slow reaction to PFC Pause 
#define TX_THROTTLE_SETTING_FAST        (2)       // Fast reaction to PFC Pause 
#define TX_THROTTLE_SETTING_MAX_ENUM    (3)       

typedef enum {
   ENUM_TX_THROTTLE_SETTING_UNDEF = 0x0UL,
   ENUM_TX_THROTTLE_SETTING_SLOW = 0x1UL,
   ENUM_TX_THROTTLE_SETTING_FAST = 0x2UL,
   ENUM_TX_THROTTLE_SETTING_MAX_ENUM = 0x3UL
} TX_THROTTLE_SETTING;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_TX_THROTTLE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_TX_THROTTLE_PARAMS_IN_AMAP, *PGET_TX_THROTTLE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP tx_throttle;
} SG_PACK BE_GET_TX_THROTTLE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } GET_TX_THROTTLE_PARAMS_OUT_AMAP, *PGET_TX_THROTTLE_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_TX_THROTTLE_PARAMS_IN_AMAP request;
   BE_GET_TX_THROTTLE_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_TX_THROTTLE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } GET_TX_THROTTLE_PARAMS_AMAP, *PGET_TX_THROTTLE_PARAMS_AMAP;


//              It is applicable to BE2 cards only.             This IOCTL is used to
// obtain the current Tx Throttle setting for the requested port on the card.             
// This IOCTL may return the following status values             <ul>                 <li>
// [link]MGMT_STATUS_SUCCESS[/link] - The requested tx throttle setting was returned
// correctly.                 <li> [link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link] - The
// buffer size in the IOCTL is insufficient to return the current                         
//       tx throttle setting.             </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_TX_THROTTLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_TX_THROTTLE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_TX_THROTTLE_AMAP, *PIOCTL_COMMON_GET_TX_THROTTLE_AMAP;



typedef struct {
   BE_UEXACT32_AMAP tx_throttle;
} SG_PACK BE_SET_TX_THROTTLE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } SET_TX_THROTTLE_PARAMS_IN_AMAP, *PSET_TX_THROTTLE_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SET_TX_THROTTLE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_TX_THROTTLE_PARAMS_OUT_AMAP, *PSET_TX_THROTTLE_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_TX_THROTTLE_PARAMS_IN_AMAP request;
   BE_SET_TX_THROTTLE_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_TX_THROTTLE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } SET_TX_THROTTLE_PARAMS_AMAP, *PSET_TX_THROTTLE_PARAMS_AMAP;


//             It is applicable to BE2 cards only.            This IOCTL is used to
// program the Tx Throttle setting for the requested port on the card.            This
// IOCTL may return the following status values             <ul>                 <li>
// [link]MGMT_STATUS_SUCCESS[/link] - The requested tx throttle setting was applied
// successfully.                 <li> [link]MGMT_STATUS_ILLEGAL_FIELD[/link] - The
// requested tx throttle setting to be applied is invalid              </ul>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_TX_THROTTLE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_TX_THROTTLE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_SET_TX_THROTTLE_AMAP, *PIOCTL_COMMON_SET_TX_THROTTLE_AMAP;


// --- PCI_FUNCTION_ASSIGNMENT ---
#define PCI_FUNCTION_UNASSIGNED         (0)       // This function is disabled 
#define PCI_FUNCTION_NIC_TOE            (1)       // NIC/TOE function 
#define PCI_FUNCTION_ISCSI_INI          (2)       // iSCSI Initiator 
#define PCI_FUNCTION_ISCSI_TGT          (3)       // iSCSI Target 
#define PCI_FUNCTION_FCOE               (4)       // FCoE Initiator or Target 
#define PCI_FUNCTION_RDMA               (5)       // RDMA function 

typedef enum {
   ENUM_PCI_FUNCTION_UNASSIGNED = 0x0UL,
   ENUM_PCI_FUNCTION_NIC_TOE = 0x1UL,
   ENUM_PCI_FUNCTION_ISCSI_INI = 0x2UL,
   ENUM_PCI_FUNCTION_ISCSI_TGT = 0x3UL,
   ENUM_PCI_FUNCTION_FCOE = 0x4UL,
   ENUM_PCI_FUNCTION_RDMA = 0x5UL
} PCI_FUNCTION_ASSIGNMENT;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP function_assignment[32];
   BE_UEXACT32_AMAP expansion_ROM_enabled;
   BE_UEXACT8_AMAP port_function_map[32];
} SG_PACK BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_AMAP;
typedef struct { u32 dw[17]; } IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_AMAP;
typedef struct { u32 dw[17]; } IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_AMAP, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_AMAP;


//              This IOCTL is used by the BE expansion ROM software to determine whether,
// or not, expansion BIOS             was enabled on a given PCI function. This
// information cannot be determined at run time by the BIOS             code since
// motherboard BIOS may have disabled the expansion ROM space after shadowing is complete.
//             The other fields are used by the PXESelect/iSCSI Select utilities for
// display purposes.             <br>            This IOCTL always returns
// [link]MGMT_STATUS_SUCCESS[/link].         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_AMAP;
typedef struct { u32 dw[21]; } IOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_AMAP, *PIOCTL_COMMON_GET_PCI_FUNCTION_MAPPING_AMAP;


// --- PERSONALITY_CHANGE_STATUS ---
#define PERSONALITY_NO_CHANGE           (0)       // A personality change  - Is not
                                                  // applicable to this BladeEngine  - Is
                                                  // applicable but never applied  - was
                                                  // applied earlier - no more reboots
                                                  // required for applying these changes 
#define PERSONALITY_CHANGED_REBOOT_REQUIRED (1)   // A personality change was requested
                                                  // since the last reboot/reset. The
                                                  // system must restarted for the change
                                                  // to take effect. 

typedef enum {
   ENUM_PERSONALITY_NO_CHANGE = 0x0UL,
   ENUM_PERSONALITY_CHANGED_REBOOT_REQUIRED = 0x1UL
} PERSONALITY_CHANGE_STATUS;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_AMAP, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP personality_change_status;
} SG_PACK BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT_AMAP, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_AMAP, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_AMAP;


//             Lets the caller know whether a system reboot is required to enforce a
// 'personality change'.            This IOCTL should be issued by all BladeEngine
// expansion ROMs. If the response is            
// [link]PERSONALITY_CHANGED_REBOOT_REQUIRED[/link] then the expansion BIOS code should
// put up an appropriate message for            the user and reboot the system after an
// appropriate delay.            <br>            This IOCTL always returns
// [link]MGMT_STATUS_SUCCESS[/link].          
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_QUERY_PERSONALITY_CHANGE_AMAP, *PIOCTL_COMMON_QUERY_PERSONALITY_CHANGE_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_AMAP, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP chip_uid0;
   BE_UEXACT32_AMAP chip_uid1;
   BE_BIT rsvd0[4][32];                           // DWORD 2
} SG_PACK BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_AMAP, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_AMAP, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_AMAP;


//             Retrieves the unique serial number assigned to each BladeEngine at
// manufacturing.             This IOCTL always returns [link]MGMT_STATUS_SUCCESS[/link]. 
//        
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_AMAP, *PIOCTL_COMMON_QUERY_CHIP_SERIAL_NUMBER_AMAP;


// --- NCSI_STATE ---
// NCSI state as reported by SEEPROM IPL data This does not necessarily mean that a 'Nemo'
// was detected on the board. 
#define NCSI_STATE_DISABLED             (0)       
#define NCSI_STATE_ENABLED              (1)       

typedef enum {
   ENUM_NCSI_STATE_DISABLED = 0x0UL,
   ENUM_NCSI_STATE_ENABLED = 0x1UL
} NCSI_STATE;

// --- NCSI_HANDSHAKE_STATUS ---
// At boot time, the ARM firmware attempts a handshake with the Nemo NCSI 8051 processor. 
#define NCSI_HANDSHAKE_SUCCESS          (0)       
#define NCSI_HANDSHAKE_FAILURE          (1)       

typedef enum {
   ENUM_NCSI_HANDSHAKE_SUCCESS = 0x0UL,
   ENUM_NCSI_HANDSHAKE_FAILURE = 0x1UL
} NCSI_HANDSHAKE_STATUS;

// --- NCSI_WOL_STATUS ---
#define NCSI_WOL_DISABLED               (0)       
#define NCSI_WOL_ENABLED                (1)       

typedef enum {
   ENUM_NCSI_WOL_DISABLED = 0x0UL,
   ENUM_NCSI_WOL_ENABLED = 0x1UL
} NCSI_WOL_STATUS;

// --- NCSI_PORT_SWAP ---
#define NCSI_NO_PORT_SWAP               (0)       
#define NCSI_PORT_SWAPPED               (1)       

typedef enum {
   ENUM_NCSI_NO_PORT_SWAP = 0x0UL,
   ENUM_NCSI_PORT_SWAPPED = 0x1UL
} NCSI_PORT_SWAP;


typedef struct {
   BE_UEXACT32_AMAP magic;
   BE_UEXACT8_AMAP valid;
   BE_UEXACT8_AMAP port0_mac[6];
   BE_UEXACT8_AMAP enable_port0_wol;
   BE_UEXACT8_AMAP port1_mac[6];
   BE_UEXACT8_AMAP enable_port1_wol;
   BE_BIT rsvd0[8];                               // DWORD 4
   BE_UEXACT16_AMAP default_vlanid;
   BE_BIT rsvd1[2][8];                            // DWORD 5
   BE_BIT rsvd2[2][32];                           // DWORD 6
} SG_PACK BE_NEMO_DYNAMIC_CONFIG_AMAP;
typedef struct { u32 dw[8]; } NEMO_DYNAMIC_CONFIG_AMAP, *PNEMO_DYNAMIC_CONFIG_AMAP;



typedef struct {
   BE_UEXACT32_AMAP magic;
   BE_UEXACT8_AMAP port_swap;
   BE_UEXACT8_AMAP port0_mac[6];
   BE_UEXACT8_AMAP enable_port0_wol;
   BE_UEXACT8_AMAP port1_mac[6];
   BE_UEXACT8_AMAP enable_port1_wol;
   BE_BIT rsvd0[8];                               // DWORD 4
   BE_UEXACT16_AMAP default_vlanid;
   BE_BIT rsvd1[2][8];                            // DWORD 5
   BE_BIT rsvd2[2][32];                           // DWORD 6
} SG_PACK BE_NEMO_STATIC_CONFIG_AMAP;
typedef struct { u32 dw[8]; } NEMO_STATIC_CONFIG_AMAP, *PNEMO_STATIC_CONFIG_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_AMAP, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP ncsi_state;
   BE_UEXACT8_AMAP ncsi_handshake_status;
   BE_BIT rsvd0[2][8];                            // DWORD 0
   BE_BIT rsvd1[32];                              // DWORD 1
   BE_NEMO_STATIC_CONFIG_AMAP nemo_static_cfg;
   BE_NEMO_DYNAMIC_CONFIG_AMAP nemo_dynamic_cfg;
} SG_PACK BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_AMAP, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_AMAP;
typedef struct { u32 dw[18]; } IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_AMAP, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_AMAP;


//             The SEEPROM has a bit indicating whether the BE2 HBA has NCSI support. When
// present            the ARM firmware has a handshake with the 8051 processor to
// determine whether a part            of the RXF initialization is completed by Nemo
// (NCSI FPGA) for supporting SOL and WOL            in the D3 state.            <br>     
//       This IOCTL always returns [link]MGMT_STATUS_SUCCESS[/link]. Check the ncsi_state
// field            to determine whether the static and dynamic configuration data
// returned is valid.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_NCSI_CONFIGURATION_AMAP;
typedef struct { u32 dw[22]; } IOCTL_COMMON_GET_NCSI_CONFIGURATION_AMAP, *PIOCTL_COMMON_GET_NCSI_CONFIGURATION_AMAP;



typedef struct {
   BE_NEMO_DYNAMIC_CONFIG_AMAP nemo_dynamic_cfg;
} SG_PACK BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_AMAP, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_AMAP, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_AMAP;



typedef union {
   BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_IN_AMAP request;
   BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_AMAP, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_AMAP;


//             Set WOL and VLAN parameters used by the Nemo NCSI processor. Only the      
//      'dynamic' configuration data can be changed. The 'static' configuration data      
//      in the Nemo flash is expected to be set at manufacturing.            This IOCTL
// returns [link]MGMT_STATUS_SUCCESS[/link] when the ncsi_state            is set to
// NCSI_STATE_ENABLED in [link]IOCTL_COMMON_GET_NCSI_CONFIGURATION[/link]           
// otherwise it will return [link]MGMT_STATUS_ILLEGAL_REQUEST[/link]         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_AMAP;
typedef struct { u32 dw[12]; } IOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_AMAP, *PIOCTL_COMMON_SET_NCSI_DYNAMIC_CONFIGURATION_AMAP;


// --- SENSOR_TYPES ---
#define NO_SENSOR                       (0)       // No sensor. 
#define THERMAL_SENSOR_ON_DIE           (1)       // Thermal sensor on die. 
#define THERMOCOUPLE_SENSOR             (2)       // Thermocouple sensor. 
#define BOARD_POWER_SENSOR              (3)       // Board power sensor. 
#define CHIP_POWER_SENSOR               (4)       // Chip power sensor. 

typedef enum {
   ENUM_NO_SENSOR = 0x0UL,
   ENUM_THERMAL_SENSOR_ON_DIE = 0x1UL,
   ENUM_THERMOCOUPLE_SENSOR = 0x2UL,
   ENUM_BOARD_POWER_SENSOR = 0x3UL,
   ENUM_CHIP_POWER_SENSOR = 0x4UL
} SENSOR_TYPES;

// --- SENSOR_LOCATION ---
#define SENSOR_NOT_PRESENT              (0)       // Sensor not present. 
#define SENSOR_ON_ASIC                  (1)       // Sensor present on ASIC. 
#define SENSOR_NEAR_HOTTEST_PART        (2)       // Sensor near hottest part. 
#define SENSOR_ON_BOARD_NEAR_CONNECTOR  (3)       // Sensor on board near connector. 
#define SENSOR_ON_BOARD_NEAR_REAR_CONNECTOR (4)   // Sensor on board near rear connector. 
#define SENSOR_ON_BOARD_AT_OTHER_LOC    (5)       // Sensor on board at other location. 
#define SENSOR_OFFBOARD_SMART_ARRAY     (6)       // Smart array sensor. 

typedef enum {
   ENUM_SENSOR_NOT_PRESENT = 0x0UL,
   ENUM_SENSOR_ON_ASIC = 0x1UL,
   ENUM_SENSOR_NEAR_HOTTEST_PART = 0x2UL,
   ENUM_SENSOR_ON_BOARD_NEAR_CONNECTOR = 0x3UL,
   ENUM_SENSOR_ON_BOARD_NEAR_REAR_CONNECTOR = 0x4UL,
   ENUM_SENSOR_ON_BOARD_AT_OTHER_LOC = 0x5UL,
   ENUM_SENSOR_OFFBOARD_SMART_ARRAY = 0x6UL
} SENSOR_LOCATION;

// --- SENSOR_STATUS ---
#define SENSOR_ENABLED                  (1)       // Sensor is enabled. 
#define SENSOR_PRESENT                  (2)       // Sensor is present. 
#define SENSOR_FAILED                   (4)       // Sensor is failed. 
#define SENSOR_CHECKSUM                 (8)       // Sensor supports checksum. 

typedef enum {
   ENUM_SENSOR_ENABLED = 0x1UL,
   ENUM_SENSOR_PRESENT = 0x2UL,
   ENUM_SENSOR_FAILED = 0x4UL,
   ENUM_SENSOR_CHECKSUM = 0x8UL
} SENSOR_STATUS;

// --- SENSOR_TEMPERATURE_CFG ---
#define SENSOR_BYTE_SIGNED_DEGREES_C    (0)       // Byte signed degrees C -128 to 127. 
#define SENSOR_BYTE_SIGNED_5_DEGREES_C  (1)       // Byte signed .5 degrees C -0 to 127.5.
#define SENSOR_BYTE_UNSIGNED_DEGREES_C  (2)       // Byte unsigned degrees C 0 to 255. 
#define SENSOR_32BIT_SIGNED_DEGREES_C   (3)       // 32 bit signed degrees C -128 to 127. 
#define SENSOR_32BIT_SIGNED_5_DEGREES_C (4)       // 32 bit signed .5 degrees C -128 to
                                                  // 127. 
#define SENSOR_32BIT_UNSIGNED_DEGREES_C (5)       // 32 bit unsigned degrees C -128 to
                                                  // 127. 
#define SENSOR_RELATIVE_HEAT_SCALE      (6)       // Relative heat scale -128 to 127. 

typedef enum {
   ENUM_SENSOR_BYTE_SIGNED_DEGREES_C = 0x0UL,
   ENUM_SENSOR_BYTE_SIGNED_5_DEGREES_C = 0x1UL,
   ENUM_SENSOR_BYTE_UNSIGNED_DEGREES_C = 0x2UL,
   ENUM_SENSOR_32BIT_SIGNED_DEGREES_C = 0x3UL,
   ENUM_SENSOR_32BIT_SIGNED_5_DEGREES_C = 0x4UL,
   ENUM_SENSOR_32BIT_UNSIGNED_DEGREES_C = 0x5UL,
   ENUM_SENSOR_RELATIVE_HEAT_SCALE = 0x6UL
} SENSOR_TEMPERATURE_CFG;

// --- SENSOR_POWER_CFG ---
#define SENSOR_UNSIGNED_WATTS           (0)       
#define SENSOR_UNSIGNED_5_WATTS         (1)       

typedef enum {
   ENUM_SENSOR_UNSIGNED_WATTS = 0x0UL,
   ENUM_SENSOR_UNSIGNED_5_WATTS = 0x1UL
} SENSOR_POWER_CFG;

//          This structure is initially populated by the System BIOS prior to Option ROM
// execution.          The Option ROM is responsible for incrementing the
// option_card_count and          recomputing the checksum field as it configures each
// card for sensor updates.		         
typedef struct {
   BE_UEXACT32_AMAP version_num;
   BE_UEXACT32_AMAP OCSD_buffer_size;
   BE_UEXACT32_AMAP max_option_card_count;
   BE_UEXACT32_AMAP option_card_and_sensor_size;
   BE_UEXACT32_AMAP option_card_buffer_start;
   BE_BIT rsvd0[3][32];                           // DWORD 5
   BE_UEXACT32_AMAP requested_update_interval;
   BE_BIT rsvd1[5][32];                           // DWORD 9
   BE_UEXACT32_AMAP option_card_count;
   BE_UEXACT32_AMAP checksum;
} SG_PACK BE_SENSOR_BIOS_CFG_AMAP;
typedef struct { u32 dw[16]; } SENSOR_BIOS_CFG_AMAP, *PSENSOR_BIOS_CFG_AMAP;


//          This structure is initially populated by the System BIOS prior to Option ROM
// execution.          The Option ROM is responsible for filling the pci_bus_num and
// pci_device_num and         recomputing the checksum field as it configures each card
// for sensor updates.                       
typedef struct {
   BE_UEXACT32_AMAP version_num;
   BE_UEXACT32_AMAP pci_bus_device_num;
   BE_BIT rsvd0[3][32];                           // DWORD 2
   BE_UEXACT32_AMAP flags_capabilities;
   BE_UEXACT32_AMAP vendor_defined;
   BE_BIT rsvd1[8][32];                           // DWORD 7
   BE_UEXACT32_AMAP checksum;
} SG_PACK BE_SENSOR_OPTIONROM_CFG_AMAP;
typedef struct { u32 dw[16]; } SENSOR_OPTIONROM_CFG_AMAP, *PSENSOR_OPTIONROM_CFG_AMAP;


//          This structure is initially populated by the System BIOS prior to Option ROM
// execution.          The Option ROM is responsible for finding the starting address and
// size of this structure         in host memory and send it to the management firmware
// through IOCTL for populating the          fields back to system BIOS.                 
typedef struct {
   BE_UEXACT32_AMAP sensor_type;
   BE_UEXACT32_AMAP sensor_location;
   BE_UEXACT32_AMAP sensor_critical_threshold;
   BE_UEXACT32_AMAP sensor_caution_threshold;
   BE_UEXACT32_AMAP sensor_config_status;
   BE_UEXACT32_AMAP sensor_reading;
   BE_UEXACT32_AMAP sensor_update_count;
   BE_UEXACT32_AMAP checksum;
} SG_PACK BE_SENSOR_FIELD_CFG_AMAP;
typedef struct { u32 dw[8]; } SENSOR_FIELD_CFG_AMAP, *PSENSOR_FIELD_CFG_AMAP;


//          This structure is initially populated by the System BIOS prior to Option ROM
// execution.          The Option ROM is responsible for filling some of the fields in
// BIOS_CFG strucure, some         of the fields in OPTION_ROM_CFG structure. The
// management firmware will fill all the fields         in FIELD_CFG structure. The order
// of the structure in host memory is as defined below.         
typedef struct {
   BE_SENSOR_BIOS_CFG_AMAP sensor_bios_config;
   BE_SENSOR_OPTIONROM_CFG_AMAP sensor_oprom_config;
   BE_SENSOR_FIELD_CFG_AMAP sensor_config[1];
} SG_PACK BE_SENSOR_CFG_STRUCT_AMAP;
typedef struct { u32 dw[40]; } SENSOR_CFG_STRUCT_AMAP, *PSENSOR_CFG_STRUCT_AMAP;



typedef struct {
   BE_UEXACT64_AMAP sensor_start_addr;
   BE_UEXACT32_AMAP sensor_size;
   BE_UEXACT32_AMAP sensor_interval;
} SG_PACK BE_POPULATE_SENSOR_CFG_INFO_IN_AMAP;
typedef struct { u32 dw[4]; } POPULATE_SENSOR_CFG_INFO_IN_AMAP, *PPOPULATE_SENSOR_CFG_INFO_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP actual_sensor_size;
} SG_PACK BE_POPULATE_SENSOR_CFG_INFO_OUT_AMAP;
typedef struct { u32 dw[1]; } POPULATE_SENSOR_CFG_INFO_OUT_AMAP, *PPOPULATE_SENSOR_CFG_INFO_OUT_AMAP;



typedef union {
   BE_POPULATE_SENSOR_CFG_INFO_IN_AMAP request;
   BE_POPULATE_SENSOR_CFG_INFO_OUT_AMAP response;
} SG_PACK BE_POPULATE_SENSOR_CFG_INFO_AMAP;
typedef struct { u32 dw[4]; } POPULATE_SENSOR_CFG_INFO_AMAP, *PPOPULATE_SENSOR_CFG_INFO_AMAP;


//          This Ioctl is issued by Option ROMs to send the sensor data structure         
// starting address, size and interval to the management firmware. Management        
// firmware updates the sensor data structure on specified intervals.          This IOCTL
// returns [link]MGMT_STATUS_SUCCESS[/link] in case of success and        
// [link]MGMT_STATUS_FAILED[/link] in case of error.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_POPULATE_SENSOR_CFG_INFO_AMAP params;
} SG_PACK BE_IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO_AMAP;
typedef struct { u32 dw[8]; } IOCTL_COMMON_POPULATE_SENSOR_CFG_INFO_AMAP, *PIOCTL_COMMON_POPULATE_SENSOR_CFG_INFO_AMAP;


// --- VF_PRIVILEGE_LEVEL_ENUM ---
#define VF_PRIVILEGE_LEVEL_0            (0)       // Privilege level 0. Full privileges,
                                                  // can act the same as a physical
                                                  // function. 
#define VF_PRIVILEGE_LEVEL_1            (1)       // Privilege level 1. 
#define VF_PRIVILEGE_LEVEL_2            (2)       // Privilege level 2. 
#define VF_PRIVILEGE_LEVEL_3            (3)       // Privilege level 3. 
#define VF_PRIVILEGE_LEVEL_4            (4)       // Privilege level 4. 
#define VF_PRIVILEGE_LEVEL_5            (5)       // Privilege level 5. 
#define VF_PRIVILEGE_LEVEL_6            (6)       // Privilege level 6. 
#define VF_PRIVILEGE_LEVEL_7            (7)       // Privilege level 7. No privileges. 

typedef enum {
   ENUM_VF_PRIVILEGE_LEVEL_0 = 0x0UL,
   ENUM_VF_PRIVILEGE_LEVEL_1 = 0x1UL,
   ENUM_VF_PRIVILEGE_LEVEL_2 = 0x2UL,
   ENUM_VF_PRIVILEGE_LEVEL_3 = 0x3UL,
   ENUM_VF_PRIVILEGE_LEVEL_4 = 0x4UL,
   ENUM_VF_PRIVILEGE_LEVEL_5 = 0x5UL,
   ENUM_VF_PRIVILEGE_LEVEL_6 = 0x6UL,
   ENUM_VF_PRIVILEGE_LEVEL_7 = 0x7UL
} VF_PRIVILEGE_LEVEL_ENUM;


typedef struct {
   BE_UEXACT32_AMAP vf_domain_id;
   BE_UEXACT32_AMAP privilege_level;
} SG_PACK BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_AMAP, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP previous_privilege_level;
} SG_PACK BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_AMAP, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_IN_AMAP request;
   BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_AMAP;
typedef struct { u32 dw[2]; } SET_VF_PRIVILEGE_LEVEL_PARAMS_AMAP, *PSET_VF_PRIVILEGE_LEVEL_PARAMS_AMAP;


//          This IOCTL may be issued by physical function drivers to set the privilege
// level          of a particular virtual function. The assigned privilege level directs
// management         firmware how to handle future requests by the virtual function that
// have privilege          level checks.                  <P>The IOCTL may complete with
// the following status/additional_status codes:         <UL>        
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//     -- the request completed successfully.         </LI>        
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]              -- the request parameter at the
// byte offset specified in the additional status response is invalid.         </LI>      
//   <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_NO_STATUS[/link]              -- the caller is not authorized to
// issue this IOCTL.         </LI>        
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_NOT_A_PROXY_CALL[/link]              -- Expected a proxy call by
// PF but thats not the case.         </LI>        
// <LI>[link]MGMT_STATUS_NOT_SUPPORTED[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]   
//           -- SRIOV is not supported for this physical function or the adapter.        
// </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_VF_PRIVILEGE_LEVEL_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL_AMAP, *PIOCTL_COMMON_SET_VF_PRIVILEGE_LEVEL_AMAP;


// --- VF_PORT_TYPE ---
#define VF_PORT_TYPE_PASSTHRU           (1)       // Passthru port. 
#define VF_PORT_TYPE_VEB                (2)       // Virtual Ethernet Bridge. 
#define VF_PORT_TYPE_VEPA               (3)       // Virtual Ethernet Port Aggregator. 

typedef enum {
   ENUM_VF_PORT_TYPE_PASSTHRU = 0x1UL,
   ENUM_VF_PORT_TYPE_VEB = 0x2UL,
   ENUM_VF_PORT_TYPE_VEPA = 0x3UL
} VF_PORT_TYPE;


typedef struct {
   BE_UEXACT32_AMAP vf_domain_id;
   BE_UEXACT32_AMAP port_type;
} SG_PACK BE_SET_VF_PORT_TYPE_PARAMS_IN_AMAP;
typedef struct { u32 dw[2]; } SET_VF_PORT_TYPE_PARAMS_IN_AMAP, *PSET_VF_PORT_TYPE_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP previous_port_type;
} SG_PACK BE_SET_VF_PORT_TYPE_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SET_VF_PORT_TYPE_PARAMS_OUT_AMAP, *PSET_VF_PORT_TYPE_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_VF_PORT_TYPE_PARAMS_IN_AMAP request;
   BE_SET_VF_PORT_TYPE_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_VF_PORT_TYPE_PARAMS_AMAP;
typedef struct { u32 dw[2]; } SET_VF_PORT_TYPE_PARAMS_AMAP, *PSET_VF_PORT_TYPE_PARAMS_AMAP;


//          This IOCTL may be issued by physical function drivers to set the privilege
// level          of a particular virtual function. The assigned privilege level directs
// management         firmware how to handle future requests by the virtual function that
// have privilege          level checks.                  <P>The IOCTL may complete with
// the following status/additional_status codes:         <UL>            
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//         -- the request completed successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                  -- the request parameter at
// the byte offset specified in the additional status response is invalid.            
// </LI>             <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_NO_STATUS[/link]                  -- the caller is not
// authorized to issue this IOCTL.             </LI>            
// <LI>[link]MGMT_STATUS_NOT_SUPPORTED[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]   
//               -- SRIOV is not supported for this physical function or the adapter.     
//        </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_VF_PORT_TYPE_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_VF_PORT_TYPE_AMAP;
typedef struct { u32 dw[6]; } IOCTL_COMMON_SET_VF_PORT_TYPE_AMAP, *PIOCTL_COMMON_SET_VF_PORT_TYPE_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_PHY_DETAILS_PARAMS_IN_AMAP, *PGET_PHY_DETAILS_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP phy_type;
   BE_UEXACT16_AMAP interface_type;
   BE_UEXACT32_AMAP misc_params;
   BE_UEXACT32_AMAP future_use[4];
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_OUT_AMAP;
typedef struct { u32 dw[6]; } GET_PHY_DETAILS_PARAMS_OUT_AMAP, *PGET_PHY_DETAILS_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_PHY_DETAILS_PARAMS_IN_AMAP request;
   BE_GET_PHY_DETAILS_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_PHY_DETAILS_PARAMS_AMAP;
typedef struct { u32 dw[6]; } GET_PHY_DETAILS_PARAMS_AMAP, *PGET_PHY_DETAILS_PARAMS_AMAP;


//              This IOCTL may be issued by VF and PF drivers to determine the PHY type
// and settings             for the port assigned to their function.          <P>The IOCTL
// may complete with the following status/additional_status codes:         <UL>           
//  <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]        
//          -- the request completed successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link]                  -- the rsvd field in the
// request structure was not set to zero.             </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_PHY_DETAILS_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_PHY_DETAILS_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_GET_PHY_DETAILS_AMAP, *PIOCTL_COMMON_GET_PHY_DETAILS_AMAP;


// --- DRIVER_FUNCTION_CAPABILITIES_ENUMS ---
#define DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS (2) // Software TCP timestamps. 
#define DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API (4) // Native BladeEngine3 Ethernet
                                                          // receive completions. 

typedef enum {
   ENUM_DRIVER_FUNCTION_CAPABILITY_SW_TIMESTAMPS = 0x2UL,
   ENUM_DRIVER_FUNCTION_CAPABILITY_BE3_NATIVE_ERX_API = 0x4UL
} DRIVER_FUNCTION_CAPABILITIES_ENUMS;


typedef struct {
   BE_UEXACT32_AMAP valid_capability_flags;
   BE_UEXACT32_AMAP capability_flags;
   BE_UEXACT8_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT32_AMAP valid_capability_flags;
   BE_UEXACT32_AMAP capability_flags;
   BE_UEXACT8_AMAP sbz[212];
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_AMAP;



typedef union {
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_IN_AMAP request;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_OUT_AMAP response;
} SG_PACK BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_AMAP;
typedef struct { u32 dw[55]; } SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_AMAP, *PSET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_AMAP;


//          This IOCTL may be issued by PF drivers to set their function's         
// capabilities. It is expected this IOCTL is issued prior to posting          resources
// to the adapter and creating rings.                  <P>         The IOCTL may complete
// with the following status/additional_status codes:         <UL>            
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//         -- the request completed successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_FIELD[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]   
//              -- the sbz[] array is not zero.             </LI>            
// <LI>[link]MGMT_STATUS_UNAUTHORIZED_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_NO_STATUS[/link]                  -- the caller is not
// authorized to issue this IOCTL.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. Callers should treat this error as indicative                
// the driver advertised capabilities are not supported and should not be used.           
//  </LI>             <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//        </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SET_DRIVER_FUNCTION_CAPABILITIES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_AMAP, *PIOCTL_COMMON_SET_DRIVER_FUNCTION_CAPABILITIES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_ADAPTER_ID_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_ADAPTER_ID_PARAMS_IN_AMAP, *PGET_ADAPTER_ID_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP adapter_id[23];
   BE_BIT rsvd0[8];                               // DWORD 5
} SG_PACK BE_GET_ADAPTER_ID_PARAMS_OUT_AMAP;
typedef struct { u32 dw[6]; } GET_ADAPTER_ID_PARAMS_OUT_AMAP, *PGET_ADAPTER_ID_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_ADAPTER_ID_PARAMS_IN_AMAP request;
   BE_GET_ADAPTER_ID_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_ADAPTER_ID_PARAMS_AMAP;
typedef struct { u32 dw[6]; } GET_ADAPTER_ID_PARAMS_AMAP, *PGET_ADAPTER_ID_PARAMS_AMAP;


//          This IOCTL may be issued to retrieve the Adapter ID string.                 
// <P>         The IOCTL may complete with the following status/additional_status codes:  
//       <UL>             <LI>[link]MGMT_STATUS_SUCCESS[/link] /
// [link]MGMT_ADDI_STATUS_NO_STATUS[/link]                  -- the request completed
// successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//            <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                 -- the
// buffer size provided is insufficient to contain the response data.                  The
// IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned response
// data.                  The IOCTL_RESPONSE_HEADER actual_response_length field indicates
// the buffer size required for                  the full response data.             </LI>
//         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_ADAPTER_ID_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_ADAPTER_ID_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_GET_ADAPTER_ID_AMAP, *PIOCTL_COMMON_GET_ADAPTER_ID_AMAP;


//          Up to 32 characters per feature string. Null terminated.         
typedef struct {
   BE_UEXACT8_AMAP string_bytes[32];
} SG_PACK BE_FEATURE_NAME_STRING_AMAP;
typedef struct { u32 dw[8]; } FEATURE_NAME_STRING_AMAP, *PFEATURE_NAME_STRING_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_UPGRADE_FEATURES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_UPGRADE_FEATURES_PARAMS_IN_AMAP, *PGET_UPGRADE_FEATURES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP feature_valid[6];
   BE_BIT rsvd0[2][8];                            // DWORD 1
   BE_FEATURE_NAME_STRING_AMAP feature_name[48];
} SG_PACK BE_GET_UPGRADE_FEATURES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[386]; } GET_UPGRADE_FEATURES_PARAMS_OUT_AMAP, *PGET_UPGRADE_FEATURES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_UPGRADE_FEATURES_PARAMS_IN_AMAP request;
   BE_GET_UPGRADE_FEATURES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_UPGRADE_FEATURES_PARAMS_AMAP;
typedef struct { u32 dw[386]; } GET_UPGRADE_FEATURES_PARAMS_AMAP, *PGET_UPGRADE_FEATURES_PARAMS_AMAP;


//          This IOCTL may be issued to retrieve a list of available upgrade features.    
//              <P>         The IOCTL may complete with the following
// status/additional_status codes:         <UL>            
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//         -- the request completed successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//            <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                 -- the
// buffer size provided is insufficient to contain the response data.                  The
// IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned response
// data.                  The IOCTL_RESPONSE_HEADER actual_response_length field indicates
// the buffer size required for                  the full response data.             </LI>
//         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_UPGRADE_FEATURES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_UPGRADE_FEATURES_AMAP;
typedef struct { u32 dw[390]; } IOCTL_COMMON_GET_UPGRADE_FEATURES_AMAP, *PIOCTL_COMMON_GET_UPGRADE_FEATURES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_INSTALLED_FEATURES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_INSTALLED_FEATURES_PARAMS_IN_AMAP, *PGET_INSTALLED_FEATURES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP feature_valid[6];
   BE_BIT rsvd0[2][8];                            // DWORD 1
   BE_FEATURE_NAME_STRING_AMAP feature_name[48];
} SG_PACK BE_GET_INSTALLED_FEATURES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[386]; } GET_INSTALLED_FEATURES_PARAMS_OUT_AMAP, *PGET_INSTALLED_FEATURES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_INSTALLED_FEATURES_PARAMS_IN_AMAP request;
   BE_GET_INSTALLED_FEATURES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_INSTALLED_FEATURES_PARAMS_AMAP;
typedef struct { u32 dw[386]; } GET_INSTALLED_FEATURES_PARAMS_AMAP, *PGET_INSTALLED_FEATURES_PARAMS_AMAP;


//          This IOCTL may be issued to retrieve a list of currently installed features.  
//                <P>         The IOCTL may complete with the following
// status/additional_status codes:         <UL>            
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//         -- the request completed successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//            <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                 -- the
// buffer size provided is insufficient to contain the response data.                  The
// IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned response
// data.                  The IOCTL_RESPONSE_HEADER actual_response_length field indicates
// the buffer size required for                  the full response data.             </LI>
//         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_INSTALLED_FEATURES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_INSTALLED_FEATURES_AMAP;
typedef struct { u32 dw[390]; } IOCTL_COMMON_GET_INSTALLED_FEATURES_AMAP, *PIOCTL_COMMON_GET_INSTALLED_FEATURES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_AVAILABLE_PERSONALITIES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_AVAILABLE_PERSONALITIES_PARAMS_IN_AMAP, *PGET_AVAILABLE_PERSONALITIES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP personality_string;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_AMAP, *PGET_AVAILABLE_PERSONALITIES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_AVAILABLE_PERSONALITIES_PARAMS_IN_AMAP request;
   BE_GET_AVAILABLE_PERSONALITIES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_AVAILABLE_PERSONALITIES_PARAMS_AMAP;
typedef struct { u32 dw[1]; } GET_AVAILABLE_PERSONALITIES_PARAMS_AMAP, *PGET_AVAILABLE_PERSONALITIES_PARAMS_AMAP;


//          This IOCTL may be issued to retrieve a list of available personalities to run.
//                  <P>         The IOCTL may complete with the following
// status/additional_status codes:         <UL>            
// <LI>[link]MGMT_STATUS_SUCCESS[/link] / [link]MGMT_ADDI_STATUS_NO_STATUS[/link]         
//         -- the request completed successfully.             </LI>0            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//            <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                 -- the
// buffer size provided is insufficient to contain the response data.                  The
// IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned response
// data.                  The IOCTL_RESPONSE_HEADER actual_response_length field indicates
// the buffer size required for                  the full response data.             </LI>
//         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_AVAILABLE_PERSONALITIES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_AVAILABLE_PERSONALITIES_AMAP, *PIOCTL_COMMON_GET_AVAILABLE_PERSONALITIES_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_CONFIGURED_PERSONALITY_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_CONFIGURED_PERSONALITY_PARAMS_IN_AMAP, *PGET_CONFIGURED_PERSONALITY_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT8_AMAP personality_string;
   BE_BIT rsvd0[3][8];                            // DWORD 0
} SG_PACK BE_GET_CONFIGURED_PERSONALITY_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } GET_CONFIGURED_PERSONALITY_PARAMS_OUT_AMAP, *PGET_CONFIGURED_PERSONALITY_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_CONFIGURED_PERSONALITY_PARAMS_IN_AMAP request;
   BE_GET_CONFIGURED_PERSONALITY_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_CONFIGURED_PERSONALITY_PARAMS_AMAP;
typedef struct { u32 dw[1]; } GET_CONFIGURED_PERSONALITY_PARAMS_AMAP, *PGET_CONFIGURED_PERSONALITY_PARAMS_AMAP;


//          This IOCTL may be issued to retrieve the personality the adapter will be
// running          upon reboot. This differs from the currently running personality as
// determined by         [flag]FIXME INSERT EXISTING (OR NEW) IOCTL HERE[/flag].          
//        <P>         The IOCTL may complete with the following status/additional_status
// codes:         <UL>             <LI>[link]MGMT_STATUS_SUCCESS[/link] /
// [link]MGMT_ADDI_STATUS_NO_STATUS[/link]                  -- the request completed
// successfully.             </LI>            
// <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is not
// supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]MGMT_STATUS_ILLEGAL_REQUEST[/link] /
// [link]MGMT_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL header
// version field indicates an unknown/unsupported version of the IOCTL.             </LI> 
//            <LI>[link]MGMT_STATUS_INSUFFICIENT_BUFFER[/link]                 -- the
// buffer size provided is insufficient to contain the response data.                  The
// IOCTL_RESPONSE_HEADER response_length field indicates the amount of returned response
// data.                  The IOCTL_RESPONSE_HEADER actual_response_length field indicates
// the buffer size required for                  the full response data.             </LI>
//         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_CONFIGURED_PERSONALITY_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_CONFIGURED_PERSONALITY_AMAP;
typedef struct { u32 dw[5]; } IOCTL_COMMON_GET_CONFIGURED_PERSONALITY_AMAP, *PIOCTL_COMMON_GET_CONFIGURED_PERSONALITY_AMAP;


// --- IOCTL_COMMON_SEND_ACTIVATION_STATUS_CODE_ENUMS ---
// Status code enumerations for IOCTL_COMMON_SEND_ACTIVATION. 
#define SEND_ACTIVATION_STATUS_SUCCESS  (0)       // IOCTL completed successfully. 
#define SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST (2) // Illegal request. Refer to the
                                                   // additional status codes for more
                                                   // information. 
#define SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY (5) // The activation key failed
                                                    // authorization. 
#define SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED (6) // Feature upgrade is not allowed on
                                                      // this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED (7) // The requested feature is not
                                                      // allowed on this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_FREE (8)   // The requested feature is free on this
                                                  // adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_ACTIVE (9) // The requested feature is already
                                                  // active on this adapter. 
#define SEND_ACTIVATION_STATUS_FEATURE_INVALID (10) // The requested feature is not a
                                                    // valid feature number. 
#define SEND_ACTIVATION_STATUS_FEATURE_UPGRADED (11) // For an activation, the requested
                                                     // feature is presently upgraded. For
                                                     // a deactivation, the requested
                                                     // feature is not presently upgraded.

typedef enum {
   ENUM_SEND_ACTIVATION_STATUS_SUCCESS = 0x0UL,
   ENUM_SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST = 0x2UL,
   ENUM_SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY = 0x5UL,
   ENUM_SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED = 0x6UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED = 0x7UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_FREE = 0x8UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_ACTIVE = 0x9UL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_INVALID = 0xaUL,
   ENUM_SEND_ACTIVATION_STATUS_FEATURE_UPGRADED = 0xbUL
} IOCTL_COMMON_SEND_ACTIVATION_STATUS_CODE_ENUMS;

// --- IOCTL_COMMON_SEND_ACTIVATION_ADDI_STATUS_CODE_ENUMS ---
// Additional status code enumerations for IOCTL_COMMON_SEND_ACTIVATION. 
#define SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE (30) // Invalid opcode. 
#define SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST (75) // The IOCTL header version field
                                                         // indicates an
                                                         // unknown/unsupported version of
                                                         // the IOCTL. 

typedef enum {
   ENUM_SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE = 0x1eUL,
   ENUM_SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST = 0x4bUL
} IOCTL_COMMON_SEND_ACTIVATION_ADDI_STATUS_CODE_ENUMS;


typedef struct {
   BE_UEXACT8_AMAP key[25];
   BE_BIT rsvd0[3][8];                            // DWORD 6
} SG_PACK BE_SEND_ACTIVATION_PARAMS_IN_AMAP;
typedef struct { u32 dw[7]; } SEND_ACTIVATION_PARAMS_IN_AMAP, *PSEND_ACTIVATION_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_SEND_ACTIVATION_PARAMS_OUT_AMAP;
typedef struct { u32 dw[1]; } SEND_ACTIVATION_PARAMS_OUT_AMAP, *PSEND_ACTIVATION_PARAMS_OUT_AMAP;



typedef union {
   BE_SEND_ACTIVATION_PARAMS_IN_AMAP request;
   BE_SEND_ACTIVATION_PARAMS_OUT_AMAP response;
} SG_PACK BE_SEND_ACTIVATION_PARAMS_AMAP;
typedef struct { u32 dw[7]; } SEND_ACTIVATION_PARAMS_AMAP, *PSEND_ACTIVATION_PARAMS_AMAP;


//          This IOCTL may be issued to activate a feature.                  <P>        
// The IOCTL may complete with the following status/additional_status codes:         <UL> 
//            <LI>[link]SEND_ACTIVATION_STATUS_SUCCESS[/link]                  -- the
// request completed successfully.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST[/link] /
// [link]SEND_ACTIVATION_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is
// not supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]SEND_ACTIVATION_STATUS_ILLEGAL_REQUEST[/link] /
// [link]SEND_ACTIVATION_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL
// header version field indicates an unknown/unsupported version of the IOCTL.            
// </LI>             <LI>[link]SEND_ACTIVATION_STATUS_UNAUTHORIZED_KEY[/link]             
//    -- the activation key failed authentication.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_UPGRADE_DISALLOWED[/link]                 -- feature
// upgrade is not allowed on the adapter.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_FEATURE_DISALLOWED[/link]                 -- the
// activation key is authentic, however the requested feature is not allowed on the
// adapter.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_FEATURE_FREE[/link]                 -- the activation
// key is authentic, however the requested feature is free on the adapter.            
// </LI>             <LI>[link]SEND_ACTIVATION_STATUS_FEATURE_ACTIVE[/link]               
//  -- the activation key is authentic, however the requested feature is active on the
// adapter.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_FEATURE_INVALID[/link]                 -- the
// activation key is authentic, however the requested feature is not a valid feature
// number.             </LI>            
// <LI>[link]SEND_ACTIVATION_STATUS_FEATURE_UPGRADED[/link]                 -- for an
// activation, the requested feature is presently upgraded; for a deactivation, the
// requested feature is not presently upgraded.             </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_SEND_ACTIVATION_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_SEND_ACTIVATION_AMAP;
typedef struct { u32 dw[11]; } IOCTL_COMMON_SEND_ACTIVATION_AMAP, *PIOCTL_COMMON_SEND_ACTIVATION_AMAP;


// --- RESET_LICENSES_STATUS_CODES ---
// Response status codes for IOCTL_COMMON_RESET_LICENSES. 
#define RESET_LICENSES_STATUS_SUCCESS   (0)       
#define RESET_LICENSES_STATUS_ILLEGAL_REQUEST (2) 
#define RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST (5) 
#define RESET_LICENSES_STATUS_LICENSE_IN_USE (16) 

typedef enum {
   ENUM_RESET_LICENSES_STATUS_SUCCESS = 0x0UL,
   ENUM_RESET_LICENSES_STATUS_ILLEGAL_REQUEST = 0x2UL,
   ENUM_RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST = 0x5UL,
   ENUM_RESET_LICENSES_STATUS_LICENSE_IN_USE = 0x10UL
} RESET_LICENSES_STATUS_CODES;

// --- RESET_LICENSES_ADDI_STATUS_CODES ---
// Response additional status codes for IOCTL_COMMON_RESET_LICENSES. 
#define RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE (30) 
#define RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST (75) 

typedef enum {
   ENUM_RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE = 0x1eUL,
   ENUM_RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST = 0x4bUL
} RESET_LICENSES_ADDI_STATUS_CODES;


typedef struct {
   BE_BIT rsvd0[220][8];                          // DWORD 0
} SG_PACK BE_RESET_LICENSES_PARAMS_IN_AMAP;
typedef struct { u32 dw[55]; } RESET_LICENSES_PARAMS_IN_AMAP, *PRESET_LICENSES_PARAMS_IN_AMAP;



typedef struct {
   BE_BIT rsvd0[220][8];                          // DWORD 0
} SG_PACK BE_RESET_LICENSES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[55]; } RESET_LICENSES_PARAMS_OUT_AMAP, *PRESET_LICENSES_PARAMS_OUT_AMAP;



typedef union {
   BE_RESET_LICENSES_PARAMS_IN_AMAP request;
   BE_RESET_LICENSES_PARAMS_OUT_AMAP response;
} SG_PACK BE_RESET_LICENSES_PARAMS_AMAP;
typedef struct { u32 dw[55]; } RESET_LICENSES_PARAMS_AMAP, *PRESET_LICENSES_PARAMS_AMAP;


//          This IOCTL may be issued to reset all licensed features. Only a physical
// function may issue the command.         [flag]This is a destructive operation that
// cannot be recovered.[/flag]                  <P>         The IOCTL may complete with
// the following status/additional_status codes:         <UL>            
// <LI>[link]RESET_LICENSES_STATUS_SUCCESS[/link]                  -- the request
// completed successfully.             </LI>            
// <LI>[link]RESET_LICENSES_STATUS_UNAUTHORIZED_REQUEST[/link]                 -- an
// unauthorized function has issued the IOCTL. Only a physical function may issue the
// command.             </LI>            
// <LI>[link]RESET_LICENSES_STATUS_LICENSE_IN_USE[/link]                 -- a licensed
// feature is currently in use and cannot be reset. A user must disable active licensed   
//               features before resetting the licenses.             </LI>            
// <LI>[link]RESET_LICENSES_STATUS_ILLEGAL_REQUEST[/link] /
// [link]RESET_LICENSES_ADDI_STATUS_INVALID_OPCODE[/link]                 -- the IOCTL is
// not supported by firmware. This is the case for adapters installed with                
// older firmware. A firmware update is required to use this IOCTL.             </LI>     
//        <LI>[link]RESET_LICENSES_STATUS_ILLEGAL_REQUEST[/link] /
// [link]RESET_LICENSES_ADDI_STATUS_INVALID_REQUEST[/link]                 -- the IOCTL
// header version field indicates an unknown/unsupported version of the IOCTL.            
// </LI>         </UL>         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_RESET_LICENSES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_RESET_LICENSES_AMAP;
typedef struct { u32 dw[59]; } IOCTL_COMMON_RESET_LICENSES_AMAP, *PIOCTL_COMMON_RESET_LICENSES_AMAP;


// --- IPL_FILE_NUMBER ---
// These enums uniquely identify the IPL programmed on the SEEPROM of a given BE
// controller. IPL identification was introduced in BE3. BE2 and earlier products will
// return 0 or 0xffff. 
#define UNKNOWNIPL                      (0)       
#define C32FELX                         (1)       // Tomcat FCoE
#define C32IELX                         (2)       // Tomcat iSCSI
#define C32NELX                         (3)       // Tomcat NIC-only
#define C32FHP                          (4)       // Boxster III 
#define M32FHP                          (5)       // Eastfield 
#define L32FHP                          (6)       // Skipper,Toronto 
#define C32IHP                          (7)       // Boxster III 
#define M32IHP                          (8)       
#define L32IHP                          (9)       
#define C32NHP                          (10)      
#define M32NHP                          (11)      
#define M32FHMN                         (12)      
#define C32FHMN                         (13)      
#define M32FIBM                         (14)      // CFFH 
#define M32IIBM                         (15)      
#define C32NIBM                         (16)      // Mirage3 
#define C32NIBN                         (17)      // Endeavor 3 
#define C32NIBS                         (18)      // Shrike-M 
#define C32NIBX                         (19)      
#define M32NIBM                         (20)      // Eraptor 3
#define M32FIMN                         (21)      
#define M32FDEL                         (22)      
#define M32IDEL                         (23)      
#define M32FCIS                         (24)      
#define C32FFTS                         (25)      
#define M32FFTS                         (26)      
#define L32FHP9                         (27)      
#define L32IHP9                         (28)      
#define L34NIBM                         (29)      // Tigershark
#define L32NIBM                         (30)      // Blacktip
#define UNKNOWN_IPL                     (65535)   

typedef enum {
   ENUM_UNKNOWNIPL = 0x0UL,
   ENUM_C32FELX = 0x1UL,
   ENUM_C32IELX = 0x2UL,
   ENUM_C32NELX = 0x3UL,
   ENUM_C32FHP = 0x4UL,
   ENUM_M32FHP = 0x5UL,
   ENUM_L32FHP = 0x6UL,
   ENUM_C32IHP = 0x7UL,
   ENUM_M32IHP = 0x8UL,
   ENUM_L32IHP = 0x9UL,
   ENUM_C32NHP = 0xaUL,
   ENUM_M32NHP = 0xbUL,
   ENUM_M32FHMN = 0xcUL,
   ENUM_C32FHMN = 0xdUL,
   ENUM_M32FIBM = 0xeUL,
   ENUM_M32IIBM = 0xfUL,
   ENUM_C32NIBM = 0x10UL,
   ENUM_C32NIBN = 0x11UL,
   ENUM_C32NIBS = 0x12UL,
   ENUM_C32NIBX = 0x13UL,
   ENUM_M32NIBM = 0x14UL,
   ENUM_M32FIMN = 0x15UL,
   ENUM_M32FDEL = 0x16UL,
   ENUM_M32IDEL = 0x17UL,
   ENUM_M32FCIS = 0x18UL,
   ENUM_C32FFTS = 0x19UL,
   ENUM_M32FFTS = 0x1aUL,
   ENUM_L32FHP9 = 0x1bUL,
   ENUM_L32IHP9 = 0x1cUL,
   ENUM_L34NIBM = 0x1dUL,
   ENUM_L32NIBM = 0x1eUL,
   ENUM_UNKNOWN_IPL = 0xffffUL
} IPL_FILE_NUMBER;

// --- DRIVER_ADV_FEATURE ---
#define DRIVER_ADV_FEATURE_IFD          (1)       

typedef enum {
   ENUM_DRIVER_ADV_FEATURE_IFD = 0x1UL
} DRIVER_ADV_FEATURE;


typedef struct {
   BE_BIT rsvd0[32];                              // DWORD 0
} SG_PACK BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_AMAP;
typedef struct { u32 dw[1]; } GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_AMAP, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT16_AMAP ipl_file_number;
   BE_UEXACT8_AMAP ipl_file_version;
   BE_BIT rsvd0[8];                               // DWORD 0
   BE_UEXACT8_AMAP on_die_temperature;
   BE_BIT rsvd1[3][8];                            // DWORD 1
   BE_UEXACT32_AMAP driver_advanced_features_supported;
   BE_BIT rsvd2[4][32];                           // DWORD 3
   BE_UEXACT8_AMAP fcoe_universal_bios_version[32];
   BE_UEXACT8_AMAP fcoe_x86_bios_version[32];
   BE_UEXACT8_AMAP fcoe_efi_bios_version[32];
   BE_UEXACT8_AMAP fcoe_fcode_version[32];
   BE_UEXACT8_AMAP uefi_bios_version[32];
   BE_UEXACT8_AMAP uefi_nic_version[32];
   BE_UEXACT8_AMAP uefi_fcode_version[32];
   BE_UEXACT8_AMAP uefi_iscsi_version[32];
   BE_UEXACT8_AMAP iscsi_x86_bios_version[32];
   BE_UEXACT8_AMAP pxe_x86_bios_version[32];
   BE_UEXACT8_AMAP fcoe_default_wwpn[8];
   BE_BIT rsvd3[120][8];                          // DWORD 89
} SG_PACK BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_AMAP;
typedef struct { u32 dw[119]; } GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_AMAP, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_AMAP;



typedef union {
   BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_IN_AMAP request;
   BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_OUT_AMAP response;
} SG_PACK BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_AMAP;
typedef struct { u32 dw[119]; } GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_AMAP, *PGET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_AMAP;


//          This IOCTL returns may be issued to retrieve the versions for all the BIOSs
// available on the BE controller.         
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_GET_CNTL_ADDITIONAL_ATTRIBUTES_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_AMAP;
typedef struct { u32 dw[123]; } IOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_AMAP, *PIOCTL_COMMON_GET_CNTL_ADDITIONAL_ATTRIBUTES_AMAP;


// --- HOST_DMA_DIRECTION_CONTROL ---
#define DMA_FROM_HOST_TO_DDR            (1)       // DMA from HOST to DDR 
#define DMA_FROM_DDR_TO_HOST            (2)       // DMA from DDR to HOST 

typedef enum {
   ENUM_DMA_FROM_HOST_TO_DDR = 0x1UL,
   ENUM_DMA_FROM_DDR_TO_HOST = 0x2UL
} HOST_DMA_DIRECTION_CONTROL;


typedef struct {
   BE_UEXACT32_AMAP direction;
   BE_UEXACT32_AMAP host_buf_len;
   BE_UEXACT64_AMAP host_buf_addr;
   BE_UEXACT64_AMAP buffer_id;
} SG_PACK BE_DMA_HOST_BUFFER_PARAMS_IN_AMAP;
typedef struct { u32 dw[6]; } DMA_HOST_BUFFER_PARAMS_IN_AMAP, *PDMA_HOST_BUFFER_PARAMS_IN_AMAP;



typedef struct {
   BE_UEXACT64_AMAP buffer_id;
} SG_PACK BE_DMA_HOST_BUFFER_PARAMS_OUT_AMAP;
typedef struct { u32 dw[2]; } DMA_HOST_BUFFER_PARAMS_OUT_AMAP, *PDMA_HOST_BUFFER_PARAMS_OUT_AMAP;



typedef union {
   BE_DMA_HOST_BUFFER_PARAMS_IN_AMAP request;
   BE_DMA_HOST_BUFFER_PARAMS_OUT_AMAP response;
} SG_PACK BE_DMA_HOST_BUFFER_PARAMS_AMAP;
typedef struct { u32 dw[6]; } DMA_HOST_BUFFER_PARAMS_AMAP, *PDMA_HOST_BUFFER_PARAMS_AMAP;


//            This Ioctl is currently used by PXE Option ROM to store the host memory     
//      segment contents temporarily as those segments will be used by the optionROMs     
//      for temporary use and restore the contents back into those segments before booting
//           continues.                    
typedef struct {
   BE_IOCTL_HEADER_AMAP header;
   BE_DMA_HOST_BUFFER_PARAMS_AMAP params;
} SG_PACK BE_IOCTL_COMMON_DMA_HOST_BUFFER_AMAP;
typedef struct { u32 dw[10]; } IOCTL_COMMON_DMA_HOST_BUFFER_AMAP, *PIOCTL_COMMON_DMA_HOST_BUFFER_AMAP;



#ifdef SG_PRAGMA_PACK
   #pragma pack(pop)
#endif

#endif // __ioctl_common_amap_h__

